* SUBROUTINE EAFU22             ALL SYSTEMS                 94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF TEST FUNCTIONS FOR NONLINEAR APPROXIMATION.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  KA  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  FA  VALUE OF THE APPROXIMATED FUNCTION AT THE
*          SELECTED POINT.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EAFU22(N,KA,X,FA,NEXT)
      INTEGER N,KA,NEXT
      $FLOAT X(N),FA
      $FLOAT A,B,P,S
      INTEGER I,J,K
      $FLOAT Y(163),PI
      COMMON /EMPR22/ Y
      PARAMETER (PI=3.14159265358979323846$P 0)
      GOTO (10,10,30,30,80,50,100,190,200,60,70,90,130,150,170,120,140,
     & 160,150,110),NEXT
   10 GOTO (11,12,13),KA
   11 FA=X(1)**2+X(2)**2+X(1)*X(2)-1.0$P 0
      RETURN
   12 FA= SIN(X(1))
      RETURN
   13 FA=-COS(X(2))
      RETURN
   30 GOTO (31,32,33),KA
   31 FA=-EXP(X(1)-X(2))
      RETURN
   32 FA= SINH(X(1)-1.0$P 0)-1.0$P 0
      RETURN
   33 FA=-LOG(X(2))-1.0$P 0
      RETURN
   80 GO TO (81,82,83) KA
   81 FA=-SQRT((X(1)-X(3))**2+(X(2)-X(4))**2)
      RETURN
   82 FA=-SQRT((X(3)-X(5))**2+(X(4)-X(6))**2)
      RETURN
   83 FA=-SQRT((X(5)-X(1))**2+(X(6)-X(2))**2)
      RETURN
   50 A=0.0$P 0
      DO 51 I=1,N
      A=A+COS(Y(KA)*X(I))
   51 CONTINUE
      FA=(1.0$P 0+2.0$P 0*A)/1.5$P 1
      RETURN
  100 FA=0.0$P 0
      K=0
      DO 102 I=1,5
      A=0.0$P 0
      P=0.0$P 0
      DO 101 J=1,N
      A=A+Y(K+J)*X(J)**(1.0$P 0-Y(I+80))
      P=P+Y(K+J+40)*X(J)
  101 CONTINUE
      FA=FA+Y(K+KA)*P/(X(KA)**Y(I+80)*A)-Y(K+KA+40)
      K=K+N
  102 CONTINUE
      RETURN
  190 FA=X(1)**2+X(2)**2+X(1)*X(2)-1.4$P 1*X(1)-1.6$P 1*X(2)+
     &(X(3)-1.0$P 1)**2+4.0$P 0*(X(4)-5.0$P 0)**2+(X(5)-3.0$P 0)**2+
     &2.0$P 0*(X(6)-1.0$P 0)**2+5.0$P 0*X(7)**2+7.0$P 0*(X(8)-
     &1.1$P 1)**2+2.0$P 0*(X(9)-1.0$P 1)**2+(X(10)-7.0$P 0)**2+4.5$P 1
      GO TO (191,192,193,194,195,196),KA
  191 CONTINUE
      RETURN
  192 FA=FA+1.0$P 1*(3.0$P 0*(X(1)-2.0$P 0)**2+4.0$P 0*(X(2)-
     &3.0$P 0)**2+2.0$P 0*X(3)**2-7.0$P 0*X(4)-1.2$P 2)
      RETURN
  193 FA=FA+1.0$P 1*(5.0$P 0*X(1)**2+8.0$P 0*X(2)+(X(3)-6.0$P 0)**2-
     &2.0$P 0*X(4)-4.0$P 1)
      RETURN
  194 FA=FA+1.0$P 1*(0.5$P 0*(X(1)-8.0$P 0)**2+2.0$P 0*(X(2)-
     &4.0$P 0)**2+3.0$P 0*X(5)**2-X(6)-3.0$P 1)
      RETURN
  195 FA=FA+1.0$P 1*(X(1)**2+2.0$P 0*(X(2)-2.0$P 0)**2-
     &2.0$P 0*X(1)*X(2)+1.4$P 1*X(5)-6.0$P 0*X(6))
      RETURN
  196 FA=FA+1.0$P 1*(6.0$P 0*X(2)-3.0$P 0*X(1)+1.2$P 1*(X(9)-
     &8.0$P 0)**2-7.0$P 0*X(10))
      RETURN
  200 FA=X(1)**2+X(2)**2+X(1)*X(2)-1.4$P 1*X(1)-1.6$P 1*X(2)+(X(3)-
     &1.0$P 1)**2+4.0$P 0*(X(4)-5.0$P 0)**2+(X(5)-3.0$P 0)**2+2.0$P 0*
     &(X(6)-1.0$P 0)**2+5.0$P 0*X(7)**2+7.0$P 0*(X(8)-1.1$P 1)**2+
     &2.0$P 0*(X(9)-1.0$P 1)**2+(X(10)-7.0$P 0)**2+(X(11)-9.0$P 0)**2+
     &1.0$P 1*(X(12)-1.0$P 0)**2+5.0$P 0*(X(13)-7.0$P 0)**2+4.0$P 0*
     &(X(14)-1.4$P 1)**2+2.7$P 1*(X(15)-1.0$P 0)**2+X(16)**4+(X(17)-
     &2.0$P 0)**2+1.3$P 1*(X(18)-2.0$P 0)**2+(X(19)-3.$P 0)**2+X(20)**2+
     &9.5$P 1
      GO TO (191,192,193,194,195,196,202,203,204,205,206,207,208,209),KA
  202 FA=FA+1.0$P 1*(X(1)**2+1.5$P 1*X(11)-8.0$P 0*X(12)-2.8$P 1)
      RETURN
  203 FA=FA+1.0$P 1*(4.0$P 0*X(1)+9.0$P 0*X(2)+5.0$P 0*X(13)**2-9.0$P 0*
     &X(14)-8.7$P 1)
      RETURN
  204 FA=FA+1.0$P 1*(3.0$P 0*X(1)+4.0$P 0*X(2)+3.0$P 0*(X(13)-
     16.0$P 0)**2-1.4$P 1*X(14)-1.0$P 1)
      RETURN
  205 FA=FA+1.0$P 1*(1.4$P 1*X(1)**2+3.5$P 1*X(15)-7.9$P 1*X(16)-
     &9.2$P 1)
      RETURN
  206 FA=FA+1.0$P 1*(1.5$P 1*X(2)**2+1.1$P 1*X(15)-6.1$P 1*X(16)-
     &5.4$P 1)
      RETURN
  207 FA=FA+1.0$P 1*(5.0$P 0*X(1)**2+2.0$P 0*X(2)+9.0$P 0*X(17)**4-
     &X(18)-6.8$P 1)
      RETURN
  208 FA=FA+1.0$P 1*(X(1)**2-X(2)+1.9$P 1*X(19)-2.0$P 1*X(20)+1.9$P 1)
      RETURN
  209 FA=FA+1.0$P 1*(7.0$P 0*X(1)**2+5.0$P 0*X(2)**2+X(19)**2-3.0$P 1*
     &X(20))
      RETURN
   60 FA=-1.0$P 0
      DO 61 I=1,N
      FA=FA+X(I)
   61 CONTINUE
      IF (MOD(KA,2).EQ.0) THEN
      I=(KA+2)/2
      FA=FA+X(I)*(X(I)-1.0$P 0)
      ELSE
      I=(KA+1)/2
      FA=FA+X(I)*(2.0$P 0*X(I)-1.0$P 0)
      ENDIF
      RETURN
   70 K=(N-1)/2
      A=Y(KA)
      S=1.0$P 0
      IF (KA.GT.62.AND.KA.LT.124) S=-S
      P=-8.0$P 0*LOG(A)
      A=A*A
      DO 71 I=1,K
      B=X(I+K)**2-A
      P=P+LOG(B*B+A*X(I)**2)
   71 CONTINUE
      FA=(0.5$P 0*P-X(N))*S
      IF (KA.EQ.1.OR.KA.EQ.124) FA=FA+3.0164$P 0
      RETURN
   90 P=5.0$P 2
      A=0.99$P 0
      FA=5.04$P 0*X(1)+0.35$P-1*X(2)+1.00$P 1*X(3)+3.36$P 0*X(5)-
     & 0.63$P-1*X(4)*X(7)
      GO TO (91,92,93,94,95,96,97,98,99),KA
   91 CONTINUE
      RETURN
   92 FA=FA+P*(1.12$P 0*X(1)+X(1)*X(8)*(1.3167$P-1-6.67$P-3*X(8))-
     & X(4)/A)
      RETURN
   93 FA=FA-P*(1.12$P 0*X(1)+X(1)*X(8)*(1.3167$P-1-6.67$P-3*X(8))-
     & X(4)*A)
      RETURN
   94 FA=FA+P*(57.425$P 0+X(8)*(1.098$P 0-0.038$P 0*X(8))+
     & 0.325$P 0*X(6)-X(7)/A)
      RETURN
   95 FA=FA-P*(57.425$P 0+X(8)*(1.098$P 0-0.038$P 0*X(8))+
     & 0.325$P 0*X(6)-X(7)*A)
      RETURN
   96 FA=FA+P*(9.8$P 4*X(3)/(X(4)*X(9)+1.0$P 3*X(3))-X(6))
      RETURN
   97 FA=FA-P*(9.8$P 4*X(3)/(X(4)*X(9)+1.0$P 3*X(3))-X(6))
      RETURN
   98 FA=FA+P*((X(2)+X(5))/X(1)-X(8))
      RETURN
   99 FA=FA-P*((X(2)+X(5))/X(1)-X(8))
      RETURN
  130 P=1.0$P 5
      FA=Y(1)*X(1)+Y(2)*X(1)*X(6)+Y(3)*X(3)+Y(4)*X(2)+Y(5)+
     & Y(6)*X(3)*X(5)
      GO TO (131,132,133,134,135,136,137,138,105,106,107,108,109),KA
  131 CONTINUE
      RETURN
  132 FA=FA+P*(Y(7)*X(6)**2+Y(8)*X(3)/X(1)+Y(9)*X(6)-1.0$P 0)
      RETURN
  133 FA=FA+P*((Y(10)+Y(11)*X(6)+Y(12)*X(6)**2)*X(1)/X(3)-1.0$P 0)
      RETURN
  134 FA=FA+P*(Y(13)*X(6)**2+Y(14)*X(5)+Y(15)*X(4)+Y(16)*X(6)-1.0$P 0)
      RETURN
  135 FA=FA+P*((Y(17)+Y(18)*X(6)+Y(19)*X(4)+Y(20)*X(6)**2)/X(5)-1.0$P 0)
      RETURN
  136 FA=FA+P*(Y(21)*X(7)+(Y(22)/X(4)+Y(23))*X(2)/X(3)-1.0$P 0)
      RETURN
  137 FA=FA+P*((Y(24)+(Y(25)+Y(26)/X(4))*X(2)/X(3))/X(7)-1.0$P 0)
      RETURN
  138 FA=FA+P*((Y(27)+Y(28)*X(7))/X(5)-1.0$P 0)
      RETURN
  105 FA=FA+P*((Y(33)*X(1)+Y(34))/X(3)-1.0$P 0)
      RETURN
  106 FA=FA+P*((Y(35)/X(4)+Y(36))*X(2)/X(3)-1.0$P 0)
      RETURN
  107 FA=FA+P*((Y(37)+Y(38)*X(3)/X(2))*X(4)-1.0$P 0)
      RETURN
  108 FA=FA+P*(Y(39)*X(1)*X(6)+Y(40)*X(1)+Y(41)*X(3)-1.0$P 0)
      RETURN
  109 FA=FA+P*((Y(42)*X(3)+Y(43))/X(1)+Y(44)*X(6)-1.0$P 0)
      RETURN
  150 P=1.0$P 5
      FA=X(1)+X(2)+X(3)
      GO TO (151,152,153,154),KA
  151 CONTINUE
      RETURN
  152 FA=FA+P*((833.33252$P 0*X(4)/X(1)+1.0$P 2-
     & 83333.333$P 0/X(1))/X(6)-1.0$P 0)
      RETURN
  153 FA=FA+P*((1.25$P 3*(X(5)-X(4))/X(2)+X(4))/X(7)-1.0$P 0)
      RETURN
  154 FA=FA+P*(((1.25$P 6-2.5$P 3*X(5))/X(3)+X(5))/X(8)-1.0$P 0)
      RETURN
  170 P=1.0$P 3
      FA=1.262626$P 0*(X(12)+X(13)+X(14)+X(15)+X(16))-
     & 1.231060$P 0*(X(1)*X(12)+X(2)*X(13)+X(3)*X(14)+X(4)*X(15)+
     & X(5)*X(16))
      GO TO (171,172,173,174,175,176,177,178,179,116,117,118,128,
     & 129,146,147,148,149,159),KA
  171 CONTINUE
      RETURN
  172 FA=FA+P*(X(1)*(9.75$P-1+(3.475$P-2-9.75$P-3*X(1))/X(6))-1.0$P 0)
      RETURN
  173 FA=FA+P*(X(2)*(9.75$P-1+(3.475$P-2-9.75$P-3*X(2))/X(7))-1.0$P 0)
      RETURN
  174 FA=FA+P*(X(3)*(9.75$P-1+(3.475$P-2-9.75$P-3*X(3))/X(8))-1.0$P 0)
      RETURN
  175 FA=FA+P*(X(4)*(9.75$P-1+(3.475$P-2-9.75$P-3*X(4))/X(9))-1.0$P 0)
      RETURN
  176 FA=FA+P*(X(5)*(9.75$P-1+(3.475$P-2-9.75$P-3*X(5))/X(10))-1.0$P 0)
      RETURN
  177 FA=FA+P*((X(6)+(X(1)-X(6))*X(12)/X(11))/X(7)-1.0$P 0)
      RETURN
  178 FA=FA+P*(((X(7)+2.0$P-3*(X(7)-X(1))*X(12))/X(8)+
     & 2.0$P-3*X(13)*(X(2)/X(8)-1.0$P 0))-1.0$P 0)
      RETURN
  179 FA=FA+P*(X(8)+X(9)+2.0$P-3*X(13)*(X(8)-X(2))+
     & 2.0$P-3*X(14)*(X(3)-X(9))-1.0$P 0)
      RETURN
  116 FA=FA+P*((X(9)+((X(4)-X(8))*X(15)+
     & 5.0$P 2*(X(10)-X(9)))/X(14))/X(3)-1.0$P 0)
      RETURN
  117 FA=FA+P*((X(10)/X(4)+(X(5)/X(4)-1.0$P 0)*X(16)/X(15)+
     & 5.0$P 2*(1.0$P 0-X(10)/X(4))/X(15))-1.0$P 0)
      RETURN
  118 FA=FA+P*(9.0$P-1/X(4)+2.0$P-3*X(16)*(1.0$P 0-X(5)/X(4))-1.0$P 0)
      RETURN
  128 FA=FA+P*(X(12)/X(11)-1.0$P 0)
      RETURN
  129 FA=FA+P*(X(4)/X(5)-1.0$P 0)
      RETURN
  146 FA=FA+P*(X(3)/X(4)-1.0$P 0)
      RETURN
  147 FA=FA+P*(X(2)/X(3)-1.0$P 0)
      RETURN
  148 FA=FA+P*(X(1)/X(2)-1.0$P 0)
      RETURN
  149 FA=FA+P*(X(9)/X(10)-1.0$P 0)
      RETURN
  159 FA=FA+P*X(8)/X(9)-P
      RETURN
  120 P=1.0$P 4
      FA=Y(1)*X(3)**2+Y(2)*X(1)*X(5)+Y(3)*X(1)+Y(4)
      GO TO (121,122,123,124,125,126,127),KA
  121 CONTINUE
      RETURN
  122 FA=FA+P*(Y(5)*X(3)*X(5)+Y(6)*X(2)*X(5)+Y(7)*X(1)*X(4)-1.0$P 0)
      RETURN
  123 FA=FA+P*(Y(8)*X(2)*X(5)+Y(9)*X(1)*X(4)+Y(10)*X(3)*X(5)-1.0$P 0)
      RETURN
  124 FA=FA+P*((Y(11)/X(2)+Y(12)*X(1)+Y(13)*X(3)**2/X(2))/X(5)-1.0$P 0)
      RETURN
  125 FA=FA+P*(Y(14)*X(2)*X(5)+Y(15)*X(1)*X(2)+Y(16)*X(3)**2-1.0$P 0)
      RETURN
  126 FA=FA+P*((Y(17)/X(3)+Y(18)*X(1)+Y(19)*X(4))/X(5)-1.0$P 0)
      RETURN
  127 FA=FA+P*(Y(20)*X(3)*X(5)+Y(21)*X(1)*X(3)+Y(22)*X(3)*X(4)-1.0$P 0)
      RETURN
  140 P=1.0$P 2
      S=6.7$P-1
      A=0.0588$P 0
      FA=4.0$P-1*(X(1)/X(7))**S+4.0$P-1*(X(2)/X(8))**S+1.0$P 1-X(1)-X(2)
      GO TO (141,142,143,144,145),KA
  141 CONTINUE
      RETURN
  142 FA=FA+P*(A*X(5)*X(7)+1.0$P-1*X(1)-1.0$P 0)
      RETURN
  143 FA=FA+P*(A*X(6)*X(8)+1.0$P-1*(X(1)+X(2))-1.0$P 0)
      RETURN
  144 FA=FA+P*(4.0$P 0*X(3)/X(5)+2.0$P 0/(X(3)**0.71$P 0*X(5))+
     & A*X(7)/X(3)**1.3$P 0-1.0$P 0)
      RETURN
  145 FA=FA+P*(4.0$P 0*X(4)/X(6)+2.0$P 0/(X(4)**0.71$P 0*X(6))+
     & A*X(8)/X(4)**1.3$P 0-1.0$P 0)
      RETURN
  160 P=1.0$P 4
      FA=X(11)+X(12)+X(13)
      GO TO (161,162,163,164,165,166,167,168,169,84,85,86,87),KA
  161 CONTINUE
      RETURN
  162 FA=FA+P*((1.262626$P 0-1.231059$P 0*X(1))*X(8)/X(11)-1.0$P 0)
      RETURN
  163 FA=FA+P*((1.262626$P 0-1.231059$P 0*X(2))*X(9)/X(12)-1.0$P 0)
      RETURN
  164 FA=FA+P*((1.262626$P 0-1.231059$P 0*X(3))*X(10)/X(13)-1.0$P 0)
      RETURN
  165 FA=FA+P*(X(1)*(9.75$P-1+(3.475$P-2-9.75$P-3*X(1))/X(4))-1.0$P 0)
      RETURN
  166 FA=FA+P*(X(2)*(9.75$P-1+(3.475$P-2-9.75$P-3*X(2))/X(5))-1.0$P 0)
      RETURN
  167 FA=FA+P*(X(3)*(9.75$P-1+(3.475$P-2-9.75$P-3*X(3))/X(6))-1.0$P 0)
      RETURN
  168 FA=FA+P*((X(4)+(X(1)-X(4))*X(8)/X(7))/X(5)-1.0$P 0)
      RETURN
  169 FA=FA+P*(X(6)+X(5)+2.0$P-3*X(9)*(X(2)-X(6))+
     & 2.0$P-3*X(8)*(X(5)-X(1))-1.0$P 0)
      RETURN
   84 FA=FA+P*((X(6)/X(2)+(X(3)/X(2)-1.0$P 0)*X(10)/X(9)+
     & 5.0$P 2*(1.0$P 0-X(6)/X(2))/X(9))-1.0$P 0)
      RETURN
   85 FA=FA+P*(0.9$P 0/X(2)+2.0$P-3*X(10)*(1.0$P 0-X(3)/X(2))-1.0$P 0)
      RETURN
   86 FA=FA+P*(X(2)/X(3)-1.0$P 0)
      RETURN
   87 FA=FA+P*(X(1)/X(2)-1.0$P 0)
      RETURN
  110 P=1.0$P 4
      FA=1.0$P 5
      DO 111 I=1,11
      FA=FA*X(I)**Y(30+I)
  111 CONTINUE
      GO TO (112,113,114,115),KA
  112 CONTINUE
      RETURN
  113 FA=FA+P*(Y(1)*X(1)+Y(2)*X(2)+Y(3)*X(3)+Y(4)*X(4)*X(5)-1.0$P 0)
      RETURN
  114 FA=FA+P*(Y(5)*X(1)+Y(6)*X(2)+Y(7)*X(3)+
     & Y(8)*X(4)*X(12)+Y(9)*X(5)/X(12)+Y(10)*X(6)/X(12)+
     & Y(11)*X(7)*X(12)+Y(12)*X(4)*X(5)+
     & Y(13)*X(2)*X(5)/X(12)+Y(14)*X(2)*X(4)*X(5)+
     & Y(15)*X(2)*X(5)/(X(4)*X(12)**2)+Y(16)*X(10)/X(12)-
     & 1.0$P 0)
      RETURN
  115 FA=FA+P*(Y(17)*X(1)+Y(18)*X(2)+Y(19)*X(3)+Y(20)*X(4)+
     & Y(21)*X(5)+Y(22)*X(6)+Y(23)*X(8)+Y(24)*X(4)*X(5)+
     & Y(25)*X(2)*X(5)+Y(26)*X(2)*X(4)*X(5)+
     & Y(27)*X(2)*X(5)/X(4)+Y(28)*X(9)+Y(29)*X(1)*X(9)+
     & Y(30)*X(11)-1.0$P 0)
      RETURN
      END


