* SUBROUTINE EAFU39             ALL SYSTEMS                 99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF TEST FUNCTIONS FOR COMPLEMENTARITY PROBLEMS.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  KA  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  FA  VALUE OF THE APPROXIMATED FUNCTION AT THE
*          SELECTED POINT.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EAFU39(N,KA,X,FA,NEXT)
      INTEGER N,KA,NEXT,I
      $FLOAT X(N),FA
      INTEGER T(33),B(33)
      INTEGER ARCSNETI(14),ARCSNETJ(14),XNET(8),YNET(8)
      INTEGER ARCSFLI(44),ARCSFLJ(44),XFL(28),YFL(28)
      $FLOAT HEIGHTNET(8),WCOSTNET(2),PCOSTNET(2)
      $FLOAT HEIGHTFL(28),WCOSTFL(9),PCOSTFL(9)
      $FLOAT DIST(44),DPRC,CPOW
C
      DATA (T(I),I=1,33) / 5,6,3,9,9,4,2,8,6,7,4,8,2,4,3,6,8,6,
     &                     2,5,3,5,4,3,2,7,8,5,3,9,7,5,6 /
      DATA (B(I),I=1,33)
     & / 12,18,35,35,20,11,11,26,33,32,26,30,19,36,25,24,39,43,
     &   22,43,32,52,41,35,21,36,42,31,23,26,37,26,42 /
      DATA (ARCSNETI(I),I=1,14) / 1,1,1,2,2,2,2,3,3,3,3,6,6,5 /
      DATA (ARCSNETJ(I),I=1,14) / 4,3,8,8,3,6,7,4,5,6,8,7,5,4 /
      DATA (XNET(I),I=1,8) / 1200,4000,2000,750,900,2000,4000,3700 /
      DATA (YNET(I),I=1,8) / 3600,2200,2300,2400,1200,1000,900,3500 /
      DATA (ARCSFLI(I),I=1,44)
     & / 1,1,2,2,2,3,3,3,3,4,4,4,4,5,5,5,5,6,6,6,7,7,
     &   7,8,8,9,9,10,13,14,14,15,15,16,18,19,20,22,23,23,25,27,27,28 /
      DATA (ARCSFLJ(I),I=1,44) / 10,16,11,12,17,16,14,17,20,15,18,19,
     & 22,19,21,22,24,21,25,26,24,26,28,23,25,27,28,11,12,16,10,17,13,
     & 20,13,17,21,18,20,25,28,22,24,27 /
      DATA (XFL(I),I=1,28) / 500,3250,1750,5500,4250,2000,4000,500,6750,
     & 1000,2500,4250,6250,1500,5250,500,3000,6750,4250,
     & 1500,3000,6250,1000,5000,1500,2750,6000,4000 /
      DATA (YFL(I),I=1,28) / 5750,6000,4250,4250,2750,2000,1500,500,250,
     & 6500,6600,6250,6250,5500,5250,4000,4500,4500,3750,
     & 3000,2500,2750,2000,2000,1000,1250,1000,250 /
      DATA (HEIGHTNET(I),I=1,8)
     & / 6.5,3.25,3.02,5.16,4.2,1.5,0.0,6.3 /
      DATA (WCOSTNET(I),I=1,2) / 0.2,0.17 /
      DATA (PCOSTNET(I),I=1,2) / 1.02,1.02 /
      DATA (HEIGHTFL(I),I=1,28) / 8.0,3.9,5.5,4.5,4.1,6.5,4.4,8.1,5.2,
     & 7.1,5.1,1.5,2.1,7.2,3.2,6.4,2.4,3.2,3.0,5.6,5.0,3.6,7.2,3.1,7.1,
     & 5.9,4.3,6.2 /
      DATA (WCOSTFL(I),I=1,9)
     & / 0.29,0.23,0.13,0.14,0.06,0.19,0.09,0.28,0.21 /
      DATA (PCOSTFL(I),I=1,9)
     & / 1.02,1.03,1.04,1.01,1.00,1.03,1.05,1.07,1.09 /
C
      GOTO (10,20,30,40), NEXT
   10      FA=T(KA)*(1 + 0.15 * ( X(KA)/B(KA) )**4)
      RETURN
   20 FA=T(KA)*(1 + 0.15 * ( X(KA)/B(KA) )**4)
      RETURN
   30 DO I=1,14
        DIST(I) = SQRT(FLOAT(XNET(ARCSNETI(I))-XNET(ARCSNETJ(I)))**2 +
     &                 FLOAT(YNET(ARCSNETI(I))-YNET(ARCSNETJ(I)))**2)
      ENDDO
      DPRC = 6.9D-2
      CPOW = 1.29
         IF (KA.LE.14) THEN
        FA=X(KA)+X(KA+14)
      ELSEIF (KA.LE.28) THEN
        FA=DPRC*DIST(KA-14)*X(KA+14)**CPOW
      ELSEIF (KA.LE.30) THEN
        FA=X(KA+22)*PCOSTNET(KA-28)*(X(KA+14)-HEIGHTNET(KA-28))*1.0D1
      ELSE
        FA=X(KA+20)*WCOSTNET(KA-30)*1.0D1
      ENDIF
      RETURN
   40 DO I=1,44
        DIST(I) = SQRT(FLOAT(XFL(ARCSFLI(I))-XFL(ARCSFLJ(I)))**2 +
     &                 FLOAT(YFL(ARCSFLI(I))-YFL(ARCSFLJ(I)))**2)
      ENDDO
      DPRC = 6.9D-2
      CPOW = 1.29
      IF (KA.LE.44) THEN
        FA=X(KA)+X(KA+44)
      ELSEIF (KA.LE.88) THEN
        FA=DPRC*DIST(KA-44)*X(KA+44)**CPOW
      ELSEIF (KA.LE.97) THEN
        FA=X(KA+72)*PCOSTFL(KA-88)*(X(KA+44)-HEIGHTFL(KA-88))*1.0D1
      ELSE
        FA=X(KA+63)*WCOSTFL(KA-97)*1.0D1
      ENDIF
      RETURN
      END
