* SUBROUTINE EAGU14                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 RA : ORIGINAL VERSION
*
* PURPOSE :
*  GRADIENTS OF MODEL FUNCTIONS FOR UNCONSTRAINED MINIMIZATION.
*  SPARSE VERSION - LU VERSION WITH MODIFIED TESTS NO 7-10,12.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  G(N)  GRADIENT OF THE MODEL FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EAGU14(N,KA,X,GA,NEXT)
      INTEGER N,NEXT
      $FLOAT X(N),GA(N)
      $FLOAT A,B,C,D,P,Q,R,U,V
      INTEGER I,J,K,KA
      GO TO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     & 170,180,190,200,210,220),NEXT
   10 A=X(KA)**2-X(KA+1)
      B=X(KA)-1.0$P 0
      GA(KA)=4.0$P 2*X(KA)*A+2.0$P 0*B
      GA(KA+1)=-2.0$P 2*A
      RETURN
   20 I=2*KA-1
      A=X(I)**2-X(I+1)
      B=X(I)-1.0$P 0
      C=X(I+2)**2-X(I+3)
      D=X(I+2)-1.0$P 0
      U=X(I+1)+X(I+3)-2.0$P 0
      V=X(I+1)-X(I+3)
      GA(I)=4.0$P 2*X(I)*A+2.0$P 0*B
      GA(I+1)=-2.0$P 2*A+2.0$P 1*U+0.2$P 0*V
      GA(I+2)=3.6$P 2*X(I+2)*C+2.0$P 0*D
      GA(I+3)=-1.8$P 2*C+2.0$P 1*U-0.2$P 0*V
      RETURN
   30 I=2*KA-1
      A=X(I)+1.0$P 1*X(I+1)
      B=X(I+2)-X(I+3)
      C=X(I+1)-2.0$P 0*X(I+2)
      D=X(I)-X(I+3)
      GA(I)=2.0$P 0*A+4.0$P 1*D**3
      GA(I+1)=2.0$P 1*A+4.0$P 0*C**3
      GA(I+2)=-8.0$P 0*C**3+1.0$P 1*B
      GA(I+3)=-4.0$P 1*D**3-1.0$P 1*B
      RETURN
   40 I=2*KA-1
      A=EXP(X(I))
      B=A-X(I+1)
      B=4.0$P 0*B**3
      D=X(I+1)-X(I+2)
      D=6.0$P 2*D**5
      P=X(I+2)-X(I+3)
      C=COS(P)
      Q=SIN(P)/COS(P)
      Q=4.0$P 0*Q**3/C**2
      U=X(I)
      V=X(I+3)-1.0$P 0
      GA(I)=A*B+8.0$P 0*U**7
      GA(I+1)=D-B
      GA(I+2)=Q-D
      GA(I+3)=2.0$P 0*V-Q
      RETURN
   50 P=7.0$P 0/3.0$P 0
      A=(3.0$P 0-2.0$P 0*X(KA))*X(KA)+1.0$P 0
      IF (KA.GT.1) A=A-X(KA-1)
      IF (KA.LT.N) A=A-X(KA+1)
      B=P*ABS(A)**(P-1.0$P 0)*SIGN(1.0$P 0,A)
      GA(KA)=B*(3.0$P 0-4.0$P 0*X(KA))
      IF (KA.GT.1) GA(KA-1)=-B
      IF (KA.LT.N) GA(KA+1)=-B
      RETURN
   60 P=7.0$P 0/3.0$P 0
      A=(2.0$P 0+5.0$P 0*X(KA)**2)*X(KA)+1.0$P 0
      DO 61 I=MAX(1,KA-5),MIN(N,KA+1)
      A=A+X(I)*(1.0$P 0+X(I))
   61 CONTINUE
      B=P*ABS(A)**(P-1.0$P 0)*SIGN(1.0$P 0,A)
      DO 62 I=MAX(1,KA-5),MIN(N,KA+1)
      GA(I)=B*(1.0$P 0+2.0$P 0*X(I))
   62 CONTINUE
      GA(KA)=GA(KA)+B*(2.0$P 0+1.5$P 1*X(KA)**2)
      RETURN
   70 P=7.0$P 0/3.0$P 0
      IF (KA.LE.N) THEN
        A=(3.0$P 0-2.0$P 0*X(KA))*X(KA)+1.0$P 0
        IF (KA.GT.1) A=A-X(KA-1)
        IF (KA.LT.N) A=A-X(KA+1)
        B=P*ABS(A)**(P-1.0$P 0)*SIGN(1.0$P 0,A)
        GA(KA)=B*(3.0$P 0-4.0$P 0*X(KA))
        IF (KA.GT.1) GA(KA-1)=-B
        IF (KA.LT.N) GA(KA+1)=-B
      ELSE
        I=KA-N
        A=X(I)+X(I+N/2)
        B=P*ABS(A)**(P-1.0$P 0)*SIGN(1.0$P 0,A)
        GA(I)=B
        GA(I+N/2)=B
      ENDIF
      RETURN
   80 K=N/2
      P=0.0$P 0
      DO 81 I=KA-2,KA+2
      IF (I.LT.1.OR.I.GT.N) GO TO 81
      A=5.0$P 0*(1.0$P 0+MOD(I,5)+MOD(KA,5))
      B=$DBLE(I+KA)/1.0$P 1
      P=P+A*SIN(X(I))+B*COS(X(I))
   81 CONTINUE
      IF (KA.GT.K) THEN
      I=KA-K
      A=5.0$P 0*(1.0$P 0+MOD(I,5)+MOD(KA,5))
      B=$DBLE(I+KA)/1.0$P 1
      P=P+A*SIN(X(I))+B*COS(X(I))
      ELSE
      I=KA+K
      A=5.0$P 0*(1.0$P 0+MOD(I,5)+MOD(KA,5))
      B=$DBLE(I+KA)/1.0$P 1
      P=P+A*SIN(X(I))+B*COS(X(I))
      ENDIF
      P=2.0$P 0*($DBLE(N+KA)-P)/$DBLE(N)
      DO 82 I=KA-2,KA+2
      IF (I.LT.1.OR.I.GT.N) GO TO 82
      A=5.0$P 0*(1.0$P 0+MOD(I,5)+MOD(KA,5))
      B=$DBLE(I+KA)/1.0$P 1
      GA(I)=-P*(A*COS(X(I))-B*SIN(X(I)))
   82 CONTINUE
      IF (KA.GT.K) THEN
      I=KA-K
      A=5.0$P 0*(1.0$P 0+MOD(I,5)+MOD(KA,5))
      B=$DBLE(I+KA)/1.0$P 1
      GA(I)=-P*(A*COS(X(I))-B*SIN(X(I)))
      ELSE
      I=KA+K
      A=5.0$P 0*(1.0$P 0+MOD(I,5)+MOD(KA,5))
      B=$DBLE(I+KA)/1.0$P 1
      GA(I)=-P*(A*COS(X(I))-B*SIN(X(I)))
      ENDIF
      RETURN
   90 K=N/2
      P=1.0$P 0/$DBLE(N)
      DO 91 I=KA-2,KA+2
      IF (I.LT.1.OR.I.GT.N) GO TO 91
      A=5.0$P 0*(1.0$P 0+MOD(I,5)+MOD(KA,5))
      B=DBLE(I+KA)/1.0D 1
      GA(I)=P*(A*COS(X(I))-B*SIN(X(I)))
   91 CONTINUE
      IF (KA.GT.K) THEN
      I=KA-K
      A=5.0$P 0*(1.0$P 0+MOD(I,5)+MOD(KA,5))
      B=$DBLE(I+KA)/1.0$P 1
      GA(I)=P*(A*COS(X(I))-B*SIN(X(I)))
      ELSE
      I=KA+K
      A=5.0$P 0*(1.0$P 0+MOD(I,5)+MOD(KA,5))
      B=$DBLE(I+KA)/1.0$P 1
      GA(I)=P*(A*COS(X(I))-B*SIN(X(I)))
      ENDIF
      GA(KA)=GA(KA)+P*$DBLE(KA)*SIN(X(KA))
      RETURN
  100 K=N/2
      GA(KA)=0.0$P 0
      Q=1.0$P 0+$DBLE(KA)/1.0$P 1
      DO 101 I=KA-2,KA+2
      IF (I.LT.1.OR.I.GT.N) GO TO 101
      A=5.0$P 0*(1.0$P 0+MOD(I,5)+MOD(KA,5))
      B=1.0$P 0+$DBLE(I)/1.0$P 1
      C=$DBLE(I+KA)/1.0$P 1
      P=A*COS(Q*X(KA)+B*X(I)+C)/$DBLE(N)
      GA(KA)=GA(KA)+P*Q
      IF (I.EQ.KA) THEN
      GA(I)=GA(I)+P*B
      ELSE
      GA(I)=P*B
      ENDIF
  101 CONTINUE
      IF (KA.GT.K) THEN
      I=KA-K
      A=5.0$P 0*(1.0$P 0+MOD(I,5)+MOD(KA,5))
      B=1.0$P 0+$DBLE(I)/1.0$P 1
      C=$DBLE(I+KA)/1.0$P 1
      P=A*COS(Q*X(KA)+B*X(I)+C)/$DBLE(N)
      GA(KA)=GA(KA)+P*Q
      GA(I)=P*B
      ELSE
      I=KA+K
      A=5.0$P 0*(1.0$P 0+MOD(I,5)+MOD(KA,5))
      B=1.0$P 0+$DBLE(I)/1.0$P 1
      C=$DBLE(I+KA)/1.0$P 1
      P=A*COS(Q*X(KA)+B*X(I)+C)/$DBLE(N)
      GA(KA)=GA(KA)+P*Q
      GA(I)=P*B
      ENDIF
      RETURN
  110 P=-0.2008$P-2
      Q=-0.1900$P-2
      R=-0.0261$P-2
      I=5*(KA-1)
      A=1.0$P 0
      B=0.0$P 0
      DO 111 J=1,5
      A=A*X(I+J)
      B=B+X(I+J)**2
  111 CONTINUE
      A=A*EXP(A)
      B=B-1.0$P 1-P
      C=X(I+2)*X(I+3)-5.0$P 0*X(I+4)*X(I+5)-Q
      D=X(I+1)**3+X(I+2)**3+1.0$P 0-R
      GA(I+1)=A/X(I+1)+2.0$P 1*(2.0$P 0*B*X(I+1)
     &       +3.0$P 0*D*X(I+1)**2)
      GA(I+2)=A/X(I+2)+2.0$P 1*(2.0$P 0*B*X(I+2)
     &       +C*X(I+3)+3.0$P 0*D*X(I+2)**2)
      GA(I+3)=A/X(I+3)+2.0$P 1*(2.0$P 0*B*X(I+3)+C*X(I+2))
      GA(I+4)=A/X(I+4)+2.0$P 1*(2.0$P 0*B*X(I+4)
     &       -5.0$P 0*C*X(I+5))
      GA(I+5)=A/X(I+5)+2.0$P 1*(2.0$P 0*B*X(I+5)-5.0$P 0*C*X(I+4))
      RETURN
  120 A=X(KA)-3.0$P 0
      B=X(KA)-X(KA+1)
      GA(KA)=2.0$P 0*A+2.0$P 0*B+2.0$P 1*EXP(2.0$P 1*B)
      GA(KA+1)=-2.0$P 0*B-2.0$P 1*EXP(2.0$P 1*B)
      RETURN
  130 A=X(KA+1)**2
      B=X(KA)**2
      C=A+1.0$P 0
      D=B+1.0$P 0
      P=0.0$P 0
      IF (A.GT.P) P=LOG(A)
      Q=0.0$P 0
      IF (B.GT.Q) Q=LOG(B)
      GA(KA)=2.0$P 0*X(KA)*(C*B**A+P*A**D)
      GA(KA+1)=2.0$P 0*X(KA+1)*(D*A**B+Q*B**C)
      RETURN
  140 P=1.0$P 0/$DBLE(N+1)
      Q=0.5$P 0*P**2
      A=2.0$P 0*X(KA)+Q*(X(KA)+$DBLE(KA)*P+1.0$P 0)**3
      IF(KA.GT.1) A=A-X(KA-1)
      IF(KA.LT.N) A=A-X(KA+1)
      GA(KA)=A*(4.0$P 0+6.0$P 0*Q*(X(KA)+$DBLE(KA)*P+1.0$P 0)**2.0$P 0)
      IF(KA.GT.1) GA(KA-1)=-2.0$P 0*A
      IF(KA.LT.N) GA(KA+1)=-2.0$P 0*A
      RETURN
  150 P=1.0$P 0/$DBLE(N+1)
      Q=2.0$P 0/P
      R=2.0$P 0*P
      A=X(KA)-X(KA+1)
      GA(KA)=Q*(2.0$P 0*X(KA)-X(KA+1))
      GA(KA+1)=-Q*X(KA)
      IF (ABS(A).LE.1.0$P-6) THEN
      GA(KA)=GA(KA)+R*EXP(X(KA+1))*(1.0$P 0/2.0$P 0+
     &  A*(1.0$P 0/3.0$P 0+A/8.0$P 0))
      GA(KA+1)=GA(KA+1)+R*EXP(X(KA+1))*(1.0$P 0/2.0$P 0+
     &  A*(1.0$P 0/6.0$P 0+A/24.0$P 0))
      ELSE
      B=EXP(X(KA))-EXP(X(KA+1))
      GA(KA)=GA(KA)+R*(EXP(X(KA))*A-B)/A**2
      GA(KA+1)=GA(KA+1)-R*(EXP(X(KA+1))*A-B)/A**2
      ENDIF
      IF (KA.EQ.1) THEN
      GA(1)=GA(1)+R*(EXP(X(1))*(X(1)-1.0$P 0)+1.0$P 0)/X(1)**2
      ELSEIF (KA.EQ.N-1) THEN
      GA(N)=GA(N)+2.0$P 0*Q*X(N)
     &           +R*(EXP(X(N))*(X(N)-1.0$P 0)+1.0$P 0)/X(N)**2
      ENDIF
      RETURN
  160 A=$DBLE(KA)*SIN(X(KA))
      GA(KA)=A
      IF(KA.GT.1) GA(KA-1)=+$DBLE(KA)*COS(X(KA-1))
      IF(KA.LT.N) GA(KA+1)=-$DBLE(KA)*COS(X(KA+1))
      RETURN
  170 P=1.0$P 0/$DBLE(N+1)
      IF (KA.EQ.1) THEN
      GA(KA)=0.5$P 0*X(KA)/P+P*EXP(X(KA))
      GA(KA+1)=0.25$P 0*X(KA+1)/P
      ELSE IF (KA.EQ.N) THEN
      GA(KA)=0.5$P 0*X(KA)/P+P*EXP(X(KA))
      GA(KA-1)=0.25$P 0*X(KA-1)/P
      ELSE
      A=0.25$P 0*(X(KA+1)-X(KA-1))/P
      GA(KA)=P*EXP(X(KA))
      GA(KA-1)=-A
      GA(KA+1)= A
      ENDIF
      RETURN
  180 P=1.0$P 0/$DBLE(N+1)
      Q=$DBLE(KA)*P
      IF (KA.EQ.1) THEN
      GA(KA)=X(KA)/P-2.0$P 0*P*(X(KA)+Q)
      GA(KA+1)=0.5$P 0*X(KA+1)/P
      ELSE IF (KA.EQ.N) THEN
      GA(KA)=X(KA)/P-2.0$P 0*P*(X(KA)+Q)
      GA(KA-1)=0.5$P 0*X(KA-1)/P
      ELSE
      A=0.5$P 0*(X(KA+1)-X(KA-1))/P
      GA(KA)=-2.0$P 0*P*(X(KA)+Q)
      GA(KA-1)=-A
      GA(KA+1)= A
      ENDIF
      RETURN
  190 P=1.0$P 0/$DBLE(N+1)
      Q=EXP(2.0$P 0*$DBLE(KA)*P)
      IF (KA.EQ.1) THEN
      R=1.0$P 0/3.0$P 0
      A=0.5$P 0*(X(KA+1)-R)/P
      GA(KA)=2.0$P 0*P*(X(KA)+Q)+(X(KA)-R)/P
      GA(KA+1)= A
      ELSE IF (KA.EQ.N) THEN
      R=EXP(2.0$P 0)/3.0$P 0
      A=0.5$P 0*(X(KA-1)-R)/P
      GA(KA)=2.0$P 0*P*(X(KA)+Q)+(X(KA)-R)/P
      GA(KA-1)= A
      ELSE
      A=0.5$P 0*(X(KA+1)-X(KA-1))/P
      GA(KA)=2.0$P 0*P*(X(KA)+Q)
      GA(KA-1)=-A
      GA(KA+1)= A
      ENDIF
      RETURN
  200 P=1.0$P 0/$DBLE(N+1)
      A=EXP(-2.0$P 0*X(KA)**2)
      IF (KA.EQ.1) THEN
      B=0.5$P 0*X(KA+1)/P
      GA(KA)=X(KA)/P-4.0$P 0*X(KA)*A*P*(B**2-1.0$P 0)
      GA(KA+1)= A*B
      ELSE IF (KA.EQ.N) THEN
      B=0.5$P 0*X(KA-1)/P
      GA(KA)=X(KA)/P*EXP(-2.0$P 0)-4.0$P 0*X(KA)*A*P*(B**2-1.0$P 0)
      GA(KA-1)= A*B
      ELSE
      B=0.5$P 0*(X(KA+1)-X(KA-1))/P
      GA(KA)=-4.0$P 0*X(KA)*A*P*(B**2-1.0$P 0)
      GA(KA-1)=-A*B
      GA(KA+1)= A*B
      ENDIF
      RETURN
  210 P=1.0$P 0/$DBLE(N+1)
      IF (KA.EQ.1) THEN
      A=0.5$P 0*(X(KA+1)-1.0$P 0)/P
      B=(X(KA)-1.0$P 0)/P
      U=0.5$P 0*ATAN(A)
      V=0.5$P 0*ATAN(B)
      GA(KA)=2.0$P 0*P*X(KA)+V
      GA(KA+1)= U
      ELSE IF (KA.EQ.N) THEN
      A=0.5$P 0*(2.0$P 0-X(KA-1))/P
      B=(2.0$P 0-X(KA))/P
      U=0.5$P 0*ATAN(A)
      V=0.5$P 0*ATAN(B)
      GA(KA)=2.0$P 0*P*X(KA)-V
      GA(KA-1)=-U
      ELSE
      A=0.5$P 0*(X(KA+1)-X(KA-1))/P
      U=0.5$P 0*ATAN(A)
      GA(KA)=2.0$P 0*P*X(KA)
      GA(KA-1)=-U
      GA(KA+1)= U
      ENDIF
      RETURN
  220 P=1.0$P 0/$DBLE(N+1)
      IF (KA.EQ.1) THEN
      A= 0.5$P 0*X(KA+1)/P
      B= X(KA)/P
      GA(KA)=2.0D 2*P*(X(KA)-A**2)+2.0D 2*B**3-(1.0$P 0-B)
      GA(KA+1)=-2.0D 2*(X(KA)-A**2)*A-(1.0$P 0-A)
      ELSE IF (KA.EQ.N) THEN
      A=-0.5$P 0*X(KA-1)/P
      B=-X(KA)/P
      GA(KA)=2.0D 2*P*(X(KA)-A**2)-2.0D 2*B**3+(1.0$P 0-B)
      GA(KA-1)= 2.0D 2*(X(KA)-A**2)*A+(1.0$P 0-A)
      ELSE
      A=0.5$P 0*(X(KA+1)-X(KA-1))/P
      GA(KA)=2.0D 2*P*(X(KA)-A**2)
      GA(KA-1)= 2.0D 2*(X(KA)-A**2)*A+(1.0$P 0-A)
      GA(KA+1)=-2.0D 2*(X(KA)-A**2)*A-(1.0$P 0-A)
      ENDIF
      RETURN
      END

