* SUBROUTINE EAGU18             ALL SYSTEMS                 92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  GRADIENTS OF TEST FUNCTIONS FOR NONLINEAR EQUATIONS.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  KA  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  GA(N)  GRADIENT OF THE APPROXIMATED FUNCTION AT THE
*          SELECTED POINT.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EAGU18(N,KA,X,GA,NEXT)
      INTEGER N,KA,NEXT
      $FLOAT X(N),GA(N)
      INTEGER I,J,K,L,M,I1,I2,J1,J2,N1,ND,LA
      $FLOAT A,B,A1,A2,A3,A4,AL,AL1,AL2,FF,FG,PAR,PI,BE,BE1,BE2,
     & CA,CB,D1S,D2S,GB,H,H2,S,S1,S2,S3,T,U,V,W,EX,ALFA
      $FLOAT GA1(2),GA2(2),GA3(6),GA4(6)
      COMMON /EMPR18/ PAR,M
      PI=3.14159265358979323846$P 0
      GOTO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     & 170,180,190,200,210,220,230,240,250,260,270,280,290,300,320,
     & 310,420,430,440,450,470,480,490,500,520,530,540,550),
     & NEXT
   10 ALFA=0.5$P 0
      IF (KA.EQ.1) THEN
      GA(1)=-1.0$P 0-4.0$P 0*X(2)
      GA(2)=-4.0$P 0*X(1)
      GA(3)=ALFA-1.0$P 0
      ELSEIF(KA.EQ.2) THEN
      GA(1)=-4.0$P 0*X(2)
      GA(2)=-1.0$P 0-4.0$P 0*X(1)
      GA(4)=-2.0$P 0+ALFA
      ELSEIF(KA.EQ.N-1) THEN
      GA(N-3)=ALFA
      GA(N-1)=-1.0$P 0-4.0$P 0*X(N)
      GA(N)=-4.0$P 0*X(N-1)
      ELSEIF (KA.EQ.N) THEN
      GA(N-2)=ALFA
      GA(N-1)=-4.0$P 0*X(N)
      GA(N)=-1.0$P 0-4.0$P 0*X(N-1)
      ELSEIF (MOD(KA,2).EQ.1) THEN
      GA(KA-2)=ALFA
      GA(KA)=-1.0$P 0-4.0$P 0*X(KA+1)
      GA(KA+1)=-4.0$P 0*X(KA)
      GA(KA+2)=-1.0$P 0+ALFA
      ELSE
      GA(KA-2)=ALFA
      GA(KA-1)=-4.0$P 0*X(KA)
      GA(KA)=-1.0$P 0-4.0$P 0*X(KA-1)
      GA(KA+2)=-2.0$P 0+ALFA
      ENDIF
      RETURN
   20 A1=0.414214$P 0
      IF (KA.EQ.1) THEN
      GA(1)=1.0$P 0+X(3)
      GA(2)=-4.0$P 0*A1
      GA(3)=-1.0$P 0+X(1)
      ELSEIF (KA.EQ.2) THEN
      GA(1)=X(4)
      GA(2)=-4.0$P 0*A1
      GA(4)=-1.0$P 0+X(1)
      ELSEIF (KA.EQ.3) THEN
      GA(1)=A1+X(5)
      GA(2)=-4.0$P 0*X(3)
      GA(3)=-1.0$P 0-4.0$P 0*X(2)
      GA(5)=-1.0$P 0+X(1)
      ELSEIF (KA.LE.N-2) THEN
      GA(1)= X(KA-2)+X(KA+2)
      GA(KA-2)=X(1)
      GA(KA-1)=-4.0$P 0*X(KA)
      GA(KA)=-1.0$P 0-4.0$P 0*X(KA-1)
      GA(KA+2)=-1.0$P 0+X(1)
      ELSEIF (KA.EQ.N-1) THEN
      GA(1)= X(N-3)
      GA(N-3)=X(1)
      GA(N-2)=-4.0$P 0*X(N-1)
      GA(N-1)=-1.0$P 0-4.0$P 0*X(N-2)
      ELSE
      GA(1)= X(N-2)+1.0$P 0
      GA(N-2)=X(1)
      GA(N-1)=-4.0$P 0*X(N)
      GA(N)=-1.0$P 0-4.0$P 0*X(N-1)
      ENDIF
      RETURN
   30 J=(KA-1)/5
      GA(KA)=-$DBLE(J+1)*SIN(X(KA))-COS(X(KA))
      J=J*5
      DO 31 I=J+1,J+5
      IF (I.EQ.KA) THEN
      GA(I)=GA(I)+SIN(X(I))
      ELSE
      GA(I)=SIN(X(I))
      ENDIF
   31 CONTINUE
      RETURN
   40 IF (KA.LT.2) THEN
      D1S=COS(X(KA)-X(KA+1))*SIN(X(KA)+X(KA+1))
      D2S=SIN(X(KA)-X(KA+1))*COS(X(KA)+X(KA+1))
      GA(KA)=9.0$P 0*X(KA)**2+D1S+D2S
      GA(KA+1)=2.0$P 0-D1S+D2S
      ELSE IF (KA.LT.N) THEN
      D1S=COS(X(KA)-X(KA+1))*SIN(X(KA)+X(KA+1))
      D2S=SIN(X(KA)-X(KA+1))*COS(X(KA)+X(KA+1))
      EX=EXP(X(KA-1)-X(KA))
      GA(KA-1)=-EX-X(KA-1)*EX
      GA(KA)=9.0$P 0*X(KA)**2+D1S+D2S+4.0$P 0+X(KA-1)*EX
      GA(KA+1)=2.0$P 0-D1S+D2S
      ELSE
      EX=EXP(X(KA-1)-X(KA))
      GA(KA-1)=-EX-X(KA-1)*EX
      GA(KA)=4.0$P 0+X(KA-1)*EX
      ENDIF
      RETURN
   50 IF (MOD(KA,2).EQ.1) THEN
      GA(KA)=0.0$P 0
      IF (KA.NE.1) THEN
      D1S=COS(X(KA-2)-X(KA-1)-X(KA))*SIN(X(KA-2)+X(KA-1)-X(KA))
      D2S=SIN(X(KA-2)-X(KA-1)-X(KA))*COS(X(KA-2)+X(KA-1)-X(KA))
      GA(KA-2)=-18.0$P 0*(X(KA-2)-X(KA))**2-2.0$P 0*(D1S+D2S)
      GA(KA-1)=-4.0$P 0+2.0$P 0*(D1S-D2S)
      GA(KA)=GA(KA)+18.0$P 0*(X(KA-2)-X(KA))**2+2.0$P 0*(D1S+D2S)
      ENDIF
      IF (KA.NE.N) THEN
      D1S=COS(X(KA)-X(KA+1)-X(KA+2))*SIN(X(KA)+X(KA+1)-X(KA+2))
      D2S=SIN(X(KA)-X(KA+1)-X(KA+2))*COS(X(KA)+X(KA+1)-X(KA+2))
      GA(KA)=GA(KA)+9.0$P 0*(X(KA)-X(KA+2))**2+D1S+D2S
      GA(KA+1)=2.0$P 0-D1S+D2S
      GA(KA+2)=-9.0$P 0*(X(KA)-X(KA+2))**2-D1S-D2S
      ENDIF
      ELSE
      EX=EXP(X(KA-1)-X(KA)-X(KA+1))
      W=X(KA-1)-X(KA+1)
      GA(KA-1)=-EX-W*EX
      GA(KA)=4.0$P 0+W*EX
      GA(KA+1)=EX+W*EX
      ENDIF
      RETURN
   60 H=2.0$P 0
      IF (KA.EQ.1) THEN
      GA(1)=2.0$P 0*((3.0$P 0-H*X(1))*X(1)-2.0$P 0*X(2)+1.0$P 0)*
     & (3.0$P 0-2.0$P 0*H*X(1))
      GA(2)=-4.0$P 0*((3.0$P 0-H*X(1))*X(1)-2.0$P 0*X(2)+1.0$P 0)
      ELSE IF (KA.LE.N-1) THEN
      GA(KA-1)=-2.0$P 0*
     & ((3.0$P 0-H*X(KA))*X(KA)-X(KA-1)-2.0$P 0*X(KA+1)+1.0$P 0)
      GA(KA)=2.0$P 0*
     & ((3.0$P 0-H*X(KA))*X(KA)-X(KA-1)-2.0$P 0*X(KA+1)+1.0$P 0)*
     & (3.0$P 0-2.0$P 0*H*X(KA))
      GA(KA+1)=-4.0$P 0*
     & ((3.0$P 0-H*X(KA))*X(KA)-X(KA-1)-2.0$P 0*X(KA+1)+1.0$P 0)
      ELSE
      GA(N-1)=-2.0$P 0*((3.0$P 0-H*X(N))*X(N)-X(N-1)+1.0$P 0)
      GA(N)=2.0$P 0*
     & ((3.0$P 0-H*X(N))*X(N)-X(N-1)+1.0$P 0)*
     & (3.0$P 0-2.0$P 0*H*X(N))
      ENDIF
      RETURN
   70 IF (KA.LT.2) THEN
      GA(KA)=4.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)
      ELSE IF (KA.LT.N) THEN
      GA(KA-1)=-8.0$P 0*X(KA)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)
      ELSE
      GA(KA-1)=-8.0$P 0*X(KA)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+2.0$P 0
      ENDIF
      RETURN
   80 IF (KA.LT.2) THEN
      GA(KA)=4.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      GA(KA+2)=-2.0$P 0*X(KA+2)
      ELSE IF (KA.LT.3) THEN
      GA(KA-1)=-8.0$P 0*X(KA)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      GA(KA+2)=-2.0$P 0*X(KA+2)
      ELSE IF (KA.LT.N-1) THEN
      GA(KA-2)=-1.0$P 0
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      GA(KA+2)=-2.0$P 0*X(KA+2)
      ELSE IF (KA.LT.N) THEN
      GA(KA-2)=-1.0$P 0
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)
      ELSE
      GA(KA-2)=-1.0$P 0
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+2.0$P 0
      ENDIF
      RETURN
   90 IF (KA.LT.2) THEN
      GA(KA)=4.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      GA(KA+2)=-2.0$P 0*X(KA+2)+1.0$P 0
      GA(KA+3)=-2.0$P 0*X(KA+3)
      ELSE IF (KA.LT.3) THEN
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      GA(KA+2)=-2.0$P 0*X(KA+2)+1.0$P 0
      GA(KA+3)=-2.0$P 0*X(KA+3)
      ELSE IF (KA.LT.4) THEN
      GA(KA-2)=2.0$P 0*X(KA-2)-1.0$P 0
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      GA(KA+2)=-2.0$P 0*X(KA+2)+1.0$P 0
      GA(KA+3)=-2.0$P 0*X(KA+3)
      ELSE IF (KA.LT.N-2) THEN
      GA(KA-3)=-1.0$P 0
      GA(KA-2)=2.0$P 0*X(KA-2)-1.0$P 0
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      GA(KA+2)=-2.0$P 0*X(KA+2)+1.0$P 0
      GA(KA+3)=-2.0$P 0*X(KA+3)
      ELSE IF (KA.LT.N-1) THEN
      GA(KA-3)=-1.0$P 0
      GA(KA-2)=2.0$P 0*X(KA-2)-1.0$P 0
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      GA(KA+2)=-2.0$P 0*X(KA+2)+1.0$P 0
      ELSE IF (KA.LT.N) THEN
      GA(KA-3)=-1.0$P 0
      GA(KA-2)=2.0$P 0*X(KA-2)-1.0$P 0
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      ELSE
      GA(KA-3)=-1.0$P 0
      GA(KA-2)=2.0$P 0*X(KA-2)-1.0$P 0
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+2.0$P 0
      ENDIF
      RETURN
  100 IF (KA.EQ.1) THEN
      GA(N-4)=3.0$P 0
      GA(N-3)=-1.0$P 0
      GA(N-2)=-1.0$P 0
      GA(N-1)=0.50$P 0
      GA(N)=-1.0$P 0
      GA(KA)=-4.0$P 0*X(KA)+3.0$P 0
      GA(KA+1)=-2.0$P 0
      ELSEIF (KA.LE.N-1) THEN
      GA(KA-1)=0.0$P 0
      GA(KA)=0.0$P 0
      GA(KA+1)=0.0$P 0
      GA(N-4)=3.0$P 0
      GA(N-3)=-1.0$P 0
      GA(N-2)=-1.0$P 0
      GA(N-1)=0.50$P 0
      GA(N)=-1.0$P 0
      GA(KA-1)=GA(KA-1)-1.0$P 0
      GA(KA)=GA(KA)-4.0$P 0*X(KA)+3.0$P 0
      GA(KA+1)=GA(KA+1)-2.0$P 0
      ELSE
      GA(N-4)=3.0$P 0
      GA(N-3)=-1.0$P 0
      GA(N-2)=-1.0$P 0
      GA(N-1)=-0.5$P 0
      GA(N)=-4.0$P 0*X(N)+2.0$P 0
      ENDIF
      RETURN
  110 IF(MOD(KA,2).EQ.1) THEN
      GA(KA)=1.0$P 0
      GA(KA+1)=10.0$P 0*X(KA+1)-3.0$P 0*X(KA+1)**2-2.0$P 0
      ELSE
      GA(KA-1)=1.0$P 0
      GA(KA)=3.0$P 0*X(KA)**2+2.0$P 0*X(KA)-1.4$P 1
      ENDIF
      RETURN
  120 IF(MOD(KA,4).EQ.1) THEN
      GA(KA)=1.0$P 0
      GA(KA+1)=1.0$P 1
      ELSE IF(MOD(KA,4).EQ.2) THEN
      GA(KA+1)=2.23606797749979$P 0
      GA(KA+2)=-GA(KA+1)
      ELSE IF(MOD(KA,4).EQ.3) THEN
      GA(KA-1)=2.0$P 0*(X(KA-1)-2.0$P 0*X(KA))
      GA(KA)= -4.0$P 0*(X(KA-1)-2.0$P 0*X(KA))
      ELSE
      GA(KA-3)=3.16227766016838$P 0*2.0$P 0*(X(KA-3)-X(KA))
      GA(KA)= -3.16227766016838$P 0*2.0$P 0*(X(KA-3)-X(KA))
      ENDIF
      RETURN
  130 IF (MOD(KA,4).EQ.1) THEN
      GA(KA)=2.0$P 0*(EXP(X(KA))-X(KA+1))*EXP(X(KA))
      IF (GA(KA).EQ.0.0$P 0) GA(KA)=1.0$P-32
      GA(KA+1)=-2.0$P 0*(EXP(X(KA))-X(KA+1))
      ELSE IF (MOD(KA,4).EQ.2) THEN
      GA(KA)=3.0$P 1*(X(KA)-X(KA+1))**2
      IF (GA(KA).EQ.0.0$P 0) GA(KA)=1.0$P-32
      GA(KA+1)=-GA(KA)
      ELSE IF (MOD(KA,4).EQ.3) THEN
      GA(KA)=2.0$P 0*SIN(X(KA)-X(KA+1))/(COS(X(KA)-X(KA+1)))**3
      IF (GA(KA).EQ.0.0$P 0) GA(KA)=1.0$P-32
      GA(KA+1)=-GA(KA)
      ELSE
      GA(KA)=1.0$P 0
      ENDIF
      RETURN
  140 IF (KA.LT.2) THEN
      GA(KA)=X(KA)-3.0$P 0
      GA(KA+1)=2.0$P 0
      ELSE IF (KA.LT.N) THEN
      GA(KA-1)=1.0$P 0
      GA(KA)=X(KA)-3.0$P 0
      GA(KA+1)=2.0$P 0
      ELSE
      GA(KA-1)=1.0$P 0
      GA(KA)=X(KA)-3.0$P 0
      ENDIF
      RETURN
  150 DO 151 J=MAX(1,KA-5),MIN(N,KA+1)
      GA(J)=1.0$P 0+2.0$P 0*X(J)
  151 CONTINUE
      GA(KA)=GA(KA)+2.0$P 0+15.0$P 0*X(KA)**2
      RETURN
  160 IF(MOD(KA,2).EQ.1) THEN
      GA(KA)=1.0$P 4*X(KA+1)
      GA(KA+1)=1.0$P 4*X(KA)
      ELSE
      GA(KA-1)=-EXP(-X(KA-1))
      GA(KA)=-EXP(-X(KA))
      ENDIF
      RETURN
  170 IF(MOD(KA,4).EQ.1) THEN
      GA(KA)=-2.0$P 2*(X(KA+1)-3.0$P 0*X(KA)**2)+1.0$P 0
      GA(KA+1)=-2.0$P 2*X(KA)
      ELSE IF(MOD(KA,4).EQ.2) THEN
      GA(KA-1)=-4.0$P 2*X(KA-1)
      GA(KA)=2.202$P 2
      GA(KA+2)=1.98$P 1
      ELSE IF(MOD(KA,4).EQ.3) THEN
      GA(KA)=-1.8$P 2*(X(KA+1)-3.0$P 0*X(KA)**2)+1.0$P 0
      GA(KA+1)=-1.8$P 2*X(KA)
      ELSE
      GA(KA-2)=1.98$P 1
      GA(KA-1)=-3.6$P 2*X(KA-1)
      GA(KA)=2.002$P 2
      ENDIF
      RETURN
  180 IF (KA.LT.2) THEN
      GA(KA+1)=EXP(COS($DBLE(KA)*(X(KA)+X(KA+1))))*
     & $DBLE(KA)*SIN($DBLE(KA)*(X(KA)+X(KA+1)))
      GA(KA)=GA(KA+1)+1.0$P 0
      ELSEIF (KA.LT.N) THEN
      GA(KA-1)=EXP(COS($DBLE(KA)*(X(KA-1)+X(KA)+X(KA+1))))*
     & SIN($DBLE(KA)*(X(KA-1)+X(KA)+X(KA+1)))*$DBLE(KA)
      GA(KA+1)=GA(KA-1)
      GA(KA)=1.0$P 0+GA(KA-1)
      ELSE
      GA(KA-1)=EXP(COS($DBLE(KA)*(X(KA-1)+X(KA))))*
     & SIN($DBLE(KA)*(X(KA-1)+X(KA)))*$DBLE(KA)
      GA(KA)=1.0$P 0+GA(KA-1)
      ENDIF
      RETURN
  190 U=1.0$P 0/$DBLE(N+1)
      V=$DBLE(KA)*U
      GA(KA)=2.0$P 0+1.5$P 0*U**2*(X(KA)+V+1.0$P 0)**2
      IF(KA.GT.1) GA(KA-1)=-1.0$P 0
      IF(KA.LT.N) GA(KA+1)=-1.0$P 0
      RETURN
  200 IF(KA.EQ.1) THEN
      GA(KA)=3.0$P 0*(X(KA+1)-4.0$P 0*X(KA))
      GA(KA+1)=3.0$P 0*X(KA)+0.5$P 0*X(KA+1)
      ELSEIF(KA.EQ.N) THEN
      GA(KA-1)=3.0$P 0*X(KA)-0.5$P 0*(2.0$P 1-X(KA-1))
      GA(KA)=3.0$P 0*(2.0$P 1-4.0$P 0*X(KA)+X(KA-1))
      ELSE
      GA(KA-1)=3.0$P 0*X(KA)-0.5$P 0*(X(KA+1)-X(KA-1))
      GA(KA)=3.0$P 0*(X(KA+1)-4.0$P 0*X(KA)+X(KA-1))
      GA(KA+1)=3.0$P 0*X(KA)+0.5$P 0*(X(KA+1)-X(KA-1))
      ENDIF
      RETURN
  210 H=1.0$P 0/$DBLE(N+1)
      IF (KA.LT.2) THEN
      GA(KA)=2.0$P 0+PAR**2*H**2*COSH(PAR*X(KA))
      GA(KA+1)=-1.0$P 0
      ELSE IF (KA.LT.N) THEN
      GA(KA-1)=-1.0$P 0
      GA(KA)=2.0$P 0+PAR**2*H**2*COSH(PAR*X(KA))
      GA(KA+1)=-1.0$P 0
      ELSE
      GA(KA)=2.0$P 0+PAR**2*H**2*COSH(PAR*X(KA))
      GA(KA-1)=-1.0$P 0
      ENDIF
      RETURN
  220 GA(KA)=6.0$P 0
C      FA=6.0$P 0*X(KA)
      A1=0.0$P 0
      A2=0.0$P 0
      A3=0.0$P 0
      GA1(1)=0.0$P 0
      GA1(2)=0.0$P 0
      GA2(1)=0.0$P 0
      GA2(2)=0.0$P 0
      IF (KA.GT.1) THEN
      GA(KA-1)=-4.0$P 0+PAR*X(KA)
      A1=A1-X(KA-1)
      A2=A2+X(KA-1)
      A3=A3+2.0$P 0*X(KA-1)
      GA1(1)=-1.0$P 0
      GA2(1)= 1.0$P 0
      ENDIF
      IF (KA.GT.2) THEN
      GA(KA-2)=1.0$P 0-0.5$P 0*PAR*X(KA)
      A3=A3-X(KA-2)
      ENDIF
      IF (KA.LT.N-1) THEN
      GA(KA+2)=1.0$P 0+0.5$P 0*PAR*X(KA)
      A3=A3+X(KA+2)
      ENDIF
      IF (KA.LT.N) THEN
      GA(KA+1)=-4.0$P 0-PAR*X(KA)
      A1=A1+X(KA+1)
      A2=A2+X(KA+1)
      A3=A3-2.0$P 0*X(KA+1)
      GA1(2)= 1.0$P 0
      GA2(2)= 1.0$P 0
      ENDIF
      IF (KA.GE.N-1) THEN
      A3=A3+1.0$P 0
      ENDIF
      IF (KA.GE.N) THEN
      A1=A1+1.0$P 0
      A2=A2+1.0$P 0
      A3=A3-2.0$P 0
      ENDIF
      GA(KA)=GA(KA)+0.5$P 0*PAR*A3
      IF (KA.GT.1)
     & GA(KA-1)=GA(KA-1)-0.5$P 0*PAR*(GA1(1)*A2+A1*GA2(1))
      IF (KA.LT.N)
     & GA(KA+1)=GA(KA+1)-0.5$P 0*PAR*(GA1(2)*A2+A1*GA2(2))
      RETURN
  230 H=1.0$P 0/(M+1)
      IF(KA.LE.M) THEN
      J=KA+M
      GA(KA)=6.0$P 0
      GA(J)=0.0$P 0
      A1=0.0$P 0
      A2=0.0$P 0
      IF (KA.EQ.1) THEN
      A1=A1+1.0$P 0
      ENDIF
      IF (KA.GT.1) THEN
      A1=A1-X(J-1)
      A2=A2+2.0$P 0*X(KA-1)
      GA(KA-1)=-4.0$P 0+PAR*H*X(KA)
      GA(J-1)=-0.5$P 0*PAR*H**3*X(J)
      ENDIF
      IF (KA.GT.2) THEN
      A2=A2-X(KA-2)
      GA(KA-2)=1.0$P 0-0.5$P 0*PAR*H*X(KA)
      ENDIF
      IF (KA.LT.M-1) THEN
      A2=A2+X(KA+2)
      GA(KA+2)=1.0$P 0+0.5$P 0*PAR*H*X(KA)
      ENDIF
      IF (KA.LT.M) THEN
      A1=A1+X(J+1)
      A2=A2-2.0$P 0*X(KA+1)
      GA(KA+1)=-4.0$P 0-PAR*H*X(KA)
      GA(J+1)= 0.5$P 0*PAR*H**3*X(J)
      ENDIF
      IF (KA.EQ.M) THEN
      A1=A1+1.0$P 0
      ENDIF
      GA(KA)=GA(KA)+0.5$P 0*PAR*H*A2
      GA(J)=GA(J)+0.5$P 0*PAR*H**3*A1
      ELSE
      J=KA-M
      GA(KA)=-2.0$P 0
      GA(J)=0.0$P 0
      A1=0.0$P 0
      A2=0.0$P 0
      IF (J.EQ.1) THEN
      A2=A2+1.0$P 0
      ENDIF
      IF (J.GT.1) THEN
      A1=A1-X(J-1)
      A2=A2-X(KA-1)
      GA(KA-1)=1.0$P 0-0.5$P 0*PAR*H*X(J)
      GA(J-1)=-0.5$P 0*PAR*H*X(KA)
      ENDIF
      IF (J.LT.M) THEN
      A1=A1+X(J+1)
      A2=A2+X(KA+1)
      GA(KA+1)=1.0$P 0+0.5$P 0*PAR*H*X(J)
      GA(J+1)= 0.5$P 0*PAR*H*X(KA)
      ENDIF
      IF (J.EQ.M) THEN
      A2=A2+1.0$P 0
      ENDIF
      GA(KA)=GA(KA)+0.5$P 0*PAR*H*A1
      GA(J)=GA(J)+0.5$P 0*PAR*H*A2
      ENDIF
      RETURN
  240 GA(KA)=4.0$P 0-PAR*EXP(X(KA))
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      IF(J.GT.1) GA(KA-M)=-1.0$P 0
      IF(I.GT.1) GA(KA-1)=-1.0$P 0
      IF(I.LT.M) GA(KA+1)=-1.0$P 0
      IF(J.LT.M) GA(KA+M)=-1.0$P 0
      RETURN
  250 GA(KA)=4.0$P 0
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      GA(KA)=GA(KA)+3.0$P 0*PAR*X(KA)**2/(1.0$P 0+PAR*$DBLE(I)**2+
     & PAR*$DBLE(J)**2)
      IF(I.GT.1) GA(KA-1)=-1.0$P 0
      IF(I.LT.M) GA(KA+1)=-1.0$P 0
      IF(J.GT.1) GA(KA-M)=-1.0$P 0
      IF(J.LT.M) GA(KA+M)=-1.0$P 0
      RETURN
  260 GA(KA)=4.0$P 0-2.0$P 0*PI*PAR*COS(2.0$P 0*PI*X(KA))
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      A1=DBLE(I)/DBLE(M+1)
      A2=DBLE(J)/DBLE(M+1)
      IF(I.EQ.1) GA(KA+1)=-1.0$P 0-PI*DBLE(M+1)*PAR*COS(PI*X(KA+1)*
     & DBLE(M+1))
      IF(I.GT.1.AND.I.LT.M) THEN
      GA(KA-1)=-1.0$P 0+PI*DBLE(M+1)*PAR*COS(PI*(X(KA+1)-X(KA-1))*
     & DBLE(M+1))
      GA(KA+1)=-1.0$P 0-PI*DBLE(M+1)*PAR*COS(PI*(X(KA+1)-X(KA-1))*
     & DBLE(M+1))
      ENDIF
      IF(I.EQ.M) GA(KA-1)=-1.0$P 0+PI*DBLE(M+1)*PAR*COS(PI*X(KA-1)*
     & DBLE(M+1))
      IF(J.EQ.1) GA(KA+M)=-1.0$P 0-PI*DBLE(M+1)*PAR*COS(PI*X(KA+M)*
     & DBLE(M+1))
      IF(J.GT.1.AND.J.LT.M) THEN
      GA(KA-M)=-1.0$P 0+PI*DBLE(M+1)*PAR*COS(PI*(X(KA+M)-X(KA-M))*
     & DBLE(M+1))
      GA(KA+M)=-1.0$P 0-PI*DBLE(M+1)*PAR*COS(PI*(X(KA+M)-X(KA-M))*
     & DBLE(M+1))
      ENDIF
      IF(J.EQ.M) GA(KA-M)=-1.0$P 0+PI*DBLE(M+1)*PAR*COS(PI*X(KA-M)*
     & DBLE(M+1))
      RETURN
  270 GA(KA)=1.6$P 1*X(KA)
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      IF(I.EQ.1) THEN
      GA(KA)=GA(KA)-2.0$P 0*(X(KA+1)+1.0$P 0)-3.0$P 0*X(KA)*
     & (X(KA+1)-1.0$P 0)*PAR
      GA(KA+1)=-2.0$P 0*X(KA)-(X(KA+1)-1.0$P 0)-1.5$P 0*X(KA)**2*PAR
      ENDIF
      IF(I.GT.1.AND.I.LT.M) THEN
      GA(KA)=GA(KA)-2.0$P 0*(X(KA+1)+X(KA-1))-3.0$P 0*X(KA)*
     & (X(KA+1)-X(KA-1))*PAR
      GA(KA-1)=-2.0$P 0*X(KA)+(X(KA+1)-X(KA-1))+1.5$P 0*X(KA)**2*PAR
      GA(KA+1)=-2.0$P 0*X(KA)-(X(KA+1)-X(KA-1))-1.5$P 0*X(KA)**2*PAR
      ENDIF
      IF(I.EQ.M) THEN
      GA(KA)=GA(KA)-2.0$P 0*X(KA-1)+3.0$P 0*X(KA)*X(KA-1)*PAR
      GA(KA-1)=-2.0$P 0*X(KA)-X(KA-1)+1.5$P 0*X(KA)**2*PAR
      ENDIF
      IF(J.EQ.1) THEN
      GA(KA)=GA(KA)-2.0$P 0*(X(KA+M)+1.0$P 0)
      GA(KA+M)=-2.0$P 0*X(KA)-(X(KA+M)-1.0$P 0)
      ENDIF
      IF(J.GT.1.AND.J.LT.M) THEN
      GA(KA)=GA(KA)-2.0$P 0*(X(KA+M)+X(KA-M))
      GA(KA-M)=-2.0$P 0*X(KA)+(X(KA+M)-X(KA-M))
      GA(KA+M)=-2.0$P 0*X(KA)-(X(KA+M)-X(KA-M))
      ENDIF
      IF(J.EQ.M) THEN
      GA(KA)=GA(KA)-2.0$P 0*X(KA-M)
      GA(KA-M)=-2.0$P 0*X(KA)-X(KA-M)
      ENDIF
      RETURN
  280 GA(KA)=4.0$P 0
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      A1=PAR*DBLE(I)
      A2=PAR*DBLE(J)
      A3=0.0$P 0
      IF(I.GT.1) THEN
      GA(KA-1)=-1.0$P 0-2.0$P 1*PAR*X(KA)
      A3=A3-X(KA-1)
      ENDIF
      IF(I.LT.M) THEN
      GA(KA+1)=-1.0$P 0+2.0$P 1*PAR*X(KA)
      A3=A3+X(KA+1)
      ENDIF
      IF(J.GT.1) THEN
      GA(KA-M)=-1.0$P 0-2.0$P 1*PAR*X(KA)
      A3=A3-X(KA-M)
      ENDIF
      IF(J.LT.M) THEN
      GA(KA+M)=-1.0$P 0+2.0$P 1*PAR*X(KA)
      A3=A3+X(KA+M)
      ENDIF
      GA(KA)=GA(KA)+2.0$P 1*PAR*A3
      RETURN
  290 GA(KA)=2.0$P 1-PAR
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      IF (J.GT.2) THEN
        GA(KA-M-M)=1.0$P 0
      ENDIF
      IF (J.GT.1) THEN
        IF (I.GT.1) THEN
          GA(KA-M-1)=2.0$P 0
        ENDIF
        GA(KA-M)=-8.0$P 0
        IF (I.LT.M) THEN
          GA(KA-M+1)=2.0$P 0
        ENDIF
      ENDIF
      IF (I.GT.1) THEN
        IF (I.GT.2) THEN
          GA(KA-2)=1.0$P 0
        ENDIF
        GA(KA-1)=-8.0$P 0
      ENDIF
      IF (I.LT.M) THEN
        GA(KA+1)=-8.0$P 0
        IF (I.LT.M-1) THEN
          GA(KA+2)=1.0$P 0
        ENDIF
      ENDIF
      IF (J.LT.M) THEN
        IF (I.GT.1) THEN
          GA(KA+M-1)=2.0$P 0
        ENDIF
        GA(KA+M)=-8.0$P 0
        IF (I.LT.M) THEN
          GA(KA+M+1)=2.0$P 0
        ENDIF
      ENDIF
      IF (J.LT.M-1) THEN
        GA(KA+M+M)=1.0$P 0
      ENDIF
      RETURN
  300 H=0.5$P 0/$DBLE(M+2)
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      GA(KA)=2.0$P 1
      A1=0.0$P 0
      A2=0.0$P 0
      A3=0.0$P 0
      A4=0.0$P 0
      GA1(1)=0.0$P 0
      GA1(2)=0.0$P 0
      GA2(1)=0.0$P 0
      GA2(2)=0.0$P 0
      DO 301 K=1,6
      GA3(K)=0.0$P 0
      GA4(K)=0.0$P 0
  301 CONTINUE
      IF (J.GT.2) THEN
        GA(KA-M-M)=1.0$P 0
        GA4(1)=GA4(1)+1.0$P 0
        A4=A4+X(KA-M-M)
      ENDIF
      IF (J.GT.1) THEN
        IF (I.GT.1) THEN
          GA(KA-M-1)=2.0$P 0
          GA3(1)=GA3(1)+1.0$P 0
          GA4(2)=GA4(2)+1.0$P 0
          A3=A3+X(KA-M-1)
          A4=A4+X(KA-M-1)
        ENDIF
        GA(KA-M)=-8.0$P 0
        GA1(1)=GA1(1)-1.0$P 0
        A1=A1-X(KA-M)
        IF (I.LT.M) THEN
          GA(KA-M+1)=2.0$P 0
          GA3(2)=GA3(2)-1.0$P 0
          GA4(3)=GA4(3)+1.0$P 0
          A3=A3-X(KA-M+1)
          A4=A4+X(KA-M+1)
        ENDIF
      ENDIF
      IF (I.GT.1) THEN
        IF (I.GT.2) THEN
          GA(KA-2)=1.0$P 0
          GA3(3)=GA3(3)+1.0$P 0
          A3=A3+X(KA-2)
        ENDIF
        GA(KA-1)=-8.0$P 0
        GA2(1)=GA2(1)-1.0$P 0
        A2=A2-X(KA-1)
      ENDIF
      IF (I.LT.M) THEN
        GA(KA+1)=-8.0$P 0
        GA2(2)=GA2(2)+1.0$P 0
        A2=A2+X(KA+1)
        IF (I.LT.M-1) THEN
          GA(KA+2)=1.0$P 0
          GA3(4)=GA3(4)-1.0$P 0
          A3=A3-X(KA+2)
        ENDIF
      ENDIF
      IF (J.LT.M) THEN
        IF (I.GT.1) THEN
          GA(KA+M-1)=2.0$P 0
          GA3(5)=GA3(5)+1.0$P 0
          GA4(4)=GA4(4)-1.0$P 0
          A3=A3+X(KA+M-1)
          A4=A4-X(KA+M-1)
        ENDIF
        GA(KA+M)=-8.0$P 0
        GA1(2)=GA1(2)+1.0$P 0
        A1=A1+X(KA+M)
        IF (I.LT.M) THEN
          GA(KA+M+1)=2.0$P 0
          GA3(6)=GA3(6)-1.0$P 0
          GA4(5)=GA4(5)-1.0$P 0
          A3=A3-X(KA+M+1)
          A4=A4-X(KA+M+1)
        ENDIF
      ENDIF
      IF (J.LT.M-1) THEN
        GA(KA+M+M)=1.0$P 0
        GA4(6)=GA4(6)-1.0$P 0
        A4=A4-X(KA+M+M)
      ENDIF
      IF (J.EQ.M) THEN
        IF (I.GT.1) THEN
          A3=A3-H
          A4=A4+H
        ENDIF
        A1=A1-H
        IF (I.LT.M) THEN
          A3=A3+H
          A4=A4+H
        ENDIF
        A4=A4-H
      ENDIF
      IF (J.EQ.M-1) THEN
        A4=A4+H
      ENDIF
      IF (KA.GT.M+M)
     & GA(KA-M-M)=GA(KA-M-M)+0.25$P 0*PAR*(-A2*GA4(1))
      IF (KA.GT.M+1)
     & GA(KA-M-1)=GA(KA-M-1)+0.25$P 0*PAR*(+A1*GA3(1)-A2*GA4(2))
      IF (KA.GT.M)
     & GA(KA-M)=GA(KA-M)+0.25$P 0*PAR*(GA1(1)*A3)
      IF (KA.GT.M-1)
     & GA(KA-M+1)=GA(KA-M+1)+0.25$P 0*PAR*(+A1*GA3(2)-A2*GA4(3))
      IF (KA.GT.2)
     & GA(KA-2)=GA(KA-2)+0.25$P 0*PAR*(+A1*GA3(3))
      IF (KA.GT.1)
     & GA(KA-1)=GA(KA-1)+0.25$P 0*PAR*(-GA2(1)*A4)
      IF (KA.LE.N-1)
     & GA(KA+1)=GA(KA+1)+0.25$P 0*PAR*(-GA2(2)*A4)
      IF (KA.LE.N-2)
     & GA(KA+2)=GA(KA+2)+0.25$P 0*PAR*(+A1*GA3(4))
      IF (KA.LE.N-M+1)
     & GA(KA+M-1)=GA(KA+M-1)+0.25$P 0*PAR*(+A1*GA3(5)-A2*GA4(4))
      IF (KA.LE.N-M)
     & GA(KA+M)=GA(KA+M)+0.25$P 0*PAR*(GA1(2)*A3)
      IF (KA.LE.N-M-1)
     & GA(KA+M+1)=GA(KA+M+1)+0.25$P 0*PAR*(+A1*GA3(6)-A2*GA4(5))
      IF (KA.LE.N-M-M)
     & GA(KA+M+M)=GA(KA+M+M)+0.25$P 0*PAR*(-A2*GA4(6))
      RETURN
  310 H=1.0$P 0/$DBLE(N+1)
      A1=$DBLE(KA)*H
      A2=(A1-0.5$P 0)**2
      IF (A1.GE.0.5$P 0) THEN
      A3= 1.0$P 6
      ELSE
      A3=-1.0$P 6
      ENDIF
      IF (KA.LT.2) THEN
      GA(KA)=2.0$P 0+
     & H**2*(3.0$P 0*X(KA)**2*EXP(X(KA))+X(KA)**3*EXP(X(KA)))
      GA(KA+1)=-1.0$P 0+
     & H**2*5.0$P 8*EXP(-1.0$P 4*A2)*SQRT(ABS(A1-0.5$P 0))
      ELSEIF (KA.LT.N) THEN
      GA(KA-1)=-1.0$P 0-
     & H**2*5.0$P 8*EXP(-1.0$P 4*A2)*SQRT(ABS(A1-0.5$P 0))
      GA(KA)=2.0$P 0+
     & H**2*(3.0$P 0*X(KA)**2*EXP(X(KA))+X(KA)**3*EXP(X(KA)))
      GA(KA+1)=-1.0$P 0+
     & H**2*5.0$P 8*EXP(-1.0$P 4*A2)*SQRT(ABS(A1-0.5$P 0))
      ELSE
      GA(KA-1)=-1.0$P 0+
     & H**2*5.0$P 8*EXP(-1.0$P 4*A2)*SQRT(ABS(A1-0.5$P 0))
      GA(KA)=2.0$P 0+
     & H**2*(3.0$P 0*X(KA)**2*EXP(X(KA))+X(KA)**3*EXP(X(KA)))
      ENDIF
      RETURN
  320 H=1.0$P 0/DBLE(N+1)
      A1=DBLE(KA)*H
      A2=(A1-0.5$P 0)**2
      IF (KA.LT.2) THEN
      GA(KA+1)=-1.0$P 0
      GA(KA)=2.0$P 0+H**2*(3*X(KA)**2+2.0$P-4*(2.0$P-4*A2-1.0$P 0))
      ELSEIF (KA.LT.N) THEN
      GA(KA-1)=-1.0$P 0
      GA(KA)=2.0$P 0+H**2*(3*X(KA)**2+2.0$P-4*(2.0$P-4*A2-1.0$P 0))
      GA(KA+1)=-1.0$P 0
      ELSE
      GA(KA-1)=-1.0$P 0
      GA(KA)=2.0$P 0+H**2*(3*X(KA)**2+2.0$P-4*(2.0$P-4*A2-1.0$P 0))
      ENDIF
      RETURN
  410 IF (KA.EQ.1) THEN
      GA(1)=-1.0D 0
      ELSE
      GA(KA)=20.0D 0*DBLE(KA-1)*(X(KA)-X(KA-1))
      GA(KA-1)=-20.0D 0*DBLE(KA-1)*(X(KA)-X(KA-1))
      ENDIF
      RETURN
  420 IF (KA.EQ.N) THEN
      GA(1)=-0.20D 0*X(1)
      GA(N)=1.0D 0
      ELSE
      GA(KA)=1.0D 0
      GA(KA+1)=-0.2D 0*X(KA+1)
      ENDIF
      RETURN
  430 S=(1.0D 0/DBLE(N+1))**2*EXP(X(KA))
      IF (N.EQ.1) THEN
      GA(KA)=-(2.0D 0+S)
      ELSE IF (KA.EQ.1) THEN
      GA(KA)=-(2.0D 0+S)
      GA(KA+1)=1.0D 0
      ELSE IF (KA.EQ.N) THEN
      GA(KA)=-(2.0D 0+S)
      GA(KA-1)=1.0D 0
      ELSE
      GA(KA)=-(2.0D 0+S)
      GA(KA-1)=1.0D 0
      GA(KA+1)=1.0D 0
      ENDIF
      RETURN
  440 S=0.1D 0
      IF (N.EQ.1) THEN
      GA(KA)=3.0D 0-2.0D 0*S*X(KA)
      ELSE IF (KA.EQ.1) THEN
      GA(KA)=3.0D 0-2.0D 0*S*X(KA)
      GA(KA+1)=-2.0D 0
      ELSE IF (KA.EQ.N) THEN
      GA(KA)=3.0D 0-2.0D 0*S*X(KA)
      GA(KA-1)=-1.0D 0
      ELSE
      GA(KA)=3.0D 0-2.0D 0*S*X(KA)
      GA(KA-1)=-1.0D 0
      GA(KA+1)=-2.0D 0
      ENDIF
      RETURN
  450 S1=1.0D 0
      S2=1.0D 0
      S3=1.0D 0
      J1=3
      J2=3
      IF (KA-J1.GT.1) THEN
      I1=KA-J1
      ELSE
      I1=1
      ENDIF
      IF (KA+J2.LT.N) THEN
      I2=KA+J2
      ELSE
      I2=N
      ENDIF
      S=0.0D 0
      DO 451 J=I1,I2
      IF (J.NE.KA) S=S+X(J)+X(J)**2
  451 CONTINUE
      GA(KA)=S1+3.0D 0*S2*X(KA)**2
      DO 452 J=I1,I2
      IF (J.NE.KA) GA(J)=-S3*(1.0D 0+2.0D 0*X(J))
  452 CONTINUE
      RETURN
  460 IF (KA.EQ.1) THEN
      GA(1)=2.0D 0*X(1)
      ELSE
      GA(KA-1)=2.0D 0*X(KA-1)
      GA(KA)=1.0D 0/X(KA)
      ENDIF
      RETURN
  470 IF (KA.EQ.1) THEN
      GA(1)=1.0D 0
      ELSE
      GA(KA)=1.0D 0
      GA(KA-1)=-SIN(X(KA-1))
      ENDIF
      RETURN
  480 S=(1.0D 0/DBLE(N+1))**2
      IF (N.EQ.1) THEN
      GA(KA)=2.0D 0+S*(1.0D 0+COS(X(KA)))
      ELSE IF (KA.EQ.1) THEN
      GA(KA)=2.0D 0+S*(1.0D 0+COS(X(KA)))
      GA(KA+1)=-1.0D 0
      ELSE IF (KA.EQ.N) THEN
      GA(KA)=2.0D 0+S*(1.0D 0+COS(X(KA)))
      GA(KA-1)=-1.0D 0
      ELSE
      GA(KA)=2.0D 0+S*(1.0D 0+COS(X(KA)))
      GA(KA-1)=-1.0D 0
      GA(KA+1)=-1.0D 0
      ENDIF
      RETURN
  490 IF (KA-5.GT.1) THEN
      I1=KA-5
      ELSE
      I1=1
      ENDIF
      IF (KA+1.LT.N) THEN
      I2=KA+1
      ELSE
      I2=N
      ENDIF
      S=0.0D 0
      DO 491 J=I1,I2
      IF (J.NE.KA) S=S+X(J)*(1.0D 0+X(J))
  491 CONTINUE
      GA(KA)=2.0D 0+15.0D 0*X(KA)**2
      DO 492 J=I1,I2
      IF (J.NE.KA) GA(J)=-(1.0D 0+2.0D 0*X(J))
  492 CONTINUE
  493 CONTINUE
      RETURN
  500 H=1.0D 0/DBLE(N+1)
      T=2.0D 0*H**2
      IF (KA.EQ.1) THEN
      GA(KA)=2.0D 0*(1.0D 0-T*X(KA))
      GA(KA+1)=-(1.0D 0+H)
      ELSE IF (1.LT.KA.AND.KA.LT.N) THEN
      GA(KA)=2.0D 0*(1.0D 0-T*X(KA))
      GA(KA-1)=-(1.0D 0-H)
      GA(KA+1)=-(1.0D 0+H)
      ELSE IF (KA.EQ.N) THEN
      GA(KA)=2.0D 0*(1.0D 0-T*X(KA))
      GA(KA-1)=-(1.0D 0-H)
      ENDIF
      RETURN
  520 A=-9.0D-3
      B=1.0D-3
      AL=0.0D 0
      BE=25.0D 0
      GB=20.0D 0
      CA=0.3D 0
      CB=0.3D 0
      H=(B-A)/DBLE(N+1)
      T=A+DBLE(KA)*H
      H=H**2
      S=DBLE(KA)/DBLE(N+1)
      U=AL*(1.0D 0-S)+BE*S+X(KA)
      FF=CB*EXP(GB*(U-BE))-CA*EXP(GB*(AL-U))
      FG=GB*(CB*EXP(GB*(U-BE))+CA*EXP(GB*(AL-U)))
      IF (T.LE.0) THEN
      FF=FF+CA
      ELSE
      FF=FF-CB
      ENDIF
      IF (N.EQ.1) THEN
      GA(KA)=2.0D 0+H*FG
      ELSE IF (KA.EQ.1) THEN
      GA(KA)=2.0D 0+H*FG
      GA(KA+1)=-1.0D 0
      ELSE IF (KA.LT.N) THEN
      GA(KA)=2.0D 0+H*FG
      GA(KA-1)=-1.0D 0
      GA(KA+1)=-1.0D 0
      ELSE
      GA(KA)=2.0D 0+H*FG
      GA(KA-1)=-1.0D 0
      ENDIF
      RETURN
  530 AL1=0.0D 0
      AL2=0.0D 0
      BE1=0.0D 0
      BE2=0.0D 0
      N1=N/2
      H=1.0D 0/DBLE(N1+1)
      T=DBLE(KA)*H
      IF (KA.EQ.1) THEN
      S1=2.0D 0*X(KA)-X(KA+1)
      B=AL1
      ELSE IF (KA.EQ.N1+1) THEN
      S1=2.0D 0*X(KA)-X(KA+1)
      B=AL2
      ELSE IF (KA.EQ.N1) THEN
      S1=-X(KA-1)+2.0D 0*X(KA)
      B=BE1
      ELSE IF (KA.EQ.N) THEN
      S1=-X(KA-1)+2.0D 0*X(KA)
      B=BE2
      ELSE
      S1=-X(KA-1)+2.0D 0*X(KA)-X(KA+1)
      B=0.0D 0
      ENDIF
      IF (KA.LE.N1) THEN
      S2=X(KA)**2+X(KA)+0.1D 0*X(N1+KA)**2-1.2D 0
      ELSE
      S2=0.2D 0*X(KA-N1)**2+X(KA)**2+2.0D 0*X(KA)-0.6D 0
      ENDIF
      H=1.0D 0/DBLE(N1+1)**2
      IF (KA.EQ.1) THEN
      GA(KA)=2.0D 0+H*(2.0D 0*X(KA)+1.0D 0)
      GA(KA+1)=-1.0D 0
      GA(N1+KA)=H*0.2D 0*X(N1+KA)
      ELSE IF (KA.EQ.N1+1) THEN
      GA(1)=H*0.4D 0*X(1)
      GA(KA)=2.0D 0+H*(2.0D 0*X(KA)+2.0D 0)
      GA(KA+1)=-1.0D 0
      ELSE IF (KA.EQ.N1) THEN
      GA(KA-1)=-1.0D 0
      GA(KA)=2.0D 0+H*(2.0D 0*X(KA)+1.0D 0)
      GA(N1+KA)=H*0.2D 0*X(N1+KA)
      ELSE IF (KA.EQ.N) THEN
      GA(N1)=H*0.4D 0*X(N1)
      GA(KA-1)=-1.0D 0
      GA(KA)=2.0D 0+H*(2.0D 0*X(KA)+2.0D 0)
      ELSE IF (KA.LT.N1) THEN
      GA(KA-1)=-1.0D 0
      GA(KA)=2.0D 0+H*(2.0D 0*X(KA)+1.0D 0)
      GA(KA+1)=-1.0D 0
      GA(N1+KA)=H*0.2D 0*X(N1+KA)
      ELSE
      GA(KA-N1)=H*0.4D 0*X(KA-N1)
      GA(KA-1)=-1.0D 0
      GA(KA)=2.0D 0+H*(2.0D 0*X(KA)+2.0D 0)
      GA(KA+1)=-1.0D 0
      ENDIF
      RETURN
  540 ND=INT(SQRT(DBLE(N)))
      L=MOD(KA,ND)
      IF (L.EQ.0) THEN
      K=KA/ND
      L=ND
      ELSE
      K=INT(KA/ND)+1
      ENDIF
      LA=1.0D 0
      H=1.0D 0/DBLE(ND+1)
      H2=LA*H*H
      IF (L.EQ.1.AND.K.EQ.1) THEN
      GA(1)=4.0D 0+H2*EXP(X(1))
      GA(2)=-1.0D 0
      GA(ND+1)=-1.0D 0
      ENDIF
      IF (1.LT.L.AND.L.LT.ND.AND.K.EQ.1) THEN
      GA(L)=4.0D 0+H2*EXP(X(L))
      GA(L-1)=-1.0D 0
      GA(L+1)=-1.0D 0
      GA(L+ND)=-1.0D 0
      ENDIF
      IF (L.EQ.ND.AND.K.EQ.1) THEN
      GA(ND)=4.0D 0+H2*EXP(X(ND))
      GA(ND-1)=-1.0D 0
      GA(ND+ND)=-1.0D 0
      ENDIF
      IF (L.EQ.1.AND.1.LT.K.AND.K.LT.ND) THEN
      GA(KA)=4.0D 0+H2*EXP(X(KA))
      GA(KA-ND)=-1.0D 0
      GA(KA+1)=-1.0D 0
      GA(KA+ND)=-1.0D 0
      ENDIF
      IF (L.EQ.ND.AND.1.LT.K.AND.K.LT.ND) THEN
      GA(KA)=4.0D 0+H2*EXP(X(KA))
      GA(KA-ND)=-1.0D 0
      GA(KA-1)=-1.0D 0
      GA(KA+ND)=-1.0D 0
      ENDIF
      IF (L.EQ.1.AND.K.EQ.ND) THEN
      GA(KA)=4.0D 0+H2*EXP(X(KA))
      GA(KA-ND)=-1.0D 0
      GA(KA+1)=-1.0D 0
      ENDIF
      IF (1.LT.L.AND.L.LT.ND.AND.K.EQ.ND) THEN
      GA(KA)=4.0D 0+H2*EXP(X(KA))
      GA(KA-ND)=-1.0D 0
      GA(KA-1)=-1.0D 0
      GA(KA+1)=-1.0D 0
      ENDIF
      IF (L.EQ.ND.AND.K.EQ.ND) THEN
      GA(KA)=4.0D 0+H2*EXP(X(KA))
      GA(KA-ND)=-1.0D 0
      GA(KA-1)=-1.0D 0
      ENDIF
      IF (1.LT.L.AND.L.LT.ND.AND.1.LT.K.AND.K.LT.ND) THEN
      GA(KA)=4.0D 0+H2*EXP(X(KA))
      GA(KA-ND)=-1.0D 0
      GA(KA-1)=-1.0D 0
      GA(KA+1)=-1.0D 0
      GA(KA+ND)=-1.0D 0
      ENDIF
      RETURN
  550 ND=INT(SQRT(DBLE(N)))
      L=MOD(KA,ND)
      IF (L.EQ.0) THEN
      K=KA/ND
      L=ND
      ELSE
      K=INT(KA/ND)+1
      ENDIF
      H=1.0D 0/DBLE(ND+1)
      H2=H*H
      IF (L.EQ.1.AND.K.EQ.1) THEN
      GA(1)=4.0D 0+H2*X(1)*2.0D 0
      GA(2)=-1.0D 0
      GA(ND+1)=-1.0D 0
      ENDIF
      IF (1.LT.L.AND.L.LT.ND.AND.K.EQ.1) THEN
      GA(L)=4.0D 0+H2*X(L)*2.0D 0
      GA(L-1)=-1.0D 0
      GA(L+1)=-1.0D 0
      GA(L+ND)=-1.0D 0
      ENDIF
      IF (L.EQ.ND.AND.K.EQ.1) THEN
      GA(ND)=4.0D 0+H2*X(ND)*2.0D 0
      GA(ND-1)=-1.0D 0
      GA(ND+ND)=-1.0D 0
      ENDIF
      IF (L.EQ.1.AND.1.LT.K.AND.K.LT.ND) THEN
      GA(KA)=4.0D 0+H2*X(KA)*2.0D 0
      GA(KA-ND)=-1.0D 0
      GA(KA+1)=-1.0D 0
      GA(KA+ND)=-1.0D 0
      ENDIF
      IF (L.EQ.ND.AND.1.LT.K.AND.K.LT.ND) THEN
      GA(KA)=4.0D 0+H2*X(KA)*2.0D 0
      GA(KA-ND)=-1.0D 0
      GA(KA-1)=-1.0D 0
      GA(KA+ND)=-1.0D 0
      ENDIF
      IF (L.EQ.1.AND.K.EQ.ND) THEN
      GA(KA)=4.0D 0+H2*X(KA)*2.0D 0
      GA(KA-ND)=-1.0D 0
      GA(KA+1)=-1.0D 0
      ENDIF
      IF (1.LT.L.AND.L.LT.ND.AND.K.EQ.ND) THEN
      GA(KA)=4.0D 0+H2*X(KA)*2.0D 0
      GA(KA-ND)=-1.0D 0
      GA(KA-1)=-1.0D 0
      GA(KA+1)=-1.0D 0
      ENDIF
      IF (L.EQ.ND.AND.K.EQ.ND) THEN
      GA(KA)=4.0D 0+H2*X(KA)*2.0D 0
      GA(KA-ND)=-1.0D 0
      GA(KA-1)=-1.0D 0
      ENDIF
      IF (1.LT.L.AND.L.LT.ND.AND.1.LT.K.AND.K.LT.ND) THEN
      GA(KA)=4.0D 0+H2*X(KA)*2.0D 0
      GA(KA-ND)=-1.0D 0
      GA(KA-1)=-1.0D 0
      GA(KA+1)=-1.0D 0
      GA(KA+ND)=-1.0D 0
      ENDIF
      RETURN
      END
