* SUBROUTINE EAGU24             ALL SYSTEMS                 90/12/01
C PORTABILITY : ALL SYSTEMS
C 90/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  GRADIENTS OF TEST FUNCTIONS FOR NONLINEAR APPROXIMATION.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  KA  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  GA(N)  GRADIENT OF THE APPROXIMATED FUNCTION AT THE
*          SELECTED POINT.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EAGU24(N,KA,X,GA,NEXT)
      INTEGER N,KA,NEXT
      $FLOAT X(N),GA(N)
      INTEGER IP02(8),IP16(9),IP17(3),IP18(38)
      DATA IP02 /20,21,22,23,25,27,29,30/
      DATA IP16 /1,2,5,9,20,21,23,24,28/
      DATA IP17 /16,19,20/
      DATA IP18 /2,3,4,5,6,8,9,11,14,16,17,18,19,20,21,22,23,24,25,26,
     & 27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44/
      IF (NEXT.LE.22) THEN
      CALL UXVSET(N,0.0D 0,GA)
      CALL EAGU15(N,KA,X,GA,NEXT)
      ELSE IF (NEXT.LE.60) THEN
      CALL UXVSET(N,0.0D 0,GA)
      CALL EAGU18(N,KA,X,GA,IP18(NEXT-22))
      ELSE IF (NEXT.LE.68) THEN 
      CALL EAGU02(N,KA,X,GA,IP02(NEXT-60))
      ELSE IF (NEXT.LE.77) THEN
      CALL EAGU16(N,KA,X,GA,IP16(NEXT-68))
      ELSE IF (NEXT.LE.80) THEN
      CALL EAGU17(N,KA,X,GA,IP17(NEXT-77))
      ENDIF
      RETURN
      END
