* SUBROUTINE EAHD02             ALL SYSTEMS                 94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 VL : ORIGINAL VERSION
*
* PURPOSE :
*  HESSIAN MATRICES OF TEST FUNCTIONS FOR NONLINEAR APPROXIMATION.
*  DENSE VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  KA  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  HA(N*(N+1)/2)  HESSIAN MATRIX OF THE APPROXIMATED FUNCTION
*          AT THE SELECTED POINT.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EAHD02(N,KA,X,HA,NEXT)
      INTEGER I,ID,J,KA,N,NEXT
      $FLOAT  HA(N*(N+1)/2), X(N)
      $FLOAT  A,B,C,D,U,V,W, Y(65)
      COMMON /EMPR02/ Y
      $FLOAT  ZERO,EPS,HALF,ONE,TWO,S10,SIX,TEN,TWE
      PARAMETER (ZERO=0$P 0, EPS=1$P-5, HALF=5$P-1, ONE=1$P 0, TWO=2$P 0
     1 ,S10=3.16227766016838$P 0, SIX=6$P 0, TEN=1$P 1, TWE=2$P 1)
      ID(I)  =(I+1)*I/2
      DO 1 J=1,N*(N+1)/2
 1    HA(J)=ZERO
      GOTO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,170,
     &      180,190,200,210,220,230,240,250,260,270,280,290,300),NEXT
  10  IF(KA.EQ.1) HA(1)=-TWE
      RETURN
  20  IF(KA.EQ.1) HA(3)=TEN-SIX*X(2)
      IF(KA.EQ.2) HA(3)=TWO+SIX*X(2)
      RETURN
  30  IF(KA.EQ.1) THEN
        HA(2)=1$P 4
      ELSE
        HA(1)=EXP(-X(1))
        HA(3)=EXP(-X(2))
      ENDIF
      RETURN
  40  IF(KA.EQ.3) HA(2)=ONE
      RETURN
  50  HA(2)=KA*X(2)**(KA-1)
      HA(3)=KA*(KA-1)*X(1)*X(2)**(KA-2)
      RETURN
  60  HA(1)=-KA*KA*EXP(KA*X(1))
      HA(3)=-KA*KA*EXP(KA*X(2))
      RETURN
  70  B=X(1)
      IF(B.EQ.ZERO) B=EPS
      IF (KA.LT.2) THEN
      A=(TEN/(B*B+X(2)**2))**2/3.14159265358979323846$P 0
      HA(3)=A*B*X(2)
      HA(1)=-HA(3)
      HA(2)=(B*B-X(2)**2)*A/TWO
      ELSE IF (KA.EQ.2) THEN
      A=TEN/SQRT(B*B+X(2)**2)**3
      HA(1)= A*X(2)**2
      HA(2)=-A*B*X(2)
      HA(3)= A*B*B
      ENDIF
      RETURN
  80  U=KA
      V=16-KA
      W=MIN(U,V)
      A=-(U+U)/(V*X(2)+W*X(3))**3
      HA(3)=A*V*V
      HA(5)=A*V*W
      HA(6)=A*W*W
      RETURN
  90  A=(8-KA)*HALF-X(3)
      B=EXP(-HALF*X(2)*A**2)
      C=A*A*HALF
      D=B*X(1)
      HA(2)=-C*B
      HA(3)= C*C*D
      HA(4)= A*B*X(2)
      HA(5)= A*D*(ONE-C*X(2))
      HA(6)= D*X(2)*((C+C)*X(2)-ONE)
      RETURN
 100  A=(45+5*KA)+X(3)
      D=X(2)/A
      B=EXP(D)
      C=B/(A*A)*X(1)
      HA(2)= B/A
      HA(3)= C
      HA(4)=-D*B/A
      HA(5)=-C*(ONE+D)
      HA(6)= C*(TWO+D)*D
      RETURN
 110  D=X(1)
      IF(D.EQ.ZERO)D=EPS
      A=Y(KA)-X(2)
      IF(A.EQ.ZERO)A=EPS
      B=ABS(A)**X(3)/D
      C=EXP(-B)
      U=1$P 9*B*C
      V=LOG(ABS(A))
      W=B-ONE
      HA(1)= U/(D*D)*(B-TWO)
      HA(2)= U*X(3)/(A*D)*W
      HA(3)= U*X(3)/(A*A)*(X(3)*W+ONE)
      HA(4)=-U*V/D*W
      HA(5)= U/A*(ONE-X(3)*V*W)
      HA(6)= U*V*V*W
      RETURN
 120  A=KA/TEN
      HA(1)= A*A*EXP(-A*X(1))
      HA(3)=-A*A*EXP(-A*X(2))
      RETURN
 130  IF (KA.EQ.3) THEN
      HA(3)= TWO
      HA(5)=-TWO-TWO
      HA(6)= TEN-TWO
      ELSE IF (KA.GT.3) THEN
      A=S10+S10
      HA(1)= A
      HA(7)=-A
      HA(10)=A
      ENDIF
      RETURN
 140  IF(KA.EQ.1) HA(1)=-TEN-TEN
      IF(KA.EQ.3) HA(6)=-SIX*S10
      RETURN
 150  U=Y(KA)
      D=ONE/(U+X(3)+X(4)/U)
      A=X(1)*D*D
      C=(U+X(2))*D
      HA(2)=-D
      HA(4)= C*D
      HA(5)= A
      HA(6)=-A*C*TWO
      HA(7)= C*D/U
      HA(8)= A/U
      HA(9)= HA(6)/U
      HA(10)=HA(9)/U
      RETURN
 160  W=(KA+KA)/TEN
      B=SIN(W)
      HA(1)=TWO
      HA(2)=W+W
      HA(3)=TWO*W*W
      HA(6)=TWO
      HA(9)=B+B
      HA(10)=B*B*TWO
      RETURN
 170  W=(KA-1)*TEN
      A=EXP(-W*X(4))
      B=EXP(-W*X(5))
      HA(8)=  A*W
      HA(10)=-A*W*W*X(2)
      HA(13)= B*W
      HA(15)=-B*W*W*X(3)
      RETURN
 180  W=-KA/TEN
      U=W*W
      A= EXP(W*X(1))
      B=-EXP(W*X(2))
      C= EXP(W*X(3))
      HA(1)= A*U*X(4)
      HA(3)= B*U*X(5)
      HA(6)= C*U*X(6)
      HA(7)= A*W
      HA(12)=B*W
      HA(18)=C*W
      RETURN
 190  W=(KA-1)/TEN
      A=EXP(-W*X(5))
      HA(11)= A*W
      HA(15)=-A*W*W*X(1)
      DO 191 I=9,11
      A=W-X(I)
      B=A*A
      C=X(I-3)
      D=EXP(-C*B)
      U=X(I-7)
      J=ID(I-3)
      HA(J-4)= D*B
      HA(J  )=-D*B*B*U
      J=ID(I)
      HA(J-7)=-D*A*C*TWO
      HA(J-3)= D*A*U*TWO*(C*B-ONE)
  191 HA(J  )= D*C*U*TWO*(ONE-C*B*TWO)
      RETURN
 200  IF (KA.LT.30) THEN
      W=KA/(29+ZERO)
      B=-TWO
      DO 203 J=2,N+N
      DO 202 I=MAX(1,J-N),J/2
  202 HA(ID(J-I-1)+I)=B
  203 B=B*W
      ELSE IF (KA.GT.30) THEN
      HA(1)=-TWO
      ENDIF
      RETURN
 210  IF(MOD(KA,2).EQ.1) HA(ID(KA))=-TEN-TEN
      RETURN
 220  IF(MOD(KA,4).EQ.3) THEN
        HA(ID(KA-1))= TWO
        HA(ID(KA)-1)=-TWO-TWO
        HA(ID(KA))  = TEN-TWO
      ELSEIF(MOD(KA,4).EQ.0) THEN
        HA(ID(KA-3))= S10+S10
        HA(ID(KA)-3)=-S10-S10
        HA(ID(KA))  = S10+S10
      ENDIF
      RETURN
 230  IF(KA.LE.N) RETURN
      DO 231 J=1,N
  231 HA(ID(J))=TWO
      RETURN
 240  IF(KA.EQ.1) THEN
      ELSEIF(KA.LE.N) THEN
        HA(ID(KA)  )=EXP(X(KA  )/TEN)*S10*EPS
        HA(ID(KA-1))=EXP(X(KA-1)/TEN)*S10*EPS
      ELSEIF(KA.LT.N+N) THEN
        HA(ID(KA+1-N))=EXP(X(KA+1-N)/TEN)*S10*EPS
      ELSE
        DO 242 J=1,N
  242   HA(ID(J))=(N+1-J)*TWO
      ENDIF
      RETURN
 250  IF(KA.NE.N+2) RETURN
      DO 251 J=1,N
      DO 251 I=1,J
  251 HA(ID(J)+I-J)=I*J*TWO
      RETURN
 260  DO 261 J=1,N
  261 HA(ID(J))=COS(X(J))
      I=ID(KA)
      HA(I)=(KA+1)*HA(I)+SIN(X(KA))
      RETURN
 270  IF(KA.LT.N) RETURN
      A=ONE
      DO 272 J=1,N
      B=X(J)
      IF(B.EQ.ZERO) B=EPS
  272 A=A*B
      DO 273 J=1,N
      B=X(J)
      IF(B.EQ.ZERO) B=EPS
      DO 273 I=1,J-1
      C=X(I)
      IF(C.EQ.ZERO) C=EPS
  273 HA(ID(J)+I-J)=A/(B*C)
      RETURN
 280  U=ONE/(N+1)
      HA(ID(KA))=U*U*(KA*U+ONE+X(KA))*(TWO+ONE)
      RETURN
 290  U=ONE/(N+1)
      DO 291 J=1,N
      IF(J.LE.KA) V=(ONE-U*KA)*J
      IF(J.GT.KA) V=(ONE-U*J)*KA
  291 HA(ID(J))=V*U*U*(J*U+ONE+X(J))*(TWO+ONE)
      RETURN
 300  HA(ID(KA))=-TWO-TWO
      RETURN
      END
