* SUBROUTINE ECGS01                 ALL SYSTEMS                90/12/01
C PORTABILITY : ALL SYSTEMS
C 90/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* VALUE OF THE NONLINEAR CONSTRAINT KC.
*
* PARAMETERS :
*  II  MCOLS  NUMBER OF DECLARED COLUMNS.
*  II  KC NUMBER OF CONSTRAINT.
*  II  NZA SIZE OF THE ARRAYS RNR/A STORING COLUMNWISE LINEARIZED
*          CONSTRAINTS.
*  RI  X(MCOLS) VECTOR OF VARIABLES.
*  RO  CF FUNCTIONAL VALUE OF THE NONLINEAR CONSTRAINT KC.
*  II  RNR(NZA) ROW INDICES OF CONSTRAINT MATRIX.
*  IO  PRNR(MCOLS+1) POINTER VECTOR TO RNR.
*  RO  A(NZA) NUMERICAL VALUES OF THE CONSTRAINT MATRIX
*             CORRESPONDING TO RNR.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE ECGS01(MCOLS,KC,NZA,X,CF,RNR,PRNR,A,NEXT)
      INTEGER MCOLS,KC,NZA,NEXT
      $FLOAT X(MCOLS)
      INTEGER RNR(NZA),PRNR(MCOLS+1)
      $FLOAT A(NZA),CF
      $FLOAT ONE
      PARAMETER(ONE=1.0$P 0)
      GO TO (10) NEXT
   10 IF(KC.EQ.3) THEN
        CALL UKSII3(3,1,X(5),RNR,PRNR,A)
        CALL UKSII3(3,5,X(1),RNR,PRNR,A)
        CF=X(1)*X(5)
        RETURN
      ELSEIF(KC.EQ.1) THEN
        CALL UKSII3(1,1,ONE,RNR,PRNR,A)
        CALL UKSII3(1,2,2*X(2),RNR,PRNR,A)
        CALL UKSII3(1,3,3*X(3)*X(3),RNR,PRNR,A)
        CF=X(1)+X(2)*X(2)+X(3)*X(3)*X(3)
      ELSE
        CALL UKSII3(2,2,ONE,RNR,PRNR,A)
        CALL UKSII3(2,3,-2*X(3),RNR,PRNR,A)
        CALL UKSII3(2,4,ONE,RNR,PRNR,A)
        CF=X(2)-X(3)*X(3)+X(4)
      END IF
      RETURN
      END
