* SUBROUTINE EFFU03                ALL SYSTEMS                92/11/01
C PORTABILITY : ALL SYSTEMS
C 92/11/01 LU : ORIGINAL V0ERSION
*
* PURPOSE :
*  VALUES OF MODEL FUNCTIONS FOR CONSTRAINED MINIMIZATION.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  F  VALUE OF THE MODEL FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EFFU03(N,X,F,NEXT)
      INTEGER N,NEXT
      $FLOAT X(N),F
      $FLOAT A,B,C,PI,H,SOUC,SQ,HK
      INTEGER I,J
      $FLOAT CC(5,5),AA(16,16),EV(5),DV(5),Y(235),CV(10)
      COMMON /EMPR03/ Y
      PI=3.1415926535897932$P 0
      GO TO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150) NEXT
   10 A=PI
      F=SIN(A*X(1)/1.2$P 1)*COS(A*X(2)/1.6$P 1)
      RETURN
   20 F=((X(1)-3.0$P 0)**2-9.0$P 0)*X(2)**3/(2.7$P 1*SQRT(3.0$P 0))
      RETURN
   30 A=X(3)+3.0$P-2
      B=A+X(2)
      C=B+X(1)
      F=-32.174$P 0*(255.0$P 0*LOG(C/(B+9.0$P-2*X(1)))+
     $  280.0$P 0*LOG(B/(A+7.0$P-2*X(2)))+
     $  290.0$P 0*LOG(A/(3.0$P-2+1.3$P-1*X(3))))
      RETURN
   40 F=-X(1)*X(2)*X(3)
      RETURN
   50 F=2.0$P 0-X(1)*X(2)*X(3)
      RETURN
   60 F=(X(1)+1.0$P 1*X(2))**2+5.0$P 0*(X(3)-X(4))**2+
     &  (X(2)-2.0$P 0*X(3))**4+1.0$P 1*(X(1)-X(4))**4
      RETURN
   70 F=(X(1)-X(2))**2+(X(3)-1.0$P 0)**2+(X(4)-1.0$P 0)**4+
     &  (X(5)-1.0$P 0)**6
      RETURN
   80 F=(X(1)-X(2))**2+(X(2)-X(3))**2+(X(3)-X(4))**4+(X(4)-X(5))**2
      RETURN
   90 F=(X(1)-X(2))**2+(X(2)+X(3)-2.0$P 0)**2+
     &   (X(4)-1.0$P 0)**2+(X(5)-1.0$P 0)**2
      RETURN
  100 EV(1)=-15.0$P 0
      EV(2)=-27.0$P 0
      EV(3)=-36.0$P 0
      EV(4)=-18.0$P 0
      EV(5)=-12.0$P 0
      CC(1,1)=30.0$P 0
      CC(1,2)=-20.0$P 0
      CC(1,3)=-10.0$P 0
      CC(1,4)=32.0$P 0
      CC(1,5)=-10.0$P 0
      CC(2,1)=-20.0$P 0
      CC(2,2)=39.0$P 0
      CC(2,3)=-6.0$P 0
      CC(2,4)=-31.0$P 0
      CC(2,5)=32.0$P 0
      CC(3,1)=-10.0$P 0
      CC(3,2)=-6.0$P 0
      CC(3,3)=10.0$P 0
      CC(3,4)=-6.0$P 0
      CC(3,5)=-10.0$P 0
      CC(4,1)=32.0$P 0
      CC(4,2)=-31.0$P 0
      CC(4,3)=-6.0$P 0
      CC(4,4)=39.0$P 0
      CC(4,5)=-20.0$P 0
      CC(5,1)=-10.0$P 0
      CC(5,2)=32.0$P 0
      CC(5,3)=-10.0$P 0
      CC(5,4)=-20.0$P 0
      CC(5,5)=30.0$P 0
      DV(1)=4.0$P 0
      DV(2)=8.0$P 0
      DV(3)=10.0$P 0
      DV(4)=6.0$P 0
      DV(5)=2.0$P 0
      F=0.0$P 0
      DO 101 J=1,5
      DO 102 I=1,5
      F=F+CC(I,J)*X(I)*X(J)
  102 CONTINUE
      F=F+EV(J)*X(J)+DV(J)*X(J)**3
  101 CONTINUE
      RETURN
  110 HK=0.96$P 0*4.9$P 13
      H=((X(1)-1.0$P 4)**2/6.4$P 7+(X(1)-1.0$P 4)*(X(2)-1.0$P 0)/2.0$P 4+
     &  (X(2)-1.0$P 0)**2)*(X(3)-2.0$P 6)**2/HK+
     &  (X(4)-10.0$P 0)**2/2.5$P 3+(X(5)-1.0$P-3)**2/2.5$P-3+
     &  (X(6)-1.0$P 8)**2/2.5$P 17
      F=-EXP(-H/2.0$P 0)
      RETURN
  120 F=X(1)+2.0$P 0*X(2)+4.0$P 0*X(5)+EXP(X(1)*X(4))
      RETURN
  130 F=0.0$P 0
      SQ=SQRT(2.0$P 0*PI)
      DO 131 I=1,235
      A=X(1)/X(6)*EXP(-(Y(I)-X(3))**2/(2.0$P 0*X(6)**2))
      B=X(2)/X(7)*EXP(-(Y(I)-X(4))**2/(2.0$P 0*X(7)**2))
      C=(1.0$P 0-X(2)-X(1))/X(8)*
     &     EXP(-(Y(I)-X(5))**2/(2.0$P 0*X(8)**2))
      F=F-LOG((A+B+C)/SQ)
  131 CONTINUE
      RETURN
  140 F=0.0$P 0
      CV(1)=-6.089$P 0
      CV(2)=-17.164$P 0
      CV(3)=-34.054$P 0
      CV(4)=-5.914$P 0
      CV(5)=-24.721$P 0
      CV(6)=-14.986$P 0
      CV(7)=-24.100$P 0
      CV(8)=-10.708$P 0
      CV(9)=-26.662$P 0
      CV(10)=-22.179$P 0
      SOUC=0.0$P 0
      DO 141 J=1,10
      SOUC=SOUC+X(J)
  141 CONTINUE
      DO 142 J=1,10
      F=F+X(J)*(CV(J)+LOG(X(J)/SOUC))
  142 CONTINUE
      RETURN
  150 F=0.0$P 0
      DO 151 I=1,16
      DO 152 J=1,16
      AA(I,J)=0.0$P 0
  152 CONTINUE
  151 CONTINUE
      DO 153 I=1,16
      AA(I,I)=1.0$P 0
  153 CONTINUE
      AA(1,4)=1.0$P 0
      AA(1,7)=1.0$P 0
      AA(1,8)=1.0$P 0
      AA(1,16)=1.0$P 0
      AA(2,3)=1.0$P 0
      AA(2,7)=1.0$P 0
      AA(2,10)=1.0$P 0
      AA(3,7)=1.0$P 0
      AA(3,9)=1.0$P 0
      AA(3,10)=1.0$P 0
      AA(3,14)=1.0$P 0
      AA(4,7)=1.0$P 0
      AA(4,11)=1.0$P 0
      AA(4,15)=1.0$P 0
      AA(5,6)=1.0$P 0
      AA(5,10)=1.0$P 0
      AA(5,12)=1.0$P 0
      AA(5,16)=1.0$P 0
      AA(6,8)=1.0$P 0
      AA(6,15)=1.0$P 0
      AA(7,11)=1.0$P 0
      AA(7,13)=1.0$P 0
      AA(8,10)=1.0$P 0
      AA(8,15)=1.0$P 0
      AA(9,12)=1.0$P 0
      AA(9,16)=1.0$P 0
      AA(10,14)=1.0$P 0
      AA(11,13)=1.0$P 0
      AA(12,14)=1.0$P 0
      AA(13,14)=1.0$P 0
      DO 154 I=1,16
      DO 155 J=1,16
      F=F+AA(I,J)*(X(I)**2+X(I)+1.0$P 0)*(X(J)**2+X(J)+1.0$P 0)
  155 CONTINUE
  154 CONTINUE
      RETURN
      END
