* SUBROUTINE EFFU07             ALL SYSTEMS                 90/12/01
C PORTABILITY : ALL SYSTEMS
C 90/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF TEST FUNCTIONS FOR NONLINEAR APPROXIMATION.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  FF  VALUE OF THE OBJECTIVE FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EFFU07(N,X,FF,NEXT)
      INTEGER N,NEXT
      $FLOAT X(N),FF
      $FLOAT X1,X2,X3,X4,X5,X6,X7,X8,A,A1,A2,A3,A4,A5,A6,A7,A8,B,B1,B3,
     * B4,B5,B6,C,P,Q
      INTEGER I,J,K
      $FLOAT Y(128)
      COMMON /EMPR07/ Y
      GOTO(10,20,30,40,50,60,70,60,90,100,110,120,130,140,150,160,170,
     * 180,190,200,210,220,230,240,250,260,270,280,290,300,310,320,330,
     * 340),NEXT
   10 FF=-X(1)-X(2)
      RETURN
   20 FF=X(1)-X(2)
      RETURN
   30 FF=0.5$P 0*X(1)**2+X(2)**2-X(1)*X(2)-7.0$P 0*X(1)-7.0$P 0*X(2)
      RETURN
   40 FF=(X(1)-2.0$P 0)**2+X(2)**2
      RETURN
   50 FF=0.0$P 0
      DO 51 I=1,44
      X1=8.0$P 0-Y(I)
      X2=EXP(X1*X(2))
      X3=X(1)-0.49$P 0
      X4=Y(I+44)-X(1)+X2*X3
      FF=FF+X4*X4
   51 CONTINUE
      RETURN
   60 FF=100.0$P 0*(X(2)-X(1)**2)**2+(1.0$P 0-X(1))**2
      RETURN
   70 FF=(X(1)-10.0$P 0)**3+(X(2)-20.0$P 0)**3
      RETURN
   90 FF=-75.196$P 0+3.8112$P 0*X(1)+0.0020567$P 0*X(1)**3-
     * 1.0345$P-5*X(1)**4+6.8306$P 0*X(2)-0.030234$P 0*X(1)*X(2)+
     * 1.28134$P-3*X(2)*X(1)**2+2.266$P-7*X(2)*X(1)**4-
     * 0.25645$P 0*X(2)**2+0.0034604$P 0*X(2)**3-1.3514$P-5*X(2)**4+
     * 28.106$P 0/(X(2)+1.0$P 0)+5.2375$P-6*(X(1)*X(2))**2+
     *  6.3$P-8*X(1)*(X(1)*X(2))**2-7.0$P-10*(X(1)*X(2))**3-
     * 3.405$P-4*X(1)*X(2)**2+1.6638$P-6*X(1)*X(2)**3+
     *2.8673$P 0*EXP(0.0005$P 0*X(1)*X(2))-3.5256$P-5*X(2)*X(1)**3
      RETURN
  100 FF=-X(1)*X(2)*X(3)
      RETURN
  110 FF=X(1)**2+X(2)**2+X(3)**2
      RETURN
  120 FF=9.0$P 0*X(1)**2+X(2)**2+9.0$P 0*X(3)**2
      RETURN
  130 FF=5.0$P 0*X(1)+5.0$P 4/X(1)+20.0$P 0*X(2)+72.0$P 3/X(2)+
     * 10.0$P 0*X(3)+14.4$P 4/X(3)
      RETURN
  140 FF=-X(1)
      RETURN
  150 X2=1.6$P 0*X(1)
  151 X3=1.22$P 0*X2-X(1)
      X6=(X(2)+X3)/X(1)
      X1=0.01$P 0*X(1)*(112.0$P 0+13.167$P 0*X6-0.6667$P 0*X6**2)
      IF (ABS(X1-X2).GT.0.001$P 0) THEN
      X2=X1
      GO TO 151
      ENDIF
      X4=93.0$P 0
  152 X5=86.35$P 0+1.098$P 0*X6-0.038$P 0*X6**2+0.325$P 0*(X4-89.0$P 0)
      X8=3.0$P 0*X5-133.0$P 0
      X7=35.82$P 0-0.222$P 0*X8
      X1=98000.0$P 0*X(3)/(X2*X7+1000.0$P 0*X(3))
      IF (ABS(X1-X4).GT.0.001$P 0) THEN
      X4=X1
      GO TO 152
      ENDIF
      FF=-(0.063$P 0*X2*X5-5.04$P 0*X(1)-3.36$P 0*X3-0.035$P 0*X(2)-
     * 10.0$P 0*X(3))
      RETURN
  160 FF=0.0$P 0
      B3=X(3)
      B4=1.0$P 0-X(3)
      C=1.0$P 0/X(4)
      B=B3+B4*X(4)
      A=B*C
      A1=LOG(A)+1.0$P 0
      B1=LOG(B)+1.0$P 0
      X1=1.0$P 0/(12.0$P 0*X(1)+1.0$P 0)
      X2=1.0$P 0/(12.0$P 0*X(2)+1.0$P 0)
      X3=SQRT(0.1591545$P 0*X(1))*12.0$P 0*X1
      X4=SQRT(0.1591545$P 0*X(2))*12.0$P 0*X2
      X5=X3*B4
      X6=X4*B3
      X7=X5*X(1)
      X8=X6*X(2)
      DO 161 I=1,19
      A5=X(1)*(Y(I+38)+A1-A*Y(I))
      A6=EXP(A5-Y(I+38))
      B5=X(2)*(Y(I+38)+B1-B*Y(I))
      B6=EXP(B5-Y(I+38))
      P=X7*A6+X8*B6
      Q=P-Y(I+19)
      FF=FF+Q*Q
  161 CONTINUE
      RETURN
  170 FF=1.0$P 0+X(1)+X(2)+X(3)+X(4)
      RETURN
  180 X1=X(1)*X(1)
      X2=X(2)*X(2)
      X3=X(3)*X(3)
      X4=X(4)*X(4)
      X5=X(1)+X(1)
      X6=X(2)+X(2)
      X7=X(3)+X(3)
      X8=X(4)+X(4)
      FF=X1+X2+X3+X3+X4-5.0$P 0*(X(1)+X(2))-2.1$P 1*X(3)+7.0$P 0*X(4)
      RETURN
  190 FF=10.0$P 0*X(1)*X(4)-6.0$P 0*X(3)*X(2)**2+X(2)*X(1)**3+
     * 9.0$P 0*SIN(X(5)-X(3))+X(2)**3*X(4)**2*X(5)**4
      RETURN
  200 FF=5.3578547$P 0*X(3)**2+0.8356891$P 0*X(1)*X(5)+
     * 37.293239$P 0*X(1)-40792.141$P 0
      RETURN
  210 FF=24345.0$P 0+8720288.849$P 0*X(1)-150512.5253$P 0*X(1)*X(2)+
     * 156.6950325$P 0*X(1)*X(3)-476470.3222$P 0*X(1)*X(4)-
     * 729482.8271$P 0*X(1)*X(5)
      RETURN
  220 A1=-5.843$P-7
      A2=1.17$P-4
      A3=2.358$P-5
      A4=1.502$P-6
      A5=0.0321$P 0
      A6=0.004324$P 0
      A7=1.0$P-4
      A8=37.48$P 0
      X1=146.312$P 3
      Y(1)=X(2)+X(3)+41.6$P 0
      Y(18)=0.024$P 0*X(4)-4.62$P 0
      Y(2)=12.5$P 0/Y(18)+12.0$P 0
      Y(19)=0.0003535$P 0*X(1)**2+0.5311$P 0*X(1)+0.08705$P 0*Y(2)*X(1)
      Y(20)=0.052$P 0*X(1)+78.0$P 0+0.002377$P 0*Y(2)*X(1)
      Y(3)=Y(19)/Y(20)
      Y(4)=19.0$P 0*Y(3)
      Y(21)=0.04782$P 0*(X(1)-Y(3))+0.1956$P 0*(X(1)-Y(3))**2/X(2)+
     * 0.6376$P 0*Y(4)+1.594$P 0*Y(3)
      Y(22)=100.0$P 0*X(2)
      Y(23)=X(1)-Y(3)-Y(4)
      Y(24)=0.95$P 0-Y(21)/Y(22)
      Y(5)=Y(23)*Y(24)
      Y(6)=X(1)-Y(5)-Y(4)-Y(3)
      Y(25)=(Y(5)+Y(4))*0.995$P 0
      Y(7)=Y(25)/Y(1)
      Y(8)=Y(25)/3798.0$P 0
      Y(26)=Y(7)-0.0663$P 0*Y(7)/Y(8)-0.3153$P 0
      Y(9)=96.82$P 0/Y(26)+0.321$P 0*Y(1)
      Y(10)=1.29$P 0*Y(5)+1.258$P 0*Y(4)+2.29$P 0*Y(3)+1.71$P 0*Y(6)
      Y(11)=1.71$P 0*X(1)-0.452$P 0*Y(4)+0.58$P 0*Y(3)
      Y(27)=12.3$P 0/752.3$P 0
      Y(28)=1.75$P 0*Y(2)*0.995$P 0*X(1)
      Y(29)=0.995$P 0*Y(10)+1998.0$P 0
      Y(12)=Y(27)*X(1)+Y(28)/Y(29)
      Y(13)=Y(29)-1.75$P 0*Y(2)
      Y(14)=3623.0$P 0+64.4$P 0*X(2)+58.4$P 0*X(3)+X1/(Y(9)+
     * X(5))
      Y(30)=0.995$P 0*Y(10)+60.8$P 0*X(2)+48.0$P 0*X(4)-0.1121$P 0*Y(14)-
     * 5095.0$P 0
      Y(15)=Y(13)/Y(30)
      Y(16)=148.0$P 3-331.0$P 3*Y(15)+40.0$P 0*Y(13)-61.0$P 0*Y(15)*Y(13)
      Y(31)=2324.0$P 0*Y(10)-2.874$P 7*Y(2)
      Y(17)=1.413$P 7-1328.0$P 0*Y(10)-531.0$P 0*Y(11)+Y(31)/Y(29)
      Y(32)=Y(13)/Y(15)-Y(13)/0.52$P 0
      Y(33)=1.104$P 0-0.72$P 0*Y(15)
      Y(34)=Y(9)+X(5)
      FF=A1*Y(17)+A2*Y(14)+A3*Y(13)+A4*Y(16)+A5*Y(12)+A6*Y(5)+
     * A7*Y(32)/Y(33)+A8*Y(2)/Y(29)+0.1365$P 0
      RETURN
  230 FF=(X(1)-X(4))**2+(X(2)-X(5))**2+(X(3)-X(6))**2
      RETURN
  240 FF=0.0204$P 0*X(1)*X(4)*(X(1)+X(2)+X(3))+0.0187$P 0*X(2)*X(3)*
     * (X(1)+1.57$P 0*X(2)+X(4))+0.0607$P 0*X(1)*X(4)*X(5)**2*(X(1)+
     * X(2)+X(3))+0.0437$P 0*X(2)*X(3)*X(6)**2*(X(1)+1.57$P 0*X(2)+X(4))
      RETURN
  250 FF=4.3$P 0*X(1)+31.8$P 0*X(2)+63.3$P 0*X(3)+15.8$P 0*X(4)+
     * 68.5$P 0*X(5)+4.7$P 0*X(6)
      RETURN
  260 FF=(X(1)-1.0$P 1)**2+5.0$P 0*(X(2)-1.2$P 1)**2+X(3)**4+3.0$P 0*
     &(X(4)-1.1$P 1)**2+1.0$P 1*X(5)**6+7.0$P 0*X(6)**2+X(7)**4-4.0$P 0*
     &X(6)*X(7)-1.0$P 1*X(6)-8.0$P 0*X(7)
      RETURN
  270 FF=10.0$P 0*X(1)*X(4)**2/(X(2)*X(6)**3*X(7)**0.25$P 0)+
     * 15.0$P 0*X(3)*X(4)/(X(1)*X(2)**2*X(5)*X(7)**0.5$P 0)+
     * 20.0$P 0*X(2)*X(6)/(X(1)**2*X(4)*X(5)**2)+
     * 25.0$P 0*X(1)**2*X(2)**2*X(5)**0.5$P 0*X(7)/(X(3)*X(6)**2)
      RETURN
  280 FF=0.4$P 0*(X(1)/X(7))**0.67$P 0+0.4$P 0*(X(2)/X(8))**0.67$P 0+
     * 10.0$P 0-X(1)-X(2)
      RETURN
  290 FF=X(1)+X(2)+X(3)
      RETURN
  300 FF=-0.5$P 0*(X(1)*X(4)-X(2)*X(3)+X(3)*X(9)-X(5)*X(9)+X(5)*X(8)-
     * X(6)*X(7))
      RETURN
  310 FF=X(1)**2+X(2)**2+X(1)*X(2)-1.4$P 1*X(1)-1.6$P 1*X(2)+
     &(X(3)-1.0$P 1)**2+4.0$P 0*(X(4)-5.0$P 0)**2+(X(5)-3.0$P 0)**2+
     &2.0$P 0*(X(6)-1.0$P 0)**2+5.0$P 0*X(7)**2+7.0$P 0*(X(8)-
     &1.1$P 1)**2+2.0$P 0*(X(9)-1.0$P 1)**2+(X(10)-7.0$P 0)**2+4.5$P 1
      RETURN
  320 FF=0.0$P 0
      DO 321 I=1,10
      FF=FF-Y(I+50)*X(I)
  321 CONTINUE
      K=0
      DO 323 I=1,5
      X1=2.0$P 0*Y(I+85)*X(I+10)**2
      X2=0.0$P 0
      DO 322 J=1,5
      X2=X2+Y(K+J+60)*X(J+10)
  322 CONTINUE
      FF=FF+(X1+X2)*X(I+10)
      K=K+5
  323 CONTINUE
      RETURN
  330 FF=0.0$P 0
      DO 331 I=1,5
      FF=FF+Y(I)*X(I+11)+Y(I+5)*X(I)*X(I+11)
  331 CONTINUE
      RETURN
  340 FF=X(1)**2+X(2)**2+X(1)*X(2)-1.4$P 1*X(1)-1.6$P 1*X(2)+(X(3)-
     &1.0$P 1)**2+4.0$P 0*(X(4)-5.0$P 0)**2+(X(5)-3.0$P 0)**2+2.0$P 0*
     &(X(6)-1.0$P 0)**2+5.0$P 0*X(7)**2+7.0$P 0*(X(8)-1.1$P 1)**2+
     &2.0$P 0*(X(9)-1.0$P 1)**2+(X(10)-7.0$P 0)**2+(X(11)-9.0$P 0)**2+
     &1.0$P 1*(X(12)-1.0$P 0)**2+5.0$P 0*(X(13)-7.0$P 0)**2+4.0$P 0*
     &(X(14)-1.4$P 1)**2+2.7$P 1*(X(15)-1.0$P 0)**2+X(16)**4+(X(17)-
     &2.0$P 0)**2+1.3$P 1*(X(18)-2.0$P 0)**2+(X(19)-3.$P 0)**2+X(20)**2+
     &9.5$P 1
      RETURN
      END



