* SUBROUTINE EFFU12                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF MODEL FUNCTIONS FOR UNCONSTRAINED MINIMIZATION.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  F  VALUE OF THE MODEL FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EFFU12(N,X,F,NEXT)
      INTEGER N,NEXT
      $FLOAT X(N),F
      INTEGER I,J,K1,K2,K3,K4,N4,M
      REAL*8 T1,T2,T3,T4,C,D
      REAL*8 S, TEMP(400000), TEMP1, SUM
      REAL*8 U(400000), V(400000), T(400000)
      REAL*8 U1, V1, C1, C2
      REAL*8 ALPHA, BETA, GAMMA, DELTA
      GO TO ( 1, 2, 3, 4, 5, 6, 7, 8, 9,10,
     *       11,12,13,14,15,16,17,18,19,20,
     *       21,22,23,24,25,26,27,28,29,30,
     *       31,32,33,34,35,36,37,38,39,40,
     *       41,42,43,44,45,46,47,48,49,50,
     *       51,52,53,54,55,56,57,58,59,60,
     *       61,62,63,64,65,66,67,68,69,70,
     *       71,72,73) NEXT
*
*     EXTENDED FREUDENSTEIN & ROTH
*     INITIAL POINT: [0.5, -2, ...,0.5, -2].
*
1     CONTINUE
      F = 0.0$P 0
      DO I=1,N/2
        T1=-13.0$P 0+X(2*I-1)+5.0$P 0*X(2*I)*X(2*I)-X(2*I)**3-
     *   2.0$P 0*X(2*I)
        T2=-29.0$P 0+X(2*I-1)+X(2*I)**3+X(2*I)**2-14.0$P 0*X(2*I)
        F = F + T1*T1 + T2*T2
      END DO
      RETURN
*
*     EXTENDED TRIGONOMETRIC FUNCTION
*     INITIAL POINT: [0.2, 0.2, ....,0.2].
*
2     CONTINUE
      S= $DBLE(N)
      DO I=1,N
        S = S - COS(X(I))
      END DO
      DO I=1,N
        TEMP(I) = S + $DBLE(I)*(1.0$P 0-COS(X(I))) - SIN(X(I))
      END DO
      F = 0.0$P 0
      DO I=1,N
        F = F + TEMP(I)**2
      END DO
      RETURN
*
*     EXTENDED ROSENBROCK FUNCTION
*     INITIAL POINT: [-1.2, 1, -1.2, 1, ..........., -1.2, 1]
*
3     CONTINUE
      C=100.0$P 0
      F=0.0$P 0
      DO I=1,N/2
        F = F + C*(X(2*I)-X(2*I-1)**2)**2 + (1.0$P 0-X(2*I-1))**2
      END DO
      RETURN
*
*     EXTENDED WHITE & HOLST FUNCTION
*
*     INITIAL POINT: [-1.2, 1, -1.2, 1, ..........., -1.2, 1]
*
4     CONTINUE
      C=100.0$P 0
      F=0.0$P 0
      DO I=1,N/2
        F = F + C*(X(2*I)-X(2*I-1)**3)**2 + (1.0$P 0-X(2*I-1))**2
      END DO
      RETURN
*
*     EXTENDED BEALE FUNCTION  U63 (MATRIXROM)
*     INITIAL POINT: [1, 0.8, ...., 1, 0.8]
*
5     CONTINUE
*
      F=0.0$P 0
      J=1
      DO I=1,N/2
        T1=1.5$P 0  -X(2*I-1)+X(2*I-1)*X(2*I)
        T2=2.25$P 0 -X(2*I-1)+X(2*I-1)*X(2*I)*X(2*I)
        T3=2.625$P 0-X(2*I-1)+X(2*I-1)*X(2*I)*X(2*I)*X(2*I)
        F = F + T1*T1 + T2*T2 + T3*T3
        J=J+2
      END DO
      RETURN
*
*     EXTENDED PENALTY FUNCTION
*     INTIAL POINT: [1,2,3,.....,N].
*
6     CONTINUE
      TEMP1=0.0$P 0
      DO I=1,N
        TEMP1 = TEMP1 + X(I)**2
      END DO
      F = (TEMP1 - 0.25$P 0)**2
      DO I=1,N-1
        F = F + (X(I)-1.0$P 0)**2
      END DO
      RETURN
*
*     PERTURBED QUADRATIC FUNCTION
*     INITIAL POINT:  [0.5, 0.5, ......, 0.5].
*
7     CONTINUE
      TEMP1 = 0.0$P 0
      DO I=1,N
        TEMP1 = TEMP1 + X(I)
      END DO
      F = TEMP1*TEMP1/100.0$P 0
      DO I=1,N
        F = F + $DBLE(I)*X(I)**2
      END DO
      RETURN
*
*     RAYDAN 1 FUNCTION
*     INITIAL POINT: [1, 1, ..., 1]
*
8     CONTINUE
      F=0.0$P 0
      DO I=1,N
        F = F + $DBLE(I) * (EXP(X(I))-X(I)) / 10.0$P 0
      END DO
      RETURN
*
*     RAYDAN 2 FUNCTION
*     INITIAL POINT: [1, 1, .....,1]
*
9     CONTINUE
      F=0.0$P 0
      DO I=1,N
        F = F + EXP(X(I)) - X(I)
      END DO
      RETURN
*
*     DIAGONAL1 FUNCTION
*     INITIAL POINT: [1/N, 1/N, ....., 1/N]
*
10    CONTINUE
      F=0.0$P 0
      DO I=1,N
        F = F + EXP(X(I)) - X(I)*$DBLE(I)
      END DO
      RETURN
*
*     DIAGONAL2 FUNCTION
*     INITIAL POINT: [1/1, 1/2, ....., 1/N]
*
11    CONTINUE
      F=0.0$P 0
      DO I=1,N
        F = F + EXP(X(I)) - X(I)/$DBLE(I)
      END DO
      RETURN
*
*     DIAGONAL3 FUNCTION
*     INITIAL POINT: [1,1,...,1]
*
12    CONTINUE
      F=0.0$P 0
      DO I=1,N
        F = F + EXP(X(I)) - $DBLE(I)*SIN(X(I))
      END DO
      RETURN
*
*     HAGER FUNCTION
*     INITIAL POINT: [1,1,...,1]
*
13    CONTINUE
      F=0.0$P 0
      DO I=1,N
        F = F + EXP(X(I)) - X(I)*SQRT($DBLE(I))
      END DO
      RETURN
*
*     GENERALIZED TRIDIAGONAL-1 FUNCTION
*     INITIAL POINT: [2,2,...,2]
*
14    CONTINUE
      F=0.0$P 0
      DO I=1,N-1
        U(I) = X(I) + X(I+1) - 3.0$P 0
        V(I) = X(I) - X(I+1) + 1.0$P 0
      END DO
      DO I=1,N-1
        F = F + U(I)**2 + V(I)**4
      END DO
      RETURN
*
*     EXTENDED TRIDIAGONAL-1 FUNCTION
*     INITIAL POINT: [2,2,...,2]
*
15    CONTINUE
      F=0.0$P 0
      DO I=1,N/2
        U(I) = X(2*I-1) + X(2*I) - 3.0$P 0
        V(I) = X(2*I-1) - X(2*I) + 1.0$P 0
      END DO
      DO I=1,N/2
        F = F + U(I)**2 + V(I)**4
      END DO
      RETURN
*
*     EXTENDED THREE EXPONENTIAL TERMS
*     INTIAL POINT: [0.1,0.1,.....,0.1].
*
16    CONTINUE
      F=0.0$P 0
      J=1
      DO I=1,N/2
        T1=X(J) + 3.0$P 0*X(J+1) - 0.1$P 0
        T2=X(J) - 3.0$P 0*X(J+1) - 0.1$P 0
        T3=-X(J) - 0.1$P 0
        F = F + EXP(T1) + EXP(T2) + EXP(T3)
        J=J+2
      END DO
      RETURN
*
*     GENERALIZED TRIDIAGONAL-2
*     INITIAL POINT: [-1, -1, .........., -1., -1]
*
17    CONTINUE
      F = 0.0$P 0
      U(1) = 5.0$P 0*X(1)-3.0$P 0*X(1)**2-X(1)**3-3.0$P 0*X(2)+1.0$P 0
      DO I=2,N-1
        U(I)=5.0$P 0*X(I)-3.0$P 0*X(I)**2-X(I)**3-X(I-1)-
     *  3.0$P 0*X(I+1)+1.0$P 0
      END DO
      U(N)=5.0$P 0*X(N)-3.0$P 0*X(N)**2-X(N)**3-X(N-1)+1.0$P 0
      DO I=1,N
        F = F + U(I)**2
      END DO
      RETURN
*
*     DIAGONAL4 FUNCTION
*     INITIAL POINT: [1, 1, .........., 1., 1]
*
18    CONTINUE
      C=100.0$P 0
      F = 0.0$P 0
      DO I=1,N/2
        F = F + (X(2*I-1)**2 + C*X(2*I)**2)/2.0$P 0
      END DO
      RETURN
*
*     DIAGONAL5 FUNCTION  (MATRIXROM)
*     INITIAL POINT: [1.1, 1.1, .........., 1.1]
*
19    CONTINUE
      F = 0.0$P 0
      DO I=1,N
        F = F + DLOG( EXP(X(I)) + EXP(-X(I)) )
      END DO
      RETURN
*
*     EXTENDED HIMMELBLAU FUNCTION
*     INITIAL POINT: [1, 1, ....., 1]
*
20    CONTINUE
      F=0.0$P 0
      DO I=1,N/2
        U1 = X(2*I-1)**2 + X(2*I)    - 11.0$P 0
        V1 = X(2*I-1)    + X(2*I)**2 - 7.0$P 0
        F = F + U1*U1 + V1*V1
      END DO
      RETURN
*
*     GENERALIZED PSC1 FUNCTION
*     INITIAL POINT: [3, 0.1, ..., 3, 0.1]
*
21    CONTINUE
      F = 0.0$P 0
      DO I=1,N-1
        F = F + (X(I)**2 +X(I+1)**2 +X(I)*X(I+1))**2
     *        + (SIN(X(I)))**2 + (COS(X(I+1)))**2
      END DO
      RETURN
*
*     EXTENDED PSC1 FUNCTION
*     INITIAL POINT: [3, 0.1, ..., 3, 0.1]
*
22    CONTINUE
      F = 0.0$P 0
      DO I=1,N/2
        F = F + (X(2*I-1)**2 +X(2*I)**2 +X(2*I-1)*X(2*I))**2
     *        + (SIN(X(2*I-1)))**2 + (COS(X(2*I)))**2
      END DO
      RETURN
*
*     EXTENDED POWELL
*     INITIAL POINT: [3, -1, 0, 1, ......].
*
23    CONTINUE
      F=0.0$P 0
      DO I=1,N/4
        T1= X(4*I-3) + 10.0$P 0*X(4*I-2)
        T2= X(4*I-1) - X(4*I)
        T3= X(4*I-2) - 2.0$P 0*X(4*I-1)
        T4= X(4*I-3) - X(4*I)
        F = F + T1*T1 + 5.0$P 0*T2*T2 + T3**4 + 10.0$P 0*T4**4
      END DO
      RETURN
*
*     EXTENDED BLOCK DIAGONAL BD1 FUNCTION
*     INITIAL POINT: [0.1, 0.1, ..., 0.1].
*
24    CONTINUE
      F = 0.0$P 0
      DO I=1,N/2
        T1 = X(2*I-1)**2 + X(2*I)**2 - 2.0$P 0
        T2 = EXP(X(2*I-1)) - X(2*I)
        F = F + T1*T1 + T2*T2
      END DO
      RETURN
*
*     EXTENDED MARATOS FUNCTION
*     INITIAL POINT: [1.1, 0.1, ...,1.1, 0.1].
*
25    CONTINUE
      C = 100.0$P 0
      F = 0.0$P 0
      DO I=1,N/2
        T1 = X(2*I-1)**2 + X(2*I)**2 - 1.0$P 0
        F = F + (X(2*I-1) + C*T1*T1)
      END DO
      RETURN
*
*     EXTENDED CLIFF
*     INITIAL POINT:  [0, -1, ......, 0, -1].
*
26    CONTINUE
      F=0.0$P 0
      DO I=1,N/2
        TEMP1 = (X(2*I-1)-3.0$P 0)/100.0$P 0
      F = F+TEMP1*TEMP1-(X(2*I-1)-X(2*I))+
     *    EXP(20.0$P 0*(X(2*I-1)-X(2*I)))
      END DO
      RETURN
*
*     QUADRATIC DIAGONAL PERTURBED FUNCTION
*                     INITIAL POINT:  [0.5, 0.5, ......, 0.5].
*
27    CONTINUE
      TEMP1 = 0.0$P 0
      DO I=1,N
        TEMP1 = TEMP1 + X(I)
      END DO
      F = TEMP1*TEMP1
      DO I=1,N
        F = F + ($DBLE(I)/100.0$P 0) * X(I)**2
      END DO
      RETURN
*
*     EXTENDED WOOD FUNCTION
*     INITIAL POINT: [-3,-1,-3,-1,......]
*
28    CONTINUE
      F=0.0$P 0
      DO I=1,N/4
        F = F + 100.0$P 0*(X(4*I-3)**2-X(4*I-2))**2
     *        +        (X(4*I-3)-1.0$P 0)**2
     *        +  90.0$P 0*(X(4*I-1)**2-X(4*I))**2
     *        +        (1.0$P 0-X(4*I-1))**2
     *        +  10.1$P 0*(X(4*I-2)-1.0$P 0)**2
     *        +  10.1$P 0*(X(4*I)  -1.0$P 0)**2
     *        +  19.8$P 0*(X(4*I-2)-1.0$P 0)*(X(4*I)-1.0$P 0)
      END DO
      RETURN
*
*     EXTENDED HIEBERT FUNCTION
*     INITIAL POINT: [0,0,...0].
*
29    CONTINUE
      C1=10.0$P 0
      C2=500.0$P 0
      F = 0.0$P 0
      DO I=1,N/2
        F = F + (X(2*I-1)-C1)**2 + (X(2*I-1)*X(2*I)-C2)**2
      END DO
      RETURN
*
*     QUADRATIC FUNCTION QF1
*     INITIAL POINT: [1,1,...1].
*
30    CONTINUE
      F = 0.0$P 0
      DO I=1,N
        F = F + $DBLE(I)*X(I)*X(I)
      END DO
      F = F/2.0$P 0
      F = F - X(N)
      RETURN
*
*     EXTENDED QUADRATIC PENALTY QP1 FUNCTION
*     INITIAL POINT:  [1, 1, ......,1].
*
31    CONTINUE
      T1=0.0$P 0
      DO I=1,N
        T1 = T1 + X(I)*X(I)
      END DO
      T1 = T1 - 0.5$P 0
      F = 0.0$P 0
      DO I=1,N-1
        F = F + (X(I)*X(I) - 2.0$P 0)**2
      END DO
      F = F + T1*T1
      RETURN
*
*     EXTENDED QUADRATIC PENALTY QP2 FUNCTION
*     INITIAL POINT:  [1, 1, ......,1].
*
32    CONTINUE
      T1=0.0$P 0
      DO I=1,N
        T1 = T1 + X(I)*X(I)
      END DO
      T1 = T1 - 100.0$P 0
      F = 0.0$P 0
      DO I=1,N-1
        F = F + (X(I)*X(I) - SIN(X(I)))**2
      END DO
      F = F + T1*T1
      RETURN
*
*     A QUADRATIC FUNCTION QF2
*     INITIAL POINT:  [0.5, 0.5, ......,0.5].
*
33    CONTINUE
      F=0.0$P 0
      DO I=1,N
        F = F + $DBLE(I)*(X(I)**2 - 1.0$P 0)**2
      END DO
      F = F/2.0$P 0
      F = F - X(N)
      RETURN
*
*     EXTENDED EP1 FUNCTION
*     INITIAL POINT: [1.5.,1.5.,...,1.5].
*
34    CONTINUE
      F=0.0$P 0
      DO I=1,N/2
        T1=EXP(X(2*I-1)-X(2*I)) - 5.0$P 0
        T2=X(2*I-1)-X(2*I)
        T3=X(2*I-1)-X(2*I)-11.0$P 0
        F = F + T1*T1 + (T2*T2)*(T3*T3)
      END DO
      RETURN
*
*     EXTENDED TRIDIAGONAL-2 FUNCTION
*     INITIAL POINT: [1.,1.,...,1.].
*
35    CONTINUE
      C=0.1$P 0
      F=0.0$P 0
      DO I=1,N-1
        F=F+(X(I)*X(I+1)-1.0$P 0)**2+C*(X(I)+1.0$P 0)*(X(I+1)+1.0$P 0)
      END DO
      RETURN
*
*     BDQRTIC (CUTE)
*     INITIAL POINT X0=[1.,1.,...,1.].
*
36    CONTINUE
      N4=N-4
      F=0.0$P 0
      DO I=1,N4
        TEMP(I) = X(I)**2 + 2.0$P 0*X(I+1)**2 + 3.0$P 0*X(I+2)**2
     *                    + 4.0$P 0*X(I+3)**2 + 5.0$P 0*X(N)**2
      END DO
      DO I=1,N4
        F = F + (-4.0$P 0*X(I)+3.0$P 0)**2 + TEMP(I)**2
      END DO
      RETURN
*
*     TRIDIA (CUTE)
*     INITIAL POINT X0=[1,1,...,1].
*
37    CONTINUE
      ALPHA=2.0$P 0
      BETA=1.0$P 0
      GAMMA=1.0$P 0
      DELTA=1.0$P 0
      F=GAMMA*(DELTA*X(1)-1.0$P 0)**2
      DO I=2,N
        F = F + $DBLE(I)*(ALPHA*X(I)-BETA*X(I-1))**2
      END DO
      RETURN
*
*     ARWHEAD (CUTE)
*     INITIAL POINT X0=[1,1,...,1].
*
38    CONTINUE
      F=0.0$P 0
      DO I=1,N-1
        F = F + (-4.0$P 0*X(I)+3.0$P 0) + (X(I)**2+X(N)**2)**2
      END DO
      RETURN
*
*     NONDIA (SHANNO-78) (CUTE)
*     INITIAL POINT X0=[-1,-1,...,-1].
*
39    CONTINUE
      C=100.0$P 0
      F=(X(1)-1.0$P 0)**2 + C*(X(1)-X(1)**2)**2
      DO I=2,N
        F = F + C*(X(1)-X(I)**2)**2
      END DO
      RETURN
*
*     NONDQUAR (CUTE)
*     INITIAL POINT X0=[1,-1,1,-1,...,].
*
40    CONTINUE
      F = (X(1)-X(2))**2 + (X(N-1)+X(N))**2
      DO I=1,N-2
        F = F + (X(I)+X(I+1)+X(N))**4
      END DO
      RETURN
*
*     DQDRTIC
*     INITIAL POINT X0=[3,3,3...,3].
*
41    CONTINUE
      C=100.0$P 0
      D=100.0$P 0
      F=0.0$P 0
      DO I=1,N-2
        F = F + (X(I)**2 + C*X(I+1)**2 + D*X(I+2)**2)
      END DO
      RETURN
*
*     EG2 (CUTE)
*     INITIAL POINT X0=[1,1,1...,1].
*
42    CONTINUE
      F=0.5$P 0*SIN(X(N)*X(N))
      DO I=1,N-1
        F = F + SIN(X(1)+X(I)*X(I)-1.0$P 0)
      END DO
      RETURN
*
*     DIXMAANA (CUTE)
*     INITIAL POINT X0=[2.,2.,2...,2.].
*
43    CONTINUE
        ALPHA = 1.0$P 0
        BETA  = 0.0$P 0
        GAMMA = 0.125$P 0
        DELTA = 0.125$P 0
        K1 = 0
        K2 = 0
        K3 = 0
        K4 = 0
        M = N/3
        F = 1.0$P 0
        DO I=1,N
          F = F + ALPHA * X(I)* X(I) * ($DBLE(I)/$DBLE(N))**K1
        END DO
        DO I=1,N-1
          F = F + BETA*X(I)*X(I)*(X(I+1)+X(I+1)*X(I+1))**2 *
     *            ($DBLE(I)/$DBLE(N))**K2
        END DO
        DO I=1,2*M
          F = F + GAMMA * X(I)*X(I) * (X(I+M)**4) *
     *            ($DBLE(I)/$DBLE(N))**K3
        END DO
        DO I=1,M
          F = F + DELTA * X(I) * X(I+2*M) *
     *            ($DBLE(I)/$DBLE(N))**K4
        END DO
        RETURN
*
*     DIXMAANB (CUTE)
*     INITIAL POINT X0=[2.,2.,2...,2.].
*
44    CONTINUE
        ALPHA = 1.0$P 0
        BETA  = 0.0625$P 0
        GAMMA = 0.0625$P 0
        DELTA = 0.0625$P 0
        K1 = 0
        K2 = 0
        K3 = 0
        K4 = 0
        M = N/3
        F = 1.0$P 0
        DO I=1,N
          F = F + ALPHA * X(I)* X(I) * ($DBLE(I)/$DBLE(N))**K1
        END DO
        DO I=1,N-1
          F = F + BETA*X(I)*X(I)*(X(I+1)+X(I+1)*X(I+1))**2 *
     *            ($DBLE(I)/$DBLE(N))**K2
        END DO
        DO I=1,2*M
          F = F + GAMMA * X(I)*X(I) * (X(I+M)**4) *
     *            ($DBLE(I)/$DBLE(N))**K3
        END DO
        DO I=1,M
          F = F + DELTA * X(I) * X(I+2*M) *
     *            ($DBLE(I)/$DBLE(N))**K4
        END DO
      RETURN
*
*     DIXMAANC (CUTE)
*     INITIAL POINT X0=[2.,2.,2...,2.].
*
45    CONTINUE
        ALPHA = 1.0$P 0
        BETA  = 0.125$P 0
        GAMMA = 0.125$P 0
        DELTA = 0.125$P 0
        K1 = 0
        K2 = 0
        K3 = 0
        K4 = 0
        M = N/3
        F = 1.0$P 0
        DO I=1,N
          F = F + ALPHA * X(I)* X(I) * ($DBLE(I)/$DBLE(N))**K1
        END DO
        DO I=1,N-1
          F = F + BETA*X(I)*X(I)*(X(I+1)+X(I+1)*X(I+1))**2 *
     *            ($DBLE(I)/$DBLE(N))**K2
        END DO
        DO I=1,2*M
          F = F + GAMMA * X(I)*X(I) * (X(I+M)**4) *
     *            ($DBLE(I)/$DBLE(N))**K3
        END DO
        DO I=1,M
          F = F + DELTA * X(I) * X(I+2*M) *
     *            ($DBLE(I)/$DBLE(N))**K4
        END DO
      RETURN
*
*     DIXMAANE (CUTE)
*     INITIAL POINT X0=[2.,2.,2...,2.].
*
46    CONTINUE
        ALPHA = 1.0$P 0
        BETA  = 0.0$P 0
        GAMMA = 0.125$P 0
        DELTA = 0.125$P 0
        K1 = 1
        K2 = 0
        K3 = 0
        K4 = 1
        M = N/3
        F = 1.0$P 0
        DO I=1,N
          F = F + ALPHA * X(I)* X(I) * ($DBLE(I)/$DBLE(N))**K1
        END DO
        DO I=1,N-1
          F = F + BETA*X(I)*X(I)*(X(I+1)+X(I+1)*X(I+1))**2 *
     *            ($DBLE(I)/$DBLE(N))**K2
        END DO
        DO I=1,2*M
          F = F + GAMMA * X(I)*X(I) * (X(I+M)**4) *
     *            ($DBLE(I)/$DBLE(N))**K3
        END DO
        DO I=1,M
          F = F + DELTA * X(I) * X(I+2*M) *
     *            ($DBLE(I)/$DBLE(N))**K4
        END DO
        RETURN
*
*       PARTIAL PERTURBED QUADRATIC
*       INITIAL POINT X0=[0.5, 0.5, ..., 0.5].
*
47    CONTINUE
        TEMP(1) = X(1) + X(2)
        DO I=2,N-1
          TEMP(I) = TEMP(I-1) + X(I+1)
        END DO
        F=X(1)*X(1)
        DO I=2,N
          F = F + $DBLE(I)*X(I)*X(I) + TEMP(I-1)*TEMP(I-1)/100.0$P 0
        END DO
      RETURN
*
*     BROYDEN TRIDIAGONAL
*     INITIAL POINT X0=[-1., -1., ..., -1.].
*
48    CONTINUE
      TEMP(1) = 3.0$P 0*X(1) - 2.0$P 0*X(1)*X(1)
      DO I=2,N-1
        TEMP(I) = 3.0$P 0*X(I)-2.0$P 0*X(I)*X(I)-X(I-1)-2.0$P 0*X(I+1)+
     *  1.0$P 0
      END DO
      TEMP(N) = 3.0$P 0*X(N)-2.0$P 0*X(N)*X(N)-X(N-1)+1.0$P 0
      F = 0.0$P 0
      DO I=1,N
        F = F + TEMP(I)*TEMP(I)
      END DO
      RETURN
*
*     ALMOST PERTURBED QUADRATIC
*     INITIAL POINT X0=[0.5, 0.5, ...,0.5].
*
49    CONTINUE
      F = 0.01$P 0*(X(1)+X(N))**2
      DO I=1,N
        F = F + $DBLE(I)*X(I)*X(I)
      END DO
      RETURN
*
*     TRIDIAGONAL PERTURBED QUADRATIC
*     INITIAL POINT X0=[0.5, 0.5, ...,0.5].
*
50    CONTINUE
      DO I=1,N-2
        TEMP(I) = X(I) + X(I+1) + X(I+2)
      END DO
      F = X(1)*X(1)
      DO I=2,N-1
        F = F + $DBLE(I)*X(I)*X(I) + TEMP(I-1)**2
      END DO
      RETURN
*
*     EDENSCH FUNCTION (CUTE)
*     INITIAL POINT: [0., 0., ..., 0.].
*
51    CONTINUE
      F = 16.0$P 0
      DO I=1,N-1
        F = F + (X(I)-2.0$P 0)**4 +
     *          (X(I)*X(I+1)-2.0$P 0*X(I+1))**2 +
     *          (X(I+1)+1.0$P 0)**2
      END DO
      RETURN
*
*     VARDIM FUNCTION (CUTE)
*     INITIAL POINT: [1-1/N, 1-2/N, ..., 1-N/N].
*
52    CONTINUE
      SUM = 0.0$P 0
      DO I=1,N
        SUM = SUM + $DBLE(I)*X(I)
      END DO
      SUM = SUM - $DBLE(N)*$DBLE(N+1)/2.0$P 0
      F = SUM**2 + SUM**4
      DO I=1,N
        F = F + (X(I)-1.0$P 0)**2
      END DO
      RETURN
*
*     STAIRCASE S1
*     INITIAL POINT X0=[1,1,...,1].
*
53    CONTINUE
      F=0.0$P 0
      DO I=1,N-1
        F = F + (X(I)+X(I+1)-$DBLE(I))**2
      END DO
      RETURN
*
*     LIARWHD (CUTE)
*     INITIAL POINT X0=[4., 4., ....4.].
*
54    CONTINUE
      F=0.0$P 0
      DO I=1,N
        F = F + 4.0$P 0*(X(I)*X(I) - X(1))**2 + (X(I)-1.0$P 0)**2
      END DO
      RETURN
*
*     DIAGONAL 6
*     INITIAL POINT X0=[1.,1., ..., 1.].
*
55    CONTINUE
      F = 0.0$P 0
      DO I=1,N
        F = F + EXP(X(I)) - (1.0$P 0+X(I))
      END DO
      RETURN
*
*     DIXON3DQ (CUTE)
*     INITIAL POINT X0=[-1, -1,..., -1]  MARCH 7, 2005
*
56    CONTINUE
      F=(X(1)-2.0$P 0)**2
      DO I=1,N-1
        F = F + (X(I)-X(I+1))**2
      END DO
      F = F + (X(N)-1.0$P 0)**2
      RETURN
*
*     DIXMAANF (CUTE)
*     INITIAL POINT X0=[2.,2.,2...,2.].
*
57    CONTINUE
        ALPHA = 1.0$P 0
        BETA  = 0.0625$P 0
        GAMMA = 0.0625$P 0
        DELTA = 0.0625$P 0
        K1 = 1
        K2 = 0
        K3 = 0
        K4 = 1
        M = N/3
        F = 1.0$P 0
        DO I=1,N
          F = F + ALPHA * X(I)* X(I) * ($DBLE(I)/$DBLE(N))**K1
        END DO
        DO I=1,N-1
          F = F + BETA*X(I)*X(I)*(X(I+1)+X(I+1)*X(I+1))**2 *
     *            ($DBLE(I)/$DBLE(N))**K2
        END DO
        DO I=1,2*M
          F = F + GAMMA * X(I)*X(I) * (X(I+M)**4) *
     *            ($DBLE(I)/$DBLE(N))**K3
        END DO
        DO I=1,M
          F = F + DELTA * X(I) * X(I+2*M) *
     *            ($DBLE(I)/$DBLE(N))**K4
        END DO
        RETURN
*
*     DIXMAANG (CUTE)
*     INITIAL POINT X0=[2.,2.,2...,2.].
*
58    CONTINUE
        ALPHA = 1.0$P 0
        BETA  = 0.125$P 0
        GAMMA = 0.125$P 0
        DELTA = 0.125$P 0
        K1 = 1
        K2 = 1
        K3 = 0
        K4 = 1
        M = N/3
        F = 1.0$P 0
        DO I=1,N
          F = F + ALPHA * X(I)* X(I) * ($DBLE(I)/$DBLE(N))**K1
        END DO
        DO I=1,N-1
          F = F + BETA*X(I)*X(I)*(X(I+1)+X(I+1)*X(I+1))**2 *
     *            ($DBLE(I)/$DBLE(N))**K2
        END DO
        DO I=1,2*M
          F = F + GAMMA * X(I)*X(I) * (X(I+M)**4) *
     *            ($DBLE(I)/$DBLE(N))**K3
        END DO
        DO I=1,M
          F = F + DELTA * X(I) * X(I+2*M) *
     *            ($DBLE(I)/$DBLE(N))**K4
        END DO
        RETURN
*
*     DIXMAANH (CUTE)
*     INITIAL POINT X0=[2.,2.,2...,2.].
*
59    CONTINUE
        ALPHA = 1.0$P 0
        BETA  = 0.26$P 0
        GAMMA = 0.26$P 0
        DELTA = 0.26$P 0
        K1 = 1
        K2 = 0
        K3 = 0
        K4 = 1
        M = N/3
        F = 1.0$P 0
        DO I=1,N
          F = F + ALPHA * X(I)* X(I) * ($DBLE(I)/$DBLE(N))**K1
        END DO
        DO I=1,N-1
          F = F + BETA*X(I)*X(I)*(X(I+1)+X(I+1)*X(I+1))**2 *
     *            ($DBLE(I)/$DBLE(N))**K2
        END DO
        DO I=1,2*M
          F = F + GAMMA * X(I)*X(I) * (X(I+M)**4) *
     *            ($DBLE(I)/$DBLE(N))**K3
        END DO
        DO I=1,M
          F = F + DELTA * X(I) * X(I+2*M) *
     *            ($DBLE(I)/$DBLE(N))**K4
        END DO
        RETURN
*
*     DIXMAANI (CUTE)
*     INITIAL POINT X0=[2.,2.,2...,2.].
*
60    CONTINUE
        ALPHA = 1.0$P 0
        BETA  = 0.0$P 0
        GAMMA = 0.125$P 0
        DELTA = 0.125$P 0
        K1 = 1
        K2 = 0
        K3 = 0
        K4 = 2
        M = N/3
        F = 1.0$P 0
        DO I=1,N
          F = F + ALPHA * X(I)* X(I) * ($DBLE(I)/$DBLE(N))**K1
        END DO
        DO I=1,N-1
          F = F + BETA*X(I)*X(I)*(X(I+1)+X(I+1)*X(I+1))**2 *
     *            ($DBLE(I)/$DBLE(N))**K2
        END DO
        DO I=1,2*M
          F = F + GAMMA * X(I)*X(I) * (X(I+M)**4) *
     *            ($DBLE(I)/$DBLE(N))**K3
        END DO
        DO I=1,M
          F = F + DELTA * X(I) * X(I+2*M) *
     *            ($DBLE(I)/$DBLE(N))**K4
        END DO
        RETURN
*
*     DIXMAANJ (CUTE)
*     INITIAL POINT X0=[2.,2.,2...,2.].
*
61    CONTINUE
        ALPHA = 1.0$P 0
        BETA  = 0.0625$P 0
        GAMMA = 0.0625$P 0
        DELTA = 0.0125$P 0
        K1 = 1
        K2 = 0
        K3 = 0
        K4 = 1
        M = N/3
        F = 1.0$P 0
        DO I=1,N
          F = F + ALPHA * X(I)* X(I) * ($DBLE(I)/$DBLE(N))**K1
        END DO
        DO I=1,N-1
          F = F + BETA*X(I)*X(I)*(X(I+1)+X(I+1)*X(I+1))**2 *
     *            ($DBLE(I)/$DBLE(N))**K2
        END DO
        DO I=1,2*M
          F = F + GAMMA * X(I)*X(I) * (X(I+M)**4) *
     *            ($DBLE(I)/$DBLE(N))**K3
        END DO
        DO I=1,M
          F = F + DELTA * X(I) * X(I+2*M) *
     *            ($DBLE(I)/$DBLE(N))**K4
        END DO
        RETURN
*
*     DIXMAANK (CUTE)
*     INITIAL POINT X0=[2.,2.,2...,2.].
*
62    CONTINUE
        ALPHA = 1.0$P 0
        BETA  = 0.625$P 0
        GAMMA = 0.625$P 0
        DELTA = 0.625$P 0
        K1 = 1
        K2 = 1
        K3 = 1
        K4 = 1
        M = N/3
        F = 1.0$P 0
        DO I=1,N
          F = F + ALPHA * X(I)* X(I) * ($DBLE(I)/$DBLE(N))**K1
        END DO
        DO I=1,N-1
          F = F + BETA*X(I)*X(I)*(X(I+1)+X(I+1)*X(I+1))**2 *
     *            ($DBLE(I)/$DBLE(N))**K2
        END DO
        DO I=1,2*M
          F = F + GAMMA * X(I)*X(I) * (X(I+M)**4) *
     *            ($DBLE(I)/$DBLE(N))**K3
        END DO
        DO I=1,M
          F = F + DELTA * X(I) * X(I+2*M) *
     *            ($DBLE(I)/$DBLE(N))**K4
        END DO
        RETURN
*
*     DIXMAANL (CUTE)
*     INITIAL POINT X0=[2.,2.,2...,2.].
*
63    CONTINUE
        ALPHA = 1.0$P 0
        BETA  = 0.26$P 0
        GAMMA = 0.26$P 0
        DELTA = 0.26$P 0
        K1 = 2
        K2 = 2
        K3 = 2
        K4 = 1
        M = N/3
        F = 1.0$P 0
        DO I=1,N
          F = F + ALPHA * X(I)* X(I) * ($DBLE(I)/$DBLE(N))**K1
        END DO
        DO I=1,N-1
          F = F + BETA*X(I)*X(I)*(X(I+1)+X(I+1)*X(I+1))**2 *
     *            ($DBLE(I)/$DBLE(N))**K2
        END DO
        DO I=1,2*M
          F = F + GAMMA * X(I)*X(I) * (X(I+M)**4) *
     *            ($DBLE(I)/$DBLE(N))**K3
        END DO
        DO I=1,M
          F = F + DELTA * X(I) * X(I+2*M) *
     *            ($DBLE(I)/$DBLE(N))**K4
        END DO
        RETURN
*
*     ENGVAL1 (CUTE)
*     INITIAL POINT X0=[2.,2.,2...,2.].
*
64    CONTINUE
      DO I=1,N-1
        T(I) = X(I)*X(I) + X(I+1)*X(I+1)
      END DO
      F = 0.0$P 0
      DO I=1,N-1
        F = F + T(I)*T(I) + (-4.0$P 0*X(I) + 3.0$P 0)
      END DO
      RETURN
*
*     FLETCHCR (CUTE)
*     INITIAL POINT: [0,0,...,0]
*
65    CONTINUE
      F=0.0$P 0
      DO I=1,N-1
        T(I) = X(I+1) - X(I) + 1.0$P 0 - X(I)*X(I)
      END DO
      DO I=1,N-1
        F = F + 100.0$P 0*T(I)*T(I)
      END DO
      RETURN
*
*     COSINE (CUTE)
*     INITIAL POINT: [1,1,...,1]
*
66    CONTINUE
      F=0.0$P 0
      DO I=1,N-1
        F = F + COS(X(I)*X(I) - X(I+1)/2.0$P 0)
      END DO
      RETURN
*
*     DENSCHNB (CUTE)
*     INITIAL POINT: [1,1,...,1]
*
67    CONTINUE
      F=0.0$P 0
      DO I=1,N/2
        F = F + (X(2*I-1)-2.0$P 0)**2 +
     *          ((X(2*I-1)-2.0$P 0)**2)*(X(2*I)**2) +
     *          (X(2*I)+1.0$P 0)**2
      END DO
      RETURN
*
*     DENSCHNF (CUTE)
*     INITIAL POINT: [2,0,2,0,...,2,0]
*
68    CONTINUE
      F=0.0$P 0
      DO  I=1,N/2
      F=F+(2.0$P 0*(X(2*I-1)+X(2*I))**2+
     *    (X(2*I-1)-X(2*I))**2-8.0$P 0)**2+
     *    (5.0$P 0*X(2*I-1)**2+(X(2*I)-3.0$P 0)**2-9.0$P 0)**2
      END DO
      RETURN
*
*     SINQUAD (CUTE)
*     INITIAL POINT: [0.1, 0.1, ..., 0.1]
*
69    CONTINUE
      F=(X(1)-1.0$P 0)**4 + (X(N)**2-X(1)**2)**2
      DO I=1,N-2
        T(I) = SIN(X(I+1)-X(N)) - X(1)**2 + X(I+1)**2
        F = F + T(I)*T(I)
      END DO
      RETURN
*
*     BIGGSB1 (CUTE)
*     INITIAL POINT: [0., 0., ....,0.]
*
70    CONTINUE
      F=(X(1)-1.0$P 0)**2 + (1.0$P 0-X(N))**2
      DO I=2,N
        F = F + (X(I)-X(I-1))**2
      END DO
      RETURN
*
*     PARTIAL PERTURBED QUADRATIC PPQ2
*     INITIAL POINT: [0.5,0.5,...,0.5]
*
71    CONTINUE
        TEMP(1) = X(1) + X(2)
        DO I=2,N-1
          TEMP(I) = TEMP(I-1) + X(I+1)
        END DO
        F=X(1)*X(1)
        DO I=2,N
          F = F + X(I)*X(I)/$DBLE(I) + TEMP(I-1)*TEMP(I-1)/100.0$P 0
        END DO
        RETURN
*
*     SCALED QUADRATIC SQ1
*     INITIAL POINT: [1,2,...,N]
*
72    CONTINUE
        F = 0.0$P 0
        DO I=1,N
          F = F + $DBLE(I) * X(I)*X(I)
        END DO
        F = F/2.0$P 0
        RETURN
*
*     SCALED QUADRATIC SQ2
*     INITIAL POINT: [1,2,...,N]
*
73    CONTINUE
           F=0.0$P 0
        DO I=1,100
          F = F + X(I)*X(I)
        END DO
        DO I=101,N
          F = F + $DBLE(I)*X(I)*X(I)
        END DO
        F=F/2.0$P 0
      RETURN
      END

