* SUBROUTINE EFGU20                ALL SYSTEMS                94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
*  GRADIENTS OF MODEL FUNCTIONS FOR UNCONSTRAINED MINIMIZATION.
*  SPARSE VERSION - LU VERSION WITH MODIFIED TESTS NO 7-10,12.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  G(N)  GRADIENT OF THE MODEL FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EFGU20(N,X,G,NEXT)
      INTEGER N,NEXT
      $FLOAT X(N),G(N)
      $FLOAT A,B,C,D,P,Q,R,U,V
      INTEGER I,J,K
      DO 1 I=1,N
        G(I)=0.0$P 0
    1 CONTINUE
      GOTO (10,20,30,40,50,60,70,80,90,100,110,120,130,110,120,160,170,
     & 160,20), NEXT
   10 DO 11 J=2,N
        A=X(J-1)**2-X(J)
        B=X(J-1)-1.0$P 0
        G(J-1)=G(J-1)+4.0$P 2*X(J-1)*A+2.0$P 0*B
        G(J)=G(J)-2.0$P 2*A
   11 CONTINUE
      RETURN
   20 DO 21 J=2,N-2,2
        A=X(J-1)**2-X(J)
        B=X(J-1)-1.0$P 0
        C=X(J+1)**2-X(J+2)
        D=X(J+1)-1.0$P 0
        U=X(J)+X(J+2)-2.0$P 0
        V=X(J)-X(J+2)
        G(J-1)=G(J-1)+4.0$P 2*X(J-1)*A+2.0$P 0*B
        G(J)=G(J)-2.0$P 2*A+2.0$P 1*U+0.2$P 0*V
        G(J+1)=G(J+1)+3.6$P 2*X(J+1)*C+2.0$P 0*D
        G(J+2)=G(J+2)-1.8$P 2*C+2.0$P 1*U-0.2$P 0*V
   21 CONTINUE
      RETURN
   30 DO 31 J=2,N-2,2
        A=X(J-1)+1.0$P 1*X(J)
        B=X(J+1)-X(J+2)
        C=X(J)-2.0$P 0*X(J+1)
        D=X(J-1)-X(J+2)
        G(J-1)=G(J-1)+2.0$P 0*A+4.0$P 1*D**3
        G(J)=G(J)+2.0$P 1*A+4.0$P 0*C**3
        G(J+1)=G(J+1)-8.0$P 0*C**3+1.0$P 1*B
        G(J+2)=G(J+2)-4.0$P 1*D**3-1.0$P 1*B
   31 CONTINUE
      RETURN
   40 DO 41 J=2,N-2,2
        A=EXP(X(J-1))
        B=A-X(J)
        B=4.0$P 0*B**3
        D=X(J)-X(J+1)
        D=6.0$P 2*D**5
        P=X(J+1)-X(J+2)
        C=COS(P)
        Q=SIN(P)/COS(P)
        Q=4.0$P 0*Q**3/C**2
        U=X(J-1)
        V=X(J+2)-1.0$P 0
        G(J-1)=G(J-1)+A*B+8.0$P 0*U**7
        G(J)=G(J)+D-B
        G(J+1)=G(J+1)+Q-D
        G(J+2)=G(J+2)+2.0$P 0*V-Q
   41 CONTINUE
      RETURN
   50 P=7.0$P 0/3.0$P 0
      DO 51 J=1,N
        A=(3.0$P 0-2.0$P 0*X(J))*X(J)+1.0$P 0
        IF (J.GT.1) A=A-X(J-1)
        IF (J.LT.N) A=A-X(J+1)
        B=P*ABS(A)**(P-1.0$P 0)*SIGN(1.0$P 0,A)
        G(J)=G(J)+B*(3.0$P 0-4.0$P 0*X(J))
        IF (J.GT.1) G(J-1)=G(J-1)-B
        IF (J.LT.N) G(J+1)=G(J+1)-B
   51 CONTINUE
      RETURN
   60 P=7.0$P 0/3.0$P 0
      DO 63 J=1,N
        A=(2.0$P 0+5.0$P 0*X(J)**2)*X(J)+1.0$P 0
        DO 61 I=MAX(1,J-5),MIN(N,J+1)
          A=A+X(I)*(1.0$P 0+X(I))
   61   CONTINUE
        B=P*ABS(A)**(P-1.0$P 0)*SIGN(1.0$P 0,A)
        G(J)=G(J)+B*(2.0$P 0+1.5$P 1*X(J)**2)
        DO 62 I=MAX(1,J-5),MIN(N,J+1)
          G(I)=G(I)+B*(1.0$P 0+2.0$P 0*X(I))
   62   CONTINUE
   63 CONTINUE
      RETURN
   70 DO 72 J=1,N
      A=$DBLE(J)*SIN(X(J))
      G(J)=G(J)+A
      IF(J.GT.1) G(J-1)=G(J-1)+$DBLE(J)*COS(X(J-1))
      IF(J.LT.N) G(J+1)=G(J+1)-$DBLE(J)*COS(X(J+1))
   72 CONTINUE
      RETURN
   80 P=-0.2008$P-2
      Q=-0.1900$P-2
      R=-0.0261$P-2
      DO 82 I=0,N-5,5
      A=1.0$P 0
      B=0.0$P 0
      DO 81 J=1,5
      A=A*X(I+J)
      B=B+X(I+J)**2
   81 CONTINUE
      A=A*EXP(A)
      B=B-1.0$P 1-P
      C=X(I+2)*X(I+3)-5.0$P 0*X(I+4)*X(I+5)-Q
      D=X(I+1)**3+X(I+2)**3+1.0$P 0-R
      G(I+1)=G(I+1)+A/X(I+1)+2.0$P 1*(2.0$P 0*B*X(I+1)
     &       +3.0$P 0*D*X(I+1)**2)
      G(I+2)=G(I+2)+A/X(I+2)+2.0$P 1*(2.0$P 0*B*X(I+2)
     &       +C*X(I+3)+3.0$P 0*D*X(I+2)**2)
      G(I+3)=G(I+3)+A/X(I+3)+2.0$P 1*(2.0$P 0*B*X(I+3)+C*X(I+2))
      G(I+4)=G(I+4)+A/X(I+4)+2.0$P 1*(2.0$P 0*B*X(I+4)
     &       -5.0$P 0*C*X(I+5))
      G(I+5)=G(I+5)+A/X(I+5)+2.0$P 1*(2.0$P 0*B*X(I+5)-5.0$P 0*C*X(I+4))
   82 CONTINUE
      RETURN
   90 C=0.0$P 0
      DO 91 J=2,N,2
      A=X(J-1)-3.0$P 0
      B=X(J-1)-X(J)
      G(J-1)=G(J-1)+2.0$P-4*A-1.0$P 0+2.0$P 1*EXP(2.0$P 1*B)
      G(J)=G(J)+1.0$P 0-2.0$P 1*EXP(2.0$P 1*B)
   91 CONTINUE
      RETURN
  100 DO 101 J=2,N,2
      A=X(J)**2
      B=X(J-1)**2
      C=A+1.0$P 0
      D=B+1.0$P 0
      P=0.0$P 0
      IF (A.GT.P) P=LOG(A)
      Q=0.0$P 0
      IF (B.GT.Q) Q=LOG(B)
      G(J-1)=G(J-1)+2.0$P 0*X(J-1)*(C*B**A+P*A**D)
      G(J)=G(J)+2.0$P 0*X(J)*(D*A**B+Q*B**C)
  101 CONTINUE
      RETURN
  110 K=(N-2)/3
      DO 111 I=1,K
      J=(I-1)*3
      G(J+1)=G(J+1)+2.0$P 0*(X(J+1)-X(J+2))
      G(J+2)=G(J+2)-2.0$P 0*(X(J+1)-X(J+2))
      G(J+3)=G(J+3)+2.0$P 0*(X(J+3)-1.0$P 0)
      G(J+4)=G(J+4)+4.0$P 0*(X(J+4)-1.0$P 0)**3
      G(J+5)=G(J+5)+6.0$P 0*(X(J+5)-1.0$P 0)**5
  111 CONTINUE
      RETURN
  120 K=(N-1)/4
      DO 121 I=1,K
      J=(I-1)*4
      G(J+1)=G(J+1)+2.0$P 0*(X(J+1)-X(J+2))
      G(J+2)=G(J+2)-2.0$P 0*(X(J+1)-X(J+2))+
     & 2.0$P 0*(X(J+2)-X(J+3))
      G(J+3)=G(J+3)-2.0$P 0*(X(J+2)-X(J+3))+
     & 4.0$P 0*(X(J+3)-X(J+4))**3
      G(J+4)=G(J+4)-4.0$P 0*(X(J+3)-X(J+4))**3+
     & 4.0$P 0*(X(J+4)-X(J+5))**3
      G(J+5)=G(J+5)-4.0$P 0*(X(J+4)-X(J+5))**3
  121 CONTINUE
      RETURN
  130 K=(N-2)/3
      DO 131 I=1,K
      J=(I-1)*3
      G(J+1)=G(J+1)+2.0$P 0*(X(J+1)-1.0$P 0)
      G(J+2)=G(J+2)+2.0$P 0*(X(J+2)-X(J+3))
      G(J+3)=G(J+3)-2.0$P 0*(X(J+2)-X(J+3))
      G(J+4)=G(J+4)+4.0$P 0*(X(J+4)-X(J+5))**3
      G(J+5)=G(J+5)-4.0$P 0*(X(J+4)-X(J+5))**3
  131 CONTINUE
      RETURN
  160 K=(N-1)/4
      DO 161 I=1,K
      J=(I-1)*4
      G(J+1)=G(J+1)+4.0$P 0*(X(J+1)-X(J+2))**3
      G(J+2)=G(J+2)-4.0$P 0*(X(J+1)-X(J+2))**3+
     & 2.0$P 0*(X(J+2)+X(J+3)-2.0$P 0)
      G(J+3)=G(J+3)+2.0$P 0*(X(J+2)+X(J+3)-2.0$P 0)
      G(J+4)=G(J+4)+2.0$P 0*(X(J+4)-1.0$P 0)
      G(J+5)=G(J+5)+2.0$P 0*(X(J+5)-1.0$P 0)
  161 CONTINUE
      RETURN
  170 K=(N-1)/4
      DO 171 I=1,K
      J=(I-1)*4
      G(J+1)=G(J+1)+8.0$P 0*(4.0$P 0*X(J+1)-X(J+2))
      G(J+2)=G(J+2)-2.0$P 0*(4.0$P 0*X(J+1)-X(J+2))+
     & 4.0$P 0*(X(J+2)+X(J+3)-2.0$P 0)**3
      G(J+3)=G(J+3)+4.0$P 0*(X(J+2)+X(J+3)-2.0$P 0)**3
      G(J+4)=G(J+4)+2.0$P 0*(X(J+4)-1.0$P 0)
      G(J+5)=G(J+5)+2.0$P 0*(X(J+5)-1.0$P 0)
  171 CONTINUE
      RETURN
      END

