* SUBROUTINE EFHS10                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
*  HESSIAN MATRICES OF TEST FUNCTIONS FOR UNCONSTRAINED MINIMIZATION.
*  SPARSE VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  M  NUMBER OF ELEMENTS OF THE SPARSE MATRIX.
*  RO  X(N)  VECTOR OF VARIABLES.
*  RO  H(M)  NUMERICAL VALUES OF THE SPARSE HESSIAN MATRIX STORED IN
*            THE PACKED ROW FORM.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EFHS10(N,M,X,H,NEXT)
      INTEGER N,M,NEXT
      $FLOAT X(N),H(M)
      $FLOAT A,B,C,D,P,Q,R
      INTEGER I,J,K,IN1DG,IN2DG,IN3DG,IN4DG,IN5DG,IN6DG,IN7DG
      IN1DG(I,J)=I/2+J
      IN2DG(I,J)=I+J-1
      IN3DG(I,J)=2*I+J-2
      DO 1 I=1,M
        H(I)=0.0$(P)0
    1 CONTINUE
      GOTO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150),NEXT
   10 DO 11 I=2,N
        H(IN2DG(I-1,I-1))=H(IN2DG(I-1,I-1))+1.2$(P)3*X(I-1)**2
     *                   -4$(P)2*X(I)+2$(P)0
        H(IN2DG(I-1,I))=H(IN2DG(I-1,I))-4$(P)2*X(I-1)
        H(IN2DG(I,I))=H(IN2DG(I,I))+2$(P)2
   11 CONTINUE
      RETURN
   20 DO 21 I=1,N-3,2
        H(IN7DG(I,I))=H(IN7DG(I,I))-4$(P)2*X(I+1)+1.2$(P)3*X(I)**2+2$(P)0
        H(IN7DG(I,I+1))=H(IN7DG(I,I+1))-4$(P)2*X(I)
        H(IN7DG(I+1,I+1))=H(IN7DG(I+1,I+1))+2.202$(P)2
        H(IN7DG(I+1,I+3))=H(IN7DG(I+1,I+3))+1.98$(P)1
        H(IN7DG(I+2,I+2))=H(IN7DG(I+2,I+2))+1.08$(P)3*X(I+2)**2
     *                   -3.6$(P)2*X(I+3)+2$(P)0
        H(IN7DG(I+2,I+3))=H(IN7DG(I+2,I+3))-3.6$(P)2*X(I+2)
        H(IN7DG(I+3,I+3))=H(IN7DG(I+3,I+3))+2.002$(P)2
   21 CONTINUE
      RETURN
   30 DO 31 I=1,N-3,2
        A=1.2$(P)2*(X(I)-X(I+3))**2
        B=1.2$(P)1*(X(I+1)-2$(P)0*X(I+2))**2
        H(IN4DG(N,I,I))=H(IN4DG(N,I,I))+A+2$(P)0
        H(IN4DG(N,I,I+1))=H(IN4DG(N,I,I+1))+2$(P)1
        H(IN4DG(N,I,I+3))=H(IN4DG(N,I,I+3))-A
        H(IN4DG(N,I+1,I+1))=H(IN4DG(N,I+1,I+1))+2$(P)2+B
        H(IN4DG(N,I+1,I+2))=H(IN4DG(N,I+1,I+2))-2$(P)0*B
        H(IN4DG(N,I+2,I+2))=H(IN4DG(N,I+2,I+2))+1$(P)1+4$(P)0*B
        H(IN4DG(N,I+2,I+3))=H(IN4DG(N,I+2,I+3))-1$(P)1
        H(IN4DG(N,I+3,I+3))=H(IN4DG(N,I+3,I+3))+1$(P)1+A
   31 CONTINUE
      RETURN
   40 DO 41 I=1,N-3,2
        A=(EXP(X(I))-X(I+1))**2
        B=3$(P)3*(X(I+1)-X(I+2))**4
        C=(X(I+2)-X(I+3))
        D=4$(P)0*(3$(P)0+2$(P)0*SIN(C)**2)*SIN(C)**2/COS(C)**6
        H(IN2DG(I,I))=H(IN2DG(I,I))+4$(P)0*EXP(X(I))*A*(4$(P)0*EXP(X(I))
     *               -X(I+1))+5.6$(P)1*X(I)**6
        H(IN2DG(I,I+1))=H(IN2DG(I,I+1))-1.2$(P)1*EXP(X(I))*A
        H(IN2DG(I+1,I+1))=H(IN2DG(I+1,I+1))+1.2$(P)1*A+B
        H(IN2DG(I+1,I+2))=H(IN2DG(I+1,I+2))-B
        H(IN2DG(I+2,I+2))=H(IN2DG(I+2,I+2))+B+D
        H(IN2DG(I+2,I+3))=H(IN2DG(I+2,I+3))-D
        H(IN2DG(I+3,I+3))=H(IN2DG(I+3,I+3))+D+2$(P)0
   41 CONTINUE
      RETURN
   50 P=7$(P)0/3$(P)0
      DO 51 I=1,N
        A=(3$(P)0-2$(P)0*X(I))*X(I)+1$(P)0
        IF (I.GT.1) A=A-X(I-1)
        IF (I.LT.N) A=A-X(I+1)
        B=P*(P-1$(P)0)*ABS(A)**(P-2$(P)0)
        C=(3$(P)0-4$(P)0*X(I))
        IF (I.GT.1) THEN
          H(IN3DG(I-1,I-1))=H(IN3DG(I-1,I-1))+B
          IF (I.LT.N) H(IN3DG(I-1,I+1))=H(IN3DG(I-1,I+1))+B
          H(IN3DG(I-1,I))=H(IN3DG(I-1,I))-B*C
        ENDIF
        IF(I.NE.N) THEN
          H(IN3DG(I,I))=H(IN3DG(I,I))+B*C**2
     *                -4$(P)0*SIGN(1$(P)0,A)*P*ABS(A)**(P-1$(P)0)
        ELSE
          H(3*(N-1))=H(3*(N-1))+B*C**2
     *                -4$(P)0*SIGN(1$(P)0,A)*P*ABS(A)**(P-1$(P)0)
        END IF
        IF (I.LT.N) THEN
          H(IN3DG(I,I+1))=H(IN3DG(I,I+1))-B*C
          IF(I+1.NE.N) THEN
            H(IN3DG(I+1,I+1))=H(IN3DG(I+1,I+1))+B
          ELSE
            H(3*(N-1))=H(3*(N-1))+B
          ENDIF
        ENDIF
   51 CONTINUE
      RETURN
   60 P=7$(P)0/3$(P)0
      DO 61 I=1,N
        A=0$(P)0
        DO 62 J=MAX(1,I-5),MIN(N,I+1)
          A=A+X(J)*(1$(P)0+X(J))
   62   CONTINUE
        A=A+1$(P)0+X(I)*(2$(P)0+5$(P)0*X(I)**2)
        B=SIGN(1$(P)0,A)*P*ABS(A)**(P-1$(P)0)
        C=P*(P-1$(P)0)*ABS(A)**(P-2$(P)0)
        D=(1.5$(P)1*X(I)**2+2$(P)0*X(I)+3$(P)0)
        H(IN6DG(N,I,I))=H(IN6DG(N,I,I))+C*D**2+B*(3$(P)1*X(I)+2$(P)0)
        DO 63 J=MAX(1,I-5),MIN(N,I+1)
          IF (I.LT.J) H(IN6DG(N,I,J))=H(IN6DG(N,I,J))+C*D*(1$(P)0+2$(P)0*X(J))
          IF (J.LT.I) H(IN6DG(N,J,I))=H(IN6DG(N,J,I))+C*D*(1$(P)0+2$(P)0*X(J))
          IF (J.NE.I) THEN
            H(IN6DG(N,J,J))=H(IN6DG(N,J,J))+C*(1$(P)0+2$(P)0*X(J))**2+2$(P)0*B
            DO 64 K=J+1,MIN(N,I+1)
              IF (K.NE.I) H(IN6DG(N,J,K))=H(IN6DG(N,J,K))
     *              + C* (1$(P)0+2$(P)0*X(J)) * (1$(P)0+2$(P)0*X(K))
   64       CONTINUE
          ENDIF
   63   CONTINUE
   61 CONTINUE
      RETURN
   70 P=7$(P)0/3$(P)0
      DO 71 I=1,N
        A=(3$(P)0-2$(P)0*X(I))*X(I)+1$(P)0
        IF (I.GT.1) A=A-X(I-1)
        IF (I.LT.N) A=A-X(I+1)
        B=P*(P-1$(P)0)*ABS(A)**(P-2$(P)0)
        C=(3$(P)0-4$(P)0*X(I))
        IF (I.GT.1) THEN
          H(IN3DG(I-1,I-1))=H(IN3DG(I-1,I-1))+B
          IF (I.LT.N) H(IN3DG(I-1,I+1))=H(IN3DG(I-1,I+1))+B
          H(IN3DG(I-1,I))=H(IN3DG(I-1,I))-B*C
        ENDIF
        IF(I.NE.N) THEN
          H(IN3DG(I,I))=H(IN3DG(I,I))+B*C**2
     *                -4$(P)0*SIGN(1$(P)0,A)*P*ABS(A)**(P-1$(P)0)
        ELSE
          H(3*(N-1))=H(3*(N-1))+B*C**2
     *                -4$(P)0*SIGN(1$(P)0,A)*P*ABS(A)**(P-1$(P)0)
        END IF
        IF (I.LT.N) THEN
          H(IN3DG(I,I+1))=H(IN3DG(I,I+1))-B*C
          IF(I+1.NE.N) THEN
            H(IN3DG(I+1,I+1))=H(IN3DG(I+1,I+1))+B
          ELSE
            H(3*(N-1))=H(3*(N-1))+B
          ENDIF
        ENDIF
   71 CONTINUE
      RETURN
   80 DO 82 J=1,N
      DO 81 I=1,N
        A=5$(P)0*(1$(P)0+MOD(I,5)+MOD(J,5))
        B=$DBLE(I+J)/1$(P)1
        H(J)=H(J)+2.0$(P)0*COS(2.0$(P)0*X(J))*
     *     (A**2-B**2)-4.0$(P)0*SIN(2.0$(P)0*X(J))*A*B
   81 CONTINUE
   82 CONTINUE
      RETURN
   90 DO 91 I=1,N
      H(I)=H(I)+$DBLE(I)*COS(X(I))
   91 CONTINUE
      H(1)=H(1)-SIN(X(1))
      H(N)=H(N)+SIN(X(N))
      RETURN
  100 DO 101 I=1,N
      H(I)=H(I)+2.0$(P)3*$DBLE(I)**2*(1.0$(P)0-2.0$(P)0*X(I))/
     *    (1.0$(P)0+X(I))**4
  101 CONTINUE
      RETURN
  110 DO 111 I=1,N-4,5
        Q=X(I)*X(I+1)*X(I+2)*X(I+3)*X(I+4)
        A=EXP(Q)
        B=X(I)**2+X(I+1)**2+X(I+2)**2+X(I+3)**2+X(I+4)**2
     *     -1$(P)1+2.008$(P)-3
        C=X(I+1)*X(I+2)-5$(P)0*X(I+3)*X(I+4)+1.9$(P)-3
        D=X(I)**3+X(I+1)**3+1$(P)0+2.61$(P)-4
        DO 112 J=I,I+4
          H(IN5DG(J,J))=H(IN5DG(J,J))+A*(Q/X(J))**2
     *               +1$(P)1*(8$(P)0*X(J)**2+4$(P)0*B)
          DO 113 K=J+1,I+4
            H(IN5DG(J,K))=H(IN5DG(J,K))+A*Q*(1$(P)0+Q)/(X(J)*X(K))
  113     CONTINUE
  112   CONTINUE
        H(IN5DG(I,I))=H(IN5DG(I,I))+1.8$(P)2*X(I)**4+1.2$(P)2*X(I)*D
        H(IN5DG(I,I+1))=H(IN5DG(I,I+1))+1.8$(P)2*(X(I)*X(I+1))**2
        DO 114 J=I+1,I+4
          H(IN5DG(I,J))=H(IN5DG(I,J))+8$(P)1*X(I)*X(J)
  114   CONTINUE
        H(IN5DG(I+1,I+1))=H(IN5DG(I+1,I+1))+2$(P)1*X(I+2)**2
     *                 +1.8$(P)2*X(I+1)**4+1.2$(P)2*D*X(I+1)
        H(IN5DG(I+1,I+2))=H(IN5DG(I+1,I+2))+8$(P)1*X(I+1)*X(I+2)
     *                 +2$(P)1*X(I+1)*X(I+2)+2$(P)1*C
        H(IN5DG(I+1,I+3))=H(IN5DG(I+1,I+3))+8$(P)1*X(I+1)*X(I+3)
     *                 -1$(P)2*X(I+2)*X(I+4)
        H(IN5DG(I+1,I+4))=H(IN5DG(I+1,I+4))+8$(P)1*X(I+1)*X(I+4)
     *                 -1$(P)2*X(I+2)*X(I+3)
        H(IN5DG(I+2,I+2))=H(IN5DG(I+2,I+2))+2$(P)1*X(I+1)**2
        H(IN5DG(I+2,I+3))=H(IN5DG(I+2,I+3))+8$(P)1*X(I+2)*X(I+3)
     *                 -1$(P)2*X(I+1)*X(I+4)
        H(IN5DG(I+2,I+4))=H(IN5DG(I+2,I+4))+8$(P)1*X(I+2)*X(I+4)
     *                 -1$(P)2*X(I+1)*X(I+3)
        H(IN5DG(I+3,I+3))=H(IN5DG(I+3,I+3))+5$(P)2*X(I+4)**2
        H(IN5DG(I+3,I+4))=H(IN5DG(I+3,I+4))+8$(P)1*X(I+3)*X(I+4)
     *                 +5$(P)2*X(I+3)*X(I+4)-1$(P)2*C
        H(IN5DG(I+4,I+4))=H(IN5DG(I+4,I+4))+5$(P)2*X(I+3)**2
  111 CONTINUE
      RETURN
  120 DO 121 I=1,N-1,2
      A=2$(P)1*(X(I)-X(I+1))
      B=4$(P)2*EXP(A)
      H(IN1DG(I,I))=H(IN1DG(I,I))+2$(P)-3+B
      H(IN1DG(I,I+1))=H(IN1DG(I,I+1))-B
      H(IN1DG(I+1,I+1))=H(IN1DG(I+1,I+1))+B
  121 CONTINUE
      RETURN
  130 DO 131 I=1,N-1,2
        A=X(I)**2
        B=X(I+1)**2
        C=0$(P)0
        IF (A.GT.C) C=LOG(A)
        D=0$(P)0
        IF (B.GT.D) D=LOG(B)
        H(IN1DG(I,I))=H(IN1DG(I,I)) + 2$(P)0*(B+1$(P)0)
     *                                *(2$(P)0*B+1$(P)0)*A**B
     *           + 2$(P)0*D*(2$(P)0*A*D+1$(P)0)*B**(A+1$(P)0)
        H(IN1DG(I,I+1))=H(IN1DG(I,I+1))+4$(P)0*X(I)*X(I+1)
     *                *( (1$(P)0+(B+1$(P)0)*C)*A**B
     *                         + (1$(P)0+(A+1$(P)0)*D)*B**A )
        H(IN1DG(I+1,I+1))=H(IN1DG(I+1,I+1)) + 2$(P)0*(A+1$(P)0)
     *                                 *(2$(P)0*A+1$(P)0)*B**A
     *                                + 2$(P)0*C*(2$(P)0*B*C+1$(P)0)
     *                                 *A**(B+1$(P)0)
  131 CONTINUE
      RETURN
  140 Q=1$(P)0/(N+1$(P)0)
      DO 141 I=1,N
        B=(X(I)+I*Q+1$(P)0)
        C=3$(P)0*Q**2 *B**2 +4$(P)0
        A=2$(P)0*X(I) + Q**2 * (X(I)+I*Q+1)**3/2$(P)0
        IF (I.GT.1) A=A-X(I-1)
        IF (I.LT.N) A=A-X(I+1)
        IF (I.GT.1) THEN
          H(IN3DG(I-1,I-1))=H(IN3DG(I-1,I-1))+2$(P)0
          H(IN3DG(I-1,I))=H(IN3DG(I-1,I))-C
          IF (I.LT.N) H(IN3DG(I-1,I+1))=H(IN3DG(I-1,I+1))+2$(P)0
        ENDIF
        IF (I.LT.N) THEN
          H(IN3DG(I,I))=H(IN3DG(I,I))+ C**2/2$(P)0 + 6$(P)0*A*B*Q**2
          H(IN3DG(I,I+1))=H(IN3DG(I,I+1))-C
          IF (I.LT.N-1) THEN
            H(IN3DG(I+1,I+1))=H(IN3DG(I+1,I+1))+2$(P)0
          ELSE
            H(3*(N-1))=H(3*(N-1))+2$(P)0
          ENDIF
        ELSE
          H(3*(N-1))=H(3*(N-1))+ C**2/2$(P)0 + 6$(P)0*A*B*Q**2
        ENDIF
  141 CONTINUE
      RETURN
  150 Q= 2.0$(P)0*$DBLE(N+1)
      R=-6.8$(P)0/$DBLE(N+1)
      DO 151 I=1,N-1
        A=X(I+1)-X(I)
        B=EXP(X(I))
        C=EXP(X(I+1))
        H(IN2DG(I,I))=H(IN2DG(I,I))+2$(P)0*Q
        H(IN2DG(I,I+1))=H(IN2DG(I,I+1))-Q
        IF (ABS(A).LE.1$(P)-6) THEN
        H(IN2DG(I,I))=H(IN2DG(I,I))
     *            +R*B*(1$(P)0/3$(P)0+A/12$(P)0)
        H(IN2DG(I,I+1))=H(IN2DG(I,I+1))
     *              +R*B*(1$(P)0/6$(P)0+A/12$(P)0)
        H(IN2DG(I+1,I+1))=H(IN2DG(I+1,I+1))
     *                +R*B*(1$(P)0/3$(P)0+A/4$(P)0)
        ELSE
        H(IN2DG(I,I))=H(IN2DG(I,I))
     *            +(2$(P)0*((C-B)/A-B)/A-B)*R/A
        H(IN2DG(I,I+1))=H(IN2DG(I,I+1))
     *              +B*R*(1$(P)0+2$(P)0/A)/A**2
     *              +C*R*(1$(P)0-2$(P)0/A)/A**2
        H(IN2DG(I+1,I+1))=H(IN2DG(I+1,I+1))
     *                +(2$(P)0*((C-B)/A-C)/A+C)*R/A
        ENDIF
  151 CONTINUE
      H(IN2DG(1,1))=H(IN2DG(1,1))
     *          +((2$(P)0/X(1)-2$(P)0)/X(1)+1$(P)0)*R*EXP(X(1))/X(1)
     *          -2$(P)0*R/X(1)**3
      H(IN2DG(N,N))=H(IN2DG(N,N))+2$(P)0*Q
     *          +((2$(P)0/X(N)-2$(P)0)/X(N)+1$(P)0)*R*EXP(X(N))/X(N)
     *         - 2$(P)0*R/X(N)**3
      RETURN
      END
      FUNCTION IN4DG(N,I,J)
      INTEGER N,I,J,K,IN4DG
      IF (MOD(I,2).EQ.1) THEN
      K=(5*I-1)/2
      ELSE
      K=5*I/2
      ENDIF
      IF(J.EQ.I+1) THEN
        IN4DG=K
      ELSEIF(I.EQ.N) THEN
        IN4DG=K-2
      ELSEIF(I.EQ.J) THEN
        IN4DG=K-1
      ELSE
        IN4DG=K+1
      ENDIF
      RETURN
      END
      FUNCTION IN5DG(I,J)
      INTEGER I,J,K,IN5DG
      K=J+10*(I/5)
      IF(MOD(I,5).EQ.1) THEN
        IN5DG=K
      ELSE IF(MOD(I,5).EQ.2) THEN
        IN5DG=K+4
      ELSE IF(MOD(I,5).EQ.3) THEN
        IN5DG=K+7
      ELSE IF(MOD(I,5).EQ.4) THEN
        IN5DG=K+9
      ELSE
        IN5DG=3*I
      ENDIF
      RETURN
      END
      FUNCTION IN6DG(N,I,J)
      INTEGER N,I,J,K,IN6DG
      K=6*I+J-6
      IF(I.LT.N-4) THEN
        IN6DG=K
      ELSEIF(I.EQ.N-4) THEN
        IN6DG=K-1
      ELSEIF(I.EQ.N-3) THEN
        IN6DG=K-3
      ELSEIF(I.EQ.N-2) THEN
        IN6DG=K-6
      ELSEIF(I.EQ.N-1) THEN
        IN6DG=K-10
      ELSEIF(I.EQ.N) THEN
        IN6DG=K-15
      ENDIF
      RETURN
      END
      FUNCTION IN7DG(I,J)
      INTEGER I,J,IN7DG
      IF (I.EQ.J) THEN
        IN7DG=2*I-1
      ELSE
        IN7DG=2*I
      ENDIF
      RETURN
      END

