* SUBROUTINE EILD04                ALL SYSTEMS                90/12/01
C PORTABILITY : ALL SYSTEMS
C 90/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF THE VARIABLES FOR CONSTRAINED MINIMIZATION.
*  DENSE VERSION OF LINEAR PROGRAMMING.
*
* PARAMETERS :
*  IO  NF  NUMBER OF VARIABLES.
*  IO  NC  NUMBER OF CONSTRAINTS.
*  II  NCL  NUMBER OF LINEAR CONSTRAINTS.
*  RO  X(NF)  VECTOR OF VARIABLES.
*  IO  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RO  XL(NF)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RO  XU(NF)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  IO  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RO  CL(NC)  VECTOR CONTAINING LOWER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RO  CU(NC)  VECTOR CONTAINING UPPER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RO  CG(NF*NC) MATRIX WHOSE COLUMNS ARE NORMALS OF THE LINEAR
*         CONSTRAINTS.
*  RO  GF(NF)  GRADIENT OF THE LINEAR OBJECTIVE FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EILD04(NF,NC,NCL,X,IX,XL,XU,IC,CL,CU,CG,FF,GF,FMIN,
     & XMAX,NEXT,IEXT,IERR)
      INTEGER NF,NC,NCL,IX(NF),IC(NC),NEXT,IEXT,IERR
      $FLOAT X(NF),XL(NF),XU(NF),CL(NC),CU(NC),CG(NF*NC),FF,GF(NF),FMIN,
     & XMAX
      INTEGER I
      $FLOAT ETA9
      PARAMETER (ETA9=1.0$P 60)
      FF=0.0$P 0
      FMIN=-ETA9
      XMAX=ETA9
      IERR=0
      GO TO (10,20,30,40,50,60) NEXT
   10 NF=4
      NC=3
      NCL=3
      IC(1)=2
      IC(2)=2
      IC(3)=5
      CU(1)=6.0$P 0
      CU(2)=4.0$P 0
      CL(3)=0.0$P 0
      CU(3)=0.0$P 0
      CG(1)=3.0$P 0
      CG(2)=2.0$P 0
      CG(3)=1.0$P 0
      CG(4)=4.0$P 0
      CG(5)=2.0$P 0
      CG(6)=1.0$P 0
      CG(7)=5.0$P 0
      CG(8)=1.0$P 0
      CG(9)=2.0$P 0
      CG(10)=6.0$P 0
      CG(11)=-4.0$P 0
      CG(12)=8.0$P 0
      GF(1)=1.0$P 0
      GF(2)=1.5$P 0
      GF(3)=5.0$P 0
      GF(4)=2.0$P 0
      IEXT=1
      GO TO 1
   20 NF=4
      NC=3
      NCL=3
      IC(1)=1
      IC(2)=1
      IC(3)=1
      CL(1)=8.0$P 1
      CL(2)=4.0$P 1
      CL(3)=2.0$P 1
      CG(1)=2.0$P 0
      CG(2)=2.0$P 0
      CG(3)=2.5$P 0
      CG(4)=3.0$P 0
      CG(5)=0.0$P 0
      CG(6)=4.0$P 0
      CG(7)=1.0$P 0
      CG(8)=2.0$P 0
      CG(9)=1.0$P 0
      CG(10)=0.0$P 0
      CG(11)=2.0$P 0
      CG(12)=0.0$P 0
      GF(1)=1.0$P 1
      GF(2)=1.0$P 1
      GF(3)=2.0$P 1
      GF(4)=8.0$P 0
      IEXT=0
      GO TO 1
   30 NF=5
      NC=3
      NCL=3
      IC(1)=2
      IC(2)=2
      IC(3)=2
      CU(1)=1.5$P 3
      CU(2)=3.0$P 2
      CU(3)=4.5$P 2
      CG(1)=0.0$P 0
      CG(2)=4.0$P-1
      CG(3)=3.0$P-1
      CG(4)=6.0$P-1
      CG(5)=6.0$P-1
      CG(6)=0.5$P-1
      CG(7)=2.0$P-1
      CG(8)=1.0$P-1
      CG(9)=1.0$P-1
      CG(10)=0.0$P-1
      CG(11)=1.0$P-1
      CG(12)=2.0$P-1
      CG(13)=2.0$P-1
      CG(14)=1.0$P-1
      CG(15)=2.0$P-1
      GF(1)=2.0$P 1
      GF(2)=1.2$P 2
      GF(3)=1.0$P 2
      GF(4)=1.4$P 2
      GF(5)=2.0$P 1
      IEXT=1
      GO TO 1
   40 NF=4
      NC=4
      NCL=4
      IC(1)=2
      IC(2)=2
      IC(3)=5
      IC(4)=5
      CU(1)=1.2$P 3
      CU(2)=1.4$P 3
      CL(3)=0.0$P 0
      CU(3)=0.0$P 0
      CL(4)=0.0$P 0
      CU(4)=0.0$P 0
      CG(1)=1.5$P 0
      CG(2)=0.0$P 0
      CG(3)=2.0$P 0
      CG(4)=2.5$P 0
      CG(5)=2.0$P 0
      CG(6)=1.5$P 0
      CG(7)=2.0$P 0
      CG(8)=0.0$P 0
      CG(9)=-1.0$P 0
      CG(10)=0.5$P 0
      CG(11)=0.0$P 0
      CG(12)=1.0$P 0
      CG(13)=0.0$P 0
      CG(14)=-1.0$P 0
      CG(15)=0.5$P 0
      CG(16)=2.0$P 0
      GF(1)=3.0$P 2
      GF(2)=4.5$P 2
      GF(3)=7.0$P 2
      GF(4)=1.5$P 3
      IEXT=1
      GO TO 1
   50 NF=5
      NC=3
      NCL=3
      IC(1)=5
      IC(2)=5
      IC(3)=5
      CL(1)=4.0$P 2
      CU(1)=4.0$P 2
      CL(2)=6.0$P 2
      CU(2)=6.0$P 2
      CL(3)=26.25$P 2
      CU(3)=26.25$P 2
      CG(1)=8.0$P 0
      CG(2)=4.0$P 0
      CG(3)=0.0$P 0
      CG(4)=0.0$P 0
      CG(5)=0.0$P 0
      CG(6)=4.0$P 0
      CG(7)=1.0$P 1
      CG(8)=1.6$P 1
      CG(9)=1.0$P 1
      CG(10)=0.0$P 0
      CG(11)=1.0$P 0
      CG(12)=2.0$P 0
      CG(13)=3.0$P 0
      CG(14)=2.0$P 1
      CG(15)=1.0$P 2
      GF(1)=1.0$P 0
      GF(2)=1.0$P 0
      GF(3)=1.0$P 0
      GF(4)=1.0$P 0
      GF(5)=1.0$P 0
      IEXT=0
      GO TO 1
   60 NF=9
      NC=9
      NCL=9
      IC(1)=2
      IC(2)=2
      IC(3)=2
      IC(4)=1
      IC(5)=1
      IC(6)=1
      IC(7)=5
      IC(8)=5
      IC(9)=5
      CU(1)=27.8$P 1
      CU(2)=18.2$P 1
      CU(3)=18.2$P 1
      CL(4)=28.3$P 1
      CL(5)=27.7$P 1
      CL(6)=18.8$P 1
      CL(7)=8.9$P 1
      CU(7)=8.9$P 1
      CL(8)=9.3$P 1
      CU(8)=9.3$P 1
      CL(9)=9.1$P 1
      CU(9)=9.1$P 1
      CG(1)=6.0$P 0
      CG(2)=9.0$P 0
      CG(3)=3.0$P 0
      CG(4)=3.0$P 0
      CG(5)=8.0$P 0
      CG(6)=9.0$P 0
      CG(7)=3.0$P 0
      CG(8)=3.0$P 0
      CG(9)=9.0$P 0
      CG(10)=4.0$P 0
      CG(11)=5.0$P 0
      CG(12)=2.0$P 0
      CG(13)=2.0$P 0
      CG(14)=6.0$P 0
      CG(15)=6.0$P 0
      CG(16)=2.0$P 0
      CG(17)=2.0$P 0
      CG(18)=6.0$P 0
      CG(19)=4.0$P 0
      CG(20)=6.0$P 0
      CG(21)=2.0$P 0
      CG(22)=2.0$P 0
      CG(23)=6.0$P 0
      CG(24)=6.0$P 0
      CG(25)=2.0$P 0
      CG(26)=1.0$P 0
      CG(27)=6.0$P 0
      CG(28)=6.0$P 0
      CG(29)=9.0$P 0
      CG(30)=3.0$P 0
      CG(31)=3.0$P 0
      CG(32)=9.0$P 0
      CG(33)=8.0$P 0
      CG(34)=3.0$P 0
      CG(35)=3.0$P 0
      CG(36)=9.0$P 0
      CG(37)=6.0$P 0
      CG(38)=9.0$P 0
      CG(39)=3.0$P 0
      CG(40)=3.0$P 0
      CG(41)=9.0$P 0
      CG(42)=9.0$P 0
      CG(43)=2.0$P 0
      CG(44)=3.0$P 0
      CG(45)=9.0$P 0
      CG(46)=4.0$P 0
      CG(47)=6.0$P 0
      CG(48)=1.0$P 0
      CG(49)=2.0$P 0
      CG(50)=6.0$P 0
      CG(51)=6.0$P 0
      CG(52)=2.0$P 0
      CG(53)=2.0$P 0
      CG(54)=6.0$P 0
      CG(55)=1.0$P 0
      CG(56)=3.0$P 0
      CG(57)=1.0$P 0
      CG(58)=1.0$P 0
      CG(59)=3.0$P 0
      CG(60)=3.0$P 0
      CG(61)=1.0$P 0
      CG(62)=1.0$P 0
      CG(63)=3.0$P 0
      CG(64)=2.0$P 0
      CG(65)=3.0$P 0
      CG(66)=1.0$P 0
      CG(67)=0.0$P 0
      CG(68)=3.0$P 0
      CG(69)=3.0$P 0
      CG(70)=1.0$P 0
      CG(71)=1.0$P 0
      CG(72)=3.0$P 0
      CG(73)=2.0$P 0
      CG(74)=3.0$P 0
      CG(75)=1.0$P 0
      CG(76)=1.0$P 0
      CG(77)=3.0$P 0
      CG(78)=3.0$P 0
      CG(79)=1.0$P 0
      CG(80)=1.0$P 0
      CG(81)=2.0$P 0
      GF(1)=2.3$P 1
      GF(2)=4.3$P 1
      GF(3)=1.2$P 1
      GF(4)=0.9$P 1
      GF(5)=4.5$P 1
      GF(6)=4.0$P 1
      GF(7)=1.0$P 1
      GF(8)=1.9$P 1
      GF(9)=3.9$P 1
      IEXT=0
      GO TO 1
    1 DO 2 I=1,NF
      X(I)=0.0$P 0
      XL(I)=0.0$P 0
      XU(I)=0.0$P 0
      IX(I)=1
    2 CONTINUE
      RETURN
      END
