* SUBROUTINE EINS41                ALL SYSTEMS                99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF THE VARIABLES AND STRUCTURE OF THE SPARSE HESSIAN
*  MATRIX FOR UNCONSTRAINED MINIMIZATION.
*  SPARSE VERSION WITH CHANGED TESTS 7-10, 12.
*  CHANGED FOR THE TESTS.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  IO  NC  NUMBER OF CONSTRAINTS.
*  IO  NCL  NUMBER OF LINEAR CONSTRAINTS.
*  IO  MC  NUMBER OF ELEMENTS OF THE SPARSE JACOBIAN MATRIX.
*  IO  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RO  CU(NC)  VECTOR CONTAINING UPPER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  IO  ICG(NC+1)  POINTERS OF THE FIRST ELEMENTS IN ROWS OF THE
*         JACOBIAN MATRIX.
*  IO  JCG(MC)  INDICES OF THE NONZERO ELEMENTS OF THE JACOBIAN MATRIX IN
*             THE PACKED ROW.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EINS41(N,NC,NCL,MC,IC,CU,ICG,JCG,NEXT)
      INTEGER N,NC,NCL,MC,IC(NC),ICG(NC+1),JCG(*),NEXT
      $FLOAT CU(NC)
      INTEGER I,J,K,L,KC
      NCL=0
      GO TO (10,20,30), NEXT
   10 NC=3*(N-2)/2
      MC=0
      KC=0
      DO 13 J=1,NC/3
      CU(KC+1)=8.0$P 0
      CU(KC+2)=1.0$P 1
      CU(KC+3)=5.0$P 0
      I=2*(J-1)
      DO 12 K=1,3
      IC(KC+K)=2
      ICG(KC+K)=MC+1
      DO 11 L=1,4
      JCG(MC+L)=I+L
   11 CONTINUE
      MC=MC+4
   12 CONTINUE
      KC=KC+3
   13 CONTINUE
      ICG(NC+1)=MC+1
      RETURN
   20 CONTINUE
      RETURN
   30 CONTINUE
      RETURN
      END

