* SUBROUTINE EIQS33                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
*  INPUT OF HESSIAN MATRIX FOR SPARSE QP.
*
* PARAMETERS :
*  II  NF ESTIMATED NUMBER OF NUMBER OF VARIABLES.
*  II  NFL NUMBER OF ELEMENTS ON INPUT.
*  II  M SIZE OF ARRAYS SH,H.
*  RO  FF  VALUE OF THE MODEL FUNCTION.
*  RO  GF(NF) GRADIENT OF THE MODEL FUNCTION.
*  RO  HF(M) NUMERICAL VALUES OF THE HESSIAN MATRIX.
*  IO  JH(M) INDEX VECTOR OF THE HESSIAN MATRIX.
*  IO  IH(MCOLS+1) POINTER VECTOR OF SH,H.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EIQS33(MCOLS,NF,FF,GF,HF,JH,IH,NEXT)
      INTEGER MCOLS,NF,NFL,NEXT
      INTEGER JH(*),IH(MCOLS+1)
      INTEGER I
      $FLOAT HF(*),GF(MCOLS),FF
      $FLOAT ONE,ZERO,TWO,THREE,FOUR,SIX,EIGHT,NINE
      PARAMETER(TWO=2.0$P 0,FOUR=4.0$P 0,SIX=6.0$P 0)
      PARAMETER(EIGHT=8.0$P 0,NINE=9.0$P 0,THREE=3.0$P 0)
      PARAMETER(ONE=1.0$P 0,ZERO=0.0$P 0)
C
      GO TO (10,20,30,40,50,60,70,80,90,100,110) NEXT
   10 NFL=NF
      DO 11 I=1,NFL/3
        HF(I)=ONE
        JH(I)=I
        IH(I)=I
   11 CONTINUE
      DO 12 I=NFL/3+1,2*(NFL/3)
        HF(I)=-ONE
        JH(I)=I
        IH(I)=I
   12 CONTINUE
      DO 13 I=2*(NFL/3)+1,NFL
        HF(I)=ZERO
        JH(I)=I
        IH(I)=I
   13 CONTINUE
      IH(NFL+1)=NFL+1
      DO 14 I=1,NF
        GF(I)=ZERO
   14 CONTINUE
      FF=ZERO
      RETURN
  20  CONTINUE
      NFL=2
      NF=2
      IH(1)=1
      IH(2)=2
      IH(3)=3
      JH(1)=1
      JH(2)=2
      HF(1)=0.02$P 0
      HF(2)=2.0$P 0
      GF(1)=0.0$P 0
      GF(2)=0.0$P 0
      FF=-100$P 0
      RETURN
 30   CONTINUE
      NF=3
      IH(1)=1
      IH(2)=3
      IH(3)=5
      IH(4)=6
      JH(1)=1
      JH(2)=2
      JH(3)=2
      JH(4)=3
      JH(5)=3
      HF(1)=2
      HF(2)=2
      HF(3)=4
      HF(4)=2
      HF(5)=2
      FF=ZERO
      GF(1)=ZERO
      GF(2)=ZERO
      GF(3)=ZERO
      RETURN
 40   CONTINUE
      NF=3
      IH(1)=1
      IH(2)=4
      IH(3)=5
      IH(4)=6
      JH(1)=1
      JH(2)=2
      JH(3)=3
      JH(4)=2
      JH(5)=3
      HF(1)=FOUR
      HF(2)=TWO
      HF(3)=TWO
      HF(4)=FOUR
      HF(5)=TWO
      FF=NINE
      GF(1)=-EIGHT
      GF(2)=-SIX
      GF(3)=-FOUR
      RETURN
 50   CONTINUE
      NF=4
      IH(1)=1
      IH(2)=4
      IH(3)=7
      IH(4)=8
      IH(5)=9
      JH(1)=1
      JH(2)=3
      JH(3)=4
      JH(4)=2
      JH(5)=3
      JH(6)=4
      JH(7)=3
      JH(8)=4
      HF(1)=ZERO
      HF(2)=-ONE
      HF(3)=ONE
      HF(4)=ZERO
      HF(5)=ONE
      HF(6)=-ONE
      HF(7)=ZERO
      HF(8)=ZERO
      FF=ZERO
      GF(1)=ONE
      GF(2)=-ONE
      GF(3)=-ONE
      GF(4)=ZERO
      RETURN
 60   CONTINUE
      NF=5
      FF=ONE
      GF(1)=-TWO
      GF(2)=ZERO
      GF(3)=ZERO
      GF(4)=ZERO
      GF(5)=ZERO
      IH(1)=1
      IH(2)=2
      IH(3)=4
      IH(4)=5
      IH(5)=7
      IH(6)=8
      JH(1)=1
      JH(2)=2
      JH(3)=3
      JH(4)=3
      JH(5)=4
      JH(6)=5
      JH(7)=5
      HF(1)=TWO
      HF(2)=TWO
      HF(3)=-TWO
      HF(4)=TWO
      HF(5)=TWO
      HF(6)=-TWO
      HF(7)=TWO
      RETURN
 70   CONTINUE
      NF=5
      FF=SIX
      GF(1)=ZERO
      GF(2)=-FOUR
      GF(3)=-FOUR
      GF(4)=-TWO
      GF(5)=-TWO
      IH(1)=1
      IH(2)=3
      IH(3)=5
      IH(4)=6
      IH(5)=7
      IH(6)=8
      JH(1)=1
      JH(2)=2
      JH(3)=2
      JH(4)=3
      JH(5)=3
      JH(6)=4
      JH(7)=5
      HF(1)=TWO
      HF(2)=-TWO
      HF(3)=FOUR
      HF(4)=TWO
      HF(5)=TWO
      HF(6)=TWO
      HF(7)=TWO
      RETURN
 80   CONTINUE
      NF=5
      FF=SIX
      GF(1)=ZERO
      GF(2)=-FOUR
      GF(3)=-FOUR
      GF(4)=-TWO
      GF(5)=-TWO
      IH(1)=1
      IH(2)=3
      IH(3)=5
      IH(4)=6
      IH(5)=7
      IH(6)=8
      JH(1)=1
      JH(2)=2
      JH(3)=2
      JH(4)=3
      JH(5)=3
      JH(6)=4
      JH(7)=5
      HF(1)=32.0$P 0
      HF(2)=-EIGHT
      HF(3)=FOUR
      HF(4)=TWO
      HF(5)=TWO
      HF(6)=TWO
      HF(7)=TWO
      RETURN
 90   CONTINUE
      NF=5
      FF=SIX
      GF(1)=ZERO
      GF(2)=-FOUR
      GF(3)=-FOUR
      GF(4)=-TWO
      GF(5)=-TWO
      IH(1)=1
      IH(2)=3
      IH(3)=5
      IH(4)=6
      IH(5)=7
      IH(6)=8
      JH(1)=1
      JH(2)=2
      JH(3)=2
      JH(4)=3
      JH(5)=3
      JH(6)=4
      JH(7)=5
      HF(1)=TWO
      HF(2)=-TWO
      HF(3)=FOUR
      HF(4)=TWO
      HF(5)=TWO
      HF(6)=TWO
      HF(7)=TWO
      RETURN
 100  CONTINUE
      NF=4
      FF=ZERO
      GF(1)=-ONE
      GF(2)=-THREE
      GF(3)=ONE
      GF(4)=-ONE
      IH(1)=1
      IH(2)=3
      IH(3)=4
      IH(4)=6
      IH(5)=7
      JH(1)=1
      JH(2)=3
      JH(3)=2
      JH(4)=3
      JH(5)=4
      JH(6)=4
      HF(1)=TWO
      HF(2)=-ONE
      HF(3)=ONE
      HF(4)=TWO
      HF(5)=ONE
      HF(6)=ONE
      RETURN
 110  CONTINUE
      NF=15
      FF=ZERO
      GF(1)=2.3$P 0
      GF(2)=1.7$P 0
      GF(3)=2.2$P 0
      GF(4)=2.3$P 0
      GF(5)=1.7$P 0
      GF(6)=2.2$P 0
      GF(7)=2.3$P 0
      GF(8)=1.7$P 0
      GF(9)=2.2$P 0
      GF(10)=2.3$P 0
      GF(11)=1.7$P 0
      GF(12)=2.2$P 0
      GF(13)=2.3$P 0
      GF(14)=1.7$P 0
      GF(15)=2.2$P 0
      IH(1)=1
      IH(2)=2
      IH(3)=3
      IH(4)=4
      IH(5)=5
      IH(6)=6
      IH(7)=7
      IH(8)=8
      IH(9)=9
      IH(10)=10
      IH(11)=11
      IH(12)=12
      IH(13)=13
      IH(14)=14
      IH(15)=15
      IH(16)=16
      JH(1)=1
      JH(2)=2
      JH(3)=3
      JH(4)=4
      JH(5)=5
      JH(6)=6
      JH(7)=7
      JH(8)=8
      JH(9)=9
      JH(10)=10
      JH(11)=11
      JH(12)=12
      JH(13)=13
      JH(14)=14
      JH(15)=15
      HF(1)=2.0$P-4
      HF(2)=2.0$P-4
      HF(3)=3.0$P-4
      HF(4)=2.0$P-4
      HF(5)=2.0$P-4
      HF(6)=3.0$P-4
      HF(7)=2.0$P-4
      HF(8)=2.0$P-4
      HF(9)=3.0$P-4
      HF(10)=2.0$P-4
      HF(11)=2.0$P-4
      HF(12)=3.0$P-4
      HF(13)=2.0$P-4
      HF(14)=2.0$P-4
      HF(15)=3.0$P-4
      RETURN
      END
