* SUBROUTINE EIUB14                ALL SYSTEMS                99/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 RA : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF THE VARIABLES AND STRUCTURE OF THE SPARSE HESSIAN
*  MATRIX FOR UNCONSTRAINED MINIMIZATION.
*  SPARSE VERSION WITH CHANGED TESTS 7-10, 12.
*  CHANGED FOR THE TESTS.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  NB  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  MB  NUMBER OF ELEMENTS OF THE SPARSE JACOBIAN MATRIX.
*  RO  X(N)  VECTOR OF VARIABLES.
*  IO  IH(N+1)  POINTERS OF THE DIAGONAL ELEMENTS OF THE HESSIAN MATRIX.
*  IO  JH(M)  INDICES OF THE NONZERO ELEMENTS OF THE HESSIAN MATRIX IN
*             THE PACKED ROW.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EIUB14(N,NB,MB,X,IH,JH,FMIN,XMAX,NEXT,IEXT,IERR)
      INTEGER N,NB,MB,NEXT,IEXT,IERR
      INTEGER IH(NB+1),JH(*)
      $FLOAT X(N),FMIN,XMAX
      $FLOAT P,Q
      INTEGER I,J,K
      $FLOAT ETA9
      PARAMETER (ETA9=1.0$P 60)
      FMIN=0.0$P 0
      XMAX=1.0$P 3
      IEXT=0
      IERR=0
      GOTO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     & 170,180,190,200,210,220),NEXT
   10 IF (N.LT.2) GO TO 999
      N=N-MOD(N,2)
      DO 11 I=1,N
        IF(MOD(I,2).EQ.1) THEN
          X(I)=-1.2$P 0
        ELSE
          X(I)=1.0$P 0
        ENDIF
   11 CONTINUE
   12 NB=N-1
      DO 13 I=1,NB
        J=2*(I-1)+1
        JH(J)=I
        JH(J+1)=I+1
        IH(I)=J
   13 CONTINUE
      MB=2*NB
      IH(NB+1)=MB+1
      RETURN
   20 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      DO 21 I=1,N
        IF(MOD(I,2).EQ.1) THEN
          X(I)=-2.0$P 0
          IF(I.LE.4) X(I)=-3.0$P 0
        ELSE
          X(I)=0.0$P 0
          IF(I.LE.4) X(I)=-1.0$P 0
        ENDIF
   21 CONTINUE
   22 NB=(N-2)/2
      DO 23 I=1,NB
        J=4*(I-1)+1
        K=2*I-1
        JH(J)=K
        JH(J+1)=K+1
        JH(J+2)=K+2
        JH(J+3)=K+3
        IH(I)=J
   23 CONTINUE
      MB=4*NB
      IH(NB+1)=IH(NB)+4
      RETURN
   30 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      DO 31 I=1,N
        IF(MOD(I,4).EQ.1) THEN
          X(I)=3.0$P 0
        ELSEIF(MOD(I,4).EQ.2) THEN
          X(I)=-1.0$P 0
        ELSEIF(MOD(I,4).EQ.3) THEN
          X(I)=0.0$P 0
        ELSE
          X(I)=1.0$P 0
        ENDIF
   31 CONTINUE
      GO TO 22
   40 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      DO 41 I=1,N
        X(I)=2.0$P 0
   41 CONTINUE
      X(1)=1.0$P 0
C      XMAX=1.0$P 1
      GO TO 22
   50 IF (N.LT.3) GO TO 999
      DO 51 I=1,N
        X(I)=-1.0$P 0
   51 CONTINUE
   52 MB=1
      NB=N
      DO 53 I=1,NB
        IH(I)=MB
        IF (I.GT.1) THEN
        JH(MB)=I-1
        MB=MB+1
        ENDIF
        JH(MB)=I
        MB=MB+1
        IF (I.LT.N) THEN
        JH(MB)=I+1
        MB=MB+1
        ENDIF
   53 CONTINUE
      IH(NB+1)=MB
      MB=MB-1
      RETURN
   60 IF (N.LT.7) GO TO 999
      DO 61 I=1,N
        X(I)=-1.0$P 0
   61 CONTINUE
      MB=1
      NB=N
      DO 62 I=1,NB
        IH(I)=MB
        IF (I.GT.5) THEN
        JH(MB)=I-5
        MB=MB+1
        ENDIF
        IF (I.GT.4) THEN
        JH(MB)=I-4
        MB=MB+1
        ENDIF
        IF (I.GT.3) THEN
        JH(MB)=I-3
        MB=MB+1
        ENDIF
        IF (I.GT.2) THEN
        JH(MB)=I-2
        MB=MB+1
        ENDIF
        IF (I.GT.1) THEN
        JH(MB)=I-1
        MB=MB+1
        ENDIF
        JH(MB)=I
        MB=MB+1
        IF (I.LT.N) THEN
        JH(MB)=I+1
        MB=MB+1
        ENDIF
   62 CONTINUE
      IH(NB+1)=MB
      MB=MB-1
      RETURN
   70 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      DO 71 I=1,N
        X(I)=-1.0$P 0
   71 CONTINUE
      MB=1
      K=N/2
      NB=N+K
      DO 72 I=1,N
        IH(I)=MB
        IF (I.GT.1) THEN
        JH(MB)=I-1
        MB=MB+1
        ENDIF
        JH(MB)=I
        MB=MB+1
        IF (I.LT.N) THEN
        JH(MB)=I+1
        MB=MB+1
        ENDIF
   72 CONTINUE
      DO 73 I=1,K
      IH(N+I)=MB
      JH(MB)=I
      MB=MB+1
      JH(MB)=I+K
      MB=MB+1
   73 CONTINUE
      IH(NB+1)=MB
      MB=MB-1
      RETURN
   80 IF (N.LT.6) GO TO 999
      DO 81 I=1,N
        X(I)=1.0$P 0/$DBLE(N)
   81 CONTINUE
   82 MB=1
      NB=N
      K=N/2
      DO 83 I=1,NB
        IH(I)=MB
        IF (I.GT.K) THEN
          JH(MB)=I-K
          MB=MB+1
        ENDIF
        IF (I.GT.2) THEN
          JH(MB)=I-2
          MB=MB+1
        ENDIF
        IF (I.GT.1) THEN
          JH(MB)=I-1
          MB=MB+1
        ENDIF
        JH(MB)=I
        MB=MB+1
        IF (I.LT.N) THEN
          JH(MB)=I+1
          MB=MB+1
        ENDIF
        IF (I.LT.N-1) THEN
          JH(MB)=I+2
          MB=MB+1
        ENDIF
        IF (I.LE.K) THEN
          JH(MB)=I+K
          MB=MB+1
        ENDIF
   83 CONTINUE
      IH(NB+1)=MB
      MB=MB-1
      RETURN
   90 IF (N.LT.6) GO TO 999
      DO 91 I=1,N
        X(I)=1.0$P 0/$DBLE(N)
   91 CONTINUE
      FMIN=-ETA9
      GO TO 82
  100 IF (N.LT.6) GO TO 999
      DO 101 I=1,N
        X(I)=1.0$P 0
  101 CONTINUE
      FMIN=-ETA9
      GO TO 82
  110 IF (N.LT.5) GO TO 999
      N=N-MOD(N,5)
      DO 111 I=0,N-5,5
        X(I+1)=-1.0$P 0
        X(I+2)=-1.0$P 0
        X(I+3)=2.0$P 0
        X(I+4)=-1.0$P 0
        X(I+5)=-1.0$P 0
  111 CONTINUE
      X(1)=-2.0$P 0
      X(2)=2.0$P 0
      MB=1
      NB=N/5
      DO 112 I=1,NB
        J=5*(I-1)+1
        IH(I)=MB
        MB=MB+5
        JH(MB-5)=J
        JH(MB-4)=J+1
        JH(MB-3)=J+2
        JH(MB-2)=J+3
        JH(MB-1)=J+4
  112 CONTINUE
      IH(NB+1)=MB
      MB=MB-1
      XMAX=1.0$P 1
      RETURN
  120 IF (N.LT.2) GO TO 999
      N=N-MOD(N,2)
      DO 121 I=2,N,2
        X(I-1)=0.0$P 0
        X(I)=-1.0$P 0
  121 CONTINUE
      XMAX=1.0$P 1
      GO TO 12
  130 IF (N.LT.2) GO TO 999
      N=N-MOD(N,2)
      DO 131 I=2,N,2
        X(I-1)=-1.0$P 0
        X(I)=1.0$P 0
  131 CONTINUE
C      XMAX=1.0$P 0
      GO TO 12
  140 IF (N.LT.3) GO TO 999
      P=1.0$P 0/$DBLE(N+1)
      DO 141 I=1,N
        Q=P*$DBLE(I)
        X(I)=Q*(Q-1.0$P 0)
  141 CONTINUE
C      XMAX=1.0$P 1
      GO TO 52
  150 IF (N.LT.2) GO TO 999
      P=1.0$P 0/$DBLE(N+1)
      DO 151 I=1,N
        X(I)=$DBLE(I)*$DBLE(N+1-I)*P**2
  151 CONTINUE
      FMIN=-ETA9
C      XMAX=1.0$P 1
      GO TO 12
  160 IF (N.LT.3) GO TO 999
      DO 161 I=1,N
        X(I)=1.0$P 0
  161 CONTINUE
      FMIN=-ETA9
      GO TO 52
  170 IF (N.LT.3) GO TO 999
      P=1.0$P 0/$DBLE(N+1)
      DO 171 I=1,N
        X(I)=$DBLE(I)*$DBLE(N+1-I)*P**2
  171 CONTINUE
      FMIN=-ETA9
      GO TO 52
  180 IF (N.LT.3) GO TO 999
      P=1.0$P 0/$DBLE(N+1)
      DO 181 I=1,N
        X(I)=$DBLE(I)*$DBLE(N+1-I)*P**2
  181 CONTINUE
      FMIN=-ETA9
      GO TO 52
  190 IF (N.LT.3) GO TO 999
      P=EXP(2.0$P 0)/$DBLE(N+1)
      DO 191 I=1,N
        X(I)=(P*$DBLE(I)+1.0$P 0)/3.0$P 0
  191 CONTINUE
      FMIN=-ETA9
      GO TO 52
  200 IF (N.LT.3) GO TO 999
      P=1.0$P 0/$DBLE(N+1)
      DO 201 I=1,N
        X(I)=P*$DBLE(I)
  201 CONTINUE
      FMIN=-ETA9
      GO TO 52
  210 IF (N.LT.3) GO TO 999
      P=1.0$P 0/$DBLE(N+1)
      DO 211 I=1,N
        X(I)=P*$DBLE(I)+1.0$P 0
  211 CONTINUE
      FMIN=-ETA9
      GO TO 52
  220 IF (N.LT.3) GO TO 999
      P=1.0$P 0/$DBLE(N+1)
      DO 221 I=1,N
        X(I)=$DBLE(I)*$DBLE(N+1-I)*P**2
  221 CONTINUE
      FMIN=-ETA9
      GO TO 52
  999 IERR=1
      RETURN
      END
