* SUBROUTINE EIUB26                ALL SYSTEMS                16/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF THE VARIABLES AND STRUCTURE OF THE SPARSE HESSIAN
*  MATRIX FOR UNCONSTRAINED MINIMIZATION.
*
* PARAMETERS :
*  II  N  NUMAER OF VARIABLES.
*  II  NA  NUMAER OF ELEMENTS OF THE SPARSE MATRIX.
*  II  MA  NUMAER OF ELEMENTS OF THE SPARSE JACOBIAN MATRIX.
*  RO  X(N)  VECTOR OF VARIABLES.
*  IO  IA(N+1)  POINTERS OF THE DIAGONAL ELEMENTS OF THE HESSIAN MATRIX.
*  IO  JA(M)  INDICES OF THE NONZERO ELEMENTS OF THE HESSIAN MATRIX IN
*             THE PACKED ROW.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EIUB26(N,NA,MA,X,IA,JA,FMIN,XMAX,NEXT,IEXT,IERR)
      INTEGER N,NA,MA,NEXT,IEXT,IERR
      INTEGER IA(NA+1),JA(*)
      $FLOAT X(N),FMIN,XMAX
      INTEGER I,J,K,L,M,I1,I2,II,J1,J2,JJ,KA,KK,LL,MM,N1,ND
      $FLOAT T,S,PAR
      $FLOAT Y(20)
      COMMON /EMPR15/ Y
      COMMON /EMPR18/ PAR,M
      $FLOAT ETA9
      PARAMETER (ETA9=1.0$P 60)
      FMIN=0.0$P 0
      XMAX=1.0$P 3
      IEXT=0
      IERR=0
      GOTO(10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     & 170,180,190,200,210,220,
     & 230,240,250,260,270,280,290,310,340,360,
     & 370,380,390,400,410,420,430,440,450,460,470,480,490,500,520,
     & 510,530,540,550,560,570,580,590,600,610,620,630,640),
     & NEXT
   10 IF (N.LT.2) GO TO 999
      N=N-MOD(N,2)
      DO 11 I=1,N
        IF(MOD(I,2).EQ.1) THEN
          X(I)=-1.2$P 0
        ELSE
          X(I)=1.0$P 0
        ENDIF
   11 CONTINUE
      DO 12 I=1,N-1
        L=3*(I-1)+1
        JA(L)=I
        JA(L+1)=I+1
        JA(L+2)=I
        K=2*(I-1)+1
        IA(K)=L
        IA(K+1)=L+2
   12 CONTINUE
      IA(K+2)=L+3
      NA=2*(N-1)
      MA=3*(N-1)
      RETURN
   20 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      DO 21 I=1,N
        IF(MOD(I,2).EQ.1) THEN
          X(I)=-2.0$P 0
          IF(I.LE.4) X(I)=-3.0$P 0
        ELSE
          X(I)=0.0$P 0
          IF(I.LE.4) X(I)=-1.0$P 0
        ENDIF
   21 CONTINUE
      DO 22 I=2,N-2,2
        L=5*(I-2)+1
        JA(L)=I-1
        JA(L+1)=I
        JA(L+2)=I-1
        JA(L+3)=I+1
        JA(L+4)=I+2
        JA(L+5)=I+1
        JA(L+6)=I
        JA(L+7)=I+2
        JA(L+8)=I
        JA(L+9)=I+2
        K=3*(I-2)+1
        IA(K)=L
        IA(K+1)=L+2
        IA(K+2)=L+3
        IA(K+3)=L+5
        IA(K+4)=L+6
        IA(K+5)=L+8
   22 CONTINUE
      IA(K+6)=L+10
      NA=K+5
      MA=L+9
      RETURN
   30 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      DO 31 I=1,N
        IF(MOD(I,4).EQ.1) THEN
          X(I)=3.0$P 0
        ELSEIF(MOD(I,4).EQ.2) THEN
          X(I)=-1.0$P 0
        ELSEIF(MOD(I,4).EQ.3) THEN
          X(I)=0.0$P 0
        ELSE
          X(I)=1.0$P 0
        ENDIF
   31 CONTINUE
      DO 32 I=2,N-2,2
        L=4*(I-2)+1
        JA(L)=I-1
        JA(L+1)=I
        JA(L+2)=I+1
        JA(L+3)=I+2
        JA(L+4)=I
        JA(L+5)=I+1
        JA(L+6)=I-1
        JA(L+7)=I+2
        K=2*(I-2)+1
        IA(K)=L
        IA(K+1)=L+2
        IA(K+2)=L+4
        IA(K+3)=L+6
   32 CONTINUE
      IA(K+4)=L+8
      NA=K+3
      MA=L+7
      RETURN
   40 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      DO 41 I=1,N
        X(I)=2.0$P 0
   41 CONTINUE
      X(1)=1.0$P 0
      DO 42 I=2,N-2,2
        L=4*(I-2)+1
        JA(L)=I-1
        JA(L+1)=I
        JA(L+2)=I
        JA(L+3)=I+1
        JA(L+4)=I+1
        JA(L+5)=I+2
        JA(L+6)=I-1
        JA(L+7)=I+2
        K=5*(I-2)/2+1
        IA(K)=L
        IA(K+1)=L+2
        IA(K+2)=L+4
        IA(K+3)=L+6
        IA(K+4)=L+7
   42 CONTINUE
      IA(K+5)=L+8
      NA=K+4
      MA=L+7
      XMAX=1.0$P 1
      RETURN
   50 IF (N.LT.3) GO TO 999
      DO 51 I=1,N
        X(I)=-1.0$P 0
   51 CONTINUE
      JA(1)=1
      JA(2)=2
      IA(1)=1
      DO 52 I=2,N-1
        K=3*(I-2)+3
        JA(K)=I-1
        JA(K+1)=I
        JA(K+2)=I+1
        IA(I)=K
   52 CONTINUE
      JA(K+3)=N-1
      JA(K+4)=N
      IA(N)=K+3
      IA(N+1)=IA(N)+2
      NA=N
      MA=3*N-2
      RETURN
   60 IF (N.LT.6) GO TO 999
      DO 61 I=1,N
        X(I)=-1.0$P 0
   61 CONTINUE
      L=1
      DO 62 I=1,5
        IA(I)=L
        DO 63 K=1,I+1
          JA(L)=K
          L=L+1
   63   CONTINUE
   62 CONTINUE
      DO 64 I=6,N-1
      IA(I)=L
        DO 65 K=I-5,I+1
        JA(L)=K
        L=L+1
   65   CONTINUE
   64 CONTINUE
      IA(N)=L
      DO 66 K=N-5,N
        JA(L)=K
        L=L+1
   66 CONTINUE
      IA(N+1)=L
      NA=N
      MA=L-1
      RETURN
   70 IF (N.LT.2) GO TO 999
      DO 71 I=1,N-1
        X(I)=0.5$P 0
        K=4*(I-1)+1
        JA(K)=I
        JA(K+1)=I+1
        JA(K+2)=I
        JA(K+3)=I+1
        L=2*(I-1)+1
        IA(L)=K
        IA(L+1)=K+2
   71 CONTINUE
      X(N)=-2.0$P 0
      IA(L+2)=IA(L+1)+2
      NA=2*(N-1)
      MA=2*NA
      RETURN
   80 IF (N.LT.4) GO TO 999
      N=N-MOD(N,4)
      DO 81 I=1,N
        X(I)=SIN($DBLE(I))**2
   81 CONTINUE
      MM=5*N
      K=1
      DO 82 KA=1,MM
        I=MOD(KA,N/2)+1
        J=I+N/2
        K=2*(KA-1)+1
        JA(K)=I
        JA(K+1)=J
        IA(KA)=K
   82 CONTINUE
      IA(MM+1)=K+2
      NA=MM
      MA=2*MM
      RETURN
   90 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      DO 91 I=1,N
        X(I)=5.0$P 0
   91 CONTINUE
      DO 93 I=2,N-2,2
        L=12*(I-2)+1
        DO 92 J=1,6
          K=(J-1)*4
          JA(L+K)=I-1
          JA(L+K+1)=I
          JA(L+K+2)=I+1
          JA(L+K+3)=I+2
   92   CONTINUE
        K=3*(I-2)+1
        IA(K)=L
        IA(K+1)=L+4
        IA(K+2)=L+8
        IA(K+3)=L+12
        IA(K+4)=L+16
        IA(K+5)=L+20
   93 CONTINUE
      IA(K+6)=L+24
      NA=K+5
      MA=L+23
      RETURN
  100 IF (N.LT.2) GO TO 999
      DO 101 I=1,N
        X(I)=0.2$P 0
  101 CONTINUE
      MM=2*N-2
      JA(1)=1
      JA(2)=2
      JA(3)=1
      JA(4)=2
      IA(1)=1
      IA(2)=3
      K=5
      L=3
      DO 102 KA=3,MM,2
        I=(KA+1)/2-1
        JA(K)=I
        JA(K+1)=I+1
        JA(K+2)=I+2
        JA(K+3)=I+1
        JA(K+4)=I+2
        IA(L)=K
        IA(L+1)=K+3
        K=K+5
        L=L+2
  102 CONTINUE
      JA(K)=N-1
      JA(K+1)=N
      IA(L)=K
      IA(L+1)=K+2
      NA=L
      MA=K+1
      RETURN
  110 CONTINUE
      IF (N.LT.2) GO TO 999
      N=N-MOD(N,2)
      DO 111 I=1,N
        IF(MOD(I,2).EQ.1) THEN
          X(I)=-0.8$P 0
        ELSE
          X(I)=-0.8$P 0
        ENDIF
  111 CONTINUE
      IA(1)=1
      NA=2*(N-1)
      MA=1
      L=1
      DO 112 K=1,N-1
        JA(MA)=K
        MA=MA+1
        JA(MA)=K+1
        MA=MA+1
        L=L+1
        IA(L)=MA
        JA(MA)=K
        MA=MA+1
        L=L+1
        IA(L)=MA
  112 CONTINUE
      MA=IA(NA+1)-1
      RETURN
  120 CONTINUE
      IF (N.LT.5) GO TO 999
      IF (MOD(N-5,3).NE.0) N=N-MOD(N-5,3)
      DO 121 I=1,N
        X(I)=-1.0$P 0
  121 CONTINUE
      IA(1)=1
      KK=(N-5)/3+1
      NA=6*KK
      MA=1
      L=1
      DO 122 K=1,KK
        I=3*(K-1)+1
        JA(MA)=I
        MA=MA+1
        JA(MA)=I+1
        MA=MA+1
        L=L+1
        IA(L)=MA
        JA(MA)=I+2
        MA=MA+1
        L=L+1
        IA(L)=MA
        JA(MA)=I+3
        MA=MA+1
        L=L+1
        IA(L)=MA
        JA(MA)=I+4
        MA=MA+1
        L=L+1
        IA(L)=MA
        JA(MA)=I
        MA=MA+1
        JA(MA)=I+3
        MA=MA+1
        JA(MA)=I+4
        MA=MA+1
        L=L+1
        IA(L)=MA
        JA(MA)=I+1
        MA=MA+1
        JA(MA)=I+2
        MA=MA+1
        JA(MA)=I+3
        MA=MA+1
        L=L+1
        IA(L)=MA
  122 CONTINUE
      MA=IA(NA+1)-1
      RETURN
  130 CONTINUE
      IF (N.LT.5) GO TO 999
      IF (MOD(N-5,3).NE.0) N=N-MOD(N-5,3)
      DO 131 I=1,N
        X(I)=-1.0$P 0
  131 CONTINUE
      IA(1)=1
      KK=(N-5)/3+1
      NA=7*KK
      MA=1
      L=1
      DO 132 K=1,KK
        I=3*(K-1)+1
        JA(MA)=I
        MA=MA+1
        JA(MA)=I+1
        MA=MA+1
        L=L+1
        IA(L)=MA
        JA(MA)=I+1
        MA=MA+1
        JA(MA)=I+2
        MA=MA+1
        L=L+1
        IA(L)=MA
        JA(MA)=I+2
        MA=MA+1
        JA(MA)=I+3
        MA=MA+1
        L=L+1
        IA(L)=MA
        JA(MA)=I+3
        MA=MA+1
        JA(MA)=I+4
        MA=MA+1
        L=L+1
        IA(L)=MA
        JA(MA)=I
        MA=MA+1
        JA(MA)=I+1
        MA=MA+1
        JA(MA)=I+2
        MA=MA+1
        L=L+1
        IA(L)=MA
        JA(MA)=I+1
        MA=MA+1
        JA(MA)=I+2
        MA=MA+1
        JA(MA)=I+3
        MA=MA+1
        L=L+1
        IA(L)=MA
        JA(MA)=I
        MA=MA+1
        JA(MA)=I+4
        MA=MA+1
        L=L+1
        IA(L)=MA
  132 CONTINUE
      MA=IA(NA+1)-1
      RETURN
  140 CONTINUE
      IF (N.LT.4) GO TO 999
      DO 141 I=1,N
        IF (MOD(I,4).EQ.1) THEN
          X(I)=-0.8$P 0
        ELSE IF (MOD(I,4).EQ.2) THEN
          X(I)= 1.2$P 0
        ELSE IF (MOD(I,4).EQ.3) THEN
          X(I)=-1.2$P 0
        ELSE
          X(I)= 0.8$P 0
        ENDIF
  141 CONTINUE
      Y(1)=14.4$P 0
      Y(2)=6.8$P 0
      Y(3)=4.2$P 0
      Y(4)=3.2$P 0
      II=4
      JJ=4
      LL=2
      IA(1)=1
  142 IF (MOD(N-II,LL).NE.0) N=N-MOD(N-II,LL)
      KK=(N-II)/LL+1
      NA=JJ*KK
      MA=1
      L=1
      DO 145 K=1,KK
        MM=(K-1)*LL
        DO 144 J=1,JJ
          DO 143 I=1,II
            JA(MA)=MM+I
            MA=MA+1
  143     CONTINUE
          L=L+1
          IA(L)=MA
  144   CONTINUE
  145 CONTINUE
      MA=IA(NA+1)-1
      RETURN
  150 CONTINUE
      IF (N.LT.4) GO TO 999
      DO 151 I=1,N
        IF (MOD(I,4).EQ.1) THEN
          X(I)=-0.8$P 0
        ELSE IF (MOD(I,4).EQ.2) THEN
          X(I)= 1.2$P 0
        ELSE IF (MOD(I,4).EQ.3) THEN
          X(I)=-1.2$P 0
        ELSE
          X(I)= 0.8$P 0
        ENDIF
  151 CONTINUE
      Y(1)=35.8$P 0
      Y(2)=11.2$P 0
      Y(3)=6.2$P 0
      Y(4)=4.4$P 0
      II=4
      JJ=4
      LL=2
      IA(1)=1
      GO TO 142
  160 CONTINUE
      IF (N.LT.4) GO TO 999
      DO 161 I=1,N
        IF (MOD(I,4).EQ.1) THEN
          X(I)=-0.8$P 0
        ELSE IF (MOD(I,4).EQ.2) THEN
          X(I)= 1.2$P 0
        ELSE IF (MOD(I,4).EQ.3) THEN
          X(I)=-1.2$P 0
        ELSE
          X(I)= 0.8$P 0
        ENDIF
  161 CONTINUE
      Y(1)=30.6$P 0
      Y(2)=72.2$P 0
      Y(3)=124.4$P 0
      Y(4)=187.4$P 0
      II=4
      JJ=4
      LL=2
      IA(1)=1
      GO TO 142
  170 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      NA=N
      MA=0
      IA(1)=1
      DO 171 I=1,N
        IF (MOD(I,8).EQ.1) X(I)=1.0$P-1
        IF (MOD(I,8).EQ.2.OR.MOD(I,8).EQ.0) X(I)=2.0$P-1
        IF (MOD(I,8).EQ.3.OR.MOD(I,8).EQ.7) X(I)=3.0$P-1
        IF (MOD(I,8).EQ.4.OR.MOD(I,8).EQ.6) X(I)=4.0$P-1
        IF (MOD(I,8).EQ.5) X(I)=5.0$P-1
        IF (I.GT.2) THEN
          MA=MA+1
          JA(MA)=I-2
        ENDIF
        MA=MA+2
        IF (MOD(I,2).EQ.1) THEN
          JA(MA-1)=I
          JA(MA)=I+1
        ELSE
          JA(MA-1)=I-1
          JA(MA)=I
        ENDIF
        IF (I.LT.N-1) THEN
          MA=MA+1
          JA(MA)=I+2
        ENDIF
        IA(I+1)=MA+1
  171 CONTINUE
      RETURN
  180 IF (N.LT.3) GO TO 999
      NA=N
      MA=0
      IA(1)=1
      DO 181 I=1,N
        X(I)=1.2$P 1
        IF(I.GT.1) THEN
          MA=MA+1
          JA(MA)=I-1
        ENDIF
        MA=MA+1
        JA(MA)=I
        IF(I.LT.N) THEN
          MA=MA+1
          JA(MA)=I+1
        ENDIF
        IA(I+1)=MA+1
  181 CONTINUE
      RETURN
  190 IF (N.LT.7) GO TO 999
      NA=N
      MA=0
      IA(1)=1
      DO 191 I=1,N
        X(I)=-1.0$P 0
        IF (I.GT.1.AND.I.LT.N-3) THEN
          MA=MA+1
          JA(MA)=I-1
        ENDIF
        IF (I.LT.N-4) THEN
          MA=MA+1
          JA(MA)=I
        ENDIF
        IF (I.LT.N-5) THEN
          MA=MA+1
          JA(MA)=I+1
        ENDIF
        MA=MA+5
        JA(MA-4)=N-4
        JA(MA-3)=N-3
        JA(MA-2)=N-2
        JA(MA-1)=N-1
        JA(MA)=N
        IA(I+1)=MA+1
  191 CONTINUE
      RETURN
  200 IF (N.LT.3) GO TO 999
      NA=N
      MA=0
      IA(1)=1
      DO 201 I=1,N
        X(I)=$DBLE(I)/$DBLE(N+1)
        X(I)=X(I)*(X(I)-1.0$P 0)
        IF(I.GT.1) THEN
          MA=MA+1
          JA(MA)=I-1
        ENDIF
        MA=MA+1
        JA(MA)=I
        IF (I.LT.N) THEN
          MA=MA+1
          JA(MA)=I+1
        ENDIF
        IA(I+1)=MA+1
  201 CONTINUE
      RETURN
  210 CONTINUE
      IF (N.LT.5) GO TO 999
      IF (MOD(N-5,3).NE.0) N=N-MOD(N-5,3)
      DO 211 I=1,N
        X(I)=-1.0$P 0
  211 CONTINUE
      IA(1)=1
      KK=(N-5)/3+1
      NA=7*KK
      MA=1
      L=1
      DO 212 K=1,KK
        I=3*(K-1)+1
        JA(MA)=I
        MA=MA+1
        JA(MA)=I+1
        MA=MA+1
        L=L+1
        IA(L)=MA
        JA(MA)=I+1
        MA=MA+1
        JA(MA)=I+2
        MA=MA+1
        L=L+1
        IA(L)=MA
        JA(MA)=I+3
        MA=MA+1
        L=L+1
        IA(L)=MA
        JA(MA)=I+4
        MA=MA+1
        L=L+1
        IA(L)=MA
        JA(MA)=I
        MA=MA+1
        JA(MA)=I+1
        MA=MA+1
        L=L+1
        IA(L)=MA
        JA(MA)=I+2
        MA=MA+1
        JA(MA)=I+3
        MA=MA+1
        JA(MA)=I+4
        MA=MA+1
        L=L+1
        IA(L)=MA
        JA(MA)=I+1
        MA=MA+1
        JA(MA)=I+4
        MA=MA+1
        L=L+1
        IA(L)=MA
  212 CONTINUE
      MA=IA(NA+1)-1
      RETURN
  220 IF (N.LT.3) GO TO 999
      DO 221 I=1,N
        IF(MOD(I,2).EQ.1) THEN
          X(I)=-1.2$P 0
        ELSE
          X(I)= 1.0$P 0
        ENDIF
  221 CONTINUE
      NA=2*(N-1)
      MA=2
      IA(1)=1
      IA(2)=2
      JA(1)=1
      DO 222 KA=1,NA-1
        I=(KA+1)/2
        IF (MOD(KA,2).EQ.1) THEN
          JA(MA)=I
          MA=MA+1
          JA(MA)=I+1
          MA=MA+1
        ELSE
          JA(MA)=I
          MA=MA+1
          JA(MA)=I+1
          MA=MA+1
          JA(MA)=I+2
          MA=MA+1
        ENDIF
        IA(KA+2)=MA
  222 CONTINUE
      MA=MA-1
      RETURN
  230 IF (N.LT.5) GO TO 999
      N=N-MOD(N,2)
      NA=N
      MA=0
      IA(1)=1
      DO 231 I=1,N
      IF (MOD(I,8).EQ.1) X(I)=1.0$P-1
      IF (MOD(I,8).EQ.2.OR.MOD(I,8).EQ.0) X(I)=2.0$P-1
      IF (MOD(I,8).EQ.3.OR.MOD(I,8).EQ.7) X(I)=3.0$P-1
      IF (MOD(I,8).EQ.4.OR.MOD(I,8).EQ.6) X(I)=4.0$P-1
      IF (MOD(I,8).EQ.5) X(I)=5.0$P-1
      MA=MA+1
      JA(MA)=1
      IF (I.GT.3) THEN
      MA=MA+1
      JA(MA)=I-2
      ENDIF
      IF (I.GT.2) THEN
      MA=MA+1
      JA(MA)=I-1
      ENDIF
      IF (I.GT.1) THEN
      MA=MA+1
      JA(MA)=I
      ENDIF
      IF (I.EQ.1) THEN
      MA=MA+1
      JA(MA)=I+1
      ENDIF
      IF (I.LT.N-1) THEN
      MA=MA+1
      JA(MA)=I+2
      ENDIF
      IA(I+1)=MA+1
  231 CONTINUE
      RETURN
  240 IF (N.LT.5) GO TO 999
      N=N-MOD(N,5)
      NA=N
      MA=0
      IA(1)=1
      DO 241 I=1,N
      X(I)=1.0$P 0/$DBLE(N)
      J=(I-1)/5*5
      MA=MA+5
      JA(MA-4)=J+1
      JA(MA-3)=J+2
      JA(MA-2)=J+3
      JA(MA-1)=J+4
      JA(MA)=J+5
      IA(I+1)=MA+1
  241 CONTINUE
      RETURN
  250 IF (N.LT.3) GO TO 999
      DO 251 I=1,N
      X(I)=0.0$P 0
  251 CONTINUE
  252 NA=N
      MA=0
      IA(1)=1
      DO 253 I=1,N
      IF(I.GT.1) THEN
      MA=MA+1
      JA(MA)=I-1
      ENDIF
      MA=MA+1
      JA(MA)=I
      IF(I.LT.N) THEN
      MA=MA+1
      JA(MA)=I+1
      ENDIF
      IA(I+1)=MA+1
  253 CONTINUE
      RETURN
  260 IF (N.LT.3) GO TO 999
      IF (MOD(N,2).NE.1) N=N-1
      NA=N
      MA=0
      IA(1)=1
      DO 261 I=1,N
      X(I)=1.0$P 0
      IF (MOD(I,2).EQ.1) THEN
      IF(I.GT.1) THEN
      MA=MA+2
      JA(MA-1)=I-2
      JA(MA)=I-1
      ENDIF
      MA=MA+1
      JA(MA)=I
      IF(I.LT.N) THEN
      MA=MA+2
      JA(MA-1)=I+1
      JA(MA)=I+2
      ENDIF
      ELSE
      MA=MA+3
      JA(MA-2)=I-1
      JA(MA-1)=I
      JA(MA)=I+1
      ENDIF
      IA(I+1)=MA+1
  261 CONTINUE
      RETURN
  270 IF (N.LT.3) GO TO 999
      DO 271 I=1,N
      X(I)=-1.0$P 0
  271 CONTINUE
      GO TO 252
  280 IF (N.LT.5) GO TO 999
      NA=N
      MA=0
      IA(1)=1
      DO 281 I=1,N
      X(I)=-2.0$P 0
      IF(I.GT.2) THEN
      MA=MA+1
      JA(MA)=I-2
      ENDIF
      IF(I.GT.1) THEN
      MA=MA+1
      JA(MA)=I-1
      ENDIF
      MA=MA+1
      JA(MA)=I
      IF(I.LT.N) THEN
      MA=MA+1
      JA(MA)=I+1
      ENDIF
      IF(I.LT.N-1) THEN
      MA=MA+1
      JA(MA)=I+2
      ENDIF
      IA(I+1)=MA+1
  281 CONTINUE
      RETURN
  290 IF (N.LT.7) GO TO 999
      NA=N
      MA=0
      IA(1)=1
      DO 291 I=1,N
      X(I)=-3.0$P 0
      IF(I.GT.3) THEN
      MA=MA+1
      JA(MA)=I-3
      ENDIF
      IF(I.GT.2) THEN
      MA=MA+1
      JA(MA)=I-2
      ENDIF
      IF(I.GT.1) THEN
      MA=MA+1
      JA(MA)=I-1
      ENDIF
      MA=MA+1
      JA(MA)=I
      IF(I.LT.N) THEN
      MA=MA+1
      JA(MA)=I+1
      ENDIF
      IF(I.LT.N-1) THEN
      MA=MA+1
      JA(MA)=I+2
      ENDIF
      IF(I.LT.N-2) THEN
      MA=MA+1
      JA(MA)=I+3
      ENDIF
      IA(I+1)=MA+1
  291 CONTINUE
      XMAX=1.0$P 1
      RETURN
  310 IF (N.LT.2) GO TO 999
      N=N-MOD(N,2)
      NA=N
      MA=0
      IA(1)=1
      DO 311 I=1,N
      IF(MOD(I,2).EQ.1) THEN
      X(I)=9.0$P 1
      MA=MA+2
      JA(MA-1)=I
      JA(MA)=I+1
      ELSE
      X(I)=6.0$P 1
      MA=MA+2
      JA(MA-1)=I-1
      JA(MA)=I
      ENDIF
      IA(I+1)=MA+1
  311 CONTINUE
      RETURN
  340 IF (N.LT.3) GO TO 999
      DO 341 I=1,N
      X(I)=-1.0$P 0
  341 CONTINUE
      GO TO 252
  360 IF (N.LT.2) GO TO 999
      N=N-MOD(N,2)
      NA=N
      DO 361 I=1,N
      IF (MOD(I,2).EQ.1) THEN
      X(I)=0.0$P 0
      ELSE
      X(I)=1.0$P 0
      ENDIF
  361 CONTINUE
      MA=1
      DO 363 I=1,N-1,2
      IA(I)=2*I-1
      IA(I+1)=2*I+1
      DO 362 J=1,2
      JA(MA)=I
      MA=MA+1
      JA(MA)=I+1
      MA=MA+1
  362 CONTINUE
  363 CONTINUE
      IA(N+1)=MA
      MA=MA-1
      RETURN
  370 IF (N.LT.4) GO TO 999
      N=N-MOD(N,4)
      NA=N
      IA(1)=1
      J=0
      DO 371 I=2,N,2
      X(I-1)=-3.0$P 0
      X(I)=-1.0$P 0
      IA(I)=IA(I-1)+2
      IA(I+1)=IA(I)+3
      MA=IA(I-1)+4
      JA(MA-4)=I-1
      JA(MA-3)=I
      IF (J.EQ.0) THEN
      JA(MA-2)=I-1
      JA(MA-1)=I
      JA(MA)=I+2
      J=1
      ELSE
      JA(MA-2)=I-2
      JA(MA-1)=I-1
      JA(MA)=I
      J=0
      ENDIF
  371 CONTINUE
      RETURN
  380 IF (N.LT.3) GO TO 999
      DO 381 I=1,N
      X(I)=1.5$P 0
  381 CONTINUE
      XMAX=1.0$P 0
      GO TO 252
  390 IF (N.LT.3) GO TO 999
      DO 391 I=1,N
      X(I)=$DBLE(I)/$DBLE(N+1)
      X(I)=X(I)*(X(I)-1.0$P 0)
  391 CONTINUE
      GO TO 252
  400 IF (N.LT.3) GO TO 999
      DO 401 I=1,N
      X(I)=1.0$P 1
  401 CONTINUE
      GO TO 252
  410 IF (N.LT.3) GO TO 999
      DO 411 I=1,N
      X(I)=1.0$P 0
  411 CONTINUE
      PAR=1.0$P 1
      GO TO 252
  420 IF (N.LT.5) GO TO 999
      PAR=5.0$P 2/$DBLE(N+2)
      NA=N
      MA=0
      IA(1)=1
      DO 421 I=1,N
      X(I)=((DBLE(I)+0.5$P 0)/DBLE(N+2)-0.5$P 0)**2
      IF (I.GT.2) THEN
      MA=MA+1
      JA(MA)=I-2
      ENDIF
      IF (I.GT.1) THEN
      MA=MA+1
      JA(MA)=I-1
      ENDIF
      MA=MA+1
      JA(MA)=I
      IF (I.LT.N) THEN
      MA=MA+1
      JA(MA)=I+1
      ENDIF
      IF (I.LT.N-1) THEN
      MA=MA+1
      JA(MA)=I+2
      ENDIF
      IA(I+1)=MA+1
  421 CONTINUE
      RETURN
  430 IF (N.LT.10) GO TO 999
      N=N-MOD(N,2)
      M=N/2
      PAR=5.0$P 2
      NA=N
      MA=0
      IA(1)=1
      DO 431 I=1,M
      K=I+M
      X(I)=(DBLE(I)/DBLE(M+1)-0.5$P 0)**2
      IF (I.GT.2) THEN
      MA=MA+1
      JA(MA)=I-2
      ENDIF
      IF (I.GT.1) THEN
      MA=MA+1
      JA(MA)=I-1
      ENDIF
      MA=MA+1
      JA(MA)=I
      IF (I.LT.M) THEN
      MA=MA+1
      JA(MA)=I+1
      ENDIF
      IF (I.LT.M-1) THEN
      MA=MA+1
      JA(MA)=I+2
      ENDIF
      IF(I.GT.1) THEN
      MA=MA+1
      JA(MA)=K-1
      ENDIF
      MA=MA+1
      JA(MA)=K
      IF(I.LT.M) THEN
      MA=MA+1
      JA(MA)=K+1
      ENDIF
      IA(I+1)=MA+1
  431 CONTINUE
      DO 432 I=M+1,N
      K=I-M
      X(I)=DBLE(K)/DBLE(M+1)-0.5$P 0
      IF (K.GT.1) THEN
      MA=MA+1
      JA(MA)=K-1
      ENDIF
      MA=MA+1
      JA(MA)=K
      IF (K.LT.M) THEN
      MA=MA+1
      JA(MA)=K+1
      ENDIF
      IF(K.GT.1) THEN
      MA=MA+1
      JA(MA)=I-1
      ENDIF
      MA=MA+1
      JA(MA)=I
      IF(K.LT.M) THEN
      MA=MA+1
      JA(MA)=I+1
      ENDIF
      IA(I+1)=MA+1
  432 CONTINUE
      RETURN
  440 IF (N.LT.16) GO TO 999
      M=INT(SQRT($DBLE(N)))
      PAR=6.7$P 0/$DBLE(M+1)**2
      N=M*M
      K=0
      DO 442 J=1,M
      DO 441 I=1,M
      K=K+1
      X(K)=0.0$P 0
  441 CONTINUE
  442 CONTINUE
      GO TO 463
  450 IF (N.LT.16) GO TO 999
      M=INT(SQRT($DBLE(N)))
      PAR=1.0$P 0/$DBLE(M+1)**2
      N=M*M
      K=0
      DO 452 J=1,M
      DO 451 I=1,M
      K=K+1
      X(K)=-1.0$P 0
  451 CONTINUE
  452 CONTINUE
      GO TO 463
  460 IF (N.LT.16) GO TO 999
      M=INT(SQRT($DBLE(N)))
      PAR=1.0$P 0/$DBLE(M+1)**2
      N=M*M
      K=0
      DO 462 J=1,M
      DO 461 I=1,M
      K=K+1
      X(K)=0.0$P 0
  461 CONTINUE
  462 CONTINUE
  463 NA=N
      MA=0
      IA(1)=1
      K=0
      DO 465 J=1,M
      DO 464 I=1,M
      K=K+1
      IF (J.GT.1) THEN
      MA=MA+1
      JA(MA)=K-M
      ENDIF
      IF (I.GT.1) THEN
      MA=MA+1
      JA(MA)=K-1
      ENDIF
      MA=MA+1
      JA(MA)=K
      IF (I.LT.M) THEN
      MA=MA+1
      JA(MA)=K+1
      ENDIF
      IF (J.LT.M) THEN
      MA=MA+1
      JA(MA)=K+M
      ENDIF
      IA(K+1)=MA+1
  464 CONTINUE
  465 CONTINUE
      RETURN
  470 IF (N.LT.16) GO TO 999
      M=INT(SQRT($DBLE(N)))
      PAR=5.0$P 1/$DBLE(M+1)
      N=M*M
      K=0
      DO 472 J=1,M
      DO 471 I=1,M
      K=K+1
      X(K)=1.0$P 0-$DBLE(I)*$DBLE(J)/$DBLE(M+1)**2
  471 CONTINUE
  472 CONTINUE
      GO TO 463
  480 IF (N.LT.16) GO TO 999
      M=INT(SQRT($DBLE(N)))
      PAR=1.0$P 0/$DBLE(M+1)
      N=M*M
      K=0
      DO 482 J=1,M
      DO 481 I=1,M
      K=K+1
      X(K)=0.0$P 0
  481 CONTINUE
  482 CONTINUE
      GO TO 463
  490 IF (N.LT.16) GO TO 999
      M=INT(SQRT($DBLE(N)))
      N=M*M
      PAR=500.0$P 0/$DBLE(M+2)**4
      K=0
      DO 492 J=1,M
      DO 491 I=1,M
      K=K+1
      X(K)=0.0$P 0
  491 CONTINUE
  492 CONTINUE
      GO TO 503
  500 IF (N.LT.16) GO TO 999
      M=INT(SQRT($DBLE(N)))
      N=M*M
      PAR=500.0$P 0
      K=0
      DO 502 J=1,M
      DO 501 I=1,M
      K=K+1
      X(K)=0.0$P 0
  501 CONTINUE
  502 CONTINUE
  503 NA=N
      MA=0
      IA(1)=1
      K=0
      DO 505 J=1,M
      DO 504 I=1,M
      K=K+1
      IF (J.GT.2) THEN
        MA=MA+1
        JA(MA)=K-M-M
      ENDIF
      IF (J.GT.1) THEN
        IF (I.GT.1) THEN
          MA=MA+1
          JA(MA)=K-M-1
        ENDIF
        MA=MA+1
        JA(MA)=K-M
        IF (I.LT.M) THEN
          MA=MA+1
          JA(MA)=K-M+1
        ENDIF
      ENDIF
      IF (I.GT.1) THEN
        IF (I.GT.2) THEN
          MA=MA+1
          JA(MA)=K-2
        ENDIF
        MA=MA+1
        JA(MA)=K-1
      ENDIF
      MA=MA+1
      JA(MA)=K
      IF (I.LT.M) THEN
        MA=MA+1
        JA(MA)=K+1
        IF (I.LT.M-1) THEN
          MA=MA+1
          JA(MA)=K+2
        ENDIF
      ENDIF
      IF (J.LT.M) THEN
        IF (I.GT.1) THEN
          MA=MA+1
          JA(MA)=K+M-1
        ENDIF
        MA=MA+1
        JA(MA)=K+M
        IF (I.LT.M) THEN
          MA=MA+1
          JA(MA)=K+M+1
        ENDIF
      ENDIF
      IF (J.LT.M-1) THEN
        MA=MA+1
        JA(MA)=K+M+M
      ENDIF
      IA(K+1)=MA+1
  504 CONTINUE
  505 CONTINUE
      RETURN
  520 IF (N.LT.3) GO TO 999
      DO 521 I=1,N
      X(I)=5.0$P 0*MIN($DBLE(I)/$DBLE(N+1),1.0$P 0-$DBLE(I)/$DBLE(N+1))
  521 CONTINUE
      GO TO 252
  510 IF (N.LT.3) GO TO 999
      DO 511 I=1,N
      X(I)=5.0$P 0*MIN($DBLE(I)/$DBLE(N+1),1.0$P 0-$DBLE(I)/$DBLE(N+1))
  511 CONTINUE
      XMAX=1.0$P 4
      GO TO 252
  530 IF (N.LT.2) GO TO 999
      N1=N-1
      DO 531 I=1,N1
      X(I)=-1.2D 0
  531 CONTINUE
      X(N)=-1.0D 0
  532 NA=N
      MA=0
      IA(1)=1
      DO 533 I=1,N
      IF (I.GT.1) THEN
      MA=MA+1
      JA(MA)=I-1
      ENDIF
      MA=MA+1
      JA(MA)=I
      IA(I+1)=MA+1
  533 CONTINUE
      RETURN
  540 IF (N.LT.3) GO TO 999
      DO 541 I=1,N
      X(I)=2.0D 0
  541 CONTINUE
      NA=N
      MA=0
      IA(1)=1
      DO 542 I=1,N
      IF (I.EQ.N) THEN
      MA=MA+1
      JA(MA)=1
      MA=MA+1
      JA(MA)=N
      ELSE
      MA=MA+1
      JA(MA)=I
      IF (I.LE.N-1) THEN
      MA=MA+1
      JA(MA)=I+1
      ENDIF
      ENDIF
      IA(I+1)=MA+1
  542 CONTINUE
      RETURN
  550 IF (N.LT.3) GO TO 999
      DO 551 I=1,N
      X(I)=0.0D 0
  551 CONTINUE
      GO TO 252
  560 IF (N.LT.3) GO TO 999
      DO 561 I=1,N
      X(I)=-1.0D 0
  561 CONTINUE
      GO TO 252
  570 IF (N.LT.7) GO TO 999
      DO 571 I=1,N
      X(I)=-1.0D 0
  571 CONTINUE
      NA=N
      MA=0
      IA(1)=1
      J1=3
      J2=3
      DO 573 I=1,N
      IF (I-J1.GT.1) THEN
      I1=I-J1
      ELSE
      I1=1
      ENDIF
      IF (I+J2.LT.N) THEN
      I2=I+J2
      ELSE
      I2=N
      ENDIF
      DO 572 J=I1,I2
      MA=MA+1
      JA(MA)=J
  572 CONTINUE
      IA(I+1)=MA+1
  573 CONTINUE
      RETURN
  580 IF (N.LT.2) GO TO 999
      DO 581 I=1,N
      X(I)=0.5D 0
  581 CONTINUE
      GO TO 532
      RETURN
  590 IF (N.LT.2) GO TO 999
      DO 591 I=1,N
      X(I)=0.5D 0
  591 CONTINUE
      GO TO 532
  600 IF (N.LT.3) GO TO 999
      DO 601 I=1,N
      X(I)=1.0D 0
  601 CONTINUE
      GO TO 252
  610 IF (N.LT.7) GO TO 999
      DO 611 I=1,N
      X(I)=-1.0D 0
  611 CONTINUE
      NA=N
      MA=0
      IA(1)=1
      DO 613 I=1,N
      IF (I-5.GT.1) THEN
      I1=I-5
      ELSE
      I1=1
      ENDIF
      IF (I+1.LT.N) THEN
      I2=I+1
      ELSE
      I2=N
      ENDIF
      DO 612 J=I1,I2
      MA=MA+1
      JA(MA)=J
  612 CONTINUE
      IA(I+1)=MA+1
  613 CONTINUE
      RETURN
  620 IF (N.LT.3) GO TO 999
      DO 621 I=1,N
      X(I)=1.0D 0
  621 CONTINUE
      GO TO 252
  630 IF (N.LT.3) GO TO 999
      DO 631 I=1,N
      X(I)=1.0D 0
  631 CONTINUE
      GO TO 252
  640 T=DBLE(2)/DBLE(N+2)
      N1=N/2
      DO 641 I=1,N1
      S=DBLE(I)*T
      X(I)=S*(1.0D 0-S)
      X(N1+I)=X(I)
  641 CONTINUE
      NA=N
      N1=N/2
      MA=0
      IA(1)=1
      DO 642 I=1,N
      IF (I.EQ.1) THEN
      MA=MA+1
      JA(MA)=I
      MA=MA+1
      JA(MA)=I+1
      MA=MA+1
      JA(MA)=I+N1
      ELSE IF (I.EQ.N1+1) THEN
      MA=MA+1
      JA(MA)=1
      MA=MA+1
      JA(MA)=I
      MA=MA+1
      JA(MA)=I+1
      ELSE IF (I.EQ.N1) THEN
      MA=MA+1
      JA(MA)=I-1
      MA=MA+1
      JA(MA)=I
      MA=MA+1
      JA(MA)=I+N1
      ELSE IF (I.EQ.N) THEN
      MA=MA+1
      JA(MA)=N1
      MA=MA+1
      JA(MA)=I-1
      MA=MA+1
      JA(MA)=I
      ELSE IF (I.LT.N1) THEN
      MA=MA+1
      JA(MA)=I-1
      MA=MA+1
      JA(MA)=I
      MA=MA+1
      JA(MA)=I+1
      MA=MA+1
      JA(MA)=I+N1
      ELSE
      MA=MA+1
      JA(MA)=I-N1
      MA=MA+1
      JA(MA)=I-1
      MA=MA+1
      JA(MA)=I
      MA=MA+1
      JA(MA)=I+1
      ENDIF
      IA(I+1)=MA+1
  642 CONTINUE
      RETURN
  650 N1=INT(SQRT(DBLE(N)))
      N=N1*N1
      DO 651 I=1,N
      X(I)=1.0D 0
  651 CONTINUE
  652 NA=N
      ND=INT(SQRT(DBLE(N)))
      MA=0
      IA(1)=1
      DO 653 I=1,N
      L=MOD(I,ND)
      IF (L.EQ.0) THEN
      K=I/ND
      L=ND
      ELSE
      K=INT(I/ND)+1
      ENDIF
      IF (L.EQ.1.AND.K.EQ.1) THEN
      MA=MA+1
      JA(MA)=1
      MA=MA+1
      JA(MA)=2
      MA=MA+1
      JA(MA)=ND+1
      ENDIF
      IF (1.LT.L.AND.L.LT.ND.AND.K.EQ.1) THEN
      MA=MA+1
      JA(MA)=L-1
      MA=MA+1
      JA(MA)=L
      MA=MA+1
      JA(MA)=L+1
      MA=MA+1
      JA(MA)=L+ND
      ENDIF
      IF (L.EQ.ND.AND.K.EQ.1) THEN
      MA=MA+1
      JA(MA)=ND-1
      MA=MA+1
      JA(MA)=ND
      MA=MA+1
      JA(MA)=2*ND
      ENDIF
      IF (L.EQ.1.AND.1.LT.K.AND.K.LT.ND) THEN
      MA=MA+1
      JA(MA)=I-ND
      MA=MA+1
      JA(MA)=I
      MA=MA+1
      JA(MA)=I+1
      MA=MA+1
      JA(MA)=I+ND
      ENDIF
      IF (L.EQ.ND.AND.1.LT.K.AND.K.LT.ND) THEN
      MA=MA+1
      JA(MA)=I-ND
      MA=MA+1
      JA(MA)=I-1
      MA=MA+1
      JA(MA)=I
      MA=MA+1
      JA(MA)=I+ND
      ENDIF
      IF (L.EQ.1.AND.K.EQ.ND) THEN
      MA=MA+1
      JA(MA)=I-ND
      MA=MA+1
      JA(MA)=I
      MA=MA+1
      JA(MA)=I+1
      ENDIF
      IF (1.LT.L.AND.L.LT.ND.AND.K.EQ.ND) THEN
      MA=MA+1
      JA(MA)=I-ND
      MA=MA+1
      JA(MA)=I-1
      MA=MA+1
      JA(MA)=I
      MA=MA+1
      JA(MA)=I+1
      ENDIF
      IF (L.EQ.ND.AND.K.EQ.ND) THEN
      MA=MA+1
      JA(MA)=I-ND
      MA=MA+1
      JA(MA)=I-1
      MA=MA+1
      JA(MA)=I
      ENDIF
      IF (1.LT.L.AND.L.LT.ND.AND.1.LT.K.AND.K.LT.ND) THEN
      MA=MA+1
      JA(MA)=I-ND
      MA=MA+1
      JA(MA)=I-1
      MA=MA+1
      JA(MA)=I
      MA=MA+1
      JA(MA)=I+1
      MA=MA+1
      JA(MA)=I+ND
      ENDIF
      IA(I+1)=MA+1
  653 CONTINUE
      RETURN
  660 N1=INT(SQRT(DBLE(N)))
      N=N1*N1
      DO 661 I=1,N
      X(I)=1.0D 0
  661 CONTINUE
      GO TO 652
  999 IERR=1
      RETURN
      END
