* SUBROUTINE EAFU14             ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 RA : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF MODEL FUNCTIONS FOR UNCONSTRAINED MINIMIZATION.
*  SPARSE VERSION - LU VERSION WITH MODIFIED TESTS NO 7-10,12.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  F  VALUE OF THE MODEL FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EAFU14(N,KA,X,FA,NEXT)
      INTEGER N,NEXT
      REAL*8 X(N),FA
      REAL*8 A,B,C,D,P,Q,R,U,V
      INTEGER I,J,K,KA
      GO TO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     &  170,180,190,200,210,220),NEXT
   10 A=X(KA)**2-X(KA+1)
      B=X(KA)-1.0D 0
      FA=1.0D 2*A**2+B**2
      RETURN
   20 I=2*KA-1
      A=X(I)**2-X(I+1)
      B=X(I)-1.0D 0
      C=X(I+2)**2-X(I+3)
      D=X(I+2)-1.0D 0
      U=X(I+1)+X(I+3)-2.0D 0
      V=X(I+1)-X(I+3)
      FA=1.0D 2*A**2+B**2+9.0D 1*C**2+D**2+
     &   1.0D 1*U**2+0.1D 0*V**2
      RETURN
   30 I=2*KA-1
      A=X(I)+1.0D 1*X(I+1)
      B=X(I+2)-X(I+3)
      C=X(I+1)-2.0D 0*X(I+2)
      D=X(I)-X(I+3)
      FA=A**2+5.0D 0*B**2+C**4+1.0D 1*D**4
      RETURN
   40 I=2*KA-1
      A=EXP(X(I))
      B=A-X(I+1)
      D=X(I+1)-X(I+2)
      P=X(I+2)-X(I+3)
      Q=SIN(P)/COS(P)
      U=X(I)
      V=X(I+3)-1.0D 0
      FA=B**4+1.0D 2*D**6+Q**4+U**8+V**2
      RETURN
   50 P=7.0D 0/3.0D 0
      A=(3.0D 0-2.0D 0*X(KA))*X(KA)+1.0D 0
      IF (KA.GT.1) A=A-X(KA-1)
      IF (KA.LT.N) A=A-X(KA+1)
      FA=ABS(A)**P
      RETURN
   60 P=7.0D 0/3.0D 0
      A=(2.0D 0+5.0D 0*X(KA)**2)*X(KA)+1.0D 0
      DO 61 I=MAX(1,KA-5),MIN(N,KA+1)
        A=A+X(I)*(1.0D 0+X(I))
   61 CONTINUE
      FA=ABS(A)**P
      RETURN
   70 P=7.0D 0/3.0D 0
      IF (KA.LE.N) THEN
      A=(3.0D 0-2.0D 0*X(KA))*X(KA)+1.0D 0
      IF (KA.GT.1) A=A-X(KA-1)
      IF (KA.LT.N) A=A-X(KA+1)
      ELSE
      I=KA-N
      A=X(I)+X(I+N/2)
      ENDIF
      FA=ABS(A)**P
      RETURN
   80 K=N/2
      P=0.0D 0
      DO 81 I=KA-2,KA+2
        IF (I.LT.1.OR.I.GT.N) GO TO 81
        A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
        B=DBLE(I+KA)/1.0D 1
        P=P+A*SIN(X(I))+B*COS(X(I))
   81 CONTINUE
      IF (KA.GT.K) THEN
        I=KA-K
        A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
        B=DBLE(I+KA)/1.0D 1
        P=P+A*SIN(X(I))+B*COS(X(I))
      ELSE
        I=KA+K
        A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
        B=DBLE(I+KA)/1.0D 1
        P=P+A*SIN(X(I))+B*COS(X(I))
      ENDIF
      FA=(DBLE(N+KA)-P)**2/DBLE(N)
      RETURN
   90 K=N/2
      FA=DBLE(KA)*(1.0D 0-COS(X(KA)))
      DO 91 I=KA-2,KA+2
        IF (I.LT.1.OR.I.GT.N) GO TO 91
        A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
        B=DBLE(I+KA)/1.0D 1
        FA=FA+A*SIN(X(I))+B*COS(X(I))
   91 CONTINUE
      IF (KA.GT.K) THEN
        I=KA-K
        A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
        B=DBLE(I+KA)/1.0D 1
        FA=FA+A*SIN(X(I))+B*COS(X(I))
      ELSE
        I=KA+K
        A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
        B=DBLE(I+KA)/1.0D 1
        FA=FA+A*SIN(X(I))+B*COS(X(I))
      ENDIF
      FA=FA/DBLE(N)
      RETURN
  100 K=N/2
      FA=0.0D 0
      Q=1.0D 0+DBLE(KA)/1.0D 1
      DO 101 I=KA-2,KA+2
      IF (I.LT.1.OR.I.GT.N) GO TO 101
      A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
      B=1.0D 0+DBLE(I)/1.0D 1
      C=DBLE(I+KA)/1.0D 1
      FA=FA+A*SIN(Q*X(KA)+B*X(I)+C)
  101 CONTINUE
      IF (KA.GT.K) THEN
        I=KA-K
        A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
        B=1.0D 0+DBLE(I)/1.0D 1
        C=DBLE(I+KA)/1.0D 1
        FA=FA+A*SIN(Q*X(KA)+B*X(I)+C)
      ELSE
        I=KA+K
        A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
        B=1.0D 0+DBLE(I)/1.0D 1
        C=DBLE(I+KA)/1.0D 1
        FA=FA+A*SIN(Q*X(KA)+B*X(I)+C)
      ENDIF
      FA=FA/DBLE(N)
      RETURN
  110 P=-0.2008D-2
      Q=-0.1900D-2
      R=-0.0261D-2
      I=5*(KA-1)
      A=1.0D 0
      B=0.0D 0
      DO 111 J=1,5
      A=A*X(I+J)
      B=B+X(I+J)**2
  111 CONTINUE
      A=EXP(A)
      B=B-1.0D 1-P
      C=X(I+2)*X(I+3)-5.0D 0*X(I+4)*X(I+5)-Q
      D=X(I+1)**3+X(I+2)**3+1.0D 0-R
      FA=A+1.0D 1*(B**2+C**2+D**2)
      RETURN
  120 A=X(KA)-3.0D 0
      B=X(KA)-X(KA+1)
      FA=A**2+B**2+EXP(2.0D 1*B)
      RETURN
  130 A=X(KA+1)**2
      B=X(KA)**2
      C=A+1.0D 0
      D=B+1.0D 0
      FA=B**C+A**D
      RETURN
  140 P=1.0D 0/DBLE(N+1)
      Q=0.5D 0*P**2
      A=2.0D 0*X(KA)+Q*(X(KA)+DBLE(KA)*P+1.0D 0)**3
      IF(KA.GT.1) A=A-X(KA-1)
      IF(KA.LT.N) A=A-X(KA+1)
      FA=A**2
      RETURN
  150 P=1.0D 0/DBLE(N+1)
      Q=2.0D 0/P
      R=2.0D 0*P
      A=X(KA)-X(KA+1)
      FA=Q*X(KA)*A
      IF (ABS(A).LE.1.0D-6) THEN
      FA=FA+R*EXP(X(KA+1))*(1.0D 0+A/2.0D 0*(1.0D 0+A/3.0D 0*(1.0D 0+
     &  A/4.0D 0)))
      ELSE
      B=EXP(X(KA))-EXP(X(KA+1))
      FA=FA+R*B/A
      ENDIF
      IF (KA.EQ.1) THEN
      FA=FA+R*(EXP(X(1))-1.0D 0)/X(1)
      ELSEIF (KA.EQ.N-1) THEN
      FA=FA+Q*X(N)**2+R*(EXP(X(N))-1.0D 0)/X(N)
      ENDIF
      RETURN
  160 A=DBLE(KA)*(1.0D 0-COS(X(KA)))
      IF(KA.GT.1) A=A+DBLE(KA)*SIN(X(KA-1))
      IF(KA.LT.N) A=A-DBLE(KA)*SIN(X(KA+1))
      FA=A
      RETURN
  170 P=1.0D 0/DBLE(N+1)
      IF (KA.EQ.1) THEN
      FA=0.25D 0*X(KA)**2/P+1.25D-1*X(KA+1)**2/P+
     &   P*(EXP(X(KA))-1.0D 0)
      ELSE IF (KA.EQ.N) THEN
      FA=0.25D 0*X(KA)**2/P+1.25D-1*X(KA-1)**2/P+
     &   P*(EXP(X(KA))-1.0D 0)
      ELSE
      FA=1.25D-1*(X(KA+1)-X(KA-1))**2/P+P*(EXP(X(KA))-1.0D 0)
      ENDIF
      RETURN
  180 P=1.0D 0/DBLE(N+1)
      Q=DBLE(KA)*P
      IF (KA.EQ.1) THEN
      FA=0.5D 0*X(KA)**2/P+0.25D 0*X(KA+1)**2/P-
     &   P*(X(KA)**2+2.0D 0*X(KA)*Q)
      ELSE IF (KA.EQ.N) THEN
      FA=0.5D 0*X(KA)**2/P+0.25D 0*X(KA-1)**2/P-
     &   P*(X(KA)**2+2.0D 0*X(KA)*Q)
      ELSE
      FA=2.5D-1*(X(KA+1)-X(KA-1))**2/P-P*(X(KA)**2+2.0D 0*X(KA)*Q)
      ENDIF
      RETURN
  190 P=1.0D 0/DBLE(N+1)
      Q=EXP(2.0D 0*DBLE(KA)*P)
      IF (KA.EQ.1) THEN
      R=1.0D 0/3.0D 0
      FA=0.5D 0*(X(KA)-R)**2/P+7.0D 0*R**2+
     &   2.5D-1*(X(KA+1)-R)**2/P+P*(X(KA)**2+2.0D 0*X(KA)*Q)
      ELSE IF (KA.EQ.N) THEN
      R=EXP(2.0D 0)/3.0D 0
      FA=0.5D 0*(X(KA)-R)**2/P+7.0D 0*R**2+
     &   2.5D-1*(X(KA-1)-R)**2/P+P*(X(KA)**2+2.0D 0*X(KA)*Q)
      ELSE
      FA=2.5D-1*(X(KA+1)-X(KA-1))**2/P+P*(X(KA)**2+2.0D 0*X(KA)*Q)
      ENDIF
      RETURN
  200 P=1.0D 0/DBLE(N+1)
      IF (KA.EQ.1) THEN
      FA=(0.5D 0*X(KA)**2/P-P)+
     &   (2.5D-1*X(KA+1)**2/P-P)*EXP(-2.0D 0*X(KA)**2)
      ELSE IF (KA.EQ.N) THEN
      FA=(0.5D 0*X(KA)**2/P-P)*EXP(-2.0D 0)+
     &   (2.5D-1*X(KA-1)**2/P-P)*EXP(-2.0D 0*X(KA)**2)
      ELSE
      FA=(2.5D-1*(X(KA+1)-X(KA-1))**2/P-P)*EXP(-2.0D 0*X(KA)**2)
      ENDIF
      RETURN
  210 P=1.0D 0/DBLE(N+1)
      IF (KA.EQ.1) THEN
      A=0.5D 0*(X(KA+1)-1.0D 0)/P
      B=(X(KA)-1.0D 0)/P
      FA=P*(X(KA)**2+A*ATAN(A)-LOG(SQRT(1.0D 0+A**2)))+
     &   0.5D 0*P*(1.0D 0+B*ATAN(B)-LOG(SQRT(1.0D 0+B**2)))
      ELSE IF (KA.EQ.N) THEN
      A=0.5D 0*(2.0D 0-X(KA-1))/P
      B=(2.0D 0-X(KA))/P
      FA=P*(X(KA)**2+A*ATAN(A)-LOG(SQRT(1.0D 0+A**2)))+
     &   0.5D 0*P*(4.0D 0+B*ATAN(B)-LOG(SQRT(1.0D 0+B**2)))
      ELSE
      A=0.5D 0*(X(KA+1)-X(KA-1))/P
      FA=P*(X(KA)**2+A*ATAN(A)-LOG(SQRT(1.0D 0+A**2)))
      ENDIF
      RETURN
  220 P=1.0D 0/DBLE(N+1)
      IF (KA.EQ.1) THEN
      A= 0.5D 0*X(KA+1)/P
      B= X(KA)/P
      FA=P*(1.0D 2*(X(KA)-A**2)**2+(1.0D 0-A)**2)+
     &   0.5D 0*P*(1.0D 2*B**4+(1.0D 0-B)**2)
      ELSE IF (KA.EQ.N) THEN
      A=-0.5D 0*X(KA-1)/P
      B=-X(KA)/P
      FA=P*(1.0D 2*(X(KA)-A**2)**2+(1.0D 0-A)**2)+
     &   0.5D 0*P*(1.0D 2*B**4+(1.0D 0-B)**2)
      ELSE
      A=0.5D 0*(X(KA+1)-X(KA-1))/P
      FA=P*(1.0D 2*(X(KA)-A**2)**2+(1.0D 0-A)**2)
      ENDIF
      RETURN
      END
