* SUBROUTINE EAFU15             ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 RA : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF MODEL FUNCTIONS FOR UNCONSTRAINED MINIMIZATION.
*  SPARSE VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  F  VALUE OF THE MODEL FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EAFU15(N,KA,X,FA,NEXT)
      INTEGER N,KA,NEXT
      REAL*8 X(N),FA
      REAL*8 A,B,C,D,P,ALFA,U,V
      INTEGER I,J,K,L,M,IA,IB,IC
      REAL*8 Y(20)
      COMMON /EMPR15/ Y
      GOTO(10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     & 170,180,190,200,210,220,260,270),NEXT
   10 I=(KA+1)/2
      IF (MOD(KA,2).EQ.1) THEN
      FA=1.0D 1*(X(I)**2-X(I+1))
      ELSE
      FA=X(I)-1.0D 0
      ENDIF
      RETURN
   20 A=SQRT(10.0D 0)
      D=SQRT(90.0D 0)
      I=2*((KA+5)/6)
      IF (MOD(KA,6).EQ.1) THEN
      FA=1.0D 1*(X(I-1)**2-X(I))
      ELSEIF (MOD(KA,6).EQ.2) THEN
      FA=X(I-1)-1.0D 0
      ELSEIF (MOD(KA,6).EQ.3) THEN
      FA=D*(X(I+1)**2-X(I+2))
      ELSEIF (MOD(KA,6).EQ.4) THEN
      FA=X(I+1)-1.0D 0
      ELSEIF (MOD(KA,6).EQ.5) THEN
      FA=A*(X(I)+X(I+2)-2.0D 0)
      ELSE
      FA=(X(I)-X(I+2))/A
      ENDIF
      RETURN
   30 A=SQRT(1.0D 1)
      C=SQRT(5.0D 0)
      I=2*((KA+3)/4)
      IF (MOD(KA,4).EQ.1) THEN
      FA=X(I-1)+1.0D 1*X(I)
      ELSEIF (MOD(KA,4).EQ.2) THEN
      FA=C*(X(I+1)-X(I+2))
      ELSEIF (MOD(KA,4).EQ.3) THEN
      FA=(X(I)-2.0D 0*X(I+1))**2
      ELSE
      FA=A*(X(I-1)-X(I+2))**2
      ENDIF
      RETURN
   40 I=2*((KA+4)/5)
      IF (MOD(KA,5).EQ.1) THEN
      FA=(EXP(X(I-1))-X(I))**2
      ELSEIF (MOD(KA,5).EQ.2) THEN
      FA=1.0D 1*(X(I)-X(I+1))**3
      ELSEIF (MOD(KA,5).EQ.3) THEN
      P=X(I+1)-X(I+2)
      FA=(SIN(P)/COS(P))**2
      ELSEIF (MOD(KA,5).EQ.4) THEN
      FA=X(I-1)**4
      ELSE
      FA=X(I+2)-1.0D 0
      ENDIF
      RETURN
   50 I=KA
      FA=(3.0D 0-2.0D 0*X(I))*X(I)+1.0D 0
      IF (I.GT.1) FA=FA-X(I-1)
      IF (I.LT.N) FA=FA-X(I+1)
      RETURN
   60 I=KA
      FA=(2.0D 0+5.0D 0*X(I)**2)*X(I)+1.0D 0
      DO 61 J=MAX(1,I-5),MIN(N,I+1)
      FA=FA+X(J)*(1.0D 0+X(J))
   61 CONTINUE
      RETURN
   70 I=(KA+1)/2
      IF (MOD(KA,2).EQ.1) THEN
      FA=X(I)+X(I+1)*((5.0D 0-X(I+1))*X(I+1)-2.0D 0)-1.3D 1
      ELSE
      FA=X(I)+X(I+1)*((1.0D 0+X(I+1))*X(I+1)-1.4D 1)-2.9D 1
      ENDIF
      RETURN
   80 I=MOD(KA,N/2)+1
      J=I+N/2
      M=5*N
      IF (KA.LE.M/2) THEN
      IA=1
      ELSE
      IA=2
      ENDIF
      IB=5-KA/(M/4)
      IC=MOD(KA,5)+1
      FA=(X(I)**IA-X(J)**IB)**IC
      RETURN
   90 I=2*((KA+5)/6)-1
      IF (MOD(KA,6).EQ.1) THEN
      FA=X(I)+3.0D 0*X(I+1)*(X(I+2)-1.0D 0)+X(I+3)**2-1.0D 0
      ELSEIF (MOD(KA,6).EQ.2) THEN
      FA=(X(I)+X(I+1))**2+(X(I+2)-1.0D 0)**2-X(I+3)-3.0D 0
      ELSEIF (MOD(KA,6).EQ.3) THEN
      FA=X(I)*X(I+1)-X(I+2)*X(I+3)
      ELSEIF (MOD(KA,6).EQ.4) THEN
      FA=2.0D 0*X(I)*X(I+2)+X(I+1)*X(I+3)-3.0D 0
      ELSEIF (MOD(KA,6).EQ.5) THEN
      FA=(X(I)+X(I+1)+X(I+2)+X(I+3))**2+(X(I)-1.0D 0)**2
      ELSE
      FA=X(I)*X(I+1)*X(I+2)*X(I+3)+(X(I+3)-1.0D 0)**2-1.0D 0
      ENDIF
      RETURN
  100 I=(KA+1)/2
      J=MOD(KA,2)
      IF (J.EQ.0) THEN
      FA=6.0D 0-EXP(2.0D 0*X(I))-EXP(2.0D 0*X(I+1))
      ELSEIF (I.EQ.1) THEN
      FA=4.0D 0-EXP(X(I))-EXP(X(I+1))
      ELSEIF (I.EQ.N) THEN
      FA=8.0D 0-EXP(3.0D 0*X(I-1))-EXP(3.0D 0*X(I))
      ELSE
      FA=8.0D 0-EXP(3.0D 0*X(I-1))-EXP(3.0D 0*X(I))+
     & 4.0D 0-EXP(X(I))-EXP(X(I+1))
      ENDIF
      RETURN
  110 I=(KA+1)/2
      IF (MOD(KA,2).EQ.1) THEN
      FA=1.0D 1*(2.0D 0*X(I)/(1.0D 0+X(I)**2)-X(I+1))
      ELSE
      FA=X(I)-1.0D 0
      ENDIF
      RETURN
  120 I=3*((KA+5)/6)-2
      IF (MOD(KA,6).EQ.1) THEN
      FA=1.0D 1*(X(I)**2-X(I+1))
      ELSEIF (MOD(KA,6).EQ.2) THEN
      FA=X(I+2)-1.0D 0
      ELSEIF (MOD(KA,6).EQ.3) THEN
      FA=(X(I+3)-1.0D 0)**2
      ELSEIF (MOD(KA,6).EQ.4) THEN
      FA=(X(I+4)-1.0D 0)**3
      ELSEIF (MOD(KA,6).EQ.5) THEN
      FA=X(I)**2*X(I+3)+SIN(X(I+3)-X(I+4))-1.0D 1
      ELSE
      FA=X(I+1)+(X(I+2)**2*X(I+3))**2-2.0D 1
      ENDIF
      RETURN
  130 I=3*((KA+6)/7)-2
      IF (MOD(KA,7).EQ.1) THEN
      FA=1.0D 1*(X(I)**2-X(I+1))
      ELSEIF (MOD(KA,7).EQ.2) THEN
      FA=1.0D 1*(X(I+1)**2-X(I+2))
      ELSEIF (MOD(KA,7).EQ.3) THEN
      FA=(X(I+2)-X(I+3))**2
      ELSEIF (MOD(KA,7).EQ.4) THEN
      FA=(X(I+3)-X(I+4))**2
      ELSEIF (MOD(KA,7).EQ.5) THEN
      FA=X(I)+X(I+1)**2+X(I+2)-3.0D 1
      ELSEIF (MOD(KA,7).EQ.6) THEN
      FA=X(I+1)-X(I+2)**2+X(I+3)-1.0D 1
      ELSE
      FA=X(I)*X(I+4)-1.0D 1
      ENDIF
      RETURN
  140 I=2*((KA+3)/4)-2
      L=MOD((KA-1),4)+1
      FA=-Y(L)
      DO 142 K=1,3
      A=DBLE(K*K)/DBLE(L)
      DO 141 J=1,4
      IF (X(I+J).EQ.0) X(I+J)=1.0D-16
      A=A*SIGN(1.0D 0,X(I+J))*ABS(X(I+J))**(DBLE(J)/DBLE(K*L))
  141 CONTINUE
      FA=FA+A
  142 CONTINUE
      RETURN
  150 I=2*((KA+3)/4)-2
      L=MOD((KA-1),4)+1
      FA=-Y(L)
      DO 152 K=1,3
      A=0.0D 0
      DO 151 J=1,4
      A=A+X(I+J)*(DBLE(J)/DBLE(K*L))
  151 CONTINUE
      FA=FA+EXP(A)*DBLE(K*K)/DBLE(L)
  152 CONTINUE
      RETURN
  160 I=2*((KA+3)/4)-2
      L=MOD((KA-1),4)+1
      FA=-Y(L)
      DO 161 J=1,4
      FA=FA+DBLE((1-2*MOD(J,2))*L*J*J)*SIN(X(I+J))+
     & DBLE(L*L*J)*COS(X(I+J))
  161 CONTINUE
      RETURN
  170 ALFA=0.5D 0
      IF (KA.EQ.1) THEN
      FA=ALFA-(1.0D 0-ALFA)*X(3)-X(1)*(1.0D 0+4.0D 0*X(2))
      ELSEIF(KA.EQ.2) THEN
      FA=-(2.0D 0-ALFA)*X(4)-X(2)*(1.0D 0+4.0D 0*X(1))
      ELSEIF(KA.EQ.N-1) THEN
      FA=ALFA*X(N-3)-X(N-1)*(1.0D 0+4.0D 0*X(N))
      ELSEIF (KA.EQ.N) THEN
      FA=ALFA*X(N-2)-(2.0D 0-ALFA)-X(N)*(1.0D 0+4.0D 0*X(N-1))
      ELSEIF (MOD(KA,2).EQ.1) THEN
      FA=ALFA*X(KA-2)-(1.0D 0-ALFA)*X(KA+2)-
     & X(KA)*(1.0D 0+4.0D 0*X(KA+1))
      ELSE
      FA=ALFA*X(KA-2)-(2.0D 0-ALFA)*X(KA+2)-
     & X(KA)*(1.0D 0+4.0D 0*X(KA-1))
      ENDIF
      RETURN
  180 IF (KA.LT.2) THEN
      FA=4.0D 0*(X(KA)-X(KA+1)**2)
      ELSEIF (KA.LT.N) THEN
      FA=8.0D 0*X(KA)*(X(KA)**2-X(KA-1))-2.0D 0*(1.0D 0-X(KA))+
     & 4.0D 0*(X(KA)-X(KA+1)**2)
      ELSE
      FA=8.0D 0*X(KA)*(X(KA)**2-X(KA-1))-2.0D 0*(1.0D 0-X(KA))
      ENDIF
      RETURN
  190 IF (KA.EQ.1) THEN
      FA=-2.0D 0*X(KA)**2+3.0D 0*X(KA)-2.0D 0*X(KA+1)+
     & 3.0D 0*X(N-4)-X(N-3)-X(N-2)+0.5D 0*X(N-1)-X(N)+1.0D 0
      ELSEIF (KA.LE.N-1) THEN
      FA=-2.0D 0*X(KA)**2+3.0D 0*X(KA)-X(KA-1)-2.0D 0*X(KA+1)+
     & 3.0D 0*X(N-4)-X(N-3)-X(N-2)+0.5D 0*X(N-1)-X(N)+1.0D 0
      ELSE
      FA=-2.0D 0*X(N)**2+3.0D 0*X(N)-X(N-1)+
     & 3.0D 0*X(N-4)-X(N-3)-X(N-2)+0.5D 0*X(N-1)-X(N)+1.0D 0
      ENDIF
      RETURN
  200 U=1.0D 0/DBLE(N+1)
      V=DBLE(KA)*U
      FA=2.0D 0*X(KA)+0.5D 0*U*U*(X(KA)+V+1.0D 0)**3+1.0D 0
      IF(KA.GT.1) FA=FA-X(KA-1)
      IF(KA.LT.N) FA=FA-X(KA+1)
      RETURN
  210 I=3*((KA+6)/7)-2
      IF (MOD(KA,7).EQ.1) THEN
      FA=1.0D 1*(X(I)**2-X(I+1))
      ELSEIF (MOD(KA,7).EQ.2) THEN
      FA=X(I+1)+X(I+2)-2.0D 0
      ELSEIF (MOD(KA,7).EQ.3) THEN
      FA=X(I+3)-1.0D 0
      ELSEIF (MOD(KA,7).EQ.4) THEN
      FA=X(I+4)-1.0D 0
      ELSEIF (MOD(KA,7).EQ.5) THEN
      FA=X(I)+3.0D 0*X(I+1)
      ELSEIF (MOD(KA,7).EQ.6) THEN
      FA=X(I+2)+X(I+3)-2.0D 0*X(I+4)
      ELSE
      FA=1.0D 1*(X(I+1)**2-X(I+4))
      ENDIF
      RETURN
  220 I=KA/2
      IF (KA.EQ.1) THEN
      FA=X(KA)-1.0D 0
      ELSE IF (MOD(KA,2).EQ.0) THEN
      FA=1.0D 1*(X(I)**2-X(I+1))
      ELSE
      FA=2.0D 0*EXP(-(X(I)-X(I+1))**2)+
     & EXP(-2.0D 0*(X(I+1)-X(I+2))**2)
      ENDIF
      RETURN
  260 I=MOD(KA,N/2)+1
      J=I+N/2
      M=5*N
      IA=KA/(M/4)+1
      B=DBLE(KA/(M/5)+1)
      C=DBLE(MOD(KA,M/4+M/5))
      FA=X(I)**IA*EXP(B*X(J))+X(J)-C
      RETURN
  270 IA=MIN(MAX(MOD(KA,13)-2,1),7)
      IB=(KA+12)/13
      I=IA+IB-1
      IF (IA.EQ.7) THEN
      J=IB
      ELSE
      J=IA+IB
      ENDIF
      C=3.0D 0*DBLE(IA)/1.0D 1
      A=0.0D 0
      DO 271 L=0,6
      IF (IB+L.NE.I.AND.IB+L.NE.J) A=A+SIN(X(IB+L))-Y(1)
  271 CONTINUE
      FA=(1.0D 0+COS(C))*(X(J)-SIN(X(I))-1.0D 0)+
     10005.0D 0*(X(I)-2.0D 0)*EXP(SIN(C*X(J)))+0.5D 0*A
      RETURN
      END
