* SUBROUTINE EAGU02             ALL SYSTEMS                 90/12/01
C PORTABILITY : ALL SYSTEMS
C 90/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  GRADIENTS OF TEST FUNCTIONS FOR NONLINEAR APPROXIMATION.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  KA  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  GA(N)  GRADIENT OF THE APPROXIMATED FUNCTION AT THE
*          SELECTED POINT.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EAGU02(N,KA,X,GA,NEXT)
      INTEGER I,J,N,KA,NEXT
      REAL*8 X(N),GA(N)
      REAL*8 A,B,C,D,U,V,W
      REAL*8 Y(65)
      COMMON /EMPR02/ Y
      GOTO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,
     &      160,170,180,190,200,210,220,230,240,250,260,270,
     &      280,290,300),NEXT
   10 GOTO(11,12),KA
   11 GA(1)=-2.0D 1*X(1)
      GA(2)=1.0D 1
      RETURN
   12 GA(1)=-1.0D 0
      GA(2)=0.0D 0
      RETURN
   20 GOTO(21,22),KA
   21 GA(1)=1.0D 0
      GA(2)=-2.0D 0+(1.0D 1-3.0D 0*X(2))*X(2)
      RETURN
   22 GA(1)=1.0D 0
      GA(2)=-1.4D 1+(3.0D 0*X(2)+2.0D 0)*X(2)
      RETURN
   30 GOTO(31,32),KA
   31 GA(1)=1.0D 4*X(2)
      GA(2)=1.0D 4*X(1)
      RETURN
   32 GA(1)=-EXP(-X(1))
      GA(2)=-EXP(-X(2))
      RETURN
   40 GOTO(41,42,43),KA
   41 GA(1)=1.0D 0
      GA(2)=0.0D 0
      RETURN
   42 GA(1)=0.0D 0
      GA(2)=1.0D 0
      RETURN
   43 GA(1)=X(2)
      GA(2)=X(1)
      RETURN
   50 GA(1)=X(2)**KA-1.0D 0
      GA(2)=KA*X(1)*X(2)**(KA-1)
      RETURN
   60 GA(1)=-KA*EXP(KA*X(1))
      GA(2)=-KA*EXP(KA*X(2))
      RETURN
   70 B=X(1)
      IF(B.EQ.0.0D 0)B=1D-5
      GOTO(71,72,73),KA
   71 A=0.5D 0/(1.0D 0+(X(2)/B)**2)/
     &  3.14159265358979323846D 0
      GA(1)=1.0D 2*A*X(2)/(B*B)
      GA(2)=-1.0D 2*A/B
      GA(3)=1.0D 1
      RETURN
   72 A=SQRT(B*B+X(2)**2)
      GA(1)=1.0D 1*B/A
      GA(2)=1.0D 1*X(2)/A
      GA(3)=0.0D 0
      RETURN
   73 GA(1)=0.0D 0
      GA(2)=0.0D 0
      GA(3)=1.0D 0
      RETURN
   80 U=KA
      V=16-KA
      W=MIN(U,V)
      A=(V*X(2)+W*X(3))**2
      GA(1)=-1.0D 0
      GA(2)=U*V/A
      GA(3)=U*W/A
      RETURN
   90 A=0.5D 0*DBLE(8-KA)-X(3)
      B=EXP(-0.5D 0*X(2)*A**2)
      GA(1)=B
      GA(2)=-0.5D 0*X(1)*B*A**2
      GA(3)=X(1)*B*X(2)*A
      RETURN
  100 A=DBLE(45+5*KA)+X(3)
      B=EXP(X(2)/A)
      GA(1)=B
      GA(2)=X(1)*B/A
      GA(3)=-X(1)*B*X(2)/A**2
      RETURN
  110 D=X(1)
      A=Y(KA)-X(2)
      W=LOG(ABS(A))
      B=ABS(A)**X(3)
      C=1.0D 3*EXP(-B/D)
      GA(3)=C*B
      GA(1)= GA(3)/(D*D)
      GA(2)= GA(3)*X(3)/(A*D)
      GA(3)=-GA(3)*W/D
      RETURN
  120 A=1.0D-1*DBLE(KA)
      GA(1)=-A*EXP(-A*X(1))
      GA(2)=A*EXP(-A*X(2))
      GA(3)=EXP(-1.0D 1*A)-EXP(-A)
      RETURN
  130 GOTO(131,132,133,134),KA
  131 GA(1)=1.0D 0
      GA(2)=1.0D 1
      GA(3)=0.0D 0
      GA(4)=0.0D 0
      RETURN
  132 GA(1)=0.0D 0
      GA(2)=0.0D 0
      GA(3)= 2.23606797749979D 0
      GA(4)=-2.23606797749979D 0
      RETURN
  133 A=X(2)-2.0D 0*X(3)
      GA(1)=0.0D 0
      GA(2)=2.0D 0*A
      GA(3)=-4.0D 0*A
      GA(4)=0.0D 0
      RETURN
  134 A=2.0D 0*(X(1)-X(4))
      GA(1)= 3.16227766016838D 0*A
      GA(2)=0.0D 0
      GA(3)=0.0D 0
      GA(4)=-3.16227766016838D 0*A
      RETURN
  140 GOTO(141,142,143,144,145,146), KA
  141 GA(1)=-2.0D 1*X(1)
      GA(2)=1.0D 1
      GA(3)=0.0D 0
      GA(4)=0.0D 0
      RETURN
  142 GA(1)=-1.0D 0
      GA(2)=0.0D 0
      GA(3)=0.0D 0
      GA(4)=0.0D 0
      RETURN
  143 GA(1)=0.0D 0
      GA(2)=0.0D 0
      GA(3)=-2.0D 0*9.486833D 0*X(3)
      GA(4)=9.486833D 0
      RETURN
  144 GA(1)=0.0D 0
      GA(2)=0.0D 0
      GA(3)=-1.0D 0
      GA(4)=0.0D 0
      RETURN
  145 GA(1)=0.0D 0
      GA(2)=3.16227766016838D 0
      GA(3)=0.0D 0
      GA(4)=3.16227766016838D 0
      RETURN
  146 GA(1)=0.0D 0
      GA(2)= 1.0D 0/3.16227766016838D 0
      GA(3)=0.0D 0
      GA(4)=-1.0D 0/3.16227766016838D 0
      RETURN
  150 A=Y(KA)*(Y(KA)+X(3))+X(4)
      B=Y(KA)*(Y(KA)+X(2))
      C=X(1)*B/A**2
      GA(1)=-B/A
      GA(2)=-Y(KA)*X(1)/A
      GA(3)=Y(KA)*C
      GA(4)=C
      RETURN
  160 W=0.2D 0*DBLE(KA)
      A=X(1)+W*X(2)-EXP(W)
      B=X(3)+SIN(W)*X(4)-COS(W)
      GA(1)=2.0D 0*A
      GA(2)=2.0D 0*W*A
      GA(3)=2.0D 0*B
      GA(4)=2.0D 0*SIN(W)*B
      RETURN
  170 W=1.0D 1*DBLE(KA-1)
      A=EXP(-W*X(4))
      B=EXP(-W*X(5))
      GA(1)=-1.0D 0
      GA(2)=-A
      GA(3)=-B
      GA(4)=X(2)*W*A
      GA(5)=X(3)*W*B
      RETURN
  180 W=0.1D 0*DBLE(KA)
      A=EXP(-W*X(1))
      B=EXP(-W*X(2))
      C=EXP(-W*X(3))
      GA(1)=-X(4)*W*A
      GA(2)=X(5)*W*B
      GA(3)=-X(6)*W*C
      GA(4)=A
      GA(5)=-B
      GA(6)=C
      RETURN
  190 W=0.1D 0*DBLE(KA-1)
      A=EXP(-W*X(5))
      B=EXP(-X(6)*(W-X(9))**2)
      C=EXP(-X(7)*(W-X(10))**2)
      D=EXP(-X(8)*(W-X(11))**2)
      GA(1)=-A
      GA(2)=-B
      GA(3)=-C
      GA(4)=-D
      GA(5)=X(1)*W*A
      GA(6)=X(2)*B*(W-X(9))**2
      GA(7)=X(3)*C*(W-X(10))**2
      GA(8)=X(4)*D*(W-X(11))**2
      GA(9)=-2.0D 0*X(2)*X(6)*B*(W-X(9))
      GA(10)=-2.0D 0*X(3)*X(7)*C*(W-X(10))
      GA(11)=-2.0D 0*X(4)*X(8)*D*(W-X(11))
      RETURN
  200 IF(KA.LT.30) THEN
      B=X(1)
      W=DBLE(KA)/2.9D 1
      DO 201 J=2,N
      B=B+X(J)*W**(J-1)
  201 CONTINUE
      B=-2.0D 0*B
      GA(1)=B
      DO 202 J=2,N
      GA(J)=DBLE(J-1)*W**(J-2)+B*W**(J-1)
  202 CONTINUE
      ELSE
      DO 203 J=1,N
      GA(J)=0.0D 0
  203 CONTINUE
      IF (KA.EQ.30) THEN
      GA(1)=1.0D 0
      ELSE
      GA(1)=-2.0D 0*X(1)
      GA(2)=1.0D 0
      ENDIF
      ENDIF
      RETURN
  210 DO 211 J=1,N
      GA(J)=0.0D 0
  211 CONTINUE
      IF(MOD(KA,2).EQ.1) THEN
      GA(KA)=-2.0D 1*X(KA)
      GA(KA+1)=1.0D 1
      ELSE
      GA(KA-1)=-1.0D 0
      ENDIF
      RETURN
  220 DO 221 J=1,N
      GA(J)=0.0D 0
  221 CONTINUE
      IF(MOD(KA,4).EQ.1) THEN
      GA(KA)=1.0D 0
      GA(KA+1)=1.0D 1
      ELSEIF(MOD(KA,4).EQ.2) THEN
      GA(KA+1)=2.23606797749979D 0
      GA(KA+2)=-GA(KA+1)
      ELSEIF(MOD(KA,4).EQ.3) THEN
      A=X(KA-1)-2.0D 0*X(KA)
      GA(KA-1)=2.0D 0*A
      GA(KA)=-4.0D 0*A
      ELSE
      A=2.0D 0*(X(KA-3)-X(KA))
      GA(KA-3)=3.16227766016838D 0*A
      GA(KA)= -3.16227766016838D 0*A
      ENDIF
      RETURN
  230 IF(KA.LE.N) THEN
      DO 231 J=1,N
      GA(J)=0.0D 0
  231 CONTINUE
      GA(KA)=1.0D 0/3.16227766016838D 0**5
      ELSE
      DO 232 J=1,N
      GA(J)=2.0D 0*X(J)
  232 CONTINUE
      ENDIF
      RETURN
  240 DO 241 J=1,N
      GA(J)=0.0D 0
  241 CONTINUE
      IF(KA.EQ.1) THEN
      GA(KA)=1.0D 0
      ELSEIF(KA.LE.N) THEN
      GA(KA)=0.1D 0*EXP(0.1D 0*X(KA))/3.16227766016838D 0**5
      GA(KA-1)=0.1D 0*EXP(0.1D 0*X(KA-1))/3.16227766016838D 0**5
      ELSEIF(KA.LT.2*N) THEN
      GA(KA+1-N)=0.1D 0*EXP(0.1D 0*X(KA+1-N))/3.16227766016838D 0**5
      ELSE
      DO 242 J=1,N
      GA(J)=2.0D 0*DBLE(N+1-J)*X(J)
  242 CONTINUE
      ENDIF
      RETURN
  250 IF(KA.LE.N) THEN
      DO 251 J=1,N
      GA(J)=0.0D 0
  251 CONTINUE
      GA(KA)=1.0D 0
      ELSEIF(KA.EQ.N+1) THEN
      DO 252 J=1,N
      GA(J)=DBLE(J)
  252 CONTINUE
      ELSE
      A=0.0D 0
      DO 253 J=1,N
      A=A+DBLE(J)*(X(J)-1.0D 0)
  253 CONTINUE
      DO 254 J=1,N
      GA(J)=2.0D 0*A*DBLE(J)
  254 CONTINUE
      ENDIF
      RETURN
  260 DO 261 J=1,N
      GA(J)=SIN(X(J))
  261 CONTINUE
      GA(KA)=GA(KA)+DBLE(KA)*SIN(X(KA))-COS(X(KA))
      RETURN
 270  DO 271 J=1,N
  271 GA(J)=1-KA/N
      IF(KA.LT.N) THEN
        GA(KA)=GA(KA)+1.0D 0
      ELSE
        A=1.0D 0
        I=0
        DO 272 J=1,N
        B=X(J)
        IF(B.EQ.0.0D 0.AND.I.EQ.0)I=J
  272   IF(I.NE.J)A=A*B
        IF(I.EQ.0) THEN
          DO 273 J=1,N
  273     GA(J)=A/X(J)
        ELSE
          GA(I)=A
        ENDIF
      ENDIF
      RETURN
  280 DO 281 J=1,N
      GA(J)=0.0D 0
  281 CONTINUE
      U=1.0D 0/DBLE(N+1)
      V=DBLE(KA)*U
      GA(KA)=2.0D 0+1.5D 0*U**2*(X(KA)+V+1.0D 0)**2
      IF(KA.GT.1) GA(KA-1)=-1.0D 0
      IF(KA.LT.N) GA(KA+1)=-1.0D 0
      RETURN
  290 U=1.0D 0/DBLE(N+1)
      V=DBLE(KA)*U
      DO 291 J=1,N
      W=DBLE(J)*U
      A=(X(J)+W+1.0D 0)**2
      IF(J.LE.KA) THEN
      GA(J)=1.5D 0*U*(1.0D 0-V)*W*A
      ELSE
      GA(J)=1.5D 0*U*(1.0D 0-W)*V*A
      ENDIF
  291 CONTINUE
      GA(KA)=GA(KA)+1.0D 0
      RETURN
  300 DO 301 J=1,N
      GA(J)=0.0D 0
  301 CONTINUE
      GA(KA)=3.0D 0-4.0D 0*X(KA)
      IF(KA.GT.1) GA(KA-1)=-1.0D 0
      IF(KA.LT.N) GA(KA+1)=-2.0D 0
      RETURN
      END
