* SUBROUTINE EAGU22             ALL SYSTEMS                 94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF TEST FUNCTIONS FOR NONLINEAR APPROXIMATION.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  KA  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  GA(N)  GRADIENT OF THE APPROXIMATED FUNCTION AT THE
*          SELECTED POINT.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EAGU22(N,KA,X,GA,NEXT)
      INTEGER N,KA,NEXT
      REAL*8 X(N),GA(N)
      INTEGER I,J,K
      REAL*8 A,B,C,P,S
      REAL*8 Y(163),PI
      COMMON /EMPR22/ Y
      PARAMETER (PI=3.14159265358979323846D 0)
      GOTO (10,10,30,30,80,50,100,190,200,60,70,90,130,150,170,120,140,
     & 160,150,110),NEXT
   10 GOTO (11,12,13),KA
   11 GA(1)=2.0D 0*X(1)+X(2)
      GA(2)=2.0D 0*X(2)+X(1)
      RETURN
   12 GA(1)=COS(X(1))
      GA(2)=0.0D 0
      RETURN
   13 GA(1)=0.0D 0
      GA(2)=SIN(X(2))
      RETURN
   30 GOTO (31,32,33),KA
   31 GA(1)=-EXP(X(1)-X(2))
      GA(2)= EXP(X(1)-X(2))
      RETURN
   32 GA(1)=COSH(X(1)-1.0D 0)
      GA(2)=0.0D 0
      RETURN
   33 GA(1)= 0.0D 0
      GA(2)=-1.0D 0/X(2)
      RETURN
   80 GO TO (81,82,83) KA
   81 A=SQRT((X(1)-X(3))**2+(X(2)-X(4))**2)
      GA(1)=-(X(1)-X(3))/A
      GA(2)=-(X(2)-X(4))/A
      GA(3)=-GA(1)
      GA(4)=-GA(2)
      GA(5)=0.0D 0
      GA(6)=0.0D 0
      RETURN
   82 A=SQRT((X(3)-X(5))**2+(X(4)-X(6))**2)
      GA(1)=0.0D 0
      GA(2)=0.0D 0
      GA(3)=-(X(3)-X(5))/A
      GA(4)=-(X(4)-X(6))/A
      GA(5)=-GA(3)
      GA(6)=-GA(4)
      RETURN
   83 A=SQRT((X(5)-X(1))**2+(X(6)-X(2))**2)
      GA(1)= (X(5)-X(1))/A
      GA(2)= (X(6)-X(2))/A
      GA(3)=0.0D 0
      GA(4)=0.0D 0
      GA(5)=-GA(1)
      GA(6)=-GA(2)
      RETURN
   50 DO 51 I=1,N
      GA(I)=-2.0D 0*Y(KA)*SIN(Y(KA)*X(I))/1.5D 1
   51 CONTINUE
      RETURN
  100 DO 189 I=1,N
      GA(I)=0.0D 0
  189 CONTINUE
      K=0
      DO 103 I=1,5
      A=0.0D 0
      P=0.0D 0
      DO 101 J=1,N
      A=A+Y(K+J)*X(J)**(1.0D 0-Y(I+80))
      P=P+Y(K+J+40)*X(J)
  101 CONTINUE
      B=Y(K+KA)/(X(KA)**Y(I+80)*A)
      DO 102 J=1,N
      C=Y(K+J)*(1.0D 0-Y(I+80))/(X(J)**Y(I+80)*A)
      GA(J)=GA(J)+B*(Y(K+J+40)-C*P)
  102 CONTINUE
      GA(KA)=GA(KA)-B*Y(I+80)*P/X(KA)
      K=K+N
  103 CONTINUE
      RETURN
  190 GA(1)=2.0D 0*X(1)+X(2)-1.4D 1
      GA(2)=2.0D 0*X(2)+X(1)-1.6D 1
      GA(3)=2.0D 0*(X(3)-1.0D 1)
      GA(4)=8.0D 0*(X(4)-5.0D 0)
      GA(5)=2.0D 0*(X(5)-3.0D 0)
      GA(6)=4.0D 0*(X(6)-1.0D 0)
      GA(7)=1.0D 1*X(7)
      GA(8)=1.4D 1*(X(8)-1.1D 1)
      GA(9)=4.0D 0*(X(9)-1.0D 1)
      GA(10)=2.0D 0*(X(10)-7.0D 0)
      GO TO (191,192,193,194,195,196),KA
  191 CONTINUE
      RETURN
  192 GA(1)=GA(1)+6.0D 1*(X(1)-2.0D 0)
      GA(2)=GA(2)+8.0D 1*(X(2)-3.0D 0)
      GA(3)=GA(3)+4.0D 1*X(3)
      GA(4)=GA(4)-7.0D 1
      RETURN
  193 GA(1)=GA(1)+1.0D 2*X(1)
      GA(2)=GA(2)+8.0D 1
      GA(3)=GA(3)+2.0D 1*(X(3)-6.0D 0)
      GA(4)=GA(4)-2.0D 1
      RETURN
  194 GA(1)=GA(1)+1.0D 1*(X(1)-8.0D 0)
      GA(2)=GA(2)+4.0D 1*(X(2)-4.0D 0)
      GA(5)=GA(5)+6.0D 1*X(5)
      GA(6)=GA(6)-1.0D 1
      RETURN
  195 GA(1)=GA(1)+2.0D 1*X(1)-2.0D 1*X(2)
      GA(2)=GA(2)+4.0D 1*(X(2)-2.0D 0)-2.0D 1*X(1)
      GA(5)=GA(5)+1.4D 2
      GA(6)=GA(6)-6.0D 1
      RETURN
  196 GA(1)=GA(1)-3.0D 1
      GA(2)=GA(2)+6.0D 1
      GA(9)=GA(9)+2.4D 2*(X(9)-8.0D 0)
      GA(10)=GA(10)-7.0D 1
      RETURN
  200 GA(1)=2.0D 0*X(1)+X(2)-1.4D 1
      GA(2)=2.0D 0*X(2)+X(1)-1.6D 1
      GA(3)=2.0D 0*(X(3)-1.0D 1)
      GA(4)=8.0D 0*(X(4)-5.0D 0)
      GA(5)=2.0D 0*(X(5)-3.0D 0)
      GA(6)=4.0D0*(X(6)-1.0D 0)
      GA(7)=1.0D 1*X(7)
      GA(8)=1.4D 1*(X(8)-1.1D 1)
      GA(9)=4.0D 0*(X(9)-1.0D 1)
      GA(10)=2.0D 0*(X(10)-7.0D0)
      GA(11)=2.0D 0*(X(11)-9.0D0)
      GA(12)=2.0D 1*(X(12)-1.0D 0)
      GA(13)=1.0D 1*(X(13)-7.0D 0)
      GA(14)=8.0D 0*(X(14)-1.4D 1)
      GA(15)=5.4D 1*(X(15)-1.0D 0)
      GA(16)=4.0D 0*X(16)**3
      GA(17)=2.0D 0*(X(17)-2.0D 0)
      GA(18)=2.6D 1*(X(18)-2.0D 0)
      GA(19)=2.0D 0*(X(19)-3.0D 0)
      GA(20)=2.0D 0*X(20)
      GO TO (191,192,193,194,195,196,202,203,204,205,206,207,208,209),KA
  202 GA(1)=GA(1)+2.0D 1*X(1)
      GA(11)=GA(11)+1.5D 2
      GA(12)=GA(12)-8.0D 1
      RETURN
  203 GA(1)=GA(1)+4.0D 1
      GA(2)=GA(2)+9.0D 1
      GA(13)=GA(13)+1.0D 2*X(13)
      GA(14)=GA(14)-9.0D 1
      RETURN
  204 GA(1)=GA(1)+3.0D 1
      GA(2)=GA(2)+4.0D 1
      GA(13)=GA(13)+6.0D 1*(X(13)-6.0D 0)
      GA(14)=GA(14)-1.4D 2
      RETURN
  205 GA(1)=GA(1)+2.8D 2*X(1)
      GA(15)=GA(15)+3.5D 2
      GA(16)=GA(16)-7.9D 2
      RETURN
  206 GA(2)=GA(2)+3.0D 2*X(2)
      GA(15)=GA(15)+1.1D 2
      GA(16)=GA(16)-6.1D 2
      RETURN
  207 GA(1)=GA(1)+1.0D 2*X(1)
      GA(2)=GA(2)+2.0D 1
      GA(17)=GA(17)+3.6D 2*X(17)**3
      GA(18)=GA(18)-1.0D 1
      RETURN
  208 GA(1)=GA(1)+2.0D 1*X(1)
      GA(2)=GA(2)-1.0D 1
      GA(19)=GA(19)+1.9D 2
      GA(20)=GA(20)-2.0D 2
      RETURN
  209 GA(1)=GA(1)+1.4D 2*X(1)
      GA(2)=GA(2)+1.0D 2*X(2)
      GA(19)=GA(19)+2.0D 1*X(19)
      GA(20)=GA(20)-3.0D 2
      RETURN
   60 DO 61 I=1,N
      GA(I)=1.0D 0
   61 CONTINUE
      IF (MOD(KA,2).EQ.0) THEN
      I=(KA+2)/2
      GA(I)=GA(I)+2.0D 0*X(I)-1.0D 0
      ELSE
      I=(KA+1)/2
      GA(I)=GA(I)+4.0D 0*X(I)-1.0D 0
      ENDIF
      RETURN
   70 K=(N-1)/2
      A=Y(KA)**2
      S=1.0D 0
      IF (KA.GT.62.AND.KA.LT.124) S=-S
      DO 71 I=1,K
      B=X(I+K)**2-A
      P=S*(B*B+A*X(I)**2)
      GA(I)=A*X(I)/P
      GA(I+K)=2.0D 0*X(I+K)*B/P
   71 CONTINUE
      GA(N)=-S
      RETURN
   90 P=5.0D 2
      A=0.99D 0
      GA(1)= 5.04D 0
      GA(2)= 0.35D-1
      GA(3)= 1.00D 1
      GA(4)=-0.63D-1*X(7)
      GA(5)= 3.36D 0
      GA(6)= 0.00D 0
      GA(7)=-0.63D-1*X(4)
      GA(8)= 0.00D 0
      GA(9)= 0.00D 0
      GA(10)=0.00D 0
      GO TO (91,92,93,94,95,96,97,98,99),KA
   91 CONTINUE
      RETURN
   92 GA(1)=GA(1)+P*(1.12D 0+X(8)*(1.3167D-1-6.67D-3*X(8)))
      GA(4)=GA(4)-P/A
      GA(8)=GA(8)+P*X(1)*(1.3167D-1-1.334D-2*X(8))
      RETURN
   93 GA(1)=GA(1)-P*(1.12D 0+X(8)*(1.3167D-1-6.67D-3*X(8)))
      GA(4)=GA(4)+P*A
      GA(8)=GA(8)-P*X(1)*(1.3167D-1-1.334D-2*X(8))
      RETURN
   94 GA(6)=GA(6)+P*0.325D 0
      GA(7)=GA(7)-P/A
      GA(8)=GA(8)+P*(1.098D 0-0.076D 0*X(8))
      RETURN
   95 GA(6)=GA(6)-P*0.325D 0
      GA(7)=GA(7)+P*A
      GA(8)=GA(8)-P*(1.098D 0-0.076D 0*X(8))
      RETURN
   96 C=(X(4)*X(9)+1.0D 3*X(3))**2
      GA(3)=GA(3)+9.8D 4*P*X(4)*X(9)/C
      GA(4)=GA(4)-9.8D 4*P*X(3)*X(9)/C
      GA(6)=GA(6)-P
      GA(9)=GA(9)-9.8D 4*P*X(3)*X(4)/C
      RETURN
   97 C=(X(4)*X(9)+1.0D 3*X(3))**2
      GA(3)=GA(3)-9.8D 4*P*X(4)*X(9)/C
      GA(4)=GA(4)+9.8D 4*P*X(3)*X(9)/C
      GA(6)=GA(6)+P
      GA(9)=GA(9)+9.8D 4*P*X(3)*X(4)/C
      RETURN
   98 GA(1)=GA(1)-P*(X(2)+X(5))/X(1)**2
      GA(2)=GA(2)+P/X(1)
      GA(5)=GA(5)+P/X(1)
      GA(8)=GA(8)-P
      RETURN
   99 GA(1)=GA(1)+P*(X(2)+X(5))/X(1)**2
      GA(2)=GA(2)-P/X(1)
      GA(5)=GA(5)-P/X(1)
      GA(8)=GA(8)+P
      RETURN
  130 P=1.0D 5
      GA(1)=Y(1)+Y(2)*X(6)
      GA(2)=Y(4)
      GA(3)=Y(3)+Y(6)*X(5)
      GA(4)=0.0D 0
      GA(5)=Y(6)*X(3)
      GA(6)=Y(2)*X(1)
      GA(7)=0.0D 0
      GO TO (131,132,133,134,135,136,137,138,105,106,107,108,109),KA
  131 CONTINUE
      RETURN
  132 GA(1)=GA(1)-P*Y(8)*X(3)/X(1)**2
      GA(3)=GA(3)+P*Y(8)/X(1)
      GA(6)=GA(6)+P*(2.0D 0*Y(7)*X(6)+Y(9))
      RETURN
  133 GA(1)=GA(1)+P*(Y(10)+Y(11)*X(6)+Y(12)*X(6)**2)/X(3)
      GA(3)=GA(3)-P*(Y(10)+Y(11)*X(6)+Y(12)*X(6)**2)*X(1)/X(3)**2
      GA(6)=GA(6)+P*(Y(11)+2.0D 0*Y(12)*X(6))*X(1)/X(3)
      RETURN
  134 GA(4)=GA(4)+P*Y(15)
      GA(5)=GA(5)+P*Y(14)
      GA(6)=GA(6)+P*(2.0D 0*Y(13)*X(6)+Y(16))
      RETURN
  135 GA(4)=GA(4)+P*Y(19)/X(5)
      GA(5)=GA(5)-P*(Y(17)+Y(18)*X(6)+Y(19)*X(4)+Y(20)*X(6)**2)/X(5)**2
      GA(6)=GA(6)+P*(Y(18)+2.0D 0*Y(20)*X(6))/X(5)
      RETURN
  136 GA(2)=GA(2)+P*(Y(22)/X(4)+Y(23))/X(3)
      GA(3)=GA(3)-P*(Y(22)/X(4)+Y(23))*X(2)/X(3)**2
      GA(4)=GA(4)-P*Y(22)*X(2)/(X(3)*X(4)**2)
      GA(7)=GA(7)+P*Y(21)
      RETURN
  137 GA(2)=GA(2)+P*(Y(25)+Y(26)/X(4))/(X(3)*X(7))
      GA(3)=GA(3)-P*(Y(25)+Y(26)/X(4))*X(2)/(X(3)**2*X(7))
      GA(4)=GA(4)-P*Y(26)*X(2)/(X(3)*X(4)**2*X(7))
      GA(7)=GA(7)-P*(Y(24)+(Y(25)+Y(26)/X(4))*X(2)/X(3))/X(7)**2
      RETURN
  138 GA(5)=GA(5)-P*(Y(27)+Y(28)*X(7))/X(5)**2
      GA(7)=GA(7)+P*Y(28)/X(5)
      RETURN
  105 GA(1)=GA(1)+P*Y(33)/X(3)
      GA(3)=GA(3)-P*(Y(33)*X(1)+Y(34))/X(3)**2
      RETURN
  106 GA(2)=GA(2)+P*(Y(35)/X(4)+Y(36))/X(3)
      GA(3)=GA(3)-P*(Y(35)/X(4)+Y(36))*X(2)/X(3)**2
      GA(4)=GA(4)-P*Y(35)*X(2)/(X(3)*X(4)**2)
      RETURN
  107 GA(2)=GA(2)-P*Y(38)*X(3)*X(4)/X(2)**2
      GA(3)=GA(3)+P*Y(38)*X(4)/X(2)
      GA(4)=GA(4)+P*(Y(37)+Y(38)*X(3)/X(2))
      RETURN
  108 GA(1)=GA(1)+P*(Y(39)*X(6)+Y(40))
      GA(3)=GA(3)+P*Y(41)
      GA(6)=GA(6)+P*Y(39)*X(1)
      RETURN
  109 GA(1)=GA(1)-P*(Y(42)*X(3)+Y(43))/X(1)**2
      GA(3)=GA(3)+P*Y(42)/X(1)
      GA(6)=GA(6)+P*Y(44)
      RETURN
  150 P=1.0D 5
      GA(1)=1.0D 0
      GA(2)=1.0D 0
      GA(3)=1.0D 0
      GA(4)=0.0D 0
      GA(5)=0.0D 0
      GA(6)=0.0D 0
      GA(7)=0.0D 0
      GA(8)=0.0D 0
      GO TO (151,152,153,154),KA
  151 CONTINUE
      RETURN
  152 GA(1)=GA(1)-P*(833.33252D 0*X(4)-83333.333D 0)/(X(1)**2*X(6))
      GA(4)=GA(4)+P*833.33252D 0/(X(1)*X(6))
      GA(6)=GA(6)-P*(833.33252D 0*X(4)/X(1)+1.0D 2-
     & 83333.333D 0/X(1))/X(6)**2
      RETURN
  153 GA(2)=GA(2)-P*1.25D 3*(X(5)-X(4))/(X(2)**2*X(7))
      GA(4)=GA(4)+P*(1.0D 0-1.25D 3/X(2))/X(7)
      GA(5)=GA(5)+P*1.25D 3/(X(2)*X(7))
      GA(7)=GA(7)-P*(1.25D 3*(X(5)-X(4))/X(2)+X(4))/X(7)**2
      RETURN
  154 GA(3)=GA(3)-P*(1.25D 6-2.5D 3*X(5))/(X(3)**2*X(8))
      GA(5)=GA(5)+P*(1.0D 0-2.5D 3/X(3))/X(8)
      GA(8)=GA(8)-P*((1.25D 6-2.5D 3*X(5))/X(3)+X(5))/X(8)**2
      RETURN
  170 P=1.0D 3
      GA(1)=-1.231060D 0*X(12)
      GA(2)=-1.231060D 0*X(13)
      GA(3)=-1.231060D 0*X(14)
      GA(4)=-1.231060D 0*X(15)
      GA(5)=-1.231060D 0*X(16)
      GA(6)= 0.0D 0
      GA(7)= 0.0D 0
      GA(8)= 0.0D 0
      GA(9)= 0.0D 0
      GA(10)=0.0D 0
      GA(11)=0.0D 0
      GA(12)=1.262626D 0-1.231060D 0*X(1)
      GA(13)=1.262626D 0-1.231060D 0*X(2)
      GA(14)=1.262626D 0-1.231060D 0*X(3)
      GA(15)=1.262626D 0-1.231060D 0*X(4)
      GA(16)=1.262626D 0-1.231060D 0*X(5)
      GO TO (171,172,173,174,175,176,177,178,179,116,117,118,128,
     & 129,146,147,148,149,159),KA
  171 CONTINUE
      RETURN
  172 GA(1)=GA(1)+P*(9.75D-1+(3.475D-2-1.95D-2*X(1))/X(6))
      GA(6)=GA(6)-P*X(1)*(3.475D-2-9.75D-3*X(1))/X(6)**2
      RETURN
  173 GA(2)=GA(2)+P*(9.75D-1+(3.475D-2-1.95D-2*X(2))/X(7))
      GA(7)=GA(7)-P*X(2)*(3.475D-2-9.75D-3*X(2))/X(7)**2
      RETURN
  174 GA(3)=GA(3)+P*(9.75D-1+(3.475D-2-1.95D-2*X(3))/X(8))
      GA(8)=GA(8)-P*X(3)*(3.475D-2-9.75D-3*X(3))/X(8)**2
      RETURN
  175 GA(4)=GA(4)+P*(9.75D-1+(3.475D-2-1.95D-2*X(4))/X(9))
      GA(9)=GA(9)-P*X(4)*(3.475D-2-9.75D-3*X(4))/X(9)**2
      RETURN
  176 GA(5)=GA(5)+P*(9.75D-1+(3.475D-2-1.95D-2*X(5))/X(10))
      GA(10)=GA(10)-P*X(5)*(3.475D-2-9.75D-3*X(5))/X(10)**2
      RETURN
  177 GA(1)=GA(1)+P*X(12)/(X(7)*X(11))
      GA(6)=GA(6)+P*(1.0D 0-X(12)/X(11))/X(7)
      GA(7)=GA(7)-P*(X(6)+(X(1)-X(6))*X(12)/X(11))/X(7)**2
      GA(11)=GA(11)-P*(X(1)-X(6))*X(12)/(X(7)*X(11)**2)
      GA(12)=GA(12)+P*(X(1)-X(6))/(X(11)*X(7))
      RETURN
  178 GA(1)=GA(1)-P*2.0D-3*X(12)/X(8)
      GA(2)=GA(2)+P*2.0D-3*X(13)/X(8)
      GA(7)=GA(7)+P*(1.0D 0+2.0D-3*X(12))/X(8)
      GA(8)=GA(8)-P*(X(7)+2.0D-3*((X(7)-X(1))*X(12)+
     & X(2)*X(13)))/X(8)**2
      GA(12)=GA(12)+P*2.0D-3*(X(7)-X(1))/X(8)
      GA(13)=GA(13)+P*2.0D-3*(X(2)/X(8)-1.0D 0)
      RETURN
  179 GA(2)=GA(2)-P*2.0D-3*X(13)
      GA(3)=GA(3)+P*2.0D-3*X(14)
      GA(8)=GA(8)+P*(1.0D 0+2.0D-3*X(13))
      GA(9)=GA(9)+P*(1.0D 0-2.0D-3*X(14))
      GA(13)=GA(13)+P*2.0D-3*(X(8)-X(2))
      GA(14)=GA(14)+P*2.0D-3*(X(3)-X(9))
      RETURN
  116 GA(3)=GA(3)-P*(X(9)+((X(4)-X(8))*X(15)+
     & 5.0D 2*(X(10)-X(9)))/X(14))/X(3)**2
      GA(4)=GA(4)+P*X(15)/(X(3)*X(14))
      GA(8)=GA(8)-P*X(15)/(X(3)*X(14))
      GA(9)=GA(9)+P*(1.0D 0-5.0D 2/X(14))/X(3)
      GA(10)=GA(10)+P*5.0D 2/(X(3)*X(14))
      GA(14)=GA(14)-P*((X(4)-X(8))*X(15)+
     & 5.0D 2*(X(10)-X(9)))/(X(3)*X(14)**2)
      GA(15)=GA(15)+P*(X(4)-X(8))/(X(3)*X(14))
      RETURN
  117 GA(4)=GA(4)-P*(X(10)+(X(5)*X(16)-5.0D 2*X(10))/X(15))/X(4)**2
      GA(5)=GA(5)+P*X(16)/(X(4)*X(15))
      GA(10)=GA(10)+P*(1.0D 0-5.0D 2/X(15))/X(4)
      GA(15)=GA(15)-P*(5.0D 2-X(16)+(X(5)*X(16)-
     & 5.0D 2*X(10))/X(4))/X(15)**2
      GA(16)=GA(16)+P*(X(5)/X(4)-1.0D 0)/X(15)
      RETURN
  118 GA(4)=GA(4)-P*(9.0D-1-2.0D-3*X(5)*X(16))/X(4)**2
      GA(5)=GA(5)-P*2.0D-3*X(16)/X(4)
      GA(16)=GA(16)+P*2.0D-3*(1.0D 0-X(5)/X(4))
      RETURN
  128 GA(11)=GA(11)-P*X(12)/X(11)**2
      GA(12)=GA(12)+P/X(11)
      RETURN
  129 GA(4)=GA(4)+P/X(5)
      GA(5)=GA(5)-P*X(4)/X(5)**2
      RETURN
  146 GA(3)=GA(3)+P/X(4)
      GA(4)=GA(4)-P*X(3)/X(4)**2
      RETURN
  147 GA(2)=GA(2)+P/X(3)
      GA(3)=GA(3)-P*X(2)/X(3)**2
      RETURN
  148 GA(1)=GA(1)+P/X(2)
      GA(2)=GA(2)-P*X(1)/X(2)**2
      RETURN
  149 GA(9)=GA(9)+P/X(10)
      GA(10)=GA(10)-P*X(9)/X(10)**2
      RETURN
  159 GA(8)=GA(8)+P/X(9)
      GA(9)=GA(9)-P*X(8)/X(9)**2
      RETURN
  120 P=1.0D 4
      GA(1)=Y(2)*X(5)+Y(3)
      GA(2)=0.0D 0
      GA(3)=2.0D 0*Y(1)*X(3)
      GA(4)=0.0D 0
      GA(5)=Y(2)*X(1)
      GO TO (121,122,123,124,125,126,127),KA
  121 CONTINUE
      RETURN
  122 GA(1)=GA(1)+P*Y(7)*X(4)
      GA(2)=GA(2)+P*Y(6)*X(5)
      GA(3)=GA(3)+P*Y(5)*X(5)
      GA(4)=GA(4)+P*Y(7)*X(1)
      GA(5)=GA(5)+P*(Y(5)*X(3)+Y(6)*X(2))
      RETURN
  123 GA(1)=GA(1)+P*Y(9)*X(4)
      GA(2)=GA(2)+P*Y(8)*X(5)
      GA(3)=GA(3)+P*Y(10)*X(5)
      GA(4)=GA(4)+P*Y(9)*X(1)
      GA(5)=GA(5)+P*(Y(8)*X(2)+Y(10)*X(3))
      RETURN
  124 GA(1)=GA(1)+P*Y(12)/X(5)
      GA(2)=GA(2)-P*(Y(11)+Y(13)*X(3)**2)/(X(5)*X(2)**2)
      GA(3)=GA(3)+P*2.0D 0*Y(13)*X(3)/(X(2)*X(5))
      GA(5)=GA(5)-P*(Y(12)*X(1)+(Y(11)+Y(13)*X(3)**2)/X(2))/X(5)**2
      RETURN
  125 GA(1)=GA(1)+P*Y(15)*X(2)
      GA(2)=GA(2)+P*(Y(14)*X(5)+Y(15)*X(1))
      GA(3)=GA(3)+P*2.0D 0*Y(16)*X(3)
      GA(5)=GA(5)+P*Y(14)*X(2)
      RETURN
  126 GA(1)=GA(1)+P*Y(18)/X(5)
      GA(3)=GA(3)-P*Y(17)/(X(5)*X(3)**2)
      GA(4)=GA(4)+P*Y(19)/X(5)
      GA(5)=GA(5)-P*(Y(17)/X(3)+Y(18)*X(1)+Y(19)*X(4))/X(5)**2
      RETURN
  127 GA(1)=GA(1)+P*Y(21)*X(3)
      GA(3)=GA(3)+P*(Y(20)*X(5)+Y(21)*X(1)+Y(22)*X(4))
      GA(4)=GA(4)+P*Y(22)*X(3)
      GA(5)=GA(5)+P*Y(20)*X(3)
      RETURN
  140 P=1.0D 2
      S=6.7D-1
      A=0.0588D 0
      GA(1)= 4.0D-1*S*(X(1)/X(7))**S/X(1)-1.0D 0
      GA(2)= 4.0D-1*S*(X(2)/X(8))**S/X(2)-1.0D 0
      GA(3)= 0.0D 0
      GA(4)= 0.0D 0
      GA(5)= 0.0D 0
      GA(6)= 0.0D 0
      GA(7)=-4.0D-1*S*(X(1)/X(7))**S/X(7)
      GA(8)=-4.0D-1*S*(X(2)/X(8))**S/X(8)
      GO TO (141,142,143,144,145),KA
  141 CONTINUE
      RETURN
  142 GA(1)=GA(1)+P*1.0D-1
      GA(5)=GA(5)+P*A*X(7)
      GA(7)=GA(7)+P*A*X(5)
      RETURN
  143 GA(1)=GA(1)+P*1.0D-1
      GA(2)=GA(2)+P*1.0D-1
      GA(6)=GA(6)+P*A*X(8)
      GA(8)=GA(8)+P*A*X(6)
      RETURN
  144 GA(3)=GA(3)+P*((4.0D 0-1.42D 0/X(3)**1.71D 0)/X(5)-
     & 1.3D 0*A*X(7)/X(3)**2.3D 0)
      GA(5)=GA(5)-P*(4.0D 0*X(3)+2.0D 0/X(3)**0.71D 0)/X(5)**2
      GA(7)=GA(7)+P*A/X(3)**1.3D 0
      RETURN
  145 GA(4)=GA(4)+P*((4.0D 0-1.42D 0/X(4)**1.71D 0)/X(6)-
     & 1.3D 0*A*X(8)/X(4)**2.3D 0)
      GA(6)=GA(6)-P*(4.0D 0*X(4)+2.0D 0/X(4)**0.71D 0)/X(6)**2
      GA(8)=GA(8)+P*A/X(4)**1.3D 0
      RETURN
  160 P=1.0D 4
      DO 188 I=1,N
      GA(I)=0.0D 0
  188 CONTINUE
      GA(11)=1.0D 0
      GA(12)=1.0D 0
      GA(13)=1.0D 0
      GO TO (161,162,163,164,165,166,167,168,169,84,85,86,87),KA
  161 CONTINUE
      RETURN
  162 GA(1)=GA(1)-P*1.231059D 0*X(8)/X(11)
      GA(8)=GA(8)+P*(1.262626D 0-1.231059D 0*X(1))/X(11)
      GA(11)=GA(11)-P*(1.262626D 0-1.231059D 0*X(1))*X(8)/X(11)**2
      RETURN
  163 GA(2)=GA(2)-P*1.231059D 0*X(9)/X(12)
      GA(9)=GA(9)+P*(1.262626D 0-1.231059D 0*X(2))/X(12)
      GA(12)=GA(12)-P*(1.262626D 0-1.231059D 0*X(2))*X(9)/X(12)**2
      RETURN
  164 GA(3)=GA(3)-P*1.231059D 0*X(10)/X(13)
      GA(10)=GA(10)+P*(1.262626D 0-1.231059D 0*X(3))/X(13)
      GA(13)=GA(13)-P*(1.262626D 0-1.231059D 0*X(3))*X(10)/X(13)**2
      RETURN
  165 GA(1)=GA(1)+P*(9.75D-1+(3.475D-2-1.95D-2*X(1))/X(4))
      GA(4)=GA(4)-P*X(1)*(3.475D-2-9.75D-3*X(1))/X(4)**2
      RETURN
  166 GA(2)=GA(2)+P*(9.75D-1+(3.475D-2-1.95D-2*X(2))/X(5))
      GA(5)=GA(5)-P*X(2)*(3.475D-2-9.75D-3*X(2))/X(5)**2
      RETURN
  167 GA(3)=GA(3)+P*(9.75D-1+(3.475D-2-1.95D-2*X(3))/X(6))
      GA(6)=GA(6)-P*X(3)*(3.475D-2-9.75D-3*X(3))/X(6)**2
      RETURN
  168 GA(1)=GA(1)+P*X(8)/(X(5)*X(7))
      GA(4)=GA(4)+P*(1.0D 0-X(8)/X(7))/X(5)
      GA(5)=GA(5)-P*(X(4)+(X(1)-X(4))*X(8)/X(7))/X(5)**2
      GA(7)=GA(7)-P*(X(1)-X(4))*X(8)/(X(5)*X(7)**2)
      GA(8)=GA(8)+P*(X(1)-X(4))/(X(7)*X(5))
      RETURN
  169 GA(1)=GA(1)-P*2.0D-3*X(8)
      GA(2)=GA(2)+P*2.0D-3*X(9)
      GA(5)=GA(5)+P*(1.0D 0+2.0D-3*X(8))
      GA(6)=GA(6)+P*(1.0D 0-2.0D-3*X(9))
      GA(8)=GA(8)+P*2.0D-3*(X(5)-X(1))
      GA(9)=GA(9)+P*2.0D-3*(X(2)-X(6))
      RETURN
   84 GA(2)=GA(2)-P*(X(6)+(X(3)*X(10)-5.0D 2*X(6))/X(9))/X(2)**2
      GA(3)=GA(3)+P*X(10)/(X(2)*X(9))
      GA(6)=GA(6)+P*(1.0D 0-5.0D 2/X(9))/X(2)
      GA(9)=GA(9)-P*(5.0D 2-X(10)+(X(3)*X(10)-
     & 5.0D 2*X(6))/X(2))/X(9)**2
      GA(10)=GA(10)+P*(X(3)/X(2)-1.0D 0)/X(9)
      RETURN
   85 GA(2)=GA(2)-P*(9.0D-1-2.0D-3*X(3)*X(10))/X(2)**2
      GA(3)=GA(3)-P*2.0D-3*X(10)/X(2)
      GA(10)=GA(10)+P*2.0D-3*(1.0D 0-X(3)/X(2))
      RETURN
   86 GA(2)=GA(2)+P/X(3)
      GA(3)=GA(3)-P*X(2)/X(3)**2
      RETURN
   87 GA(1)=GA(1)+P/X(2)
      GA(2)=GA(2)-P*X(1)/X(2)**2
      RETURN
  110 P=1.0D 4
      A=1.0D 5
      DO 111 I=1,11
      A=A*X(I)**Y(30+I)
  111 CONTINUE
      DO 187 I=1,11
      GA(I)=Y(30+I)*A/X(I)
  187 CONTINUE
      GA(12)=0.0D 0
      GO TO (112,113,114,115),KA
  112 CONTINUE
      RETURN
  113 GA(1)=GA(1)+P*Y(1)
      GA(2)=GA(2)+P*Y(2)
      GA(3)=GA(3)+P*Y(3)
      GA(4)=GA(4)+P*Y(4)*X(5)
      GA(5)=GA(5)+P*Y(4)*X(4)
      RETURN
  114 GA(1)=GA(1)+P*Y(5)
      GA(2)=GA(2)+P*(Y(6)+(Y(13)+Y(15)/(X(4)*X(12)))*X(5)/X(12)+
     & Y(14)*X(4)*X(5))
      GA(3)=GA(3)+P*Y(7)
      GA(4)=GA(4)+P*(Y(8)*X(12)+Y(12)*X(5)+Y(14)*X(2)*X(5)-
     & Y(15)*X(2)*X(5)/(X(4)*X(12))**2)
      GA(5)=GA(5)+P*(Y(9)/X(12)+(Y(12)+Y(14)*X(2))*X(4)+
     & (Y(13)+Y(15)/(X(4)*X(12)))*X(2)/X(12))
      GA(6)=GA(6)+P*Y(10)/X(12)
      GA(7)=GA(7)+P*Y(11)*X(12)
      GA(10)=GA(10)+P*Y(16)/X(12)
      GA(12)=GA(12)+P*(Y(8)*X(4)+Y(11)*X(7)-(Y(9)*X(5)+Y(10)*X(6)+
     & (Y(13)+2.0D 0*Y(15)/(X(4)*X(12)))*X(2)*X(5)+
     & Y(16)*X(10))/X(12)**2)
      RETURN
  115 GA(1)=GA(1)+P*(Y(17)+Y(29)*X(9))
      GA(2)=GA(2)+P*(Y(18)+X(5)*(Y(25)+Y(26)*X(4)+Y(27)/X(4)))
      GA(3)=GA(3)+P*Y(19)
      GA(4)=GA(4)+P*(Y(20)+X(5)*(Y(24)+Y(26)*X(2))-
     & Y(27)*X(2)*X(5)/X(4)**2)
      GA(5)=GA(5)+P*(Y(21)+Y(24)*X(4)+X(2)*(Y(25)+Y(26)*X(4)+
     & Y(27)/X(4)))
      GA(6)=GA(6)+P*Y(22)
      GA(8)=GA(8)+P*Y(23)
      GA(9)=GA(9)+P*(Y(28)+Y(29)*X(1))
      GA(11)=GA(11)+P*Y(30)
      RETURN
      END
