* SUBROUTINE EAGU25                ALL SYSTEMS                99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF MODEL FUNCTIONS FOR UNCONSTRAINED MINIMIZATION.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  G(N)  GRADIENT OF THE MODEL FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EAGU25(N,IA,JA,KA,X,GA,NEXT)
      INTEGER N,IA(*),JA(*),KA,NEXT
      REAL*8 X(N),GA(N)
      REAL*8 A,FA
      INTEGER IND(100)
      COMMON /INDEX/ IND
      IF (NEXT.LE.22) THEN
      CALL EAGU14(N,KA,X,GA,NEXT)
      ELSE IF (NEXT.EQ.23) THEN
      IF (MOD(KA,2).EQ.1) THEN
      FA=1.0D 1*(X(KA+1)-X(KA)**2)
      GA(KA)=-2.0D 1*X(KA)*FA
      GA(KA+1)=1.0D 1*FA
      ELSE
      FA=1.0D 0-X(KA-1)
      GA(KA-1)=-FA
      ENDIF
      ELSE IF (NEXT.EQ.24) THEN
      IF (MOD(KA,4).EQ.1) THEN
      FA=X(KA)+1.0D 1*X(KA+1)
      GA(KA)=FA
      GA(KA+1)=1.0D 1*FA
      ELSE IF (MOD(KA,4).EQ.2) THEN
      FA=2.23606797749979D 0*(X(KA+1)-X(KA+2))
      GA(KA+1)=2.23606797749979D 0*FA
      GA(KA+2)=-2.23606797749979D 0*FA
      ELSE IF (MOD(KA,4).EQ.3) THEN
      A=X(KA-1)-2.0D 0*X(KA)
      FA=A**2
      GA(KA-1)=2.0D 0*A*FA
      GA(KA)=-4.0D 0*A*FA
      ELSE
      FA=3.16227766016838D 0*(X(KA-3)-X(KA))**2
      A=2.0D 0*(X(KA-3)-X(KA))
      GA(KA-3)=3.16227766016838D 0*A*FA
      GA(KA)=-3.16227766016838D 0*A*FA
      ENDIF
      ELSE IF (NEXT.EQ.25) THEN
      FA=(3.0D 0-2.0D 0*X(KA))*X(KA)+1.0D 0
      IF (KA.GT.1) FA=FA-X(KA-1)
      IF (KA.LT.N) FA=FA-2.0D 0*X(KA+1)
      GA(KA)=(3.0D 0-4.0D 0*X(KA))*FA
      IF (KA.GT.1) GA(KA-1)=-FA
      IF (KA.LT.N) GA(KA+1)=-2.0D 0*FA
      ELSE IF (NEXT.EQ.26) THEN
      IF (KA.EQ.1) THEN
      FA=1.0D 0-X(1)
      GA(1)=-FA
      ELSE
      FA=10.0D 0*DBLE(KA-1)*(X(KA)-X(KA-1))**2
      GA(KA)=20.0D 0*DBLE(KA-1)*(X(KA)-X(KA-1))*FA
      GA(KA-1)=-20.0D 0*DBLE(KA-1)*(X(KA)-X(KA-1))*FA
      ENDIF
      ELSE IF (NEXT.LE.44) THEN
      CALL EAFU15(N,KA,X,FA,NEXT-22)
      CALL EAGU15(N,KA,X,GA,NEXT-22)
      CALL UXWSCL(IA(KA+1)-IA(KA),N,JA(IA(KA)),FA,GA,GA,1)
      ELSE IF (NEXT.LE.82) THEN
      CALL EAFU18(N,KA,X,FA,IND(NEXT)-44)
      CALL EAGU18(N,KA,X,GA,IND(NEXT)-44)
      CALL UXWSCL(IA(KA+1)-IA(KA),N,JA(IA(KA)),FA,GA,GA,1)
      ENDIF
      RETURN
      END
