* SUBROUTINE ECFU20             ALL SYSTEMS                 94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF TEST FUNCTIONS FOR NONLINEAR EQUATIONS.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  KA  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  FC  VALUE OF THE APPROXIMATED FUNCTION AT THE
*          SELECTED POINT.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE ECFU20(N,KC,X,FC,NEXT)
      INTEGER I,N,K,KC,NEXT
      REAL*8 X(N),FC
      REAL*8 U,V
      GOTO (40,60,45,70,80,50,85,180,90,200,110,120,130,140,150,160,
     & 170,170,100),NEXT
   40 K=KC+1
      FC=3.0D 0*X(K)**3+2.0D 0*X(K+1)-5.0D 0+
     & SIN(X(K)-X(K+1))*SIN(X(K)+X(K+1))+4.0D 0*X(K)-
     & X(K-1)*EXP(X(K-1)-X(K))-3.0D 0
      RETURN
   45 IF (KC.EQ.1) THEN
      K=1
      FC=3.0D 0*X(K)**3+2.0D 0*X(K+1)-5.0D 0+
     & SIN(X(K)-X(K+1))*SIN(X(K)+X(K+1))
      ELSE
      K=N
      FC=4.0D 0*X(K)-X(K-1)*EXP(X(K-1)-X(K))-3.0D 0
      ENDIF
      RETURN
   50 K=2*KC
      FC=4.0D 0*X(K)-(X(K-1)-X(K+1))*EXP(X(K-1)-X(K)-X(K+1))-
     & 3.0D 0
      RETURN
   60 K=KC+5
      FC=(2.0D 0+5.0D 0*X(K)**2)*X(K)+1.0D 0
      DO 61 I=K-5,K+1
      FC=FC+X(I)*(1.0D 0+X(I))
   61 CONTINUE
      RETURN
   70 K=KC+1
      FC=8.0D 0*X(K)*(X(K)**2-X(K-1))-2.0D 0*(1.0D 0-X(K))+
     & 4.0D 0*(X(K)-X(K+1)**2)
      RETURN
   80 K=KC+2
      FC=8.0D 0*X(K)*(X(K)**2-X(K-1))-2.0D 0*(1.0D 0-X(K))+
     & 4.0D 0*(X(K)-X(K+1)**2)+X(K-1)**2-X(K-2)+X(K+1)-
     & X(K+2)**2
      RETURN
   85 IF (KC.EQ.1) THEN
      K=1
      FC=4.0D 0*(X(K)-X(K+1)**2)+X(K+1)-X(K+2)**2
      ELSEIF (KC.EQ.2) THEN
      K=2
      FC=8.0D 0*X(K)*(X(K)**2-X(K-1))-2.0D 0*(1.0D 0-X(K))+
     & 4.0D 0*(X(K)-X(K+1)**2)+X(K+1)-X(K+2)**2
      ELSEIF (KC.EQ.3) THEN
      K=N-1
      FC=8.0D 0*X(K)*(X(K)**2-X(K-1))-2.0D 0*(1.0D 0-X(K))+
     & 4.0D 0*(X(K)-X(K+1)**2)+X(K-1)**2-X(K-2)
      ELSE
      K=N
      FC=8.0D 0*X(K)*(X(K)**2-X(K-1))-2.0D 0*(1.0D 0-X(K))
     & +X(K-1)**2-X(K-2)
      ENDIF
      RETURN
   90 IF (KC.EQ.1) THEN
      K=1
      FC=4.0D 0*(X(K)-X(K+1)**2)+X(K+1)-X(K+2)**2+
     & X(K+2)-X(K+3)**2
      ELSEIF (KC.EQ.2) THEN
      K=2
      FC=8.0D 0*X(K)*(X(K)**2-X(K-1))-2.0D 0*(1.0D 0-X(K))+
     & 4.0D 0*(X(K)-X(K+1)**2)+X(K-1)**2+X(K+1)-X(K+2)**2+
     & X(K+2)-X(K+3)**2
      ELSEIF (KC.EQ.3) THEN
      K=3
      FC=8.0D 0*X(K)*(X(K)**2-X(K-1))-2.0D 0*(1.0D 0-X(K))+
     & 4.0D 0*(X(K)-X(K+1)**2)+X(K-1)**2-X(K-2)+
     & X(K+1)-X(K+2)**2+X(K-2)**2+X(K+2)-X(K+3)**2
      ELSEIF (KC.EQ.4) THEN
      K=N-2
      FC=8.0D 0*X(K)*(X(K)**2-X(K-1))-2.0D 0*(1.0D 0-X(K))+
     & 4.0D 0*(X(K)-X(K+1)**2)+X(K-1)**2-X(K-2)+
     & X(K+1)-X(K+2)**2+X(K-2)**2-X(K-3)+X(K+2)
      ELSEIF (KC.EQ.5) THEN
      K=N-1
      FC=8.0D 0*X(K)*(X(K)**2-X(K-1))-2.0D 0*(1.0D 0-X(K))+
     & 4.0D 0*(X(K)-X(K+1)**2)+X(K-1)**2-X(K-2)+
     & X(K+1)+X(K-2)**2-X(K-3)
      ELSE
      K=N
      FC=8.0D 0*X(K)*(X(K)**2-X(K-1))-2.0D 0*(1.0D 0-X(K))
     & +X(K-1)**2-X(K-2)+X(K-2)**2-X(K-3)
      ENDIF
      RETURN
  180 U=1.0D 0/DBLE(N+1)
      K=KC+1
      V=DBLE(K)*U
      FC=2.0D 0*X(K)+0.5D 0*U*U*(X(K)+V+1.0D 0)**3-X(K-1)-X(K+1)
      RETURN
  200 K=KC+1
      FC=(3.0D 0-2.0D 0*X(K))*X(K)+1.0D 0-X(K-1)-2.0D 0*X(K+1)
      RETURN
  110 K=(KC-1)/2*3
      IF (MOD(KC,2).EQ.1) THEN
      FC=X(K+1)**2*X(K+4)+SIN(X(K+4)-X(K+5))-1.0D 0
      ELSE
      FC=X(K+2)+X(K+3)**4*X(K+4)**2-2.0D 0
      ENDIF
      RETURN
  120 K=(KC-1)/3*4
      IF (MOD(KC,3).EQ.1) THEN
      FC=X(K+1)+X(K+2)**2+X(K+3)**3-3.0D 0
      ELSE IF (MOD(KC,3).EQ.2) THEN
      FC=X(K+2)-X(K+3)**2+X(K+4)-1.0D 0
      ELSE
      FC=X(K+1)*X(K+5)-1.0D 0
      ENDIF
      RETURN
  130 K=(KC-1)/2*3
      IF (MOD(KC,2).EQ.1) THEN
      FC=X(K+1)+X(K+2)**2+X(K+3)+X(K+4)+X(K+5)-5.0D 0
      ELSE
      FC=X(K+3)**2-2.0D 0*(X(K+4)+X(K+5))+3.0D 0
      ENDIF
      RETURN
  140 K=(KC-1)/2*3
      IF (MOD(KC,2).EQ.1) THEN
      FC=X(K+1)**2+X(K+2)+X(K+3)+4.0D 0*X(K+4)-7.0D 0
      ELSE
      FC=X(K+3)**2+5.0D 0*X(K+5)-6.0D 0
      ENDIF
      RETURN
  150 K=(KC-1)/3*4
      IF (MOD(KC,3).EQ.1) THEN
      FC=X(K+1)**2+2.0D 0*X(K+2)+3.0D 0*X(K+3)-6.0D 0
      ELSE IF (MOD(KC,3).EQ.2) THEN
      FC=X(K+2)**2+2.0D 0*X(K+3)+3.0D 0*X(K+4)-6.0D 0
      ELSE
      FC=X(K+3)**2+2.0D 0*X(K+4)+3.0D 0*X(K+5)-6.0D 0
      ENDIF
      RETURN
  160 K=(KC-1)/3*4
      IF (MOD(KC,3).EQ.1) THEN
      FC=X(K+1)**2+3.0D 0*X(K+2)-4.0D 0
      ELSE IF (MOD(KC,3).EQ.2) THEN
      FC=X(K+3)**2+X(K+4)-2.0D 0*X(K+5)
      ELSE
      FC=X(K+2)**2-X(K+5)
      ENDIF
      RETURN
  170 K=(KC-1)/3*4
      IF (MOD(KC,3).EQ.1) THEN
      FC=X(K+1)**2+3.0D 0*X(K+2)
      ELSE IF (MOD(KC,3).EQ.2) THEN
      FC=X(K+3)**2+X(K+4)-2.0D 0*X(K+5)
      ELSE
      FC=X(K+2)**2-X(K+5)
      ENDIF
      RETURN
  100 K=KC+1
      FC=-2.0D 0*X(K)**2+3.0D 0*X(K)-X(K-1)-2.0D 0*X(K+1)+
     & 3.0D 0*X(N-4)-X(N-3)-X(N-2)+0.5D 0*X(N-1)-X(N)+1.0D 0
      RETURN
      END
