* SUBROUTINE EEFU30             ALL SYSTEMS                 93/12/01
C PORTABILITY : ALL SYSTEMS
C 93/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF TEST FUNCTIONS FOR PARAMETER ESTIMATION OF DYNAMICAL
*  SYSTEMS. UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  NE  NUMBER OF DIFFERENTIAL EQUATIONS.
*  II  KE  INDEX OF THE DIFFERENTIAL EQUATION.
*  RI  TA  VALUE OF THE TIME.
*  RI  YA(NE)  SOLUTION VECTOR.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  FE  VALUE OF THE RIGHT HAND SIDE FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EEFU30(N,NE,KE,TA,YA,X,FE,NEXT)
      INTEGER N,NE,KE,NEXT
      REAL*8 TA,YA(NE),X(N),FE,DEN
      GOTO (10,20,30,40),NEXT
   10 GOTO (11,12,13,14),KE
   11 FE=YA(2)
      RETURN
   12 FE=0.64D 0*YA(1)*EXP(YA(3)/(1.0D 0+0.05D 0*YA(3)))
      RETURN
   13 FE=YA(4)
      RETURN
   14 FE=-2.56D 0*YA(1)*EXP(YA(3)/(1.0D 0+0.05D 0*YA(3)))
      RETURN
   20 DEN=TA
      IF (DEN.LE.0.0D 0) DEN=1.0D 0
      GOTO (21,22,23,24),KE
   21 FE=YA(2)
      RETURN
   22 FE=0.11357D 0*YA(1)*EXP(YA(3)/(1.0D 0+0.025D 0*YA(3)))-
     & 2.0D 0*YA(2)/DEN
      RETURN
   23 FE=YA(4)
      RETURN
   24 FE=-5.0D 0*0.11357D 0*YA(1)*EXP(YA(3)/(1.0D 0+0.05D 0*YA(3)))-
     & 2.0D 0*YA(4)/DEN
      RETURN
   30 GOTO (31,32,33,34,35),KE
   31 FE=YA(2)
      RETURN
   32 FE=YA(3)
      RETURN
   33 FE=-1.55D 0*YA(1)*YA(3)+0.1D 0*YA(2)**2-YA(4)**2+0.2D 0*YA(2)+
     & 1.0D 0
      RETURN
   34 FE=YA(5)
      RETURN
   35 FE=-1.55D 0*YA(1)*YA(2)+1.1D 0*YA(2)*YA(4)+0.2D 0*(YA(4)-
     & 1.0D 0)
      RETURN
   40 GOTO (41,42,43,44,45),KE
   41 FE=YA(2)
      RETURN
   42 FE=10.0D 0*YA(2)*YA(5)+100.0D 0*(YA(1)**2-YA(3)**2+X(3))
      RETURN
   43 FE=YA(4)
      RETURN
   44 FE=200.0D 0*YA(1)*YA(3)+10.0D 0*YA(4)*YA(5)
      RETURN
   45 FE=-20.0D 0*YA(1)
      RETURN
      END
