* SUBROUTINE EEGU30             ALL SYSTEMS                 94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  GRADIENTS OF TEST FUNCTIONS FOR NONLINEAR APPROXIMATION.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  NE  NUMBER OF DIFFERENTIAL EQUATIONS.
*  II  KE  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  TA  VALUE OF TIME.
*  RI  YA(NE)  SOLUTION VECTOR.
*  RO  DE(N)  DERIVATIVES OF THE RIGHT HAND SIDE FUNCTION.
*  RO  GE(N)  GRADIENT OF THE RIGHT HAND SIDE FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EEGU30(N,NE,KE,TA,YA,DE,GE,NEXT)
      INTEGER I,N,NE,KE,NEXT
      REAL*8 TA,YA(NE),DE(NE),GE(N),DEN
      DO 1 I=1,N
      GE(I)=0.0D 0
    1 CONTINUE
      DO 2 I=1,NE
      DE(I)=0.0D 0
    2 CONTINUE
      GOTO (10,20,30,40),NEXT
   10 GOTO (11,12,13,14),KE
   11 DE(2)=1.0D 0
      RETURN
   12 DE(1)=0.64D 0*EXP(YA(3)/(1.0D 0+0.05D 0*YA(3)))
      DE(3)=0.64D 0*YA(1)*EXP(YA(3)/(1.0D 0+0.05D 0*YA(3)))/
     & (1.0D 0+0.05D 0*YA(3))**2
      RETURN
   13 DE(4)=1.0D 0
      RETURN
   14 DE(1)=-2.56D 0*EXP(YA(3)/(1.0D 0+0.05D 0*YA(3)))
      DE(3)=-2.56D 0*YA(1)*EXP(YA(3)/(1.0D 0+0.05D 0*YA(3)))/
     & (1.0D 0+0.05D 0*YA(3))**2
      RETURN
   20 DEN=TA
      IF (DEN.LE.0.0D 0) DEN=1.0D 0
      GOTO (21,22,23,24),KE
   21 DE(2)=1.0D 0
      RETURN
   22 DE(1)=0.11357D 0*EXP(YA(3)/(1.0D 0+0.025D 0*YA(3)))
      DE(2)=-2.0D 0/DEN
      DE(3)=0.11357D 0*YA(1)*EXP(YA(3)/(1.0D 0+0.025D 0*YA(3)))/
     & (1.0D 0+0.025D 0*YA(3))**2
      RETURN
   23 DE(4)=1.0D 0
      RETURN
   24 DE(1)=-5.0D 0*0.11357D 0*EXP(YA(3)/(1.0D 0+0.05D 0*YA(3)))
      DE(3)=-5.0D 0*0.11357D 0*YA(1)*EXP(YA(3)/(1.0D 0+0.05D 0*
     & YA(3)))/(1.0D 0+0.05D 0*YA(3))**2
      DE(4)=-2.0D 0/DEN
      RETURN
   30 GOTO (31,32,33,34,35),KE
   31 DE(2)=1.0D 0
      RETURN
   32 DE(3)=1.0D 0
      RETURN
   33 DE(1)=-1.55D 0*YA(3)
      DE(2)=0.2D 0*YA(2)+0.2D 0
      DE(3)=-1.55D 0*YA(1)
      DE(4)=-2.0D 0*YA(4)
      RETURN
   34 DE(5)=1.0D 0
      RETURN
   35 DE(1)=-1.55D 0*YA(2)
      DE(2)=-1.55D 0*YA(1)+1.1D 0*YA(4)
      DE(4)=1.1D 0*YA(2)+0.2D 0
      RETURN
   40 GOTO (41,42,43,44,45),KE
   41 DE(2)=1.0D 0
      RETURN
   42 DE(1)=200.0D 0*YA(1)
      DE(2)=10.0D 0*YA(5)
      DE(3)=-200.0D 0*YA(3)
      DE(5)=10.0D 0*YA(2)
      GE(3)=100.0D 0
      RETURN
   43 DE(4)=1.0D 0
      RETURN
   44 DE(1)=200.0D 0*YA(3)
      DE(3)=200.0D 0*YA(1)
      DE(4)=10.0D 0*YA(5)
      DE(5)=10.0D 0*YA(4)
      RETURN
   45 DE(1)=-20.0D 0
      RETURN
      END
