* SUBROUTINE EFBU29                ALL SYSTEMS                00/12/01
C PORTABILITY : ALL SYSTEMS
C 00/12/01 VL : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES AND GRADIENTS OF MODEL FUNCTIONS
*   FOR UNCONSTRAINED MINIMIZATION.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  F  VALUE OF THE MODEL FUNCTION.
*  RO  G(N)  GRADIENT OF THE MODEL FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EFBU29(N,X,F,G,NEXT)
      INTEGER N,NEXT,I,IA,IB,IC,J,K,KA,L,M
      REAL*8 X(N),G(N),Y(20),PAR
      REAL*8 A,A1,A2,AI,B,C,D,D1S,D2S,E,ETA9,EX,F,FA,H,P,Q,R,U,V
      COMMON /EMPR15/ Y
      COMMON /EMPR18/ PAR,M
      PARAMETER (ETA9=1.0D 60)
C     PI=3.14159265358979323846D 0
      F=0.0D 0
      DO 1 I=1,N
      G(I)=0.0D 0
    1 CONTINUE
      GO TO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     & 170,180,190,200,210,220,230,240,250,260,270,280,290,300,310),NEXT
   10 F=X(1)**2
      K=1
      DO 11 I=2,N
      FA=X(I)**2
      IF (F.LT.FA) K=I
      F=MAX(F,FA)
   11 CONTINUE
      G(K)=2.0D 0*X(K)
      RETURN
   20 F=ABS(X(1))
      K=1
      DO 21 I=2,N
      FA=ABS(X(I))
      IF (F.LT.FA) K=I
      F=MAX(F,FA)
   21 CONTINUE
      G(K)=SIGN(1.0D 0,X(K))
      RETURN
   30 A=0.0D 0
      F=-ETA9
      DO 31 I=1,N
      FA=X(I)
      A=A+FA
      IF (F.LT.FA) K=I
      F=MAX(F,FA)
      G(I)=-1.0D 0/N
   31 CONTINUE
      F=F-A/N
      G(K)=G(K)+1.0D 0
      RETURN
   40 F=-ETA9
      DO 42 I=1,N
      FA=0.0D 0
      DO 41 J=1,N
      FA=FA+X(J)/DBLE(I+J-1)
   41 CONTINUE
      IF (F.GE.ABS(FA)) GO TO 42
      K=I
      AI=SIGN(1D 0,FA)
      F=ABS(FA)
   42 CONTINUE
      DO 43 J=1,N
      G(J)=AI/DBLE(K+J-1)
   43 CONTINUE
      RETURN
   50 DO 52 J=1,N
      FA=0.0D 0
      DO 51 I=1,N
      FA=FA+X(I)/DBLE(I+J-1)
   51 CONTINUE
      F=F+ABS(FA)
      AI=SIGN(1.0D 0,FA)
      DO 52 I=1,N
      G(I)=G(I)+AI/DBLE(I+J-1)
   52 CONTINUE
      RETURN
   60 K=1
      DO 61 I=1,N
      FA=(3.0D 0-2.0D 0*X(I))*X(I)+1.0D 0
      IF (I.GT.1) FA=FA-X(I-1)
      IF (I.LT.N) FA=FA-X(I+1)
      IF (F.LT.ABS(FA)) THEN
        K=I
        AI=SIGN(1D 0,FA)
        F=ABS(FA)
      ENDIF
   61 CONTINUE
      G(K)=(3.0D 0-4.0D 0*X(K))*AI
      IF (K.GT.1) G(K-1)=-AI
      IF (K.LT.N) G(K+1)=-AI
      RETURN
   70 K=1
      DO 72 I=1,N
      FA=(2.0D 0+5.0D 0*X(I)**2)*X(I)+1.0D 0
      DO 71 J=MAX(1,I-5),MIN(N,I+1)
      FA=FA+X(J)*(1.0D 0+X(J))
   71 CONTINUE
      IF (F.LT.ABS(FA)) THEN
        K=I
        AI=SIGN(1D 0,FA)
        F=ABS(FA)
      ENDIF
   72 CONTINUE
      DO 73 J=MAX(1,K-5),MIN(N,K+1)
      G(J)=(1.0D 0+2.0D 0*X(J))*AI
   73 CONTINUE
      G(K)=G(K)+(2.0D 0+1.5D 1*X(K)**2)*AI
      RETURN
   80 K=1
      DO 81 KA=1,2*N-2
      I=(KA+1)/2
      IF (MOD(KA,2).EQ.1) THEN
      FA=X(I)+X(I+1)*((5.0D 0-X(I+1))*X(I+1)-2.0D 0)-1.3D 1
      ELSE
      FA=X(I)+X(I+1)*((1.0D 0+X(I+1))*X(I+1)-1.4D 1)-2.9D 1
      ENDIF
      IF (F.LT.ABS(FA)) THEN
        K=KA
        AI=SIGN(1D 0,FA)
        F=ABS(FA)
      ENDIF
   81 CONTINUE
      I=(K+1)/2
      IF (MOD(K,2).EQ.1) THEN
      G(I)=AI
      G(I+1)=(1.0D 1*X(I+1)-3.0D 0*X(I+1)**2-2.0D 0)*AI
      ELSE
      G(I)=AI
      G(I+1)=(2.0D 0*X(I+1)+3.0D 0*X(I+1)**2-1.4D 1)*AI
      ENDIF
      RETURN
   90 DO 91 I=1,N
      FA=(3.0D 0-2.0D 0*X(I))*X(I)+1.0D 0
      IF (I.GT.1) FA=FA-X(I-1)
      IF (I.LT.N) FA=FA-X(I+1)
      F=F+ABS(FA)
      AI=SIGN(1D 0,FA)
      G(I)=G(I)+(3.0D 0-4.0D 0*X(I))*AI
      IF (I.GT.1) G(I-1)=G(I-1)-AI
      IF (I.LT.N) G(I+1)=G(I+1)-AI
   91 CONTINUE
      RETURN
  100 DO 102 I=1,N
      FA=(2.0D 0+5.0D 0*X(I)**2)*X(I)+1.0D 0
      DO 101 J=MAX(1,I-5),MIN(N,I+1)
      FA=FA+X(J)*(1.0D 0+X(J))
  101 CONTINUE
      F=F+ABS(FA)
      AI=SIGN(1D 0,FA)
      DO 103 J=MAX(1,I-5),MIN(N,I+1)
      G(J)=G(J)+(1.0D 0+2.0D 0*X(J))*AI
  103 CONTINUE
      G(I)=G(I)+(2.0D 0+1.5D 1*X(I)**2)*AI
  102 CONTINUE
      RETURN
  110 DO 111 KA=1,2*N-2
      I=(KA+1)/2
      IF (MOD(KA,2).EQ.1) THEN
      FA=X(I)+X(I+1)*((5.0D 0-X(I+1))*X(I+1)-2.0D 0)-1.3D 1
      AI=SIGN(1D 0,FA)
      G(I)=G(I)+AI
      G(I+1)=G(I+1)+(1.0D 1*X(I+1)-3.0D 0*X(I+1)**2-2.0D 0)*AI
      ELSE
      FA=X(I)+X(I+1)*((1.0D 0+X(I+1))*X(I+1)-1.4D 1)-2.9D 1
      AI=SIGN(1D 0,FA)
      G(I)=G(I)+AI
      G(I+1)=G(I+1)+(2.0D 0*X(I+1)+3.0D 0*X(I+1)**2-1.4D 1)*AI
      ENDIF
      F=F+ABS(FA)
  111 CONTINUE
      RETURN
  120 B=SQRT(1.0D 1)
      A=SQRT(5.0D 0)
      DO 121 KA=1,2*N-4
      I=2*((KA+3)/4)
      IF (MOD(KA,4).EQ.1) THEN
      FA=X(I-1)+1.0D 1*X(I)
      ELSEIF (MOD(KA,4).EQ.2) THEN
      FA=A*(X(I+1)-X(I+2))
      ELSEIF (MOD(KA,4).EQ.3) THEN
      FA=(X(I)-2.0D 0*X(I+1))**2
      ELSE
      FA=B*(X(I-1)-X(I+2))**2
      ENDIF
      AI=SIGN(1D 0,FA)
      F=F+ABS(FA)
      IF (MOD(KA,4).EQ.1) THEN
      G(I-1)=G(I-1)+AI
      G(I)=G(I)+1.0D 1*AI
      ELSEIF (MOD(KA,4).EQ.2) THEN
      G(I+1)=G(I+1)+A*AI
      G(I+2)=G(I+2)-A*AI
      ELSEIF (MOD(KA,4).EQ.3) THEN
      C=X(I)-2.0D 0*X(I+1)
      G(I)=G(I)+2.0D 0*C*AI
      G(I+1)=G(I+1)-4.0D 0*C*AI
      ELSE
      C=X(I-1)-X(I+2)
      D=2.0D 0*B*C
      G(I-1)=G(I-1)+D*AI
      G(I+2)=G(I+2)-D*AI
      ENDIF
  121 CONTINUE
      RETURN
  130 DO 136 KA=1,2*N-4
      I=2*((KA+3)/4)-2
      L=MOD((KA-1),4)+1
      FA=-Y(L)
      DO 132 K=1,3
      A=DBLE(K*K)/DBLE(L)
      DO 131 J=1,4
      IF (X(I+J).EQ.0D0) X(I+J)=1.0D-16
      A=A*SIGN(1.0D 0,X(I+J))*ABS(X(I+J))**(DBLE(J)/DBLE(K*L))
  131 CONTINUE
      FA=FA+A
  132 CONTINUE
      F=F+ABS(FA)
      AI=SIGN(1D 0,FA)
      DO 135 K=1,3
      A=DBLE(K*K)/DBLE(L)
      DO 133 J=1,4
      IF (X(I+J).EQ.0D0) X(I+J)=1.0D-16
      A=A*SIGN(1.0D 0,X(I+J))*ABS(X(I+J))**(DBLE(J)/DBLE(K*L))
  133 CONTINUE
      DO 134 J=1,4
      G(I+J)=G(I+J)+(DBLE(J)/DBLE(K*L))*A/X(I+J)*AI
  134 CONTINUE
  135 CONTINUE
  136 CONTINUE
      RETURN
  140 DO 146 KA=1,2*N-4
      I=2*((KA+3)/4)-2
      L=MOD((KA-1),4)+1
      FA=-Y(L)
      DO 142 K=1,3
      A=0.0D 0
      DO 141 J=1,4
      A=A+X(I+J)*(DBLE(J)/DBLE(K*L))
  141 CONTINUE
      FA=FA+EXP(A)*DBLE(K*K)/DBLE(L)
  142 CONTINUE
      F=F+ABS(FA)
      AI=SIGN(1D 0,FA)
      DO 145 K=1,3
      A=0.0D 0
      DO 143 J=1,4
      A=A+X(I+J)*(DBLE(J)/DBLE(K*L))
  143 CONTINUE
      A=EXP(A)*DBLE(K*K)/DBLE(L)
      DO 144 J=1,4
      G(I+J)=G(I+J)+A*(DBLE(J)/DBLE(K*L))*AI
  144 CONTINUE
  145 CONTINUE
  146 CONTINUE
      RETURN
  150 M=5*N
      DO 151 KA=1,N*5
      I=MOD(KA,N/2)+1
      J=I+N/2
      IF (KA.LE.M/2) THEN
      IA=1
      ELSE
      IA=2
      ENDIF
      IB=5-KA/(M/4)
      IC=MOD(KA,5)+1
      FA=(X(I)**IA-X(J)**IB)**IC
      AI=SIGN(1D 0,FA)
      F=F+ABS(FA)
      A=DBLE(IA)
      B=DBLE(IB)
      C=DBLE(IC)
      D=X(I)**IA-X(J)**IB
      IF (D.NE.0.0D 0) THEN
      E=C*D**(IC-1)
      G(I)=G(I)+E*A*X(I)**(IA-1)*AI
      G(J)=G(J)-E*B*X(J)**(IB-1)*AI
      ENDIF
  151 CONTINUE
      RETURN
  160 U=1.0D 0/DBLE(N+1)
      DO 161 KA=1,N
      V=DBLE(KA)*U
      FA=2.0D 0*X(KA)+0.5D 0*U*U*(X(KA)+V+1.0D 0)**3+1.0D 0
      IF(KA.GT.1) FA=FA-X(KA-1)
      IF(KA.LT.N) FA=FA-X(KA+1)
      AI=SIGN(1D 0,FA)
      F=F+ABS(FA)
      G(KA)=G(KA)+(2.0D 0+1.5D 0*U**2*(X(KA)+V+1.0D 0)**2)*AI
      IF(KA.GT.1) G(KA-1)=G(KA-1)-AI
      IF(KA.LT.N) G(KA+1)=G(KA+1)-AI
  161 CONTINUE
      RETURN
  170 K=1
      DO 172 KA=1,N
      J=(KA-1)/5
      FA=5.0D 0-DBLE(J+1)*(1.0D 0-COS(X(KA)))-SIN(X(KA))
      J=J*5
      DO 171 I=J+1,J+5
      FA=FA-COS(X(I))
  171 CONTINUE
      IF (F.LT.ABS(FA)) THEN
        K=KA
        AI=SIGN(1D 0,FA)
        F=ABS(FA)
      ENDIF
  172 CONTINUE
      J=(K-1)/5
      G(K)=(-DBLE(J+1)*SIN(X(K))-COS(X(K)))*AI
      J=J*5
      DO 173 I=J+1,J+5
      IF (I.EQ.K) THEN
      G(I)=G(I)+SIN(X(I))*AI
      ELSE
      G(I)=SIN(X(I))*AI
      ENDIF
  173 CONTINUE
      RETURN
  180 K=1
      DO 181 KA=1,N
      IF (KA.LT.2) THEN
      FA=3.0D 0*X(KA)**3+2.0D 0*X(KA+1)-5.0D 0+
     & SIN(X(KA)-X(KA+1))*SIN(X(KA)+X(KA+1))
      ELSEIF (KA.LT.N) THEN
      FA=3.0D 0*X(KA)**3+2.0D 0*X(KA+1)-5.0D 0+
     & SIN(X(KA)-X(KA+1))*SIN(X(KA)+X(KA+1))+4.0D 0*X(KA)-
     & X(KA-1)*EXP(X(KA-1)-X(KA))-3.0D 0
      ELSE
      FA=4.0D 0*X(KA)-X(KA-1)*EXP(X(KA-1)-X(KA))-3.0D 0
      ENDIF
      IF (F.LT.ABS(FA)) THEN
        K=KA
        AI=SIGN(1D 0,FA)
        F=ABS(FA)
      ENDIF
  181 CONTINUE
      IF (K.LT.2) THEN
      D1S=COS(X(K)-X(K+1))*SIN(X(K)+X(K+1))
      D2S=SIN(X(K)-X(K+1))*COS(X(K)+X(K+1))
      G(K)=(9.0D 0*X(K)**2+D1S+D2S)*AI
      G(K+1)=(2.0D 0-D1S+D2S)*AI
      ELSE IF (K.LT.N) THEN
      D1S=COS(X(K)-X(K+1))*SIN(X(K)+X(K+1))
      D2S=SIN(X(K)-X(K+1))*COS(X(K)+X(K+1))
      EX=EXP(X(K-1)-X(K))
      G(K-1)=(-EX-X(K-1)*EX)*AI
      G(K)=(9.0D 0*X(K)**2+D1S+D2S+4.0D 0+X(K-1)*EX)*AI
      G(K+1)=(2.0D 0-D1S+D2S)*AI
      ELSE
      EX=EXP(X(K-1)-X(K))
      G(K-1)=(-EX-X(K-1)*EX)*AI
      G(K)=(4.0D 0+X(K-1)*EX)*AI
      ENDIF
      RETURN
  190 K=1
      H=2.0D 0
      DO 191 KA=1,N
      IF (KA.EQ.1) THEN
      FA=((3.0D 0-H*X(1))*X(1)-2.0D 0*X(2)+1.0D 0)**2
      ELSEIF (KA.LE.N-1) THEN
      FA=((3.0D 0-H*X(KA))*X(KA)-X(KA-1)-2.0D 0*X(KA+1)+1.0D 0)**2
      ELSE
      FA=((3.0D 0-H*X(N))*X(N)-X(N-1)+1.0D 0)**2
      ENDIF
      IF (F.LT.ABS(FA)) THEN
        K=KA
        AI=SIGN(1D 0,FA)
        F=ABS(FA)
      ENDIF
  191 CONTINUE
      IF (K.EQ.1) THEN
      G(1)=(2.0D 0*((3.0D 0-H*X(1))*X(1)-2.0D 0*X(2)+1.0D 0)*
     & (3.0D 0-2.0D 0*H*X(1)))*AI
      G(2)=(-4.0D 0*((3.0D 0-H*X(1))*X(1)-2.0D 0*X(2)+1.0D 0))*AI
      ELSE IF (K.LE.N-1) THEN
      G(K-1)=(-2.0D 0*
     & ((3.0D 0-H*X(K))*X(K)-X(K-1)-2.0D 0*X(K+1)+1.0D 0))*AI
      G(K)=(2.0D 0*
     & ((3.0D 0-H*X(K))*X(K)-X(K-1)-2.0D 0*X(K+1)+1.0D 0)*
     & (3.0D 0-2.0D 0*H*X(K)))*AI
      G(K+1)=(-4.0D 0*
     & ((3.0D 0-H*X(K))*X(K)-X(K-1)-2.0D 0*X(K+1)+1.0D 0))*AI
      ELSE
      G(N-1)=(-2.0D 0*((3.0D 0-H*X(N))*X(N)-X(N-1)+1.0D 0))*AI
      G(N)=(2.0D 0*
     & ((3.0D 0-H*X(N))*X(N)-X(N-1)+1.0D 0)*
     & (3.0D 0-2.0D 0*H*X(N)))*AI
      ENDIF
      RETURN
  200 K=1
      DO 201 KA=1,N
      IF(KA.LT.2) THEN
      FA=X(KA)*(0.5D 0*X(KA)-3.0D 0)-1.0D 0+2.0D 0*X(KA+1)
      ELSEIF (KA.LT.N) THEN
      FA=X(KA-1)+X(KA)*(0.5D 0*X(KA)-3.0D 0)-1.0D 0+2.0D 0*X(KA+1)
      ELSE
      FA=X(KA-1)+X(KA)*(0.5D 0*X(KA)-3.0D 0)-1.0D 0
      ENDIF
      IF (F.LT.ABS(FA)) THEN
        K=KA
        AI=SIGN(1D 0,FA)
        F=ABS(FA)
      ENDIF
  201 CONTINUE
      IF (K.LT.2) THEN
      G(K)=(X(K)-3.0D 0)*AI
      G(K+1)=2.0D 0*AI
      ELSE IF (K.LT.N) THEN
      G(K-1)=AI
      G(K)=(X(K)-3.0D 0)*AI
      G(K+1)=2.0D 0*AI
      ELSE
      G(K-1)=AI
      G(K)=(X(K)-3.0D 0)*AI
      ENDIF
      RETURN
  210 DO 211 KA=1,N
      IF (KA.EQ.1) THEN
      FA=-2.0D 0*X(KA)**2+3.0D 0*X(KA)-2.0D 0*X(KA+1)+
     & 3.0D 0*X(N-4)-X(N-3)-X(N-2)+0.5D 0*X(N-1)-X(N)+1.0D 0
      ELSEIF (KA.LE.N-1) THEN
      FA=-2.0D 0*X(KA)**2+3.0D 0*X(KA)-X(KA-1)-2.0D 0*X(KA+1)+
     & 3.0D 0*X(N-4)-X(N-3)-X(N-2)+0.5D 0*X(N-1)-X(N)+1.0D 0
      ELSE
      FA=-2.0D 0*X(N)**2+3.0D 0*X(N)-X(N-1)+
     & 3.0D 0*X(N-4)-X(N-3)-X(N-2)+0.5D 0*X(N-1)-X(N)+1.0D 0
      ENDIF
      F=F+ABS(FA)
      AI=SIGN(1D 0,FA)
      IF (KA.EQ.1) THEN
      G(N-4)=G(N-4)+3.0D 0*AI
      G(N-3)=G(N-3)-AI
      G(N-2)=G(N-2)-AI
      G(N-1)=G(N-1)+0.50D 0*AI
      G(N)=G(N)-AI
      G(KA)=G(KA)+(-4.0D 0*X(KA)+3.0D 0)*AI
      G(KA+1)=G(KA+1)-2.0D 0*AI
      ELSEIF (KA.LE.N-1) THEN
      G(N-4)=G(N-4)+3.0D 0*AI
      G(N-3)=G(N-3)-AI
      G(N-2)=G(N-2)-AI
      G(N-1)=G(N-1)+0.50D 0*AI
      G(N)=G(N)-AI
      G(KA-1)=G(KA-1)-AI
      G(KA)=G(KA)+(-4.0D 0*X(KA)+3.0D 0)*AI
      G(KA+1)=G(KA+1)-2.0D 0*AI
      ELSE
      G(N-4)=G(N-4)+3.0D 0*AI
      G(N-3)=G(N-3)-AI
      G(N-2)=G(N-2)-AI
      G(N-1)=G(N-1)+0.50D 0*AI
      G(N)=G(N)+(-4.0D 0*X(N)+2.0D 0)*AI
      ENDIF
  211 CONTINUE
      RETURN
  220 K=1
      U=1.0D 0/DBLE(N+1)
      DO 221 KA=1,N
      V=DBLE(KA)*U
      FA=2.0D 0*X(KA)+0.5D 0*U*U*(X(KA)+V+1.0D 0)**3
      IF(KA.GT.1) FA=FA-X(KA-1)
      IF(KA.LT.N) FA=FA-X(KA+1)
      IF (F.LT.ABS(FA)) THEN
        K=KA
        AI=SIGN(1D 0,FA)
        F=ABS(FA)
      ENDIF
  221 CONTINUE
      V=DBLE(K)*U
      G(K)=(2.0D 0+1.5D 0*U**2*(X(K)+V+1.0D 0)**2)*AI
      IF(K.GT.1) G(K-1)=-AI
      IF(K.LT.N) G(K+1)=-AI
      RETURN
  230 K=1
      DO 231 KA=1,N
      IF(KA.EQ.1) THEN
      FA=3.0D 0*X(KA)*(X(KA+1)-2.0D 0*X(KA))+0.25D 0*X(KA+1)**2
      ELSEIF(KA.EQ.N) THEN
      FA=3.0D 0*X(KA)*(2.0D 1-2.0D 0*X(KA)+X(KA-1))+
     & 0.25D 0*(2.0D 1-X(KA-1))**2
      ELSE
      FA=3.0D 0*X(KA)*(X(KA+1)-2.0D 0*X(KA)+X(KA-1))+
     & 0.25D 0*(X(KA+1)-X(KA-1))**2
      ENDIF
      IF (F.LT.ABS(FA)) THEN
        K=KA
        AI=SIGN(1D 0,FA)
        F=ABS(FA)
      ENDIF
  231 CONTINUE
      IF(K.EQ.1) THEN
      G(K)=(3.0D 0*(X(K+1)-4.0D 0*X(K)))*AI
      G(K+1)=(3.0D 0*X(K)+0.5D 0*X(K+1))*AI
      ELSEIF(K.EQ.N) THEN
      G(K-1)=(3.0D 0*X(K)-0.5D 0*(2.0D 1-X(K-1)))*AI
      G(K)=(3.0D 0*(2.0D 1-4.0D 0*X(K)+X(K-1)))*AI
      ELSE
      G(K-1)=(3.0D 0*X(K)-0.5D 0*(X(K+1)-X(K-1)))*AI
      G(K)=(3.0D 0*(X(K+1)-4.0D 0*X(K)+X(K-1)))*AI
      G(K+1)=(3.0D 0*X(K)+0.5D 0*(X(K+1)-X(K-1)))*AI
      ENDIF
      RETURN
  240 K=1
      H=1.0D 0/DBLE(N+1)
      DO 241 KA=1,N
      IF (KA.LT.2) THEN
      FA=2.0D 0*X(KA)+PAR*H**2*SINH(PAR*X(KA))-X(KA+1)
      ELSE IF (KA.LT.N) THEN
      FA=2.0D 0*X(KA)+PAR*H**2*SINH(PAR*X(KA))-X(KA-1)-X(KA+1)
      ELSE
      FA=2.0D 0*X(KA)+PAR*H**2*SINH(PAR*X(KA))-X(KA-1)-1.0D 0
      ENDIF
      IF (F.LT.ABS(FA)) THEN
        K=KA
        AI=SIGN(1D 0,FA)
        F=ABS(FA)
      ENDIF
  241 CONTINUE
      IF (K.LT.2) THEN
      G(K)=(2.0D 0+PAR**2*H**2*COSH(PAR*X(K)))*AI
      G(K+1)=-AI
      ELSE IF (K.LT.N) THEN
      G(K-1)=-AI
      G(K)=(2.0D 0+PAR**2*H**2*COSH(PAR*X(K)))*AI
      G(K+1)=-AI
      ELSE
      G(K)=(2.0D 0+PAR**2*H**2*COSH(PAR*X(K)))*AI
      G(K-1)=-AI
      ENDIF
      RETURN
  250 K=1
      DO 251 KA=1,N
      FA=8.0D 0*X(KA)**2
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      IF(I.EQ.1) FA=FA-2.0D 0*X(KA)*(X(KA+1)+1.0D 0)-
     & 0.5D 0*(X(KA+1)-1.0D 0)**2-
     & 1.5D 0*X(KA)**2*(X(KA+1)-1.0D 0)*PAR
      IF(I.GT.1.AND.I.LT.M) FA=FA-2.0D 0*X(KA)*(X(KA+1)+X(KA-1))-
     & 0.5D 0*(X(KA+1)-X(KA-1))**2-
     & 1.5D 0*X(KA)**2*(X(KA+1)-X(KA-1))*PAR
      IF(I.EQ.M) FA=FA-2.0D 0*X(KA)*X(KA-1)-
     & 0.5D 0*X(KA-1)**2+
     & 1.5D 0*X(KA)**2*X(KA-1)*PAR
      IF(J.EQ.1) FA=FA-2.0D 0*X(KA)*(X(KA+M)+1.0D 0)-
     & 0.5D 0*(X(KA+M)-1.0D 0)**2
      IF(J.GT.1.AND.J.LT.M) FA=FA-2.0D 0*X(KA)*(X(KA+M)+X(KA-M))-
     & 0.5D 0*(X(KA+M)-X(KA-M))**2
      IF(J.EQ.M) FA=FA-2.0D 0*X(KA)*X(KA-M)-
     & 0.5D 0*X(KA-M)**2
      IF (I.EQ.1.AND.J.EQ.1) FA=FA-PAR/DBLE(M+1)
      IF (F.LT.ABS(FA)) THEN
        K=KA
        AI=SIGN(1D 0,FA)
        F=ABS(FA)
      ENDIF
  251 CONTINUE
      G(K)=1.6D 1*X(K)*AI
      J=(K-1)/M+1
      I=K-(J-1)*M
      IF(I.EQ.1) THEN
      G(K)=G(K)+(-2.0D 0*(X(K+1)+1.0D 0)-3.0D 0*X(K)*
     & (X(K+1)-1.0D 0)*PAR)*AI
      G(K+1)=(-2.0D 0*X(K)-(X(K+1)-1.0D 0)-1.5D 0*X(K)**2*PAR)*AI
      ENDIF
      IF(I.GT.1.AND.I.LT.M) THEN
      G(K)=G(K)+(-2.0D 0*(X(K+1)+X(K-1))-3.0D 0*X(K)*
     & (X(K+1)-X(K-1))*PAR)*AI
      G(K-1)=(-2.0D 0*X(K)+(X(K+1)-X(K-1))+1.5D 0*X(K)**2*PAR)*AI
      G(K+1)=(-2.0D 0*X(K)-(X(K+1)-X(K-1))-1.5D 0*X(K)**2*PAR)*AI
      ENDIF
      IF(I.EQ.M) THEN
      G(K)=G(K)+(-2.0D 0*X(K-1)+3.0D 0*X(K)*X(K-1)*PAR)*AI
      G(K-1)=(-2.0D 0*X(K)-X(K-1)+1.5D 0*X(K)**2*PAR)*AI
      ENDIF
      IF(J.EQ.1) THEN
      G(K)=G(K)+(-2.0D 0*(X(K+M)+1.0D 0))*AI
      G(K+M)=(-2.0D 0*X(K)-(X(K+M)-1.0D 0))*AI
      ENDIF
      IF(J.GT.1.AND.J.LT.M) THEN
      G(K)=G(K)+(-2.0D 0*(X(K+M)+X(K-M)))*AI
      G(K-M)=(-2.0D 0*X(K)+(X(K+M)-X(K-M)))*AI
      G(K+M)=(-2.0D 0*X(K)-(X(K+M)-X(K-M)))*AI
      ENDIF
      IF(J.EQ.M) THEN
      G(K)=G(K)+(-2.0D 0*X(K-M))*AI
      G(K-M)=(-2.0D 0*X(K)-X(K-M))*AI
      ENDIF
      RETURN
  260 A2=0.5D 0
      DO 261 KA=1,N
      IF (KA.EQ.1) THEN
      FA=A2-(1.0D 0-A2)*X(3)-X(1)*(1.0D 0+4.0D 0*X(2))
      ELSEIF(KA.EQ.2) THEN
      FA=-(2.0D 0-A2)*X(4)-X(2)*(1.0D 0+4.0D 0*X(1))
      ELSEIF(KA.EQ.N-1) THEN
      FA=A2*X(N-3)-X(N-1)*(1.0D 0+4.0D 0*X(N))
      ELSEIF (KA.EQ.N) THEN
      FA=A2*X(N-2)-(2.0D 0-A2)-X(N)*(1.0D 0+4.0D 0*X(N-1))
      ELSEIF (MOD(KA,2).EQ.1) THEN
      FA=A2*X(KA-2)-(1.0D 0-A2)*X(KA+2)-
     & X(KA)*(1.0D 0+4.0D 0*X(KA+1))
      ELSE
      FA=A2*X(KA-2)-(2.0D 0-A2)*X(KA+2)-
     & X(KA)*(1.0D 0+4.0D 0*X(KA-1))
      ENDIF
      F=F+ABS(FA)
      AI=SIGN(1D 0,FA)
      IF (KA.EQ.1) THEN
      G(1)=G(1)+(-1.0D 0-4.0D 0*X(2))*AI
      G(2)=G(2)-4.0D 0*X(1)*AI
      G(3)=G(3)+(A2-1.0D 0)*AI
      ELSEIF(KA.EQ.2) THEN
      G(1)=G(1)-4.0D 0*X(2)*AI
      G(2)=G(2)+(-1.0D 0-4.0D 0*X(1))*AI
      G(4)=G(4)+(-2.0D 0+A2)*AI
      ELSEIF(KA.EQ.N-1) THEN
      G(N-3)=G(N-3)+A2*AI
      G(N-1)=G(N-1)+(-1.0D 0-4.0D 0*X(N))*AI
      G(N)=G(N)+(-4.0D 0*X(N-1))*AI
      ELSEIF (KA.EQ.N) THEN
      G(N-2)=G(N-2)+A2*AI
      G(N-1)=G(N-1)-4.0D 0*X(N)*AI
      G(N)=G(N)+(-1.0D 0-4.0D 0*X(N-1))*AI
      ELSEIF (MOD(KA,2).EQ.1) THEN
      G(KA-2)=G(KA-2)+A2*AI
      G(KA)=G(KA)+(-1.0D 0-4.0D 0*X(KA+1))*AI
      G(KA+1)=G(KA+1)-4.0D 0*X(KA)*AI
      G(KA+2)=G(KA+2)+(-1.0D 0+A2)*AI
      ELSE
      G(KA-2)=G(KA-2)+A2*AI
      G(KA-1)=G(KA-1)-4.0D 0*X(KA)*AI
      G(KA)=G(KA)+(-1.0D 0-4.0D 0*X(KA-1))*AI
      G(KA+2)=G(KA+2)+(-2.0D 0+A2)*AI
      ENDIF
  261 CONTINUE
      RETURN
  270 K=1
      A1=0.414214D 0
      DO 271 KA=1,N
      IF (KA.EQ.1) THEN
      FA=X(1)-(1.0D 0-X(1))*X(3)-A1*(1.0D 0+4.0D 0*X(2))
      ELSEIF (KA.EQ.2) THEN
      FA=-(1.0D 0-X(1))*X(4)-A1*(1.0D 0+4.0D 0*X(2))
      ELSEIF (KA.EQ.3) THEN
      FA=A1*X(1)-(1.0D 0-X(1))*X(5)-X(3)*(1.0D 0+4.0D 0*X(2))
      ELSEIF (KA.LE.N-2) THEN
      FA=X(1)*X(KA-2)-(1.0D 0-X(1))*X(KA+2)-
     & X(KA)*(1.0D 0+4.0D 0*X(KA-1))
      ELSEIF (KA.EQ.N-1) THEN
      FA=X(1)*X(N-3)-X(N-1)*(1.0D 0+4.0D 0*X(N-2))
      ELSE
      FA=X(1)*X(N-2)-(1.0D 0-X(1))-X(N)*(1.0D 0+4.0D 0*X(N-1))
      ENDIF
      IF (F.LT.ABS(FA)) THEN
        K=KA
        AI=SIGN(1D 0,FA)
        F=ABS(FA)
      ENDIF
  271 CONTINUE
      IF (K.EQ.1) THEN
      G(1)=(1.0D 0+X(3))*AI
      G(2)=-4.0D 0*A1*AI
      G(3)=(-1.0D 0+X(1))*AI
      ELSEIF (K.EQ.2) THEN
      G(1)=X(4)*AI
      G(2)=-4.0D 0*A1*AI
      G(4)=(-1.0D 0+X(1))*AI
      ELSEIF (K.EQ.3) THEN
      G(1)=(A1+X(5))*AI
      G(2)=-4.0D 0*X(3)*AI
      G(3)=(-1.0D 0-4.0D 0*X(2))*AI
      G(5)=(-1.0D 0+X(1))*AI
      ELSEIF (K.LE.N-2) THEN
      G(1)= (X(K-2)+X(K+2))*AI
      G(K-2)=X(1)*AI
      G(K-1)=-4.0D 0*X(K)*AI
      G(K)=(-1.0D 0-4.0D 0*X(K-1))*AI
      G(K+2)=(-1.0D 0+X(1))*AI
      ELSEIF (K.EQ.N-1) THEN
      G(1)= X(N-3)*AI
      G(N-3)=X(1)*AI
      G(N-2)=-4.0D 0*X(N-1)*AI
      G(N-1)=(-1.0D 0-4.0D 0*X(N-2))*AI
      ELSE
      G(1)= (X(N-2)+1.0D 0)*AI
      G(N-2)=X(1)*AI
      G(N-1)=-4.0D 0*X(N)*AI
      G(N)=(-1.0D 0-4.0D 0*X(N-1))*AI
      ENDIF
      RETURN
  280 K=1
      DO 281 KA=1,N
      IF (KA.LT.2) THEN
      FA=X(KA)-EXP(COS(DBLE(KA)*(X(KA)+X(KA+1))))
      ELSEIF (KA.LT.N) THEN
      FA=X(KA)-EXP(COS(DBLE(KA)*(X(KA-1)+X(KA)+X(KA+1))))
      ELSE
      FA=X(KA)-EXP(COS(DBLE(KA)*(X(KA-1)+X(KA))))
      ENDIF
      IF (F.LT.ABS(FA)) THEN
        K=KA
        AI=SIGN(1D 0,FA)
        F=ABS(FA)
      ENDIF
  281 CONTINUE
      IF (K.LT.2) THEN
      G(K+1)=(EXP(COS(DBLE(K)*(X(K)+X(K+1))))*
     & DBLE(K)*SIN(DBLE(K)*(X(K)+X(K+1))))*AI
      G(K)=G(K+1)+AI
      ELSEIF (K.LT.N) THEN
      G(K-1)=(EXP(COS(DBLE(K)*(X(K-1)+X(K)+X(K+1))))*
     & SIN(DBLE(K)*(X(K-1)+X(K)+X(K+1)))*DBLE(K))*AI
      G(K+1)=G(K-1)
      G(K)=AI+G(K-1)
      ELSE
      G(K-1)=(EXP(COS(DBLE(K)*(X(K-1)+X(K))))*
     & SIN(DBLE(K)*(X(K-1)+X(K)))*DBLE(K))*AI
      G(K)=AI+G(K-1)
      ENDIF
      RETURN
  290 K=1
      DO 291 KA=1,N
      FA=4.0D 0*X(KA)
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      FA=FA+PAR*X(KA)**3/(1.0D 0+PAR*DBLE(I)**2+
     & PAR*DBLE(J)**2)
      IF(I.EQ.1) FA=FA-1.0D 0
      IF(I.GT.1) FA=FA-X(KA-1)
      IF(I.LT.M) FA=FA-X(KA+1)
      IF(I.EQ.M) FA=FA-2.0D 0+EXP(DBLE(J)/DBLE(M+1))
      IF(J.EQ.1) FA=FA-1.0D 0
      IF(J.GT.1) FA=FA-X(KA-M)
      IF(J.LT.M) FA=FA-X(KA+M)
      IF(J.EQ.M) FA=FA-2.0D 0+EXP(DBLE(I)/DBLE(M+1))
      IF (F.LT.ABS(FA)) THEN
        K=KA
        AI=SIGN(1D 0,FA)
        F=ABS(FA)
      ENDIF
  291 CONTINUE
      G(K)=4.0D 0*AI
      J=(K-1)/M+1
      I=K-(J-1)*M
      G(K)=G(K)+(3.0D 0*PAR*X(K)**2/(1.0D 0+PAR*DBLE(I)**2+
     & PAR*DBLE(J)**2))*AI
      IF(I.GT.1) G(K-1)=-AI
      IF(I.LT.M) G(K+1)=-AI
      IF(J.GT.1) G(K-M)=-AI
      IF(J.LT.M) G(K+M)=-AI
      RETURN
  300 DO 301 KA=1,5*N/2-5
      I=2*((KA+4)/5)
      IF (MOD(KA,5).EQ.1) THEN
      FA=(EXP(X(I-1))-X(I))**2
      ELSEIF (MOD(KA,5).EQ.2) THEN
      FA=1.0D 1*(X(I)-X(I+1))**3
      ELSEIF (MOD(KA,5).EQ.3) THEN
      P=X(I+1)-X(I+2)
      FA=(SIN(P)/COS(P))**2
      ELSEIF (MOD(KA,5).EQ.4) THEN
      FA=X(I-1)**4
      ELSE
      FA=X(I+2)-1.0D 0
      ENDIF
      AI=SIGN(1D 0,FA)
      F=F+ABS(FA)
      IF (MOD(KA,5).EQ.1) THEN
      A=EXP(X(I-1))
      B=A-X(I)
      C=2.0D 0*B
      G(I-1)=G(I-1)+C*A*AI
      G(I)=G(I)-C*AI
      ELSEIF (MOD(KA,5).EQ.2) THEN
      A=X(I)-X(I+1)
      B=3.0D 1*A**2
      G(I)=G(I)+B*AI
      G(I+1)=G(I+1)-B*AI
      ELSEIF (MOD(KA,5).EQ.3) THEN
      C=X(I+1)-X(I+2)
      Q=SIN(C)/COS(C)
      R=COS(C)
      D=2.0D 0*Q/R**2
      G(I+1)=G(I+1)+D*AI
      G(I+2)=G(I+2)-D*AI
      ELSEIF (MOD(KA,5).EQ.4) THEN
      G(I-1)=G(I-1)+4.0D 0*X(I-1)**3*AI
      ELSE
      G(I+2)=G(I+2)+AI
      ENDIF
  301 CONTINUE
      RETURN
  310 DO 311 KA=1,2*N-2
      I=(KA+1)/2
      J=MOD(KA,2)
      IF (J.EQ.0) THEN
      FA=6.0D 0-EXP(2.0D 0*X(I))-EXP(2.0D 0*X(I+1))
      ELSEIF (I.EQ.1) THEN
      FA=4.0D 0-EXP(X(I))-EXP(X(I+1))
      ELSEIF (I.EQ.N) THEN
      FA=8.0D 0-EXP(3.0D 0*X(I-1))-EXP(3.0D 0*X(I))
      ELSE
      FA=8.0D 0-EXP(3.0D 0*X(I-1))-EXP(3.0D 0*X(I))+
     & 4.0D 0-EXP(X(I))-EXP(X(I+1))
      ENDIF
      AI=SIGN(1D 0,FA)
      F=F+ABS(FA)
      IF (J.EQ.0) THEN
      G(I)=G(I)-2.0D 0*EXP(2.0D 0*X(I))*AI
      G(I+1)=G(I+1)-2.0D 0*EXP(2.0D 0*X(I+1))*AI
      ELSEIF (I.EQ.1) THEN
      G(I)=G(I)-EXP(X(I))*AI
      G(I+1)=G(I+1)-EXP(X(I+1))*AI
      ELSEIF (I.EQ.N) THEN
      G(I-1)=G(I-1)-3.0D 0*EXP(3.0D 0*X(I-1))*AI
      G(I)=G(I)-3.0D 0*EXP(3.0D 0*X(I))*AI
      ELSE
      G(I-1)=G(I-1)-3.0D 0*EXP(3.0D 0*X(I-1))*AI
      G(I)=G(I)-3.0D 0*EXP(3.0D 0*X(I))*AI-EXP(X(I))*AI
      G(I+1)=G(I+1)-EXP(X(I+1))*AI
      ENDIF
  311 CONTINUE
      RETURN
      END
