* SUBROUTINE EFFU14                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF MODEL FUNCTIONS FOR UNCONSTRAINED MINIMIZATION.
*  SPARSE VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  F  VALUE OF THE MODEL FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EFFU14(N,X,F,NEXT)
      INTEGER N,NEXT
      REAL*8 X(N),F
      REAL*8 A,B,C,D,P,Q,R,U,V
      INTEGER I,J,K
      F=0.0D 0
      GO TO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     &  170,180,190,200,210,220),NEXT
   10 DO 11 J=2,N
      A=X(J-1)**2-X(J)
      B=X(J-1)-1.0D 0
      F=F+1.0D 2*A**2+B**2
   11 CONTINUE
      RETURN
   20 DO 21 J=2,N-2,2
      A=X(J-1)**2-X(J)
      B=X(J-1)-1.0D 0
      C=X(J+1)**2-X(J+2)
      D=X(J+1)-1.0D 0
      U=X(J)+X(J+2)-2.0D 0
      V=X(J)-X(J+2)
      F=F+1.0D 2*A**2+B**2+9.0D 1*C**2+D**2+
     &  1.0D 1*U**2+0.1D 0*V**2
   21 CONTINUE
      RETURN
   30 DO 31 J=2,N-2,2
      A=X(J-1)+1.0D 1*X(J)
      B=X(J+1)-X(J+2)
      C=X(J)-2.0D 0*X(J+1)
      D=X(J-1)-X(J+2)
      F=F+A**2+5.0D 0*B**2+C**4+1.0D 1*D**4
   31 CONTINUE
      RETURN
   40 DO 41 J=2,N-2,2
      A=EXP(X(J-1))
      B=A-X(J)
      D=X(J)-X(J+1)
      P=X(J+1)-X(J+2)
      Q=SIN(P)/COS(P)
      U=X(J-1)
      V=X(J+2)-1.0D 0
      F=F+B**4+1.0D 2*D**6+Q**4+U**8+V**2
   41 CONTINUE
      RETURN
   50 P=7.0D 0/3.0D 0
      DO 51 J=1,N
      A=(3.0D 0-2.0D 0*X(J))*X(J)+1.0D 0
      IF (J.GT.1) A=A-X(J-1)
      IF (J.LT.N) A=A-X(J+1)
      F=F+ABS(A)**P
   51 CONTINUE
      RETURN
   60 P=7.0D 0/3.0D 0
      DO 62 J=1,N
      A=(2.0D 0+5.0D 0*X(J)**2)*X(J)+1.0D 0
      DO 61 I=MAX(1,J-5),MIN(N,J+1)
      A=A+X(I)*(1.0D 0+X(I))
   61 CONTINUE
      F=F+ABS(A)**P
   62 CONTINUE
      RETURN
   70 P=7.0D 0/3.0D 0
      K=N/2
      DO 71 J=1,N
      A=(3.0D 0-2.0D 0*X(J))*X(J)+1.0D 0
      IF (J.GT.1) A=A-X(J-1)
      IF (J.LT.N) A=A-X(J+1)
      F=F+ABS(A)**P
      IF (J.LE.K) THEN
      F=F+ABS(X(J)+X(J+K))**P
      ENDIF
   71 CONTINUE
      RETURN
   80 K=N/2
      DO 82 J=1,N
      P=0.0D 0
      DO 81 I=J-2,J+2
      IF (I.LT.1.OR.I.GT.N) GO TO 81
      A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(J,5))
      B=DBLE(I+J)/1.0D 1
      P=P+A*SIN(X(I))+B*COS(X(I))
   81 CONTINUE
      IF (J.GT.K) THEN
      I=J-K
      A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(J,5))
      B=DBLE(I+J)/1.0D 1
      P=P+A*SIN(X(I))+B*COS(X(I))
      ELSE
      I=J+K
      A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(J,5))
      B=DBLE(I+J)/1.0D 1
      P=P+A*SIN(X(I))+B*COS(X(I))
      ENDIF
      F=F+(DBLE(N+J)-P)**2/DBLE(N)
   82 CONTINUE
      RETURN
   90 K=N/2
      DO 92 J=1,N
      P=0.0D 0
      DO 91 I=J-2,J+2
      IF (I.LT.1.OR.I.GT.N) GO TO 91
      A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(J,5))
      B=DBLE(I+J)/1.0D 1
      P=P+A*SIN(X(I))+B*COS(X(I))
   91 CONTINUE
      IF (J.GT.K) THEN
      I=J-K
      A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(J,5))
      B=DBLE(I+J)/1.0D 1
      P=P+A*SIN(X(I))+B*COS(X(I))
      ELSE
      I=J+K
      A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(J,5))
      B=DBLE(I+J)/1.0D 1
      P=P+A*SIN(X(I))+B*COS(X(I))
      ENDIF
      F=F+(P+DBLE(J)*(1.0D 0-COS(X(J))))/DBLE(N)
   92 CONTINUE
      RETURN
  100 K=N/2
      DO 102 J=1,N
      P=0.0D 0
      Q=1.0D 0+DBLE(J)/1.0D 1
      DO 101 I=J-2,J+2
      IF (I.LT.1.OR.I.GT.N) GO TO 101
      A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(J,5))
      B=1.0D 0+DBLE(I)/1.0D 1
      C=DBLE(I+J)/1.0D 1
      P=P+A*SIN(Q*X(J)+B*X(I)+C)
  101 CONTINUE
      IF (J.GT.K) THEN
      I=J-K
      A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(J,5))
      B=1.0D 0+DBLE(I)/1.0D 1
      C=DBLE(I+J)/1.0D 1
      P=P+A*SIN(Q*X(J)+B*X(I)+C)
      ELSE
      I=J+K
      A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(J,5))
      B=1.0D 0+DBLE(I)/1.0D 1
      C=DBLE(I+J)/1.0D 1
      P=P+A*SIN(Q*X(J)+B*X(I)+C)
      ENDIF
      F=F+P
  102 CONTINUE
      F=F/DBLE(N)
      RETURN
  110 P=-0.2008D-2
      Q=-0.1900D-2
      R=-0.0261D-2
      DO 112 I=0,N-5,5
      A=1.0D 0
      B=0.0D 0
      DO 111 J=1,5
      A=A*X(I+J)
      B=B+X(I+J)**2
  111 CONTINUE
      A=EXP(A)
      B=B-1.0D 1-P
      C=X(I+2)*X(I+3)-5.0D 0*X(I+4)*X(I+5)-Q
      D=X(I+1)**3+X(I+2)**3+1.0D 0-R
      F=F+A+1.0D 1*(B**2+C**2+D**2)
  112 CONTINUE
      RETURN
  120 DO 121 J=2,N
      A=X(J-1)-3.0D 0
      B=X(J-1)-X(J)
      F=F+A**2+B**2+EXP(2.0D 1*B)
  121 CONTINUE
      RETURN
  130 DO 131 J=2,N
      A=X(J)**2
      B=X(J-1)**2
      C=A+1.0D 0
      D=B+1.0D 0
      F=F+B**C+A**D
  131 CONTINUE
      RETURN
  140 P=1.0D 0/DBLE(N+1)
      Q=0.5D 0*P**2
      DO 141 J=1,N
      A=2.0D 0*X(J)+Q*(X(J)+DBLE(J)*P+1.0D 0)**3
      IF(J.GT.1) A=A-X(J-1)
      IF(J.LT.N) A=A-X(J+1)
      F=F+A**2
  141 CONTINUE
      RETURN
  150 P=1.0D 0/DBLE(N+1)
      Q=2.0D 0/P
      R=2.0D 0*P
      DO 151 J=2,N
      A=X(J-1)-X(J)
      F=F+Q*X(J-1)*A
      IF (ABS(A).LE.1.0D-6) THEN
      F=F+R*EXP(X(J))*(1.0D 0+A/2.0D 0*(1.0D 0+A/3.0D 0*(1.0D 0+
     &  A/4.0D 0)))
      ELSE
      B=EXP(X(J-1))-EXP(X(J))
      F=F+R*B/A
      ENDIF
  151 CONTINUE
      F=F+Q*X(N)**2+R*(EXP(X(1))-1.0D 0)/X(1)
     &             +R*(EXP(X(N))-1.0D 0)/X(N)
      RETURN
  160 DO 161 J=1,N
      A=DBLE(J)*(1.0D 0-COS(X(J)))
      IF(J.GT.1) A=A+DBLE(J)*SIN(X(J-1))
      IF(J.LT.N) A=A-DBLE(J)*SIN(X(J+1))
      F=F+A
  161 CONTINUE
      RETURN
  170 P=1.0D 0/DBLE(N+1)
      DO 171 J=1,N
      IF (J.EQ.1) THEN
      F=F+0.25D 0*X(J)**2/P+1.25D-1*X(J+1)**2/P+
     & P*(EXP(X(J))-1.0D 0)
      ELSE IF (J.EQ.N) THEN
      F=F+0.25D 0*X(J)**2/P+1.25D-1*X(J-1)**2/P+
     & P*(EXP(X(J))-1.0D 0)
      ELSE
      F=F+1.25D-1*(X(J+1)-X(J-1))**2/P+P*(EXP(X(J))-1.0D 0)
      ENDIF
  171 CONTINUE
      RETURN
  180 P=1.0D 0/DBLE(N+1)
      DO 181 J=1,N
      Q=DBLE(J)*P
      IF (J.EQ.1) THEN
      F=F+0.5D 0*X(J)**2/P+0.25D 0*X(J+1)**2/P-
     & P*(X(J)**2+2.0D 0*X(J)*Q)
      ELSE IF (J.EQ.N) THEN
      F=F+0.5D 0*X(J)**2/P+0.25D 0*X(J-1)**2/P-
     & P*(X(J)**2+2.0D 0*X(J)*Q)
      ELSE
      F=F+2.5D-1*(X(J+1)-X(J-1))**2/P-P*(X(J)**2+
     & 2.0D 0*X(J)*Q)
      ENDIF
  181 CONTINUE
      RETURN
  190 P=1.0D 0/DBLE(N+1)
      DO 191 J=1,N
      Q=EXP(2.0D 0*DBLE(J)*P)
      IF (J.EQ.1) THEN
      R=1.0D 0/3.0D 0
      F=F+0.5D 0*(X(J)-R)**2/P+7.0D 0*R**2+
     & 2.5D-1*(X(J+1)-R)**2/P+P*(X(J)**2+2.0D 0*X(J)*Q)
      ELSE IF (J.EQ.N) THEN
      R=EXP(2.0D 0)/3.0D 0
      F=F+0.5D 0*(X(J)-R)**2/P+7.0D 0*R**2+
     & 2.5D-1*(X(J-1)-R)**2/P+P*(X(J)**2+2.0D 0*X(J)*Q)
      ELSE
      F=F+2.5D-1*(X(J+1)-X(J-1))**2/P+P*(X(J)**2+
     & 2.0D 0*X(J)*Q)
      ENDIF
  191 CONTINUE
      RETURN
  200 P=1.0D 0/DBLE(N+1)
      DO 201 J=1,N
      IF (J.EQ.1) THEN
      F=F+(0.5D 0*X(J)**2/P-P)+
     & (2.5D-1*X(J+1)**2/P-P)*EXP(-2.0D 0*X(J)**2)
      ELSE IF (J.EQ.N) THEN
      F=F+(0.5D 0*X(J)**2/P-P)*EXP(-2.0D 0)+
     & (2.5D-1*X(J-1)**2/P-P)*EXP(-2.0D 0*X(J)**2)
      ELSE
      F=F+(2.5D-1*(X(J+1)-X(J-1))**2/P-P)*EXP(-2.0D 0*X(J)**2)
      ENDIF
  201 CONTINUE
      RETURN
  210 P=1.0D 0/DBLE(N+1)
      DO 211 J=1,N
      IF (J.EQ.1) THEN
      A=0.5D 0*(X(J+1)-1.0D 0)/P
      B=(X(J)-1.0D 0)/P
      F=F+P*(X(J)**2+A*ATAN(A)-LOG(SQRT(1.0D 0+A**2)))+
     &   0.5D 0*P*(1.0D 0+B*ATAN(B)-LOG(SQRT(1.0D 0+B**2)))
      ELSE IF (J.EQ.N) THEN
      A=0.5D 0*(2.0D 0-X(J-1))/P
      B=(2.0D 0-X(J))/P
      F=F+P*(X(J)**2+A*ATAN(A)-LOG(SQRT(1.0D 0+A**2)))+
     &   0.5D 0*P*(4.0D 0+B*ATAN(B)-LOG(SQRT(1.0D 0+B**2)))
      ELSE
      A=0.5D 0*(X(J+1)-X(J-1))/P
      F=F+P*(X(J)**2+A*ATAN(A)-LOG(SQRT(1.0D 0+A**2)))
      ENDIF
  211 CONTINUE
      RETURN
  220 P=1.0D 0/DBLE(N+1)
      DO 221 J=1,N
      IF (J.EQ.1) THEN
      A= 0.5D 0*X(J+1)/P
      B= X(J)/P
      F=F+P*(1.0D 2*(X(J)-A**2)**2+(1.0D 0-A)**2)+
     &   0.5D 0*P*(1.0D 2*B**4+(1.0D 0-B)**2)
      ELSE IF (J.EQ.N) THEN
      A=-0.5D 0*X(J-1)/P
      B=-X(J)/P
      F=F+P*(1.0D 2*(X(J)-A**2)**2+(1.0D 0-A)**2)+
     &   0.5D 0*P*(1.0D 2*B**4+(1.0D 0-B)**2)
      ELSE
      A=0.5D 0*(X(J+1)-X(J-1))/P
      F=F+P*(1.0D 2*(X(J)-A**2)**2+(1.0D 0-A)**2)
      ENDIF
  221 CONTINUE
      RETURN
      END
