* SUBROUTINE EFHD01                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  HESSIAN MATRICES OF MODEL FUNCTIONS FOR UNCONSTRAINED MINIMIZATION.
*  DENSE VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  H(N*(N+1)/2)  HESSIAN MATRIX OF THE MODEL FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EFHD01(N,X,H,NEXT)
      INTEGER N,NEXT
      REAL*8 X(N),H(N*(N+1)/2)
      REAL*8 A,B,C,D,P,Q,R,SX(1000),CX(1000)
      INTEGER I,J,IN,K
      IN(I,J)=(J-1)*J/2+I
      DO 1 I=1,N*(N+1)/2
        H(I)=0.0D0
    1 CONTINUE
      GOTO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150),NEXT
   10 DO 11 I=2,N
        H(IN(I-1,I-1))=H(IN(I-1,I-1))+1.2D3*X(I-1)**2
     *                   -4D2*X(I)+2D0
        H(IN(I-1,I))=H(IN(I-1,I))-4D2*X(I-1)
        H(IN(I,I))=H(IN(I,I))+2D2
   11 CONTINUE
      RETURN
   20 DO 21 I=1,N-3,2
        H(IN(I,I))=H(IN(I,I))-4D2*X(I+1)+1.2D3*X(I)**2+2D0
        H(IN(I,I+1))=H(IN(I,I+1))-4D2*X(I)
        H(IN(I+1,I+1))=H(IN(I+1,I+1))+2.202D2
        H(IN(I+1,I+3))=H(IN(I+1,I+3))+1.98D1
        H(IN(I+2,I+2))=H(IN(I+2,I+2))+1.08D3*X(I+2)**2
     *                   -3.6D2*X(I+3)+2D0
        H(IN(I+2,I+3))=H(IN(I+2,I+3))-3.6D2*X(I+2)
        H(IN(I+3,I+3))=H(IN(I+3,I+3))+2.002D2
   21 CONTINUE
      RETURN
   30 DO 31 I=1,N-3,2
        A=1.2D2*(X(I)-X(I+3))**2
        B=1.2D1*(X(I+1)-2D0*X(I+2))**2
        H(IN(I,I))=H(IN(I,I))+A+2D0
        H(IN(I,I+1))=H(IN(I,I+1))+2D1
        H(IN(I,I+3))=H(IN(I,I+3))-A
        H(IN(I+1,I+1))=H(IN(I+1,I+1))+2D2+B
        H(IN(I+1,I+2))=H(IN(I+1,I+2))-2D0*B
        H(IN(I+2,I+2))=H(IN(I+2,I+2))+1D1+4D0*B
        H(IN(I+2,I+3))=H(IN(I+2,I+3))-1D1
        H(IN(I+3,I+3))=H(IN(I+3,I+3))+1D1+A
   31 CONTINUE
      RETURN
   40 DO 41 I=1,N-3,2
        A=(EXP(X(I))-X(I+1))**2
        B=3D3*(X(I+1)-X(I+2))**4
        C=(X(I+2)-X(I+3))
        D=4D0*(3D0+2D0*SIN(C)**2)*SIN(C)**2/COS(C)**6
        H(IN(I,I))=H(IN(I,I))+4D0*EXP(X(I))*A*(4D0*EXP(X(I))
     *               -X(I+1))+5.6D1*X(I)**6
        H(IN(I,I+1))=H(IN(I,I+1))-1.2D1*EXP(X(I))*A
        H(IN(I+1,I+1))=H(IN(I+1,I+1))+1.2D1*A+B
        H(IN(I+1,I+2))=H(IN(I+1,I+2))-B
        H(IN(I+2,I+2))=H(IN(I+2,I+2))+B+D
        H(IN(I+2,I+3))=H(IN(I+2,I+3))-D
        H(IN(I+3,I+3))=H(IN(I+3,I+3))+D+2D0
   41 CONTINUE
      RETURN
   50 P=7D0/3D0
      DO 51 I=1,N
        A=(3D0-2D0*X(I))*X(I)+1D0
        IF (I.GT.1) A=A-X(I-1)
        IF (I.LT.N) A=A-X(I+1)
        B=P*(P-1D0)*ABS(A)**(P-2D0)
        C=(3D0-4D0*X(I))
        IF (I.GT.1) THEN
          H(IN(I-1,I-1))=H(IN(I-1,I-1))+B
          IF (I.LT.N) H(IN(I-1,I+1))=H(IN(I-1,I+1))+B
          H(IN(I-1,I))=H(IN(I-1,I))-B*C
        ENDIF
        H(IN(I,I))=H(IN(I,I))+B*C**2
     *                -4D0*SIGN(1D0,A)*P*ABS(A)**(P-1D0)
        IF (I.LT.N) THEN
          H(IN(I,I+1))=H(IN(I,I+1))-B*C
          H(IN(I+1,I+1))=H(IN(I+1,I+1))+B
        ENDIF
   51 CONTINUE
      RETURN
   60 P=7D0/3D0
      DO 61 I=1,N
        A=0D0
        DO 62 J=MAX(1,I-5),MIN(N,I+1)
          A=A+X(J)*(1D0+X(J))
   62   CONTINUE
        A=A+1D0+X(I)*(2D0+5D0*X(I)**2)
        B=SIGN(1D0,A)*P*ABS(A)**(P-1D0)
        C=P*(P-1D0)*ABS(A)**(P-2D0)
        D=(1.5D1*X(I)**2+2D0*X(I)+3D0)
        H(IN(I,I))=H(IN(I,I))+C*D**2+B*(3D1*X(I)+2D0)
        DO 63 J=MAX(1,I-5),MIN(N,I+1)
          IF (I.LT.J) H(IN(I,J))=H(IN(I,J))+C*D*(1D0+2D0*X(J))
          IF (J.LT.I) H(IN(J,I))=H(IN(J,I))+C*D*(1D0+2D0*X(J))
          IF (J.NE.I) THEN
            H(IN(J,J))=H(IN(J,J))+C*(1D0+2D0*X(J))**2+2D0*B
            DO 64 K=J+1,MIN(N,I+1)
              IF (K.NE.I) H(IN(J,K))=H(IN(J,K))
     *              + C* (1D0+2D0*X(J)) * (1D0+2D0*X(K))
   64       CONTINUE
          ENDIF
   63   CONTINUE
   61 CONTINUE
      RETURN
   70 P=7D0/3D0
      DO 71 I=1,N
        A=(3D0-2D0*X(I))*X(I)+1D0
        IF (I.GT.1) A=A-X(I-1)
        IF (I.LT.N) A=A-X(I+1)
        B=P*(P-1D0)*ABS(A)**(P-2D0)
        C=3D0-4D0*X(I)
        IF (I.GT.1) THEN
          H(IN(I-1,I-1))=H(IN(I-1,I-1))+B
          H(IN(I-1,I))=H(IN(I-1,I))-B*C
          IF (I.LT.N) H(IN(I-1,I+1))=H(IN(I-1,I+1))+B
        ENDIF
        H(IN(I,I))=H(IN(I,I))+B*C**2
     *                -4D0*SIGN(1D0,A)*P*ABS(A)**(P-1D0)
        IF (I.LT.N) THEN
          H(IN(I,I+1))=H(IN(I,I+1))-B*C
          H(IN(I+1,I+1))=H(IN(I+1,I+1))+B
        ENDIF
   71 CONTINUE
      J=N/2
      DO 72 I=1,J
        A=X(I)+X(I+J)
        B=(P-1D0)*P*ABS(A)**(P-2D0)
        H(IN(I,I))=H(IN(I,I))+B
        H(IN(I,I+J))=H(IN(I,I+J))+B
        H(IN(I+J,I+J))=H(IN(I+J,I+J))+B
   72 CONTINUE
      RETURN
   80 DO 85 J=1,N
      SX(J)=SIN(X(J))
      CX(J)=COS(X(J))
   85 CONTINUE
      DO 81 I=1,N
        R=0D0
        DO 84 J=1,N
          A=5D0*(1D0+MOD(I,5)+MOD(J,5))
          B=DBLE(I+J)/1D1
          R=R+A*SX(J)+B*CX(J)
   84   CONTINUE
        R=2D0*(DBLE(N+I)-R)
        DO 82 J=1,N
          A=5D0*(1D0+MOD(I,5)+MOD(J,5))
          B=DBLE(I+J)/1D1
          H(IN(J,J))=H(IN(J,J))+R*(A*SX(J)+B*CX(J))
          P=A*CX(J)-B*SX(J)
          DO 83 K=J,N
            C=1D1*(1D0+MOD(I,5)+MOD(K,5))
            D=DBLE(I+K)/5D0
            Q=C*CX(K)-D*SX(K)
            H(IN(J,K))=H(IN(J,K))+P*Q
   83     CONTINUE
   82   CONTINUE
   81 CONTINUE
      RETURN
   90 DO 91 I=1,N
        DO 92 J=1,N
          IF (MOD( ABS(I-J),4 ).NE.0) GOTO 92
          B=1D0+I/1D1
          C=1D0+J/1D1
          A=-5D0*(1D0+MOD(I,5)+MOD(J,5))
     *      *SIN(B*X(I)+C*X(J)+(I+J)/1D1)
          IF (I.NE.J) THEN
            IF (I.LT.J) THEN
              H(IN(I,J))=H(IN(I,J))+A*B*C
            ELSE
              H(IN(J,I))=H(IN(J,I))+A*B*C
            ENDIF
            H(IN(I,I))=H(IN(I,I))+A*B**2
            H(IN(J,J))=H(IN(J,J))+A*C**2
          ELSE
            H(IN(I,I))=H(IN(I,I))+4D0*A*B**2
          ENDIF
   92   CONTINUE
   91 CONTINUE
      RETURN
  100 D=1D3
      DO 101 J=1,N
        DO 102 K=J,N
          IF (J.EQ.K) THEN
            A=0D0
            B=0D0
            DO 103 I=1,N
              A=A+1D0/X(I)
              B=B+I/X(I)
  103       CONTINUE
            H(IN(K,K))=H(IN(K,K))+2D0*D*( (1D0/X(K)**2)**2
     *                             - (1D0-A)*(2D0/X(K)**3) )
     *                           +2D0*D*( (J/X(K)**2)**2
     *                             - (1D0-B)*(2D0*K/X(K)**3) )
          ELSE
            H(IN(J,K))=H(IN(J,K))
     *                      +2D0*D*(1D0+J*K)/(X(J)**2*X(K)**2)
          ENDIF
  102   CONTINUE
  101 CONTINUE
      RETURN
  110 DO 111 I=1,N-4,5
        Q=X(I)*X(I+1)*X(I+2)*X(I+3)*X(I+4)
        A=EXP(Q)
        B=X(I)**2+X(I+1)**2+X(I+2)**2+X(I+3)**2+X(I+4)**2
     *     -1D1+2.008D-3
        C=X(I+1)*X(I+2)-5D0*X(I+3)*X(I+4)+1.9D-3
        D=X(I)**3+X(I+1)**3+1D0+2.61D-4
        DO 112 J=I,I+4
          H(IN(J,J))=H(IN(J,J))+A*(Q/X(J))**2
     *               +1D1*(8D0*X(J)**2+4D0*B)
          DO 113 K=J+1,I+4
            H(IN(J,K))=H(IN(J,K))+A*Q*(1D0+Q)/(X(J)*X(K))
  113     CONTINUE
  112   CONTINUE
        H(IN(I,I))=H(IN(I,I))+1.8D2*X(I)**4+1.2D2*X(I)*D
        H(IN(I,I+1))=H(IN(I,I+1))+1.8D2*(X(I)*X(I+1))**2
        DO 114 J=I+1,I+4
          H(IN(I,J))=H(IN(I,J))+8D1*X(I)*X(J)
  114   CONTINUE
        H(IN(I+1,I+1))=H(IN(I+1,I+1))+2D1*X(I+2)**2
     *                 +1.8D2*X(I+1)**4+1.2D1*D*X(I+1)
        H(IN(I+1,I+2))=H(IN(I+1,I+2))+8D1*X(I+1)*X(I+2)
     *                 +2D1*X(I+1)*X(I+2)+2D1*C
        H(IN(I+1,I+3))=H(IN(I+1,I+3))+8D1*X(I+1)*X(I+3)
     *                 -1D2*X(I+2)*X(I+4)
        H(IN(I+1,I+4))=H(IN(I+1,I+4))+8D1*X(I+1)*X(I+4)
     *                 -1D2*X(I+2)*X(I+3)
        H(IN(I+2,I+2))=H(IN(I+2,I+2))+2D1*X(I+1)**2
        H(IN(I+2,I+3))=H(IN(I+2,I+3))+8D1*X(I+2)*X(I+3)
     *                 -1D2*X(I+1)*X(I+4)
        H(IN(I+2,I+4))=H(IN(I+2,I+4))+8D1*X(I+2)*X(I+4)
     *                 -1D2*X(I+1)*X(I+3)
        H(IN(I+3,I+3))=H(IN(I+3,I+3))+5D2*X(I+4)**2
        H(IN(I+3,I+4))=H(IN(I+3,I+4))+8D1*X(I+3)*X(I+4)
     *                 +5D2*X(I+3)*X(I+4)-1D2*C
        H(IN(I+4,I+4))=H(IN(I+4,I+4))+5D2*X(I+3)**2
  111 CONTINUE
      RETURN
  120 DO 121 I=1,N-1,2
        A=4D2*EXP( 2D1*(X(I)-X(I+1)) )
        DO 122 J=I,N-1,2
          H(IN(I,J))=H(IN(I,J))+2D0
  122   CONTINUE
        H(IN(I,I))=H(IN(I,I))+2D-4+A
        H(IN(I,I+1))=H(IN(I,I+1))-A
        H(IN(I+1,I+1))=H(IN(I+1,I+1))+A
  121 CONTINUE
      RETURN
  130 DO 131 I=1,N-1,2
        A=X(I)**2
        B=X(I+1)**2
        C=0D0
        IF (A.GT.C) C=LOG(A)
        D=0D0
        IF (B.GT.D) D=LOG(B)
        H(IN(I,I))=H(IN(I,I)) + 2D0*(B+1D0)
     *                                *(2D0*B+1D0)*A**B
     *           + 2D0*D*(2D0*A*D+1D0)*B**(A+1D0)
        H(IN(I,I+1))=H(IN(I,I+1))+4D0*X(I)*X(I+1)
     *                *((1D0+(B+1D0)*C)*A**B
     *                         + (1D0+(A+1D0)*D)*B**A)
        H(IN(I+1,I+1))=H(IN(I+1,I+1)) + 2D0*(A+1D0)
     *                                 *(2D0*A+1D0)*B**A
     *                                + 2D0*C*(2D0*B*C+1D0)
     *                                 *A**(B+1D0)
  131 CONTINUE
      RETURN
  140 Q=1D0/DBLE(N+1)
      P=5D-1*Q**2
      DO 141 I=1,N
        B=(X(I)+I*Q+1D0)
        C=3D0*Q**2 *B**2 +4D0
        A=2D0*X(I) + Q**2 * (X(I)+I*Q+1)**3/2D0
        IF (I.GT.1) A=A-X(I-1)
        IF (I.LT.N) A=A-X(I+1)
        IF (I.GT.1) THEN
          H(IN(I-1,I-1))=H(IN(I-1,I-1))+2D0
          H(IN(I-1,I))=H(IN(I-1,I))-C
          IF (I.LT.N) H(IN(I-1,I+1))=H(IN(I-1,I+1))+2D0
        ENDIF
        H(IN(I,I))=H(IN(I,I))+ C**2/2D0 + 6D0*A*B*Q**2
        IF (I.LT.N) THEN
          H(IN(I,I+1))=H(IN(I,I+1))-C
          H(IN(I+1,I+1))=H(IN(I+1,I+1))+2D0
        ENDIF
  141 CONTINUE
      RETURN
  150 Q= 2.0D0*DBLE(N+1)
      R=-6.8D0/DBLE(N+1)
      DO 151 I=1,N-1
        A=X(I+1)-X(I)
        B=EXP(X(I))
        C=EXP(X(I+1))
        H(IN(I,I))=H(IN(I,I))+2D0*Q
        H(IN(I,I+1))=H(IN(I,I+1))-Q
        IF (ABS(A).LE.1D-6) THEN
        H(IN(I,I))=H(IN(I,I))
     *            +R*B*(1D0/3D0+A/12D0)
        H(IN(I,I+1))=H(IN(I,I+1))
     *              +R*B*(1D0/6D0+A/12D0)
        H(IN(I+1,I+1))=H(IN(I+1,I+1))
     *                +R*B*(1D0/3D0+A/4D0)
        ELSE
        H(IN(I,I))=H(IN(I,I))
     *            +(2D0*((C-B)/A-B)/A-B)*R/A
        H(IN(I,I+1))=H(IN(I,I+1))
     *              +B*R*(1D0+2D0/A)/A**2
     *              +C*R*(1D0-2D0/A)/A**2
        H(IN(I+1,I+1))=H(IN(I+1,I+1))
     *                +(2D0*((C-B)/A-C)/A+C)*R/A
        ENDIF
  151 CONTINUE
      H(IN(1,1))=H(IN(1,1))
     *          +((2D0/X(1)-2D0)/X(1)+1D0)*R*EXP(X(1))/X(1)
     *          -2D0*R/X(1)**3
      H(IN(N,N))=H(IN(N,N))+2D0*Q
     *          +((2D0/X(N)-2D0)/X(N)+1D0)*R*EXP(X(N))/X(N)
     *         - 2D0*R/X(N)**3
      RETURN
      END
