* SUBROUTINE EICS39                ALL SYSTEMS                94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF THE VARIABLES AND STRUCTURE OF THE SPARSE HESSIAN
*  MATRIX FOR COMPLEMENTARITY PROBLEMS.
*
* PARAMETERS :
*  IU  N  NUMBER OF VARIABLES.
*  IU  NC  NUMBER OF CONSTRAINTS.
*  IU  NCC  NUMBER OF COMPLEMENTARITY CONSTRAINTS.
*  IU  MC  NUMBER OF ELEMENTS OF THE SPARSE JACOBIAN MATRIX.
*  IO  IC(NC+1)  POINTERS OF THE FIRST ELEMENTS IN ROWS OF THE
*         JACOBIAN MATRIX.
*  IO  JC(MC)  INDICES OF THE NONZERO ELEMENTS OF THE JACOBIAN MATRIX IN
*             THE PACKED ROW.
*  IO  IC(2*NCC) INDICES OF COMPLEMENTARITY FUNCTIONS
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EICS39(N,NC,NCC,MC,IC,JC,ICC,NEXT)
      INTEGER N,NC,NCC,MC,IC(NC+1),JC(MC),ICC(2*NCC),NEXT,I,J
      INTEGER TIMENN(66)
      INTEGER ARCSNETI(14),ARCSNETJ(14),ARCSFLI(44),ARCSFLJ(44)
C
      DATA (TIMENN(I),I=1,66) / 5,6,5,6,6,5,7,9,8,9,7,8,8,7,3,4,3,4,
     &                     14,14,12,6,12,8,13,13,13,8,15,11,15,4,11,
     &                          1,1,2,2,5,6,5,5,6,6,9,9,7,8,7,7,8,8,
     &                     2,10,10,14,14,12,12,6,8,13,13,13,8,15,15 /
      DATA (ARCSNETI(I),I=1,14) / 1,1,1,2,2,2,2,3,3,3,3,6,6,5 /
      DATA (ARCSNETJ(I),I=1,14) / 4,3,8,8,3,6,7,4,5,6,8,7,5,4 /
      DATA (ARCSFLI(I),I=1,44)
     & / 1,1,2,2,2,3,3,3,3,4,4,4,4,5,5,5,5,6,6,6,7,7,
     &   7,8,8,9,9,10,13,14,14,15,15,16,18,19,20,22,23,23,25,27,27,28 /
      DATA (ARCSFLJ(I),I=1,44) / 10,16,11,12,17,16,14,17,20,15,18,19,
     & 22,19,21,22,24,21,25,26,24,26,28,23,25,27,28,11,12,16,10,17,13,
     & 20,13,17,21,18,20,25,28,22,24,27 /
C
      GOTO (10,20,30,40), NEXT
   10 NC=70
      NCC=32
      DO I=1,14
        ICC(I)=-(54+I)
        ICC(NCC+I)=I
        ICC(16+I)=-(72+I)
        ICC(NCC+16+I)=18+I
      ENDDO
      ICC(15)=-69
      ICC(NCC+15)=15
      ICC(16)=-71
      ICC(NCC+16)=17
      ICC(31)=-88
      ICC(NCC+31)=34
      ICC(32)=-90
      ICC(NCC+32)=36
      MC=0
      IC(1)=1
      DO I=1,18
        JC(MC+1)=I
        JC(MC+2)=18+I
        IF (TIMENN(I).LT.TIMENN(I+33)) THEN
          JC(MC+3)=36+TIMENN(I)
          JC(MC+4)=36+TIMENN(I+33)
        ELSE
          JC(MC+3)=36+TIMENN(I+33)
          JC(MC+4)=36+TIMENN(I)
        ENDIF
        MC=MC+4
        IC(I+1)=MC+1
      ENDDO
      DO I=19,36
        JC(MC+1)=I-18
        JC(MC+2)=I
        IF (TIMENN(I-18).LT.TIMENN(I+15)) THEN
          JC(MC+3)=45+TIMENN(I-18)
          JC(MC+4)=45+TIMENN(I+15)
        ELSE
          JC(MC+3)=45+TIMENN(I+15)
          JC(MC+4)=45+TIMENN(I-18)
        ENDIF
        MC=MC+4
        IC(I+1)=MC+1
      ENDDO
      DO I=37,54
        JC(MC+1)=I-36
        JC(MC+2)=I+18
        JC(MC+3)=I+36
        MC=MC+3
        IC(I+1)=MC+1
      ENDDO
      JC(MC+1)=55
      JC(MC+2)=56
      MC=MC+2
      IC(56)=MC+1
      JC(MC+1)=57
      JC(MC+2)=58
      MC=MC+2
      IC(57)=MC+1
      JC(MC+1)=70
      JC(MC+2)=72
      MC=MC+2
      IC(58)=MC+1
      JC(MC+1)=55
      JC(MC+2)=57
      JC(MC+3)=59
      JC(MC+4)=60
      JC(MC+5)=61
      JC(MC+6)=62
      MC=MC+6
      IC(59)=MC+1
      JC(MC+1)=56
      JC(MC+2)=58
      JC(MC+3)=59
      JC(MC+4)=60
      JC(MC+5)=63
      JC(MC+6)=64
      MC=MC+6
      IC(60)=MC+1
      JC(MC+1)=61
      JC(MC+2)=65
      JC(MC+3)=67
      JC(MC+4)=68
      JC(MC+5)=69
      MC=MC+5
      IC(61)=MC+1
      JC(MC+1)=63
      JC(MC+2)=66
      JC(MC+3)=67
      JC(MC+4)=68
      JC(MC+5)=71
      MC=MC+5
      IC(62)=MC+1
      JC(MC+1)=62
      JC(MC+2)=64
      JC(MC+3)=65
      JC(MC+4)=66
      MC=MC+4
      IC(63)=MC+1
      JC(MC+1)=73
      JC(MC+2)=74
      MC=MC+2
      IC(64)=MC+1
      JC(MC+1)=75
      JC(MC+2)=76
      MC=MC+2
      IC(65)=MC+1
      JC(MC+1)=88
      JC(MC+2)=90
      MC=MC+2
      IC(66)=MC+1
      JC(MC+1)=73
      JC(MC+2)=75
      JC(MC+3)=77
      JC(MC+4)=78
      JC(MC+5)=79
      JC(MC+6)=80
      MC=MC+6
      IC(67)=MC+1
      JC(MC+1)=74
      JC(MC+2)=76
      JC(MC+3)=77
      JC(MC+4)=78
      JC(MC+5)=81
      JC(MC+6)=82
      MC=MC+6
      IC(68)=MC+1
      JC(MC+1)=79
      JC(MC+2)=83
      JC(MC+3)=85
      JC(MC+4)=86
      JC(MC+5)=87
      MC=MC+5
      IC(69)=MC+1
      JC(MC+1)=81
      JC(MC+2)=84
      JC(MC+3)=85
      JC(MC+4)=86
      JC(MC+5)=89
      MC=MC+5
      IC(70)=MC+1
      JC(MC+1)=80
      JC(MC+2)=82
      JC(MC+3)=83
      JC(MC+4)=84
      MC=MC+4
      IC(71)=MC+1
      RETURN
   20 NC=174
      NCC=83
      DO I=1,14
        ICC(I)=-(111+I)
        ICC(NCC+I)=I
        ICC(26+I)=-(144+I)
        ICC(NCC+26+I)=33+I
        ICC(55+I)=-(177+I)
        ICC(NCC+55+I)=66+I
      ENDDO
      ICC(15)=-126
      ICC(NCC+15)=15
      ICC(16)=-128
      ICC(NCC+16)=17
      ICC(41)=-160
      ICC(NCC+41)=49
      DO I=1,10
        ICC(16+I)=-129-I
        ICC(NCC+16+I)=18+I
        ICC(41+I)=-161-I
        ICC(NCC+41+I)=50+I
        ICC(69+I)=-195-I
        ICC(NCC+69+I)=84+I
      ENDDO
      DO I=1,2
        ICC(51+I)=-171-I
        ICC(NCC+51+I)=60+I
        ICC(53+I)=-174-I
        ICC(NCC+53+I)=63+I
        ICC(79+I)=-205-I
        ICC(NCC+79+I)=94+I
      ENDDO
      ICC(82)=-208
      ICC(NCC+82)=97
      ICC(83)=-210
      ICC(NCC+83)=99
      MC=0
      IC(1)=1
      DO I=1,33
        JC(MC+1)=I
        JC(MC+2)=33+I
        IF (TIMENN(I).LT.TIMENN(I+33)) THEN
          JC(MC+3)=36+TIMENN(I)
          JC(MC+4)=36+TIMENN(I+33)
        ELSE
          JC(MC+3)=36+TIMENN(I+33)
          JC(MC+4)=36+TIMENN(I)
        ENDIF
        MC=MC+4
        IC(I+1)=MC+1
      ENDDO
      DO I=34,66
        JC(MC+1)=I-33
        JC(MC+2)=I
        IF (TIMENN(I-33).LT.TIMENN(I)) THEN
          JC(MC+3)=81+TIMENN(I-33)
          JC(MC+4)=81+TIMENN(I)
        ELSE
          JC(MC+3)=81+TIMENN(I)
          JC(MC+4)=81+TIMENN(I-33)
        ENDIF
        MC=MC+4
        IC(I+1)=MC+1
      ENDDO
      DO I=67,99
        JC(MC+1)=I-66
        JC(MC+2)=I-33
        IF (TIMENN(I-66).LT.TIMENN(I-33)) THEN
          JC(MC+3)=96+TIMENN(I-66)
          JC(MC+4)=96+TIMENN(I-33)
        ELSE
          JC(MC+3)=96+TIMENN(I-33)
          JC(MC+4)=96+TIMENN(I-66)
        ENDIF
        MC=MC+4
        IC(I+1)=MC+1
      ENDDO
      DO I=100,132
        JC(MC+1)=I-99
        JC(MC+2)=I+12
        JC(MC+3)=I+45
        JC(MC+4)=I+78
        MC=MC+4
        IC(I+1)=MC+1
      ENDDO
      JC(MC+1)=112
      JC(MC+2)=113
      MC=MC+2
      IC(134)=MC+1
      JC(MC+1)=114
      JC(MC+2)=115
      JC(MC+3)=130
      MC=MC+3
      IC(135)=MC+1
      JC(MC+1)=127
      JC(MC+2)=129
      JC(MC+3)=143
      MC=MC+3
      IC(136)=MC+1
      JC(MC+1)=112
      JC(MC+2)=114
      JC(MC+3)=116
      JC(MC+4)=117
      JC(MC+5)=118
      JC(MC+6)=119
      MC=MC+6
      IC(137)=MC+1
      JC(MC+1)=113
      JC(MC+2)=115
      JC(MC+3)=116
      JC(MC+4)=117
      JC(MC+5)=120
      JC(MC+6)=121
      JC(MC+7)=133
      JC(MC+8)=137
      MC=MC+8
      IC(138)=MC+1
      JC(MC+1)=118
      JC(MC+2)=122
      JC(MC+3)=124
      JC(MC+4)=125
      JC(MC+5)=126
      JC(MC+6)=127
      MC=MC+6
      IC(139)=MC+1
      JC(MC+1)=120
      JC(MC+2)=123
      JC(MC+3)=124
      JC(MC+4)=125
      JC(MC+5)=128
      JC(MC+6)=129
      JC(MC+7)=135
      JC(MC+8)=138
      JC(MC+9)=139
      JC(MC+10)=142
      MC=MC+10
      IC(140)=MC+1
      JC(MC+1)=119
      JC(MC+2)=121
      JC(MC+3)=122
      JC(MC+4)=123
      MC=MC+4
      IC(141)=MC+1
      JC(MC+1)=131
      JC(MC+2)=132
      MC=MC+2
      IC(142)=MC+1
      JC(MC+1)=141
      JC(MC+2)=144
      MC=MC+2
      IC(143)=MC+1
      JC(MC+1)=132
      JC(MC+2)=134
      JC(MC+3)=135
      JC(MC+4)=136
      MC=MC+4
      IC(144)=MC+1
      JC(MC+1)=136
      JC(MC+2)=137
      JC(MC+3)=138
      JC(MC+4)=139
      JC(MC+5)=140
      JC(MC+6)=141
      MC=MC+6
      IC(145)=MC+1
      JC(MC+1)=130
      JC(MC+2)=131
      JC(MC+3)=133
      JC(MC+4)=134
      MC=MC+4
      IC(146)=MC+1
      JC(MC+1)=140
      JC(MC+2)=142
      JC(MC+3)=143
      JC(MC+4)=144
      MC=MC+4
      IC(147)=MC+1
      JC(MC+1)=145
      JC(MC+2)=146
      MC=MC+2
      IC(148)=MC+1
      JC(MC+1)=147
      JC(MC+2)=148
      JC(MC+3)=163
      MC=MC+3
      IC(149)=MC+1
      JC(MC+1)=160
      JC(MC+2)=162
      JC(MC+3)=176
      MC=MC+3
      IC(150)=MC+1
      JC(MC+1)=145
      JC(MC+2)=147
      JC(MC+3)=149
      JC(MC+4)=150
      JC(MC+5)=151
      JC(MC+6)=152
      MC=MC+6
      IC(151)=MC+1
      JC(MC+1)=146
      JC(MC+2)=148
      JC(MC+3)=149
      JC(MC+4)=150
      JC(MC+5)=153
      JC(MC+6)=154
      JC(MC+7)=166
      JC(MC+8)=170
      MC=MC+8
      IC(152)=MC+1
      JC(MC+1)=151
      JC(MC+2)=155
      JC(MC+3)=157
      JC(MC+4)=158
      JC(MC+5)=159
      JC(MC+6)=160
      MC=MC+6
      IC(153)=MC+1
      JC(MC+1)=153
      JC(MC+2)=156
      JC(MC+3)=157
      JC(MC+4)=158
      JC(MC+5)=161
      JC(MC+6)=162
      JC(MC+7)=168
      JC(MC+8)=171
      JC(MC+9)=172
      JC(MC+10)=175
      MC=MC+10
      IC(154)=MC+1
      JC(MC+1)=152
      JC(MC+2)=154
      JC(MC+3)=155
      JC(MC+4)=156
      MC=MC+4
      IC(155)=MC+1
      JC(MC+1)=164
      JC(MC+2)=165
      MC=MC+2
      IC(156)=MC+1
      JC(MC+1)=174
      JC(MC+2)=177
      MC=MC+2
      IC(157)=MC+1
      JC(MC+1)=165
      JC(MC+2)=167
      JC(MC+3)=168
      JC(MC+4)=169
      MC=MC+4
      IC(158)=MC+1
      JC(MC+1)=169
      JC(MC+2)=170
      JC(MC+3)=171
      JC(MC+4)=172
      JC(MC+5)=173
      JC(MC+6)=174
      MC=MC+6
      IC(159)=MC+1
      JC(MC+1)=163
      JC(MC+2)=164
      JC(MC+3)=166
      JC(MC+4)=167
      MC=MC+4
      IC(160)=MC+1
      JC(MC+1)=173
      JC(MC+2)=175
      JC(MC+3)=176
      JC(MC+4)=177
      MC=MC+4
      IC(161)=MC+1
      JC(MC+1)=178
      JC(MC+2)=179
      MC=MC+2
      IC(162)=MC+1
      JC(MC+1)=180
      JC(MC+2)=181
      JC(MC+3)=196
      MC=MC+3
      IC(163)=MC+1
      JC(MC+1)=193
      JC(MC+2)=195
      JC(MC+3)=209
      MC=MC+3
      IC(164)=MC+1
      JC(MC+1)=178
      JC(MC+2)=180
      JC(MC+3)=182
      JC(MC+4)=183
      JC(MC+5)=184
      JC(MC+6)=185
      MC=MC+6
      IC(165)=MC+1
      JC(MC+1)=179
      JC(MC+2)=181
      JC(MC+3)=182
      JC(MC+4)=183
      JC(MC+5)=186
      JC(MC+6)=187
      JC(MC+7)=199
      JC(MC+8)=203
      MC=MC+8
      IC(166)=MC+1
      JC(MC+1)=184
      JC(MC+2)=188
      JC(MC+3)=190
      JC(MC+4)=191
      JC(MC+5)=192
      JC(MC+6)=193
      MC=MC+6
      IC(167)=MC+1
      JC(MC+1)=186
      JC(MC+2)=189
      JC(MC+3)=190
      JC(MC+4)=191
      JC(MC+5)=194
      JC(MC+6)=195
      JC(MC+7)=201
      JC(MC+8)=204
      JC(MC+9)=205
      JC(MC+10)=208
      MC=MC+10
      IC(168)=MC+1
      JC(MC+1)=185
      JC(MC+2)=187
      JC(MC+3)=188
      JC(MC+4)=189
      MC=MC+4
      IC(169)=MC+1
      JC(MC+1)=197
      JC(MC+2)=198
      MC=MC+2
      IC(170)=MC+1
      JC(MC+1)=207
      JC(MC+2)=210
      MC=MC+2
      IC(171)=MC+1
      JC(MC+1)=198
      JC(MC+2)=200
      JC(MC+3)=201
      JC(MC+4)=202
      MC=MC+4
      IC(172)=MC+1
      JC(MC+1)=202
      JC(MC+2)=203
      JC(MC+3)=204
      JC(MC+4)=205
      JC(MC+5)=206
      JC(MC+6)=207
      MC=MC+6
      IC(173)=MC+1
      JC(MC+1)=196
      JC(MC+2)=197
      JC(MC+3)=199
      JC(MC+4)=200
      MC=MC+4
      IC(174)=MC+1
      JC(MC+1)=206
      JC(MC+2)=208
      JC(MC+3)=209
      JC(MC+4)=210
      MC=MC+4
      IC(175)=MC+1
      RETURN
   30 NC=22
      NCC=14
      DO I=1,28
        ICC(I)=-I
      ENDDO
      MC=0
      IC(1)=1
      DO I=1,14
        JC(MC+1)=I
        JC(MC+2)=I+14
        JC(MC+3)=I+28
        IF (ARCSNETI(I).LT.ARCSNETJ(I)) THEN
          JC(MC+4)=42+ARCSNETI(I)
          JC(MC+5)=42+ARCSNETJ(I)
        ELSE
          JC(MC+4)=42+ARCSNETJ(I)
          JC(MC+5)=42+ARCSNETI(I)
        ENDIF
        MC=MC+5
        IC(I+1)=MC+1
      ENDDO
      DO I=1,3
        JC(MC+I)=I
        JC(MC+I+3)=14+I
      ENDDO
      JC(MC+7)=51
      MC=MC+7
      IC(16)=MC+1
      DO I=1,4
        JC(MC+I)=3+I
        JC(MC+I+4)=17+I
      ENDDO
      JC(MC+9)=52
      MC=MC+9
      IC(17)=MC+1
      JC(MC+1)=2
      JC(MC+2)=5
      JC(MC+3)=8
      JC(MC+4)=9
      JC(MC+5)=10
      JC(MC+6)=11
      JC(MC+7)=16
      JC(MC+8)=19
      JC(MC+9)=22
      JC(MC+10)=23
      JC(MC+11)=24
      JC(MC+12)=25
      MC=MC+12
      IC(18)=MC+1
      JC(MC+1)=1
      JC(MC+2)=8
      JC(MC+3)=14
      JC(MC+4)=15
      JC(MC+5)=22
      JC(MC+6)=28
      MC=MC+6
      IC(19)=MC+1
      JC(MC+1)=9
      JC(MC+2)=13
      JC(MC+3)=14
      JC(MC+4)=23
      JC(MC+5)=27
      JC(MC+6)=28
      MC=MC+6
      IC(20)=MC+1
      JC(MC+1)=6
      JC(MC+2)=10
      JC(MC+3)=12
      JC(MC+4)=13
      JC(MC+5)=20
      JC(MC+6)=24
      JC(MC+7)=26
      JC(MC+8)=27
      MC=MC+8
      IC(21)=MC+1
      JC(MC+1)=7
      JC(MC+2)=12
      JC(MC+3)=21
      JC(MC+4)=26
      MC=MC+4
      IC(22)=MC+1
      JC(MC+1)=3
      JC(MC+2)=4
      JC(MC+3)=11
      JC(MC+4)=17
      JC(MC+5)=18
      JC(MC+6)=25
      MC=MC+6
      IC(23)=MC+1
      RETURN
   40 NC=72
      NCC=44
      DO I=1,88
        ICC(I)=-I
      ENDDO
      MC=0
      IC(1)=1
      DO I=1,44
        JC(MC+1)=I
        JC(MC+2)=I+44
        JC(MC+3)=I+88
        IF (ARCSFLI(I).LT.ARCSFLJ(I)) THEN
          JC(MC+4)=132+ARCSNETI(I)
          JC(MC+5)=132+ARCSNETJ(I)
        ELSE
          JC(MC+4)=132+ARCSNETJ(I)
          JC(MC+5)=132+ARCSNETI(I)
        ENDIF
        MC=MC+5
        IC(I+1)=MC+1
      ENDDO
      DO I=1,2
        JC(MC+I)=I
        JC(MC+I+2)=44+I
      ENDDO
      JC(MC+5)=161
      MC=MC+5
      IC(46)=MC+1
      DO I=1,3
        JC(MC+I)=2+I
        JC(MC+I+3)=46+I
      ENDDO
      JC(MC+7)=162
      MC=MC+7
      IC(47)=MC+1
      DO I=1,4
        JC(MC+I)=5+I
        JC(MC+I+4)=49+I
      ENDDO
      JC(MC+9)=163
      MC=MC+9
      IC(48)=MC+1
      DO I=1,4
        JC(MC+I)=9+I
        JC(MC+I+4)=53+I
      ENDDO
      JC(MC+9)=164
      MC=MC+9
      IC(49)=MC+1
      DO I=1,4
        JC(MC+I)=13+I
        JC(MC+I+4)=57+I
      ENDDO
      JC(MC+9)=165
      MC=MC+9
      IC(50)=MC+1
      DO I=1,3
        JC(MC+I)=17+I
        JC(MC+I+3)=61+I
      ENDDO
      JC(MC+7)=166
      MC=MC+7
      IC(51)=MC+1
      DO I=1,3
        JC(MC+I)=20+I
        JC(MC+I+3)=64+I
      ENDDO
      JC(MC+7)=167
      MC=MC+7
      IC(52)=MC+1
      DO I=1,2
        JC(MC+I)=23+I
        JC(MC+I+2)=67+I
      ENDDO
      JC(MC+5)=168
      MC=MC+5
      IC(53)=MC+1
      DO I=1,2
        JC(MC+I)=25+I
        JC(MC+I+2)=69+I
      ENDDO
      JC(MC+5)=162
      MC=MC+5
      IC(54)=MC+1
      JC(MC+1)=1
      JC(MC+2)=28
      JC(MC+3)=31
      JC(MC+4)=45
      JC(MC+5)=72
      JC(MC+6)=75
      MC=MC+6
      IC(55)=MC+1
      JC(MC+1)=3
      JC(MC+2)=28
      JC(MC+3)=47
      JC(MC+4)=72
      MC=MC+4
      IC(56)=MC+1
      JC(MC+1)=4
      JC(MC+2)=29
      JC(MC+3)=48
      JC(MC+4)=73
      MC=MC+4
      IC(57)=MC+1
      JC(MC+1)=29
      JC(MC+2)=33
      JC(MC+3)=35
      JC(MC+4)=73
      JC(MC+5)=77
      JC(MC+6)=79
      MC=MC+6
      IC(58)=MC+1
      JC(MC+1)=7
      JC(MC+2)=30
      JC(MC+3)=31
      JC(MC+4)=51
      JC(MC+5)=74
      JC(MC+6)=75
      MC=MC+6
      IC(59)=MC+1
      JC(MC+1)=10
      JC(MC+2)=32
      JC(MC+3)=33
      JC(MC+4)=54
      JC(MC+5)=76
      JC(MC+6)=77
      MC=MC+6
      IC(60)=MC+1
      JC(MC+1)=2
      JC(MC+2)=6
      JC(MC+3)=30
      JC(MC+4)=34
      JC(MC+5)=46
      JC(MC+6)=50
      JC(MC+7)=74
      JC(MC+8)=78
      MC=MC+8
      IC(61)=MC+1
      JC(MC+1)=5
      JC(MC+2)=8
      JC(MC+3)=32
      JC(MC+4)=36
      JC(MC+5)=49
      JC(MC+6)=52
      JC(MC+7)=76
      JC(MC+8)=80
      MC=MC+8
      IC(62)=MC+1
      JC(MC+1)=11
      JC(MC+2)=35
      JC(MC+3)=38
      JC(MC+4)=55
      JC(MC+5)=79
      JC(MC+6)=82
      MC=MC+6
      IC(63)=MC+1
      JC(MC+1)=12
      JC(MC+2)=14
      JC(MC+3)=36
      JC(MC+4)=56
      JC(MC+5)=58
      JC(MC+6)=80
      MC=MC+6
      IC(64)=MC+1
      JC(MC+1)=9
      JC(MC+2)=34
      JC(MC+3)=37
      JC(MC+4)=39
      JC(MC+5)=53
      JC(MC+6)=78
      JC(MC+7)=81
      JC(MC+8)=83
      MC=MC+8
      IC(65)=MC+1
      JC(MC+1)=15
      JC(MC+2)=18
      JC(MC+3)=37
      JC(MC+4)=59
      JC(MC+5)=62
      JC(MC+6)=81
      MC=MC+6
      IC(66)=MC+1
      JC(MC+1)=13
      JC(MC+2)=16
      JC(MC+3)=38
      JC(MC+4)=42
      JC(MC+5)=57
      JC(MC+6)=60
      JC(MC+7)=82
      JC(MC+8)=86
      MC=MC+8
      IC(67)=MC+1
      JC(MC+1)=24
      JC(MC+2)=39
      JC(MC+3)=40
      JC(MC+4)=68
      JC(MC+5)=83
      JC(MC+6)=84
      MC=MC+6
      IC(68)=MC+1
      JC(MC+1)=17
      JC(MC+2)=21
      JC(MC+3)=43
      JC(MC+4)=61
      JC(MC+5)=65
      JC(MC+6)=87
      MC=MC+6
      IC(69)=MC+1
      JC(MC+1)=19
      JC(MC+2)=25
      JC(MC+3)=40
      JC(MC+4)=41
      JC(MC+5)=63
      JC(MC+6)=69
      JC(MC+7)=84
      JC(MC+8)=85
      MC=MC+8
      IC(70)=MC+1
      JC(MC+1)=20
      JC(MC+2)=22
      JC(MC+3)=64
      JC(MC+4)=66
      MC=MC+4
      IC(71)=MC+1
      JC(MC+1)=26
      JC(MC+2)=42
      JC(MC+3)=43
      JC(MC+4)=44
      JC(MC+5)=70
      JC(MC+6)=86
      JC(MC+7)=87
      JC(MC+8)=88
      MC=MC+8
      IC(72)=MC+1
      JC(MC+1)=23
      JC(MC+2)=27
      JC(MC+3)=41
      JC(MC+4)=44
      JC(MC+5)=67
      JC(MC+6)=71
      JC(MC+7)=85
      JC(MC+8)=88
      MC=MC+8
      IC(72)=MC+1
      RETURN
      END
