* SUBROUTINE EILD05                ALL SYSTEMS                90/12/01
C PORTABILITY : ALL SYSTEMS
C 90/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF THE VARIABLES FOR CONSTRAINED MINIMIZATION.
*  DENSE VERSION OF LINEAR PROGRAMMING.
*
* PARAMETERS :
*  IO  NF  NUMBER OF VARIABLES.
*  IO  NC  NUMBER OF CONSTRAINTS.
*  II  NCL  NUMBER OF LINEAR CONSTRAINTS.
*  RO  X(NF)  VECTOR OF VARIABLES.
*  IO  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RO  XL(NF)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RO  XU(NF)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  IO  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RO  CL(NC)  VECTOR CONTAINING LOWER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RO  CU(NC)  VECTOR CONTAINING UPPER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RO  CG(NF*NC) MATRIX WHOSE COLUMNS ARE NORMALS OF THE LINEAR
*         CONSTRAINTS.
*  RO  GF(NF)  LINEAR TERM OF THE QUADRATIC OBJECTIVE FUNCTION.
*  RO  HF(NF*(NF+1)/2))  HESSIAN MATRIX OF THE QUADRATIC OBJECTIVE
*         FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EILD05(NF,NC,NCL,X,IX,XL,XU,IC,CL,CU,CG,FF,GF,HF,FMIN,
     & XMAX,NEXT,IEXT,IERR)
      INTEGER NF,NC,NCL,IX(NF),IC(NC),NEXT,IEXT,IERR
      REAL*8 X(NF),XL(NF),XU(NF),CL(NC),CU(NC),CG(NF*NC),FF,GF(NF),
     & HF(NF*(NF+1)/2),FMIN,XMAX
      INTEGER I
      REAL*8 ETA9
      PARAMETER (ETA9=1.0D 60)
      FF=0.0D 0
      FMIN=-ETA9
      XMAX=ETA9
      IERR=0
      GO TO (10,20,30,40,50) NEXT
   10 NF=3
      NC=2
      NCL=2
      IC(1)=5
      IC(2)=5
      CL(1)=13.0D 0
      CU(1)=13.0D 0
      CL(2)=11.0D 0
      CU(2)=11.0D 0
      CG(1)=3.0D 0
      CG(2)=3.0D 0
      CG(3)=1.0D 0
      CG(4)=2.0D 0
      CG(5)=3.0D 0
      CG(6)=2.0D 0
      GF(1)=-24.0D 0
      GF(2)=-29.0D 0
      GF(3)=2.0D 0
      HF(1)=4.0D 0
      HF(2)=4.0D 0
      HF(3)=10.0D 0
      HF(4)=-4.0D 0
      HF(5)=-8.0D 0
      HF(6)=10.0D 0
      IEXT=0
      GO TO 1
   20 NF=3
      NC=2
      NCL=2
      IC(1)=2
      IC(2)=2
      CU(1)=14.0D 0
      CU(2)=15.0D 0
      CG(1)=4.0D 0
      CG(2)=3.0D 0
      CG(3)=2.0D 0
      CG(4)=3.0D 0
      CG(5)=1.0D 0
      CG(6)=5.0D 0
      GF(1)=-15.0D 0
      GF(2)=-9.0D 0
      GF(3)=-15.0D 0
      HF(1)=4.0D 0
      HF(2)=-2.0D 0
      HF(3)=4.0D 0
      HF(4)=2.0D 0
      HF(5)=-2.0D 0
      HF(6)=4.0D 0
      IEXT=0
      GO TO 1
   30 NF=3
      NC=2
      NCL=2
      IC(1)=1
      IC(2)=1
      CL(1)=15.0D 0
      CL(2)=15.0D 0
      CG(1)=2.0D 0
      CG(2)=3.0D 0
      CG(3)=2.0D 0
      CG(4)=3.0D 0
      CG(5)=2.0D 0
      CG(6)=3.0D 0
      GF(1)=13.0D 0
      GF(2)=-18.0D 0
      GF(3)=-5.0D 0
      HF(1)=4.0D 0
      HF(2)=-4.0D 0
      HF(3)=10.0D 0
      HF(4)=-2.0D 0
      HF(5)=4.0D 0
      HF(6)=4.0D 0
      IEXT=0
      GO TO 1
   40 NF=5
      NC=3
      NCL=3
      IC(1)=5
      IC(2)=5
      IC(3)=5
      CL(1)=0.0D 0
      CU(1)=0.0D 0
      CL(2)=0.0D 0
      CU(2)=0.0D 0
      CL(3)=0.0D 0
      CU(3)=0.0D 0
      CG(1)=1.0D 0
      CG(2)=3.0D 0
      CG(3)=0.0D 0
      CG(4)=0.0D 0
      CG(5)=0.0D 0
      CG(6)=0.0D 0
      CG(7)=0.0D 0
      CG(8)=1.0D 0
      CG(9)=1.0D 0
      CG(10)=-2.0D 0
      CG(11)=0.0D 0
      CG(12)=1.0D 0
      CG(13)=0.0D 0
      CG(14)=-1.0D 0
      CG(15)=0.0D 0
      GF(1)=0.0D 0
      GF(2)=-4.0D 0
      GF(3)=-4.0D 0
      GF(4)=-2.0D 0
      GF(5)=-2.0D 0
      HF(1)=1.0D 0
      HF(2)=-1.0D 0
      HF(3)=2.0D 0
      HF(4)=0.0D 0
      HF(5)=1.0D 0
      HF(6)=1.0D 0
      HF(7)=0.0D 0
      HF(8)=0.0D 0
      HF(9)=0.0D 0
      HF(10)=1.0D 0
      HF(11)=0.0D 0
      HF(12)=0.0D 0
      HF(13)=0.0D 0
      HF(14)=0.0D 0
      HF(15)=1.0D 0
      IEXT=0
      GO TO 1
   50 NF=9
      NC=9
      NCL=9
      IC(1)=2
      IC(2)=2
      IC(3)=2
      IC(4)=1
      IC(5)=1
      IC(6)=1
      IC(7)=5
      IC(8)=5
      IC(9)=5
      CU(1)=27.8D 1
      CU(2)=18.2D 1
      CU(3)=18.2D 1
      CL(4)=28.3D 1
      CL(5)=27.7D 1
      CL(6)=18.8D 1
      CL(7)=8.9D 1
      CU(7)=8.9D 1
      CL(8)=9.3D 1
      CU(8)=9.3D 1
      CL(9)=9.1D 1
      CU(9)=9.1D 1
      CG(1)=6.0D 0
      CG(2)=9.0D 0
      CG(3)=3.0D 0
      CG(4)=3.0D 0
      CG(5)=8.0D 0
      CG(6)=9.0D 0
      CG(7)=3.0D 0
      CG(8)=3.0D 0
      CG(9)=9.0D 0
      CG(10)=4.0D 0
      CG(11)=5.0D 0
      CG(12)=2.0D 0
      CG(13)=2.0D 0
      CG(14)=6.0D 0
      CG(15)=6.0D 0
      CG(16)=2.0D 0
      CG(17)=2.0D 0
      CG(18)=6.0D 0
      CG(19)=4.0D 0
      CG(20)=6.0D 0
      CG(21)=2.0D 0
      CG(22)=2.0D 0
      CG(23)=6.0D 0
      CG(24)=6.0D 0
      CG(25)=2.0D 0
      CG(26)=1.0D 0
      CG(27)=6.0D 0
      CG(28)=6.0D 0
      CG(29)=9.0D 0
      CG(30)=3.0D 0
      CG(31)=3.0D 0
      CG(32)=9.0D 0
      CG(33)=8.0D 0
      CG(34)=3.0D 0
      CG(35)=3.0D 0
      CG(36)=9.0D 0
      CG(37)=6.0D 0
      CG(38)=9.0D 0
      CG(39)=3.0D 0
      CG(40)=3.0D 0
      CG(41)=9.0D 0
      CG(42)=9.0D 0
      CG(43)=2.0D 0
      CG(44)=3.0D 0
      CG(45)=9.0D 0
      CG(46)=4.0D 0
      CG(47)=6.0D 0
      CG(48)=1.0D 0
      CG(49)=2.0D 0
      CG(50)=6.0D 0
      CG(51)=6.0D 0
      CG(52)=2.0D 0
      CG(53)=2.0D 0
      CG(54)=6.0D 0
      CG(55)=1.0D 0
      CG(56)=3.0D 0
      CG(57)=1.0D 0
      CG(58)=1.0D 0
      CG(59)=3.0D 0
      CG(60)=3.0D 0
      CG(61)=1.0D 0
      CG(62)=1.0D 0
      CG(63)=3.0D 0
      CG(64)=2.0D 0
      CG(65)=3.0D 0
      CG(66)=1.0D 0
      CG(67)=0.0D 0
      CG(68)=3.0D 0
      CG(69)=3.0D 0
      CG(70)=1.0D 0
      CG(71)=1.0D 0
      CG(72)=3.0D 0
      CG(73)=2.0D 0
      CG(74)=3.0D 0
      CG(75)=1.0D 0
      CG(76)=1.0D 0
      CG(77)=3.0D 0
      CG(78)=3.0D 0
      CG(79)=1.0D 0
      CG(80)=1.0D 0
      CG(81)=2.0D 0
      GF(1)=2.3D 1
      GF(2)=4.3D 1
      GF(3)=1.2D 1
      GF(4)=0.9D 1
      GF(5)=4.5D 1
      GF(6)=4.0D 1
      GF(7)=1.0D 1
      GF(8)=1.9D 1
      GF(9)=3.9D 1
      HF(1)=1.0D 0
      HF(2)=0.0D 0
      HF(3)=1.0D 0
      HF(4)=0.0D 0
      HF(5)=0.0D 0
      HF(6)=1.0D 0
      HF(7)=0.0D 0
      HF(8)=0.0D 0
      HF(9)=0.0D 0
      HF(10)=1.0D 0
      HF(11)=0.0D 0
      HF(12)=0.0D 0
      HF(13)=0.0D 0
      HF(14)=0.0D 0
      HF(15)=1.0D 0
      HF(16)=0.0D 0
      HF(17)=0.0D 0
      HF(18)=0.0D 0
      HF(19)=0.0D 0
      HF(20)=0.0D 0
      HF(21)=1.0D 0
      HF(22)=0.0D 0
      HF(23)=0.0D 0
      HF(24)=0.0D 0
      HF(25)=0.0D 0
      HF(26)=0.0D 0
      HF(27)=0.0D 0
      HF(28)=1.0D 0
      HF(29)=0.0D 0
      HF(30)=0.0D 0
      HF(31)=0.0D 0
      HF(32)=0.0D 0
      HF(33)=0.0D 0
      HF(34)=0.0D 0
      HF(35)=0.0D 0
      HF(36)=1.0D 0
      HF(37)=0.0D 0
      HF(38)=0.0D 0
      HF(39)=0.0D 0
      HF(40)=0.0D 0
      HF(41)=0.0D 0
      HF(42)=0.0D 0
      HF(43)=0.0D 0
      HF(44)=0.0D 0
      HF(45)=1.0D 0
      IEXT=0
      GO TO 1
    1 DO 2 I=1,NF
      X(I)=0.0D 0
      XL(I)=0.0D 0
      XU(I)=0.0D 0
      IX(I)=1
      IF (NEXT.EQ.4) IX(I)=0
    2 CONTINUE
      RETURN
      END
