* SUBROUTINE EILS13                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
*  INPUT MATRICES FOR CONSTRAINED MINIMIZATION.
*  SPARSE VERSION OF PROGRAMMING WITH NONLINEAR OBJECTIVE AND
*  LINEAR CONSTRAINTS.
*
* PARAMETERS :
*  II  NF ESTIMATED NUMBER OF NUMBER OF VARIABLES.
*  II  NC ESTIMATED NUMBER OF CONSTRAINTS.
*  II  MROWS DECLARED NUMBER OF VARIABLES.
*  II  NZ  SIZE OF ARRAYS CG/JCG.
*  IU  ICG(NEST) VECTOR SHOWING BEGINNINGS OF THE INPUT MATRIX ROWS.
*  IU  JCG(NZ) INPUT MATRIX COLUMN INDICES.
*  RU  CG(NZ) INPUT MATRIX VALUES.
*  IO  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS:
*                                     =1 FOR LOWER BOUNDED VARIABLE.
*                                     =2 FOR UPPER BOUNDED VARIABLE.
*                                     =3 FOR LOWER AND UPPER BOUNDED.
*  RO  XL(NF)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RO  XU(NF)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  IO  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS:
*                                     =1 FOR LOWER BOUNDED ROW.
*                                     =2 FOR UPPER BOUNDED ROW.
*                                     =3 FOR LOWER AND UPPER BOUNDED ROW
*  RO  CL(NC)  VECTOR CONTAINING LOWER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RO  CU(NC)  VECTOR CONTAINING UPPER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RO  FMIN  LOWER BOUND FOR THE OBJECTIVE FUNCTION.
*  RO  XMAX  MAXIMUM STEPSIZE.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IER  ERROR INDICATOR: =0 FOR SUCCESFUL WORK, <>0 WHEN SOME
*            ERROR IS DETECTED.
*
      SUBROUTINE EILS13(NF,NC,MROWS,NZ,ICG,JCG,CG,IX,XL,XU,IC,CL,CU,
     & FMIN,XMAX,NEXT,IER)
      INTEGER NF,NC,MROWS,NZ,NEXT,IER
      INTEGER ICG(MROWS),JCG(NZ)
      INTEGER IX(NF),IC(NF)
      REAL*8 CG(NZ),XL(NF),XU(NF),CL(NC),CU(NC)
      REAL*8 FMIN,XMAX,ONE,TWO,THREE
      REAL*8 NGNE,NGT,FTH
      REAL*8 NTW
      INTEGER NDV3
      REAL*8 ZERO,FOUR,FIVE,SIX,SEVEN,EIGHT,TEN
      PARAMETER(NTW=-1.02D 0,ZERO=0.0D 0)
      PARAMETER(ONE=1.0D 0,TWO=2.0D 0,THREE=3.0D 0)
      PARAMETER(FOUR=4.0D 0, FIVE=5.0D 0,SIX=6.0D 0)
      PARAMETER(SEVEN=7.0D 0,EIGHT=8.0D 0,TEN=1.0D 1)
      PARAMETER(NGNE=-1.0D 0,NGT=-0.2D 0,FTH=0.004D 0)
      INTEGER I
      REAL*8 ETA9
      PARAMETER (ETA9=1.0D 60)
      FMIN=-ETA9
      XMAX=ETA9
      IER=0
      GO TO (10,20,30,40,50,60) NEXT
10    CONTINUE
C
C     NUMBER OF EQUATIONS IS 2*NDV3-1
C
      NF=30
      NC=19
      NDV3=NF/3
      DO 15 I=1,NDV3-1
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,I,I,NGNE)
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,I,I+1,ONE)
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,I,I+NDV3,NGT)
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,I+NDV3,I,FTH)
15    CONTINUE
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,NDV3,NDV3+1,ONE)
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,NDV3,2*NDV3+1,NGT)
      DO 16 I=NDV3+1,2*NDV3-1
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,I,I,NTW)
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,I,I+1,ONE)
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,I,I+NDV3+1,NGT)
16    CONTINUE
      IX(1)=3
      XL(1)=10
      XU(1)=10
      DO 17 I=2,NDV3
      IX(I)=3
      XL(I)=-1000
      XU(I)=1000
17    CONTINUE
      DO 18 I=NDV3+1,2*NDV3-1
      IX(I)=1
      XL(I)=-1
18    CONTINUE
      IX(2*NDV3)=3
      XL(2*NDV3)=0
      XU(2*NDV3)=0
      DO 19 I=2*NDV3+1,3*NDV3
      IX(I)=3
      XL(I)=NGT
      XU(I)=-NGT
19    CONTINUE
      DO 1 I=1,NDV3-1
      CL(I)=-TWO
      CU(I)=-TWO
1     CONTINUE
      CL(NDV3)=-0.02D 0
      CU(NDV3)=-0.02D 0
      DO 2 I=NDV3+2,NC
      CL(I)=-0.18D 0
      CU(I)=-0.18D 0
2     CONTINUE
      DO 3 I=1,NC
      IC(I)=3
3     CONTINUE
      CL(1)=0
      CU(1)=0
      CL(NDV3+1)=10.02D 0
      CU(NDV3+1)=10.02D 0
      CL(2*NDV3-1)=-10.18D 0
      CU(2*NDV3-1)=-10.18D 0
      RETURN
   20 CONTINUE
      NC=1
      NF=2
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,1,1,FOUR)
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,1,2,-THREE)
      IC(1)=5
      CL(1)=ZERO
      IX(1)=6
      IX(2)=6
      RETURN
   30 CONTINUE
      NF=39
      NC=25
      NDV3=NF/3
      DO 31 I=1,NDV3-1
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,I,I,NGNE)
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,I,I+1,ONE)
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,I,I+NDV3,NGT)
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,I+NDV3,I,FTH)
31    CONTINUE
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,NDV3,NDV3+1,ONE)
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,NDV3,2*NDV3+1,NGT)
      DO 32 I=NDV3+1,2*NDV3-1
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,I,I,NTW)
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,I,I+1,ONE)
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,I,I+NDV3+1,NGT)
32    CONTINUE
      IX(1)=3
      XL(1)=10
      XU(1)=10
      DO 33 I=2,NDV3
      IX(I)=3
      XL(I)=-1000
      XU(I)=1000
33    CONTINUE
      DO 34 I=NDV3+1,2*NDV3-1
      IX(I)=1
      XL(I)=-1
34    CONTINUE
      IX(2*NDV3)=3
      XL(2*NDV3)=0
      XU(2*NDV3)=0
      DO 35 I=2*NDV3+1,3*NDV3
      IX(I)=3
      XL(I)=NGT
      XU(I)=-NGT
35    CONTINUE
      DO 36 I=1,NDV3-1
      CL(I)=-TWO
      CU(I)=-TWO
36    CONTINUE
      CL(NDV3)=-0.02D 0
      CU(NDV3)=-0.02D 0
      DO 37 I=NDV3+2,NC
      CL(I)=-0.18D 0
      CU(I)=-0.18D 0
37    CONTINUE
      DO 38 I=1,NC
      IC(I)=3
38    CONTINUE
      CL(1)=0
      CU(1)=0
      CL(NDV3+1)=10.02D 0
      CU(NDV3+1)=10.02D 0
      CL(2*NDV3-1)=-10.18D 0
      CU(2*NDV3-1)=-10.18D 0
      RETURN
40    NF=45
      NC=29
      NDV3=NF/3
      DO 41 I=1,NDV3-1
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,I,I,NGNE)
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,I,I+1,ONE)
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,I,I+NDV3,NGT)
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,I+NDV3,I,FTH)
41    CONTINUE
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,NDV3,NDV3+1,ONE)
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,NDV3,2*NDV3+1,NGT)
      DO 42 I=NDV3+1,2*NDV3-1
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,I,I,NTW)
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,I,I+1,ONE)
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,I,I+NDV3+1,NGT)
42    CONTINUE
      IX(1)=3
      XL(1)=10
      XU(1)=10
      DO 43 I=2,NDV3
      IX(I)=3
      XL(I)=-1000
      XU(I)=1000
43    CONTINUE
      DO 44 I=NDV3+1,2*NDV3-1
      IX(I)=1
      XL(I)=-1
44    CONTINUE
      IX(2*NDV3)=3
      XL(2*NDV3)=0
      XU(2*NDV3)=0
      DO 45 I=2*NDV3+1,3*NDV3
      IX(I)=3
      XL(I)=NGT
      XU(I)=-NGT
45    CONTINUE
      DO 46 I=1,NDV3-1
      CL(I)=-TWO
      CU(I)=-TWO
46    CONTINUE
      CL(NDV3)=-0.02D 0
      CU(NDV3)=-0.02D 0
      DO 47 I=NDV3+2,NC
      CL(I)=-0.18D 0
      CU(I)=-0.18D 0
47    CONTINUE
      DO 48 I=1,NC
      IC(I)=3
48    CONTINUE
      CL(1)=0
      CU(1)=0
      CL(NDV3+1)=10.02D 0
      CU(NDV3+1)=10.02D 0
      CL(2*NDV3-1)=-10.18D 0
      CU(2*NDV3-1)=-10.18D 0
      RETURN
50    NF=120
      NC=79
      NDV3=NF/3
      DO 51 I=1,NDV3-1
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,I,I,NGNE)
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,I,I+1,ONE)
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,I,I+NDV3,NGT)
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,I+NDV3,I,FTH)
51    CONTINUE
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,NDV3,NDV3+1,ONE)
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,NDV3,2*NDV3+1,NGT)
      DO 52 I=NDV3+1,2*NDV3-1
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,I,I,NTW)
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,I,I+1,ONE)
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,I,I+NDV3+1,NGT)
52    CONTINUE
      IX(1)=3
      XL(1)=10
      XU(1)=10
      DO 53 I=2,NDV3
      IX(I)=3
      XL(I)=-1000
      XU(I)=1000
53    CONTINUE
      DO 54 I=NDV3+1,2*NDV3-1
      IX(I)=1
      XL(I)=-1
54    CONTINUE
      IX(2*NDV3)=3
      XL(2*NDV3)=0
      XU(2*NDV3)=0
      DO 55 I=2*NDV3+1,3*NDV3
      IX(I)=3
      XL(I)=NGT
      XU(I)=-NGT
55    CONTINUE
      DO 56 I=1,NDV3-1
      CL(I)=-TWO
      CU(I)=-TWO
56    CONTINUE
      CL(NDV3)=-0.02D 0
      CU(NDV3)=-0.02D 0
      DO 57 I=NDV3+2,NC
      CL(I)=-0.18D 0
      CU(I)=-0.18D 0
57    CONTINUE
      DO 58 I=1,NC
      IC(I)=3
58    CONTINUE
      CL(1)=0
      CU(1)=0
      CL(NDV3+1)=10.02D 0
      CU(NDV3+1)=10.02D 0
      CL(2*NDV3-1)=-10.18D 0
      CU(2*NDV3-1)=-10.18D 0
      RETURN
   60 CONTINUE
      NC=1
      NF=3
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,1,1,-ONE)
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,1,2,-TWO)
      CALL UKMCI1(NF,NC,ICG,JCG,CG,1,IER,1,3,-TWO)
      IC(1)=1
      CL(1)=-72.0D0
      IX(1)=3
      IX(2)=3
      IX(3)=3
      XL(1)=ZERO
      XL(2)=ZERO
      XL(3)=ZERO
      XU(1)=20.0D0
      XU(2)=11.0D0
      XU(3)=42.0D0
      RETURN
      END
