* SUBROUTINE EIND07             ALL SYSTEMS                 90/12/01
C PORTABILITY : ALL SYSTEMS
C 90/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF THE VARIABLES FOR NONLINEAR PROGRAMMING.
*  DENSE VERSION.
*
* PARAMETERS :
*  IO  N  NUMBER OF VARIABLES.
*  IO  NC  NUMBER OF CONSTRAINTS.
*  IO  NCL NUMBER OF LINEAR CONSTRAINTS.
*  RO  X(N)  VECTOR OF VARIABLES.
*  IO  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RO  XL(NF)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RO  XU(NF)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  IO  IC(NC)  TYPES OF CONSTRAINTS.
*  RO  CL(NC)  LOWER BOUNDS OF CONSTRAINTS.
*  RO  CU(NC)  UPPER BOUNDS OF CONSTRAINTS.
*  RO  FMIN  LOWER BOUND FOR VALUE OF THE OBJECTIVE FUNCTION.
*  RO  XMAX  MAXIMUM STEPSIZE.
*  IO  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EIND07(N,NC,NCL,X,IX,XL,XU,IC,CL,CU,FMIN,XMAX,NEXT,
     * IEXT,IERR)
      INTEGER I,N,NC,NCL,IX(N),IC(NC),NEXT,IEXT,IERR
      REAL*8 X(N),XL(N),XU(N),CL(NC),CU(NC),FMIN,XMAX
      REAL*8 Y(128)
      COMMON /EMPR07/ Y
      NCL=0
      FMIN=-1.0D 60
      XMAX=1.0D 3
      IEXT=0
      IERR=0
      DO 1 I=1,N
      IX(I)=0
      XL(I)=0.0D 0
      XU(I)=0.0D 0
    1 CONTINUE
      DO 2 I=1,NC
      IC(I)=1
      CL(I)=0.0D 0
      CU(I)=0.0D 0
    2 CONTINUE
      GOTO(10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,170,
     * 180,190,200,210,220,230,240,250,260,270,280,290,300,310,320,330,
     * 340) NEXT
   10 IF(N.GE.2.AND.NC.GE.1) THEN
      N=2
      NC=1
      X(1)=2.0D 0
      X(2)=0.0D 0
      IC(1)=2
      CU(1)=1.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   20 IF(N.GE.2.AND.NC.GE.1) THEN
      N=2
      NC=1
      X(1)=-10.0D 0
      X(2)= 10.0D 0
      IC(1)=2
      CU(1)=1.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   30 IF(N.GE.2.AND.NC.GE.1) THEN
      N=2
      NC=1
      X(1)=0.0D 0
      X(2)=0.0D 0
      IC(1)=2
      CU(1)=25.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   40 IF(N.GE.2.AND.NC.GE.1) THEN
      N=2
      NC=1
      X(1)=-2.0D 0
      X(2)=-2.0D 0
      IX(1)=1
      IX(2)=1
      ELSE
      IERR=1
      ENDIF
      RETURN
   50 IF(N.GE.2.AND.NC.GE.1) THEN
      N=2
      NC=1
      X(1)=4.2D-1
      X(2)=5.0D 0
      IX(1)=1
      IX(2)=1
      XL(1)= 0.4D 0
      XL(2)=-4.0D 0
      CL(1)=0.09D 0
      Y(1)=8.0D 0
      Y(2)=8.0D 0
      Y(3)=10.0D 0
      Y(4)=10.0D 0
      Y(5)=10.0D 0
      Y(6)=10.0D 0
      Y(7)=12.0D 0
      Y(8)=12.0D 0
      Y(9)=12.0D 0
      Y(10)=12.0D 0
      Y(11)=14.0D 0
      Y(12)=14.0D 0
      Y(13)=14.0D 0
      Y(14)=16.0D 0
      Y(15)=16.0D 0
      Y(16)=16.0D 0
      Y(17)=18.0D 0
      Y(18)=18.0D 0
      Y(19)=20.0D 0
      Y(20)=20.0D 0
      Y(21)=20.0D 0
      Y(22)=22.0D 0
      Y(23)=22.0D 0
      Y(24)=22.0D 0
      Y(25)=24.0D 0
      Y(26)=24.0D 0
      Y(27)=24.0D 0
      Y(28)=26.0D 0
      Y(29)=26.0D 0
      Y(30)=26.0D 0
      Y(31)=28.0D 0
      Y(32)=28.0D 0
      Y(33)=30.0D 0
      Y(34)=30.0D 0
      Y(35)=30.0D 0
      Y(36)=32.0D 0
      Y(37)=32.0D 0
      Y(38)=34.0D 0
      Y(39)=36.0D 0
      Y(40)=36.0D 0
      Y(41)=38.0D 0
      Y(42)=38.0D 0
      Y(43)=40.0D 0
      Y(44)=42.0D 0
      Y(45)=0.49D 0
      Y(46)=0.49D 0
      Y(47)=0.48D 0
      Y(48)=0.47D 0
      Y(49)=0.48D 0
      Y(50)=0.47D 0
      Y(51)=0.46D 0
      Y(52)=0.46D 0
      Y(53)=0.45D 0
      Y(54)=0.43D 0
      Y(55)=0.45D 0
      Y(56)=0.43D 0
      Y(57)=0.43D 0
      Y(58)=0.44D 0
      Y(59)=0.43D 0
      Y(60)=0.43D 0
      Y(61)=0.46D 0
      Y(62)=0.45D 0
      Y(63)=0.42D 0
      Y(64)=0.42D 0
      Y(65)=0.43D 0
      Y(66)=0.41D 0
      Y(67)=0.41D 0
      Y(68)=0.40D 0
      Y(69)=0.42D 0
      Y(70)=0.40D 0
      Y(71)=0.40D 0
      Y(72)=0.41D 0
      Y(73)=0.40D 0
      Y(74)=0.41D 0
      Y(75)=0.41D 0
      Y(76)=0.40D 0
      Y(77)=0.40D 0
      Y(78)=0.40D 0
      Y(79)=0.38D 0
      Y(80)=0.41D 0
      Y(81)=0.40D 0
      Y(82)=0.40D 0
      Y(83)=0.41D 0
      Y(84)=0.38D 0
      Y(85)=0.40D 0
      Y(86)=0.40D 0
      Y(87)=0.39D 0
      Y(88)=0.39D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   60 IF(N.GE.2.AND.NC.GE.2) THEN
      N=2
      NC=2
      X(1)=-2.0D 0
      X(2)= 1.0D 0
      IX(1)=3
      IX(2)=2
      XL(1)=-0.5D 0
      XU(1)= 0.5D 0
      XU(2)= 1.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   70 IF(N.GE.2.AND.NC.GE.2) THEN
      N=2
      NC=2
      X(1)=20.1D 0
      X(2)=5.84D 0
      IX(1)=3
      IX(2)=3
      XL(1)=1.3D 1
      XU(1)=1.0D 2
      XL(2)=0.0D 0
      XU(2)=1.0D 2
      IC(2)=2
      CL(1)=1.0D 2
      CU(2)=82.81D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   80 IF(N.GE.2.AND.NC.GE.3) THEN
      N=2
      NC=3
      X(1)=-2.0D 0
      X(2)= 1.0D 0
      IX(1)=3
      XL(1)=-0.5D 0
      XU(1)= 0.5D 0
      CL(3)= 1.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   90 IF(N.GE.2.AND.NC.GE.3) THEN
      N=2
      NC=3
      X(1)=90.0D 0
      X(2)=10.0D 0
      IX(1)=3
      IX(2)=3
      XL(1)=0.0D 0
      XU(1)=75.0D 0
      XL(2)=0.0D 0
      XU(2)=65.0D 0
      CL(1)=700.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  100 IF(N.GE.3.AND.NC.GE.1) THEN
      N=3
      NC=1
      X(1)=1.0D 0
      X(2)=1.0D 0
      X(3)=1.0D 0
      IC(1)=2
      CU(1)=48.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  110 IF(N.GE.3.AND.NC.GE.1) THEN
      N=3
      NC=1
      X(1)=1.0D 0
      X(2)=1.0D 0
      X(3)=1.0D 0
      IX(1)=3
      IX(2)=3
      IX(3)=3
      XL(1)= 1.0D 0
      XU(1)= 1.0D 1
      XL(2)=-1.0D 1
      XU(2)= 1.0D 1
      XL(3)=-1.0D 1
      XU(3)= 1.0D 1
      CL(1)= 1.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  120 IF(N.GE.3.AND.NC.GE.1) THEN
      N=3
      NC=1
      X(1)=1.0D 0
      X(2)=1.0D 0
      X(3)=1.0D 0
      IX(1)=3
      IX(2)=3
      IX(3)=3
      XL(1)=-1.0D 1
      XU(1)= 1.0D 1
      XL(2)= 1.0D 0
      XU(2)= 1.0D 1
      XL(3)=-1.0D 1
      XU(3)= 1.0D 0
      CL(1)= 1.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  130 IF(N.GE.3.AND.NC.GE.1) THEN
      N=3
      NC=1
      X(1)=1.0D 0
      X(2)=1.0D 0
      X(3)=1.0D 0
      IX(1)=1
      IX(2)=1
      IX(3)=1
      XL(1)=1.0D-5
      XL(2)=1.0D-5
      XL(3)=1.0D-5
      IC(1)=2
      CU(1)=1.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  140 IF(N.GE.3.AND.NC.GE.2) THEN
      N=3
      NC=2
      X(1)=0.0D 0
      X(2)=1.05D 0
      X(3)=2.9D 0
      IX(1)=3
      IX(2)=3
      IX(3)=3
      XL(1)=0.0D 0
      XU(1)=1.0D 2
      XL(2)=0.0D 0
      XU(2)=1.0D 2
      XL(3)=0.0D 0
      XU(3)=1.0D 1
      IC(1)=2
      IC(2)=2
      ELSE
      IERR=1
      ENDIF
      RETURN
  150 IF(N.GE.3.AND.NC.GE.7) THEN
      N=3
      NC=7
      X(1)=1745.0D 0
      X(2)=12000.0D 0
      X(3)=110.0D 0
      IX(1)=3
      IX(2)=3
      IX(3)=3
      XL(1)=1.0D-5
      XU(1)=2.0D 3
      XL(2)=1.0D-5
      XU(2)=1.6D 4
      XL(3)=1.0D-5
      XU(3)=1.2D 2
      DO 151 I=1,7
      IC(I)=3
  151 CONTINUE
      CL(1)=0.0D 0
      CL(2)=0.0D 0
      CL(3)=8.5D 1
      CL(4)=9.0D 1
      CL(5)=3.0D 0
      CL(6)=1.0D-2
      CL(7)=1.45D 2
      CU(1)=5.0D 3
      CU(2)=2.0D 3
      CU(3)=9.3D 1
      CU(4)=9.5D 1
      CU(5)=1.2D 1
      CU(6)=4.0D 0
      CU(7)=1.62D 2
      ELSE
      IERR=1
      ENDIF
      RETURN
  160 IF(N.GE.4.AND.NC.GE.1) THEN
      N=4
      NC=1
      X(1)=2.0D 0
      X(2)=4.0D 0
      X(3)=4.0D-2
      X(4)=2.0D 0
      DO 161 I=1,4
      IX(I)=3
      XL(I)=1.0D-5
      XU(I)=1.0D 2
  161 CONTINUE
      XU(3)=1.0D 0
      DO 162 I=2,19
      Y(I)=DBLE(I-1)
      Y(I+38)=LOG(Y(I))
  162 CONTINUE
      Y(1)=0.1D 0
      Y(1+38)=LOG(Y(1))
      Y(20)=0.00189D 0
      Y(21)=0.1038D 0
      Y(22)=0.268D 0
      Y(23)=0.506D 0
      Y(24)=0.577D 0
      Y(25)=0.604D 0
      Y(26)=0.725D 0
      Y(27)=0.898D 0
      Y(28)=0.947D 0
      Y(29)=0.845D 0
      Y(30)=0.702D 0
      Y(31)=0.528D 0
      Y(32)=0.385D 0
      Y(33)=0.257D 0
      Y(34)=0.159D 0
      Y(35)=0.0869D 0
      Y(36)=0.0453D 0
      Y(37)=0.01509D 0
      Y(38)=0.00189D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  170 IF(N.GE.4.AND.NC.GE.2) THEN
      N=4
      NC=2
      X(1)=1.0D 0
      X(2)=1.0D 0
      X(3)=1.0D 0
      X(4)=1.0D 0
      DO 171 I=1,4
      IX(I)=3
      XL(I)=1.0D-3
      XU(I)=DBLE(5-I)*1.0D 5
  171 CONTINUE
      IC(1)=2
      IC(2)=2
      CU(1)=0.0401D 0
      CU(2)=0.010085D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  180 IF(N.GE.4.AND.NC.GE.3) THEN
      N=4
      NC=3
      DO 181 I=1,N
      X(I)=0.0D 0
  181 CONTINUE
      IC(1)=2
      IC(2)=2
      IC(3)=2
      CU(1)=8.0D 0
      CU(2)=1.0D 1
      CU(3)=5.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  190 IF(N.GE.5.AND.NC.GE.3) THEN
      N=5
      NC=3
      X(1)=1.0D 0
      X(2)=1.0D 0
      X(3)=1.0D 0
      X(4)=1.0D 0
      X(5)=1.0D 0
      IC(1)=2
      CU(1)= 2.0D 1
      CL(2)=-2.0D 0
      CL(3)= 5.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  200 IF(N.GE.5.AND.NC.GE.3) THEN
      N=5
      NC=3
      X(1)=78.0D 0
      X(2)=33.0D 0
      X(3)=27.0D 0
      X(4)=27.0D 0
      X(5)=27.0D 0
      DO 201 I=1,5
      IX(I)=3
      XL(I)=27.0D 0
      XU(I)=45.0D 0
  201 CONTINUE
      XL(1)=78.0D 0
      XL(2)=33.0D 0
      XU(1)=10.2D 1
      IC(1)=3
      IC(2)=3
      IC(3)=3
      CL(1)=0.0D 0
      CU(1)=9.2D 1
      CL(2)=9.0D 1
      CU(2)=1.1D 2
      CL(3)=2.0D 1
      CU(3)=2.5D 1
      ELSE
      IERR=1
      ENDIF
      RETURN
  210 IF(N.GE.5.AND.NC.GE.3) THEN
      N=5
      NC=3
      X(1)=2.52D 0
      X(2)=2.0D 0
      X(3)=37.5D 0
      X(4)=9.25D 0
      X(5)=6.8D 0
      DO 211 I=1,5
      IX(I)=3
  211 CONTINUE
      XL(1)=0.0D 0
      XU(1)=1.0D 3
      XL(2)=1.2D 0
      XU(2)=2.4D 0
      XL(3)=2.0D 1
      XU(3)=6.0D 1
      XL(4)=9.0D 0
      XU(4)=9.3D 0
      XL(5)=6.5D 0
      XU(5)=7.0D 0
      IC(1)=3
      IC(2)=3
      IC(3)=3
      CL(1)=0.0D 0
      CU(1)=294.0D 3
      CL(2)=0.0D 0
      CU(2)=294.0D 3
      CL(3)=0.0D 0
      CU(3)=277.2D 3
      ELSE
      IERR=1
      ENDIF
      RETURN
  220 IF(N.GE.5.AND.NC.GE.21) THEN
      N=5
      NC=21
      X(1)=900.0D 0
      X(2)=80.0D 0
      X(3)=115.0D 0
      X(4)=267.0D 0
      X(5)=27.0D 0
      DO 221 I=1,5
      IX(I)=3
  221 CONTINUE
      XL(1)=704.4148D 0
      XU(1)=906.3855D 0
      XL(2)=68.6D 0
      XU(2)=288.88D 0
      XL(3)=0.0D 0
      XU(3)=134.75D 0
      XL(4)=193.0D 0
      XU(4)=287.0966D 0
      XL(5)=25.0D 0
      XU(5)=84.1988D 0
      IC(3)=2
      CU(3)=21.0D 0
      CL(4)=110.6D 0
      DO 222 I=5,21
      IC(I)=3
  222 CONTINUE
      CL(5)= 213.1D 0
      CL(6)= 17.505D 0
      CL(7)= 11.275D 0
      CL(8)= 214.228D 0
      CL(9)= 7.458D 0
      CL(10)= 0.961D 0
      CL(11)= 1.612D 0
      CL(12)= 0.146D 0
      CL(13)= 107.99D 0
      CL(14)= 922.693D 0
      CL(15)= 926.832D 0
      CL(16)= 18.766D 0
      CL(17)= 1072.163D 0
      CL(18)= 8961.448D 0
      CL(19)= 0.063D 0
      CL(20)= 71084.33D 0
      CL(21)= 2.802713D 6
      CU(5)= 405.23D 0
      CU(6)= 1053.6667D 0
      CU(7)= 35.03D 0
      CU(8)= 665.585D 0
      CU(9)= 584.463D 0
      CU(10)= 265.916D 0
      CU(11)= 7.046D 0
      CU(12)= 0.222D 0
      CU(13)= 273.366D 0
      CU(14)= 1286.105D 0
      CU(15)= 1444.046D 0
      CU(16)= 537.141D 0
      CU(17)= 3247.039D 0
      CU(18)= 26844.086D 0
      CU(19)= 0.386D 0
      CU(20)= 1.4D 5
      CU(21)= 1.2146108D 7
      ELSE
      IERR=1
      ENDIF
      RETURN
  230 IF(N.GE.6.AND.NC.GE.2) THEN
      N=6
      NC=2
      X(1)=1.0D 0
      X(2)=1.0D 0
      X(3)=1.0D 0
      X(4)=3.0D 0
      X(5)=0.0D 0
      X(6)=0.5D 0
      IX(6)=3
      XL(6)=4.0D 0
      XU(6)=8.0D 0
      IC(1)=2
      IC(2)=2
      CU(1)=5.0D 0
      CU(2)=1.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  240 IF(N.GE.6.AND.NC.GE.2) THEN
      N=6
      NC=2
      X(1)=5.54D 0
      X(2)=4.4D 0
      X(3)=12.02D 0
      X(4)=11.82D 0
      X(5)=0.702D 0
      X(6)=0.852D 0
      DO 241 I=1,6
      IX(I)=1
  241 CONTINUE
      IC(2)=2
      CL(1)=2.07D 0
      CU(2)=1.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  250 IF(N.GE.6.AND.NC.GE.4) THEN
      N=6
      NC=4
      DO 251 I=1,6
      X(I)=0.0D 0
      IX(I)=3
  251 CONTINUE
      XU(1)=0.31D 0
      XU(2)=0.046D 0
      XU(3)=0.068D 0
      XU(4)=0.042D 0
      XU(5)=0.028D 0
      XU(6)=0.134D-1
      CL(1)=32.97D 0
      CL(2)=25.12D 0
      CL(3)=-124.08D 0
      CL(4)=-173.02D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  260 IF(N.GE.7.AND.NC.GE.4) THEN
      N=7
      NC=4
      X(1)=1.0D 0
      X(2)=2.0D 0
      X(3)=0.0D 0
      X(4)=4.0D 0
      X(5)=0.0D 0
      X(6)=1.0D 0
      X(7)=1.0D 0
      IC(1)=2
      IC(2)=2
      IC(3)=2
      IC(4)=2
      CU(1)=127.0D 0
      CU(2)=282.0D 0
      CU(3)=196.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  270 IF(N.GE.7.AND.NC.GE.5) THEN
      N=7
      NC=5
      DO 271 I=1,7
      X(I)=6.0D 0
      IX(I)=3
      XL(I)=1.0D-1
      XU(I)=1.0D 1
  271 CONTINUE
      XL(7)=1.0D-2
      DO 272 I=1,4
      IC(I)=2
      CU(I)=1.0D 0
  272 CONTINUE
      IC(5)=3
      CL(5)=1.0D 2
      CU(5)=3.0D 3
      ELSE
      IERR=1
      ENDIF
      RETURN
  280 IF(N.GE.8.AND.NC.GE.5) THEN
      N=8
      NC=5
      X(1)=6.0D 0
      X(2)=3.0D 0
      X(3)=0.4D 0
      X(4)=0.2D 0
      X(5)=6.0D 0
      X(6)=6.0D 0
      X(7)=1.0D 0
      X(8)=0.5D 0
      DO 281 I=1,8
      IX(I)=3
      XL(I)=1.0D-1
      XU(I)=1.0D 1
  281 CONTINUE
      DO 282 I=1,4
      IC(I)=2
      CU(I)=1.0D 0
  282 CONTINUE
      IC(5)=3
      CL(5)=1.0D 0
      CU(5)=4.2D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  290 IF(N.GE.8.AND.NC.GE.6) THEN
      N=8
      NC=6
      DO 291 I=1,8
      X(I)=5.0D 3
      IX(I)=3
      XL(I)=1.0D 1
      XU(I)=1.0D 3
  291 CONTINUE
      X(4)=200.0D 0
      X(5)=350.0D 0
      X(6)=150.0D 0
      X(7)=225.0D 0
      X(8)=425.0D 0
      XL(1)=1.0D 2
      XL(2)=1.0D 3
      XL(3)=1.0D 3
      XU(1)=1.0D 4
      XU(2)=1.0D 4
      XU(3)=1.0D 4
      DO 292 I=1,3
      IC(I)=2
      CU(I)=1.0D 0
  292 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  300 IF(N.GE.9.AND.NC.GE.13) THEN
      N=9
      NC=13
      DO 301 I=1,9
      X(I)=1.0D 0
      IX(I)=1
      XL(I)=0.0D 0
      IC(I)=2
      CU(I)=1.0D 0
  301 CONTINUE
      IX(9)=1
      XL(9)=0.0D 0
      IC(13)=2
      ELSE
      IERR=1
      ENDIF
      RETURN
  310 IF(N.GE.10.AND.NC.GE.8) THEN
      N=10
      NC=8
      X(1)=2.0D 0
      X(2)=3.0D 0
      X(3)=5.0D 0
      X(4)=5.0D 0
      X(5)=1.0D 0
      X(6)=2.0D 0
      X(7)=7.0D 0
      X(8)=3.0D 0
      X(9)=6.0D 0
      X(10)=1.0D 1
      DO 311 I=1,8
      IC(I)=2
  311 CONTINUE
      CU(1)=120.0D 0
      CU(2)=40.0D 0
      CU(3)=30.0D 0
      CU(4)=0.0D 0
      CU(5)=105.0D 0
      CU(6)=0.0D 0
      CU(7)=0.0D 0
      CU(8)=12.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  320 IF(N.GE.15.AND.NC.GE.5) THEN
      N=15
      NC=5
      DO 321 I=1,15
      X(I)=0.001D 0
      IX(I)=1
      XL(I)=0.0D 0
  321 CONTINUE
      X(7)=60.0D 0
      CL(1)=15.0D 0
      CL(2)=27.0D 0
      CL(3)=36.0D 0
      CL(4)=18.0D 0
      CL(5)=12.0D 0
      DO 322 I=1,90
      Y(I)=0.0D 0
  322 CONTINUE
      Y(1)=-16.0D 0
      Y(3)=-3.5D 0
      Y(6)= 2.0D 0
      Y(7)=-1.0D 0
      Y(8)=-1.0D 0
      Y(9)= 1.0D 0
      Y(10)= 1.0D 0
      Y(11)= 2.0D 0
      Y(12)=-2.0D 0
      Y(14)=-2.0D 0
      Y(15)=-9.0D 0
      Y(17)=-1.0D 0
      Y(18)=-2.0D 0
      Y(19)= 2.0D 0
      Y(20)= 1.0D 0
      Y(23)= 2.0D 0
      Y(25)=-2.0D 0
      Y(26)=-4.0D 0
      Y(27)=-1.0D 0
      Y(28)=-3.0D 0
      Y(29)= 3.0D 0
      Y(30)= 1.0D 0
      Y(31)= 1.0D 0
      Y(32)= 4.0D 0
      Y(34)=-4.0D 0
      Y(35)= 1.0D 0
      Y(37)=-1.0D 0
      Y(38)=-2.0D 0
      Y(39)= 4.0D 0
      Y(40)= 1.0D 0
      Y(42)= 2.0D 0
      Y(44)=-1.0D 0
      Y(45)=-2.8D 0
      Y(47)=-1.0D 0
      Y(48)=-1.0D 0
      Y(49)= 5.0D 0
      Y(50)= 1.0D 0
      Y(51)=-4.0D 1
      Y(52)=-2.0D 0
      Y(53)=-2.5D-1
      Y(54)=-4.0D 0
      Y(55)=-4.0D 0
      Y(56)=-1.0D 0
      Y(57)=-4.0D 1
      Y(58)=-6.0D 1
      Y(59)= 5.0D 0
      Y(60)= 1.0D 0
      Y(61)= 3.0D 1
      Y(62)=-2.0D 1
      Y(63)=-1.0D 1
      Y(64)= 3.2D 1
      Y(65)=-1.0D 1
      Y(66)=-2.0D 1
      Y(67)= 3.9D 1
      Y(68)=-6.0D 0
      Y(69)=-3.1D 1
      Y(70)= 3.2D 1
      Y(71)=-1.0D 1
      Y(72)=-6.0D 0
      Y(73)= 1.0D 1
      Y(74)=-6.0D 0
      Y(75)=-1.0D 1
      Y(76)= 3.2D 1
      Y(77)=-3.1D 1
      Y(78)=-6.0D 0
      Y(79)= 3.9D 1
      Y(80)=-2.0D 1
      Y(81)=-1.0D 1
      Y(82)= 3.2D 1
      Y(83)=-1.0D 1
      Y(84)=-2.0D 1
      Y(85)= 3.0D 1
      Y(86)= 4.0D 0
      Y(87)= 8.0D 0
      Y(88)= 1.0D 1
      Y(89)= 6.0D 0
      Y(90)= 2.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  330 IF(N.GE.16.AND.NC.GE.19) THEN
      N=16
      NC=19
      X(1)=0.8D 0
      X(2)=0.83D 0
      X(3)=0.85D 0
      X(4)=0.87D 0
      X(5)=0.9D 0
      X(6)=0.1D 0
      X(7)=0.12D 0
      X(8)=0.19D 0
      X(9)=0.25D 0
      X(10)=0.29D 0
      X(11)=512.0D 0
      X(12)=13.1D 0
      X(13)=71.8D 0
      X(14)=640.0D 0
      X(15)=650.0D 0
      X(16)=5.7D 0
      DO 331 I=1,16
      IX(I)=3
  331 CONTINUE
      DO 332 I=1,10
      XL(I)=0.1D 0
      XU(I)=0.9D 0
  332 CONTINUE
      XL(5)=0.9D 0
      XU(5)=1.0D 0
      XL(6)=1.0D-4
      XU(6)=0.1D 0
      XL(11)=1.0D 0
      XU(11)=1.0D 3
      XL(12)=1.0D-6
      XU(12)=5.0D 2
      XL(13)=1.0D 0
      XU(13)=5.0D 2
      DO 333 I=14,15
      XL(I)=5.0D 2
      XU(I)=1.0D 3
  333 CONTINUE
      XL(16)=1.0D-6
      XU(16)=5.0D 2
      DO 334 I=1,19
      IC(I)=2
      CU(I)=1.0D 0
  334 CONTINUE
      DO 335 I=1,5
      Y(I)=1.262626D 0
      Y(I+5)=-1.231060D 0
      Y(I+25)=1.0D 0
      Y(I+34)=0.002D 0
      Y(I+43)=1.D 0
      Y(I+51)=1.D 0
      Y(I+56)=1.D 0
  335 CONTINUE
      DO 336 I=11,23,3
      Y(I)=0.03475D 0
      Y(I+1)=0.975D 0
      Y(I+2)=-0.00975D 0
  336 CONTINUE
      Y(28)=-Y(28)
      Y(30)=0.002D 0
      Y(31)=Y(30)
      Y(32)=-Y(30)
      Y(33)=-Y(30)
      Y(34)=1.0D 0
      Y(37)=1.0D 0
      Y(38)=-Y(38)
      Y(39)=-Y(39)
      Y(40)=1.0D 0
      Y(41)=Y(40)
      Y(42)=5.0D 2
      Y(43)=-Y(42)
      Y(44)=-Y(44)
      Y(47)=Y(42)
      Y(48)=-Y(48)
      Y(49)=Y(43)
      Y(50)=0.9D 0
      Y(51)=0.002D 0
      Y(52)=-Y(51)
      Y(53)=Y(51)
      Y(54)=Y(52)
      ELSE
      IERR=1
      ENDIF
      RETURN
  340 IF(N.GE.20.AND.NC.GE.17) THEN
      N=20
      NC=17
      X(1)=2.0D 0
      X(2)=3.0D 0
      X(3)=5.0D 0
      X(4)=5.0D 0
      X(5)=1.0D 0
      X(6)=2.0D 0
      X(7)=7.0D 0
      X(8)=3.0D 0
      X(9)=6.0D 0
      X(10)=1.0D 1
      X(11)=2.0D 0
      X(12)=2.0D 0
      X(13)=6.0D 0
      X(14)=1.5D 1
      X(15)=1.0D 0
      X(16)=2.0D 0
      X(17)=1.0D 0
      X(18)=2.0D 0
      X(19)=1.0D 0
      X(20)=3.0D 0
      DO 341 I=1,17
      IC(I)=2
  341 CONTINUE
      CU(1)=120.0D 0
      CU(2)=40.0D 0
      CU(3)=30.0D 0
      CU(4)=0.0D 0
      CU(5)=105.0D 0
      CU(6)=0.0D 0
      CU(7)=0.0D 0
      CU(8)=12.0D 0
      CU(9)=0.0D 0
      CU(10)=28.0D 0
      CU(11)=87.0D 0
      CU(12)=10.0D 0
      CU(13)=92.0D 0
      CU(14)=54.0D 0
      CU(15)=68.0D 0
      CU(16)=-19.0D 0
      CU(17)=0.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
      END
