* SUBROUTINE EIUB25                ALL SYSTEMS                99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF VARIABLES AND SPARSITY PATTERN OF THE JACOBIAN
*  MATRIX FOR PARTIALLY SEPARABLE MINIMIZATION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  NB  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  MB  NUMBER OF ELEMENTS OF THE SPARSE JACOBIAN MATRIX.
*  RO  X(N)  VECTOR OF VARIABLES.
*  IO  IH(N+1)  POINTERS OF THE DIAGONAL ELEMENTS OF THE HESSIAN MATRIX.
*  IO  JH(M)  INDICES OF THE NONZERO ELEMENTS OF THE HESSIAN MATRIX IN
*             THE PACKED ROW.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IEXT  TYPE OF EXTREMUM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EIUB25(N,NB,MB,X,IH,JH,FMIN,XMAX,NEXT,IEXT,IERR)
      INTEGER N,NB,MB,NEXT,IEXT,IERR
      INTEGER IH(NB+1),JH(*)
      REAL*8 X(N),FMIN,XMAX
      INTEGER IND(100),I
      COMMON /INDEX/ IND
      DO 1 I=1,44
      IND(I)=I
    1 CONTINUE
      DO 2 I=45,49
      IND(I)=I+1
    2 CONTINUE
      DO 3 I=50,51
      IND(I)=I+2
    3 CONTINUE
      IND(52)=55
      DO 4 I=53,54
      IND(I)=I+4
    4 CONTINUE
      DO 5 I=55,57
      IND(I)=I+5
    5 CONTINUE
      DO 6 I=58,82
      IND(I)=I+6
    6 CONTINUE
      IF (NEXT.LE.22) THEN
      CALL EIUB14(N,NB,MB,X,IH,JH,FMIN,XMAX,NEXT,IEXT,IERR)
      ELSE IF (NEXT.EQ.23) THEN
      IF (N.GE.2) THEN
      N=N-MOD(N,2)
      NB=N
      MB=0
      IH(1)=1
      DO 111 I=1,N
      IF (MOD(I,2).EQ.1) THEN
      X(I)=-1.2D 0
      MB=MB+1
      JH(MB)=I
      MB=MB+1
      JH(MB)=I+1
      ELSE
      X(I)=1.0D 0
      MB=MB+1
      JH(MB)=I-1
      ENDIF
      IH(I+1)=MB+1
  111 CONTINUE
      ELSE
      IERR=1
      ENDIF
      ELSE IF (NEXT.EQ.24) THEN
      IF (N.GE.4) THEN
      N=N-MOD(N,4)
      NB=N
      MB=0
      IH(1)=1
      DO 121 I=1,N
      IF (MOD(I,4).EQ.1) THEN
      X(I)=3.0D 0
      MB=MB+2
      JH(MB-1)=I
      JH(MB)=I+1
      ELSE IF (MOD(I,4).EQ.2) THEN
      X(I)=-1.0D 0
      MB=MB+2
      JH(MB-1)=I+1
      JH(MB)=I+2
      ELSE IF (MOD(I,4).EQ.3) THEN
      X(I)=0.0D 0
      MB=MB+2
      JH(MB-1)=I-1
      JH(MB)=I
      ELSE
      X(I)=1.0D 0
      MB=MB+2
      JH(MB-1)=I-3
      JH(MB)=I
      ENDIF
      IH(I+1)=MB+1
  121 CONTINUE
      XMAX=1.0D 2
      ELSE
      IERR=1
      ENDIF
      ELSE IF (NEXT.EQ.25) THEN
      IF (N.GE.2) THEN
      NB=N
      MB=0
      IH(1)=1
      DO 131 I=1,N
      X(I)=-1.0D 0
      IF (I.GT.1) THEN
      MB=MB+1
      JH(MB)=I-1
      ENDIF
      MB=MB+1
      JH(MB)=I
      IF (I.LT.N) THEN
      MB=MB+1
      JH(MB)=I+1
      ENDIF
      IH(I+1)=MB+1
  131 CONTINUE
      ELSE
      IERR=1
      ENDIF
      ELSE IF (NEXT.EQ.26) THEN
      IF (N.GE.2) THEN
      NB=N
      MB=0
      IH(1)=1
      DO 141 I=1,N
      X(I)=-1.2D 0
      IF (I.GT.1) THEN
      MB=MB+1
      JH(MB)=I-1
      ENDIF
      MB=MB+1
      JH(MB)=I
      IH(I+1)=MB+1
  141 CONTINUE
      X(N)=-1.0D 0
      ELSE
      IERR=1
      ENDIF
      ELSE IF (NEXT.LE.44) THEN
      CALL EIUB15(N,NB,MB,X,IH,JH,FMIN,XMAX,NEXT-22,IEXT,IERR)
      ELSE IF (NEXT.LE.82) THEN
      CALL EIUB18(N,NB,MB,X,IH,JH,FMIN,XMAX,IND(NEXT)-44,IEXT,IERR)
      ENDIF
      RETURN
      END
