* SUBROUTINE EIUD17             ALL SYSTEMS                 95/12/01
C PORTABILITY : ALL SYSTEMS
C 95/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF THE VARIABLES FOR NONLINEAR APPROXIMATION.
*  UNCONSTRAINED AND DENSE VERSION.
*
* PARAMETERS :
*  IO  N  NUMBER OF VARIABLES.
*  IO  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  IO  NAL NUMBER OF LINEAR APPROXIMATED FUNCTIONS.
*  RO  X(N)  VECTOR OF VARIABLES.
*  RO  FMIN  LOWER BOUND FOR VALUE OF THE OBJECTIVE FUNCTION.
*  RO  XMAX  MAXIMUM STEPSIZE.
*  IO  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EIUD17(N,NA,NAL,X,FMIN,XMAX,NEXT,IEXT,IERR)
      INTEGER N,NA,NAL,NEXT,IEXT,IERR
      REAL*8 X(N),FMIN,XMAX
      REAL*8 Y(530),R,W,UNRAN1
      INTEGER I,J,K
      COMMON /EMPR17/ Y
      NAL=0
      FMIN=0.0D 0
      XMAX=1.0D 3
      IEXT=0
      IERR=0
      GOTO(10,10,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     &    170,180,190,200,210,220,230,240,250,260,270,280,290,300),NEXT
   10 IF(N.GE.2) THEN
      N=2
      NA=2
      X(1)=-1.2D 0
      X(2)=1.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   30 IF(N.GE.2) THEN
      N=2
      NA=2
      X(1)=0.0D 0
      X(2)=1.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   40 IF(N.GE.3) THEN
      N=3
      NA=3
      X(1)=0.0D 0
      X(2)=0.0D 0
      X(3)=0.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   50 IF(N.GE.3) THEN
      N=3
      NA=3
      X(1)=1.0D 0
      X(2)=1.0D 0
      X(3)=1.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   60 IF(N.GE.3) THEN
      N=3
      NA=3
      X(1)=0.0D 0
      X(2)=1.0D 1
      X(3)=2.0D 1
      XMAX=1.0D 2
      ELSE
      IERR=1
      ENDIF
      RETURN
   70 IF(N.GE.3) THEN
      N=3
      NA=3
      X(1)=-1.0D 0
      X(2)=0.0D 0
      X(3)=0.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   80 IF(N.GE.4) THEN
      N=4
      NA=4
      X(1)=3.0D 0
      X(2)=-1.0D 0
      X(3)=0.0D 0
      X(4)=1.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   90 IF(N.GE.6) THEN
      N=6
      NA=6
      DO 91 I=1,N
      X(I)=1.0D 0
   91 CONTINUE
      X(2)=2.0D 0
      DO 92 I=1,NA
      W=0.3D 0*DBLE(I)
      Y(I)=EXP(-W)-5.0D 0*EXP(-1.0D 1*W)+3.0D 0*EXP(-4.0D 0*W)
   92 CONTINUE
      XMAX=1.0D 1
      ELSE
      IERR=1
      ENDIF
      RETURN
  100 IF(N.GE.6) THEN
      N=6
      NA=6
      X(1)=1.03D 2
      X(2)=-1.7D 1
      X(3)= 6.8D 1
      X(4)= 7.8D-1
      X(5)= 4.2D-1
      X(6)=-1.1D-1
      Y(1)=4.14D 3
      Y(2)=7.50D 5
      Y(3)=2.00D 2
      Y(4)=1.60D 3
      Y(5)=8.00D 2
      Y(6)=5.74D 3
      Y(7)=3.335972309D-3
      Y(8)=1.080575317D 0
      Y(9)=1.004224000D 2
      Y(10)=7.470000000D 3
      Y(11)=1.250989616D-3
      Y(12)=1.440767090D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  110 IF(N.GE.16) THEN
      N=16
      NA=N
      DO 112 K=1,N
      Y(K)=DBLE(K-8)**3
      DO 111 I=1,N
      IF (I.NE.K) THEN
      R=SQRT(DBLE(K)/DBLE(I))
      W=LOG(R)
      Y(K)=Y(K)+R*(SIN(W)**5+COS(W)**5)
      ENDIF
  111 CONTINUE
      X(K)=-2.8742711D 0*Y(K)
  112 CONTINUE
      XMAX=1.0D 4
      ELSE
      IERR=1
      ENDIF
      RETURN
  120 IF(N.GE.16) THEN
      N=16
      NA=N
      R=1.0D 0
      W=3.141592653589793D 0
      DO 121 I=1,N
      X(I)=(2.0D 0*UNRAN1(R)-1.0D 0)*W
  121 CONTINUE
      J=0
      DO 123 K=1,N
      Y(K+512)=0.0D 0
      DO 122 I=1,N
      Y(I+J)=2.0D 2*UNRAN1(R)-1.0D 2
      Y(I+J+256)=2.0D 2*UNRAN1(R)-1.0D 2
      Y(K+512)=Y(K+512)+Y(I+J)*SIN(X(I))+Y(I+J+256)*COS(X(I))
  122 CONTINUE
      J=J+N
  123 CONTINUE
      DO 124 I=1,N
      X(I)=X(I)+1.0D-1*(2.0D 0*UNRAN1(R)-1.0D 0)*W
  124 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  130 IF(N.GE.5) THEN
      N=N-MOD(N,5)
      NA=N
      DO 131 I=1,N
      X(I)=1.0D 0/DBLE(N)
  131 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  140 IF(N.GE.3) THEN
      NA=N
      DO 141 I=1,N
      X(I)=0.0D 0
  141 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  150 IF(N.GE.3) THEN
      IF (MOD(N,2).NE.1) N=N-1
      NA=N
      DO 151 I=1,N
      X(I)=1.0D 0
  151 CONTINUE
      XMAX=1.0D 2
      ELSE
      IERR=1
      ENDIF
      RETURN
  160 IF(N.GE.2) THEN
      NA=N
      DO 161 I=1,N
      IF (MOD(I,2).EQ.1) THEN
      X(I)=1.0D 0
      ELSE
      X(I)=3.0D 0
      ENDIF
  161 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  170 IF(N.GE.3) THEN
      NA=N
      DO 171 I=1,N
      X(I)=1.2D 1
  171 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  180 IF(N.GE.5) THEN
      NA=N
      DO 181 I=1,N
      X(I)=-2.0D 0
  181 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  190 IF(N.GE.7) THEN
      NA=N
      DO 191 I=1,N
      X(I)=-3.0D 0
  191 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  200 IF(N.GE.3) THEN
      NA=N
      DO 201 I=1,N
      X(I)=0.0D 0
  201 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  210 IF(N.GE.2) THEN
      N=N-MOD(N,2)
      NA=N
      DO 211 I=1,N
      IF(MOD(I,2).EQ.1) THEN
      X(I)=-1.2D 0
      ELSE
      X(I)= 1.0D 0
      ENDIF
  211 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  220 IF(N.GE.4) THEN
      N=N-MOD(N,4)
      NA=N
      DO 221 I=1,N
      IF (MOD(I,4).EQ.1) THEN
      X(I)=3.0D 0
      ELSE IF(MOD(I,4).EQ.2) THEN
      X(I)=-1.0D 0
      ELSEIF(MOD(I,4).EQ.3) THEN
      X(I)=0.0D 0
      ELSE
      X(I)=1.0D 0
      ENDIF
  221 CONTINUE
      XMAX=1.0D 2
      ELSE
      IERR=1
      ENDIF
      RETURN
  230 IF(N.GE.4) THEN
      N=N-MOD(N,4)
      NA=N
      DO 231 I=1,N
      X(I)=2.0D 0
      IF (MOD(I,4).EQ.1) X(I)=1.0D 0
  231 CONTINUE
      XMAX=1.0D 1
      ELSE
      IERR=1
      ENDIF
      RETURN
  240 IF(N.GE.3) THEN
      NA=N
      DO 241 I=1,N
      X(I)=-1.0D 0
  241 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  250 IF(N.GE.7) THEN
      NA=N
      DO 251 I=1,N
      X(I)=-1.0D 0
  251 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  260 IF(N.GE.2.AND.NA.GE.N) THEN
      NA=N
      DO 261 I=1,N
      X(I)=1.0D 0/DBLE(N)
  261 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  270 IF(N.GE.2) THEN
      NA=N
      DO 271 I=1,N
      X(I)=0.5D 0
  271 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  280 IF(N.GE.3) THEN
      NA=N
      DO 281 I=1,N
      X(I)=DBLE(I)/DBLE(N+1)
      X(I)=X(I)*(X(I)-1.0D 0)
  281 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  290 GOTO 280
  300 IF(N.GE.3) THEN
      NA=N
      DO 301 I=1,N
      X(I)=-1.0D 0
  301 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
      END
