* SUBROUTINE EIUD26                ALL SYSTEMS                16/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF THE VARIABLES AND STRUCTURE OF THE SPARSE HESSIAN
*  MATRIX FOR UNCONSTRAINED MINIMIZATION.
*
* PARAMETERS :
*  II  N  NUMAER OF VARIABLES.
*  II  NA  NUMAER OF ELEMENTS OF THE SPARSE MATRIX.
*  RO  X(N)  VECTOR OF VARIABLES.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EIUD26(N,NA,X,FMIN,XMAX,NEXT,IEXT,IERR)
      INTEGER N,NA,NEXT,IEXT,IERR
      REAL*8 X(N),FMIN,XMAX
      INTEGER I,J,K,M,N1
      REAL*8 T,S,PAR
      REAL*8 Y(20)
      COMMON /EMPR15/ Y
      COMMON /EMPR18/ PAR,M
      REAL*8 ETA9
      PARAMETER (ETA9=1.0D 60)
      FMIN=0.0D 0
      XMAX=1.0D 3
      IEXT=0
      IERR=0
      GOTO(10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     & 170,180,190,200,210,220,
     & 230,240,250,260,270,280,290,310,340,360,
     & 370,380,390,400,410,420,430,440,450,460,470,480,490,500,520,
     & 510,530,540,550,560,570,580,590,600,610,620,630,640),
     & NEXT
   10 IF (N.LT.2) GO TO 999
      N=N-MOD(N,2)
      DO 11 I=1,N
        IF(MOD(I,2).EQ.1) THEN
          X(I)=-1.2D 0
        ELSE
          X(I)=1.0D 0
        ENDIF
   11 CONTINUE
      NA=2*(N-1)
      RETURN
   20 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      DO 21 I=1,N
        IF(MOD(I,2).EQ.1) THEN
          X(I)=-2.0D 0
          IF(I.LE.4) X(I)=-3.0D 0
        ELSE
          X(I)=0.0D 0
          IF(I.LE.4) X(I)=-1.0D 0
        ENDIF
   21 CONTINUE
      NA=3*(N-2)
      RETURN
   30 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      DO 31 I=1,N
        IF(MOD(I,4).EQ.1) THEN
          X(I)=3.0D 0
        ELSEIF(MOD(I,4).EQ.2) THEN
          X(I)=-1.0D 0
        ELSEIF(MOD(I,4).EQ.3) THEN
          X(I)=0.0D 0
        ELSE
          X(I)=1.0D 0
        ENDIF
   31 CONTINUE
      NA=2*(N-2)
      RETURN
   40 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      DO 41 I=1,N
        X(I)=2.0D 0
   41 CONTINUE
      X(1)=1.0D 0
      NA=5*(N-2)/2
      XMAX=1.0D 1
      RETURN
   50 IF (N.LT.3) GO TO 999
      DO 51 I=1,N
        X(I)=-1.0D 0
   51 CONTINUE
      NA=N
      RETURN
   60 IF (N.LT.6) GO TO 999
      DO 61 I=1,N
        X(I)=-1.0D 0
   61 CONTINUE
      NA=N
      RETURN
   70 IF (N.LT.2) GO TO 999
      DO 71 I=1,N-1
        X(I)=0.5D 0
   71 CONTINUE
      X(N)=-2.0D 0
      NA=2*(N-1)
      RETURN
   80 IF (N.LT.4) GO TO 999
      N=N-MOD(N,4)
      DO 81 I=1,N
        X(I)=SIN(DBLE(I))**2
   81 CONTINUE
      NA=5*N
      RETURN
   90 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      DO 91 I=1,N
        X(I)=5.0D 0
   91 CONTINUE
      NA=3*(N-2)
      RETURN
  100 IF (N.LT.2) GO TO 999
      DO 101 I=1,N
        X(I)=0.2D 0
  101 CONTINUE
      NA=N+3
      RETURN
  110 CONTINUE
      IF (N.LT.2) GO TO 999
      N=N-MOD(N,2)
      DO 111 I=1,N
        IF(MOD(I,2).EQ.1) THEN
          X(I)=-0.8D 0
        ELSE
          X(I)=-0.8D 0
        ENDIF
  111 CONTINUE
      NA=2*(N-1)
      RETURN
  120 CONTINUE
      IF (N.LT.5) GO TO 999
      IF (MOD(N-5,3).NE.0) N=N-MOD(N-5,3)
      DO 121 I=1,N
        X(I)=-1.0D 0
  121 CONTINUE
      NA=2*(N-2)
      RETURN
  130 CONTINUE
      IF (N.LT.5) GO TO 999
      IF (MOD(N-5,3).NE.0) N=N-MOD(N-5,3)
      DO 131 I=1,N
        X(I)=-1.0D 0
  131 CONTINUE
      NA=7*(N-2)/3
      RETURN
  140 CONTINUE
      IF (N.LT.4) GO TO 999
      DO 141 I=1,N
        IF (MOD(I,4).EQ.1) THEN
          X(I)=-0.8D 0
        ELSE IF (MOD(I,4).EQ.2) THEN
          X(I)= 1.2D 0
        ELSE IF (MOD(I,4).EQ.3) THEN
          X(I)=-1.2D 0
        ELSE
          X(I)= 0.8D 0
        ENDIF
  141 CONTINUE
      Y(1)=14.4D 0
      Y(2)=6.8D 0
      Y(3)=4.2D 0
      Y(4)=3.2D 0
  142 IF (MOD(N-4,2).NE.0) N=N-MOD(N-4,2)
      NA=2*(N-2)
      RETURN
  150 CONTINUE
      IF (N.LT.4) GO TO 999
      DO 151 I=1,N
        IF (MOD(I,4).EQ.1) THEN
          X(I)=-0.8D 0
        ELSE IF (MOD(I,4).EQ.2) THEN
          X(I)= 1.2D 0
        ELSE IF (MOD(I,4).EQ.3) THEN
          X(I)=-1.2D 0
        ELSE
          X(I)= 0.8D 0
        ENDIF
  151 CONTINUE
      Y(1)=35.8D 0
      Y(2)=11.2D 0
      Y(3)=6.2D 0
      Y(4)=4.4D 0
      GO TO 142
  160 CONTINUE
      IF (N.LT.4) GO TO 999
      DO 161 I=1,N
        IF (MOD(I,4).EQ.1) THEN
          X(I)=-0.8D 0
        ELSE IF (MOD(I,4).EQ.2) THEN
          X(I)= 1.2D 0
        ELSE IF (MOD(I,4).EQ.3) THEN
          X(I)=-1.2D 0
        ELSE
          X(I)= 0.8D 0
        ENDIF
  161 CONTINUE
      Y(1)=30.6D 0
      Y(2)=72.2D 0
      Y(3)=124.4D 0
      Y(4)=187.4D 0
      GO TO 142
  170 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      NA=N
      DO 171 I=1,N
        IF (MOD(I,8).EQ.1) X(I)=1.0D-1
        IF (MOD(I,8).EQ.2.OR.MOD(I,8).EQ.0) X(I)=2.0D-1
        IF (MOD(I,8).EQ.3.OR.MOD(I,8).EQ.7) X(I)=3.0D-1
        IF (MOD(I,8).EQ.4.OR.MOD(I,8).EQ.6) X(I)=4.0D-1
        IF (MOD(I,8).EQ.5) X(I)=5.0D-1
  171 CONTINUE
      RETURN
  180 IF (N.LT.3) GO TO 999
      NA=N
      DO 181 I=1,N
        X(I)=1.2D 1
  181 CONTINUE
      RETURN
  190 IF (N.LT.7) GO TO 999
      NA=N
      DO 191 I=1,N
        X(I)=-1.0D 0
  191 CONTINUE
      RETURN
  200 IF (N.LT.3) GO TO 999
      NA=N
      DO 201 I=1,N
        X(I)=DBLE(I)/DBLE(N+1)
        X(I)=X(I)*(X(I)-1.0D 0)
  201 CONTINUE
      RETURN
  210 CONTINUE
      IF (N.LT.5) GO TO 999
      IF (MOD(N-5,3).NE.0) N=N-MOD(N-5,3)
      DO 211 I=1,N
        X(I)=-1.0D 0
  211 CONTINUE
      NA=7*(N-2)/3
      RETURN
  220 IF (N.LT.3) GO TO 999
      DO 221 I=1,N
        IF(MOD(I,2).EQ.1) THEN
          X(I)=-1.2D 0
        ELSE
          X(I)= 1.0D 0
        ENDIF
  221 CONTINUE
      NA=2*(N-1)
      RETURN
  230 IF (N.LT.5) GO TO 999
      N=N-MOD(N,2)
      NA=N
      DO 231 I=1,N
      IF (MOD(I,8).EQ.1) X(I)=1.0D-1
      IF (MOD(I,8).EQ.2.OR.MOD(I,8).EQ.0) X(I)=2.0D-1
      IF (MOD(I,8).EQ.3.OR.MOD(I,8).EQ.7) X(I)=3.0D-1
      IF (MOD(I,8).EQ.4.OR.MOD(I,8).EQ.6) X(I)=4.0D-1
      IF (MOD(I,8).EQ.5) X(I)=5.0D-1
  231 CONTINUE
      RETURN
  240 IF (N.LT.5) GO TO 999
      N=N-MOD(N,5)
      NA=N
      DO 241 I=1,N
      X(I)=1.0D 0/DBLE(N)
  241 CONTINUE
      RETURN
  250 IF (N.LT.3) GO TO 999
      DO 251 I=1,N
      X(I)=0.0D 0
  251 CONTINUE
      NA=N
      RETURN
  260 IF (N.LT.3) GO TO 999
      IF (MOD(N,2).NE.1) N=N-1
      NA=N
      DO 261 I=1,N
      X(I)=1.0D 0
  261 CONTINUE
      RETURN
  270 IF (N.LT.3) GO TO 999
      DO 271 I=1,N
      X(I)=-1.0D 0
  271 CONTINUE
      NA=N
      RETURN
  280 IF (N.LT.5) GO TO 999
      NA=N
      DO 281 I=1,N
      X(I)=-2.0D 0
  281 CONTINUE
      RETURN
  290 IF (N.LT.7) GO TO 999
      NA=N
      DO 291 I=1,N
      X(I)=-3.0D 0
  291 CONTINUE
      XMAX=1.0D 1
      RETURN
  310 IF (N.LT.2) GO TO 999
      N=N-MOD(N,2)
      NA=N
      DO 311 I=1,N
      IF(MOD(I,2).EQ.1) THEN
      X(I)=9.0D 1
      ELSE
      X(I)=6.0D 1
      ENDIF
  311 CONTINUE
      RETURN
  340 IF (N.LT.3) GO TO 999
      DO 341 I=1,N
      X(I)=-1.0D 0
  341 CONTINUE
      NA=N
      RETURN
  360 IF (N.LT.2) GO TO 999
      N=N-MOD(N,2)
      NA=N
      DO 361 I=1,N
      IF (MOD(I,2).EQ.1) THEN
      X(I)=0.0D 0
      ELSE
      X(I)=1.0D 0
      ENDIF
  361 CONTINUE
      RETURN
  370 IF (N.LT.4) GO TO 999
      N=N-MOD(N,4)
      NA=N
      DO 371 I=2,N,2
      X(I-1)=-3.0D 0
      X(I)=-1.0D 0
  371 CONTINUE
      RETURN
  380 IF (N.LT.3) GO TO 999
      DO 381 I=1,N
      X(I)=1.5D 0
  381 CONTINUE
      XMAX=1.0D 0
      NA=N
      RETURN
  390 IF (N.LT.3) GO TO 999
      DO 391 I=1,N
      X(I)=DBLE(I)/DBLE(N+1)
      X(I)=X(I)*(X(I)-1.0D 0)
  391 CONTINUE
      NA=N
      RETURN
  400 IF (N.LT.3) GO TO 999
      DO 401 I=1,N
      X(I)=1.0D 1
  401 CONTINUE
      NA=N
      RETURN
  410 IF (N.LT.3) GO TO 999
      DO 411 I=1,N
      X(I)=1.0D 0
  411 CONTINUE
      PAR=1.0D 1
      NA=N
      RETURN
  420 IF (N.LT.5) GO TO 999
      PAR=5.0D 2/DBLE(N+2)
      NA=N
      DO 421 I=1,N
      X(I)=((DBLE(I)+0.5D 0)/DBLE(N+2)-0.5D 0)**2
  421 CONTINUE
      RETURN
  430 IF (N.LT.10) GO TO 999
      N=N-MOD(N,2)
      M=N/2
      PAR=5.0D 2
      NA=N
      DO 431 I=1,M
      K=I+M
      X(I)=(DBLE(I)/DBLE(M+1)-0.5D 0)**2
  431 CONTINUE
      DO 432 I=M+1,N
      K=I-M
      X(I)=DBLE(K)/DBLE(M+1)-0.5D 0
  432 CONTINUE
      RETURN
  440 IF (N.LT.16) GO TO 999
      M=INT(SQRT(DBLE(N)))
      PAR=6.7D 0/DBLE(M+1)**2
      N=M*M
      K=0
      DO 442 J=1,M
      DO 441 I=1,M
      K=K+1
      X(K)=0.0D 0
  441 CONTINUE
  442 CONTINUE
      RETURN
  450 IF (N.LT.16) GO TO 999
      M=INT(SQRT(DBLE(N)))
      PAR=1.0D 0/DBLE(M+1)**2
      N=M*M
      K=0
      DO 452 J=1,M
      DO 451 I=1,M
      K=K+1
      X(K)=-1.0D 0
  451 CONTINUE
  452 CONTINUE
      RETURN
  460 IF (N.LT.16) GO TO 999
      M=INT(SQRT(DBLE(N)))
      PAR=1.0D 0/DBLE(M+1)**2
      N=M*M
      K=0
      DO 462 J=1,M
      DO 461 I=1,M
      K=K+1
      X(K)=0.0D 0
  461 CONTINUE
  462 CONTINUE
      RETURN
  470 IF (N.LT.16) GO TO 999
      M=INT(SQRT(DBLE(N)))
      PAR=5.0D 1/DBLE(M+1)
      N=M*M
      K=0
      DO 472 J=1,M
      DO 471 I=1,M
      K=K+1
      X(K)=1.0D 0-DBLE(I)*DBLE(J)/DBLE(M+1)**2
  471 CONTINUE
  472 CONTINUE
      RETURN
  480 IF (N.LT.16) GO TO 999
      M=INT(SQRT(DBLE(N)))
      PAR=1.0D 0/DBLE(M+1)
      N=M*M
      K=0
      DO 482 J=1,M
      DO 481 I=1,M
      K=K+1
      X(K)=0.0D 0
  481 CONTINUE
  482 CONTINUE
      RETURN
  490 IF (N.LT.16) GO TO 999
      M=INT(SQRT(DBLE(N)))
      N=M*M
      PAR=500.0D 0/DBLE(M+2)**4
      K=0
      DO 492 J=1,M
      DO 491 I=1,M
      K=K+1
      X(K)=0.0D 0
  491 CONTINUE
  492 CONTINUE
      NA=N
      RETURN
  500 IF (N.LT.16) GO TO 999
      M=INT(SQRT(DBLE(N)))
      N=M*M
      PAR=500.0D 0
      K=0
      DO 502 J=1,M
      DO 501 I=1,M
      K=K+1
      X(K)=0.0D 0
  501 CONTINUE
  502 CONTINUE
      NA=N
      RETURN
  520 IF (N.LT.3) GO TO 999
      DO 521 I=1,N
      X(I)=5.0D 0*MIN(DBLE(I)/DBLE(N+1),1.0D 0-DBLE(I)/DBLE(N+1))
  521 CONTINUE
      NA=N
      RETURN
  510 IF (N.LT.3) GO TO 999
      DO 511 I=1,N
      X(I)=5.0D 0*MIN(DBLE(I)/DBLE(N+1),1.0D 0-DBLE(I)/DBLE(N+1))
  511 CONTINUE
      XMAX=1.0D 4
      NA=N
      RETURN
  530 IF (N.LT.2) GO TO 999
      N1=N-1
      DO 531 I=1,N1
      X(I)=-1.2D 0
  531 CONTINUE
      X(N)=-1.0D 0
      NA=N
      RETURN
  540 IF (N.LT.3) GO TO 999
      DO 541 I=1,N
      X(I)=2.0D 0
  541 CONTINUE
      NA=N
      RETURN
  550 IF (N.LT.3) GO TO 999
      DO 551 I=1,N
      X(I)=0.0D 0
  551 CONTINUE
      NA=N
      RETURN
  560 IF (N.LT.3) GO TO 999
      DO 561 I=1,N
      X(I)=-1.0D 0
  561 CONTINUE
      NA=N
      RETURN
  570 IF (N.LT.7) GO TO 999
      DO 571 I=1,N
      X(I)=-1.0D 0
  571 CONTINUE
      NA=N
      RETURN
  580 IF (N.LT.2) GO TO 999
      DO 581 I=1,N
      X(I)=0.5D 0
  581 CONTINUE
      NA=N
      RETURN
      RETURN
  590 IF (N.LT.2) GO TO 999
      DO 591 I=1,N
      X(I)=0.5D 0
  591 CONTINUE
      NA=N
      RETURN
  600 IF (N.LT.3) GO TO 999
      DO 601 I=1,N
      X(I)=1.0D 0
  601 CONTINUE
      NA=N
      RETURN
  610 IF (N.LT.7) GO TO 999
      DO 611 I=1,N
      X(I)=-1.0D 0
  611 CONTINUE
      NA=N
      RETURN
  620 IF (N.LT.3) GO TO 999
      DO 621 I=1,N
      X(I)=1.0D 0
  621 CONTINUE
      NA=N
      RETURN
  630 IF (N.LT.3) GO TO 999
      DO 631 I=1,N
      X(I)=1.0D 0
  631 CONTINUE
      NA=N
      RETURN
  640 T=DBLE(2)/DBLE(N+2)
      N1=N/2
      DO 641 I=1,N1
      S=DBLE(I)*T
      X(I)=S*(1.0D 0-S)
      X(N1+I)=X(I)
  641 CONTINUE
      NA=N
      RETURN
  650 N1=INT(SQRT(DBLE(N)))
      N=N1*N1
      DO 651 I=1,N
      X(I)=1.0D 0
  651 CONTINUE
      NA=N
      RETURN
  660 N1=INT(SQRT(DBLE(N)))
      N=N1*N1
      DO 661 I=1,N
      X(I)=1.0D 0
  661 CONTINUE
      NA=N
      RETURN
  999 IERR=1
      RETURN
      END
