* SUBROUTINE EIUD43             ALL SYSTEMS                 91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF THE VARIABLES FOR NONLINEAR APPROXIMATION.
*  UNCONSTRAINED AND DENSE VERSION.
*
* PARAMETERS :
*  IO  N  NUMBER OF VARIABLES.
*  IO  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  IO  NAL NUMBER OF LINEAR APPROXIMATED FUNCTIONS.
*  RO  X(N)  VECTOR OF VARIABLES.
*  RO  FMIN  LOWER BOUND FOR VALUE OF THE OBJECTIVE FUNCTION.
*  RO  XMAX  MAXIMUM STEPSIZE.
*  IO  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EIUD43(N,NA,NAL,X,FMIN,XMAX,NEXT,IEXT,IERR)
      INTEGER N,NA,NAL,NEXT,IEXT,IERR
      REAL*8 X(N),FMIN,XMAX
      REAL*8 Y(65)
      COMMON /EMPR43/ Y
      NAL=0
      FMIN=0.0D 0
      XMAX=1.0D 3
      IEXT=0
      IERR=0
      GOTO(10,20,30,40,50,60),NEXT
   10 IF(N.GE.3.AND.NA.GE.10) THEN
      N=3
      NA=10
      X(1)=2.0D 1
      X(2)=LOG(2.0D 0)
      X(3)=5.0D-1
      Y(1)=16.7D 0
      Y(2)=16.8D 0
      Y(3)=16.9D 0
      Y(4)=17.1D 0
      Y(5)=17.2D 0
      Y(6)=17.4D 0
      Y(7)=17.6D 0
      Y(8)=17.9D 0
      Y(9)=18.1D 0
      Y(10)=18.7D 0
      Y(11)=1.0D 0
      Y(12)=5.0D 0
      Y(13)=10.0D 0
      Y(14)=15.0D 0
      Y(15)=20.0D 0
      Y(16)=25.0D 0
      Y(17)=30.0D 0
      Y(18)=35.0D 0
      Y(19)=40.0D 0
      Y(20)=50.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   20 IF(N.GE.2.AND.NA.GE.10) THEN
      N=2
      NA=10
      X(1)=0.3D 0
      X(2)=0.4D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   30 IF(N.GE.3.AND.NA.GE.16) THEN
      N=3
      NA=16
      X(1)=LOG(2.0D-2)
      X(2)=4.0D 3
      X(3)=2.5D 2
      Y(1)=3478D 1
      Y(2)=2861D 1
      Y(3)=2365D 1
      Y(4)=1963D 1
      Y(5)=1637D 1
      Y(6)=1372D 1
      Y(7)=1154D 1
      Y(8)=9744D 0
      Y(9)=8261D 0
      Y(10)=7030D 0
      Y(11)=6005D 0
      Y(12)=5147D 0
      Y(13)=4427D 0
      Y(14)=3820D 0
      Y(15)=3307D 0
      Y(16)=2872D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   40 IF(N.GE.4.AND.NA.GE.10) THEN
      N=4
      NA=10
      X(1)=LOG(1.0D 0)
      X(2)=LOG(1.0D 0)
      X(3)=1.0D 0
      X(4)=1.0D 0
      Y(1)=99.6D 0
      Y(2)=67.1D 0
      Y(3)=45.9D 0
      Y(4)=31.9D 0
      Y(5)=22.5D 0
      Y(6)=16.1D 0
      Y(7)=11.7D 0
      Y(8)=8.60D 0
      Y(9)=6.38D 0
      Y(10)=4.78D 0
      XMAX=1.0D 1
      ELSE
      IERR=1
      ENDIF
      RETURN
   50 IF(N.GE.4.AND.NA.GE.16) THEN
      N=4
      NA=16
      X(1)=LOG(1.0D 5)
      X(2)=LOG(1.0D 5)
      X(3)=-1.679D 0
      X(4)=-1.310D 0
      Y(1)=57.544D 0
      Y(2)=53.546D 0
      Y(3)= 3.006D 0
      Y(4)=19.498D 0
      Y(5)=16.444D 0
      Y(6)= 4.305D 0
      Y(7)=45.290D 0
      Y(8)=27.952D 0
      Y(9)=11.803D 0
      Y(10)= 4.764D 0
      Y(11)=51.286D 0
      Y(12)=31.623D 0
      Y(13)=21.777D 0
      Y(14)=13.996D 0
      Y(15)= 7.727D 0
      Y(16)= 4.990D 0
      Y(17)= 7.448D 0
      Y(18)= 7.448D 0
      Y(19)= 9.439D 0
      Y(20)= 7.969D 0
      Y(21)= 8.176D 0
      Y(22)= 9.284D 0
      Y(23)= 7.552D 0
      Y(24)= 7.877D 0
      Y(25)= 8.552D 0
      Y(26)= 9.314D 0
      Y(27)= 7.607D 0
      Y(28)= 7.847D 0
      Y(29)= 8.176D 0
      Y(30)= 8.523D 0
      Y(31)= 8.903D 0
      Y(32)= 9.314D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   60 IF(N.GE.4.AND.NA.GE.12) THEN
      N=4
      NA=12
      X(1)=LOG(1.0D 2)
      X(2)=LOG(1.0D-2)
      X(3)=2.0D 0
      X(4)=1.0D 1
      Y(1)=7.31D 0
      Y(2)=7.55D 0
      Y(3)=7.80D 0
      Y(4)=8.05D 0
      Y(5)=8.31D 0
      Y(6)=8.57D 0
      Y(7)=8.84D 0
      Y(8)=9.12D 0
      Y(9)=9.40D 0
      Y(10)=9.69D 0
      Y(11)=9.99D 0
      Y(12)=10.30D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
      END
