* SUBROUTINE SCFGUX                ALL SYSTEMS                99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  EVALUATE THE VALUE OF THE SELECTED CONSTRAINT FUNCTION
*  (CONSTRAINT GROUP).
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  ICON  INDEX OF THE SELECTED CONSTRAINT (CONSTRAINT GROUP).
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  CI  VALUE OF THE SELECTED CONSTRAINT FUNCTION (CONSTRAINT
*         GROUP).
*
      SUBROUTINE SCFUXX ( N, ICON, X, CI )
      INTEGER            N, ICON
      DOUBLE PRECISION   CI
      DOUBLE PRECISION   X( N )
C
C  Based on the subroutine cfn.f by Nick Gould, which is in turn based
C  on the subroutine SBMIN by Conn, Gould and Toint.
C
C  Nick Gould, for CGT productions,
C  November 1991.
C
      INTEGER            LIWK  , LWK   , LFUVAL, LLOGIC, LCHARA
C
C  ---------------------------------------------------------------------
C
C  Parameters whose value might be changed by the user:
C
C  The following parameters define the sizes of problem
C  dependent arrays. These may be changed by the user to
C  suit a particular problem or system configuration.
C
C  The TOOLS will issue error messages if any of these sizes
C  is too small, telling which parameter to increase.
C
C  ---------------------------------------------------------------------
C
C  Integer workspace
C
      PARAMETER       ( LIWK   =  3000000 )
CMED  PARAMETER       ( LIWK   =  300000  )
CTOY  PARAMETER       ( LIWK   =  10000   )
COLD  PARAMETER       ( LIWK   =  1000000 )
      INTEGER                IWK( LIWK    )
C
C  Real/double precision workspace
C
      PARAMETER       ( LWK    =  3000000 )
CMED  PARAMETER       ( LWK    =  300000  )
CTOY  PARAMETER       ( LWK    =  10000   )
COLD  PARAMETER       ( LWK    =  500000  )
      DOUBLE PRECISION       WK ( LWK     )
C
C  Logical workspace
C
      PARAMETER       ( LLOGIC =  350000  )
CMED  PARAMETER       ( LLOGIC =  15000   )
CTOY  PARAMETER       ( LLOGIC =  1500    )
COLD  PARAMETER       ( LLOGIC =  100000  )
      LOGICAL              LOGI ( LLOGIC  )
C
C  Character workspace
C
      PARAMETER       ( LCHARA =  300000  )
CMED  PARAMETER       ( LCHARA =  30000   )
CTOY  PARAMETER       ( LCHARA =  3000    )
COLD  PARAMETER       ( LCHARA =  100000  )
      CHARACTER * 10       CHA  ( LCHARA  )
C
C  Workspace to store the problem's function and derivatives values
C
      PARAMETER       ( LFUVAL =  960000  )
CMED  PARAMETER       ( LFUVAL =  50000   )
CTOY  PARAMETER       ( LFUVAL =  5000    )
COLD  PARAMETER       ( LFUVAL =  200000  )
      DOUBLE PRECISION  FUVALS  ( LFUVAL  )
C
C  ---------------------------------------------------------------------
C
C  End of parameters which might be changed by the user.
C
C  ---------------------------------------------------------------------
C
C  integer variables from the GLOBAL common block.
C
      INTEGER            NG    , NELNUM, NGEL  , NVARS , NNZA  , NGPVLU
      INTEGER            NEPVLU, NG1   , NEL1  , ISTADG, ISTGP , ISTADA
      INTEGER            ISTAEV, ISTEP , ITYPEG, KNDOFC, ITYPEE
      INTEGER            IELING, IELVAR, ICNA  , ISTADH, INTVAR, IVAR
      INTEGER            ICALCF, IWRK  , A     , B
      INTEGER            U     , GPVALU, EPVALU
      INTEGER            ESCALE, GSCALE, VSCALE, GVALS , XT    , DGRAD
      INTEGER            Q     , WRK   , INTREP, GXEQX , GNAMES, VNAMES
      INTEGER            LO    , CH    , LIWORK, LWORK , NGNG  , FT
      INTEGER            LA, LB, NOBJGR, LU, LELVAR
      INTEGER            LSTAEV, LSTADH, LNTVAR, LCALCF
      INTEGER            LELING, LINTRE, LFT, LGXEQX, LSTADG, LGVALS
      INTEGER            LICNA , LSTADA, LKNDOF
      INTEGER            LGSCAL, LESCAL, LVSCAL, LCALCG
C
C  integer variables from the LOCAL common block.
C
      INTEGER            LFXI  , LGXI  , LHXI  , LGGFX , LDX   , LGRJAC
      INTEGER            LQGRAD, LBREAK, LP    , LXCP  , LX0   , LGX0
      INTEGER            LDELTX, LBND  , LWKSTR, LSPTRS, LSELTS, LINDEX
      INTEGER            LSWKSP, LSTAGV, LSTAJC, LIUSED, LFREEC
      INTEGER            LNNONZ, LNONZ2, LSYMMD, LSYMMH
      INTEGER            LSLGRP, LSVGRP, LGCOLJ, LVALJR, LSEND
      INTEGER            LNPTRS, LNELTS, LNNDEX, LNWKSP, LNSTGV
      INTEGER            LNSTJC, LNIUSE, LNFREC, LNNNON, LNNNO2, LNSYMD
      INTEGER            LNSYMH, LNLGRP, LNVGRP, LNGCLJ, LNVLJR, LNQGRD
      INTEGER            LNBRAK, LNP   , LNBND , LNFXI , LNGXI , LNGUVL
      INTEGER            LNHXI , LNHUVL, LNGGFX, LNDX  , LNGRJC, LIWK2
      INTEGER            LWK2  , MAXSIN, NINVAR, MAXSEL
      INTEGER            NTYPE , NSETS , LSTYPE, LSSWTR, LSSIWT, LSIWTR
      INTEGER            LSWTRA, LNTYPE, LNSWTR, LNSIWT, LNIWTR
      INTEGER            LNWTRA, LSISET, LSSVSE, LNISET, LNSVSE
      LOGICAL            ALTRIV, FIRSTG
      COMMON / GLOBAL /  IWK   , WK    , FUVALS, LOGI,
     *                   NG    , NELNUM, NGEL  , NVARS , NNZA  , NGPVLU,
     *                   NEPVLU, NG1   , NEL1  , ISTADG, ISTGP , ISTADA,
     *                   ISTAEV, ISTEP , ITYPEG, KNDOFC, ITYPEE,
     *                   IELING, IELVAR, ICNA  , ISTADH, INTVAR, IVAR  ,
     *                   ICALCF, IWRK  , A     , B     ,
     *                   U     , GPVALU, EPVALU,
     *                   ESCALE, GSCALE, VSCALE, GVALS , XT    , DGRAD ,
     *                   Q     , WRK   , INTREP, GXEQX , GNAMES, VNAMES,
     *                   LO    , CH    , LIWORK, LWORK , NGNG  , FT    ,
     *                   ALTRIV, FIRSTG,
     *                   LA, LB, NOBJGR, LU, LELVAR,
     *                   LSTAEV, LSTADH, LNTVAR, LCALCF,
     *                   LELING, LINTRE, LFT, LGXEQX, LSTADG, LGVALS,
     *                   LICNA , LSTADA, LKNDOF,
     *                   LGSCAL, LESCAL, LVSCAL, LCALCG
      COMMON / CHARA /   CHA
      COMMON / LOCAL /   LFXI  , LGXI  , LHXI  , LGGFX , LDX   , LGRJAC,
     *                   LQGRAD, LBREAK, LP    , LXCP  , LX0   , LGX0  ,
     *                   LDELTX, LBND  , LWKSTR, LSPTRS, LSELTS, LINDEX,
     *                   LSWKSP, LSTAGV, LSTAJC, LIUSED, LFREEC,
     *                   LNNONZ, LNONZ2, LSYMMD, LSYMMH,
     *                   LSLGRP, LSVGRP, LGCOLJ, LVALJR, LSEND ,
     *                   LNPTRS, LNELTS, LNNDEX, LNWKSP, LNSTGV,
     *                   LNSTJC, LNIUSE, LNFREC, LNNNON, LNNNO2, LNSYMD,
     *                   LNSYMH, LNLGRP, LNVGRP, LNGCLJ, LNVLJR, LNQGRD,
     *                   LNBRAK, LNP   , LNBND , LNFXI , LNGXI , LNGUVL,
     *                   LNHXI , LNHUVL, LNGGFX, LNDX  , LNGRJC, LIWK2 ,
     *                   LWK2  , MAXSIN, NINVAR, MAXSEL, NTYPE ,
     *                   NSETS , LSTYPE, LSSWTR, LSSIWT, LSIWTR,
     *                   LSWTRA, LNTYPE, LNSWTR, LNSIWT, LNIWTR,
     *                   LNWTRA, LSISET, LSSVSE, LNISET, LNSVSE
      INTEGER            IOUT
      COMMON / OUTPUT /  IOUT
      INTEGER            NUMVAR, NUMCON
      COMMON / DIMS /    NUMVAR, NUMCON
      SAVE             / GLOBAL /, / LOCAL /, / CHARA /, / OUTPUT /,
     *                 / DIMS   /
C
C  local variables.
C
      INTEGER            I , J , IG,  NELING
      INTEGER            NELOW , NELUP
      EXTERNAL           DSETVL, DSETVI, RANGES
      DOUBLE PRECISION   FTT   , ONE   , ZERO
      PARAMETER        ( ZERO  = 0.0D+0, ONE  = 1.0D+0 )
C
C  Return if there are no constraints.
C
      IF ( NUMCON .EQ. 0 ) RETURN
C
C  Check input parameters.
C
      IF ( ICON .LE. 0 ) THEN
         WRITE( IOUT, 2000 )
         STOP
      END IF
C
C  Find group index IG of constraint ICON.
C
      IG = 0
      DO 70 I = 1, NG
         IF ( IWK( KNDOFC + I ) .EQ. ICON ) THEN
           IG = I
           GOTO 80
         END IF
   70 CONTINUE
   80 IF ( IG .EQ. 0 ) THEN
         WRITE( IOUT, 2000 )
         STOP
      END IF
C
C  Determine nonlinear elements in group IG.
C  Record their indices in IWK( ICALCF ).
C
      NELOW  = IWK( ISTADG + IG )
      NELUP  = IWK( ISTADG + IG + 1 ) - 1
      NELING = NELUP - NELOW + 1
      J      = NELOW - 1
      DO 10 I = 1, NELING
         J = J + 1
         IWK( ICALCF + I ) = IWK( IELING + J )
   10 CONTINUE
C
C  Evaluate the element functions.
C
      CALL ELFUNS( FUVALS, X, WK( EPVALU + 1 ), NELING,
     *             IWK( ITYPEE + 1 ), IWK( ISTAEV + 1 ),
     *             IWK( IELVAR + 1 ), IWK( INTVAR + 1 ),
     *             IWK( ISTADH + 1 ), IWK( ISTEP  + 1 ),
     *             IWK( ICALCF + 1 ), 1 )
C
C  Compute the group argument value FTT.
C  Consider only the group associated with constraint ICON.
C
      FTT = - WK( B + IG )
C
C  Include the contribution from the linear element
C  only if the variable belongs to the first N variables.
C
      DO 30 I = IWK( ISTADA + IG ), IWK( ISTADA + IG + 1 ) - 1
         J = IWK( ICNA + I )
         IF ( J .LE. N )
     *      FTT  = FTT + WK( A + I ) * X( J )
   30 CONTINUE
C
C  Include the contributions from the nonlinear elements.
C
      DO 60 I = NELOW, NELUP
         FTT  = FTT +
     *      WK( ESCALE + I ) * FUVALS( IWK( IELING + I ) )
   60 CONTINUE
      WK( FT + IG ) = FTT
C
C  If IG is a trivial group, record the function value and derivative.
C
      IF ( LOGI( GXEQX + IG ) ) THEN
         WK( GVALS + IG )      = WK( FT + IG )
         WK( GVALS + NG + IG ) = ONE
      ELSE
C
C  Otherwise, evaluate group IG.
C
         CALL GROUPS( WK ( GVALS  + 1 ), NG, WK( FT + 1 ),
     *                WK ( GPVALU + 1 ), 1,
     *                IWK( ITYPEG + 1 ), IWK( ISTGP + 1 ),
     *                IG               , .FALSE. )
      END IF
C
C  Compute the constraint function value.
C
      IF ( LOGI( GXEQX  + IG ) ) THEN
         CI = WK( GSCALE + IG ) * WK( FT + IG )
      ELSE
         CI = WK( GSCALE + IG ) * WK( GVALS + IG )
      END IF
      RETURN
C
C Non-executable statements.
C
 2000 FORMAT( ' ** SUBROUTINE ECFU: invalid constraint index ICON ' )
C
C  end of ECFU.
C
      END
