* SUBROUTINE UALNG2             ALL SYSTEMS                   04/12/01
C PORTABILITY : ALL SYSTEMS
C 04/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE LINEAR FUNCTION GRADIENT. THE DENSE CASE.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF FUNCTIONS.
*  II  KA  INDEX OF THE SELECTED FUNCTION.
*  II  KAP  SIGNUM OF THE SELECTED FUNCTION.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RI  AG(NF*NA)  DENSE JACOBIAN MATRIX.
*  RO  GA(NF)  GRADIENT OF THE SELECTED FUNCTION.
*  II  ISNA  SAVING SPECIFICATION. ISNA=0-NO SAVING. ISNA=1-FUNCTION
*         VALUES ARE STORED. ISNA=2-FUNCTION VALUES AND GRADIENTS ARE
*         STORED.
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*  TI  JASA  STORE OF THE JACOBIAN MATRIX. JASA='R'-ROWWISE.
*            JASA='C'-COLUMNWISE.
*
* SUBPROGRAMS USED :
*  S   UXVCOP  COPYING OF A VECTOR.
*  S   UXVMUL  MULTIPLICATION OF A VECTOR BY A DIAGONAL MATRIX.
*
      SUBROUTINE UALNG2(NF,NA,KA,KAP,XN,AG,GA,ISNA,NORMF,JASA)
      INTEGER NF,NA,KA,KAP,ISNA,NORMF
      REAL*8 XN(NF),AG(NF*NA),GA(NF)
      CHARACTER*1 JASA
      INTEGER I,L
      IF (JASA.EQ.'R') THEN
      IF (NORMF.GT.0.AND.ISNA.GT.2) THEN
      CALL UXVMUL(NF,XN,AG((KA-1)*NF+1),GA,-1)
      ELSE
      CALL UXVCOP(NF,AG((KA-1)*NF+1),GA)
      ENDIF
      IF (KAP.LT.0) CALL UXVNEG(NF,GA,GA)
      ELSE
      L=0
      IF (NORMF.GT.0.AND.ISNA.GT.2) THEN
      IF (KAP.GT.0) THEN
      DO 1 I=1,NF
      GA(I)= AG(L+KA)/XN(I)
      L=L+NA
    1 CONTINUE
      ELSE
      DO 2 I=1,NF
      GA(I)=-AG(L+KA)/XN(I)
      L=L+NA
    2 CONTINUE
      ENDIF
      ELSE
      IF (KAP.GT.0) THEN
      DO 3 I=1,NF
      GA(I)= AG(L+KA)
      L=L+NA
    3 CONTINUE
      ELSE
      DO 4 I=1,NF
      GA(I)=-AG(L+KA)
      L=L+NA
    4 CONTINUE
      ENDIF
      ENDIF
      ENDIF
      RETURN
      END
