* SUBROUTINE UALNH3             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE LINEAR FUNCTION HESSIAN MATRIX. THE SPARSE CASE.
*
* PARAMETERS :
*  II  NA  NUMBER OF FUNCTIONS.
*  II  NB  POINTER IN THE PARTITIONED STRUCTURE.
*  II  M  NUMBER OF ELEMENTS IN THE FIELD HA.
*  II  KA  INDEX OF THE SELECTED FUNCTION.
*  RO  HA(M)  HESSIAN MATRIX OF THE LINEAR FUNCTION.
*  RI  IAG(NA+1)  POSITION OF THE FIRST ROWS ELEMENTS IN THE FIELD AG.
*
* SUBPROGRAMS USED :
*  S   UXDSMO  INITIATION OF A SYMMETRIC MATRIX.
*
      SUBROUTINE UALNH3(NA,NB,M,KA,HA,IAG)
      INTEGER NA,NB,M,KA,IAG(NA+1)
      REAL*8 HA(M)
      INTEGER K,L
      K=IAG(KA)
      L=IAG(KA+1)-K
      CALL UXDSMO(L,0.0D 0,HA(NB+1))
      RETURN
      END
