* SUBROUTINE UANRL1             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* INITIAL SCALING OF THE LINEAR FUNCTIONS.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NAL  NUMBER OF LINEAR FUNCTIONS.
*  RI  AW(NA)  VECTOR OF SCALING PARAMETERS.
*  RU  AF(NA)  VECTOR CONTAINING FUNCTION VALUES.
*  RU  AM(NA)  VECTOR CONTAINING MEASURED VALUES.
*  RI  AG(NF*NAL)  DENSE JACOBIAN MATRIX.
*  II  KBA  SPECIFICATION OF MEASURED VALUES. KBA=0-ZERO MEASURED
*         VALUES. KBA=1 MEASURED VALUES ARE GIVEN IN THE FIELD AM.
*  II  NORMA  SCALING SPECIFICATION. NORMA=0-NO SCALING IS PERFORMED.
*         NORMA=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMA=2-SCALING FACTORS ARE SUPPLIED BY USER.
*  II  JOB  SCALING SPECIFICATION. IF JOB=1 THEN FORWARD SCALING
*         IS PERFORMED. IF JOB=-1 THEN BACKWARD SCALING IS PERFORMED.
*
* SUBPROGRAMS USED :
*  S   UXVSCL  SCALING OF A VECTOR.
*
      SUBROUTINE UANRL1(NF,NAL,AW,AF,AM,AG,KBA,NORMA,JOB)
      INTEGER NF,NAL,KBA,NORMA,JOB
      REAL*8 AW(NAL),AF(NAL),AM(NAL),AG(NF*NAL)
      REAL*8 POM
      INTEGER KA,JAG
      IF (NORMA.LE.0) RETURN
      IF (JOB.EQ.0) RETURN
      JAG=0
      DO 1 KA=1,NAL
      POM=AW(KA)
      IF (JOB.LT.0) POM=1.0D 0/POM
      CALL UXVSCL(NF,POM,AG(JAG+1),AG(JAG+1))
      IF (KBA.GT.0) THEN
      IF (JOB.LT.0) AF(KA)=AF(KA)+AM(KA)
      AM(KA)=POM*AM(KA)
      ENDIF
      IF (JOB.LT.0) AF(KA)=POM*AF(KA)
      JAG=JAG+NF
    1 CONTINUE
      RETURN
      END
