* SUBROUTINE UASSH2             ALL SYSTEMS                   98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE SPARSE HESSIAN MATRIX FROM THE SPARSE JACOBIAN
* MATRIX.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF ROWS OF THE SPARSE JACOBIAN MATRIX.
*  II  MA  NUMBER OF NONZERO ELEMENTS OF THE SPARSE JACOBIAN MATRIX.
*  II  ME  NUMBER OF ELEMENTS OF THE MATRIX HA.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE SPARSE HESSIAN MATRIX.
*  RU  H(M)  NONZERO ELEMENTS OF THE SPARSE HESSIAN MATRIX.
*  II  IH(NF+1)  POINTERS OF THE DIAGONAL ELEMENTS OF H.
*  II  JH(M)  COLUMN INDICES OF THE NONZERO ELEMENTS OF H.
*  II  HA(ME)  PACKED HESSIAN MATRIX OF THE SELECTED FUNCTION.
*  II  IAG(NA+1)  POSITIONS OF THE FIRST ROWS ELEMENTS IN THE SPARSE
*         JACOBIAN STRUCTURE.
*  II  JAG(MA)  COLUMN INDICES OF ELEMENTS IN THE SPARSE JACOBIAN
*         STRUCTURE.
*  II  KA  INDEX OF THE SELECTED FUNCTION (ROW OF THE SPARSE JACOBIAN
*         MATRIX).
*  RI  FACTOR  SCALING FACTOR.
*
      SUBROUTINE UASSH2(N,NA,MA,ME,M,H,IH,JH,HA,IAG,JAG,KA,FACTOR)
      INTEGER N,NA,MA,ME,M,IH(N+1),JH(M),IAG(NA+1),JAG(MA),KA
      REAL*8 H(M),HA(ME),FACTOR
      INTEGER I,II,IA,J,JJ,JA,JF,K,KK,L
      KK=0
      II=IAG(KA)
      L=IAG(KA+1)-II
      DO 6 IA=1,L
      KK=KK+IA
      I=ABS(JAG(II))
C      I=JAG(II)
C      IF (I.LE.0) GO TO 5
      JF=IH(I)
      JJ=II
      K=KK
      DO 4 JA=IA,L
      J=ABS(JAG(JJ))
C      J=JAG(JJ)
C      IF (J.LE.0) GO TO 3
    2 IF (ABS(JH(JF)).LT.J) THEN
      JF=JF+1
      GO TO 2
      ENDIF
      H(JF)=H(JF)+FACTOR*HA(K)
C    3 K=K+JA
      K=K+JA
      JJ=JJ+1
    4 CONTINUE
C    5 II=II+1
      II=II+1
    6 CONTINUE
      RETURN
      END
