* SUBROUTINE UATRL1             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* INITIAL TRANSFORMATION OF THE LINEAR APPROXIMATED FUNCTIONS.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF LINEAR FUNCTIONS.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RU  AG(NF*MAL)  MATRIX WHOSE COLUMNS ARE GRADIENTS OF THE LINEAR
*         APPROXIMATED FUNCTIONS.
*  II  ISNA  SAVING SPECIFICATION. ISNA=0-NO SAVING. ISNA=1-FUNCTION
*         VALUES ARE SAVED. ISNA=2-FUNCTION VALUES AND GRADIENTS ARE
*         SAVED.
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*  II  JOB  TRANSFORMATION SPECIFICATION. IF JOB=1 THEN FORWARD
*         TRANSFORMATION IS PERFORMED. IF JOB=-1 THEN BACKWARD
*         TRANSFORMATION IS PERFORMED.
*
* SUBPROGRAMS USED :
*  S   UXVMUL  DIAGONAL PREMULTIPLICATION OF A VECTOR.
*
      SUBROUTINE UATRL1(NF,NA,XN,AG,ISNA,NORMF,JOB)
      INTEGER NF,NA,ISNA,NORMF,JOB
      REAL*8 XN(NF),AG(NF*NA)
      INTEGER KA,JAG
      IF (NORMF.LE.0) RETURN
      IF (ISNA.LE.2) RETURN
      IF (JOB.EQ.0) RETURN
      JAG=0
      DO 1 KA=1,NA
      CALL UXVMUL(NF,XN,AG(JAG+1),AG(JAG+1),JOB)
      JAG=JAG+NF
    1 CONTINUE
      RETURN
      END
