* SUBROUTINE UCCDEL             ALL SYSTEMS                 08/12/01
C PORTABILITY : ALL SYSTEMS
C 08/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETERMINATION OF ACTIVE AND INACTIVE INCREMENTS.
*
* PARAMETERS :
*  II  NX  NUMBER OF BOX CONSTRAINTS.
*  II  NC  NUMBER OF GENERAL CONSTRAINTS.
*  II  NCA  NUMBER OF ACTIVE CONSTRAINTS.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XSL(NX)  VECTOR CONTAINING LOVER SLACKS FOR VARIABLES.
*  RI  XSU(NX)  VECTOR CONTAINING UPPER SLACKS FOR VARIABLES.
*  RI  XZL(NF)  VECTOR CONTAINING LOVER MULTIPLIERS FOR VARIABLES.
*  RI  XZU(NF)  VECTOR CONTAINING UPPER MULTIPLIERS FOR VARIABLES.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  CSL(NC)  VECTOR CONTAINING LOVER SLACKS FOR CONSTRAINTS.
*  RI  CSU(NC)  VECTOR CONTAINING UPPER SLACKS FOR CONSTRAINTS.
*  RI  CZL(NC)  VECTOR CONTAINING LOVER MULTIPLIERS FOR CONSTRAINTS.
*  RI  CZU(NC)  VECTOR CONTAINING UPPER MULTIPLIERS FOR CONSTRAINTS.
*  II  ICA(NCA)  VECTOR CONTAINING INDICES OF ACTIVE CONSTRAINTS.
*  II  ICCA(NCA)  VECTOR CONTAINING INDICES OF COUPLED COMPLEMENTARITY
*         CONSTRAINTS.
*  RI  S(NCA)  VECTOR CONTAINING NEWTON INCREMENTS.
*  RU  GS(NCA)  VECTOR CONTAINING ACTIVE SLACK INCREMENTS.
*  RI  RPF3  BARRIER COEFFICIENT.
*  RI  RPF4  EXACT PENALTY COEFFICIENT.
*
      SUBROUTINE UCCDEL(NX,NC,NCA,IX,XSL,XSU,XZL,XZU,IC,CSL,CSU,
     & CZL,CZU,ICA,ICCA,S,GS,RPF3,RPF4)
      INTEGER NX,NC,NCA,IX(NX),IC(NC),ICA(NCA),ICCA(NCA)
      REAL*8 XSL(NX),XSU(NX),XZL(NX),XZU(NX),CSL(NC),CSU(NC),CZL(NC),
     & CZU(NC),S(NCA),GS(NCA),RPF3,RPF4
      INTEGER I,J,K,KK,L
      REAL*8 SK,SL,UK,UL,GK,GL,WK,WL,DD
      DO 1 I=1,NCA
      J=ICCA(I)
      IF (J.LE.0) THEN
      K=ICA(I)
      IF (K.LT.0) THEN
      K=-K
      KK=-IX(K)
      IF (KK.EQ.1.OR.KK.EQ.3) THEN
      S(I)=-S(I)
      GS(I)=(RPF3-XSL(K)*S(I))/XZL(K)-XSL(K)
      ELSE IF (KK.EQ.2.OR.KK.EQ.4) THEN
      GS(I)=(RPF3-XSU(K)*S(I))/XZU(K)-XSU(K)
      ENDIF
      ELSE
      KK=-IC(K)
      IF (KK.EQ.1.OR.KK.EQ.3) THEN
      S(I)=-S(I)
      GS(I)=(RPF3-CSL(K)*S(I))/CZL(K)-CSL(K)
      ELSE IF (KK.EQ.2.OR.KK.EQ.4) THEN
      GS(I)=(RPF3-CSU(K)*S(I))/CZU(K)-CSU(K)
      ENDIF
      ENDIF
      ELSE IF (J.GT.I) THEN
      K=ICA(I)
      IF (K.LT.0) THEN
      K=-K
      IF (IX(K).EQ.-1) THEN
      S(I)=-S(I)
      SK=XSL(K)
      UK=XZL(K)
      ELSE IF (IX(K).EQ.-2) THEN
      SK=XSU(K)
      UK=XZU(K)
      ENDIF
      ELSE
      IF (IC(K).EQ.-1) THEN
      S(I)=-S(I)
      SK=CSL(K)
      UK=CZL(K)
      ELSE IF (IC(K).EQ.-2) THEN
      SK=CSU(K)
      UK=CZU(K)
      ENDIF
      ENDIF
      L=ICA(J)
      IF (L.LT.0) THEN
      L=-L
      IF (IX(L).EQ.-1) THEN
      S(J)=-S(J)
      SL=XSL(L)
      UL=XZL(L)
      ELSE IF (IX(L).EQ.-2) THEN
      SL=XSU(L)
      UL=XZU(L)
      ENDIF
      ELSE
      IF (IC(L).EQ.-1) THEN
      S(J)=-S(J)
      SL=CSL(L)
      UL=CZL(L)
      ELSE IF (IC(L).EQ.-2) THEN
      SL=CSU(L)
      UL=CZU(L)
      ENDIF
      ENDIF
      WK=UK+RPF4*SL
      WL=UL+RPF4*SK
      GK=SK*WK-RPF3+SK*S(I)
      GL=SL*WL-RPF3+SL*S(J)
      DD=1.0D 0/(UK*UL+RPF4*(SK*UK+SL*UL))
      GS(I)=-DD*(WL*GK-RPF4*SK*GL)
      GS(J)=-DD*(WK*GL-RPF4*SL*GK)
      ENDIF
    1 CONTINUE
      RETURN
      END
