* SUBROUTINE UCCMAX                ALL SYSTEMS                08/12/01
C PORTABILITY : ALL SYSTEMS
C 08/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETRMINATION OF THE MAXIMUM STEPSIZE.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NX  NUMBER OF BOX CONSTRAINTS.
*  II  NC  NUMBER OF GENERAL CONSTRAINTS.
*  II  NCA  NUMBER OF ACTIVE CONSTRAINTS.
*  II  IX(NX)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XSL(NX)  VECTOR CONTAINING LOVER SLACKS FOR VARIABLES.
*  RI  XSU(NX)  VECTOR CONTAINING UPPER SLACKS FOR VARIABLES.
*  RI  XZL(NX)  VECTOR CONTAINING LOVER MULTIPLIERS FOR VARIABLES.
*  RI  XZU(NX)  VECTOR CONTAINING UPPER MULTIPLIERS FOR VARIABLES.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  CSL(NC)  VECTOR CONTAINING LOVER SLACKS FOR CONSTRAINTS.
*  RI  CSU(NC)  VECTOR CONTAINING UPPER SLACKS FOR CONSTRAINTS.
*  RI  CZL(NC)  VECTOR CONTAINING LOVER MULTIPLIERS FOR CONSTRAINTS.
*  RI  CZU(NC)  VECTOR CONTAINING UPPER MULTIPLIERS FOR CONSTRAINTS.
*  II  ICA(NX+NC)  VECTOR CONTAINING INDICES OF ACTIVE CONSTRAINTS.
*  RI  S(NCA)  DIRECTION VECTOR.
*  RI  GS(NCA)  VECTOR CONTAINING ACTIVE SLACK INCREMENTS.
*  RI  RMAX  MAXIMUM VALUE OF THE STEPSIZE PARAMETER.
*  RO  RMAXP  MAXIMUM VALUE OF THE PRIMAL STEPSIZE PARAMETER.
*  RO  RMAXD  MAXIMUM VALUE OF THE DUAL STEPSIZE PARAMETER.
*  RI  ETA6  COEFFICIENT FOR COMPUTING PRIMAL AND DUAL MAXIMUM
*            STEPSIZES.
*
      SUBROUTINE UCCMAX(NX,NC,NCA,IX,XSL,XSU,XZL,XZU,IC,CSL,CSU,
     & CZL,CZU,ICA,ICCA,S,GS,RMAX,RMAXP,RMAXD,ETA6,RPF4)
      INTEGER NX,NC,NCA,IX(NX),IC(NC),ICA(NCA),ICCA(NCA)
      REAL*8 XSL(NX),XSU(NX),XZL(NX),XZU(NX),CSL(NC),CSU(NC),CZL(NC),
     & CZU(NC),S(NCA),GS(NCA),RMAX,RMAXP,RMAXD,ETA6,RPF4
      INTEGER I,J,K,KK,L
      REAL*8 SK,UK,SL,UL,RTEMP
      RMAXP=RMAX/ETA6
      RMAXD=RMAX/ETA6
      DO 1 I=1,NCA
      J=ICCA(I)
      IF (J.LE.0) THEN
      K=ICA(I)
      IF (K.LT.0) THEN
      K=-K
      KK=-IX(K)
      IF (KK.EQ.1.OR.KK.EQ.3) THEN
      IF (GS(I).LT.0.0D 0) RMAXP=MIN(RMAXP,-XSL(K)/GS(I))
      IF (S(I).LT.0.0D 0) RMAXD=MIN(RMAXD,-XZL(K)/S(I))
      ELSE IF (KK.EQ.2.OR.KK.EQ.4) THEN
      IF (GS(I).LT.0.0D 0) RMAXP=MIN(RMAXP,-XSU(K)/GS(I))
      IF (S(I).LT.0.0D 0) RMAXD=MIN(RMAXD,-XZU(K)/S(I))
      ENDIF
      ELSE
      KK=-IC(K)
      IF (KK.EQ.1.OR.KK.EQ.3) THEN
      IF (GS(I).LT.0.0D 0) RMAXP=MIN(RMAXP,-CSL(K)/GS(I))
      IF (S(I).LT.0.0D 0) RMAXD=MIN(RMAXD,-CZL(K)/S(I))
      ELSE IF (KK.EQ.2.OR.KK.EQ.4) THEN
      IF (GS(I).LT.0.0D 0) RMAXP=MIN(RMAXP,-CSU(K)/GS(I))
      IF (S(I).LT.0.0D 0) RMAXD=MIN(RMAXD,-CZU(K)/S(I))
      ENDIF
      ENDIF
      ELSE
      K=ICA(I)
      IF (K.LT.0) THEN
      K=-K
      IF (IX(K).EQ.-1) THEN
      SK=XSL(K)
      UK=XZL(K)
      ELSE IF (IX(K).EQ.-2) THEN
      SK=XSU(K)
      UK=XZU(K)
      ENDIF
      ELSE
      IF (IC(K).EQ.-1) THEN
      SK=CSL(K)
      UK=CZL(K)
      ELSE IF (IC(K).EQ.-2) THEN
      SK=CSU(K)
      UK=CZU(K)
      ENDIF
      ENDIF
      L=ICA(J)
      IF (L.LT.0) THEN
      L=-L
      IF (IX(L).EQ.-1) THEN
      SL=XSL(L)
      UL=XZL(L)
      ELSE IF (IX(L).EQ.-2) THEN
      SL=XSU(L)
      UL=XZU(L)
      ENDIF
      ELSE
      IF (IC(L).EQ.-1) THEN
      SL=CSL(L)
      UL=CZL(L)
      ELSE IF (IC(L).EQ.-2) THEN
      SL=CSU(L)
      UL=CZU(L)
      ENDIF
      ENDIF
      IF (GS(I).LT.0.0D 0) RMAXP=MIN(RMAXP,-SK/GS(I))
      IF (S(I)+RPF4*GS(J).LT.0.0D 0) THEN
      RTEMP=-(UK+RPF4*SL)/(S(I)+RPF4*GS(J))
      RMAXP=MIN(RMAXP,RTEMP)
      ENDIF
      ENDIF
    1 CONTINUE
      RMAXP=ETA6*MIN(RMAXP,RMAXD)
      RMAXD=RMAXP
      RETURN
      END
