* FUNCTION UCIBAR               ALL SYSTEMS                 98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SLACK TERM FOR DETERMINATION OF PENALTY COEFFICIENT.
*
* PARAMETERS :
*  II  NX  NUMBER OF BOX CONSTRAINTS.
*  II  NC  NUMBER OF GENERAL CONSTRAINTS.
*  II  NCA  NUMBER OF ACTIVE CONSTRAINTS.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XSL(NX)  VECTOR CONTAINING LOVER SLACKS FOR VARIABLES.
*  RI  XSU(NX)  VECTOR CONTAINING UPPER SLACKS FOR VARIABLES.
*  RI  XZL(NF)  VECTOR CONTAINING LOVER MULTIPLIERS FOR VARIABLES.
*  RI  XZU(NF)  VECTOR CONTAINING UPPER MULTIPLIERS FOR VARIABLES.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  CSL(NC)  VECTOR CONTAINING LOVER SLACKS FOR CONSTRAINTS.
*  RI  CSU(NC)  VECTOR CONTAINING UPPER SLACKS FOR CONSTRAINTS.
*  RI  CZL(NC)  VECTOR CONTAINING LOVER MULTIPLIERS FOR CONSTRAINTS.
*  RI  CZU(NC)  VECTOR CONTAINING UPPER MULTIPLIERS FOR CONSTRAINTS.
*  II  ICA(NCA)  VECTOR CONTAINING INDICES OF ACTIVE CONSTRAINTS.
*  RI  D(NCA)  DIAGONAL SOUTH-EAST CORNER.
*  RI  S(NCA)  INCREMENTS OF LAGRANGE MULTIPLIERS.
*  RI  RPF3  BARRIER COEFFICIENT.
*
      FUNCTION UCIBAR(NX,NC,NCA,IX,XSL,XSU,XZL,XZU,IC,CSL,CSU,
     & CZL,CZU,ICA,D,S,RPF3)
      INTEGER NX,NC,NCA,IX(NX),IC(NC),ICA(NCA)
      REAL*8 XSL(NX),XSU(NX),XZL(NX),XZU(NX),CSL(NC),CSU(NC),
     & CZL(NC),CZU(NC),D(NCA),S(NCA),RPF3,UCIBAR
      INTEGER I,K
      REAL*8 TEMP
      TEMP=0.0D 0
      DO 1 I=1,NCA
      K=ICA(I)
      IF (K.LT.0) THEN
      K=-K
      IF (IX(K).EQ.-1.OR.IX(K).EQ.-3) THEN
      TEMP=TEMP-D(I)*(XZL(K)-S(I)-RPF3/XSL(K))**2
      ELSE IF (IX(K).EQ.-2.OR.IX(K).EQ.-4) THEN
      TEMP=TEMP-D(I)*(XZU(K)+S(I)-RPF3/XSU(K))**2
      ENDIF
      ELSE
      IF (IC(K).EQ.-1.OR.IC(K).EQ.-3) THEN
      TEMP=TEMP-D(I)*(CZL(K)-S(I)-RPF3/CSL(K))**2
      ELSE IF (IC(K).EQ.-2.OR.IC(K).EQ.-4) THEN
      TEMP=TEMP-D(I)*(CZU(K)+S(I)-RPF3/CSU(K))**2
      ENDIF
      ENDIF
    1 CONTINUE
      UCIBAR=TEMP
      RETURN
      END
