* SUBROUTINE UCIRMM             ALL SYSTEMS                 98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF TRANSPOSE OF THE ACTIVE CONSTRAINT MATRIX CG BY
* A VECTOR X.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NC  NUMBER OF GENERAL CONSTRAINTS.
*  II  NCA  NUMBER OF ACTIVE CONSTRAINTS.
*  II  MC  NUMBER OF NONZERO ELEMENTS IN THE FIELD CG.
*  IO  ICA(NCA)  VECTOR CONTAINING INDICES OF ACTIVE CONSTRAINTS.
*  RI  CG(MC)  ELEMENTS OF THE CONSTRAINT JACOBIAN MATRIX.
*  II  ICG(NC+1)  POSITION OF THE FIRST ROWS ELEMENTS IN THE FIELD CG.
*  II  JCG(MC)  COLUMN INDICES OF ELEMENTS IN THE FIELD CG.
*  RI  X(NF)  INPUT VECTOR.
*  RO  Y(NCA)  OUTPUT VECTOR EQUAL TO TRANS(CG)*X.
*
*  SUBPROGRAMS USED :
*  S   UXWDOT  DOT PRODUCT OF TWO VECTORS (PACKED CASE).
*
      SUBROUTINE UCIRMM(NF,NC,NCA,MC,ICA,CG,ICG,JCG,X,Y)
      INTEGER NF,NC,NCA,MC,ICA(NCA),ICG(NC+1),JCG(MC)
      REAL*8 CG(MC),X(NF),Y(NC)
      INTEGER I,K,KC,L
      REAL*8 UXWDOT
      DO 1 I=1,NCA
      KC=ICA(I)
      IF (KC.LT.0) THEN
      K=-KC
      Y(I)=X(K)
      ELSE
      K=ICG(KC)
      L=ICG(KC+1)-K
      Y(I)=UXWDOT(L,NF,JCG(K),CG(K),X,2)
      ENDIF
    1 CONTINUE
      RETURN
      END
