* SUBROUTINE UCLNF2             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF VALUES OF THE LINEAR CONSTRAINT FUNCTIONS.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NC  NUMBER OF FUNCTIONS.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  XN(NF)  VECTOR OF SCALING PARAMETERS.
*  RO  CF(NC)  VECTOR CONTAINING VALUES OF THE CONSTRAINT FUNCTIONS.
*  RI  CG(NF*MCL)  MATRIX WHOSE COLUMNS ARE NORMALS OF THE LINEAR
*         CONSTRAINTS.
*  II  ISNC  SAVING SPECIFICATION. ISNC=0-NO SAVING. ISNC=1-FUNCTION
*         VALUES ARE SAVED. ISNC=2-FUNCTION VALUES AND GRADIENTS ARE
*         SAVED.
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*
* SUBPROGRAMS USED :
*  RF   UXVDOT  DOT PRODUCT OF TWO VECTORS.
*  RF   UXVVDP  INVERSELY SCALED DOT PRODUCT OF TWO VECTORS.
*
      SUBROUTINE UCLNF2(NF,NC,X,XN,CF,CG,ISNC,NORMF)
      INTEGER NF,NC,ISNC,NORMF
      REAL*8 X(NF),XN(NF),CF(NC),CG(NF*NC)
      REAL*8 UXVDOT,UXVVDP
      INTEGER KC,JCG
      JCG=0
      DO 2 KC=1,NC
      IF (NORMF.GT.0.AND.ISNC.GT.2) THEN
      CF(KC)=UXVVDP(NF,XN,X,CG(JCG+1))
      ELSE
      CF(KC)=UXVDOT(NF,X,CG(JCG+1))
      ENDIF
      JCG=JCG+NF
    2 CONTINUE
      RETURN
      END
