* SUBROUTINE UCQADD               ALL SYSTEMS                   01/12/01
C PORTABILITY : ALL SYSTEMS
C 01/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* FINAL CG STEP AND DETERMINATION OF THE NEW ACTIVE CONSTRAINTS.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NX  NUMBER OF BOX CONSTRAINTS.
*  II  NC  NUMBER OF GENERAL CONSTRAINTS.
*  II  MC  NUMBER OF NONZERO ELEMENTS OF THE JACOBIAN MATRIX.
*  II  NCA  NUMBER OF ACTIVE CONSTRAINTS.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XL(NF)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RI  XU(NF)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  RI  CF(NC)  VECTOR CONTAINING VALUES OF THE CONSTRAINT FUNCTIONS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  CL(NC)  VECTOR CONTAINING LOWER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CU(NC)  VECTOR CONTAINING UPPER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  IO  ICA(NX+NC)  VECTOR CONTAINING INDICES OF ACTIVE CONSTRAINTS.
*  II  CG(MC)  ELEMENTS OF THE CONSTRAINT JACOBIAN MATRIX.
*  II  ICG(NC+1)  POSITIONS OF THE FIRST ROWS ELEMENTS IN THE SPARSE
*         JACOBIAN STRUCTURE.
*  RI  S(NF)  DIRECTION VECTOR.
*  RI  SO(NF)  OLD DIRECTION VECTOR.
*  RU  GS(NX+NC)  RIGHT HAND SIDE VECTOR.
*  RA  CP(NC)  AUXILIARY ARRAY.
*  RI  EPS9  TOLERANCE FOR ACTIVITY OF CONSTRAINTS.
*  IO  INEW  INDEX OF THE NEW ACTIVE CONSTRAINT.
*
*  COMMON DATA :
*  II  KBF  SPECIFICATION OF SIMPLE BOUNDS. KBF=0-NO SIMPLE BOUNDS.
*         KBF=1-ONE SIDED SIMPLE BOUNDS. KBF=2=TWO SIDED SIMPLE BOUNDS.
*  II  KBC  SPECIFICATION OF LINEAR CONSTRAINTS. KBC=0-NO LINEAR
*         CONSTRAINTS. KBC=1-ONE SIDED LINEAR CONSTRAINTS. KBC=2=TWO
*         SIDED LINEAR CONSTRAINTS.
*
      SUBROUTINE UCQADD(NF,NX,NC,NCA,MC,X,IX,XL,XU,CF,IC,CL,CU,CG,ICG,
     & ICA,S,SO,GS,CP,EPS9,INEW)
      INTEGER NS,ISB,ISP(20),ISD(20),KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI(7)
      COMMON /UMOPTI/ NS,ISB,ISP,ISD,KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI
      REAL*8 TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR(12)
      COMMON /UMOPTR/ TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR
      REAL*8 ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS(2)
      COMMON /UMCONS/ ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS
      CHARACTER*4 TSS(20)
      CHARACTER*8 TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,TUXX,
     & TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT(3)
      CHARACTER*80 TER
      COMMON /UMOPTT/ TSS,TER,TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,
     & TUXX,TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT
      CHARACTER*6 NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN
      CHARACTER*14 NAME
      COMMON /UMOPTN/ NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN,NAME
      INTEGER NF,NX,NC,NCA,MC,IX(NX),IC(NC),ICG(NC+1),ICA(NX+NC),INEW
      REAL*8 X(NF),XL(NX),XU(NX),CF(NC),CL(NC),CU(NC),CG(MC),S(NF),
     & SO(NF),GS(NX+NC),CP(NC),EPS9
      REAL*8 RMAX,TEMP,UXWDOT
      INTEGER KC,K,L
      INEW=0
      RMAX=ONE
      IF (KBF.GT.0) THEN
      DO 1 K=1,NX
      IF (IX(K).LT.0) S(K)=SO(K)
      IF (IX(K).EQ.1.OR.IX(K).GE.3) THEN
      IF (S(K)-SO(K).LT.ZERO) THEN
      TEMP=(XL(K)-X(K)-SO(K))/(S(K)-SO(K))
      IF (TEMP.LE.RMAX) THEN
      RMAX=TEMP
      INEW=-K
      ENDIF
      ENDIF
      ENDIF
      IF (IX(K).EQ.2.OR.IX(K).GE.3) THEN
      IF (S(K)-SO(K).GT.ZERO) THEN
      TEMP=(XU(K)-X(K)-SO(K))/(S(K)-SO(K))
      IF (TEMP.LE.RMAX) THEN
      RMAX=TEMP
      INEW=-K
      ENDIF
      ENDIF
      ENDIF
    1 CONTINUE
      ENDIF
      IF (INEW.NE.0) THEN
      INEW=0
      DO 2 K=1,NX
      IF (IX(K).GT.0) S(K)=SO(K)+RMAX*(S(K)-SO(K))
      IF (IX(K).EQ.1.OR.IX(K).GE.3) THEN
      IF (X(K)+S(K).LE.XL(K)+EPS9*MAX(ABS(XL(K)),ONE)) THEN
      S(K)=XL(K)-X(K)
      IX(K)=-IX(K)
      INEW=-K
      ENDIF
      ENDIF
      IF (IX(K).EQ.2.OR.IX(K).GE.3) THEN
      IF (X(K)+S(K).GE.XU(K)-EPS9*MAX(ABS(XU(K)),ONE)) THEN
      S(K)=XU(K)-X(K)
      IX(K)=-IX(K)
      INEW=-K
      ENDIF
      ENDIF
    2 CONTINUE
      ENDIF
      IF (KBC.GT.0) THEN
      DO 3 KC=1,NC
      IF (IC(KC).GT.0) THEN
      K=ICG(KC)
      L=ICG(KC+1)-K
      CP(KC)=CF(KC)+UXWDOT(L,NF,CG(K),S,2)
      ENDIF
      IF (IC(KC).EQ.1.OR.IC(KC).GE.3) THEN
      IF (CP(KC).LE.CL(KC)+EPS9*MAX(ABS(CL(KC)),ONE)) THEN
      IF (IC(KC).EQ.1) THEN
      IC(KC)=-1
      ELSE
      IC(KC)=-3
      ENDIF
      INEW=KC
      NCA=NCA+1
      ICA(NCA)=KC
      GS(NCA)=CL(KC)-CP(KC)
      ENDIF
      ENDIF
      IF (IC(K).EQ.2.OR.IC(K).GE.3) THEN
      IF (X(K)+S(K).GE.XU(K)-EPS9*MAX(ABS(XU(K)),ONE)) THEN
      IF (IC(KC).EQ.2) THEN
      IC(KC)=-2
      ELSE
      IC(KC)=-4
      ENDIF
      INEW=KC
      NCA=NCA+1
      ICA(NCA)=KC
      GS(NCA)=CU(KC)-CP(KC)
      ENDIF
      ENDIF
    3 CONTINUE
      ENDIF
      RETURN
      END
