* SUBROUTINE UCSSH3             ALL SYSTEMS                   98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE SPARSE HESSIAN MATRIX FROM THE SPARSE JACOBIAN
* MATRIX.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  NC  NUMBER OF ROWS OF THE SPARSE JACOBIAN MATRIX.
*  II  MC  NUMBER OF NONZERO ELEMENTS OF THE SPARSE JACOBIAN MATRIX.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE SPARSE HESSIAN MATRIX.
*  II  ML  SIZE OF THE FACTOR.
*  RU  H(M)  ELEMENTS OF THE SPARSE MATRIX H.
*  II  IH(NF+1)  POINTERS OF THE DIAGONAL ELEMENTS OF H.
*  II  JH(M)  COLUMN INDICES OF THE NONZERO ELEMENTS OF H.
*  II  ICG(NC+1)  POSITIONS OF THE FIRST ROWS ELEMENTS IN THE SPARSE
*         JACOBIAN STRUCTURE.
*  II  JCG(MC)  COLUMN INDICES OF ELEMENTS IN THE SPARSE JACOBIAN
*         STRUCTURE.
*  RI  GC(NF)  GRADIENT OF THE SELECTED FUNCTION.
*  II  KC  INDEX OF THE SELECTED FUNCTION (ROW OF THE SPARSE JACOBIAN
*         MATRIX).
*  RI  FACTOR  SCALING FACTOR.
*
      SUBROUTINE UCSSH3(N,NC,MC,M,ML,H,IH,JH,ICG,JCG,GC,KC,FACTOR)
      INTEGER N,NC,MC,M,ML,IH(N+1),JH(M),ICG(NC+1),JCG(MC),KC
      REAL*8 H(M),GC(N),FACTOR
      REAL*8 TEMP
      INTEGER I,J,JF,JC,K,LF,LC
      LC=ICG(KC+1)-1
      DO 6 K=ICG(KC),LC
      I=ABS(JCG(K))
      IF (I.LE.0) GO TO 6
      TEMP=FACTOR*GC(I)
      JF=IH(I)
      DO 5 JC=K,LC
      J=ABS(JCG(JC))
      IF (J.LE.0) GO TO 5
    2 IF (ABS(JH(JF)).LT.J) THEN
      JF=JF+1
      GO TO 2
      ENDIF
      LF=M+JH(M+ML+JF)
      H(LF)=H(LF)+TEMP*GC(J)
    5 CONTINUE
    6 CONTINUE
      RETURN
      END
