* SUBROUTINE UE1DQ2             ALL SYSTEMS                 98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE AND THE GRADIENT OF THE OBJECTIVE FUNCTION
* WHICH IS DEFINED AS A SUM OF SQUARES.
*
* PARAMETERS:
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  NE  DECLARED NUMBER OF DIFFERENTIAL EQUATIONS.
*  II  MEL  ACTUAL NUMBER OF DIFFERENTIAL EQUATIONS.
*  IU  KE  INDEX OF THE DIFFERENTIAL EQUATION.
*  RU  GE(NF)  GRADIENT OF THE RIGHT HAND SIDE FUNCTION.
*  RU  DE(NF)  DERIVATIVES OF THE RIGHT HAND SIDE FUNCTION.
*  RI  YA(MEL)  SOLUTION VECTOR.
*  RO  EF(MEL)  RIGHT HAND SIDE VECTOR.
*  RI  FE  VALUE OF THE RIGHT HAND SIDE FUNCTION.
*  RI  WE  WEIGHT COEFFICIENT.
*  RI  YE  REQUIRED VALUE OF THE RIGHT HAND SIDE FUNCTION.
*
* COMMON DATA :
*  II  KD  ORDER OF REQUIRED DERIVATIVES.
*  II  KDA  ORDER OF ANALYTICALLY COMPUTED DERIVATIVES.
*  II  KDE  ORDER OF ANALYTICALLY COMPUTED DERIVATIVES.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S  UYPRO1  PROLOGUE.
*  S  UYEPI1  EPILOGUE.
*  S  UYSET0  STATUS DEFINITION.
*  S  UXVCOP  COPYING OF A VECTOR.
*  S  UXVDIR  VECTOR AUGMENTED BY THE SCALED VECTOR.
*  S  UXVSET  INITIATION OF A VECTOR.
*
      SUBROUTINE UE1DQ2(NF,NE,MEL,KE,GE,DE,YA,EF,FE,WE,YE)
      INTEGER NS,ISB,ISP(20),ISD(20),KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI(7)
      COMMON /UMOPTI/ NS,ISB,ISP,ISD,KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI
      REAL*8 TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR(12)
      COMMON /UMOPTR/ TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR
      REAL*8 ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS(2)
      COMMON /UMCONS/ ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS
      CHARACTER*4 TSS(20)
      CHARACTER*8 TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,TUXX,
     & TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT(3)
      CHARACTER*80 TER
      COMMON /UMOPTT/ TSS,TER,TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,
     & TUXX,TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT
      CHARACTER*6 NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN
      CHARACTER*14 NAME
      COMMON /UMOPTN/ NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN,NAME
      INTEGER NF,NE,MEL,KE
      REAL*8 GE(NF),DE(NE),YA(MEL),EF(MEL),FE,WE,YE
      IF (TSS(NS).NE.'UEXX') CALL UYPRO1('UEXX',-1)
      GO TO (1,3) ISP(NS)
    1 CONTINUE
      IF (KD.LE.0.AND.KDA.GE.0) EF(NE+1)=ZERO
      IF (KD.GT.0) THEN
      CALL UXVSET(NE,ZERO,EF(NE+1))
      CALL UXVSET(NF,ZERO,EF(2*NE+1))
      ENDIF
      KE=1
    2 IF (KE.GT.NE) GO TO 4
      CALL UYSET0(1,2)
      RETURN
    3 CONTINUE
      EF(KE)=FE
      IF (KD.LE.0.AND.KDA.GE.0) EF(NE+1)=EF(NE+1)+HALF*WE*(YA(KE)-YE)**2
      IF (KD.GT.0) THEN
      CALL UXVDIR(NE,-YA(NE+KE),DE,EF(NE+1),EF(NE+1))
      EF(NE+KE)=EF(NE+KE)+WE*(YA(KE)-YE)
      IF (KDE.GT.0) CALL UXVDIR(NF,-YA(NE+KE),GE,EF(2*NE+1),EF(2*NE+1))
      ENDIF
      KE=KE+1
      GO TO 2
    4 CALL UYEPI1(-1)
      RETURN
      END
