* SUBROUTINE UEVEXB                ALL SYSTEMS                94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* HERMITE INTERPOLATION FOR THE FIFTH ORDER DORMAN AND PRINCE INTEGRATION
* FORMULA.
*
* PARAMETERS :
*  II  N  DECLARED NUMBER OF DIFFERENTIAL EQUATIONS.
*  RU  Y(N*(IMIT+5))  FIELD OF SOLUTION VECTORS IN THE MESH POINTS.
*  II  IMIT  NUMBER OF SOLUTION VECTORS IN THE MESH POINTS.
*
      SUBROUTINE UEVEXB(N,Y,IMIT)
      INTEGER N,IMIT
      REAL*8 Y(N*(IMIT+5)),A(0:30)
      REAL*8 Y0,Y1,YP0,YP1,YDIFF,ASPL,BSPL,PH0,PH1,PH2,PH3,FAC1,FAC2
      INTEGER I,IM
C
C     BEGIN WITH HERMITE INTERPOLATION
C
      DO 100 I=1,N
      Y0=Y(I)
      Y1=Y(2*N+I)
      YP0=Y(N+I)
      YP1=Y(3*N+I)
      YDIFF=Y1-Y0
      ASPL=-YP1+YDIFF
      BSPL=YP0-YDIFF
      Y(N+I)=YDIFF
      Y(2*N+I)=ASPL
      Y(3*N+I)=BSPL
      IF (IMIT.LT.0) GOTO 100
C
C     COMPUTE THE DERIVATIVES OF HERMITE AT MIDPOINT
C
      PH0=(Y0+Y1)*0.5D0+0.125D0*(ASPL+BSPL)
      PH1=YDIFF+(ASPL-BSPL)*0.25D0
      PH2=-(YP0-YP1)
      PH3=6.D0*(BSPL-ASPL)
C
C     COMPUTE THE FURTHER COEFFICIENTS
C
      IF (IMIT.LT.1) GOTO 20
      A(1)=16.D0*(Y(5*N+I)-PH1)
      IF (IMIT.LT.3) GOTO 20
      A(3)=16.D0*(Y(7*N+I)-PH3+3*A(1))
      IF (IMIT.LT.5) GOTO 20
      DO 10 IM=5,IMIT,2
      FAC1=IM*(IM-1)/2.D0
      FAC2=FAC1*(IM-2)*(IM-3)*2.D0
  10  A(IM)=16.D0*(Y((IM+4)*N+I)+FAC1*A(IM-2)-FAC2*A(IM-4))
  20  CONTINUE
      A(0)=(Y(4*N+I)-PH0)*16.D0
      IF (IMIT.LT.2) GOTO 60
      A(2)=(Y(N*6+I)-PH2+A(0))*16.D0
      IF (IMIT.LT.4) GOTO 60
      DO 30 IM=4,IMIT,2
      FAC1=IM*(IM-1)/2.D0
      FAC2=IM*(IM-1)*(IM-2)*(IM-3)
  30  A(IM)=(Y(N*(IM+4)+I)+A(IM-2)*FAC1-A(IM-4)*FAC2)*16.D0
  60  CONTINUE
      DO 70 IM=0,IMIT
  70  Y(N*(IM+4)+I)=A(IM)
 100  CONTINUE
      RETURN
      END
