* SUBROUTINE UFSET7             ALL SYSTEMS                   07/12/01
C PORTABILITY : ALL SYSTEMS
C 07/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SPARSE STRUCTURE OF THE JACOBIAN IS COMPUTED FROM THE INPUT DATA.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  M  NUMBER OF NONZERO ELEMENTS IN THE UPPER PART OF THE SPARSE
*         HESSIAN MATRIX.
*  IU  IH(M+NF)  ON INPUT ROW INDICES OF NONZERO ELEMENTS IN THE FIELD
*         H. ON OUTPUT POSITIONS OF DIAGONAL ELEMENTS IN THE FIELD H.
*  II  JH(M)  COLUMN INDICES OF NONZERO ELEMENTS IN THE FIELD H.
*
      SUBROUTINE UFSET7(NF,M,IH,JH)
      INTEGER NF,M,IH(M+NF),JH(M+NF)
      INTEGER I,J,K,L,LL
      DO 1 J=1,M
      IF (IH(J).GT.JH(J)) THEN
      K=IH(J)
      IH(J)=JH(J)
      JH(J)=K
      ENDIF
    1 CONTINUE
      DO 2 I=1,NF
      IH(M+I)=I
      JH(M+I)=I
    2 CONTINUE
      CALL UXVSR7(M+NF,IH,JH)
      K=1
      DO 3 J=1,M+NF
      IF (IH(J).EQ.K) THEN
      IH(K)=J
      K=K+1
      ENDIF
    3 CONTINUE
      IH(K)=J
      LL=0
      DO 5 I=1,NF
      K=IH(I)
      L=IH(I+1)-K
      CALL UXVSRT(L,JH(K))
      IH(I)=IH(I)-LL
      DO 4 J=1,L
      IF (J.GT.1.AND.JH(K).EQ.JH(K-1)) THEN
      LL=LL+1
      ELSE
      JH(K-LL)=JH(K)
      ENDIF
      K=K+1
    4 CONTINUE
    5 CONTINUE
      IH(NF+1)=IH(NF+1)-LL
      M=IH(NF+1)-1
      RETURN
      END
