* SUBROUTINE UKLNBS                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* NONBASIC PART OF SOLUTION IS SET UP.
*
* PARAMETERS :
*  II  N NUMBER OF COLUMNS.
*  II  M NUMBER OF ROWS.
*  II  MROWS DECLARED NUMBER OF ROWS.
*  II  MCOLS DECLARED NUMBER OF COLUMNS.
*  II  NZA  SIZE OF ARRAYS A/RNR.
*  II  RNR(NZA) ROW INDICES OF CONSTRAINT MATRIX.
*  II  PRNR(MCOLS+1) POINTER VECTOR TO RNR.
*  RI  A(NZA) NUMERICAL VALUES OF THE CONSTRAINT MATRIX
*             CORRESPONDING TO RNR.
*  RA  WR01(MROWS) AUXILIARY VECTOR.
*  RU  X(MCOLS) VECTOR OF SOME ESTIMATE TO THE SOLUTION - NOT AVAILABLE
*           FOR IJOB.GT.4.
*  RI  LB(MCOLS) LOWER BOUNDS ON VARIABLES.
*  RI  UB(MCOLS) UPPER BOUNDS ON VARIABLES.
*  IU  TYPE(MCOLS) TYPE OF THE VARIABLES:
*                                    =1 FOR NONBASIC LOWER BOUNDED
*                                    =2 FOR NONBASIC UPPER BOUNDED
*                                    =3 FOR NONBASIC LOWER AND UPPER
*                     BOUNDED VARIABLE SET TO ITS LOWER BOUND
*                                    =4 FOR NONBASIC LOWER AND UPPER
*                     BOUNDED VARIABLE SET TO ITS UPPER BOUND
*                                    =5 FOR NONBASIC FIXED VARIABLE
*                                    =6 FOR NONBASIC FREE VARIABLE
*                                    =-1 FOR BASIC LOWER BOUNDED
*                                    =-2 FOR BASIC UPPER BOUNDED
*                                    =-3 FOR BASIC LOWER AND UPPER
*                     BOUNDED VARIABLE
*                                    =-6 FOR BASIC FREE VARIABLE.
*  II  MFP  TYPE OF FEASIBLE POINT: =0 WHEN NO FFEASIBLE/NONFEASIBLE
*           SOLUTION IS INITIALLY GIVEN,  >0 WHEN SOME SOLUTION IS
*           GIVEN AND WE WANT AT LEAST A FEASIBLE ONE.
*
      SUBROUTINE UKLNBS(N,M,MROWS,MCOLS,NZA,RNR,PRNR,A,WR01,X,LB,UB,
     & TYPE,MFP)
      INTEGER N,M,MROWS,MCOLS,NZA,RNR(NZA),PRNR(MCOLS+1),TYPE(MCOLS),
     & MFP
      REAL*8 A(NZA),WR01(MROWS),X(MCOLS),LB(MCOLS),UB(MCOLS)
      INTEGER I,J,K
      REAL*8 BL,BU
C
C INITIALIZE WR01
C
      DO 50 I=1,M
      WR01(I)=0.0D 0
   50 CONTINUE
C
C SET INITIAL VALUES OF NONBASIC VARIABLES
C
      IF(MFP.GT.0) THEN
        DO 100 I=1,N
          IF(TYPE(I).LT.0) GO TO 100
          IF(TYPE(I).EQ.1) THEN
             X(I)=LB(I)
          ELSEIF(TYPE(I).EQ.2) THEN
             X(I)=UB(I)
          ELSEIF(TYPE(I).EQ.3) THEN
             BL=LB(I)
             BU=UB(I)
             IF(ABS(X(I)-BL).LT.ABS(X(I)-BU)) THEN
                X(I)=BL
                ELSE
                X(I)=BU
                TYPE(I)=4
             END IF
          ELSEIF(TYPE(I).EQ.5) THEN
             X(I)=LB(I)
          ELSEIF(TYPE(I).EQ.6) THEN
             X(I)=X(I)
          ELSE
             X(I)=0.0D 0
          END IF
C
C PUT INTO WR01 NEGATIVE SUM OF NONBASICS' CONTRIBUTIONS
C
          DO 60 J=PRNR(I),PRNR(I+1)-1
            K=RNR(J)
            WR01(K)=WR01(K)-X(I)*A(J)
   60     CONTINUE
  100   CONTINUE
C
C IN CASE TYPE(I).EQ.5 WE PASS THE VALUE OF X(I)
C
      ELSEIF(MFP.EQ.0) THEN
        DO 200 I=1,N
          IF(TYPE(I).LT.0) GO TO 200
          IF(TYPE(I).EQ.1) THEN
             X(I)=LB(I)
          ELSEIF(TYPE(I).EQ.2) THEN
             X(I)=UB(I)
          ELSEIF(TYPE(I).EQ.3) THEN
             BL=LB(I)
             BU=UB(I)
             IF(ABS(0.0D 0-BL).LT.ABS(0.0D 0-BU)) THEN
                X(I)=BL
                ELSE
                X(I)=BU
                TYPE(I)=4
             END IF
          ELSEIF(TYPE(I).EQ.5) THEN
             X(I)=LB(I)
          ELSE
             X(I)=0.0D 0
          END IF
C
C PUT INTO WR01 NEGATIVE SUM OF NONBASICS' CONTRIBUTIONS
C
        DO 300 J=PRNR(I),PRNR(I+1)-1
          K=RNR(J)
          WR01(K)=WR01(K)-X(I)*A(J)
  300   CONTINUE
  200   CONTINUE
      END IF
      RETURN
      END
