* SUBROUTINE UKSII2                 ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
*  SYMBOLIC INPUT OF THE ELEMENT A(I,J)
*
* PARAMETERS :
*  II  MROWS DECLARED NUMBER OF ROWS.
*  II  MCOLS DECLARED NUMBER OF COLUMNS.
*  II  NZ  SIZE OF ARRAYS INR/CNR.
*  II  NAU SIZE OF VECTORS AI/AU.
*  II  I  INPUT ROW INDEX.
*  II  J  INPUT COLUMN INDEX.
*  II  PIN SIZE OF THE INPUT MATRIX STRUCTURE.
*  IU  PINR(MROWS) VECTOR POINTING AT BEGINNINGS OF THE INPUT MATRIX ROWS
*  IU  INR(NZ) INPUT MATRIX COLUMN INDICES.
*  IU  LENR(MROWS) LENGTHS OF THE INPUT MATRIX ROWS.
*  IU  IER  INFORMATION FLAG: =0 FOR SUCCESFUL WORK,=1 WHEN ELEMENT
*           IS STORED REPEATEDLY,=2 WHEN LACK OF SPACE IS FACED,
*           =3 WHEN SOME OTHER ERROR IS FACED.
*
* SUBROUTINES USED:
*  S   UKMCP2  GARBAGE COLLECTION
*
      SUBROUTINE UKSII2(MROWS,MCOLS,NZ,NAU,I,J,PIN,PINR,INR,LENR,IER)
      INTEGER MROWS,MCOLS,NZ,NAU,I,J,PIN,PINR(MROWS),INR(NZ),
     & LENR(MROWS),IER
      INTEGER KSTRT,KSTOP,L,K,J1,J2,J3,IQCMPR
C
C     INITIALIZE IER
C
      IF(IER.NE.0) THEN
                   RETURN
      END IF
C
C     ROW BEGINS AT KSTRT
C
      KSTRT=PINR(I)
      KSTOP=KSTRT+LENR(I)-1
      J=INT(J)
      IF(J.LE.0) THEN
                 IER=3
                 RETURN
      END IF
      DO 100 K=KSTRT,KSTOP
      L=INR(K)
      IF(L.EQ.J) THEN
                 IER=1
                 RETURN
      END IF
100   CONTINUE
C
C     TRY TO PLACE ELEMENT AT THE END
C
200   IF(INR(KSTOP+1).EQ.0) THEN
                            IQCMPR=0
                            KSTOP=KSTOP+1
                            INR(KSTOP)=J
                            PIN=MAX(PIN,KSTOP)
                            LENR(I)=LENR(I)+1
                            ELSE
                            J1=KSTOP-KSTRT+1
          IF((PIN+J1).LT.MIN(NZ,NAU)) THEN
                                  DO 300 J2=1,J1
                                  J3=KSTRT+J2-1
                                  INR(J2+PIN)=INR(J3)
                                  INR(J3)=0
300                               CONTINUE
                                  KSTRT=PIN+1
                                  PINR(I)=KSTRT
                                  KSTOP=PIN+J1
                                  GO TO 200
                                           ELSE
              IF(IQCMPR.EQ.1) THEN
                              IER=2
                              RETURN
              END IF
              IQCMPR=1
              CALL UKMCP2(MROWS,MCOLS,NZ,PINR,LENR,INR,1,PIN+1)
              KSTRT=PINR(I)
              KSTOP=KSTRT+LENR(L)-1
              GO TO 200
          END IF
      END IF
      RETURN
      END
