* SUBROUTINE ULMAXA               ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETERMINATION OF THE MAXIMUM STEPSIZE USING LINEAR FUNCTIONS.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  NA  NUMBER OF DECLARED LINEAR APPROXIMATED FUNCTIONS.
*  II  NAD  NUMBER OF CURRENT LINEAR APPROXIMATED FUNCTIONS.
*  II  NC  NUMBER OF CURRENT LINEAR CONSTRAINTS.
*  RI  AF(2*NA)  VECTOR CONTAINING VALUES OF THE APPROXIMATED FUNCTIONS.
*  RO  AFD(2*NA)  VECTOR CONTAINING INCREMENTS OF THE APPROXIMATED
*         FUNCTIONS.
*  II  IA(2*NA)  VECTOR CONTAINING TYPES OF APPROXIMATED FUNCTIONS.
*  RI  AG(NF*NA)  MATRIX WHOSE COLUMNS ARE GRADIENTS OF THE APPROXIMATED
*         FUNCTIONS.
*  RI  S(NF)  DIRECTION VECTOR.
*  RO  STEP  MAXIMUM STEPSIZE.
*  RI  XNORM  VALUE OF A LINEARIZED MINIMAX FUNCTION.
*  RI  SNORM  SLOPE OF A LINEARIZED MINIMAX FUNCTION DECREASE.
*  II  KREM  INDICATION OF LINEARLY DEPENDENT GRADIENTS.
*  IO  INEW  INDEX OF THE NEW ACTIVE FUNCTION.
*
* SUBPROGRAMS USED :
*  RF  UXVDOT  DOT PRODUCT OF TWO VECTORS.
*
      SUBROUTINE ULMAXA(NF,NA,NAD,NC,AF,AFD,IA,AG,S,STEP,XNORM,SNORM,
     & KREM,INEW)
      INTEGER NF,NA,NAD,NC,IA(2*NA),KREM,INEW
      REAL*8 AF(2*NA),AFD(2*NA),AG(NF*NA),S(NF),STEP,XNORM,SNORM
      REAL*8 TEMP,POM,UXVDOT
      INTEGER JAG,KA
      JAG=1
      DO 1 KA=1,NAD
      IF (KREM.GT.0.AND.IA(KA).GT.10) IA(KA)=IA(KA)-10
      IF (IA(KA).GT.0.AND.IA(KA).LE.10) THEN
      TEMP=UXVDOT(NF,AG(JAG),S)
      AFD(KA)=TEMP
      IF (IA(KA).EQ.1.OR.IA(KA).EQ.3) THEN
      IF (TEMP+SNORM.LT.0.0D 0) THEN
      POM=-(AF(KA)+XNORM)/(TEMP+SNORM)
      IF (POM.LE.STEP) THEN
      INEW=KA+NC
      STEP=MAX(0.0D 0,POM)
      ENDIF
      ENDIF
      ENDIF
      IF (IA(KA).EQ.2.OR.IA(KA).EQ.4) THEN
      IF (TEMP-SNORM.GT.0.0D 0) THEN
      POM=-(AF(KA)-XNORM)/(TEMP-SNORM)
      IF (POM.LE.STEP) THEN
      INEW=KA+NC
      STEP=MAX(0.0D 0,POM)
      ENDIF
      ENDIF
      ENDIF
      ENDIF
      IF (KA.EQ.NA) THEN
      JAG=1
      ELSE
      JAG=JAG+NF
      ENDIF
    1 CONTINUE
      RETURN
      END
