* SUBROUTINE ULMINS             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETERMINATION OF THE NEW ACTIVE SIMPLE BOUND.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RI  XO(NF)  SAVED VECTOR OF VARIABLES.
*  RI  XL(NF)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RI  XU(NF)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  RI  S(NF)  DIRECTION VECTOR.
*  RI  EPS9  TOLERANCE FOR ACTIVE CONSTRAINTS.
*  RA  PAR  AUXILIARY VARIABLE.
*  II  KBF  SPECIFICATION OF SIMPLE BOUNDS. KBF=0-NO SIMPLE BOUNDS.
*         KBF=1-ONE SIDED SIMPLE BOUNDS. KBF=2=TWO SIDED SIMPLE BOUNDS.
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*  IO  INEW  INDEX OF THE NEW ACTIVE CONSTRAINT.
*  IO  KNEW  SIGNUM OF THE NEW NORMAL.
*
      SUBROUTINE ULMINS(NF,IX,XN,XO,XL,XU,S,EPS9,PAR,KBF,NORMF,INEW,
     & KNEW)
      INTEGER NF,IX(NF),KBF,NORMF,INEW,KNEW
      REAL*8 XN(NF),XO(NF),XL(NF),XU(NF),S(NF),EPS9,PAR
      REAL*8 POM,TEMP
      INTEGER I
      IF (KBF.GT.0) THEN
      DO 1 I=1,NF
      IF(IX(I).GT.0) THEN
      TEMP=1.0D 0
      IF (NORMF.GT.0) TEMP=XN(I)
      IF (IX(I).EQ.1.OR.IX(I).GE.3) THEN
      POM=XO(I)+S(I)*TEMP-XL(I)
      IF (POM.LT.MIN(PAR,-EPS9*MAX(ABS(XL(I)),TEMP))) THEN
      INEW=-I
      KNEW= 1
      PAR=POM
      ENDIF
      ENDIF
      IF (IX(I).EQ.2.OR.IX(I).GE.3) THEN
      POM=XU(I)-S(I)*TEMP-XO(I)
      IF (POM.LT.MIN(PAR,-EPS9*MAX(ABS(XU(I)),TEMP))) THEN
      INEW=-I
      KNEW=-1
      PAR=POM
      ENDIF
      ENDIF
      ENDIF
    1 CONTINUE
      ENDIF
      RETURN
      END
