* SUBROUTINE ULRMZ1               ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* NEW BASIC VECTOR FROM THE REDUCED SUBSPACE IS G-ORTOGONALIZED.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  RI  CR(NF*(NF+1)/2)  TRIANGULAR DECOMPOSITION OF KERNEL OF THE
*         ORTHOGONAL PROJECTION.
*  RI  CZ(NF*NF)  MATRIX WHOSE COLUMNS ARE BASIC VECTORS FROM THE
*         CURRENT REDUCED SUBSPACE.
*  RU  H(NF*(NF+1)/2)  TRIANGULAR DECOMPOSITION OR INVERSION OF THE
*         HESSIAN MATRIX APPROXIMATION.
*  II  IDECF  DECOMPOSITION INDICATOR. IDECF=0-NO DECOMPOSITION.
*  IO  IER  ERROR INDICATOR.
*
* SUBPROGRAMS USED:
*  S   UXDPGM  MATRIX VECTOR PRODUCT AFTER GILL-MURRAY DECOMPOSITION.
*  S   UXDPGQ  VALUE OF THE QUADRATIC FORM AFTER GILL-MURRAY
*         DECOMPOSITION.
*  S   UXDSMM  MATRIX VECTOR PRODUCT.
*  S   UXDSMQ  VALUE OF THE QUADRATIC FORM.
*  S   UXVCOP  COPYING OF A VECTOR.
*  S   UXVDIR  VECTOR AUGMENTED BY THE SCALED VECTOR.
*  RF  UXVDOT  DOT PRODUCT OF TWO VECTORS.
*  S   UXVSCL  SCALING OF A VECTOR.
*
      SUBROUTINE ULRMZ1(NF,N,CR,CZ,H,IDECF,IER)
      INTEGER NF,N,IDECF,IER
      REAL*8 CR(NF*(NF+1)/2),CZ(NF*NF),H(NF*(NF+1)/2)
      REAL*8 TEMP,UXDPGQ,UXDSMQ,UXVDOT
      INTEGER NCA,NCR,NCZ,JCZ,J
      IF (IDECF.NE.0.AND.IDECF.NE.1) THEN
      IER=-2
      RETURN
      ENDIF
      J=NF
      NCA=NF-N
      NCR=NCA*(NCA+1)/2
      NCZ=(N-1)*NF+1
      JCZ=(J-1)*NF+1
      IF (N.GT.1) THEN
      IF (IDECF.EQ.0) THEN
      CALL UXDSMM(NF,H,CZ(NCZ),CR(NCR+1))
      ELSE
      CALL UXVCOP(NF,CZ(NCZ),CR(NCR+1))
      CALL UXDPGM(NF,H,CR(NCR+1),0)
      ENDIF
      JCZ=1
      DO 1 J=1,N-1
      TEMP=UXVDOT(NF,CZ(JCZ),CR(NCR+1))
      CALL UXVDIR(NF,-TEMP,CZ(JCZ),CZ(NCZ),CZ(NCZ))
      JCZ=JCZ+NF
    1 CONTINUE
      ENDIF
      IF (IDECF.EQ.0) THEN
      TEMP=SQRT(UXDSMQ(NF,H,CZ(NCZ),CZ(NCZ)))
      ELSE
      CALL UXVCOP(NF,CZ(NCZ),CR(NCR+1))
      CALL UXDPGM(NF,H,CR(NCR+1),1)
      TEMP=SQRT(UXDPGQ(NF,H,CR(NCR+1),CR(NCR+1)))
      ENDIF
      CALL UXVSCL(NF,1.0D 0/TEMP,CZ(NCZ),CZ(NCZ))
      RETURN
      END
