* SUBROUTINE UNDOG1                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETERMINATION OF A SCALING FACTOR FOR THE DOG-LEG STRATEGY.
*
* PARAMETERS :
*  RI  DEL  MAXIMUM STEPSIZE.
*  RI  C  INPUT PARAMETER.
*  RI  CD  INPUT PARAMETER.
*  RI  D  INPUT PARAMETER.
*  RI  TAU  PARAMETER FOR THE DOUBLE DOG-LEG STRATEGY.
*  RO  ALF  SCALING FACTOR FOR THE DOG-LEG STRATEGY.
*  RO  BET  SCALING FACTOR FOR THE DOG-LEG STRATEGY.
*  II  JOB  SPECIFICATION. IF JOB.EQ.1 THEN SINGLE DOG-LEG STRATEGY
*         IS USED. IF JOB.EQ.2 THEN DOUBLE DOG-LEG STRATEGY IS USED.
*
      SUBROUTINE UNDOG1(DEL,C,CD,D,TAU,ALF,BET,JOB)
      INTEGER JOB
      REAL*8 DEL,C,CD,D,TAU,ALF,BET
      REAL*8 CPOM,CDPOM,DPOM
      REAL*8 ZERO,ONE
      PARAMETER (ZERO=0.0D 0,ONE=1.0D 0)
      IF (C.GE.DEL) THEN
      ALF=ZERO
      BET=DEL/C
      ELSE IF (D.LE.DEL) THEN
      ALF=ONE
      BET=ZERO
      ELSE IF (JOB.GT.1.AND.TAU.LE.DEL/D) THEN
      ALF=DEL/D
      BET=ZERO
      ELSE
      CPOM=C/DEL
      CDPOM=CD/D/DEL
      DPOM=DEL/D
      IF (JOB.GT.1) THEN
      TAU=MIN(TAU,ONE)
      CDPOM=TAU*CDPOM
      BET=TAU**2-DPOM**2
      ELSE
      BET=ONE-DPOM**2
      ENDIF
      ALF=ONE-CPOM**2
      BET=CDPOM-DPOM*CPOM**2+SQRT((CDPOM-DPOM)**2+ALF*BET)
      ALF=DPOM*ALF/BET
      BET=ONE-ALF
      IF (JOB.GT.1) ALF=ALF*TAU
      ENDIF
      RETURN
      END
