* SUBROUTINE UNINT7                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* EXTRAPOLATION OR INTERPOLATION FOR LINE SEARCH USED IN LEAST SQUARES
* APPROXIMATION.
*
* PARAMETERS :
*  RO  R  VALUE OF THE STEPSIZE PARAMETER.
*  RI  RL  LOWER VALUE OF THE STEPSIZE PARAMETER.
*  RI  RU  UPPER VALUE OF THE STEPSIZE PARAMETER.
*  RO  RP  PREVIOUS VALUE OF THE STEPSIZE PARAMETER.
*  RI  FL  VALUE OF THE OBJECTIVE FUNCTION FOR R=RL.
*  RI  FU  VALUE OF THE OBJECTIVE FUNCTION FOR R=RU.
*  RO  FP  PREVIOUS VALUE OF THE OBJECTIVE FUNCTION.
*  RI  PL  DIRECTIONAL DERIVATIVE FOR R=RL.
*  RI  PU  DIRECTIONAL DERIVATIVE FOR R=RU.
*  RO  PP  PREVIOUS VALUE OF THE DIRECTIONAL DERIVATIVE.
*  RI  ETA9  MAXIMUM VALUE LESS THEN INFINITY.
*  II  MES1  SWITCH FOR EXTRAPOLATION. MES1=1-CONSTANT INCREASING OF
*         THE INTERVAL. MES1=2-EXTRAPOLATION SPECIFIED BY THE PARAMETER
*         MES. MES1=3 SUPPRESSED EXTRAPOLATION.
*  IO  MERR  ERROR INDICATOR. MERR=0 FOR NORMAL RETURN.
*  IO  MODE  MODE OF LINE SEARCH. MODE=0-INITIAL STEPSIZE.
*
* COMMON DATA :
*
      SUBROUTINE UNINT7(R,RL,RU,RP,FL,FU,FP,PL,PU,PP,ETA9,MES1,MERR,
     & MODE)
      INTEGER NS,ISB,ISP(20),ISD(20),KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI(7)
      COMMON /UMOPTI/ NS,ISB,ISP,ISD,KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI
      REAL*8 TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR(12)
      COMMON /UMOPTR/ TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR
      REAL*8 ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS(2)
      COMMON /UMCONS/ ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS
      CHARACTER*4 TSS(20)
      CHARACTER*8 TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,TUXX,
     & TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT(3)
      CHARACTER*80 TER
      COMMON /UMOPTT/ TSS,TER,TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,
     & TUXX,TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT
      CHARACTER*6 NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN
      CHARACTER*14 NAME
      COMMON /UMOPTN/ NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN,NAME
      INTEGER MES1,MERR,MODE
      REAL*8 R,RL,RU,RP,FL,FU,FP,PL,PU,PP,ETA9
      REAL*8 B1,B2,B3,B4,C1,C2,C3,C4,POM,DEN,DIS,RBEST,SIX
      INTEGER K
      REAL*8 C1L,C1U,C2L,C2U,C3L,PI,CON1,CON2
      PARAMETER (C1L=1.1D 0,C1U=1.0D 4,C2L=1.0D-4,C2U=0.9D 0,
     * C3L=0.1D 0,PI=3.14159265358979323846D 0)
      PARAMETER (CON1=1.2D 2,CON2=1.0D-5)
      MERR=0
      IF (MODE.LE.0) THEN
      RETURN
      ELSE IF (MODE.EQ.1) THEN
      IF (MES1.EQ.1) THEN
      R=FOUR*RU
      TSXX='BISECT. '
      RETURN
      ELSE
      TSXX='LSQ EXT '
      ENDIF
      ELSE IF (MODE.EQ.2) THEN
      TSXX='LSQ INT '
      ENDIF
      IF (RP.EQ.RL.OR.RP.EQ.RU) THEN
      DEN=RU-RL
      B1=(FU-FL)/(PL*DEN)
      B3=PU/PL
      C1=B3-TWO*B1+ONE
      C3=B3-THREE*B1+TWO
      DIS=C3*C3-THREE*C1
      IF (DIS.LT.ZERO) THEN
      DIS=TWO*(ONE-B1)
      POM=ONE-B3
      R=HALF*(DEN/DIS+DEN/POM)
      TSXX='QUAD-3  '
      GO TO 3
      ELSE
      POM=C3+SQRT(DIS)
      R=DEN/POM
      TSXX='CUBIC   '
      GO TO 3
      ENDIF
      ENDIF
      RBEST=ZERO
      IF (FU.LT.FL) RBEST=RU-RL
      SIX=THREE+THREE
C
C     DETERMINATION OF COEFFICIENTS OF THE CUBIC EQUATION
C     C1 + C2*R + 3*C3*R**2 + 2*C4*R**3 = 0
C
      DEN=RU-RL
      DIS=RP-RL
      POM=RP-RU
      B1=((FU-FL)/(PL*DEN)-ONE)/DEN
      B2=((FP-FL)/(PL*DIS)-ONE)/DIS
      B3=((PU/PL-ONE)/DEN-TWO*B1)/DEN
      B4=((PP/PL-ONE)/DIS-TWO*B2)/DIS
      C4=HALF*(B4-B3)/POM
      C3=HALF*B3-DEN*C4
      C2=B1-DEN*(TWO*C3+DEN*C4)
      C1=HALF
      B3=THREE*C3
      B4=TWO*C4
C
C     DECISION BETWEEN DIRECT AND ITERATIVE SOLUTION
C
      POM=C1+RBEST*(C2+RBEST*(B3+RBEST*B4))
      DEN=C2+SIX*RBEST*(C3+RBEST*C4)
      IF (DEN.EQ.ZERO) THEN
      DIS=ETA9
      ELSE
      DIS=ABS(POM/DEN)
      ENDIF
      B2=ABS(C3+TWO*C4*RBEST)+FOUR*C4*DIS
      IF (DEN.LE.CON1*B2*MAX(ONE,DIS)) THEN
C
C     DIRECT SOLUTION
C
      B1=C1/B4
      B2=C2/B4
      B3=C3/B4
      POM=(B2-THREE*B3**2)/THREE
      DEN=(B1-B2*B3+TWO*B3**3)/TWO
      DIS=DEN**2+POM**3
      IF (DIS.LT.ZERO) THEN
C
C     THREE REAL ROOTS
C
      DIS=SQRT(-DIS)
      IF (DEN.EQ.ZERO) THEN
      B1=HALF*PI
      ELSE
      B1=ATAN(DIS/ABS(DEN))
      ENDIF
      B2=TWO*SQRT(-POM)
      IF (DEN.GT.ZERO) B2=-B2
      C1=B2*COS(B1/THREE)-B3
      C2=B2*COS((B1+ TWO*PI)/THREE)-B3
      C3=B2*COS((B1+FOUR*PI)/THREE)-B3
      IF (C2.LT.C1) THEN
      C4=C1
      C1=C2
      C2=C4
      ENDIF
      IF (C3.LT.C1) THEN
      C4=C1
      C1=C3
      C3=C4
      ENDIF
      IF (C3.LT.C2) THEN
      C4=C2
      C2=C3
      C3=C4
      ENDIF
      IF (MODE.EQ.1) THEN
      DEN=RU-RL
      IF (C1.GT.DEN) THEN
      R=C1
      ELSE IF (C2.GT.DEN) THEN
      R=C2
      ELSE
      R=C3
      ENDIF
      ELSE
      IF (RBEST.LE.C2.AND.C1.GT.ZERO) THEN
      R=C1
      ELSE
      R=C3
      ENDIF
      ENDIF
      ELSE
C
C     ONE REAL ROOT
C
      DIS=SQRT(DIS)
      B1=-DEN-DIS
      B2=-DEN+DIS
      C1=SIGN(ONE,B1)
      C2=SIGN(ONE,B2)
      C3=ONE/THREE
      R=C1*ABS(B1)**C3+C2*ABS(B2)**C3-B3
      ENDIF
      ELSE
C
C     ITERATIVE SOLUTION BY THE NEWTON METHOD
C
      K=1
    2 DIS=-POM/DEN
      R=RBEST+DIS
      B1=B2*DIS*DIS/ABS(DEN)
      IF (B1.LE.CON2.OR.K.GE.3) GO TO 3
      K=K+1
      RBEST=R
      POM=C1+RBEST*(C2+RBEST*(B3+RBEST*B4))
      DEN=C2+SIX*RBEST*(C3+RBEST*C4)
      GO TO 2
      ENDIF
    3 DEN=RU-RL
      IF (MODE.EQ.1) THEN
      IF (R.GT.DEN ) THEN
C
C     EXTRAPOLATION ACCEPTED
C
      R=RL+R
      R=MAX(R,C1L*RU)
      R=MIN(R,C1U*RU)
      ELSE
      R=FOUR*RU
      TSXX='BISECT. '
      ENDIF
      ELSE
      IF (R.GT.ZERO.AND.R.LT.DEN) THEN
C
C     INTERPOLATION ACCEPTED
C
      R=RL+R
      IF (RL.EQ.ZERO) THEN
      R = MAX(R,RL+C2L*(RU-RL))
      ELSE
      R = MAX(R,RL+C3L*(RU-RL))
      ENDIF
      R=MIN(R,RL+C2U*DEN)
      ELSE
      R=HALF*(RL+RU)
      TSXX='BISECT. '
      ENDIF
      ENDIF
      RETURN
      END
