* SUBROUTINE UNLAG5             ALL SYSTEMS                 05/12/01
C PORTABILITY : ALL SYSTEMS
C 05/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* ROOT OF THE NONLINEAR EQUATION (S/B)*((S+C)/B)**(P-1) = 1.
*
* PARAMETERS :
*  RI  C  INPUT PARAMETER.
*  RO  S  COMPUTED SOLUTION POINT.
*  RI  TOL  REQUIRED PRECISION FOR THE NONLINEAR FUNCTION.
*  IO  IE  ERROR SPECIFICATION.
*
*  COMMON DATA :
*  RI  P  REAL PARAMETER.
*  RI  B  REAL PARAMETER.
*
      SUBROUTINE UNLAG5(C,S,TOL,IE)
      INTEGER IE
      REAL*8 C,S,TOL
      INTEGER IC
      REAL*8 SL,SU,F,FUN5
      EXTERNAL FUN5
      REAL*8 CC,P,B
      COMMON /UMFUL5/ CC,P,B
      CC=C
      IC=25
      IF (C.GE.0.0D 0) THEN
      SL=MAX(B*(B/(C+B))**P,B-C)
      SU=B
      ELSE
      SL=MAX(B-C*(P-1)/P,-C)
      SU=B-C
      ENDIF
      CALL UNNEQ1(SL,SU,S,F,FUN5,0.0D 0,TOL,IC,IE)
      RETURN
      END
      FUNCTION FUN5(S)
      REAL*8 FUN5,S
      REAL*8 C,P,B
      COMMON /UMFUL5/ C,P,B
      FUN5=S*((S+C)/B)**(P-1.0D 0)/B-1.0D 0
      RETURN
      END
