* SUBROUTINE UO1FJ3                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  GRAPHICAL VISUALIZATION OF THE FINAL RESULTS.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  NC  NUMBER OF CONSTRAINTS.
*  II  NE  NUMBER OF DIFFERENTIAL EQUATIONS.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  XL(NF)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RI  XU(NF)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RO  AF(NA)  VECTOR CONTAINING EITHER VALUES OF APPROXIMATED
*         FUNCTIONS OR COMPUTED SOLUTIONS OF DIFFERENTIAL EQUATIONS.
*  RI  AM(NA)  VECTOR CONTAINING REQUIRED VALUES OF APPROXIMATED
*         FUNCTIONS.
*  RI  CF(NC)  VECTOR CONTAINING VALUES OF THE CONSTRAINT FUNCTIONS.
*  RI  CL(NC)  VECTOR CONTAINING LOWER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CU(NC)  VECTOR CONTAINING UPPER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  AT(NA)  VECTOR CONTAINING MESH POINTS.
*  NGR  NUMBER OF NODES FOR THE COLOR MAP.
*
* COMMON DATA :
*  II  KBF  SPECIFICATION OF SIMPLE BOUNDS.
*  II  KBA  SPECIFICATION OF DEVIATIONS.
*  II  KBC  SPECIFICATION OF GENERAL CONSTRAINTS.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
      SUBROUTINE UO1FJ3(NF,NA,NAL,MAL,NC,NCL,MCL,NE,X,XL,XU,IX,AF,AM,
     & CF,CL,CU,IC,AT,EPS0,EPS1,EPS2,EPS3,EPS4,EPS5,EPS6,EPS7,EPS8,
     & EPS9,ETA0,ETA1,ETA2,ETA3,ETA4,ETA5,ETA6,ETA7,ETA8,ETA9,ALF1,
     & ALF2,ALF3,BET1,BET2,BET3,GAM1,GAM2,GAM3,DEL1,DEL2,DEL3,F,FMIN,
     & FMAX,DMAX,GMAX,XMAX,XDEL,RPF1,RPF2,RPF3,RPF4,RPF5,
     & MET,MET1,MET2,MET3,MET4,MET5,MOT,MOT1,MOT2,MOT3,MOT4,MOT5,
     & MES,MES1,MES2,MES3,MES4,MES5,MOS,MOS1,MOS2,MOS3,MOS4,MOS5,
     & MEP,MEP1,MEP2,MEP3,MEP4,MEP5,MOP,MOP1,MOP2,MOP3,MOP4,MOP5,
     & MED,MED1,MED2,MED3,MED4,MED5,MEX,MEX1,MEX2,MEX3,MEX4,MEX5,
     & MFP,MFP1,MFP2,MLC,MLC1,MLC2,MLP,MLP1,MLP2,MQP,MQP1,MQP2,
     & KSF,KCF,KSA,KCA,KSC,KCC,KTERS,INITD,INITS,INITH,IREM,IADD,
     & MRED,IRES1,IRES2,XPA,FPA,JOB)
      INTEGER NS,ISB,ISP(20),ISD(20),KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI(7)
      COMMON /UMOPTI/ NS,ISB,ISP,ISD,KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI
      REAL*8 TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR(12)
      COMMON /UMOPTR/ TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR
      REAL*8 ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS(2)
      COMMON /UMCONS/ ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS
      CHARACTER*4 TSS(20)
      CHARACTER*8 TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,TUXX,
     & TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT(3)
      CHARACTER*80 TER
      COMMON /UMOPTT/ TSS,TER,TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,
     & TUXX,TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT
      CHARACTER*6 NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN
      CHARACTER*14 NAME
      COMMON /UMOPTN/ NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN,NAME
      INTEGER IGR,JGR,KGR,NGR,NPH,IMIN,JMIN,KMIN,ICOLOR,IRET,
     & IMAP,IHIL,ICON,IPA,NPA,IGCOM(4),LLC(28)
      COMMON /UMGRFI/ IGR,JGR,KGR,NGR,NPH,IMIN,JMIN,KMIN,ICOLOR,IRET,
     & IMAP,IHIL,ICON,IPA,NPA,IGCOM,LLC
      REAL*8 XLIGR,XUIGR,XLJGR,XUJGR,VALMIN,VALMAX,XIGR,XJGR,RGCOM(2)
      COMMON /UMGRFR/ XLIGR,XUIGR,XLJGR,XUJGR,VALMIN,VALMAX,XIGR,XJGR,
     & RGCOM
      INTEGER NF,NA,NAL,MAL,NC,NCL,MCL,NE,IX(NF),IC(NC),
     & MET,MET1,MET2,MET3,MET4,MET5,MOT,MOT1,MOT2,MOT3,MOT4,MOT5,
     & MES,MES1,MES2,MES3,MES4,MES5,MOS,MOS1,MOS2,MOS3,MOS4,MOS5,
     & MEP,MEP1,MEP2,MEP3,MEP4,MEP5,MOP,MOP1,MOP2,MOP3,MOP4,MOP5,
     & MED,MED1,MED2,MED3,MED4,MED5,MEX,MEX1,MEX2,MEX3,MEX4,MEX5,
     & MFP,MFP1,MFP2,MLC,MLC1,MLC2,MLP,MLP1,MLP2,MQP,MQP1,MQP2,
     & KSF,KCF,KSA,KCA,KSC,KCC,KTERS,INITD,INITS,INITH,IREM,IADD,
     & MRED,IRES1,IRES2,JOB
      REAL*8 X(NF),XL(NF),XU(NF),AF(*),AM(NA),CF(NC),CL(NC),CU(NC),
     & AT(NA),EPS0,EPS1,EPS2,EPS3,EPS4,EPS5,EPS6,EPS7,EPS8,EPS9,ETA0,
     & ETA1,ETA2,ETA3,ETA4,ETA5,ETA6,ETA7,ETA8,ETA9,ALF1,ALF2,ALF3,
     & BET1,BET2,BET3,GAM1,GAM2,GAM3,DEL1,DEL2,DEL3,F,FMIN,FMAX,DMAX,
     & GMAX,XMAX,XDEL,RPF1,RPF2,RPF3,RPF4,RPF5,FPA(NPA)
      REAL*4 XPA(NPA,*)
      INTEGER NED,IG,JG,KG,NPAC,I
      IF (NS.EQ.0) NS=1
      IF (TSS(NS).NE.'UOXX') CALL UYPRO1('UOXX',-1)
      GO TO (1,2,3) ISP(NS)
    1 CONTINUE
      OPEN(11,FILE='P.GRF',STATUS='UNKNOWN')
      OPEN(12,FILE='P.SUR',STATUS='UNKNOWN')
      OPEN(13,FILE='P.PAR',STATUS='UNKNOWN')
      OPEN(14,FILE='P.DIF',STATUS='UNKNOWN')
      OPEN(15,FILE='P.PTH',STATUS='UNKNOWN')
C
C     variables
C
      WRITE(11,'(2I5)') NF,KBF
      IF (NF.GT.0) THEN
      WRITE(11,'(4D20.12)')(X(I),I=1,NF)
      IF (KBF.GT.0) THEN
      WRITE(11,'(16I5)') (IX(I),I=1,NF)
      WRITE(11,'(4D20.12)')(XL(I),I=1,NF)
      WRITE(11,'(4D20.12)')(XU(I),I=1,NF)
      ENDIF
      ENDIF
C
C     approximation
C
      IF (NE.GT.0) THEN
      WRITE(11,'(2I5)') 0,0
      ELSE
      WRITE(11,'(2I5)') NA,KBA
      IF (NA.GT.0) THEN
      WRITE(11,'(4D20.12)')(AF(I),I=1,NA)
      IF (KBA.GT.0) THEN
      WRITE(11,'(4D20.12)')(AM(I),I=1,NA)
      ENDIF
      ENDIF
      ENDIF
C
C     constraints
C
      WRITE(11,'(2I5)') NC,KBC
      IF (NC.GT.0) THEN
      WRITE(11,'(4D20.12)')(CF(I),I=1,NC)
      IF (KBC.GT.0) THEN
      WRITE(11,'(16I5)') (IC(I),I=1,NC)
      WRITE(11,'(4D20.12)')(CL(I),I=1,NC)
      WRITE(11,'(4D20.12)')(CU(I),I=1,NC)
      ENDIF
      ENDIF
C
C     function
C
      WRITE(13,'(16I5)') NIT,NFV,NFG,NFH,NAV,NAG,NAH,NCV,NCG,NCH,NDECF,
     & NCGR,NRES,NREM,NADD,NEXT
      WRITE(13,'(4D20.12)') F,DMAX,GMAX
      IF (NGR.LE.0) GO TO 2
      CALL UYSET0(1,2)
      RETURN
    2 CONTINUE
C
C     data
C
      WRITE(13,'(16I5)') NF,NA,NAL,MAL,NC,NCL,MCL,KDF,KBF,KSF,KCF,ISNF,
     & NORMF,KDA,KBA,KSA,KCA,ISNA,NORMA,KDC,KBC,KSC,KCC,ISNC,NORMC
C
C     options
C
      WRITE(13,'(16I5)') MET,MET1,MET2,MET3,MET4,MET5,MOT,MOT1,MOT2,
     & MOT3,MOT4,MOT5,MES,MES1,MES2,MES3,MES4,MES5,MOS,MOS1,MOS2,MOS3,
     & MOS4,MOS5,MEP,MEP1,MEP2,MEP3,MEP4,MEP5,MOP,MOP1,MOP2,MOP3,MOP4,
     & MOP5,MED,MED1,MED2,MED3,MED4,MED5,MEX,MEX1,MEX2,MEX3,MEX4,MEX5,
     & MFP,MFP1,MFP2,MLC,MLC1,MLC2,MLP,MLP1,MLP2,MQP,MQP1,MQP2,KTERS,
     & INITD,INITS,INITH,IREM,IADD, MRED,IRES1,IRES2,MIC,MIT,MFV,MFG,
     & MCGR,MSTP
      WRITE(13,'(4D20.12)') XDEL,XMAX,FMIN,FMAX,RPF1,RPF2,RPF3,RPF4,
     & RPF5,EPS0,EPS1,EPS2,EPS3,EPS4,EPS5,EPS6,EPS7,EPS8,EPS9,ETA0,
     & ETA1,ETA2,ETA3,ETA4,ETA5,ETA6,ETA7,ETA8,ETA9,ALF1,ALF2,ALF3,
     & BET1,BET2,BET3,GAM1,GAM2,GAM3,DEL1,DEL2,DEL3,TOLX,TOLF,TOLG,
     & TOLB,TOLC,TOLA,TOLR
C
C     differential equations
C
      NED=MIN(NE,3)
      WRITE(14,'(2I5)') NED,NA
      IF (NED.GT.0.AND.NA.GT.0) THEN
      WRITE(14,'(4D20.12)') (AT(I),I=1,NA)
      IF (NE.LE.NED) THEN
      IG=1
      JG=2
      KG=3
      ELSE
      CALL UOJZD2(NE,NED,IG,JG,KG)
      ENDIF
      WRITE(14,'(2I5)') 1,IG
      WRITE(14,'(4D20.12)') (AF((I-1)*NE+IG),I=1,NA)
      IF (NED.GE.2) THEN
      WRITE(14,'(2I5)') 2,JG
      WRITE(14,'(4D20.12)') (AF((I-1)*NE+JG),I=1,NA)
      ENDIF
      IF (NED.GE.3) THEN
      WRITE(14,'(2I5)') 3,KG
      WRITE(14,'(4D20.12)') (AF((I-1)*NE+KG),I=1,NA)
      ENDIF
      ENDIF
C
C     path
C
      NPAC=MIN(NPA,NIT)
      IF (JOB.EQ.0.OR.NF.EQ.0) THEN
      WRITE(15,'(2I5)') 0,0
      GO TO 3
      ELSE IF (NF.EQ.1) THEN
      WRITE(15,'(2I5)') 1,NPAC
      IF (NPAC.GT.0) THEN
      WRITE(15,'(4D20.12)')(FPA(I),I=1,NPAC)
      WRITE(15,'(2I5)') IGR,NPAC
      WRITE(15,'(4D20.12)')(XPA(I,1),I=1,NPAC)
      ENDIF
      ELSE IF (JOB.EQ.1) THEN
      WRITE(15,'(2I5)') 2,NPAC
      IF (NPAC.GT.0) THEN
      WRITE(15,'(4D20.12)')(FPA(I),I=1,NPAC)
      WRITE(15,'(2I5)') IGR,NPAC
      WRITE(15,'(4D20.12)')(XPA(I,1),I=1,NPAC)
      WRITE(15,'(2I5)') JGR,NPAC
      WRITE(15,'(4D20.12)')(XPA(I,2),I=1,NPAC)
      ENDIF
      ELSE IF (JOB.EQ.2) THEN
      WRITE(15,'(2I5)') 3,NPAC
      IF (NPAC.GT.0) THEN
      WRITE(15,'(4D20.12)')(FPA(I),I=1,NPAC)
      WRITE(15,'(2I5)') IGR,NPAC
      WRITE(15,'(4D20.12)')(XPA(I,1),I=1,NPAC)
      WRITE(15,'(2I5)') JGR,NPAC
      WRITE(15,'(4D20.12)')(XPA(I,2),I=1,NPAC)
      WRITE(15,'(2I5)') KGR,NPAC
      WRITE(15,'(4D20.12)')(XPA(I,3),I=1,NPAC)
      ENDIF
      ENDIF
      IF (NGR.LE.0) GO TO 3
      CALL UYSET0(2,3)
      RETURN
    3 CONTINUE
      CLOSE(11)
      CLOSE(12)
      CLOSE(13)
      CLOSE(14)
      CLOSE(15)
      CALL UYEPI1(-1)
      IF (NS.EQ.1) NS=0
      RETURN
      END
