* SUBROUTINE UO1FN2                ALL SYSTEMS                94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF EXIT FROM FUNCTION MINIMIZATION.
*
* PARAMETERS:
*  II  NF DECLARED NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  NC  NUMBER OF CONSTRAINTS
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  GF(NF)  GRADIENT OF THE MODEL FUNCTION.
*  RI  AF(NA)  VALUES OF THE APPROXIMATED FUNCTIONS.
*  RI  CF(NC)  VALUES OF THE CONSTRAINT FUNCTIONS.
*
* COMMON DATA :
*  II  NF DECLARED NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  NC  NUMBER OF CONSTRAINTS
*  IU  NAV  NUMBER OF VALUES OF THE APPROXIMATED FUNCTIONS.
*  IU  NAG  NUMBER OF GRADIENTS OF THE APPROXIMATED FUNCTIONS.
*  IU  NAH  NUMBER OF HESSIAN MATRICES OF THE APPROXIMATED FUNCTIONS.
*  II  KD  DEGREE OF REQUIRED DERIVATIVES.
*  II  KDF  DEGREE OF ANALYTICALLY COMPUTED DERIVATIVES.
*  II  ISNA  LEVEL OF PRINT. IF ISNA>0 VALUES OF THE APPROXIMATED
*         FUNCTIONS ARE PRINTED.
*  II  ISNC  LEVEL OF PRINT. IF ISNC>0 VALUES OF CONSTRAINTS ARE
*         PRINTED.
*  II  IOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INITIAL VALUES
*         AND FINAL RESULTS. IOUT=0-NO PRINT. IOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF MATRIX CORRECTION.
*         KOUT=5-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=6-ADDITIONAL PRINT OF DEBUGGING.
*  II  MOUT  LEVEL OF PRINT ON THE TERMINAL DEVICE.
*         MOUT=0 - NO PRINT.
*         MOUT=1 - PRINT OF FINAL RESULTS.
*         MOUT=2 - ADDITIONAL PRINT OF ITERATIONS.
*
* OUTPUT VARIABLES :
* FF,X(NF),GF(NF),AF(NA*NAP),CF(NC),ITERM,TXFU,F,GMAX,DMAX,NIT,
* NFV,NFG,NFH,NAV,NAG,NAH,NCV,NCG,NCH,NRES,NREM,NADD,NEXT,MET,
* MET1,MET2,MET3,MOT,MOT1,MOT2,MOT3,MES,MES1,MES2,MES3,MOS,MOS1,
* MOS2,MOS3,INITD,INITS,INITH,IRES1,IRES2,EPS0,EPS1,EPS2,EPS3,
* EPS4,EPS5,BET1,BET2,GAM1,GAM2,ETA1,ETA2,XMAX
*
      SUBROUTINE UO1FN2(NF,NA,NC,X,GF,AF,CF,FF,F,FO,DMAX,GMAX,XMAX,
     & CMAX,EPS0,EPS1,EPS2,EPS3,EPS4,EPS5,BET1,BET2,GAM1,GAM2,ETA1,
     & ETA2,MET,MET1,MET2,MET3,MOT,MOT1,MOT2,MOT3,MES,MES1,MES2,MES3,
     & MOS,MOS1,MOS2,MOS3,INITD,INITS,INITH,IRES1,KTERS,IPRN)
      INTEGER NS,ISB,ISP(20),ISD(20),KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI(7)
      COMMON /UMOPTI/ NS,ISB,ISP,ISD,KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI
      REAL*8 TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR(12)
      COMMON /UMOPTR/ TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR
      REAL*8 ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS(2)
      COMMON /UMCONS/ ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS
      CHARACTER*4 TSS(20)
      CHARACTER*8 TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,TUXX,
     & TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT(3)
      CHARACTER*80 TER
      COMMON /UMOPTT/ TSS,TER,TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,
     & TUXX,TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT
      CHARACTER*6 NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN
      CHARACTER*14 NAME
      COMMON /UMOPTN/ NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN,NAME
      INTEGER NDEM
      COMMON /UMCOMD/ NDEM
      INTEGER NF,NA,NC,MET,MET1,MET2,MET3,MOT,MOT1,MOT2,MOT3,MES,MES1,
     & MES2,MES3,MOS,MOS1,MOS2,MOS3,INITD,INITS,INITH,IRES1,KTERS,IPRN
      REAL*8 X(NF),GF(NF),AF(*),CF(*),FF,F,FO,DMAX,GMAX,XMAX,CMAX,
     & EPS0,EPS1,EPS2,EPS3,EPS4,EPS5,BET1,BET2,GAM1,GAM2,ETA1,ETA2
      INTEGER I
      LOGICAL LL
      NDEM=NF
      LL=KOUT.EQ.0.AND.LOUT.GT.0
      IF(KOUT.EQ.0.AND.LOUT.LT.0) IPRN=0
      IF(ABS(MOUT).GT.0) THEN
      IF(KD.LE.0) THEN
      IF(ABS(LOUT).LE.1) THEN
      WRITE(ITR,16) NEXT,NIC,NIT,NFV,F,CMAX
      IF(LL) WRITE(IWR,16) NEXT,NIC,NIT,NFV,F,CMAX
      ELSE
      WRITE(ITR,26) NEXT,NIT,NFV,TXFU,F,CMAX
      IF(LL) WRITE(IWR,26) NEXT,NIT,NFV,TXFU,F,CMAX
      ENDIF
      ELSE
      IF(ABS(LOUT).LE.1) THEN
      WRITE(ITR,17) NEXT,NIC,NIT,NFV,NFG,F,CMAX,GMAX
      IF(LL) WRITE(IWR,17) NEXT,NIC,NIT,NFV,NFG,F,CMAX,GMAX
      ELSE
      WRITE(ITR,27) NEXT,NIT,NFV,NFG,TXFU,F,CMAX,GMAX
      IF(LL) WRITE(IWR,27) NEXT,NIT,NFV,NFG,TXFU,F,CMAX,GMAX
      ENDIF
      ENDIF
      IF (ITERM.GE.0.AND.ITERM.LE.10.OR.ITERM.GE.20.OR.ITERM.EQ.-6.AND.
     & GMAX.LE.1.0D 3*TOLG) THEN
      ELSE
      WRITE(ITR,'(A80)') TER
      IF(LL) WRITE(IWR,'(A80)') TER
      IF (NOUT1.GT.0) THEN
      WRITE(ITR,'('' ACTUAL VALUE:'',I8,
     & ''   -   DECLARED VALUE:'',I8)') NOUT1,NOUT2
      IF(LL) WRITE(IWR,'('' ACTUAL VALUE:'',I8,
     & ''   -   DECLARED VALUE:'',I8)') NOUT1,NOUT2
      ENDIF
      ENDIF
      ENDIF
      IF(NOUT.NE.0) THEN
      IF(KDF.GE.0) THEN
      WRITE ( ITR, 18)  FF
      IF(LL) WRITE ( IWR, 18)  FF
      ELSEIF(KDA.GE.0) THEN
      FO=F
      IF (IEXT.GT.0) FO=-FO
      WRITE ( ITR, 28)  FO
      IF(LL) WRITE ( IWR, 28)  FO
      ENDIF
      WRITE ( ITR, 19)  (X(I), I=1,MIN(NF,100))
      IF(LL) WRITE ( IWR, 19)  (X(I), I=1,MIN(NF,100))
      IF(ABS(NOUT).GT.1) THEN
      IF (KDA.GE.0.AND.ISNA.GE.1) THEN
      WRITE ( ITR, 20)  (AF(I), I=1,MIN(NA,100))
      IF(LL) WRITE ( IWR, 20)  (AF(I), I=1,MIN(NA,100))
      ENDIF
      IF (KDC.GE.0.AND.ISNC.GE.1) THEN
      WRITE ( ITR, 21)  (CF(I), I=1,MIN(NC,100))
      IF(LL) WRITE ( IWR, 21)  (CF(I), I=1,MIN(NC,100))
      ENDIF
      ENDIF
      ENDIF
      IF(IPRN.EQ.0.OR.IOUT.EQ.0.OR.KOUT.EQ.0) GO TO 10
      WRITE ( IWR, 1)
    1 FORMAT ( /1X,'FINAL RESULTS'/1X,13('-'))
      IF(NOUT.NE.0) THEN
      IF (KDF.GE.0) THEN
      WRITE ( IWR, 2)  FF
      ELSEIF(KDA.GE.0) THEN
      FO=F
      IF (IEXT.GT.0) FO=-FO
      WRITE ( IWR, 28)  FO
      ENDIF
    2 FORMAT ( /1X, 'FF=', D 18.10)
      WRITE ( IWR, 3)  (X(I), I=1,MIN(NF,100))
    3 FORMAT ( ' ', 'X =', 4D 18.10:/( 4X, 4D 18.10))
      IF(ABS(NOUT).GT.1) THEN
      IF (KDF .GE.1) WRITE ( IWR, 4)  (GF(I), I=1,MIN(NF,100))
    4 FORMAT ( ' ', 'GF=', 4D 18.10:/( 4X, 4D 18.10))
      IF (ISNA.GE.1) WRITE ( IWR, 5)  (AF(I), I=1,MIN(NA,100))
    5 FORMAT ( ' ', 'AF=', 4D 18.10:/( 4X, 4D 18.10))
      IF (ISNC.GE.1) WRITE ( IWR, 6)  (CF(I), I=1,MIN(NC,100))
    6 FORMAT ( ' ', 'CF=', 4D 18.10:/( 4X, 4D 18.10))
      ENDIF
      ENDIF
      IF(KD.LE.0) THEN
      WRITE ( IWR, 7)  ITERM, TXFU, F, CMAX, DMAX
    7 FORMAT ( /1X, 'TERMINATION:',I4,2X,A8,2X,
     *         'F=',D 9.3,1X,'C=',D 9.3,1X,'D=',D 9.3)
      ELSE
      WRITE ( IWR, 8)  ITERM, TXFU, F, CMAX, GMAX, DMAX
    8 FORMAT ( /1X, 'TERMINATION:',I4,2X,A8,2X,
     *         'F=',D 9.3,1X,'C=',D 9.3,1X,'G=',D 9.3,1X,
     *         'D=',D 9.3)
      ENDIF
      IF(ITERM.LT.0) WRITE(IWR,'(A80)') TER
      IF(NA.GE.1) THEN
        NAV=NAV/NA
        NAG=NAG/NA
        NAH=NAH/NA
      ENDIF
      WRITE ( IWR, 9) NIT, NIC,
     *                NFV, NAV, NCV, NRES,
     *                NFG, NAG, NCG, NREM,
     *                NFH, NAH, NCH, NADD
    9 FORMAT (/1X,'STATISTICS'/1X,10('-')/
     *     ' ','NIT=',I5,3X,'NIC=',I5/
     *     ' ','NFV=',I5,3X,'NAV=',I5,3X,'NCV=',I5,3X,'NRES=',I5/
     *     ' ','NFG=',I5,3X,'NAG=',I5,3X,'NCG=',I5,3X,'NREM=',I5/
     *     ' ','NFH=',I5,3X,'NAH=',I5,3X,'NCH=',I5,3X,'NADD=',I5)
      RETURN
   10 IF (KOUT .NE. 0 .OR. LOUT. GE. 0) RETURN
      WRITE (IWR,11) NEXT
   11 FORMAT (/1X,'PROBLEM NO',I5/' ',15('-'))
      WRITE (IWR,12) MET,MET1,MET2,MET3,MOT,MOT1,MOT2,MOT3,
     *               MES,MES1,MES2,MES3,MOS,MOS1,MOS2,MOS3,
     *               INITD,INITS,INITH,KTERS,IRES1
   12 FORMAT (' ','MET  MET1 MET2 MET3 MOT  MOT1 MOT2 MOT3 ',
     *            'MES  MES1 MES2 MES3 MOS  MOS1 MOS2 MOS3 ',
     *            'INITD INITS INITH KTERS IRES1'/
     *            ' ',16(I3,2X),5(I4,2X)/' ',117('-'))
      WRITE (IWR,13) EPS0,EPS1,EPS2,EPS3,EPS4,EPS5,
     *               BET1,BET2,GAM1,GAM2,ETA1,ETA2,XMAX
   13 FORMAT (' ','     EPS0     EPS1     EPS2     EPS3     EPS4',
     *            '     EPS5     BET1     BET2     GAM1     GAM2',
     *            '     ETA1     ETA2     XMAX'/' ',13D 9.2/
     *            ' ',117('-'))
      IF(KD.LE.0) THEN
      WRITE (IWR,14) TXFU,F,CMAX,NIC,NIT,NFV,NFG,NRES
      ELSE
      WRITE (IWR,15) TXFU,F,CMAX,GMAX,NIC,NIT,NFV,NFG,NRES
      ENDIF
   14 FORMAT (' ','TERMINATION : ',A8,2X,'F =',D 10.3,2X,'C =',
     *            D 10.3,2X,'NIC=',I3,2X,'NIT=',I5,2X,'NFV=',I5,2X,
     *            'NFG=',I5,2X,'NRES=',I4)
   15 FORMAT (' ','TERMINATION : ',A8,2X,'F =',D 10.3,2X,'C =',
     *            D 10.3,2X,'G =',D 10.3,2X,'NIC=',I3,2X,'NIT=',I5,2X,
     *            'NFV=',I5,2X,'NFG=',I5,2X,'NRES=',I4)
   16 FORMAT(' ',I3,1X,'NIC=',I3,1X,'NIT=',I4,1X,'NFV=',I5,1X,'F=',
     *            D9.3,1X,'C=',D9.3)
   26 FORMAT(' ',I3,1X,'NIT=',I4,1X,'NFV=',I4,1X,A8,1X,'F=',G13.6,
     *            1X,'C=',D9.3)
   17 FORMAT(' ',I3,1X,'NIC=',I3,1X,'NIT=',I4,1X,'NFV=',I5,1X,'NFG=',
     *            I5,1X,'F=',D9.3,1X,'C=',D9.3,1X,'G=',D9.3)
   27 FORMAT(' ',I3,1X,'NIT=',I4,1X,'NFV=',I4,1X,'NFG=',
     *            I5,1X,A8,1X,'F=',G13.6,1X,'C=',D7.1,1X,'G=',D7.1)
   18 FORMAT ( ' ', 'FF =',D 18.10)
   28 FORMAT ( ' ', 'F  =',D 18.10)
   19 FORMAT ( ' ', 'X  =',4D 18.10:/(5X,4D 18.10))
   20 FORMAT ( ' ', 'AF =',4D 18.10:/(5X,4D 18.10))
   21 FORMAT ( ' ', 'CF =',4D 18.10:/(5X,4D 18.10))
      RETURN
      END
