* SUBROUTINE UOKLP3                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
*  PRINT OF ITERATION OF THE SPARSE LINEAR PROGRAMMING.
*
* PARAMETERS:
*  II  N  TRANSFORMED NUMBER OF VARIABLES.
*  II  M  TRANSFORMED NUMBER OF CONSTRAINTS.
*  II  MROWS DECLARED NUMBER OF ROWS.
*  II  MCOLS DECLARED NUMBER OF COLUMNS.
*  II  NEL NUMBER OF ELEMENTS IN ARRAYS LI/LJ/CM.
*  II  IJNEW PRINTED COLUMN ENTERING THE BASIS.
*  II  IJOLD PRINTED COLUMN LEAVING THE BASIS.
*  II  PHASE LINEAR PROGRAMMING PHASE.
*  II  NUMITR NUMBER OF THE PENDING ITERATION.
*  II  LENR(MCOLS) LENGTHS OF THE ROWS OF THE FACTOR U.
*  II  TYPE(MCOLS) TYPES OF THE VARIABLES:
*                                    =1 FOR NONBASIC LOWER BOUNDED
*                                    =2 FOR NONBASIC UPPER BOUNDED
*                                    =3 FOR NONBASIC LOWER AND UPPER
*                     BOUNDED VARIABLE SET TO ITS LOWER BOUND
*                                    =4 FOR NONBASIC LOWER AND UPPER
*                     BOUNDED VARIABLE SET TO ITS UPPER BOUND
*                                    =5 FOR NONBASIC FIXED VARIABLE
*                                    =6 FOR NONBASIC FREE VARIABLE
*                                    =-1 FOR BASIC LOWER BOUNDED
*                                    =-2 FOR BASIC UPPER BOUNDED
*                                    =-3 FOR BASIC LOWER AND UPPER
*                     BOUNDED VARIABLE
*                                    =-6 FOR BASIC FREE VARIABLE.
*  II  BCOL(MCOLS) M FIRST ELEMENTS CONTAIN COLUMN INDICES OF BASIC
*              COLUMNS.
*  RI  X(MCOLS) VECTOR OF SOLUTION.
*  RI  C(MCOLS) COST VECTOR - GRADIENT OF THE LINEAR FUNCTION.
*  RO  FF  ORIGINAL FUNCTIONAL VALUE.
*  II  KINP NUMBER OF ARTIFICIALS.
*
* COMMON DATA :
*  II  NREF NUMBER OF REFACTORIZATIONS.
*  II  JOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INFORMATION
*         DURING THE OPTIMIZATION PROCESS. JOUT=0-NO PRINT.
*         JOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF MATRIX CORRECTION.
*         KOUT=5-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=6-ADDITIONAL PRINT OF DEBUGGING.
*  II  LOUT  PRINT OF ITERATIONS. LOUT=0-STANDARD PAPER SAVING PRINT.
*         LOUT=1-ADDITIONAL PRINT OF FINAL RESULTS OF SUBROUTINES.
*         LOUT=2-ADDITIONAL PRINT OF VARIABLES. LOUT=3-ADDITIONAL
*         PRINT OF THE GRADIENT. LOUT=4-ADDITIONAL PRINT OF THE HESSIAN
*         MATRIX.
*  II  MOUT  LEVEL OF PRINT ON THE TERMINAL DEVICE.
*         ABS(MOUT)=0 - NO PRINT.
*         ABS(MOUT)=1 - PRINT OF FINAL RESULTS.
*         ABS(MOUT)=2 - ADDITIONAL PRINT OF ITERATIONS.
*
      SUBROUTINE UOKLP3(N,M,MROWS,MCOLS,NEL,IJNEW,IJOLD,PHASE,NUMITR,
     & LENR,TYPE,BCOL,X,C,FF,KINP)
      INTEGER NS,ISB,ISP(20),ISD(20),KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI(7)
      COMMON /UMOPTI/ NS,ISB,ISP,ISD,KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI
      REAL*8 TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR(12)
      COMMON /UMOPTR/ TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR
      REAL*8 ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS(2)
      COMMON /UMCONS/ ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS
      CHARACTER*4 TSS(20)
      CHARACTER*8 TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,TUXX,
     & TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT(3)
      CHARACTER*80 TER
      COMMON /UMOPTT/ TSS,TER,TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,
     & TUXX,TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT
      CHARACTER*6 NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN
      CHARACTER*14 NAME
      COMMON /UMOPTN/ NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN,NAME
      INTEGER I,IU
      INTEGER N,M,MROWS,MCOLS,NEL,IJNEW,IJOLD,PHASE,NUMITR,LENR(MROWS),
     & TYPE(MCOLS),BCOL(MCOLS),KINP
      REAL*8 X(MCOLS),C(MCOLS),FF
      REAL*8 DENSU,FHERE
      LOGICAL LL
      LL=KOUT.EQ.0.AND.LOUT.GT.0
C
C COMPUTE FHERE
C
      IF(PHASE.NE.1) THEN
        FHERE=FF
      DO 50 I=1,N
        FHERE=FHERE+C(I)*X(I)
   50 CONTINUE
      ELSE
        FHERE=0.0D 0
      DO 51 I=1,N
        FHERE=FHERE+ABS(C(I)*X(I))
   51 CONTINUE
      ENDIF
C
C COMPUTE IU,DENSITIES
C
      IU=0
      DO 100 I=1,M
        IU=IU+LENR(I)
  100 CONTINUE
      IF(ABS(MOUT).GT.3) THEN
      WRITE(ITR,8)NUMITR,IJNEW,IJOLD,KINP,IU,FHERE
      IF(LL) WRITE(IWR,8)NUMITR,IJNEW,IJOLD,KINP,IU,FHERE
      ENDIF
    8 FORMAT(' ','NUMITR=',I5,1X,'INEW=',I5,1X,'IOLD=',I5,1X,
     *       'KINP=',I4,1X,'IU=',I5,2X,'F=',D 9.3)
      IF(JOUT.EQ.0) RETURN
      IF(ABS(KOUT).LE.3) RETURN
      IF(M.GT.0) THEN
        DENSU=2*IU-M
        DENSU=DENSU/(M*M)
      ELSE
        DENSU=0
      ENDIF
      WRITE(IWR,2) IJNEW,IJOLD,KINP,PHASE,NUMITR,FHERE
    2 FORMAT(' ','INEW=',I4,2X,'BCOL(IOLD)=',I4,2X,'KINP=',
     *       I4,2X,'PHASE=',I3,2X,'NUMITR=',I5,2X,'F=',D 9.3)
      IF(ABS(LOUT).GE.2) WRITE(IWR,7) DENSU,IU,NEL,NREF
    7 FORMAT (' ','DENSITY OF U =',D 9.3,2X,'ELEMENTS OF U =',
     *       I4,2X,'NEL =',I4,2X,'NREF =',I4)
      IF(ABS(LOUT).GE.3) WRITE(IWR,4)(BCOL(I),I=1,MIN(M,50))
    4 FORMAT(' ','BCOL=',10I7:/(6X,10I7))
      IF(ABS(LOUT).GE.3) WRITE(IWR,5)(X(I),I=1,MIN(N,25))
    5 FORMAT(' ','X   =',5D 14.5:/(6X,5D 14.5))
      IF(ABS(LOUT).GT.3.AND.KBF.GT.0)WRITE(IWR,6)(TYPE(I),I=1,MIN(N,50))
    6 FORMAT(' ','IX  =',10I7:/(6X,10I7))
      IF(ABS(LOUT).GT.3) WRITE(IWR,3)(C(I),I=1,MIN(N,50))
    3 FORMAT(' ','GF  =',5D 14.5:/(6X,5D 14.5))
      RETURN
      END
