* SUBROUTINE UOMPIC                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  MATLAB GRAPHICAL VISUALIZATION OF THE FINAL RESULTS.
*
* PARAMETERS :
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  NE  NUMBER OF DIFFERENTIAL EQUATIONS.
*  RI  AY(*)  VECTOR CONTAINING COMPUTED SOLUTIONS OF DIFFERENTIAL EQUATIONS.
*  II  IG  INDEX OF THE 1-ST VISUALIZED DIFFERENTIAL EQUATION.
*  II  JG  INDEX OF THE 2-ND VISUALIZED DIFFERENTIAL EQUATION.
*  II  KG  INDEX OF THE 3-RD VISUALIZED DIFFERENTIAL EQUATION.
*  LI  VYPISF(3)  THE SAME DRAWN FUNCTION VALUES CAN BE PUT INTO P.m ONLY ONCE
*  II  CISLO  SERIAL NUMBER OF THE MATLAB SOURCE CODE
*  II  GFMT  GRAPHIC FORMAT
*
      SUBROUTINE UOMPIC(NA,NE,AY,IG,JG,KG,VYPISF,CISLO,GFMT)
      INTEGER NA,NE,IG,JG,KG,CISLO,GFMT
      REAL*8 AY(*),MINIMX,MAXIMX,MINIMY,MAXIMY,MINIMZ,MAXIMZ,TEMP,EPS
      CHARACTER*25 T1,T2,T3,T4,T5,T6
      LOGICAL VYPISF(3)
C
      CALL UOMOPN(14,GFMT)
      CALL UOMPIE(NA,NE,AY,IG,JG,KG,VYPISF,
     &            MINIMX,MAXIMX,MINIMY,MAXIMY,MINIMZ,MAXIMZ)
C
      EPS=1.0D-15
      WRITE(T1,'(I10)')IG
      T1=ADJUSTL(T1)
      WRITE(T2,'(I10)')JG
      T2=ADJUSTL(T2)
      WRITE(T3,'(I10)')KG
      T3=ADJUSTL(T3)
      WRITE(14,'(A)')'h = plot3(y1,y2,y3);'
      WRITE(14,'(A)')'set(h,{''LineWidth''},{2});'
      WRITE(14,'(A)')'set(h,{''LineStyle''},{''-''});'
      WRITE(14,'(A)')'set(h,{''Color''},{''b''});'
      WRITE(14,'(7A)')'tit=title(''Picture of YA(', TRIM(T1),
     &   '), YA(', TRIM(T2), '), YA(', TRIM(T3), ')'');'
      WRITE(14,'(3A)')'xl=xlabel(''YA(', TRIM(T1), ')'');'
      WRITE(14,'(3A)')'yl=ylabel(''YA(', TRIM(T2), ')'');'
      WRITE(14,'(3A)')'zl=zlabel(''YA(', TRIM(T3), ')'');'
      WRITE(14,'(A)')'set(gca,''FontSize'',20);'
      WRITE(14,'(A)')'set(tit,''FontSize'',25);'
      WRITE(14,'(A)')'set(xl,''FontSize'',20);'
      WRITE(14,'(A)')'set(yl,''FontSize'',20);'
      WRITE(14,'(A)')'set(zl,''FontSize'',20);'
      WRITE(14,'(A)')'grid on;'
      WRITE(14,'(A)')'box on;'
      TEMP=(MAXIMX-MINIMX)*1.0D-1
      IF ((MAXIMX-MINIMX).LE.MAX(ABS(MAXIMX+MINIMX),1.0D0)*EPS) TEMP=EPS
      WRITE(T1,'(D25.16)') MINIMX-TEMP
      T1=ADJUSTL(T1)
      WRITE(T2,'(D25.16)') MAXIMX+TEMP
      T2=ADJUSTL(T2)
      TEMP=(MAXIMY-MINIMY)*1.0D-1
      IF ((MAXIMY-MINIMY).LE.MAX(ABS(MAXIMY+MINIMY),1.0D0)*EPS) TEMP=EPS
      WRITE(T3,'(D25.16)') MINIMY-TEMP
      T3=ADJUSTL(T3)
      WRITE(T4,'(D25.16)') MAXIMY+TEMP
      T4=ADJUSTL(T4)
      TEMP=(MAXIMZ-MINIMZ)*1.0D-1
      IF ((MAXIMZ-MINIMZ).LE.MAX(ABS(MAXIMZ+MINIMZ),1.0D0)*EPS) TEMP=EPS
      WRITE(T5,'(D25.16)') MINIMZ-TEMP
      T5=ADJUSTL(T5)
      WRITE(T6,'(D25.16)') MAXIMZ+TEMP
      T6=ADJUSTL(T6)
      WRITE(14,'(13A)')'axis([', TRIM(T1), ' ', TRIM(T2), ' ',
     & TRIM(T3), ' ', TRIM(T4), ' ', TRIM(T5), ' ', TRIM(T6), ']);'
      CALL UOMGRX(14,'PMPIC',CISLO,GFMT)
      RETURN
      END
