* SUBROUTINE UOMSUR                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  MATLAB GRAPHICAL VISUALIZATION OF SURFACE.
*
* PARAMETERS :
*  II  NGR  THE NUMBER OF NODES CORRESPONDING TO EVERY SELECTED VARIABLE
*  II  IGR  THE INDEX OF THE FIRST SELECTED VARIABLE
*  II  JGR  THE INDEX OF THE SECOND SELECTED VARIABLE
*  RI  XLIGR  THE MINIMUM VALUE OF THE FIRST VARIABLE OF THE SELECTED REGION
*  RI  XUIGR  THE MAXIMUM VALUE OF THE FIRST VARIABLE OF THE SELECTED REGION
*  RI  XLJGR  THE MINIMUM VALUE OF THE SECOND VARIABLE OF THE SELECTED REGION
*  RI  XUIGR  THE MAXIMUM VALUE OF THE SECOND VARIABLE OF THE SELECTED REGION
*  RI  FL(NGR,NGR)  THE FIELD CONTAINING DRAWN FUNCTION VALUES
*  LU  VYPISF   THE SAME DRAWN FUNCTION VALUES CAN BE PUT INTO P.m ONLY ONCE
*  II  SCALE  LINEAR OR LOGARITHMIC SCALE OF THE PLOT
*  II  CISLO  THE NUMBER OF THE GRAPH
*  II  GFMT  GRAPHIC FORMAT
*
      SUBROUTINE UOMSUR(NGR,IGR,JGR,XLIGR,XUIGR,XLJGR,XUJGR,
     & FL,VYPISF,SCALE,CISLO,GFMT)
      INTEGER NGR,IGR,JGR,SCALE,CISLO,GFMT
      REAL*4 FL(NGR,NGR)
      REAL*8 XLIGR,XUIGR,XLJGR,XUJGR
      CHARACTER*25 RET
      LOGICAL VYPISF,ENLX,ENLY,CONSTF
C
      CALL UOMOPN(12,GFMT)
      CALL UOMIMS(NGR,0.0D0,0.0D0,XLIGR,XUIGR,XLJGR,XUJGR,
     & 0,0,FL,VYPISF,SCALE,'S',ENLX,ENLY,CONSTF)
C
      WRITE(12,'(A)') 'surfc(x,y,f);'
      WRITE(12,'(A)') 'mn=min(f(:));'
      WRITE(12,'(A)') 'mx=max(f(:));'
      IF (CONSTF.OR.ENLX.OR.ENLY) WRITE(12,'(A)') 'eps=1.0d-6;'
      IF (CONSTF) THEN
        WRITE(12,'(A)') 'set(gca, ''CLim'', [mn-eps, mx+eps]);'
      ELSE
        WRITE(12,'(A)') 'set(gca, ''CLim'', [mn, mx]);'
      ENDIF
      WRITE(12,'(A)') 'colorbar;'
      IF (ENLX) THEN
        WRITE(12,'(A)') 'xlim([xligr-eps xuigr+eps]);'
      ELSE
        WRITE(12,'(A)') 'xlim([xligr xuigr]);'
      ENDIF
      IF (ENLY) THEN
        WRITE(12,'(A)') 'ylim([xljgr-eps xujgr+eps]);'
      ELSE
        WRITE(12,'(A)') 'ylim([xljgr xujgr]);'
      ENDIF
      WRITE(12,'(A)') 'zlim(''auto'');'
      IF (CONSTF) THEN
        IF (SCALE.EQ.2) THEN
         WRITE(12,'(A)') 'tit=title(''Surface (constant, log scale)'');'
        ELSE
          WRITE(12,'(A)') 'tit=title(''Surface (constant)'');'
        ENDIF
      ELSE
        IF (SCALE.EQ.2) THEN
          WRITE(12,'(A)') 'tit=title(''Surface (log scale)'');'
        ELSE
          WRITE(12,'(A)') 'tit=title(''Surface'');'
        ENDIF
      ENDIF
      WRITE(RET,'(I15)') IGR
      RET=ADJUSTL(RET)
      WRITE(12,'(3A)') 'xl=xlabel(''X(', TRIM(RET), ')'');'
      WRITE(RET,'(I15)') JGR
      RET=ADJUSTL(RET)
      WRITE(12,'(3A)') 'yl=ylabel(''X(', TRIM(RET), ')'');'
      WRITE(12,'(A)') 'zl=zlabel(''F'');'
      WRITE(12,'(A)') 'set(gca,''FontSize'',15);'
      WRITE(12,'(A)') 'set(tit,''FontSize'',25);'
      WRITE(12,'(A)') 'set(xl,''FontSize'',15);'
      WRITE(12,'(A)') 'set(yl,''FontSize'',15);'
      WRITE(12,'(A)') 'set(zl,''FontSize'',15,''Rotation'',0);'
      WRITE(12,'(A)') 'pos = get(zl,''Position'');'
      WRITE(12,'(A)') 'set(zl,''Position'', pos + [-0.1, 0, 0]);'
      CALL UOMGRX(12,'PMSUR',CISLO,GFMT)
      RETURN
      END
