* SUBROUTINE UOSAPP                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  SCILAB GRAPHICAL VISUALIZATION OF APPROXIMATIONS.
*
* PARAMETERS :
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  RI  AF(NA)  VECTOR CONTAINING THE VALUES OF APPROXIMATED FUNCTIONS.
*  RI  AM(NA)  VECTOR CONTAINING REQUIRED VALUES OF APPROXIMATED FUNCTIONS.
*  II  CISLO  SERIAL NUMBER OF THE SCILAB SOURCE CODE.
*  II  STA  START INDEX OF THE VARIABLES IN THE GRAPH.
*  II  STO  STOP INDEX OF THE VARIABLES IN THE GRAPH.
*  II  GFMT  GRAPHIC FORMAT.
*
      SUBROUTINE UOSAPP(NA,AF,AM,CISLO,STA,STO,GFMT)
      INTEGER NA,CISLO,STA,STO,GFMT
      REAL*8 AF(NA),AM(NA),EPS,MINIM,MAXIM,TEMP
      CHARACTER*16 RETSTA,RETSTO
      CHARACTER*25 RETMIN,RETMAX
C
      CALL UOSOPN(11,GFMT)
      CALL UOMAPN(NA,AF,AM,CISLO,STA,STO,MINIM,MAXIM)
C
      EPS=1.0D-6
      IF (CISLO.EQ.1) THEN
        WRITE(11,'(A)') 'plot(ii,af);'
        WRITE(11,'(A)') 'p=get("hdl");'
        WRITE(11,'(A)') 'p.children(1).line_mode="off";'
        WRITE(11,'(A)') 'p.children(1).mark_mode="on";'
        WRITE(11,'(A)') 'p.children(1).mark_size=3;'
        WRITE(11,'(A)') 'p.children(1).mark_style=10;'
        WRITE(11,'(A)') 'p.children(1).mark_foreground=5;'
        WRITE(11,'(A)') 'p.children(1).mark_background=5;'
      ELSEIF (CISLO.EQ.2) THEN
        WRITE(11,'(A)') 'h = plot(ii,af);'
        WRITE(11,'(A)') 'p=get("hdl");'
        WRITE(11,'(A)') 'p.children(1).line_mode="on";'
        WRITE(11,'(A)') 'p.children(1).mark_mode="off";'
        WRITE(11,'(A)') 'p.children(1).polyline_style=1;'
        WRITE(11,'(A)') 'p.children(1).line_style=1;'
        WRITE(11,'(A)') 'p.children(1).thickness=1;'
        WRITE(11,'(A)') 'p.children(1).foreground=5;'
      ELSEIF (CISLO.EQ.3) THEN
        WRITE(11,'(A)') 'for i=1:length(ii)'
        WRITE(11,'(2A)') 'plot([ii(i) ii(i)],[0 af(i)],',
     &                   '"Color","red","Thickness",0.5);'
        WRITE(11,'(A)') 'end'
      ELSEIF (CISLO.EQ.4) THEN
        WRITE(11,'(A)') 'plot(ii,af,ii,am);'
        WRITE(11,'(A)') 'p=get("hdl");'
        WRITE(11,'(A)') 'p.children(1).line_mode="off";'
        WRITE(11,'(A)') 'p.children(1).mark_mode="on";'
        WRITE(11,'(A)') 'p.children(1).mark_size=3;'
        WRITE(11,'(A)') 'p.children(1).mark_style=11;'
        WRITE(11,'(A)') 'p.children(1).mark_foreground=2;'
        WRITE(11,'(A)') 'p.children(1).mark_background=2;'
        WRITE(11,'(A)') 'p.children(2).line_mode="off";'
        WRITE(11,'(A)') 'p.children(2).mark_mode="on";'
        WRITE(11,'(A)') 'p.children(2).mark_size=3;'
        WRITE(11,'(A)') 'p.children(2).mark_style=10;'
        WRITE(11,'(A)') 'p.children(2).mark_foreground=5;'
        WRITE(11,'(A)') 'p.children(2).mark_background=5;'
      ELSEIF (CISLO.EQ.5) THEN
        WRITE(11,'(A)') 'h=plot(ii,af,ii,am);'
        WRITE(11,'(A)') 'p=get("hdl");'
        WRITE(11,'(A)') 'p.children(1).line_mode="off";'
        WRITE(11,'(A)') 'p.children(1).mark_mode="on";'
        WRITE(11,'(A)') 'p.children(1).mark_size=3;'
        WRITE(11,'(A)') 'p.children(1).mark_style=11;'
        WRITE(11,'(A)') 'p.children(1).mark_foreground=2;'
        WRITE(11,'(A)') 'p.children(1).mark_background=2;'
        WRITE(11,'(A)') 'p.children(2).line_mode="on";'
        WRITE(11,'(A)') 'p.children(2).mark_mode="off";'
        WRITE(11,'(A)') 'p.children(2).polyline_style=1;'
        WRITE(11,'(A)') 'p.children(2).line_style=1;'
        WRITE(11,'(A)') 'p.children(2).thickness=1;'
        WRITE(11,'(A)') 'p.children(2).foreground=5;'
      ELSEIF (CISLO.EQ.6) THEN
        WRITE(11,'(A)') 'h=plot(ii,am);'
        WRITE(11,'(A)') 'p=get("hdl");'
        WRITE(11,'(A)') 'p.children(1).line_mode="off";'
        WRITE(11,'(A)') 'p.children(1).mark_mode="on";'
        WRITE(11,'(A)') 'p.children(1).mark_size=3;'
        WRITE(11,'(A)') 'p.children(1).mark_style=11;'
        WRITE(11,'(A)') 'p.children(1).mark_foreground=2;'
        WRITE(11,'(A)') 'p.children(1).mark_background=2;'
        WRITE(11,'(A)') 'for i=1:length(ii)'
        WRITE(11,'(2A)') 'plot([ii(i) ii(i)],[0 af(i)],',
     &                   '"Color","red","Thickness",0.5);'
        WRITE(11,'(A)') 'end'
      ELSEIF (CISLO.EQ.7) THEN
        WRITE(11,'(A)') 'h=plot(ii,dif);'
        WRITE(11,'(A)') 'p.children(1).line_mode="off";'
        WRITE(11,'(A)') 'p.children(1).mark_mode="on";'
        WRITE(11,'(A)') 'p.children(1).mark_size=3;'
        WRITE(11,'(A)') 'p.children(1).mark_style=10;'
        WRITE(11,'(A)') 'p.children(1).mark_foreground=5;'
        WRITE(11,'(A)') 'p.children(1).mark_background=5;'
      ELSEIF (CISLO.EQ.8) THEN
        WRITE(11,'(A)') 'h=plot(ii,dif);'
        WRITE(11,'(A)') 'p=get("hdl");'
        WRITE(11,'(A)') 'p.children(1).line_mode="on";'
        WRITE(11,'(A)') 'p.children(1).mark_mode="off";'
        WRITE(11,'(A)') 'p.children(1).polyline_style=1;'
        WRITE(11,'(A)') 'p.children(1).line_style=1;'
        WRITE(11,'(A)') 'p.children(1).thickness=1;'
        WRITE(11,'(A)') 'p.children(1).foreground=5;'
      ELSEIF (CISLO.EQ.9) THEN
        WRITE(11,'(A)') 'for i=1:length(ii)'
        WRITE(11,'(2A)') 'plot([ii(i) ii(i)],[0 dif(i)],',
     &                   '"Color","red","Thickness",0.5);'
        WRITE(11,'(A)') 'end'
      ENDIF
C
      TEMP=(MAXIM-MINIM)*1.0D-1
      IF ((MAXIM-MINIM).LE.MAX(ABS(MAXIM+MINIM),1.0D0)*EPS) TEMP=EPS
      WRITE(RETSTA,'(I10)') STA-1
      RETSTA=ADJUSTL(RETSTA)
      WRITE(RETSTO,'(I10)') STO+1
      RETSTO=ADJUSTL(RETSTO)
      WRITE(RETMIN,'(D25.16)') MINIM-TEMP
      RETMIN=ADJUSTL(RETMIN)
      WRITE(RETMAX,'(D25.16)') MAXIM+TEMP
      RETMAX=ADJUSTL(RETMAX)
      WRITE(11,'(A)') 'a=gca();'
      WRITE(11,'(A)') 'a.font_size=3;'
      WRITE(11,'(9A)') 'a.zoom_box=[', TRIM(RETSTA), ' ', TRIM(RETMIN),
     &    ' ', TRIM(RETSTO), ' ', TRIM(RETMAX), '];'
      WRITE(11,'(A)') 'title(''Approximations'',''fontsize'',5);'
      WRITE(11,'(A)')
     & 'xlabel(''Indices of approximations'',''fontsize'',3);'
      IF (CISLO.LE.6) THEN
        WRITE(11,'(A)')
     &   'ylabel(''Values of approximations'',''fontsize'',3);'
      ELSE
        WRITE(11,'(A)')
     &   'ylabel(''Differences of approximations'',''fontsize'',3);'
      ENDIF
      CALL UOSGRX(11,'PSAPP',CISLO,GFMT)
      RETURN
      END
