* SUBROUTINE UOSSUR                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  SCILAB GRAPHICAL VISUALIZATION OF SURFACE.
*
* PARAMETERS :
*  II  NGR  THE NUMBER OF NODES CORRESPONDING TO EVERY SELECTED VARIABLE
*  II  IGR  THE INDEX OF THE FIRST SELECTED VARIABLE
*  II  JGR  THE INDEX OF THE SECOND SELECTED VARIABLE
*  RI  XLIGR  THE MINIMUM VALUE OF THE FIRST VARIABLE OF THE SELECTED REGION
*  RI  XUIGR  THE MAXIMUM VALUE OF THE FIRST VARIABLE OF THE SELECTED REGION
*  RI  XLJGR  THE MINIMUM VALUE OF THE SECOND VARIABLE OF THE SELECTED REGION
*  RI  XUIGR  THE MAXIMUM VALUE OF THE SECOND VARIABLE OF THE SELECTED REGION
*  RI  FL(NGR,NGR)  THE FIELD CONTAINING DRAWN FUNCTION VALUES
*  LU  VYPISF   THE SAME DRAWN FUNCTION VALUES CAN BE PUT INTO P.sci ONLY ONCE
*  II  SCALE  LINEAR OR LOGARITHMIC SCALE OF THE PLOT
*  II  CISLO  THE NUMBER OF THE GRAPH
*  II  GFMT  GRAPHIC FORMAT
*
      SUBROUTINE UOSSUR(NGR,IGR,JGR,XLIGR,XUIGR,XLJGR,XUJGR,
     & FL,VYPISF,SCALE,CISLO,GFMT)
      INTEGER NGR,IGR,JGR,SCALE,CISLO,GFMT
      REAL*4 FL(NGR,NGR)
      REAL*8 XLIGR,XUIGR,XLJGR,XUJGR
      CHARACTER*25 RET
      LOGICAL VYPISF,ENLX,ENLY,CONSTF
C
      CALL UOSOPN(12,GFMT)
      CALL UOMIMS(NGR,0.0D0,0.0D0,XLIGR,XUIGR,XLJGR,XUJGR,
     & 0,0,FL,VYPISF,SCALE,'S',ENLX,ENLY,CONSTF)
C
      WRITE(12,'(A)') 'xset("fpf"," ");'
      WRITE(12,'(A)') 'surf(x,y,f);'
      WRITE(12,'(A)') 'fs=gcf();'
      WRITE(12,'(A)') 'fs.color_map=jetcolormap(16);'
      WRITE(12,'(A)') 'mn=min(f);'
      WRITE(12,'(A)') 'mx=max(f);'
      IF (CONSTF.OR.ENLX.OR.ENLY) WRITE(12,'(A)') 'eps=1.0d-6;'
      IF (CONSTF) THEN
        WRITE(12,'(A)') 'colorbar(mn-eps,mx+eps);'
      ELSE
        WRITE(12,'(A)') 'colorbar(mn,mx);'
      ENDIF
      WRITE(12,'(A)') 'as=gca();'
      WRITE(12,'(A)') 'as.font_size=3;'
      IF (CONSTF.AND.ENLX.AND.ENLY) THEN
        WRITE(12,'(2A)') 'as.zoom_box=',
     &  '[xligr-eps, xljgr-eps, xuigr+eps, xujgr+eps, mn-eps, mx+eps];'
      ELSEIF (ENLX.AND.ENLY) THEN
        WRITE(12,'(2A)') 'as.zoom_box=',
     &  '[xligr-eps, xljgr-eps, xuigr+eps, xujgr+eps, mn, mx];'
      ELSEIF (CONSTF.AND.ENLX) THEN
        WRITE(12,'(2A)') 'as.zoom_box=',
     &  '[xligr-eps, xljgr, xuigr+eps, xujgr, mn-eps, mx+eps];'
      ELSEIF (CONSTF.AND.ENLY) THEN
        WRITE(12,'(2A)') 'as.zoom_box=',
     &  '[xligr, xljgr-eps, xuigr, xujgr+eps, mn-eps, mx+eps];'
      ELSEIF (ENLX) THEN
        WRITE(12,'(A)')
     &  'as.zoom_box=[xligr-eps, xljgr, xuigr+eps, xujgr, mn, mx];'
      ELSEIF (ENLY) THEN
        WRITE(12,'(A)')
     &  'as.zoom_box=[xligr, xljgr-eps, xuigr, xujgr+eps, mn, mx];'
      ELSEIF (CONSTF) THEN
        WRITE(12,'(A)')
     &  'as.zoom_box=[xligr, xljgr, xuigr, xujgr, mn-eps, mx+eps];'
      ELSE
        WRITE(12,'(A)')
     &  'as.zoom_box=[xligr, xljgr, xuigr, xujgr, mn, mx];'
      ENDIF
      IF (CONSTF) THEN
        IF (SCALE.EQ.2) THEN
          WRITE(12,'(A)')
     &  'tit=title(''Surface (constant, log scale)'',''fontsize'',5);'
        ELSE
          WRITE(12,'(A)')
     &  'tit=title(''Surface (constant)'',''fontsize'',5);'
        ENDIF
      ELSE
        IF (SCALE.EQ.2) THEN
          WRITE(12,'(A)')
     &  'tit=title(''Surface (log scale)'',''fontsize'',5);'
        ELSE
          WRITE(12,'(A)') 'tit=title(''Surface'',''fontsize'',5);'
        ENDIF
      ENDIF
      WRITE(RET,'(I15)') IGR
      RET=ADJUSTL(RET)
      WRITE(12,'(3A)') 'xlabel(''X(', TRIM(RET),')'',''fontsize'',3);'
      WRITE(RET,'(I15)') JGR
      RET=ADJUSTL(RET)
      WRITE(12,'(3A)') 'ylabel(''X(', TRIM(RET),')'',''fontsize'',3);'
      WRITE(12,'(A)') 'zlabel(''F'',''fontsize'',3);'
      CALL UOSGRX(12,'PSSUR',CISLO,GFMT)
      RETURN
      END
