* SUBROUTINE UP0AF3             ALL SYSTEMS                 97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF VALUE OF THE AUGMENTED LAGRANGIAN FUNCTION.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NC  NUMBER OF CONSTRAINTS.
*  RI  CF(NC+1)  VECTOR CONTAINING VALUES OF THE CONSTRAINTS.
*  RI  CZ(NC)  VECTOR OF LAGRANGE MULTIPLIERS.
*  RI  S(NF+NC)  DIRECTION VECTOR.
*  RI  RPF2  PENALTY COEFFICIENT.
*  RI  RPF3  PENALTY COEFFICIENT.
*  RO  FC  VALUE OF THE PENALTY TERM.
*  RO  F  VALUE OF THE PENALTY FUNCTION.
*
      SUBROUTINE UP0AF3(NF,NC,CF,CZ,S,RPF2,RPF3,FC,F)
      INTEGER NF,NC
      REAL*8 CF(NC+1),CZ(NC),S(NF+NC),RPF2,RPF3,FC,F
      INTEGER KC
      FC=0.0D 0
      DO 1 KC=1,NC
      FC=FC+(CZ(KC)+S(NF+KC)+0.5D 0*RPF3*CF(KC))*CF(KC)+
     & RPF2*ABS(CF(KC))
    1 CONTINUE
      F=CF(NC+1)+FC
      RETURN
      END
