* SUBROUTINE UP0BA2             ALL SYSTEMS                 16/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF VALUE OF THE AUGMENTED LAGRANGIAN FUNCTION.
*
* PARAMETERS :
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  RI  AF(NA)  VECTOR CONTAINING VALUES OF APPROXIMATED FUNCTIONS.
*  RI  AS(NA)  VECTOR CONTAINING EXPONENTIAL TERMS.
*  RO  F  VALUE OF THE BARRIER FUNCTION.
*  RI  RPF3  BARRIER COEFFICIENT.
*  II  MEP2  SAVING EXPONENTIAL TERMS. MEP2=0-SAVING SUPPRESSED.
*         MEP2=1-SAVING EXPONENTIAL TERMS.
*
      SUBROUTINE UP0BA2(NA,AF,AS,F,RPF3,MEP2)
      INTEGER NA,MEP2
      REAL*8 AF(NA),AS(NA),F,RPF3
      REAL*8 FA,TEMP
      INTEGER KA
      F=0.0D 0
      DO 1 KA=1,NA
      FA=AF(KA)
      IF (MEP2.EQ.0) THEN
      TEMP=EXP(-2.0D 0*ABS(FA)/RPF3)
      ELSE
      TEMP=AS(KA)
      ENDIF
      F=F+ABS(FA)+RPF3*LOG(1.0D 0+TEMP)
    1 CONTINUE
C      F=FF+RPF3*F
      RETURN
      END
