* SUBROUTINE UP0GF1             ALL SYSTEMS                 00/12/01
C PORTABILITY : ALL SYSTEMS
C 00/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF VALUE OF THE AUGMENTED LAGRANGIAN FUNCTION.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NC  NUMBER OF CONSTRAINTS.
*  RI  CF(NC+1)  VECTOR CONTAINING VALUES OF THE CONSTRAINTS.
*  RI  CZ(NC)  VECTOR OF LAGRANGE MULTIPLIERS.
*  RI  G(NF)  GRADIENT OF THE LAGRANGIAN FUNCTION.
*  RI  S(NF+NC)  DIRECTION VECTOR.
*  RI  RPF2  PENALTY COEFFICIENT.
*  RI  RPF3  PENALTY COEFFICIENT.
*  RO  FC  VALUE OF THE PENALTY TERM.
*  RO  F  VALUE OF THE PENALTY FUNCTION.
*
      SUBROUTINE UP0GF1(NF,NC,CF,CZ,G,S,RPF2,RPF3,FC,F,IX,KBF)
      INTEGER NF,NC,IX(NF),KBF
      REAL*8 CF(NC+1),CZ(NC),G(NF),S(NF+NC),RPF2,RPF3,FC,F
      REAL*8 UXUDOT
      INTEGER KC
      FC=0.0D 0
      DO 1 KC=1,NC
      FC=FC+(CZ(KC)+S(NF+KC)+0.5D 0*RPF2*CF(KC))*CF(KC)
    1 CONTINUE
      FC=FC+0.5D 0*RPF3*UXUDOT(NF,G,G,IX,KBF)
      F=CF(NC+1)+FC
      RETURN
      END
