* SUBROUTINE UP0KT1             ALL SYSTEMS                 97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION THE KUHN-TUCKER MEASURE.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NC  NUMBER OF CONSTRAINTS.
*  RI  G(NF)  GRADIENT OF THE LAGRANGIAN FUNCTION.
*  RI  CF(NC)  VECTOR CONTAINING VALUES OF THE CONSTRAINT FUNCTIONS.
*  II  IX(N)  VECTOR CONTAINING TYPES OF BOUNDS.
*  II  KBF  VARIABLE WHICH SPECIFIES SIMPLE BOUNDS.
*  RO  F  VALUE OF THE PENALTY FUNCTION.
*
* SUBPROGRAMS USED :
*  S   UXUDOT  DOT PRODUCT OF TWO VECTORS.
*  S   UXVDOT  DOT PRODUCT OF TWO VECTORS.
*
      SUBROUTINE UP0KT1(NF,NC,G,CF,IX,KBF,F)
      INTEGER NF,NC,IX(NF),KBF
      REAL*8 G(NF),CF(NC),F
      REAL*8 UXUDOT,UXVDOT
      F=0.5D 0*(UXUDOT(NF,G,G,IX,KBF)+UXVDOT(NC,CF,CF))
      RETURN
      END
