* SUBROUTINE UP0MX3             ALL SYSTEMS                 05/12/01
C PORTABILITY : ALL SYSTEMS
C 05/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF VALUE OF THE AUGMENTED LAGRANGIAN FUNCTION.
*
* PARAMETERS :
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  RI  AF(NA)  VECTOR CONTAINING VALUES OF APPROXIMATED FUNCTIONS.
*  RI  AZL(NF)  VECTOR CONTAINING LOVER LAGRANGE MULTIPLIERS.
*  RI  AZU(NF)  VECTOR CONTAINING UPPER LAGRANGE MULTIPLIERS.
*  RO  F  VALUE OF THE PENALTY FUNCTION.
*  II  IEXT  KIND OF THE MINIMAX APPROXIMATION. IEXT=0-CHEBYSHEV
*         APPROXIMATION. IEXT=-1-MINIMAX. IEXT=+1-MAXIMIN.
*
      SUBROUTINE UP0MX3(NA,AF,AZL,AZU,F,IEXT)
      INTEGER NA,IEXT
      REAL*8 AF(NA+1),AZL(NA),AZU(NA),F
      REAL*8 FA
      INTEGER KA
      F=0.0D 0
      DO 1 KA=1,NA
      FA=AF(KA)
      IF (IEXT.EQ.0) THEN
      F=F+(AZU(KA)-AZL(KA))*FA
      ELSE IF (IEXT.LT.0) THEN
      F=F+AZU(KA)*FA
      ELSE IF (IEXT.GT.0) THEN
      F=F-AZL(KA)*FA
      ENDIF
    1 CONTINUE
      RETURN
      END
