* SUBROUTINE UQCLEA                ALL SYSTEMS                98/12/01
* PORTABILITY : ALL SYSTEMS
* 98/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  PERFORM DIRECTIVE 'CLEAR'
*
* PARAMETERS :
*  TI  BUFFER(MLENB) - WORK BUFFER
*  II  MLENB - MAX. LENGTH OF THE BUFFER
*  II  IPOSD - POSITION OF THE FIRST CHARACTER OF DIRECTIVE
*               IN THE BUFFER
*  II  IPOS2 - POSITION OF THE LAST CHARACTER OF LINE
*               IN THE BUFFER
*  TU  SYMTAB(MLENST) - SYMBOL TABLE
*  II  MLENST - MAX. LENGTH OF THE SYMBOL TABLE
*  IU  IPOINT(MNP,6) - ARRAY OF POINTERS TO THE SYMBOL TABLE
*               1-LINK, 2-POSITION OF THE FIRST CHARACTER,
*               3-LENGTH OF NAME, 4-POSITION OF THE LAST CHARACTER,
*               5-POINTER OF LIST, 6-MODERW (1-RW, 2-RA, 3-RO)
*  II  MNP - MAX. NUMBER OF POINTERS
*  II  LP - LAST POINTER TO THE SYMBOL TABLE
*  TI  CHDS - THE DATA SEPARATOR MARKER
*  IO  IER - ERROR INDICATOR
*
* SUBPROGRAMS USED :
*  S   UQSADR - SYNTAX ANALYSIS OF DIRECTIVE LINE
*  LF  UQVDEF - IS MACRO DEFINED IN THE SYMBOL TABLE
*  S   UQDLCH - DELETE SPECIFIED CHARACTER FROM STRING ARRAY
*  S   UQFCHR - FIND NEXT POSITION OF SPECIFIED CHARACTER IN
*               STRING ARRAY
*  LF  UQSTRC - COMPARISON OF TWO SUBSTRINGS
*
      SUBROUTINE UQCLEA(BUFFER,MLENB,IPOSD,IPOS2,SYMTAB,MLENST,
     *                  IPOINT,MNP,LP,CHDS,IER)
      INTEGER MLENB,IPOSD,IPOS2,MLENST,MNP,IPOINT(MNP,6),LP,IER
      INTEGER MNPAR
      CHARACTER*1 BUFFER(MLENB),SYMTAB(MLENST),CHDS
      CHARACTER*50   FN1,FN2,FNAMES(20),NAME,MSG(50)*70
      COMMON/UQCHRX/ FN1,FN2,FNAMES,NAME,MSG
      PARAMETER(MNPAR=1)
      INTEGER NPAR,IPOSP(MNPAR,2),ITYPE(MNPAR)
      INTEGER I,J,K,L,MBEGIN,IP,II,IS1,IS2
      INTEGER UQIARE
      LOGICAL UQVDEF,UQSTRC
      CALL UQSADR(BUFFER,MLENB,IPOSD,IPOS2,IPOSP,MNPAR,NPAR,ITYPE,IER)
      IF(IER.NE.0) RETURN
      IF(NPAR.NE.1) GOTO 4
      IF(ITYPE(1).NE.5) GOTO 5
      IF(UQVDEF(BUFFER,MLENB,IPOSP(1,1),IPOSP(1,2),SYMTAB,MLENST,
     *          IPOINT,MNP,LP,IP,I)) THEN
        MBEGIN=IPOINT(IP,2)+IPOINT(IP,3)
        CALL UQDLCH(SYMTAB,MLENST,MBEGIN,IPOINT(IP,4),' ')
        I=MBEGIN
        CALL UQFCHR(SYMTAB,MLENST,IPOINT(IP,4),I,CHDS)
        IF(I.LT.IPOINT(IP,4)) THEN
          I=I+1
    1     J=I
          IF(J.LE.IPOINT(IP,4)) THEN
            CALL UQFCHR(SYMTAB,MLENST,IPOINT(IP,4),J,CHDS)
            IF(SYMTAB(J).EQ.CHDS) J=J-1
            K=MBEGIN
    2       L=K
            CALL UQFCHR(SYMTAB,MLENST,IPOINT(IP,4),L,CHDS)
            IF(UQSTRC(SYMTAB,MLENST,I,J,SYMTAB,MLENST,K,L-1)) THEN
              CALL UQDELS(SYMTAB,MLENST,IPOINT(IP,4),I-1,J)
              GOTO 1
            ELSEIF(K+3.LT.L) THEN
              II=K+1
              CALL UQFCHR(SYMTAB,MLENST,L-2,II,'(')
              IF(SYMTAB(II).EQ.'(') THEN
                IF(UQSTRC(SYMTAB,MLENST,I,I+II-K,SYMTAB,MLENST,K,II))
     *            THEN
C-----------------------------------------------------------------------
                  IS1=UQIARE(SYMTAB(II+1),L-2-II,IER)
                  IS2=UQIARE(SYMTAB(I+II-K+1),J-1-I-II+K,IER)
                  IF(IS1.LT.IS2) THEN
                    CALL UQDELS(SYMTAB,MLENST,IPOINT(IP,4),K,L)
                    I=I-(L-K+1)
                    IF(I.EQ.MBEGIN) THEN
                      CALL UQFCHR(SYMTAB,MLENST,IPOINT(IP,4),I,CHDS)
                      I=I+1
                    ENDIF
                  ELSE
                    CALL UQDELS(SYMTAB,MLENST,IPOINT(IP,4),I-1,J)
                  ENDIF
                  GOTO 1
C-----------------------------------------------------------------------
                ENDIF
              ENDIF
            ENDIF
            IF(L+1.NE.I) THEN
              K=L+1
              GOTO 2
            ENDIF
            I=J+2
            GOTO 1
          ENDIF
        ENDIF
C
C CHANGE OF DIMENSION (0 TO 1)  IN ARRAY DECLARATIONS
C
        J=MBEGIN
    3   CALL UQFCHR(SYMTAB,MLENST,IPOINT(IP,4),J,'0')
        IF(J.GT.1.AND.J.LT.IPOINT(IP,4)) THEN
          IF((SYMTAB(J-1).EQ.'('.OR.SYMTAB(J-1).EQ.',').AND.
     *       (SYMTAB(J+1).EQ.')'.OR.SYMTAB(J+1).EQ.',')) SYMTAB(J)='1'
        ENDIF
        J=J+1
        IF(J.LT.IPOINT(IP,4)) GOTO 3
      ELSE
C
C ERROR: VARIABLE NOT DEFINED
C
        IER=9
        NAME='                                                  '
        DO 6 I=0,IPOSP(1,2)-IPOSP(1,1)
        NAME(I+1:I+1)=BUFFER(IPOSP(1,1)+I)
    6   CONTINUE
      ENDIF
      RETURN
C
C ERROR: SYNTAX ERROR
C
    4 IER=20
      RETURN
C
C ERROR: MACRO NAME EXPECTED
C
    5 IER=23
      RETURN
      END
