* SUBROUTINE UQGVAL                ALL SYSTEMS                98/12/01
* PORTABILITY : ALL SYSTEMS
* 98/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  GIVE VALUE OF A MACRO VARIABLE
*
* PARAMETERS :
*  TI  BUFFER(MLENB) - WORK BUFFER
*  II  MLENB - MAX. LENGTH OF THE BUFFER
*  II  IPOS11 - POSITION OF THE FIRST CHARACTER OF MACRO NAME
*               IN THE BUFFER
*  II  IPOS12 - POSITION OF THE LAST CHARACTER OF MACRO NAME
*               IN THE BUFFER
*  TI  SYMTAB(MLENST) - SYMBOL TABLE
*  II  MLENST - MAX. LENGTH OF THE SYMBOL TABLE
*  IO  IPOS21 - POSITION OF THE FIRST CHARACTER OF MACRO VALUE
*               IN THE SYMBOL TABLE
*  IO  IPOS22 - POSITION OF THE LAST CHARACTER OF MACRO VALUE
*               IN THE SYMBOL TABLE
*  II  IPOINT(MNP,6) - ARRAY OF POINTERS TO THE SYMBOL TABLE
*               1-LINK, 2-POSITION OF THE FIRST CHARACTER,
*               3-LENGTH OF NAME, 4-POSITION OF THE LAST CHARACTER,
*               5-POINTER OF LIST, 6-MODERW (1-RW, 2-RA, 3-RO)
*  II  MNP - MAX. NUMBER OF POINTERS
*  IO  IER - ERROR INDICATOR
*
* COMMON DATA:
*  II  LP - LAST POINTER TO THE SYMBOL TABLE
*  II  LENOPT(NOPT) - LENGTHS OF OPTION PARAMETER NAMES
*  TI  OPTNM(*) - NAMES OF OPTION PARAMETERS
*  II  NOPT - NUMBER OF OPTIONS
*  II  LENST - ACTUAL LENGTH OF THE BUFFER
*  TI  WTRUE - STRING '.TRUE.'
*  TI  WFALSE - STRING '.FALSE.'
*  TU  CHDIR - THE DIRECTIVE CHARACTER
*  TU  CHEOL - THE END OF LINE MARKER
*  TU  CHCON - THE CONTINUATION MARKER
*  TU  CHDS - THE DATA SEPARATOR MARKER
*  TU  FN1 - FILENAME PART 1 (E.G. LIBRARY)
*  TU  FN2 - FILENAME PART 2 (E.G. EXTENSION)
*  IU  DIALOG - TYPE OF DIALOGUE (0-NO DIALOGUE, 1-SHORT DIALOGUE,
*               2-FULL DIALOGUE)
*  IU  MODERW - READ/WRITE MODE (1-READ/WRITE, 2-READ/APPEND,
*               3-READ ONLY)
*  IU  ILNLEN - THE NUMBER OF CHARACTERS PER LINE OF INPUT
*  IU  OLNLEN - THE NUMBER OF CHARACTERS PER LINE OF OUTPUT
*  IU  OUNIT - THE OUTPUT UNIT NUMBER
*  IU  IUNIT - THE INPUT UNIT NUMBER
*  IU  INUNIT - THE INCLUDE UNIT NUMBER
*  IU  IIUNIT - THE INPUT INTERACTIVE UNIT NUMBER
*  IU  OIUNIT - THE OUTPUT INTERACTIVE UNIT NUMBER
*  IU  LABEL1 - STARTING VALUE OF LABEL
*  IU  LABEL2 - STEP OF LABEL AFTER SUBST('FILENAME')
*  IU  ADF - PERFORM AUTOMATICAL DIFFERENTIATION ON FMODELF? WHAT TYPE?
*  IU  ADA - PERFORM AUTOMATICAL DIFFERENTIATION ON FMODELA? WHAT TYPE?
*  IU  ADC - PERFORM AUTOMATICAL DIFFERENTIATION ON FMODELC? WHAT TYPE?
*  LU  LSUBS - PERFORM SUBSTITUTIONS ?
*  LU  LFORTO - IS IT A FORTRAN ?
*  LU  LOUT - OUTPUT FILE ?
*  LU  LSMLET - LOWER CASE LETTERS ALLOWED ?
*  LU  LFRFMT - IS IT A FORTRAN IN FREE FORMAT ?
*
* SUBPROGRAMS USED :
*  F  UQVDEF - IS VARIABLE DEFINED IN THE SYMBOL TABLE ?
*  S  UQGCST - GARBAGE COLLECTOR
*  S  UQINCS - INCLUDE SUBSTRING TO STRING ARRAY
*  S  UQSTRI - CONVERT INTEGER NUMBER TO STRING
*
      SUBROUTINE UQGVAL(BUFFER,MLENB,IPOS11,IPOS12,SYMTAB,
     *                  MLENST,IPOS21,IPOS22,IPOINT,MNP,IER)
      INTEGER MLENB,IPOS11,IPOS12,MLENST,IPOS21,IPOS22,
     *                  MNP,IPOINT(MNP,6),IER
      CHARACTER*1 BUFFER(MLENB),SYMTAB(MLENST)
C ----------------------------------------------------------------------
      INTEGER        LENB,LENST,LP,ILNLEN,OLNLEN,MODERW,DIALOG,IUNIT,
     *        OUNIT,INUNIT,IIUNIT,OIUNIT,NOPT,LENOPT(30),NSUB,MNSUB,
     *        NDIR,LENDIR(30),NMSG,MNIF,NIF1,NIF2,TABCH(0:255),ADF,
     *        ADA,ADC,ARD,CRD
      COMMON/UQINT2/ LENB,LENST,LP,ILNLEN,OLNLEN,MODERW,DIALOG,IUNIT,
     *        OUNIT,INUNIT,IIUNIT,OIUNIT,NOPT,LENOPT,NSUB,MNSUB,
     *        NDIR,LENDIR,NMSG,MNIF,NIF1,NIF2,TABCH,ADF,ADA,ADC,ARD,CRD
      INTEGER*4      LABEL1,LABEL2,MAXLAB,LEVLAB(20)
      COMMON/UQINT4/ LABEL1,LABEL2,MAXLAB,LEVLAB
      CHARACTER*1    CHCON,CHEOL,CHDS,CHDIR,WTRUE(6),WFALSE(7),
     *        ASCII(32:127),OPTNM(200),DIRNM(200)
      COMMON/UQCHR1/ CHCON,CHEOL,CHDS,CHDIR,WTRUE,WFALSE,
     *        ASCII,OPTNM,DIRNM
      CHARACTER*50   FN1,FN2,FNAMES(20),NAME,MSG(50)*70
      COMMON/UQCHRX/ FN1,FN2,FNAMES,NAME,MSG
      LOGICAL        LFORTO,LSMLET,LFRFMT,LSUBS,LOUT,LHELP,LIFDON(20),
     *        LELSE(20),CONDIF,CONDDO,LOOP,SIFDEC,DIALGR,LPERFD
      COMMON/UQLOGL/ LFORTO,LSMLET,LFRFMT,LSUBS,LOUT,LHELP,LIFDON,
     *        LELSE,CONDIF,CONDDO,LOOP,SIFDEC,DIALGR,LPERFD
C ----------------------------------------------------------------------
      INTEGER IP,IPPRED,LEN,I,J,K
      INTEGER*4 IV
      CHARACTER*1 CHV
      CHARACTER*50 FN
      LOGICAL UQVDEF,LV
C
C     IS IT A MACRO ?
C
      IF(UQVDEF(BUFFER,MLENB,IPOS11,IPOS12,SYMTAB,MLENST,
     *          IPOINT,MNP,LP,IP,IPPRED)) THEN
        IPOS21=IPOINT(IP,2)+IPOINT(IP,3)
        IPOS22=IPOINT(IP,4)
C
C     IS IT AN OPTION ?
C
      ELSE
        K=0
        LEN=IPOS12-IPOS11+1
        DO 2 I=1,NOPT
          IF(LEN.EQ.LENOPT(I)) THEN
            DO 1 J=1,LEN
              IF(BUFFER(IPOS11+J-1).NE.OPTNM(K+J)) THEN
                K=K+LEN
                GOTO 2
              ENDIF
    1       CONTINUE
            GOTO 3
          ELSE
            K=K+LENOPT(I)
          ENDIF
    2   CONTINUE
        GOTO 31
    3   IF(LENST+50.GT.MLENST) THEN
          CALL UQGCST(SYMTAB,MLENST,LENST,IPOINT,MNP,LP)
          IF(LENST+50.GT.MLENST) GOTO 32
        ENDIF
        GOTO (4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
     *      21,22,23,24,25,35,36,37,38,39,40), I
    4   CHV=CHDIR
        GOTO 28
    5   CHV=CHEOL
        GOTO 28
    6   CHV=CHCON
        GOTO 28
    7   CHV=CHDS
        GOTO 28
    8   FN=FN1
        GOTO 29
    9   FN=FN2
        GOTO 29
   10   IV=DIALOG
        GOTO 27
   11   IV=MODERW
        GOTO 27
   12   IV=ILNLEN
        GOTO 27
   13   IV=OLNLEN
        GOTO 27
   14   IV=OUNIT
        GOTO 27
   15   IV=IUNIT
        GOTO 27
   16   IV=INUNIT
        GOTO 27
   17   IV=IIUNIT
        GOTO 27
   18   IV=OIUNIT
        GOTO 27
   19   IV=LABEL1
        GOTO 27
   20   IV=LABEL2
        GOTO 27
   21   LV=LSUBS
        GOTO 26
   22   LV=LFORTO
        GOTO 26
   23   LV=LOUT
        GOTO 26
   24   LV=LSMLET
        GOTO 26
   25   LV=LFRFMT
        GOTO 26
   35   LV=SIFDEC
        GOTO 26
   36   LV=DIALGR
        GOTO 26
   37   IV=ADF
        GOTO 27
   38   IV=ADA
        GOTO 27
   39   IV=ADC
        GOTO 27
   40   LV=LPERFD
        GOTO 27
C
C     LOGICAL OPTION
C
   26   IPOS22=LENST
        IPOS21=LENST+1
        IF(LV) THEN
          CALL UQINCS(SYMTAB,MLENST,IPOS22,IPOS21,WTRUE,6,1,6,IER)
        ELSE
          CALL UQINCS(SYMTAB,MLENST,IPOS22,IPOS21,WFALSE,7,1,7,IER)
        ENDIF
        RETURN
C
C     NUMERICAL OPTION
C
   27   IPOS22=LENST
        IPOS21=LENST+1
        CALL UQSTRI(IV,SYMTAB,MLENST,IPOS22,IPOS21,IER)
        RETURN
C
C     CHARACTER OPTION
C
   28   IPOS22=LENST+1
        IPOS21=IPOS22
        SYMTAB(IPOS22)=CHV
        RETURN
C
C     STRING OPTION
C
   29   IPOS21=LENST+1
        IPOS22=LENST
        DO 30 I=1,50
          IF(FN(I:I).NE.' ') THEN
            IPOS22=IPOS22+1
            SYMTAB(IPOS22)=FN(I:I)
          ENDIF
   30   CONTINUE
        IF(IPOS21.GT.IPOS22) THEN
          IPOS22=IPOS21
          SYMTAB(IPOS22)=' '
        ENDIF
      ENDIF
      RETURN
C
C ERROR: VARIABLE NOT DEFINED
C
   31 IER=9
      NAME='                                                  '
      DO 33 I=0,IPOS12-IPOS11
      NAME(I+1:I+1)=BUFFER(IPOS11+I)
   33 CONTINUE
      RETURN
C
C ERROR: MAX. LENGTH OF SYMBOL TABLE EXCEEDED
C
   32 IER=4
      RETURN
      END
