* SUBROUTINE UQREPU                ALL SYSTEMS                89/12/01
* PORTABILITY : ALL SYSTEMS
* 89/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  PERFORM DIRECTIVE REPEAT - UNTIL(CONDITION)
*
* PARAMETERS :
*  TI  BUFFER(MLENB) - WORK BUFFER
*  II  MLENB - MAX. LENGTH OF THE BUFFER
*  IU  LENB - ACTUAL LENGTH OF THE BUFFER
*  II  IPOS1 - POSITION OF THE FIRST CHARACTER OF LINE
*               IN THE BUFFER
*  II  IPOSD - POSITION OF THE FIRST CHARACTER OF DIRECTIVE
*               IN THE BUFFER
*  II  IPOS2 - POSITION OF THE LAST CHARACTER OF LINE
*               IN THE BUFFER
*  TI  SYMTAB(MLENST) - SYMBOL TABLE
*  II  MLENST - MAX. LENGTH OF THE SYMBOL TABLE
*  II  IPOINT(MNP,6) - ARRAY OF POINTERS TO THE SYMBOL TABLE
*               1-LINK, 2-POSITION OF THE FIRST CHARACTER,
*               3-LENGTH OF NAME, 4-POSITION OF THE LAST CHARACTER,
*               5-POINTER OF LIST, 6-MODERW (1-RW, 2-RA, 3-RO)
*  II  MNP - MAX. NUMBER OF POINTERS
*  II  IDIRN - NUMBER OF DIRECTIVE
*  II  NREP - NUMBER OF NESTED REPEAT-UNTIL
*  II  IUNIT - THE INPUT UNIT NUMBER
*  II  ILNLEN - THE INPUT LINE LENGTH
*  II  NLINES - NUMBER OF LINES
*  TI  CHCON - THE CONTINUATION MARKER
*  TI  CHEOL - THE END OF LINE MARKER
*  IO  IER - ERROR INDICATOR
*
* SUBPROGRAMS USED :
*  S   UQCEOL - CHECK END OF LINE
*  LF  UQLEXP - EVALUATION OF LOGICAL EXPRESSION
*  S   UQRDLN - READ A LINE
*  S   UQSUBS - PERFORM SUBSTITUTIONS
*  S   UQDELS - DELETE A SUBSTRING FROM A STRING ARRAY
*
      SUBROUTINE UQREPU(BUFFER,MLENB,LENB,IPOS1,IPOSD,IPOS2,SYMTAB,
     *                  MLENST,IPOINT,MNP,IDIRN,NREP,IUNIT,ILNLEN,
     *                  NLINES,CHCON,CHEOL,IER)
      INTEGER MLENB,LENB,IPOS1,IPOSD,IPOS2,MLENST,MNP,IPOINT(MNP,6),
     *        IDIRN,NREP,IUNIT,ILNLEN,NLINES,IER
      CHARACTER*1 BUFFER(MLENB),SYMTAB(MLENST),CHCON,CHEOL
      INTEGER MNREP
      PARAMETER(MNREP=20)
      INTEGER IREPLN(MNREP),IPOSM1,IPOSM2,I,K
      LOGICAL COND,UQLEXP
      SAVE IREPLN
C
C REPEAT
C
      IF(IDIRN.EQ.20) THEN
        CALL UQCEOL(BUFFER,MLENB,IPOSD,IER)
        IF(IER.NE.0) RETURN
        NREP=NREP+1
        IF(NREP.GT.MNREP) GOTO 5
        IREPLN(NREP)=NLINES
C
C UNTIL(CONDITION)
C
      ELSE
        IF(NREP.LE.0) GOTO 6
        COND=UQLEXP(BUFFER,MLENB,IPOSD,IPOS2,SYMTAB,MLENST,
     *                IPOINT,MNP,IDIRN,IER)
        IF(IER.NE.0) RETURN
        IF(COND) THEN
          NREP=NREP-1
        ELSE
    1     DO 2 NLINES=NLINES,IREPLN(NREP),-1
            BACKSPACE IUNIT
    2     CONTINUE
          LENB=IPOS1-1
          I=1
          K=1
    3     IF(NREP-K.LE.0) THEN
          ELSEIF(IREPLN(NREP-K).EQ.IREPLN(NREP)) THEN
            K=K+1
            GOTO 3
          ENDIF
          CALL UQRDLN(BUFFER,MLENB,LENB,NLINES,ILNLEN,IUNIT,
     *                CHCON,CHEOL,IER)
          IF(IER.NE.0) RETURN
    4     CALL UQSUBS(BUFFER,MLENB,IPOS1,IPOS2,SYMTAB,MLENST,
     *                IPOINT,MNP,IDIRN,IPOSD,IPOSM1,IPOSM2,IER)
          IF(IER.NE.0) RETURN
          IF(IDIRN.EQ.20) THEN
            IF(I.EQ.K) RETURN
            I=I+1
          ENDIF
          CALL UQDELS(BUFFER,MLENB,LENB,IPOS1,IPOS2)
          IF(IPOS1.GE.LENB) THEN
            BACKSPACE IUNIT
            GOTO 1
          ENDIF
          GOTO 4
        ENDIF
      ENDIF
      RETURN
C
C ERROR: 'MNREP' EXCEEDED - TOO MANY NESTED REPEAT-UNTIL
C
    5 IER=42
      RETURN
C
C ERROR: UNEXPECTED 'UNTIL'
C
    6 IER=43
      RETURN
      END
