* SUBROUTINE UUGAM1                ALL SYSTEMS                02/12/01
C PORTABILITY : ALL SYSTEMS
C 02/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETERMINATION OF THE SCALING PARAMETER.
*
* PARAMETERS :
*  RI  A  INPUT PARAMETER.
*  RI  B  INPUT PARAMETER.
*  RI  C  INPUT PARAMETER.
*  RI  RHO  NONQUADRATIC CORRECTION PARAMETER.
*  RO  GAM  SCALING PARAMETER.
*  RO  PAR  NUMBER RHO/GAM.
*  RI  PAR1  PARAMETER FOR SCALING.
*  RI  PAR2  PARAMETER FOR SCALING.
*  II  MET1  SCALING OPTION.
*  II  MET4  SCALING OPTION.
*
* COMMON DATA :
*  II  NIT  ACTUAL NUMBER OF ITERATIONS.
*  II  KIT  NUMBER OF THE ITERATION AFTER LAST RESTART.
*  TO  TUXX  TEXT INFORMATION ON THE CORRECTION USED.
*
      SUBROUTINE UUGAM1(A,B,C,RHO,GAM,PAR,PAR1,PAR2,MET1,MET4)
      INTEGER NS,ISB,ISP(20),ISD(20),KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI(7)
      COMMON /UMOPTI/ NS,ISB,ISP,ISD,KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI
      REAL*8 TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR(12)
      COMMON /UMOPTR/ TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR
      REAL*8 ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS(2)
      COMMON /UMCONS/ ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS
      CHARACTER*4 TSS(20)
      CHARACTER*8 TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,TUXX,
     & TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT(3)
      CHARACTER*80 TER
      COMMON /UMOPTT/ TSS,TER,TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,
     & TUXX,TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT
      CHARACTER*6 NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN
      CHARACTER*14 NAME
      COMMON /UMOPTN/ NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN,NAME
      INTEGER MET1,MET4
      REAL*8 A,B,C,RHO,GAM,PAR,PAR1,PAR2
      REAL*8 POM3,POM4
      LOGICAL L1,L2,L3
      REAL*8 CON3,CON6
      PARAMETER(CON3=0.2D 0,CON6=1.0D-4)
      L1=ABS(MET1).GE.3.OR.ABS(MET1).EQ.2.AND.NIT.EQ.KIT
      L3=.NOT.L1
      IF (L1) THEN
C
C     DETERMINATION OF THE PARAMETER GAM (SELF SCALING)
C
      IF (C.LE.ZERO) THEN
      PAR=A/B
      POM3=0.7D 0
      POM4=6.0D 0
      ELSE
      IF (MET4.EQ.1) THEN
      PAR=A/B
      POM3=0.7D 0
      POM4=6.0D 0
      ELSE IF (MET4.EQ.2) THEN
      PAR=B/C
      POM3=0.7D 0
      POM4=6.0D 0
      ELSE IF (MET4.EQ.3) THEN
      PAR=SQRT(A/C)
      POM3=0.7D 0
      POM4=6.0D 0
      ELSE IF (MET4.EQ.4) THEN
      PAR=TWO*(A/C)/(A/B+B/C)
      POM3=0.7D 0
      POM4=6.0D 0
      ELSE IF (MET4.EQ.5) THEN
      PAR=HALF*(A/B+B/C)
      POM3=0.7D 0
      POM4=6.0D 0
      ENDIF
      ENDIF
      IF (PAR.LE.ZERO) THEN
      L3=.TRUE.
      ELSE
      GAM=RHO/PAR
      IF (MET1.LT.0.AND.NIT.EQ.KIT) THEN
      GAM=MAX(GAM,CON6)
      GAM=MIN(GAM,ONE/CON6)
      PAR=RHO/GAM
      ENDIF
      IF (ABS(MET1).EQ.3.AND.NIT.NE.KIT) THEN
      L2=PAR2.LE.ZERO
      L3=L2.AND.ABS(PAR1).LE.CON3
      L3=L3.OR.(.NOT.L2.AND.GAM.GT.ONE)
      L3=L3.OR.(L2.AND.PAR1.LT.ZERO.AND.GAM.GT.ONE)
      L3=L3.OR.(L2.AND.PAR1.GT.ZERO.AND.GAM.LT.ONE)
      L3=L3.OR.GAM.LT.POM3
      L3=L3.OR.GAM.GT.POM4
      ELSE IF (ABS(MET1).EQ.4.AND.NIT.NE.KIT) THEN
      L3=GAM.LT.POM3.OR.GAM.GT.POM4
      ENDIF
      ENDIF
      ENDIF
      IF(L3) THEN
      GAM=ONE
      PAR=RHO/GAM
      ENDIF
      RETURN
      END
