* SUBROUTINE UUSBA2                ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* RANK-ONE UPDATE OF A SPARSE RECTANGULAR MATRIX.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NA  NEW NUMBER OF APPROXIMATED FUNCTIONS.
*  II  NB  OLD NUMBER OF APPROXIMATED FUNCTIONS.
*  II  MA  NUMBER OF NONZERO ELEMENTS OF THE MATRIX.
*  RI  AG(MA+NF)  AUGMENTED SPARSE JACOBIAN MATRIX.
*  II  IAG(NA+2)  POSITION OF THE FIRST RORWS ELEMENTS IN THE FIELD AG.
*  II  JAG(MA+NF) COLUMN INDICES OF ELEMENTS IN THE FIELD AG.
*  RI  AF(NA+1)  VECTOR OF RIGHT HAND SIDES.
*  RU  XO(NF)  VECTORS OF VARIABLES DIFFERENCE.
*  RU  GO(NF)  GRADIENTS DIFFERENCE.
*  RI  AFO(NA+1)  AUGMENTED VECTOR OF RIGHT HAND SIDES DIFFERENCE.
*  RA  S(NF)  AUXILIARY VECTOR.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*
* COMMON DATA :
*  IO  ITERH  TERMINATION INDICATOR. ITERH<0-BAD DECOMPOSITION.
*         ITERH=0-SUCCESSFUL UPDATE. ITERH>0-NONPOSITIVE PARAMETERS.
*  II  IDECA  DECOMPOSITION INDICATOR. IDECA=0-NO DECOMPOSITION.
*  TO  TUXX  TEXT INFORMATION ON THE CORRECTION USED.
*
* SUBPROGRAMS USED :
*  S   UXSRMM  ROWWISE ORDERED SPARSE RECTANGULAR MATRIX-VECTOR PRODUCT.
*  S   UXSCMD  COLUMNWISE ORDERED SPARSE RECTANGULAR MATRIX-VECTOR
*         PRODUCT ADDED TO A SCALED VECTOR.
*  S   UXVCOP  COPYING OF A VECTOR.
*  RF  UXUDOT  DOT PRODUCT OF VECTORS.
*  S   UXVSCL  SCALING OF A VECTOR.
*  S   UOERR1  ERROR MESAGES.
*  S   UOU1D1  PRINT OF ENTRY TO VARIABLE METRIC UPDATE.
*  S   UOU1D2  PRINT OF EXIT FROM VARIABLE METRIC UPDATE.
*
* METHOD :
* BASIC VARIABLE METRIC METHODS.
*
      SUBROUTINE UUSBA2(NF,NA,NB,MA,AG,IAG,JAG,AF,XO,GO,AFO,S,IX,MET)
      INTEGER NS,ISB,ISP(20),ISD(20),KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI(7)
      COMMON /UMOPTI/ NS,ISB,ISP,ISD,KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI
      REAL*8 TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR(12)
      COMMON /UMOPTR/ TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR
      REAL*8 ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS(2)
      COMMON /UMCONS/ ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS
      CHARACTER*4 TSS(20)
      CHARACTER*8 TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,TUXX,
     & TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT(3)
      CHARACTER*80 TER
      COMMON /UMOPTT/ TSS,TER,TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,
     & TUXX,TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT
      CHARACTER*6 NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN
      CHARACTER*14 NAME
      COMMON /UMOPTN/ NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN,NAME
      INTEGER NF,NA,NB,MA,IAG(NA+2),JAG(MA+NF),IX(NF),MET
      REAL*8 AG(MA+NF),AF(NA+1),XO(NF),GO(NF),AFO(NA+1),S(NF)
      REAL*8 UXUDOT
      REAL*8 B,DEN
      IF (MET.LE.0) RETURN
C      CALL UOU1D1(N,XO,GO)
      IF(IDECA.NE.0) THEN
      ITERH=-1
      TUXX='BAD DEC0'
      CALL UOERR1('UUSBA2',1)
      GOTO 5
      ENDIF
C
C     DETERMINATION OF THE PARAMETERS B, C
C
      B=UXUDOT(NF,XO,GO,IX,KBF)
      IF (B.LE.ZERO)  THEN
      ITERH=2
      TUXX='B - NEG.'
      GOTO 5
      ENDIF
      CALL UXSRMM(NF,NA,MA,AG,IAG,JAG,XO,AFO)
      CALL UXSCMD(NF,NA,MA,AG,IAG,JAG,AFO,-ONE,GO,S)
      DEN=-UXUDOT(NF,XO,S,IX,KBF)
      IF (DEN.LE.ZERO)  THEN
      ITERH=3
      TUXX='DEN-NEG.'
      GOTO 5
      ENDIF
C
C     RANK ONE UPDATE
C
      NA=NB+1
      MA=IAG(NA+1)-1
      CALL UXVSCL(NF,SQRT(ONE/DEN),S,S)
      CALL UXVCOP(NF,S,AG(IAG(NA)))
      AF(NA)=ZERO
      TUXX='RANK ONE'
      ITERH=0
    5 CONTINUE
C      CALL UOU1D2(N,H,S,RHO,GAM,PAR,A,B,C,POM,ETA9)
      RETURN
      END
