* SUBROUTINE UUVLVT                ALL SYSTEMS                31/12/16
C PORTABILITY : ALL SYSTEMS
C 31/12/16 VL :                                       ORIGINAL VERSION
*
* PURPOSE :
* TEST OF POSITIVE DEFINITENESS USING  RDR^T  FACTORIZATION.
*
* PARAMETERS :
*  II  M  NUMBER OF COLUMNS OF MATRICES XM, GM.
*  II  MM  MAXIMUM NUMBER OF COLUMNS OF MATRICES XM, GM.
*  RI  XR(MM,MM)  MATRIX  XM^T . GM .
*  RO  XRP(MM,MM)  AUXILIARY MATRIX.
*  RO  HR(M*(M+1)/2)  UPPER TRIANGULAR MATRIX  R  STORED COLUMNWISE.
*  RI  GR(M*(M+1)/2)  SYMMETRIC MATRIX  GM^T . GM  STORED COLUMNWISE.
*  RI  DR(M)  DIAGONAL OF MATRIX  HR.
*  IO  IND(MM)  ARRAY CONTAINING ORDERS OF BLOCKS.
*  RI  DEL1  TOLERANCE 1.
*  RI  DEL2  TOLERANCE 2.
*  RI  DEL3  TOLERANCE 3.
*  IO  NL  NUMBER OF BLOCKS.
*  IU  LS  TYPE OF UPDATE.
*
* SUBPROGRAMS USED :
*  S  UXELVS  TEST OF SYMMETRY AND OTHER PROPERTIES OF MATRIX.
*  S  UXELVP  TEST OF POSITIVE DEFINITENESS BY  RDR^T  FACTORIZATION.
*  S  UUVLVC  COMPUTATION OF  Y^T . HH: . Y,  WHERE  HH:  IS THE LAST
*             BUT ONE VARIABLE METRIC AUXILIARY MATRIX.
*
      SUBROUTINE UUVLVT(M,MM,XR,XRP,HR,GR,DR,IND,DEL1,DEL2,DEL3,NL,LS)
      INTEGER J,LD,LQ,LS,M,MM,IND(MM),N,NL,ML
      REAL*8 DR(M),XR(MM,MM),XRP(MM,MM),HR(M*(M+1)/2),GR(M*(M+1)/2)
      REAL*8 ADD,B,BS,BST,DEL1,DEL2,DEL3, BH,Q,W
      LOGICAL L
      ML=M
      DO NL=1,M
        IF(NL.EQ.1)CALL UXELVS(ML,MM,XR,DEL1,Q,W,N)
        IF(NL.GT.1)CALL UXELVS(ML,MM,XR,DEL3,Q,W,N)
C   blok.test poz.definit. S^T.Y rozkladem RL, BS=Tr(S^T.Y) pro glob. konverg.
        BS=0.0D 0
        DO J=ML-N+1,ML
          BS=BS+XR(J,J)
        END DO
        CALL UXELVP(ML,MM,XR,HR,IND(NL),N,BS)
        LD=IND(NL)
        IF(NL.EQ.1.AND.LD.GT.2.AND.Q.LT.ABS(DEL2))THEN
          LQ=M
          CALL UUVLVC(M,MM,LD,XR,HR,GR,XRP,DR,B,BST,ADD)
          BH=B-XR(ML-1,ML)*XR(ML,ML-1)/XR(ML-1,ML-1)
          IF(W.GT.1.0D-3.OR.BH/B.GT.0.5D 0)LS=0
          L=(1.0D 0-BST/B)*ABS(1.0D 0-ADD/BST).GT.1.0D 0.AND.
     &    B/BST.GT.1.5D 0
          IF(L.OR.BST/B.LT.2D-2.OR.W.LT.1.0D-10)LQ=0
          IF(LQ.GT.0.AND.LS.EQ.0)N=1
          IF(LQ.GT.0.AND.LS.NE.0)LS=LS+LS
        END IF
        IND(NL)=N
        ML=ML-N
        IF(ML.LE.0)EXIT
      END DO
      RETURN
      END
