* SUBROUTINE UXBSBD                ALL SYSTEMS                93/12/01
C PORTABILITY : ALL SYSTEMS
C 93/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF A BLOCKED SYMMETRIC MATRIX A BY A VECTOR X.
*
* PARAMETERS :
* PARAMETERS :
*  II  L  BLOCK DIMENSION.
*  II  N  VECTOR DIMENSION.
*  RI  ABL(L*(L+1)/2)  VALUES OF NONZERO ELEMENTS OF THE GIVEN BLOCK.
*  II  JBL(L)  INDICES OF THE INDIVIDUAL BLOCKS
*  RI  X(N)  UNPACKED INPUT VECTOR.
*  RI  ALF   SCALING FACTOR.
*  RI  Y(N)  UNPACKED INPUT VECTOR.
*  RI  Z(N)  UNPACKED OR PACKED OUTPUT VECTOR EQUAL TO A*X+ALF*Y.
*  II  JOB  FORM OF THE VECTOR X. JOB=1-UNPACKED FORM. JOB=2-PACKED
*         FORM.
*
      SUBROUTINE UXBSBD(L,N,ABL,JBL,X,ALF,Y,Z,JOB)
      INTEGER L,N,JBL(L),JOB
      REAL*8 ABL(L*(L+1)/2),X(N),ALF,Y(N),Z(*)
      INTEGER I,J,IP,JP,K
      REAL*8 TEMP,POM
      REAL*8 ZERO
      PARAMETER  (ZERO = 0.0D 0)
      DO 1 I=1,L
      IP=JBL(I)
      IF (JOB.EQ.1) THEN
      Z(IP)=Y(IP)
      ELSE
      Z(I)=Y(IP)
      ENDIF
   1  CONTINUE
      K=0
      DO 4 I=1,L
      IP=JBL(I)
      TEMP=X(IP)
      IF (JOB.EQ.1) THEN
      DO 2 J=1,I-1
      JP=JBL(J)
      K=K+1
      IF (IP.GT.0.AND.JP.GT.0) THEN
      POM=ALF*ABL(K)
      Z(IP)=Z(IP)+POM*X(JP)
      Z(JP)=Z(JP)+POM*TEMP
      ENDIF
    2 CONTINUE
      K=K+1
      IF (IP.GT.0) Z(IP)=Z(IP)+ALF*ABL(K)*TEMP
      ELSE
      DO 3 J=1,I-1
      JP=JBL(J)
      K=K+1
      IF (IP.GT.0.AND.JP.GT.0) THEN
      POM=ALF*ABL(K)
      Z(I)=Z(I)+POM*X(JP)
      Z(J)=Z(J)+POM*TEMP
      ENDIF
    3 CONTINUE
      K=K+1
      IF (IP.GT.0) Z(I)=Z(I)+ALF*ABL(K)*TEMP
      ENDIF
    4 CONTINUE
      RETURN
      END
