* SUBROUTINE UXBSBM                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF A BLOCKED SYMMETRIC MATRIX A BY A VECTOR X.
*
* PARAMETERS :
* PARAMETERS :
*  II  L  BLOCK DIMENSION.
*  II  N  VECTOR DIMENSION.
*  RI  ABL(L*(L+1)/2)  VALUES OF NONZERO ELEMENTS OF THE GIVEN BLOCK.
*  II  JBL(L)  INDICES OF THE INDIVIDUAL BLOCKS
*  RI  X(N)  UNPACKED INPUT VECTOR.
*  RI  Y(N)  UNPACKED OR PACKED OUTPUT VECTOR EQUAL TO A*X.
*  II  JOB  FORM OF THE VECTOR Y. JOB=1-UNPACKED FORM. JOB=2-PACKED
*         FORM.
*
      SUBROUTINE UXBSBM(L,N,ABL,JBL,X,Y,JOB)
      INTEGER L,N,JBL(L),JOB
      REAL*8 ABL(L*(L+1)/2),X(N),Y(*)
      INTEGER I,J,IP,JP,K
      REAL*8 TEMP
      REAL*8 ZERO
      PARAMETER  (ZERO = 0.0D 0)
      DO 1 I=1,L
      IP=JBL(I)
      IF (IP.GT.0) THEN
      IF (JOB.EQ.1) THEN
      Y(IP)=ZERO
      ELSE
      Y(I)=ZERO
      ENDIF
      ENDIF
   1  CONTINUE
      K=0
      DO 4 I=1,L
      IP=JBL(I)
      IF (IP.GT.0) TEMP=X(IP)
      IF (JOB.EQ.1) THEN
      DO 2 J=1,I-1
      JP=JBL(J)
      K=K+1
      IF (IP.GT.0.AND.JP.GT.0) THEN
      Y(IP)=Y(IP)+ABL(K)*X(JP)
      Y(JP)=Y(JP)+ABL(K)*TEMP
      ENDIF
    2 CONTINUE
      K=K+1
      IF (IP.GT.0) Y(IP)=Y(IP)+ABL(K)*TEMP
      ELSE
      DO 3 J=1,I-1
      JP=JBL(J)
      K=K+1
      IF (IP.GT.0.AND.JP.GT.0) THEN
      Y(I)=Y(I)+ABL(K)*X(JP)
      Y(J)=Y(J)+ABL(K)*TEMP
      ENDIF
    3 CONTINUE
      K=K+1
      IF (IP.GT.0) Y(I)=Y(I)+ABL(K)*TEMP
      ENDIF
    4 CONTINUE
      RETURN
      END
