* SUBROUTINE UXBSDC                ALL SYSTEMS                93/12/01
C PORTABILITY : ALL SYSTEMS
C 93/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* THE DIAGONAL OF A BLOCKED SYMMETRIC MATRIX A IS COPIED INTO THE VECTOR X.
*
* PARAMETERS :
*  II  N  MATRIX DIMENSION.
*  II  NBLA  DIMENSION OF THE ARRAY ABL.
*  II  NBLKS  NUMBER OF BLOCKS OF THE MATRIX.
*  II  NBLJ  DIMENSION OF THE ARRAY JBL.
*  RI  ABL(NBLA)  VALUES OF THE NONZERO ELEMENTS OF THE MATRIX.
*  II  IBLBG(NBLKS+1)  BEGINNINGS OF THE BLOCKS IN THE MATRIX.
*  II  JBL(NBLJ)  INDICES OF THE INDIVIDUAL BLOCKS
*  RO  X(N)  OUTPUT VECTOR CONTAINING DIAGONAL OF THE BLOCKED SYMMETRIC
*         MATRIX.
*
      SUBROUTINE UXBSDC(N,NBLA,NBLKS,NBLJ,ABL,IBLBG,JBL,X)
      INTEGER N,NBLKS,NBLJ,NBLA,IBLBG(NBLKS+1),JBL(NBLJ)
      REAL*8 ABL(NBLA),X(N)
      INTEGER I,J,K,L,KBEG,KLEN
      REAL*8 ZERO
      PARAMETER  (ZERO = 0.0D 0)
      DO 1 I=1,N
      X(I)=ZERO
   1  CONTINUE
      K=0
      DO 4 I=1,NBLKS
         KBEG=IBLBG(I)
         KLEN=IBLBG(I+1)-KBEG
         DO 3 L=1,KLEN
            K=K+L
            J=JBL(KBEG)
            X(J)=X(J)+ABL(K)
            KBEG=KBEG+1
    3    CONTINUE
    4 CONTINUE
      RETURN
      END
