* SUBROUTINE UXDGGU                ALL SYSTEMS                16/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* RANK ONE UPDATE OF FACTORIZATION A*P=L*U OBTAINED BY THE SUBROUTINE
* UXDGGF.
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX A.
*  RU  A(N*N) THE FACTORIZATION A*P=L*U COMPUTED BY THE SUBROUTINE
*         UXDGGF.
*  II  IA(N) A PERMUTATION FIELD WHICH CONTAINS AN INFORMATION ABOUT
*         PERMUTATION MATRIX P.
*  RU  X(N) INPUT VECTOR.
*  RU  Y(N) INPUT VECTOR.
*  RA  Z(N) AUXILIARY VECTOR.
*  IO  INF INDICATOR. INF=0 - CORRECT COMPUTATION. INF=1 - DIVISION BY
*         ZERO.
*
* METHOD :
* BACK SUBSTITUTION.
*
      SUBROUTINE UXDGGU(N,A,IA,X,Y,Z,INF)
      INTEGER N,IA(N),INF
      REAL*8 A(N*N),X(N),Y(N),Z(N)
      INTEGER J,K,KP
      CALL UXVGFP(N,IA,X,Z)
      DO 3 K=1,N
      KP=IA(K)
      DO 1 J=1,K-1
      X(K)=X(K)-A(KP+J)*X(J)
      A(KP+J)=A(KP+J)+X(K)*Y(J)
    1 CONTINUE
      INF=1
      A(KP+K)=A(KP+K)+X(K)*Y(K)
      IF (A(KP+K).EQ.0.0D 0) RETURN
      INF=0
      Y(K)=Y(K)/A(KP+K)
      DO 2 J=K+1,N
      A(KP+J)=A(KP+J)+X(K)*Y(J)
      Y(J)=Y(J)-A(KP+J)*Y(K)
    2 CONTINUE
    3 CONTINUE
      RETURN
      END
