* SUBROUTINE UXDGLU                ALL SYSTEMS                16/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* RANK ONE UPDATE OF FACTORIZATION A=P*L*U OBTAINED BY THE SUBROUTINE
* UXDGGB.
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX A.
*  RU  A(N,N) THE FACTORIZATION A=P*L*U COMPUTED BY THE SUBROUTINE
*         UXDGLF.
*  IO  IA(N) A PERMUTATION FIELD WHICH CONTAINS AN INFORMATION ABOUT
*         PERMUTATION MATRIX P.
*  RU  X(N) INPUT VECTOR.
*  RU  Y(N) INPUT VECTOR.
*  IO  INF INDICATOR. INF=0 - CORRECT COMPUTATION. INF=1 - DIVISION BY
*         ZERO.
*
* METHOD :
* BACK SUBSTITUTION.
*
      SUBROUTINE UXDGLU(N,A,IA,X,Y,INF)
      INTEGER N,IA(N),INF
      REAL*8 A(N,N),X(N),Y(N)
      INTEGER J,K
      CALL DLASWP(1,X,N,1,N,IA,1)
      DO 3 K=1,N
      DO 1 J=1,K-1
      X(K)=X(K)-A(K,J)*X(J)
      A(K,J)=A(K,J)+X(K)*Y(J)
    1 CONTINUE
      INF=1
      A(K,K)=A(K,K)+X(K)*Y(K)
      IF (A(K,K).EQ.0.0D 0) RETURN
      INF=0
      Y(K)=Y(K)/A(K,K)
      DO 2 J=K+1,N
      A(K,J)=A(K,J)+X(K)*Y(J)
      Y(J)=Y(J)-A(K,J)*Y(K)
    2 CONTINUE
    3 CONTINUE
      RETURN
      END
