* SUBROUTINE UXDLGQ                ALL SYSTEMS                15/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE NUMBER UXDLGQ=TRANS(X)*D*X WHERE D IS A
* DIAGONAL MATRIX IN THE FACTORIZATION  A+E=P*U*D*TRANS(U)*TRANS(P)
* OBTAINED BY THE SUBROUTINE UXDLGF.
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX A.
*  RI  A(N*(N+1)/2) FACTORIZATION A+E=P*L*D*TRANS(L)*TRANS(P) OBTAINED
*         BY THE SUBROUTINE UXDSGF.
*  II  IA(N)  A PERMUTATION FIELD WHICH CONTAINS AN INFORMATION ABOUT
*         PERMUTATION MATRIX P.
*  RI  X(N)  INPUT VECTOR.
*  RR  UXDLGQ  COMPUTED NUMBER UXDLGQ=TRANS(X)*D*X.
*
      FUNCTION UXDLGQ(N,A,IA,X)
      INTEGER N,IA(N)
      REAL*8 A(N*(N+1)/2),X(N)
      INTEGER K, KD, KP
      REAL*8 TEMP, UXDLGQ
      K = N
      KD = N*( N+1 ) / 2
      TEMP = 0.0D 0
   10 CONTINUE
      KP = IA(K)
      IF( KP.NE.K ) CALL UNSWAP(X(K),X(KP))
      TEMP = TEMP + X(K)*X(K)*A(KD)
      KD = KD - K
      K = K - 1
      IF (K.GE.1) GOTO 10
      UXDLGQ = TEMP
      RETURN
      END
