* SUBROUTINE UXDRCF               ALL SYSTEMS                07/12/01
C PORTABILITY : ALL SYSTEMS
C 07/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* FORWARD PART OF THE STRANG FORMULA FOR PREMULTIPLICATION OF
* THE VECTOR X BY AN IMPLICIT BFGS UPDATE.
*
* PARAMETERS :
*  II  N  NUMBER OF ROWS OF THE MATRICES A AND B.
*  II  M  NUMBER OF COLUMNS OF THE MATRICES A AND B.
*  RI  A(N*M)  RECTANGULAR MATRIX STORED AS A ONE-DIMENSIONAL ARRAY.
*  RI  B(N*M)  RECTANGULAR MATRIX STORED AS A ONE-DIMENSIONAL ARRAY.
*  RI  U(M)  VECTOR OF SCALAR COEFFICIENTS.
*  RI  V(M)  VECTOR OF SCALAR COEFFICIENTS.
*  RU  X(N)  PREMULTIPLIED VECTOR.
*  II  IX(N)  VECTOR CONTAINING TYPES OF BOUNDS.
*  II  JOB  OPTION. IF JOB.GT.0 THEN INDEX I IS NOT USED WHENEVER
*         IX(I).LE.-1. IF JOB.LT.0 THEN INDEX I IS NOT USED WHENEVER
*         IX(I).EQ.-5.
*
* SUBPROGRAM USED :
*  S   UXUDIR  VECTOR AUGMENTED BY THE SCALED VECTOR.
*  RF  UXUDOT  DOT PRODUCT OF VECTORS.
*
* METHOD :
* H.MATTHIES, G.STRANG: THE SOLUTION OF NONLINEAR FINITE ELEMENT
* EQUATIONS. INT.J.NUMER. METHODS ENGN. 14 (1979) 1613-1626.
*
      SUBROUTINE UXDRCF(N,M,A,B,U,V,X,IX,JOB)
      INTEGER N,M,IX(N),JOB
      REAL*8 A(N*M),B(N*M),U(M),V(M),X(N)
      REAL*8 TEMP,UXUDOT
      INTEGER I,K
      K=(M-1)*N+1
      DO 1 I=M,1,-1
      TEMP=U(I)*UXUDOT(N,X,B(K),IX,JOB)
      CALL UXUDIR(N,V(I)-TEMP,A(K),X,X,IX,JOB)
      K=K-N
    1 CONTINUE
      RETURN
      END
