* SUBROUTINE UXDRHB               ALL SYSTEMS                93/12/01
C PORTABILITY : ALL SYSTEMS
C 93/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* VECTOR B IS PREMULTIPLIED BY THE ORTHOGONAL MATRIX TRANS(Q) AFTER QR
* DECOMPOSITION.
*
* PARAMETERS :
*  II  N  NUMBER OF COLUMNS OF THE MATRIX A.
*  II  M  NUMBER OF ROWS OF THE MATRIX A.
*  RI  A(M*N)  RECTANGULAR MATRIX STORED ROWWISE IN THE
*         ONE-DIMENSIONAL ARRAY.
*  II  IA(N)  A PERMUTATION FIELD WHICH CONTAINS AN INFORMATION ABOUT
*         PERMUTATION MATRIX.
*  RU  B(M)  ON INPUT THE RIGHT HAND SIDE. ON OUTPUT THE TRANSFORMED
*         RIGHT HAND SIDE.
*  RO  D(N)  VECTOR CONTAINING INFORMATION ABOUT HOUSEHOLDER
*         TRANSFORMATIONS.
*  IO  NM  ASSUMED RANK OF THE MATRIX A.
*
      SUBROUTINE UXDRHB(N,M,A,IA,B,D,NM)
      INTEGER N,M,IA(N),NM
      REAL*8 A(M*N),B(M),D(N)
      REAL*8 POM
      INTEGER J,K,L,LL,KP
      L=0
      DO 3 K=1,NM
      KP=IA(K)
      POM=D(KP)*B(K)
      LL=L
      DO 1 J=K+1,M
      LL=LL+N
      POM=POM+A(LL+KP)*B(J)
    1 CONTINUE
      B(K)=B(K)-POM
      POM=POM/D(KP)
      LL=L
      DO 2 J=K+1,M
      LL=LL+N
      B(J)=B(J)-POM*A(LL+KP)
    2 CONTINUE
      L=L+N
    3 CONTINUE
      RETURN
      END
