* SUBROUTINE UXDRMU               ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* UPDATE OF A ROWWISE STORED DENSE RECTANGULAR MATRIX A. THIS MATRIX
* IS UPDATED BY THE RULE A:=A+ALF*X*TRANS(Y).
*
* PARAMETERS :
*  II  N  NUMBER OF COLUMNS OF THE MATRIX A.
*  II  M  NUMBER OF ROWS OF THE MATRIX A.
*  RU  A(M*N)  RECTANGULAR MATRIX STORED ROWWISE IN THE
*         ONE-DIMENSIONAL ARRAY.
*  RI  ALF  SCALAR PARAMETER.
*  RI  X(M)  INPUT VECTOR.
*  RI  Y(N)  INPUT VECTOR.
*
      SUBROUTINE UXDRMU(N,M,A,ALF,X,Y)
      INTEGER N,M
      REAL*8 A(M*N),ALF,X(M),Y(N)
      REAL*8 TEMP
      INTEGER I,J,K
      K=0
      DO 2 J=1,M
      TEMP=ALF*X(J)
      DO 1 I=1,N
      A(K+I)=A(K+I)+TEMP*Y(I)
    1 CONTINUE
      K=K+N
    2 CONTINUE
      RETURN
      END
