* SUBROUTINE UXDRTB                ALL SYSTEMS               16/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  TRANSFORMATION OF SOLUTION OBTAINED FROM THE TOTAL QR DECOMPOSITION.
*
* PARAMETERS :
*  II  N  NUMBER OF COLUMNS OF THE MATRIX A.
*  II  M  NUMBER OF ROWS OF THE MATRIX A.
*  RU  A(M*N)  RECTANGULAR MATRIX STORED ROWWISE IN THE
*         ONE-DIMENSIONAL ARRAY.
*  IO  IA(N)  A PERMUTATION FIELD WHICH CONTAINS AN INFORMATION ABOUT
*         PERMUTATION MATRIX.
*  RO  D(N)  VECTOR CONTAINING INFORMATION ABOUT HOUSEHOLDER
*         TRANSFORMATIONS.
*  RU  X(N)  SOLUTION VECTOR.
*  II  NP  PSAUDORANK OF THE MATRIX A.
*
      SUBROUTINE UXDRTB(N,M,A,IA,X,D,NP)
      INTEGER N,M,IA(N),NP
      REAL*8 A(M*N),D(N),X(N)
      REAL*8 POM
      REAL*8 ZERO
      PARAMETER (ZERO=0.0D 0)
      INTEGER J,K,L,JP,KP
      IF (NP.LT.N) THEN
      L=0
      DO 6 K=1,NP
      KP=IA(K)
      POM=D(KP)*X(KP)
      DO 4 J=NP+1,N
      JP=IA(J)
      POM=POM+A(L+JP)*X(JP)
    4 CONTINUE
      X(KP)=X(KP)-POM
      POM=POM/D(KP)
      DO 5 J=NP+1,N
      JP=IA(J)
      X(JP)=X(JP)-POM*A(L+JP)
    5 CONTINUE
      L=L+N
    6 CONTINUE
      ENDIF
      RETURN
      END
