* SUBROUTINE UXDSMD                ALL SYSTEMS                93/12/01
C PORTABILITY : ALL SYSTEMS
C 93/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF A DENSE SYMMETRIC MATRIX A BY A VECTOR X
* AND ADDITION OF A SCALED VECTOR ALF*Y.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  RI  A(N*(N+1)/2)  DENSE SYMMETRIC MATRIX STORED IN THE PACKED FORM.
*  RI  X(N)  INPUT VECTOR.
*  RI  ALF  SCALING FACTOR.
*  RI  Y(N)  INPUT VECTOR.
*  RO  Z(N)  OUTPUT VECTOR EQUAL TO A*X+ALF*Y.
*
      SUBROUTINE UXDSMD(N,A,X,ALF,Y,Z)
      INTEGER N
      REAL*8  A(N*(N+1)/2),X(N),ALF,Y(N),Z(N)
      REAL*8 TEMP
      INTEGER  I,J,K,L
      K=0
      DO  3  I = 1, N
      TEMP = ALF*Y(I)
      L=K
      DO  1  J = 1, I
      L=L+1
      TEMP = TEMP + A(L) * X(J)
    1 CONTINUE
      DO  2  J = I+1, N
      L=L+J-1
      TEMP = TEMP + A(L) * X(J)
    2 CONTINUE
      Z(I)=TEMP
      K=K+I
    3 CONTINUE
      RETURN
      END
