* SUBROUTINE UXDSMW                ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* UPDATE OF A DENSE SYMMETRIC MATRIX A. THIS UPDATE IS A MEMBER OF
* THE DENNIS CLASS.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  RU  A(N*(N+1)/2)  DENSE SYMMETRIC MATRIX STORED IN THE PACKED FORM.
*  RI  X(N)  VECTORS OF VARIABLES DIFFERENCE.
*  RI  Y(N)  VECTOR IN THE CORRECTION TERM.
*  RI  Z(N)  VECTOR IN THE CORRECTION TERM.
*
      SUBROUTINE UXDSMW( N, A, X, Y, Z)
      INTEGER N
      REAL*8  A(N*(N+1)/2), X(N), Y(N), Z(N)
      REAL*8 TEMP, TEMP1, UXVDOT
      INTEGER I, J, K
      REAL*8 ZERO, ONE
      PARAMETER (ZERO = 0.0D 0, ONE = 1.0D 0)
      TEMP = UXVDOT( N, X, Z)
      IF (TEMP.EQ.ZERO) RETURN
      CALL UXVSCL( N, ONE/TEMP, Z, Z)
      TEMP = UXVDOT( N, X, Y)
      K = 0
      DO 2 I = 1, N
      TEMP1 = TEMP * Z(I)
      DO 1 J = 1, I
      K = K + 1
      A(K) = A(K) + Y(I) * Z(J) + Z(I) * Y(J) - TEMP1 * Z(J)
    1 CONTINUE
    2 CONTINUE
      RETURN
      END
