* SUBROUTINE UXECRC                ALL SYSTEMS                16/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* CORRECTION OF A SINGULAR DENSE SYMMETRIC POSITIVE SEMIDEFINITE MATRIX
* A DECOMPOSED AS A=TRANS(R)*R.
*
* PARAMETERS :
*  II  N  NUMBER OF COLUMNS OF THE MATRIX A.
*  II  M  NUMBER OF ROWS OF THE MATRIX A.
*  RU  A(M,N)  UPPER TRIANGULAR MATRIX STORED COLUMNWISE IN THE
*         TWO-DIMENSIONAL ARRAY.
*  IO  INF  AN INFORMATION OBTAINED IN THE CORRECTION PROCESS. IF
*         INF=0 THEN A IS SUFFICIENTLY POSITIVE DEFINITE. IF
*         INF<0 THEN A IS NOT SUFFICIENTLY POSITIVE DEFINITE.
*  RI  TOL  DESIRED TOLERANCE FOR POSITIVE DEFINITENESS.
*
      SUBROUTINE UXECRC(N,M,A,INF,TOL)
      INTEGER N,M,INF
      REAL*8  A(M,N),TOL
      REAL*8 TOL1,TEMP
      INTEGER I,K
      REAL*8 ZERO
      PARAMETER (ZERO=0.0D 0)
      INF=0
      TOL1=SQRT(TOL)
      TEMP=TOL1
      DO 4 K=1,N
      DO 3 I=K,N
      TEMP=MAX(TEMP,ABS(A(K,I)))
    3 CONTINUE
    4 CONTINUE
      TEMP=TEMP*TOL1
      DO 1 K=1,N
      IF (ABS(A(K,K)).LE.TEMP) THEN
      A(K,K)=SIGN(TEMP,A(K,K))
      INF=-1
      ENDIF
    1 CONTINUE
      RETURN
      END
