* SUBROUTINE UXEGGF                ALL SYSTEMS                94/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* FACTORIZATION A=P*L*U OF A DENSE GENERAL MATRIX A WHERE P IS A
* PERMUTATION MATRIX, L IS A LOWER TRIANGULAR MATRIX AND U IA AN
* UPPER TRIANGULAR MATRIX.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  II  ND  DECLARED ORDER OF THE MATRIX A.
*  RU  A(ND,N)  ON INPUT A GIVEN GENERAL MATRIX STORED AS A
*         TWO-DIMENSIONAL ARRAY. ON OUTPUT THE COMPUTED FACTORIZATION
*         A=P*L*U.
*  IO  IP(N)  A PERMUTATION FIELD WHICH CONTAINS AN INFORMATION ABOUT
*         THE PERMUTATION MATRIX P.
*  IO  IER  ON INPUT THE CHOICE OF THE ZERO PIVOT CHANGE. IF IER=0 - ZERO
*         PIVOT TERMINATES COMPUTATION. IER=
*  AN INFORMATION OBTAINED IN THE FACTORIZATION PROCESS. IF
*         INF=0 THEN A IS NONSINGULAR. IF INF>0 THEN A IS SINGULAR.
*
* METHOD :
* C.B.MOLER, ALGORITHM 423, LINEAR EQUATION SOLVER, C.A.C.M. 15 (1972),
* P. 274.
*
      SUBROUTINE UXEGGF(N,ND,A,IP,IER,TOL)
      INTEGER N,ND,IP(N),IER,K,KP1,M,I,J
      REAL*8 A(ND,N),TOL,T,ZERO,ONE
      PARAMETER (ZERO=0.0D 0,ONE=1.0D 0)
      IER = 0
      DO 60 K = 1,N
      KP1 = K + 1
      M = K
      DO 10 I = KP1,N
      IF (ABS(A(I,K)) .GT. ABS(A(M,K))) M = I
 10   CONTINUE
      IP(K) = M
      IF (M .NE. K) THEN
      DO 20 I = 1,N
      T = A(M,I)
      A(M,I) = A(K,I)
      A(K,I) = T
 20   CONTINUE
      ENDIF
      IF (A(K,K) .EQ. ZERO) THEN
      IF (TOL .EQ. ZERO) THEN
      IER=-K
      RETURN
      ENDIF
      A(K,K) = TOL
      IF (IER .EQ. 0) IER = K
      ENDIF
      T = ONE/A(K,K)
      DO 30 I = KP1,N
      A(I,K) = A(I,K)*T
 30   CONTINUE
      DO 50 J = KP1,N
      T = A(K,J)
      IF (T .NE. ZERO) THEN
      DO 40 I = KP1,N
      A(I,J) = A(I,J) - A(I,K)*T
 40   CONTINUE
      ENDIF
 50   CONTINUE
 60   CONTINUE
      RETURN
      END
