* SUBROUTINE UXELVP                ALL SYSTEMS                31/12/16
C PORTABILITY : ALL SYSTEMS
C 31/12/16 VL :                                       ORIGINAL VERSION
*
* PURPOSE :
* TEST OF POSITIVE DEFINITENESS BY  RDR^T  FACTORIZATION.
*
* PARAMETERS :
*  II  M  NUMBER OF COLUMNS OF MATRICES XM, GM.
*  II  MM  MAXIMUM NUMBER OF COLUMNS OF MATRICES XM, GM.
*  RI  XR(MM,MM)  MATRIX  XM^T . GM .
*  RO  HR(M*(M+1)/2)  UPPER TRIANGULAR MATRIX  R  STORED COLUMNWISE.
*  IO  LD  RESULTANT ORDER OF THE CURRENT BLOCK.
*  IU  N  PRELIMINARY ORDER OF THE CURRENT BLOCK.
*  RI  BS  TOLERANCE PARAMETER FOR GLOBAL CONVERGENCE.
*
      SUBROUTINE UXELVP(M,MM,XR,HR,LD,N,BS)
      INTEGER LD,M,MM, I,J,K,L,MD,N
      REAL*8 XR(MM,MM),HR(M*(M+1)/2),BS
C   vlastni test poz.definitnosti mat. S^T.Y   R.D^-1.R^T rozkladem
      L=0
      DO J=1,M
        HR(L+1:L+J)=XR(:J,J)+XR(J,:J)
        L=L+J
      END DO
      DO LD=1,N-1
        MD=M-LD
        DO J=M-1,MD,-1
          L=J*(J-1)/2+MD
          DO I=M,J+1,-1
            K=I*(I-1)/2
            HR(L)=HR(L)-HR(K+MD)*HR(K+J)/HR(K+I)
          END DO
        END DO
        IF(HR(L).LE.BS*1.0D-6)N=LD
        IF(HR(L).LE.BS*1.0D-6)RETURN
      END DO
      LD=N
      RETURN
      END
