* SUBROUTINE UXEPRM                ALL SYSTEMS                16/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF A GIVEN VECTOR X BY A DENSE SYMMETRIC POSITIVE
* DEFINITE MATRIX A USING THE FACTORIZATION A=TRANS(R)*R.
*
* PARAMETERS :
*  II  N  NUMBER OF COLUMNS OF THE MATRIX A.
*  II  M  NUMBER OF ROWS OF THE MATRIX A.
*  RI  A(M,N) UPPER TRIANGULAR MATRIX IN THE DECOMPOSITION A = Q R
*         STORED COLUMNWISE IN THE TWO DIMENSIONAL ARRAY A.
*  RU  X(N)  ON INPUT THE GIVEN VECTOR. ON OUTPUT THE RESULT OF
*         MULTIPLICATION.
*  II  JOB  OPTION. IF JOB=0 THEN X:=A*X. IF JOB>0 THEN X:=R*X.
*         IF JOB<0 THEN X:=TRANS(R)*X.
*
      SUBROUTINE UXEPRM(N,M,A,X,JOB)
      INTEGER N,M,JOB
      REAL*8 A(M,N),X(N)
      INTEGER I,J
      REAL*8 TEMP
      REAL*8 ZERO
      PARAMETER (ZERO=0.0D 0)
      IF (JOB.GE.0) THEN
C
C     PHASE 1 : X:=R*X
C
      DO 3 I=1,N
      IF (X(I).NE.ZERO) THEN
      TEMP=X(I)
      DO 2 J=1,I-1
      X(J)=X(J)+A(J,I)*TEMP
    2 CONTINUE
      X(I)=A(I,I)*X(I)
      ENDIF
    3 CONTINUE
      ENDIF
      IF (JOB.LE.0) THEN
C
C     PHASE 2 : X:=TRANS(R)*X
C
      DO 6 I = N,1,-1
      TEMP=A(I,I)*X(I)
      DO 5 J=I-1,1,-1
      TEMP=TEMP+A(J,I)*X(J)
    5 CONTINUE
      X(I)=TEMP
    6 CONTINUE
      ENDIF
      RETURN
      END
