* SUBROUTINE UXSGF1                 ALL SYSTEMS                95/12/01
C PORTABILITY : ALL SYSTEMS
C 95/12/01 DA : ORIGINAL VERSION
*
* PURPOSE :
* AUXILIARY SUBROUTINE FOR UXSGDF FROM UMFPACK.
*
      SUBROUTINE UXSGF1(LU,AINDC,AINDR,AVALUE,XX,II,ERROR,
     & MMEM,XGAR,LUPAT,PERMR,PERMC,LUBLP,ABLKP,LUP,
     & AOFFP,AOFFI,NB,NPIV,AN,ANZ,ANZ2,ANZOFF,
     & ABLKS,LUNS,ABSPT,PMIN,
     & NINVLD,TRANS)
      INTEGER AN,ANZ,ABLKS,LUNS,ANZOFF,AINDC(ANZ),AINDR(ANZ),II(*),
     & LU(2,2),MMEM(7,2),LUPAT(*),PERMR(AN),PERMC(AN),
     & LUBLP(ABLKS+1),ABLKP(ABLKS+1),LUP(LUNS),ERROR,
     & NIL,AOFFI(*),NB,NPIV,ANZ2,
     & ARRSIZ,AIP,AXP,LUTXPP,WMP,WIP,R,C,ANZOF2,
     & AOFFXP,TCOLXP,TCOLIP,TCOLPP,AROW2P,TLENP,ACOL2P,
     & P,SIZE,INBLKP,POSP,APIVPP,NINVLD,
     & TLEN2P,AOF2P,AOFFP(AN+1),XGAR
      LOGICAL TRANS
      REAL*8 AVALUE(ANZ),XX(*),ABSPT,PMIN
      PARAMETER (NIL = 0, R = 1, C = 2)
C
C     SET INITIAL STUB FOR NUMERICAL LU FACTORS
C
      CALL UXIGET(MMEM,ERROR,2,0,1,LU(1,2))
      IF (ERROR .NE. 0) GOTO 997
      IF (LU (1,2) .EQ. NIL) GOTO 999
      IF (LU (1,2) .NE. 1) GOTO 997
C
C     ALLOCATE AOFFXP
C
      CALL UXIGET(MMEM,ERROR,2,ANZOFF,1,AOFFXP)
      IF (ERROR .NE. 0) GOTO 997
      IF (AOFFXP .EQ. NIL) GOTO 999
      IF (AOFFXP .NE. 1) GOTO 997
C
C     ALLOCATE WORKSPACE NEEDED FOR RE-FACTORIZATION
C
      SIZE = 3*AN+LUNS+1
      CALL UXIGET(MMEM,ERROR,1,SIZE,2,P)
      IF (ERROR .NE. 0) GOTO 997
      IF (P .EQ. NIL) GOTO 998
      WIP = P
      P = P + (2*AN)
      LUTXPP = P
      P = P + (LUNS)
      WMP = P
      P = P + (AN+1)
C
C     CONVERT TO TEMPORARY COLUMN-ORIENTED FORM, REMOVE DUPLICATES,
C     ENTIRES BELOW DROP TOLERANCE, AND CHECK FOR INVALID ENTRIES
C
      CALL UXIGET(MMEM,ERROR,2,ANZ,1,TCOLXP)
      IF (ERROR .NE. 0) GOTO 997
      IF (TCOLXP .EQ. NIL) GOTO 999
      CALL UXIGET(MMEM,ERROR,1,ANZ,1,TCOLIP)
      IF (ERROR .NE. 0) GOTO 997
      IF (TCOLIP .EQ. NIL) GOTO 998
      TCOLPP = WMP
      AROW2P = WIP
      TLENP  = WIP
      ACOL2P = WIP + AN
      SIZE = 2*AN
      IF (ABLKS .GT. 1) SIZE = SIZE + AN
      CALL UXIGET(MMEM,ERROR,1,SIZE,1,P)
      IF (ERROR .NE. 0) GOTO 997
      IF (P .EQ. NIL) GOTO 998
      INBLKP = P
      POSP   = P
      TLEN2P = P+AN
      APIVPP = P+AN
      AOF2P  = P+2*AN
      CALL UXSGF6(AVALUE,AINDC,AINDR,AN,ANZ,ANZ2,
     & II(TLENP),II(TCOLPP),II(TCOLIP),
     & XX(TCOLXP),II(POSP),TRANS,
     & NINVLD)
      IF (NINVLD .NE. 0) GOTO 996
C
C     COUNT THE NONZEROS IN TCOLI/X/P, FOR ARROWHEAD FORM AND AOFFI/P/X
C
      CALL UXSGF3(II(TCOLPP),II(TCOLIP),II(TLEN2P),
     & II(AROW2P),II(ACOL2P),II(INBLKP),PERMR,PERMC,
     & ABLKP,AN,ABLKS,ARRSIZ,ANZOF2,NINVLD,AOFFP)
      IF (NINVLD .NE. 0 .OR. ANZOF2 .GT. ANZOFF) GOTO 996
C
C     ALLOCATE AND STORE THE ARROWHEAD FORM AND AOFFI/P/X
C
      CALL UXIGET(MMEM,ERROR,1,ARRSIZ,2,AIP)
      IF (ERROR .NE. 0) GOTO 997
      IF (AIP .EQ. NIL) GOTO 998
      CALL UXIGET(MMEM,ERROR,2,ARRSIZ,2,AXP)
      IF (ERROR .NE. 0) GOTO 997
      IF (AXP .EQ. NIL) GOTO 999
      CALL UXSGF4(II(TCOLPP),II(TCOLIP),XX(TCOLXP),II(AROW2P),
     & II(ACOL2P),II(INBLKP),II(APIVPP),II(AIP),
     & XX(AXP),PERMR,PERMC,AN,ANZ,ARRSIZ,
     & II(AOF2P),AOFFP,AOFFI,XX(AOFFXP),ABLKS)
C
C     DEALLOCATE TCOLI/X, AND 2*AN or 3*AN TEMPORARY STORAGE IN II
C
      CALL UXIFRE(MMEM,ERROR,1,SIZE+ANZ,TCOLIP)
      IF (ERROR .NE. 0) GOTO 997
      CALL UXIFRE(MMEM,ERROR,2,ANZ,TCOLXP)
      IF (ERROR .NE. 0) GOTO 997
C
C     FACTORIZATION
C
      CALL UXSGF2(LU,ERROR,XX,II,LUPAT,PERMR,PERMC,LUBLP,
     & ABLKP,LUP,II(WMP),II(LUTXPP),II(WIP),
     & II(WIP+AN),MMEM,NB,NPIV,AN,NINVLD,ABLKS,
     & LUNS,ABSPT,PMIN,XGAR,AIP,AXP)
      IF (ERROR .NE. 0) RETURN
      RETURN
C
C     ERROR CONDITIONS
C
  999 ERROR = 66
      CALL UOERR1('UXSGF1',ERROR)
      RETURN
  998 ERROR = 65
      CALL UOERR1('UXSGF1',ERROR)
      RETURN
  997 ERROR = 64
      CALL UOERR1('UXSGF1',ERROR)
      RETURN
  996 ERROR = 63
      CALL UOERR1('UXSGF1',ERROR)
      RETURN
      END
