* SUBROUTINE UXSGF2                 ALL SYSTEMS                95/12/01
C PORTABILITY : ALL SYSTEMS
C 95/12/01 DA : ORIGINAL VERSION
*
* PURPOSE :
* AUXILIARY SUBROUTINE FOR UXSGDF FROM UMFPACK.
*
      SUBROUTINE UXSGF2(LU,ERROR,XX,II,LUPAT,PERMR,PERMC,
     & LUBLP,ABLKP,LUP,WM,LUTXP,WIR,WIC,MMEM,
     & NB,NPIV,AN,NINVLD,ABLKS,LUNS,ABSPT,PMIN,XGAR,
     & AIP, AXP)
      INTEGER AN,ABLKS,LUNS,LUPAT(*),PERMR(AN),PERMC(AN),
     & LUBLP(ABLKS+1),ABLKP(ABLKS+1),NIL,R,C,LUP(LUNS),
     & AXP,AIP,NINVLD,WM(AN+1),LUTXP(LUNS),
     & WIR(AN),WIC(AN),II(*),MMEM (7,2),KLU,SLU,
     & KFIRST,KLAST,ERROR,LU(2,2),P,KBLOCK,KSIZE,I,J,
     & FRDEGR,FRDEGC,FRXP,FRIPR,FRIPC,FFLEFR,FFLEFC,K,
     & LUAXP,XDP,XSP,COL,K1,K0,FFDEGR,FFDEGC,FFP,
     & FFIPR,FFIPC,FFIP(2),FFXP,FFDIMR,FFDIMC,EP,ARIP,
     & ARXP,SAVE1(2,2),NSON,DEGR,DEGC,FFNODE,FFSONP,
     & XDRP,XDCP,SON,NB,NPIV,GARBAG(2,2),S,UIP,
     & NODE,LIP,OLD,NEW,MARK(2,2),XGAR
      LOGICAL SGLTON, ALLROW, ALLCOL
      REAL*8 XX(*),VALUE,ABSPT,PMIN,ONE
      PARAMETER (NIL = 0, R = 1, C = 2, ONE = 1.0)
        PMIN = 0.0
        NPIV = 0
        KLU = 0
        ARIP = AIP
        ARXP = AXP
        DO 9020 I = 1, AN
           WIR (I) = -1
           WIC (I) = -1
9020       CONTINUE
C
C     FACTOR EACH BLOCK
C
        DO 9000 KBLOCK = 1, ABLKS
        KFIRST = ABLKP (KBLOCK)
        KLAST  = ABLKP (KBLOCK+1) - 1
        IF (KFIRST .EQ. KLAST) THEN
C
C     SINGLETON BLOCK
C
           SLU = LUBLP (KBLOCK)
           FFP = LUP (SLU)
           COL = KFIRST
           LUPAT(FFP) = NIL
           VALUE = XX(ARXP + 1)
           ARIP = ARIP + 2
           ARXP = ARXP + 2
C
C     DEALLOCATE THE USED ARROWHEAD STRUCTURE FOR A
C     (NO FRONTAL MATRICES ON STACK)
C
           SAVE1 (1,1) = MMEM (1,1)
           SAVE1 (1,2) = MMEM (1,2)
           SAVE1 (2,1) = ARIP
           SAVE1 (2,2) = ARXP
           CALL UXIRST (MMEM, ERROR, SAVE1, 2)
           IF (ERROR .NE. 0) GOTO 998
           CALL UXIRST (MMEM, ERROR, SAVE1, 1)
           IF (ERROR .NE. 0) GOTO 998
C
C     ALLOCATE PERMANENT SPACE FOR THE NUMERICAL LU ARROWHEAD
C
           CALL UXIGET (MMEM,ERROR, 2, 1, 1, LUAXP)
           IF (ERROR .NE. 0) GOTO 998
           IF (LUAXP .EQ. NIL) GOTO 997
C
C     STORE THE PIVOT ELEMENT
C
           XX (LUAXP) = VALUE
           IF (ABS (VALUE) .GT. ABSPT) THEN
              NPIV = NPIV + 1
C
C     FLAG THIS AS A GOOD PIVOT
C
              WIC (COL) = 0
C
C     KEEP TRACK OF THE SMALLEST PIVOT ENTRY
C
              IF (PMIN .EQ. 0.0) THEN
                 PMIN = ABS (VALUE)
              ELSE
                 PMIN = MIN (PMIN, ABS (VALUE))
                 ENDIF
           ELSE
C
C     THIS BLOCK IS STRUCTURALLY SINGULAR
C
              ENDIF
C
C     SAVE POINTERS TO LU ARROWHEAD (PIVOT COLUMN)
C
           LUTXP (SLU) = LUAXP
           WIR (SLU) = 0
        ELSE
C
C     OTHERWISE - BLOCK IS LARGER THAN ONE-BY-ONE
C
        KSIZE  = KLAST - KFIRST + 1
        KLU = KFIRST - 1
C
C     FACTOR A SINGLE BLOCK
C
        DO 1000 SLU = LUBLP (KBLOCK), LUBLP (KBLOCK+1) - 1
        FFP = LUP (SLU)
        FFNODE = LUPAT((FFP)+1)
        FFLEFR = LUPAT((FFP)+2)
        FFLEFC = LUPAT((FFP)+3)
        FFDEGR = FFLEFR + FFNODE
        FFDEGC = FFLEFC + FFNODE
        FFIPR = ((FFP)+5+LUPAT((FFP)+3))
        FFIPC = ((FFP)+5)
        FFIP (R) = FFIPR
        FFIP (C) = FFIPC
        FFSONP = ((FFP)+5+LUPAT((FFP)+2)+LUPAT((FFP)+3))
C
C     ALLOCATE SPACE ON STACK FOR THE FRONTAL MATRIX
C
        FFDIMR = FFDEGR
        FFDIMC = FFDEGC
        CALL UXIGET (MMEM,ERROR,
     &          2, FFDIMC * FFDIMR, 1, FFXP)
        IF (ERROR .NE. 0) GOTO 998
        IF (FFXP .EQ. NIL) THEN
           GARBAG(2,2) = ARXP + 1
           XGAR = XGAR + 1
           CALL UXSGF5 (XX, MMEM, LUPAT, LUBLP(KBLOCK), LUP, SLU,
     &                  ERROR, GARBAG
     &                  )
           IF (ERROR .NE. 0) GOTO 998
           CALL UXIGET (MMEM,ERROR,
     &          2, FFDIMC * FFDIMR, 1, FFXP)
           IF (ERROR .NE. 0) GOTO 998
           IF (FFXP .EQ. NIL) GOTO 997
           ENDIF
        DO 500 XDP = FFXP, FFXP + (FFDEGR * FFDEGC) - 1
500        XX (XDP) = 0.0
C
C     COMPUTE PIVOT ROW AND COLUMN OFFSETS
C     AT THIS POINT, WI(KLU+1,...,KLAST,RC) = -1
C
        DO 773 I = 1, FFNODE
           WIR (KLU+I) = (I - 1)
           WIC (KLU+I) = (I - 1) * FFDIMC
773        CONTINUE
        DO 774 I = 1, FFLEFC
           WIR (LUPAT(FFIPC+(I)-1)) = I - 1 + FFNODE
774        CONTINUE
        DO 775 I = 1, FFLEFR
           WIC (LUPAT(FFIPR+(I)-1)) = (I - 1 + FFNODE) * FFDIMC
775        CONTINUE
C
C     ASSEMBLE THE ORIGINAL ENTRIES FROM THE ARROWHEAD DATA STRUCTURE
C
        XDRP = FFXP
        XDCP = FFXP
        DO 400 K = 1, FFNODE
           DEGR = II(ARIP)
           ARIP = ARIP + 1
           ARXP = ARXP + 1
           DEGC = II(ARIP)
           XX (XDCP+K-1) = XX(ARXP)
           ARIP = ARIP + 1
           ARXP = ARXP + 1
           DO 410 J = 1, DEGR
              I = WIC (II(ARIP))
              IF (I .LT. 0) THEN
                 NINVLD = NINVLD + 1
              ELSE
                 XX (XDRP + I) = XX(ARXP)
                 ENDIF
              ARIP = ARIP + 1
              ARXP = ARXP + 1
410           CONTINUE
           DO 420 J = 1, DEGC
              I = WIR (II(ARIP))
              IF (I .LT. 0) THEN
                 NINVLD = NINVLD + 1
              ELSE
                 XX (XDCP + I) = XX(ARXP)
                 ENDIF
              ARIP = ARIP + 1
              ARXP = ARXP + 1
420           CONTINUE
           XDRP = XDRP + 1
           XDCP = XDCP + FFDEGC
400        CONTINUE
        IF (NINVLD .NE. 0) GOTO 996
C
C     ASSEMBLE THE SONS
C
        DO 310 NSON = 1, LUPAT((FFP)+4)
           SON = LUPAT(FFSONP+(NSON)-1)
           IF (SON .GT. 0) THEN
C
C     THIS IS AN LU-SON
C
              EP = LUP (SON)
              FRXP = LUPAT(EP)
              FRDEGR = LUPAT((EP)+2)
              FRDEGC = LUPAT((EP)+3)
              FRIPC = ((EP)+5)
              FRIPR = ((EP)+5+LUPAT((EP)+3))
              ALLROW = WIR (SON) .EQ. 0 .OR. WIR (SON) .EQ. 1
              ALLCOL = WIR (SON) .EQ. 0 .OR. WIR (SON) .EQ. 2
C
C     (NO NEED TO UPDATE WIR(SON), SINCE THIS ELEMENT WON'T
C     BE REFERRED TO AGAIN) WIR(SON) = 3
C
              IF (ALLROW) THEN
C
C     NO ROWS ASSEMBLED OUT OF THIS FRONTAL YET
C
C
C     COMPUTE THE COMPRESSED COLUMN OFFSET VECTOR
C
                 DO 10 I = 1, FRDEGC
                    WM (I) = WIR (LUPAT(FRIPC+(I)-1))
10                  CONTINUE
                 IF (ALLCOL) THEN
C
C     NO ROWS OR COLUMNS ASSEMBLED OUT OF FRONTAL YET
C
                    DO 30 J = 1, FRDEGR
                       XSP = FRXP
                       XDP = FFXP + WIC (LUPAT(FRIPR+(J)-1))
                       DO 20 I = 1, FRDEGC
                          XX(XDP+WM(I)) =
     &                    XX(XDP+WM(I)) + XX (XSP)
                          XSP = XSP + 1
20                        CONTINUE
                       FRXP = FRXP + FRDEGC
30                     CONTINUE
                ELSE
C
C     ONLY COLUMNS HAVE BEEN ASSEMBLED OUT OF FRONTAL
C
                    DO 50 J = 1, FRDEGR
                       IF (LUPAT(FRIPR+(J)-1) .GT. 0) THEN
                          XSP = FRXP
                          XDP = FFXP + WIC (LUPAT(FRIPR+(J)-1))
                          DO 40 I = 1, FRDEGC
                             XX (XDP+WM(I)) =
     &                       XX (XDP+WM(I)) + XX (XSP)
                             XSP = XSP + 1
40                           CONTINUE
                          ENDIF
                       FRXP = FRXP + FRDEGC
50                     CONTINUE
                    ENDIF
              ELSE
C
C     SOME ROWS HAVE BEEN ASSEMBLED OUT OF THIS FRONTAL
C
C
C     COMPUTE THE COMPRESSED COLUMN OFFSET VECTOR
C
                 DO 60 I = 1, FRDEGC
                    IF (LUPAT(FRIPC+(I)-1) .GT. 0) THEN
                       WM (I) = WIR (LUPAT(FRIPC+(I)-1))
                    ELSE
                       WM (I) = -1
                       ENDIF
60                  CONTINUE
                 IF (ALLCOL) THEN
C
C     ONLY ROWS ASSEMBLED OUT OF DIS FRONTAL
C
                    DO 80 J = 1, FRDEGR
                       XSP = FRXP
                       XDP = FFXP + WIC (LUPAT(FRIPR+(J)-1))
                       DO 70 I = 1, FRDEGC
                          IF (WM (I) .GE. 0) THEN
                             XX (XDP+WM(I)) =
     &                       XX (XDP+WM(I)) + XX (XSP)
                             ENDIF
                          XSP = XSP + 1
70                        CONTINUE
                       FRXP = FRXP + FRDEGC
80                     CONTINUE
                 ELSE
C
C     BOTH ROWS AND COLUMNS ASSEMBLED OUT OF FRONTAL
C
                    DO 100 J = 1, FRDEGR
                       IF (LUPAT(FRIPR+(J)-1) .GT. 0) THEN
                          XSP = FRXP
                          XDP = FFXP + WIC (LUPAT(FRIPR+(J)-1))
                          DO 90 I = 1, FRDEGC
                             IF (WM (I) .GE. 0) THEN
                                XX (XDP+WM(I)) =
     &                          XX (XDP+WM(I)) + XX (XSP)
                                ENDIF
                             XSP = XSP + 1
90                           CONTINUE
                          ENDIF
                       FRXP = FRXP + FRDEGC
100                    CONTINUE
                    ENDIF
                 ENDIF
C
C     DEALLOCATE THE FRONTAL MATRIX
C
              CALL UXIFRE (MMEM,ERROR,2,
     &                  FRDEGR*FRDEGC, LUPAT(EP))
              IF (ERROR .NE. 0) GOTO 998
              LUPAT(EP) = NIL
           ELSE IF (SON .GE. -AN) THEN
              SON = -SON
C
C     THIS IS AN L-SON
C
              EP = LUP (SON)
              FRXP = LUPAT(EP)
              FRDEGR = LUPAT((EP)+2)
              FRDEGC = LUPAT((EP)+3)
              FRIPC = ((EP)+5)
              FRIPR = ((EP)+5+LUPAT((EP)+3))
              ALLROW = WIR (SON) .EQ. 0 .OR. WIR (SON) .EQ. 1
              ALLCOL = WIR (SON) .EQ. 0 .OR. WIR (SON) .EQ. 2
              IF (ALLCOL) THEN
C
C     NO COLUMNS ASSEMBLED OUT OF THIS FRONTAL YET
C
C
C     COMPUTE THE COMPRESSED ROW OFFSET VECTOR
C
                 DO 110 J = 1, FRDEGR
                    WM (J) = WIC (LUPAT(FRIPR+(J)-1))
110                 CONTINUE
                 IF (ALLROW) THEN
C
C     NO ROWS OR COLUMNS ASSEMBLED OUT OF FRONTAL YET
C
C
C     FLAG THIS FRONT - SOME ROWS ASSEMBLED HERE, NO COLUMNS
C     (WIR(SON) WAS 0, IS NOW 2)
C
                    WIR (SON) = 2
                    DO 130 I = 1, FRDEGC
                       IF (WIR (LUPAT(FRIPC+(I)-1)) .GE. 0) THEN
                          XSP = FRXP
                          XDP = FFXP + WIR (LUPAT(FRIPC+(I)-1))
                          LUPAT(FRIPC+(I)-1) = -LUPAT(FRIPC+(I)-1)
                          DO 120 J = 1, FRDEGR
                             XX(XDP+WM(J)) =
     &                       XX(XDP+WM(J)) + XX (XSP)
                             XSP = XSP + FRDEGC
120                          CONTINUE
                          ENDIF
                       FRXP = FRXP + 1
130                    CONTINUE
                 ELSE
C
C     ONLY ROWS HAVE BEEN ASSEMBLED OUT OF FRONTAL
C
                    DO 150 I = 1, FRDEGC
                       IF (LUPAT(FRIPC+(I)-1) .GT. 0) THEN
                          IF (WIR (LUPAT(FRIPC+(I)-1)) .GE. 0) THEN
                             XSP = FRXP
                             XDP = FFXP + WIR (LUPAT(FRIPC+(I)-1))
                             LUPAT(FRIPC+(I)-1) = -LUPAT(FRIPC+(I)-1)
                             DO 140 J = 1, FRDEGR
                                XX (XDP+WM(J)) =
     &                          XX (XDP+WM(J)) + XX (XSP)
                                XSP = XSP + FRDEGC
140                             CONTINUE
                             ENDIF
                          ENDIF
                       FRXP = FRXP + 1
150                    CONTINUE
                    ENDIF
              ELSE
C
C     SOME COLUMNS HAVE BEEN ASSEMBLED OUT OF THIS FRONTAL
C
C
C     COMPUTE THE COMPRESSED ROW OFFSET VECTOR
C
                 DO 160 J = 1, FRDEGR
                    IF (LUPAT(FRIPR+(J)-1) .GT. 0) THEN
                       WM (J) = WIC (LUPAT(FRIPR+(J)-1))
                    ELSE
                       WM (J) = -1
                       ENDIF
160                 CONTINUE
                 IF (ALLROW) THEN
C
C     ONLY COLUMNS ASSEMBLED OUT OF THIS FRONTAL
C
C
C     FLAG THIS FRONT - SOME ROWS ASSEMBLED HERE, SOME COLUMN
C     (WIR(SON) WAS 1, IS NOW 3)
C
                    WIR (SON) = 3
                    DO 180 I = 1, FRDEGC
                       IF (WIR (LUPAT(FRIPC+(I)-1)) .GE. 0) THEN
                          XSP = FRXP
                          XDP = FFXP + WIR (LUPAT(FRIPC+(I)-1))
                          LUPAT(FRIPC+(I)-1) = -LUPAT(FRIPC+(I)-1)
                          DO 170 J = 1, FRDEGR
                             IF (WM (J) .GE. 0) THEN
                                XX (XDP+WM(J)) =
     &                          XX (XDP+WM(J)) + XX (XSP)
                                ENDIF
                             XSP = XSP + FRDEGC
170                          CONTINUE
                          ENDIF
                       FRXP = FRXP + 1
180                    CONTINUE
                 ELSE
C
C     BOTH ROWS AND COLUMNS ASSEMBLED OUT OF FRONTAL
C
                    DO 200 I = 1, FRDEGC
                       IF (LUPAT(FRIPC+(I)-1) .GT. 0) THEN
                          IF (WIR (LUPAT(FRIPC+(I)-1)) .GE. 0) THEN
                             XSP = FRXP
                             XDP = FFXP + WIR (LUPAT(FRIPC+(I)-1))
                             LUPAT(FRIPC+(I)-1) = -LUPAT(FRIPC+(I)-1)
                             DO 190 J = 1, FRDEGR
                                IF (WM (J) .GE. 0) THEN
                                   XX (XDP+WM(J)) =
     &                             XX (XDP+WM(J)) + XX (XSP)
                                   ENDIF
                                XSP = XSP + FRDEGC
190                             CONTINUE
                             ENDIF
                          ENDIF
                       FRXP = FRXP + 1
200                    CONTINUE
                    ENDIF
                 ENDIF
           ELSE
              SON = -(SON+AN)
C
C     THIS IS A U-SON
C
              EP = LUP (SON)
              FRXP = LUPAT(EP)
              FRDEGR = LUPAT((EP)+2)
              FRDEGC = LUPAT((EP)+3)
              FRIPC = ((EP)+5)
              FRIPR = ((EP)+5+LUPAT((EP)+3))
              ALLROW = WIR (SON) .EQ. 0 .OR. WIR (SON) .EQ. 1
              ALLCOL = WIR (SON) .EQ. 0 .OR. WIR (SON) .EQ. 2
              IF (ALLROW) THEN
C
C     NO ROWES ASSEMBLED OUT OF THIS FRONTAL YET
C
C
C     COMPUTE THE COMPRESSED COLUMN OFFSET VECTOR
C
                 DO 210 I = 1, FRDEGC
                    WM (I) = WIR (LUPAT(FRIPC+(I)-1))
210                 CONTINUE
                 IF (ALLCOL) THEN
C
C     NO ROWS OR COLUMNS ASSEMBLED OUT OF FRONTAL YET
C
C
C     FLAG THIS FRONT - SOME COLUMNS ASSEMBLED HERE, NO ROWS
C     (WIR(SON) WAS 0, IS NOW 1)
C
                    WIR (SON) = 1
                    DO 230 J = 1, FRDEGR
                       IF (WIC (LUPAT(FRIPR+(J)-1)) .GE. 0) THEN
                          XSP = FRXP
                          XDP = FFXP + WIC (LUPAT(FRIPR+(J)-1))
                          LUPAT(FRIPR+(J)-1) = -LUPAT(FRIPR+(J)-1)
                          DO 220 I = 1, FRDEGC
                             XX(XDP+WM(I)) =
     &                       XX(XDP+WM(I)) + XX (XSP)
                             XSP = XSP + 1
220                          CONTINUE
                          ENDIF
                       FRXP = FRXP + FRDEGC
230                    CONTINUE
                 ELSE
C
C     ONLY COLUMNS HAVE BEEN ASSEMBLED OUT OF FRONTAL
C
                    DO 250 J = 1, FRDEGR
                       IF (LUPAT(FRIPR+(J)-1) .GT. 0) THEN
                          IF (WIC (LUPAT(FRIPR+(J)-1)) .GE. 0) THEN
                             XSP = FRXP
                             XDP = FFXP + WIC (LUPAT(FRIPR+(J)-1))
                             LUPAT(FRIPR+(J)-1) = -LUPAT(FRIPR+(J)-1)
                             DO 240 I = 1, FRDEGC
                                XX (XDP+WM(I)) =
     &                          XX (XDP+WM(I)) + XX (XSP)
                                XSP = XSP + 1
240                             CONTINUE
                             ENDIF
                          ENDIF
                       FRXP = FRXP + FRDEGC
250                    CONTINUE
                    ENDIF
              ELSE
C
C     SOME ROWS HAVE BEEN ASSEMBLED OUT OF THIS FRONTAL
C
C
C     COMPUTE THE COMPRESSED COLUMN OFFSET VECTOR
C
                 DO 260 I = 1, FRDEGC
                    IF (LUPAT(FRIPC+(I)-1) .GT. 0) THEN
                       WM (I) = WIR (LUPAT(FRIPC+(I)-1))
                    ELSE
                       WM (I) = -1
                       ENDIF
260                 CONTINUE
                 IF (ALLCOL) THEN
C
C     ONLY ROWS ASSEMBLED OUT OF THIS FRONTAL
C
C
C     FLAG THIS FRONT - SOME COLUMNS ASSEMBLED, SOME ROWS
C     (WIR(SON) WAS 2, IS NOW 3)
C
                    WIR (SON) = 3
                    DO 280 J = 1, FRDEGR
                       IF (WIC (LUPAT(FRIPR+(J)-1)) .GE. 0) THEN
                          XSP = FRXP
                          XDP = FFXP + WIC (LUPAT(FRIPR+(J)-1))
                          LUPAT(FRIPR+(J)-1) = -LUPAT(FRIPR+(J)-1)
                          DO 270 I = 1, FRDEGC
                             IF (WM (I) .GE. 0) THEN
                                XX (XDP+WM(I)) =
     &                          XX (XDP+WM(I)) + XX (XSP)
                                ENDIF
                             XSP = XSP + 1
270                          CONTINUE
                          ENDIF
                       FRXP = FRXP + FRDEGC
280                    CONTINUE
                 ELSE
C
C     BOTH ROWS AND COLUMNS ASSEMBLED OUT OF FRONTAL
C
                    DO 300 J = 1, FRDEGR
                       IF (LUPAT(FRIPR+(J)-1) .GT. 0) THEN
                          IF (WIC (LUPAT(FRIPR+(J)-1)) .GE. 0) THEN
                             XSP = FRXP
                             XDP = FFXP + WIC (LUPAT(FRIPR+(J)-1))
                             LUPAT(FRIPR+(J)-1) = -LUPAT(FRIPR+(J)-1)
                             DO 290 I = 1, FRDEGC
                                IF (WM (I) .GE. 0) THEN
                                   XX (XDP+WM(I)) =
     &                             XX (XDP+WM(I)) + XX (XSP)
                                   ENDIF
                                XSP = XSP + 1
290                             CONTINUE
                             ENDIF
                          ENDIF
                       FRXP = FRXP + FRDEGC
300                    CONTINUE
                    ENDIF
                 ENDIF
              ENDIF
310        CONTINUE
C
C     FLAG THIS NODE AS UNASSEMBLED
C
C
        WIR (SLU) = 0
C
C     CLEAR THE PIVOT ROW AND COLUMN OFFSETS
C
        DO 340 I = 1, FFLEFC
           WIR (LUPAT(FFIPC+(I)-1)) = -1
340        CONTINUE
        DO 350 I = 1, FFLEFR
           WIC (LUPAT(FFIPR+(I)-1)) = -1
350        CONTINUE
C
C     FACTORIZE THE FRONTAL MATRIX
C
        K0 = 0
        DO 320 K = 1, FFNODE
C
C     SCALE CURRENT PIVOT COLUMN (COLUMN K OF THE CURRENT
C     FRONTAL MATRIX)
C
        K1 = K + 1
        IF (ABS (XX(FFXP+((K)-1)+((K)-1)*FFDIMC)) .GT. ABSPT) THEN
           NPIV = NPIV + 1
C
C     FLAG THIS AS A GOOD PIVOT
C
           WIC (KLU+K) = 0
           CALL UXVSCL
     &          (FFDEGC-K, ONE/XX(FFXP+((K)-1)+((K)-1)*FFDIMC),
     &          XX(FFXP+((K1)-1)+((K)-1)*FFDIMC),
     &          XX(FFXP+((K1)-1)+((K)-1)*FFDIMC))
C
C     KEEP TRACK OF THE SMALLEST PIVOT ENTRY
C
           IF (PMIN .EQ. 0.0) THEN
              PMIN = ABS (XX(FFXP+((K)-1)+((K)-1)*FFDIMC))
           ELSE
              PMIN = MIN (PMIN, ABS (XX(FFXP+((K)-1)+((K)-1)*FFDIMC)))
              ENDIF
        ELSE
           WIC (KLU+K) = -1
           ENDIF
C
C     ONE MORE PIVOT STEP HAS BEEN COMPLETED
C
C
C     IF THE NUMBER OF PIVOTS IS GETTING LARGE, UPDATE
C     CONTRIBUTION BLOCK
C
        IF (MOD (K, NB) .EQ. 0) THEN
C
C     PERFORM BLOCK UPDATE TO CONTRIBUTION BLOCK
C
           CALL UXEGMM
     &          (FFDEGC-K, FFDEGR-K, K-K0, -ONE,
     &          XX(FFXP+((K1)-1)+((   K0+1)-1)*FFDIMC), FFDIMC,
     &          XX(FFXP+((K0+1)-1)+((   K1)-1)*FFDIMC), FFDIMC,
     &          ONE,
     &          XX(FFXP+((K1)-1)+((     K1)-1)*FFDIMC), FFDIMC)
           K0 = K
           ENDIF
C
C     IF THIS IS THE LAST PIVOT, SKIP THE REST OF THE LOOP
C
        IF (K .LT. FFNODE) THEN
C
C     FACTOR THE NEXT PIVOT COLUMN (K+1)
C
C
C     UPDATE THE PIVOT COLUMN WITH PREVIOUS PIVOTS
C
        CALL UXEGMV
     &          (FFDEGC-K, K-K0, -ONE,
     &          XX(FFXP+((K1)-1)+((   K0+1)-1)*FFDIMC), FFDIMC,
     &          XX(FFXP+((K0+1)-1)+((   K1)-1)*FFDIMC), 1,
     &          ONE,
     &          XX(FFXP+((K1)-1)+((     K1)-1)*FFDIMC), 1, 0)
C
C     FACTOR THE NEXT PIVOT ROW (K+1)
C
C
C     UPDATE THE PIVOT ROW WITH PREVIOUS PIVOTS
C
        CALL UXEGMV
     &          (K-K0, FFDEGR-K-1, -ONE,
     &          XX(FFXP+((K0+1)-1)+((  K+2)-1)*FFDIMC), FFDIMC,
     &          XX(FFXP+((K1)-1)+((   K0+1)-1)*FFDIMC), FFDIMC,
     &          ONE,
     &          XX(FFXP+((K1)-1)+((    K+2)-1)*FFDIMC), FFDIMC, 1)
           ENDIF
320     CONTINUE
C
C     DONE FACTORING THE FIRST K ROWS/COLUMNS OF THE CURRENT
C     FRONTAL MATRIX
C
        SGLTON = FFLEFR .LE. 0 .OR. FFLEFC .LE. 0
        K = FFNODE
        KLU = KLU + K
        FRDEGC = FFLEFC
        IF (.NOT. SGLTON) THEN
           CALL UXEGMM
     &          (FFLEFC, FFLEFR, K-K0, -ONE,
     &          XX(FFXP+((K+1)-1)+(( K0+1)-1)*FFDIMC), FFDIMC,
     &          XX(FFXP+((K0+1)-1)+(( K+1)-1)*FFDIMC), FFDIMC,
     &          ONE,
     &          XX(FFXP+((K+1)-1)+((  K+1)-1)*FFDIMC), FFDIMC)
           ENDIF
C
C     ALLOCATE SPACE FOR THE NEW FRONTAL MATRIX AND LU ARROWHEAD.
C     CAN BE DONE IN PLACE IF NECESSARY.
C
        IF (.NOT. SGLTON) THEN
C
C     MOVE THE CONTRIBUTION BLOCK TO THE TAIL OF XX
C
           CALL UXIGET (MMEM,ERROR,
     &          2, FFLEFC * FFLEFR, 2, FRXP)
           IF (ERROR .NE. 0) GOTO 998
           IF (FRXP .EQ. NIL) THEN
              GARBAG(2,2) = ARXP + 1
              XGAR = XGAR + 1
              CALL UXSGF5 (XX, MMEM, LUPAT, LUBLP(KBLOCK), LUP, SLU,
     &                  ERROR, GARBAG)
              IF (ERROR .NE. 0) GOTO 998
              CALL UXIGET (MMEM,ERROR,
     &          2, FFLEFC * FFLEFR, 2, FRXP)
              IF (ERROR .NE. 0) GOTO 998
              IF (FRXP .EQ. NIL) GOTO 997
              ENDIF
           DO 460 J = 1, FFLEFR
              DO 460 I = 1, FFLEFC
                 XX(FRXP+((I)-1)+((J)-1)* FRDEGC) =
     &           XX(FFXP+((I+K)-1)+(( J+K)-1)*FFDIMC)
460              CONTINUE
           ENDIF
C
C     THE (L1\U1 AND L2) MATRIX IS ALREADY IN PLACE
C     LU ARROWHEAD GROWS ON TOP OF THE STACK.
C
        LUAXP = FFXP
        IF (.NOT. SGLTON) FFXP = FRXP
        XDP = LUAXP + K*FFDEGC
        XSP = XDP
C
C     MOVE THE U2 BLOCK.
C
        IF (FFLEFR .NE. 0) THEN
           DO 470 J = K+1, FFDEGR
              DO 480 I = 1, K
                 XX (XDP) = XX (XSP)
                 XDP = XDP + 1
                 XSP = XSP + 1
480              CONTINUE
              XSP = XSP + (FFDIMC - K)
470           CONTINUE
           ENDIF
C
C     DEALLOCATE STACK
        P = LUAXP + K*FFDEGC + K*FFDEGR - K*K
        IF (P .NE. MMEM (1,2)) THEN
           CALL UXIFRE (MMEM,ERROR,2,MMEM(1,2)-P,P)
           IF (ERROR .NE. 0) GOTO 998
           ENDIF
C
C     SAVE POINTER TO LU ARROWHEAD
C
        LUTXP (SLU) = LUAXP
C
C     FINALIZE THE SCALAR DATA FOR THR CURRENT FRONTAL MATRIX
C
        IF (SGLTON) THEN
C
C     FLAG THE NEW FRONTAL MATRIX AS ALREADY ASSEMBLED
C
           LUPAT(FFP)  = NIL
        ELSE
           LUPAT(FFP)  = FFXP
           ENDIF
1000    CONTINUE
C
C     SINGLE BLOCK FACTORED
C
C
C     DEALLOCATE THE USED ARROWHEAD STRUCTURE FOR A,
C     AND ALL FRONTAL MATRICES
C
        SAVE1 (1,1) = MMEM (1,1)
        SAVE1 (1,2) = MMEM (1,2)
        SAVE1 (2,1) = ARIP
        SAVE1 (2,2) = ARXP
        CALL UXIRST (MMEM, ERROR, SAVE1, 2)
        IF (ERROR .NE. 0) GOTO 998
        CALL UXIRST (MMEM, ERROR, SAVE1, 1)
        IF (ERROR .NE. 0) GOTO 998
        ENDIF
9000    CONTINUE
C
C     ALL BLOCKS FACTORED
C
C
C     WRAP-UP: STORE LU FACTORS IN THEIR FINAL FORM
C
C
C     FIX THE INDICES IN LU
C
        DO 810 S = 1, LUNS
           EP = LUP (S)
           LUPAT(EP) = LUTXP (S)
           NODE = LUPAT((EP)+1)
           LIP = ((EP)+5)
           UIP = ((EP)+5+LUPAT((EP)+3))
           FFSONP = ((EP)+5+LUPAT((EP)+2)+LUPAT((EP)+3))
           DO 820 P = LIP, LIP+LUPAT((EP)+3)-1
              LUPAT (P) = ABS (LUPAT (P))
820           CONTINUE
           DO 840 P = UIP, UIP+LUPAT((EP)+2)-1
              LUPAT (P) = ABS (LUPAT (P))
840           CONTINUE
810        CONTINUE
C
C     FLAG THE PERMUTATION VECTOR WITH BAD PIVOTS
C
        DO 850 OLD = 1, AN
           NEW = ABS (PERMR (OLD))
           IF (WIC (NEW) .EQ. 0) THEN
C
C     THIS IS A GOOD PIVOT ROW
C
              PERMR (OLD) = NEW
           ELSE
              PERMR (OLD) = -NEW
              ENDIF
           NEW = ABS (PERMC (OLD))
           IF (WIC (NEW) .EQ. 0) THEN
C
C     THIS IS A GOOD PIVOT COLUMN
C
              PERMC (OLD) = NEW
           ELSE
              PERMC (OLD) = -NEW
              ENDIF
850        CONTINUE
C
C     DEALLOCATE THE TAIL OF XX AND II
C
        MARK (1,1) = MMEM (1,1)
        MARK (1,2) = MMEM (1,2)
        MARK (2,1) = MMEM (4,1)
        MARK (2,2) = MMEM (4,2)
        CALL UXIRST (MMEM, ERROR, MARK, 1)
        IF (ERROR .NE. 0) GOTO 998
        CALL UXIRST (MMEM, ERROR, MARK, 2)
        IF (ERROR .NE. 0) GOTO 998
        LU (2,2) = MMEM (1,2)
        RETURN
C
C     ERROR CONDITIONS
C
  997 ERROR = 66
      CALL UOERR1('UXSGF2',ERROR)
      RETURN
  998 ERROR = 64
      CALL UOERR1('UXSGF2',ERROR)
      RETURN
  996 ERROR = 63
      CALL UOERR1('UXSGF2',ERROR)
      RETURN
      END
