* SUBROUTINE UXSGFG                 ALL SYSTEMS                90/12/01
C PORTABILITY : ALL SYSTEMS
C 90/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTING THE MAXIMUM ELEMENT IN THE UNFACTORIZED PART
* OF THE MATRIX THAT IS BEEING FACTORIZED.
*
* PARAMETERS :
*  II  N  NUMBER OF ROWS OF THE SPARSE MATRIX
*  II  M  NUMBER OF PROCESSED COLUMNS THAT FORM THE COLUMS OF THE MATRIX
*         THAT DESCRIBES THE ACTIVE SET. M <= N.
*  II  K  ITERATION NUMBER.
*  II  NAU SIZE OF THE ARRAY THAT STORES THE NUMERICAL ELEMENTS OF
*          THE PROCESSED MATRIX.
*  II  PTC(N) POINTER VECTOR FOR COLUMNS OF THE MATRIX.
*  II  LENC(N) LENGTHS OF THE COLUMNS.
*  II  LENCH(N) LENGTHS OF THE U-PART OF THE COLUMN.
*  II  ORDC(N)  VECTOR OF THE COLUMN ORDER.
*  RI  AU(NAU) ELEMENTS OF THE PROCESSED SPARSE MATRIX.
*  RO  AMX MAXIMUM ELEMENT IN THE UNFACTORIZED SUBMATRIX.
*
      SUBROUTINE UXSGFG(N,M,K,NAU,PTC,LENC,LENCH,ORDC,AU,AMX)
      INTEGER N,M,NAU,K
      INTEGER PTC(N),LENC(N),LENCH(N),ORDC(N)
      REAL*8 AU(NAU)
      REAL*8 AMX
      INTEGER I,J,J1,K1
C
      AMX=0
      DO 200 I=K+1,M
      J=ORDC(I)
      K1=PTC(J)
         DO 100 J1=K1+LENCH(J),K1+LENC(J)-1
         AMX=MAX(AMX,ABS(AU(J1)))
100      CONTINUE
200   CONTINUE
      RETURN
      END
