* SUBROUTINE UXSGFS                 ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* SETTING THE ORDER OF COLUMNS AND ROWS IN WHICH THEY WILL
* BE PROCESSED BY THE PIVOTING SUBROUTINE.
*
* PARAMETERS :
*  II  N  NUMBER OF ROWS OF THE SPARSE MATRIX
*  II  M  NUMBER OF PROCESSED COLUMNS THAT FORM THE COLUMS OF THE MATRIX
*         THAT DESCRIBES THE ACTIVE SET. M <= N.
*  II  P  NUMBER OF ACTIVE BOUNDS.
*  IO  LENC(N) LENGTHS OF THE COLUMNS.
*  IO  LENCH(N) LENGTHS OF THE U-PART OF THE COLUMN. IT IS NOW
*  II  LENR(N) LENGTHS OF THE ROWS OF THE FACTORIZED SPARSE MATRIX.
*  II  BCOL(N) NUMBERS OF THE COLUMNS CHOSEN FOR THE SPARSE
*              BASIS THAT IS BEEING FACTORIZED.
*               INITIALIZED TO THE ZERO.
*  IO  PORDR(N) INDEX VECTOR OF THE ROW ORDERING.
*  IO  ORDR(N) ORDER OF THE ROWS WHICH WILL BE FURTHER UPDATED.
*  IO  PORDC(N) INDEX VECTOR OF THE COLUMN ORDERING.
*  IO  ORDC(N) ORDER OF THE COLUMNS WHICH WILL BE FURTHER UPDATED.
*
      SUBROUTINE UXSGFS(N,M,P,LENC,LENCH,LENR,BCOL,PORDR,ORDR,PORDC,
     & ORDC,IJOB)
      INTEGER N,M,P,IJOB
      INTEGER LENC(N),LENCH(N),LENR(N)
      INTEGER PORDR(N),ORDR(N),PORDC(N),ORDC(N),BCOL(N)
      INTEGER I,J,K,LA,LB,LS,LT,IS,JS,LLS,MHALF,NHALF,NMINP
C
C     SET LENGTH INTO THE LENCH AND SET ORDC
C
      DO 100 I=1,M
      LENCH(I)=LENC(I)
      ORDC(I)=I
100   CONTINUE
C
C     SET ORDR
C
      DO 150 I=1,N
      ORDR(I)=I
150   CONTINUE
C
C     SORT THE LENGTHS
C     SHELLSORT OF THE ROW COUNTS
C
      MHALF=M/2
      LS=131071
      DO 400 LT=1,17
      IF(LS.GT.MHALF) THEN
                      LS=LS/2
                      GO TO 400
      END IF
      LLS=M-LS
            DO 300 I=1,LLS
            IS=I+LS
            LA=LENCH(IS)
            LB=ORDC(IS)
            J=I
            JS=IS
200         IF(LA.GE.LENCH(J)) THEN
                              LENCH(JS)=LA
                              ORDC(JS)=LB
                              GO TO 300
                              ELSE
                              LENCH(JS)=LENCH(J)
                              ORDC(JS)=ORDC(J)
                              JS=J
                              J=J-LS
            END IF
            IF(J.GE.1) GO TO 200
            LENCH(JS)=LA
            ORDC(JS)=LB
300         CONTINUE
      LS=LS/2
400   CONTINUE
C
C     CREATE PORDC
C
      I=0
      J=1
500   IF(J.GT.M) GO TO 700
      IF(LENCH(J).LE.I) THEN
                        J=J+1
                        GO TO 500
                        ELSE
                        DO 600 K=I+1,LENCH(J)
                        PORDC(K)=J
600                     CONTINUE
                        I=LENCH(J)
                        J=J+1
                        GO TO 500
      END IF
700   CONTINUE
      DO 800 K=LENCH(M)+1,N
      PORDC(K)=M+1
800   CONTINUE
C
C     ROW LENGTHS ARE PLACED INTO LENCH
C
      DO 900 I=1,N
      LENCH(I)=LENR(I)
900   CONTINUE
C
C     ROWS CORRESPONDING TO THE ACTIVE BOUNDS ARE HANDICAPPED
C
      DO 1000 I=M+1,M+P
      J=I
      IF (IJOB.NE.1) J=BCOL(I)
      LENCH(I)=LENCH(I)+N+1
1000  CONTINUE
C
C SHELL-SORT OF THE ROW COUNTS
C
      NHALF=N/2
      LS=131071
      DO 1300 LT=1,17
      IF(LS.GT.NHALF) THEN
                      LS=LS/2
                      GO TO 1300
      END IF
      LLS=N-LS
            DO 1200 I=1,LLS
            IS=I+LS
            LA=LENCH(IS)
            LB=ORDR(IS)
            J=I
            JS=IS
1100         IF(LA.GE.LENCH(J)) THEN
                              LENCH(JS)=LA
                              ORDR(JS)=LB
                              GO TO 1200
                              ELSE
                              LENCH(JS)=LENCH(J)
                              ORDR(JS)=ORDR(J)
                              JS=J
                              J=J-LS
            END IF
            IF(J.GE.1) GO TO 1100
            LENCH(JS)=LA
            ORDR(JS)=LB
1200         CONTINUE
      LS=LS/2
1300   CONTINUE
C
C     CREATE PORDR
C
      I=0
      J=1
      NMINP=N-P
1400  IF(J.GT.NMINP) GO TO 1600
      IF(LENCH(J).LE.I) THEN
                        J=J+1
                        GO TO 1400
                        ELSE
                        DO 1500 K=I+1,LENCH(J)
                        PORDR(K)=J
1500                    CONTINUE
                        I=LENCH(J)
                        J=J+1
                        GO TO 1400
      END IF
1600  CONTINUE
      DO 1700 K=LENCH(NMINP)+1,N
      PORDR(K)=NMINP+1
1700  CONTINUE
C
C     SET LENCH,LENCH
C
      DO 1800 I=1,M
      LENCH(I)=0
1800  CONTINUE
      RETURN
      END
