* SUBROUTINE  UXSGFV               ALL SYSTEMS               24/06/92
C PORTABILITY : ALL SYSTEMS
C 16/06/92 TU : ORIGINAL VERSION
*
* PURPOSE :  ROW TO COLUMN STRUCTURE TRANSFORMATION
*      FOR LU DECOMPOSITION. REALS OVERWRITTEN, POINTERS AND
*      INTEGERS SAVED.
*
*  PARAMETERS :
*  II  N  SIZE OF THE MATRIX.
*  II  MMAX LENGTH OF JA AND A.
*  IO  NJA NUMBER OF TRANSFORMED NONZEROS = JA(N+1)-1.
*  II  IA(N+1) POINTERS TO MATRIX ROWS.
*  II  JA(MMAX) COLUMN INDICES.
*  IO  IB(N+1) POINTERS TO MATRIX ROWS.
*  IO  JB(MMAX) COLUMN INDICES.
*  IU  A NUMERICAL VALUES OF THE MATRIX.
*  IA  WN01(M) AUXILIARY VECTOR.
*  IO  IER  INFORMATION OUTPUT.
*
      SUBROUTINE UXSGFV(N,MMAX,NJA,IA,JA,IB,JB,A,WN01,IER)
      INTEGER N,MMAX,NJA,IA(N+1),JA(NJA),IB(N+1),JB(NJA),IER
      REAL*8 A(MMAX)
      INTEGER WN01(N)
      INTEGER I,J,K,L
C
      NJA=IA(N+1)-1
C
C NO SPACE FOR TRANSFORMATION AVAILABLE.
C
      IER=1
      IF (2*NJA.GT.MMAX) RETURN
      IER=0
C
C   INITIATE WN01
C
      DO 50 I=1,N
        WN01(I) = 0
   50 CONTINUE
C
C NUMBER OF NONZEROS IN ROWS
C
      DO 100 I=1, NJA
        J=JA(I)
        WN01(J)=WN01(J) + 1
  100 CONTINUE
C
C FIND COLUMN POINTERS IB
C
      IB(1)=1
      DO 200 I=1,N
        IB(I+1)=IB(I)+WN01(I)
        WN01(I)=IB(I)-1
  200 CONTINUE
C
C MOVE INDICES AND VALUES.
C
      DO 300 I=1,N
        DO 400 J=IA(I),IA(I+1)-1
          K=JA(J)
          L=WN01(K)
          WN01(K)=L+1
          JB(L+1)=I
          A(NJA+L+1) = A(J)
  400   CONTINUE
  300 CONTINUE
C
C SHIFT VALUES
C
      DO 500 I=1,NJA
        A(I)=A(NJA+I)
 500  CONTINUE
C
      RETURN
      END
