* SUBROUTINE UXSGIB                ALL SYSTEMS                95/12/01
C PORTABILITY : ALL SYSTEMS
C 95/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SOLUTION OF A SYSTEM OF LINEAR EQUATIONS WITH A SPARSE UNSYMMETRIC
* MATRIX A USING INCOMPLETE FACTORIZATION OBTAINED BY THE SUBROUTINE
* UXSGIF.
*
* PARAMETERS :
*  II  N  MATRIX DIMENSION.
*  II  M  NUMBER OF MATRIX NONZERO ELEMENTS.
*  RU  A(M)  NONZERO ELEMENTS OF THE MATRIX A.
*  II  IA(N+1)  ROW POINTERS OF THE MATRIX A.
*  II  JA(M)  COLUMN INDICES OF THE MATRIX A.
*  IO  IP(N)  PERMUTATION VECTOR.
*  II  ID(N) INDICES OF DIAGONAL ELEMENTS.
*  RU  X(N)  ON INPUT THE RIGHT HAND SIDE OF A SYSTEM OF LINEAR
*         EQUATIONS. ON OUTPUT THE SOLUTION OF A SYSTEM OF LINEAR
*         EQUATIONS.
*  RA  Y(N)  AUXILIARY VECTOR.
*  JOB  OPTION. JOB=0 - SOLUTION WITH THE ORIGINAL MATRIX.
*         JOB=1 - SOLUTION WITH THE MATRIX TRANSPOSE.
*
      SUBROUTINE UXSGIB(N,M,A,IA,JA,IP,ID,X,Y,JOB)
      INTEGER N,M,IA(N+1),JA(M),IP(N),ID(N),JOB
      REAL*8 A(M),X(N),Y(N)
      INTEGER J,K,JJ,JP,KSTRT,KSTOP
      REAL*8 APOM,CON
      PARAMETER (CON=1.0D 120)
      IF (JOB.LE.0) THEN
      DO 2 K=1,N
      KSTRT=IA(K)
      KSTOP=IA(K+1)-1
      DO 1 JJ=KSTRT,KSTOP
      J=JA(JJ)
      JP=IP(J)
      IF (JP.LT.K) THEN
      X(K)=X(K)-A(JJ)*X(JP)
      IF (ABS(X(K)).GE.CON) X(K)=SIGN(CON,X(K))
      ENDIF
    1 CONTINUE
    2 CONTINUE
      DO 4 K=N,1,-1
      KSTRT=IA(K)
      KSTOP=IA(K+1)-1
      DO 3 JJ=KSTRT,KSTOP
      J=JA(JJ)
      JP=IP(J)
      IF (JP.GT.K) X(K)=X(K)-A(JJ)*X(JP)
      IF (JP.EQ.K) APOM=A(JJ)
    3 CONTINUE
      X(K)=X(K)/APOM
    4 CONTINUE
      CALL UXVSFP(N,IP,X,Y)
      ELSE
      CALL UXVSBP(N,IP,X,Y)
      DO 6 K=1,N
      X(K)=X(K)/A(ID(K))
      KSTRT=IA(K)
      KSTOP=IA(K+1)-1
      DO 5 JJ=KSTRT,KSTOP
      J=JA(JJ)
      JP=IP(J)
      IF (JP.GT.K) X(JP)=X(JP)-A(JJ)*X(K)
    5 CONTINUE
    6 CONTINUE
      DO 8 K=N,1,-1
      KSTRT=IA(K)
      KSTOP=IA(K+1)-1
      DO 7 JJ=KSTRT,KSTOP
      J=JA(JJ)
      JP=IP(J)
      IF (JP.LT.K) X(JP)=X(JP)-A(JJ)*X(K)
    7 CONTINUE
    8 CONTINUE
      ENDIF
      RETURN
      END
