* SUBROUTINE UXSGUA                 ALL SYSTEMS                90/12/01
C PORTABILITY : ALL SYSTEMS
C 90/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* ADDITIONAL PERMUTATIONS FINDING.
*
* PARAMETERS :
*  II  N  NUMBER OF ROWS OF THE SPARSE MATRIX
*  II  NZ SIZE OF THE INDEX ARRAY CNR
*  IU  PTR(N) POINTER VECTOR OF THE ROWS OF THE FACTOR U.
*  IU  LENR(N) LENGTHS OF THE ROWS OF THE FACTOR U.
*  IU  CNR(NZ) CONTAINS THE INDICES OF THE FACTORS.
*  IU  ORDR(N) ROW PERMUTATION OF THE FACTOR U.
*  IU  ORDC(N) COLUMN PERMUTATION OF THE FACTOR U.
*  IU  RIGHT(N) RIGHTMOST POSITION OF THE ROW SPIKE FOR BASIS.
*  IU  UP(N) UPPERMOST POSITION OF THE COLUMN SPIKE FOR BASIS.
*  RA  WR01(N) AUXILIARY VECTOR
*  RA  WR01(N) AUXILIARY VECTOR
*  IU  COLUP FIRST INDEX OF THE BUMP.
*  IU  LAST  LAST INDEX OF THE BUMP.
*
      SUBROUTINE UXSGUA(N,NZ,PTR,LENR,CNR,ORDR,
     *                 ORDC,RIGHT,UP,WR01,WR02,
     *                 COLUP,LAST)
      INTEGER N,NZ,COLUP,LAST
      INTEGER PTR(N),LENR(N),ORDR(N),ORDC(N)
      INTEGER RIGHT(N),UP(N)
      INTEGER CNR(NZ)
      INTEGER I,J,I1,I2,I3,L,LL,IND,JND
      REAL*8 WR01(N),WR02(N)
      INTEGER RA,RL,K1,K2,IMODE,K,PTRL
C
C     INITIALIZATION
C
      IMODE=0
      I2=0
      I3=0
      I1=N+1
      IND=LAST
      JND=COLUP
      DO 50 I=COLUP,LAST
      WR01(I)=I
50    CONTINUE
C
C     ROW SCAN. WR01 IS FILLED WITH THE NEW INDICES OF THE BUMP.
C     WR02 CONTAINS AT THE POSITIONS 1,...,I2  "FILLED" COLUMNS THAT
C     WILL BE SHIFTED UP AND AT THE POSITIONS
C     I1,...,N "EMPTY" COLUMNS THAT WILL BE TRANSFERRED AT THE END
C     OF THE BUMP.
C
      DO 100 I=LAST,COLUP,-1
      IF(RIGHT(ORDR(I)).GT.LAST) THEN
                           I1=I1-1
                           WR01(I)=IND
                           IND=IND-1
                           WR02(I1)=I
                                 ELSE
          IF(UP(ORDR(I)).GT.LAST) THEN
                               I1=I1-1
                               I3=I3+1
                               WR01(I)=JND
                               JND=JND+1
                               WR02(I1)=-I
                                  ELSE
                                  I2=I2+1
                                  WR02(I2)=I
           END IF
      END IF
100   CONTINUE
      IND=COLUP+I3
      DO 155 I=I2,1,-1
      J=WR02(I)
      WR01(J)=IND
      IND=IND+1
155   CONTINUE
C
C     CHANGE THE INDICES IN THE REDUCED BUMP.
C     RIGHT IS ALSO UPDATED BY COMPARING IT WITH THE
C     NONDIAGONAL ELEMENTS OUTSIDE THE REDUCED BUMP.
C
      DO 300 I=1,I2
      LL=WR02(I)
      L=ORDR(LL)
      RA=N+1
      RL=RIGHT(L)
         DO 200 J=PTR(L)+1,PTR(L)+LENR(L)-1
         K=CNR(J)
         K2=ORDC(K)
         K1=WR01(K)
         IF(K.LE.LAST) THEN
                       CNR(J)=K1
                       RA=MIN(RA,K1)
          END IF
         LL=WR02(I)
         UP(K2)=MAX(UP(K2),LL)
200      CONTINUE
         J=PTR(L)
         K=CNR(J)
         CNR(J)=WR01(K)
         IF(RL.LT.COLUP.OR.RL.GT.LAST) GO TO 300
         RIGHT(L)=RA
300   CONTINUE
      DO 320 I=I1,N
      LL=WR02(I)
      L=ORDR(LL)
      RA=N+1
      RL=RIGHT(L)
         DO 310 J=PTR(L)+1,PTR(L)+LENR(L)-1
         K=CNR(J)
         K2=ORDC(K)
         K1=WR01(K)
         IF(K.LE.LAST) THEN
                       CNR(J)=K1
                       RA=MIN(RA,K1)
          END IF
         LL=WR02(I)
         UP(K2)=MAX(UP(K2),LL)
310      CONTINUE
         J=PTR(L)
         K=CNR(J)
         CNR(J)=WR01(K)
         IF(RL.LT.COLUP.OR.RL.GT.LAST) GO TO 320
         RIGHT(L)=RA
320   CONTINUE
C
C     CHANGE THE OTHER INDICES
C
      DO 400 I=1,COLUP-1
      RA=N+1
      L=ORDR(I)
      RL=RIGHT(L)
      PTRL=PTR(L)
      K=CNR(PTRL)
      IF(K.LE.LAST.AND.K.GE.COLUP) CNR(J)=WR01(K)
            DO 350 J=PTRL+1,PTRL+LENR(L)-1
            K=CNR(J)
            K2=ORDC(K)
            IF(K.LE.LAST.AND.K.GE.COLUP) THEN
                                         K1=WR01(K)
                                         CNR(J)=K1
                                         RA=MIN(RA,K1)
            END IF
            UP(K2)=MAX(UP(K2),I)
350         CONTINUE
C
C     SETTING OF THE RIGHT
C
      IF (RL.LT.COLUP.OR.RL.GT.LAST) GO TO 400
      RIGHT(L)=RA
400   CONTINUE
C
C     PERMUTE THE ROWS AND COLUMNS.
C     ROWS.
C
      IND=I3+1
      JND=0
      DO 600 I=I2,1,-1
      L=WR02(I)
      L=ORDR(L)
      IND=IND+1
      WR01(IND)=L
600   CONTINUE
      IND=IND+1
      DO 500 I=I1,N
      L=WR02(I)
      IF(L.LT.0) THEN
                 L=-L
                 L=ORDR(L)
                 JND=JND+1
                 WR01(JND)=L
                 ELSE
                 L=ORDR(L)
                 IND=IND+1
                 WR01(IND)=L
      END IF
500   CONTINUE
      DO 700 I=LAST,COLUP,-1
      ORDR(I)=WR01(IND)
      IND=IND-1
700   CONTINUE
C
C     COLUMNS.
C
      IND=I3+1
      JND=0
      DO 900 I=I2,1,-1
      L=WR02(I)
      L=ORDC(L)
      IND=IND+1
      WR01(IND)=L
900   CONTINUE
      IND=IND+1
      DO 800 I=I1,N
      L=WR02(I)
      IF(L.LT.0) THEN
                 L=-L
                 L=ORDC(L)
                 JND=JND+1
                 WR01(JND)=L
                 ELSE
                 L=ORDC(L)
                 IND=IND+1
                 WR01(IND)=L
      END IF
800   CONTINUE
      DO 1000 I=LAST,COLUP,-1
      ORDC(I)=WR01(IND)
      IND=IND-1
1000  CONTINUE
C
C     SET NEW LAST,COLUP
C
      COLUP=COLUP+I3
      LAST=COLUP+I3+I2
      RETURN
      END
