* SUBROUTINE UXSPCA                 ALL SYSTEMS                93/12/01
C PORTABILITY : ALL SYSTEMS
C 93/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* REWRITE SYMMETRIC MATRIX INTO THE PERMUTED FACTORIZED COMPACT SCHEME.
* MOIDIFIED VERSION FOR THE USE WITH UXSPCJ.
*
* PARAMETERS:
*  II  N  SIZE OF THE SYSTEM SOLVED.
*  II  NB NUMBER OF NONZEROS IN THE UPPER TRIANGLE OF THE ORIGINAL
*         MATRIX.
*  II  ML SIZE OF THE COMPACT FACTOR.
*  II  MMAX DECLARED LENGTH OF THE ARRAYS JA,A.
*  RU  A(MMAX) NUMERICAL VALUES OF THE SPARSE HESSIAN APPROXIMATION
*              STORED AT THE POSITIONS 1, ...,NB.
*  IU  JA(MMAX) INDICES OF THE NONZERO ELEMENTS OF THE HESSIAN MATRIX IN
*             THE PACKED ROW FORM AT THE FIRST NB POSITIONS.
*             NEW POSITIONS
*             IN THE PERMUTED FACTOR STORED IN A(NB+1), ..., A(2*NB),
*             INDICES OF COMPACT SCHEME IN A(2*NB+1), ..., A(2*NB+ML).
*  II  PSL(N+1)  POINTER VECTOR OF THE COMPACT FORM OF THE TRIANGULAR
*             FACTOR OF THE HESSIAN APPROXIMATION.
*  RI  T  CORRECTION FACTOR THAT IS ADDED TO THE DIAGONAL.
*
*
      SUBROUTINE UXSPCA(N,NB,ML,MMAX,A,IA,JA,T)
      INTEGER N,NB,ML,MMAX,IA(N+1),JA(MMAX)
      REAL*8 A(MMAX),T
      INTEGER I,J
      DO 100 I=1,N
        J=ABS(JA(IA(I)+NB+ML))
        A(NB+J)=A(NB+J)+T
 100  CONTINUE
      RETURN
      END
