* SUBROUTINE UXSPCG                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* REWRITING THE FACTOR  FROM THE COMPRESSED STRUCTURE
* INTO THE WIDE ONE , THAT IS THE OUTPUT OF THE SYMBOLIC
* FACTORIZATION SUBROUTINE UXSPGI.
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX A.
*  IU  ML NUMBER OF NONZERO ELEMENTS IN THE FACTOR.
*  II  PA(N+1) POINTER VECTOR OF THE INPUT MATRIX
*  II  PD(N+1) POINTER VECTOR OF THE DIAGONAL OF THE INPUT MATRIX
*  II  SA(MMAX) VECTOR OF THE COLUMN INDICES OF THE INPUT MATRIX
*  II  PSL(N+1) POINTER VECTOR OF THE FACTOR
*  II  SL(MMAX) COMPACT SCHEME OF THE INDICES OF THE FACTOR
*  IU  A(MMAX) NUMERICAL VALUES OF THE FACTOR ELEMENTS THAT ARE REWRITED
*        INTO THE WIDE STRUCTURE.
*  II  MMAX  LENGTH OF THE PRINCIPAL MATRIX VECTORS (SL,A).
*
      SUBROUTINE UXSPCG(N,ML,PA,PD,SA,PSL,SL,A,MMAX)
      INTEGER N,MMAX,ML
      REAL*8 A(MMAX)
      INTEGER PA(N+1),PD(N+1),SA(MMAX),PSL(N+1),SL(MMAX)
      INTEGER K,K1,K2,K3,K4,K5,I,J,L1,M1,P
      K=1
      PA(1)=1
      DO 200 I=1,N
      DO 100 J=PD(I),PA(I+1)-1
      A(K)=A(J)
      K=K+1
100   CONTINUE
      PA(I+1)=K
200   CONTINUE
      K5=PSL(N+1)+N-1
      DO 400 J=N,1,-1
      K1=PSL(J)
      K2=PSL(J+1)-1
      K3=PA(J)+1
      K4=PA(J+1)-1
      L1=K2-K1+1
      M1=K4-K3+1
      P=PD(J)+M1
      PA(J+1)=P+1
      DO 300 K=SL(J)+L1-1,SL(J),-1
      IF(M1.LE.0) THEN
                  A(K5)=0
                  K5=K5-1
                  GO TO 300
                  ELSE
                  IF(SL(N+1+K).EQ.SA(P)) THEN
                                         A(K5)=A(K4)
                                         K4=K4-1
                                         K5=K5-1
                                         P=P-1
                                         M1=M1-1
                                         ELSE
                                         A(K5)=0
                                         K5=K5-1
                  END IF
      END IF
300   CONTINUE
      A(K5)=A(K4)
      K5=K5-1
400   CONTINUE
      ML=PSL(N+1)-1
      RETURN
      END
