* SUBROUTINE UXSPCS                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* SCALING OF A SPARSE SYMMETRIC POSITIVE DEFINITE MATRIX A+E USING THE
* FACTORIZATION A+E=L*D*TRANS(L) OBTAINED BY THE SUBROUTINE UXSPGN.
* FACTORS ARE STORED IN THE COMPACT FORM.
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX A.
*  II  MMAX  LENGTH OF THE PRINCIPAL MATRIX VECTORS (SL,A).
*  RI  A(MMAX)      FACTORIZATION A+E=L*D*TRANS(L) OBTAINED BY THE
*         SUBROUTINE UXSPGN.IT CONTAINS THE NUMERICAL VALUES OF THE
*         FACTORS STORED IN THE COMPACT FORM ACCORDING TO THE
*         INFORMATION IN THE VECTORS PSL,SL.
*  II  PSL(N+1)  POINTER VECTOR OF THE FACTORIZED MATRIX A
*  RI  ALF   SCALING FACTOR
*
      SUBROUTINE UXSPCS(N,MMAX,A,PSL,ALF)
      INTEGER  N,MMAX
      REAL*8  A(MMAX),ALF
      INTEGER  PSL(N+1),I
      DO  100 I=1,N
      A(PSL(I)+I-1)=A(PSL(I)+I-1)*ALF
100   CONTINUE
      RETURN
      END
