* SUBROUTINE UXSPIQ                ALL SYSTEMS                96/12/01
C PORTABILITY : ALL SYSTEMS
C 96/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE NUMBER UXSPIQ=TRANS(X)*D**(-1)*Y WHERE D IS A
* DIAGONAL MATRIX IN THE FACTORIZATION A+E=L*D*TRANS(L) OBTAINED BY THE
* SUBROUTINE UXSPIF.
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX A.
*  II  M NUMBER OF NONZERO ELEMENTS OF THE MATRIX A.
*  RI  A(M) INCOMPLETE FACTORIZATION A+E=L*D*TRANS(L) OBTAINED BY THE
*         SUBROUTINE UXSPGF.
*  II  IA(N+1)  POINTERS OF THE DIAGONAL ELEMENTS OF A.
*  II  JA(M)  INDICES OF THE NONZERO ELEMENTS OF A.
*  RI  X(N)  INPUT VECTOR.
*  RI  Y(N)  INPUT VECTOR.
*  RO  UXSPIQ  COMPUTED NUMBER UXSPIQ=TRANS(X)*D**(-1)*Y.
*
      FUNCTION UXSPIQ(N,M,A,IA,X,Y)
      INTEGER N,M,IA(N+1)
      REAL*8 A(M),X(N),Y(N),UXSPIQ
      INTEGER K
      REAL*8 ZERO
      PARAMETER (ZERO=0.0D 0)
      UXSPIQ=ZERO
      DO 1 K=1,N
      UXSPIQ=UXSPIQ+X(K)*Y(K)*A(IA(K))
    1 CONTINUE
      RETURN
      END
