* SUBROUTINE  UXSRBR               ALL SYSTEMS               92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE : ROW PERMUTATION INDUCED BY BLOCKS IS REFINED.
*
*  PARAMETERS :
*  II  M NUMBER OF ROWS OF THE MATRIX.
*  II  N NUMBER OF COLUMN OF THE MATRIX.
*  II  JP  LAST ACTIVE BLOCK IN A
*  II  IB INDICES OF THE FIRST MEMBERS IN ROWS OF THE MATRIX.
*  II  JB INDICES OF MEMBERS OF THE MATRIX.
*  II  LABEL2  SCHEME OF LABELS (BLOCK STRUCTURE FROM UXVETI).
*  II  LABEL  STRUCTURE OF TREE FROM UXSRBN.
*  II  SON  POLE ZOBRAZUJICI NASLEDNOU STRUKTURU STROMU.
*  IU  PERMR  ROW PERMUTATION.
*  IU  WN01 INVERSE ROW PERMUTATION.
*  II  IPERMC  INVERSE COLUMN PERMUTATION.
*  IA  WN02,WN03,WN0X  AUXILIARY VECTORS.
*  II  NUM0  BEGIN SECTION.
*  II  NUM  END SECTION.
*
      SUBROUTINE UXSRBR(JP,IB,JB,LABEL2,LABEL,SON,PERMR,IPERMC,
     + WN01,WN03,WN0X,NUM0,NUM,M,N)
      INTEGER M,N,IB(M+1),JB(*),PERMR(M),IPERMC(N),LABEL2(N),
     + SON(N),LABEL(N),JP,WN01(*),WN03(*),WN0X(*),NUM0,NUM,I,II,I1,
     + L2,L3,J,K1,K
       DO 5 I=1,5
         WN0X(I)=0
 5     CONTINUE
C
C  NOVE ZALOZENE (ZPERMUTOVANE) RADKY
C
      DO 10 I=NUM0, NUM
C
C  PUVODNI RADEK V MATICI A
C
        II = PERMR(I)
C
C  URCENI, DO JAKYCH BLOKU (LABEL2) PATRI NENUL. PRVKY NA RADKU I A
C  VYTVORENI STRUKTURY WN03(I) PRO RADEK I
C
        DO 20 I1=IB(II), IB(II+1) - 1
          L2 = LABEL2(IPERMC(JB(I1)))
          IF (ABS(L2).GT.ABS(JP)) THEN
            IF (ABS(L2).EQ.ABS(JP)+1) THEN
              IF (WN03(I).NE.1) THEN
                WN03(I) = 4
              END IF
            ELSE IF (WN03(I).NE.1.AND.WN03(I).NE.4) THEN
                   WN03(I) = 3
            END IF
          ELSE IF (ABS(L2).LT.ABS(JP)) THEN
                 L3 = SON(ABS(LABEL(JB(I1))))
                 IF (L3.EQ.0) THEN
                   WN03(I) = 1
                 END IF
               ELSE IF (WN03(I).EQ.0) THEN
                      J = LABEL(JB(I1))
                      K = INT(J/2)
                      L3 = K * 2
                      K1 = SON(ABS(J))
                      IF (J.NE.L3.OR.J.EQ.L3.AND.(K1.NE.0.OR.K.NE.
     +                   INT(K/2)*2)) THEN
                        WN03(I) = 2
                      ELSE
                        WN03(I) = 5
                      END IF
          END IF
   20   CONTINUE
C
C NASTAVENI STRUKTURY WN0X(1..5). INDEXY V STRUKTURE WN0X ODPOVIDAJI
C HODNOTAM 1-5 V POLI WN03. HODNOTA V KAZDEM INDEXU POLE WN0X SE ROVNA
C POCTU ODPOVIDAJICICH HODNOT V POLI WN03 V ROZMEZI NUM0 - NUM.
C
        J = WN03(I)
        WN0X(J) = WN0X(J) + 1
   10 CONTINUE
C
C PRVNI JESTE NEZPERMUTOVANY RADEK V A
C
      K1 = NUM0
C
C VYTVORENI NOVE STRUKTURY VE WN0X ( HODNOTY V POLI URCUJI INDEXY RADKU
C V MATICI A NA KTERE SE PRESUNOU PRISLUSNE RADKY )
C
      DO 30 I=1, 5
        K = WN0X(I)
        WN0X(I) = K1
        K1 = K1 + K
   30 CONTINUE
C
C PRESUNUTI CASTI POLE PERMR DO POMOCNEHO POLE
C
      DO 40 I=NUM0, NUM
        WN0X(I+5) = PERMR(I)
   40 CONTINUE
C
C KONECNE PREMISTENI RADKU V INTERVALU NUM0 - NUM
C
      DO 50 I=NUM0, NUM
        J = WN03(I)
        PERMR(WN0X(J)) = WN0X(I+5)
        WN01(WN0X(I+5)) = WN0X(J)
        WN0X(J) = WN0X(J) + 1
   50 CONTINUE
      NUM0 = NUM + 1
      RETURN
      END
