* SUBROUTINE  UXSRBS              ALL SYSTEMS               92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :  FORMING OF THE SPARSE STRUCTURE OF TRANS(A)*A
*            WHERE A IS THE MATRIX (M,N)
*
*  PARAMETERS :
*  II  M NUMBER OF ROW OF THE MATRIX.
*  II  N NUMBER OF COLUMN OF THE MATRIX.
*  II  NJA NUMBER OF NONZEROES MEMBERS IN THE MATRIX.
*  II  IA(N+1) INDICES OF THE FIRST MEMBERS IN COLUMNS OF THE MATRIX.
*  II  IB(M+1) INDICES OF THE FIRST MEMBERS IN ROWS OF THE MATRIX.
*  II  MAXNADJ  MAX. SIZE OF NADJ.
*  IU  JA INDICES OF MEMBERS OF THE MATRIX (ROWS AND COLUMNS STRUCTURE)
*         AND ROW (COLUMN) INDICES OF THE SPARSE STRUCTURE
*         OF THE PRODUCT.
*  IO  XADJ(N+1) POINTERS TO THE BEGINNINGS OF THE ROWS (COLUMNS)
*        IN THE SPARSE STRUCTURE OF THE PRODUCT.
*  IO  NADJ NUMBER OF NONZEROES MEMBERS IN ADJNCY.
*  IA  WN01(N) AUXILIARY VECTOR.
*  IO  IER  ERROR FLAG.
*
      SUBROUTINE UXSRBS(M,N,NJA,IA,IB,XADJ,JA,NADJ,MAXNADJ,WN01,IER)
      INTEGER M,N,NADJ,I,J,K,NJA,FTOP,MAXNADJ,IER
      INTEGER IA(N+1),IB(M+1),JA(*),XADJ(N+1),WN01(N)
C ---------------------------
C SET INITIAL INDEX IN ADJNCY
C ---------------------------
      FTOP = 2 * NJA
      NADJ = 1
      XADJ(1) = 1
C -------------
C INITIATE WN01
C -------------
      DO 50 J=1, N
        WN01(J) = 0
   50 CONTINUE
C ------------------------------------------
C MAIN CYCLE - TAKES FROM THE SINGLE COLUMNS
C ------------------------------------------
      DO 100 J=1, N
C --------------------
C CYCLE OF THE COLUMNS
C --------------------
        DO 200 I=IA(J)+NJA, IA(J+1) - 1 + NJA
C -----------------
C CYCLE OF THE ROWS
C -----------------
          DO 300 K=IB(JA(I)), IB(JA(I)+1)-1
            IF (J.EQ.JA(K)) GO TO 300
            IF (WN01(JA(K)).EQ.0) THEN
              JA(FTOP+NADJ) = JA(K)
              NADJ = NADJ + 1
              WN01(JA(K)) = 1
            END IF
  300     CONTINUE
  200   CONTINUE
        XADJ(J+1) = NADJ
C ----------
C CLEAR WN01
C ----------
        DO 400 I=XADJ(J), XADJ(J+1) - 1
          WN01(JA(FTOP+I)) = 0
  400   CONTINUE
  100 CONTINUE
      NADJ = NADJ - 1
      IF (NADJ.GT.MAXNADJ) THEN
        IER = 60
        CALL UOERR1('UXSRBS',60)
      END IF
      RETURN
      END
