* FUNCTION UXSRMP                 ALL SYSTEMS                93/12/01
C PORTABILITY : ALL SYSTEMS
C 93/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DOT PRODUCT OF THE ROWS WITH INDICES K AND L OF THE SPARSE MATRIX A.
*
* PARAMETERS :
*  II  N  NUMBER OF ROWS OF THE MATRIX A.
*  II  NA NUMBER OF COLUMNS OF THE MATRIX A.
*  II  MA  NUMBER OF ELEMENTS IN THE FIELD A.
*  RI  A(MA)  RECTANGULAR MATRIX STORED AS A TWO-DIMENSIONAL ARRAY.
*  II  IA(NA+1)  POSITION OF THE FIRST RORWS ELEMENTS IN THE FIELD A.
*  II  JA(MA) COLUMN INDICES OF ELEMENTS IN THE FIELD A.
*  II  K  INPUT INDEX.
*  II  L  INPUT INDEX.
*
      FUNCTION UXSRMP(NA,MA,A,IA,JA,K,L)
      INTEGER NA,MA,IA(NA+1),JA(MA),K,L
      REAL*8 A(MA),UXSRMP
      INTEGER I,IK,KK,LK,IL,KL,LL
      REAL*8 ZERO,ONE
      PARAMETER (ZERO=0.0D 0,ONE=1.0D 0)
      UXSRMP=ZERO
      IF (K.LT.0) THEN
      IF (L.LT.0) THEN
      IF (L.EQ.K) UXSRMP=ONE
      ELSE IF (L.GT.0) THEN
      KL=IA(L)
      LL=IA(L+1)-1
      DO 1 I=KL,LL
      IL=JA(I)
      IF (IL.EQ.-K) UXSRMP=A(I)
      IF (IL.GE.-K) RETURN
    1 CONTINUE
      RETURN
      ENDIF
      ELSE IF (K.GT.0) THEN
      KK=IA(K)
      LK=IA(K+1)-1
      IF (L.LT.0) THEN
      DO 2 I=KK,LK
      IK=JA(I)
      IF (IK.EQ.-L) UXSRMP=A(I)
      IF (IK.GE.-L) RETURN
    2 CONTINUE
      RETURN
      ELSE IF (L.GT.0) THEN
      KL=IA(L)
      LL=IA(L+1)-1
    3 IK=JA(KK)
      IL=JA(KL)
    4 IF (IK.LT.IL) THEN
      IF (KK.GE.LK) RETURN
      KK=KK+1
      IK=JA(KK)
      GO TO 4
      ELSE IF (IL.LT.IK) THEN
      IF (KL.GE.LL) RETURN
      KL=KL+1
      IL=JA(KL)
      GO TO 4
      ELSE
      UXSRMP=UXSRMP+A(KK)*A(KL)
      IF (KK.GE.LK) RETURN
      IF (KL.GE.LL) RETURN
      KK=KK+1
      KL=KL+1
      GO TO 3
      ENDIF
      ENDIF
      ENDIF
      RETURN
      END
