* SUBROUTINE UXSRMX                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SCALING FACTORS FOR A DENSE RECTANGULAR MATRIX A STORED BY ROWS.
* THESE SCALING FACTORS ARE NORMS OF THE CORRESPONDING COLUMNS.
*
* PARAMETERS :
*  II  N  NUMBER OF ROWS OF THE MATRIX A.
*  II  NA NUMBER OF COLUMNS OF THE MATRIX A.
*  II  MA  NUMBER OF ELEMENTS IN THE FIELD A.
*  RI  A(MA)  RECTANGULAR MATRIX STORED AS A TWO-DIMENSIONAL ARRAY.
*  II  IA(NA+1)  POSITION OF THE FIRST RORWS ELEMENTS IN THE FIELD A.
*  II  JA(MA) COLUMN INDICES OF ELEMENTS IN THE FIELD A.
*  RI  X(N)  VECTOR OF SCALING FACTORS.
*
      SUBROUTINE UXSRMX(N,NA,MA,A,IA,JA,X)
      INTEGER N,NA,MA,IA(NA+1),JA(MA)
      REAL*8 A(MA),X(N)
      INTEGER I,J,K,L,JP
      REAL*8 TEMP
      REAL*8 ZERO,ONE,CON,CON1,CON2
      PARAMETER (ZERO=0.0D 0,ONE=1.0D 0,CON=1.0D-60,CON1=2.0D-5,
     * CON2=1.0D 5)
      CALL UXVSET(N,ZERO,X)
      DO 2 I=1,NA
      K=IA(I)
      L=IA(I+1)-K
      DO 1 J=1,L
      JP=JA(K)
      IF (JP.GT.0) X(JP)=X(JP)+A(K)*A(K)
      K=K+1
    1 CONTINUE
    2 CONTINUE
      DO 3 I=1,N
      TEMP=ONE/SQRT(MAX(X(I),CON))
      IF (TEMP.LE.CON1) TEMP=CON1
      IF (TEMP.GE.CON2) TEMP=CON2
      X(I)=TEMP
    3 CONTINUE
      DO 5 I=1,NA
      K=IA(I)
      L=IA(I+1)-K
      DO 4 J=1,L
      JP=JA(K)
      IF (JP.GT.0) A(K)=A(K)*X(JP)
      K=K+1
    4 CONTINUE
    5 CONTINUE
      RETURN
      END
