* SUBROUTINE UXSRQ2              ALL SYSTEMS                94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* MULTIFRONTAL QR DECOMPOSITION - GATHER, DECOMPOSE AND SCATTER MATRIX
* INFORMATION.
*
* PARAMETERS :
*  II  N NUMBER OF NATRIX ROWS.
*  II  M NUMBER OF MATRIX ROWS.
*  II  NJB DIMENSION OF THE ARRAY JB.
*  II  NJBR DIMENSION OF THE ARRAY B.
*  IU  WN01IND POINTER TO THE BEGINNING OF THE FRONTAL MATRIX.
*  IU  JB(NJB) INTEGER ARRAY COVERING INDICES OF MATRIX ELEMENTS,
*        STACK AND FRONTAL MATRIX.
*  RU  B(NJBR) REAL ARRAY COVERING MATRIX ELEMENTS, STACK AND
*        FRONTAL MATRIX.
*  IU  SBT WORKING BOTTOM OF THE INTEGER PART OF THE FRONTAL MATRIX.
*  IU  SBTR WORKING BOTTOM OF THE REAL PART OF THE FRONTAL MATRIX.
*  IU  STOP WORKING TOP OF THE INTEGER PART OF THE FRONTAL MATRIX.
*  IU  STOPR WORKING TOP OF THE REAL PART OF THE FRONTAL MATRIX.
*  II  PI PREVIOUS PARTIAL SUM OF THE COLUMNS COMPUTES SO FAR.
*  IO  PBNBL   PLACE IN JB WHERE TO STORE THE FINAL
*          NUMBER OF THE BLOCKS AFTER THE CURRENT ITERATION.
*  IO  NBNBL   NUMBER OF THE BLOCKS AFTER FINISHING THE CURRENT
*          ITERATION.
*  IO  LMM  CURRENT LENGTH FOR THE STACK INCREASE AFTER THE CURRENT
*          ITERATION.
*  IO  INDMM MINIMUM INDEX OF THE STACK INCREASE FOUND SO FAR.
*  IU  WN01(N) AUXILIARY ARRAY.
*  IA  WN02(N) AUXILIARY ARRAY.
*  IA  WN03(N) AUXILIARY ARRAY.
*  IO  WN01IND POINTER TO THE BEGINNING OF THE FRONTAL MATRIX INDICES.
*  IO  PND NUMBER OF FRONTAL INDICES LESS OR EQUAL TO PI.
*  IO  QND NUMBER OF FRONTAL INDICES GREATER THAN PI.
*  IO  IER ERROR FLAG.
*
      SUBROUTINE UXSRQ2(N,NRHS,M,NJB,NJBR,
     *           WN01IND,JB,B,SBT,SBTR,STOP,STOPR,
     *           IA,IB,IPRMC,PERM,
     *           PI,NBNBL,LMM,INDMM,WN01,WN02,WN03,
     *           PND,QND,MASK,IER,RHS)
C
      INTEGER N,M,IER,NJBR,MBL,NJA,IA(N+1),MASK(M)
      INTEGER NJB,JB(NJB),WN01(N),WN02(N),WN03(N),NRHS
      INTEGER IB(N+1),IPRMC(N),PERM(N)
      INTEGER PI,NBNBL,LMM,INDMM,KKKK
      REAL*8 B(NJBR),RHS(M*NRHS),TEMP,ZERO
C
      INTEGER JND,STOP,STOPR,SBT,SBTR,LSBTR,INDM,LM,PVAL
      INTEGER K,LB,NB,MB,INDB,PINDB,NBL,PNBL,IPOM,WN01IND
      INTEGER NROWM,PND,QND,JSTRT,JSTOP,J1,J2,L2,JP,J3
      INTEGER NIND,MTOP,MTOPR,J,L,KK,K1,K2,KKK,BOT,NBLL
      INTEGER ISTRT,ISTOP,INDBL
      PARAMETER (ZERO=0.0D 0)
C
C GO THROUGH BLOCKS OF STACK MATRICES AND TEST THEIR MINIMUM INDICES
C BEGININGS OF BLOCKS OF STACK MATRICES ARE STORED IN (WN02,JND).
C
      IER=0
      JND=0
      NJA=IB(M+1)-1
C
C SAVE SBT. IT IS RETRIEVED IN CASE OF UNSUCCESSFUL SEARCH.
C
      J1=SBT
      BOT=SBT+1
      NBNBL=0
      LMM=0
      INDMM=N+M+1
 50   INDM=JB(BOT)
C
C TEST END OF JB
C
      IF(INDM.GT.NJB) THEN
        IF(JND.EQ.0) THEN
          SBT=J1
          GO TO 51
        ELSE
          GO TO 51
        END IF
      END IF
      LM=JB(BOT+1)
      IF(INDM.LE.PI) THEN
        JND=JND+1
        WN02(JND)=BOT
        SBT=SBT+LM
C
C DETERMINE SBT, SBTR
C SBTR IS USED ONLY TO CHECK THE FREE SPACE.
C
        BOT=SBT+1
C       SBTR=JB(SBT-LM+4)
      ELSE
        GO TO 51
C       SBT=SBT+LM
C       BOT=SBT+1
      END IF
      GO TO 50
C
 51   CONTINUE
      LSBTR=0
      PND=0
      QND=N+1
      INDB=M+N+1
      IER=0
      MB=0
      NB=0
      MBL=0
C
C INDICES FROM THE STACK. POINTERS STORED IN WN02.
C
      DO 300 J=JND,1,-1
        BOT=WN02(J)
C
C WE DO NOT CLEAR WN02
C
        PNBL=BOT+2
        NBL=JB(PNBL)
        BOT=BOT+JB(BOT+1)
        DO 200 L=1,NBL
          PINDB=BOT-1
C ###
          INDBL=JB(PINDB)
          LB=JB(PINDB-1)
          BOT=BOT-LB
          MB=MB+JB(PINDB-2)
          NBLL=JB(PINDB-3)
          IF(INDBL.LE.PI) THEN
            DO 100 K=PINDB-4,PINDB-3-NBLL,-1
              KK=JB(K)
              IF(WN03(KK).EQ.0) THEN
                IF(KK.LE.PI) THEN
                  PND=PND+1
                  WN03(KK)=PND
                  WN01(PND)=KK
                ELSE
                  INDB=MIN(INDB,KK)
                  QND=QND-1
                  WN03(KK)=-QND
                  WN01(QND)=KK
                END IF
              END IF
 100        CONTINUE
          ENDIF
 200    CONTINUE
 300  CONTINUE
C
C INDICES FROM THE MATRIX - ONLY ONE BLOCK IS USED.
C CYCLE OF BLOCKS OF THE INITIAL MATRIX USING MASK.
C
        ISTRT=NJA+IA(PERM(PI))
        ISTOP=NJA+IA(PERM(PI)+1)-1
C
C SCAN INDICES AND GIVE THEM INTO WN01, WN03.
C
        DO 500 J1=ISTRT,ISTOP
          J=JB(J1)
C         J=PERMR(J)
          IF(MASK(J).NE.0) GO TO 500
          MB=MB+1
          JSTRT=IB(J)
          JSTOP=IB(J+1)-1
          DO 400 J2=JSTRT,JSTOP
            K1=JB(J2)
            K2=IPRMC(K1)
            IF(K2.LE.PI) THEN
              IF(WN03(K2).EQ.0) THEN
                WN03(K2)=K2
                PND=PND+1
                WN01(PND)=K2
              END IF
            ELSE
              INDB=MIN(INDB,K2)
              IF(WN03(K2).EQ.0) THEN
                QND=QND-1
                WN03(K2)=-QND
                WN01(QND)=K2
              END IF
            END IF
 400      CONTINUE
 500    CONTINUE
C
C INSERT INDICES OF RIGHT-HAND SIDES
C
        IF(NRHS.EQ.0) GO TO 502
        IF(WN03(N).NE.0) GO TO 502
        DO 501 J1=N-NRHS+1,N
          QND=QND-1
          WN03(J1)=-QND
          WN01(QND)=J1
 501    CONTINUE
 502    CONTINUE
C
C SHIFT INDICES AND VALUES FROM STACK AND MATRIX.
C
         MTOP=STOP
         MTOPR=STOPR
C
C NUMBER OF VARIABLES
C
         NIND=PND+N-QND+1
         NB=NIND
C
         IF(STOP+NB+10.GE.SBTR) THEN
           IER=52
           CALL UOERR1('UXSRQ2',52)
           RETURN
         ENDIF
C
         IF(PND.NE.1) THEN
           IER=53
           CALL UOERR1('UXSRQ2',53)
           RETURN
         END IF
C
         JB(MTOP)=MB
C
C BEGINNING OF THE FRONTAL MATRIX INFORMATION.
C
         WN01IND=MTOP
         MTOP=MTOP+1
         JB(MTOP)=NB
         MTOP=MTOP+1
         JB(MTOP)=MTOPR
         MTOP=MTOP+1
C
         STOP=MTOP
C
C INTO WN03 WE GIVE RIGHT ORDER OF INDICES LESS THAN PI.
C FILL JB. FIRST INDICES LESS THAN PI.
C
         WN03(PI)=1
         JB(MTOP)=PI
         MTOP=MTOP+1
C
          NIND=PND
          DO 64 J1=N,QND,-1
            L2=WN01(J1)
            JB(MTOP)=L2
            NIND=NIND+1
            WN03(L2)=NIND
            MTOP=MTOP+1
  64      CONTINUE
C
         J1=MB*NB
         IF((SBTR-MTOPR).LE.2*J1) THEN
           IER=54
           CALL UOERR1('UXSRQ2',54)
           RETURN
         END IF
C
C CLEAR FRONTAL SPACE
C
            DO 53 J2=MTOPR,MTOPR+J1-1
              B(J2)=0
  53        CONTINUE
C
C COPY STACK ELEMENTS INTO THE FRONTAL MATRIX.
C
      DO 700 J=JND,1,-1
        BOT=WN02(J)
C
C CLEAR WN02
C
        WN02(J)=0
        PNBL=BOT+2
        NBL=JB(PNBL)
        BOT=BOT+JB(BOT+1)
        DO 600 L=1,NBL
          PINDB=BOT-1
C #####
          INDBL=JB(PINDB)
          LB=JB(PINDB-1)
C
C LOCAL MB.
C
          MBL=JB(PINDB-2)
          NBLL=JB(PINDB-3)
          IF(INDBL.LE.PI) THEN
C
C INDEX CORRECTION
C
            IPOM=-1
C
C BEGINNING OF STACK VALUES.
C
            PVAL=JB(PINDB-4-NBLL)
            IF(LSBTR.EQ.0) THEN
              SBTR=PVAL
              LSBTR=1
            END IF
C
            DO 560 K1=1,MBL
              DO 550 K2=PINDB-4,PINDB-3-NBLL,-1
                KK=JB(K2)
                KKK=WN03(KK)
                B(MTOPR+KKK+IPOM)=B(PVAL)
                PVAL=PVAL-1
  550         CONTINUE
              IPOM=IPOM+NB
  560       CONTINUE
          ELSE
            IF(PINDB.NE.SBT) THEN
              IER=55
              CALL UOERR1('UXSRQ2',55)
              RETURN
            END IF
          END IF
  600   CONTINUE
        MTOPR=MTOPR+MBL*NB
  700 CONTINUE
C
C COPY MATRIX VALUES INTO THE FRONTAL MATRIX.
C
        DO 65 J1=ISTRT,ISTOP
          J=JB(J1)
          JP=J
C         J=PERMR(J)
          IF(MASK(J).NE.0) GO TO 65
          MASK(J)=1
          JSTRT=IB(J)
          JSTOP=IB(J+1)-1
          DO 66 J2=JSTRT,JSTOP
            K1=JB(J2)
            K2=IPRMC(K1)
            B(MTOPR+WN03(K2)-1)=B(J2)
  66      CONTINUE
C
C COPY RIGHT-HAND SIDES
C
          J3=JP
          JP=WN03(N)
          DO 67 J2=N-NRHS+1,N
            B(MTOPR+WN03(J2)-1)=RHS(J3)
            J3=J3+M
  67      CONTINUE
C
C UPDATE POINTER MTOPR FOR SUBSEQUENT UPDATES.
C
          MTOPR=MTOPR+NB
  65    CONTINUE
C
C PARTIAL NUMERICAL DECOMPOSITION
C
            IPOM=0
            IF(PI.EQ.48) THEN
            DO 4445 KKK=0,NB*NB-1
              B(STOPR+KKK)=B(STOPR+KKK)
 4445       CONTINUE
          END IF
          DO 8989 KKK=1,MB
            ISTRT=STOPR+(KKK-1)*NB
            ISTOP=ISTRT+NB-1
            TEMP=ZERO
            do 8990 KKKK=ISTRT,ISTOP
              TEMP=TEMP+B(KKKK)
 8990       CONTINUE
 8989     CONTINUE
            CALL UXSRBV(MB,NB,IPOM,B(STOPR),PND)
          DO 8991 KKK=1,MB
            ISTRT=STOPR+(KKK-1)*NB+MIN(KKK-1,PND)
            ISTOP=STOPR+KKK*NB-1
            TEMP=ZERO
            DO 8992 KKKK=ISTRT,ISTOP
              TEMP=TEMP+B(KKKK)
 8992       CONTINUE
 8991     CONTINUE
          IF(PI.EQ.48) THEN
            DO 4446 KKK=0,NB*MB-1
              B(STOPR+KKK)=B(STOPR+KKK)
 4446       CONTINUE
          END IF
            NROWM=PND
            STOPR=STOPR+NROWM*NB
C
C UPDATE NUMBER OF FACTOR ROWS
C
            JB(WN01IND)=NROWM
C
C RETURN REST OF THE BLOCK BACK INTO THE STACK
C NROWM IS THE NUMBER OF ROWS WHICH STAY NOW IN THE FRONTAL MATRIX.
C
            IF(NROWM.LT.MB.AND.NROWM.LT.NB) THEN
C
C UPDATE GLOBAL VALUES
C
              NBNBL=NBNBL+1
C
C UPDATE INDMM, LMM
C
              INDMM=MIN(INDMM,INDB)
              LMM=LMM+N-QND+6
C
C SAVE
C
              JB(SBT)=INDB
              JB(SBT-1)=NIND-PND+5
              JB(SBT-2)=MB-NROWM
              JB(SBT-3)=NIND-PND
              SBT=SBT-4
C
              DO 85 K=1,NIND-PND
                JB(SBT)=JB(STOP+PND-1+K)
                SBT=SBT-1
   85         CONTINUE
C
              STOP=MTOP
C
              JB(SBT)=SBTR
              SBT=SBT-1
              PVAL=STOPR
              DO 90 K1=1,MB-NROWM
                DO 91 K2=PVAL+PND,PVAL+NIND-1
                  B(SBTR)=B(K2)
                  SBTR=SBTR-1
   91           CONTINUE
                PVAL=PVAL+NIND
   90         CONTINUE
C
C SAVE NUMBER OF ROWS WHICH REMAIN IN THE FRONTAL MATRIX FOR
C FURTHER PROCESSING
C
              JB(WN01IND)=NROWM
            ELSE
              STOP=MTOP
            END IF
C
C RETURN
C
      RETURN
      END
