* SUBROUTINE UXSSDD                ALL SYSTEMS                95/12/01
C PORTABILITY : ALL SYSTEMS
C 95/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* A SPARSE SYMMETRIC MATRIX A IS AUGMENTED BY THE SCALED DIAGONAL MATRIX
* SUCH THAT A:=A+ALF*D (D IS THE DIAGONAL MATRIX OF ORDER N).
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE MATRIX A.
*  RI  A(M) ELEMENTS OF THE SPARSE SYMMETRIC MATRIX STORED IN THE
*      PACKED FORM.
*  II  IA(N+1)  POINTERS OF THE DIAGONAL ELEMENTS OF A.
*  RI  ALF  SCALING FACTOR.
*
      SUBROUTINE UXSSDD(N,M,A,IA,D,ALF)
      INTEGER N,M,IA(N)
      REAL*8  A(M), D(N), ALF
      INTEGER I
      DO 100 I=1,N
      A(IA(I))=A(IA(I))+ALF*D(I)
100   CONTINUE
      RETURN
      END
