* SUBROUTINE UXSSML                ALL SYSTEMS                93/12/01
C PORTABILITY : ALL SYSTEMS
C 93/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SPARSE LANCZOS RECURRENCE.
*
* PARAMETERS :
*  II  N  ORDER OF THE SPARSE SYMMETRIC MATRIX A.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE MATRIX A.
*  RI  A(M) ELEMENTS OF THE SPARSE SYMMETRIC MATRIX STORED IN THE
*      PACKED FORM.
*  II  IA(N)  POINTERS OF THE DIAGONAL ELEMENTS OF A.
*  II  JA(M)  INDICES OF THE NONZERO ELEMENTS OF A.
*  RO  D(K)  DIAGONAL ELEMENTS OF THE LANCZOS TRIDIAGONAL MATRIX.
*  RO  E(K)  SUBDIAGONAL ELEMENTS OF THE LANCZOS TRIDIAGONAL MATRIX.
*  RU  U(N)  INPUT VECTOR.
*  RO  V(N)  OUTPUT VECTOR.
*  II  K  NUMBER OF LANCZOS STEPS.
*  IO  INF  ERROR INDICATOR.
*
      SUBROUTINE UXSSML(N,M,A,IA,JA,D,E,U,V,K,INF)
      INTEGER N,M,IA(N+1),JA(M),K,INF
      REAL*8  A(M),D(K),E(K),U(N),V(N)
      REAL*8  DI,EI,UXVDOT,UXVNOR
      REAL*8 ZERO,ONE
      INTEGER I,J
      PARAMETER (ZERO=0.0D 0,ONE=1.0D 0)
      INF=0
      CALL UXVSET(N,ZERO,V)
      CALL UXVSCL(N,ONE/UXVNOR(N,U),U,U)
      DO 2 I=1,K
      IF (I.GT.1) THEN
      DO 1 J=1,N
      DI=U(J)
      U(J)=V(J)/EI
      V(J)=-EI*DI
    1 CONTINUE
      ENDIF
      CALL UXSSMD(N,M,A,IA,JA,U,ONE,V,V)
      DI=UXVDOT(N,U,V)
      CALL UXVDIR(N,-DI,U,V,V)
      EI=UXVNOR(N,V)
      IF (EI.LE.ZERO) THEN
      INF=I
      RETURN
      ENDIF
      D(I)=DI
      E(I)=EI
    2 CONTINUE
      RETURN
      END
