* SUBROUTINE UXSTM2                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF A SPARSE SYMMETRIC MATRIX WITH NUMERICAL ELEMENTS
* STORED IN THE INDEX/VALUE STRUCTURE BY THE SUM OF MULTIPLES
* OF UNIT VECTORS.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE MATRIX A.
*  RI  A(M) ELEMENTS OF THE SPARSE SYMMETRIC MATRIX STORED IN THE
*      PACKED FORM.
*  II  IA(N+1)  POINTERS OF THE DIAGONAL ELEMENTS OF A.
*  II  JA(M)  INDICES OF THE NONZERO ELEMENTS OF A.
*  II  IVAR BEGINNING OF THE GROUP IN COL.
*  II  JVAR END OF THE GROUP IN COL.
*  II  COL(NF) GROUPS OF THE SAME COLOUR FORMED BY THE INDICES
*           OF THE COLUMNS. LAST ONE HAS NEGATIVE SIGN.
*  RI  XO(NF) DIFFERENCE OF THE NEW ITERATE AND THE OLD ONE.
*  RO  Y(N)  OUTPUT VECTOR WHERE Y := A * X.
*
      SUBROUTINE UXSTM2(N,M,A,IA,JA,IVAR,JVAR,COL,XO,Y)
      INTEGER N,M,IA(N+1),JA(M),IVAR,JVAR,COL(N)
      REAL*8  A(M),Y(N),STEMP,XO(N)
      REAL*8 ZERO
      INTEGER I,I1,J,K,L,ISTRT,ISTOP
      PARAMETER   (ZERO = 0.0D 0)
C
C INITIATE
C
      DO 100 I=1,N
      Y(I)=ZERO
100   CONTINUE
C
C MAIN CYCLE OF THE COMPONENTS
C
      DO 600 I1=IVAR,JVAR
      L=ABS(COL(I1))
      STEMP=XO(L)
C
C MULTIPLY
C
      ISTRT=IA(L)
      ISTOP=IA(L+1)-1
      DO 300 I=ISTRT,ISTOP
        J=JA(I)
        IF(J.GE.L) GO TO 400
        K=A(I)
        Y(J)=Y(J)+A(K)*STEMP
  300 CONTINUE
  400 CONTINUE
      DO 500 J=I,ISTOP
        K=JA(J)
        Y(K)=Y(K)+A(J)*STEMP
  500 CONTINUE
  600 CONTINUE
      RETURN
      END
