* SUBROUTINE UXSTQM                ALL SYSTEMS                86/11/01
C PORTABILITY : ALL SYSTEMS
C 93/01/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLY TRANS(R)*X=Y OR R*X=Y OR TRANS(R)*R*X=Y
* USING SPARSE TRIANGULAR MATRIX
* WHICH IS STORED ROWWISE. MODE DETERMINED BY JOB.
*
* PARAMETERS :
*  II  N ROW ORDER OF THE MATRIX
*  II  NJA LENGTH OF THE VECTORS A,JA
*  II  JA(NJA) VECTOR OF THE ROW INDICES OF THE MATRIX AND OF THE
*         POINTERS - STORED ON OUTPUT OF THE MULTIFRONTAL SOLVER.
*  RI  A(N) NUMERICAL ELEMENTS OF THE MATRIX.
*  RU  X(N) ON INPUT: VECTOR TO BE MULTIPLIED, ON OUTPUT:
*           RESULT OF THE MULTIPLICATION.
*  RA  Y(N) AUXILIARY VECTOR.
*  II  JOB  JOB: =1 FOR REULT OF R*X=Y,
*           =-1 FOR THE SYSTEM TRANS(R)*X=Y, =0 FOR TRANS(R)*R*X=Y.
*
      SUBROUTINE UXSTQM(N,NJA,JA,A,X,Y,JOB)
      INTEGER N,NJA,ISTRT,ISTOP,JSTRT,JSTOP,KK
      INTEGER JA(NJA),JOB
      REAL*8 A(NJA),X(N),Y(N)
      REAL*8 ZERO,TEMP
      INTEGER I,J,K,L
      PARAMETER (ZERO=0.0D 0)
      IF(JOB.GE.0) THEN
        KK=NJA+NJA+1
        ISTRT=JA(KK)
        ISTOP=JA(KK+1)-1
        JSTRT=ISTRT-NJA
        JSTOP=ISTOP-NJA
        KK=KK+1
        DO 400 I=1,N
          L=JSTRT
          TEMP=ZERO
          DO 300 J=ISTRT,ISTOP
            K=JA(J)
            IF(K.GT.N) THEN
            ELSEIF(K.GE.I) THEN
              TEMP=TEMP+A(L)*X(K)
            END IF
            L=L+1
 300      CONTINUE
          X(I)=TEMP
          ISTRT=ISTOP+1
          JSTRT=JSTOP+1
          ISTOP=JA(KK+1)-1
          JSTOP=ISTOP-NJA
          KK=KK+1
 400    CONTINUE
      END IF
C
      IF(JOB.LE.0) THEN
        DO 200 I=1,N
          Y(I)=ZERO
 200    CONTINUE
        KK=NJA+NJA+N
        ISTRT=JA(KK)
        ISTOP=JA(KK+1)-1
        JSTRT=ISTRT-NJA
        JSTOP=ISTOP-NJA
        KK=KK-1
        DO 500 I=N,1,-1
          L=JSTRT
          DO 600 J=ISTRT,ISTOP
            K=JA(J)
            IF(K.GT.N) THEN
            ELSEIF(K.GE.I) THEN
              Y(K)=Y(K)+A(L)*X(I)
            END IF
            L=L+1
 600      CONTINUE
          ISTOP=ISTRT-1
          JSTOP=JSTRT-1
          ISTRT=JA(KK)
          JSTRT=ISTRT-NJA
          KK=KK-1
 500    CONTINUE
        DO 700 I=1,N
          X(I)=Y(I)
 700    CONTINUE
      END IF
      RETURN
      END
