* SUBROUTINE UXTPGB                ALL SYSTEMS                93/12/01
C PORTABILITY : ALL SYSTEMS
C 93/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* BACK SUBSTITUTION FOR A DECOMPOSED TRIDIAGONAL MATRIX.
*
* PARAMETERS :
*  II  N  ORDER OF THE TRIDIAGONAL MATRIX T.
*  RI  D(N)  ELEMENTS OF THE DIAGONAL MATRIX D IN THE DECOMPOSITION
*         T=L*D*TRANS(L).
*  RI  E(N)  SUBDIAGONAL ELEMENTS OF THE LOWER TRIANGULAR MATRIX L IN
*         THE DECOMPOSITION T=L*D*TRANS(L).
*  RU  X(N)  ON INPUT THE RIGHT HAND SIDE OF A SYSTEM OF LINEAR
*         EQUATIONS. ON OUTPUT THE SOLUTION OF A SYSTEM OF LINEAR
*         EQUATIONS.
*  II  JOB  OPTION. IF JOB=0 THEN X:=T**(-1)*X. IF JOB>0 THEN
*         X:=L**(-1)*X. IF JOB<0 THEN X:=TRANS(L)**(-1)*X.
*
      SUBROUTINE UXTPGB(N,D,E,X,JOB)
      INTEGER N,JOB
      REAL*8  D(N),E(N),X(N)
      INTEGER I
      IF (JOB.GE.0) THEN
C
C     PHASE 1 : X:=L**(-1)*X
C
      DO 1 I=2,N
      X(I)=X(I)-X(I-1)*E(I-1)
    1 CONTINUE
      ENDIF
      IF (JOB.EQ.0) THEN
C
C     PHASE 2 : X:=D**(-1)*X
C
      DO 2 I=1,N
      X(I)=X(I)/D(I)
    2 CONTINUE
      ENDIF
      IF (JOB.LE.0) THEN
C
C     PHASE 3 : X:=TRANS(L)**(-1)*X
C
      DO 3 I=N-1,1,-1
      X(I)=X(I)-X(I+1)*E(I)
    3 CONTINUE
      ENDIF
      RETURN
      END
