* SUBROUTINE UXTPMG                ALL SYSTEMS                03/12/01
C PORTABILITY : ALL SYSTEMS
C 03/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  GERSHGORIN BOUNDS FOR EIGENVALUES OF A DENSE SYMMETRIC MATRIX.
*  AMIN .LE. ANY EIGENVALUE OF A .LE. AMAX.
*
* PARAMETERS :
*  II  N  DIMENSION OF THE MATRIX A.
*  RU  D(N)  ON INPUT DIAGONAL ELEMENTS OF THE TRIDIAGONAL MATRIX T.
*         ON OUTPUT ELEMENTS OF THE DIAGONAL MATRIX D IN THE
*         DECOMPOSITION T=L*D*TRANS(L).
*  RU  E(N)  ON INPUT SUBDIAGONAL ELEMENTS OF THE TRIDIAGONAL MATRIX T.
*         ON OUTPUT SUBDIAGONAL ELEMENTS OF THE LOWER TRIANGULAR MATRIX L
*         IN THE DECOMPOSITION T=L*D*TRANS(L).
*  RO  AMIN  LOWER BOUND FOR EIGENVALUES OF A.
*  RO  AMAX  UPPER BOUND FOR EIGENVALUES OF A.
*
      SUBROUTINE UXTPMG(N,D,E,AMIN,AMAX)
      INTEGER  N
      REAL*8  D(N),E(N),AMIN,AMAX
      REAL*8 TEMP
      INTEGER I
      REAL*8 ZERO
      PARAMETER (ZERO=0.0D 0)
      AMAX=D(1)
      AMIN=D(1)
      DO 3 I=1,N
      TEMP=ZERO
      IF (I.GT.1) TEMP=TEMP+ABS(E(I-1))
      IF (I.LT.N) TEMP=TEMP+ABS(E(I))
      AMAX=MAX(AMAX,D(I)+TEMP)
      AMIN=MIN(AMIN,D(I)-TEMP)
    3 CONTINUE
      RETURN
      END
