* SUBROUTINE UXULIN                ALL SYSTEMS                99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* LINEAR COMBINATION OF TWO VECTORS.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  A  SCALING FACTOR.
*  RI  X(N)  INPUT VECTOR.
*  RI  B  SCALING FACTOR.
*  RI  Y(N)  INPUT VECTOR.
*  RO  Z(N)  OUTPUT VECTOR WHERE Z:= A*X + B*Y.
*  II  IX(N)  VECTOR CONTAINING TYPES OF BOUNDS.
*  II  JOB  OPTION. IF JOB.GT.0 THEN INDEX I IS NOT USED WHENEVER
*         IX(I).LE.-1. IF JOB.LT.0 THEN INDEX I IS NOT USED WHENEVER
*         IX(I).EQ.-5.
*
      SUBROUTINE UXULIN(N,A,X,B,Y,Z,IX,JOB)
      INTEGER N,IX(N),JOB
      REAL*8  A, X(N), B, Y(N), Z(N)
      INTEGER I
      IF (JOB.EQ.0) THEN
      DO 1 I=1,N
      Z(I) = A*X(I) + B*Y(I)
    1 CONTINUE
      ELSE IF (JOB.GT.0) THEN
      DO 2 I=1,N
      IF (IX(I).GE. 0) Z(I) = A*X(I) + B*Y(I)
    2 CONTINUE
      ELSE
      DO 3 I=1,N
      IF (IX(I).NE.-5) Z(I) = A*X(I) + B*Y(I)
    3 CONTINUE
      ENDIF
      RETURN
      END
