* FUNCTION UXUVDP                  ALL SYSTEMS                99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE NUMBER UXUVDP=TRANS(X)*D**(-1)*Y WHERE D IS A
* DIAGONAL MATRIX STORED AS A VECTOR.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  D(N)  DIAGONAL MATRIX STORED AS A VECTOR.
*  RI  X(N)  INPUT VECTOR.
*  RI  Y(N)  INPUT VECTOR.
*  II  IX(N)  VECTOR CONTAINING TYPES OF BOUNDS.
*  II  JOB  OPTION. IF JOB.GT.0 THEN INDEX I IS NOT USED WHENEVER
*         IX(I).LE.-1. IF JOB.LT.0 THEN INDEX I IS NOT USED WHENEVER
*         IX(I).EQ.-5.
*  RR  UXUVDP  VALUE OF DOT PRODUCT UXUVDP=TRANS(X)*Y.
*
      FUNCTION UXUVDP(N,D,X,Y,IX,JOB)
      INTEGER N,IX(N),JOB
      REAL*8 D(N),X(N),Y(N),UXUVDP
      DOUBLE PRECISION TEMP
      INTEGER I
      REAL*8 ZERO
      PARAMETER (ZERO = 0.0D 0)
      TEMP = ZERO
      IF (JOB.EQ.0) THEN
      DO 1 I=1,N
      TEMP=TEMP+X(I)*Y(I)/D(I)
    1 CONTINUE
      ELSE IF (JOB.GT.0) THEN
      DO 2 I=1,N
      IF (IX(I).GE. 0) TEMP=TEMP+X(I)*Y(I)/D(I)
    2 CONTINUE
      ELSE
      DO 3 I=1,N
      IF (IX(I).NE.-5) TEMP=TEMP+X(I)*Y(I)/D(I)
    3 CONTINUE
      ENDIF
      UXUVDP=TEMP
      RETURN
      END
