* SUBROUTINE UXVTRS                ALL SYSTEMS                03/12/01
C PORTABILITY : ALL SYSTEMS
C 03/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETERMINATION OF A SCALING FACTOR FOR THE BOUNDARY STEP.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  DEL  MAXIMUM STEPSIZE.
*  RI  X(N)  INTERIOR VECTOR.
*  RI  Y(N)  DIRECTION VECTOR OR EXTERIOR VECTOR.
*  RU  ALF  SCALING FACTOR FOR THE BOUNDARY STEP.
*  II  INT  CHOICE OF THE INTERIOR VECTOR AND THE DIRECTION VECTOR.
*         INTERIOR VECTOR IS EQUAL TO ZERO IF INT=0 OR X OTHERWISE.
*         DIRECTION VECTOR IS EQUAL TO Y IF INT>0 OR Y-X OTHERWISE.
*
      SUBROUTINE UXVTRS(N,DEL,X,Y,ALF,INT)
      INTEGER N,INT
      REAL*8 DEL,X(N),Y(N),ALF
      REAL*8 VINT,VDIF
      INTEGER I,IPOM
      IPOM= 1
      IF (ALF.LT.0.0D 0) THEN
      IPOM=-1
      ALF=-ALF
      ENDIF
      DO 1 I=1,N
      IF (INT.EQ.0) THEN
      VINT=0.0D 0
      ELSE
      VINT=X(I)
      ENDIF
      IF (INT.GE.0) THEN
      VDIF=Y(I)
      ELSE
      VDIF=Y(I)-VINT
      ENDIF
      IF (IPOM.LT.0) VDIF=-VDIF
      IF (VDIF.GT.0.0D 0) THEN
      ALF=MIN(ALF,( DEL-VINT)/VDIF)
      ELSE IF (VDIF.LT.0.0D 0) THEN
      ALF=MIN(ALF,(-DEL-VINT)/VDIF)
      ENDIF
    1 CONTINUE
      IF (IPOM.LT.0) ALF=-ALF
      RETURN
      END
