* SUBROUTINE UYADS0                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* NEW SIMPLE BOUNDS ARE ADDED TO THE ACTIVE SET.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RI  XL(NF)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RI  XU(NF)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  RI  EPS9  TOLERANCE FOR ACTIVE CONSTRAINTS.
*  II  MOT  SPECIFICATION OF RESTART AFTER CHANGE OF ACTIVE
*         CONSTRAINTS. MOT=1-RESTART AFTER EACH CHANGE OF ACTIVE
*         CONSTRAINTS. MOT=2-NO RESTART.
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*  IO  INEW  INDEX OF THE NEW ACTIVE CONSTRAINT.
*
* SUBPROGRAMS USED :
*  S   ULNEWS  IDENTIFICATION OF ACTIVE BOUNDS.
*  S   UYRES1  DEFINITION OF THE RESTART VARIABLES.
*
      SUBROUTINE UYADS0(NF,X,IX,XN,XL,XU,EPS9,MOT,NORMF,INEW)
      INTEGER NF,IX(NF),MOT,NORMF,INEW
      REAL*8  X(NF),XN(NF),XL(NF),XU(NF),EPS9
      INTEGER I
      INEW=0
      DO 1 I=1,NF
      CALL ULNEWS(NF,X,IX,XN,XL,XU,EPS9,NORMF,I,INEW)
      IF (IX(I).GT.10) IX(I)=10-IX(I)
    1 CONTINUE
      IF (INEW.LT.0.AND.MOT.EQ.1) CALL UYRES1('ADD CONS')
      RETURN
      END
