* SUBROUTINE UYTSUD             ALL SYSTEMS                   98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* UPDATE OF THE NONBASICS AND SUPERBASICS AFTER QP STEP.
*
* PARAMETERS :
*  II  N NUMBER OF VARIABLES.
*  II  MCOLS  NUMBER OF VARIABLES DECLARED.
*  II  M SIZE OF THE BASIS.
*  RI  X(MCOLS)  VECTOR OF VARIABLES.
*  IU  BCOL(MCOLS) NUMBERS OF THE BASIC ,SUPERBASIC AND NONBASIC COLUMNS.
*  IU  INBCOL(MCOLS) VECTOR WITH COMPONENTS :
*                INBCOL(K)=I WHEN EXISTS K=BCOL(I) AND I<=NS,
*                INBCOL(K)=0 OTHERWISE.
*  II  TYPE(MCOLS) TYPES OF THE VARIABLES:
*                                    =1 FOR NONBASIC LOWER BOUNDED
*                                    =2 FOR NONBASIC UPPER BOUNDED
*                                    =3 FOR NONBASIC LOWER AND UPPER
*                     BOUNDED VARIABLE SET TO ITS LOWER BOUND
*                                    =4 FOR NONBASIC LOWER AND UPPER
*                     BOUNDED VARIABLE SET TO ITS UPPER BOUND
*                                    =5 FOR NONBASIC FIXED VARIABLE
*                                    =6 FOR NONBASIC FREE VARIABLE
*                                    =-1 FOR BASIC LOWER BOUNDED
*                                    =-2 FOR BASIC UPPER BOUNDED
*                                    =-3 FOR BASIC LOWER AND UPPER
*                     BOUNDED VARIABLE
*                                    =-6 FOR BASIC FREE VARIABLE.
*  RI  LB(MCOLS) LOWER BOUNDS FOR SOLUTION.
*  RI  UB(MCOLS) UPPER BOUNDS FOR SOLUTION.
*  RI  EPS7 TOLERANCE ON THE ACTIVITY OF THE SUPERBASICS.
*  RI  EPS9 ZERO TOLERANCE USED AS THE CRITERION OF THE PASIVITY
*           OF THER VARIABLES OF THE SUPERBASIS.
*  IU  LINP SIZE OF THE BASIS + SIZE OF THE SUPERBASIS.
*
      SUBROUTINE UYTSUD(N,MCOLS,M,X,BCOL,INBCOL,TYPE,LB,UB,EPS7,EPS9,
     & LINP)
      INTEGER NS,ISB,ISP(20),ISD(20),KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI(7)
      COMMON /UMOPTI/ NS,ISB,ISP,ISD,KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI
      REAL*8 TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR(12)
      COMMON /UMOPTR/ TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR
      REAL*8 ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS(2)
      COMMON /UMCONS/ ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS
      CHARACTER*4 TSS(20)
      CHARACTER*8 TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,TUXX,
     & TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT(3)
      CHARACTER*80 TER
      COMMON /UMOPTT/ TSS,TER,TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,
     & TUXX,TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT
      CHARACTER*6 NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN
      CHARACTER*14 NAME
      COMMON /UMOPTN/ NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN,NAME
      INTEGER N,MCOLS,M,BCOL(MCOLS),INBCOL(MCOLS),TYPE(MCOLS),LINP
      REAL*8 X(MCOLS),LB(MCOLS),UB(MCOLS),EPS7,EPS9
      INTEGER I,J1,K,L,NBB,NSB,NMX,TYPV
      EPS9=1.0D-9
      EPS7=1.0D-7
      NBB=0
      NSB=0
      NMX=0
C
C DEGENERATE BASICS ARE DETERMINED
C
C      DO 100 I=1,M
C        J=BCOL(I)
C        TYPV=TYPE(J)
C        IF(TYPV.EQ.-1.OR.TYPV.EQ.-3) THEN
C          IF((X(J)-LB(J)).LE.EPS9) THEN
C            NMX=NMX+1
C            WN01(NMX)=I
C          ENDIF
C        ENDIF
C        IF(TYPV.EQ.-2.OR.TYPV.EQ.-3) THEN
C          IF((UB(J)-X(J)).LE.EPS9) THEN
C            NMX=NMX+1
C            WN01(NMX)=I
C          ENDIF
C        ENDIF
C 100  CONTINUE
C      NBB=NMX
C
C EXCHANGE OUT OF THE SUPERBASIS
C
      DO 150 I=M+1,LINP
        J1=BCOL(I)
        TYPV=TYPE(J1)
        IF(TYPV.EQ.1.OR.TYPV.EQ.3) THEN
          IF((X(J1)-LB(J1)).LE.EPS9) THEN
            NSB=1
          ENDIF
        ENDIF
        IF(TYPV.EQ.2.OR.TYPV.EQ.4) THEN
          IF((UB(J1)-X(J1)).LE.EPS9) THEN
            NSB=1
          ENDIF
        ENDIF
C
C COLUMN OUT
C
        IF(NSB.EQ.1) THEN
          K=BCOL(LINP)
          BCOL(LINP)=J1
          BCOL(I)=K
          INBCOL(K)=I
          INBCOL(J1)=0
          LINP=LINP-1
        ENDIF
 150  CONTINUE
C
C EXCHANGE INTO SUPERBASIS
C
      DO 200 I=LINP+1,N
        J1=BCOL(I)
        TYPV=TYPE(J1)
        IF(TYPV.EQ.1.OR.TYPV.EQ.3) THEN
          IF((X(J1)-LB(J1)).GE.EPS7) THEN
            NSB=1
          ENDIF
        ENDIF
        IF(TYPV.EQ.2.OR.TYPV.EQ.4) THEN
          IF((UB(J1)-X(J1)).GE.EPS7) THEN
            NSB=1
          ENDIF
        ENDIF
        IF(NSB.EQ.1) THEN
          LINP=LINP+1
          L=BCOL(LINP)
          BCOL(LINP)=J1
          BCOL(I)=L
          INBCOL(J1)=LINP
          IF(I.GT.LINP) THEN
            INBCOL(L)=0
          ELSE
            INBCOL(L)=I
          END IF
        END IF
 200  CONTINUE
      RETURN
      END
