$INTERFACE U1FSL1                                             97/12/01
$REM TU

  $PTR='ICG'
  $CNR='JCG'
  $AU='CG'
  $N='NF'
  $HESR='S'
  $IF(MODEL='AF') $HESR='B'
  $IF(MODEL='AQ') $HESR='B'
  $IF(MODEL='AP') $HESR='B'
  $ADD(REAL,'\UXVDOT')
  $ADD(INTEGER,'\IMD\KBFPOM')
  $HELP
    LOWER BOUND FOR CONSTRAINT VIOLATION
  $CHECK(TOLC,'1.0$P-6',REAL,3)
  $TYPE='L'
  $HELP
    TYPE OF METHOD:
      L - LINE SEARCH
      G - GENERAL TRUST REGION
  $CHECK(TYPE,'L','L\G',2,NO)
  $DECOMP='M'
  $NUMBER=3
  $IF(TYPE='G')
    $HELP
      CHOICE OF THE VARIABLE METRIC UPDATE AFTER ZERO STEP:
        0 - NO UPDATE
        1 - NORMAL UPDATE
    $CHECK(MOT3,0,'0\1',4)
  $ELSE
    $HELP
      CHOICE OF THE INITIAL STEPSIZE:
        1-UNIT INITIAL STEPSIZE
        2-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR VM METHODS
        3-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR CG METHODS
        4-QUADRATICALLY ESTIMATED INITIAL STEPSIZE
    $CHECK(INITS,2,'1\2\3\4',4)
  $ENDIF
  $HELP
    CHOICE OF THE INITIAL APPROXIMATION OF THE HESSIAN
    MATRIX:
      0 - INITIAL APPROXIMATION IS SPECIFIED IN THE CALLING
          PROGRAM
      1 - UNIT INITIAL APPROXIMATION
      2 - RANDOM INITIAL APPROXIMATION
  $CHECK(INITH,1,'0\1\2',4)
  $IF(HESR='B')
    $HELP
      TYPE OF SPARSE UPDATE:
        M - BASIC MARWILL UPDATE
        B - PARTITIONED VARIABLE METRIC UPDATES
    $CHECK(UPDATE,'M','M\B',3,NO)
    $IF(UPDATE='B')
      $IF($DEF(MET3))
        $IF(MET3=3) $MET3=1
      $ENDIF
      $SUBST('UFSET2')
      $ISNA=2
      $ADD(INIT)
        ISNA=2
      $ENDADD
    $ELSE
      $HESR='S'
    $ENDIF
  $ELSE
    $UPDATE='M'
  $ENDIF
  $HELP
    CORRECTION OF APPROXIMATION OF HESSIAN MATRIX
    AFTER CHANGE OF BASIS:
      1 - RESTART
      2 - CORRECTION
  $CHECK(MLC,2,'1\2',3)
  $HELP
    TOLERANCE FOR DESCENT DIRECTION
  $CHECK(EPS0,'1.0$P-8',REAL,4)
  ISNC=0
  MCL=M
  HDEL=XMAX
  KBFPOM=KBF
  $NF='$MCOLS'
  CALL UXVINS(NF,0,$LENR)
  IF (KBF.LE.0) CALL UXVINS(NF,0,$IX)
    $ICS=IC
    $CLS=CL
    $CUS=CU
    $IF(KBC>0)
      $IC='ICC'
      CALL UXVICP(NC,$ICS,$IC)
      $ADD(INTEGER,'\$ICS($MROWS)')
      $CL='CCL'
      CALL UXVCOP(NC,$CLS,$CL)
      $ADD(REAL,'\$CLS($MROWS)')
    $ENDIF
    $IF(KBC>1)
      $CU='CCU'
      CALL UXVCOP(NC,$CUS,$CU)
      $ADD(REAL,'\$CUS($MROWS)')
    $ENDIF
  $KD=1
  KD=1
  JOUT=1
  $SUBST('UO0FU1')
  $IF(MODEL='FQ')
*
*     -----------------
*     MODEL DESCRIPTION
*     -----------------
*
    $HELP
      LOWER BOUND FOR FUNCTION VALUE
    $CHECK(FMIN,'-$ETA9',REAL,3)
    $GQ='GQ'
    $HQ='HQ'
    $ADD(REAL,'\$HQ($M)\$GQ($NF)\FQ')
    FQ=FF
    CALL UXVCOP(NF,$GF,$GQ)
    CALL UXVCOP($IH(NF+1)-1,$HF,$HQ)
    $IF(IEXT=0)
      $G=GF
      $H=HF
    $ENDIF
    CALL UF1FQ2(NF,$IH(NF+1)-1,$X,$GQ,$G,$HQ,$IH,$JH,FQ,F)
*
*     ------------------------
*     END OF MODEL DESCRIPTION
*     ------------------------
*
  $ELSE
    $SUBST('UZMODL')
  $ENDIF
  MFP=1
  LCS=0
  JOUT=1
  $SUBST('UKLINM')
  $SUBST('UKSGLM')
  ITERM=ITERL
  IF (ITERM.GE.0) THEN
  $SUBST('UKLNF4')
  CALL UYCMAX(NC,$CF,$ICS,$CLS,$CUS,CMAX)
  IF (CMAX.GE.TOLC) THEN
  CALL UOERR1('U1FSQ1',89)
  ITERM=-89
  ENDIF
  ENDIF
  CALL UYSET2
  $SUBST('UZLIND')
  LINP=M
  MFP=2
  ITERQ=0
*
*     ------------------------------------------------------
*     RECURSIVE QUADRATIC PROGRAMMING VARIABLE METRIC METHOD
*     TEMPLATE : U1FSL1
*     ------------------------------------------------------
*
  $LMD=$10
  ASSIGN $30 TO IMD
  CALL UYPRO1('UXFU',1)
  CALL UYPRO2(FMIN,FO)
  IF (ITERM.GE.0) THEN
  ITERM=0
  ELSE
  GO TO $90
  ENDIF
$L=$10 ; $LABEL
  $KD=1 ; $IF(INITH=3) $KD=2
  $IF(MODEL='FQ')
*
*     -----------------
*     MODEL DESCRIPTION
*     -----------------
*
    $IF(IEXT=0)
      $G=GF
    $ENDIF
    CALL UF1FQ2(NF,$IH(NF+1)-1,$X,$GQ,$G,$HQ,$IH,$JH,FQ,F)
*
*     ------------------------
*     END OF MODEL DESCRIPTION
*     ------------------------
*
  $ELSE
    $SUBST('UZMODL')
  $ENDIF
  $IF(KDS<1)
  $ELSE
    IF (TSS(NS).EQ.'USXX') P=UXVDOT(NF,$G,$S)
  $ENDIF
  GO TO IMD
$L=$ 30 ; $LABEL
  $SUBST('UYTSLM')
  $SUBST('UYTSSG')
  $IF(NORMF=0) $GN=G
  $SUBST('UO2FU3')
  $SUBST('UYFUT1')
  IF(ITERM.NE.0) GOTO $90
$L=$ 40 ; $LABEL
  $SUBST('UU$(HESR)SD1')
  IF (ITERM.NE.0) GOTO $90
  $IF($DEF(MCG))
    $IF(MCG<>0)
      $IF(MCG1=2)
        $SUBST('UYCP$(CON)D')
      $ENDIF
    $ENDIF
  $ENDIF
  $SUBST('UYT$(HESR)UH')
  $G='G'
  KBF=0
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UDSSQ$(NUMBER)
*     -----------------------
*
  $SUBST('UDSSQ$(NUMBER)')
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
$REM  XMAX=HDEL
  KBF=KBFPOM
  $G='GF'
  $SN='S'
  $SUBST('UD1T$(TYPE)1')
  $SN='SN'
  IF(ITERM.NE.0) GOTO $90
  IF(IREST.NE.0) GOTO $40
  $SUBST('UYTRUS')
  $IF(HESR='B') CALL UXVCOP(MA,$AG,$AGO)
$L=$ 70 ; $LABEL
  ASSIGN $70 TO IMD
  $SUBST('UZLINS')
  GOTO ($74,$72) ISB+1
$L=$ 72 ; $LABEL
  CALL UXVDIR(NF,R,$S,$XO,$X)
  GOTO $10
$L=$ 74 ; $LABEL
  IF (ITERS.LE.0) THEN
  $IF(KDS<1)
    $SUBST('UYZER0')
  $ELSE
    $SUBST('UYZER1')
    $IF(HESR='B') CALL UXVCOP(MA,$AGO,$AG)
  $ENDIF
  IF(IDIR.EQ.0) THEN
  CALL UYRES1(TSXX)
  CALL UYSET1
  GO TO $40
  ELSE IF (MOT3.EQ.0) THEN
  CALL UYSET1
  GO TO $40
  ELSE
  ITERD=0
  ENDIF
  ENDIF
  IF(KD.GT.LD) THEN
  ASSIGN $80 TO IMD
  GO TO $10
  ENDIF
$L=$ 80 ; $LABEL
  TXFU=TUXX
  $IF($DEF(MCG))
    $IF(MCG<>0)
      $IF(MCG1=2)
        $SUBST('UYUP$(CON)D')
      $ENDIF
    $ENDIF
  $ENDIF
  KBF=0
  $SUBST('UYTSUD')
  $IF(HESR='S')
    $SUBST('UYTRUD')
    $SUBST('UUS$(UPDATE)M1')
  $ELSE
    $SUBST('UYTAUD')
    IDECF=0
    $IHLP=1
    $IF(MET=4) $IHLP=2
    $SUBST('UUB$(UPDATE)M$(IHLP)')
  $ENDIF
  KBF=KBFPOM
  GOTO $30
$L=$ 90 ; $LABEL
  XMAX=HDEL
  IF(ITERM.LT.0) TXFU=TDXX
  CALL UYEPI1(1)
  $IF(KBC>0) $IC=ICS
  $IF(KBC>0) $CL=CLS
  $IF(KBC>1) $CU=CUS
  $SUBST('UKLNF4')
  $SUBST('UYCMAX')
  FF=F
  $SUBST('UO1FU2')
  M=MCL
  $ADD(INIT)
    NXFU='U1FSL1'
  $ENDADD
  $EXIT

