$INTERFACE U1FSU5                                             04/12/01
$REM VL

  $PREC='1.0D-4'
  $AM=AG
  $MAM=MA
  $AX='AX'
  $AY='AY'
  $AZ='AZ'
  $AGP='AGP'
  $N='NF'
  $HERF='S'
  $HESR='B'
  $IF(CONSTR='S')
    $CONSTR='C'
    $ADD(REAL,'\UXUDOT')
  $ELSE
    $ADD(REAL,'\UXVDOT')
  $ENDIF
  $ADD(REAL,'\ALFN\ALFV\GAM\DF\POM\ZET\FZET')
  $ADD(REAL,'\UXVSAB\UXVNOR')
  $HELP
    MAXIMUM NUMBER OF TESTS ON STEPLENGTH
  $CHECK(MTESX,10,INT,4)
  $HELP
    MAXIMUM NUMBER OF TESTS ON FUNCTION DECREASE
  $CHECK(MTESF,10,INT,4)
  $HELP
    TYPE OF PROBLEM:
      0 - CONVEX PROBLEM
      1 - NONCONVEX PROBLEM
  $CHECK(MEX,1,'0\1',3)
  $IF(MEX=0)
    $ETA5='0.0$P 0'
  $ELSE
    $HELP
      LOCALITY MEASURE EXPONENT (SEE MANUAL UFO)
        1 - EXPONENT ONE
        2 - EXPONENT TWO
    $CHECK(MOS3,2,'1\2',3)
    $HELP
      MEASURE OF NONCONVEXITY
    $CHECK(ETA5,'0.25$P 0',REAL,3)
  $ENDIF
  $HELP
    TYPE OF DIRECTION VECTOR CORRECTION
      0 - BASIC ALGORITHM
      1 - RESTART IF THE DIRECTION VECTOR IS SHORT
      2 - CONTROLLED CORRECTION OF THE DIRECTION VECTOR
      3 - PERMANENT  CORRECTION OF THE DIRECTION VECTOR
  $CHECK(MEX1,0,'0\1\2\3',3)
  $HELP
    TERMINATION CRITERION:
      0 - BASIC CRITERION
      1 - EXTENDED CRITERION FOR LARGE PROBLEMS
  $CHECK(MEX2,0,'0\1',3)
  $HELP
    TERMINATION OR EXTRAPOLATION AFTER ZERO DIFFERENCE OF GRADIENTS:
      0 - TERMINATION
      1 - EXTRAPOLATION WITH CONSTANT STEPSIZE
      2 - EXTRAPOLATION WITH INCREASING STEPSIZE
  $CHECK(MEX3,0,'0\1\2',3)
  $HELP
    MATRIX SCALING:
      0 - MATRIX SCALING SUPPRESED
      1 - MATRIX SCALING USED
  $CHECK(MET1,0,'0\1',3)
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,'1.0$P-12',REAL,4)
  $IF(MEX1>1)
    $HELP
      CORRECTION PARAMETER
    $CHECK(ETA3,'1.0$P-12',REAL,4)
  $ENDIF
  $ADD(INTEGER,'\JC\JE\JR\NNK\NNV\IRT\MAM')
  $ADD(INTEGER,'\IMD')
  $HELP
    NUMBER OF BUNDLE POINTS:
  $CHECK(MB,20,INT,2,NO)
  $IF(MB<=0) $MB=20
  $IF(MODEL='AM')
    $HELP
      REDUCTION OF THE BARRIER PARAMETER
    $CHECK(ETA4,'8.5$P-1',REAL,4)
$REM    $HELP
$REM      MINIMUM VALUE OF THE BARRIER PARAMETER
$REM    $CHECK(ETA5,'0.0$P 0',REAL,4)
    $AZL='AZL'
    $AZU='AZL'
    $ADD(REAL,'\TOLP')
    $ADD(INTEGER,'\NACOM\IEXC\NNIT')
    $IF(IEXT=0)
      $AZU='AZU'
      $ADD(REAL,'\$AZL($NA)\$AZU($NA)\BARP\PARAM\UNFUZ1')
      $SET(SINIC)
        COMMON /UMFUZ1/ $AF,$AZL,$AZU,BARP,PARAM,NACOM,IEXC
        EXTERNAL UNFUZ1
      $ENDSET
    $ELSE
      $ADD(REAL,'\$AZL($NA)\BARP\PARAM\UNFUZ1')
      $SET(SINIC)
        COMMON /UMFUZ1/ $AF,$AZL,BARP,PARAM,NACOM,IEXC
        EXTERNAL UNFUZ1
      $ENDSET
    $ENDIF
  $ENDIF
  $ADD(INIT)
    MB=$MB
  $ENDADD
  $TYPE='L'
  $DECOMP='M'
  $NUMBER=1
  $KDS=1
  $IF(TYPE='L')
    $LCS=0
    $IF(MEX=0)
      $STEP=7
      $CON1='2.0$P 0'
      $CON2='1.0$P 0'
    $ELSE
      $STEP=8
      $CON1='1.0$P 2'
      $CON2='1.0$P-1'
    $ENDIF
    $MES3=0
    $HELP
      CHOICE OF THE INITIAL STEPSIZE:
        1-UNIT INITIAL STEPSIZE
        2-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR VM METHODS
        3-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR CG METHODS
        4-QUADRATICALLY ESTIMATED INITIAL STEPSIZE
    $CHECK(INITS,1,'1\2\3\4',4)
  $ENDIF
  $HELP
    CHOICE OF THE INITIAL APPROXIMATION OF THE HESSIAN
    MATRIX:
      0 - INITIAL APPROXIMATION IS SPECIFIED IN THE CALLING
          PROGRAM
      1 - UNIT INITIAL APPROXIMATION
      2 - RANDOM INITIAL APPROXIMATION
  $CHECK(INITH,1,'0\1\2',4)
  $UPDATE='V'
  $IF(UPDATE='V')
    $SUBST('UFSET2')
    $ISNA=2
    $ADD(INIT)
      ISNA=2
    $ENDADD
  $ELSE
    $HESR='S'
  $ENDIF
  $HELP
    RESTART SPECIFICATION. RESTART IS PERFORMED AFTER
    IRES1*N+IRES2 ITERATIONS.
  $CHECK(IRES1,111,INT,4)
  $HELP
    RESTART SPECIFICATION. RESTART IS PERFORMED AFTER
    IRES1*N+IRES2 ITERATIONS.
  $CHECK(IRES2,999,INT,4)
  $ADD(INIT)
    ISNA=$ISNA
  $ENDADD
  $HELP
    CORRECTION OF APPROXIMATION OF HESSIAN MATRIX
    AFTER CHANGE OF BASIS:
      1 - RESTART
      2 - CORRECTION
  $CHECK(MLC,2,'1\2',3)
  NDECF=0
  $SUBST('UFSET1')
$REM  $IF(MODEL='AM') $SUBST('UASET2')
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
$REM  N=NF
  $IF(NAL>0)
    $MAL='$NAL'
    $ADD(INIT)
      MAL=NAL
    $ENDADD
    $JOB=1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $IF(CONSTR='C') $SUBST('UYFPC1')
  $IF(NUMBER=1)
    $SUBST('UYSFSH')
  $ENDIF
  $DEC='G'
  IF (ITERM.NE.0) GO TO $90
*
*     -----------------------------
*     BUNDLE VARIABLE METRIC METHOD
*     TEMPLATE : U1FSU5
*     -----------------------------
*
  $LMD=$10
  ASSIGN $20 TO IMD
  CALL UYPRO1('UXFU',1)
  CALL UYPRO2(FMIN,FO)
  NB=0
  MB=$MB
  IF (MB.GT.NF) MB=NF+3
  JR=0
  $IF(MEX=1)
    JE=0
  $ENDIF
  NNK=0
  NNV=0
  $IF(MET1>0)
    GAM=ONE
  $ENDIF
  $IF(MODEL='AM')
    IEXC=IEXT
    NACOM=NA
    RPF3=ONE
$REM    IF (ETA5.LE.ZERO) THEN
    TOLP=ETA0**(TWO/THREE)
$REM    ELSE
$REM      TOLP=ETA5
$REM    ENDIF
  $ENDIF
$L=$10 ; $LABEL
  $KD=1 ; $IF(INITH=3) $KD=2
  $SUBST('UZMODN')
  $IF(KDS<1)
  $ELSEIF(CONSTR='C')
    IF(TSS(NS).EQ.'USXX') P=UXUDOT(NF,$G,$S,$IX,KBF)
  $ELSE
    IF(TSS(NS).EQ.'USXX') P=UXVDOT(NF,$G,$S)
  $ENDIF
  GO TO IMD
$L=$ 20 ; $LABEL
  DF=ABS(F)+ONE
  $SUBST('UYBUN1')
$L=$ 30 ; $LABEL
  ITES=-1
  IF (ITERS.GT.0) THEN
  JC=0
  ALFN=ZERO
  ALFV=ZERO
  CALL UXVCOP(NF,$G,$GP)
  ENDIF
  $GH=G
  $G=GP
  $SUBST('UYTR$(CONSTR)G')
  $SUBST('UO2FU3')
  $SUBST('UYFUT5')
  IF (ITERM.NE.0) GO TO $90
  $IF(CONSTR='C')
$REM    GMAX=XNORM
    $SUBST('UYRM$(CONSTR)0')
  $ENDIF
  $G=GH
$L=$ 40 ; $LABEL
  $SUBST('UU$(HESR)SD1')
  IF (ITERM.NE.0) GO TO $90
  $IF(CONSTR='C')
    CALL UXVINB(NF,M,$IX,$JH)
    $IF(HESR='B') CALL UXVINB(NF,MA,$IX,$JAG)
  $ENDIF
  $IF(HESR='B')
    $HELP
      MAXIMUM SIZE OF THE PARTITIONED HESSIAN MATRIX
    $CHECK(MAH,'25*$NA',INT,1)
    CALL UXVSET($IH(NF+1)-1,ZERO,$H)
    $IF(MODEL='AM')
      NACOM=NA
      IEXC=IEXT
      BARP=RPF3
      PARAM=PAR
      IF (F+RPF3.GT.F) THEN
      $ZL='F+RPF3'
      $IF(IEXT=0)
        $ZU='F+RPF3*DBLE(2*NA)'
      $ELSE
        $ZU='F+RPF3*DBLE(NA)'
      $ENDIF
      NNIT=20
      CALL UNNEQ1($ZL,$ZU,ZET,FZET,UNFUZ1,ZERO,MIN(ETA3,TOLG),NNIT,IER)
      ELSE
      ZET=(ONE+ETA0)*F
      FZET=UNFUZ1(ZET)
      ENDIF
      CALL UFSEX4(NF,NA,MA,MAH,M,$H,$IH,$JH,$AH,$IAG,$JAG,$AZL,$AZU&
,IEXT)
    $ELSE
      CALL UFSET4(NF,NA,NAL,MA,MAH,M,$H,$IH,$JH,$AH,$IAG,$JAG)
    $ENDIF
    $ADD(INTEGER,'\$IH($NF+1)\$JH($M)\$IAG($NA+1)\$JAG($MA)')
    $ADD(REAL,'\$H($M)\$AH($MAH)')
$REM    $SUBST('UFSET4')
  $ENDIF
  $SUBST('UYTS$(CONSTR)H')
  $IF(MEX=1)
    IF (JE.GT.0) GO TO $50
  $ENDIF
  $MAT='G'
  $DEC='G'
  $DECOMG='G'
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UD$(MAT)$(TYPE)$(DECOMG)$NUMBER
*     -----------------------
*
  $SUBST('UD$(MAT)$(TYPE)$(DECOMG)$NUMBER')
  $IF(MEX1=3)
    JC=1
  $ELSEIF(MEX1=2)
    IF (-UXVDOT(NF,GP,S).LE.1.0D-10*GNORM**2) JC=1
  $ENDIF
  $IF(MEX1>1)
    IF (JC.EQ.1) THEN
    CALL UXVDIR(NF,-ETA3,GP,S,S)
    $IF(CONSTR='C')
      SNORM=SQRT(UXUDOT(NF,S,S,IX,KBF))
    $ELSE
      SNORM=SQRT(UXVDOT(NF,S,S))
    $ENDIF
    ENDIF
  $ENDIF
  TXFU=TDXX
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
  $IF(TYPE='L')
    $SUBST('UD1T$(TYPE)1')
    $IF(MEX1=1)
      IF(SNORM.LE.ETA0*GNORM) THEN
      CALL UYRES1('ZERO DIR')
      ENDIF
    $ENDIF
    IF (ITERS.EQ.0) IREST=0
    IF (SNORM.LE.ZERO) IREST=0
  $ENDIF
  IF (ITERM.NE.0) GO TO $90
  IF (IREST.NE.0) GO TO $40
  XNORM=-P+TWO*ALFV
  $IF(MODEL='AM')
    RPF3=MIN(ETA4*RPF3,XNORM)
    RPF3=MAX(RPF3,TOLP,ETA0*ABS(FF))
  $ENDIF
$L=$ 50 ; $LABEL
  $SUBST('UYFUT6')
  IF (ITERM.NE.0) GO TO $90
  $IF(MEX=0)
    POM=1.0$P-4*XNORM
  $ENDIF
  $IF(TYPE='L')
    IF (SNORM.GT.ZERO) RMAX=XMAX/SNORM
    RMIN=MIN(1.0$P-10,RMAX/TEN)
  $ENDIF
  $SUBST('UYTR$(CONSTR)S')
  $IF(CONSTR='C')
    IF (RMAX.EQ.ZERO) GO TO $85
  $ENDIF
  $IF(HESR='B') CALL UXVCOP(MA,$AG,$AGO)
  IF (RMAX.LE.RMIN) THEN
  R=ZERO
  GO TO $85
  ENDIF
$L=$ 60 ; $LABEL
  ASSIGN $60 TO IMD
  $SUBST('UZLINS')
  GO TO ($64,$62) ISB+1
$L=$ 62 ; $LABEL
  $IF(CONSTR='C')
    $IF(TYPE='G')
      CALL UXVDIR(NF,R,$S,$XO,$X)
    $ELSE
      CALL UXUDIR(NF,R,$S,$XO,$X,$IX,KBF)
    $ENDIF
    $SUBST('UCBS04')
  $ELSE
    CALL UXVDIR(NF,R,$S,$XO,$X)
  $ENDIF
  GO TO $10
$L=$ 64 ; $LABEL
  TXFU=TSXX
  IF(KD.GT.LD) THEN
  ASSIGN $80 TO IMD
  GO TO $10
  ENDIF
$L=$ 80 ; $LABEL
  $LMF=$90
  $SUBST('UYFUT7')
  $SUBST('UYBUN1')
  $IF(MET1>0)
    IF (RP.LT.SQRT($ETA9)) THEN
    GAM=(MAX($CON2,MIN(1.0$P 2,RP))+TWO*GAM)/THREE
    ENDIF
    IRT=0
  $ENDIF
  IF (ITERS.EQ.0) THEN
  NNK=NNK+1
  $IF(MEX=0)
    ALFN=ABS((FO-F)/R+P)
  $ELSE
    ALFN=MAX(ABS(FO-F+P*R),ETA5*(SNORM*R)**MOS3)
  $ENDIF
  MAM=MA
  IF (NNK.EQ.1) THEN
  $SUBST('UYAB$(CONSTR)2')
  ELSE
  $SUBST('UYAB$(CONSTR)1')
  ENDIF
  F=FO
  ELSE
  NNK=0
  $IF(MET1>0)
    IF (GAM.GT.ONE) JR=JR+1
    IF (GAM.GT.TEN.AND.NNV.GT.3.AND.JR.GT.1) THEN
*
*     MATRIX SCALING
*
    NNV=0
    JR=0
    CALL UXVSCL(MAH,GAM,$AH,$AH)
    GAM=SQRT(GAM)
    IRT=1
    ENDIF
  $ENDIF
  ENDIF
  POM=P
  $SUBST('UYTR$(CONSTR)D')
  $IF(CONSTR='C') CALL UXVINB(NF,M,$IX,$JH)
  P=POM
  POM=UXVSAB(NF,$GO)
  $IF(MET1>0)
    IF (IRT.GT.0) THEN
    IF (POM.NE.ZERO) JE=0
    GO TO $85
    ENDIF
  $ENDIF
  $IF(MEX=0)
    $KHLP='1.0D-5*SNORM**2'
  $ELSE
    IF (POM.EQ.ZERO.AND.ITERS.GT.0) THEN
    $IF(MEX3=0)
      ITERM=6
      TXFU='ZERO DIF'
      GO TO $90
    $ELSE
      JE=JE+1
      $IF(MEX3=1)
        IF (JE.GT.1) JE=99
      $ENDIF
      GO TO $85
    $ENDIF
    ELSE
    JE=0
    ENDIF
    $KHLP='ZERO'
  $ENDIF
  TXFU=TUXX
  TUXX='SKIP UP.'
  POM=UXVDOT(NF,$XO,$GO)
  IF (POM.GT.R*$KHLP.AND.ABS(POM).GT.1.0$P-6*UXVNOR(NF,XO)&
*UXVNOR(NF,GO)) THEN
  $IF(HESR='B')
    IDECF=0
  $ENDIF
  $SUBST('UU$(HESR)$(UPDATE)I2')
  ENDIF
$L=$ 85 ; $LABEL
  $IF(CONSTR='C') $SUBST('UYADC0')
  GO TO $30
$L=$ 90 ; $LABEL
  GMAX=XNORM
  CALL UYEPI1(1)
  $IF(NAL>0)
    $JOB=-1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $SUBST('UO1FU2')
  $ADD(INIT)
    NXFU='U1FSU5'
  $ENDADD
  $IF(MODEL='AM')
$REM    $ADD(SINIT)
$REM      $SUBST('UASET1')
$REM    $ENDADD
    $ADD(SUBROUTINES)
      FUNCTION UNFUZ1(Z)
      INTEGER NACOM,IEXC
      $IF(IEXT=0)
        $FLOAT $AF($NA),$AZL($NA),$AZU($NA),BARP,PARAM
        COMMON /UMFUZ1/ $AF,$AZL,$AZU,BARP,PARAM,NACOM,IEXC
      $ELSEIF(IEXT<0)
        $FLOAT $AF($NA),$AZU($NA),BARP,PARAM
        COMMON /UMFUZ1/ $AF,$AZU,BARP,PARAM,NACOM,IEXC
      $ELSEIF(IEXT>0)
        $FLOAT $AF($NA),$AZL($NA),BARP,PARAM
        COMMON /UMFUZ1/ $AF,$AZL,BARP,PARAM,NACOM,IEXC
      $ENDIF
      $FLOAT Z,UNFUZ1,RHO
      INTEGER KA
      UNFUZ1=1.0$P 0
      DO 1 KA=1,NACOM
      $IF(IEXT<=0)
        $AZU(KA)=BARP/(Z-$AF(KA))
        UNFUZ1=UNFUZ1-$AZU(KA)
      $ENDIF
      $IF(IEXT>=0)
        $AZL(KA)=BARP/(Z+$AF(KA))
        UNFUZ1=UNFUZ1-$AZL(KA)
      $ENDIF
  1   CONTINUE
      RETURN
      END
    $ENDADD
  $ENDIF
  $EXIT
