$INTERFACE U1QDL1                                             97/12/01
$REM LU

  $TYPE='L'
  $HELP
    METHOD
      1 - PRIMAL NULL SPACE QUADRATIC PROGRAMMING METHOD
      2 - PRIMAL RANGE SPACE QUADRATIC PROGRAMMING METHOD
      3 - DUAL RANGE SPACE QUADRATIC PROGRAMMING METHOD
  $CHECK(NUMBER,1,'1\2\3',2,NO)
  $HELP
    PRECISION FOR EITHER LINEAR OR QUADRATIC PROGRAMMING SUBROUTINE
  $CHECK(EPS7,'1.0$P-10',REAL,4)
  $HELP
    TOLERANCE FOR ACTIVE CONSTRAINTS
  $CHECK(EPS9,'1.0$P-8',REAL,4)
  $KD=2
  $ADD(INIT)
    MFP=2
    NXFU='U1QDL1'
  $ENDADD
  KD=2
  JOUT=1
  IF(ABS(KOUT).EQ.2) KOUT=SIGN(4,KOUT)
$REM  IF(ABS(MOUT).EQ.1) MOUT=SIGN(3,MOUT)
  IF(ABS(MOUT).EQ.2) MOUT=SIGN(4,MOUT)
  $SUBST('UO0FU1')
  $SUBST('UZMODL')
  $IF(NORMF>0)
    ITERS=1
    $SUBST('UYTRUG')
    $SUBST('UYTRUH')
  $ENDIF
  $IF(NCL>0)
    $MCL='$NCL'
     MCL=NCL
    $JOB=1
    $IF(NORMC>0) $SUBST('UCNRL1')
    $SUBST('UCLNF2')
    $IF(NORMF>0) $SUBST('UCTRL1')
  $ENDIF
*
*     -----------------------
*     PROJECTED NEWTON METHOD
*     TEMPLATE : U1QDL1
*     -----------------------
*
   LCS=0
  $IXA='IX'
  $JOB=0
  $IF(NUMBER=1)
    $SUBST ('ULQPB1')
  $ELSEIF(NUMBER=2)
    $SUBST ('ULQPB2')
  $ELSE
    $SUBST ('ULQDB1')
    $ADD(REAL,'\$X($NF)\$XO($NF)\$CF($NC)\$CG($NF*$MCL)\$S($NF)')
  $ENDIF
  $ADD(INIT)
    NDXX=NQPX
  $ENDADD
  $IF(NCL>0)
    $JOB=-1
    $IF(NORMF>0) $SUBST('UCTRL1')
    $IF(NORMC>0) $SUBST('UCNRL1')
  $ENDIF
  ITERM=ITERQ
  NIT=NRED
  NFV=2
  CALL UYSET2
  $SUBST('UZMODL')
  FF=F
  KDC=0
  ISNC=1
  $SUBST('UO1FN2')
$EXIT

