$INTERFACE U1QSL1                                             97/12/01
$REM TU
  $PTR='ICG'
  $CNR='JCG'
  $AU='CG'
  $TYPE='L'
  $HELP
    METHOD
      1 - PRIMAL NULL SPACE QUADRATIC PROGRAMMING METHOD
      2 - PRIMAL RANGE SPACE QUADRATIC PROGRAMMING METHOD
  $CHECK(NUMBER,2,'1\2',2,NO)
  $HELP
    LOWER BOUND FOR CONSTRAINT VIOLATION
  $CHECK(TOLC,'1.0$P-6',REAL,3)
  $HELP
    PRECISION FOR EITHER LINEAR OR QUADRATIC PROGRAMMING SUBROUTINE
  $CHECK(EPS7,'1.0$P-7',REAL,4)
  $HELP
    TOLERANCE FOR LAGRANGE MULTIPLIERS
  $CHECK(EPS8,'1.0$P-8',REAL,4)
  $HELP
    TOLERANCE FOR ACTIVE CONSTRAINTS
  $CHECK(EPS9,'1.0$P-9',REAL,4)
  ISNC=0
  $ADD(INIT)
    $ISNC=ISNC
  $ENDADD
  $KD=1
  $ADD(INIT)
    MFP=2
    NXFU='U1QSL1'
  $ENDADD
  KD=1
  JOUT=1
  IF(ABS(KOUT).EQ.2) KOUT=SIGN(4,KOUT)
$REM  IF(ABS(MOUT).EQ.1) MOUT=SIGN(3,MOUT)
  IF(ABS(MOUT).EQ.2) MOUT=SIGN(4,MOUT)
  $SUBST('UO0FU1')
  $SUBST('UZMODL')
  $IF(NCL>0)
    $IF(NUMBER=1) $NC=MCOLS
    $MCL=NCL
     MCL=NCL
    $JOB=1
    $IF(NORMC>0) $SUBST('UCNRL3')
    $IF(NUMBER=2) $SUBST('UCLNF4')
    $IF(NORMF>0) $SUBST('UCTRL3')
    $IF(NUMBER=1) $NC=NCL
  $ENDIF
  LCS=0
  $IXA='IX'
*
*     ------------------------------
*     SPARSE SIMPLEX TYPE QP METHODS
*     TEMPLATE : U1QSL1
*     ------------------------------
*
  $IF(NUMBER=1)
    $HELP
      UPPER BOUND FOR FUNCTION VALUE
    $CHECK(FMAX,'1.0$P 20',REAL,4)
    $HELP
      MAXIMUM NUMBER OF EXTRAPOLATIONS OR INTERPOLATIONS
    $CHECK(MRED,10,INT,4)
    CALL UXVSET(MCOLS-NF,ZERO,$GF(NF+1))
    CALL UXVSET(MCOLS-NF,ZERO,$G(NF+1))
    MFP=1
    $ICS=IC
    $CLS=CL
    $CUS=CU
    $IF(KBC>0)
      $IC='ICC'
      CALL UXVICP(NC,$ICS,$IC)
      $ADD(INTEGER,'\$ICS($MROWS)')
      $CL='CCL'
      CALL UXVCOP(NC,$CLS,$CL)
      $ADD(REAL,'\$CLS($MROWS)')
    $ENDIF
    $IF(KBC>1)
      $CU='CCU'
      CALL UXVCOP(NC,$CUS,$CU)
      $ADD(REAL,'\$CUS($MROWS)')
    $ENDIF
    $SUBST('UKLINM')
    $SUBST('UKSGLM')
    IF (ITERM.GE.0) THEN
    $SUBST('UKLNF4')
    CALL UYCMAX(NC,$CF,$ICS,$CLS,$CUS,CMAX)
    IF (CMAX.GE.TOLC) THEN
    CALL UOERR1('UKSGLM',89)
    TDXX='INFEAS  '
    ITERM=-89
    ENDIF
    ENDIF
    IF (ITERM.GE.0) THEN
    CALL UYSET2
    LINP=M
    $SUBST('UZMODL')
    NFV=NFV+1
    MFP=2
    CALL UXVINS(MCOLS-NF,$IH(NF+1),$IH(NF+1))
    $SUBST('UKQGLM')
    NIT=NRED+NAQ
    ITERM=ITERQ
    $SUBST('UKLNF4')
    CALL UYCMAX(NC,$CF,$ICS,$CLS,$CUS,CMAX)
    IF (CMAX.GE.TOLC) THEN
    CALL UOERR1('UKQGLM',89)
    TDXX='INFEAS  '
    ITERM=-89
    ENDIF
    ENDIF
    $IF(KBC>0) $IC=ICS
    $IF(KBC>0) $CL=CLS
    $IF(KBC>1) $CU=CUS
    $ADD(INIT)
      NDXX='UKQGLM'
    $ENDADD
    GMAX=GNORM
    NF=NFL
    NC=NCL
  $ELSE
    $DEFAULT='20*($NF+$NC)'
    $HELP
      LENGTH OF WORK SPACE
    $CHECK(MMAX,DEFAULT,INT,1)
    $IF(KBC=1) $CU=CL
    $REPEAT
      $HELP
        LENGTH OF WORK SPACE
      $CHECK(MMAX,0,INT,1)
      $IF(MMAX=0)
        $IF(DIALOG>0)
          $ERASE(MMAX)
        $ELSE
          $ERROR: 'MMAX' - LACK OF WORK SPACE FOR SPARSE
                           DIRECT METHODS
          $STOP
        $ENDIF
      $ENDIF
    $UNTIL($DEF(MMAX))
    $JOB=0
    $SUBST('UMQPB2')
    IF (KBF.GT.0) CALL UXVINA(NF,IX)
    ITERM=ITERQ
    CALL UYCMAX(NC,$CF,$IC,$CL,$CU,CMAX)
  $ENDIF
  $ADD(INIT)
    NDXX=NQPX
  $ENDADD
  $IF(NCL>0)
    $IF(NUMBER=1) $NC=MCOLS
    $IF(NUMBER=2) CALL UXVINA(NC,IC)
    $JOB=-1
    $IF(NORMF>0) $SUBST('UCTRL3')
    $IF(NORMC>0) $SUBST('UCNRL3')
    $IF(NUMBER=1) $NC=NCL
    NIT=NRED
  $ENDIF
  NFV=2
  CALL UYSET2
  $SUBST('UZMODL')
  IF (ITERQ.EQ.-2) THEN
  TXFU='INFINITY'
  ELSE IF (ITERQ.EQ.-1) THEN
  TXFU='INFEAS  '
  ELSE IF (ITERQ.EQ.1) THEN
  TXFU='FEASIBLE'
  ELSE IF (ITERQ.EQ.2) THEN
  TXFU='OPTIMUM '
  ELSE
  TXFU=TDXX
  ENDIF
  KDC=0
  ISNC=1
  $SUBST('UO1FN2')
$EXIT

