$INTERFACE U1QSL2                                             99/12/01
$REM LU

  $N='NF'
  $NN='NC'
  $RDEL='ONE'
  $IF(KBF>0)
    $XSL='XSL'
    $XZL='XZL'
    $XSU='XSU'
    $XZU='XZU'
    $IF(KBF<2)
      $XU=XL
      $XSU=XSL
      $XZU=XZL
    $ENDIF
  $ELSE
    $XSL=X
    $XZL=X
    $XSU=X
    $XZU=X
  $ENDIF
  $IF(KBC>0)
    $CSL='CSL'
    $CZL='CZL'
    $CSU='CSU'
    $CZU='CZU'
    $IF(KBC<2)
      $CU=CL
      $CSU=CSL
      $CZU=CZL
    $ENDIF
  $ELSE
    $NC=1
    $CSL=CF
    $CZL=CF
    $CSU=CF
    $CZU=CF
  $ENDIF
  $NCA='($NX+$NC)'
  $HERF='S'
  $HELP
    INITIAL VALUE OF SLACK VARIABLES
  $CHECK(EPS7,'1.0$P-1',REAL,4)
  $HELP
    INITIAL VALUE OF LAGRANGE MULTIPLIERS
  $CHECK(EPS8,'1.0$P-1',REAL,4)
  $ADD(REAL,'\$CFO($NC+1)\$CFD($NC+1)\RMAXP\RMAXD')
  $ADD(INTEGER,'\IMD')
  $ADD(REAL,'\UXUDOT')
  $ADD(REAL,'\UXVDOT')
  $CONSTR='U'
  $TYPE='L'
  $MERIT='P'
  $DECOMP='I'
  $ISNC=2
  $ADD(INIT)
    ISNC=2
  $ENDADD
  $HELP
     METHOD
       1 - EXACT SOLUTION WITH BUNCH PARLETT DECOMPOSITION
       3 - INEXACT SOLUTION BY SMOOTHED CONJUGATE GRADIENT
           METHOD
  $CHECK(NUMBER,3,'1\3',2,NO)
  $IF(NUMBER=1) $MOS2=0
  $HELP
    PRECONDITIONING THE KARUSH-KUHN-TUCKER SYSTEM
           0 - PRECONDITIONING IS SUPPRESSED
     -1 OR 1 - INDEFIFITE PRECONDITIONING BASED ON A DIAGONAL
               APPROXIMATION OF THE HESSIAN MATRIX
    MOS2 > 0 - COMPLETE CHOLESKI DECOMPOSITION
    MOS2 < 0 - INCOMPLETE CHOLESKI DECOMPOSITION
  $CHECK(MOS2,1,'-1\0\1',3)
  $NOS2=0
  $IF(MOS2= 1) $NOS2=1
  $IF(MOS2=-1) $NOS2=1
  $HELP
    IP FORMULATION
      1 - PRIMAL
      2 - PRIMAL-DUAL
  $CHECK(MOS5,2,'1\2',4)
  $HELP
    BARRIER COEFFICIENT
  $CHECK(RPF3,'1.0$P 0',REAL,3)
  $KDS=0
  $MEP1=1
  $HELP
    MERIT FUNCTION
      0 - MERIT FUNCTION IS NOT USED
      1 - L2 AUGMENTED BARRIER FUNCTION
  $CHECK(MEP,0,'0\1',2)
  $IF(MEP=0) $KTERS=6
  $HELP
    STRATEGY FOR PRIMAL AND DUAL STEPSIZES
      0      - UCISTP
     -1 OR 1 - R, MIN(R,RMAXP), MIN(R,RMAXD)
     -2 OR 2 - R, MIN(R,RMAXP), MIN(R,RMAXP,RMAXD)
     -3 OR 3 - R, MIN(R,RMAXP,RMAXD), MIN(R,RMAXP,RMAXD)
    MEP2 > 0 - R <= RMAX
    MEP2 < 0 - R <= MIN(RMAX, RMAXP)
  $CHECK(MEP2,0,'-3\-2\-1\0\1\2\3',4)
  $IF(MEP2= 1) $NEP2=1
  $IF(MEP2=-1) $NEP2=1
  $IF(MEP2= 2) $NEP2=2
  $IF(MEP2=-2) $NEP2=2
  $IF(MEP2= 3) $NEP2=3
  $IF(MEP2=-3) $NEP2=3
  $HELP
    CHOICE OF THE BARRIER COEFFICIENT
      1 - VANERBEI AND SHANNO
      2 - EL-BAKRY
  $CHECK(MEP3,1,'1\2',4)
  $HELP
    TYPE OF REGULARIZATION
      0 - NO REGULARIZATION
      1 - REGULARIZATION BY GILL-MURRAY DECOMPOSITION
  $CHECK(MEP4,0,'0\1',4)
  $IF(MEP4=0)
    $ED=S
  $ELSE
    $ED='ED'
    $ADD(REAL,'\$ED($NCA)')
  $ENDIF
  $IF(MEP>0) $MES5=1
  $HELP
    RESTART IN THE CASE OF UNSUITABLE DIRECTION
      0 - RESTART SUPPRESED
      1 - UNIFORM DESCENT ASSURED
  $CHECK(MES5,0,'0\1',4)
  $STEP=1
  $HELP
    CHOICE OF THE INITIAL STEPSIZE:
      1-UNIT INITIAL STEPSIZE
      2-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
        STEPSIZE FOR VM METHODS
      3-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
        STEPSIZE FOR CG METHODS
      4-QUADRATICALLY ESTIMATED INITIAL STEPSIZE
  $CHECK(INITS,1,'1\2\3\4',4)
  $DEFAULT='0.99$P 0'
  $IF(MEP=1) $DEFAULT='0.95$P 0'
  $HELP
    COEFFICIENT FOR COMPUTING PRIMAL AND DUAL MAXIMUM
    STEPSIZES
  $CHECK(ETA6,DEFAULT,REAL,3)
  $HELP
    MAXIMUM STEPSIZE FOR LAGRANGE MULTIPLIERS
  $CHECK(UMAX,'1.0$P 6',REAL,3)
  $MCL=NC
   MCL=NC
  $GN='GF'
  $SN='S'
  NDECF=0
  $SUBST('UFSET1')
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
  $IF(NAL>0)
    $MAL=NAL
     MAL=NAL
    $JOB=1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $IF(NCL>0)
    $JOB=1
    $IF(NORMC>0) $SUBST('UCNRL3')
    $IF(NORMF>0) $SUBST('UCTRL3')
  $ENDIF
  $JOB=NUMBER
*
*     --------------------------------
*     SPARSE INTERIOR POINT QP METHODS
*     TEMPLATE : U1QSL2
*     --------------------------------
*
  $LMD=$10
  ASSIGN $20 TO IMD
  CALL UYPRO1('UXFU',2)
  CALL UYPRO2(FMIN,FO)
  IF (KBF.GT.0) CALL UXVINI(NF,$IX)
  MOT=0
  T=ZERO
  R=ZERO
  IPOM1=0
  IF (ITERM.NE.0) GO TO $80
$L=$ 10 ; $LABEL
  $KD=2
  $SUBST('UP2LQ5')
  IF (TSS(NS).EQ.'UUXX') THEN
  ELSE IF (TSS(NS).EQ.'UXFU') THEN
  ELSE
  $IF(MEP=0)
    F=CF(NC+1)
  $ELSE
    $IF(MEP2=0)
      $SUBST('UP0BF2')
    $ELSE
      $SUBST('UP0BF1')
    $ENDIF
  $ENDIF
  $IF(KDS<1)
  $ELSE
    IF (TSS(NS).EQ.'USXX') P=UXUDOT(NF,$G,$S,$IX,-KBF)
  $ENDIF
  ENDIF
  GO TO IMD
$L=$ 20 ; $LABEL
  NCA=0
$L=$ 30 ; $LABEL
  $SUBST('UYTS$(CONSTR)G')
  $SUBST('UO2FN4')
  $SUBST('UYFUT2')
  IF (GMAX.LE.TOLG.AND.CMAX.LE.TOLC.AND.RPF3.LE.ETA0) THEN
  ITERM=4
  TXFU='GRAD TOL'
  ENDIF
$REM  IF (ITERM.EQ.1.AND.ABS(F).GE.1.0$P 10) THEN
  IF (.FALSE.) THEN
  CALL UOERR1('U1QSL2',88)
  ITERM=-88
  TDXX='LIN. DEP.'
  ENDIF
  IF (ITERM.NE.0) GO TO $80
$L=$ 40 ; $LABEL
  $IF(KBF>0)
    CALL UXVINF(NF,M,$IX,$JH)
    CALL UXVINF(NF,MC,$IX,$JCG)
  $ENDIF
  $SUBST('UYTS$(CONSTR)H')
$REM  $TYP=TYPE
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UDS$(TYPE)$(DECOMP)$(NUMBER)
*     -----------------------
*
  $SUBST('UDS$(TYPE)$(DECOMP)$(NUMBER)')
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
  $SUBST('UD1T$(TYPE)3')
  $IF(MEP2=0)
  $ELSE
  CALL UCIMAX(NF,NX,NC,NCA,$X,$IX,$XL,$XU,$XSL,$XSU,$XZL,$XZU,$CFD,$IC&
,$CL,$CU,$CSL,$CSU,$CZL,$CZU,$ICA,$S,$GS(NF+1),$XO(NF+1),$GO(NF+1),RMAX&
,RMAXP,RMAXD,ETA6)
    $IF(MEP2<0)
      RMAX=MIN(RMAX,RMAXP)
    $ENDIF
  $ENDIF
  $IF(KBF>0)
    CALL UXVINE(M,$JH)
    CALL UXVINE(MC,$JCG)
    $IF(MODELA='YES') CALL UXVINE(MA,$JAG)
  $ENDIF
  $IF(MEP=0)
    F=CF(NC+1)
  $ELSE
    $IF(MEP2=0)
      $SUBST('UP0BF2')
    $ELSE
      $SUBST('UP0BF1')
    $ENDIF
  $ENDIF
  IF (ITERM.NE.0) GO TO $80
$REM  IF (IREST.NE.0) GO TO $40
  IF (NIT.EQ.LIT+1) KIT=NIT
$L=$ 50 ; $LABEL
  $SUBST('UYTR$(CONSTR)S')
  CALL UXVCOP(NC+1,$CF,$CFO)
$L=$ 60 ; $LABEL
  ASSIGN $60 TO IMD
  $SUBST('UZLINS')
  GOTO ($64,$62) ISB+1
$L=$ 62 ; $LABEL
  CALL UXUDIR(NF,R,$S,$XO,$X,$IX,-KBF)
  ISNC=1
  GOTO $10
$L=$ 64 ; $LABEL
  IF (ITERS.LE.0) THEN
  $IF(KDS<1)
    $SUBST('UYZER0')
  $ELSE
    $SUBST('UYZER1')
  $ENDIF
  CALL UXVCOP(NC+1,$CFO,$CF)
  IF (IDIR.EQ.0) CALL UYRES1(TSXX)
  CALL UYSET1
$REM  GOTO $40
  ENDIF
  $IF(MEP2=0)
    CALL UCISTP(NF,NX,NC,NCA,$XO,$IX,$XL,$XU,$XSL,$XSU,$XZL,$XZU,$CF&
,$CFD,$IC,$CL,$CU,$CSL,$CSU,$CZL,$CZU,$ICA,$S,$GS(NF+1),$XO(NF+1)&
,$GO(NF+1),R,ETA6,$MEP1)
  $ELSE
    RMAXP=MIN(R,RMAXP)
    RMAXD=MIN(R,RMAXD)
    $IF(NEP2=2)
      RMAXD=MIN(RMAXP,RMAXD)
    $ENDIF
    $IF(NEP2=3)
      RMAXD=MIN(RMAXP,RMAXD)
      RMAXP=RMAXD
    $ENDIF
    CALL UCIDIR(NF,NX,NC,NCA,$XO,$IX,$XL,$XU,$XSL,$XSU,$XZL,$XZU,$CF&
,$CFD,$IC,$CL,$CU,$CSL,$CSU,$CZL,$CZU,$ICA,$S,$GS(NF+1),$XO(NF+1)&
,$GO(NF+1),R,RMAXP,RMAXD,$RDEL,$MEP1)
  $ENDIF
  CALL UODLI5(R,RMAX,RMAXP,RMAXD)
  $BPAR=MEP3
  $SUBST('UPSEB$BPAR')
$REM      RPF3=MIN(RPF3,(ONE/TEN)**(NIT-LIT)/TEN)
  IF (KD.GT.LD) THEN
  ASSIGN $70 TO IMD
  GO TO $10
  ENDIF
$L=$ 70 ; $LABEL
  TXFU=TUXX
  TUXX='NEWTON  '
  $SUBST('UYTRED')
  GOTO $30
$L=$ 80 ; $LABEL
  IF(ITERM.LT.0) TXFU=TDXX
  CALL UYEPI1(2)
  $IF(NAL>0)
    $JOB=-1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $IF(NCL>0)
    $JOB=-1
    $IF(NORMF>0) $SUBST('UCTRL3')
    $IF(NORMC>0) $SUBST('UCNRL3')
  $ENDIF
$REM  $TYPE=TYP
  $SUBST('UCTRF3')
  $SUBST('UO1FN2')
  $ADD(INIT)
    NXFU='U1QSL2'
  $ENDADD
  $EXIT
