$INTERFACE U2FDU1                                             97/12/01
$REM LU

$N='N'
$HERF='D'
$ADD(REAL,'\UXVDOT')
$ADD(INTEGER,'\IMD')
$IF(CONSTR='U')
  $HELP
    TYPE OF METHOD:
      L - LINE SEARCH
      G - GENERAL TRUST REGION
      R - CUBIC REGULARIZATION
  $CHECK(TYPE,'G','L\G\R',2,NO)
  $IF(TYPE='L')
    $HELP
      MATRIX DECOMPOSITION
        M - NO DECOMPOSITION
        G - GILL-MURRAY DECOMPOSITION WITHOUT PERMUTATIONS
        S - SCHNABEL-ESKOV DECOMPOSITION WITH PERMUTATIONS
        B - BUNCH-PARLETT  DECOMPOSITION WITH PERMUTATIONS
    $CHECK(DECOMP,'G','M\G\S\B',2,NO)
    $IF(DECOMP='M')
      $HELP
        METHOD
          1 - THE MODIFIED NEWTON STEP USING THE GILL
              AND MURRAY DECOMPOSITION
          2 - SWITCH BETWEEN THE NEWTON AND THE CG METHODS
          3 - INEXACT SOLUTION BY CONJUGATE GRADIENT METHOD
      $CHECK(NUMBER,1,'1\2\3',2,NO)
    $ELSE
      $HELP
        METHOD
          1 - THE MODIFIED NEWTON STEP USING THE GILL
              AND MURRAY DECOMPOSITION
          2 - SWITCH BETWEEN THE NEWTON AND THE CG METHODS
      $CHECK(NUMBER,1,'1\2',2,NO)
    $ENDIF
  $ELSEIF(TYPE='G')
    $HELP
      MATRIX DECOMPOSITION
        M - NO DECOMPOSITION
        G - GILL-MURRAY DECOMPOSITION WITHOUT PERMUTATIONS
        S - SCHNABEL-ESKOV DECOMPOSITION WITH PERMUTATIONS
        B - BUNCH-PARLETT  DECOMPOSITION WITH PERMUTATIONS
    $CHECK(DECOMP,'M','M\G\S\B',2,NO)
    $IF(DECOMP='M')
      $HELP
         METHOD
           1 - SINGLE DOG-LEG STRATEGIES
           2 - MULTIPLE DOG-LEG STRATEGY
           3 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
           4 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
               WITH THE LANCZOS STEPS
           5 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
               WITH THE LANCZOS STEPS
           6 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
               WITH THE LANCZOS STEPS
           7 - OPTIMUM LOCALLY CONSTRAINED STEP
      $CHECK(NUMBER,7,'1\2\3\4\5\6\7',2,NO)
    $ELSE
      $HELP
         METHOD
           1 - SINGLE DOG-LEG STRATEGIES
           2 - MULTIPLE DOG-LEG STRATEGY
      $CHECK(NUMBER,1,'1\2',2,NO)
    $ENDIF
  $ELSEIF(TYPE='R')
    $HELP
      MATRIX DECOMPOSITION
        M - NO DECOMPOSITION
    $CHECK(DECOMP,'M','M',2,NO)
    $HELP
      METHOD
        7 - OPTIMUM LOCALLY CONSTRAINED STEP
    $CHECK(NUMBER,7,'7',2,NO)
  $ENDIF
$ELSE
  $HELP
    TYPE OF METHOD:
      L - LINE SEARCH
      G - GENERAL TRUST REGION
  $CHECK(TYPE,'G','L\G\',2,NO)
  $IF(TYPE='L')
    $HELP
      MATRIX DECOMPOSITION
        M - NO DECOMPOSITION
        G - GILL-MURRAY DECOMPOSITION WITHOUT PERMUTATIONS
    $CHECK(DECOMP,'G','M\G',2,NO)
    $IF(DECOMP='M')
      $HELP
         METHOD
           1 - EXACT SOLUTION BY THE GILL-MURRAY DECOMPOSITION
           3 - INEXACT SOLUTION BY CONJUGATE GRADIENT METHOD
      $CHECK(NUMBER,1,'1\3',2,NO)
    $ELSE
      $NUMBER=1
    $ENDIF
  $ELSEIF(TYPE='G')
    $HELP
      MATRIX DECOMPOSITION
        M - NO DECOMPOSITION
        G - GILL-MURRAY DECOMPOSITION WITHOUT PERMUTATIONS
    $CHECK(DECOMP,'M','M\G',2,NO)
    $IF(DECOMP='M')
      $HELP
         METHOD
           1 - SINGLE DOG-LEG STRATEGIES
           2 - MULTIPLE DOG-LEG STRATEGY
           3 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
           4 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
               WITH THE LANCZOS STEPS
           5 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
               WITH THE LANCZOS STEPS
           6 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
               WITH THE LANCZOS STEPS
           7 - OPTIMUM LOCALLY CONSTRAINED STEP
      $CHECK(NUMBER,7,'1\2\3\4\5\6\7',2,NO)
    $ELSE
      $HELP
         METHOD
           1 - SINGLE DOG-LEG STRATEGIES
           2 - MULTIPLE DOG-LEG STRATEGY
      $CHECK(NUMBER,1,'1\2',2,NO)
    $ENDIF
  $ENDIF
$ENDIF
  $IF(TYPE='L')
    $HELP
      CHOICE OF THE INITIAL STEPSIZE:
        1-UNIT INITIAL STEPSIZE
        2-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR VM METHODS
        3-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR CG METHODS
        4-QUADRATICALLY ESTIMATED INITIAL STEPSIZE
    $CHECK(INITS,2,'1\2\3\4',4)
  $ENDIF
  $HELP
    CHOICE OF THE SCALING MATRIX:
      0 - UNIT MATRIX
      1 - SQUARE OF DIAGONAL OF THE MATRIX H
  $CHECK(MOS1,0,'0\1',4)
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,'ETA0*1.0$P 2',REAL,4)
  NDECF=0
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
  $IF(NAL>0)
    $MAL=NAL
     MAL=NAL
    $JOB=1
    $IF(NORMA>0) $SUBST('UANRL1')
  $ENDIF
  $IF(NCL>0)
    $MCL=NCL
     MCL=NCL
    $ISNC=3
    $ADD(INIT)
      ISNC=3
    $ENDADD
    $JOB=1
    $IF(NORMC>0) $SUBST('UCNRL1')
    $IF(NORMF>0) $SUBST('UCTRL1')
    $SUBST('UCLNF2')
  $ENDIF
  $IF(CONSTR<>'U') $SUBST('UYFP$(CONSTR)1')
*
*     -----------------
*     NEWTON METHOD
*     TEMPLATE : U2FDU1
*     -----------------
*
  $LMD=$10
  ASSIGN $20 TO IMD
  CALL UYPRO1('UXFU',2)
  CALL UYPRO3(0)
  MOT=0
  T=ZERO
  FO=FMIN
  IPOM1=0
$L=$10 ; $LABEL
  $KD=2
  $SUBST('UZMODN')
  $IF(KDS<1)
  $ELSE
    IF (TSS(NS).EQ.'USXX') P=UXVDOT(NF,$G,$S)
  $ENDIF
  GO TO IMD
$L=$20 ; $LABEL
  $SUBST('UYTR$(CONSTR)G')
  $SUBST('UO2FU3')
  $SUBST('UYFUT1')
  IF (ITERM.NE.0) GOTO $80
  $IF(CONSTR<>'U') $SUBST('UYRM$(CONSTR)0')
$L=$30 ; $LABEL
  $SUBST('UUDSD1')
  IF (ITERM.NE.0) GOTO $80
  $IF($DEF(MCG))
    $IF(MCG<>0)
      $IF(MCG1=1)
        $SUBST('UYCP$(CON)D')
      $ENDIF
    $ENDIF
  $ENDIF
  $SUBST('UYTR$(CONSTR)H')
  $MAT='G'
  $DEC=DECOMP
  $DECOMG=DEC
  $IF(NUMBER=1)
    $DECOMG='G'
    $IF(DEC='M')
      $HELP
         TYPE OF DECOMPOSITION
           0 - GILL-MURRAY DECOMPOSITION
           1 - SCHNABEL-ESKOW DECOMPOSITION WITH NUMERICAL PERMUTATIONS
           2 - SCHNABEL-ESKOW DECOMPOSITION WITH TWO LEVEL INDICES
      $CHECK(MOS2,0,'0\1\2',2)
      $IF(MOS2=0) $DEC='G'
      $IF(MOS2>0) $DEC='S'
    $ENDIF
  $ELSEIF(NUMBER=2)
    $DECOMG='G'
    $IF(DEC='M')
      $HELP
         TYPE OF DECOMPOSITION
           0 - GILL-MURRAY DECOMPOSITION
           1 - SCHNABEL-ESKOW DECOMPOSITION WITH NUMERICAL PERMUTATIONS
           2 - SCHNABEL-ESKOW DECOMPOSITION WITH TWO LEVEL INDICES
      $CHECK(MOS2,0,'0\1\2',2)
      $IF(MOS2=0) $DEC='G'
      $IF(MOS2>0) $DEC='S'
    $ENDIF
  $ENDIF
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UD$(MAT)$(TYPE)$(DECOMG)$(NUMBER)
*     -----------------------
*
  $SUBST('UD$(MAT)$(TYPE)$(DECOMG)$(NUMBER)')
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
  $SUBST('UD1T$(TYPE)1')
  IF(ITERM.NE.0) GOTO $80
  IF(IREST.NE.0) GOTO $30
  IF(NIT.EQ.LIT+1) KIT=NIT
$L=$40 ; $LABEL
  $SUBST('UYTR$(CONSTR)S')
  $IF(CONSTR<>'U')
    IF (RMAX.LE.ZERO) GO TO $75
  $ENDIF
$L=$50 ; $LABEL
  ASSIGN $50 TO IMD
  $SUBST('UZLINS')
  GOTO ($54,$52) ISB+1
$L=$ 52 ; $LABEL
  CALL UXVDIR(NF,R,$S,$XO,$X)
  GOTO $10
$L=$ 54 ; $LABEL
  $IF(KDA=1) LD=0
  IF (ITERS.LE.0) THEN
  $IF(KDS<1)
    $SUBST('UYZER0')
  $ELSE
    $SUBST('UYZER1')
  $ENDIF
  IF (IDIR.EQ.0) CALL UYRES1(TSXX)
  CALL UYSET1
  GOTO $30
  ENDIF
  IF(KD.GT.LD) THEN
  ASSIGN $70 TO IMD
  GO TO $10
  ENDIF
$L=$70 ; $LABEL
  TXFU=TUXX
  TUXX='NEWTON  '
  $IF(NUMBER=2)
  $SUBST('UYTRUD')
  $ELSE
  $SUBST('UYTRED')
  $ENDIF
  $IF(CONSTR<>'U')
$L=$75 ; $LABEL
    $SUBST('UYAD$(CONSTR)0')
  $ENDIF
  GOTO $20
$L=$80 ; $LABEL
  IF(ITERM.LT.0) TXFU=TDXX
  CALL UYEPI1(2)
  $IF(NAL>0)
    $JOB=-1
    $IF(NORMA>0) $SUBST('UANRL1')
  $ENDIF
  $IF(NCL>0)
    $JOB=-1
    $IF(NORMF>0) $SUBST('UCTRL1')
    $IF(NORMC>0) $SUBST('UCNRL1')
  $ENDIF
  $SUBST('UO1FU2')
  $ADD(INIT)
    NXFU='U2FDU1'
  $ENDADD
  $EXIT
