$INTERFACE U2SDU1                                             97/12/01
$REM LU

$N='N'
$HH='HH'
$ADD(REAL,'\UXVDOT')
$ADD(INTEGER,'\IMD\METS')
$HERF='D'
$IF(CONSTR='U')
  $HELP
    TYPE OF METHOD:
      L - LINE SEARCH
      G - GENERAL TRUST REGION
      T - TRUST REGION FOR LEAST SQUARES
      R - CUBIC REGULARIZATION
      M - MARQUARDT
  $CHECK(TYPE,'G','L\G\T\R\M',2,NO)
  $IF(TYPE='L')
    $IF(MODEL='AQ')
      $HELP
        MATRIX DECOMPOSITION
          M - NORMAL MATRIX
          G - GILL-MURRAY DECOMPOSITION WITHOUT PERMUTATIONS
          S - SCHNABEL-ESKOV DECOMPOSITION WITH PERMUTATIONS
          B - BUNCH-PARLETT  DECOMPOSITION WITH PERMUTATIONS
          R - RECURSIVE QR DECOMPOSITION
$REM          C - RECURSIVE QR DECOMPOSITION WITH RANK REVEALING
$REM              PERMUTATIONS
      $CHECK(DECOMP,'G','M\G\S\B\R\C',2,NO)
    $ELSE
      $HELP
        MATRIX DECOMPOSITION
          M - NORMAL MATRIX
          G - GILL-MURRAY DECOMPOSITION WITHOUT PERMUTATIONS
          S - SCHNABEL-ESKOV DECOMPOSITION WITH PERMUTATIONS
          B - BUNCH-PARLETT  DECOMPOSITION WITH PERMUTATIONS
      $CHECK(DECOMP,'G','M\G\S\B',2,NO)
    $ENDIF
    $IF(DECOMP='M')
      $HELP
         METHOD
           1 - EXACT SOLUTION BY GILL-MURRAY DECOMPOSITION
           3 - INEXACT SOLUTION BY CONJUGATE GRADIENT METHOD
      $CHECK(NUMBER,3,'1\3',2,NO)
    $ELSE
      $NUMBER=1
    $ENDIF
  $ELSEIF(TYPE='G')
    $IF(MODEL='AQ')
      $HELP
        MATRIX DECOMPOSITION
          M - NORMAL MATRIX
          G - GILL-MURRAY DECOMPOSITION WITHOUT PERMUTATIONS
          S - SCHNABEL-ESKOV DECOMPOSITION WITH PERMUTATIONS
          B - BUNCH-PARLETT  DECOMPOSITION WITH PERMUTATIONS
          R - RECURSIVE QR DECOMPOSITION
$REM          C - RECURSIVE QR DECOMPOSITION WITH RANK REVEALING
$REM              PERMUTATIONS
      $CHECK(DECOMP,'M','M\G\S\B\R\C',2,NO)
    $ELSE
      $HELP
        MATRIX DECOMPOSITION
          M - NORMAL MATRIX
          G - GILL-MURRAY DECOMPOSITION WITHOUT PERMUTATIONS
          S - SCHNABEL-ESKOV DECOMPOSITION WITH PERMUTATIONS
          B - BUNCH-PARLETT  DECOMPOSITION WITH PERMUTATIONS
      $CHECK(DECOMP,'M','M\G\S\B',2,NO)
    $ENDIF
    $IF(DECOMP='M')
      $HELP
         METHOD
           1 - SINGLE DOG-LEG STRATEGIES
           2 - MULTIPLE DOG-LEG STRATEGY
           3 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
           4 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
               WITH THE LANCZOS STEPS
           5 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
               WITH THE LANCZOS STEPS
           6 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
               WITH THE LANCZOS STEPS
           7 - OPTIMUM LOCALLY CONSTRAINED STEP
      $CHECK(NUMBER,7,'1\2\3\4\5\6\7',2,NO)
    $ELSEIF(DECOMP='B')
      $HELP
         METHOD
           1 - SINGLE DOG-LEG STRATEGIES
           2 - MULTIPLE DOG-LEG STRATEGY
      $CHECK(NUMBER,1,'1\2',2,NO)
    $ELSE
      $HELP
         METHOD
           1 - SINGLE DOG-LEG STRATEGIES
           2 - MULTIPLE DOG-LEG STRATEGY
      $CHECK(NUMBER,1,'1\2',2,NO)
    $ENDIF
  $ELSEIF(TYPE='R')
    $HELP
      MATRIX DECOMPOSITION
        M - NO DECOMPOSITION
    $CHECK(DECOMP,'M','M',2,NO)
    $HELP
      METHOD
        7 - OPTIMUM LOCALLY CONSTRAINED STEP
    $CHECK(NUMBER,7,'7',2,NO)
  $ELSEIF(TYPE='T')
    $IF(MODEL='AQ')
      $HELP
        MATRIX DECOMPOSITION
          M - NORMAL MATRIX
          G - GILL-MURRAY  DECOMPOSITION WITHOUT PERMUTATIONS
          S - SCHNABEL-ESKOV  DECOMPOSITION WITH PERMUTATIONS
          R - RECURSIVE QR DECOMPOSITION
$REM          C - RECURSIVE QR DECOMPOSITION WITH  RANK REVEALING
$REM              PERMUTATIONS
      $CHECK(DECOMP,'S','M\G\S\R\C',2,NO)
    $ELSE
      $HELP
        MATRIX DECOMPOSITION
          M - NORMAL MATRIX
          G - GILL-MURRAY  DECOMPOSITION WITHOUT PERMUTATIONS
          S - SCHNABEL-ESKOV  DECOMPOSITION WITH PERMUTATIONS
      $CHECK(DECOMP,'S','M\G\S',2,NO)
    $ENDIF
    $IF(DECOMP='M')
      $HELP
         METHOD
           1 - DOG-LEG STRATEGIES
           7 - OPTIMUM LOCALLY CONSTRAINED STEP
      $CHECK(NUMBER,7,'1\7',2,NO)
    $ELSEIF(DECOMP='G')
      $HELP
         METHOD
           1 - DOG-LEG STRATEGY
           2 - MULTIPLE DOG-LEG STRATEGY
      $CHECK(NUMBER,2,'1\2',2,NO)
    $ELSEIF(DECOMP='S')
      $HELP
         METHOD
           1 - DOG-LEG STRATEGY
           7 - OPTIMUM LOCALLY CONSTRAINED STEP WITH SPECIAL
               TRUST REGION
      $CHECK(NUMBER,7,'1\7',2,NO)
    $ELSEIF(DECOMP='C')
      $HELP
         METHOD
           1 - DOG-LEG STRATEGY
           7 - OPTIMUM LOCALLY CONSTRAINED STEP WITH SPECIAL
                TRUST REGION
      $CHECK(NUMBER,7,'1\7',2,NO)
    $ELSE
      $NUMBER=1
    $ENDIF
  $ELSE
    $DECOMP='M'
    $NUMBER=1
  $ENDIF
$ELSE
  $HELP
    TYPE OF METHOD:
      L - LINE SEARCH
      G - GENERAL TRUST REGION
      T - TRUST REGION FOR LEAST SQUARES
      M - MARQUARDT
  $CHECK(TYPE,'G','L\G\T\M',2,NO)
  $IF(TYPE='L')
    $HELP
      MATRIX DECOMPOSITION
        M - NORMAL MATRIX
        G - GILL-MURRAY DECOMPOSITION WITHOUT PERMUTATIONS
    $CHECK(DECOMP,'G','M\G',2,NO)
    $IF(DECOMP='M')
      $HELP
         METHOD
           1 - EXACT SOLUTION BY GILL-MURRAY DECOMPOSITION
           3 - INEXACT SOLUTION BY CONJUGATE GRADIENT METHOD
      $CHECK(NUMBER,3,'1\3',2,NO)
    $ELSE
      $NUMBER=1
    $ENDIF
  $ELSEIF(TYPE='G')
    $HELP
      MATRIX DECOMPOSITION
        M - NORMAL MATRIX
        G - GILL-MURRAY DECOMPOSITION WITHOUT PERMUTATIONS
    $CHECK(DECOMP,'M','M\G',2,NO)
    $IF(DECOMP='M')
      $HELP
         METHOD
           1 - SINGLE DOG-LEG STRATEGIES
           2 - MULTIPLE DOG-LEG STRATEGY
           3 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
           4 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
               WITH THE LANCZOS STEPS
           5 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
               WITH THE LANCZOS STEPS
           6 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
               WITH THE LANCZOS STEPS
           7 - OPTIMUM LOCALLY CONSTRAINED STEP
      $CHECK(NUMBER,7,'1\2\3\4\5\6\7',2,NO)
    $ELSE
      $HELP
         METHOD
           1 - SINGLE DOG-LEG STRATEGIES
           2 - MULTIPLE DOG-LEG STRATEGY
      $CHECK(NUMBER,1,'1\2',2,NO)
    $ENDIF
  $ELSEIF(TYPE='R')
      $HELP
        METHOD
          7 - OPTIMUM LOCALLY CONSTRAINED STEP
      $CHECK(NUMBER,7,'7',2,NO)
  $ELSEIF(TYPE='T')
    $DECOMP='G'
    $HELP
       METHOD
         1 - SINGLE AND DOUBLE DOG-LEG
         2 - MULTIPLE DOG-LEG
    $CHECK(NUMBER,2,'1\2',2,NO)
  $ELSE
    $DECOMP='M'
    $NUMBER=1
  $ENDIF
$ENDIF
  $IF(TYPE='L')
    $DEFAULT=0
    $IF(KDF>0) $DEFAULT=1
    $IF(KDA>0) $DEFAULT=1
    $IF(DEFAULT=1)
      $HELP
        DEGREE OF DIRECTIONAL DERIVATIVES IN LINE SEARCH:
          0 - NO DIRECTIONAL DERIVATIVES
          1 - FIRST DIRECTIONAL DERIVATIVES
          2 - FIRST DIRECTIONAL DERIVATIVES
              (WITH COMPUTED HESSIAN MATRICES)
      $CHECK(KDS,$DEFAULT,'0\1\2',4,NO)
      $IF(KDF>1) $KDS=1
      $IF(KDA>1) $KDS=1
      $IF(KDS>1)
        $IF(DECOMP='R') $KDS=1
        $IF(DECOMP='C') $KDS=1
      $ENDIF
    $ELSE
      $KDS=0
    $ENDIF
    $HELP
      CHOICE OF THE INITIAL STEPSIZE:
                0 - INITIAL STEPSIZE IS SPECIFIED IN THE CALLING PROGRAM
          -1 OR 1 - UNIT INITIAL STEPSIZE
          -2 OR 2 - COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
                    STEPSIZE (DAVIDON)
          -3 OR 3 - COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
                    STEPSIZE (STOREY )
          -4 OR 4 - QUADRATICALLY ESTIMATED INITIAL STEPSIZE
        INITS < 0 - THE PREVIOUS FUNCTION VALUE IS USED
        INITS > 0 - THE MINIMUM  FUNCTION VALUE IS USED 
    $CHECK(INITS,-2,'-4\-3\-2\-1\1\2\3\4',4)
    $HELP
      CONTROLLING OF THE INITIAL STEPSIZE:
        0-NO CONTROLLING OF THE INITIAL STEPSIZE
        1-CONTROLLING BASED ON THE FUNCTION DECREASE
        2-CONTROLLING BASED ON THE DIRECTION VECTOR
        3-CONTROLLING BASED ON THE NUMBER OF FUNCTIONS
    $CHECK(ISTEP,0,'0\1\2\3',4)
    $HELP
      LOWER BOUND FOR STEPSIZE PARAMETER
    $CHECK(ALF1,'1.0$P-15',REAL,4)
    $LCS=0
  $ELSE
    $ISTEP=0
    $HELP
      DECISION AFTER ZERO STEP
        0 - NEW DIRECTION DETERMINATION
        1 - CONTINUATION OF THE ITERATION
    $CHECK(MOT3,0,'0\1',4)
    $KDS=0
    $LCS=1
  $ENDIF
  $ADD(INIT)
    LCS=$LCS
  $ENDADD
  $HELP
    CHOICE OF THE INITIAL APPROXIMATION OF THE HESSIAN MATRIX:
      1 - UNIT INITIAL APPROXIMATION
      2 - RANDOM INITIAL APPROXIMATION
  $CHECK(INITH,1,'1\2',4)
  $IF(KDA>1)
    $UPDATE='NO'
  $ELSEIF(TYPE='M')
    $UPDATE='NO'
$REM  $ELSEIF(DECOMP='S')
$REM    $UPDATE='NO'
$REM  $ELSEIF(DECOMP='C')
$REM    $UPDATE='NO'
  $ELSEIF(DECOMP='M')
    $HELP
      TYPE OF UPDATE
        B - SIMPLE CORRECTION OF THE GAUSS-NEWTON MATRIX
        F - FLETCHER'S HYBRID UPDATE
        S - CORRECTION OF THE SECOND DERIVATIVE TERM
        N - NO UPDATE
    $CHECK(UPDATE,'N','B\F\S\NO\N',3,NO)
    $IF(UPDATE='N') $UPDATE='NO'
    $IF(UPDATE<>'NO')
      $DEFAULT=1
      $IF(UPDATE='S') $DEFAULT=4
      $HELP
        UPDATE OF THE HESSIAN MATRIX:
          1 - BFGS UPDATE
          2 - DFP  UPDATE
          3 - HOSHINO UPDATE
          4 - RANK ONE UPDATE
      $CHECK(MET,DEFAULT,'0\1\2\3\4',3)
    $ENDIF
  $ELSEIF(CONSTR='U')
    $HELP
      TYPE OF UPDATE
        B - SIMPLE CORRECTION OF THE GAUSS-NEWTON MATRIX
        F - FLETCHER'S HYBRID UPDATE
        N - NO UPDATE
    $CHECK(UPDATE,'N','B\F\NO\N',3,NO)
    $IF(UPDATE='N') $UPDATE='NO'
  $ELSE
    $UPDATE='NO'
  $ENDIF
  $IF(UPDATE<>'NO')
    $HELP
      CORRECTION OF APPROXIMATION OF HESSIAN MATRIX
      AFTER CHANGE OF BASIS:
        1 - RESTART
        2 - CORRECTION
    $CHECK(MLC,2,'1\2',3)
    $IF(UPDATE='B')
     $HELP
        SELECTION OF SELF SCALING:
          1 - SELF SCALING SUPPRESSED
          2 - INITIAL SELF SCALING
          3 - CONTROLLED SELF SCALING
          4 - INTERVAL SELF SCALING
          5 - SELF SCALING IN EACH ITERATION
      $CHECK(MET1,5,'1\2\3\4\5',4)
      $HELP
        SELECTION OF THE LINE SEARCH MODEL:
          1 - QUADRATIC MODEL
          2 - USE OF TAYLOR EXPANSION
      $CHECK(MET2,2,'1\2',4)
      $HELP
        RESTART OF VARIABLE METRIC METHODS:
          1 - SIMPLE UPDATE
          2 - CUMMULATIVE UPDATE
      $CHECK(MET5,2,'1\2',4)
      $IF(MET5=2)
        $IF(KDS=2) $KDS=1
      $ENDIF
      $DEFAULT='5.0D-4'
      $IF(TYPE='L') $DEFAULT='3.0D-2'
      $HELP
        TOLERANCE FOR APPLICATION OF THE BFGS METHOD
      $CHECK(ETA5,DEFAULT,REAL,4)
    $ELSEIF(UPDATE='F')
      $HELP
        RESTART OF VARIABLE METRIC METHODS:
          1 - SIMPLE UPDATE
          2 - CUMMULATIVE UPDATE
      $CHECK(MET5,1,'1\2',4)
    $ELSEIF(UPDATE='S')
      $HELP
        SELECTION OF SELF SCALING:
          1 - SELF SCALING SUPPRESSED
          2 - INITIAL SELF SCALING
          5 - PERMANENT SELF SCALING
      $CHECK(MET1,5,'1\2\5',4)
      $HELP
        SELECTION OF SELF SCALING:
          1 - STANDARD SELF SCALING
          2 - SELF SCALING BY BIGGS
      $CHECK(MET2,1,'1\2',4)
      $HELP
        SELECTION OF STRUCTURED UPDATES:
          1 - STANDARD STRUCTURED UPDATES
          2 - TOTALLY STRUCTURED UPDATES
      $CHECK(MET3,1,'1\2',4)
      $HELP
        RESTART OF VARIABLE METRIC METHODS:
          1 - BASIC QN CONDITION
          2 - QN CONDITION WITH INTERMEDIATE GRADIENT
      $CHECK(MET4,1,'1\2',4)
      $QCON=MET4
      $IF(MET2=2) $ADD(REAL,'\$AFO($NA)')
    $ENDIF
  $ENDIF
  $HELP
    CHOICE OF THE SCALING MATRIX:
      0 - UNIT MATRIX (NO SCALING)
      1 - SQUARE OF THE MATRIX H DIAGONAL
  $CHECK(MOS1,0,'0\1',4)
  $IF(UPDATE='S')
    $IF(MET4=2)
      $ISNA=3
      $ADD(INIT)
        ISNA=3
      $ENDADD
    $ENDIF
  $ENDIF  
  NDECF=0
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
  $IF(NAL>0)
    $MAL=NAL
     MAL=NAL
    $JOB=1
    $IF(NORMA>0) $SUBST('UANRL1')
  $ENDIF
  $IF(NCL>0)
    $MCL=NCL
     MCL=NCL
    $ISNC=3
    $ADD(INIT)
      ISNC=3
    $ENDADD
    $JOB=1
    $IF(NORMC>0) $SUBST('UCNRL1')
    $IF(NORMF>0) $SUBST('UCTRL1')
    $SUBST('UCLNF2')
  $ENDIF
  $IF(CONSTR<>'U') $SUBST('UYFP$(CONSTR)1')
*
*     -------------------
*     GAUSS-NEWTON METHOD
*     TEMPLATE : U2SDU1
*     -------------------
*
  $LMD=$10
  ASSIGN $20 TO IMD
  CALL UYPRO1('UXFU',2)
  CALL UYPRO3(-1)
  MLC=0
  T=ZERO
  FO=FMIN
  IPOM1=0
  METS=MET
$L=$10 ; $LABEL
  $KD=2
  $SUBST('UZMODL')
  $IF(KDS<1)
  $ELSE
    IF (TSS(NS).EQ.'USXX') P=UXVDOT(NF,$G,$S)
  $ENDIF
  GO TO IMD
$L=$20 ; $LABEL
  $SUBST('UYTR$(CONSTR)G')
  $SUBST('UO2FU3')
  $SUBST('UYFUT1')
  IF (ITERM.NE.0) GOTO $80
  $IF(CONSTR<>'U')
    $HPOM=H
    $KHLP=0
    $IF(UPDATE<>'NO')
      $IF(MLC=2)
        $H=HH
        $KHLP=1
      $ENDIF
    $ENDIF
    $SUBST('UYRM$(CONSTR)$(KHLP)')
    $H=HPOM
  $ENDIF
  $IF(ISTEP=2)
    DMAX=R*SNORM
  $ENDIF
$L=$30 ; $LABEL
  $IF(DECOMP='M')  $SUBST('UYTR$(CONSTR)H')
  $IF(DECOMP='G')  $SUBST('UYTR$(CONSTR)H')
  $IF(DECOMP='S')  $SUBST('UYTR$(CONSTR)H')
  $IF(UPDATE='F')
    $SUBST('UUDSD3')
  $ELSEIF(UPDATE='S')
    $SUBST('UUDSD2')
  $ELSE
    $SUBST('UUDSD1')
  $ENDIF
  IF (ITERM.NE.0) GOTO $80
$REM  $IF(DECOMP='R')
$REM    $IF(UPDATE<>'NO') $DECOMP='G'
$REM  $ENDIF
$REM  $IF(DECOMP='C')
$REM    $IF(UPDATE<>'NO') $DECOMP='S'
$REM  $ENDIF
  $MAT='G'
  $IF(NUMBER=7)
    $IF(DECOMP='S') $MAT='D'
  $ENDIF
  $DEC=DECOMP
  $DECOMG=DEC
  $IF(NUMBER=1)
    $DECOMG='G'
    $IF(TYPE='M') $DECOMG='M'
    $IF(UPDATE='NO')
      $IF(DEC='M')
        $HELP
           TYPE OF DECOMPOSITION
             0 - GILL-MURRAY DECOMPOSITION
             1 - SCHNABEL-ESKOW DECOMPOSITION WITH NUMERICAL PERMUTATIONS
             2 - SCHNABEL-ESKOW DECOMPOSITION WITH TWO LEVEL INDICES
        $CHECK(MOS2,0,'0\1\2',2)
        $IF(MOS2=0) $DEC='G'
        $IF(MOS2>0) $DEC='S'
      $ENDIF
    $ENDIF
  $ELSEIF(NUMBER=2)
    $DECOMG='G'
    $IF(UPDATE='NO')
      $IF(DEC='M')
        $HELP
           TYPE OF DECOMPOSITION
             0 - GILL-MURRAY DECOMPOSITION
             1 - SCHNABEL-ESKOW DECOMPOSITION WITH NUMERICAL PERMUTATIONS
             2 - SCHNABEL-ESKOW DECOMPOSITION WITH TWO LEVEL INDICES
        $CHECK(MOS2,0,'0\1\2',2)
        $IF(MOS2=0) $DEC='G'
        $IF(MOS2>0) $DEC='S'
      $ENDIF
    $ENDIF
  $ENDIF
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UD$(MAT)$(TYPE)$(DECOMG)$(NUMBER)
*     -----------------------
*
  $SUBST('UD$(MAT)$(TYPE)$(DECOMG)$(NUMBER)')
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
  $TYPES=TYPE
  $IF(TYPE='T') $TYPE='G'
  $SUBST('UD1T$(TYPE)1')
  IF (ITERM.NE.0) GOTO $80
  IF (IREST.NE.0) GOTO $30
  IF(NIT.EQ.LIT+1) KIT=NIT
$L=$40 ; $LABEL
  $IF(UPDATE='F')
$REM    $IF(DECOMP='G')
      $IF(MET5=1) $SUBST('UUDSD5')
$REM    $ELSE
$REM      $IF(MET5=1) $SUBST('UUDSD4')
$REM    $ENDIF
  $ELSEIF(UPDATE='S')
    $IF(MET2=2)
      CALL UXVCOP(NA,$AF,$AFO)
    $ENDIF
  $ENDIF
  $IF(ISTEP>0)
    CALL UYSET4(NF,NA,INITS,ISTEP,F,FO,SNORM,DMAX)
  $ENDIF
  $SUBST('UYTR$(CONSTR)S')
  $IF(UPDATE='S')
    $IF(MET4=2)
      IF (KD.GT.0) ISNA=1
    $ENDIF
  $ENDIF    
$L=$50 ; $LABEL
  ASSIGN $50 TO IMD
  $SUBST('UZLINS')
  GOTO ($54,$52) ISB+1
$L=$ 52 ; $LABEL
  CALL UXVDIR(NF,R,$S,$XO,$X)
  GOTO $10
$L=$ 54 ; $LABEL
  $IF(UPDATE='S')
    $IF(MET4=2)
      ISNA=3
      LD=0
    $ENDIF
  $ENDIF    
  IF (ITERS.LE.0) THEN
  $IF(KDS<1)
    $SUBST('UYZER0')
  $ELSE
    $SUBST('UYZER1')
  $ENDIF
  IF(IDIR.EQ.0) THEN
  CALL UYRES1(TSXX)
  CALL UYSET1
  GO TO $30
  ELSE IF (MOT3.EQ.0) THEN
  CALL UYSET1
  GO TO $30
  ELSE
  ITERD=0
  ENDIF
  ENDIF
  $IF(UPDATE='B')
    $IF(MET5=2)
      IF (FO-F.LE.ETA5*FO) KD=1
    $ENDIF
  $ENDIF
  IF(KD.GT.LD) THEN
  ASSIGN $70 TO IMD
  GO TO $10
  ENDIF
$L=$70 ; $LABEL
  TXFU=TUXX
  TUXX='NEWTON  '
  ITERD=0
  $IF(UPDATE='B')
    KD=2
    $SUBST('UYTR$(CONSTR)D')
    $IHLP=1
    $IF(DECOMP='M') $DECOMG='G'
    $IF(TYPE='L')
      IF (FO-F.LE.ETA5*FO) THEN
      CALL UXDSDA(N,H,0.02$P 0)
      $SUBST('UUDB$(DECOMG)$IHLP')
      ENDIF
    $ELSE
      IF (FO-F.LE.ETA5*FO) THEN
      $SUBST('UUDB$(DECOMG)$IHLP')
      ENDIF
    $ENDIF
  $ELSEIF(UPDATE='F')
    $SUBST('UYTR$(CONSTR)D')
    $IF(DECOMP='M') $DECOMG='G'
    $SUBST('UUDF$(DECOMG)1')
  $ELSEIF(UPDATE='S')
    $JOB=1
    $SUBST('UYTR$(CONSTR)D')
    $IF(MET2=2)
      PAR=UXVDOT(NA,$AF,$AFO)/UXVDOT(NA,$AFO,$AFO)
    $ENDIF
    $IF (MET4=2)
      CALL UXVDIF(NF,$G,$GS,$GA)
    $ENDIF
    $SUBST('UUDBM2')
  $ELSE
    $SUBST('UYTRED')
  $ENDIF
  $IF(CONSTR<>'U')
    $HPOM=H
    $KHLP=0
    $IF(UPDATE<>'NO')
      $IF(MLC=2)
        $H=HH
        $IF(DECOMP='G') $KHLP=1
        $IF(DECOMP='M') $KHLP=4
        $IF(DECOMP='I') $KHLP=4
      $ENDIF
    $ENDIF
    $SUBST('UYAD$(CONSTR)$(KHLP)')
    $H=HPOM
  $ENDIF
  MET=METS
  IF(IDIR.EQ.0) THEN
  IF(ITERH.NE.0) CALL UYRES1('UPDATE  ')
  GOTO $20
  ELSE
  GOTO $30
  ENDIF
$L=$80 ; $LABEL
  IF(ITERM.LT.0) TXFU=TDXX
  CALL UYEPI1(2)
  $IF(NAL>0)
    $JOB=-1
    $IF(NORMA>0) $SUBST('UANRL1')
  $ENDIF
  $IF(NCL>0)
    $JOB=-1
    $IF(NORMF>0) $SUBST('UCTRL1')
    $IF(NORMC>0) $SUBST('UCNRL1')
  $ENDIF
  $SUBST('UO1FU2')
  $TYPE=TYPES
  $ADD(INIT)
    NXFU='U2SDU1'
  $ENDADD
  $EXIT

