$INTERFACE UA0HS3                                              99/12/01

  $HELP
    PRECISION OF THE COMPUTED VALUES
  $CHECK(ETA1,ETA0,REAL,4)
  CALL UA0HS3(NF,NA,MA,MHA,KA,$X,$IX,$XN,$HA,$GO,$GS,$IAG,$JAG,FA&
,$ETA1,$INDEX)
  $ADD(REAL,'\$X($NF)\$XN($NF)\$HA($MHA)\$GO($NF)\$GS($NF)')
$REM  $ADD(REAL,'\FA')
  $ADD(INTEGER,'\$IX($NX)\$IAG($NA+1)\$JAG($MA)')
$REM  $ADD(INTEGER,'\NF\NA\MA\MHA\KA')
  $ADD(SINID)
    CALL UXVSET(NF,ZERO,$GA)
  $ENDADD
  $ADD(INIT)
    NAHX='UA0HS3'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UA0HS3                ALL SYSTEMS                 99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* NUMERICAL COMPUTATION OF THE HESSIAN MATRIX OF THE APPROXIMATED
* FUNCTION USING ITS VALUES.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF FUNCTIONS.
*  II  MA  NUMBER OF ELEMENTS IN THE FIELD AG.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE SPARSE HESSIAN MATRIX.
*  II  KA  INDEX OF THE SELECTED FUNCTION.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RO  HA(M) HESSIAN MATRIX OF THE APPROXIMATED FUNCTION.
*  RA  GO(NF)  AUXILIARY VECTOR.
*  RA  GS(NF)  AUXILIARY VECTOR.
*  RI  IAG(NA+1)  POSITION OF THE FIRST ROWS ELEMENTS IN THE FIELD AG.
*  RI  JAG(MA)  COLUMN INDICES OF ELEMENTS IN THE FIELD AG.
*  RI  FA  VALUE OF THE SELECTED FUNCTION.
*  RI  ETA1  PRECISION OF THE COMPUTED VALUES.
*  RI  INDEX  INDEX IN THE FIELD HA.
*
* COMMON DATA :
*  II  KBF  TYPE OF BOUNDS. KBF=0-BOUNDS ARE NOT USED. KBF=1-ONE SIDED
*         BOUNDS. KBF=1-TWO SIDED BOUNDS.
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S   UYPRO1  PROLOGUE.
*  S   UYEPI1  EPILOGUE.
*  S   UYSET0  STATUS DEFINITION.
*
      SUBROUTINE UA0HS3(NF,NA,MA,M,KA,X,IX,XN,HA,GO,GS,IAG,JAG,FA,ETA1,
     & INDEX)
      $INCLUDE('UMCOMM')
      INTEGER NF,NA,MA,M,KA,IX(NF),IAG(NA+1),JAG(MA),INDEX
      $FLOAT X(NF),XN(NF),HA(M),GO(NF),GS(NF),FA,ETA1
      $FLOAT XTEMPI,XTEMPJ,FTEMP,ETA
      INTEGER I,J,IJ,IND
      INTEGER IVAR,JVAR,KVAR,LVAR,MVAR
      SAVE XTEMPI,XTEMPJ,FTEMP,ETA
      SAVE IVAR,JVAR,KVAR,LVAR,MVAR
      IND(I,J)=MAX(I,J)*(MAX(I,J)-1)/2+MIN(I,J)
      IF (TSS(NS).NE.'UAHX') CALL UYPRO1('UAHX',-1)
      GO TO (1,3,8) ISP(NS)
    1 CONTINUE
      ETA=ETA1**(ONE/THREE)
      FTEMP=FA
      MVAR=IAG(KA)-1
      KVAR=MVAR+1
    2 CONTINUE
      IF (KVAR.GE.IAG(KA+1)) GO TO 4
      IVAR=ABS(JAG(KVAR))
      IF (KBF.GT.0) THEN
      IF (IX(IVAR).LE.-5) THEN
      KVAR=KVAR+1
      GO TO 2
      ENDIF
      ENDIF
      IF (NORMF.GT.0) THEN
      GO(IVAR)=XN(IVAR)
      ELSE
      GO(IVAR)=ONE
      ENDIF
      GO(IVAR)=ETA*MAX(ABS(X(IVAR)),GO(IVAR)) * SIGN(ONE,X(IVAR))
      XTEMPI=X(IVAR)
      X(IVAR)=X(IVAR)+GO(IVAR)
      GO(IVAR)=X(IVAR)-XTEMPI
      CALL UYSET0(1,2)
      RETURN
    3 CONTINUE
      GS(IVAR)=FA
      X(IVAR)=XTEMPI
      KVAR=KVAR+1
      GO TO 2
    4 KVAR=MVAR+1
    5 CONTINUE
      IF (KVAR.GE.IAG(KA+1)) GO TO 10
      IVAR=ABS(JAG(KVAR))
      IF (KBF.GT.0) THEN
      IF (IX(IVAR).LE.-5) THEN
      KVAR=KVAR+1
      GO TO 5
      ENDIF
      ENDIF
      XTEMPI=X(IVAR)
      X(IVAR)=XTEMPI+GO(IVAR)
      LVAR=KVAR
    7 CONTINUE
      IF (LVAR.GE.IAG(KA+1)) GO TO 9
      JVAR=ABS(JAG(LVAR))
      IF (KBF.GT.0) THEN
      IF (IX(JVAR).LE.-5) THEN
      LVAR=LVAR+1
      GO TO 7
      ENDIF
      ENDIF
      XTEMPJ=X(JVAR)
      X(JVAR)=X(JVAR)+GO(JVAR)
      CALL UYSET0(1,3)
      RETURN
    8 CONTINUE
      IJ=IND(KVAR-MVAR,LVAR-MVAR)+INDEX
      IF (IJ.GT.M) THEN
      ITERM=-44
      TDXX='LACK SPC'
      CALL UOERR1('UA0HS3',44)
      GO TO 11
      ENDIF
      HA(IJ)=((FTEMP-GS(IVAR))+(FA-GS(JVAR)))/(GO(IVAR)*GO(JVAR))
      X(JVAR)=XTEMPJ
      LVAR=LVAR+1
      GO TO 7
    9 X(IVAR)=XTEMPI
      KVAR=KVAR+1
      GO TO 5
   10 FA=FTEMP
   11 CALL UYEPI1(-1)
      RETURN
      END
