$INTERFACE UA0HS4                                              98/12/01

  $AFS='AFS'
  $HELP
    SUPPOSED NUMBER OF GROUPS
  $CHECK(NVAR,5,INT,2,NO)
  $HELP
    PRECISION OF THE COMPUTED VALUES
  $CHECK(ETA1,ETA0,REAL,4)
  IF (JVAR.GT.$NVAR) THEN
  ITERM=-47
  CALL UOERR2('UA0HS4',47,JVAR,$NVAR)
  ENDIF
  CALL UA0HS4(NF,NA,NAL,MA,MAH,$X,$XN,$S,$AH,$GO,$IAG,$JAG,$AF,$AFO&
,$AFS,$COLA,JVAR,$ETA1)
  $ADD(REAL,'\$X($NF)\$XN($NF)\$S($NF)\$AH($MAH)\$GO($NF)\$AF($NA)&
  \$AFO($NA)\$AFS($NVAR*$NA)')
  $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)\$COLA($NF)')
$REM  $ADD(INTEGER,'\NF\NA\NAL\MA\MAH\JVAR')
  $ADD(SINID)
    CALL UXVSET(NF,ZERO,$GA)
  $ENDADD
  $ADD(INIT)
    NAHX='UA0HS4'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UA0HS4                ALL SYSTEMS                 98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* NUMERICAL COMPUTATION OF THE HESSIAN MATRIX OF THE APPROXIMATED
* FUNCTION USING ITS VALUES.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF FUNCTIONS.
*  II  NAL  NUMBER OF LINEAR FUNCTIONS.
*  II  MA  NUMBER OF ELEMENTS IN THE FIELD AG.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE SPARSE HESSIAN MATRIX.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RA  XO(NF)  AUXILIARY VECTOR.
*  RO  H(M) HESSIAN MATRIX OF THE APPROXIMATED FUNCTION.
*  RA  GO(NF)  AUXILIARY VECTOR.
*  RI  IAG(NA+1)  POSITION OF THE FIRST ROWS ELEMENTS IN THE FIELD AG.
*  RI  JAG(MA)  COLUMN INDICES OF ELEMENTS IN THE FIELD AG.
*  RI  AF(NA)  VECTOR CONTAINING VALUES OF THE APPROXIMATED
*         FUNCTIONS.
*  RO  AFO(NA)  SAVED VECTOR CONTAINING VALUES OF THE APPROXIMATED
*         FUNCTIONS.
*  RA  AFS(NVAR*NA)  AUXILIARY ARRAY.
*  II  IG(NF) VECTOR DEFINING GROUPS CONTAINING JACOBIAN COLUMNS.
*  II  NVAR  NUMBER OF GROUPS IN NUMERICAL DIFFERENTIATION.
*  RI  ETA1  PRECISION OF THE COMPUTED VALUES.
*
* COMMON DATA :
*  II  KBF  TYPE OF BOUNDS. KBF=0-BOUNDS ARE NOT USED. KBF=1-ONE SIDED
*         BOUNDS. KBF=1-TWO SIDED BOUNDS.
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S   UYPRO1  PROLOGUE.
*  S   UYEPI1  EPILOGUE.
*  S   UYSET0  STATUS DEFINITION.
*
      SUBROUTINE UA0HS4(NF,NA,NAL,MA,M,X,XN,XO,H,GO,IAG,JAG,AF,
     & AFO,AFS,IG,NVAR,ETA1)
      $INCLUDE('UMCOMM')
      INTEGER NF,NA,NAL,MA,M,IAG(NA+1),JAG(MA),IG(NF),NVAR
      $FLOAT X(NF),XN(NF),XO(NF),H(M),GO(NF),AF(NA),AFO(NA),
     & AFS(NVAR*NA),ETA1
      $FLOAT ETA
      INTEGER I,J,K,L,II,IJ,JJ,KK,KA,NB,IND
      INTEGER IVAR,JVAR
      SAVE ETA
      SAVE IVAR,JVAR
      IND(I,J)=MAX(I,J)*(MAX(I,J)-1)/2+MIN(I,J)
      IF (TSS(NS).NE.'UAHX') CALL UYPRO1('UAHX',-1)
      GO TO (1,3,7) ISP(NS)
    1 CONTINUE
      ETA=ETA1**(ONE/THREE)
      CALL UXVCOP(NF,X,XO)
      CALL UXVCOP(NA,AF,AFO)
      DO 11 I=1,NF
      IF (NORMF.GT.0) THEN
      GO(I)=XN(I)
      ELSE
      GO(I)=ONE
      ENDIF
      GO(I)=ETA*MAX(ABS(X(I)),GO(I))*SIGN(ONE,X(I))
   11 CONTINUE
      IVAR=0
    2 IVAR=IVAR+1
      IF (IVAR.GT.NVAR) GO TO 4
      DO 22 I=1,NF
      X(I)=XO(I)
      IF (IG(I).EQ.IVAR) X(I)=X(I)+GO(I)
   22 CONTINUE
      CALL UYSET0(1,2)
      RETURN
    3 CONTINUE
      CALL UXVCOP(NA,AF,AFS((IVAR-1)*NA+1))
      GO TO 2
    4 IVAR=0
    5 IVAR=IVAR+1
      IF (IVAR.GT.NVAR) GO TO 9
      JVAR=IVAR-1
    6 JVAR=JVAR+1
      IF (JVAR.GT.NVAR) GO TO 5
      DO 66 I=1,NF
      X(I)=XO(I)
      IF (IG(I).EQ.IVAR) X(I)=X(I)+GO(I)
      IF (IG(I).EQ.JVAR) X(I)=X(I)+GO(I)
   66 CONTINUE
      CALL UYSET0(1,3)
      RETURN
    7 CONTINUE
      NB=0
      DO 77 KA=1,NAL
      K=IAG(KA)
      L=IAG(KA+1)-K
      NB=NB+L*(L+1)/2
   77 CONTINUE
      DO 8 KA=NAL+1,NA
      K=IAG(KA)
      L=IAG(KA+1)-K
      II=0
      JJ=0
      DO 88 KK=1,L
      IJ=ABS(JAG(K))
      IF (IG(IJ).EQ.IVAR) THEN
      I=IJ
      II=KK
      ENDIF
      IF (IG(IJ).EQ.JVAR) THEN
      J=IJ
      JJ=KK
      ENDIF
      K=K+1
   88 CONTINUE
      IF (II*JJ.NE.0) THEN
      IJ=IND(II,JJ)
      H(NB+IJ)=((AFO(KA)-AFS((IVAR-1)*NA+KA))+
     & (AF(KA)-AFS((JVAR-1)*NA+KA)))/(GO(I)*GO(J))
      ENDIF
      NB=NB+L*(L+1)/2
    8 CONTINUE
      GO TO 6
    9 CALL UXVCOP(NF,XO,X)
      CALL UXVCOP(NA,AFO,AF)
      CALL UYEPI1(-1)
      RETURN
      END
