$INTERFACE UA0MX1                                             97/12/01

  $SUBST('UZASET')
  $HELP
    TYPE OF EXTREMUM:
       0 - CHEBYSHEV APPROXIMATION
      -1 - MINIMAX
       1 - MAXIMIN
  $CHECK(IEXT,0,'-1\0\1',1)
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(FMIN,'-$ETA9',REAL,2)
$REM  $ADD(REAL,'\FA\F')
$REM  $ADD(INTEGER,'\NA\NAL\KA\KAP')
 $00  CALL UA0MX1(NA,NAL,KA,KAP,FA,F)
      GO TO ($20,$10) ISB+1
 $10  CONTINUE
      $IF(SAVA>-1)
        IF(LDA.GE.0) THEN
        FA=$AF(KA)
        GO TO $00
        ENDIF
      $ENDIF
      $IF(NAL>0)
        IF(KA.LE.NAL) THEN
        $SUBST('UALNF1')
        $IF(KBA>0) $SUBST('UATRF1')
        $IF(ISNA>0)
          $SUBST('UASVF1')
        $ENDIF
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LAD<0)
        $IF(NAL<$NA)
          $MTYPE=FMODA
          $SUBST('UZAMOD')
          $IF(NORMA>0) $SUBST('UANRF1')
          $IF(KBA>0) $SUBST('UATRF1')
          $IF(ISNA>0)
            $SUBST('UASVF1')
          $ENDIF
          GO TO $00
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $20  CONTINUE
      $ADD(INIT)
        NAXX='UA0MX1'
      $ENDADD
      $EXIT

* IMPLEMENTATION

* SUBROUTINE UA0MX1             ALL SYSTEMS                 97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE OF THE OBJECTIVE FUNCTION WHICH IS DEFINED
* AS A SUM OF SQUARES.
*
* PARAMETERS:
*  II  NF  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  NAL  NUMBER OF LINEAR APPROXIMATED FUNCTIONS.
*  II  KA  INDEX OF THE APPROXIMATED FUNCTION.
*  II  KAP  OPTIMUM INDEX OF THE APPROXIMATED FUNCTION.
*  RI  FA  VALUE OF THE SELECTED FUNCTION.
*  RO  F  VALUE OF THE OBJECTIVE FUNCTION.
*
* COMMON DATA :
*  II  KD  DEGREE OF REQUIRED DERVATIVES.
*  IO  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*  IU  NAV  NUMBER OF APPROXIMATED FUNCTION VALUES COMPUTED.
*  IU  NFV  NUMBER OF OBJECTIVE FUNCTION VALUES COMPUTED.
*  II  IEXT  TYPE OF EXTREMUM. IEXT<0-MINIMAX. IEXT=0-CHEBYSHEV
*         APPROXIMATION, IEXT>0-MAXIMIN.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S  UYPRO1  PROLOGUE.
*  S  UYEPI1  EPILOGUE.
*  S  UYSET0  STATUS DEFINITION.
*
      SUBROUTINE UA0MX1(NA,NAL,KA,KAP,FA,F)
      $INCLUDE ('UMCOMM')
      INTEGER NA,NAL,KA,KAP
      $FLOAT FA,F
      $FLOAT FTEMP,FVAL
      SAVE FVAL
      IF (TSS(NS).NE.'UAXX') CALL UYPRO1('UAXX',-1)
      GO TO (1,4) ISP(NS)
    1 CONTINUE
      IF (KD.LE.LD) GO TO 9
      KA=1
    2 IF (KA.GT.NA) GO TO 7
      IF (KD.LT.0) GO TO 5
      IF (LD.GE.0) GO TO 5
      CALL UYSET0(1,2)
      RETURN
    4 CONTINUE
      IF (IEXT.EQ.0.AND.FA.GE.ZERO.OR.IEXT.LT.0) THEN
      FTEMP= FA
      ELSE
      FTEMP=-FA
      ENDIF
      IF (KA.EQ.1) THEN
      FVAL=FTEMP
      KAP=KA
      ELSE IF (FVAL.LT.FTEMP) THEN
      FVAL=FTEMP
      KAP=KA
      ENDIF
    5 KA=KA+1
      GO TO 2
    7 IF (LD.GE.0) GO TO 8
      F=FVAL
    8 NFV=NAV/(NA-NAL)
      LD=KD
    9 CALL UYEPI1(-1)
      RETURN
      END
