$INTERFACE UA0SP1                                           97/12/01

  $SUBST('UZASET')
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(FMIN,'0.0$P 0',REAL,2)
  $HELP
    EXPONENT IN SUM OF POWERS
  $CHECK(REXP,'2.0$P 0',REAL,2)
$REM  $ADD(REAL,'\FA\F')
$REM  $ADD(INTEGER,'\NA\NAL\KA')
 $00  CALL UA0SP1(NA,NAL,KA,FA,F,$REXP)
      GO TO ($20,$10) ISB+1
 $10  CONTINUE
      $IF(SAVA>-1)
        IF(LDA.GE.0) THEN
        FA=$AF(KA)
        GO TO $00
        ENDIF
      $ENDIF
      $IF(NAL>0)
        IF(KA.LE.NAL) THEN
        $SUBST('UALNF1')
        $IF(KBA>0) $SUBST('UATRF1')
        $IF(ISNA>0)
          $SUBST('UASVF1')
        $ENDIF
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LAD<0)
        $IF(NAL<$NA)
          $MTYPE=FMODA
          $SUBST('UZAMOD')
          $IF(NORMA>0) $SUBST('UANRF1')
          $IF(KBA>0) $SUBST('UATRF1')
          $IF(ISNA>0)
            $SUBST('UASVF1')
          $ENDIF
          GO TO $00
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $20  CONTINUE
      $ADD(INIT)
        NAXX='UA0SP1'
      $ENDADD
      $EXIT

* IMPLEMENTATION

* SUBROUTINE UA0SP1             ALL SYSTEMS                 97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE OF THE OBJECTIVE FUNCTION WHICH IS DEFINED
* AS A SUM OF POWERS.
*
* PARAMETERS:
*  II  NF  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  NAL  NUMBER OF LINEAR APPROXIMATED FUNCTIONS.
*  II  KA  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  FA  VALUE OF THE SELECTED FUNCTION.
*  RO  F  VALUE OF THE OBJECTIVE FUNCTION.
*  RI  REXP  EXPONENT IN A SUM OF POWERS.
*
* COMMON DATA :
*  II  KD  DEGREE OF REQUIRED DERVATIVES.
*  IO  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*  IU  NAV  NUMBER OF APPROXIMATED FUNCTION VALUES COMPUTED.
*  IU  NFV  NUMBER OF OBJECTIVE FUNCTION VALUES COMPUTED.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S  UYPRO1  PROLOGUE.
*  S  UYEPI1  EPILOGUE.
*  S  UYSET0  STATUS DEFINITION.
*
      SUBROUTINE UA0SP1(NA,NAL,KA,FA,F,REXP)
      $INCLUDE ('UMCOMM')
      INTEGER NA,NAL,KA
      $FLOAT FA,F,REXP
      $FLOAT FTEMP
      SAVE FTEMP
      IF (TSS(NS).NE.'UAXX') CALL UYPRO1('UAXX',-1)
      GO TO (1,4) ISP(NS)
    1 CONTINUE
      IF (REXP.LE.ONE) REXP=TWO
      IF (KD.LE.LD) GO TO 8
      IF (KD.GE.0.AND.LD.LT.0) F=ZERO
      KA=1
    2 IF (KA.GT.NA) GO TO 7
      IF (KD.LT.0) GO TO 5
      CALL UYSET0(1,2)
      RETURN
    4 CONTINUE
      IF (FA.EQ.ZERO) GO TO 5
      FTEMP=ABS(FA)**REXP
      F=F+FTEMP
    5 KA=KA+1
      GO TO 2
    7 IF (KD.GE.0.AND.LD.LT.0) F=F/REXP
      NFV=NAV/(NA-NAL)
      LD=KD
    8 CALL UYEPI1(-1)
      RETURN
      END
