$INTERFACE UA1DF2                                             98/12/01

  $IF(MODELY='YES') $SUBST('UZYSET')
  $IF(MODELF='NO')
    $GF='G'
    $DF='G'
  $ENDIF
  $MCG=0
  $IF(GRAPH='NO')
    $HELP
      CHOICE OF MESH POINTS
        0 - MESH POINTS UNUSED
        1 - MESH POINTS IN ALL INTEGRATION STEPS
        2 - PRESCRIBED MESH POINTS
    $CHECK(MED,0,'0\1\2',4)
  $ELSE
    $HELP
      OUTPUT SPECIFICATION
        1 - OUTPUT IN ALL INTEGRATION STEPS
        2 - OUTPUT IN PRESCRIBED MESH POINTS
    $CHECK(MED,1,'1\2',4)
    $HELP
      NUMBER OF MESH POINTS
    $CHECK(NA,50,INT,1)
  $ENDIF
  $IF(MED=0)
    $NA=1
  $ELSEIF(MED=1)
    $REPEAT
      $HELP
        DECLARED NUMBER OF MESH POINTS
      $CHECK(NA,0,INT,1)
      $IF(NA<=0)
        $IF(DIALOG>0)
          $ERASE(NA)
        $ELSE
          $ERROR: 'NA' - NUMBER OF MESH POINTS WAS NOT SPECIFIED
          $STOP
        $ENDIF
      $ENDIF
    $UNTIL($DEF(NA))
  $ELSEIF(MED=2)
    $HELP
      NUMBER OF MESH POINTS
    $CHECK(NA,50,INT,1)
  $ENDIF
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(FMIN,'-$ETA9',REAL,2)
  $DEFAULT='DP8'
  $IF(MED=1) $DEFAULT='DP5'
  $HELP
    TYPE OF METHOD
      DP5 - DORMAN PRINCE OF THE 5'TH ORDER
      DP8 - DORMAN PRINCE OF THE 8'TH ORDER
  $CHECK(SOLVER,DEFAULT,'DP5\DP8',2,NO)
  $MEL='2*$NE+$NF'
  $ADD(REAL,'\$AT($NA)\$AY($NA*$NE)\$YA($MEL)\$G($NF)\$GE($NF)\$GF($NF)&
  \$DF($NE)')
      $IF(MED=2)
        $ADD(SINID)
          CALL UESET1(NA,$AT,TA,TAMAX,HEMAX)
        $ENDADD
      $ENDIF
      $ADD(SINIT)
        CALL UXVSET(NE,ZERO,YA)
      $ENDADD
      $ADD(SINID)
        CALL UESET2(NA,NE,$AT,$AY,$YA,TA)
      $ENDADD
      $IF(MODELY='YES')
        $SUBST('UE0Y01')
        CALL UESET2(NA,NE,$AT,$AY,$YA,TA)
      $ENDIF
 $00  CALL UA1DF2(NF,NA,NE,MEL,KA,KE,$AT,$AY,$YA,$G,$GE,$GF,$DF,$ETA9&
,F,FF,TA,TAMAX,HE,MED,MED1,MED2,IER)
      GOTO ($60,$10,$30,$40,$50) ISB+1
 $10  CONTINUE
      $LET=$00
      $LED=$20
      $SUBST('UEV$SOLVER')
 $20  CONTINUE
      $SUBST('UE1DF2')
      $GO TO $10
 $30  CONTINUE
      $IF(MODELF='YES')
        $MTYPE=FMODF
        $SUBST('UZFMOD')
      $ENDIF
      $GO TO $00
 $40  CONTINUE
      $IF(MODELF='YES')
        $IF(GMODF='G')
          $MTYPE=GMODF
          $SUBST('UZFMOD')
        $ENDIF
        $IF(DMODF='D')
          $MTYPE=DMODF
          $SUBST('UZFMOD')
        $ENDIF
        $IF(GMODF='GD')
          $MTYPE=GMODF
          $SUBST('UZFMOD')
        $ENDIF
      $ENDIF
      $GO TO $00
 $50  CONTINUE
      $IF(MODELY='YES')
        $IF(LYD<1)
          $IF(GMODY='G')
            $MTYPE=GMODY
            $SUBST('UZYMOD')
          $ENDIF
        $ELSE
          CALL UXVCOP(NF,$EG((KE-1)*NF+1),$GE)
        $ENDIF
      $ENDIF
      $GO TO $00
 $60  CONTINUE
      IF (ITERM.NE.0) CALL UXVSET(NF,ZERO,G)
      $ADD(INIT)
        NAXX='UA1DF2'
      $ENDADD
      $EXIT

* IMPLEMENTATION

* SUBROUTINE UA1DF2             ALL SYSTEMS                 98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE AND THE GRADIENT OF THE OBJECTIVE FUNCTION
* WHICH IS DEFINED AS A SUM OF SQUARES.
*
* PARAMETERS:
*  II  NF  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF MESH POINTS.
*  II  NE  DECLARED NUMBER OF DIFFERENTIAL EQUATIONS.
*  II  MEL  ACTUAL NUMBER OF DIFFERENTIAL EQUATIONS.
*  IU  KA  INDEX OF THE APPROXIMATED FUNCTION.
*  IU  KE  INDEX OF THE DIFFERENTIAL EQUATION.
*  RI  AT(NA)  MESH POINTS.
*  RO  AY(NA*NE)  FIELD OF SOLUTION VECTORS IN THE MESH POINTS.
*  RU  YA(MEL)  SOLUTION VECTOR.
*  RO  G(NF)  GRADIENT OF THE OBJECTIVE FUNCTION.
*  RI  GF(NF)  GRADIENT OF THE OBJECTIVE FUNCTION.
*  RI  DF(NF)  DERIVATIVES OF THE OBJECTIVE FUNCTION.
*  RI  ETA9  MAXIMUM VALUE LESS THEN INFINITY.
*  RO  F  VALUE OF THE OBJECTIVE FUNCTION.
*  RI  FF  OLD VALUE OF THE OBJECTIVE FUNCTION.
*  RU  TA  VALUE OF THE INTEGRATION PARAMETER.
*  RI  TAMAX  MAXIMUM VALUE OF THE INTEGRATION PARAMETER.
*  RU  HE  ACTUAL STEPSIZE.
*  II  MED  NUMBER OF STEPS PRECEEDING TEST OF STIFTNESS.
*  II  MED1  CHOICE OF STEP SELECTION.
*  II  MED2  NUMBER OF RESETING SOLUTIONS.
*  IO  IER  ERROR INDICATOR.
*
* COMMON DATA :
*  II  KD  DEGREE OF REQUIRED DERVATIVES.
*  II  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*  II  KDF  DEGREE OF ANALYTICALLY COMPUTED DERVATIVES.
*  II  KDA  DEGREE OF ANALYTICALLY COMPUTED DERVATIVES.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S  UYPRO1  PROLOGUE.
*  S  UYEPI1  EPILOGUE.
*  S  UYSET0  STATUS DEFINITION.
*  S  UXVCOP  COPY OF A VECTOR.
*  S  UXVDIR  VECTOR AUGMENTED BY THE SCALED VECTOR.
*  S  UXVNEG  COPY OF A VECTOR WITH CHANGE OF THE SIGN.
*  S  UXVSET  INITIATION OF A VECTOR.
*
      SUBROUTINE UA1DF2(NF,NA,NE,MEL,KA,KE,AT,AY,YA,G,GE,GF,DF,ETA9,
     & F,FF,TA,TAMAX,HE,MED,MED1,MED2,IER)
      $INCLUDE ('UMCOMM')
      INTEGER NF,NA,NE,MEL,KA,KE,MED,MED1,MED2,IER
      $FLOAT AT(NA),AY(NA*NE),YA(2*NE+NF),G(NF),GE(NF),GF(NF),DF(NE),
     & ETA9,F,FF,TA,TAMAX,HE
      $FLOAT TEMP
      INTEGER KDS,MEDS
      SAVE KDS,MEDS,TEMP
      IF (TSS(NS).NE.'UAXX') CALL UYPRO1('UAXX',-1)
      GO TO (1,2,3,5,6,8) ISP(NS)
    1 CONTINUE
      MEDS=MED
      KDS=KD
      IF (KD.LT.0) GO TO 9
      IF (LD.GE.0) GO TO 4
      MED=MEDS
      MED1=1
      MED2=0
      IF (KDA.LT.0) THEN
      MEL=NE
      ELSE
      MEL=NE+1
      YA(MEL)=ZERO
      ENDIF
      TA=AT(1)
      IF (KDY.LT.0) CALL UXVCOP(NE,AY,YA)
      KD=0
      HE=ZERO
      CALL UYSET0(1,2)
      RETURN
    2 CONTINUE
      IF (IER.LT.0) THEN
      F=ETA9
      ITERM=MAX(-96,-90+IER)
      CALL UOERR1('UA1DF2',-ITERM)
      TDXX=TEDX
      GO TO 9
      ENDIF
      IF (ITERM.LT.0) ITERM=0
      KD=KDS
      IF (MED.EQ.1) NA=KA-1
      IF (KDA.LT.0) THEN
      F=ZERO
      ELSE
      F=YA(MEL)
      ENDIF
      IF (KDF.LT.0) GO TO 4
      CALL UYSET0(2,3)
      RETURN
    3 CONTINUE
      F=F+FF
    4 IF (KD.LT.1) GO TO 9
      IF (LD.GE.1) GO TO 9
      IF (KDF.LT.0) GO TO 5
      CALL UYSET0(3,4)
      RETURN
    5 CONTINUE
      MED=0
      IF (MEDS.GT.0) THEN
      MED1=2
      MED2=1
      ELSE
      MED1=1
      MED2=0
      HE=ZERO
      ENDIF
      MEL=2*NE+NF
      IF (KDF.LT.0) THEN
      CALL UXVSET(NE,ZERO,YA(NE+1))
      ELSE
      CALL UXVNEG(NE,DF,YA(NE+1))
      ENDIF
      IF (KDF.LE.0) THEN
      CALL UXVSET(NF,ZERO,YA(2*NE+1))
      ELSE
      CALL UXVNEG(NF,GF,YA(2*NE+1))
      ENDIF
      TA=TAMAX
      TEMP=TAMAX
      TAMAX=AT(1)
      CALL UYSET0(1,5)
      RETURN
    6 CONTINUE
      CALL UXVNEG(NF,YA(2*NE+1),G)
      TAMAX=TEMP
      IF (KDY.LE.0) GO TO 9
      KE=1
    7 IF (KE.GT.NE) GO TO 9
      CALL UYSET0(4,6)
      RETURN
    8 CONTINUE
      CALL UXVDIR(NF,-YA(NE+KE),GE,G,G)
      KE=KE+1
      GO TO 7
    9 CALL UYEPI1(-1)
      MED=MEDS
      LD=KD
      RETURN
      END
