$INTERFACE UA2SQ2                                             97/12/01

  $SUBST('UZASET')
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(FMIN,'0.0$P 0',REAL,2)
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,'ETA0*1.0D-3',REAL,4)
  $ADD(REAL,'\$GA($NF)\$G($NF)\$H($NF*($NF+1)/2)\$S($NF)')
$REM  $ADD(REAL,'\FA\F')
$REM  $ADD(INTEGER,'\NF\NA\NAL\KA\IVAR\INF')
 $00  CALL UA2SQ2(NF,NA,NAL,KA,$GA,$G,$S,$H,FA,F,IVAR,INF)
      GO TO ($60,$10,$20,$50) ISB+1
 $10  CONTINUE
      $IF(SAVA>-1)
        IF(LDA.GE.0) THEN
        FA=$AF(KA)
        GO TO $00
        ENDIF
      $ENDIF
      $IF(NAL>0)
        IF(KA.LE.NAL) THEN
        $SUBST('UALNF1')
        $IF(KBA>0) $SUBST('UATRF1')
        $IF(ISNA>0)
          $SUBST('UASVF1')
        $ENDIF
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LAD<0)
        $IF(NAL<$NA)
          $MTYPE=FMODA
          $SUBST('UZAMOD')
          $IF(NORMA>0) $SUBST('UANRF1')
          $IF(KBA>0) $SUBST('UATRF1')
          $IF(ISNA>0)
            $SUBST('UASVF1')
          $ENDIF
          $IF(FMODA<>'F')
            $IF(NORMA>0) $SUBST('UANRG1')
          $ENDIF
          GO TO $00
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $20  CONTINUE
      $IF(SAVA>0)
        IF(LDA.GE.1) THEN
        $SUBST('UALNG1')
        GO TO $00
        ENDIF
      $ENDIF
      $IF(NAL>0)
        IF(KA.LE.NAL) THEN
        $SUBST('UALNG1')
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LAD<1)
        $IF(NAL<$NA)
          $IF(GMODA='G')
            $MTYPE='G'
            $SUBST('UZAMOD')
            $IF(NORMA>0) $SUBST('UANRG1')
            GO TO $00
          $ELSEIF(FMODA='F')
            $SUBST('UA0G$(CON)1')
            GO TO ($00,$30) ISB+1
 $30  CONTINUE
            $MTYPE=FMODA
            $SUBST('UZAMOD')
            $IF(NORMA>0) $SUBST('UANRF1')
            $IF(KBA>0) $SUBST('UATRF1')
            GO TO $20
          $ELSE
            IF (LD.LT.0) GO TO $00
            $MTYPE=FMODA
            $SUBST('UZAMOD')
            $IF(NORMA>0) $SUBST('UANRF1')
            $IF(KBA>0) $SUBST('UATRF1')
            $IF(NORMA>0) $SUBST('UANRG1')
            GO TO $00
          $ENDIF
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $50  CONTINUE
      $SUBST('UYTR$(CONSTR)A')
      GO TO $00
 $60  CONTINUE
      IF (IVAR.GT.0) THEN
      $IF(DECOMP='R')
        CALL UXDTGF(N,INF,$H,$S,ETA2)
        NDECF=NDECF+1
        IDECF=2
        IDECA=5
      $ELSEIF(DECOMP='C')
        $ADD(REAL,'\$SO($NF)')
        CALL UXDTGC(N,INF,$H,$IH,$S,$SO,ETA2)
        NDECF=NDECF+1
        IDECF=5
        IDECA=6
$REM      $ELSEIF(DECOMP='T')
$REM        $ADD(REAL,'\$SO($NF)')
$REM        CALL UXDTGC(N,INF,$H,$IH,$S,$SO,ETA2)
$REM        NDECF=NDECF+1
$REM        IDECF=5
$REM        IDECA=6
      $ENDIF
      ENDIF
      $ADD(INIT)
        NAXX='UA2SQ2'
      $ENDADD
      $EXIT

* IMPLEMENTATION

* SUBROUTINE UA2SQ2             ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  COMPUTATION OF THE VALUE AND THE GRADIENT AND THE HESSIAN MATRIX
*  OF THE OBJECTIVE FUNCTION WHICH IS DEFINED AS A SUM OF SQUARES.
*
* PARAMETERS:
*  II  NF  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  NAL  NUMBER OF LINEAR APPROXIMATED FUNCTIONS.
*  II  KA  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  GA(NF)  GRADIENT OF THE APPROXIMATED FUNCTION.
*  RO  G(NF)  GRADIENT OF THE OBJECTIVE FUNCTION.
*  RO  S(NF)  RIGHT HAND SIDE VECTOR OBTAINED USING ORTHOGONAL
*         TRANSFORMATION OF A SET OF LINEAR EQUATIONS.
*  RO  H(NF*(NF+1)/2)  UPPER TRIANGULAR MATRIX OBTAINED USING ORTHOGONAL
*         TRANSFORMATION OF A SET OF LINEAR EQUATIONS.
*  RI  FA  VALUE OF THE SELECTED FUNCTION.
*  RO  F  VALUE OF THE OBJECTIVE FUNCTION.
*  IO  INF  ACTUAL NUMBER OF ROWS IN THE MATRIX H.
*
* COMMON DATA :
*  II  KD  DEGREE OF REQUIRED DERVATIVES.
*  IO  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*  IU  NAV  NUMBER OF APPROXIMATED FUNCTION VALUES COMPUTED.
*  IU  NAG  NUMBER OF APPROXIMATED FUNCTION GRADIENTS COMPUTED.
*  IU  NFV  NUMBER OF OBJECTIVE FUNCTION VALUES COMPUTED.
*  IU  NFG  NUMBER OF OBJECTIVE FUNCTION GRADIENTS COMPUTED.
*  IU  IDECF  DECOMPOSITION INDICATOR. IDECF=0-NO DECOMPOSITION.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S  UYPRO1  PROLOGUE.
*  S  UYEPI1  EPILOGUE.
*  S  UYSET0  STATUS DEFINITION.
*  S  UXVSET  INITIATION OF A VECTOR.
*  S  UXVDIR  VECTOR AUGMENTED BY THE SCALED VECTOR.
*  S  UXDTGR  RECURSIVE ORTHOGONAL TRANSFORMATION OF A SET OF LINEAR
*             EQUATIONS.
*
      SUBROUTINE UA2SQ2(NF,NA,NAL,KA,GA,G,S,H,FA,F,IVAR,INF)
      $INCLUDE ('UMCOMM')
      INTEGER NF,NA,NAL,KA,IVAR,INF
      $FLOAT GA(NF),G(NF),S(NF),H(NF*(NF+1)/2),FA,F
      $FLOAT POM
      IF (TSS(NS).NE.'UAXX') CALL UYPRO1('UAXX',-1)
      GO TO (1,4,6,8) ISP(NS)
    1 CONTINUE
      IF (KD.LE.LD) GO TO 12
      IF (KD.GE.0.AND.LD.LT.0) F=ZERO
      IF (KD.GE.1.AND.LD.LT.1) CALL UXVSET(NF,ZERO,G)
      IF (KD.GE.2.AND.LD.LT.2) INF=0
      KA=1
    2 IF (KA.GT.NA) GO TO 11
      IF (KD.LT.0) GO TO 9
      CALL UYSET0(1,2)
      RETURN
    4 CONTINUE
      IF(LD.GE.0) GO TO 5
      F=F+FA*FA
    5 IF (KD.LT.1) GO TO 9
      CALL UYSET0(2,3)
      RETURN
    6 CONTINUE
      IF (LD.GE.1) GO TO 7
      CALL UXVDIR(NF,FA,GA,G,G)
    7 IF (KD.LT.2) GO TO 9
      CALL UYSET0(3,4)
      RETURN
    8 CONTINUE
      POM=-FA
      CALL UXDTGR(NF,INF,H,S,GA,POM)
    9 KA=KA+1
      GO TO 2
   11 IF (KD.GE.0.AND.LD.LT.0) F=HALF*F
      IF (KD.GE.2.AND.LD.LT.2) THEN
      IVAR=1
      ELSE
      IVAR=0
      ENDIF
      NFV=NAV/(NA-NAL)
      NFG=NAG/(NA-NAL)
      LD=KD
   12 CALL UYEPI1(-1)
      RETURN
      END
