$INTERFACE UA2SQ3                                             97/12/01

  $SUBST('UZASET')
  $IF(KDA<2)
    $HA=AH
    $MHA=MAH
    $INDEX='NB'
  $ELSEIF(SAVA=2)
    $HA=AH
    $MHA=MAH
  $ENDIF
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(FMIN,'0.0$P 0',REAL,2)
  $ADD(REAL,'\$GA($NF)\$G($NF)\$HA($MHA)\$AH($MAH)')
$REM  $ADD(REAL,'\FA\F')
  $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)')
$REM  $ADD(INTEGER,'\NF\NA\NAL\MA\MHA\MAH\KA')
 $00  CALL UA2SQ3(NF,NA,NAL,MA,MHA,MAH,KA,$GA,$G,$HA,$AH,$IAG,$JAG&
,FA,F)
      GO TO ($60,$10,$20,$50) ISB+1
 $10  CONTINUE
      $IF(SAVA>-1)
        IF(LDA.GE.0) THEN
        FA=$AF(KA)
        GO TO $00
        ENDIF
      $ENDIF
      $IF(NAL>0)
        IF(KA.LE.NAL) THEN
        $SUBST('UALNF3')
        $IF(KBA>0) $SUBST('UATRF1')
        $IF(ISNA>0)
          $SUBST('UASVF1')
        $ENDIF
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LAD<0)
        $IF(NAL<$NA)
          $MTYPE=FMODA
          $SUBST('UZAMOD')
          $IF(NORMA>0) $SUBST('UANRF1')
          $IF(KBA>0) $SUBST('UATRF1')
          $IF(ISNA>0)
            $SUBST('UASVF1')
          $ENDIF
          $IF(FMODA<>'F')
            $IF(NORMA>0) $SUBST('UANRG1')
            $IF(ISNA>1)
              $SUBST('UASVG3')
            $ENDIF
          $ENDIF
          $IF(FMODA='FGH')
            $IF(NORMA>0) $SUBST('UANRH3')
          $ENDIF
          GO TO $00
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $20  CONTINUE
      $IF(SAVA>0)
        IF(LDA.GE.1) THEN
        $SUBST('UALNG3')
        GO TO $00
        ENDIF
      $ENDIF
      $IF(NAL>0)
        IF(KA.LE.NAL) THEN
        $SUBST('UALNG3')
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LAD<1)
        $IF(NAL<$NA)
          $IF(GMODA='G')
            $MTYPE='G'
            $SUBST('UZAMOD')
            $IF(NORMA>0) $SUBST('UANRG1')
            $IF(ISNA>1)
              $SUBST('UASVG3')
            $ENDIF
            GO TO $00
          $ELSEIF(FMODA='F')
            $SUBST('UA0G$(CON)3')
            GO TO ($40,$30) ISB+1
 $30  CONTINUE
            $MTYPE=FMODA
            $SUBST('UZAMOD')
            $IF(NORMA>0) $SUBST('UANRF1')
            $IF(KBA>0) $SUBST('UATRF1')
            GO TO $20
 $40  CONTINUE
            $IF(ISNA>1)
              $SUBST('UASVG3')
            $ENDIF
            GO TO $00
          $ELSE
            IF (LD.LT.0) GO TO $00
            $MTYPE=FMODA
            $SUBST('UZAMOD')
            $IF(NORMA>0) $SUBST('UANRF1')
            $IF(KBA>0) $SUBST('UATRF1')
            $IF(NORMA>0) $SUBST('UANRG1')
            $IF(ISNA>1)
              $SUBST('UASVG3')
            $ENDIF
            GO TO $00
          $ENDIF
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $50  CONTINUE
      $IF(NAL>0)
        IF(KA.LE.NAL) THEN
        $SUBST('UALNH3')
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LAD<2)
        $IF(NAL<$NA)
          $IF(HMODA='H')
            $MTYPE='H'
            $SUBST('UZAMOD')
            $IF(NORMA>0) $SUBST('UANRH3')
            GO TO $00
          $ELSEIF(FMODA='F')
            GO TO $00
          $ELSEIF(FMODA='FG')
            GO TO $00
          $ELSE
            IF (LD.LT.0) GO TO $00
            $MTYPE=FMODA
            $SUBST('UZAMOD')
            $IF(NORMA>0) $SUBST('UANRF1')
            $IF(KBA>0) $SUBST('UATRF1')
            $IF(NORMA>0) $SUBST('UANRG1')
            $IF(NORMA>0) $SUBST('UANRH3')
            GO TO $00
          $ENDIF
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $60  CONTINUE
      $ADD(INIT)
        NAXX='UA2SQ3'
      $ENDADD
      $EXIT

* IMPLEMENTATION

* SUBROUTINE UA2SQ3             ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  COMPUTATION OF THE VALUE AND THE GRADIENT AND THE HESSIAN MATRIX
*  OF THE OBJECTIVE FUNCTION WHICH IS DEFINED AS A SUM OF SQUARES.
*
* PARAMETERS:
*  II  NF  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  NAL  NUMBER OF LINEAR APPROXIMATED FUNCTIONS.
*  II  MA  NUMBER OF ELEMENTS IN THE FIELD AG.
*  II  ME  NUMBER OF ELEMENTS OF THE MATRIX HA.
*  II  MB NUMBER OF NONZERO ELEMENTS OF THE PARTITIONED HESSIAN
*         MATRIX H.
*  II  KA  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  GA(NF)  GRADIENT OF THE APPROXIMATED FUNCTION.
*  RO  G(NF)  GRADIENT OF THE OBJECTIVE FUNCTION.
*  RI  HA(ME)  HESSIAN MATRIX OF THE APPROXIMATED FUNCTION.
*  RO  AH(MB)  PARTITIONED HESSIAN MATRIX OF THE OBJECTIVE FUNCTION.
*  RI  IAG(NA+1)  POSITION OF THE FIRST ROWS ELEMENTS IN THE FIELD AG.
*  RI  JAG(MA)  COLUMN INDICES OF ELEMENTS IN THE FIELD AG.
*  RI  FA  VALUE OF THE SELECTED FUNCTION.
*  RO  F  VALUE OF THE OBJECTIVE FUNCTION.
*
* COMMON DATA :
*  II  KDA  DEGREE OF ANALYTICALLY COMPUTED DERIVATIVES.
*  II  KD  DEGREE OF REQUIRED DERVATIVES.
*  IO  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*  IU  NAV  NUMBER OF APPROXIMATED FUNCTION VALUES COMPUTED.
*  IU  NAG  NUMBER OF APPROXIMATED FUNCTION GRADIENTS COMPUTED.
*  IU  NAH  NUMBER OF APPROXIMATED FUNCTION HESSIAN MATRICES COMPUTED.
*  IU  NFV  NUMBER OF OBJECTIVE FUNCTION VALUES COMPUTED.
*  IU  NFG  NUMBER OF OBJECTIVE FUNCTION GRADIENTS COMPUTED.
*  IU  NFH  NUMBER OF OBJECTIVE FUNCTION HESSIAN MATRICES COMPUTED.
*  IU  IDECF  DECOMPOSITION INDICATOR. IDECF=0-NO DECOMPOSITION.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S   UYPRO1  PROLOGUE.
*  S   UYEPI1  EPILOGUE.
*  S   UYSET0  STATUS DEFINITION.
*  S   UXVSET  INITIATION OF A VECTOR.
*  S   UXDSMC  COPYING A DENSE SYMMETRIC MATRIX.
*  S   UXDSMO  INITIATION OF A DENSE SYMMETRIC MATRIX.
*  S   UXDSMS  SCALING A DENSE SYMMETRIC MATRIX.
*  S   UXBSBU  CORRECTION OF A BLOCKED SYMMETRIC MATRIX.
*
      SUBROUTINE UA2SQ3(NF,NA,NAL,MA,ME,MB,KA,GA,G,HA,AH,IAG,JAG,FA,F)
      $INCLUDE ('UMCOMM')
      INTEGER NF,NA,NAL,MA,ME,MB,KA,IAG(NA+1),JAG(MA)
      $FLOAT GA(NF),G(NF),HA(ME),AH(MB),FA,F
      INTEGER J,JP,K,L,NB
      SAVE NB
      IF (TSS(NS).NE.'UAXX') CALL UYPRO1('UAXX',-1)
      GO TO (1,4,6,8) ISP(NS)
    1 CONTINUE
      IF (KD.LE.LD) GO TO 12
      IF (KD.GE.0.AND.LD.LT.0) F=ZERO
      IF (KD.GE.1.AND.LD.LT.1) CALL UXVSET(NF,ZERO,G)
      NB=0
      KA=1
    2 IF (KA.GT.NA) GO TO 11
      IF (KD.LT.0) GO TO 9
      IF (LD.GE.1.AND.KDA.LT.2) GO TO 5
      CALL UYSET0(1,2)
      RETURN
    4 CONTINUE
      IF(LD.GE.0) GO TO 5
      F=F+FA*FA
    5 IF (KD.LT.1) GO TO 9
      CALL UYSET0(2,3)
      RETURN
    6 CONTINUE
      IF (LD.GE.1) GO TO 7
      K=IAG(KA)
      L=IAG(KA+1)-K
      DO 3 J=1,L
      JP=ABS(JAG(K))
      G(JP)=G(JP)+FA*GA(JP)
      K=K+1
    3 CONTINUE
    7 IF (KD.LT.2) GO TO 9
      IF (KA.LE.NAL) THEN
      GO TO 9
      ENDIF
      CALL UYSET0(3,4)
      RETURN
    8 CONTINUE
      IDECF=0
      K=IAG(KA)
      L=IAG(KA+1)-K
      IF (KDA.GE.2) THEN
      IF (LDA.LE.1) THEN
      CALL UXDSMC(L,HA,AH(NB+1))
      ENDIF
      CALL UXDSMS(L,AH(NB+1),FA)
      ELSE
      CALL UXDSMO(L,ZERO,AH(NB+1))
      ENDIF
      CALL UXBSBU(L,NF,AH(NB+1),JAG(K),ONE,GA,1)
      NB=NB+L*(L+1)/2
    9 KA=KA+1
      GO TO 2
   11 IF (KD.GE.0.AND.LD.LT.0) F=HALF*F
      NFV=NAV/(NA-NAL)
      NFG=NAG/(NA-NAL)
      NFH=NAH/(NA-NAL)
      LD=KD
   12 CALL UYEPI1(-1)
      RETURN
      END
