$INTERFACE UALNG4                                             04/12/01

  CALL UALNG4(NF,NA,MA,KA,KAP,$XN,$AG,$IAG,$JAG,$GA,ISNA,$NORMF)
  $ADD(REAL,'\$XN($NF)\$AG($MA)\$GA($NF)')
  $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)')
$REM  $ADD(INTEGER,'\NF\NA\MA\KA\KAP\ISNA')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UALNG4             ALL SYSTEMS                   04/12/01
C PORTABILITY : ALL SYSTEMS
C 04/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE GRADIENT OF THE LINEAR APPROXIMATED FUNCTION.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF FUNCTIONS.
*  II  MA  NUMBER OF ELEMENTS IN THE FIELD AG.
*  II  KA  INDEX OF THE SELECTED FUNCTION.
*  II  KAP  SIGNUM OF THE SELECTED FUNCTION.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RO  AG(MA)  SPARSE JACOBIAN MATRIX.
*  RI  IAG(NA+1)  POSITION OF THE FIRST ROWS ELEMENTS IN THE FIELD AG.
*  RI  JAG(MA)  COLUMN INDICES OF ELEMENTS IN THE FIELD AG.
*  RO  GA(NF)  GRADIENT OF THE APPROXIMATED FUNCTION.
*  II  ISNA  SAVING SPECIFICATION. ISNA=0-NO SAVING. ISNA=1-FUNCTION
*         VALUES ARE STORED. ISNA=2-FUNCTION VALUES AND GRADIENTS ARE
*         STORED.
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*
      SUBROUTINE UALNG4(NF,NA,MA,KA,KAP,XN,AG,IAG,JAG,GA,ISNA,NORMF)
      INTEGER NF,NA,MA,KA,KAP,IAG(NA+1),JAG(MA),ISNA,NORMF
      $FLOAT XN(NF),AG(MA),GA(NF)
      INTEGER J,JP,K,L
      K=IAG(KA)
      L=IAG(KA+1)-K
      IF (NORMF.GT.0.AND.ISNA.GT.2) THEN
      IF (KAP.GT.0) THEN
      DO 1 J=1,L
      JP=ABS(JAG(K))
      GA(JP)= AG(K)/XN(JP)
      K=K+1
    1 CONTINUE
      ELSE
      ENDIF
      DO 2 J=1,L
      JP=ABS(JAG(K))
      GA(JP)=-AG(K)/XN(JP)
      K=K+1
    2 CONTINUE
      ELSE
      IF (KAP.GT.0) THEN
      DO 3 J=1,L
      JP=ABS(JAG(K))
      GA(JP)= AG(K)
      K=K+1
    3 CONTINUE
      ELSE
      DO 4 J=1,L
      JP=ABS(JAG(K))
      GA(JP)=-AG(K)
      K=K+1
    4 CONTINUE
      ENDIF
      ENDIF
      RETURN
      END
