* SUBROUTINE UASSH1             ALL SYSTEMS                   98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE SPARSE HESSIAN MATRIX FROM THE SPARSE JACOBIAN
* MATRIX.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF ROWS OF THE SPARSE JACOBIAN MATRIX.
*  II  MA  NUMBER OF NONZERO ELEMENTS OF THE SPARSE JACOBIAN MATRIX.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE SPARSE HESSIAN MATRIX.
*  RU  H(M)  NONZERO ELEMENTS OF THE SPARSE HESSIAN MATRIX.
*  II  IH(NF+1)  POINTERS OF THE DIAGONAL ELEMENTS OF H.
*  II  JH(M)  COLUMN INDICES OF THE NONZERO ELEMENTS OF H.
*  II  IAG(NA+1)  POSITIONS OF THE FIRST ROWS ELEMENTS IN THE SPARSE
*         JACOBIAN STRUCTURE.
*  II  JAG(MA)  COLUMN INDICES OF ELEMENTS IN THE SPARSE JACOBIAN
*         STRUCTURE.
*  RI  GA(NF)  GRADIENT OF THE SELECTED FUNCTION.
*  II  KA  INDEX OF THE SELECTED FUNCTION (ROW OF THE SPARSE JACOBIAN
*         MATRIX).
*  RI  FACTOR  SCALING FACTOR.
*
      SUBROUTINE UASSH1(N,NA,MA,M,H,IH,JH,IAG,JAG,GA,KA,FACTOR)
      INTEGER N,NA,MA,M,IH(N+1),JH(M),IAG(NA+1),JAG(MA),KA
      $FLOAT H(M),GA(N),FACTOR
      $FLOAT TEMP
      INTEGER I,J,JF,JA,K,LA
      LA=IAG(KA+1)-1
      DO 6 K=IAG(KA),LA
      I=ABS(JAG(K))
      TEMP=FACTOR*GA(I)
      JF=IH(I)
      DO 5 JA=K,LA
      J=ABS(JAG(JA))
    2 IF (ABS(JH(JF)).LT.J) THEN
      JF=JF+1
      GO TO 2
      ENDIF
      H(JF)=H(JF)+TEMP*GA(J)
    5 CONTINUE
    6 CONTINUE
      RETURN
      END
