$INTERFACE UCCST1                                             08/12/01

  CALL UCCST1(NX,$IX,NC,NCC,$IC,$ICC)
  $ADD(INTEGER,'\$IX($NX)\$IC($NC)\$ICC(2*$NCC)')
$REM  $ADD(INTEGER,'\NX\NC\NCC')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UCCST1             ALL SYSTEMS                   08/12/01
C PORTABILITY : ALL SYSTEMS
C 08/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* CHECK OF COMPLEMENTARITY CONSTRAINTS.
*
* PARAMETERS :
*  II  NX  NUMBER OF BOX CONSTRAINTS.
*  II  IX(NX)  TYPES OF BOX CONSTRAINTS.
*  II  NC  NUMBER OF GENERAL CONSTRAINTS.
*  II  NCC  NUMBER OF COMPLEMENTARITY CONSTRAINTS.
*  II  IC(NC)  TYPES OF GENERAL CONSTRAINTS.
*  II  ICC(2*NCC)  VECTOR CONTAINING INDICES OF COMPLEMENTRIRY
*         CONSTRAINTS.
*
*  COMMON DATA :
*  II  KBF  SPECIFICATION OF SIMPLE BOUNDS. KBF=0-NO SIMPLE BOUNDS.
*         KBF=1-ONE SIDED SIMPLE BOUNDS. KBF=2=TWO SIDED SIMPLE BOUNDS.
*  II  KBC  SPECIFICATION OF LINEAR CONSTRAINTS. KBC=0-NO LINEAR
*         CONSTRAINTS. KBC=1-ONE SIDED LINEAR CONSTRAINTS. KBC=2=TWO
*         SIDED LINEAR CONSTRAINTS.
*  IO  ITERM  TERMINATION INDICATOR.
*
      SUBROUTINE UCCST1(NX,IX,NC,NCC,IC,ICC)
      $INCLUDE('UMCOMM')
      INTEGER NX,IX(NX),NC,NCC,IC(NC),ICC(2*NCC)
      INTEGER I,J,K
      DO 3 I=1,NCC
      DO 2 J=1,2
      K=ICC((J-1)*NCC+I)
      IF (K.EQ.0) THEN
      ITERM=-114
      TXFU='NO COMPL'
      CALL UOERR1('UCCST1',114)
      RETURN
      ELSE IF (K.LT.0) THEN
      K=-K
      IF (KBF.LE.0.OR.K.GT.NX) THEN
      ITERM=-115
      TXFU='CC INDEX'
      CALL UOERR1('UCCST1',115)
      RETURN
      ELSE IF (IX(K).EQ.3.OR.IX(K).EQ.4) THEN
      ITERM=-111
      TXFU='TWO SIDE'
      CALL UOERR1('UCCST1',111)
      RETURN
      ENDIF
      ELSE
      IF (KBC.LE.0.OR.K.GT.NC) THEN
      ITERM=-116
      TXFU='CC INDEX'
      CALL UOERR1('UCCST1',116)
      RETURN
      ELSE IF (IC(K).EQ.3.OR.IC(K).EQ.4) THEN
      ITERM=-112
      TXFU='TWO SIDE'
      CALL UOERR1('UCCST1',112)
      RETURN
      ELSE IF (IC(K).EQ.5) THEN
      ITERM=-113
      TXFU='EQ COMPL'
      CALL UOERR1('UCCST1',113)
      RETURN
      ENDIF
      ENDIF
    2 CONTINUE
      IF (ICC(I).EQ.ICC(NCC+I)) THEN
      IF (ICC(I).LT.0) THEN
      ITERM=-117
      TXFU='DUPL CON'
      CALL UOERR1('UCCST1',117)
      RETURN
      ELSE
      ITERM=-118
      TXFU='DUPL CON'
      CALL UOERR1('UCCST1',118)
      RETURN
      ENDIF
      ENDIF
    3 CONTINUE
      RETURN
      END

