$INTERFACE UCESS1                                             98/12/01

  $HELP
    MAXIMUM BANDWITH OF THE CONSTRAINT PRECONDITIONER
  $CHECK(IBAN,NC,INT,2,NO)
  $DEFAULT=0
  $IF(IBAN='$NC') $DEFAULT=10
  $HELP
    MAXIMUM NUMBER OF DENSE ROWS:
  $CHECK(MD,DEFAULT,INT,2,NO)
  $HELP
    MINIMUM NUMBER OF NONZERO ELEMENTS IN A SPARSE ROWS:
  $CHECK(MDE,50,INT,2,NO)
  $HELP
    NUMBER OF NONZERO ELEMENTS IN THE PRECONDITIONER:
  $CHECK(MMAX,'20*$MC',INT,2)
  $IF(MD=0)
    $SB='UCESS1'
    CALL UCESS1(NC,MC,$MMAX,$IB,$JB,$ICG,$JCG,$IBAN)
    $ADD(INTEGER,'\$IB($NC+1)\$JB($MMAX)\$ICG($NC+1)\$JCG($MC)')
$REM  $ADD(INTEGER,'\NC\MC\MMAX')
  $ELSE
    $BD='BD'
    $KCG='KCG'
    $SB='UCESD1'
    CALL UCESD1(NF,NC,MC,$MMAX,ND,$MD,$MDE,$IB,$JB,$ICG,$JCG,$KCG&
,ITERM)
    WRITE(3,'(''NUMBER OF DENSE COLUMNS:    ND  ='',I8)') ND
    $ADD(INTEGER,'\$IB($NC+1)\$JB($MMAX)\$ICG($NC+1)\$JCG($MC)&
    \$KCG($NF)')
    $ADD(REAL,'\$BD($MD*($MD+1)/2)')
$REM  $ADD(INTEGER,'\NF\NC\MC\MMAX\ND\ITERM')
  $ENDIF
  IF ($IB(NC+1)-1.GT.$MMAX) THEN
  CALL UOERR2('$SB',97,$IB(NC+1)-1,$MMAX)
  CALL UOERR4
  ITERM=-97
  ENDIF
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UCESS1             ALL SYSTEMS                   98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE SPARSE SCHUR COMPLEMENT STRUCTURE FOR THE
* KARUSH-KUHN-TUCKER MATRIX WITH THE UNIT HESSIAN BLOCK.
*
* PARAMETERS :
*  II  NC  NUMBER OF CONSTRAINT FUNCTIONS.
*  II  MC  NUMBER OF NONZERO ELEMENTS IN THE FIELD CG.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE SPARSE SCHUR COMPLEMENT.
*  IO  IB(NF+1)  POINTERS OF DIAGONAL ELEMENTS OF THE SPARSE SCHUR
*         COMPLEMENT.
*  IO  JB(M)  COLUMN INDICES OF NONZERO ELEMENTS OF THE SPARSE SCHUR
*         COMPLEMENT.
*  II  ICG(NC+1)  POSITION OF THE FIRST ROWS ELEMENTS IN THE FIELD CG.
*  II  JCG(MC)  COLUMN INDICES OF ELEMENTS IN THE FIELD CG.
*  II  IBAN  MAXIMUM BANDWITH OF THE CONSTRAINT PRECONDITIONER.
*
      SUBROUTINE UCESS1(NC,MC,M,IB,JB,ICG,JCG,IBAN)
      INTEGER NC,MC,M,IB(NC+1),JB(M),ICG(NC+1),JCG(MC),IBAN
      INTEGER K,KK,K1,K2,L,LL,L2,MM,KC,KCP
      MM=0
      IB(1)=1
      DO 3 KC=1,NC
      MM=MM+1
      JB(MM)=KC
      K1=ICG(KC)
      K2=ICG(KC+1)-1
      DO 2 KCP=KC+1,MIN(KC+IBAN-1,NC)
      KK=K1
      LL=ICG(KCP)
      L2=ICG(KCP+1)-1
      K=ABS(JCG(KK))
      L=ABS(JCG(LL))
    1 IF (K.LT.L) THEN
      IF (KK.GE.K2) GO TO 2
      KK=KK+1
      K=ABS(JCG(KK))
      GO TO 1
      ELSE IF (L.LT.K) THEN
      IF (LL.GE.L2) GO TO 2
      LL=LL+1
      L=ABS(JCG(LL))
      GO TO 1
      ELSE
      MM=MM+1
      JB(MM)=KCP
      ENDIF
    2 CONTINUE
      IB(KC+1)=MM+1
    3 CONTINUE
      RETURN
      END
