* SUBROUTINE UCIRMD             ALL SYSTEMS                 98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF TRANSPOSE OF THE ACTIVE CONSTRAINT MATRIX CG BY
* A VECTOR X AND ADDITION OF A SCALED VECTOR ALF*Y.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NC  NUMBER OF GENERAL CONSTRAINTS.
*  II  NCA  NUMBER OF ACTIVE CONSTRAINTS.
*  II  MC  NUMBER OF NONZERO ELEMENTS IN THE FIELD CG.
*  IO  ICA(NCA)  VECTOR CONTAINING INDICES OF ACTIVE CONSTRAINTS.
*  RI  CG(MC)  ELEMENTS OF THE CONSTRAINT JACOBIAN MATRIX.
*  II  ICG(NC+1)  POSITION OF THE FIRST ROWS ELEMENTS IN THE FIELD CG.
*  II  JCG(MC)  COLUMN INDICES OF ELEMENTS IN THE FIELD CG.
*  RI  X(NF)  INPUT VECTOR.
*  RI  ALF  SCALING FACTOR.
*  RI  Y(NCA)  INPUT VECTOR.
*  RO  Z(NCA)  OUTPUT VECTOR EQUAL TO TRANS(CG)*X+ALF*Y.
*
*  SUBPROGRAMS USED :
*  S   UXWDOT  DOT PRODUCT OF TWO VECTORS (PACKED CASE).
*
      SUBROUTINE UCIRMD(NF,NC,NCA,MC,ICA,CG,ICG,JCG,X,ALF,Y,Z)
      INTEGER NF,NC,NCA,MC,ICA(NCA),ICG(NC+1),JCG(MC)
      $FLOAT CG(MC),X(NF),ALF,Y(NCA),Z(NCA)
      INTEGER I,K,KC,L
      $FLOAT UXWDOT
      DO 1 I=1,NCA
      KC=ICA(I)
      IF (KC.LT.0) THEN
      K=-KC
      Z(I)=ALF*Y(I)+X(K)
      ELSE
      K=ICG(KC)
      L=ICG(KC+1)-K
      Z(I)=ALF*Y(I)+UXWDOT(L,NF,JCG(K),CG(K),X,2)
      ENDIF
    1 CONTINUE
      RETURN
      END
