* SUBROUTINE UCQACT             ALL SYSTEMS                 99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETERMINATION OF ACTIVE CONSTRAINTS.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NX  NUMBER OF BOX CONSTRAINTS.
*  II  NC  NUMBER OF GENERAL CONSTRAINTS.
*  II  NCA  NUMBER OF ACTIVE CONSTRAINTS.
*  II  X(NF)  VECTOR OF VARIABLES.
*  II  IX(NX)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XL(NX)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RI  XU(NX)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  RI  CF(NC)  VECTOR CONTAINING VALUES OF THE CONSTRAINT FUNCTIONS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  CL(NC)  VECTOR CONTAINING LOWER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CU(NC)  VECTOR CONTAINING UPPER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  IO  ICA(NC)  VECTOR CONTAINING INDICES OF ACTIVE CONSTRAINTS.
*  RI  EPS9  TOLERANCE FOR ACTIVE CONSTRAINTS.
*
*  COMMON DATA :
*  II  KBF  SPECIFICATION OF SIMPLE BOUNDS. KBF=0-NO SIMPLE BOUNDS.
*         KBF=1-ONE SIDED SIMPLE BOUNDS. KBF=2=TWO SIDED SIMPLE BOUNDS.
*  II  KBC  SPECIFICATION OF LINEAR CONSTRAINTS. KBC=0-NO LINEAR
*         CONSTRAINTS. KBC=1-ONE SIDED LINEAR CONSTRAINTS. KBC=2=TWO
*         SIDED LINEAR CONSTRAINTS.
*
      SUBROUTINE UCQACT(NF,NX,NC,NCA,X,IX,XL,XU,CF,IC,CL,CU,ICA,GS,
     & EPS9)
      $INCLUDE ('UMCOMM')
      INTEGER NF,NX,NC,NCA,IX(NX),IC(NC),ICA(NX+NC)
      $FLOAT X(NF),XL(NX),XU(NX),CF(NC),CL(NC),CU(NC),GS(NX+NC),EPS9
      INTEGER I,KC
      NCA=0
      IF (KBF.GT.0) THEN
      DO 1 I=1,NX
      IX(I)=ABS(IX(I))
      IF (IX(I).EQ.0) THEN
      ELSE IF (IX(I).EQ.1) THEN
      IF (X(I).LE.XL(I)+EPS9*MAX(ABS(XL(I)),ONE)) IX(I)=-1
      ELSE IF (IX(I).EQ.2) THEN
      IF (X(I).GE.XU(I)-EPS9*MAX(ABS(XU(I)),ONE)) IX(I)=-2
      ELSE IF (IX(I).EQ.3.OR.IX(I).EQ.4) THEN
      IF (X(I).LE.XL(I)+EPS9*MAX(ABS(XL(I)),ONE)) IX(I)=-3
      IF (X(I).GE.XU(I)-EPS9*MAX(ABS(XU(I)),ONE)) IX(I)=-4
      ELSE IF (IX(I).EQ.5) THEN
      IX(I)=-5
      ENDIF
    1 CONTINUE
      ENDIF
      IF (KBC.GT.0) THEN
      DO 2 KC=1,NC
      IC(KC)=ABS(IC(KC))
      IF (IC(KC).EQ.0) THEN
      ELSE IF (IC(KC).EQ.1) THEN
      IF (CF(KC).LE.CL(KC)+EPS9*MAX(ABS(CL(KC)),ONE)) THEN
      IC(KC)=-1
      NCA=NCA+1
      ICA(NCA)=KC
      GS(NCA)=-CF(KC)
      ENDIF
      ELSE IF (IC(KC).EQ.2) THEN
      IF (CF(KC).GE.CU(KC)-EPS9*MAX(ABS(CU(KC)),ONE)) THEN
      IC(KC)=-2
      NCA=NCA+1
      ICA(NCA)=KC
      GS(NCA)=-CF(KC)
      ENDIF
      ELSE IF (IC(KC).EQ.3.OR.IC(KC).EQ.4) THEN
      IF (CF(KC).LE.CL(KC)+EPS9*MAX(ABS(CL(KC)),ONE)) THEN
      IC(KC)=-3
      NCA=NCA+1
      ICA(NCA)=KC
      GS(NCA)=-CF(KC)
      ENDIF
      IF (CF(KC).GE.CU(KC)-EPS9*MAX(ABS(CU(KC)),ONE)) THEN
      IC(KC)=-4
      NCA=NCA+1
      ICA(NCA)=KC
      GS(NCA)=-CF(KC)
      ENDIF
      ELSE IF (IC(KC).EQ.5) THEN
      IC(KC)=-5
      NCA=NCA+1
      ICA(NCA)=KC
      GS(NCA)=-CF(KC)
      ENDIF
    2 CONTINUE
      ENDIF
      RETURN
      END
