* SUBROUTINE UCQREM               ALL SYSTEMS                   01/12/01
C PORTABILITY : ALL SYSTEMS
C 01/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* CONSTRAINT DELETION.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NX  NUMBER OF BOX CONSTRAINTS.
*  II  NC  NUMBER OF GENERAL CONSTRAINTS.
*  II  NCA  NUMBER OF ACTIVE CONSTRAINTS.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  IO  ICA(NX+NC)  VECTOR CONTAINING INDICES OF ACTIVE CONSTRAINTS.
*  RI  G(NF)  NEGATIVE GRADIENT.
*  RI  GS(NX+NC)  RIGHT HAND SIDE VECTOR.
*  RI  S(NF+NCA)  DIRECTION VECTOR.
*  IO  IOLD  CONSTRAINT-DELETION INDICATOR. IF IOLD=0, CONSTRAINTS
*         ARE UNCHANGED, OTHERWISE A CONSTRAINT IS DELETED.
*
*  COMMON DATA :
*  II  KBF  SPECIFICATION OF SIMPLE BOUNDS. KBF=0-NO SIMPLE BOUNDS.
*         KBF=1-ONE SIDED SIMPLE BOUNDS. KBF=2=TWO SIDED SIMPLE BOUNDS.
*  II  KBC  SPECIFICATION OF LINEAR CONSTRAINTS. KBC=0-NO LINEAR
*         CONSTRAINTS. KBC=1-ONE SIDED LINEAR CONSTRAINTS. KBC=2=TWO
*         SIDED LINEAR CONSTRAINTS.
*
      SUBROUTINE UCQREM(NF,NX,NC,NCA,IX,IC,ICA,G,GS,S,IOLD)
      $INCLUDE('UMCOMM')
      INTEGER NF,NX,NC,NCA,IX(NX),IC(NC),ICA(NX+NC),IOLD
      $FLOAT G(NF),GS(NX+NC),S(NX+NC)
      INTEGER I,K,NCP
      $FLOAT GMAX,CON,UXUMAX
      PARAMETER(CON=0.5$P 0)
      IOLD=0
      GMAX=UXUMAX(NF,G,IX,KBF)
      IF (KBF.GT.0) THEN
      DO 1 I=1,NX
      IF (IX(I).EQ.-1.OR.IX(I).EQ.-3) THEN
      IF (GMAX.LE. CON*G(I)) THEN
      IX(I)=-IX(I)
      IOLD=-I
      ENDIF
      ELSE IF (IX(I).EQ.-2.OR.IX(I).EQ.-4) THEN
      IF (GMAX.LE.-CON*G(I)) THEN
      IX(I)=-IX(I)
      IOLD=-I
      ENDIF
      ENDIF
    1 CONTINUE
      ENDIF
      DO 2 I=1,NCA
      K=ICA(I)
      IF (IC(K).EQ.-1.OR.IC(K).EQ.-3) THEN
      IF (GMAX.LE. S(K)) THEN
      IC(K)=-IC(K)
      ICA(I)=0
      IOLD=I
      ENDIF
      ELSE IF (IC(K).EQ.-2.OR.IC(K).EQ.-5) THEN
      IF (GMAX.LE.-S(K)) THEN
      IC(K)=-IC(K)
      ICA(I)=0
      IOLD=I
      ENDIF
      ENDIF
    2 CONTINUE
      IF (IOLD.GT.0) THEN
      NCP=NCA
      NCA=0
      DO 3 I=1,NCP
      IF (ICA(I).NE.0) NCA=NCA+1
      ICA(NCA)=ICA(I)
      S(NCA)=S(I)
      GS(NCA)=GS(I)
    3 CONTINUE
      ENDIF
      RETURN
      END
