$INTERFACE UD1TG3                                             00/12/01

  CALL UD1TG3(NF,$GN,$SN,P,PP,GNORM,SNORM,RMAX,XMAX)
  $ADD(REAL,'\$GN($NF)\$SN($NF)')
$REM  $ADD(INTEGER,'\NF')
$REM  $ADD(REAL,'\P\PP,GNORM\SNORM\RMAX\XMAX')
  $HELP
    MAXIMUM STEPSIZE
  $CHECK(XMAX,'1.0$P 3',REAL,2)
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UD1TG3                ALL SYSTEMS                00/12/01
C PORTABILITY : ALL SYSTEMS
C 00/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* TEST ON LOCALLY CONSTRAINED STEP AND PREPARATION OF SIMPLE SEARCH.
*
* PARAMETERS :
*  II  NDIM DECLARED NUMBER OF VARIABLES.
*  RI  G(NDIM) GRADIENT OF THE OBJECTIVE FUNCTION.
*  RI  S(NDIM) DIRECTION VECTOR.
*  RI  P  DIRECTIONAL DERIVATE.
*  RI  PP  SECOND-ORDER TERM.
*  RI  GNORM  EUCLIDEAN NORM OF THE GRADIENT.
*  RI  SNORM  EUCLIDEAN NORM OF THE DIRECTION VECTOR.
*  RO  RMAX  MAXIMUM VALUE OF THE STEPSIZE PARAMETER.
*  RI  XMAX  MAXIMUM STEPSIZE.
*
* COMMON DATA :
*  II  ITERD  TERMINATION INDICATOR. ITERD<0-BAD DECOMPOSITION.
*         ITERD=0-DESCENT DIRECTION. ITERD=1-NEWTON LIKE STEP.
*         ITERD=2-INEXACT NEWTON LIKE STEP. ITERD=3-BOUNDARY STEP.
*         ITERD=4-DIRECTION WITH THE NEGATIVE CURVATURE.
*         ITERD=5-MARQUARDT STEP.
*  IU  IREST  RESTART SPECIFICATION. IF IREST>0 THEN RESTART IS
*         PERFORMED.
*  IU  ITERM  TERMINATION INDICATOR. TERMINATION IF ITERM .NE. 0.
*  TO  TDXX  TEXT INFORMATION ON THE DIRECTION VECTOR OBTAINED.
*
* SUBPROGRAMS USED :
*  RF  UXVDOT  DOT PRODUCT OF VECTORS.
*  S   UXVNEG  COPYING OF A VECTOR WITH CHANGE OF THE SIGN.
*  S   UYRES1  DEFINITION OF THE RESTART VARIABLES.
*  S   UOD1D8  INTERMEDIATE PRINT.
*
      SUBROUTINE UD1TG3(NDIM,G,S,P,PP,GNORM,SNORM,RMAX,XMAX)
      $INCLUDE('UMCOMM')
      $INCLUDE('UMCOMD')
      INTEGER NDIM
      $FLOAT G(NDIM),S(NDIM),P,PP,GNORM,SNORM,RMAX,XMAX
      NDEM=NDIM
      IF(ITERD.LT.0) THEN
        ITERM=ITERD
        RETURN
      ENDIF
C
C     TEST ON LOCALLY CONSTRAINED STEP
C
      IF(SNORM.LE.ZERO) THEN
        CALL UYRES1('ZERO DIR')
      ELSE IF (P+PP.GE.ZERO) THEN
        CALL UYRES1('UNIFORM ')
      ELSE
        IREST=0
      ENDIF
      IF (IREST.EQ.0) THEN
C
C     PREPARATION OF SIMPLE SEARCH
C
        RMAX=XMAX/SNORM
      ENDIF
      CALL UOD1D8(NDIM,G,S,GNORM,SNORM,P)
      RETURN
      END
