$INTERFACE UDGLG1                                             16/12/01
$REM LU

  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,'ETA0*1.0D-3',REAL,4)
  $ADD(REAL,'\$GN($NF)\$SN($NF)')
  $ADD(REAL,'\ALF\BET')
  CALL UOD1D1
  $IF(HERF='D')
    $ADD(REAL,'\$H($M)')
    $ADD(REAL,'\UXVDOT')
    $POM1='V'
    $POM2=')'
    $N='N'
    IF (IDECF.LT.0) THEN
    $IF(DEC='M')
      $HELP
         TYPE OF DECOMPOSITION
           0 - GILL-MURRAY DECOMPOSITION
           1 - SCHNABEL-ESKOW DECOMPOSITION WITH NUMERICAL PERMUTATIONS
           2 - SCHNABEL-ESKOW DECOMPOSITION WITH TWO LEVEL INDICES
      $CHECK(MOS2,0,'0\1\2',2)
      $IF(MOS2=0)
      $ELSE
        $IF(MOS2=1) 
          $LET='L'
          $ART=',$IB)'
          $ADD(INTEGER,'\$IB($NF)')
        $ELSE  
          $LET='S'
          $ART=')'
        $ENDIF
        $ADD(INTEGER,'\$IH($NF)')
        CALL UXVINP($N,$IH)
      $ENDIF
      $IDECF=0
      IDECF=0
      INF=0
      ENDIF
      $ADD(REAL,'\$B($M)')
      CALL UXDSMC($N,$H,$B)
      $HS=H
      $H=B
      $IF(MOS2=0)
        TDXX(1:4)='G-M '
      $ELSE
        TDXX(1:4)='S-E '
      $ENDIF
      IF (IDECF.EQ.0) THEN
      $IF(MOS2=0)
*
*     GILL-MURRAY DECOMPOSITION
*
        ALF=ETA2
        CALL UXDPGF($N,$H,INF,ALF,BET)
      $ELSE
*
*     SCHNABEL-ESKOW DECOMPOSITION
*
        ALF=ETA2
        CALL UXD$(LET)GF($N,$H,$IH,$SN,INF,ALF,BET$ART
      $ENDIF
      NDECF=NDECF+1
    $ELSEIF(DEC='G')
      $IDECF=1
      IDECF=1
      INF=0
      ENDIF
      TDXX(1:4)='G-M '
      IF (IDECF.EQ.0) THEN
*
*     GILL-MURRAY DECOMPOSITION
*
      ALF=ETA2
      CALL UXDPGF($N,$H,INF,ALF,BET)
      NDECF=NDECF+1
      IDECF=1
      ELSE IF (IDECF.EQ.1) THEN
      ELSE IF (IDECF.EQ.2) THEN
      CALL UXDPRT($N,$H)
      IDECF=1
    $ELSEIF(DEC='S')
      $HELP
         TYPE OF DECOMPOSITION
           1 - SCHNABEL-ESKOW DECOMPOSITION WITH NUMERICAL PERMUTATIONS
           2 - SCHNABEL-ESKOW DECOMPOSITION WITH TWO LEVEL INDICES
      $CHECK(MOS2,1,'1\2',2)
      $IF(MOS2=1) 
        $LET='L'
        $ART=',$IB)'
        $ADD(INTEGER,'\$IB($NF)')
      $ELSE  
        $LET='S'
        $ART=')'
      $ENDIF
      $ADD(INTEGER,'\$IH($NF)')
      CALL UXVINP($N,$IH)
      $IDECF=4
      IDECF=4
      INF=0
      ENDIF
      TDXX(1:4)='S-E '
      IF (IDECF.EQ.0) THEN
*
*     SCHNABEL-ESKOW DECOMPOSITION
*
      ALF=ETA2
      CALL UXD$(LET)GF($N,$H,$IH,$SN,INF,ALF,BET$ART
      NDECF=NDECF+1
      IDECF=4
      ELSE IF (IDECF.EQ.1) THEN
      CALL UXVINP($N,$IH)
      IDECF=4
      ELSE IF (IDECF.EQ.2) THEN
      CALL UXDPRT($N,$H)
      CALL UXVINP($N,$IH)
      IDECF=4
      ELSE IF (IDECF.EQ.4) THEN
      ELSE IF (IDECF.EQ.5) THEN
      CALL UXDSRT($N,$H,$IH)
      IDECF=4
    $ELSEIF(DEC='B')
      $ADD(INTEGER,'\$IH($NF)')
      $HELP
         TYPE OF DECOMPOSITION
           1 - BUNCH-PARLETT DECOMPOSITION WITH NUMERICAL PERMUTATIONS
           2 - BUNCH-KAUFMAN DECOMPOSITION WITH NUMERICAL PERMUTATIONS
           3 - BUNCH PARLETT DECOMPOSITION WITH TWO LEVEL INDICES
      $CHECK(MOS2,1,'1\2\3',2)
      $IF(MOS2<3)
        $LET='L'
        $ART=',MOS2)'
$REM        $ADD(REAL,'\UXDLBQ')
      $ELSE
        $LET=S
        $ART=')'
$REM        $ADD(REAL,'\UXDSBQ')
      $ENDIF
      CALL UXVINP($N,$IH)
      $IDECF=3
      IDECF=3
      INF=0
      ENDIF
      TDXX(1:4)='B-P '
      IF (IDECF.EQ.0) THEN
*
*     BUNCH PARLETT DECOMPOSITION
*
      ALF=ETA2
      CALL UXD$(LET)BF($N,$H,$IH,INF,ALF$ART
      NDECF=NDECF+1
      IDECF=3
      ELSE IF (IDECF.EQ.3) THEN
    $ELSEIF(DEC='R')
      CALL UXVNEG($N,$GN,$SN)
      $IDECF=2
      IDECF=2
      INF=0
      ENDIF
      TDXX(1:4)='QR  '
      IF (IDECF.EQ.2) THEN
    $ELSEIF(DEC='C')
      $ADD(REAL,'\$SO($NF)')
      $ADD(INTEGER,'\$IH($NF)')
      CALL UXVINP($N,$IH)
      CALL UXVNEG($N,$GN,$SN)
      $HELP
        QR DECOMPOSITION SPECIFICATION
          1 - RANK REVEALING QR DECOMPOSITION
              WITH PERMUTATIONS
          2 - FULL QR DECOMPOSITION WITH
              PERMUTATIONS
      $CHECK(MOS3,1,'1\2',3)
      $IDECF=5
      IDECF=5
      INF=0
      ENDIF
      TDXX(1:4)='    '
      IF (IDECF.EQ.5) THEN
      $IF(MOS3=2)
        IF (IDECA.EQ.6) THEN
*
*     FULL QR DECOMPOSITION
*
        CALL UXDTTF($N,INF,$H,$IH,$SO)
      $ENDIF
    $ELSEIF(DEC='I')
      $IDECF=9
      IDECF=9
      INF=0
      ENDIF
      TDXX(1:4)='INV '
      IF (IDECF.EQ.0) THEN
*
*     INVERSION
*
      ALF=ETA2
      CALL UXDPGF($N,$H,INF,ALF,BET)
      CALL UXDPGI($N,$H)
      NDECF=NDECF+1
      IDECF=9
      ELSE IF (IDECF.EQ.9) THEN
    $ENDIF
  $ELSEIF(HERF='S')
    $ADD(REAL,'\UXUDOT')
    $POM1='U'
    $POM2=',$$IX,KBF)'
    $N='NF'
    $ADD(REAL,'\$H($M)\$XO($NF)')
    $ADD(INTEGER,'\MM\$IX($NX)\$IH($NF+1)\$JH($MMAX)\$PSL($NF+1)&
    \$PERM($NF)\$WN11($NF+1)\$WN12($NF+1)')
    IF (IDECF.LT.0) THEN
    $IDECF=1
    IDECF=0
    INF=0
    ENDIF
    MM=$IH($N+1)-1
    TDXX(1:4)='G-M '
    IF (IDECF.EQ.0) THEN
    CALL UXSPCT($N,MM,MH,MMAX,$H,$JH,$PSL,ITERM)
    IF (ITERM.NE.0) THEN
    TDXX='LACK SPC'
    GO TO $30
    ENDIF
*
*     SPARSE GILL-MURRAY DECOMPOSITION
*
    ALF=ETA2
    CALL UXSPCF($N,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$WN11,$WN12,$XO,INF&
,ALF,BET)
    NDECF=NDECF+1
    IDECF=1
    ELSE IF (IDECF.EQ.1) THEN
  $ELSEIF(HERF='L')
    $ADD(REAL,'\UXUDOT')
    $POM1='U'
    $POM2=',$$IX,KBF)'
    $N='NF'
$REM    $ADD(REAL,'\$XM($NF*$MF)\$GM($NF*$MF)\$XR($MF*($MF+1)/2)&
$REM    \$GR($MF*($MF+1)/2)\$HR($MF*($MF+1)/2)\$XO($NF)')
$REM    $ADD(INTEGER,'\$IX($NX)\MX')
    $IDECF=9
    IDECF=9
    INF=0
    IF (IDECF.EQ.9) THEN
  $ENDIF
  ELSE
  ITERD=-1
  TDXX='BAD DEC$IDECF'
  CALL UOERR1('UD$(HERF)L$(DEC)1',1)
  GO TO $30
  ENDIF
  GNORM=SQRT(UX$(POM1)DOT($N,$GN,$GN$POM2)
*
*     NEWTON LIKE STEP
*
  $IF(HERF='D')
    $IF(DEC='M')
      CALL UXVNEG($N,$GN,$SN)
      $IF(MOS2=0)
        CALL UXDPGB($N,$H,$SN,0)
      $ELSE
        CALL UXD$(LET)GB($N,$H,$IH,$SN,0)
      $ENDIF
      $H=HS
    $ELSEIF(DEC='G')
      CALL UXVNEG($N,$GN,$SN)
      CALL UXDPGB($N,$H,$SN,0)
    $ELSEIF(DEC='S')
      CALL UXVNEG($N,$GN,$SN)
      CALL UXD$(LET)GB($N,$H,$IH,$SN,0)
    $ELSEIF(DEC='B')
      IF (INF.LE.0) THEN
      CALL UXVNEG($N,$GN,$SN)
      $IF(MOS2<3) 
        CALL UXDLBB($N,$H,$IH,$SN,0)
      $ELSE
        CALL UXDSBB($N,$H,$IH,$SN,0)
      $ENDIF
      ELSE
*
*     DIRECTION OF NEGATIVE CURVATURE
*
      $IF(MOS2<3) 
        CALL UXDLBD($N,$H,$IH,$SN,ALF,INF)
      $ELSE
        CALL UXDSBD($N,$H,$IH,$SN,ALF,INF)
      $ENDIF
      ENDIF
    $ELSEIF(DEC='R')
      IF (IDECA.EQ.5) THEN  
      ALF=ETA2
      CALL UXDTGB($N,INF,$H,$SN,ALF)
      ELSE
      CALL UXVNEG($N,$GN,$SN)
      CALL UXDPRB($N,$H,$SN,0)
      ENDIF
    $ELSEIF(DEC='C')
      CALL UXVCOP(N,S,GO)
      $IF(MOS3=2)
      IF (IDECA.EQ.6) THEN
      CALL UXDTTB($N,INF,$H,$IH,$SO,$GO,$SN,0)
      TDXX(1:4)='RANK'
      ELSE
      CALL UXDSRB($N,$H,$IH,$GO,0)
      TDXX(1:4)='FULL'
      $ELSE
      $ENDIF
      ENDIF
    $ELSEIF(DEC='I')
      CALL UXDSMM($N,$H,$GN,$SN)
      CALL UXVNEG($N,$SN,$SN)
    $ENDIF
  $ELSEIF(HERF='S')
    CALL UX$(POM1)NEG($N,$GN,$SN$POM2
    CALL UXVSFP($N,$PERM,$SN,$XO)
    CALL UXSPCB($N,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$SN,0)
    CALL UXVSBP($N,$PERM,$SN,$XO)
  $ELSEIF(HERF='L')
$REM    CALL UX$(POM1)COP($N,$GN,$XO$POM2
    $IF(UPDATE='E')
      CALL UXLSIS($N,MX,$XM,$GM,$XR,$HR,$IHR,$U1,$U2,$GN,$SN,PAR3&
,MET,MET5)
    $ELSE
      CALL UXLSIG($N,MX,$XM,$HR,$U1,$U3,$GN,$SN,PAR3,MET1,MET5)
    $ENDIF
    CALL UX$(POM1)NEG($N,$SN,$SN$POM2
  $ENDIF
  INITD=MAX(ABS(INITD),1)
  ITERD=1
  $IF(DEC='M')
    IF (INF.NE.0) ITERD=2
  $ELSEIF(DEC='B')
    IF (INF.GT.0) THEN
    ITERD=4
    INITD=-INITD
    ENDIF
  $ENDIF
  IF(INF.EQ.0) THEN
  TDXX(5:8)=' POS'
  ELSEIF(INF.LT.0) THEN
  TDXX(5:8)=' ZER'
  ELSE
  TDXX(5:8)=' NEG'
  ENDIF
  SNORM=SQRT(UX$(POM1)DOT($N,$SN,$SN$POM2)
  NRED=INF
  CALL UOD1D5(ALF,BET,INF)
$30 CALL UOD1D2($N,$GN,$SN)
  $ADD(INIT)
    NDXX='UD$(HERF)L$(DEC)1'
  $ENDADD
  $EXIT
