$INTERFACE UDSLC1                                             03/12/01
$REM LU

  $D='D'
  $GS='GS'
  $KX='KX'
  $KCG='KCG'
  $CON1='1.0$P-3'
  $CON2='5.0$P-1'
  $CON3='0.0$P 0'
  $CON4='1.0$P-1'
  $CON5='1.0$P-3'
  $CON6='1.0$P 6'
$REM  $CON7='1.0$P-12'
  $POM1='U'
  $POM2=',$$IX,-KBF)'
$REM  $POM1='V'
$REM  $POM2=')'
  $HELP
    TOLERANCE FOR ACTIVE CONSTRAINTS
  $CHECK(EPS9,'1.0$P-1',REAL,4)
  $ADD(REAL,'\$H($M)\$CG($MC)\$B($MMAX)\$CF($NC+1)\$CFD($NC+1)&
  \$G($NF)\$S($NF+$NCA)\$XO($NF+$NCA)\$GO($NF+$NCA)\$GS($NF+$NCA)&
  \$D($NF+2*$NCA)\$B($M+$MC+$NC+2*$NX)')
  $ADD(REAL,'\$X($NF)\$XL($NX)\$XU($NX)\$XSL($NX)\$XSU($NX)\$XZL($NX)&
  \$XZU($NX)\$CL($NC)\$CU($NC)\$CSL($NC)\$CSU($NC)\$CZL($NC)\$CZU($NC)')
  $ADD(INTEGER,'\$ID($NCA+1)\$JD(2*$NCA)\$ICG($NC+1)\$JCG($MC)&
  \$KCG($MC)\$KX($NX)\$ICA($NC+$NX)\$IB($NF+$NC+$NX+1)&
  \$JB($M+$MC+$NC+2*$NX)\$KB($M+$MC+$NC+$NX)\$IW($MMAX)&
  \$IW1(2*($NF+$NC+$NX))\$IW2(3*($NF+$NC+$NX))\$IX($NX)')
  $ADD(REAL,'\UXVDOT\UX$(POM1)DOT')
  $ADD(REAL,'\STOL\SIG1')
  $ADD(INTEGER,'\I\J\MM\NN\NCA\IPOM\KPOM')
  $MOT1=0
  $HELP
    METHOD SELECTION:
      1 - BISECTION
      2 - TWO POINT QUADRATIC INTERPOLATION
      3 - THREE POINT QUADRATIC INTERPOLATION
      4 - THREE POINT CUBIC INTERPOLATION
  $CHECK(MES,1,'1\2\3\4',3)
  $DEFAULT='ETA0*1.0D-3'
$REM  $IF(MEP=3) $DEFAULT='1.0$P-4'
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,DEFAULT,REAL,4)
  CALL UOD1D1
  $GRAD=G
  GNORM=SQRT(UX$(POM1)DOT($N,$G,$G$POM2)
  CALL UXVNEG($N,$G,$GS)
  CALL UCCSEC(NX,NC,NCA,$X,$IX,$XL,$XU,$XSL,$XSU,$XZL,$XZU,$CF,$IC&
,$CL,$CU,$CSL,$CSU,$CZL,$CZU,$ICA,$ICCA,$D($N+1),$ID,$JD,$GS($N+1)&
,RPF3,RPF4,SIG1)
  CALL UODLI3($N,NX,$NN,NCA,$IX,$IC,$ICA,$GS,RPF2,RPF3,INF)
  CALL UXSLCN($N,M,$H,$IH,NX,NC,MC,$CG,$ICG,$JCG,$KCG,KX,NCA,$ICA&
,$D($N+1),$ID,$B,$IB)
*
*     BUNCH-PARLETT DECOMPOSITION
*
  CALL UXSIBF(NN,MM,$KB,$JB,$B,MMAX,$IW,MMAX,$IW1,$IW2,NAU,NUP,IER)
  IF (IER.LT.0) THEN
  TDXX='LACK SPC'
  ITERM=IER
  GO TO $90
  ENDIF
  NDECF=NDECF+1
  IDECF=7
*
*     NEWTON LIKE STEP
*
  CALL UXVCOP(NN,$GS,$S)
  CALL UXSIBB(NN,$B,MMAX,$IW,MMAX,$XO,$S,$IW1,NAU,NUP)
  INITD=MAX(ABS(INITD),1)
  ITERD=1
  TDXX = 'B-P STEP'
*
*     COMPUTATION OF THE DIRECTIONAL DERIVATIVE
*
  IPOM=0
  KPOM=0
  RPF2=RPF1
  $SUBST('UDSLCD')
  CALL UODLI4($N,NX,$NN,NCA,$D,$S($N+1),$XO($N+1),$GO($N+1),$GS($N+1))
$90 CONTINUE
  R=ZERO
  CALL UXVSET(NX,ZERO,XO)
  CALL UOD1D2($N,$G,$S)
  $ADD(INIT)
    NDXX='UDSLC1'
  $ENDADD
  $EXIT
