$INTERFACE UDSLK3                                             99/12/01
$REM LU

  $CON1='1.0$P-3'
  $CON2='9.0$P-1'
  $CON3='1.0$P-8'
  $CON4='1.0$P-8'
  $CON5='1.0$P-3'
  $CON6='1.0$P 6'
  $CON7='1.0$P-12'
  $POM1='U'
  $POM2=',$$IX,KBF)'
$REM  $HELP
$REM    MAXIMUM NUMBER OF DENSE COLUMNS:
$REM  $CHECK(MD,10,INT,2)
$REM  $HELP
$REM    MINIMUM NUMBER OF NONZERO ELEMENTS IN DENSE ROWS:
$REM  $CHECK(MDE,50,INT,2)
  $HELP
    MAXIMUM NUMBER OF CG ITERATIONS
  $CHECK(MCGR,0,INT,3,NO)
  $HELP
    STRATEGY FOR PRECISION DETERMINATION:
      1 - SINGLE STRATEGY
      2 - GEOMETRIC DECREASING STRATEGY
      3 - HARMONIC  DECREASING STRATEGY
  $CHECK(MOS,3,'1\2\3',3)
  $IF(MEP=0) $MOS1=0
  $HELP
    TERMINATION, MATRIX CORRECTION AND
    CHOICE OF THE PENALTY PARAMETER
      0 - CLASSIC TERMINATION
      1 - DESCENT TERMINATION
      2 - EXTENDED CHOICE OF THE PENALTY PARAMETER
  $CHECK(MOS1,0,'0\1\2',4)
  $DEFAULT=0
  $IF(MOS2=0) $DEFAULT=1
  $HELP
    TYPE OF SMOOTHING
      0 - NO SMOOTHING
      1 - SINGLE SMOTHING
  $CHECK(MOS3,DEFAULT,'0\1',4)
  $IF(MOS3=0)
    $XS=GS
    $XP=S
  $ENDIF
  $IF(MOS2=1)
    $HELP
      CHOICE OF INITIAL DIRECTION
        0 - ZERO INITIAL DIRECTION
        1 - VERTICAL INITIAL DIRECTION
    $CHECK(MOS4,0,'-1\0\1',4)
  $ELSEIF(MOS2=2)
    $HELP
      CHOICE OF INITIAL DIRECTION
        0 - ZERO INITIAL DIRECTION
        1 - VERTICAL INITIAL DIRECTION
    $CHECK(MOS4,0,'-1\0\1',4)
  $ELSEIF(MOS2=-1)
    $MOS4= 0
  $ELSEIF(MOS2=-2)
    $MOS4= 0
  $ELSE
    $MOS4=-1
  $ENDIF
  $IF(NOS2=3)
    $HELP
      PARAMETER FOR CONSTRUCTION OF PRECONDITIONER
    $CHECK(EPS5,'1.0$P 2',REAL,4)
  $ENDIF
  $ADD(REAL,'\$CG($MC)\$CF($NC)\$G($NF)\$S($NF+$NC)\$XO($NF+$NC)&
  \$GO($NF+$NC)\$XS($NF+$NC)\$GS($NF+$NC)\$XP($NF+$NC)\$CZ($NC)')
  $ADD(INTEGER,'\$ICG($NC+1)\$JCG($MC)\$IX($NX)')
  $IF(MEP=1) $ADD(REAL,'\$CP($NC)')
  $ADD(REAL,'\UX$(POM1)DOT\UXVDOT\UXWDOT')
  $ADD(REAL,'\ALF\RHO\RHO1\RHO2\SIG\SIG1\SIG2\TEMP\TEMP1\TEMP2')
  $IF(MOS4=0) $ADD(REAL,'\BTB,BTR')
  $IF(MOS3=1) $ADD(REAL,'\POM1')
  $IF(MOS4=1) $ADD(REAL,'\POM2')
  $ADD(INTEGER,'\I\K\L\MM\MMX\IPOM\KPOM\NOS')
  $ADD(LOGICAL,'\L1')
  $HELP
    METHOD SELECTION:
      1 - BISECTION
      2 - TWO POINT QUADRATIC INTERPOLATION
      3 - THREE POINT QUADRATIC INTERPOLATION
      4 - THREE POINT CUBIC INTERPOLATION
  $CHECK(MES,1,'1\2\3\4',3)
  $IF(MEP=0)
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF1,'1.0$P-4',REAL,3)
  $ELSEIF(MEP=1)
    $HELP
      PENALTY COEFFICIENT (IT MUST BE GREATER THEN ONE)
    $CHECK(RPF1,'1.0$P 0',REAL,3)
    $ADD(SINIT)
      CALL UXVSET($NN,ZERO,$CP)
    $ENDADD
  $ELSEIF(MEP=2)
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF1,'1.0$P 0',REAL,3)
  $ELSEIF(MEP=3)
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF1,'1.0$P 0',REAL,3)
  $ELSEIF(MEP=4)
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF1,'1.0$P 0',REAL,3)
  $ELSEIF(MEP=5)
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF1,'1.0$P 2',REAL,3)
  $ENDIF
  $DEFAULT='0.9$P 0'
  $IF (MOS=1) $DEFAULT='0.1$P 0'
  $HELP
    MINIMUM PRECISION OF AN INEXACT SOLUTION
  $CHECK(EPS6,DEFAULT,REAL,4)
  $DEFAULT='5.0$P-5'
  $IF(MEP=3) $DEFAULT='1.0$P-4'
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,DEFAULT,REAL,4)
  CALL UOD1D1
  $GRAD=G
  $IF(HERF='L')
    $ADD(INTEGER,'\MX')
    MX=MIN(NIT-KIT,MF)
  $ELSEIF(HERF='V')
    $GRAD=GN
    $SNS=SN
    $GAS=GA
    $XOS=XO
    $GCS=GC
    $GC=GP
    $ADD(REAL,'\$GC($NF)')
  $ENDIF
  IPOM=0
  RHO1=UX$(POM1)DOT($N,$G,$G$POM2
  SIG1=UXVDOT($NN,$CF,$CF)
*
*     SYSTEM TRANSFORMATION
*
  $FILE=XS
  $SUBST('UDSLKA')
  SIG=SIG1
*
*     CONSTRUCTION OF PRECONDITIONER
*
  $LKI=$90
  $SUBST('UDSLKI')
  MM=$N+$NN
  GNORM=SQRT(RHO1+SIG1)
  INITD=MAX(ABS(INITD),1)
  PAR=MIN(EPS6,GNORM)
  IF (PAR.GT.TEN*$CON1) THEN
  $IF(MOS=1)
  $ELSEIF(MOS=2)
    PAR=MIN(PAR,$CON1**($DBLE(NIT-LIT)/$DBLE(MM)))
  $ELSEIF(MOS=3)
    PAR=MIN(PAR,ONE/$DBLE(NIT-LIT))
  $ENDIF
  ENDIF
  PAR=PAR*PAR
  $IF(MOS4<1)
    CALL UXVNEG($NN,$CF,$XS($N+1))
    CALL UXVSET(MM,ZERO,$S)
  $ELSE
*
*     RANGE SPACE (VERTICAL) DIRECTION
*
    $IF(HERF='S')
      $JOB=1
    $ELSE
      $JOB=0
    $ENDIF
    $SO='XO'
    $SUBST('UDSLZR')
    CALL UXVSET($NN,ZERO,$S($N+1))
    CALL UXSSMD($N,M,$H,$IH,$JH,$S,-ONE,$GS,$GS)
    CALL UXVNEG($N,$GS,$GS)
    CALL UXVSET($NN,ZERO,$GS($N+1))
  $ENDIF
*
*     CG INITIATION
*
  $IF(MOS3=0)
  $ELSE
    CALL UXVSET(MM,ZERO,$XP)
    CALL UXVCOP(MM,$XS,$GS)
  $ENDIF
  $IF(NOS2=0)
    CALL UXVCOP(MM,$XS,$XO)
  $ENDIF
*
*     CG PRECONDITIONING
*
  $INPF=XS
  $OUTF=XO
  $SUBST('UDSLKP')
  RHO=UX$(POM1)DOT($N,$XS,$XO$POM2
  SIG=UXVDOT($NN,$XS($N+1),$XO($N+1))
  $IF(MOS4=1)
    POM2=RHO
  $ENDIF
  KPOM=0
  $IF(NOS2=1)
    $INDP=1
  $ELSEIF(NOS2=2)
    $INDP=1
  $ELSE
    $INDP=0
  $ENDIF
  MMX=MM+3
  $IF(MCGR>0)
    MMX=MIN(MMX,$MCGR)
  $ENDIF
*
*     CG ITERATIONS
*
  DO $15 NRED=1,MMX
  IF (RHO+SIG.EQ.ZERO) THEN
  ITERD=-4
  TDXX='CG BREAK'
  CALL UOERR1('UDSLK3',4)
  GO TO $90
  ENDIF
  $IF(HERF='D')
    CALL UXDSMM($N,$H,$XO,$GO)
  $ELSEIF(HERF='S')
    CALL UXSSMM($N,M,$H,$IH,$JH,$XO,$GO)
  $ELSEIF(HERF='L')
    $IF(CONSTR='C') CALL UX$(POM1)COP($N,$XO,$XO$POM2
    $IF(UPDATE='E')
      CALL UXLSMM($N,MX,$XM,$GM,$GR,$HR,$DR,$U1,$U2,$U3,$XO,$GO,PAR3&
,MET)
    $ELSE
      CALL UXLSMG($N,MX,$XM,$HR,$U1,$U3,$XO,$GO,PAR3,MET1)
    $ENDIF
  $ELSEIF(HERF='V')
    IF (IREST.NE.0) THEN
    CALL UXVCOP($N,$XO,$GO)
    GO TO $35
    ENDIF
    FO=F
    PP=SQRT(ETA0/UX$(POM1)DOT($N,$XO,$XO$POM2)
    $IF(MODP='FF')
      LD=MIN(KDF-1,0)
    $ELSE
      LD=MIN(KDA-1,0)
      $IF(MODEL='AF')
        LDA=LD
      $ELSE
        LDA=-1
      $ENDIF
      ISNAS=ISNA
      ISNA=0
    $ENDIF
    LDC=LD
    ISNCS=ISNC
    ISNC=0
    $SN=XO
    $XO=XV
    $SUBST('UYTR$(CONSTR)X')
    ASSIGN $30 TO IMD
    GO TO $LMD
$30 CONTINUE
    $IF(MODEL='AF')
      ISNA=ISNAS
    $ENDIF
    ISNC=ISNCS
    $XO=XOS
    $SN=SNS
    $GA=G
    $SUBST('UYTR$(CONSTR)A')
    CALL UXVDIF($N,$G,$GN,$GO)
    F=FO
    CALL UXVSCL($N,ONE/PP,$GO,$GO)
    $GA=GAS
$35 CONTINUE
  $ENDIF
  CALL UXSCMD($N,$NN,MC,$CG,$ICG,$JCG,$XO($N+1),ONE,$GO,$GO)
  CALL UXSRMM($N,$NN,MC,$CG,$ICG,$JCG,$XO,$GO($N+1))
  ALF=UX$(POM1)DOT($N,$XO,$GO$POM2+UXVDOT($NN,$XO($N+1),$GO($N+1))
  IF (ALF.EQ.ZERO) THEN
  ITERD=-5
  TDXX='CG BREAK'
  CALL UOERR1('UDSLK3',5)
  GO TO $90
  ENDIF
*
*     CG STEP
*
  ALF=(RHO+SIG)/ALF
  TDXX='CG STEP '
  CALL UX$(POM1)DIR($N, ALF,$XO,$XP,$XP$POM2
  CALL UXVDIR($NN, ALF,$XO($N+1),$XP($N+1),$XP($N+1))
  CALL UX$(POM1)DIR($N,-ALF,$GO,$XS,$XS$POM2
  CALL UXVDIR($NN,-ALF,$GO($N+1),$XS($N+1),$XS($N+1))
  $IF(MOS3=0)
  $ELSE
*
*     CG SMOOTHING
*
    POM1=ONE/$ETA9
    CALL UX$(POM1)DIF($N,$GS,$XS,$GO$POM2
    CALL UXVDIF($NN,$GS($N+1),$XS($N+1),$GO($N+1))
    TEMP1=UX$(POM1)DOT($N,$GO,$GO$POM2+UXVDOT($NN,$GO($N+1),$GO($N+1))
    TEMP2=UX$(POM1)DOT($N,$GO,$XS$POM2+UXVDOT($NN,$GO($N+1),$XS($N+1))
    POM1=-TEMP2/MAX(TEMP1,POM1)
    CALL UX$(POM1)DIR($N,POM1,$GO,$XS,$GS$POM2
    CALL UXVDIR($NN,POM1,$GO($N+1),$XS($N+1),$GS($N+1))
    CALL UX$(POM1)DIF($N,$S,$XP,$GO$POM2
    CALL UXVDIF($NN,$S($N+1),$XP($N+1),$GO($N+1))
    CALL UX$(POM1)DIR($N,POM1,$GO,$XP,$S$POM2
    CALL UXVDIR($NN,POM1,$GO($N+1),$XP($N+1),$S($N+1))
  $ENDIF
  TDXX='CG STEP '
*
*     TERMINATION CRITERION
*
  L1=NRED.GE.MMX
  IF (L1) TDXX='MAX ITER'
  SIG2=UXVDOT($NN,$GS($N+1),$GS($N+1))
  $IF(MOS4<1)
    IF (SIG2.LE.PAR*MAX(SIG1,ONE/$ETA9)) THEN
  $ENDIF
  $IF($DEF(RPF3))
    IF (RPF3.GT.ZERO) THEN
    CALL UXSCMD($N,$NN,MC,$CG,$ICG,$JCG,$GS($N+1),-ONE/RPF3,$GS,$GO)
    RHO2=UX$(POM1)DOT($N,$GO,$GO$POM2*RPF3**2
    ELSE
    RHO2=UX$(POM1)DOT($N,$GS,$GS$POM2
    ENDIF
  $ELSE
    RHO2=UX$(POM1)DOT($N,$GS,$GS$POM2
  $ENDIF
  IF (RHO2.LE.PAR*RHO1) L1=.TRUE.
  $IF(MOS4<1)
    ELSE IF (KOUT.GT.2) THEN
$REM    ELSE
    RHO2=UX$(POM1)DOT($N,$GS,$GS$POM2
    ENDIF
  $ENDIF
*
*     TEST FOR DESCENT DIRECTION
*
  $LKT=$16
  $FILE=GO
  $SUBST('UDSLKT')
*
*     CG PRECONDITIONING
*
  $INPF=XS
  $IF(MOS2=0)
    $OUTF=XS
  $ELSE
    $OUTF=GO
  $ENDIF
  $SUBST('UDSLKP')
  $IF(MOS4=0)
    BTB=ABS(SIG2)
    BTR=ABS(RHO2+SIG2)
    IF (BTR.LE.ONE/ETA9) GO TO $16
  $ENDIF
  RHO2=UX$(POM1)DOT($N,$XS,$OUTF$POM2
  SIG2=UXVDOT($NN,$XS($N+1),$OUTF($N+1))
*
*     SPECIAL TEST FOR NULL SPACE DIRECTION
*
  $IF(MOS4=0)
    IF (BTB.LE.PAR*(RHO1+SIG1).AND.ABS(RHO2+SIG2).LE.$CON7*BTR) THEN
$REM    $IF(MOS2=1)
    $IF(NOS2=1)
      CALL UXVMUL($N,$D,$XS,$GO,1)
      CALL UXSRMM($N,$NN,MC,$CG,$ICG,$JCG,$GO,$GO($N+1))
    $IF(MOS2<0)
      $IF(MD>0)
$REM        CALL UXSPIZ($NN,L,ND,$B,$IB,$JB,$CGD,$DD,$BD,$GO($N+1),$CP)
        CALL UXSPTZ($NN,L,ND,$B,$IB,$JB,$CGD,$DD,$BD,$GO($N+1),$CP)
      $ELSE
$REM        CALL UXSPIB($NN,L,$B,$IB,$JB,$GO($N+1),0)
        CALL UXSPTB($NN,L,$B,$IB,$JB,$GO($N+1),0)
      $ENDIF
    $ELSE
      $IF(MD>0)
        CALL UXSPCZ($NN,MMAX-L,ND,$B(L+1),$PSR,$JB(L+1),$PERC,$CGD,$DD&
,$BD,$GO,$GO($N+1),$CP)
      $ELSE
        CALL UXVSFP($NN,$PERC,$GO($N+1),$GO)
        CALL UXSPCB($NN,MMAX-L,$B(L+1),$PSR,$JB(L+1),$GO($N+1),0)
        CALL UXVSBP($NN,$PERC,$GO($N+1),$GO)
      $ENDIF
    $ENDIF
$REM      $IF(MD>0)
$REM        CALL UXSPCZ($NN,MMAX,ND,$B(L+1),$PSR,$JB(L+1),$PERC,$CGD,$DD&
$REM,$BD,$GO,$GO($N+1),$CP)
$REM      $ELSE
$REM        CALL UXVSFP($NN,$PERC,$GO($N+1),$GO)
$REM        CALL UXSPCB($NN,MMAX,$B(L+1),$PSR,$JB(L+1),$GO($N+1),0)
$REM        CALL UXVSBP($NN,$PERC,$GO($N+1),$GO)
$REM      $ENDIF
      CALL UXVSUM($NN,$XP($N+1),$GO($N+1),$S($N+1))
$REM    $ELSEIF(MOS2=2)
    $ELSEIF(NOS2=2)
      CALL UXVSET($N,$XS,$GO)
      CALL UXVNEG($NN,ZERO,$GO($N+1))
      CALL UXSIBB($N+$NN,$B,MMAX,$IW,MMAX,$XO,$GO,$IW1,NAU,NUP)
    $ENDIF
    $IF(MOS3=0)
    $ELSE
      CALL UX$(POM1)COP($N,$XP,$S$POM2
    $ENDIF
    $IF(HERF='D')
      CALL UXDSMM($N,$H,$S,$GO)
    $ELSEIF(HERF='S')
      CALL UXSSMM($N,M,$H,$IH,$JH,$S,$GO)
    $ELSEIF(HERF='L')
      $IF(CONSTR='C') CALL UX$(POM1)COP($N,$S,$S$POM2
      CALL UXLSMM($N,MX,$XM,$GM,$GR,$HR,$DR,$U1,$U2,$U3,$S,$GO,PAR3&
,$MET)
    $ELSEIF(HERF='V')
      IF (IREST.NE.0) THEN
      CALL UXVCOP($N,$XO,$GO)
      GO TO $45
      ENDIF
      FO=F
      PP=SQRT(ETA0/UX$(POM1)DOT($N,$XO,$XO$POM2)
      $IF(MODP='FF')
        LD=MIN(KDF-1,0)
      $ELSE
        LD=MIN(KDA-1,0)
        $IF(MODEL='AF')
          LDA=LD
        $ELSE
          LDA=-1
        $ENDIF
        ISNAS=ISNA
        ISNA=0
      $ENDIF
      LDC=LD
      ISNCS=ISNC
      ISNC=0
      $SN=S
      $XO=XV
      $SUBST('UYTR$(CONSTR)X')
      ASSIGN $40 TO IMD
      GO TO $LMD
$40   CONTINUE
      $IF(MODEL='AF')
        ISNA=ISNAS
      $ENDIF
      ISNC=ISNCS
      $XO=XOS
      $SN=SNS
      $GA=G
      $SUBST('UYTR$(CONSTR)A')
      CALL UXVDIF($N,$G,$GN,$GO)
      F=FO
      CALL UXVSCL($N,ONE/PP,$GO,$GO)
      $GA=GAS
$45   CONTINUE
    $ENDIF
    CALL UXSCMD($N,$NN,MC,$CG,$ICG,$JCG,$S($N+1),ONE,$GO,$GO)
    CALL UXVSUM($N,$GO,$GRAD,$GO)
    CALL UXSRMD($N,$NN,MC,$CG,$ICG,$JCG,$S,ONE,$CF,$GO($N+1))
    RHO2=UX$(POM1)DOT($N,$GO,$GO$POM2
    SIG2=UXVDOT($NN,$GO($N+1),$GO($N+1))
    GO TO $16
    ENDIF
  $ELSEIF(MOS4=1)
    IF (RHO2.LE.PAR*POM2) THEN
    CALL UXVSUM($NN,$XP($N+1),$GO($N+1),$S($N+1))
    $IF(MOS3=0)
    $ELSE
      CALL UX$(POM1)COP($N,$XP,$S$POM2
    $ENDIF
    GO TO $16
    ENDIF
  $ENDIF
  ALF=(RHO2+SIG2)/(RHO+SIG)
  CALL UX$(POM1)DIR($N,ALF,$XO,$OUTF,$XO$POM2
  CALL UXVDIR($NN,ALF,$XO($N+1),$OUTF($N+1),$XO($N+1))
  RHO=RHO2
  SIG=SIG2
$15 CONTINUE
  TDXX='MAX ITER'
  $IF(INDP=1)
    $IF(MOS1=2)
      $ADD(REAL,'\UXVNOR\UXUNOR')
      IF (IREST.EQ.0) THEN
      IF (UXVNOR($NN,$S($N+1)).LT.TEN*UX$(POM1)NOR($N,$S$POM2) THEN
      KPOM=1
      P=ZERO
      ENDIF
      ENDIF
    $ENDIF
  $ENDIF
*
*     AN INEXACT SOLUTION IS OBTAINED
*
$16 CONTINUE
*
*     COMPUTATION OF THE DIRECTIONAL DERIVATIVE
*
  $SUBST('UDSLKD')
$90 CONTINUE
  $IF(HERF='V')
    CALL UXVCOP(NF,$XV,$X)
    CALL UXVCOP(NF,$GN,$G)
    $GC=GCS
  $ENDIF
  CALL UOD1D2($N,$G,$S)
  $ADD(INIT)
    NDXX='UD$(HERF)LK3'
  $ENDADD
  $EXIT

