$INTERFACE UDSLQ3                                             04/12/01
$REM LU

  $D='D'
  $XS='XS'
  $GS='GS'
  $XP='XP'
  $CON1='1.0$P-3'
  $CON2='5.0$P-1'
  $CON4='1.0$P-1'
  $CON5='1.0$P-3'
  $CON6='1.0$P 6'
  $POM1='U'
  $POM2=',$$IX,-KBF)'
$REM  $POM1='V'
$REM  $POM2=')'
$REM  $HELP
$REM    MAXIMUM NUMBER OF DENSE COLUMNS:
$REM  $CHECK(MD,10,INT,2)
$REM  $HELP
$REM    MINIMUM NUMBER OF NONZERO ELEMENTS IN DENSE ROWS:
$REM  $CHECK(MDE,50,INT,2)
  $HELP
    STRATEGY FOR PRECISION DETERMINATION:
      1 - SINGLE STRATEGY
      2 - GEOMETRIC DECREASING STRATEGY
      3 - HARMONIC  DECREASING STRATEGY
  $CHECK(MOS,3,'1\2\3',3)
  $IF(MEP=0) $MOS1=0
$REM  $IF(MEP=1) $MOS1=2
  $HELP
    TERMINATION, MATRIX CORRECTION AND
    CHOICE OF THE PENALTY PARAMETER
      0 - CLASSIC TERMINATION
      1 - DESCENT TERMINATION
      2 - EXTENDED CHOICE OF THE PENALTY PARAMETER
  $CHECK(MOS1,0,'0\1\2',4)
  $HELP
    PRECONDITIONING THE KARUSH-KUHN-TUCKER SYSTEM
           0 - PRECONDITIONING IS SUPPRESSED
     -1 OR 1 - INDEFIFITE PRECONDITIONING BASED ON A DIAGONAL
               APPROXIMATION OF THE HESSIAN MATRIX
    MOS2 > 0 - COMPLETE CHOLESKI DECOMPOSITION
    MOS2 < 0 - INCOMPLETE CHOLESKI DECOMPOSITION
  $CHECK(MOS2,1,'-1\0\1',3)
$REM  $IF(MEP=1) $MOS3=1
  $HELP
    TYPE OF SMOOTHING
      0 - NO SMOOTHING
      1 - SINGLE SMOOTHING
  $CHECK(MOS3,0,'0\1',4)
  $IF(MOS3=0)
    $XS=GS
    $XP=S
  $ENDIF
  $ADD(REAL,'\$H($MMAX)\$CG($MC)\$CF($NC+1)\$CFD($NC+1)\$G($NF)&
  \$S($NF+$NCA)\$XO($NF+$NCA)\$GO($NF+$NCA)\$XS($NF+$NCA)&
  \$GS($NF+$NCA)\$XP($NF+$NCA)\$D($NF+$NCA)')
  $ADD(INTEGER,'\$IH($NF+1)\$JH($MMAX)\$ICG($NC+1)\$JCG($MC)\$IX($NX)')
  $ADD(REAL,'\UXVDOT\UX$(POM1)DOT\UCIDOT\UCIPEN')
  $ADD(REAL,'\ALF\RHO\RHO1\RHO2\SIG\SIG1\SIG2\BTR\BTB\RMU\TEMP\TEMP2')
  $ADD(INTEGER,'\I\K\L\MM\MMX\NCA\IPOM\KPOM\NOS')
  $ADD(LOGICAL,'\L1')
  $HELP
    METHOD SELECTION:
      1 - BISECTION
      2 - TWO POINT QUADRATIC INTERPOLATION
      3 - THREE POINT QUADRATIC INTERPOLATION
      4 - THREE POINT CUBIC INTERPOLATION
  $CHECK(MES,1,'1\2\3\4',3)
  $IF(MEP=0)
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF1,'1.0$P-4',REAL,3)
  $ELSEIF(MEP=1)
  $ELSEIF(MEP=2)
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF1,'1.5$P 0',REAL,3)
  $ELSEIF(MEP=3)
  $ENDIF
  $DEFAULT='0.9$P 0'
  $IF (MOS=1) $DEFAULT='0.1$P 0'
  $HELP
    MINIMUM PRECISION OF AN INEXACT SOLUTION
  $CHECK(EPS6,DEFAULT,REAL,4)
  $DEFAULT='ETA0*1.0D-3'
$REM  $IF(MEP=3) $DEFAULT='1.0$P-4'
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,DEFAULT,REAL,4)
  $IF(MD>0)
    $BD='BD'
    $ADD(REAL,'\$BD($MD*($MD+1)/2)')
  $ENDIF
  CALL UOD1D1
  IPOM=0
  GNORM=SQRT(UX$(POM1)DOT(NF,$G,$G$POM2)
  CALL UXVNEG(NF,$G,$XS)
  RHO1=UX$(POM1)DOT(NF,$XS,$XS$POM2
  SIG1=ZERO
  M=$IH(NF+1)-1
*
*     INITIAL ACTIVE CONSTRAINTS
*
  CALL UCQACT(NF,NX,NC,NCA,$X,$IX,$XL,$XU,$CF,$IC,$CL,$CU,$ICA&
,$XS(NF+1),EPS9)
  INEW=1
  INITD=MAX(ABS(INITD),1)
$10 CONTINUE
*
*     CONSTRAINT DELETION
*
  CALL UCQREM(NF,NX,NC,NCA,$IX,$IC,$ICA,$XS,$XS(NF+1),$S(NF+1),IOLD)
  IF (INEW.EQ.0.AND.IOLD.EQ.0) GO TO $25
  SIG1=MAX(SIG1,UXVDOT(NCA,$XS(NF+1),$XS(NF+1)))
*
*     CONSTRUCTION OF THE CG PRECONDITIONER
*
  CALL UXVCOP(NF,S,SO)
  CALL UXUCOP(NF,S,S,IX,1)
  $LQI=$90
  $SUBST('UDSLQI')
  MM=NF+NCA
  PAR=MIN(EPS6,SQRT(RHO1+SIG1))
  IF (PAR.GT.TEN*$CON1) THEN
  $IF(MOS=1)
  $ELSEIF(MOS=2)
    PAR=MIN(PAR,$CON1**($DBLE(NIT-LIT)/$DBLE(MM)))
  $ELSEIF(MOS=3)
    PAR=MIN(PAR,ONE/$DBLE(NIT-LIT))
  $ENDIF
  ENDIF
  PAR=PAR*PAR
*
*     CG INITIATION
*
  CALL UXVSET(MM,ZERO,$S)
  $IF(MOS3=0)
  $ELSE
    CALL UXVSET(MM,ZERO,$XP)
    CALL UXVCOP(MM,$XS,$GS)
  $ENDIF
  $IF(NOS2=0)
    CALL UXVCOP(MM,$XS,$XO)
  $ENDIF
*
*     CG PRECONDITIONING
*
  $INPF=$XS
  $OUTF=$XO
  $SUBST('UDSLIP')
  RHO=UX$(POM1)DOT(NF,$INPF,$OUTF$POM2
  SIG=UXVDOT(NCA,$INPF(NF+1),$OUTF(NF+1))
  KPOM=0
  MMX=MM+3
*
*    CG ITERATIONS
*
  DO $15 NRED=1,MMX
  IF (RHO+SIG.EQ.ZERO) THEN
  ITERD=-4
  TDXX='CG BREAK'
  CALL UOERR1('UDSLQ3',4)
  GO TO $90
  ENDIF
  CALL UXSSMM(NF,M,$H,$IH,$JH,$XO,$GO)
  CALL UCICMD(NF,NC,NCA,MC,$ICA,$CG,$ICG,$JCG,$XO(NF+1),ONE,$GO,$GO)
  CALL UXVMUL(NCA,$D(NF+1),$XO(NF+1),$GO(NF+1),1)
  CALL UCIRMD(NF,NC,NCA,MC,$ICA,$CG,$ICG,$JCG,$XO,ONE,$GO(NF+1)&
,$GO(NF+1))
  ALF=UX$(POM1)DOT(NF,$XO,$GO$POM2+UXVDOT(NCA,$XO(NF+1),$GO(NF+1))
  IF (ALF.EQ.ZERO) THEN
  ITERD=-5
  TDXX='CG BREAK'
  CALL UOERR1('UDSLQ3',5)
  GO TO $90
  ENDIF
*
*     CG STEP
*
  ALF=(RHO+SIG)/ALF
  TDXX='CG  STEP'
  CALL UX$(POM1)DIR(NF, ALF,$XO,$XP,$XP$POM2
  CALL UXVDIR(NCA, ALF,$XO(NF+1),$XP(NF+1),$XP(NF+1))
  CALL UX$(POM1)DIR(NF,-ALF,$GO,$XS,$XS$POM2
  CALL UXVDIR(NCA,-ALF,$GO(NF+1),$XS(NF+1),$XS(NF+1))
*
*     CG SMOOTHING
*
  $IF(MOS3=0)
  $ELSE
    RMU=ONE/ETA9
    CALL UX$(POM1)DIF(NF,$GS,$XS,$GO$POM2
    CALL UXVDIF(NCA,$GS(NF+1),$XS(NF+1),$GO(NF+1))
    BTB=UX$(POM1)DOT(NF,$GO,$GO$POM2+UXVDOT(NCA,$GO(NF+1),$GO(NF+1))
    BTR=UX$(POM1)DOT(NF,$GO,$XS$POM2+UXVDOT(NCA,$GO(NF+1),$XS(NF+1))
    RMU=-BTR/MAX(BTB,RMU)
    CALL UX$(POM1)DIR(NF,RMU,$GO,$XS,$GS$POM2
    CALL UXVDIR(NCA,RMU,$GO(NF+1),$XS(NF+1),$GS(NF+1))
    CALL UX$(POM1)DIF(NF,$S,$XP,$GO$POM2
    CALL UXVDIF(NCA,$S(NF+1),$XP(NF+1),$GO(NF+1))
    CALL UX$(POM1)DIR(NF,RMU,$GO,$XP,$S$POM2
    CALL UXVDIR(NCA,RMU,$GO(NF+1),$XP(NF+1),$S(NF+1))
  $ENDIF
  TDXX='CG  STEP'
*
*     TERMINATION CRITERION
*
  L1=NRED.GE.MMX
  IF (L1) TDXX='MAX ITER'
  SIG2=UXVDOT(NCA,$GS(NF+1),$GS(NF+1))
  IF (SIG2.LE.PAR*SIG1) THEN
  RHO2=UX$(POM1)DOT(NF,$GS,$GS$POM2
  IF (RHO2.LE.PAR*RHO1) L1=.TRUE.
  ELSE IF (KOUT.GT.2) THEN
  RHO2=UX$(POM1)DOT(NF,$GS,$GS$POM2
  ENDIF
*
*     TEST FOR DESCENT DIRECTION
*
$REM  $LIT=$20
$REM  $SUBST('UDSLQT')
*
*     CG PRECONDITIONING
*
  $INPF=XS
  $IF(MOS2=0)
    $OUTF=XS
  $ELSE
    $OUTF=GO
  $ENDIF
  $SUBST('UDSLIP')
  RHO2=UX$(POM1)DOT(NF,$XS,$OUTF$POM2
  SIG2=UXVDOT(NCA,$XS(NF+1),$OUTF(NF+1))
  ALF=(RHO2+SIG2)/(RHO+SIG)
  CALL UX$(POM1)DIR(NF,ALF,$XO,$OUTF,$XO$POM2
  CALL UXVDIR(NCA,ALF,$XO(NF+1),$OUTF(NF+1),$XO(NF+1))
  RHO=RHO2
  SIG=SIG2
$15 CONTINUE
  TDXX='MAX ITER'
*
*     AN INEXACT SOLUTION IS OBTAINED
*
$20 CONTINUE
  CALL UCQADD(NF,NX,NC,NCA,MC,$X,$IX,$XL,$XU,$CF,$IC,$CL,$CU,$CG,$ICG,
     & $ICA,$S,$SO,$XS,$CP,EPS9,INEW)
  GO TO $10
$25 CONTINUE
*
*     COMPUTATION OF THE DIRECTIONAL DERIVATIVE
*
$REM  $SUBST('UDSLID')
$REM  CALL UODLI4(NF,NX,NC,NCA,$D,$S(NF+1),$XO,$GO,$GS(NF+1))
$90 CONTINUE
  CALL UOD1D2(NF,$G,$S)
  $ADD(INIT)
    NDXX='UDSLQ3'
  $ENDADD
  $EXIT

