$INTERFACE UDSLX1                                             16/12/01
$REM LU

  $GS='GS'
  $GP='GP'
$REM  $POM1='U'
$REM  $POM2=',$$IX,-KBF)'
  $POM1='V'
  $POM2=')'
$REM  $HELP
$REM    METHOD SELECTION:
$REM      1 - BISECTION
$REM      2 - TWO POINT QUADRATIC INTERPOLATION
$REM      3 - THREE POINT QUADRATIC INTERPOLATION
$REM      4 - THREE POINT CUBIC INTERPOLATION
$REM  $CHECK(MES,1,'1\2\3\4',3)
  $DEFAULT='ETA0*1.0$P-3'
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,DEFAULT,REAL,4)
  $ADD(REAL,'\$H($MMAX)\$G($NF+1)\$S($NF+1)\$XO($NF+1)\$GO($NF+1)&
  \$GS($NF+1)\$GP($NF+1)')
  $ADD(REAL,'\$X($NF+1)\$AZL($NA)\$AZU($NA)')
  $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)')
  $IF(HESF='S')
  $ADD(INTEGER,'\$IH($NF+2)\$JH($MMAX)')
  $ELSEIF(HESF='D')
  $ADD(REAL,'\HH($MMAX)')
  $ENDIF
  $ADD(REAL,'\UXVDOT\UX$(POM1)DOT')
  $ADD(REAL,'\ALF\BET\RHO')
  $ADD(INTEGER,'\I\J\JP\K\L\MM')
  CALL UOD1D1
  GNORM=SQRT(UXVDOT(NF,$G,$G))
  $IF(HESF='D')
    $HH='HH'
    CALL UXDSMC(NF,$H,$HH)
  $ENDIF
  $SUBST('UDSLXI')
  IDECF=0
  INITD=MAX(ABS(INITD),1)
  IF (IDECF.NE.1) THEN
*
*     GILL-MURRAY DECOMPOSITION
*
  $IF(HESF='S')
    MM=$IH(NF+1)-1
    CALL UXSPCT(NF,MM,MH,MMAX,$H,$JH,$PSL,ITERM)
    IF (ITERM.NE.0) THEN
    TDXX='LACK SPC'
    GO TO $90
    ENDIF
    ALF=ETA2
    CALL UXSPCF(NF,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$WN11,$WN12,$GO,INF&
,ALF,RHO)
  $ELSEIF(HESF='D')
    ALF=ETA2
    CALL UXDPGF(NF,$HH,INF,ALF,RHO)
  $ENDIF
  NDECF=NDECF+1
  IDECF=1
  ENDIF
*
*     BACK SUBSTITUTIONS
*
  CALL UXVCOP(NF,$GS,$GP)
  $IF(HESF='S')
  CALL UXVSFP(NF,$PERM,$GP,$GO)
  CALL UXSPCB(NF,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$GP,0)
  CALL UXVSBP(NF,$PERM,$GP,$GO)
  $ELSEIF(HESF='D')
    CALL UXDPGB(NF,$HH,$GP,0)
  $ENDIF
  CALL UXVNEG(NF,$G,$S)
  $IF(HESF='S')
    CALL UXVSFP(NF,$PERM,$S,$GO)
    CALL UXSPCB(NF,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$S,0)
    CALL UXVSBP(NF,$PERM,$S,$GO)
  $ELSEIF(HESF='D')
    CALL UXDPGB(NF,$HH,$S,0)
  $ENDIF
  IF (UXVDOT(NF,$GS,$GP)-$GS(NF+1).EQ.ZERO) THEN
  $S(NF+1)=ZERO
  ELSE
  $S(NF+1)=-(UXVDOT(NF,$GS,$S)-G(NF+1))/(UXVDOT(NF,$GS,$GP)-$GS(NF+1))
  CALL UXVDIR(NF,$S(NF+1),$GP,$S,$S)
  ENDIF
  SNORM=SQRT(UXVDOT(NF,$S,$S))
*
*     COMPUTATION OF THE DIRECTIONAL DERIVATIVE
*
  P=UXVDOT(NF,$S,$G)
  CALL UODLX4(NF,NA,$X,$G,$S,$GS,FF,RPF3,INF)
$90 CONTINUE
  R=ZERO
  CALL UOD1D2(NF,$G,$S)
  $ADD(INIT)
    NDXX='UDSLX1'
  $ENDADD
  $EXIT
