$INTERFACE UE1DQ2                                             98/12/01

      $SUBST('UZESET')
 $ADD(REAL,'\$GE($NF)\$DE($NE)\$YA($MEL)\$EF($MEL)')
$REM $ADD(INTEGER,'\NF\NE\MEL\KE')
$REM $ADD(REAL,'\FE\WE\YE')
 $00  CALL UE1DQ2(NF,NE,MEL,KE,$GE,$DE,$YA,$EF,FE,WE,YE)
      GO TO ($20,$10) ISB+1
 $10  CONTINUE
      $IF(LED<0)
        $MTYPE=FMODE
        $SUBST('UZEMOD')
      $ELSE
        FE=$EF(KE)
      $ENDIF
      IF (KD.LE.0) GO TO $00
      $IF(LED<1)
        $IF(GMODE='G')
          $MTYPE=GMODE
          $SUBST('UZEMOD')
        $ENDIF
        $IF(DMODE='D')
          $MTYPE=DMODE
          $SUBST('UZEMOD')
        $ENDIF
        $IF(GMODE='GD')
          $MTYPE=GMODE
          $SUBST('UZEMOD')
        $ENDIF
      $ELSE
        CALL UXVCOP(NF,$EG((KE-1)*NF+1),$GE)
        CALL UXVCOP(NE,$ED((KE-1)*NE+1),$DE)
      $ENDIF
      $GO TO $00
 $20  CONTINUE
      $ADD(INIT)
        NEXX='UE1DQ2'
      $ENDADD
      $EXIT

* IMPLEMENTATION

* SUBROUTINE UE1DQ2             ALL SYSTEMS                 98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE AND THE GRADIENT OF THE OBJECTIVE FUNCTION
* WHICH IS DEFINED AS A SUM OF SQUARES.
*
* PARAMETERS:
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  NE  DECLARED NUMBER OF DIFFERENTIAL EQUATIONS.
*  II  MEL  ACTUAL NUMBER OF DIFFERENTIAL EQUATIONS.
*  IU  KE  INDEX OF THE DIFFERENTIAL EQUATION.
*  RU  GE(NF)  GRADIENT OF THE RIGHT HAND SIDE FUNCTION.
*  RU  DE(NF)  DERIVATIVES OF THE RIGHT HAND SIDE FUNCTION.
*  RI  YA(MEL)  SOLUTION VECTOR.
*  RO  EF(MEL)  RIGHT HAND SIDE VECTOR.
*  RI  FE  VALUE OF THE RIGHT HAND SIDE FUNCTION.
*  RI  WE  WEIGHT COEFFICIENT.
*  RI  YE  REQUIRED VALUE OF THE RIGHT HAND SIDE FUNCTION.
*
* COMMON DATA :
*  II  KD  ORDER OF REQUIRED DERIVATIVES.
*  II  KDA  ORDER OF ANALYTICALLY COMPUTED DERIVATIVES.
*  II  KDE  ORDER OF ANALYTICALLY COMPUTED DERIVATIVES.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S  UYPRO1  PROLOGUE.
*  S  UYEPI1  EPILOGUE.
*  S  UYSET0  STATUS DEFINITION.
*  S  UXVCOP  COPYING OF A VECTOR.
*  S  UXVDIR  VECTOR AUGMENTED BY THE SCALED VECTOR.
*  S  UXVSET  INITIATION OF A VECTOR.
*
      SUBROUTINE UE1DQ2(NF,NE,MEL,KE,GE,DE,YA,EF,FE,WE,YE)
      $INCLUDE ('UMCOMM')
      INTEGER NF,NE,MEL,KE
      $FLOAT GE(NF),DE(NE),YA(MEL),EF(MEL),FE,WE,YE
      IF (TSS(NS).NE.'UEXX') CALL UYPRO1('UEXX',-1)
      GO TO (1,3) ISP(NS)
    1 CONTINUE
      IF (KD.LE.0.AND.KDA.GE.0) EF(NE+1)=ZERO
      IF (KD.GT.0) THEN
      CALL UXVSET(NE,ZERO,EF(NE+1))
      CALL UXVSET(NF,ZERO,EF(2*NE+1))
      ENDIF
      KE=1
    2 IF (KE.GT.NE) GO TO 4
      CALL UYSET0(1,2)
      RETURN
    3 CONTINUE
      EF(KE)=FE
      IF (KD.LE.0.AND.KDA.GE.0) EF(NE+1)=EF(NE+1)+HALF*WE*(YA(KE)-YE)**2
      IF (KD.GT.0) THEN
      CALL UXVDIR(NE,-YA(NE+KE),DE,EF(NE+1),EF(NE+1))
      EF(NE+KE)=EF(NE+KE)+WE*(YA(KE)-YE)
      IF (KDE.GT.0) CALL UXVDIR(NF,-YA(NE+KE),GE,EF(2*NE+1),EF(2*NE+1))
      ENDIF
      KE=KE+1
      GO TO 2
    4 CALL UYEPI1(-1)
      RETURN
      END
