$INTERFACE UE1SQ1                                             98/12/01

      $HELP
        MASS OF THE FICTIONAL PARTICLE
      $CHECK(GAM1,'1.0$P 0',REAL,4)
      $ADD(REAL,'\$EF($MEL)\$YA($MEL)\$G($NF)')
$REM $ADD(INTEGER,'\NF\MEL')
$REM $ADD(REAL,'\F\E\GMAX')
 $00  CALL UE1SQ1(NF,MEL,$EF,$X,$G,$GAM1,F,E,GMAX)
      GOTO ($20,$10,$LET) ISB+1
 $10  CONTINUE
      $HELP
        MAXIMUM NUMBER OF ITERATIONS
      $CHECK(MIT,1000,INT,3)
      $HELP
        MAXIMUM NUMBER OF COMPUTED FUNCTION VALUES
      $CHECK(MFV,6000,INT,3)
      $HELP
        LOWER BOUND FOR FUNCTION VALUE
      $CHECK(TOLB,'1.0D-16',REAL,3)
      $IF(KD<>0)
        $DEFAULT='1.0$P-6'
        $IF(KDF=0) $DEFAULT='1.0$P-5'
        $HELP
          LOWER BOUND FOR GRADIENT
        $CHECK(TOLG,DEFAULT,REAL,3)
      $ENDIF
      $SUBST('UZMODL')
      GOTO $00
 $20  CONTINUE
      $ADD(INIT)
        NEXX='UE1SQ1'
      $ENDADD
      $EXIT

* IMPLEMENTATION

* SUBROUTINE UE1SQ1             ALL SYSTEMS                 98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE OF THE RIHGT HAND SIDE FUNCTION.
*
* PARAMETERS :
*  RO  EF(MEL)  RIGHT HAND SIDE VECTOR.
*  RI  X(MEL)  SOLUTION VECTOR.
*  RI  G(NF)  GRADIENT OF THE OBJECTIVE FUNCTION.
*  RI  GAM1 PARAMETER.
*  RI  F  NEW VALUE OF THE OBJECTIVE FUNCTION.
*  RI  E  VALUE.
*  RI  GNORM  NORM OF THE GRADIENT VECTOR.
*
* COMMON DATA :
*  II  LFV  NUMBER OF THE FIRST COMPUTED FUNCTION VALUE.
*  II  MFV  MAXIMUM NUMBER OF COMPUTED FUNCTION VALUES.
*  IU  NFV  ACTUAL NUMBER OF COMPUTED FUNCTION VALUES.
*  IO  ITERM  TERMINATION INDICATOR. ITERM=1-TERMINATION AFTER MTESX
*         UNSUFFICIENT STEPLENGTHS. ITERM=2-TERMINATION AFTER MTESF
*         UNSUFFICIENT FUNCTION DECREASES. ITERM=3-TERMINATION ON LOWER
*         BOUND FOR FUNCTION VALUE. ITERM=4-TERMINATION ON LOWER BOUND
*         FOR GRADIENT. ITERM=11-TERMINATION AFTER MAXIMUM NUMBER OF
*         ITERATIONS. ITERM=12-TERMINATION AFTER MAXIMUM NUMBER OF
*         COMPUTED FUNCTION VALUES.
*  RI  TOLB  LOWER BOUND FOR FUNCTION VALUE.
*  RI  TOLG  LOWER BOUND FOR GRADIENT.
*  TO  TXFU  TEXT INFORMATION ON THE CAUSE OF TERMINATION.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S  UYPRO1  PROLOGUE.
*  S  UYEPI1  EPILOGUE.
*  S  UYSET0  STATUS DEFINITION.
*  S  UYSET2  RESETING OF DERIVATIVE INDICATOR.
*
      SUBROUTINE UE1SQ1(NF,MEL,EF,YA,G,GAM1,F,E,GMAX)
      $INCLUDE ('UMCOMM')
      INTEGER NF,MEL
      $FLOAT EF(MEL),YA(MEL),G(NF),GAM1,F,E,GMAX
      $FLOAT BET,UXVMAX
      INTEGER KE
      IF (TSS(NS).NE.'UEXX') CALL UYPRO1('UEXX',-1)
      GO TO (1,2) ISP(NS)
    1 CONTINUE
      CALL UYSET2
      CALL UYSET0(1,2)
      RETURN
    2 CONTINUE
      IF (E.EQ.ZERO) E=F
      IF (F.LE.TOLB) THEN
      ITERM=3
      TXFU = 'FV BOUND'
      GO TO 5
      ENDIF
      GMAX=UXVMAX(NF,G)
      IF (GMAX.LE.TOLG) THEN
      ITERM=4
      TXFU = 'GRAD TOL'
      GO TO 5
      ENDIF
      IF (NFV-LFV.GE.MFV) THEN
      ITERM=12
      TXFU='FV LIMIT'
      CALL UOERR1('UYFUT1',-2)
      GO TO 5
      ENDIF
      DO 3 KE=1,NF
      EF(KE)=YA(KE+NF)
      BET=E/F
      EF(KE+NF)=-(BET*YA(KE+NF)+G(KE))/GAM1
    3 CONTINUE
      CALL UYEPI1(-1)
      RETURN
    5 CALL UYEPI1(-1)
      ISB=2
      RETURN
      END
