$INTERFACE UF0F01                                             97/12/01

  $HELP
    TYPE OF EXTREMUM:
      0 - MINIMUM
      1 - MAXIMUM
  $CHECK(IEXT,0,'0\1',1)
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(FMIN,'-$ETA9',REAL,2)
$REM  $ADD(REAL,'\FF\F')
 $00  CALL UF0F01(FF,F)
      GOTO ($20,$10) ISB+1
 $10  CONTINUE
      $MTYPE=FMODF
      $SUBST('UZFMOD')
      GOTO $00
 $20  CONTINUE
      $ADD(INIT)
        NFXX='UF0F01'
      $ENDADD
      $EXIT

* IMPLEMENTATION

* SUBROUTINE UF0F01             ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE OBJECTIVE FUNCTION VALUE.
*
* PARAMETERS :
*  RI  FF  VALUE OF THE MODEL FUNCTION.
*  RO  F  VALUE OF THE OBJECTIVE FUNCTION.
*
* COMMON DATA :
*  II  KD  DEGREE OF REQUIRED DERIVATIVES.
*  II  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*  II  IEXT  TYPE OF EXTREMUM. IEXT=0-MINIMUM. IEXT=1-MAXIMUM.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S   UYPRO1  PROLOGUE.
*  S   UYEPI1  EPILOGUE.
*  S   UYSET0  STATUS DEFINITION.
*
      SUBROUTINE UF0F01(FF,F)
      $INCLUDE ('UMCOMM')
      $FLOAT FF,F
      IF (TSS(NS).NE.'UFXX') CALL UYPRO1('UFXX',-1)
      GO TO (1,2) ISP(NS)
    1 CONTINUE
      IF (KD.LT.0) GO TO 3
      IF (LD.GE.0) GO TO 3
      CALL UYSET0(1,2)
      RETURN
    2 CONTINUE
      IF (IEXT.LE.0) THEN
      F= FF
      ELSE
      F=-FF
      ENDIF
    3 CALL UYEPI1(-1)
      LD=KD
      RETURN
      END
