$INTERFACE UF0FL1                                             97/12/01

  $HELP
    TYPE OF EXTREMUM
      0 - MINIMUM
      1 - MAXIMUM
  $CHECK(IEXT,0,'0\1',1)
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(FMIN,'-$ETA9',REAL,2)
  $ADD(REAL,'\$X($NF)\$XN($NF)\$GF($NF)')
$REM  $ADD(REAL,'\FF\F')
$REM  $ADD(INTEGER,'\NF')
  CALL UF0FL1(NF,$X,$XN,$GF,FF,F)
  $ADD(INIT)
    NFXX='UF0FL1'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UF0FL1                ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE OF THE LINEAR OBJECTIVE FUNCTION.
*
* PARAMETERS:
*  II  NF  NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RI  GF(NF)  GRADIENT OF THE LINEAR MODEL FUNCTION.
*  RI  FF  CONSTANT TERM OF THE LINEAR MODEL FUNCTION.
*  RO  F  VALUE OF THE LINEAR OBJECTIVE FUNCTION.
*
* COMMON DATA :
*  II  KD  DEGREE OF REQUIRED DERVATIVES.
*  II  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*  II  ISNC  SAVING SPECIFICATION. ISNC=0-NO SAVING. ISNC=1-CONSTRAINT
*         VALUES ARE SAVED. ISNC=2-CONSTRAINT VALUES AND GRADIENTS ARE
*         SAVED.
*  II  IEXT  TYPE OF EXTREMUM. IEXT=0-MINIMUM. IEXT=1-MAXIMUM.
*
* SUBPROGRAMS USED :
*  RF  UXVDOT  DOT PRODUCT OF TWO VECTORS.
*  RF  UXVVDP  INVERSELY SCALED DOT PRODUCT OF TWO VECTORS.
*
      SUBROUTINE UF0FL1(NF,X,XN,GF,FF,F)
      $INCLUDE ('UMCOMM')
      INTEGER NF
      $FLOAT X(NF),XN(NF),GF(NF),FF,F
      $FLOAT UXVDOT,UXVVDP
      IF (NORMF.GT.0.AND.ISNC.GT.2) THEN
      F=FF+UXVVDP(NF,XN,X,GF)
      ELSE
      F=FF+UXVDOT(NF,X,GF)
      ENDIF
      IF (IEXT.GT.0) F=-F
      RETURN
      END
