$INTERFACE UF0HS1                                             97/12/01

  $HELP
    PRECISION OF THE COMPUTED VALUES
  $CHECK(ETA1,ETA0,REAL,4)
  CALL UF0HS1(NF,$X,$IX,$XN,$HF,$GO,$GS,FF,$ETA1)
  $ADD(REAL,'\$X($NF)\$XN($NF)\$HF($NF*($NF+1)/2)\$GO($NF)\$GS($NF)')
$REM  $ADD(REAL,'\FF')
  $ADD(INTEGER,'\$IX($NX)')
$REM  $ADD(INTEGER,'\NF')
  $ADD(INIT)
    NFHX='UF0HS1'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UF0HS1              ALL SYSTEMS                  97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* NUMERICAL COMPUTATION OF THE HESSIAN MATRIX OF THE MODEL FUNCTION
* USING ITS VALUES.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RO  HF(NF*(NF+1)/2) HESSIAN MATRIX OF THE MODEL FUNCTION.
*  RA  GO(NF)  AUXILIARY VECTOR.
*  RA  GS(NF)  AUXILIARY VECTOR.
*  RI  FF  VALUE OF THE MODEL FUNCTION.
*  RI  ETA1  PRECISION OF THE COMPUTED VALUES.
*
* COMMON DATA :
*  II  KBF  TYPE OF BOUNDS. KBF=0-BOUNDS ARE NOT USED. KBF=1-ONE SIDED
*         BOUNDS. KBF=1-TWO SIDED BOUNDS.
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S   UYPRO1  PROLOGUE.
*  S   UYEPI1  EPILOGUE.
*  S   UYSET0  STATUS DEFINITION.
*
      SUBROUTINE UF0HS1(NF,X,IX,XN,HF,GO,GS,FF,ETA1)
      $INCLUDE('UMCOMM')
      INTEGER NF,IX(NF)
      $FLOAT X(NF),XN(NF),HF(NF*(NF+1)/2),GO(NF),GS(NF),FF,ETA1
      $FLOAT XTEMPI,XTEMPJ,FTEMP,ETA
      INTEGER I,J,IJ,IVAR,JVAR,IND
      SAVE XTEMPI,XTEMPJ,FTEMP,ETA
      SAVE IVAR,JVAR
      IND(I,J)=MAX(I,J)*(MAX(I,J)-1)/2+MIN(I,J)
      IF (TSS(NS).NE.'UFHX') CALL UYPRO1('UFHX',-1)
      GO TO (1,3,8) ISP(NS)
    1 CONTINUE
      ETA=ETA1**(ONE/THREE)
      FTEMP=FF
      IVAR=0
    2 CONTINUE
      IVAR=IVAR+1
      IF (IVAR.GT.NF) GO TO 4
      IF (KBF.GT.0) THEN
      IF (IX(IVAR).LE.-5) GO TO 2
      ENDIF
      IF (NORMF.GT.0) THEN
      GO(IVAR)=XN(IVAR)
      ELSE
      GO(IVAR)=ONE
      ENDIF
      GO(IVAR)=ETA*MAX(ABS(X(IVAR)),GO(IVAR))*SIGN(ONE,X(IVAR))
      XTEMPI=X(IVAR)
      X(IVAR)=X(IVAR)+GO(IVAR)
      GO(IVAR)=X(IVAR)-XTEMPI
      CALL UYSET0(1,2)
      RETURN
    3 CONTINUE
      GS(IVAR)=FF
      X(IVAR)=XTEMPI
      GO TO 2
    4 IVAR=0
    5 CONTINUE
      IVAR=IVAR+1
      IF (IVAR.GT.NF) GO TO 10
      IF (KBF.GT.0) THEN
      IF (IX(IVAR).LE.-5) GO TO 5
      ENDIF
      XTEMPI=X(IVAR)
      X(IVAR)=XTEMPI+GO(IVAR)
      JVAR=IVAR-1
    7 CONTINUE
      JVAR=JVAR+1
      IF (KBF.GT.0) THEN
      IF (IX(JVAR).LE.-5) GO TO 7
      ENDIF
      IF (JVAR.GT.NF) GO TO 9
      XTEMPJ=X(JVAR)
      X(JVAR)=X(JVAR)+GO(JVAR)
      CALL UYSET0(1,3)
      RETURN
    8 CONTINUE
      IJ=IND(IVAR,JVAR)
      HF(IJ)=((FTEMP-GS(IVAR))+(FF-GS(JVAR)))/(GO(IVAR)*GO(JVAR))
      X(JVAR)=XTEMPJ
      GO TO 7
    9 X(IVAR)=XTEMPI
      GO TO 5
   10 FF=FTEMP
      CALL UYEPI1(-1)
      RETURN
      END
