$INTERFACE UF2F02                                             97/12/01

  $IF(MODEL='FF')
    $HELP
      LOWER BOUND FOR FUNCTION VALUE
    $CHECK(FMIN,'-$ETA9',REAL,2)
  $ENDIF
  $IF(HESF='D')
    $KHLP=1
  $ELSEIF(HESF='S')
    $KHLP=2
  $ENDIF
  $00 CALL UF2F02
      GOTO ($40,$10,$30) ISB+1
  $10 CONTINUE
      $KD=1
      NRED=KD
      IF(KD.EQ.2) KD=1
      $SUBST('UZMODL')
      KD=NRED
      $KD=2
      IF(TSS(NS).EQ.'UFXX') GOTO $00
  $30 CONTINUE
      $IF(HMODA='H')
        $MTYPE='H'
        $SUBST('UZAMOD')
        $IF(NORMA>0) $SUBST('UANRH1')
        GOTO $00
      $ELSEIF(GMODA='G')
        $IF(HESF='S')
          $N='NF'
          $SUBST('UYPTSH')
        $ENDIF
        $SUBST('UF1H$(CON)$(KHLP)')
        GOTO ($00,$10) ISB+1
      $ELSEIF(FMODA='F')
        $SUBST('UF0H$(CON)$(KHLP)')
        GOTO ($00,$10) ISB+1
      $ELSEIF(FMODF='FG')
        $IF(HESF='S')
          $SUBST('UYPTSH')
        $ENDIF
        $SUBST('UF1H$(CON)$(KHLP)')
        GOTO ($00,$10) ISB+1
      $ELSE
        IF (LD.LT.0) GOTO $00
        GOTO $10
      $ENDIF
  $40 CONTINUE
      $ADD(INIT)
        NFXX='UF2F02'
      $ENDADD
      $EXIT

* IMPLEMENTATION

* SUBROUTINE UF2F02             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE AND THE GRADIENT AND THE HESSIAN MATRIX
* OF THE OBJECTIVE FUNCTION.
*
* COMMON DATA :
*  II  KD  DEGREE OF REQUIRED DERIVATIVES.
*  II  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S   UYPRO1  PROLOGUE.
*  S   UYEPI1  EPILOGUE.
*  S   UYSET0  STATUS DEFINITION.
*
      SUBROUTINE UF2F02
      $INCLUDE ('UMCOMM')
      IF (TSS(NS).NE.'UFXX') CALL UYPRO1('UFXX',-1)
      GO TO (1,2,4,6) ISP(NS)
    1 CONTINUE
      IF (KD.LT.0) GO TO 7
      IF (LD.GE.0) GO TO 3
      CALL UYSET0(1,2)
      RETURN
    2 CONTINUE
    3 IF (KD.LT.1) GO TO 7
      IF (LD.GE.1) GO TO 5
      CALL UYSET0(1,3)
      RETURN
    4 CONTINUE
    5 IF (KD.LT.2) GO TO 7
      IF (LD.GE.2) GO TO 7
      CALL UYSET0(2,4)
      RETURN
    6 CONTINUE
      IDECF=0
    7 CALL UYEPI1(-1)
      LD=KD
      RETURN
      END
