$INTERFACE UFSET2                                             16/12/01

  $HELP
    MAXIMUM SIZE OF THE PARTITIONED HESSIAN MATRIX
  $CHECK(MAH,'25*$NA',INT,1,NO)
  $ADD(INTEGER,'\$IAG($NA+1)')
$REM  $ADD(INTEGER,'\NA\MAH')
  $ADD(SINID)
    CALL UFSET2(NA,MAH,$IAG)
    WRITE(3,'(''NUMBER OF NONZERO ELEMENTS: MAH ='',I8)') MAH
    IF (MAH.GT.$MAH) THEN
    ITERM=-76
    CALL UOERR2('UFSET2',76,MAH,$MAH)
    CALL UOERR4
    ENDIF
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UFSET2             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE NUMBER OF NONZERO ELEMENTS OF THE SPARSE
* HESSIAN MATRIX STORED IN THE BLOCKED FORM.
*
* PARAMETERS :
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  MB  NUMBER OF NONZERO ELEMENTS OF THE PARTITIONED HESSIAN MATRIX.
*  RI  IAG(NA+1)  POSITION OF THE FIRST ROWS ELEMENTS IN THE SPARSE
*         JACOBIAN MATRIX.
*
      SUBROUTINE UFSET2(NA,MB,IAG)
      INTEGER NA,MB,IAG(NA+1)
      INTEGER K,L,KA
      MB=0
      DO 1 KA=1,NA
      K=IAG(KA)
      L=IAG(KA+1)-K
      MB=MB+L*(L+1)/2
    1 CONTINUE
      RETURN
      END

