$INTERFACE UFSET3                                             97/12/01

  CALL UXVINP(NF+1,$IH)
  CALL UXVINP(NF,$JH)
  CALL UFSET3(NF,NA,NAL,MA,M,MMAX,$IH,$JH,$IAG,$JAG,ITERM)
  CALL UFSET1(NF,M,$IH)
  $ADD(INTEGER,'\$IH($NF+1)\$JH($MMAX)\$IAG($NA+1)\$JAG($MA)')
$REM  $ADD(INTEGER,'\NF\NA\MA\ITERM')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UFSET3             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE SPARSE STRUCTURE OF THE HESSIAN MATRIX FROM THE
* SPARSE STRUCTURE OF THE JACOBIAN MATRIX.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIADLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  NAL  NUMBER OF LINEAR APPROXIMATED FUNCTIONS.
*  II  MA  NUMBER OF NONZERO ELEMENTS IN THE FIELD AG.
*  II  M  NUMBER OF NONZERO ELEMENTS IN THE FIELD H.
*  II  MMAX DECLARED LENGTH OF THE ARRAYS JH,H.
*  IO  IH(NF+1)  POINTERS OF THE DIAGONAL ELEMENTS OF H.
*  IO  JH(M)  INDICES OF THE NONZERO ELEMENTS OF H.
*  II  IAG(NA+1)  POSITION OF THE FIRST ROWS ELEMENTS IN THE FIELD AG.
*  II  JAG(MA)  COLUMN INDICES OF ELEMENTS IN THE FIELD AG.
*  IO  ITERM  CAUSE OF TERMINATION.
*
      SUBROUTINE UFSET3(NF,NA,NAL,MA,M,MMAX,IH,JH,IAG,JAG,ITERM)
      INTEGER NF,NA,NAL,MA,M,MMAX,IH(NF+1),JH(*),IAG(NA+1),JAG(MA),
     & ITERM
      INTEGER I,J,JF,JA,K,LF,LA,KA
      M=IH(NF+1)-1
      IF (M.GT.MMAX) THEN
      ITERM=-104
      CALL UOERR1('UFSET3',104)
      RETURN
      ENDIF
      DO 7 KA=NAL+1,NA
      LA=IAG(KA+1)-1
      DO 6 K=IAG(KA),LA
      I=JAG(K)
      JF=IH(I)
      LF=IH(I+1)-1
      DO 5 JA=K,LA
      J=JAG(JA)
    2 IF (JH(JF).LT.J.AND.JF.LE.LF) THEN
      JF=JF+1
      IF (JF.LE.LF) GO TO 2
      ENDIF
      IF (JH(JF).GT.J .OR.JF.GT.LF) THEN
      DO 3 J=I+1,NF+1
      IH(J)=IH(J)+1
    3 CONTINUE
      DO 4 J=M,JF,-1
      JH(J+1)=JH(J)
    4 CONTINUE
      JH(JF)=JAG(JA)
      JF=JF+1
      LF=LF+1
      M=M+1
      IF (M.GT.MMAX) THEN
      ITERM=-104
      CALL UOERR1('UFSET3',104)
      RETURN
      ENDIF
      ENDIF
    5 CONTINUE
    6 CONTINUE
    7 CONTINUE
      RETURN
      END
