$INTERFACE UFSET4                                             98/12/01

  $HELP
    MAXIMUM SIZE OF THE PARTITIONED HESSIAN MATRIX
  $CHECK(MAH,'25*$NA',INT,1)
  IF (ITERS.NE.0) THEN
  CALL UXVSET($IH(NF+1)-1,ZERO,$H)
  CALL UFSET4(NF,NA,NAL,MA,MAH,M,$H,$IH,$JH,$AH,$IAG,$JAG)
  ENDIF
  $ADD(INTEGER,'\$IH($NF+1)\$JH($M)\$IAG($NA+1)\$JAG($MA)')
$REM  $ADD(INTEGER,'\NF\NA\NAL\MA\MAH\M\ITERS')
  $ADD(REAL,'\$H($M)\$AH($MAH)')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UFSET4             ALL SYSTEMS                   98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE SPARSE HESSIAN MATRIX FROM THE PARTITIONED HESSIAN
* MATRIX.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIADLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  NAL  NUMBER OF LINEAR APPROXIMATED FUNCTIONS.
*  II  MA  NUMBER OF NONZERO ELEMENTS OF THE SPARSE JACOBIAN MATRIX.
*  II  MB  NUMBER OF NONZERO ELEMENTS OF THE PARTITIONED HESSIAN MATRIX.
*  IO  M  NUMBER OF NONZERO ELEMENTS OF THE SPARSE HESSIAN MATRIX.
*  RU  B(M)  ELEMENTS OF THE SPARSE MATRIX B.
*  IO  IH(NF+1)  POINTERS OF THE DIAGONAL ELEMENTS OF B.
*  IO  JH(M)  INDICES OF THE NONZERO ELEMENTS OF B.
*  II  AH(MB)  ELEMENTS OF THE PARTITIONED MATRIX H.
*  II  IAG(NA+1)  POSITION OF THE FIRST ROWS ELEMENTS IN THE FIELD AG.
*  II  JAG(MA)  COLUMN INDICES OF ELEMENTS IN THE FIELD AG.
*
      SUBROUTINE UFSET4(NF,NA,NAL,MA,MB,M,B,IH,JH,AH,IAG,JAG)
      INTEGER NF,NA,NAL,MA,MB,M,IH(NF+1),JH(M),IAG(NA+1),JAG(MA)
      $FLOAT B(M),AH(MB)
      INTEGER I,II,IA,J,JJ,JA,JF,K,KK,L,KA
      KK=0
      DO 7 KA=1,NA
      II=IAG(KA)
      L=IAG(KA+1)-II
      DO 6 IA=1,L
      KK=KK+IA
      IF (KA.LE.NAL) GO TO 5
      I=JAG(II)
      IF (I.LE.0) GO TO 5
      JF=IH(I)
      JJ=II
      K=KK
      DO 4 JA=IA,L
      J=JAG(JJ)
      IF (J.LE.0) GO TO 3
    2 IF (JH(JF).LT.J) THEN
      JF=JF+1
      GO TO 2
      ENDIF
      B(JF)=B(JF)+AH(K)
    3 K=K+JA
      JJ=JJ+1
    4 CONTINUE
    5 II=II+1
    6 CONTINUE
    7 CONTINUE
      RETURN
      END
