$INTERFACE UFSET8                                             98/12/01

  $HELP
    MAXIMUM SIZE OF THE PARTITIONED HESSIAN MATRIX
  $CHECK(MHA,'100',INT,1,NO)
  $ADD(INTEGER,'\$IAG($NA+1)')
$REM  $ADD(INTEGER,'\NA\MHA')
  $ADD(SINID)
    CALL UFSET8(NA,MHA,$IAG)
    IF (MHA.GT.$MHA) THEN
    ITERM=-86
    CALL UOERR2('UFSET8',86,MHA,$MHA)
    CALL UOERR4
    ENDIF
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UFSET8             ALL SYSTEMS                   98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE NUMBER OF NONZERO ELEMENTS OF THE SPARSE
* HESSIAN MATRIX STORED IN THE BLOCKED FORM.
*
* PARAMETERS :
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  MB  NUMBER OF NONZERO ELEMENTS OF THE PARTITIONED HESSIAN MATRIX.
*  RI  IAG(NA+1)  POSITION OF THE FIRST ROWS ELEMENTS IN THE SPARSE
*         JACOBIAN MATRIX.
*
      SUBROUTINE UFSET8(NA,MB,IAG)
      INTEGER NA,MB,IAG(NA+1)
      INTEGER K,L,KA
      MB=0
      DO 1 KA=1,NA
      K=IAG(KA)
      L=IAG(KA+1)-K
      MB=MAX(MB,L*(L+1)/2)
    1 CONTINUE
      RETURN
      END
