$INTERFACE UFSET9                                             97/12/01

  CALL UFSET9(NF,NC,NCC,MC,M,MMAX,$H,$IH,$JH,$ICG,$JCG,$PEN,ITERM)
  CALL UFSET1(NF,M,$IH)
  $ADD(INTEGER,'\$IH($NF+1)\$JH($MMAX)\$ICG($NC+1)\$JCG($MC)')
  $ADD(REAL,'\$H($MMAX)')
$REM  $ADD(INTEGER,'\NF\NC\NCC\MC\ITERM')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UFSET9             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE SPARSE STRUCTURE OF THE HESSIAN MATRIX FROM THE
* SPARSE STRUCTURE OF THE JACOBIAN MATRIX.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIADLES.
*  II  NC  NUMBER OF GENERAL CONSTRAINTS.
*  II  NCC  NUMBER OF COMPLEMENTARITY CONSTRAINTS.
*  II  MC  NUMBER OF NONZERO ELEMENTS IN THE FIELD CG.
*  II  M  NUMBER OF NONZERO ELEMENTS IN THE FIELD H.
*  II  MMAX DECLARED LENGTH OF THE ARRAYS JH,H.
*  IO  H(M)  NONZERO ELEMENTS OF H.
*  IO  IH(NF+2)  POINTERS OF THE DIAGONAL ELEMENTS OF H.
*  IO  JH(M)  INDICES OF THE NONZERO ELEMENTS OF H.
*  II  ICG(NC+NCC+1)  POSITION OF THE FIRST ROWS ELEMENTS IN THE
*         FIELD CG.
*  II  JCG(MC)  COLUMN INDICES OF ELEMENTS IN THE FIELD CG.
*  II  JOB  TYPE OF THE JACOBIAN MATRIX. JOB=0-STANDARD JACOBIAN
*         MATRIX. JOB=1-JACOBIAN MATRIX WITH THE MINIMAX ROW.
*  IO  ITERM  CAUSE OF TERMINATION.
*
      SUBROUTINE UFSET9(NF,NC,NCC,MC,M,MMAX,H,IH,JH,ICG,JCG,JOB,ITERM)
      INTEGER NF,NC,NCC,MC,M,MMAX,IH(NF+2),JH(*),ICG(NC+1),JCG(MC),
     & JOB,ITERM
      $FLOAT H(*)
      INTEGER I,J,JF,JC,K,LF,LC,KC
      M=IH(NF+1)-1
      IF (M.GT.MMAX) THEN
      ITERM=-104
      CALL UOERR1('UFSET9',104)
      RETURN
      ENDIF
      DO 7 KC=NC+1,NC+NCC
      LC=ICG(KC+1)-1
      DO 6 K=ICG(KC),LC
      I=JCG(K)
      JF=IH(I)
      LF=IH(I+1)-1
      DO 5 JC=K,LC
      J=JCG(JC)
    2 IF (JH(JF).LT.J.AND.JF.LE.LF) THEN
      JF=JF+1
      IF (JF.LE.LF) GO TO 2
      ENDIF
      IF (JH(JF).GT.J .OR.JF.GT.LF) THEN
      DO 3 J=I+1,NF+1
      IH(J)=IH(J)+1
    3 CONTINUE
      DO 4 J=M,JF,-1
      JH(J+1)=JH(J)
    4 CONTINUE
      JH(JF)=JCG(JC)
      JF=JF+1
      LF=LF+1
      M=M+1
      IF (M.GT.MMAX) THEN
      ITERM=-104
      CALL UOERR1('UFSET9',104)
      RETURN
      ENDIF
      ENDIF
    5 CONTINUE
    6 CONTINUE
    7 CONTINUE
      IF (JOB.GT.0) THEN
      M=M+1
      IF (M.GT.MMAX) THEN
      ITERM=-104
      CALL UOERR1('UFSET9',104)
      RETURN
      ENDIF
      JH(M)=NF+1
      H(M)=0.0$P 0
      IH(NF+2)=IH(NF+1)+1
      ENDIF
      RETURN
      END
