* SUBROUTINE UG1F02             ALL SYSTEMS                 91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  COMPUTATION OF THE TUNNELING FUNCTION AND ITS GRADIENT.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  RU  F  FUNCTION VALUE.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  FMIN  FUNCTION VALUE IN XMIN.
*  RI  XMIN(NF)  VECTOR OF VARIABLES IN MINIMUM.
*  RU  G(NF)  GRADIENT.
*  RI  PFILL  FILL PARAMETER.
*  II  KD  DEGREE OF REQUARED DERIVATION.
*
      SUBROUTINE UG1F02(NF,F,X,FMIN,XMIN,G,PFILL,KD)
      INTEGER NF,KD
      $FLOAT F,X(NF),FMIN,XMIN(NF),G(NF),PFILL
      $FLOAT UXVNM2
      $FLOAT A,B,C,D,DMAX
      PARAMETER (DMAX=100.0$P 0)
      INTEGER I
      A=UXVNM2(NF,X,XMIN)
      D=PFILL*A
      IF (D.GT.DMAX) D=DMAX
      B=EXP(D)
      C=F-FMIN
      IF (KD.GT.0) THEN
        DO 10 I=1,NF
          G(I)=-(G(I)+PFILL*C*((X(I)-XMIN(I))/A))*B
   10   CONTINUE
      ENDIF
      F=-C*B
      END
