$REM +---------------------------------------------------------------+
$REM + TEMPLATE: UGFU14                                    01/12/01  +
$REM + SI                                                            +
$REM + PURPOSE: GLOBAL OPTIMIZATION VIA REDUCED MULTIPLE RANDOM      +
$REM +          START METHOD WITH BAYESIAN STOPPING RULE             +
$REM +---------------------------------------------------------------+

      $HELP
        MAX. NUMBER OF POINTS IN THE RANDOM SAMPLE (IN ONE STEP)
      $CHECK(MNRND,'100+20*$NF',STR,3,NO)
      $HELP
        MAX. NUMBER OF LOCAL MINIMA
      $CHECK(MNLMIN,'50+10*$NF',STR,3,NO)
      $HELP
        REDUCTION OF RANDOM SAMPLE (TYPICALLY: 0.1 .. 0.2)
      $CHECK(GAMA,'0.1$(P)0',REAL,3,NO)
      $SUBST('UZSRND')
      $ADD(REAL,'\X($NF)\XL($NF)\XU($NF)')
      $TEXT='UGFU14'
      $SUBST('UO3FU1')
$L=$00; $LABEL
      CALL UGFU14(NF,X,XL,XU,F)
      GOTO ($30,$10,$20) ISB+1
$L=$20; $LABEL
      $SUBST('UZLMIN')
      GOTO $00
$L=$10; $LABEL
      $KD=0
      $SUBST('UZMODL')
      GOTO $00
$L=$30; $LABEL
$ADD(SUBROUTINES)
      SUBROUTINE UGFU14(NF,X,XL,XU,F)
      INTEGER NF
      $FLOAT X($NF),XL($NF),XU($NF),F
      $INCLUDE('UMCOMM')
      REAL UNRAN$RGTYPE
      $FLOAT FRS($MNRND),XRS($NF*($MNRND)),FSET($MNLMIN),
     &       XSET($NF*($MNLMIN)),GAMA
      INTEGER NRND,NRRND,NRNDT,MNRND,NLMIN,MNLMIN,INDX($MNRND),
     &       UYGSST,UYGSSZ,NITT,NFVT,NFGT,NFHT,NLMST,I,J,IDUM
      LOGICAL UYGST1,UYDMIN
      SAVE FRS,XRS,FSET,XSET,GAMA
      SAVE NRND,NRRND,NRNDT,MNRND,NLMIN,MNLMIN,INDX,
     & NITT,NFVT,NFGT,NFHT,NLMST,I,J
$REM      IF (NS.EQ.0.OR.TSS(NS).NE.'UGFX') THEN
      IF (NS.EQ.0) THEN
        CALL UYPRO1('UGFX',-1)
        NITT=0
        NFVT=0
        NFGT=0
        NFHT=0
        IDUM=-1
        NLMST=0
        MNRND=$MNRND
        MNLMIN=$MNLMIN
        GAMA=$GAMA
        X(1)=UNRAN$RGTYPE(IDUM)
        NRND=UYGSST(NF)
        IF (NRND.GT.MNRND) NRND=MNRND
        NRNDT=NRND
        NLMIN=0
      ENDIF
      GOTO (10,40,60), ISP(NS)
  *
  *     RANDOM SAMPLE
  *
   10 J=1
   20 CONTINUE
        IDUM=1
        DO 30 I=1,NF
          X(I)=(XU(I)-XL(I))*UNRAN$RGTYPE(IDUM)+XL(I)
   30   CONTINUE
        CALL UXVCOP(NF,X,XRS((J-1)*NF+1))
  *
  *     COMPUTATION OF THE FUNCTION VALUE
  *
        KD=0
        CALL UYSET2
        CALL UYSET0(1,2)
        RETURN
   40   CONTINUE
        FRS(J)=F
        NFVT=NFVT+1
        J=J+1
      IF (J.LE.NRND) GOTO 20
  *
  *     CREATE INDEX TABLE
  *
      CALL UYINDX(NRND,FRS,INDX)
  *
  *     REDUCTION
  *
      NRRND=NRND*GAMA
      I=1
   50 CALL UXVCOP(NF,XRS((INDX(I)-1)*NF+1),X)
  *
  *     LOCAL OPTIMIZATION
  *
      CALL UYCLST
      CALL UYSET0(2,3)
      RETURN
   60 CONTINUE
      NITT=NITT+NIT
      NFVT=NFVT+NFV
      NFGT=NFGT+NFG
      NFHT=NFHT+NFH
      NLMST=NLMST+1
      J=1
   70 CONTINUE
      IF (J.LE.NLMIN) THEN
        IF (UYDMIN(NF,F,X,FSET(J),XSET((J-1)*NF+1))) THEN
          J=J+1
          GOTO 70
        ENDIF  
      ENDIF
      IF (J.GT.NLMIN.AND.ITERM.GE.1.AND.ITERM.LE.10) THEN
        NLMIN=NLMIN+1
        CALL UXVCOP(NF,X,XSET((NLMIN-1)*NF+1))
        FSET(NLMIN)=F
        CALL UO3FU4(NITT,NFVT,NLMIN,F)
        IF (NLMIN.GE.MNLMIN) GOTO 80
      ENDIF
      I=I+1
      IF (I.LE.NRRND) GOTO 50
  *
  *     STOP IT ?
  *
      IF (.NOT.UYGST1(NLMIN,INT(GAMA*NRNDT))) THEN
  *
  *     NEW RANDOM SAMPLE SIZE
  *
        NRND=UYGSSZ(NLMIN,GAMA)
        IF (NRND.GT.MNRND) NRND=MNRND
        NRNDT=NRNDT+NRND
        GOTO 10
      ENDIF
  *
  *     PRINT OF RESULTS
  *
   80 CALL UYINDX(NLMIN,FSET,INDX)
      F=FSET(1)
      CALL UXVCOP(NF,XSET,X)
      NIT=NITT
      NFV=NFVT
      NFG=NFGT
      NFH=NFHT
      CALL UO3FU5(NF,NLMIN,MNLMIN,FSET,XSET,INDX)
      CALL UYEPI1(-1)
      END
$ENDADD
