* SUBROUTINE UKLOBJ                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* OBJECTIVE FUNCTION UPDATED.
*
* PARAMETERS :
*  II  N NUMBER OF COLUMNS.
*  II  M NUMBER OF ROWS.
*  II  MCOLS DECLARED NUMBER OF COLUMNS.
*  II  TYPE(N) TYPE OF THE VARIABLES:
*                                    =1 FOR NONBASIC LOWER BOUNDED
*                                    =2 FOR NONBASIC UPPER BOUNDED
*                                    =3 FOR NONBASIC LOWER AND UPPER
*                     BOUNDED VARIABLE SET TO ITS LOWER BOUND
*                                    =4 FOR NONBASIC LOWER AND UPPER
*                     BOUNDED VARIABLE SET TO ITS UPPER BOUND
*                                    =5 FOR NONBASIC FIXED VARIABLE
*                                    =6 FOR NONBASIC FREE VARIABLE
*                                    =-1 FOR BASIC LOWER BOUNDED
*                                    =-2 FOR BASIC UPPER BOUNDED
*                                    =-3 FOR BASIC LOWER AND UPPER
*                     BOUNDED VARIABLE
*                                    =-6 FOR BASIC FREE VARIABLE.
*  II  BCOL(N) COLUMNS OF THE BASIS.
*  RI  LB(N) LOWER BOUNDS ON VARIABLES.
*  RI  UB(N) UPPER BOUNDS ON VARIABLES.
*  RU  X(N) SOLUTION VECTOR.
*  IU  C(N) OBJECTIVE FUNCTION FOR THE LP PHASE.
*  RI  EPS9 TOLERANCE ON THE ZERO IN THE FIRST PHASE OBJECTIVE.
*  IO  KINP NUMBER OF ARTIFICIALS.
*
      SUBROUTINE UKLOBJ(N,M,MCOLS,TYPE,BCOL,LB,UB,X,C,EPS9,KINP)
      INTEGER N,M,MCOLS,TYPE(MCOLS),BCOL(MCOLS),KINP
      $FLOAT X(MCOLS),LB(MCOLS),UB(MCOLS),C(MCOLS),EPS9
      INTEGER I,J,TYPV
C
C BASIC PART OF OBJECTIVE FUNCTION IS FORMED
C
      DO 100 J=1,M-KINP
      I=BCOL(J)
      TYPV=TYPE(I)
      IF(TYPV.EQ.-1) THEN
         IF(X(I).LT.LB(I)-EPS9) THEN
           C(I)=-LB(I)+X(I)
         ELSE
           C(I)=0
         END IF
      ELSEIF(TYPV.EQ.-2) THEN
         IF(X(I).GT.UB(I)+EPS9) THEN
           C(I)=X(I)-UB(I)
         ELSE
           C(I)=0
         END IF
      ELSEIF(TYPV.EQ.-3) THEN
         IF(X(I).LT.LB(I)-EPS9) THEN
           C(I)=-LB(I)+X(I)
         ELSEIF(X(I).GT.UB(I)+EPS9) THEN
           C(I)=X(I)-UB(I)
         ELSE
           C(I)=0
         END IF
      ELSE
         C(I)=0
      END IF
  100 CONTINUE
C
C SIMPLE CORRECTION OF PART OF OBJECTIVE CORRESPONDING TO ARTIFICIALS
C
      DO 150 I=M-KINP+1,M
        J=BCOL(I)
        IF(X(J).LT.0) THEN
          C(J)=-1.0$P 0
        ELSE
          C(J)= 1.0$P 0
        ENDIF
  150 CONTINUE
C
C NONBASICS PART OF THE OBJECTIVE FUNCTION IS FORMED
C
         DO 200 I=1,N
         TYPV=TYPE(I)
         IF(TYPV.LT.0) GO TO 200
         IF(TYPV.EQ.1) THEN
            IF(X(I).LT.LB(I)-EPS9) THEN
              C(I)=-LB(I)+X(I)
            ELSE
              C(I)=0
            END IF
         ELSEIF(TYPV.EQ.2) THEN
            IF(X(I).GT.UB(I)+EPS9) THEN
              C(I)=X(I)-UB(I)
            ELSE
              C(I)=0
            END IF
         ELSEIF(TYPV.EQ.3) THEN
            IF(X(I).LT.LB(I)-EPS9) THEN
              C(I)=-LB(I)+X(I)
            ELSE
              C(I)=0
            END IF
         ELSEIF(TYPV.EQ.4) THEN
            IF(X(I).GT.UB(I)+EPS9) THEN
              C(I)=X(I)-UB(I)
            ELSE
              C(I)=0
            END IF
         ELSE
            C(I)=0
         END IF
  200    CONTINUE
      RETURN
      END
