$INTERFACE UKQGLM                                             98/12/01

  $HELP
    PRECISION FOR EITHER LINEAR OR QUADRATIC PROGRAMMING SUBROUTINE
  $CHECK(EPS7,'1.0$P-7',REAL,4)
  $HELP
    TOLERANCE FOR LAGRANGE MULTIPLIERS
  $CHECK(EPS8,'1.0$P-8',REAL,4)
  $HELP
    TOLERANCE FOR ACTIVE CONSTRAINTS
  $CHECK(EPS9,'1.0$P-9',REAL,4)
  $HELP
    MAXIMUM STEPSIZE
  $CHECK(XMAX,'1.0$P 3',REAL,2)
  $HELP
    MAXIMUM NUMBER OF MINOR CYCLES
  $CHECK(MIQ,500,INT,4,NO)
  $HELP
    MAXIMUM NUMBER OF MAJOR CYCLES
  $CHECK(MAQ,500,INT,4,NO)
  $HELP
    MAXIMUM NUMBER OF EXTRAPOLATIONS OR INTERPOLATIONS
  $CHECK(MRED,10,INT,4)
  CALL UKQGLM(NF,N,M,MROWS,MCOLS,NZ,NZA,NAU,NUP,MMAX,NEL,IBEG,IBGR&
,IENDLU,$PTL,$LENL,$CNR,$PTR,$LENR,$ORDC,$ORDR,$ORDL,$LI,$LJ,$CM,$AU&
,$LAM,$WR01,$X,$GF,$G,$HF,$JH,$IH,$BCOL,$RNR,$PRNR,$A,$INBCOL,$IX,$WN01&
,$WR02,$S,$XL,$XU,$ECG,$FCG,$RCG,$PV,$RIGHT,$UP,ALF1,ALF2,DEL1,DEL2&
,DEL3,EPS6,EPS7,EPS8,EPS9,RMIN,RMAX,DMAX,GMAX,UMAX,XMAX,GNORM,SNORM&
,XNORM,R,FF,F,FO,P,PO,T,TO,TL,TU,E,EL,EU,MFP,MQP,MQP1,MLP1,NIQ,NAQ,MRED&
,$MIQ,$MAQ,INEW,IOLD,KOLD,KINP,LINP,MINP,IER)
  $ADD(INTEGER,'\$INBCOL($MCOLS)\$JH($M)\$IH($MCOLS+1)')
  $ADD(REAL,'\$LAM($MCOLS)\$ECG($MCOLS)\$FCG($MCOLS)\$RCG($MCOLS)')
  $ADD(REAL,'\$PV($MCOLS)\$HF($M)\$S($MCOLS)')
$REM  $ADD(INTEGER,'NF\N\M\MROWS\MCOLS\NZ\NZA\NAU\NUP\MMAX\NEL\NAP\IBEG&
\IBGR\IENDLU\MFP\MQP\MQP1\MLP1\NIQ\NAQ\MRED\INEW\IOLD\KOLD\KINP\LINP&
\MINP\IER')
$REM  $ADD(REAL,'\ALF1\ALF2\DEL1\DEL2\DEL3\EPS6\EPS7\EPS8\EPS9\RMIN&
\RMAX\DMAX\GMAX\UMAX\XMAX\GNORM\SNORM\XNORM\FF\F\FO\P\PO\T\TO\TL\TU&
\E\EL\EU')
  $ADD(SINID)
    CALL UXVSET(MCOLS,ZERO,LAM)
  $ENDADD
  $ADD(INIT)
    NDXX='UKQGLM'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UKQGLM                 ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* PRIMAL SPARSE QUADRATIC PROGRAMMING DRIVER.
*
* PARAMETERS :
*  II  NF  ORIGINAL NUMBER OF VARIABLES.
*  II  N  NUMBER OF VARIABLES.
*  II  M  NUMBER OF ROWS OF THE MATRIX OF CONSTRAINTS.
*  II  MROWS DECLARED NUMBER OF ROWS.
*  II  MCOLS DECLARED NUMBER OF VARIABLES.
*  II  NZ SIZE OF THE INDEX ARRAY CNR
*  II  NZA SIZE OF THE INDEX ARRAY RNR
*  II  NAU SIZE OF THE ARRAY AU.
*  II  NUP SIZE OF THE ARRAYS LI,LJ,CM.
*  II  MMAX SIZE OF THE VECTORS SH,H.
*  II  NEL NUMBER OF L-UPDATES IN THE ARRAYS LI,LJ,CM.
*  IU  IBEG  BEGINNING OF THE FACTOR U IN CNR.
*  IU  IBGR  BEGINNING OF THE ROW INDICES OF THE FACTOR U IN CNR.
*  IU  IENDLU  END OF THE ROW INDICES OF THE FACTOR U IN CNR.
*  IU  PTL(MROWS) POINTER VECTOR OF THE COLUMNS OF THE L-FACTOR.
*  IU  LENL(MROWS) LENGTHS OF THE COLUMNS OF THE FACTOR L.
*  IU  CNR(NZ) CONTAINS THE INDICES OF THE FACTORS.
*  IU  PTR(MROWS) POINTER VECTOR OF THE ROWS OF THE FACTOR U.
*  IU  LENR(MRROWS) LENGTHS OF THE ROWS OF THE FACTOR U.
*  IU  ORDC(MROWS) COLUMN PERMUTATION OF THE FACTOR U OF THE BASIS.
*  IU  ORDR(MROWS) ROW PERMUTATION OF THE FACTOR U OF THE BASIS.
*  IU  ORDL(MROWS) ROW PERMUTATION OF THE ORIGINAL FACTOR L.
*  IU  LI(NUP) ROW INDICES OF THE L-UPDATES.
*  IU  LJ(NUP) COLUMN INDICES OF THE L-UPDATES.
*  RU  CM(NUP) UPDATE MULTIPLIERS.
*  RU  AU(NAU) NUMERICAL VALUES OF THE FACTORS.
*  RU  LAM(MCOLS) VECTOR OF REDUCED COSTS.
*  RA  WR01(MCOLS) AUXILIARY VECTOR.
*  RU  X(MCOLS) VECTOR OF SOLUTION.
*  RI  GF(MCOLS) GRADIENT OF THE MODEL FUNCTION.
*  RO  C(MCOLS)  GRADIENT VECTOR
*  RO  H(MMAX) NUMERICAL VALUES OF THE HESSIAN MATRIX.
*  IO  JH(MMAX) INDEX VECTOR OF THE HESSIAN MATRIX.
*  IO  IH(MROWS+1) POINTER VECTOR OF JH,H.
*  IU  BCOL(MCOLS) PERMUTATION ARRAY: FIRST M COMPONENTS FORM BASIS,
*              NEXT LINP-M FORM SUPERBASIS AND REST CORRESPOND TO
*              THE NON-BASIC VARIABLES.
*  II  RNR(NZA) COLUMNS OF THE ORIGINAL MATRIX A.
*  II  PRNR(MCOLS+1) POINTER VECTOR FOR RNR.
*  RI  A(NZA) NUMERICAL VALUES OF THE ELEM*ENTS OF THE CONSTRAINT
*             MATRIX.
*  IU  INBCOL(MCOLS) VECTOR WITH COMPONENTS :
*                INBCOL(K)=I WHEN EXISTS K=BCOL(I) AND I<=LINP,
*                INBCOL(K)=0 OTHERWISE.
*  II  TYPE(MCOLS) TYPES OF THE VARIABLES:
*                                    =1 FOR NONBASIC LOWER BOUNDED
*                                    =2 FOR NONBASIC UPPER BOUNDED
*                                    =3 FOR NONBASIC LOWER AND UPPER
*                     BOUNDED VARIABLE SET TO ITS LOWER BOUND
*                                    =4 FOR NONBASIC LOWER AND UPPER
*                     BOUNDED VARIABLE SET TO ITS UPPER BOUND
*                                    =5 FOR NONBASIC FIXED VARIABLE
*                                    =6 FOR NONBASIC FREE VARIABLE
*                                    =-1 FOR BASIC LOWER BOUNDED
*                                    =-2 FOR BASIC UPPER BOUNDED
*                                    =-3 FOR BASIC LOWER AND UPPER
*                     BOUNDED VARIABLE
*                                    =-6 FOR BASIC FREE VARIABLE.
*  IA  WN01(MCOLS) AUXILIARY VECTOR.
*  RA  WR02(MCOLS) AUXILIARY VECTOR.
*  RA  S(MCOLS) DIRECTION VECTOR.
*  RI  LB(MCOLS) LOWER BOUNDS ON VARIABLES.
*  RI  UB(MCOLS) UPPER BOUNDS ON VARIABLES.
*  RA  ECG(LINP-M) AUXILIARY VECTOR USED FOR CONJUGATE GRADIENTS.
*  RA  FCG(LINP-M) AUXILIARY VECTOR USED FOR CONJUGATE GRADIENTS.
*  RA  RCG(LINP-M) RESIDUUM VECTOR FOR CONJUGATE GRADIENTS.
*  RA  PV(LINP-M) PRECONDITIONING VECTOR FOR CONJUGATE GRADIENTS.
*  IU  RIGHT(MROWS) RIGHTMOST POSITION OF THE ROW SPIKE FOR BASIS.
*  IU  UP(MROWS) UPPERMOST POSITION OF THE COLUMN SPIKE FOR BASIS.
*  RI  ALF1  LOWER BOUND FOR STEPSIZE PARAMETER.
*  RI  ALF2  UPPER BOUND FOR STEPSIZE PARAMETER.
*  RI  DEL1  MULTIPLIER BOUND FOR PIVOT LOOK-UP.
*  RI  DEL2  RELATIVE BOUND FOR NEGLECTING SMALL ELEMENTS WHEN
*  RO  DEL3 CONTRACTING PARAMETER FOR CONVERGENCE WITH
*           THE PRESENT ACTIVE SET.
*  RO  EPS6  TOLERANCE.
*  RI  EPS7  DROPPING PARAMETER.
*  RO  EPS8  TOLERANCE.
*  RI  EPS9  TOLERANCE ON MULTIPLIERS.
*  RO  RMIN  MINIMUM VALUE OF THE STEPSIZE PARAMETER.
*  RO  RMAX  MAXIMUM VALUE OF THE STEPSIZE PARAMETER.
*  RU  DMAX   MINIMUM ELEMENT OF THE U-DIAGONAL.
*  RU  GMAX  MAXIMUM MULTIPLIER FOUND.
*  RU  UMAX   MAXIMUM ELEMENT OF THE U-DIAGONAL.
*  RI  XMAX  MAXIMUM STEPSIZE.
*  RO  GNORM NORM OF THE REDUCED GRADIENT.
*  RO  SNORM NORM OF THE VARIABLES CORRESPONDING TO THE ACTIVE SET.
*  RO  XNORM NORM OF THE STEP IN SUPERBASICS
*  RO  FF  ORIGINAL FUNCTIONAL VALUE.
*  RO  F  FUNCTIONAL VALUE.
*  RO  FO OLD FUNCTIONAL VALUE.
*  RO  P  VALUE OF THE DIRECTIONAL DERIVATIVE.
*  RI  PO  INITIAL VALUE OF THE DIRECTIONAL DERIVATIVE.
*  IO  T  PARAMETER INFLUENCING CONVERGENCE OF CG-ALGORITHM.
*  RO  TO  PARAMETER SIGNALIZING INCREASED ACCURACY FOR POSSIBLE
*            LAST UPDATE : =1  FOR POSSIBLE LAST UPDATE
*                          =0  OTHERWISE.
*  RA  TL  NORM OF THE CG-DIRECTION.
*  RA  TU  PARAMETER.
*  RI  E SPARSE QUADRATIC PROGRAMMING ACCURACY.
*  RO  EL NORM OF THE REDUCED COST.
*  RO  EU GNORM OF THE PREVIOUS ITERATION.
*  II  MFP  TYPE OF FEASIBLE POINT: ON OUTPUT FROM THE INITIAL
*           TRANSFORMATION IT IS >0  : =1 WHEN WE WANT A FEASIBLE
*           SOLUTION, =2 WHEN WE WANT AN OPTIMAL ONE, =3 WHEN
*           FEASIBLE SOLUTION IS GIVEN AND WE WANT AN OPTIMAL ONE.
*  IA  MQP  AUXILIARY DEGENERACY PARAMETER.
*  IO  MQP1 NUMBER OF REPEATED NULL ITERATIONS.
*  IU  MLP1  ACTUAL NUMBER OF DEGENERATE ITERATIONS.
*  IO  NIQ MINOR CYCLE COUNT.
*  IO  NAQ MAJOR CYCLE COUNT.
*  IO  MRED MAXIMUM REDUCTIONS DURING LINESEARCH.
*  IO  MIQ MAXIMUM NUMBER OF MINOR CYCLES.
*  IO  MAQ MAXIMUM NUMBER OF MAJOR CYCLES.
*  IO  INEW WHEN PNORM=0 AND ANTICYCLING RULE HAS BEEN USED - IT
*           DENOTES THE COLUMN GIVEN INTO THE BASIS.
*  IO  IOLD WHEN PNORM=0 AND ANTICYCLING RULE HAS BEEN USED - IT
*           DENOTES OUT-OF-THE-BASIS COLUMN ELSE : =0.
*  IU  KOLD NUMBER OF UPDATES AFTER THE LATEST ITERATION.
*  IO  KINP DEGENERACY INFORMATION PARAMETER.
*  IO  LINP  NUMBER OF SUPERBASICS.
*  IO  MINP SET UP WHEN FUNCTION/GRADIENT ARE INACCURATELY COMPUTED.
*  IO  IER  TYPE OF ABANDONING OF THE ACTIVE SET :
*           = 0 FOR FURTHER OPTIMIZATION WITH THE PRESENT ACTIVE SET
*           = 1 ABANDON ACTIVE SET FOR THE GRADIENT IS SMALLER THAN
*               SOME LOOSE BOUND AND DECREASE IN FUNCTION AND CHANGE
*               IN VARIABLES ARE BOTH TOO SMALL.
*           = 2 ABANDON ACTIVE SET FOR THE GRADIENT IS SMALLER THAN
*               SOME SHARP BOUND.
*           = 3 ABANDON ACTIVE SET WHEN NO PROGRESS IN OPTIMIZATION
*               IN CHNBND ITERATIONS IS NOT FACED.
*           = 4 ABANDON ACTIVE SET FOR THE ACCURACY OF THE FUNCTION
*               BEEING MINIMIZED IS SMALLER THAN CHANGES IN DIRECTION
*               AND/OR VARIABLES.
* COMMON DATA :
*  IO  NCGR  NUMBER OF ITERATIONS OF CONJUGATE GRADIENTS.
*  IU  NREF  NUMBER OF REFACTORIZATIONS OF THE BASIS MATRIX.
*  IA  ITERL TERMINATION INDICATOR USED FOR INTERNAL COMMUNICATION:
*                              =0 STANDARD VALUE
*                              FACTORIZATION OUTPUT:
*                              =1 IF NAU IS DECLARED TOO SMALL.
*                              =2 IF NZ IS TO BE INCREASED.
*                              =3 IF MATRIX IS TOO UNSTABLE.
*                              =4 IF MATRIX IS SINGULAR.
*                              =5 IF NZ IS TOO SMALL FOR THE FACTORS.
*                              =6 IF NAU IS TOO SMALL FOR FACTORS.
*                              =7 IF NZ IS SMALL FOR THE AFTER-F-MANIP.
*                              =8 LACK OF SPACE IN UXSGFD.
*                              DRIVER THROUGHPUT:
*                              =9 IF COLUMN INTO BASE IS THE SAME AS
*                                 OUT-OF-THE -BASE-COLUMN (INTERNAL).
*                              UPDATE OUTPUT:
*                              =11 IF NAU IS DECLARED TOO SMALL.
*                              =12 IF MATRIX IS SINGULAR.
*                              =13 IF FACTORS ARE BADLY CONDITIONED.
*                              =14 LITTLE SPACE FOR L-UPDATES.
*                              =15 MATRIX SINGULARITY IS FACED.
*                              DRIVER END OUTPUT (UKSGLE):
*                              =16 IF THERE IS NO FEASIBLE SOLUTION.
*  IO  ITERL TYPE OF FEASIBLE POINT. ITERL=1-ARBITRARY FEASIBLE POINT-
*         PHASE 1 OUTPUT,
*         ITERL=2-OPTIMUM FEASIBLE POINT. ITERL=-1 FEASIBLE POINT DOES
*         NOT EXISTS. ITERL=-2 OPTIMUM FEASIBLE POINT DOES NOT EXISTS,
*         ITERL=-3 - SMALL NAU, ITERL=-4 - NZ IS SMALL, ITERL=-5 - BADLY
*         CONDITIONED PROBLEM, ITERL=-6 -  SMALL NUP
*  IO  ITERQ INTERNAL OUTPUT INFORMATION:
*                              =0 FOR STANDARD OUTPUT
*                              FACTORIZATION OUTPUT:
*                              =1 IF NAU IS DECLARED TOO SMALL
*                              =2 IF NZ IS TO BE INCREASED
*                              =3 IF MATRIX IS TOO UNSTABLE
*                              =4 IF MATRIX IS SINGULAR
*                              =5 IF NZ IS TOO SMALL FOR THE FACTORS
*                              =6 IF NAU IS TOO SMALL FOR FACTORS
*                              =7 IF NZ IS SMALL FOR THE AFTER-F-MANIP.
*                              DRIVER OUTPUT:
*                              =10 IF THE SOLUTION IS UNBOUNDED.
*                              UPDATE OUTPUT:
*                              =11 IF NAU IS DECLARED TOO SMALL
*                              =12 IF MATRIX IS SINGULAR
*                              =13 IF FACTORS ARE BADLY CONDITIONED.
*                              =14 LITTLE SPACE FOR L-UPDATES.
*                              =15 MATRIX SINGULARITY IS FACED.
*                              DRIVER ULSGLM OUTPUT :
*                              =17 IF UNBOUNDNESS IS FACED.
*                              =51-54 FOR OPTIMUM SOLUTION :
*                                 EXPLAINED IN UKQGLC.
*  IO  ITERD  TERMINATION INDICATOR. ITERD<0-BAD DECOMPOSITION.
*         ITERD=0-DESCENT DIRECTION. ITERD=1-NEWTON LIKE STEP.
*         ITERD=2-INEXACT NEWTON LIKE STEP. ITERD=3-BOUNDARY STEP.
*         ITERD=4-DIRECTION WITH THE NEGATIVE CURVATURE.
*         ITERD=5-MARQUARDT STEP.
*  IO  ITERS  TERMINATION INDICATOR. ITERS=0-ZERO STEP. ITERS=1-PERFECT
*         LINE SEARCH. ITERS=2 GOLDSTEIN STEPSIZE. ITERS=3-WEAK WOLFE
*         STEPSIZE. ITERS=4-STRONG WOLFE STEPSIZE.
*         ITERS=5-ARMIJO STEPSIZE. ITERS=6-FIRST STEPSIZE.
*         ITERS=7-MAXIMUM STEPSIZE. ITERS=8-UNBOUNDED FUNCTION.
*         ITERS=-1-MRED REACHED. ITERS=-2-POSITIVE DIRECTIONAL
*         DERIVATIVE. ITERS=-3-ERROR IN INTERPOLATION.
*  TO  TLPX  TEXT INFORMATION ABOUT CAUSE OF LP TERMINATION.
*  TO  TQPX  TEXT INFORMATION ABOUT CAUSE OF QP TERMINATION.
*
      SUBROUTINE UKQGLM(NF,N,M,MROWS,MCOLS,NZ,NZA,NAU,NUP,MMAX,NEL,
     & IBEG,IBGR,IENDLU,PTL,LENL,CNR,PTR,LENR,ORDC,ORDR,ORDL,LI,LJ,CM,
     & AU,LAM,WR01,X,GF,C,H,JH,IH,BCOL,RNR,PRNR,A,INBCOL,TYPE,WN01,WR02,
     & S,LB,UB,ECG,FCG,RCG,PV,RIGHT,UP,ALF1,ALF2,DEL1,DEL2,DEL3,EPS6,
     & EPS7,EPS8,EPS9,RMIN,RMAX,DMAX,GMAX,UMAX,XMAX,GNORM,SNORM,XNORM,
     & R,FF,F,FO,P,PO,T,TO,TL,TU,E,EL,EU,MFP,MQP,MQP1,MLP1,NIQ,NAQ,MRED,
     & MIQ,MAQ,INEW,IOLD,KOLD,KINP,LINP,MINP,IER)
      $INCLUDE('UMCOMM')
      INTEGER NF,N,M,MROWS,MCOLS,NZ,NZA,NAU,NUP,MMAX,NEL,IBEG,IBGR,
     & IENDLU,PTL(MROWS),LENL(MROWS),CNR(NZ),PTR(MROWS),LENR(MROWS),
     & ORDC(MROWS),ORDR(MROWS),ORDL(MROWS),LI(NUP),LJ(NUP),JH(MMAX),
     & IH(MCOLS+1),BCOL(MCOLS),RNR(NZA),PRNR(MCOLS+1),INBCOL(MCOLS),
     & TYPE(MCOLS),WN01(MCOLS),RIGHT(MROWS),UP(MROWS),MFP,MQP,MQP1,
     & MLP1,NIQ,NAQ,MRED,MIQ,MAQ,INEW,IOLD,KOLD,KINP,LINP,MINP,IER
      $FLOAT CM(NUP),AU(NAU),LAM(MCOLS),WR01(MCOLS),X(MCOLS),GF(MCOLS),
     & C(MCOLS),H(MMAX),A(NZA),WR02(MCOLS),S(MCOLS),LB(MCOLS),UB(MCOLS),
     & ECG(MCOLS),FCG(MCOLS),RCG(MCOLS),PV(MCOLS),ALF1,ALF2,
     & DEL1,DEL2,DEL3,EPS6,EPS7,EPS8,EPS9,RMIN,RMAX,DMAX,GMAX,UMAX,XMAX,
     & GNORM,SNORM,XNORM,R,FF,F,FO,P,PO,T,TO,TL,TU,E,EL,EU
      INTEGER OPFL,IDEB,NSB,NBB,I,J,ITNO,IPFL,NCYCLE,NCGOLD,STCYCL,ITERX
      $FLOAT STFL,GRFL,GSFL
      $FLOAT UXVDOT
      PARAMETER(OPFL=30)
      CALL UOKLQ1('UKQGLM')
      ITERX=0
      IF(ITERL.LT.1) THEN
        ITERQ=-1
        GO TO 600
      ENDIF
      IF(MFP.EQ.1) THEN
        ITERQ=1
        GO TO 600
      ENDIF
      GRFL=1.0$P 1
      GSFL=1.0$P 16
      IPFL=1
      IDEB=1
      NCYCLE=0
      CALL UKSGLF(STFL,DEL1,DEL2,EPS7,EPS9,MLP1)
C
      CALL UKQGLI(NF,N,M,MROWS,MCOLS,NZ,NZA,NAU,NUP,MMAX,NEL,PTL,LENL,
     & CNR,PTR,LENR,ORDC,ORDR,ORDL,LI,LJ,CM,AU,LAM,WR01,X,C,GF,H,IH,JH,
     & BCOL,RNR,PRNR,A,INBCOL,TYPE,WN01,LB,UB,DEL3,GNORM,SNORM,XNORM,
     & FF,F,FO,TO,EL,EU,MQP1,NIQ,NAQ,NCGR,MRED,KINP,LINP,MINP,ITERQ)
C
C     JUMP LABEL CLOSING THE ITERATION CYCLE
C
50    CONTINUE
C
C     T IS PARAMETER USED FOR CONSTRUCTION OF CONVERGENCE
C     CRITERIUM  FOR TRUNCATED NEWTON-METHOD. IT IS MORE STRINGENT
C     THAN THE ONE USED BY DEMBO-STEIHAUG'S PRESENTATION.
C
      T=ONE/(TWO+$DBLE(NAQ))
C
C     SECOND TYPE OF CLOSING THE ITERATION CYCLE
C
60    CONTINUE
C
C     CHECK FUNCTION CHANGE
C
      IF(XNORM.EQ.0) THEN
        MQP1=MQP1+1
      ELSE
        MQP1=0
      END IF
C
C     CONVERGENCE WITH THE PRESENT ACTIVE SET IS TESTED.
C     IF IER=1 THEN CONVERGENCE
C
      CALL UKQGLC(DEL3,SNORM,GNORM,XNORM,F,FO,TO,E,EL,EU,MLP1,MINP,IER)
C
      IF(IER.GT.0) THEN
C
C     RELAXING DIRECTION IS LOOKED FOR
C
C
C     STANDARD DEGENERACY PARAMETER SET UP
C
      MQP=1
      CALL UKQGLR(N,M,MROWS,MCOLS,NZ,NZA,NAU,NUP,NEL,PTL,LENL,CNR,PTR,
     & LENR,ORDC,ORDR,ORDL,PRNR,RNR,LI,LJ,CM,A,AU,TYPE,BCOL,WN01,WR01,
     & WR02,LAM,S,C,LB,UB,X,INBCOL,NSB,NBB,ALF1,ALF2,EPS9,RMIN,RMAX,
     & DMAX,XMAX,GNORM,SNORM,XNORM,TO,EL,MQP,MLP1,INEW,IOLD,KINP,LINP,
     & ITERD,IER)
      IF(ITERX.EQ.1) THEN
        ITERQ=2
        GO TO 600
      ENDIF
C
C TEST OF ITERD , SET OF NSB,NBB
C
      IF(ITERD.EQ.1) THEN
C
C OPTIMUM SOLUTION IS FOUND
C
        IF(IER.GE.1.AND.IER.LE.3) THEN
          ITERQ=2
          GO TO 600
        ELSEIF(IER.EQ.4) THEN
          ITERQ=3
          GO TO 600
        ELSE
          ITERQ=4
          GO TO 600
        ENDIF
      ELSEIF(ITERD.EQ.2) THEN
C
C TO IS SET UP
C
        TO=ONE
        GO TO 50
      ELSEIF(ITERD.EQ.3) THEN
C
C DEGENERATE EXCHANGE
C
        DEL3=TWO
        NSB=0
        NBB=0
        ITERS=7
        GO TO 500
      ELSEIF(ITERD.EQ.4) THEN
C
C DEGENERATE PIVOT - NEXT STEP WILL BE SAFEGUARED
C
        IF(DEL3.EQ.TWO) THEN
          ITERQ=3
          GO TO 600
        ELSE
          DEL3=TWO
          GO TO 50
        ENDIF
      ELSE
        DEL3=TWO
      END IF
      NIQ=0
      NAQ=NAQ+1
      NCYCLE=NCYCLE+1
      STCYCL=2
                   ELSE
      NIQ=NIQ+1
      NCYCLE=NCYCLE+1
      STCYCL=1
      TO=ZERO
      DEL3=MAX(DEL3*0.1$P 0,0.5$P-6)
C
C     MINOR CYCLE - INNER ITERATION
C
      NCGOLD=NCGR
C
C S SUBSTITUTED FOR PCG
C
      CALL UKQGL1(N,M,MROWS,MCOLS,NZ,NZA,NAU,NUP,NEL,MMAX,PTL,LENL,CNR,
     & PTR,LENR,IH,JH,H,RNR,PRNR,ORDC,ORDR,ORDL,LI,LJ,CM,AU,A,WR01,BCOL,
     & INBCOL,LAM,S,ECG,FCG,RCG,PV,IPFL,EPS6,EPS8,GNORM,T,TL,LINP,NCGR,
     & ITERD)
C
C CG ITERATIONS COUNT FOR THE PREVIOUS CALL
C
      ITNO=NCGR-NCGOLD
C
C ITERD INFORMATION NOT USED
C
C
C     WIDTHEN THE DIRECTION,COMPUTE XNORM
C
      CALL UKQGLD(N,M,MROWS,MCOLS,NZ,NZA,NAU,NUP,NEL,PTL,LENL,CNR,PTR,
     & LENR,RNR,PRNR,ORDC,ORDR,ORDL,LI,LJ,CM,AU,A,WR01,WR02,BCOL,S,LINP)
      SNORM=ZERO
      DO 70 J=1,LINP
        I=BCOL(J)
        SNORM=SNORM+S(I)*S(I)
   70 CONTINUE
      SNORM=DSQRT(SNORM)
      XNORM=SNORM
C
C MAXIMUM STEPSIZE
C
      CALL UKQGLX(MCOLS,M,TYPE,X,LB,UB,S,BCOL,NSB,NBB,WN01,ALF1,ALF2,
     & EPS9,RMIN,RMAX,DMAX,XMAX,GNORM,XNORM,LINP)
C
C END OF MINOR ITERATION
C
      END IF
C
C     COMPARE RMAX AND RMIN
C
      IF(RMAX.LE.RMIN) THEN
        ITERS=0
        GO TO 120
      END IF
C
C     LINSEARCH
C
      DO 100 I=1,N
        WR01(I)=X(I)
100   CONTINUE
      FO=F
      PO=UXVDOT(N,C,S)
      CALL US1Q01(NF,N,M,MCOLS,MMAX,X,WR01,C,GF,H,IH,JH,S,R,FF,F,FO,
     & P,PO,RMIN,RMAX,TU,ITERS)
C
C     TEST ON ITERS
C
120   IF(ITERS.EQ.8) THEN
C
C UNBOUNDNESS DETECTED
C
        ITERQ=-2
        GO TO 600
      END IF
C
C     LOGICAL ONE INDICATES STATE WHEN UPDATE OF SOLUTION
C     IS NOT NEEDED.
C
      IF(ITERS.EQ.-1.OR.ITERS.EQ.-3) THEN
        CALL UXVDIR(N,TU,S,WR01,X)
        IF(ITERX.EQ.-1) THEN
          ITERX= 1
        ELSE
          ITERX=-1
        ENDIF
C
C     XNORM IS UPDATED
C
        XNORM=ZERO
        DO 460 I=M+1,LINP
          WR01(I)=WR01(I)-X(I)
460     CONTINUE
        XNORM=DSQRT(UXVDOT(LINP-M,WR01,WR01))
C
C COMPUTE FUNCTIONAL VALUE / GRADIENT
C
        CALL UYSET2
        CALL UF1FQ2(NF,IH(NF+1)-1,X,GF,C,H,IH,JH,FF,F)
      END IF
      IF (ITERS.LE.0)  THEN
         IF(STCYCL.EQ.1) THEN
            IF(T.EQ.1.0$P-8) MINP=1
            T=MAX(1.0$P-8,0.02$P 0*T)
            GO TO 550
                         ELSE
            IF(TO.EQ.ONE) MINP=1
            TO=ONE
            T=ONE/(TWO+$DBLE(NAQ))
            GO TO 550
         END IF
      END IF
C
C     XNORM IS UPDATED
C
      XNORM=ZERO
      DO 450 I=M+1,LINP
        WR01(I)=WR01(I)-X(I)
450   CONTINUE
      XNORM=DSQRT(UXVDOT(LINP-M,WR01,WR01))
C
C     NEW FEASIBLE SOLUTION
C
  500 IF(ITERS.NE.7) THEN
        CALL UKQGLY(N,M,MROWS,MCOLS,NZ,NZA,NAU,NUP,NEL,PTL,LENL,CNR,
     &  PTR,LENR,RNR,PRNR,ORDC,ORDR,ORDL,LI,LJ,CM,AU,A,WR01,BCOL,LAM,
     &  X,C,GNORM,SNORM,LINP)
      ELSE
C
C     COLUMN EXCHANGE
C
        CALL UKQGLU(N,M,MROWS,MCOLS,NZ,NZA,NAU,NUP,NEL,IBEG,IBGR,IENDLU,
     &   PTR,LENR,CNR,PRNR,RNR,ORDR,ORDC,BCOL,PTL,LENL,ORDL,WN01,WR01,
     &   WR02,LI,LJ,CM,RIGHT,A,AU,STFL,LB,UB,X,TYPE,NSB,NBB,INBCOL,IDEB,
     &   UP,EPS7,EPS9,DMAX,GMAX,UMAX,P,NREF,INEW,IOLD,KOLD,LINP,ITERQ)
C
C     CHECK RETURN CODE
C
        IF(ITERQ.LT.0) GO TO 600
        CALL UKQGLY(N,M,MROWS,MCOLS,NZ,NZA,NAU,NUP,NEL,PTL,LENL,CNR,
     &  PTR,LENR,RNR,PRNR,ORDC,ORDR,ORDL,LI,LJ,CM,AU,A,WR01,BCOL,LAM,
     &  X,C,GNORM,SNORM,LINP)
        DEL3=TWO
      END IF
      IF(STCYCL.EQ.2)EL=GNORM
      T=ONE/(TWO+$DBLE(NAQ))
550   CONTINUE
      CALL UOKLQ3(N,M,MROWS,MCOLS,NEL,LENR,TYPE,BCOL,X,C,F,GNORM,NIQ,
     & NAQ,LINP)
      IF (NIQ.GT.MIQ) THEN
      ITERQ=-3
      GO TO 600
      ENDIF
      IF (NAQ.GT.MAQ) THEN
      ITERQ=-4
      GO TO 600
      ENDIF
      GO TO 60
600   CONTINUE
C
C SET TQPX
C
      IF(ITERL.EQ.-3) THEN
        TLPX='SMLL NAU'
      ELSEIF(ITERL.EQ.-4) THEN
        TLPX='SMALL NZ'
      ELSEIF(ITERL.EQ.-5) THEN
        TLPX='BAD COND'
      ELSEIF(ITERL.EQ.-6) THEN
        TLPX='SMLL NUP'
      ENDIF
      IF(ITERQ.EQ.3) THEN
        TQPX='INEX.SOL'
      ELSEIF(ITERQ.EQ.2) THEN
        TQPX='OPT. QP '
      ELSEIF(ITERQ.EQ.1) THEN
        TQPX='FEAS SOL'
      ELSEIF(ITERQ.EQ.-1) THEN
        TQPX=TLPX
        CALL UOERR1('UKQGLM',11)
      ELSEIF(ITERQ.EQ.-2) THEN
        TQPX='UNBOUND '
        CALL UOERR1('UKQGLM',12)
      ELSEIF(ITERQ.EQ.-3) THEN
        TQPX='INEXACT '
        CALL UOERR1('UKQGLM',98)
      ELSEIF(ITERQ.EQ.-4) THEN
        TQPX='INEXACT '
        CALL UOERR1('UKQGLM',99)
      ENDIF
      GMAX=GNORM
      CALL UOKLQ2(N,M,MROWS,MCOLS,X,C,TYPE,BCOL,LENR,F,GNORM,NIQ,NAQ,
     & LINP)
      RETURN
      END
