* SUBROUTINE UKQGLY                 ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* NEW REDUCED COST AND NEW REDUCED GRADIENT ARE COMPUTED
*
* PARAMETERS :
*  II  N  NUMBER OF COLUMNS OF THE SPARSE MATRIX
*  II  M  NUMBER OF ROWS OF THE SPARSE MATRIX.
*  II  MCOLS DECLARED NUMBER OF VARIABLES.
*  II  MROWS DECLARED NUMBER OF ROWS.
*  II  NZ SIZE OF THE INDEX ARRAY CNR
*  II  NZA SIZE OF THE INDEX ARRAY RNR.
*  II  NAU SIZE OF THE ARRAY THAT STORES THE NUMERICAL ELEMENTS OF
*          THE PROCESSED MATRIX.
*  II  NUP  LENGTH OF THE ARRAYS LI,LJ,CM.
*  II  NEL  NUMBER OF TRIPLES IN ARRAYS (LI,LJ,CM).
*  II  PTL(MROWS) POINTER VECTOR OF THE COLUMNS OF THE L-FACTOR.
*  II  LENL(MROWS) LENGTHS OF THE COLUMNS OF THE FACTOR L.
*  II  CNR(NZ) CONTAINS THE INDICES OF THE FACTORS.
*  II  PTR(MROWS) POINTER VECTOR OF THE ROWS OF THE FACTOR U.
*  II  LENR(MROWS) LENGTHS OF THE ROWS OF THE FACTOR U.
*  II  RNR(NZA) COLUMNS OF THE ORIGINAL MATRIX A.
*  II  PRNR(MCOLS+1) INDEX VECTOR FOR THE ARRAY RNR.
*  II  ORDC(MROWS) COLUMN PERMUTATION.
*  II  ORDR(MROWS) ROW PERMUTATION.
*  II  ORDL(MROWS) ROW PERMUTATION OF THE ORIGINAL FACTOR L.
*  II  LI(NUP) ROW INDICES OF THE L-UPDATES.
*  II  LJ(NUP) COLUMN INDICES OF THE L-UPDATES.
*  RI  CM(NUP) UPDATE MULTIPLIERS.
*  RI  AU(NZ) NUMERICAL VALUES OF THE FACTORS.
*  RI  A(NZA) NUMERICAL VALUES OF THE ELEMENTS OF THE CONSTRAINT
*             MATRIX.
*  RA  WR01(MCOLS) AUXILIARY ARRAY.
*  II  BCOL(MCOLS) PERMUTATION ARRAY: FIRST M COMPONENTS FORM BASIS,
*              NEXT LINP-M FORM SUPERBASIS AND REST CORRESPOND TO
*              THE NON-BASIC VARIABLES.
*  RU  LAM(MCOLS) VECTOR LAM(1,LINP)=(TRANS(B)*LAM(M),
*                                     TRANS(Z)*LAM(LINP)).
*  RI  X(MCOLS) VECTOR OF VARIABLES.
*  RO  C(MCOLS) GRADIENT VECTOR.
*  RU  GNORM REDUCED GRADIENT NORM.
*  RU  SNORM  EUCLIDEAN NORM OF THE SUPERBASICS' VARIABLES.
*  II  LINP NUMBER OF BASICS AND SUPERBASICS.
*
      SUBROUTINE UKQGLY(N,M,MROWS,MCOLS,NZ,NZA,NAU,NUP,NEL,PTL,LENL,
     & CNR,PTR,LENR,RNR,PRNR,ORDC,ORDR,ORDL,LI,LJ,CM,AU,A,WR01,BCOL,
     & LAM,X,C,GNORM,SNORM,LINP)
      INTEGER N,M,MROWS,MCOLS,NZ,NZA,NAU,NUP,NEL,PTL(MROWS),
     & LENL(MROWS),CNR(NZ),PTR(MROWS),LENR(MROWS),RNR(NZA),
     & PRNR(MCOLS+1),ORDC(MROWS),ORDR(MROWS),ORDL(MROWS),LI(NUP),
     & LJ(NUP),BCOL(MCOLS),LINP
      $FLOAT CM(NUP),AU(NAU),A(NZA),WR01(MCOLS),LAM(MCOLS),X(MCOLS),
     & C(MCOLS),GNORM,SNORM
      $FLOAT UXVDOT
      INTEGER I,J
C
C     COMPUTE NEW REDUCED GRADIENT
C
      CALL UKQGLL(M,MCOLS,BCOL,LAM,C)
      CALL UKQGLV(N,M,MROWS,MCOLS,NZ,NZA,NAU,NUP,NEL,PTL,LENL,CNR,PTR,
     & LENR,RNR,PRNR,ORDC,ORDR,ORDL,LI,LJ,CM,AU,A,WR01,BCOL,LAM,C,LINP)
C
C     UPDATE SNORM,GNORM
C
      GNORM=DSQRT(UXVDOT(LINP-M,LAM(M+1),LAM(M+1)))
      SNORM=0.0$P 0
      DO 300 I=M+1,LINP
      J=BCOL(I)
      SNORM=SNORM+X(J)*X(J)
300   CONTINUE
      SNORM=DSQRT(SNORM)
      RETURN
      END
