* SUBROUTINE ULGLAG               ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* GRADIENT OF THE LAGRANGIAN FUNCTION IS DETERMINED.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  II  NA  NUMBER OF CURRENT LINEAR APPROXIMATED FUNCTIONS.
*  II  NB  NUMBER OF DECLARED CONSTRAINTS OR APPROXIMATED FUNCTIONS.
*  II  NC  NUMBER OF LINEARIZED CONSTRAINTS.
*  II  IAA(NF+1)  VECTOR CONTAINING INDICES OF ACTIVE FUNCTIONS.
*  RI  AG(NF*NA)  MATRIX WHOSE COLUMNS ARE GRADIENTS OF THE LINEAR
*         APPROXIMATED FUNCTIONS.
*  RO  AZ(NF+1)  VECTOR OF LAGRANGE MULTIPLIERS.
*  RI  CG(NF*NC)  MATRIX WHOSE COLUMNS ARE NORMALS OF THE LINEAR
*         CONSTRAINTS.
*  RU  G(NF)  GRADIENT OF THE LAGRANGIAN FUNCTION.
*
* SUBPROGRAMS USED :
*  S   UXVDIR  VECTOR AUGMENTED BY THE SCALED VECTOR.
*
      SUBROUTINE ULGLAG(NF,N,NA,NB,NC,IAA,AG,AZ,CG,G)
      INTEGER NF,N,NA,NB,NC,IAA(*)
      $FLOAT AG(NF*NA),AZ(*),CG(NF*NB),G(NF)
      INTEGER NAA,J,L
      NAA=NF-N
      DO 3 J=1,NAA
      L=IAA(J)
      IF (L.GT.NC) THEN
      L=L-NC
      IF (L.GT.NA) L=L-NA
      CALL UXVDIR(NF,-AZ(J),AG((L-1)*NF+1),G,G)
      ELSE IF (L.GT.0) THEN
      CALL UXVDIR(NF,-AZ(J),CG((L-1)*NF+1),G,G)
      ELSE
      L=-L
      G(L)=G(L)-AZ(J)
      ENDIF
    3 CONTINUE
      RETURN
      END
