* SUBROUTINE ULMAXT               ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETERMINATION OF THE MAXIMUM STEPSIZE USING TRUST REGION BOUNDS.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  IO  IXA(NF)  VECTOR CONTAINING INFORMATION ON TRUST REGION ACTIVITY.
*  II  XN(NF)  VECTOR OF SCALING PARAMETERS.
*  RI  XO(NF)  SAVED VECTOR OF VARIABLES.
*  RI  S(NF)  DIRECTION VECTOR.
*  RO  STEP  MAXIMUM STEPSIZE.
*  RU  XDEL  TRUST REGION BOUND.
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*  II  KREM  INDICATION OF LINEARLY DEPENDENT GRADIENTS.
*  IO  INEW  INDEX OF THE NEW ACTIVE CONSTRAINT.
*
      SUBROUTINE ULMAXT(NF,X,IX,IXA,XN,XO,S,STEP,XDEL,NORMF,KREM,INEW)
      INTEGER NF,IX(NF),IXA(NF),NORMF,KREM,INEW
      $FLOAT X(NF),XN(NF),XO(NF),S(NF),STEP,XDEL
      $FLOAT TEMP
      INTEGER I
      DO 1 I=1,NF
      IF (KREM.GT.0.AND.IX(I).GT.10) THEN
      IF (IXA(I).GE.0) THEN
      IX(I)=IXA(I)
      IXA(I)=-1
      ELSE
      IX(I)=IX(I)-10
      ENDIF
      ENDIF
      IF (IX(I).GE.0.AND.IX(I).LE.10) THEN
      TEMP=1.0$P 0
      IF (NORMF.GT.0) TEMP=XN(I)
      IF (S(I).LT.0.0$P 0) THEN
      TEMP=(XO(I)-XDEL*TEMP-X(I))/S(I)
      IF (TEMP.LE.STEP) THEN
      INEW=-(I+NF)
      STEP=TEMP
      ENDIF
      ELSE IF (S(I).GT.0.0$P 0) THEN
      TEMP=(XO(I)+XDEL*TEMP-X(I))/S(I)
      IF (TEMP.LE.STEP) THEN
      INEW=-(I+NF)
      STEP=TEMP
      ENDIF
      ENDIF
      ENDIF
    1 CONTINUE
      RETURN
      END
