* SUBROUTINE ULRMR0               ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* TRIANGULAR DECOMPOSITION OF KERNEL OF THE ORTHOGONAL PROJECTION IS
* UPDATED AFTER CONSTRAINT DELETION.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  IU  ICA(NF)  VECTOR CONTAINING INDICES OF ACTIVE CONSTRAINTS.
*  RU  CR(NF*(NF+1)/2)  TRIANGULAR DECOMPOSITION OF KERNEL OF THE
*         ORTHOGONAL PROJECTION.
*  RA  G(NF)  AUXILIARY VECTOR.
*  II  IOLD  INDEX OF THE OLD ACTIVE CONSTRAINT.
*  IO  KREM  AUXILIARY VARIABLE.
*  IO  IER  ERROR INDICATOR.
*
* SUBPROGRAMS USED :
*  S   UXVCOP  COPYING OF A VECTOR.
*  S   UXVORT  DETERMINATION OF AN ELEMENTARY ORTHOGONAL MATRIX FOR
*         PLANE ROTATION.
*  S   UXVROT  PLANE ROTATION OF A VECTOR.
*  S   UXVSET  INITIATION OF A VECTOR.
*
      SUBROUTINE ULRMR0(NF,N,ICA,CR,G,IOLD,KREM,IER)
      INTEGER NF,N,ICA(*),IOLD,KREM,IER
      $FLOAT CR(*),G(*)
      $FLOAT CK,CL
      INTEGER NCA,I,J,K,L,KC
      NCA=NF-N
      IF (IOLD.LT.NCA) THEN
      K=IOLD*(IOLD-1)/2
      KC=ICA(IOLD)
      CALL UXVCOP(IOLD,CR(K+1),G)
      CALL UXVSET(NCA-IOLD,0.0$P 0,G(IOLD+1))
      K=K+IOLD
      DO 2 I=IOLD+1,NCA
      K=K+I
      CALL UXVORT(CR(K-1),CR(K),CK,CL,IER)
      CALL UXVROT(G(I-1),G(I),CK,CL,IER)
      L=K
      DO 1 J=I,NCA-1
      L=L+J
      CALL UXVROT(CR(L-1),CR(L),CK,CL,IER)
    1 CONTINUE
    2 CONTINUE
      K=IOLD*(IOLD-1)/2
      DO 3 I=IOLD,NCA-1
      L=K+I
      ICA(I)=ICA(I+1)
      CALL UXVCOP(I,CR(L+1),CR(K+1))
      K=L
    3 CONTINUE
      ICA(NCA)=KC
      CALL UXVCOP(NCA,G,CR(K+1))
      KREM=1
      ENDIF
      RETURN
      END
