* SUBROUTINE UMSETC             ALL SYSTEMS                   93/12/01
C PORTABILITY : ALL SYSTEMS
C 93/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETERMINATION OF INITIAL VALUES OF THE CONSTRAINT FUNCTIONS.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NC  NUMBER OF CURRENT LINEAR CONSTRAINTS.
*  II  MC  NUMBER OF ELEMENTS IN THE FIELD CG.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RO  XO(NF)  SAVED VECTOR OF VARIABLES.
*  RI  CF(NC)  VECTOR CONTAINING VALUES OF THE CONSTRAINT FUNCTIONS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  CG(MC)  SPARSE CONSTRAINT JACOBIAN MATRIX.
*  II  ICG(NC+1)  POSITION OF THE FIRST RORWS ELEMENTS IN THE FIELD CG.
*  II  JCG(MC) COLUMN INDICES OF ELEMENTS IN THE FIELD CG.
*         CONSTRAINTS.
*  RA  S(NF)  AUXILIARY VECTOR.
*  II  ISNC  SAVING SPECIFICATION. ISNC=0-NO SAVING. ISNC=1-FUNCTION
*         VALUES ARE SAVED. ISNC=2-FUNCTION VALUES AND GRADIENTS ARE
*         SAVED.
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*
* SUBPROGRAMS USED :
*  S   UXVDIF  DIFFERENCE OF TWO VECTORS.
*  S   UXVMUL  DIAGONAL PREMULTIPLICATION OF A VECTOR.
*  RF  UXWDOT  DOT PRODUCT OF TWO SPARSE VECTORS.
*
      SUBROUTINE UMSETC(NF,NC,MC,X,XN,XO,CF,IC,CG,ICG,JCG,S,ISNC,NORMF)
      INTEGER NF,NC,MC,IC(NC),ICG(NC+1),JCG(MC),ISNC,NORMF
      $FLOAT X(NF),XN(NF),XO(NF),CF(NC),CG(MC),S(NF)
      $FLOAT UXWDOT
      INTEGER K,L,KC
      CALL UXVDIF(NF,X,XO,S)
      IF (NORMF.GT.0.AND.ISNC.GT.2) CALL UXVMUL(NF,XN,S,S,-1)
      DO 1 KC=1,NC
      K=ICG(KC)
      L=ICG(KC+1)-K
      IF (IC(KC).NE.0) CF(KC)=CF(KC)+UXWDOT(L,NF,JCG(K),CG(K),S,2)
    1 CONTINUE
      RETURN
      END


