* SUBROUTINE UNDRD5                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* INTERPOLATION IN MESH POINTS FOR THE SUBROUTINE UEVRK1.
*
* PARAMETERS :
*  II  NA  NUMBER OF MESH POINTS.
*  II  NAL  NUMBER OF MESH POINTS.
*  II  NE  DECLARED NUMBER OF EQUATIONS.
*  II  MEL  ACTUAL NUMBER OF EQUATIONS.
*  IU  KA  INDEX OF THE MESH POINT.
*  RI  AT(NA)  MESH POINTS.
*  RO  AY(NA*NE)  FIELD OF SOLUTION VECTORS IN THE MESH POINTS.
*  RI  YA(MEL)  SOLUTION VECTOR.
*  RA  ES(3*MEL)  AUXILIARY VECTOR.
*  RI  C1  USED CONSTANT.
*  RI  C2  USED CONSTANT.
*  RU  TA  VALUE OF THE INTEGRATION PARAMETER.
*  RU  TAO  OLD VALUE OF THE INTEGRATION PARAMETER.
*  RU  HE  ACTUAL STEPSIZE.
*  RU  HEO  OLD STEPSIZE.
*  IO  IER  ERROR INDICATOR.
*  II  JOB  TYPE OF OUTPUT.
*
* SUBPROGRAMS USED :
*  S   UXVCOP  COPYING OF A VECTOR.
*
      SUBROUTINE UNDRD5(NA,NAL,NE,MEL,KA,AT,AY,YA,ES,TA,TAO,HE,
     & HEO,C1,C2,IER,JOB)
      $INCLUDE('UMCOMM')
      INTEGER NA,NAL,NE,MEL,KA,IER,JOB
      $FLOAT AT(*),AY(*),YA(MEL),ES(*),C1,C2,TA,TAO,HE,HEO
      INTEGER NE1,NE2,I,K
      $FLOAT S
      SAVE NE1,NE2
      IF (JOB.LT.0) THEN
        KA=2
        IF (JOB.EQ.-2) THEN
          NE1=MEL
          NE2=2*MEL
        END IF
      ELSE IF (JOB.EQ.1) THEN
        K=(KA-1)*NE
        IF (KA.LE.NAL) THEN
          AT(KA)=TA
          CALL UXVCOP(NE,ES,AY(K+1))
        ELSE
          IER=-11
          TEDX='LACK SP.'
          RETURN
        END IF
        KA=KA+1
      ELSE IF (JOB.EQ.2) THEN
 10     CONTINUE
        K=(KA-1)*NE
        IF (KA.LE.NA) THEN
        IF (HE*(TA-AT(KA)).GE.ZERO) THEN
          S=(AT(KA)-TAO)/HEO
          DO 20 I=1,NE
          AY(K+I)=YA(I)+S*(ES(I)+(S-C2)*(ES(NE1+I)+
     &            (S-C1)*ES(NE2+I)))
 20       CONTINUE
          KA=KA+1
          GO TO 10
        END IF
        END IF
      END IF
      RETURN
      END
