* SUBROUTINE UNNEQ3                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SOLUTION OF A SINGLE NONLINEAR EQUATION.
*
* PARAMETERS :
*  RI  X1  LEFT ENDPOINT OF THE INTERVAL.
*  RI  X2  RIGHT ENDPOINT OF THE INTERVAL.
*  RO  X  COMPUTED SOLUTION POINT.
*  RO  F  COMPUTED VALUE OF THE NONLINEAR FUNCTION.
*  RF  FUN  EXTERNAL CODE FOR COMPUTING THE VALUE OF THE
*         NONLINEAR FUNCTION.
*  RI  EPS1  REQUIRED PRECISION FOR THE SOLUTION POINT.
*  RI  EPS  REQUIRED PRECISION FOR THE NONLINEAR FUNCTION.
*  IO  IC  NUMBER OF ITERATIONS.
*  IO  IE  ERROR SPECIFICATION.
*
* METHOD :
* BISECTION.
*
      SUBROUTINE UNNEQ3(X1,X2,X,Y,FUN,EPS1,EPS,IC,IE)
      INTEGER IC,IE
      REAL*8 X1,X2,X,Y,FUN,EPS1,EPS
      REAL*8 Y1,Y2,A2
      EXTERNAL FUN
      IC=0
      IE=0
      A2=X2
      IF (X2-X1.LE.EPS1*A2) THEN
      X=A2
      RETURN
      ENDIF
      Y1=FUN(X1)
      Y2=FUN(X2)
      IC=IC+2
      IF (ABS(Y1).LE.EPS) THEN
      X=X1
      RETURN
      ENDIF
      IF (ABS(Y2).LE.EPS) THEN
      X=X2
      RETURN
      ENDIF
      IF (Y1.GT.0.0D0.OR.Y2.LT.0.0D0) THEN
      IE=-2
      RETURN
      ENDIF
    2 X=(X1+X2)/2.0D0
      Y=FUN(X)
      IC=IC+1
      IF (ABS(Y).LE.EPS) RETURN
      IF (X2-X1.LE.EPS1*A2) RETURN
      IF (Y.LT.0.0D0) X1=X
      IF (Y.GT.0.0D0) X2=X
      GO TO 2
      END
