* SUBROUTINE UOD0D1               ALL SYSTEMS                 94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF ENTRY TO DIRECTION DETERMINATION.
*
* PARAMETERS :
*  RI  R  STEPSIZE PARAMETER.
*  RI  GNORM  NORM OF THE GRADIENT VECTOR.
*
* COMMON DATA :
*  II  IWR  NUMBER OF THE OUTPUT UNIT.
*  II  JOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INFORMATION
*         DURING THE OPTIMIZATION PROCESS. JOUT=0-NO PRINT.
*         JOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=5-ADDITIONAL PRINT OF DEBUGGING.
*  TI  NDXX  PRINTED TEXT.
*
      SUBROUTINE UOD0D1(R,GNORM)
      $INCLUDE('UMCOMM')
      $FLOAT R,GNORM
      IF (JOUT.EQ.0) RETURN
      IF (ABS(KOUT).LE.2) RETURN
      WRITE (IWR,1) NDXX
    1 FORMAT (' ','DIRECTION DETERMINATION USING',1X,A6)
      WRITE(IWR,2) R,GNORM
    2 FORMAT(' ','R=',$P 9.3,1X,'G=',$P 9.3)
      RETURN
      END
