* SUBROUTINE UOD0D3                ALL SYSTEMS               03/12/01
C PORTABILITY : ALL SYSTEMS
C 03/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF ITERATIONS IN DIRECTION DETERMINATION.
*
* PARAMETERS :
*  RI  ALF  STEPSIZE.
*  RI  SNORM  NORM OF THE DIRECTION VECTOR.
*  RI  XDEL  TRUST REGION RADIUS.
*
* COMMON DATA :
*  II  IWR  NUMBER OF THE OUTPUT UNIT.
*  II  JOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INFORMATION
*         DURING THE OPTIMIZATION PROCESS. JOUT=0-NO PRINT.
*         JOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=5-ADDITIONAL PRINT OF DEBUGGING.
*
      SUBROUTINE UOD0D3(ALF,SNORM,XDEL)
      $INCLUDE('UMCOMM')
      $FLOAT ALF,SNORM,XDEL
      IF (JOUT.EQ.0) RETURN
      IF (ABS(KOUT).LE.2) RETURN
      WRITE (IWR,1) 0,ALF,SNORM,XDEL,TDXX
    1 FORMAT (' ',I5,2X,'R =',$P 9.3,2X,'S =',$P 9.3,2X,'D =',$P 9.3,
     & 2X,A8)
      RETURN
      END
