* SUBROUTINE UOD1D3                ALL SYSTEMS                94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF ITERATIONS IN DIRECTION DETERMINATION.
*
* PARAMETERS :
*  RI  T  TRUST REGION (LEVENBERG) PARAMETER.
*  RI  TL  LOWER BOUND FOR TRUST REGION PARAMETER.
*  RI  TU  UPPER BOUND FOR TRUST REGION PARAMETER.
*  RI  E  LOWER BOUND FOR MINIMUM EIGENVALUE.
*  RI  SNORM  NORM OF THE DIRECTION VECTOR.
*  RI  XDEL  TRUST REGION RADIUS.
*  II  MODE  MODE OF LINE SEARCH.
*
* COMMON DATA :
*  II  NRED  NUMBER OF REDUCTIONS.
*  II  IWR  NUMBER OF THE OUTPUT UNIT.
*  II  JOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INFORMATION
*         DURING THE OPTIMIZATION PROCESS. JOUT=0-NO PRINT.
*         JOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=5-ADDITIONAL PRINT OF DEBUGGING.
*  TI  TDXX  PRINTED TEXT.
*
      SUBROUTINE UOD1D3(T,TL,TU,E,SNORM,XDEL,MODE)
      $INCLUDE ('UMCOMM')
      INTEGER MODE
      $FLOAT T,TL,TU,E,SNORM,XDEL
      IF (JOUT.EQ.0) RETURN
      IF (ABS(KOUT).LE.2) RETURN
      WRITE (IWR,1) MODE,NRED,T,TL,TU,E,SNORM,XDEL,TDXX
    1 FORMAT (' ',I1,2X,I3,2X,'T=',$P 9.3,1X,
     &  'L=',$P 9.3,1X,'U=',$P 9.3,1X,'E=',$P 9.3,1X,'S=',$P 9.3,
     &  1X,'D=',$P 9.3,1X,A8)
      RETURN
      END
