* SUBROUTINE UOD1D5                ALL SYSTEMS               94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF INFORMATION DURING DIRECTION DETERMINATION.
*
* PARAMETERS :
*  RI  ALF  SCALED RAILEIGH QUOTIENT.
*  RI  SIG  SCALING FACTOR.
*  II  INF  INFORMATION ABOUT THE GILL-MURRAY DECOMPOSITION.
*
* COMMON DATA :
*  II  IWR  NUMBER OF THE OUTPUT UNIT.
*  II  JOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INFORMATION
*         DURING THE OPTIMIZATION PROCESS. JOUT=0-NO PRINT.
*         JOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=5-ADDITIONAL PRINT OF DEBUGGING.
*
      SUBROUTINE UOD1D5(ALF,SIG,INF)
      $INCLUDE ('UMCOMM')
      INTEGER INF
      $FLOAT ALF,SIG
      IF (JOUT.EQ.0) RETURN
      IF (ABS(KOUT).LE.2) RETURN
      WRITE(IWR,1) INF,ALF,SIG
    1 FORMAT (' ',I4,2X,'ALF=',$P 9.3,1X,'SIG=',$P 9.3)
      RETURN
      END
