* SUBROUTINE UOD1D9                ALL SYSTEMS               94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF ITERATIONS IN DIRECTION DETERMINATION.
*
* PARAMETERS :
*  RI  RHO1  NORM OF THE FIRST OLD RESIDUUM.
*  RI  RHO2  NORM OF THE FIRST NEW RESIDUUM.
*  RI  SIG1  NORM OF THE SECOND OLD RESIDUUM.
*  RI  SIG2  NORM OF THE SECOND NEW RESIDUUM.
*  RI  PREC  REQUIRED PRECISION.
*
* COMMON DATA :
*  IU  NCGR  NUMBER OF CG ITERATIONS.
*  II  NRED  NUMBER OF THE CURRENT ITERATION
*  II  IWR  NUMBER OF THE OUTPUT UNIT.
*  II  JOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INFORMATION
*         DURING THE OPTIMIZATION PROCESS. JOUT=0-NO PRINT.
*         JOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=5-ADDITIONAL PRINT OF DEBUGGING.
*
      SUBROUTINE UOD1D9(RHO1,RHO2,SIG1,SIG2,PREC)
      $INCLUDE ('UMCOMM')
      $FLOAT RHO1,RHO2,SIG1,SIG2,PREC
      NCGR=NCGR+1
      IF(JOUT.EQ.0) RETURN
      IF (ABS(KOUT).LE.2) RETURN
      WRITE(IWR,1) NRED,SQRT(ABS(RHO1)),SQRT(ABS(RHO2)),
     & SQRT(ABS(SIG1)),SQRT(ABS(SIG2)),SQRT(ABS(PREC))
    1 FORMAT (' ',I5,2X,'G1=',$P 9.3,2X,'R1=',$P 9.3,2X,'G2=',$P 9.3,
     & 2X,'R2=',$P 9.3,2X,'P =',$P 9.3)
      RETURN
      END
