* SUBROUTINE UODLI5                ALL SYSTEMS                99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF ENTRY TO STEPSIZE SELECTION.
*
* PARAMETERS :
*  RI  R  VALUE OF THE STEPSIZE PARAMETER.
*  RI  RMAX  MAXIMUM STEPSIZE.
*  RI  RMAXP  PRIMAL MAXIMUM STEPSIZE.
*  RI  RMAXD  DUAL MAXIMUM STEPSIZE.
*
* COMMON DATA :
*  II  IWR  NUMBER OF THE OUTPUT UNIT.
*  II  JOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INFORMATION
*         DURING THE OPTIMIZATION PROCESS. JOUT=0-NO PRINT.
*         JOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=5-ADDITIONAL PRINT OF DEBUGGING.
*
      SUBROUTINE UODLI5(R,RMAX,RMAXP,RMAXD)
      $INCLUDE ('UMCOMM')
      $FLOAT R,RMAX,RMAXP,RMAXD
      IF(JOUT.EQ.0) RETURN
      IF (ABS(KOUT).LE.1) RETURN
      WRITE (IWR,2) R,RMAX,RMAXP,RMAXD
    2 FORMAT (' ',7X,'R=',$P 9.3,1X,'RMAX=',$P 9.3,1X,'RMAXP=',
     & $P 9.3,1X,'RMAXD=',$P 9.3)
      RETURN
      END
