* SUBROUTINE UODLQ3                ALL SYSTEMS                99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF ITERATIONS IN INTERIOR POINT METHOD.
*
* PARAMETERS:
*  II  NF  NUMBER OF VARIABLES.
*  II  NX  NUMBER OF BOX CONSTRAINTS.
*  II  NC  NUMBER OF GENERAL CONSTRAINTS.
*  II  NCA  NUMBER OF ACTIVE CONSTRAINTS.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  II  ICA(NF)  VECTOR CONTAINING INDICES OF ACTIVE CONSTRAINTS.
*  RI  B(NF+NCA) RIGHT DAND SIDE.
*  RO  GMAX  NORM OF THE PROJECTED GRADIENT.
*  RO  UMAX  NORM OF THE NEGATIVE MULTIPLIERS.
*  II  INF  CHANGE OF ACTIVE SET INDICATOR. INF=0 - ACTIVE SET WAS NOT
*         CHANGED. INF=1 - ACTIVE SET WAS CHANGED.
*
* COMMON DATA :
*  II  KBF  SPECIFICATION OF SIMPLE BOUNDS. KBF=0-NO SIMPLE BOUNDS.
*         KBF=1-ONE SIDED SIMPLE BOUNDS. KBF=2=TWO SIDED SIMPLE BOUNDS.
*  II  KBC  SPECIFICATION OF LINEAR CONSTRAINTS. KBC=0-NO LINEAR
*         CONSTRAINTS. KBC=1-ONE SIDED LINEAR CONSTRAINTS. KBC=2=TWO
*         SIDED LINEAR CONSTRAINTS.
*  II  IWR  NUMBER OF THE OUTPUT UNIT.
*  II  JOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INFORMATION
*         DURING THE OPTIMIZATION PROCESS. JOUT=0-NO PRINT.
*         JOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=5-ADDITIONAL PRINT OF DEBUGGING.
*  II  LOUT  LEVEL OF PRINT. LOUT=0-PRINT OF SCALAR VALUES.
*         LOUT=1-ADDITIONAL PRINT OF BASIC VECTORS.
*         LOUT=2-ADDITIONAL PRINT OF OTHER VECTORS.
*         LOUT=3-ADDITIONAL PRINT OF MATRICES.
*  II  MOUT  LEVEL OF PRINT ON THE TERMINAL DEVICE.
*         MOUT=0-NO PRINT.
*         MOUT=1-PRINT OF FINAL RESULTS.
*         MOUT=2-ADDITIONAL PRINT OF ITERATIONS.
*
      SUBROUTINE UODLQ3(NF,NX,NC,NCA,IX,IC,ICA,B,GMAX,UMAX,INF)
      $INCLUDE ('UMCOMM')
      INTEGER NF,NX,NC,NCA,IX(NX),IC(NC),ICA(NCA),INF
      $FLOAT B(NF+NCA),GMAX,UMAX
      INTEGER I
      LOGICAL LL
      LL=KOUT.EQ.0.AND.LOUT.GT.0
      IF(ABS(MOUT).GT.3) THEN
      WRITE (ITR,10) NX,NC,NCA,INF,GMAX,UMAX
      IF(LL) WRITE (IWR,4) NX,NC,NCA,INF,GMAX,UMAX
      ENDIF
   10 FORMAT (' ','NX =',I4,2X,'NC =',I4,2X,'NCA =',I4,2X,'INF =',I2,
     & 2X,'GMAX =',$P 9.3,2X,'UMAX =',$P 9.3)
      IF(JOUT.EQ.0) RETURN
      IF(ABS(KOUT).LE.3) RETURN
      WRITE (IWR,1) NX,NC,NCA,INF,GMAX,UMAX
    1 FORMAT ( ' ','NX =',I4,2X,'NC =',I4,2X,'NCA=',I4,2X,'INF=',I2,2X,
     & 'GMAX=',$P 9.3,1X,'UMAX=',$P 9.3)
      IF(ABS(LOUT).GE.2) WRITE(IWR,2) (ICA(I),I=1,MIN(NCA,50))
    2 FORMAT(' ','ICA =',10I7:/(6X,10I7))
      IF(ABS(LOUT).GE.2.AND.KBF.GT.0) WRITE(IWR,3) (IX(I),I=1,
     & MIN(NX,50))
    3 FORMAT(' ','IX  =',10I7:/(6X,10I7))
      IF(ABS(LOUT).GE.2.AND.KBC.GT.0) WRITE(IWR,4) (IC(I),I=1,
     & MIN(NC,50))
    4 FORMAT(' ','IC  =',10I7:/(6X,10I7))
      IF (ABS(LOUT).GE.3) WRITE (IWR,5) (B(I),I=1,MIN(NF,25))
    5 FORMAT(' ','BX  =',5$P 14.5:/(6X,5$P 14.5))
      IF (ABS(LOUT).GE.3) WRITE (IWR,6) (B(NF+I),I=1,
     & MIN(NCA,25))
    6 FORMAT(' ','BU  =',5$P 14.5:/(6X,5$P 14.5))
      WRITE(IWR,9)
    9 FORMAT(' ','ITERATIONS:')
      RETURN
      END
