* SUBROUTINE UODSD1                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF ENTRY TO UNCONSTRAINED MINIMIZATION.
*
* COMMON DATA :
*  II  IEXT  TYPE OF EXTREMUM. IEXT=0-MINIMIZATION. IEXT=1-MAXIMIZATION.
*  II  IOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INITIAL VALUES
*         AND FINAL RESULTS. IOUT=0-NO PRINT. IOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF MATRIX CORRECTION.
*         KOUT=5-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=6-ADDITIONAL PRINT OF DEBUGGING.
*
* OUTPUT VARIABLES :
*  NF,NA,NAL,MAL,NC,NCL,MCL,KDF,KSF,KCF,KBF,KDA,KSA,KCA,KBA,KDC,KSC,KCC,
*  KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,NEXT
*
      SUBROUTINE UODSD1(NF,NA,NAL,MAL,NC,NCL,MCL,KSF,KCF,KSA,KCA,KSC,
     & KCC)
      $INCLUDE ('UMCOMM')
      INTEGER NF,NA,NAL,MAL,NC,NCL,MCL,KSF,KCF,KSA,KCA,KSC,KCC
      WRITE ( ITR, 4)  NF,   NA,   NC,   NEXT,
     *                       NAL,  NCL,
     *                       MAL,  MCL,
     *                 KDF,  KDA,  KDC,
     *                 KSF,  KSA,  KSC,
     *                 KCF,  KCA,  KCC,
     *                 KBF,  KBA,  KBC,
     *                 ISNF, ISNA, ISNC,
     *                 NORMF,NORMA,NORMC
    4 FORMAT (/
     *        ' ','NF  =',I5,3X,'NA  =',I5,3X,'NC  =',I5,3X,'NEXT =',I3/
     *        ' ',13X,'NAL =',I5,3X,'NCL =',I5,3X/
     *        ' ',13X,'MAL =',I5,3X,'MCL =',I5,3X/
     *        ' ','KDF =',I5,3X,'KDA =',I5,3X,'KDC =',I5/
     *        ' ','KSF =',I5,3X,'KSA =',I5,3X,'KSC =',I5/
     *        ' ','KBF =',I5,3X,'KBA =',I5,3X,'KBC =',I5/
     *        ' ','KCF =',I5,3X,'KCA =',I5,3X,'KCC =',I5/
     *        ' ','ISNF=',I5,3X,'ISNA=',I5,3X,'ISNC=',I5/
     *        ' ','NORMF =',I3,3X,'NORMA =',I3,3X,'NORMC =',I3)
      RETURN
      END
