* SUBROUTINE UOF0G3                ALL SYSTEMS                89/12/01
C PORTABILITY : ALL SYSTEMS
C 89/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF INFORMATION DURING NUMERICAL DIFFERENTIATION.
*
* PARAMETERS :
*  RI  HD  APPROXIMATION OF THE SECOND ORDER DERIVATIVE.
*  RI  XSTEP  STEPSIZE FOR NUMERICAL DIFFERENTIATION.
*  II  MODE  MODE OF NUMERICAL DIFFERENTIATION.
*  II  IVAR  INDEX OF THE SELECTED VARIABLE.
*
* COMMON DATA :
*  II  IWR  NUMBER OF THE OUTPUT UNIT.
*  II  JOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INFORMATION
*         DURING THE OPTIMIZATION PROCESS. JOUT=0-NO PRINT.
*         JOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=5-ADDITIONAL PRINT OF DEBUGGING.
*

      SUBROUTINE UOF0G3(HD,XSTEP,MODE,IVAR)
      $INCLUDE('UMCOMM')
      INTEGER IVAR,MODE
      $FLOAT HD,XSTEP
      IF(JOUT.EQ.0) RETURN
      IF(ABS(KOUT).LE.4) RETURN
      WRITE(IWR,1) MODE,IVAR,HD,XSTEP
    1 FORMAT(' ',I1,2X,I3,2X,'DIAG=',$P 9.3,1X,'STEP=',$P 9.3)
      RETURN
      END
