* SUBROUTINE UOLLP3                ALL SYSTEMS                99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF ITERATIONS IN LINEARLY CONSTRAINED MINIMIZATION.
*
* PARAMETERS:
*  II  NF  NUMBER OF VARIABLES.
*  II  NC  NUMBER OF LINEAR CONSTRAINTS.
*  RI  X(NF)  VECTOR OF PRIMAL VARIABLES.
*  RI  Y(NC)  VECTOR OF DUAL VARIABLES.
*  RI  S(NF)  VECTOR OF SLACK VARIABLES.
*  RI  G(NF)  GRADIENT OF THE LAGRANGIAN FUNCTION.
*  RI  CF(NC)  VALUES OF THE CONSTRAINT FUNCTIONS.
*  RO  CMAX  MAXIMUM CONSTRAINT VIOLATION.
*  RO  GMAX  NORM OF THE TRANSFORMED GRADIENT.
*  RI  UMAX  MAXIMUN ABSOLUTE VALUE OF THE NEGATIVE LAGRANGE MULTIPLIER.
*  IO  INEW  INDEX OF THE NEW ACTIVE CONSTRAINT.
*
* COMMON DATA :
*  II  IWR  NUMBER OF THE OUTPUT UNIT.
*  II  JOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INFORMATION
*         DURING THE OPTIMIZATION PROCESS. JOUT=0-NO PRINT.
*         JOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=5-ADDITIONAL PRINT OF DEBUGGING.
*  II  LOUT  LEVEL OF PRINT. LOUT=0-PRINT OF SCALAR VALUES.
*         LOUT=1-ADDITIONAL PRINT OF BASIC VECTORS.
*         LOUT=2-ADDITIONAL PRINT OF OTHER VECTORS.
*         LOUT=3-ADDITIONAL PRINT OF MATRICES.
*  II  MOUT  LEVEL OF PRINT ON THE TERMINAL DEVICE.
*         MOUT=0 - NO PRINT.
*         MOUT=1 - PRINT OF FINAL RESULTS.
*         MOUT=2 - ADDITIONAL PRINT OF ITERATIONS.
*
      SUBROUTINE UOLLP3(NF,NC,X,Y,S,G,CF,CMAX,GMAX,UMAX,INEW)
      $INCLUDE ('UMCOMM')
      INTEGER NF,NC,INEW
      $FLOAT X(NF),Y(NC),S(NF),G(NF),CF(NC),CMAX,GMAX,UMAX
      INTEGER I,NFMAX,NCMAX
      LOGICAL LL
      LL=KOUT.EQ.0.AND.LOUT.GT.0
      IF(ABS(MOUT).GT.3) THEN
      WRITE (ITR,3) INEW,GMAX,CMAX,UMAX
      IF(LL) WRITE (IWR,3) INEW,GMAX,CMAX,UMAX
      ENDIF
    3 FORMAT (' ','INEW =',I4,2X,'G=',$P 9.3,2X,'P=',$P 9.3,2X,
     & 'D=',$P 9.3)
      IF(JOUT.EQ.0) RETURN
      IF(ABS(KOUT).LE.3) RETURN
      NFMAX=MIN(NF,25)
      NCMAX=MIN(NC,25)
      WRITE (IWR,3) INEW,GMAX,CMAX,UMAX
      IF(ABS(LOUT).GE.1) WRITE(IWR,2) (X(I),I=1,MIN(NF,25))
    2 FORMAT(' ','X   =',5$P 14.5:/(6X, 5$P 14.5))
      IF(ABS(LOUT).GE.2.AND.KBC.GT.0) WRITE(IWR,4) (Y(I),I=1,
     & MIN(NC,25))
    4 FORMAT(' ','Y   =',5$P 14.5:/(6X, 5$P 14.5))
      IF(ABS(LOUT).GE.3) WRITE(IWR,5) (S(I),I=1,MIN(NF,25))
    5 FORMAT(' ','S   =',5$P 14.5:/(6X, 5$P 14.5))
      IF(ABS(LOUT).GE.3) WRITE(IWR,6) (G(I),I=1,MIN(NF,25))
    6 FORMAT(' ','G   =',5$P 14.5:/(6X, 5$P 14.5))
      IF(ABS(LOUT).GE.3.AND.KBC.GT.0) WRITE(IWR,7) (CF(I),I=1,
     & MIN(NC,25))
    7 FORMAT(' ','CF  =',5$P 14.5:/(6X, 5$P 14.5))
      RETURN
      END
