* SUBROUTINE UOMORT                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  MATLAB GRAPHICAL VISUALIZATION OF ORBIT.
*
* PARAMETERS :
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  NE  NUMBER OF DIFFERENTIAL EQUATIONS.
*  RI  AY(*)  VECTOR CONTAINING COMPUTED SOLUTIONS OF DIFFERENTIAL EQUATIONS.
*  II  IG  INDEX OF THE 1-ST VISUALIZED DIFFERENTIAL EQUATION.
*  II  JG  INDEX OF THE 2-ND VISUALIZED DIFFERENTIAL EQUATION.
*  II  KG  INDEX OF THE 3-RD VISUALIZED DIFFERENTIAL EQUATION.
*  LU  VYPISF(3)  THE SAME DRAWN FUNCTION VALUES CAN BE PUT INTO P.m ONLY ONCE
*  CI  INFO  WHICH INDEXES [IG JG KG] OF GRAPH TO PRINT = [110] OR [101] OR [011]
*  RO  MINIMX  MINIMAL VALUE AMONG THE PLOTTING VALUES IN X-AXIS.
*  RO  MAXIMX  MAXIMAL VALUE AMONG THE PLOTTING VALUES IN X-AXIS.
*  RO  MINIMY  MINIMAL VALUE AMONG THE PLOTTING VALUES IN Y-AXIS.
*  RO  MAXIMY  MAXIMAL VALUE AMONG THE PLOTTING VALUES IN Y-AXIS.
*
      SUBROUTINE UOMORT
     & (NA,NE,AY,IG,JG,KG,VYPISF,INFO,MINIMX,MAXIMX,MINIMY,MAXIMY)
      $OPTION(CHEOL='^')
      INTEGER NA,NE,IG,JG,KG,I,J,K,S
      $FLOAT AY(*),MINIMX,MAXIMX,MINIMY,MAXIMY
      CHARACTER*3 INFO
      CHARACTER*25 RET1
      CHARACTER*250 RET
      LOGICAL VYPISF(3)
C
      MAXIMX=-1D60
      MINIMX= 1D60
      MAXIMY=-1D60
      MINIMY= 1D60
C
      IF (INFO(1:1).EQ.'1') THEN
        DO K=1,NA
          I=(K-1)*NE+IG
          MAXIMX=MAX(MAXIMX,AY(I))
          MINIMX=MIN(MINIMX,AY(I))
        ENDDO
        IF (.NOT.VYPISF(1)) THEN
          WRITE(14,'(A)') 'y1=[ ...'
          S=10
          DO J=0,NA/10
            IF (J.EQ.NA/10) S=MOD(NA,10)
            RET=''
            DO K=10*J+1,10*J+S
              I=(K-1)*NE+IG
              WRITE(RET1,'(D25.16)') AY(I)
              RET(1:LEN_TRIM(RET)+25)=RET(1:LEN_TRIM(RET))//RET1(1:25)
            ENDDO
            IF (S.GT.0) WRITE(14,'(2A)') TRIM(RET), ' ...'
          ENDDO
          WRITE(14,'(A)') '];'
          VYPISF(1)=.TRUE.
        ENDIF
      ENDIF
C
      IF (INFO(2:2).EQ.'1') THEN
        DO K=1,NA
          I=(K-1)*NE+JG
          IF (INFO(1:1).EQ.'0') THEN
            MAXIMX=MAX(MAXIMX,AY(I))
            MINIMX=MIN(MINIMX,AY(I))
          ELSE
            MAXIMY=MAX(MAXIMY,AY(I))
            MINIMY=MIN(MINIMY,AY(I))
          ENDIF
        ENDDO
        IF (.NOT.VYPISF(2)) THEN
          WRITE(14,'(A)') 'y2=[ ...'
          S=10
          DO J=0,NA/10
            IF (J.EQ.NA/10) S=MOD(NA,10)
            RET=''
            DO K=10*J+1,10*J+S
              I=(K-1)*NE+JG
              WRITE(RET1,'(D25.16)') AY(I)
              RET(1:LEN_TRIM(RET)+25)=RET(1:LEN_TRIM(RET))//RET1(1:25)
            ENDDO
            IF (S.GT.0) WRITE(14,'(2A)') TRIM(RET), ' ...'
          ENDDO
          WRITE(14,'(A)') '];'
          VYPISF(2)=.TRUE.
        ENDIF
      ENDIF
C
      IF (INFO(3:3).EQ.'1') THEN
        DO K=1,NA
          I=(K-1)*NE+KG
          MAXIMY=MAX(MAXIMY,AY(I))
          MINIMY=MIN(MINIMY,AY(I))
        ENDDO
        IF (.NOT.VYPISF(3)) THEN
          WRITE(14,'(A)') 'y3=[ ...'
          S=10
          DO J=0,NA/10
            IF (J.EQ.NA/10) S=MOD(NA,10)
            RET=''
            DO K=10*J+1,10*J+S
              I=(K-1)*NE+KG
              WRITE(RET1,'(D25.16)') AY(I)
              RET(1:LEN_TRIM(RET)+25)=RET(1:LEN_TRIM(RET))//RET1(1:25)
            ENDDO
            IF (S.GT.0) WRITE(14,'(2A)') TRIM(RET), ' ...'
          ENDDO
          WRITE(14,'(A)') '];'
          VYPISF(3)=.TRUE.
        ENDIF
      ENDIF
      RETURN
      $OPTION(CHEOL=';')
      END
