* SUBROUTINE UOMPIE                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  MATLAB GRAPHICAL VISUALIZATION OF THE FINAL RESULTS.
*
* PARAMETERS :
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  NE  NUMBER OF DIFFERENTIAL EQUATIONS.
*  RI  AY(*)  VECTOR CONTAINING COMPUTED SOLUTIONS OF DIFFERENTIAL EQUATIONS.
*  II  IG  INDEX OF THE 1-ST VISUALIZED DIFFERENTIAL EQUATION.
*  II  JG  INDEX OF THE 2-ND VISUALIZED DIFFERENTIAL EQUATION.
*  II  KG  INDEX OF THE 3-RD VISUALIZED DIFFERENTIAL EQUATION.
*  LI  VYPISF(3)  THE SAME DRAWN FUNCTION VALUES CAN BE PUT INTO P.m ONLY ONCE
*  II  CISLO  SERIAL NUMBER OF THE MATLAB SOURCE CODE
*  RO  MINIMX  MINIMAL VALUE AMONG THE PLOTTING VALUES IN X-AXIS.
*  RO  MAXIMX  MAXIMAL VALUE AMONG THE PLOTTING VALUES IN X-AXIS.
*  RO  MINIMY  MINIMAL VALUE AMONG THE PLOTTING VALUES IN Y-AXIS.
*  RO  MAXIMY  MAXIMAL VALUE AMONG THE PLOTTING VALUES IN Y-AXIS.
*  RO  MINIMZ  MINIMAL VALUE AMONG THE PLOTTING VALUES IN Z-AXIS.
*  RO  MAXIMZ  MAXIMAL VALUE AMONG THE PLOTTING VALUES IN Z-AXIS.
*
      SUBROUTINE UOMPIE(NA,NE,AY,IG,JG,KG,VYPISF,
     &                  MINIMX,MAXIMX,MINIMY,MAXIMY,MINIMZ,MAXIMZ)
      $OPTION(CHEOL='^')
      INTEGER NA,NE,IG,JG,KG,I,J,K,S
      $FLOAT AY(*),MINIMX,MAXIMX,MINIMY,MAXIMY,MINIMZ,MAXIMZ
      CHARACTER*25 RET1
      CHARACTER*250 RET
      LOGICAL VYPISF(3)
C
      MAXIMX=-1D60
      MINIMX= 1D60
      MAXIMY=-1D60
      MINIMY= 1D60
      MAXIMZ=-1D60
      MINIMZ= 1D60
C
      DO K=1,NA
        J=(K-1)*NE+IG
        MAXIMX=MAX(MAXIMX,AY(J))
        MINIMX=MIN(MINIMX,AY(J))
        J=(K-1)*NE+JG
        MAXIMY=MAX(MAXIMY,AY(J))
        MINIMY=MIN(MINIMY,AY(J))
        J=(K-1)*NE+KG
        MAXIMZ=MAX(MAXIMZ,AY(J))
        MINIMZ=MIN(MINIMZ,AY(J))
      ENDDO
C
      IF (.NOT.VYPISF(1)) THEN
        WRITE(14,'(A)') 'y1=[ ...'
        S=10
        DO J=0,NA/10
          IF (J.EQ.NA/10) S=MOD(NA,10)
          RET=''
          DO K=10*J+1,10*J+S
            I=(K-1)*NE+IG
            WRITE(RET1,'(D25.16)') AY(I)
            RET(1:LEN_TRIM(RET)+25)=RET(1:LEN_TRIM(RET))//RET1(1:25)
          ENDDO
          IF (S.GT.0) WRITE(14,'(2A)') TRIM(RET), ' ...'
        ENDDO
        WRITE(14,'(A)') '];'
      ENDIF
C
      IF (.NOT.VYPISF(2)) THEN
        WRITE(14,'(A)') 'y2=[ ...'
        S=10
        DO J=0,NA/10
          IF (J.EQ.NA/10) S=MOD(NA,10)
          RET=''
          DO K=10*J+1,10*J+S
            I=(K-1)*NE+JG
            WRITE(RET1,'(D25.16)') AY(I)
            RET(1:LEN_TRIM(RET)+25)=RET(1:LEN_TRIM(RET))//RET1(1:25)
          ENDDO
          IF (S.GT.0) WRITE(14,'(2A)') TRIM(RET), ' ...'
        ENDDO
        WRITE(14,'(A)') '];'
      ENDIF
C
      IF (.NOT.VYPISF(3)) THEN
        WRITE(14,'(A)') 'y3=[ ...'
        S=10
        DO J=0,NA/10
          IF (J.EQ.NA/10) S=MOD(NA,10)
          RET=''
          DO K=10*J+1,10*J+S
            I=(K-1)*NE+KG
            WRITE(RET1,'(D25.16)') AY(I)
            RET(1:LEN_TRIM(RET)+25)=RET(1:LEN_TRIM(RET))//RET1(1:25)
          ENDDO
          IF (S.GT.0) WRITE(14,'(2A)') TRIM(RET), ' ...'
        ENDDO
        WRITE(14,'(A)') '];'
      ENDIF
      RETURN
      $OPTION(CHEOL=';')
      END
