* SUBROUTINE UOMPTH                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  MATLAB GRAPHICAL VISUALIZATION OF THE PATH OF ITERATIONS.
*
* PARAMETERS :
*  II  NPAC  NUMBER OF VALUES FOR PLOTTING.
*  RI  YPA(3*NPAC)  VECTOR CONTAINING VALUES FOR PLOTTING.
*  II  I1  INDEX OF THE 1-ST PLOTTING VARIABLE.
*  II  I2  INDEX OF THE 2-ND PLOTTING VARIABLE.
*  II  I3  INDEX OF THE 3-RD PLOTTING VARIABLE.
*  II  INFO  HOW MANY AND WHAT TYPE OF GRAPHS TO PLOT [MT]
*  II  CISLO  SERIAL NUMBER OF THE MATLAB SOURCE CODE
*  II  GFMT  GRAPHIC FORMAT
*
      SUBROUTINE UOMPTH(NPAC,YPA,I1,I2,I3,INFO,CISLO,GFMT)
      $OPTION(CHEOL='^')
      INTEGER NPAC,I1,I2,I3,INFO,CISLO,GFMT
      $FLOAT YPA(3*NPAC),MINIM,MAXIM,TEMP,EPS
      CHARACTER*25 T1,T2,T3
C
      CALL UOMOPN(15,GFMT)
      CALL UOMPAT(NPAC,YPA,INFO,MINIM,MAXIM)
C
      EPS=1.0D-15
      IF (INFO/10.EQ.0) THEN
C       FUNCTION F
        WRITE(15,'(A)')'h=plot(x,f);'
        IF (MOD(INFO,10).EQ.1) THEN
          WRITE(15,'(A)')'set(h,{''LineStyle''},{''none''});'
          WRITE(15,'(A)')'set(h,{''Marker''},{''o''});'
          WRITE(15,'(A)')'set(h,{''MarkerSize''},{3});'
          WRITE(15,'(A)')'set(h,{''MarkerEdgeColor''},{''b''});'
          WRITE(15,'(A)')'set(h,{''MarkerFaceColor''},{''b''});'
        ELSEIF (MOD(INFO,10).EQ.2) THEN
          WRITE(15,'(A)')'set(h,{''LineStyle''},{''-''});'
          WRITE(15,'(A)')'set(h,{''LineWidth''},{2});'
          WRITE(15,'(A)')'set(h,{''Color''},{''b''});'
        ENDIF
        WRITE(15,'(A)')'tit=title(''Iterations of F'');'
      ELSEIF (INFO/10.EQ.1) THEN
C       X(I1)
        WRITE(15,'(A)')'h=plot(x,x1);'
        IF (MOD(INFO,10).EQ.1) THEN
          WRITE(15,'(A)')'set(h,{''LineStyle''},{''none''});'
          WRITE(15,'(A)')'set(h,{''Marker''},{''o''});'
          WRITE(15,'(A)')'set(h,{''MarkerSize''},{3});'
          WRITE(15,'(A)')'set(h,{''MarkerEdgeColor''},{''b''});'
          WRITE(15,'(A)')'set(h,{''MarkerFaceColor''},{''b''});'
        ELSEIF (MOD(INFO,10).EQ.2) THEN
          WRITE(15,'(A)')'set(h,{''LineStyle''},{''-''});'
          WRITE(15,'(A)')'set(h,{''LineWidth''},{2});'
          WRITE(15,'(A)')'set(h,{''Color''},{''b''});'
        ENDIF
        WRITE(T1,'(I10)')I1
        T1=ADJUSTL(T1)
        WRITE(15,'(3A)')'tit=title(''Iterations of {\color{blue}X(',
     &   TRIM(T1),')}'');'
      ELSEIF (INFO/10.EQ.2) THEN
C       X(I1), X(I2)
        WRITE(15,'(A)')'h=plot(x,x1,x,x2);'
        IF (MOD(INFO,10).EQ.1) THEN
          WRITE(15,'(A)')'set(h,{''LineStyle''},{''none''});'
          WRITE(15,'(A)')'set(h,{''Marker''},{''o'';''o''});'
          WRITE(15,'(A)')'set(h,{''MarkerSize''},{3;3});'
          WRITE(15,'(A)')'set(h,{''MarkerEdgeColor''},{''b'';''r''});'
          WRITE(15,'(A)')'set(h,{''MarkerFaceColor''},{''b'';''r''});'
        ELSEIF (MOD(INFO,10).EQ.2) THEN
          WRITE(15,'(A)')'set(h,{''LineStyle''},{''-'';''--''});'
          WRITE(15,'(A)')'set(h,{''LineWidth''},{2;2});'
          WRITE(15,'(A)')'set(h,{''Color''},{''b'';''r''});'
        ENDIF
        WRITE(T1,'(I10)')I1
        T1=ADJUSTL(T1)
        WRITE(T2,'(I10)')I2
        T2=ADJUSTL(T2)
        WRITE(15,'(5A)')'tit=title(''Iterations of {\color{blue}X(',
     &   TRIM(T1),')}, {\color{red}X(',TRIM(T2),
     &   ')}'');'
      ELSEIF (INFO/10.EQ.3) THEN
C       X(I1), X(I2), X(I3)
        WRITE(15,'(A)')'h=plot(x,x1,x,x2,x,x3);'
        IF (MOD(INFO,10).EQ.1) THEN
          WRITE(15,'(A)')'set(h,{''LineStyle''},{''none''});'
          WRITE(15,'(A)')'set(h,{''Marker''},{''o'';''o'';''o''});'
          WRITE(15,'(A)')'set(h,{''MarkerSize''},{3;3;3});'
          WRITE(15,'(A)')
     &     'set(h,{''MarkerEdgeColor''},{''b'';''r'';[0 0.5 0]});'
          WRITE(15,'(A)')
     &     'set(h,{''MarkerFaceColor''},{''b'';''r'';[0 0.5 0]});'
        ELSEIF (MOD(INFO,10).EQ.2) THEN
          WRITE(15,'(A)')'set(h,{''LineStyle''},{''-'';''--'';''-.''});'
          WRITE(15,'(A)')'set(h,{''LineWidth''},{2;2;2});'
          WRITE(15,'(A)')'set(h,{''Color''},{''b'';''r'';[0 0.5 0]});'
        ENDIF
        WRITE(T1,'(I10)')I1
        T1=ADJUSTL(T1)
        WRITE(T2,'(I10)')I2
        T2=ADJUSTL(T2)
        WRITE(T3,'(I10)')I3
        T3=ADJUSTL(T3)
        WRITE(15,'(7A)')'tit=title(''Iterations of {\color{blue}X(',
     &   TRIM(T1),')}, {\color{red}X(',TRIM(T2),
     &   ')}, {\color[rgb]{0 0.5 0}X(',TRIM(T3),')}'');'
      ENDIF
C
      WRITE(15,'(A)')'xl=xlabel(''Iteration'');'
      WRITE(15,'(A)')'yl=ylabel(''Values'');'
      WRITE(15,'(A)')'set(gca,''FontSize'',20);'
      WRITE(15,'(A)')'set(tit,''FontSize'',25);'
      WRITE(15,'(A)')'set(xl,''FontSize'',20);'
      WRITE(15,'(A)')'set(yl,''FontSize'',20);'
      WRITE(T1,'(I10)')NPAC
      T1=ADJUSTL(T1)
      TEMP=(MAXIM-MINIM)*1.0D-1
      IF ((MAXIM-MINIM).LE.MAX(ABS(MAXIM+MINIM),1.0D0)*EPS) TEMP=EPS
      WRITE(T2,'(D25.16)') MINIM-TEMP
      T2=ADJUSTL(T2)
      WRITE(T3,'(D25.16)') MAXIM+TEMP
      T3=ADJUSTL(T3)
      WRITE(15,'(7A)')'axis([1 ',TRIM(T1),' ',
     & TRIM(T2),' ',TRIM(T3),']);'
      WRITE(15,'(A)')'grid on;'
      CALL UOMGRX(15,'PMPTH',CISLO,GFMT)
      RETURN
      $OPTION(CHEOL=';')
      END
