$INTERFACE UOMRF1                                             10/12/01

  $ADD(INTEGER,'\NFV1\NAV1')
  $ADD(REAL,'\$X($NF)')
  $ADD(REAL4,'\$FL($NGR,$NGR)')
$REM  $ADD(INTEGER,'\NF')
$REM  $ADD(REAL,'\F\FO')
      $IF(NA>0)
        CALL UXVCOP(NA,$AF,$AFO)
        $ADD(REAL,'\$AFO($NA)')
      $ENDIF
$REM      IF (NF.LE.1) THEN
$REM      WRITE(12,'(2I5)') 0,0
$REM      GO TO $LGR
$REM      ELSE
$REM      WRITE(12,'(2I5)') 1,NGR
$REM      ENDIF
  $50 CONTINUE
      CALL UOMRF1(NF,$X,$FL,F,FO,$ETA9,$OBR)
      GOTO ($60,$70) ISB+1
  $60 CONTINUE
      $IF(NA>0)
        CALL UXVCOP(NA,$AFO,$AF)
      $ENDIF
      GOTO $LGR
  $70 CONTINUE
      NFV1=NFV
      NAV1=NAV
      $SUBST('UZMODL')
      NFV=NFV1
      NAV=NAV1
      GOTO $50
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UOMRF1                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  MATLAB GRAPHICAL OUTPUT - ISOLINES, MAP, HILLS.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RO  FL(NGR,NGR)  FIELD OF DRAWN FUNCTION VALUES.
*  RO  F  VALUE OF THE OBJECTIVE FUNCTION.
*  RO  FO  OLD VALUE OF THE OBJECTIVE FUNCTION.
*  RI  ETA9  MAXIMUM MACHINE CONSTANT.
*  RI  GFMT  GRAPHIC FORMAT: 0=INTERNAL GRAPHICS,
*                            1=EXTERNAL GRAPHICS (*.EPS FILES),
*                            2=EXTERNAL GRAPHICS (*.PNG FILES).
*
* COMMON DATA :
*  II  NGR  TOTAL NUMBER OF DRAWN NODES.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
      SUBROUTINE UOMRF1(NF,X,FL,F,FO,ETA9,GFMT)
      $INCLUDE ('UMCOMM')
      $INCLUDE ('UMCOMG')
      INTEGER NF,GFMT
      REAL*4 FL(NGR,NGR)
      $FLOAT X(NF),F,FO,ETA9
      $FLOAT STIGR,STJGR,DFIGR,DFJGR
      $FLOAT CON1,CON2
      LOGICAL VYPISF
      PARAMETER(CON1=1.0$P-60,CON2=1.0$P 60)
      INTEGER IVAR,JVAR,INFO,LEVEL,SCALE
      SAVE IVAR,JVAR,STIGR,STJGR,DFIGR,DFJGR,INFO,LEVEL,SCALE
      CHARACTER ANSWER
C
      IF (TSS(NS).NE.'UYXX') CALL UYPRO1('UYXX',0)
      GO TO (1,4) ISP(NS)
    1 CONTINUE
      IF (GFMT.GT.0) THEN
        WRITE(*,'(A)') 'GRAPH OF MAPS:'
        WRITE(*,'(A)')
     &    '  S = ISOLINES/MAP/SURFACE, R = RETURN  [ENTER = R]'
        READ(*,'(A)') ANSWER
        IF (ANSWER.NE.'S'.AND.ANSWER.NE.'s') GOTO 5
      ENDIF
   10 IF (NF.LE.2) THEN
        IGR=1
        JGR=NF
      ELSE
   11   WRITE(*,'(A)') 'INDEX OF THE 1-ST VARIABLE:'
        READ(*,*,ERR=11) IGR
        IF (IGR.LE.0.OR.IGR.GT.NF) GO TO 11
   12   WRITE(*,'(A)') 'INDEX OF THE 2-ND VARIABLE:'
        READ(*,*,ERR=12) JGR
        IF (JGR.LE.0.OR.JGR.GT.NF.OR.JGR.EQ.IGR) GO TO 12
      ENDIF
      CALL UOJZD3(NF,X,IGR,XLIGR,XUIGR)
      CALL UOJZD3(NF,X,JGR,XLJGR,XUJGR)
C
      FO=F
      XIGR=X(IGR)
      XJGR=X(JGR)
      STIGR=(XUIGR-XLIGR)/(NGR-1)
      STJGR=(XUJGR-XLJGR)/(NGR-1)
      DFIGR=ETA9
      DFJGR=ETA9
      VALMIN= ETA9
      VALMAX=-ETA9
      IVAR=0
    2 IVAR=IVAR+1
      X(IGR)=XLIGR+(IVAR-1)*STIGR
      JVAR=0
    3 JVAR=JVAR+1
      X(JGR)=XLJGR+(JVAR-1)*STJGR
      CALL UYSET2
      CALL UYSET0(1,2)
      RETURN
    4 CONTINUE
      IF (ABS(F).GE.CON2) THEN
      FL(IVAR,JVAR)=SIGN(CON2,F)
      ELSE IF (ABS(F).LE.CON1) THEN
      FL(IVAR,JVAR)=SIGN(CON1,F)
      ELSE
      FL(IVAR,JVAR)=F
      ENDIF
      IF (ABS(XIGR-X(IGR)).LT.DFIGR) THEN
      DFIGR=ABS(XIGR-X(IGR))
      IMIN=IVAR
      ENDIF
      IF (ABS(XJGR-X(JGR)).LT.DFJGR) THEN
      DFJGR=ABS(XJGR-X(JGR))
      JMIN=JVAR
      ENDIF
      IF (FL(IVAR,JVAR).LT.VALMIN) VALMIN=FL(IVAR,JVAR)
      IF (FL(IVAR,JVAR).GT.VALMAX) VALMAX=FL(IVAR,JVAR)
      IF (JVAR.LT.NGR) GO TO 3
      IF (IVAR.LT.NGR) GO TO 2
      IF (XIGR.LT.XLIGR.OR.XIGR.GT.XUIGR) IMIN=0
      IF (XJGR.LT.XLJGR.OR.XJGR.GT.XUJGR) JMIN=0
      X(IGR)=XIGR
      X(JGR)=XJGR
      F=FO
C
   21 CONTINUE
      LEVEL=64
      CALL UOMSCR('S',0,0,0,0,0,GFMT,0,0,INFO,LEVEL,SCALE)
      IF (INFO.EQ.-1) GOTO 10
      IF (INFO.EQ.0) THEN
        IF (GFMT.EQ.0) GOTO 5
        IF (GFMT.GT.0) GOTO 1
      ENDIF
      VYPISF=.FALSE.
      IF (INFO.EQ.1.OR.INFO.EQ.12.OR.INFO.EQ.13.OR.INFO.EQ.123)
     &  CALL UOMISO(NGR,IGR,JGR,XIGR,XJGR,XLIGR,XUIGR,XLJGR,XUJGR,
     &  IMIN,JMIN,FL,VYPISF,LEVEL,SCALE,1,GFMT)
      IF (INFO.EQ.2.OR.INFO.EQ.12.OR.INFO.EQ.23.OR.INFO.EQ.123)
     &  CALL UOMMAP(NGR,IGR,JGR,XIGR,XJGR,XLIGR,XUIGR,XLJGR,XUJGR,
     &  IMIN,JMIN,FL,VYPISF,LEVEL,SCALE,1,GFMT)
      IF (INFO.EQ.3.OR.INFO.EQ.13.OR.INFO.EQ.23.OR.INFO.EQ.123)
     &  CALL UOMSUR(NGR,IGR,JGR,XLIGR,XUIGR,XLJGR,XUJGR,
     &  FL,VYPISF,SCALE,1,GFMT)
      IF (GFMT.EQ.0) GOTO 21
    5 CONTINUE
      CALL UYEPI1(0)
      RETURN
      END

