$INTERFACE UOMRF4                                             10/12/01

  $FTH='FTH'
  $IF(PATH='YES')
    $DIM=2
  $ELSE
    $IF(GRAPH='INTERNAL')
      $DIM=NF
    $ELSE
      $DIM=3
    $ENDIF  
  $ENDIF
  $ADD(INTEGER,'\NFV1\NAV1') 
  $ADD(REAL4,'\$FL($NGR,$NGR)\$FTH($NGR,2)\$XPA($NPA,$DIM)')
  $ADD(REAL,'\$X($NF)')
      $IF(NA>0)
        CALL UXVCOP(NA,$AF,$AFO)
        $ADD(REAL,'\$AFO($NA)')
      $ENDIF
$REM      IF (NF.LE.1) THEN
$REM      WRITE(15,'(2I5)') 0,0
$REM      GO TO $LGR
$REM      ELSE IF (NF.LE.2) THEN
$REM      WRITE(15,'(2I5)') 1,NGR
$REM      ELSE
$REM      WRITE(15,'(2I5)') 3,NGR
$REM      ENDIF
  $50 CONTINUE
      IF (NF.LE.2) THEN
$REM      $JOB=1
      CALL UOMRF3(NF,$X,$XPA,$FL,F,FO,$ETA9,$OBR,1)
      ELSE
      CALL UOMRF4(NF,$X,$XPA,$FL,F,FO,$ETA9,$OBR)
      ENDIF
      GOTO ($60,$70) ISB+1
  $60 CONTINUE
      $IF(NA>0)
        CALL UXVCOP(NA,$AFO,$AF)
      $ENDIF
      GOTO $LGR
  $70 CONTINUE
      NFV1=NFV
      NAV1=NAV
      $SUBST('UZMODL')
      NFV=NFV1
      NAV=NAV1
      GOTO $50
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UOMRF4                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  MATLAB GRAPHICAL OUTPUT - EXTENDED PATH.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  XPA(NPA,3)  VALUES OF SELECTED VARIABLES.
*  RO  FL(NGR,NGR)  FIELD OF DRAWN FUNCTION VALUES.
*  RO  F  VALUE OF THE OBJECTIVE FUNCTION.
*  RO  FO  OLD VALUE OF THE OBJECTIVE FUNCTION.
*  RI  ETA9  MAXIMUM MACHINE CONSTANT.
*  RI  GFMT  GRAPHIC FORMAT: 0=INTERNAL GRAPHICS,
*                            1=EXTERNAL GRAPHICS (*.EPS FILES),
*                            2=EXTERNAL GRAPHICS (*.PNG FILES).
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
      SUBROUTINE UOMRF4(NF,X,XPA,FL,F,FO,ETA9,GFMT)
      $INCLUDE ('UMCOMM')
      $INCLUDE ('UMCOMG')
      INTEGER NF,GFMT
      REAL*4 FL(NGR,NGR),XPA(NPA,3)
      $FLOAT X(NF),F,FO,ETA9
      $FLOAT DVYB(3),HVYB(3),XVYB(3),SVYB(3),XPAI(3)
      $FLOAT CON1,CON2
      LOGICAL VYPISF
      PARAMETER(CON1=1.0$P-60,CON2=1.0$P 60)
      INTEGER IPOM,JPOM,INDEX(3),INMIN(3),IVAR,JVAR,I,IPAC,NPAC,
     & INFO,CISLOGRAFU,LEVEL,SCALE
      SAVE IPOM,JPOM,INDEX,INMIN,IVAR,JVAR,IPAC,NPAC,DVYB,HVYB,XVYB,SVYB
      SAVE INFO,CISLOGRAFU,LEVEL,SCALE
C
      IF (TSS(NS).NE.'UYXX') CALL UYPRO1('UYXX',0)
      GO TO (1,6) ISP(NS)
    1 CONTINUE
      CISLOGRAFU=0
      INDEX(1)=IGR
      INDEX(2)=JGR
      INDEX(3)=KGR
      IPA=MIN(NPA,NIT)   ! NUMBER OF POINTS
      LEVEL=64
      CALL UOMSCR('I',IPA,1,0,0,0,GFMT,0,0,INFO,LEVEL,SCALE)
      IF (INFO.EQ.0) GOTO 20
C
C     COMPUTATION OF BOUNDS
C
      NPAC=MIN(NPA,NIT)
      IPAC=MAX(NPAC-IPA+1,1)
      DVYB(1)=X(INDEX(1))
      DVYB(2)=X(INDEX(2))
      DVYB(3)=X(INDEX(3))
      HVYB(1)=X(INDEX(1))
      HVYB(2)=X(INDEX(2))
      HVYB(3)=X(INDEX(3))
      DO I=IPAC,NPAC
      XPAI(1)=XPA(I,1)
      XPAI(2)=XPA(I,2)
      XPAI(3)=XPA(I,3)
      DVYB(1)=MIN(DVYB(1),DBLE(XPAI(1)))
      DVYB(2)=MIN(DVYB(2),DBLE(XPAI(2)))
      DVYB(3)=MIN(DVYB(3),DBLE(XPAI(3)))
      HVYB(1)=MAX(HVYB(1),DBLE(XPAI(1)))
      HVYB(2)=MAX(HVYB(2),DBLE(XPAI(2)))
      HVYB(3)=MAX(HVYB(2),DBLE(XPAI(3)))
      ENDDO
      SVYB(1)=MAX((HVYB(1)-DVYB(1))/TEN,(HVYB(1)+DVYB(1))*1D-6,1.0D-16)
      SVYB(2)=MAX((HVYB(2)-DVYB(2))/TEN,(HVYB(2)+DVYB(2))*1D-6,1.0D-16)
      SVYB(3)=MAX((HVYB(3)-DVYB(3))/TEN,(HVYB(3)+DVYB(3))*1D-6,1.0D-16)
      DVYB(1)=DVYB(1)-SVYB(1)
      DVYB(2)=DVYB(2)-SVYB(2)
      DVYB(3)=DVYB(3)-SVYB(3)
      HVYB(1)=HVYB(1)+SVYB(1)
      HVYB(2)=HVYB(2)+SVYB(2)
      HVYB(3)=HVYB(3)+SVYB(3)
      FO=F
      XVYB(1)=X(INDEX(1))
      XVYB(2)=X(INDEX(2))
      XVYB(3)=X(INDEX(3))
      SVYB(1)=(HVYB(1)-DVYB(1))/(NGR-1)
      SVYB(2)=(HVYB(2)-DVYB(2))/(NGR-1)
      SVYB(3)=(HVYB(3)-DVYB(3))/(NGR-1)
      IMIN=0
      IPOM=0
    2 IPOM=IPOM+1
      JPOM=IPOM
    3 JPOM=JPOM+1
      IMIN=IMIN+1
      VALMIN= ETA9
      VALMAX=-ETA9
      IVAR=0
    4 IVAR=IVAR+1
      X(INDEX(IPOM))=DVYB(IPOM)+(IVAR-1)*SVYB(IPOM)
      JVAR=0
    5 JVAR=JVAR+1
      X(INDEX(JPOM))=DVYB(JPOM)+(JVAR-1)*SVYB(JPOM)
      CALL UYSET2
      CALL UYSET0(1,2)
      RETURN
    6 CONTINUE
      IF (ABS(F).GE.CON2) THEN
      FL(IVAR,JVAR)=SIGN(CON2,F)
      ELSE IF (ABS(F).LE.CON1) THEN
      FL(IVAR,JVAR)=SIGN(CON1,F)
      ELSE
      FL(IVAR,JVAR)=F
      ENDIF
      IF (FL(IVAR,JVAR).LT.VALMIN) THEN
      VALMIN=FL(IVAR,JVAR)
      INMIN(IPOM)=IVAR
      INMIN(JPOM)=JVAR
      ENDIF
      IF (FL(IVAR,JVAR).GT.VALMAX) VALMAX=FL(IVAR,JVAR)
      IF (JVAR.LT.NGR) GO TO 5
      IF (IVAR.LT.NGR) GO TO 4
      X(INDEX(IPOM))=XVYB(IPOM)
      X(INDEX(JPOM))=XVYB(JPOM)
      VYPISF=.FALSE.
      CISLOGRAFU=10*(CISLOGRAFU/10+1)+MOD(INFO,10)
      IF (INFO/10.EQ.1.OR.INFO/10.EQ.12)
     &  CALL UOMPWI(IPAC,NPAC,NGR,INDEX(IPOM),INDEX(JPOM),
     &   XVYB(IPOM),XVYB(JPOM),
     &   DVYB(IPOM),HVYB(IPOM),DVYB(JPOM),HVYB(JPOM),
     &   XPA(:,IPOM),XPA(:,JPOM),FL,VYPISF,LEVEL,SCALE,CISLOGRAFU,GFMT)
      IF (INFO/10.EQ.2.OR.INFO/10.EQ.12)
     &  CALL UOMPWM(IPAC,NPAC,NGR,INDEX(IPOM),INDEX(JPOM),
     &   XVYB(IPOM),XVYB(JPOM),
     &   DVYB(IPOM),HVYB(IPOM),DVYB(JPOM),HVYB(JPOM),
     &   XPA(:,IPOM),XPA(:,JPOM),FL,VYPISF,LEVEL,SCALE,CISLOGRAFU,GFMT)
      IF (JPOM.LT.3) GO TO 3
      IF (IPOM.LT.2) GO TO 2
      F=FO
      IMIN=INMIN(1)
      JMIN=INMIN(2)
      KMIN=INMIN(3)
   20 CONTINUE
      CALL UYEPI1(0)
      RETURN
      END

