* SUBROUTINE UOS0L3                ALL SYSTEMS               99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF ITERATIONS IN STEPSIZE SELECTION.
*
* PARAMETERS :
*  RI  R  CURRENT VALUE OF THE STEPSIZE PARAMETER.
*  RI  F  CURRENT VALUE OF THE OBJECTIVE FUNCTION.
*  RI  SNORM  NORM OF THE DIRECTION VECTOR.
*  II  MODE  MODE OF LINE SEARCH.
*
* COMMON DATA :
*  IU  NLNS  NUMBER OF LINE SEARCHES.
*  II  NRED  NUMBER OF THE CURRENT ITERATION
*  II  IWR  NUMBER OF THE OUTPUT UNIT.
*  II  JOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INFORMATION
*         DURING THE OPTIMIZATION PROCESS. JOUT=0-NO PRINT.
*         JOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=5-ADDITIONAL PRINT OF DEBUGGING.
*  TI  TSXX  PRINTED TEXT.
*
      SUBROUTINE UOS0L3(R,F,SNORM,MODE)
      $INCLUDE ('UMCOMM')
      INTEGER MODE
      $FLOAT R,F,SNORM
      IF (MODE.NE.0) NLNS=NLNS+1
      IF (JOUT.EQ.0) RETURN
      IF (ABS(KOUT).LE.1) RETURN
      WRITE (IWR,1) MODE,NRED,R,R*SNORM,F,TSXX
    1 FORMAT (' ',I1,1X,I3,2X,'R=',$P 9.3,1X,'D=',$P 9.3,1X,
     & 'F=',$P 18.12,1X,A8)
      RETURN
      END
