* SUBROUTINE UOSMAP                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  SCILAB GRAPHICAL VISUALIZATION OF MAP.
*
* PARAMETERS :
*  II  NGR  THE NUMBER OF NODES CORRESPONDING TO EVERY SELECTED VARIABLE
*  II  IGR  THE INDEX OF THE FIRST SELECTED VARIABLE
*  II  JGR  THE INDEX OF THE SECOND SELECTED VARIABLE
*  RI  XIGR  THE VALUE OF THE FIRST VARIABLE IN THE MINIMUM POINT
*  RI  XJGR  THE VALUE OF THE SECOND VARIABLE IN THE MINIMUM POINT
*  RI  XLIGR  THE MINIMUM VALUE OF THE FIRST VARIABLE OF THE SELECTED REGION
*  RI  XUIGR  THE MAXIMUM VALUE OF THE FIRST VARIABLE OF THE SELECTED REGION
*  RI  XLJGR  THE MINIMUM VALUE OF THE SECOND VARIABLE OF THE SELECTED REGION
*  RI  XUIGR  THE MAXIMUM VALUE OF THE SECOND VARIABLE OF THE SELECTED REGION
*  II  IMIN  THE FIRST COORDINATE OF THE MINIMUM IN THE SELECTED REGION
*  II  JMIN  THE SECOND COORDINATE OF THE MINIMUM IN THE SELECTED REGION
*  RI  FL(NGR,NGR)  THE FIELD CONTAINING DRAWN FUNCTION VALUES
*  LU  VYPISF   THE SAME DRAWN FUNCTION VALUES CAN BE PUT INTO P.sci ONLY ONCE
*  II  LEVEL  NUMBER OF CONTOUR LEVELS
*  II  SCALE  LINEAR OR LOGARITHMIC SCALE OF THE PLOT
*  II  CISLO  THE NUMBER OF THE GRAPH
*  II  GFMT  GRAPHIC FORMAT
*
      SUBROUTINE UOSMAP(NGR,IGR,JGR,XIGR,XJGR,XLIGR,XUIGR,XLJGR,XUJGR,
     & IMIN,JMIN,FL,VYPISF,LEVEL,SCALE,CISLO,GFMT)
      $OPTION(CHEOL='#')
      INTEGER NGR,IGR,JGR,IMIN,JMIN,LEVEL,SCALE,CISLO,GFMT
      REAL*4 FL(NGR,NGR)
      $FLOAT XIGR,XJGR,XLIGR,XUIGR,XLJGR,XUJGR
      CHARACTER*25 RET
      LOGICAL VYPISF,ENLX,ENLY,CONSTF
C
      CALL UOSOPN(12,GFMT)
      CALL UOMIMS(NGR,XIGR,XJGR,XLIGR,XUIGR,XLJGR,XUJGR,
     & IMIN,JMIN,FL,VYPISF,SCALE,'M',ENLX,ENLY,CONSTF)
C
      WRITE(RET,'(I15)') LEVEL
      RET=ADJUSTL(RET)
      WRITE(12,'(3A)') 'level=', TRIM(RET),';'
      WRITE(12,'(A)') 'xset("fpf"," ");'
      WRITE(12,'(A)') 'ff=f'';'
      WRITE(12,'(A)') 'Sgrayplot(x,y,ff);'
C
      IF (IMIN.GT.0.OR.JMIN.GT.0) THEN
        WRITE(12,'(A)') 'plot(xm,ym);'
        WRITE(12,'(A)') 'pm=get("hdl");'
        WRITE(12,'(A)') 'pm.children.line_mode="off";'
        WRITE(12,'(A)') 'pm.children.mark_mode="on";'
        WRITE(12,'(A)') 'pm.children.mark_style=11;'
        WRITE(12,'(A)') 'pm.children.mark_size=10;'
        IF (CONSTF) THEN
          WRITE(12,'(A)') 'pm.children.mark_foreground=-1;'
          WRITE(12,'(A)') 'pm.children.mark_background=-1;'
        ELSE
          WRITE(12,'(A)') 'pm.children.mark_foreground=-2;'
          WRITE(12,'(A)') 'pm.children.mark_background=-2;'
        ENDIF
      ENDIF
C
      WRITE(12,'(A)') 'fm=gcf();'
      WRITE(12,'(A)') 'fm.color_map=jetcolormap(level);'
      WRITE(12,'(A)') 'mn=min(f);'
      WRITE(12,'(A)') 'mx=max(f);'
      IF (CONSTF.OR.ENLX.OR.ENLY) WRITE(12,'(A)') 'eps=1.0d-6;'
      IF (CONSTF) THEN
        WRITE(12,'(A)') 'colorbar(mn-eps,mx+eps);'
      ELSE
        WRITE(12,'(A)') 'colorbar(mn,mx);'
      ENDIF
C
      WRITE(12,'(A)') 'am=gca();'
      WRITE(12,'(A)') 'am.font_size=3;'
      WRITE(12,'(A)') 'am.auto_ticks="on";'
      WRITE(12,'(A)') 'am.box="on";'
      IF (ENLX.AND.ENLY) THEN
       WRITE(12,'(A)')
     &  'am.zoom_box=[xligr-eps, xljgr-eps, xuigr+eps, xujgr+eps];'
      ELSEIF (ENLX) THEN
       WRITE(12,'(A)')
     &  'am.zoom_box=[xligr-eps, xljgr, xuigr+eps, xujgr];'
      ELSEIF (ENLY) THEN
       WRITE(12,'(A)')
     &  'am.zoom_box=[xligr, xljgr-eps, xuigr, xujgr+eps];'
      ELSE
       WRITE(12,'(A)')'am.zoom_box=[xligr, xljgr, xuigr, xujgr];'
      ENDIF
      IF (CONSTF) THEN
        IF (SCALE.EQ.2) THEN
          WRITE(12,'(A)')
     &  'tit=title(''Map (constant, log scale)'',''fontsize'',5);'
        ELSE
          WRITE(12,'(A)')
     &  'tit=title(''Map (constant)'',''fontsize'',5);'
        ENDIF
      ELSE
        IF (SCALE.EQ.2) THEN
          WRITE(12,'(A)')
     &  'tit=title(''Map (log scale)'',''fontsize'',5);'
        ELSE
          WRITE(12,'(A)') 'tit=title(''Map'',''fontsize'',5);'
        ENDIF
      ENDIF
      WRITE(RET,'(I15)') IGR
      RET=ADJUSTL(RET)
      WRITE(12,'(3A)') 'xlabel(''X(', TRIM(RET), ')'',''fontsize'',3);'
      WRITE(RET,'(I15)') JGR
      RET=ADJUSTL(RET)
      WRITE(12,'(3A)') 'ylabel(''X(', TRIM(RET), ')'',''fontsize'',3);'
      CALL UOSGRX(12,'PSMAP',CISLO,GFMT)
      RETURN
      $OPTION(CHEOL=';')
      END
