* SUBROUTINE UOSPWM                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  SCILAB GRAPHICAL VISUALIZATION OF PATH WITH MAP.
*
* PARAMETERS :
*  II  IPAC  THE FIRST ITERATION POINT FOR PLOTTING THE PATH.
*  II  NPAC  THE LAST ITERATION POINT FOR PLOTTING THE PATH.
*  II  NGR  THE NUMBER OF NODES CORRESPONDING TO EVERY SELECTED VARIABLE
*  II  IGR  THE INDEX OF THE FIRST SELECTED VARIABLE
*  II  JGR  THE INDEX OF THE SECOND SELECTED VARIABLE
*  RI  XIGR  THE VALUE OF THE FIRST VARIABLE IN THE MINIMUM POINT
*  RI  XJGR  THE VALUE OF THE SECOND VARIABLE IN THE MINIMUM POINT
*  RI  XLIGR  THE MINIMUM VALUE OF THE FIRST VARIABLE OF THE SELECTED REGION
*  RI  XUIGR  THE MAXIMUM VALUE OF THE FIRST VARIABLE OF THE SELECTED REGION
*  RI  XLJGR  THE MINIMUM VALUE OF THE SECOND VARIABLE OF THE SELECTED REGION
*  RI  XUJGR  THE MAXIMUM VALUE OF THE SECOND VARIABLE OF THE SELECTED REGION
*  RI  XPA1(NPAC)  VALUES OF THE FIRST SELECTED VARIABLE.
*  RI  XPA2(NPAC)  VALUES OF THE SELECTED SELECTED VARIABLE.
*  RI  FL(NGR,NGR)  THE FIELD CONTAINING DRAWN FUNCTION VALUES
*  LI  VYPISF   THE SAME DRAWN FUNCTION VALUES CAN BE PUT INTO P.sci ONLY ONCE
*  II  LEVEL  NUMBER OF CONTOUR LEVELS
*  II  SCALE  LINEAR OR LOGARITHMIC SCALE OF THE PLOT
*  II  CISLO  THE NUMBER OF THE GRAPH
*  II  GFMT  GRAPHIC FORMAT
*
      SUBROUTINE UOSPWM(IPAC,NPAC,NGR,IGR,JGR,XIGR,XJGR,XLIGR,XUIGR,
     &  XLJGR,XUJGR,XPA1,XPA2,FL,VYPISF,LEVEL,SCALE,CISLO,GFMT)
      INTEGER IPAC,NPAC,NGR,IGR,JGR,LEVEL,SCALE,CISLO,GFMT
      REAL*4 XPA1(NPAC),XPA2(NPAC),FL(NGR,NGR)
      $FLOAT XIGR,XJGR,XLIGR,XUIGR,XLJGR,XUJGR
      LOGICAL VYPISF,ENLX,ENLY,CONSTF
C
      CALL UOSOPN(15,GFMT)
      CALL UOMPW1(IPAC,NPAC,NGR,XIGR,XJGR,XLIGR,XUIGR,XLJGR,XUJGR,
     &   XPA1,XPA2,FL,VYPISF,SCALE,ENLX,ENLY,CONSTF)
      CALL UOSPW2
     &  (NPAC-IPAC+1,IGR,JGR,LEVEL,SCALE,ENLX,ENLY,CONSTF,'M',CISLO)
      CALL UOSGRX(15,'PSPWM',CISLO,GFMT)
      RETURN
      END