$INTERFACE UOT2C3                                             98/12/01

  CALL UOT2C3(NF,NC,MC,KC,$MHC,$GC,$HC,$ICG,$JCG,FC)
  $ADD(REAL,'\$GC($NF)\$HC($MHC)')
  $ADD(INTEGER,'\$ICG($NC+1)\$JCG($MC)')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UOT2C3                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF TEST OF EXTERNAL SUBROUTINES.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  NC  NUMBER OF CONSTRAINTS.
*  II  MC  NUMBER OF NONZERO ELEMENTS OF THE SPARSE JACOBIAN MATRIX.
*  II  KC  INDEX OF THE CONSTRAINT.
*  II  ME  NUMBER OF NONZERO ELEMENTS OF THE MATRIX HA.
*  RI  GC(NF)  GRADIENT OF THE CONSTRAINT FUNCTION.
*  RI  HC(M) HESSIAN MATRIX OF THE CONSTRAINT FUNCTION.
*  RI  FC  VALUE OF THE CONSTRAINT FUNCTION.
*
* COMMON DATA :
*  II  IWR  NUMBER OF THE OUTPUT UNIT.
*  II  KD DEGREE OF REQUIRED DERIVATIVES.
*
* OUTPUT VARIABLES::
* FC,GC(NF),HC(M)
*
      SUBROUTINE UOT2C3(NF,NC,MC,KC,ME,GC,HC,ICG,JCG,FC)
      $INCLUDE('UMCOMM')
      INTEGER NF,NC,MC,KC,ME,ICG(NC+1),JCG(MC)
      $FLOAT GC(NF),HC(ME),FC
      INTEGER I,K
      K=ICG(KC+1)-ICG(KC)
      GOTO(1,4,5) KD+1
    1 WRITE(IWR,2) 'FC A =',FC
    2 FORMAT(/1X,A6,$P 18.10)
      WRITE(IWR,3) 'GC N =',(GC(JCG(I)),I=ICG(KC),ICG(KC+1)-1)
    3 FORMAT(' ',A6,4$P 18.10:/(7X,4$P 18.10))
      RETURN
    4 WRITE(IWR,3) 'GC A =',(GC(JCG(I)),I=ICG(KC),ICG(KC+1)-1)
      WRITE(IWR,3) 'HC N =',(HC(I),I=1,K*(K+1)/2)
      RETURN
    5 WRITE(IWR,3) 'HC A =',(HC(I),I=1,K*(K+1)/2)
      RETURN
      END
