* SUBROUTINE UOTES5                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* INITIATION FOR SIMULTANEOUS TESTS.
*
* COMMON DATA :
*  II  NIT  NUMBER OF ITERATIONS.
*  II  NFV  NUMBER OF FUNCTION VALUE EVALUATIONS.
*  II  NFG  NUMBER OF FUNCTION GRADIENT EVALUATIONS.
*  II  NDC  NUMBER OF MATRIX DECOMPOSITIONS
*
      SUBROUTINE UOTES5(NITF,NFVF,NFGF,NFHF,NDCF,NCGF,NLSF,NTMF,NDIM)
      $INCLUDE('UMCOMM')
      INTEGER NDIM,NITF(NDIM),NFVF(NDIM),NFGF(NDIM),NFHF(NDIM),
     & NDCF(NDIM),NCGF(NDIM),NLSF(NDIM),NTMF(NDIM)
      INTEGER NFD,NAD,NCD,NED,NITT,NFVT,NFGT,NFHT,NDCT,NCGT,
     & NLST,NSCT,NUPT,NMXT,NRST,NADT,NRMT,NSUC,NTOT,NTIM,ITIM
      COMMON /UMTEST/ NFD,NAD,NCD,NED,NITT,NFVT,NFGT,NFHT,NDCT,NCGT,
     & NLST,NSCT,NUPT,NMXT,NRST,NADT,NRMT,NSUC,NTOT,NTIM,ITIM
      INTEGER IHR,IMIN,ISEC,I
      $FLOAT RIT,RFV,RFG,RFH,RDC,RCG,RLS,RTM,RDIM
      WRITE(ITR,55) NITT,NFVT,NFGT,NDCT,NSUC,NCGT,NLST,NSCT,NUPT,NRST,
     & NMXT,NADT,NRMT
      IF (KOUT.EQ.0.AND.LOUT.GT.0) THEN
      WRITE(IWR,55) NITT,NFVT,NFGT,NDCT,NSUC,NCGT,NLST,NSCT,NUPT,NRST,
     & NMXT,NADT,NRMT
      ENDIF
   55 FORMAT(' TOTAL',3X,'NIT=',I8,3X,'NFV=',I8,3X,'NFG=',I8,3X,'NDC=',
     & I8,' * ',I5/9X,'NCG=',I8,3X,'NLS=',I8,3X,'NSC=',I8,3X,'NUP=',
     & I8/9X,'NRS=',I8,3X,'NMX=',I8,3X,'NAD=',I8,3X,'NRM=',I8)
      CALL UYTIM2(ITIM)
      RIT=ZERO
      RFV=ZERO
      RFG=ZERO
      RFH=ZERO
      RDC=ZERO
      RCG=ZERO
      RLS=ZERO
      RTM=ZERO
      RDIM=$DBLE(NDIM)
      DO 1 I=1,NDIM
      RIT=RIT+LOG($DBLE(NITF(I)+1))
      RFV=RFV+LOG($DBLE(NFVF(I)+1))
      RFG=RFG+LOG($DBLE(NFGF(I)+1))
      RFH=RFH+LOG($DBLE(NFHF(I)+1))
      RDC=RDC+LOG($DBLE(NDCF(I)+1))
      RCG=RCG+LOG($DBLE(NCGF(I)+1))
      RLS=RLS+LOG($DBLE(NLSF(I)+1))
      RTM=RTM+LOG($DBLE(NTMF(I)+1))
    1 CONTINUE
      NITT=INT(EXP(RIT/RDIM))-1
      NFVT=INT(EXP(RFV/RDIM))-1
      NFGT=INT(EXP(RFG/RDIM))-1
      NFHT=INT(EXP(RFH/RDIM))-1
      NDCT=INT(EXP(RDC/RDIM))-1
      NCGT=INT(EXP(RCG/RDIM))-1
      NLST=INT(EXP(RLS/RDIM))-1
      ITIM=INT(EXP(RTM/RDIM))-1
      WRITE(ITR,56) NITT,NFVT,NFGT,NDCT,NCGT,NLST
      IF (KOUT.EQ.0.AND.LOUT.GT.0) THEN
      WRITE(IWR,56) NITT,NFVT,NFGT,NDCT,NCGT,NLST
      ENDIF
   56 FORMAT(' MEAN ',3X,'NIT=',I4,3X,'NFV=',I5,3X,'NFG=',I4,3X,'NDC='
     & ,I4,3X,'NCG=',I5,3X,'NLS=',I4)
      IHR=ITIM/(60*60*100)
      ITIM=ITIM-IHR*60*60*100
      IMIN=ITIM/(60*100)
      ITIM=ITIM-IMIN*60*100
      ISEC=ITIM/100
      ITIM=ITIM-ISEC*100
      IF(MOUT.NE.0) WRITE(ITR,10) IHR,IMIN,ISEC,ITIM
      IF(KOUT.NE.0) WRITE(IWR,10) IHR,IMIN,ISEC,ITIM
      IF(KOUT.EQ.0.AND.LOUT.GT.0) WRITE(IWR,10) IHR,IMIN,ISEC,ITIM
   10 FORMAT(' TIME=',I2,':',I2.2,':',I2.2,'.',I2.2)
      NITT=0
      NFVT=0
      NFGT=0
      NFHT=0
      NDCT=0
      NCGT=0
      NLST=0
      NSCT=0
      NUPT=0
      NRST=0
      NMXT=0
      NADT=0
      NRMT=0
      NSUC=0
      NTOT=0
      RETURN
      END
