* SUBROUTINE UOTES7                ALL SYSTEMS                05/12/01
C PORTABILITY : ALL SYSTEMS
C 05/12/01 LU : ORIGINAL VERSION
*
* PARAMETERS:
*  CI  PROFILE  TYPE OF PERFORMANCE PROFILE. PROFILE='NIT'-NUMBER OF
*         ITERATIONS. PROFILE='NFV'-NUMBER OF FUNCTION EVALUATIONS.
*         PROFILE='NFG'-NUMBER OF GRADIENT EVALUATIONS. 
*         PROFILE='NCGR'-NUMBER OF CONJUGATE GRADIENT ITERATIONS.
*         PROFILE='TIME'-CPU TIME.
*  RI  BOUND  BOUND FOR  PERFORMANCE PROFILE.           
*
* PURPOSE :
* PRINT OF DATA FOR PERFORMANCE PROFILES.
*
      SUBROUTINE UOTES7(PROFILE,BOUND)
      CHARACTER*4 PROFILE
      $FLOAT BOUND
      CHARACTER*6 METHOD
      CHARACTER*14 NAME,NAMES(20)
      $FLOAT P(200,20),R(200,20),E(20),F(20),TAU,POM,TEMP,FMAX,STEP,CON
      INTEGER NMETH,NPROB,I,J,K,NRES(5),IP(200,20),IM(200),IS(200),NPOM
      INTEGER MMETH,MPROB
      PARAMETER(MMETH=20,MPROB=200,CON=0.9999999999$P 0)
      IF (PROFILE.EQ.'NIT') J=1
      IF (PROFILE.EQ.'NFV') J=2
      IF (PROFILE.EQ.'NFG') J=3
      IF (PROFILE.EQ.'NCGR') J=4
      IF (PROFILE.EQ.'TIME') J=5
      IF (BOUND.LE.0.5$P 0) THEN
      BOUND=0.5$P 0
      STEP=0.25$P-1
      ELSEIF(BOUND.LE.1.0$P 0) THEN
      BOUND=1.0$P 0
      STEP=0.50$P-1
      ELSEIF(BOUND.LE.1.5$P 0) THEN
      BOUND=1.5$P 0
      STEP=0.75$P-1
      ELSEIF(BOUND.LE.2.0$P 0) THEN
      BOUND=2.0$P 0
      STEP=1.00$P-1
      ELSEIF(BOUND.LE.2.5$P 0) THEN
      BOUND=2.5$P 0
      STEP=1.25$P-1
      ELSEIF(BOUND.LE.3.0$P 0) THEN
      BOUND=3.0$P 0
      STEP=1.50$P-1
      ELSEIF(BOUND.LE.3.5$P 0) THEN
      BOUND=3.5$P 0
      STEP=1.75$P-1
      ELSEIF(BOUND.LE.4.0$P 0) THEN
      BOUND=4.0$P 0
      STEP=2.00$P-1
      ELSEIF(BOUND.LE.4.5$P 0) THEN
      BOUND=4.5$P 0
      STEP=2.25$P-1
      ELSE
      BOUND=5.0$P 0
      STEP=2.50$P-1
      ENDIF
      NMETH=0
    1 READ (7,'(A6,2X,A14,5I10)',END=2) METHOD,NAME,(NRES(I),I=1,5)
      IF (METHOD.EQ.'METHOD') THEN
      NMETH=NMETH+1
      IF (NMETH.LE.MMETH) NAMES(NMETH)=NAME
      NPROB=0
      ELSE
      NPROB=NPROB+1
      IF (NPROB.LE.MPROB) IP(NPROB,NMETH)=MAX(NRES(J),1)
      ENDIF
      GO TO 1
    2 CONTINUE
      WRITE(8,'(A21,3X,A4,3X,''BOUND ='',F10.4,3X,''STEP ='',F10.4,3X,
     % ''NMETH ='',I3)')
     & 'PERFORMANCE PROFILES:',PROFILE,BOUND,STEP,NMETH
      WRITE(8,'(A1)') ' '
      DO 12 J=1,NMETH
      E(J)=0.0$P 0
      F(J)=0.0$P 0
   12 CONTINUE   
      DO 5 I=1,NPROB
      IM(I)=IP(I,1)
      IS(I)=0
      DO 3 J=1,NMETH
      IF(IM(I).GT.IP(I,J)) IM(I)=IP(I,J)
      IS(I)=IS(I)+IP(I,J)
    3 CONTINUE
      DO 4 J=1,NMETH
      R(I,J)=$DBLE(IP(I,J))/$DBLE(IM(I))
      F(J)=F(J)+$DBLE(IP(I,J)-IM(I))/$DBLE(IS(I))
    4 CONTINUE
    5 CONTINUE
      FMAX=0.0$P 0   
      DO 15 J=1,NMETH
      F(J)=$DBLE(NPROB)/F(J)
      IF (FMAX.LT.F(J)) FMAX=F(J)
   15 CONTINUE   
      POM=1.0$P 0/LOG(2.0$P 0)
      TAU=0.0$P 0
      K=1
    6 DO 8 J=1,NMETH
      NPOM=0
      DO 7 I=1,NPROB
      TEMP=R(I,J)
      IF (TEMP.GT.1.0$P 0) THEN
      TEMP=LOG(TEMP)
      ELSE
      TEMP=0.0$P 0
      ENDIF
      IF(POM*TEMP.LE.TAU) NPOM=NPOM+1
    7 CONTINUE
      P(K,J)=$DBLE(NPOM)/$DBLE(NPROB)
      E(J)=E(J)+P(K,J)
    8 CONTINUE
      IF (TAU.LT.CON*BOUND.AND.K.LT.200) THEN
      TAU=TAU+STEP
      K=K+1
      GO TO 6
      ENDIF
      DO 9 J=1,NMETH
      E(J)=E(J)/$DBLE(K)
      WRITE(8,'(A6,3X,I3,3X,A14,3X,A12,F10.4,3X,A12,F10.4)') 'METHOD',
     & J,NAMES(J),'MEAN VALUE =',E(J),'EFFICIENCY =',F(J)/FMAX
      WRITE(8,'(A1)') ' '
      WRITE(8,'(8F10.4)') (P(I,J),I=1,K)
      WRITE(8,'(A1)') ' '
    9 CONTINUE
      RETURN
      END

