* SUBROUTINE UOYRM1                ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  PRINT OF ENTRY TO CONSTRAINT DELETION.
*
* PARAMETERS :
*  II  N  ACTUAL NUMBER OF VARIABLES
*  RO  GMAX  NORM OF THE TRANSFORMED GRADIENT.
*  RI  UMAX  MAXIMUN ABSOLUTE VALUE OF THE NEGATIVE LAGRANGE MULTIPLIER.
*  II  IOLD  INDEX OF THE OLD ACTIVE CONSTRAINT.
*  TI  TEXT  PRINTED TEXT.
*
* COMMON DATA :
*  II  IWR  NUMBER OF THE OUTPUT UNIT.
*  II  JOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INFORMATION
*         DURING THE OPTIMIZATION PROCESS. JOUT=0-NO PRINT.
*         JOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=5-ADDITIONAL PRINT OF DEBUGGING.
*
      SUBROUTINE UOYRM1(N,GMAX,UMAX,IOLD,TEXT)
      $INCLUDE('UMCOMM')
      INTEGER N,IOLD
      $FLOAT GMAX,UMAX
      CHARACTER*6 TEXT
      IF(JOUT.EQ.0) RETURN
      IF(ABS(KOUT).LE.3) RETURN
      WRITE(IWR,1) TEXT
    1 FORMAT(' ','CONSTRAINT DELETION USING',1X,A6)
      WRITE(IWR,2) IOLD,N,UMAX,GMAX
    2 FORMAT(' ','OLD=',I3,2X,'N=',I3,2X,'U =',$P 9.3,1X,'G =',$P 9.3)
      RETURN
      END
