$INTERFACE UP0BC3                                             08/12/01

  $R='R'
  $IF(MEP2>0) $R='MIN(R,RMAXP)'
  CALL UP0BC3(NF,NX,NC,NCA,$X,$IX,$XL,$XU,$XSL,$XSU,$XZL,$XZU,$CF,$IC&
,$CL,$CU,$CSL,$CSU,$CZL,$CZU,$ICA,$ICCA,$S,$GS(NF+1),$R,RPF2,RPF3,RPF4&
,FC,F,PMAX)
  $ADD(REAL,'\$X($NF)\$XL($NX)\$XU($NX)\$XSL($NX)\$XSU($NX)\$XZL($NX)&
  \$XZU($NX)\$CF($NC+1)\$CL($NC)\$CU($NC)\$CSL($NC)\$CSU($NC)&
  \$CZL($NC)\$CZU($NC)\S($NF+$NCA)\GS($NF+$NCA)')
  $ADD(INTEGER,'\$IX($NX)\$IC($NC)\$ICA($NCA)\$ICCA($NCA)')
$REM  $ADD(REAL,'\RPF2\RPF3\RPF4\FC\F\PMAX')
$REM  $ADD(INTEGER,'\NF\NX\NC\NCA')
  $ADD(INIT)
    NBFX='UP0BC3'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UP0BC3             ALL SYSTEMS                 08/12/01
C PORTABILITY : ALL SYSTEMS
C 08/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF VALUE OF THE BARRIER FUNCTION.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NX  NUMBER OF BOX CONSTRAINTS.
*  II  NC  NUMBER OF GENERAL CONSTRAINTS.
*  II  NCA  NUMBER OF ACTIVE CONSTRAINTS.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XL(NF)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RI  XU(NF)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  RI  XSL(NX)  VECTOR CONTAINING LOVER SLACKS FOR VARIABLES.
*  RI  XSU(NX)  VECTOR CONTAINING UPPER SLACKS FOR VARIABLES.
*  RI  XZL(NF)  VECTOR CONTAINING LOVER MULTIPLIERS FOR VARIABLES.
*  RI  XZU(NF)  VECTOR CONTAINING UPPER MULTIPLIERS FOR VARIABLES.
*  RI  CF(NC+1)  VECTOR CONTAINING VALUES OF CONSTRAINT FUNCTIONS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  CL(NC)  VECTOR CONTAINING LOWER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CU(NC)  VECTOR CONTAINING UPPER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CSL(NC)  VECTOR CONTAINING LOVER SLACKS FOR CONSTRAINTS.
*  RI  CSU(NC)  VECTOR CONTAINING UPPER SLACKS FOR CONSTRAINTS.
*  RI  CZL(NC)  VECTOR CONTAINING LOVER MULTIPLIERS FOR CONSTRAINTS.
*  RI  CZU(NC)  VECTOR CONTAINING UPPER MULTIPLIERS FOR CONSTRAINTS.
*  II  ICA(NCA)  VECTOR CONTAINING INDICES OF ACTIVE CONSTRAINTS.
*  II  ICCA(NCA)  VECTOR CONTAINING INDICES OF COUPLED COMPLEMENTARITY
*         CONSTRAINTS.
*  RI  S(NCA)  VECTOR CONTAINING NEWTON INCREMENTS.
*  RI  GS(NCA)  VECTOR CONTAINING ACTIVE SLACK INCREMENTS.
*  RI  R  STEPSIZE  PARAMETER.
*  RI  RPF2  PENALTY COEFFICIENT.
*  RI  RPF3  BARRIER COEFFICIENT.
*  RI  RPF4  EXACT PENALTY COEFFICIENT.
*  RO  FC  VALUE OF THE PENALTY TERM.
*  RO  F  VALUE OF THE BARRIER FUNCTION.
*  RO  PMAX  MAXIMUM COMPLEMENTARITY VIOLATION.
*
*  COMMON DATA :
*  II  KBF  SPECIFICATION OF SIMPLE BOUNDS. KBF=0-NO SIMPLE BOUNDS.
*         KBF=1-ONE SIDED SIMPLE BOUNDS. KBF=2=TWO SIDED SIMPLE BOUNDS.
*  II  KBC  SPECIFICATION OF LINEAR CONSTRAINTS. KBC=0-NO LINEAR
*         CONSTRAINTS. KBC=1-ONE SIDED LINEAR CONSTRAINTS. KBC=2=TWO
*         SIDED LINEAR CONSTRAINTS.
*
      SUBROUTINE UP0BC3(NF,NX,NC,NCA,X,IX,XL,XU,XSL,XSU,XZL,XZU,CF,
     & IC,CL,CU,CSL,CSU,CZL,CZU,ICA,ICCA,S,GS,R,RPF2,RPF3,RPF4,FC,F,
     & PMAX)
      $INCLUDE ('UMCOMM')
      INTEGER NF,NX,NC,NCA,IX(NX),IC(NC),ICA(NCA),ICCA(NCA)
      $FLOAT X(NF),XL(NX),XU(NX),XSL(NX),XSU(NX),XZL(NX),XZU(NX),
     & CF(NC+1),CL(NC),CU(NC),CSL(NC),CSU(NC),CZL(NC),CZU(NC),S(*),
     & GS(*),R,RPF2,RPF3,RPF4,FC,F,PMAX
      INTEGER I,J,K,KK,L,LL
      $FLOAT TEMP,SK,SL
      F=ZERO
      FC=ZERO
      PMAX=ZERO
      DO 1 I=1,NCA
      K=ICA(I)
      IF (K.LT.0) THEN
      K=-K
      KK=-IX(K)
      IF (KK.EQ.1) THEN
      SK=XSL(K)+R*GS(I)
      TEMP=XL(K)-X(K)+SK
      FC=FC+(XZL(K)+S(NF+I)+HALF*RPF2*TEMP)*TEMP-RPF3*LOG(SK)
      ELSE IF (KK.EQ.2) THEN
      SK=XSU(K)+R*GS(I)
      TEMP=X(K)-XU(K)+SK
      FC=FC+(XZU(K)+S(NF+I)+HALF*RPF2*TEMP)*TEMP-RPF3*LOG(SK)
      ENDIF
      ELSE
      KK=-IC(K)
      IF (KK.EQ.1) THEN
      SK=CSL(K)+R*GS(I)
      TEMP=CL(K)-CF(K)+SK
      FC=FC+(CZL(K)+S(NF+I)+HALF*RPF2*TEMP)*TEMP-RPF3*LOG(SK)
      ELSE IF (KK.EQ.2) THEN
      SK=CSU(K)+R*GS(I)
      TEMP=CF(K)-CU(K)+SK
      FC=FC+(CZU(K)+S(NF+I)+HALF*RPF2*TEMP)*TEMP-RPF3*LOG(SK)
      ELSE IF (KK.EQ.5) THEN
      FC=FC+(CZL(K)+S(NF+I)+HALF*RPF2*CF(K))*CF(K)
      ENDIF
      ENDIF
      J=ICCA(I)
      IF (J.NE.0) THEN
      L=ICA(J)
      IF (L.LT.0) THEN
      L=-L
      LL=-IX(L)
      IF (LL.EQ.1) THEN
      SL=XSL(L)+GS(J)
      ELSE IF (LL.EQ.2) THEN
      SL=XSU(L)+GS(J)
      ENDIF
      ELSE
      LL=-IC(L)
      IF (LL.EQ.1) THEN
      SL=CSL(L)+GS(J)
      ELSE IF (LL.EQ.2) THEN
      SL=CSU(L)+GS(J)
      ENDIF
      ENDIF
      F=F+SK*SL
      PMAX=MAX(PMAX,SK*SL)
      ENDIF
    1 CONTINUE
      F=CF(NC+1)+RPF4*F+FC
      RETURN
      END
