$INTERFACE UP0BC8                                             03/12/01

  $R='R'
  $IF(MEP2>0) $R='MIN(R,RMAXP)'
  CALL UP0BC8(NF,NX,$NN,NCC,NCA,$X,$XO,$IX,$XL,$XU,$XSL,$XSU,$CF,$CFD&
,$IC,$ICC,$CL,$CU,$CSL,$CSU,$ICA,$S,$GS(NF+1),$R,$RDEL,FC,F,PMAX)
  $ADD(REAL,'\$X($NF)\$XL($NX)\$XU($NX)\$XSL($NX)\$XSU($NX)\$CF($NC+1)&
  \$CFD($NC)\$CL($NC)\$CU($NC)\$CSL($NC)\$CSU($NC)\S($NF+$NCA)&
  \GS($NF+$NCA)')
  $ADD(INTEGER,'\$IX($NX)\$IC($NC)\$ICC(2*$NCC)\$ICA($NCA)')
$REM  $ADD(REAL,'\RPF3\FC\F\PMAX')
$REM  $ADD(INTEGER,'\NF\NX\NC\NCC\NCA')
  $ADD(INIT)
    NBFX='UP0BC8'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UP0BC8             ALL SYSTEMS                 03/12/01
C PORTABILITY : ALL SYSTEMS
C 03/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF VALUE OF THE BARRIER FUNCTION.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NX  NUMBER OF BOX CONSTRAINTS.
*  II  NC  NUMBER OF GENERAL CONSTRAINTS.
*  II  NCC  NUMBER OF COMPLEMENTRITY CONSTRAINTS.
*  II  NCA  NUMBER OF ACTIVE CONSTRAINTS.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  XP(NF)  PREVIOUS VECTOR OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XL(NF)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RI  XU(NF)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  RI  XSL(NX)  VECTOR CONTAINING LOVER SLACKS FOR VARIABLES.
*  RI  XSU(NX)  VECTOR CONTAINING UPPER SLACKS FOR VARIABLES.
*  RI  CF(NC+1)  VECTOR CONTAINING VALUES OF CONSTRAINT FUNCTIONS.
*  RI  CFD(NC)  VECTOR CONTAINING INCREMENTS OF CONSTRAINT FUNCTIONS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  II  ICC(2*NCC)  VECTOR CONTAINING INDICES OF COMPLEMENTRIRY
*         CONSTRAINTS.
*  RI  CL(NC)  VECTOR CONTAINING LOWER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CU(NC)  VECTOR CONTAINING UPPER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CSL(NC)  VECTOR CONTAINING LOVER SLACKS FOR CONSTRAINTS.
*  RI  CSU(NC)  VECTOR CONTAINING UPPER SLACKS FOR CONSTRAINTS.
*  II  ICA(NCA)  VECTOR CONTAINING INDICES OF ACTIVE CONSTRAINTS.
*  RI  S(NCA)  VECTOR CONTAINING NEWTON INCREMENTS.
*  RI  GS(NCA)  VECTOR CONTAINING ACTIVE SLACK INCREMENTS.
*  RI  R  STEPSIZE  PARAMETER.
*  RI  RAT  RATIO OF TRUST REGION RADIUS.
*  RO  FC  VALUE OF THE PENALTY TERM.
*  RO  F  VALUE OF THE BARRIER FUNCTION.
*  RO  PMAX  MAXIMUM COMPLEMENTARITY VIOLATION.
*
*  COMMON DATA :
*  II  KBF  SPECIFICATION OF SIMPLE BOUNDS. KBF=0-NO SIMPLE BOUNDS.
*         KBF=1-ONE SIDED SIMPLE BOUNDS. KBF=2=TWO SIDED SIMPLE BOUNDS.
*  II  KBC  SPECIFICATION OF LINEAR CONSTRAINTS. KBC=0-NO LINEAR
*         CONSTRAINTS. KBC=1-ONE SIDED LINEAR CONSTRAINTS. KBC=2=TWO
*         SIDED LINEAR CONSTRAINTS.
*
      SUBROUTINE UP0BC8(NF,NX,NC,NCC,NCA,X,XP,IX,XL,XU,XSL,XSU,CF,CFD,
     & IC,ICC,CL,CU,CSL,CSU,ICA,S,GS,R,RAT,FC,F,PMAX)
      $INCLUDE ('UMCOMM')
      INTEGER NF,NX,NC,NCC,NCA,IX(NX),IC(NC),ICC(2*NCC),ICA(NCA)
      $FLOAT X(NF),XP(NF),XL(NX),XU(NX),XSL(NX),XSU(NX),CF(NC+1),
     & CFD(NC),CL(NC),CU(NC),CSL(NC),CSU(NC),S(*),GS(*),R,RAT,FC,F,PMAX
      INTEGER I,K,KK,L,LL
      $FLOAT TMP,TEMP,RR,FP
      RR=RAT*R
      F=ZERO
      FC=ZERO
      FP=ZERO
      PMAX=ZERO
      DO 1 I=1,NCA
      K=ICA(I)
      IF (K.LT.0) THEN
      K=-K
      KK=-IX(K)
      IF (KK.EQ.1.OR.KK.EQ.3) THEN
      TMP=XSL(K)+R*GS(I)
      TEMP=XL(K)-X(K)+TMP
      F=F-LOG(TMP)
      FC=FC+TEMP*TEMP
      ELSE IF (KK.EQ.2.OR.KK.EQ.4) THEN
      TMP=XSU(K)+R*GS(I)
      TEMP=X(K)-XU(K)+TMP
      F=F-LOG(TMP)
      FC=FC+TEMP*TEMP
      ENDIF
      ELSE
      KK=-IC(K)
      IF (KK.EQ.1.OR.KK.EQ.3) THEN
      TMP=CSL(K)+R*GS(I)
      TEMP=CL(K)-CF(K)+TMP
      F=F-LOG(TMP)
      FC=FC+TEMP*TEMP
      ELSE IF (KK.EQ.2.OR.KK.EQ.4) THEN
      TMP=CSU(K)+R*GS(I)
      TEMP=CF(K)-CU(K)+TMP
      F=F-LOG(TMP)
      FC=FC+TEMP*TEMP
      ELSE IF (KK.EQ.5) THEN
      FC=FC+CF(K)*CF(K)
      ENDIF
      ENDIF
    1 CONTINUE
      IF (KBF.GT.0) THEN
      DO 2 K=1,NX
      KK=IX(K)
      IF (KK.EQ.1.OR.KK.EQ.3.OR.ABS(KK).EQ.4) THEN
      TMP=XSL(K)-RR*(XL(K)-XP(K)-S(K)+XSL(K))
      TEMP=XL(K)-X(K)+TMP
      F=F-LOG(TMP)
      FC=FC+TEMP*TEMP
      ENDIF
      IF (KK.EQ.2.OR.KK.EQ.4.OR.ABS(KK).EQ.3) THEN
      TMP=XSU(K)-RR*(XP(K)-XU(K)+S(K)+XSU(K))
      TEMP=X(K)-XU(K)+TMP
      F=F-LOG(TMP)
      FC=FC+TEMP*TEMP
      ENDIF
    2 CONTINUE
      ENDIF
      IF (KBC.GT.0) THEN
      DO 3 K=1,NC
      KK=IC(K)
      IF (KK.EQ.1.OR.KK.EQ.3.OR.ABS(KK).EQ.4) THEN
      TMP=CSL(K)-RR*(CL(K)-CFD(K)+CSL(K))
      TEMP=CL(K)-CF(K)+TMP
      F=F-LOG(TMP)
      FC=FC+TEMP*TEMP
      ENDIF
      IF (KK.EQ.2.OR.KK.EQ.4.OR.ABS(KK).EQ.3) THEN
      TMP=CSU(K)-RR*(CFD(K)-CU(K)+CSU(K))
      TEMP=CF(K)-CU(K)+TMP
      F=F-LOG(TMP)
      FC=FC+TEMP*TEMP
      ENDIF
    3 CONTINUE
      ENDIF
      DO 4 I=1,NCC
      K=ICC(I)
      IF (K.LT.0) THEN
      K=-K
      KK=ABS(IX(K))
      IF (KK.EQ.1) THEN
      TMP=XL(K)-X(K)
      ELSE IF (KK.EQ.2) THEN
      TMP=X(K)-XU(K)
      ENDIF
      ELSE
      KK=ABS(IC(K))
      IF (KK.EQ.1) THEN
      TMP=CL(K)-CF(K)
      ELSE IF (KK.EQ.2) THEN
      TMP=CF(K)-CU(K)
      ENDIF
      ENDIF
      L=ICC(NCC+I)
      IF (K.LT.0) THEN
      L=-L
      LL=ABS(IX(L))
      IF (LL.EQ.1) THEN
      TEMP=XL(L)-X(L)
      ELSE IF (LL.EQ.2) THEN
      TEMP=X(L)-XU(L)
      ENDIF
      ELSE
      LL=ABS(IC(L))
      IF (LL.EQ.1) THEN
      TEMP=CL(L)-CF(L)
      ELSE IF (LL.EQ.2) THEN
      TEMP=CF(L)-CU(L)
      ENDIF
      ENDIF
      FP=FP+TMP*TEMP
      PMAX=MAX(PMAX,TMP*TEMP)
    4 CONTINUE
      FC=SQRT(FC)
      RETURN
      END
