$INTERFACE UP0BC9                                             08/12/01

  $R='R'
  $IF(MEP2>0) $R='MIN(R,RMAXP)'
  CALL UP0BC9(NF,NX,NC,NCA,$X,$XO,$IX,$XL,$XU,$XSL,$XSU,$CF,$CFD,$IC&
,$CL,$CU,$CSL,$CSU,$ICA,$ICCA,$S,$GS(NF+1),$R,FP,FC,F)
  $ADD(REAL,'\$X($NF)\$XL($NX)\$XU($NX)\$XSL($NX)\$XSU($NX)\$CF($NC+1)&
  \$CFD($NC)\$CL($NC)\$CU($NC)\$CSL($NC)\$CSU($NC)\S($NF+$NCA)&
  \GS($NF+$NCA)')
  $ADD(INTEGER,'\$IX($NX)\$IC($NC)\$ICA($NCA)\$ICCA($NCA)')
$REM  $ADD(REAL,'\RPF3\FP\FC\F')
$REM  $ADD(INTEGER,'\NF\NX\NC\NCA')
  $ADD(INIT)
    NBFX='UP0BC9'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UP0BC9             ALL SYSTEMS                 08/12/01
C PORTABILITY : ALL SYSTEMS
C 08/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF VALUE OF THE BARRIER FUNCTION.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NX  NUMBER OF BOX CONSTRAINTS.
*  II  NC  NUMBER OF GENERAL CONSTRAINTS.
*  II  NCA  NUMBER OF ACTIVE CONSTRAINTS.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  XP(NF)  PREVIOUS VECTOR OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XL(NF)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RI  XU(NF)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  RI  XSL(NX)  VECTOR CONTAINING LOVER SLACKS FOR VARIABLES.
*  RI  XSU(NX)  VECTOR CONTAINING UPPER SLACKS FOR VARIABLES.
*  RI  CF(NC+1)  VECTOR CONTAINING VALUES OF CONSTRAINT FUNCTIONS.
*  RI  CFD(NC)  VECTOR CONTAINING INCREMENTS OF CONSTRAINT FUNCTIONS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  CL(NC)  VECTOR CONTAINING LOWER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CU(NC)  VECTOR CONTAINING UPPER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CSL(NC)  VECTOR CONTAINING LOVER SLACKS FOR CONSTRAINTS.
*  RI  CSU(NC)  VECTOR CONTAINING UPPER SLACKS FOR CONSTRAINTS.
*  II  ICA(NCA)  VECTOR CONTAINING INDICES OF ACTIVE CONSTRAINTS.
*  II  ICCA(NCA)  VECTOR CONTAINING INDICES OF COUPLED COMPLEMENTARITY
*         CONSTRAINTS.
*  RI  S(NCA)  VECTOR CONTAINING NEWTON INCREMENTS.
*  RI  GS(NCA)  VECTOR CONTAINING ACTIVE SLACK INCREMENTS.
*  RI  R  STEPSIZE  PARAMETER.
*  RO  FB  VALUE OF THE BARRIER TERM.
*  RO  FC  VALUE OF THE PENALTY TERM.
*  RO  F  VALUE OF THE EXACT PENALTY TERM.
*
*  COMMON DATA :
*  II  KBF  SPECIFICATION OF SIMPLE BOUNDS. KBF=0-NO SIMPLE BOUNDS.
*         KBF=1-ONE SIDED SIMPLE BOUNDS. KBF=2=TWO SIDED SIMPLE BOUNDS.
*  II  KBC  SPECIFICATION OF LINEAR CONSTRAINTS. KBC=0-NO LINEAR
*         CONSTRAINTS. KBC=1-ONE SIDED LINEAR CONSTRAINTS. KBC=2=TWO
*         SIDED LINEAR CONSTRAINTS.
*
      SUBROUTINE UP0BC9(NF,NX,NC,NCA,X,XP,IX,XL,XU,XSL,XSU,CF,CFD,IC,
     & CL,CU,CSL,CSU,ICA,ICCA,S,GS,R,FB,FC,F)
      $INCLUDE ('UMCOMM')
      INTEGER NF,NX,NC,NCA,IX(NX),IC(NC),ICA(NCA),ICCA(NCA)
      $FLOAT X(NF),XP(NF),XL(NX),XU(NX),XSL(NX),XSU(NX),CF(NC+1),
     & CFD(NC),CL(NC),CU(NC),CSL(NC),CSU(NC),S(*),GS(*),R,FB,FC,F
      INTEGER I,J,K,KK,L,LL
      $FLOAT TEMP,SK,SL
      F=ZERO
      FB=ZERO
      FC=ZERO
      DO 1 I=1,NCA
      K=ICA(I)
      IF (K.LT.0) THEN
      K=-K
      KK=-IX(K)
      IF (KK.EQ.1.OR.KK.EQ.3) THEN
      SK=XSL(K)+R*GS(I)
      TEMP=XL(K)-X(K)+SK
      FB=FB-LOG(SK)
      FC=FC+TEMP*TEMP
      ELSE IF (KK.EQ.2.OR.KK.EQ.4) THEN
      SK=XSU(K)+R*GS(I)
      TEMP=X(K)-XU(K)+SK
      FB=FB-LOG(SK)
      FC=FC+TEMP*TEMP
      ENDIF
      ELSE
      KK=-IC(K)
      IF (KK.EQ.1.OR.KK.EQ.3) THEN
      SK=CSL(K)+R*GS(I)
      TEMP=CL(K)-CF(K)+SK
      FB=FB-LOG(SK)
      FC=FC+TEMP*TEMP
      ELSE IF (KK.EQ.2.OR.KK.EQ.4) THEN
      SK=CSU(K)+R*GS(I)
      TEMP=CF(K)-CU(K)+SK
      FB=FB-LOG(SK)
      FC=FC+TEMP*TEMP
      ELSE IF (KK.EQ.5) THEN
      FC=FC+CF(K)*CF(K)
      ENDIF
      ENDIF
      J=ICCA(I)
      IF (J.GT.I) THEN
      L=ICA(J)
      IF (L.LT.0) THEN
      L=-L
      LL=-IX(L)
      IF (LL.EQ.1) THEN
      SL=XSL(L)+R*GS(J)
      ELSE IF (LL.EQ.2) THEN
      SL=XSU(L)+R*GS(J)
      ENDIF
      ELSE
      LL=-IC(L)
      IF (LL.EQ.1) THEN
      SL=CSL(L)+R*GS(J)
      ELSE IF (LL.EQ.2) THEN
      SL=CSU(L)+R*GS(J)
      ENDIF
      ENDIF
      F=F+SK*SL
      ENDIF
    1 CONTINUE
      FC=SQRT(FC)
      RETURN
      END
