$INTERFACE UP0BF1                                             02/12/01

  $R='R'
  $IF(MEP2>0) $R='MIN(R,RMAXP)'
  CALL UP0BF1(NF,NX,$NN,NCA,$X,$XO,$IX,$XL,$XU,$XSL,$XSU,$XZL,$XZU,$CF&
,$CFD,$IC,$CL,$CU,$CSL,$CSU,$CZL,$CZU,$ICA,$S,$GS(NF+1),$XO(NF+1)&
,$GO(NF+1),$ED,$R,$RDEL,RPF2,RPF3,FC,F,$MOP1,$MEP4)
$REM  $ADD(REAL,'\$X($NF)\$XL($NX)\$XU($NX)\$XSL($NX)\$XSU($NX)\$XZL($NX)&
$REM  \$XZU($NX)\$CF($NC+1)\$CFD($NC)\$CL($NC)\$CU($NC)\$CSL($NC)&
$REM  \$CSU($NC)\$CZL($NC)\$CZU($NC)\S($NF+$NCA)\GS($NF+$NCA)\XO($NF+$NCA)&
$REM  \GO($NF+$NCA)\$ED($NCA)')
$REM  $ADD(INTEGER,'\$IX($NX)\$IC($NC)\$ICA($NCA)')
$REM  $ADD(REAL,'\RPF2\RPF3\FC\F')
$REM  $ADD(INTEGER,'\NF\NX\NC\NCA')
  $ADD(INIT)
    NBFX='UP0BF1'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UP0BF1             ALL SYSTEMS                 02/12/01
C PORTABILITY : ALL SYSTEMS
C 02/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF VALUE OF THE BARRIER FUNCTION.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NX  NUMBER OF BOX CONSTRAINTS.
*  II  NC  NUMBER OF GENERAL CONSTRAINTS.
*  II  NCA  NUMBER OF ACTIVE CONSTRAINTS.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  XP(NF)  PREVIOUS VECTOR OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XL(NF)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RI  XU(NF)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  RI  XSL(NX)  VECTOR CONTAINING LOVER SLACKS FOR VARIABLES.
*  RI  XSU(NX)  VECTOR CONTAINING UPPER SLACKS FOR VARIABLES.
*  RI  XZL(NF)  VECTOR CONTAINING LOVER MULTIPLIERS FOR VARIABLES.
*  RI  XZU(NF)  VECTOR CONTAINING UPPER MULTIPLIERS FOR VARIABLES.
*  RI  CF(NC+1)  VECTOR CONTAINING VALUES OF CONSTRAINT FUNCTIONS.
*  RI  CFD(NC)  VECTOR CONTAINING INCREMENTS OF CONSTRAINT FUNCTIONS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  CL(NC)  VECTOR CONTAINING LOWER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CU(NC)  VECTOR CONTAINING UPPER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CSL(NC)  VECTOR CONTAINING LOVER SLACKS FOR CONSTRAINTS.
*  RI  CSU(NC)  VECTOR CONTAINING UPPER SLACKS FOR CONSTRAINTS.
*  RI  CZL(NC)  VECTOR CONTAINING LOVER MULTIPLIERS FOR CONSTRAINTS.
*  RI  CZU(NC)  VECTOR CONTAINING UPPER MULTIPLIERS FOR CONSTRAINTS.
*  II  ICA(NCA)  VECTOR CONTAINING INDICES OF ACTIVE CONSTRAINTS.
*  RI  S(NCA)  VECTOR CONTAINING NEWTON INCREMENTS.
*  RI  GS(NCA)  VECTOR CONTAINING ACTIVE SLACK INCREMENTS.
*  RI  XO(NX+NC)  VECTOR CONTAINING INCREMENTS FOR LOWER INACTIVE
*         MULTIPLIERS.
*  RI  GO(NX+NC)  VECTOR CONTAINING INCREMENTS FOR UPPER INACTIVE
*         MULTIPLIERS.
*  RO  ED(NCA)  DIAGONAL ELEMENTS OF THE PERTURBATION MATRIX.
*  RI  R  STEPSIZE  PARAMETER.
*  RI  RAT  RATIO OF TRUST REGION RADIUS.
*  RI  RPF2  PENALTY COEFFICIENT.
*  RI  RPF3  BARRIER COEFFICIENT.
*  RO  FC  VALUE OF THE PENALTY TERM.
*  RO  F  VALUE OF THE BARRIER FUNCTION.
*  II  ICON  OPTION. ABS(ICON)=1-SLACK VARIABLES ARE DETERMINED BY
*         LINE SEARCH. ABS(ICON)=2-SLACK VARIABLES ARE DETERMINED FROM
*         CONSTRAINTS. ICON>0-BOX CONSTRAINTS ARE DETERMINED BY LINE
*         SEARCH. ICON<0-BOX CONSTRAINTS ARE ALWAYS FEASIBLE.
*  II  IREG  OPTION. IREG=0-REGULARIZATION IS NOT USED. IREG=1-DIAGONAL
*         REGULARIZATION IS USED.
*
*  COMMON DATA :
*  II  KBF  SPECIFICATION OF SIMPLE BOUNDS. KBF=0-NO SIMPLE BOUNDS.
*         KBF=1-ONE SIDED SIMPLE BOUNDS. KBF=2=TWO SIDED SIMPLE BOUNDS.
*  II  KBC  SPECIFICATION OF LINEAR CONSTRAINTS. KBC=0-NO LINEAR
*         CONSTRAINTS. KBC=1-ONE SIDED LINEAR CONSTRAINTS. KBC=2=TWO
*         SIDED LINEAR CONSTRAINTS.
*
      SUBROUTINE UP0BF1(NF,NX,NC,NCA,X,XP,IX,XL,XU,XSL,XSU,XZL,XZU,CF,
     & CFD,IC,CL,CU,CSL,CSU,CZL,CZU,ICA,S,GS,XO,GO,ED,R,RAT,RPF2,RPF3,
     & FC,F,ICON,IREG)
      $INCLUDE ('UMCOMM')
      INTEGER NF,NX,NC,NCA,IX(NX),IC(NC),ICA(NCA),ICON,IREG
      $FLOAT X(NF),XP(NF),XL(NX),XU(NX),XSL(NX),XSU(NX),XZL(NX),XZU(NX),
     & CF(NC+1),CFD(NC),CL(NC),CU(NC),CSL(NC),CSU(NC),CZL(NC),CZU(NC),
     & S(*),GS(*),XO(*),GO(*),ED(NCA),R,RAT,RPF2,RPF3,FC,F
      INTEGER I,K,KK
      $FLOAT TMP,TEMP,RR
      RR=RAT*R
      FC=0.0$P 0
      DO 1 I=1,NCA
      K=ICA(I)
      IF (K.LT.0) THEN
      K=-K
      KK=-IX(K)
      IF (KK.EQ.1.OR.KK.EQ.3) THEN
      IF (ABS(ICON).EQ.2.AND.X(K).GT.XL(K)) THEN
      TMP=X(K)-XL(K)
      ELSE
      TMP=XSL(K)+R*GS(I)
      ENDIF
      TEMP=XL(K)-X(K)+TMP
      IF (IREG.EQ.0) THEN
      FC=FC+(XZL(K)+S(NF+I)+HALF*RPF2*TEMP)*TEMP-
     & RPF3*LOG(TMP)
      ELSE
      FC=FC+(XZL(K)+S(NF+I))*TEMP+HALF*RPF2*(TEMP-R*ED(I)*S(NF+I))**2-
     & RPF3*LOG(TMP)
      ENDIF
      ELSE IF (KK.EQ.2.OR.KK.EQ.4) THEN
      IF (ABS(ICON).EQ.2.AND.X(K).LT.XU(K)) THEN
      TMP=XU(K)-X(K)
      ELSE
      TMP=XSU(K)+R*GS(I)
      ENDIF
      TEMP=X(K)-XU(K)+TMP
      IF (IREG.EQ.0) THEN
      FC=FC+(XZU(K)+S(NF+I)+HALF*RPF2*TEMP)*TEMP-
     & RPF3*LOG(TMP)
      ELSE
      FC=FC+(XZU(K)+S(NF+I))*TEMP+HALF*RPF2*(TEMP-R*ED(I)*S(NF+I))**2-
     & RPF3*LOG(TMP)
      ENDIF
      ENDIF
      ELSE
      KK=-IC(K)
      IF (KK.EQ.1.OR.KK.EQ.3) THEN
      IF (ABS(ICON).EQ.2.AND.CF(K).GT.CL(K)) THEN
      TMP=CF(K)-CL(K)
      ELSE
      TMP=CSL(K)+R*GS(I)
      ENDIF
      TEMP=CL(K)-CF(K)+TMP
      IF (IREG.EQ.0) THEN
      FC=FC+(CZL(K)+S(NF+I)+HALF*RPF2*TEMP)*TEMP-
     & RPF3*LOG(TMP)
      ELSE
      FC=FC+(CZL(K)+S(NF+I))*TEMP+HALF*RPF2*(TEMP-R*ED(I)*S(NF+I))**2-
     & RPF3*LOG(TMP)
      ENDIF
      ELSE IF (KK.EQ.2.OR.KK.EQ.4) THEN
      IF (ABS(ICON).EQ.2.AND.CF(K).LT.CU(K)) THEN
      TMP=CU(K)-CF(K)
      ELSE
      TMP=CSU(K)+R*GS(I)
      ENDIF
      TEMP=CF(K)-CU(K)+TMP
      IF (IREG.EQ.0) THEN
      FC=FC+(CZU(K)+S(NF+I)+HALF*RPF2*TEMP)*TEMP-
     & RPF3*LOG(TMP)
      ELSE
      FC=FC+(CZU(K)+S(NF+I))*TEMP+HALF*RPF2*(TEMP-R*ED(I)*S(NF+I))**2-
     & RPF3*LOG(TMP)
      ENDIF
      ELSE IF (KK.EQ.5) THEN
      FC=FC+(CZL(K)+S(NF+I)+HALF*RPF2*CF(K))*CF(K)
      ENDIF
      ENDIF
    1 CONTINUE
      IF (KBF.GT.0) THEN
      DO 2 K=1,NX
      KK=IX(K)
      IF (KK.EQ.1.OR.KK.EQ.3.OR.ABS(KK).EQ.4) THEN
      IF (ABS(ICON).EQ.2.AND.X(K).GT.XL(K)) THEN
      TMP=X(K)-XL(K)
      ELSE
      TMP=XSL(K)-RR*(XL(K)-XP(K)-S(K)+XSL(K))
      ENDIF
      TEMP=XL(K)-X(K)+TMP
      FC=FC+(XZL(K)+XO(K)+HALF*RPF2*TEMP)*TEMP-
     & RPF3*LOG(TMP)
      ENDIF
      IF (KK.EQ.2.OR.KK.EQ.4.OR.ABS(KK).EQ.3) THEN
      IF (ABS(ICON).EQ.2.AND.X(K).LT.XU(K)) THEN
      TMP=XU(K)-X(K)
      ELSE
      TMP=XSU(K)-RR*(XP(K)-XU(K)+S(K)+XSU(K))
      ENDIF
      TEMP=X(K)-XU(K)+TMP
      FC=FC+(XZU(K)+GO(K)+HALF*RPF2*TEMP)*TEMP-
     & RPF3*LOG(TMP)
      ENDIF
    2 CONTINUE
      ENDIF
      IF (KBC.GT.0) THEN
      DO 3 K=1,NC
      KK=IC(K)
      IF (KK.EQ.1.OR.KK.EQ.3.OR.ABS(KK).EQ.4) THEN
      IF (ABS(ICON).EQ.2.AND.CF(K).GT.CL(K)) THEN
      TMP=CF(K)-CL(K)
      ELSE
      TMP=CSL(K)-RR*(CL(K)-CFD(K)+CSL(K))
      ENDIF
      TEMP=CL(K)-CF(K)+TMP
      FC=FC+(CZL(K)+XO(NX+K)+HALF*RPF2*TEMP)*TEMP-
     & RPF3*LOG(TMP)
      ENDIF
      IF (KK.EQ.2.OR.KK.EQ.4.OR.ABS(KK).EQ.3) THEN
      IF (ABS(ICON).EQ.2.AND.CF(K).LT.CU(K)) THEN
      TMP=CU(K)-CF(K)
      ELSE
      TMP=CSU(K)-RR*(CFD(K)-CU(K)+CSU(K))
      ENDIF
      TEMP=CF(K)-CU(K)+TMP
      FC=FC+(CZU(K)+GO(NX+K)+HALF*RPF2*TEMP)*TEMP-
     & RPF3*LOG(TMP)
      ENDIF
    3 CONTINUE
      ENDIF
      F=CF(NC+1)+FC
      RETURN
      END

