$INTERFACE UP0LF4                                             97/12/01

  $ADD(REAL,'\$GA($NF)\$CG($MC)\$G($NF)\$CZ($NC)')
  $ADD(INTEGER,'\$ICG($NC+1)\$JCG($MC)')
$REM  $ADD(INTEGER,'\NF\NC\MC')
  CALL UP0LF4(NF,NC,MC,$GA,$CG,$ICG,$JCG,$G,$CZ)
  $ADD(INIT)
    NPFX='UP0LF4'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UP0LF4             ALL SYSTEMS                 97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE AND THE GRADIENT OF THE OBJECTIVE FUNCTION.
* COMPUTATION OF THE VALUES AND THE GRADIENTS OF THE CONSTRAINT
* FUNCTIONS.
*
* PARAMETERS :
*  II  NF NUMBER OF VARIABLES.
*  II  NC  NUMBER OF CONSTRAINTS.
*  II  MC  NUMBER OF NONZERO ELEMENTS OF THE SPARSE JACOBIAN MATRIX.
*  RI  GA(NF)  GRADIENT OF THE APPROXIMATED FUNCTION.
*  RI  GC(NF)  GRADIENT OF THE SELECTED FUNCTION.
*  II  ICG(NC+1)  POSITIONS OF THE FIRST ROWS ELEMENTS IN THE SPARSE
*         JACOBIAN STRUCTURE.
*  II  JCG(MC)  COLUMN INDICES OF ELEMENTS IN THE SPARSE JACOBIAN
*         STRUCTURE.
*  RO  G(NF)  GRADIENT OF THE OBJECTIVE FUNCTION.
*  RI  CZ(NC)  VECTOR OF LAGRANGE MULTIPLIERS.
*
* COMMON DATA :
*  II  IEXT  TYPE OF EXTREMUM. IEXT=0-MINIMUM. IEXT=1-MAXIMUM.
*
* SUBPROGRAMS USED :
*  S   UXVCOP  COPYING OF A VECTOR.
*
      SUBROUTINE UP0LF4(NF,NC,MC,GA,CG,ICG,JCG,G,CZ)
      $INCLUDE ('UMCOMM')
      INTEGER NF,NC,MC,ICG(NC+1),JCG(MC)
      $FLOAT GA(NF),CG(MC),G(NF),CZ(NC)
      INTEGER J,K,L,JP,KC
      CALL UXVCOP(NF,GA,G)
      DO 11 KC=1,NC
      K=ICG(KC)
      L=ICG(KC+1)-K
      DO 12 J=1,L
      JP=ABS(JCG(K))
      G(JP)=G(JP)+CZ(KC)*CG(K)
      K=K+1
   12 CONTINUE
   11 CONTINUE
      RETURN
      END
