$INTERFACE UP0SA1                                             97/12/01

  CALL UP0SA1(NC,$CF,$CP,RPF2,RPF3,FC,F)
  $ADD(REAL,'\$CF($NC+1)\$CP($NC)')
$REM  $ADD(REAL,'\RPF2\RPF3\FC\F')
$REM  $ADD(INTEGER,'\NC')
  $ADD(INIT)
    NPFX='UP0SA1'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UP0SA1             ALL SYSTEMS                 97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF VALUE  OF THE L1 EXACT PENALTY FUNCTION.
*
* PARAMETERS :
*  II  NC  NUMBER OF CONSTRAINTS.
*  RI  CF(NC+1)  VECTOR CONTAINING VALUES OF THE CONSTRAINTS.
*  RI  CP(NC)  VECTOR CONTAINING PENALTY PARAMETERS.
*  RI  RPF2  PENALTY COEFFICIENT.
*  RI  RPF3  PENALTY COEFFICIENT.
*  RO  FC  VALUE OF THE PENALTY TERM.
*  RO  F  VALUE OF THE PENALTY FUNCTION.
*
      SUBROUTINE UP0SA1(NC,CF,CP,RPF2,RPF3,FC,F)
      INTEGER NC
      $FLOAT CF(NC+1),CP(NC),RPF2,RPF3,FC,F
      INTEGER KC
      FC=0.0$P 0
      DO 1 KC=1,NC
      FC=FC+RPF2*ABS(CP(KC)*CF(KC))+0.5$P 0*RPF3*CF(KC)**2
    1 CONTINUE
      F=CF(NC+1)+FC
      RETURN
      END
