$INTERFACE UPLAG1                                             05/12/01

  CALL UPLAG1(NA,$AF,$AS,$AZ,RPF3)
  $ADD(REAL,'\$AF($NA)\$AS($NA)\$AZ($NA)')
$REM  $ADD(REAL,'\RPF3')
$REM  $ADD(INTEGER,'\NA')
  $ADD(INIT)
    NPFX='UPLAG1'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UPLAG1             ALL SYSTEMS                 05/12/01
C PORTABILITY : ALL SYSTEMS
C 05/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF VALUE OF THE AUGMENTED LAGRANGIAN FUNCTION.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  RI  AF(NA)  VECTOR CONTAINING VALUES OF APPROXIMATED FUNCTIONS.
*  RO  AS(NA)  VECTOR OF SLACK VARIABLES.
*  RO  AZ(NA)  VECTOR OF LAGRANGE MULTIPLIERS.
*  RI  RPF3  BARRIER COEFFICIENT.
*
      SUBROUTINE UPLAG1(NA,AF,AS,AZ,RPF3)
      INTEGER NA
      $FLOAT AF(NA),AS(NA),AZ(NA),RPF3
      $FLOAT FA
      INTEGER KA
      DO 1 KA=1,NA
      FA=AF(KA)
      AS(KA)=RPF3+SQRT(RPF3**2+FA**2)
      AZ(KA)=FA/AS(KA)
    1 CONTINUE
      RETURN
      END
