$INTERFACE UPLAG3                                             05/12/01

  CALL UPLAG3(NF,NX,NC,$X,$IX,$XL,$XU,$XSL,$XSU,$XZL,$XZU,$CF,$IC,$CL&
,$CU,$CSL,$CSU,$CZL,$CZU,RPF3,MEP4)
  $ADD(REAL,'\$X($NF)\$XL($NX)\$XU($NX)\$XSL($NX)\$XSU($NX)\$XZL($NX)&
  \$XZU($NX)\$CF($NC)\$CL($NC)\$CU($NC)\$CSL($NC)\$CSU($NC)\$CZL($NC)&
  \$CZU($NC)')
  $ADD(INTEGER,'\$IX($NX)\$IC($NC)')
$REM  $ADD(REAL,'\RPF3')
$REM  $ADD(INTEGER,'\NF\NX\NC\MEP4')
  $ADD(INIT)
    NPFX='UPLAG3'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UPLAG3             ALL SYSTEMS                 05/12/01
C PORTABILITY : ALL SYSTEMS
C 05/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF VALUE OF THE AUGMENTED LAGRANGIAN FUNCTION.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NX  NUMBER OF BOX CONSTRAINTS.
*  II  NC  NUMBER OF GENERAL CONSTRAINTS.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XL(NF)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RI  XU(NF)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  RI  XSL(NX)  VECTOR CONTAINING LOVER SLACKS FOR VARIABLES.
*  RI  XSU(NX)  VECTOR CONTAINING UPPER SLACKS FOR VARIABLES.
*  RI  XZL(NF)  VECTOR CONTAINING LOVER MULTIPLIERS FOR VARIABLES.
*  RI  XZU(NF)  VECTOR CONTAINING UPPER MULTIPLIERS FOR VARIABLES.
*  RI  CF(NC)  VECTOR CONTAINING VALUES OF APPROXIMATED FUNCTIONS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  CL(NC)  VECTOR CONTAINING LOWER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CU(NC)  VECTOR CONTAINING UPPER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CSL(NC)  VECTOR CONTAINING LOVER SLACKS FOR CONSTRAINTS.
*  RI  CSU(NC)  VECTOR CONTAINING UPPER SLACKS FOR CONSTRAINTS.
*  RI  CZL(NC)  VECTOR CONTAINING LOVER MULTIPLIERS FOR CONSTRAINTS.
*  RI  CZU(NC)  VECTOR CONTAINING UPPER MULTIPLIERS FOR CONSTRAINTS.
*  RI  RPF3  BARRIER COEFFICIENT.
*  II  MEP4  COMPUTATION OF THE LAGRANGE MULTIPLIERS. |MEP4|=1-LAGRANGE
*         MULTIPLIERS COMPUTED FROM THE PENALTY TERM. |MEP4|=2-LAGRANGE 
*         MULTIPLIERS COMPUTED FROM THE BARRIER TERM. MEP4>0 TWO BARRIER
*         FUNCTIONS ARE USED. MEP4<0 ONE BARRIER FUNCTION IS USED.
*
*  COMMON DATA :
*  II  KBF  SPECIFICATION OF SIMPLE BOUNDS. KBF=0-NO SIMPLE BOUNDS.
*         KBF=1-ONE SIDED SIMPLE BOUNDS. KBF=2=TWO SIDED SIMPLE BOUNDS.
*  II  KBC  SPECIFICATION OF LINEAR CONSTRAINTS. KBC=0-NO LINEAR
*         CONSTRAINTS. KBC=1-ONE SIDED LINEAR CONSTRAINTS. KBC=2=TWO
*         SIDED LINEAR CONSTRAINTS.
*
      SUBROUTINE UPLAG3(NF,NX,NC,X,IX,XL,XU,XSL,XSU,XZL,XZU,CF,IC,CL,
     & CU,CSL,CSU,CZL,CZU,RPF3,MEP4)
      $INCLUDE ('UMCOMM')
      INTEGER NF,NX,NC,IX(NX),IC(NC),MEP4
      $FLOAT X(NF),XL(NX),XU(NX),XSL(NX),XSU(NX),XZL(NX),XZU(NX),
     & CF(NC),CL(NC),CU(NC),CSL(NC),CSU(NC),CZL(NC),CZU(NC),RPF3
      INTEGER K,KK
      IF (KBF.GT.0) THEN
      DO 1 K=1,NX
      KK=ABS(IX(K))
      IF (KK.EQ.1.OR.KK.EQ.3.OR.KK.EQ.4) THEN
      IF (XL(K)-X(K).GE.ZERO.OR.MEP4.LE.0) THEN
      XSL(K)=TWO*RPF3**2/(XL(K)-X(K)+SQRT((XL(K)-X(K))**2+FOUR*RPF3**2))
      IF (ABS(MEP4).LE.1) THEN
      XZL(K)=(XL(K)-X(K)+XSL(K))/RPF3
      ELSE
      XZL(K)=RPF3/XSL(K)
      ENDIF
      ELSE
      XSL(K)=TWO*RPF3**2/(X(K)-XL(K)+SQRT((X(K)-XL(K))**2+FOUR*RPF3**2))
      IF (ABS(MEP4).LE.1) THEN
      XZL(K)=XSL(K)/RPF3
      ELSE
      XZL(K)=RPF3/(X(K)-XL(K)+XSL(K))
      ENDIF
      ENDIF
      ENDIF
      IF (KK.EQ.2.OR.KK.EQ.3.OR.KK.EQ.4) THEN
      IF (X(K)-XU(K).GE.ZERO.OR.MEP4.LE.0) THEN
      XSU(K)=TWO*RPF3**2/(X(K)-XU(K)+SQRT((X(K)-XU(K))**2+FOUR*RPF3**2))
      IF (ABS(MEP4).LE.1) THEN
      XZU(K)=(X(K)-XU(K)+XSU(K))/RPF3
      ELSE
      XZU(K)=RPF3/XSU(K)
      ENDIF
      ELSE
      XSU(K)=TWO*RPF3**2/(XU(K)-X(K)+SQRT((XU(K)-X(K))**2+FOUR*RPF3**2))
      IF (ABS(MEP4).LE.1) THEN
      XZU(K)=XSU(K)/RPF3
      ELSE
      XZU(K)=RPF3/(XU(K)-X(K)+XSU(K))
      ENDIF
      ENDIF
      ENDIF
    1 CONTINUE
      ENDIF
      IF (KBC.GT.0) THEN
      DO 2 K=1,NC
      KK=ABS(IC(K))
      IF (KK.EQ.1.OR.KK.EQ.3.OR.KK.EQ.4) THEN
      IF (CL(K)-CF(K).GE.ZERO.OR.MEP4.LE.0) THEN
      CSL(K)=TWO*RPF3**2/(CL(K)-CF(K)+SQRT((CL(K)-CF(K))**2+
     & FOUR*RPF3**2))
      IF (ABS(MEP4).LE.1) THEN
      CZL(K)=(CL(K)-CF(K)+CSL(K))/RPF3
      ELSE
      CZL(K)=RPF3/CSL(K)
      ENDIF
      ELSE
      CSL(K)=TWO*RPF3**2/(CF(K)-CL(K)+SQRT((CF(K)-CL(K))**2+
     & FOUR*RPF3**2))
      IF (ABS(MEP4).LE.1) THEN
      CZL(K)=CSL(K)/RPF3
      ELSE
      CZL(K)=RPF3/(CF(K)-CL(K)+CSL(K))
      ENDIF
      ENDIF
      ENDIF
      IF (KK.EQ.2.OR.KK.EQ.3.OR.KK.EQ.4) THEN
      IF (CF(K)-CU(K).GE.ZERO.OR.MEP4.LE.0) THEN
      CSU(K)=TWO*RPF3**2/(CF(K)-CU(K)+SQRT((CF(K)-CU(K))**2+
     & FOUR*RPF3**2))
      IF (ABS(MEP4).LE.1) THEN
      CZU(K)=(CF(K)-CU(K)+CSU(K))/RPF3
      ELSE
      CZU(K)=RPF3/CSU(K)
      ENDIF
      ELSE
      CSU(K)=TWO*RPF3**2/(CU(K)-CF(K)+SQRT((CU(K)-CF(K))**2+
     & FOUR*RPF3**2))
      IF (ABS(MEP4).LE.1) THEN
      CZU(K)=CSU(K)/RPF3
      ELSE
      CZU(K)=RPF3/(CU(K)-CF(K)+CSU(K))
      ENDIF
      ENDIF
      ENDIF
    2 CONTINUE
      ENDIF
      RETURN
      END

