$INTERFACE UPLAG6                                             05/12/01

  CALL UPLAG6(NF,NX,NC,$X,$IX,$XL,$XU,$XSL,$XSU,$XZL,$XZU,$CF,$IC,$CL&
,$CU,$CSL,$CSU,$CZL,$CZU,RPF2,RPF3,ETA3,MEP4)
  $ADD(REAL,'\$X($NF)\$XL($NX)\$XU($NX)\$XSL($NX)\$XSU($NX)\$XZL($NX)&
  \$XZU($NX)\$CF($NC)\$CL($NC)\$CU($NC)\$CSL($NC)\$CSU($NC)\$CZL($NC)&
  \$CZU($NC)')
  $ADD(INTEGER,'\$IX($NX)\$IC($NC)')
$REM  $ADD(REAL,'\RPF3')
$REM  $ADD(INTEGER,'\NF\NX\NC\MEP4')
  $ADD(INIT)
    NPFX='UPLAG6'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UPLAG6             ALL SYSTEMS                 05/12/01
C PORTABILITY : ALL SYSTEMS
C 05/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF VALUE OF THE AUGMENTED LAGRANGIAN FUNCTION.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NX  NUMBER OF BOX CONSTRAINTS.
*  II  NC  NUMBER OF GENERAL CONSTRAINTS.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XL(NF)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RI  XU(NF)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  RI  XSL(NX)  VECTOR CONTAINING LOVER SLACKS FOR VARIABLES.
*  RI  XSU(NX)  VECTOR CONTAINING UPPER SLACKS FOR VARIABLES.
*  RI  XZL(NF)  VECTOR CONTAINING LOVER MULTIPLIERS FOR VARIABLES.
*  RI  XZU(NF)  VECTOR CONTAINING UPPER MULTIPLIERS FOR VARIABLES.
*  RI  CF(NC)  VECTOR CONTAINING VALUES OF APPROXIMATED FUNCTIONS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  CL(NC)  VECTOR CONTAINING LOWER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CU(NC)  VECTOR CONTAINING UPPER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CSL(NC)  VECTOR CONTAINING LOVER SLACKS FOR CONSTRAINTS.
*  RI  CSU(NC)  VECTOR CONTAINING UPPER SLACKS FOR CONSTRAINTS.
*  RI  CZL(NC)  VECTOR CONTAINING LOVER MULTIPLIERS FOR CONSTRAINTS.
*  RI  CZU(NC)  VECTOR CONTAINING UPPER MULTIPLIERS FOR CONSTRAINTS.
*  RI  RPF2  PENALTY COEFFICIENT.
*  RI  RPF3  BARRIER COEFFICIENT.
*  II  MEP4  COMPUTATION OF THE LAGRANGE MULTIPLIERS. MEP4=1-LAGRANGE
*         MULTIPLIERS ARE COMPUTED FROM THE PENALTY TERM.
*         MEP4=2-LAGRANGE MULTIPLIERS ARE COMPUTED FROM VARIOUS TERMS.
*         MEP4=3-LAGRANGE MULTIPLIERS ARE COMPUTED FROM THE BARRIER
*         TERM.
*
*  COMMON DATA :
*  II  KBF  SPECIFICATION OF SIMPLE BOUNDS. KBF=0-NO SIMPLE BOUNDS.
*         KBF=1-ONE SIDED SIMPLE BOUNDS. KBF=2=TWO SIDED SIMPLE BOUNDS.
*  II  KBC  SPECIFICATION OF LINEAR CONSTRAINTS. KBC=0-NO LINEAR
*         CONSTRAINTS. KBC=1-ONE SIDED LINEAR CONSTRAINTS. KBC=2=TWO
*         SIDED LINEAR CONSTRAINTS.
*
      SUBROUTINE UPLAG6(NF,NX,NC,X,IX,XL,XU,XSL,XSU,XZL,XZU,CF,IC,CL,
     & CU,CSL,CSU,CZL,CZU,RPF2,RPF3,ETA3,MEP4)
      $INCLUDE ('UMCOMM')
      INTEGER NF,NX,NC,IX(NX),IC(NC),MEP4
      $FLOAT X(NF),XL(NX),XU(NX),XSL(NX),XSU(NX),XZL(NX),XZU(NX),
     & CF(NC),CL(NC),CU(NC),CSL(NC),CSU(NC),CZL(NC),CZU(NC),RPF2,RPF3,
     & ETA3
      $FLOAT POM,CON1,CON2
      INTEGER K,KK,IER
      CON1=RPF3**(RPF2/(RPF2-1.0$P 0))
      CON2=CON1/(RPF2-1.0$P 0)
      IF (KBF.GT.0) THEN
      DO 1 K=1,NX
      KK=ABS(IX(K))
      IF (KK.EQ.1.OR.KK.EQ.3.OR.KK.EQ.4) THEN
      POM=XL(K)-X(K)
      CALL UNLAG6(POM,XSL(K),RPF2,RPF3,ETA3,IER)
      IF (POM.GE.ZERO) THEN
      IF (MEP4.LE.1) THEN
      XZL(K)=((XSL(K)+POM)/RPF3)**(RPF2-1.0$P 0)
      ELSE
      XZL(K)=RPF3/XSL(K)
      ENDIF
      ELSE
      IF (MEP4.LE.2) THEN
      XZL(K)=(XSL(K)/RPF3)**(RPF2-1.0$P 0)
      ELSE
      XZL(K)=RPF3/(XSL(K)-POM)
      ENDIF
      ENDIF
      ENDIF
      IF (KK.EQ.2.OR.KK.EQ.3.OR.KK.EQ.4) THEN
      POM=X(K)-XU(K)
      CALL UNLAG6(POM,XSU(K),RPF2,RPF3,ETA3,IER)
      IF (POM.GE.ZERO) THEN
      IF (MEP4.LE.1) THEN
      XZU(K)=((XSU(K)+POM)/RPF3)**(RPF2-1.0$P 0)
      ELSE
      XZU(K)=RPF3/XSU(K)
      ENDIF
      ELSE
      IF (MEP4.LE.2) THEN
      XZU(K)=(XSU(K)/RPF3)**(RPF2-1.0$P 0)
      ELSE
      XZU(K)=RPF3/(XSU(K)-POM)
      ENDIF
      ENDIF
      ENDIF
    1 CONTINUE
      ENDIF
      IF (KBC.GT.0) THEN
      DO 2 K=1,NC
      KK=ABS(IC(K))
      IF (KK.EQ.1.OR.KK.EQ.3.OR.KK.EQ.4) THEN
      POM=CL(K)-CF(K)
      CALL UNLAG6(POM,CSL(K),RPF2,RPF3,ETA3,IER)
      IF (POM.GE.ZERO) THEN
      IF (MEP4.LE.1) THEN
      CZL(K)=((CSL(K)+POM)/RPF3)**(RPF2-1.0$P 0)
      ELSE
      CZL(K)=RPF3/CSL(K)
      ENDIF
      ELSE
      IF (MEP4.LE.2) THEN
      CZL(K)=(CSL(K)/RPF3)**(RPF2-1.0$P 0)
      ELSE
      CZL(K)=RPF3/(CSL(K)-POM)
      ENDIF
      ENDIF
      ENDIF
      IF (KK.EQ.2.OR.KK.EQ.3.OR.KK.EQ.4) THEN
      POM=CF(K)-CU(K)
      CALL UNLAG6(POM,CSU(K),RPF2,RPF3,ETA3,IER)
      IF (POM.GE.ZERO) THEN
      IF (MEP4.LE.1) THEN
      CZU(K)=((CSU(K)+POM)/RPF3)**(RPF2-1.0$P 0)
      ELSE
      CZU(K)=RPF3/CSU(K)
      ENDIF
      ELSE
      IF (MEP4.LE.2) THEN
      CZU(K)=(CSU(K)/RPF3)**(RPF2-1.0$P 0)
      ELSE
      CZU(K)=RPF3/(CSU(K)-POM)
      ENDIF
      ENDIF
      ENDIF
    2 CONTINUE
      ENDIF
      RETURN
      END

