* SUBROUTINE UQADDM                ALL SYSTEMS                89/12/01
* PORTABILITY : ALL SYSTEMS
* 89/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  PERFORM DIRECTIVE 'ADD'
*
* PARAMETERS :
*  TI  BUFFER(MLENB) - WORK BUFFER
*  II  MLENB - MAX. LENGTH OF THE BUFFER
*  II  IPOS1 - POSITION OF THE FIRST CHARACTER OF LINE
*               IN THE BUFFER
*  II  IPOSD - POSITION OF THE FIRST CHARACTER OF DIRECTIVE
*               IN THE BUFFER
*  II  IPOS2 - POSITION OF THE LAST CHARACTER OF LINE
*               IN THE BUFFER
*  TU  SYMTAB(MLENST) - SYMBOL TABLE
*  II  MLENST - MAX. LENGTH OF THE SYMBOL TABLE
*  IU  IPOINT(MNP,6) - ARRAY OF POINTERS TO THE SYMBOL TABLE
*               1-LINK, 2-POSITION OF THE FIRST CHARACTER,
*               3-LENGTH OF NAME, 4-POSITION OF THE LAST CHARACTER,
*               5-POINTER OF LIST, 6-MODERW (1-RW, 2-RA, 3-RO)
*  II  MNP - MAX. NUMBER OF POINTERS
*  IU  NADD - NUMBER OF NESTED ADD-ENDADD
*  IO  NMSET1 - POSITION OF THE FIRST CHARACTER OF A MACRO NAME
*  IO  NMSET2 - POSITION OF THE LAST CHARACTER OF A MACRO NAME
*  IO  IPOSS0 - STARTING POSITION OF ADD-ENDADD
*  IO  IPOSS1 - STARTING POSITION OF TEXT OF ADD-ENDADD
*  IO  IER - ERROR INDICATOR
*
* SUBPROGRAMS USED :
*  S   UQSADR - SYNTAX ANALYSIS OF DIRECTIVE LINE
*  S   UQGVAL - GIVE VALUE OF A MACRO
*  S   UQADDV - APPEND VALUE TO A MACRO
*
      SUBROUTINE UQADDM(BUFFER,MLENB,IPOS1,IPOSD,IPOS2,SYMTAB,MLENST,
     *                  IPOINT,MNP,NADD,NMSET1,NMSET2,IPOSS0,IPOSS1,
     *                  IER)
      INTEGER MLENB,IPOS1,IPOSD,IPOS2,MLENST,MNP,IPOINT(MNP,6),NADD,
     *                  NMSET1,NMSET2,IPOSS0,IPOSS1,IER
      CHARACTER*1 BUFFER(MLENB),SYMTAB(MLENST)
      INTEGER MNPAR
      PARAMETER(MNPAR=3)
      INTEGER NPAR,IPOSP(MNPAR,2),ITYPE(MNPAR),I
      CALL UQSADR(BUFFER,MLENB,IPOSD,IPOS2,IPOSP,MNPAR,NPAR,ITYPE,IER)
      IF(IER.NE.0) RETURN
      IF(NPAR.NE.1.AND.NPAR.NE.3) GOTO 1
      IF(ITYPE(1).NE.5) GOTO 2
      IF(NPAR.EQ.1) THEN
C
C ADD(MACRO)  -  ENDADD
C
        NADD=NADD+1
        IF(NADD.EQ.1) THEN
          NMSET1=IPOSP(1,1)
          NMSET2=IPOSP(1,2)
          IPOSS0=IPOS1
          IPOSS1=IPOS2
        ENDIF
      ELSE
C
C ADD(MACRO,VALUE)
C
        IF(NADD.GT.0) RETURN
        IF(ITYPE(2).NE.4) GOTO 3
        IF(ITYPE(3).LT.5.OR.ITYPE(3).GT.9) GOTO 4
        I=1
        IF(ITYPE(3).EQ.5) THEN
          I=2
          CALL UQGVAL(BUFFER,MLENB,IPOSP(3,1),IPOSP(3,2),SYMTAB,
     *                MLENST,IPOSP(3,1),IPOSP(3,2),IPOINT,MNP,IER)
          IF(IER.NE.0) RETURN
        ENDIF
        CALL UQADDV(BUFFER,MLENB,IPOSP(1,1),IPOSP(1,2),IPOSP(3,1),
     *              IPOSP(3,2),SYMTAB,MLENST,IPOINT,MNP,I,IER)
      ENDIF
      RETURN

C
C ERROR: SYNTAX ERROR
C
    1 IER=20
      RETURN
C
C ERROR: MACRO NAME EXPECTED
C
    2 IER=23
      RETURN
C
C ERROR: ',' EXPECTED
C
    3 IER=31
      RETURN
C
C ERROR: IDENTIFIER,STRING,INTEGER CONSTANT,.TRUE. OR .FALSE. EXPECTED
C
    4 IER=30
      RETURN
      END



