* SUBROUTINE UQSUBS                ALL SYSTEMS               98/12/01
* PORTABILITY : ALL SYSTEMS
* 98/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  RECOGNIZE AND PERFORM ALL SUBSTITUTIONS IN ONE LOGICAL LINE
*  AND FIND END OF LINE
*
* PARAMETERS :
*  TU  BUFFER(MLENB) - WORK BUFFER
*  II  MLENB - MAX. LENGTH OF BUFFER
*  II  IPOS1 - POSITION OF THE FIRST CHARACTER OF A LINE IN BUFFER
*  IO  IPOS2 - POSITION OF THE LAST CHARACTER OF A LINE IN BUFFER
*  TI  SYMTAB(MLENST) - SYMBOL TABLE
*  II  MLENST - MAX. LENGTH OF SYMBOL TABLE
*  IU  IPOINT(MNP,6) - ARRAY OF POINTERS TO SYMBOL TABLE
*  II  MNP - MAX. NUMBER OF POINTERS TO SYMBOL TABLE
*  IO  IDIRN - NUMBER OF DIRECTIVE
*  IO  IPOSD - POSITION OF DIRECTIVE BODY
*  IO  IPOSM1 - POSITION OF THE FIRST CHARACTER OF MACRO NAME
*  IO  IPOSM2 - POSITION OF THE LAST CHARACTER OF MACRO NAME
*  IO  IER - ERROR INDICATOR
*
* COMMON DATA :
*  II  LABEL1 - STARTING VALUE OF LABEL
*  II  MNSUB - MAX. NUMBER OF SUBSTITUTIONS 'SUBST(FILE)'
*  II  NSUB - NUMBER OF SUBSTITUTIONS 'SUBST(FILE)'
*  II  LEVLAB(MNSUB) - LEVELS OF LABELS
*  II  MAXLAB - MAX. VALUE OF LABEL
*  II  LENST - ACTUAL LENGTH OF SYMBOL TABLE
*  II  LP - LAST POINTER TO SYMBOL TABLE
*  II  NDIR - NUMBER OF DIRECTIVES
*  II  LENDIR(NDIR) - LENGTHS OF NAMES OF DIRECTIVES
*  II  NIF1 - NUMBER OF NESTED IF-ENDIF WITH CONDIF=.TRUE.
*  II  NIF2 - NUMBER OF NESTED IF-ENDIF
*  II  LIFDON(*) - WORK ARRAY
*  IU  LENB - ACTUAL LENGTH OF BUFFER
*  LI  CONDIF - PERFORM BLOCK IF-ENDIF ?
*  LI  CONDDO - PERFORM DO-LOOP ?
*  LI  LSUBS - PERFORM SUBSTITUTIONS ?
*  TI  DIRNM(*) - DIRECTIVE NAMES
*  TI  CHDIR - THE DIRECTIVE CHARACTER
*  TI  CHEOL - THE SECOND CHARACTER OF THE END OF LINE MARKER
*  TI  CHDS  - THE SECOND CHARACTER OF THE DATA SEPARATOR MARKER
*  TI  WTRUE - STRING '.TRUE.'
*  TI  WFALSE - STRING '.FALSE.'
*
* SUBPROGRAMS USED :
*  S   UQNXTC - GIVE NEXT CHARACTER FROM BUFFER
*  S   UQNEXT - GIVE NEXT WORD FROM BUFFER
*  S   UQDELS - DELETE A SUBSTRING FROM A STRING ARRAY
*  LF  UQSTRC - COMPARISON OF TWO SUBSTRINGS
*  S   UQFCHR - FIND NEXT POSITION OF CHARACTER 'CH'
*  S   UQSASB - SYNTAX ANALYSIS OF SUBSTITUTION
*  IF  UQINTI - CONVERT A STRING TO AN INTEGER NUMBER
*  S   UQSTRI - CONVERT AN INTEGER NUMBER TO A STRING
*  S   UQINCS - INCLUDE A SUBSTRING TO A STRING ARRAY
*  S   UQUPCS - CONVERT A SUBSTRING TO UPPERCASE
*  LF  UQREAM - IS IT A REAL CONSTANT ?
*  LF  UQINTM - IS IT AN INTEGER CONSTANT ?
*  LF  UQLOGM - IS IT A LOGICAL CONSTANT ?
*  S   UQGVAL - GIVE VALUE OF A MACRO VARIABLE
*  LF  UQVDEF - IS VARIABLE DEFINED IN SYMBOL TABLE ?
*  LF  UQCSIF - CHECK IF DIRECTIVE IS SIMPLE OR BLOCK 'IF'
*
      SUBROUTINE UQSUBS(BUFFER,MLENB,IPOS1,IPOS2,SYMTAB,MLENST,
     *                  IPOINT,MNP,IDIRN,IPOSD,IPOSM1,IPOSM2,IER)
      INTEGER MLENB,IPOS1,IPOS2,MLENST,MNP,IPOINT(MNP,6),
     *        IDIRN,IPOSD,IPOSM1,IPOSM2,IER
      CHARACTER*1 BUFFER(MLENB),SYMTAB(MLENST)
C ----------------------------------------------------------------------
      INTEGER        LENB,LENST,LP,ILNLEN,OLNLEN,MODERW,DIALOG,IUNIT,
     *        OUNIT,INUNIT,IIUNIT,OIUNIT,NOPT,LENOPT(30),NSUB,MNSUB,
     *        NDIR,LENDIR(30),NMSG,MNIF,NIF1,NIF2,TABCH(0:255),ADF,
     *        ADA,ADC,ARD,CRD
      COMMON/UQINT2/ LENB,LENST,LP,ILNLEN,OLNLEN,MODERW,DIALOG,IUNIT,
     *        OUNIT,INUNIT,IIUNIT,OIUNIT,NOPT,LENOPT,NSUB,MNSUB,
     *        NDIR,LENDIR,NMSG,MNIF,NIF1,NIF2,TABCH,ADF,ADA,ADC,ARD,CRD
      INTEGER*4      LABEL1,LABEL2,MAXLAB,LEVLAB(20)
      COMMON/UQINT4/ LABEL1,LABEL2,MAXLAB,LEVLAB
      CHARACTER*1    CHCON,CHEOL,CHDS,CHDIR,WTRUE(6),WFALSE(7),
     *        ASCII(32:127),OPTNM(200),DIRNM(200)
      COMMON/UQCHR1/ CHCON,CHEOL,CHDS,CHDIR,WTRUE,WFALSE,
     *        ASCII,OPTNM,DIRNM
      CHARACTER*50   FN1,FN2,FNAMES(20),NAME,MSG(50)*70
      COMMON/UQCHRX/ FN1,FN2,FNAMES,NAME,MSG
      LOGICAL        LFORTO,LSMLET,LFRFMT,LSUBS,LOUT,LHELP,LIFDON(20),
     *        LELSE(20),CONDIF,CONDDO,LOOP,SIFDEC,DIALGR,LPERFD
      COMMON/UQLOGL/ LFORTO,LSMLET,LFRFMT,LSUBS,LOUT,LHELP,LIFDON,
     *        LELSE,CONDIF,CONDDO,LOOP,SIFDEC,DIALGR,LPERFD
C ----------------------------------------------------------------------
      LOGICAL UQVDEF,UQSTRC,UQLOGM,UQINTM,UQREAM,UQCSIF
      INTEGER*4 UQINTI,I4
      INTEGER I,J,K,L,IPOS,IPOSH2,IPOSH3,IPOSH4,ITYP,LEN,IP,IPPRED
      LOGICAL LHLP,LSIGN,LNUM,FIRST
      CHARACTER*1 WDATA(4),WREAL(4),WLOG(3),WINT(3),WDEF(3)
      SAVE WDATA,WREAL,WLOG,WINT,WDEF
      DATA WDATA /'D','A','T','A'/, WREAL /'R','E','A','L'/,
     *     WLOG /'L','O','G'/,      WINT /'I','N','T'/,
     *     WDEF/'D','E','F'/
      IDIRN=0
C
C FIND FIRST CHARACTER
C
      CALL UQNXTC(BUFFER,MLENB,LENB,IPOS1,IPOS)
      FIRST=.TRUE.
C
C IS IT A DIRECTIVE ?
C
    1 IF(BUFFER(IPOS).EQ.CHDIR) THEN
        CALL UQNEXT(BUFFER,MLENB,IPOS+1,IPOSH2,IPOSH3,I,ITYP,IER)
        IF(IER.NE.0) RETURN
        IF(ITYP.NE.5) GOTO 5
        CALL UQUPCS(BUFFER,MLENB,IPOSH2,IPOSH3)
        K=0
        LEN=IPOSH3-IPOSH2+1
        DO 3 IDIRN=1,NDIR
          IF(LENDIR(IDIRN).EQ.LEN) THEN
            DO 2 I=1,LEN
              IF(DIRNM(K+I).NE.BUFFER(IPOSH2+I-1)) THEN
                K=K+LEN
                GOTO 3
              ENDIF
    2       CONTINUE
            IF(IDIRN.EQ.1) THEN
C
C REM: FIND EOL AND RETURN
C
              IPOS2=IPOSH3+1
              CALL UQFCHR(BUFFER,MLENB,LENB,IPOS2,CHEOL)
              RETURN
            ENDIF
            IPOSD=IPOSH3+1
            IPOS=IPOSD
            GOTO 4
          ELSE
            K=K+LENDIR(IDIRN)
          ENDIF
    3   CONTINUE
        IDIRN=0
C
C IS IT 'MACRO=VALUE' ?
C
        CALL UQNXTC(BUFFER,MLENB,LENB,IPOSH3+1,I)
        IF(BUFFER(I).EQ.'=') THEN
          IDIRN=112
          IPOSM1=IPOSH2
          IPOSM2=IPOSH3
          IPOSD=I+1
          IPOS=IPOSD
          GOTO 4
        ENDIF
        GOTO 5
      ENDIF
C
C NEXT CHDIR
C
    4 IF(BUFFER(IPOS).NE.CHDIR) THEN
        IF(BUFFER(IPOS).EQ.CHEOL) THEN
C
C EOL FOUND
C
          IPOS2=IPOS
          RETURN
        ELSEIF(BUFFER(IPOS).EQ.'@'.AND.BUFFER(IPOS+1).NE.'''') THEN
          CALL UQDELS(BUFFER,MLENB,LENB,IPOS,IPOS+1)
          GOTO 4
        ENDIF
        IPOS=IPOS+1
        GOTO 4
      ENDIF
      FIRST=.FALSE.
C
C CONTINUE IN SUBSTITUTION ?
C
    5 IF(.NOT.LSUBS.OR..NOT.CONDDO) THEN
        IPOS2=IPOS
        CALL UQFCHR(BUFFER,MLENB,LENB,IPOS2,CHEOL)
        RETURN
      ENDIF
      IF (CONDIF) GO TO 6
      IF (IDIRN.EQ.16) GO TO 6
      IF (IDIRN.EQ.17.AND.NIF1.EQ.NIF2.AND.NIF1.NE.0) THEN
        IF(.NOT.LIFDON(NIF1)) GO TO 6
      ENDIF
      IPOS2=IPOS
      CALL UQFCHR(BUFFER,MLENB,LENB,IPOS2,CHEOL)
      RETURN
C
C NAME OF SUBSTITUTION ?
C
    6 IF(.NOT.FIRST) THEN
        CALL UQNEXT(BUFFER,MLENB,IPOS+1,IPOSH2,IPOSH3,I,ITYP,IER)
        IF(IER.NE.0) RETURN
      ENDIF
      IF(ITYP.EQ.5) THEN
        CALL UQUPCS(BUFFER,MLENB,IPOSH2,IPOSH3)
        CALL UQNXTC(BUFFER,MLENB,LENB,IPOSH3+1,IPOSH4)
        IF(BUFFER(IPOSH4).EQ.'(') THEN
C
C SUBSTITUTION '$$DATA(NAME)'
C
          IF(UQSTRC(BUFFER,MLENB,IPOSH2,IPOSH3,WDATA,4,1,4)) THEN
            CALL UQSASB(BUFFER,MLENB,IPOSH4+1,IPOSH2,IPOSH3,IPOSH4,IER)
            IF(IER.NE.0) RETURN
            IF(UQVDEF(BUFFER,MLENB,IPOSH2,IPOSH3,SYMTAB,MLENST,
     *         IPOINT,MNP,LP,IP,IPPRED)) THEN
              J=IPOINT(IP,2)+IPOINT(IP,3)
              L=IPOINT(IP,4)
              IPOSH2=J
              K=0
   10         IF(J.GE.L) THEN
                IPOSH3=L
                GOTO 11
              ENDIF
              IF(SYMTAB(J).EQ.CHDS) THEN
                K=K+1
                IF(K.EQ.IPOINT(IP,5)) THEN
                  IPOSH3=J-1
                  GOTO 11
                ELSE
                  IPOSH2=J+1
                  IF(IPOSH2.GT.L) GOTO 101
                ENDIF
              ENDIF
              J=J+1
              GOTO 10
   11         IF(.NOT.LOOP) THEN
                IF(J.GE.L) THEN
                  IPOINT(IP,5)=1
                ELSE
                  IPOINT(IP,5)=IPOINT(IP,5)+1
                ENDIF
              ENDIF
              GOTO 12
            ENDIF
            GOTO 102
C
C SUBSTITUTION '$$DEF(NAME)':
C
          ELSEIF(UQSTRC(BUFFER,MLENB,IPOSH2,IPOSH3,WDEF,3,1,3)) THEN
            CALL UQSASB(BUFFER,MLENB,IPOSH4+1,IPOSH2,IPOSH3,IPOSH4,IER)
            IF(IER.NE.0) RETURN
            LHLP=UQVDEF(BUFFER,MLENB,IPOSH2,IPOSH3,SYMTAB,MLENST,
     *                  IPOINT,MNP,LP,IP,IPPRED)
            GOTO 13
C
C SUBSTITUTION '$$REAL(NAME)':
C
          ELSEIF(UQSTRC(BUFFER,MLENB,IPOSH2,IPOSH3,WREAL,4,1,4)) THEN
            CALL UQSASB(BUFFER,MLENB,IPOSH4+1,IPOSH2,IPOSH3,IPOSH4,IER)
            IF(IER.NE.0) RETURN
            CALL UQGVAL(BUFFER,MLENB,IPOSH2,IPOSH3,SYMTAB,MLENST,
     *                  IPOSH2,IPOSH3,IPOINT,MNP,IER)
            IF(IER.NE.0) RETURN
            LHLP=UQREAM(SYMTAB,MLENST,IPOSH2,IPOSH3)
            GOTO 13
C
C SUBSTITUTION '$$INT(NAME)':
C
          ELSEIF(UQSTRC(BUFFER,MLENB,IPOSH2,IPOSH3,WINT,3,1,3)) THEN
            CALL UQSASB(BUFFER,MLENB,IPOSH4+1,IPOSH2,IPOSH3,IPOSH4,IER)
            IF(IER.NE.0) RETURN
            CALL UQGVAL(BUFFER,MLENB,IPOSH2,IPOSH3,SYMTAB,MLENST,
     *                  IPOSH2,IPOSH3,IPOINT,MNP,IER)
            IF(IER.NE.0) RETURN
            LHLP=UQINTM(SYMTAB,MLENST,IPOSH2,IPOSH3,LSIGN,LNUM)
            GOTO 13
C
C SUBSTITUTION '$$LOG(NAME)':
C
          ELSEIF(UQSTRC(BUFFER,MLENB,IPOSH2,IPOSH3,WLOG,3,1,3)) THEN
            CALL UQSASB(BUFFER,MLENB,IPOSH4+1,IPOSH2,IPOSH3,IPOSH4,IER)
            IF(IER.NE.0) RETURN
            CALL UQGVAL(BUFFER,MLENB,IPOSH2,IPOSH3,SYMTAB,MLENST,
     *                  IPOSH2,IPOSH3,IPOINT,MNP,IER)
            IF(IER.NE.0) RETURN
            LHLP=UQLOGM(SYMTAB,MLENST,IPOSH2,IPOSH3)
            GOTO 13
          ENDIF
        ENDIF
C
C SIMPLE OR BLOCK 'IF' ?
C
        IF(IDIRN.EQ.16) THEN
          IF(BUFFER(IPOSH4).EQ.'('.OR.BUFFER(IPOSH4).EQ.'='.OR.
     *       BUFFER(IPOSH4).EQ.CHEOL) THEN
            IF(UQCSIF(BUFFER,MLENB,IPOSD,IPOS-1)) THEN
              IDIRN=116
              IPOS2=IPOSH4+1
              CALL UQFCHR(BUFFER,MLENB,LENB,IPOS2,CHEOL)
              RETURN
            ENDIF
          ENDIF
        ENDIF
C
C SUBSTITUTION '$$NAME':
C
        IPOSH4=IPOSH3
        CALL UQGVAL(BUFFER,MLENB,IPOSH2,IPOSH3,SYMTAB,MLENST,
     *              IPOSH2,IPOSH3,IPOINT,MNP,IER)
        IF(IER.NE.0) RETURN
        GOTO 12
C
C SUBSTITUTION '$$(NAME)':
C
      ELSEIF(ITYP.EQ.1) THEN
        CALL UQSASB(BUFFER,MLENB,IPOSH3+1,IPOSH2,IPOSH3,IPOSH4,IER)
        IF(IER.NE.0) RETURN
        CALL UQGVAL(BUFFER,MLENB,IPOSH2,IPOSH3,SYMTAB,MLENST,
     *              IPOSH2,IPOSH3,IPOINT,MNP,IER)
        IF(IER.NE.0) RETURN
        GOTO 12
C
C SUBSTITUTION '$$123' (LABEL):
C
      ELSEIF(ITYP.EQ.7) THEN
        I4=UQINTI(BUFFER,MLENB,IPOSH2,IPOSH3,IER)
        IF(IER.NE.0) RETURN
        IF(NSUB.GT.0) THEN
          I4=I4+LEVLAB(NSUB)
        ELSE
          I4=I4+LABEL1
        ENDIF
        IF(I4.GT.MAXLAB) GOTO 103
        CALL UQDELS(BUFFER,MLENB,LENB,IPOS,IPOSH3)
        CALL UQSTRI(I4,BUFFER,MLENB,LENB,IPOS,IER)
        IF(IER.NE.0) RETURN
        GOTO 4
C
C SUBSTITUTION '$$$$':
C
      ELSEIF(BUFFER(IPOSH2).EQ.CHDIR) THEN
        CALL UQDELS(BUFFER,MLENB,LENB,IPOSH2,IPOSH2)
        IPOS=IPOSH2
        GOTO 4
      ENDIF
      GOTO 104
C
C PERFORM A SUBSTITUTION:
C
   12 CALL UQDELS(BUFFER,MLENB,LENB,IPOS,IPOSH4)
      CALL UQINCS(BUFFER,MLENB,LENB,IPOS,SYMTAB,MLENST,
     *            IPOSH2,IPOSH3,IER)
      IF(IER.NE.0) RETURN
      IF(FIRST) THEN
        IPOSH2=IPOS
        CALL UQNXTC(BUFFER,MLENB,LENB,IPOSH2,IPOS)
        GOTO 1
      ELSE
        GOTO 4
      ENDIF
   13 IF(LHLP) THEN
        CALL UQDELS(BUFFER,MLENB,LENB,IPOS,IPOSH4)
        CALL UQINCS(BUFFER,MLENB,LENB,IPOS,WTRUE,6,1,6,IER)
      ELSE
        CALL UQDELS(BUFFER,MLENB,LENB,IPOS,IPOSH4)
        CALL UQINCS(BUFFER,MLENB,LENB,IPOS,WFALSE,7,1,7,IER)
      ENDIF
      IF(IER.NE.0) RETURN
      GOTO 4
C
C ERROR: UNEXPECTED CHDS
C
  101 IER=15
      RETURN
C
C ERROR: VARIABLE NOT DEFINED
C
  102 IER=9
      NAME='                                                  '
      DO 105 I=0,IPOSH3-IPOSH2
      NAME(I+1:I+1)=BUFFER(IPOSH2+I)
  105 CONTINUE
      RETURN
C
C ERROR: MAX. VALUE OF LABEL EXCEEDED
C
  103 IER=16
      RETURN
C
C ERROR: UNEXPECTED CHDIR
C
  104 IER=17
      RETURN
      END
