$INTERFACE UUBBM1                                             99/12/01
$REM LU

  $CON0='0.1$P 0'
  $CON2='4.0$P 0'
  $CON3='0.2$P 0'
  $CON6='0.5$P 0'
  $CON7='3.0$P 0'
  $HELP
    UPDATE OF THE HESSIAN MATRIX:
      1 - BFGS UPDATE
      2 - DFP  UPDATE
      3 - HOSHINO UPDATE
      4 - RANK ONE UPDATE
  $CHECK(MET,1,'1\2\3\4',3)
  $HELP
    SELECTION OF SELF SCALING:
      1 - SELF SCALING SUPPRESSED
      2 - INITIAL SELF SCALING
      3 - CONTROLLED SELF SCALING
      4 - INTERVAL SELF SCALING
      5 - SELF SCALING IN EACH ITERATION
  $CHECK(MET1,1,'1\2\3\4\5',4)
  $HELP
    METHOD CORRECTION:
      1 - NO CORRECTION
      2 - CORRECTION BY RANK ONE METHOD
      3 - CORRECTION BY RANK ONE METHOD
  $CHECK(MET3,3,'1\2\3',4)
  $ADD(REAL,'\$AH($MAH)\$S($NF)\$XO($NF)\$AGO($MA)')
  $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)')
$REM  $ADD(INTEGER,'\NF\NA\NAL\MA\MAH')
  $IF(MET3=2)
  $ADD(INTEGER,'\$IA($NA)')
  $POM1='NF,NA,NAL,MA,MAH,$AH,$IAG,$JAG,$S,$XO,$AGO,$IA'
  $POM2='NF,NA,NAL,MA,MB,AH,IAG,JAG,S,XO,AGO,IA'
  $ELSE
  $POM1='NF,NA,NAL,MA,MAH,$AH,$IAG,$JAG,$S,$XO,$AGO'
  $POM2='NF,NA,NAL,MA,MB,AH,IAG,JAG,S,XO,AGO'
  $ENDIF
  $IF(MET1=3)
    $ADD(POM1,',PAR1,PAR2')
    $ADD(POM2,',PAR1,PAR2')
$REM    $ADD(REAL,'\PAR1\PAR2')
  $ENDIF
  $ADD(POM1,',$ETA0,$ETA9')
  $ADD(POM2,',ETA0,ETA9')
$REM  $IF(MET3=2)
$REM    $ADD(SINID)
$REM      CALL UXVINP(NA,IA)
$REM    $ENDADD
$REM  $ELSEIF(MET3=3)
  $IF(MET3=3)
    $ADD(SINID)
      ICOR=0
    $ENDADD
    $ADD(POM1,',ICOR')
    $ADD(POM2,',ICOR')
    $ADD(INTEGER,'\ICOR')
  $ENDIF
  $ADD(POM1,',$MET')
  $ADD(POM2,',MET')
  $NUMSUB=''
  $IF(NMET>1) $NUMSUB='_$NMET'
  CALL UUBBM1$(NUMSUB)($POM1)
  $ADD(SUBROUTINES)
*     -----------------------------------
*     PARTITIONED VARIABLE METRIC UPDATES
*     TEMPLATE : UUBBM1
*     -----------------------------------
  SUBROUTINE UUBBM1$(NUMSUB)($POM2)
  $INCLUDE('UMCOMM')
  INTEGER NF,NA,NAL,MA,MB,IAG(NA+1),JAG(MA),MET
  $$FLOAT AH(MB),S(NF),XO(NF),AGO(MA)
  $$IF($MET>1)
    $$FLOAT DEN
  $$ELSEIF($MET3>1)
    $$FLOAT DEN
  $$ENDIF
  $$IF($MET=2)
    $$FLOAT DIS
  $$ELSEIF($MET=3)
    $$FLOAT DIS
  $$ENDIF
  $$IF(MET3=2)
    INTEGER IA(NA)
  $$ENDIF
  $$IF($MET1=3) $$FLOAT PAR1,PAR2
  $$FLOAT ETA0,ETA9
  $$FLOAT UXWDOT
  $$FLOAT A,B,C,GAM,POM
  INTEGER K,L,KA,NB
  $$IF($MET3=3)
    INTEGER INEG,ICOR
  $$ENDIF
  LOGICAL L1,L3
  $$IF($MET1=3)
    LOGICAL L2
  $$ENDIF
  IF (MET.LE.0) GO TO 22
  IF(IDECF.NE.0) THEN
  ITERH=-1
  TUXX='BAD DEC0'
  CALL UOERR1('UUBBM1',1)
  GO TO 22
  ENDIF
  L1=$MET1.GE.3.OR.$MET1.EQ.2.AND.NIT.EQ.KIT
  L3=.NOT.L1
  TUXX='        '
  NB=0
  $$IF($MET3=3)
    INEG=0
  $$ENDIF
  DO 21 KA=1,NA
  K=IAG(KA)
  L=IAG(KA+1)-K
  IF (KA.LE.NAL) GO TO 20
*
*     DETERMINATION OF THE PARAMETERS B, C
*
  B=UXWDOT(L,NF,JAG(K),AGO(K),XO,2)
  $$IF($MET3=1)
    IF (B.LE.ONE/ETA9) GO TO 20
  $$ELSE
    IF (ABS(B).LE.ONE/ETA9) GO TO 20
  $$ENDIF
  A=ZERO
  CALL UXBSBM(L,NF,AH(NB+1),JAG(K),XO,S,1)
  C=UXWDOT(L,NF,JAG(K),XO,S,1)
  IF (ABS(C).LE.ONE/ETA9) GO TO 20
  IF (L1) THEN
*
*     DETERMINATION OF THE PARAMETER GAM (SELF SCALING)
*
  GAM=C/B
  $$IF($MET1=3)
    IF (NIT.NE.KIT) THEN
    L2=PAR2.LE.ZERO
    L3=L2.AND.ABS(PAR1).LE.$CON3
    L3=L3.OR.(.NOT.L2.AND.GAM.GT.ONE)
    L3=L3.OR.(L2.AND.PAR1.LT.ZERO.AND.GAM.GT.ONE)
    L3=L3.OR.(L2.AND.PAR1.GT.ZERO.AND.GAM.LT.ONE)
    L3=L3.OR.GAM.LT.$CON6
    L3=L3.OR.GAM.GT.$CON7
    ENDIF
  $$ELSEIF($MET1=4)
    IF (NIT.NE.KIT) THEN
    L3=GAM.LT.$CON6.OR.GAM.GT.$CON2
    ENDIF
  $$ENDIF
  IF (L3) THEN
  GAM=ONE
  ENDIF
  ELSE
  GAM=ONE
  ENDIF
  $$IF($MET3=2)
    IF (B.LT.ZERO) IA(KA)=-ABS(IA(KA))
    IF (IA(KA).LT.0) THEN
*
*    RANK ONE UPDATE
*
    DEN=GAM*B-C
    IF (ABS(DEN).GT.ETA0*ABS(C)) THEN
    POM=GAM*B/DEN
    CALL UXWDIR(L,NF,JAG(K),-GAM,AGO(K),S,AGO(K),2)
    CALL UXBSBU(L,NF,AH(NB+1),JAG(K), ONE/DEN,AGO(K),2)
    IF (TUXX.EQ.'        ') TUXX='RANK ONE'
    GO TO 19
    ELSE
    GO TO 20
    ENDIF
    ELSE
  $$ELSEIF($MET3=3)
    IF (B.LT.ZERO) INEG=INEG+1
    IF (ICOR.GT.0) THEN
*
*    RANK ONE UPDATE
*
    DEN=GAM*B-C
    IF (ABS(DEN).GT.ETA0*ABS(C)) THEN
    POM=GAM*B/DEN
    CALL UXWDIR(L,NF,JAG(K),-GAM,AGO(K),S,AGO(K),2)
    CALL UXBSBU(L,NF,AH(NB+1),JAG(K), ONE/DEN,AGO(K),2)
    IF (TUXX.EQ.'        ') TUXX='RANK ONE'
    GO TO 19
    ELSE
    GO TO 20
    ENDIF
    ELSE IF (B.LT.ZERO) THEN
    GO TO 20
    ELSE
  $$ENDIF
  $$IF($MET=1)
*
*     BFGS UPDATE
*
    POM=ZERO
    CALL UXBSBU(L,NF,AH(NB+1),JAG(K),GAM/B,AGO(K),2)
    CALL UXBSBU(L,NF,AH(NB+1),JAG(K),-ONE/C,S,1)
    IF (TUXX.EQ.'        ') TUXX='BFGS    '
    NUPD=NUPD+1
  $$ELSEIF($MET=2)
*
*     DFP UPDATE
*
    DEN=GAM*B+C
    DIS=GAM+C/B
    POM=ONE
    CALL UXWDIR(L,NF,JAG(K),-DIS,AGO(K),S,AGO(K),2)
    CALL UXBSBU(L,NF,AH(NB+1),JAG(K),ONE/DEN,AGO(K),2)
    CALL UXBSBU(L,NF,AH(NB+1),JAG(K),-ONE/DEN,S,1)
    IF (TUXX.EQ.'        ') TUXX='DFP     '
    NUPD=NUPD+1
  $$ELSEIF($MET=3)
*
*     HOSHINO UPDATE
*
    DEN=GAM*B+C
    DIS=HALF*B
    POM=GAM*B/DEN
    CALL UXBSBU(L,NF,AH(NB+1),JAG(K),GAM/DIS,AGO(K),2)
    CALL UXWDIR(L,NF,JAG(K),GAM,AGO(K),S,AGO(K),2)
    CALL UXBSBU(L,NF,AH(NB+1),JAG(K),-ONE/DEN,AGO(K),2)
    IF (TUXX.EQ.'        ') TUXX='HOSHINO '
    NUPD=NUPD+1
  $$ELSEIF($MET=4)
*
*    RANK ONE UPDATE
*
    DEN=GAM*B-C
    $$IF($MET3=1)
      IF (DEN.GT.ETA0*C) THEN
    $$ELSE
      IF (ABS(DEN).GT.ETA0*ABS(C)) THEN
    $$ENDIF
    POM=GAM*B/DEN
    CALL UXWDIR(L,NF,JAG(K),-GAM,AGO(K),S,AGO(K),2)
    CALL UXBSBU(L,NF,AH(NB+1),JAG(K), ONE/DEN,AGO(K),2)
    IF (TUXX.EQ.'        ') TUXX='RANK ONE'
    NUPD=NUPD+1
    ELSE
*
*     BFGS UPDATE
*
    POM=ZERO
    CALL UXBSBU(L,NF,AH(NB+1),JAG(K),GAM/B,AGO(K),2)
    CALL UXBSBU(L,NF,AH(NB+1),JAG(K),-ONE/C,S,1)
    IF (TUXX.EQ.'        ') TUXX='BFGS    '
    ENDIF
  $$ENDIF
  $$IF($MET3=2)
    ENDIF
  $$ELSEIF($MET3=3)
    ENDIF
  $$ENDIF
19 CONTINUE
  ITERH=0
  IF (GAM.NE.ONE) THEN
    CALL UXDSMS(L,AH(NB+1),ONE/GAM)
    NSCL=NSCL+1
  ENDIF
20 CONTINUE
  NB=NB+L*(L+1)/2
21 CONTINUE
  IF (TUXX.EQ.'        ') TUXX='NONE UP.'
  $$IF($MET3=3)
    IF (INEG.GE.NA/2) ICOR=1
  $$ENDIF
22 CONTINUE
  RETURN
  END
  $ENDADD
  $ADD(INIT)
    NUXX='UUBBM1'
  $ENDADD
  $EXIT

