$INTERFACE UUBSD4                                             97/12/01

  $HELP
    MAXIMUM SIZE OF THE PARTITIONED HESSIAN MATRIX
  $CHECK(MAH,'25*$NA',INT,1)
  $ADD(REAL,'\$AH($MAH)\$AB($MAH)')
  $ADD(INTEGER,'\$IAG($NA+1)')
$REM  $ADD(INTEGER,'\NA\NB\IPOM1\IPOM2')
  CALL UUBSD4(NA,NB,$AH,$AB,$IAG,IPOM1,IPOM2)
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UUBSD4                ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* MODIFICATION OF A PARTITIONED SYMMETRIC POSITIVE DEFINITE MATRIX.
*
* PARAMETERS :
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  MB  NUMBER OF NONZERO ELEMENTS OF THE PARTITIONED HESSIAN MATRIX.
*  RI  AH(MB)  NUMERICAL VALUES OF ELEMENTS OF THE PARTITIONED HESSIAN
*         MATRIX.
*  RO  AB(MB)  NUMERICAL VALUES OF ELEMENTS OF THE PARTITIONED HESSIAN
*         MATRIX.
*  II  IAG(NA+1)  POINTERS OF THE JACOBIAN MATRIX.
*         MATRIX.
*  II  IPOM1  METHOD INDICATOR.
*  IO  IPOM2  INDICATOR FOR SCALING.
*
* COMMON DATA :
*  II  ITERS  TERMINATION INDICATOR. ITERS=0-ZERO STEP.
*  II  LCS  INDICATION OF LOCALLY CONSTRAINED STEP. LCS=0 IF LOCALLY
*         CONSTRAINED STEP (TRUST REGION) WAS NOT USED.
*
* SUBPROGRAMS USED :
*  S   UXDSMC  COPYING OF A DENSE SYMMETRIC MATRIX.
*  S   UXDSDA  DIAGONAL MODIFICATION OF A DENSE SYMMETRIC MATRIX.
*
      SUBROUTINE UUBSD4(NA,MB,AH,AB,IAG,IPOM1,IPOM2)
      $INCLUDE('UMCOMM')
      INTEGER NA,MB,IAG(NA+1),IPOM1,IPOM2
      $FLOAT AH(MB),AB(MB)
      INTEGER K,L,KA,NB
      $FLOAT CON
      PARAMETER (CON=0.02$P 0)
      IF (IPOM1.EQ.0) THEN
      IF (ITERS.GT.0) THEN
      NB=0
      DO 2 KA=1,NA
      K=IAG(KA)
      L=IAG(KA+1)-K
      CALL UXDSMC(L,AH(NB+1),AB(NB+1))
      IF (LCS.EQ.0) CALL UXDSDA(L,AB(NB+1),CON)
      NB=NB+L*(L+1)/2
    2 CONTINUE
      ENDIF
      IPOM2=2
      ENDIF
      RETURN
      END
