$INTERFACE UUCSD1                                             97/12/01

  $HELP
    CHOICE OF THE INITIAL APPROXIMATION OF THE SPARSE
    HESSIAN  MATRIX:
      1 - UNIT INITIAL APPROXIMATION
      2 - RANDOM INITIAL APPROXIMATION
      3 - NUMERICAL INITIAL APPROXIMATION
  $CHECK(INITH,1,'1\2\3',4)
  $IF(INITH>2)
    IF (IREST.LE.0) GO TO $20
    CALL UYPRO1('UUXX',2)
    ASSIGN $10 TO IMD
    $GO TO $LMD
$10 CONTINUE
    TUXX='NEWTON  '
    IDECF=0
    CALL UYEPI1(2)
$20 CONTINUE
  $ELSE
    $N='NF'
    $ADD(REAL,'\$CH($MCH)')
    $ADD(INTEGER,'\$ICG($NC+1)')
$REM    $ADD(INTEGER,'\$N\NC\MCH')
    CALL UUCSD1($N,NC,MCH,$CH,$ICG,$INITH)
  $ENDIF
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UUCSD1                ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* INITIATION OF A SPARSE SYMMETRIC POSITIVE DEFINITE MATRIX
*
* PARAMETERS :
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  II  NC  NUMBER OF CONSTRAINTS.
*  II  MB  NUMBER OF NONZERO ELEMENTS OF THE PARTITIONED HESSIAN MATRIX
*         (PART OF THE MATRIX H).
*  RO  CH(MB)  NUMERICAL VALUES OF THE PARTITIONED MATRIX H.
*  II  ICG(NC+1)  POINTERS OF THE CONSTRAINT JACOBIAN MATRIX.
*  II  INITH  CHOICE OF THE INITIAL APPROXIMATION OF THE HESSIAN
*         MATRIX. INITH=1-UNIT INITIAL APPROXIMATION.
*         INITH=2-RANDOM INITIAL APPROXIMATION.
*
* COMMON DATA :
*  II  IREST  RESTART SPECIFICATION. IF IREST=0 DOES NOT HOLD THEN A
*         RESTART IS PERFORMED.
*  IU  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*  TO  TUXX   TEXT INFORMATION ON THE RESTART USED.
*
* SUBPROGRAMS USED :
*  S   UXBSMI  GENERATION OF THE UNIT MATRIX.
*  S   UXSSDO  INITIATION OF A DIAGONAL MATRIX.
*  RF  UNRAN1  RANDOM NUMBER GENERATOR.
*
      SUBROUTINE UUCSD1(N,NC,MB,CH,ICG,INITH)
      $INCLUDE('UMCOMM')
      INTEGER N,NC,MB,ICG(NC+1),INITH
      $FLOAT CH(MB)
      INTEGER K
      $FLOAT POM,UNRAN1
      $FLOAT CON
      PARAMETER (CON=1.0$P 1)
      ISB=0
      IF(IREST.LE.0) RETURN
      IF(INITH.LE.0) RETURN
      GOTO (1,2) INITH
    1 CALL UXBSMI(MB,NC,CH,ICG)
      TUXX='UNIT    '
      LD=MIN(LD,1)
      GOTO 6
    2 POM=(CON-ONE)/(CON+ONE)
      POM=POM/$DBLE(N+1)
      DO 7 K=1,MB
      CH(K)=POM*(TWO*UNRAN1(RAN)-ONE)
    7 CONTINUE
      CALL UXBSDO(MB,NC,ONE,CH,ICG)
      TUXX='RANDOM  '
      LD=MIN(LD,1)
    6 IDECF=0
      RETURN
      END
