$INTERFACE UUDBA2                                             16/12/01
$REM LU

  $POMD='D'
  $POMH=H
  $POMN='N'
  $HELP
    UPDATE OF THE JACOBIAN MATRIX:
      1 - BASIC RESIDUAL ADJOINT UPDATE
      2 - NEW BROYDEN'S UPDATE
      3 - SECANT RESIDUAL ADJOINT UPDATE
      4 - TWO-SIDED RESIDUAL ADJOINT UPDATE
  $CHECK(MET,2,'1\2\3\4',3)
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,'ETA0*1.0D-3',REAL,4)
  $N='N'
  $ADD(REAL,'\$AG($NF*$NA)\$AF($NA)\$S($NF)\$XO($NF)\$GG($NF)')
  $IF(DEC='A')
    $POM1='$N,NA'
    $POM2='N,NA'
  $ELSEIF(DEC='E')
    $IF(NUMBER<3)
      $POM1='$N,NA,ETA2,IAG'
      $POM2='N,NA,ETA2,IA'
      $ADD(INTEGER,'\$IAG($NF)')
      $HELP
        RANK ONE UPDATE OF THE LU DECOMPOSITION:
          1 - BENNETT'S METHOD WITHOUT PERMUTATIONS 
          2 - SCHWETLICK'S METHOD WITH PERMUTATIONS
          3 - COMBINATION OF THE PREVIOUS METHODS
      $CHECK(MOS3,1,'1\2\3',3)
      $IF(LAPACK='NO')
        $ADD(POM1,',$GO')
        $ADD(POM2,',GO')
        $HELP
          STORING PERMUTATIONS IN THE LU DECOMPOSITION:
            1 - CHANGES OF MATRIX ROWS 
            2 - TWO LEVEL INDICES
        $CHECK(MOS2,1,'1\2',3)
      $ELSEIF(MOS3>1)
        $ADD(POM1,',$GO')
        $ADD(POM2,',GO')
        $MOS2=1
      $ELSE
        $MOS2=1  
      $ENDIF  
      $IF(MOS2=1)
        $IF(MOS3>1)
          $IBG='IBG'
          $ADD(POM1,',$IBG')
          $ADD(POM2,',IB')
          $ADD(INTEGER,'\$IBG($NF)')
        $ENDIF
      $ENDIF
    $ELSE
      $POM1='$N,NA'
      $POM2='N,NA'
    $ENDIF  
  $ELSEIF(DEC='Q')
    $IF(MOS2=1)
      $POMD='E'
    $ELSE
      $POMD='D'
    $ENDIF  
    $IF(MOS3=1)
      $POM1='$N,NA,$H,$AFD,$XS,ETA2'
      $POM2='N,NA,H,AFD,XS,ETA2'
      $ADD(REAL,'\$H($NA*$NF)\$AFD($NA)\$XS($NF)')
    $ELSE
      $POM1='$N,NA,$H,ETA2'
      $POM2='N,NA,H,ETA2'
      $ADD(REAL,'\$H($NF*($NF+1)/2)')
    $ENDIF
  $ENDIF
  $IF(MET<4)
  $ADD(REAL,'\$AFO($NF)')
  $ADD(POM1,',$AG,$AF,$S,$XO,$AFO,$GG,$MET')
  $ADD(POM2,',AG,AF,S,XO,AFO,G,MET')
  $ELSE
  $ADD(REAL,'\$AFO($NF)')
  $ADD(POM1,',$AG,$AF,$S,$XO,$GP,$GG,$MET')
  $ADD(POM2,',AG,AF,S,XO,AFO,G,MET')
  $ENDIF
  $NUMSUB=''
  $IF(NMET>1) $NUMSUB='_$NMET'
  CALL UUDB$(DEC)2$(NUMSUB)($POM1)
  $ADD(SUBROUTINES)
*     ----------------------------
*     ADJOINT QUASI-NEWTON UPDATES
*     TEMPLATE : UUDBA2
*     ----------------------------
  SUBROUTINE UUDB$(DEC)2$(NUMSUB)($POM2)
  $$INCLUDE('UMCOMM')
  INTEGER N,NA,MET
  $$FLOAT AG(N*NA),AF(NA),S(N),XO(N),AFO(NA),G(N)
  $$FLOAT DEN,UXVDOT
  $$IF(DEC='E')
    $$IF(NUMBER<3)
      INTEGER IA(N),JOB,INF
      $$FLOAT ETA2
      $$IF(LAPACK='NO')
        $$FLOAT GO(N)
      $$ELSEIF(MOS3>1)  
        $$FLOAT GO(N)
      $$ENDIF  
      $$IF(MOS2=1)
        $$IF(MOS3>1)
          INTEGER IB(N)
        $$ENDIF
      $$ENDIF
    $$ENDIF  
  $$ELSEIF(DEC='Q')
    INTEGER INF
    $$IF(MOS2=1)
      $$FLOAT H(NA,N),AFD(NA),XS(N),ETA2
    $$ELSEIF(MOS3=1)
      $$FLOAT H(NA*N),AFD(NA),XS(N),ETA2
    $$ELSE
      $$FLOAT H(N*(N+1)/2),ETA2
    $$ENDIF
  $$ENDIF
  IF (MET.LE.0) RETURN
*     CALL UOU1D1(N,XO,GO)
  $$IF(DEC='A')
    $$I=0
    IF (IDECA.NE.0) THEN
  $$ELSEIF(DEC='E')
    $$IF(NUMBER<3)
      $$I=2
      IF (IDECA.EQ.0) THEN
*
*     LU DECOMPOSITION
*
      DEN=ETA2
      $$IF(LAPACK='YES')
        CALL UXDGLF(N,AG,IA,INF,DEN)
      $$ELSEIF(MOS2=1)
        CALL UXEGGF(N,N,AG,IA,INF,DEN)
      $$ELSE
        CALL UXDGGF(N,AG,IA,INF,DEN)
      $$ENDIF
      NDECA=NDECA+1
      IDECA=2
      ELSE IF (IDECA.NE.2) THEN
    $$ELSE  
      $$I=0
      IF (IDECA.NE.0) THEN
    $$ENDIF  
  $$ELSEIF(DEC='Q')
    $$I=1
    IF (IDECA.EQ.0) THEN
*
*     QR DECOMPOSITION
*
    DEN=ETA2
    $IF(MOS3=1)
      CALL UX$(POMD)$(JASA)QF(N,NA,AG,H,$XS)
      CALL UX$(POMD)CRC(N,NA,AG,INF,DEN)    
    $ELSE
      CALL UXD$(JASA)PF(N,NA,AG,H)
      CALL UXDPRC(N,H,INF,DEN)
    $ENDIF
    NDECA=NDECA+1
    IDECA=1
    ELSE IF (IDECA.NE.1) THEN
  $$ENDIF
  ITERH=-1
  TUXX='BAD DEC$$I'
  CALL UOERR1('UUDB$(DEC)2',1)
  GOTO 22
  ENDIF
  $$IF($MET=1)
*
*     THE RESIDUAL ADJOINT UPDATE
*
    DEN=UXVDOT(NA,AF,AF)
    IF (DEN.LE.ZERO) THEN
    ITERH=2
    TUXX='SINGULAR'
    GOTO 22
    ENDIF
    TUXX='ADJ RES1'
    CALL UXVCOP(NA,AF,AFO)
  $$ENDIF
  $$IF(DEC='A')
    CALL UXD$(JASB)MM($POMA,AG,AF,S)
  $$ELSEIF(DEC='E')
    $$IF(NUMBER<3)
      CALL UXVCOP(N,AF,S)
      JOB=1
      $$IF(LAPACK='YES')
        $$IF (JASA='R') JOB=0
        CALL UXDGLM(N,AG,IA,S,JOB)
      $$ELSEIF(MOS2=1)
        $$IF (JASA='R') JOB=0
        CALL UXEGGM(N,N,AG,IA,S,JOB)
      $$ELSE
        $$IF (JASA='C') JOB=0
        CALL UXDGGM(N,AG,IA,S,GO,JOB)
      $$ENDIF
    $$ELSE
      CALL UXD$(JASB)MM($POMA,AG,AF,S)
    $$ENDIF
  $$ELSEIF(DEC='Q')
    $$IF(MOS3=1)
      CALL UXVCOP(NA,AF,AFD)
      CALL UX$(POMD)CQB(N,NA,AG,AFD,XS)
      CALL UXD$(JASB)MM($POMA,H,AFD,S)
      CALL UX$(POMD)CRM(N,NA,AG,S,-1)
    $$ELSE
      CALL UXD$(JASB)MM($POMA,AG,AF,S)
      CALL UXDPRM(N,H,S,-1)
    $$ENDIF
  $$ENDIF
  CALL UXVDIF(N,G,S,S)
  $$IF(MET=1)
  $$ELSEIF($MET=2)
    DEN=UXVDOT(N,XO,S)
    IF (DEN.EQ.ZERO) THEN
    ITERH=2
    TUXX='SINGULAR'
    GOTO 22
    ENDIF
    TUXX='ADJ RES2'
    CALL UXVNEG(N,XO,XO)
    $$IF(DEC='A')
      CALL UXD$(JASA)MD($POMA,AG,XO,ONE,AFO,AFO)
    $$ELSEIF(DEC='E')
      $$IF(NUMBER<3)
        JOB=0
        $$IF(LAPACK='YES')
          $$IF (JASA='R') JOB=1
          CALL UXDGLM(N,AG,IA,XO,JOB)
        $$ELSEIF(MOS2=1)
          $$IF (JASA='R') JOB=1
          CALL UXEGGM(N,N,AG,IA,XO,JOB)
        $$ELSE
          $$IF (JASA='C') JOB=1
          CALL UXDGGM(N,AG,IA,XO,GO,JOB)
        $$ENDIF
        CALL UXVDIR(N,ONE,AFO,XO,AFO)
      $$ELSE
        CALL UXD$(JASA)MD($POMA,AG,XO,ONE,AFO,AFO)
      $$ENDIF 
    $$ELSEIF(DEC='Q')
      $$IF(MOS3=1)
        CALL UX$(POMD)CRM(N,NA,AG,XO,1)
        CALL UXD$(JASA)MM($POMA,H,XO,AFD)
        CALL UX$(POMD)CQM(N,NA,AG,AFD,XS)
        CALL UXVDIR(NA,ONE,AFD,AFO,AFO)
      $$ELSE
        CALL UXDPRM(N,H,XO,1)
        CALL UXD$(JASA)MD($POMA,AG,XO,ONE,AFO,AFO)
      $$ENDIF
    $$ENDIF
  $$ELSEIF($MET=3)
    CALL UXVNEG(N,XO,XO)
    $$IF(DEC='A')
      CALL UXD$(JASA)MD($POMA,AG,XO,ONE,AFO,AFO)
    $$ELSEIF(DEC='E')
      $$IF(NUMBER<3)
        JOB=0
        $$IF(LAPACK='YES')
          $$IF (JASA='R') JOB=1
          CALL UXDGLM(N,AG,IA,XO,JOB)
        $$ELSEIF(MOS2=1)
          $$IF (JASA='R') JOB=1
          CALL UXEGGM(N,N,AG,IA,XO,JOB)
        $$ELSE
          $$IF (JASA='C') JOB=1
          CALL UXDGGM(N,AG,IA,XO,GO,JOB)
        $$ENDIF
        CALL UXVDIR(N,ONE,AFO,XO,AFO)
      $$ELSE
        CALL UXD$(JASA)MD($POMA,AG,XO,ONE,AFO,AFO)
      $$ENDIF 
    $$ELSEIF(DEC='Q')
      $$IF(MOS3=1)
        CALL UX$(POMD)CRM(N,NA,AG,XO,1)
        CALL UXD$(JASA)MM($POMA,H,XO,AFD)
        CALL UX$(POMD)CQM(N,NA,AG,AFD,XS)
        CALL UXVDIR(NA,ONE,AFD,AFO,AFO)
      $$ELSE
        CALL UXDPRM(N,H,XO,1)
        CALL UXD$(JASA)MD($POMA,AG,XO,ONE,AFO,AFO)
      $$ENDIF
    $$ENDIF
    DEN=UXVDOT(N,AF,AFO)
    IF (DEN.EQ.ZERO) THEN
    ITERH=2
    TUXX='SINGULAR'
    GOTO 22
    ENDIF
    TUXX='ADJ RES3'
  $$ELSEIF($MET=4)
    DEN=UXVDOT(N,XO,S)
    IF (DEN.EQ.ZERO) THEN
    ITERH=2
    TUXX='SINGULAR'
    GOTO 22
    ENDIF
    TUXX='ADJ RES4'
    CALL UXVNEG(N,XO,XO)
    $$IF(DEC='A')
      CALL UXD$(JASA)MD($POMA,AG,XO,ONE,AFO,AFO)
    $$ELSEIF(DEC='E')
      $$IF(NUMBER<3)
        JOB=0
        $$IF(LAPACK='YES')
          $$IF (JASA='R') JOB=1
          CALL UXDGLM(N,AG,IA,XO,JOB)
        $$ELSEIF(MOS2=1)
          $$IF (JASA='R') JOB=1
          CALL UXEGGM(N,N,AG,IA,XO,JOB)
        $$ELSE
          $$IF (JASA='C') JOB=1
          CALL UXDGGM(N,AG,IA,XO,GO,JOB)
        $$ENDIF
        CALL UXVDIR(N,ONE,AFO,XO,AFO)
      $$ELSE
        CALL UXD$(JASA)MD($POMA,AG,XO,ONE,AFO,AFO)
      $$ENDIF 
    $$ELSEIF(DEC='Q')
      $$IF(MOS3=1)
        CALL UX$(POMD)CRM(N,NA,AG,XO,1)
        CALL UXD$(JASA)MM($POMA,H,XO,AFD)
        CALL UX$(POMD)CQM(N,NA,AG,AFD,XS)
        CALL UXVDIR(NA,ONE,AFO,AFD,AFO)
      $$ELSE
        CALL UXDPRM(N,H,XO,1)
        CALL UXD$(JASA)MD($POMA,AG,XO,ONE,AFO,AFO)
      $$ENDIF
    $$ENDIF
  $$ENDIF
  $$IF(DEC='A')
    CALL UXD$(JASA)MU($POMA,AG,ONE/DEN,AFO,S)
  $$ELSEIF(DEC='E')
    $$IF(NUMBER<3)
      $$IF(LAPACK='YES')
        CALL UXVSCL(N,ONE/DEN,S,S)
        $$IF(MOS3=1)
          CALL UXDGLU(N,AG,IA,S,AFO,INF)
        $$ELSE
          CALL UXDGLV(N,AG,IA,IB,S,AFO,XO,GO,INF)
        $$ENDIF
      $$ELSEIF(MOS2=1)
        CALL UXVSCL(N,ONE/DEN,S,S)
        $$IF(MOS3=1)
          CALL UXEGGU(N,N,AG,IA,S,AFO,INF)
        $$ELSEIF(MOS3=2)
          CALL UXEGGV(N,N,AG,IA,IB,S,AFO,XO,GO,INF)
        $$ELSE
          CALL UXEGGW(N,N,AG,IA,IB,S,AFO,XO,GO,INF,1.0$P-6)
        $$ENDIF
      $$ELSE
        CALL UXVSCL(N,ONE/DEN,S,S)
        $$IF(MOS3=1)
          CALL UXDGGU(N,AG,IA,AFO,S,GO,INF)
        $$ELSEIF(MOS3=2)
          CALL UXDGGV(N,AG,IA,AFO,S,XO,GO,INF)
        $$ELSE
          CALL UXDGGW(N,AG,IA,AFO,S,XO,GO,INF,1.0$P-6)
        $$ENDIF
      $$ENDIF    
    $$ELSE
      CALL UXD$(JASA)MU($POMA,AG,ONE/DEN,AFO,S)
    $$ENDIF
  $$ELSEIF(DEC='Q')
    $$IF(MOS3=1)
      CALL UX$(POMD)$(JASA)QU(N,NA,H,AG,XS,ONE/DEN,AFO,S,XO,INF)
    $$ELSE
      CALL UXD$(JASA)PU(N,NA,AG,H,ONE/DEN,AFO,S,XO,INF)
    $$ENDIF
  $$ENDIF
  ITERH=0
  NUPD=NUPD+1
22 CONTINUE
*  CALL UOU1D2(N,H,S,RHO,GAM,PAR,A,B,C,POM,ETA9)
  RETURN
  END
  $ENDADD
  $ADD(INIT)
    NUXX='UUDB$(DEC)2'
  $ENDADD
  $EXIT
