$INTERFACE UUDRD3                                             97/12/01

  $N='N'
  $ADD(REAL,'\$AG($NF*$NA)\$AGH($NF*$NA)')
$REM  $ADD(INTEGER,'\$N\NA\IPOM1\POM2')
  CALL UUDRD3($N,NA,$AG,$AGH,IPOM1,IPOM2)
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UUDRD3                ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* INITIATION OF A DENSE RECTANGULAR MATRIX
*
* PARAMETERS :
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  RU  AG(N*NA)  JACOBIAN MATRIX.
*  RU  BG(N*NA)  CORRECTION OF THE JACOBIAN MATRIX.
*  IU  IPOM1  METHOD INDICATOR.
*  IU  IPOM2  INDICATOR FOR SCALING.
*
* COMMON DATA :
*  II  IDECA  DECOMPOSITION INDICATOR. IDECA=0-NO DECOMPOSITION.
*  II  IREST  RESTART SPECIFICATION. IF IREST=0 DOES NOT HOLD THEN A
*         RESTART IS PERFORMED.
*  II  ITERS  TERMINATION INDICATOR. ITERS=0-ZERO STEP.
*  IU  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*  TO  TUXX   TEXT INFORMATION ON THE RESTART USED.
*
* SUBPROGRAMS USED :
*  S   UXVCOP  COPYING OF A VECTOR.
*  S   UYSET3  DEFINITION OF THE RESTART VARIABLES.
*
      SUBROUTINE UUDRD3(N,NA,AG,BG,IPOM1,IPOM2)
      $INCLUDE('UMCOMM')
      INTEGER N,NA,IPOM1,IPOM2
      $FLOAT AG(N*NA),BG(N*NA)
      IF(IREST.EQ.0.OR.IREST.GT.0.AND.IPOM1.EQ.0) THEN
      ELSE
      CALL UXVCOP(N*NA,AG,BG)
      TUXX='NEWTON  '
      IPOM2=1
      ENDIF
      IF (IPOM1.EQ.1) THEN
      IF (ITERS.GT.0.OR.IREST.GT.0) THEN
      CALL UXVCOP(N*NA,BG,AG)
      LD=MIN(LD,1)
      IF(IREST.GT.0) CALL UYSET3
      ENDIF
      ELSE
      IF(IREST.LE.0) THEN
      TUXX='NEWTON  '
      ELSE
      IPOM1=1
      CALL UXVCOP(N*NA,BG,AG)
      LD=MIN(LD,1)
      ENDIF
      ENDIF
      IDECA=0
      RETURN
      END
