$INTERFACE UUDRD5                                             97/12/01

  $N='N'
  $ADD(REAL,'\$AG($NF*$NA)\$H($M)\$AGH($NF*$NA)\$HH($M)')
$REM  $ADD(INTEGER,'\$N\NA\IPOM1')
  CALL UUDRD5($N,NA,$AG,$H,$AGH,$HH,ETA2,IPOM1)
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UUDRD5                ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COPY AND DECOMPOSITION OF A DENSE RECTANGULAR MATRIX.
*
* PARAMETERS :
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  RU  AG(N*NA)  JACOBIAN MATRIX.
*  RU  A(N*(N+1)/2)  UPPER TRIANGULAR MATRIX AFTER DECOMPOSOTOIN OF AG.
*  RU  BG(N*NA)  CORRECTION OF THE JACOBIAN MATRIX.
*  RU  B(N*(N+1)/2)  UPPER TRIANGULAR MATRIX AFTER DECOMPOSOTOIN OF BG.
*  RI  ETA2  TOLERANCE FOR POSITIVE DEFINITENESS.
*  II  IPOM1  METHOD INDICATOR.
*
* COMMON DATA :
*  II  IDECA  DECOMPOSITION INDICATOR. IDECA=0-NO DECOMPOSITION.
*  II  NDECA  NUMBER OF QR DECOMPOSITIONS.
*  II  ITERS  TERMINATION INDICATOR. ITERS=0-ZERO STEP.
*  TO  TUXX   TEXT INFORMATION ON THE RESTART USED.
*
* SUBPROGRAMS USED :
*  S   UXDRQF  QR DECOMPOSITION OF THE RECTANGULAR MATRIX.
*  S   UXDPRC  CORRECTION AFTER QR DECOMPOSITION.
*  S   UXVCOP  COPYING OF A VECTOR.
*
      SUBROUTINE UUDRD5(N,NA,AG,A,BG,B,ETA2,IPOM1)
      $INCLUDE('UMCOMM')
      INTEGER N,NA,IPOM1
      $FLOAT AG(N*NA),A(N*(N+1)/2),BG(N*NA),B(N*(N+1)/2),ETA2
      INTEGER INF
      $FLOAT POM
      IF (IPOM1.EQ.1) RETURN
      IF (ITERS.LE.0) RETURN
      IF (IDECA.EQ.0) THEN
C
C     QR DECOMPOSITION
C
      POM=ETA2
      CALL UXDRQF(N,NA,AG,A)
      CALL UXDPRC(N,A,INF,POM)
      NDECF=NDECF+1
      IDECA=1
      ENDIF
      CALL UXVCOP(N*NA,AG,BG)
      CALL UXVCOP(N*(N+1)/2,A,B)
      TUXX='NEWTON  '
      RETURN
      END
