$INTERFACE UUDSD1                                             97/12/01

  $HELP
    CHOICE OF THE INITIAL APPROXIMATION OF THE HESSIAN
    MATRIX:
      1 - UNIT INITIAL APPROXIMATION
      2 - RANDOM INITIAL APPROXIMATION
      3 - NUMERICAL INITIAL APPROXIMATION
  $CHECK(INITH,1,'1\2\3',4)
  $N='N'
  $IF(INITH>2)
    IF (IREST.LE.0) GO TO $20
    CALL UYPRO1('UUXX',2)
    ASSIGN $10 TO IMD
    $GO TO $LMD
$10 CONTINUE
    TUXX='NEWTON  '
    IDECF=0
    CALL UYSET3
    CALL UYEPI1(2)
$20 CONTINUE
  $ELSE
    $N='N'
    $ADD(REAL,'\$H($NF*($NF+1)/2)')
$REM    $ADD(INTEGER,'\$N')
    CALL UUDSD1($N,$H,$INITH)
  $ENDIF
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UUDSD1                ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* INITIATION OF A DENSE SYMMETRIC POSITIVE DEFINITE MATRIX
*
* PARAMETERS :
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  RU  H(N*(N+1)/2)  POSITIVE DEFINITE APPROXIMATION OF THE HESSIAN
*         MATRIX.
*  II  INITH  CHOICE OF THE INITIAL APPROXIMATION OF THE HESSIAN
*         MATRIX. INITH=1-UNIT INITIAL APPROXIMATION.
*         INITH=2-RANDOM INITIAL APPROXIMATION.
*
* COMMON DATA :
*  RU  RAN  RANDOM NUMBER.
*  II  IDECF  DECOMPOSITION INDICATOR. IDECF=0-NO DECOMPOSITION.
*  II  IREST  RESTART SPECIFICATION. IF IREST=0 DOES NOT HOLD THEN A
*         RESTART IS PERFORMED.
*  IU  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*  TO  TUXX   TEXT INFORMATION ON THE RESTART USED.
*
* SUBPROGRAMS USED :
*  S   UXDSMI  GENERATION OF THE UNIT MATRIX.
*  S   UXDSDO  INITIATION OF A DIAGONAL MATRIX.
*  RF  UNRAN1  RANDOM NUMBER GENERATOR.
*  S   UYSET3  DEFINITION OF THE RESTART VARIABLES.
*
      SUBROUTINE UUDSD1(N,H,INITH)
      $INCLUDE('UMCOMM')
      INTEGER N,INITH
      $FLOAT H(N*(N+1)/2)
      INTEGER K
      $FLOAT POM,UNRAN1
      $FLOAT CON
      PARAMETER (CON=1.0$P 1)
      IF(IREST.LE.0) RETURN
      IF(INITH.LE.0) RETURN
      GOTO (1,2) INITH
    1 CALL UXDSMI(N,H)
      TUXX='UNIT    '
      LD=MIN(LD,1)
      GOTO 6
    2 POM=(CON-ONE)/(CON+ONE)
      POM=POM/$DBLE(N+1)
      DO 7 K=1,N*(N+1)/2
      H(K)=POM*(TWO*UNRAN1(RAN)-ONE)
    7 CONTINUE
      CALL UXDSDO(N,ONE,H)
      TUXX='RANDOM  '
      LD=MIN(LD,1)
    6 IDECF=0
      IF (INITH.EQ.1) IDECF=-1
      CALL UYSET3
      RETURN
      END
