$INTERFACE UUDSD6                                             97/12/01

    $ADD(REAL,'\$CG($NF*$MCL)\$CZ($NF*$NF)\$G($NF)\$GN($NF)\$S($NF)')
    $ADD(INTEGER,'\$ICA($NF)')
    CALL UUDSD6(NF,N,MCL,$ICA,$CG,$CZ,$G,$GN,$S,IERR)
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UUDSD6                ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* INITIATION OF A DENSE SYMMETRIC POSITIVE DEFINITE MATRIX
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  N  DIMENSION OF THE NULL SPACE.
*  II  NC  NUMBER OF LINEARIZED CONSTRAINTS.
*  II  ICA(NF)  VECTOR CONTAINING INDICES OF ACTIVE CONSTRAINTS.
*  RI  CG(NF*NC)  MATRIX WHOSE COLUMNS ARE NORMALS OF THE LINEAR
*         CONSTRAINTS.
*  RI  CZ(NF*NF)  MATRIX WHOSE COLUMNS ARE BASIC VECTORS FROM THE
*         CURRENT REDUCED SUBSPACE.
*  RI  G(NF)  GRADIENT OF THE OBJECTIVE FUNCTION.
*  RO  GN(NF)  TRANSFORMED GRADIENT OF THE OBJECTIVE FUNCTION.
*  RA  S(NF)  AUXILIARY VECTOR.
*  IO  IER  ERROR INDICATOR.
*
* COMMON DATA :
*  II  IDECF  DECOMPOSITION INDICATOR. IDECF=0-NO DECOMPOSITION.
*  II  IREST  RESTART SPECIFICATION. IF IREST=0 DOES NOT HOLD THEN A
*         RESTART IS PERFORMED.
*  IU  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*  TO  TUXX   TEXT INFORMATION ON THE RESTART USED.
*
* SUBPROGRAMS USED :
*  S   UXDCMI  GENERATION OF THE UNIT MATRIX.
*  S   UXDRMM  PREMULTIPLICATION OF A VECTOR BY A ROWWISE STORED DENSE
*         RECTANGULAR MATRIX.
*  S   UXDRMV  COPY OF THE SELECTED COLUMN OF A ROWWISE STORED DENSE
*         RECTANGULAR MATRIX.
*  S   UXDRGR  PLANE ROTATION OF A TRANSPOSED DENSE RECTANGULAR MATRIX.
*  S   UXVORT  DETERMINATION OF AN ELEMENTARY ORTHOGONAL MATRIX FOR
*         PLANE ROTATION.
*  S   UYSET3  DEFINITION OF THE RESTART VARIABLES.
*
      SUBROUTINE UUDSD6(NF,N,NC,ICA,CG,CZ,G,GN,S,IER)
      $INCLUDE('UMCOMM')
      INTEGER NF,N,NC,ICA(NF),IER
      $FLOAT CG(NF*NC),CZ(NF*NF),G(NF),GN(NF),S(NF)
      $FLOAT CK,CL
      INTEGER NCA,INEW,I,K,L,N1
      IF(IREST.LE.0) RETURN
      NCA=NF-N
      N=NF
      CALL UXDCMI(NF,N,CZ)
      IF (NCA.GT.0) THEN
      DO 2 I=1,NCA
      INEW=ICA(I)
      N1=N
      IF (N.GT.1) THEN
      N=N-1
      IF (INEW.GT.0) THEN
      CALL UXDRMM(NF,N1,CZ,CG((INEW-1)*NF+1),S)
      ELSE
      CALL UXDRMV(NF,N1,CZ,S,-INEW)
      ENDIF
      DO 1 L=1,N
      K=L+1
      CALL UXVORT(S(K),S(L),CK,CL,IER)
      CALL UXDRGR(NF,N1,CZ,K,L,CK,CL,IER)
      IF (IER.LT.0) RETURN
    1 CONTINUE
      ENDIF
      IER=0
    2 CONTINUE  
      ENDIF
      CALL UXDRMM(NF,N,CZ,G,GN)
      TUXX='ORTHOG  '
      LD=MIN(LD,1)
      IDECF=-1
      CALL UYSET3
      RETURN
      END
