$INTERFACE UUDSI1                                             97/12/01
$REM LU

  $CON0='2.2$P-1'
  $CON1='1.8$P-1'
  $CON2='7.0$P-1'
  $CON3='0.2$P 0'
  $CON4='1.0$P-2'
  $CON5='5.0$P-8'
  $CON6='1.0$P-4'
  $HELP
    METHOD OF UPDATE OF HESSIAN MATRIX:
      1 - BFGS UPDATE
      2 - DFP UPDATE
      3 - HOSHINO UPDATE
      4 - SAFEGUARDED RANK ONE UPDATE
      5 - VARIATIONALLY DERIVED PRECONVEX UPDATE
      6 - GLOBALLY CONVERGENT UPDATE
  $CHECK(MET,1,'1\2\3\4\5\6\7',3)
  $HELP
    SELECTION OF SELF SCALING:
      ABS(MET1)=1 - SELF SCALING SUPPRESSED
      ABS(MET1)=2 - INITIAL SELF SCALING
      ABS(MET1)=3 - CONTROLLED SELF SCALING
      ABS(MET1)=4 - SIMPLIFIED CONTROLLED SELF SCALING
      ABS(MET1)=5 - SELF SCALING IN EACH ITERATION
           MET1>0 - BASIC INITIAL SELF SCALING
           MET1<0 - MODIFIED INITIAL SELF SCALING
  $CHECK(MET1,1,'-5\-4\-3\-2\-1\1\2\3\4\5',4)
  $NET1=MET1
  $IF(NET1=-1) $NET1=1
  $IF(NET1=-2) $NET1=2
  $IF(NET1=-3) $NET1=3
  $IF(NET1=-4) $NET1=4
  $IF(NET1=-5) $NET1=5
  $HELP
    SELECTION OF THE LINE SEARCH MODEL:
      1 - QUADRATIC MODEL
      2 - BACKWARD TAYLOR EXPANSION (3 TERMS)
      3 - BACKWARD TAYLOR EXPANSION (4 TERMS)
      4 - HOMOGENEOUS MODEL
  $CHECK(MET2,1,'1\2\3\4',4)
  $HELP
    COMPUTATION OF THE WEIGHTING PARAMETER:
      0 - PREVIOUS CHOICE
      1 - SIMPLE CHOICE WITH A CONSTANT RELATIVE PARAMETER
      2 - USING QUADRATIC EQUATION
      3 - HEURISTIC CHOICE WITH A RELATIVE PARAMETER LESS
          THEN HALF
      4 - HEURISTIC CHOICE WITH THE OPTIMUM CONDITION NUMBER
          IN THE FIRST ITERATION (FIRST FORMULA)
      5 - HEURISTIC CHOICE WITH THE OPTIMUM CONDITION NUMBER
          IN THE FIRST ITERATION (SECOND FORMULA)
      6 - HEURISTIC CHOICE DERIVED FROM THE LOWEST EIGENVALUE
  $CHECK(MET3,4,'0\1\2\3\4\5\6',4)
  $IF(MET= 1) $DEFAULT=1
  $IF(MET= 2) $DEFAULT=2
  $IF(MET= 3) $DEFAULT=3
  $IF(MET= 4) $DEFAULT=1
  $IF(MET= 5) $DEFAULT=3
  $IF(MET= 6) $DEFAULT=3
  $IF(MET= 7) $DEFAULT=2
  $IF(MET1=5) $DEFAULT=3
  $HELP
    METHOD CORRECTION:
      1 - BFGS SCALING
      2 - DFP SCALING
      3 - GEOMETRIC MEAN
      4 - HARMONIC MEAN
      5 - ARITHMETIC MEAN
      6 - INVERTIBLE UPDATE
  $CHECK(MET4,DEFAULT,'1\2\3\4\5\6',4)
  $SNORM=0
  $N='N'
  $IF(CLASS='VR') $N='NN'
  $ADD(REAL,'\$H($NF*($NF+1)/2)\$GN($NF)\$SN($NF)\$XO($NF)\$GO($NF)')
  $ADD(REAL,'\GAM')
  $POM4='($N,$H,$S,$XO,$GO,PAR,R,PO'
  $POM6='(N,H,S,XO,GO,SIG,R,PO'
  $IF(MET3=3)
    $ADD(POM4,',$GN')
    $ADD(POM6,',G')
  $ENDIF
  $IF(NET1=3)
    $ADD(POM4,',PAR1,PAR2')
    $ADD(POM6,',PAR1,PAR2')
  $ENDIF
  $IF(MET2>1)
    $ADD(POM4,',F,FO,P')
    $ADD(POM6,',F,FO,P')
  $ENDIF
  $IF(SNORM=1)
    $ADD(POM4,',SNORM')
    $ADD(POM6,',SNORM')
  $ENDIF
  $ADD(POM4,',ETA9,MET,GAM)')
  $ADD(POM6,',ETA9,MET,GAM)')
  $NUMSUB=''
  $IF(NMET>1) $NUMSUB='_$NMET'
  CALL UUDSI1$(NUMSUB)$POM4
  $ADD(SUBROUTINES)
*     ----------------------------------------
*     BROYDEN CLASS OF VARIABLE METRIC UPDATES
*     TEMPLATE : UUDSI1
*     ----------------------------------------
  SUBROUTINE UUDSI1$(NUMSUB)$POM6
  $$INCLUDE('UMCOMM')
  INTEGER N,MET
  $$FLOAT H(N*(N+1)/2),S(N),XO(N),GO(N),SIG,R,PO,ETA9
  $$IF(MET3=3)
    $$FLOAT G(N)
  $$ENDIF
  $$IF($NET1=3) $$FLOAT PAR1,PAR2
  $$IF($MET2>1) $$FLOAT F,FO,P
  $$IF($SNORM=1) $$FLOAT SNORM
  $$FLOAT UXVDOT
  $$FLOAT DEN,DIS,POM,POM3,POM4,A,B,C,AA,GAM,RHO,PAR
  $$IF($MET3=3)
    $$FLOAT BB,CC,AH,BH,CH,PSI,UNFUN2
    EXTERNAL UNFUN2
    COMMON  /UMFUN2/ A,B,C,AA,BB,CC,AH,BH,CH,PAR
  $$ENDIF
  $$IF($MET3=5)
    $$FLOAT TMP
  $$ENDIF
  $$IF($MET3=6)
    $$FLOAT TMP
  $$ENDIF
  $$IF($MET3=7)
    $$FLOAT AH,CH,PSI,UNFUN2
    EXTERNAL UNFUN3
    COMMON  /UMFUN3/ B,AA,AH,CH
  $$ENDIF
  INTEGER IUPDT
  LOGICAL L1,L3
  $$IF ($NET1=3) LOGICAL L2
  $$IF($MET>8)
    $$FLOAT POM1,POM2
  $$ELSEIF($MET2>1)
    $$FLOAT POM1,POM2
  $$ENDIF
  $$IF($MET1=6) $$FLOAT BS,CS,DS,DEL
  IF (MET.LE.0) GO TO 22
  CALL UOU1D1(N,XO,GO)
  IF (IDECF.NE.9) THEN
  ITERH=-1
  TUXX='BAD DEC9'
  CALL UOERR1('UUDSI1',1)
  GO TO 22
  ENDIF
  L1=ABS($MET1).GE.3.OR.ABS($MET1).EQ.2.AND.NIT.EQ.KIT
  L3=.NOT.L1
*
*     DETERMINATION OF THE PARAMETERS A, B, C
*
  B=UXVDOT(N,XO,GO)
  IF (B.LE.ZERO) THEN
  ITERH=2
  TUXX='B - NEG.'
  GO TO 22
  ENDIF
  DIS=UXVDOT(N,GO,GO)
  C=-R*PO
  $$IF($MET3=3)
    CALL UXVDIF(N,GO,G,S)
    CALL UXVSCL(N,R,S,S)
    AH=DIS
    BH=UXVDOT(N,GO,S)
    CH=UXVDOT(N,S,S)
    BB=B-SIG*BH
    CC=C-SIG*CH
  $$ENDIF
  $$IF($MET3=7)
    AH=DIS
    CH=UXVDOT(N,XO,XO)
  $$ENDIF
  CALL UXDSMM(N,H,GO,S)
  AA=UXVDOT(N,GO,S)
  DEN=SIG*DIS
  A=AA+DEN
*
*     DETERMINATION OF THE PARAMETER RHO (NONQUADRATIC PROPERTIES)
*
  $$IF($MET2=1)
    RHO=ONE
  $$ELSEIF($MET2<5)
    POM1=(F-FO)/PO
    POM2=P/PO
    $$IF($MET2=2)
      IF (POM1.EQ.POM2.OR.POM2.EQ.ONE) THEN
      RHO=ONE
      ELSE
      RHO=HALF*(POM2-ONE)/(POM2-POM1)
      ENDIF
    $$ELSEIF($MET2=3)
      IF (TWO*(POM2-ONE)-THREE*(POM1-ONE).EQ.ZERO) THEN
      RHO=ONE
      ELSE
      RHO=HALF*(POM2-ONE)/(TWO*(POM2-ONE)-THREE*(POM1-ONE))
      ENDIF
    $$ELSEIF($MET2=4)
      IF (POM1.EQ.ONE.OR.POM2.EQ.POM1) THEN
      RHO=ONE
      ELSE
      RHO=(POM1-ONE)/(POM2-POM1)
      ENDIF
    $ENDIF
    IF(RHO.LE.$CON4) RHO=ONE
    IF(RHO*$CON4.GE.ONE) RHO=ONE
  $$ELSE
    RHO=ONE
  $$ENDIF
  IUPDT=0
  IF (L1) THEN
*
*     DETERMINATION OF THE PARAMETER GAM (SELF SCALING)
*
  $$IF($MET4=6)
    PAR=SIG*DIS/($CON0*B)
    POM3=0.7$P 0
    POM4=6.0$P 0
  $$ELSE
    IF (C.LE.ZERO) THEN
    PAR=A/B
    POM3=0.7$P 0
    POM4=6.0$P 0
    ELSE
    $$IF(MET4=1)
      PAR=A/B
      POM3=0.7$P 0
      POM4=6.0$P 0
    $$ELSEIF(MET4=2)
      PAR=B/C
      POM3=0.7$P 0
      POM4=6.0$P 0
    $$ELSEIF(MET4=3)
      PAR=SQRT(A/C)
      POM3=0.7$P 0
      POM4=6.0$P 0
    $$ELSEIF(MET4=4)
      PAR=TWO*(A/C)/(A/B+B/C)
      POM3=0.7$P 0
      POM4=6.0$P 0
    $$ELSEIF(MET4=5)
      PAR=HALF*(A/B+B/C)
      POM3=0.7$P 0
      POM4=6.0$P 0
    $$ENDIF
    ENDIF
  $$ENDIF
  GAM=RHO/PAR
  $$IF($MET1<0)
    IF (NIT.EQ.KIT) THEN
    GAM=MAX(GAM,$CON6)
    GAM=MIN(GAM,ONE/$CON6)
    PAR=RHO/GAM
    ENDIF
  $$ENDIF
  $$IF($NET1=3)
    IF (NIT.NE.KIT) THEN
    L2=PAR2.LE.ZERO
    L3=L2.AND.ABS(PAR1).LE.$CON3
    L3=L3.OR.(.NOT.L2.AND.GAM.GT.ONE)
    L3=L3.OR.(L2.AND.PAR1.LT.ZERO.AND.GAM.GT.ONE)
    L3=L3.OR.(L2.AND.PAR1.GT.ZERO.AND.GAM.LT.ONE)
    L3=L3.OR.GAM.LT.POM3
    L3=L3.OR.GAM.GT.POM4
    ENDIF
  $$ELSEIF($NET1=4)
    IF (NIT.NE.KIT) THEN
    L3=GAM.LT.POM3.OR.GAM.GT.POM4
    ENDIF
  $$ENDIF
  ENDIF
  IF (L3) THEN
  GAM=ONE
  PAR=RHO/GAM
  ENDIF
*
*     DETERMINATION OF THE PARAMETER SIG (SHIFT)
*
  POM=B/DIS
  $$IF($MET3=1)
    SIG=$CON0*POM
  $$ELSEIF($MET3=2)
    IF (NIT.EQ.KIT.OR.AA.LE.ZERO) THEN
    SIG=$CON0*POM
    ELSE
    SIG=SIG*TWO*PAR*B/(DEN+SQRT(DEN**2+FOUR*PAR*A*B))
    SIG=MAX(SIG,1.8$P-1*POM)
    SIG=MIN(SIG,6.5$P-1*POM)
    ENDIF
  $$ELSEIF($MET3=3)
    IF (A.GT.ZERO) THEN
    SIG=HALF*SQRT(SIG*DIS/A)*POM
    SIG=MAX(SIG,1.8$P-1*POM)
    ELSE
    SIG=$CON0*POM
    ENDIF
  $$ELSEIF($MET3=4)
    IF (A.GT.ZERO) THEN
    DEN=UXVDOT(N,XO,XO)
    SIG=SQRT(MAX(ZERO,ONE-AA/A))/(ONE+SQRT(MAX(ZERO,ONE-B*B&
/(DEN*DIS))))*POM
    IF (NIT.LE.KIT+5) THEN
    SIG=MAX(SIG,2.0$P-1*POM)
    SIG=MIN(SIG,8.0$P-1*POM)
    ENDIF
    ELSE
    SIG=$CON0*POM
    ENDIF
  $$ELSEIF($MET3=5)
    IF (A.GT.ZERO) THEN
    DEN=UXVDOT(N,XO,XO)
    SIG=SQRT(SIG*DIS/A)/(ONE+SQRT(MAX(ZERO,ONE-B*B/(DEN*DIS))))*POM
    IF (NIT.LE.KIT+5) THEN
    SIG=MAX(SIG,2.0$P-1*POM)
    SIG=MIN(SIG,8.0$P-1*POM)
    ENDIF
    ELSE
    SIG=$CON0*POM
    ENDIF
  $$ELSEIF($MET3=6)
    TMP=C/B
    DEN=MAX(ONE,TMP*(A/B))+TMP
    TMP=SQRT(MAX(ZERO,ONE-FOUR*TMP/(DEN*DEN)))
    SIG=SIG*HALF*DEN*(ONE-TMP)
    SIG=SQRT(HALF)*SQRT(SIG*POM)
    SIG=MAX(SIG,1.8$P-1*POM)
    SIG=MIN(SIG,7.0$P-1*POM)
  $$ELSE
    SIG=MAX(SIG,1.4$P-1*POM)
    SIG=MIN(SIG,4.5$P-1*POM)
  $$ENDIF
  A=AA
  B=B-SIG*DIS
  CALL UXVDIR(N,-SIG,GO,XO,XO)
  IF (RHO.NE.ONE) SIG=RHO*SIG
  $$IF($MET=7)
  $$ELSE
  IF (NIT.EQ.KIT.OR.A.LE.ZERO) THEN
*
*     INITIAL UPDATE
*
    POM=ONE
    TUXX='BFGS    '
    NUPD=NUPD+1
    CALL UXDSMU(N,H,PAR/B,XO)
    GO TO 21
    ENDIF
  $$ENDIF
  $$U17=0
  $$U18=0
  $$U20=0
  $$IF($MET=1)
    $$U17=1
    NUPD=NUPD+1
  $$ELSEIF($MET=2)
*
*     DFP UPDATE
*
    POM=ZERO
    CALL UXDSMU(N,H,PAR/B,XO)
    CALL UXDSMU(N,H,-ONE/A,S)
    TUXX='DFP     '
    NUPD=NUPD+1
  $$ELSEIF($MET=3)
*
*     HOSHINO UPDATE
*
    DEN=PAR*B+A
    DIS=HALF*B
    POM=PAR*B/DEN
    CALL UXVDIR(N,PAR,XO,S,S)
    CALL UXDSMU(N,H,PAR/DIS,XO)
    CALL UXDSMU(N,H,-ONE/DEN,S)
    TUXX='HOSHINO '
    NUPD=NUPD+1
  $$ELSEIF($MET=4)
*
*     SAFEGUARDED RANK ONE UPDATE
*
    $$U17=1
    $$U18=1
    DEN=PAR*B-A
    DIS=PAR*C-B
    IF (DEN.GT.ZERO) GO TO 18
  $$ELSEIF($MET=5)
*
*     VARIATIONALLY DERIVED PRECONVEX UPDATE
*
    POM=TWO
    DIS=TWO*A/B
    CALL UXVDIR(N,-DIS,XO,S,S)
    CALL UXDSMU(N,H,ONE/A,S)
    CALL UXDSMU(N,H,(PAR-DIS)/B,XO)
    TUXX='PRECON 2'
    NUPD=NUPD+1
  $$ELSEIF($MET=6)
*
*     GLOBALLY CONVERGENT UPDATE
*
    $$U20=1
    CALL UXVDIR(N,-A/B,XO,S,GO)
    POM=MIN(ONE,UXVDOT(N,S,S)/UXVDOT(N,GO,GO))
    TUXX='GLOBAL  '
    NUPD=NUPD+1
  $$ELSEIF($MET=7)
*
*     DFP UPDATE IN THE RANK ONE FORM
*
    CALL UXDSMO(N,ZERO,H)
    CALL UXDSMU(N,H,ONE/B,XO)
    POM=ZERO
    TUXX='DFP     '
    NUPD=NUPD+1
  $$ENDIF
  $$IF(U17>0)
17 CONTINUE
*
*     BFGS UPDATE
*
    POM=ONE
    DIS=PAR+A/B
    CALL UXVDIR(N,-DIS,XO,S,XO)
    DIS=ONE/(B*DIS)
    CALL UXDSMU(N,H,DIS,XO)
    CALL UXDSMU(N,H,-DIS,S)
    TUXX='BFGS    '
    GO TO 21
  $$ENDIF
  $$IF(U18>0)
18 CONTINUE
*
*     RANK ONE UPDATE
*
    POM=PAR*B/DEN
    CALL UXVDIR(N,-PAR,XO,S,XO)
    CALL UXDSMU(N,H,ONE/DEN,XO)
    TUXX='RANK ONE'
    NUPD=NUPD+1
    GO TO 21
  $$ENDIF
  $$IF(U20>0)
20 CONTINUE
*
*     GENERAL UPDATE
*
    DEN=PAR+POM*A/B
    DIS=POM/DEN
    CALL UXDSMU(N,H,(PAR*DIS-ONE)/A,S)
    CALL UXVDIR(N,-DIS,S,XO,S)
    CALL UXDSMU(N,H,DEN/B,S)
  $$ENDIF
21 CONTINUE
$REM  ITERH=0
  IF (GAM.EQ.ONE) GO TO 22
*
*     SCALING
*
  CALL UXDSMS(N,H,GAM)
  NSCL=NSCL+1
22 CONTINUE
  ITERH=0
  CALL UOU1D2(N,H,S,RHO,GAM,PAR,A,B,C,POM,ETA9)
  RETURN
  END
  $ENDADD
  $ADD(INIT)
    NUXX='UUDSI1'
  $ENDADD
  $EXIT
