* SUBROUTINE UUGAM1                ALL SYSTEMS                02/12/01
C PORTABILITY : ALL SYSTEMS
C 02/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETERMINATION OF THE SCALING PARAMETER.
*
* PARAMETERS :
*  RI  A  INPUT PARAMETER.
*  RI  B  INPUT PARAMETER.
*  RI  C  INPUT PARAMETER.
*  RI  RHO  NONQUADRATIC CORRECTION PARAMETER.
*  RO  GAM  SCALING PARAMETER.
*  RO  PAR  NUMBER RHO/GAM.
*  RI  PAR1  PARAMETER FOR SCALING.
*  RI  PAR2  PARAMETER FOR SCALING.
*  II  MET1  SCALING OPTION.
*  II  MET4  SCALING OPTION.
*
* COMMON DATA :
*  II  NIT  ACTUAL NUMBER OF ITERATIONS.
*  II  KIT  NUMBER OF THE ITERATION AFTER LAST RESTART.
*  TO  TUXX  TEXT INFORMATION ON THE CORRECTION USED.
*
      SUBROUTINE UUGAM1(A,B,C,RHO,GAM,PAR,PAR1,PAR2,MET1,MET4)
      $INCLUDE('UMCOMM')
      INTEGER MET1,MET4
      $FLOAT A,B,C,RHO,GAM,PAR,PAR1,PAR2
      $FLOAT POM3,POM4
      LOGICAL L1,L2,L3
      $FLOAT CON3,CON6
      PARAMETER(CON3=0.2$P 0,CON6=1.0$P-4)
      L1=ABS(MET1).GE.3.OR.ABS(MET1).EQ.2.AND.NIT.EQ.KIT
      L3=.NOT.L1
      IF (L1) THEN
C
C     DETERMINATION OF THE PARAMETER GAM (SELF SCALING)
C
      IF (C.LE.ZERO) THEN
      PAR=A/B
      POM3=0.7$P 0
      POM4=6.0$P 0
      ELSE
      IF (MET4.EQ.1) THEN
      PAR=A/B
      POM3=0.7$P 0
      POM4=6.0$P 0
      ELSE IF (MET4.EQ.2) THEN
      PAR=B/C
      POM3=0.7$P 0
      POM4=6.0$P 0
      ELSE IF (MET4.EQ.3) THEN
      PAR=SQRT(A/C)
      POM3=0.7$P 0
      POM4=6.0$P 0
      ELSE IF (MET4.EQ.4) THEN
      PAR=TWO*(A/C)/(A/B+B/C)
      POM3=0.7$P 0
      POM4=6.0$P 0
      ELSE IF (MET4.EQ.5) THEN
      PAR=HALF*(A/B+B/C)
      POM3=0.7$P 0
      POM4=6.0$P 0
      ENDIF
      ENDIF
      IF (PAR.LE.ZERO) THEN
      L3=.TRUE.
      ELSE
      GAM=RHO/PAR
      IF (MET1.LT.0.AND.NIT.EQ.KIT) THEN
      GAM=MAX(GAM,CON6)
      GAM=MIN(GAM,ONE/CON6)
      PAR=RHO/GAM
      ENDIF
      IF (ABS(MET1).EQ.3.AND.NIT.NE.KIT) THEN
      L2=PAR2.LE.ZERO
      L3=L2.AND.ABS(PAR1).LE.CON3
      L3=L3.OR.(.NOT.L2.AND.GAM.GT.ONE)
      L3=L3.OR.(L2.AND.PAR1.LT.ZERO.AND.GAM.GT.ONE)
      L3=L3.OR.(L2.AND.PAR1.GT.ZERO.AND.GAM.LT.ONE)
      L3=L3.OR.GAM.LT.POM3
      L3=L3.OR.GAM.GT.POM4
      ELSE IF (ABS(MET1).EQ.4.AND.NIT.NE.KIT) THEN
      L3=GAM.LT.POM3.OR.GAM.GT.POM4
      ENDIF
      ENDIF
      ENDIF
      IF(L3) THEN
      GAM=ONE
      PAR=RHO/GAM
      ENDIF
      RETURN
      END
