* SUBROUTINE UULBV2                ALL SYSTEMS                31/12/13
C PORTABILITY : ALL SYSTEMS
C 31/12/13 VL :                                       ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF TRANS(GO)*HH*GO, WHERE HH IS THE LAST BUT ONE VARIABLE
* METRIC AUXILIARY MATRIX.
*
* PARAMETERS :
*  IU  N  NUMBER OF ROWS OF  MATRICES XM, GM.
*  II  MM  MAXIMUM NUMBER OF COLUMNS OF MATRICES XM, GM.
*  RU  XR(MM,MM) MATRIX  TRANS(XM)*GM.
*  RU  GR(M*(M+1)/2)  SYMMETRIC MATRIX TRANS(GM)*GM STORED COLUMNWISE.
*  RU  RV(M*(M+1)/2)  UPPER TRIANGULAR PART OF XR STORED COLUMNWISE.
*  RU  DV(M)  DIAGONAL OF MATRIX XR.
*  RA  WW(3*M)  AUXILIARY ARRAY.
*  RI  BB  INPUT PARAMETER  BB = TRANS(GO)*XO/TRANS(GO)*GO.
*  RI  AH  INPUT PARAMETER  AH = TRANS(GO)*GO.
*  RO  A  OUTPUT PARAMETER A = TRANS(GO)*HH*GO
*
* SUBPROGRAMS USED :
*  S   UXDPRB  BACK SUBSTITUTION.
*  S   UXDSMM  MULTIPLICATION OF A DENSE SYMMETRIC MATRIX BY A VECTOR.
*  S   UXVCOP  COPYING OF A VECTOR.
*
* METHOD :
* 
      SUBROUTINE UULBV2(M,MM,XR,GR,RV,DV,WW,BB,AH,A)
      INTEGER I,M,MM,L
      REAL*8 XR(MM,MM),GR(M*(M+1)/2),RV(M*(M+1)/2),DV(M),WW(M*3)
      REAL*8 A,AH,BB
      A=BB*AH
      IF (M.GT.1) THEN
        L=M*(M-1)/2
        CALL UXVCOP(M-1,XR(:,M),WW)
        CALL UXDPRB(M-1,RV,WW,-1)
        CALL UXDSMM(M-1,GR,WW,WW(2*M+1))
        DO I=1,M-1
          WW(M+I)=WW(I)*DV(I)+BB*(WW(2*M+I)-GR(L+I)*2D0)
        ENDDO
        CALL UXDPRB(M-1,RV,WW(M+1),1)
        DO I=1,M-1
          A=A+XR(I,M)*WW(M+I)
        ENDDO
      ENDIF
      RETURN
      END
