$INTERFACE UULCI2                                             97/12/01

  CALL UULCI2(NF,MF,MA,$AG,$IAG,$JAG,$IB,$IW1,$XM,$GM,$IH,$XO,$AFO,$S)
  $ADD(REAL,'\$AG($MA)\$XM($NF*$MF)\$GM($MF)&
  \$XO($NF)\$AFO($NA)\$S($NF)')
  $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)\$IB($NA)\$IW1($NF)\$IH($MF)')
$REM  $ADD(INTEGER,'\NF\MF\MA')
  $ADD(INIT)
    NUXX='UULCI2'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UULCI2                ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* LIMITED STORAGE INVERSE COLUMN UPDATE METHOD.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  MF  MAXIMUM NUMBER OF VARIABLE METRIC STEPS.
*  II  MA  NUMBER OF ELEMENTS IN THE FIELD AG.
*  RO  AG(MA)  SPARSE JACOBIAN MATRIX.
*  RI  IAG(NA+1)  POSITION OF THE FIRST ROWS ELEMENTS IN THE FIELD AG.
*  RI  JAG(MA)  COLUMN INDICES OF ELEMENTS IN THE FIELD AG.
*  IO  IP(NF)  PERMUTATION VECTOR.
*  II  ID(NF) INDICES OF DIAGONAL ELEMENTS.
*  RU  XM(NF*MF)  SET OF VECTOR OF VARIABLES DIFFERENCES.
*  RU  GM(MF)  SET OF GRADIENT DIFFERENCES.
*  IU  IM(MF)  VECTOR OF INDICES.
*  RI  XO(NF)  VECTOR OF VARIABLES DIFFERENCE.
*  RI  AFO(NF)  GRADIENTS DIFFERENCE.
*  RA  S(NF)  AUXILIARY.
*
* COMMON DATA :
*  IU  IREST  RESTART INDICATOR.
*  IO  ITERH  TERMINATION INDICATOR. ITERH<0-BAD DECOMPOSITION.
*         ITERH=0-SUCCESSFUL UPDATE. ITERH>0-NONPOSITIVE PARAMETERS.
*  II  NIT  ACTUAL NUMBER OF ITERATIONS.
*  II  KIT  NUMBER OF THE ITERATION AFTER LAST RESTART.
*  TO  TUXX  TEXT INFORMATION ON THE CORRECTION USED.
*
* SUBPROGRAMS USED :
*  S   UXLIIM  MATRIX MULTIPLICATION FOR LIMITED STORAGE INVERSE
*         COLUMN UPDATE METHOD. INCOMPLETE LU DECOMPOSITION VARIANT.
*  S   UXVDIR  VECTOR AUGMENTED BY THE SCALED VECTOR.
*  RF  UXVMX1  L-INFINITY NORM OF A VECTOR.
*
* METHOD :
* INVERSE COLUMN UPDATE LIMITED STORAGE VARIABLE METRIC METHOD.
*
      SUBROUTINE UULCI2(NF,MF,MA,AG,IAG,JAG,IP,ID,XM,GM,IM,XO,
     & AFO,S)
      $INCLUDE('UMCOMM')
      INTEGER NF,MF,MA,IAG(NF+1),JAG(MA),IP(NF),ID(NF),IM(MF)
      $FLOAT AG(MA),XM(NF*MF),GM(MF),XO(NF),AFO(NF),S(NF)
      INTEGER II,MM
      $FLOAT TEMP,UXVMX1
      MM=MIN(NIT-KIT,MF)
      IF (MM.GE.MF) THEN
      IREST=1
      ELSE
      II=NF*MM+1
      CALL UXLIIM(NF,MA,MM,AG,IAG,JAG,IP,ID,XM,GM,IM,AFO,XM(II),S)
      CALL UXVDIR(NF,-ONE,XM(II),XO,XM(II))
      MM=MM+1
      TEMP=UXVMX1(NF,AFO,II)
      IF (TEMP.LE.ZERO) THEN
      ITERH=2
      TUXX='ZERO DEN'
      CALL UOERR1('UULCI2',1)
      ELSE
      IM(MM)=II
      GM(MM)=AFO(II)
      TUXX='INV COL '
      NUPD=NUPD+1
      ITERH=0
      ENDIF
      ENDIF
      RETURN
      END
