$INTERFACE UULVP3                                             03/12/01

  $XR='XR'
  $GR='GR'
  $SO='SO'
  $GG=G
  $SS=S
  $HELP
    VALUE OF THE CORRECTION PARAMETER:
      MET2=1 - UNIT VALUE
      MET2=2 - BALANCING VALUE EQUAL TO THE PREVIOUS RELATIVE 
               PARAMETER
      MET2=3 - VALUE DERIVED FROM THE GRADIENT DIFFERENCES 
      MET2=4 - GEOMETRIC MEAN OF THE PREVIOUS VALUES
      MET2=5 - GEOMETRIC MEAN OF THE PREVIOUS RELATIVE PARAMETER
               AND THE RATIO ZET/(ZET+SIG)
      MET2=6 - RATIO ZET/(ZET+SIG) 
      MET2=7 - RATIO SQRT(ZET)/(SQRT(ZET)+SQRT(SIG))
  $CHECK(MET2,6,'1\2\3\4\5\6\7',4)
  $IF(MET5>4) $SS='SS'
  $IF(CONSTR='C') $GG=SO
  $HELP
    PARAMETER ETA FOR VARIABLE METRIC UPDATES
  $CHECK(ETA3,'1.5$P 0',REAL,4)
  $ADD(REAL,'\$XM($NF*$MF)\$XR($MF)\$GR($MF)\$SO($NF)\$SS($NF)&
  \$XO($NF)\$GO($NF)')
$REM  $ADD(INTEGER,'\NF\MF\INF')
  CALL UULVP3(NF,NN,$XM,$XR,$GR,$S,$SO,$SS,$XO,$GO,R,PO,PAR,ETA3&
,MET2,MET3,MET5)
  $ADD(INIT)
    NUXX='UULVP3'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UULVP3                ALL SYSTEMS                03/12/01
C PORTABILITY : ALL SYSTEMS
C 03/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* RANK-TWO LIMITED-STORAGE VARIABLE-METRIC METHODS IN THE PRODUCT FORM.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES (NUMBER OF ROWS OF XM).
*  II  M  NUMBER OF COLUMNS OF XM.
*  RI  XM(N*M)  RECTANGULAR MATRIX IN THE PRODUCT FORM SHIFTED BROYDEN
*         METHOD (STORED COLUMNWISE): H-SIGMA*I=XM*TRANS(XM)
*  RO  XR(M)  VECTOR TRANS(XM)*H**(-1)*XO.
*  RO  GR(M)  MATRIX TRANS(XM)*GO.
*  RA  S(N)  AUXILIARY VECTORS (H**(-1)*XO AND U).
*  RA  SO(N)  AUXILIARY VECTORS ((H-SIGMA*I)*H**(-1)*XO AND V).
*  RU  XO(N)  VECTORS OF VARIABLES DIFFERENCE XO AND VECTOR XO-TILDE.
*  RU  GO(N)  GRADIENT DIFFERENCE GO AND VECTOR XM*TRANS(XM)*GO.
*  RI  R  STEPSIZE PARAMETER.
*  RI  PO  OLD DIRECTIONAL DERIVATIVE (MULTIPLIED BY R)
*  RU  SIG  SCALING PARAMETER (ZETA AND SIGMA).
*  RI  ETA  BROYDEN PARAMETER.
*  II  MET2  CHOICE OF THE CORRECTION PARAMETER RHO. MET2=1-UNIT
*         PARAMETER. MET2=2-BALANCING PARAMETER. MET2=3-DAMPING
*         PARAMETER. MET2=4-GEOMETRIC MEAN OF TWO PREVIOUS CJOICES.
*         MET2=5-NEW FORMULA. MET2=6-RATIO ZET/(ZET+SIG).
*  II  MET3  CHOICE OF THE RELATIVE SHIFT PARAMETER SIGMA. MET3=4-BASIC
*         FORMULA THAT USES BALANCING AND DAMPING TERMS. MET3=5-NEW
*         FORMULA THAT USES BALANCING AND DAMPING TERMS.
*  II  MET5  CHOICE OF THE SHIFTED UPDATE. MET5=1-RANK ONE UPDATE.
*         MET5=2-SIMPLE RANK TWO SHIFTED UBDATE DERIVED FROM THE BFGS
*         METHOD (WITH THE BROYDEN PARAMETER POM=1). MET5=3-RANK TWO
*         SHIFTED UPDATE DERIVED FROM THE GENERAL BROYDEN CLASS (WITH
*         CONSTANT NONZERO POM. MET5=4-RANK TWO SHIFTED UPDATE DERIVED
*         FROM THE GENERAL BROYDEN CLASS (WITH POM COMPUTED BY A
*         MINIMIZATION PRINCIPLE). MET5=5,6,7-RANK TWO SHIFTED UPDATES
*         WITH SPECIAL CHOICES OF T*Y).
*
* COMMON DATA :
*  IO  ITERH  TERMINATION INDICATOR. ITERH<0-BAD DECOMPOSITION.
*         ITERH=0-SUCCESSFUL UPDATE. ITERH>0-NONPOSITIVE PARAMETERS.
*  II  NIT  ACTUAL NUMBER OF ITERATIONS.
*  II  KIT  NUMBER OF THE ITERATION AFTER LAST RESTART.
*  TO  TUXX  TEXT INFORMATION ON THE CORRECTION USED.
*
* SUBPROGRAMS USED :
*  S   UXDRMM  MULTIPLICATION OF A ROWWISE STORED DENSE RECTANGULAR
*         MATRIX BY A VECTOR.
*  S   UXDCMM  MULTIPLICATION OF A COLUMNWISE STORED DENSE RECTANGULAR
*         MATRIX BY A VECTOR.
*  S   UXDCMU  UPDATE OF A COLUMNWISE STORED DENSE RECTANGULAR MATRIX.
*         WITH CONTROLLING OF POSITIVE DEFINITENESS.
*  S   UXVDIF  DIFFERENCE OF TWO VECTORS.
*  S   UXVDIR  VECTOR AUGMENTED BY A SCALED VECTOR.
*  RF  UXVDOT  DOT PRODUCT OF VECTORS.
*  RF  UXVNOR  EUCLIDEAN NORM OF A VECTOR.
*  S   UXVSCL  SCALING OF A VECTOR.
*  S   UXVSET  INITIATION OF A VECTOR.
*
* METHOD :
* VARIATIONALLY DERIVED SHIFTED LIMITED-MEMORY VARIABLE-METRIC METHODS
* IN THE PRODUCT FORM.
*
      SUBROUTINE UULVP3(N,M,XM,XR,GR,S,SO,SS,XO,GO,R,PO,SIG,ETA,MET2,
     & MET3,MET5)
      $INCLUDE('UMCOMM')
      INTEGER N,M,MET2,MET3,MET5
      $FLOAT XM(N*M),XR(M),GR(M),S(N),SO(N),SS(N),XO(N),GO(N),
     & R,PO,ETA,SIG
      $FLOAT UXVDOT
      $FLOAT DEN,POM,POM1,POM2,A,B,C,AA,BB,CC,AH,PAR,PAR1,PAR2,ZET
      $FLOAT CON1,CON2
      PARAMETER(CON1=2.5$P-1,CON2=1.0$P 2)
      CALL UOU1D1(N,XO,GO)
      ZET=SIG
C
C     COMPUTATION OF B
C
      B=UXVDOT(N,XO,GO)
      IF (B.LE.ZERO) THEN
      ITERH=2
      TUXX='B - NEG.'
      GO TO 22
      ENDIF
C
C     COMPUTATION OF GR=TRANS(XM)*GO, XR=TRANS(XM)*H**(-1)*XO
C     AND S=H**(-1)*XO, SO=(H-SIGMA*I)*H**(-1)*XO. COMPUTATION
C     OF AA=GR*GR, BB=GR*XR, CC=XR*XR. COMPUTATION OF A AND C.
C
      CALL UXDRMM(N,M,XM,GO,GR)
C      CALL UXVDIF(N,GO,G,S)
      CALL UXVSCL(N,R,S,S)
      CALL UXDRMM(N,M,XM,S,XR)
      CALL UXVDIR(N,-SIG,S,XO,SO)
      AH=UXVDOT(N,GO,GO)
      AA=UXVDOT(M,GR,GR)
      BB=UXVDOT(M,GR,XR)
      CC=UXVDOT(M,XR,XR)
      A=AA+AH*SIG
      C=-R*PO
C
C     DETERMINATION OF THE PARAMETER SIG (SHIFT)
C
      POM=B/AH
      IF (A.GT.ZERO) THEN
      DEN=UXVDOT(N,XO,XO)
      IF (MET3.LE.4) THEN
      SIG=SQRT(MAX(ZERO,ONE-AA/A))/(ONE+SQRT(MAX(ZERO,ONE-B*B/
     & (DEN*AH))))*POM
      ELSE
      SIG=SQRT(MAX(ZERO,SIG*AH/A))/(ONE+SQRT(MAX(ZERO,ONE-B*B/
     & (DEN*AH))))*POM
      ENDIF
      SIG=MAX(SIG,2.0$P-1*POM)
      SIG=MIN(SIG,8.0$P-1*POM)
      ELSE
      SIG=2.5$P-1*POM
      ENDIF
C
C     COMPUTATION OF SHIFTED XO AND SHIFTED B
C
      DEN=B
      B=B-AH*SIG
      CALL UXVDIR(N,-SIG,GO,XO,XO)
C
C     COMPUTATION OF THE PARAMETER RHO (CORRECTION)
C
      IF (MET2.LE.1) THEN
      PAR=ONE
      ELSE IF (MET2.EQ.2) THEN
      PAR=SIG*AH/B
      ELSE IF (MET2.EQ.3) THEN
      PAR=SQRT(ONE-AA/A)
      ELSE IF (MET2.EQ.4) THEN
      PAR=SQRT(SQRT(ONE-AA/A)*(SIG*AH/B))
      ELSE IF (MET2.EQ.5) THEN
      PAR=SQRT(SQRT(HALF*ZET/(SIG+ZET))*SIG*AH/DEN)
      ELSE IF (MET2.EQ.6) THEN
      PAR=ZET/(ZET+SIG)
      ELSE
      PAR=SQRT(ZET)/(SQRT(ZET)+SQRT(SIG))
      ENDIF
C
C     COMPUTATION OF THE PARAMETER THETA (BFGS)
C
      POM=SIGN(SQRT(PAR*B/CC),BB)
C
C     COMPUTATION OF Q AND P
C
      IF (MET5.EQ.1) THEN
C
C     RANK ONE UPDATE OF XM
C
      CALL UXVDIR(M,POM,XR,GR,XR)
      CALL UXVLIN(N,PAR,XO,POM,SO,S)
      CALL UXDCMU(N,M,XM,-ONE/(PAR*B+POM*BB),S,XR)
      TUXX='SHIFT R1'
      NUPD=NUPD+1
      ELSE IF (MET5.EQ.2) THEN
C
C     SPECIAL RANK TWO UPDATE OF XM
C
      CALL UXVDIR(N,PAR/POM-BB/B,XO,SO,S)
      CALL UXDCMV(N,M,XM,-ONE/B,XO,GR,-ONE/CC,S,XR)
      TUXX='SHIFT R2'
      NUPD=NUPD+1
      ELSE IF (MET5.LE.4) THEN
C
C     GENERAL RANK TWO UPDATE OF XM
C
      CALL UXDCMM(N,M,XM,GR,GO)
      IF (MET5.EQ.3) THEN
      TUXX='SHIFT-3 '
      POM=ETA
      ELSE
      TUXX='SHIFT-4 '
      CALL UXVDIR(N,-AA/B,XO,GO,S)
      POM=UXVDOT(N,S,GO)/UXVDOT(N,S,S)
      IF (POM.LT.CON1) THEN
      POM=ONE
      ELSE IF (POM.LE.ONE) THEN
      POM=POM*POM
      ELSE
      POM=MIN(TWO*POM-ONE,CON2)
      ENDIF
      ENDIF
      POM1=B*(ONE/SQRT(POM)-ONE)
C      PAR2=-SIGN(SQRT(PAR*B*AA/(AA*CC-BB*BB+(POM1+BB)**2)),BB)
      PAR2=-SQRT(PAR*B*AA/(AA*CC-BB*BB+(POM1+BB)**2))
      PAR1=PAR2*POM1/AA
C      CALL UXVDIR(N,AA/POM1,XO,GO,S)
C      POM1=AA+AA*B/POM1
      CALL UXVLIN(N,AA,XO,POM1,GO,S)
      POM1=AA*(B+POM1)
      POM2=PAR1*AA+PAR2*BB
      CALL UXVLIN(M,PAR1,GR,PAR2,XR,XR)
      CALL UXVLIN(N,PAR1,GO,PAR2,SO,GO)
      CALL UXVDIR(N,-POM2/POM1,S,GO,GO)
      CALL UXVDIR(N,-PAR,XO,GO,GO)
      CALL UXDCMV(N,M,XM,-ONE/POM1,S,GR,-ONE/(PAR*B),GO,XR)
      NUPD=NUPD+1
      ELSE
C
C     ADDITIONAL RANK TWO UPDATES OF XM
C
      IF (MET5.EQ.5) THEN
      TUXX='SHIFT-5 '
      CALL UXVDIR(N,3.5$P 0*ZET,S,XO,SS)
      ELSE IF (MET5.EQ.6) THEN
      TUXX='SHIFT-6 '
      CALL UXVDIR(N,3.0$P 0*ZET,S,XO,SS)
      CALL UXVDIR(N,-0.2$P 0*SIG,GO,SS,SS)
      ELSE IF (MET5.EQ.7) THEN
      TUXX='SHIFT-7 '
      CALL UXVDIR(N,(ZET+SQRT(ZET*SIG)),S,XO,SS)
      CALL UXVDIR(N,-0.1$P 0*SIG,GO,SS,SS)
      ELSE
      TUXX='SHIFT-8 '
      CALL UXDCMV(N,M,XM,-ONE/BB,SO,GR,-PAR/(POM*CC),XO,XR)
      ENDIF
      DEN=UXVDOT(N,GO,SS)
      CALL UXVDIR(N,PAR/POM,XO,SO,S)
      CALL UXVDIR(N,-BB/DEN,SS,S,S)
      CALL UXDCMV(N,M,XM,-ONE/DEN,SS,GR,-ONE/CC,S,XR)
      NUPD=NUPD+1
      ENDIF
   22 CONTINUE
      ITERH=0
C      CALL UOU1D3(N,H,S,RHO,GAM,PAR,A,B,C,POM,ETA9)
      RETURN
      END

