$INTERFACE UULVP4                                             06/12/01

  $HR='HR'
  $GR='GR'
  $SO='SO'
  $GG=G
  $SS=S
  $IF(MET5>4) $SS='SS'
  $IF(CONSTR='C') $GG=SO
  $ADD(REAL,'\$XM($NF*$MF)\$S($NF)\$XS($NF)\$GS($NF)\$HR(3*$MF)')
$REM  $ADD(INTEGER,'\NF\NN')
$REM  $ADD(REAL,'\RHO\AP\B')
  CALL UULVP4(NF,NN,$XM,$XO,$GO,$XS,$GS,$HR,RHO,AP,B)
  $ADD(INIT)
    NUXX='UULVP4'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UULVP4                ALL SYSTEMS                06/12/01
C PORTABILITY : ALL SYSTEMS
C 06/12/01 VL : ORIGINAL VERSION
*
* PURPOSE :
* LIMITED-STORAGE VARIABLE-METRIC UPDATE IN THE PRODUCT FORM.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES (NUMBER OF ROWS OF THE MATRIX XM).
*  II  M  NUMBER OF COLUMNS OF THE MATRIX XM.
*  RU  XM(N*M)  RECTANGULAR MATRIX FOR THE PRODUCT FORM VM
*         METHOD (STORED COLUMNWISE): BAR(H)=XM*TRANS(XM).
*  RI  XO(N)  VECTOR OF VARIABLES DIFFERENCE.
*  RI  GO(N)  GRADIENT DIFFERENCE.
*  RU  XS(N)  ON INPUT VECTOR H**(-1)*XO AND THEN AUXILIARY VECTOR.
*  RA  GS(N)  AUXILIARY VECTOR.
*  RA  HR(M*3) AUXILIARY VECTORS (TRANS(XM)*GO, TRANS(XM)*B*XO).
*  RI  RHO  CORRECTION PARAMETER.
*  RO  AP  OUTPUT PARAMETER BAR(A)=TRANS(GO)*BAR(H)*GO.
*  RO  B  OUTPUT PARAMETER B=TRANS(GO)*XO.
*
* SUBPROGRAMS USED :
*  S   UXDRMM  MULTIPLICATION OF A ROWWISE STORED DENSE RECTANGULAR
*         MATRIX BY A VECTOR.
*  S   UXDCMM  MULTIPLICATION OF A COLUMNWISE STORED DENSE RECTANGULAR
*         MATRIX BY A VECTOR.
*  RF  UXVDOT  DOT PRODUCT OF VECTORS.
*
* METHOD :
* J.VLCEK, L.LUKSAN: NEW CLASS OF LIMITED-MEMORY VARIATIONALLY-DERIVED
* VARIABLE METRIC METHODS. ICS REPORT V973-06, ICS AVCR, PRAGUE 2006.
*
      SUBROUTINE UULVP4(N,M,XM,XO,GO,XS,GS,HR,RHO,AP,B)
      $INCLUDE('UMCOMM')
      INTEGER M,N
      $FLOAT XM(N*M),XO(N),GO(N),XS(N),GS(N),HR(M*3),RHO,AP,B
      INTEGER I,J,L
      $FLOAT GAM,ETA,BP,CP,TMP,TEMP,UXVDOT
      GAM=1.0$P 0
      ETA=0.5$P 0
      CALL UXDRMM(N,M,XM,GO,HR)
      CALL UXDRMM(N,M,XM,XS,HR(M+1))
      AP=UXVDOT(M,HR,HR)
      BP=UXVDOT(M,HR,HR(M+1))
      CP=UXVDOT(M,HR(M+1),HR(M+1))
      IF (AP*(AP*CP-BP*BP).LE.0.0$P 0) RETURN
      DO 1 I=1,M
      HR(M+M+I)=(AP*HR(M+I)-BP*HR(I))/SQRT(AP*(AP*CP-BP*BP))
  1   CONTINUE
      CALL UXDCMM(N,M,XM,HR(M+M+1),XS)
      CALL UXDCMM(N,M,XM,HR,GS)
      DO 3 I=1,N
      L=I
      TMP=SQRT(RHO/(GAM*B))*XO(I)-XS(I)
      TEMP=SQRT(ETA)/B*XO(I)+(1.0$P 0-SQRT(ETA))/AP*GS(I)
      DO 2 J=1,M
      XM(L)=SQRT(GAM)*(XM(L)-TEMP*HR(J)+TMP*HR(J+M+M))
      L=L+N
   2  CONTINUE
   3  CONTINUE
      TUXX='PROJ-1  '
      NUPD=NUPD+1
      ITERH=0
      RETURN
      END

