$INTERFACE UUSAA1                                             16/12/01

  CALL UUSAA1(NF,NA,MA,$AG,$IAG,$JAG,$AF,$GG,$XO,$GO)
  $ADD(REAL,'\$AG($MA)\$AF($NA)\$GG($NF)\$XO($NF)\$GO($NF)')
  $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)')
$REM  $ADD(INTEGER,'\NF\NA\MA')
  $ADD(INIT)
    NUXX='UUSAA1'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UUSAA1                ALL SYSTEMS                16/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* RESIDUAL ADJOINT BROYDEN UPDATE OF A SPARSE RECTANGULAR MATRIX.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  MA  NUMBER OF NONZERO ELEMENTS OF THE MATRIX.
*  RI  AG(MA)  SPARSE JACOBIAN MATRIX.
*  II  IAG(NA+1)  POSITION OF THE FIRST RORWS ELEMENTS IN THE FIELD AG.
*  II  JAG(MA) COLUMN INDICES OF ELEMENTS IN THE FIELD AG.
*  RI  AF(NA)  VECTOR OF RIGHT HAND SIDES.
*  RI  G(NF)  GRADIENT OF THE SUM OF SQUARES.
*  RA  XO(NF)  AUXILIARY VECTOR.
*  RI  GO(NF)  AUXILIARY VECTOR.
*
* COMMON DATA :
*  IO  ITERH  TERMINATION INDICATOR. ITERH<0-BAD DECOMPOSITION.
*         ITERH=0-SUCCESSFUL UPDATE. ITERH>0-NONPOSITIVE PARAMETERS.
*  II  IDECA  DECOMPOSITION INDICATOR. IDECA=0-NO DECOMPOSITION.
*  TO  TUXX  TEXT INFORMATION ON THE CORRECTION USED.
*
* SUBPROGRAMS USED :
*  S   UOERR1  ERROR MESAGES.
*  S   UOU1D1  PRINT OF ENTRY TO VARIABLE METRIC UPDATE.
*  S   UOU1D2  PRINT OF EXIT FROM VARIABLE METRIC UPDATE.
*
      SUBROUTINE UUSAA1(NF,NA,MA,AG,IAG,JAG,AF,G,XO,GO)
      $INCLUDE('UMCOMM')
      INTEGER NF,NA,MA,IAG(NA+1),JAG(MA)
      $FLOAT AG(MA),AF(NA),G(NF),XO(NF),GO(NF)
      INTEGER I,J,K,L,JP
C      CALL UOU1D1(N,XO,GO)
      IF(IDECA.NE.0) THEN
      ITERH=-1
      TUXX='BAD DEC0'
      CALL UOERR1('UUSAA1',1)
      GOTO 5
      ENDIF
C
C     THE ADJOINT BROYDEN UPDATE
C
      TUXX='ADJOINT '
      CALL UXSCMD(NF,NA,MA,AG,IAG,JAG,AF,-ONE,G,GO)
      CALL UXVSET(NF,ZERO,XO)
      DO 2 I=1,NA
      K=IAG(I)
      L=IAG(I+1)-1
      DO 1 J=K,L
      JP=JAG(J)
      IF (JP.LE.0) GO TO 1
      XO(JP)=XO(JP)+AF(I)**2
    1 CONTINUE  
    2 CONTINUE
      DO 4 I=1,NA
      K=IAG(I)
      L=IAG(I+1)-1
      DO 3 J=K,L
      JP=JAG(J)
      IF (JP.LE.0.OR.XO(JP).EQ.ZERO) GO TO 3
      AG(J)=AG(J)-GO(JP)*AF(I)/XO(JP)
    3 CONTINUE
    4 CONTINUE
      ITERH=0
    5 CONTINUE
C      CALL UOU1D2(N,H,S,RHO,GAM,PAR,A,B,C,POM,ETA9)
      RETURN
      END
