$INTERFACE UUSBA4                                             97/12/01

  CALL UUSBA4(NF,NA,MA,$AG,$IAG,$JAG,$XO,$AFO,$MET)
  $ADD(REAL,'\$AG($MA)\$XO($NF)\$AFO($NA)')
  $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)')
$REM  $ADD(INTEGER,'\NF\NA\MA')
  $ADD(INIT)
    NUXX='UUSBA4'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UUSBA4                ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* ROW-SCALING UPDATE OF A SPARSE RECTANGULAR MATRIX.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  MA  NUMBER OF NONZERO ELEMENTS OF THE MATRIX.
*  RI  AG(MA)  SPARSE JACOBIAN MATRIX.
*  II  IAG(NA+1)  POSITION OF THE FIRST RORWS ELEMENTS IN THE FIELD AG.
*  II  JAG(MA) COLUMN INDICES OF ELEMENTS IN THE FIELD AG.
*  RU  XO(NF)  VECTOR OF VARIABLES DIFFERENCE.
*  RI  AFO(NA)  VECTOR OF RIGHT HAND SIDES DIFFERENCE.
*  II  MET  METHOD SELECTION. MET=0-NO UPDATE.
*
* COMMON DATA :
*  IO  ITERH  TERMINATION INDICATOR. ITERH<0-BAD DECOMPOSITION.
*         ITERH=0-SUCCESSFUL UPDATE. ITERH>0-NONPOSITIVE PARAMETERS.
*  II  IDECA  DECOMPOSITION INDICATOR. IDECA=0-NO DECOMPOSITION.
*  TO  TUXX  TEXT INFORMATION ON THE CORRECTION USED.
*
* SUBPROGRAMS USED :
*  S   UOERR1  ERROR MESAGES.
*  S   UOU1D1  PRINT OF ENTRY TO VARIABLE METRIC UPDATE.
*  S   UOU1D2  PRINT OF EXIT FROM VARIABLE METRIC UPDATE.
*
      SUBROUTINE UUSBA4(NF,NA,MA,AG,IAG,JAG,XO,AFO,MET)
      $INCLUDE('UMCOMM')
      INTEGER NF,NA,MA,IAG(NA+1),JAG(MA),MET
      $FLOAT AG(MA),XO(NF),AFO(NA)
      INTEGER I,J,K,L,JP
      $FLOAT TEMP
      IF (MET.LE.0) RETURN
C      CALL UOU1D1(N,XO,GO)
      IF(IDECA.NE.0) THEN
      ITERH=-1
      TUXX='BAD DEC0'
      CALL UOERR1('UUSBA4',1)
      GOTO 5
      ENDIF
C
C     THE ROW SCALING UPDATE
C
      TUXX='ROW     '
      DO 3 I=1,NA
      TEMP=ZERO
      K=IAG(I)
      L=IAG(I+1)-K
      DO 1 J=1,L
      JP=JAG(K)
      IF (JP.GT.0) TEMP=TEMP+AG(K)*XO(JP)
      K=K+1
    1 CONTINUE
      IF (AFO(I)*TEMP.LE.ZERO) GO TO 3
      TEMP=AFO(I)/TEMP
      K=IAG(I)
      DO 2 J=1,L
      JP=JAG(K)
      IF (JP.GT.0) AG(K)=AG(K)*TEMP
      K=K+1
    2 CONTINUE
    3 CONTINUE
    5 CONTINUE
C      CALL UOU1D2(N,H,S,RHO,GAM,PAR,A,B,C,POM,ETA9)
      RETURN
      END
