$INTERFACE UUSTM1                                             97/12/01

  $HELP
    PRELIMINARY BFGS UPDATE:
      1 - NO PRELIMINARY BFGS UPDATE
      2 - PRELIMINARY BFGS UPDATE IS USED
  $CHECK(MET,1,'1\2',4)
  $HELP
    SELECTION OF SELF SCALING:
      1 - SELF SCALING SUPPRESSED
      2 - INITIAL SELF SCALING
      3 - SELF SCALING IN EACH ITERATION
  $CHECK(MET1,1,'1\2\3',4)
  $ADD(REAL,'\$H($M)\$B($M)\$GN($NF)\$XS($NF)\$S($NF)\$XO($NF)&
             \$GO($NF)')
$REM  $ADD(REAL,'\R\PO')
  $ADD(INTEGER,'\$IH($NF+1)\$JH($M)\$IX($NX)\$PSL($NF)\$PERM($NF)&
                \$WN11($NF+1)\$WN12($NF+1)')
$REM  $ADD(INTEGER,'\NF\MH\MMAX')
  $IF(CHORDAL='YES')
    CALL UUSTM1(NF,$IH(NF+1)-1,MH,MMAX,$H,$IH,$JH,$B,$GN,$XS,$S,$XO,$GO&
,$IX,$PSL,$PERM,$WN11,$WN12,R,PO,ETA2,MET,MET1,1)
  $ELSE
    CALL UUSTM1(NF,$IH(NF+1)-1,MH,MMAX,$H,$IH,$JH,$B,$GN,$XS,$S,$XO,$GO&
,$IX,$PSL,$PERM,$WN11,$WN12,R,PO,ETA2,MET,MET1,0)
  $ENDIF
  $ADD(INIT)
    NUXX='UUSTM1'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UUSTM1                ALL SYSTEMS                15/12/01
C PORTABILITY : ALL SYSTEMS
C 15/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* VARIABLE METRIC UPDATE OF A SPARSE SYMMETRIC POSITIVE DEFINITE MATRIX.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE MATRIX H.
*  RU  H(M)  POSITIVE DEFINITE APPROXIMATION OF THE SPARSE HESSIAN
*         MATRIX.
*  II  IH(NF)  POINTERS OF THE DIAGONAL ELEMENTS OF H.
*  II  JH(M)  INDICES OF THE NONZERO ELEMENTS OF H.
*  RI  G(NF)  GRADIENT OF THE OBJECTIVE FUNCTION.
*  RA  XS(NF)  AUXILIARY WECTOR.
*  RA  S(NF)  AUXILIARY VECTOR.
*  RU  XO(NF)  VECTORS OF VARIABLES DIFFERENCE.
*  RI  GO(NF)  GRADIENTS DIFFERENCE.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RO  R  VALUE OF THE STEPSIZE PARAMETER.
*  RI  PO  INITIAL VALUE OF THE DIRECTIONAL DERIVATIVE.
*  II  MET1  SELECTION OF SELF SCALING. MET1=1-SELF SCALING SUPPRESSED.
*         MET1=2-INITIAL SELF SCALING. MET1=3-SELF SCALING IN EACH
*         ITERATION.
*  II  JOB  TYPE OF MATRIX PATTERN. JOB=0-STANDARD PATTERN. 
*         JOB=1-CHORDAL PATTERN.     
*
* COMMON DATA :
*  IO  ITERH  TERMINATION INDICATOR. ITERH<0-BAD DECOMPOSITION.
*         ITERH=0-SUCCESSFUL UPDATE. ITERH>0-NONPOSITIVE PARAMETERS.
*  II  ITERD  TERMINATION INDICATOR. ITERD<0-BAD DECOMPOSITION.
*         ITERD=0-DESCENT DIRECTION. ITERD=1-NEWTON LIKE STEP.
*         ITERD=2-INEXACT NEWTON LIKE STEP. ITERD=3-BOUNDARY STEP.
*         ITERD=4-DIRECTION WITH THE NEGATIVE CURVATURE.
*         ITERD=5-MARQUARDT STEP.
*  II  IDECF  DECOMPOSITION INDICATOR. IDECF=0-NO DECOMPOSITION.
*  II  NIT  ACTUAL NUMBER OF ITERATIONS.
*  II  KIT  NUMBER OF THE ITERATION AFTER LAST RESTART.
*  TO  TUXX  TEXT INFORMATION ON THE CORRECTION USED.
*
* SUBPROGRAMS USED :
*  S   UXSSMM  MATRIX-VECTOR PRODUCT.
*  S   UXUDIF  DIFFERENCE OF TWO VECTORS.
*  S   UXUDIR  VECTOR AUGMENTED BY THE SCALED VECTOR.
*  RF  UXUDOT  DOT PRODUCT OF VECTORS.
*  S   UXVSCL  SCALING OF A VECTOR.
*  S   UOERR1  ERROR MESAGES.
*
      SUBROUTINE UUSTM1(NF,M,MH,MMAX,H,IH,JH,Q,G,XS,S,XO,GO,IX,PSL,
     & PERM,WN11,WN12,R,PO,ETA2,MET,MET1,JOB)
      $INCLUDE('UMCOMM')
      INTEGER NF,M,MH,MMAX,IH(NF+1),JH(M),IX(NF),PSL(NF),PERM(NF),
     & WN11(NF+1),WN12(NF+1),MET,MET1,JOB
      $FLOAT H(M),Q(M),G(NF),S(NF),XO(NF),GO(NF),XS(NF),R,PO,ETA2
      INTEGER MM,I,J,JSTRT,JSTOP,K,ITERX,INF
      $FLOAT UXUDOT
      $FLOAT A,B,C,GAM,TEMP
      LOGICAL L1,L2
      IF (IDECF.NE.0) THEN
      ITERH=-1
      TUXX='BAD DEC0'
      CALL UOERR1('UUSTM1',1)
      GO TO 500
      ENDIF
      MM=IH(NF+1)-1
C
C     DETERMINATION OF THE PARAMETER C AND THE VECTOR S
C
      L1=MET1.GE.3.OR.MET1.GE.2.AND.NIT.EQ.KIT
      L2=L1.OR.MET.GT.1
      A=ZERO
      IF (L2) B=UXUDOT(NF,XO,GO,IX,KBF)
      IF (ITERD.NE.1) THEN
      CALL UXSSMM(NF,MM,H,IH,JH,XO,S)
      IF (L2) C=UXUDOT(NF,XO,S,IX,KBF)
      ELSE
      CALL UXUDIF(NF,GO,G,S,IX,KBF)
      CALL UXVSCL(NF,R,S,S)
      IF (L2) C=-R*PO
      ENDIF
      GAM=ONE
      IF (B.GT.ZERO.AND.C.GT.ZERO) THEN
      IF (L1) THEN
C
C     SELF SCALING
C
      B=UXUDOT(NF,XO,GO,IX,KBF)
      GAM=C/B
      CALL UXVSCL(MM,ONE/GAM,H,H)
      CALL UXVSCL(NF,ONE/GAM,S,S)
      NSCL=NSCL+1
      ENDIF
      IF (MET.GT.1) THEN
      JSTOP=0
      DO 20 I=1,NF
        JSTRT=JSTOP+1
        JSTOP=IH(I+1)-1
        IF (JH(JSTRT).GT.0) THEN
          DO 10 J=JSTRT,JSTOP
            K=JH(J)
            IF (K.GT.0) THEN
            H(J)=H(J)+GO(I)*GO(K)/B-S(I)*S(K)/C
            ENDIF
   10     CONTINUE        
        ENDIF
   20 CONTINUE
      CALL UXSSMM(NF,MM,H,IH,JH,XO,S)
      ENDIF
      ENDIF
      CALL UXUDIR(NF,-ONE,S,GO,S,IX,KBF)
      CALL UXVSET(NF,ZERO,XS)
C
C  COMPUTE MATRIX Q
C
      JSTOP=0
      DO 200 I=1,NF
        JSTRT=JSTOP+1
        JSTOP=IH(I+1)-1
        IF (JH(JSTRT).GT.0) THEN
          TEMP=ZERO
          DO 100 J=JSTRT,JSTOP
            K=JH(J)
            IF (K.GT.0) THEN
              Q(J)=XO(I)*XO(K)
              TEMP=TEMP+XO(K)*XO(K)
              IF(K.NE.I) XS(K)=XS(K)+XO(I)*XO(I)
            ENDIF
100       CONTINUE
          XS(I)=XS(I)+TEMP
        ENDIF
        Q(JSTRT)=Q(JSTRT)+XS(I)                 
200   CONTINUE
      CALL UXSPCT(NF,MM,MH,MMAX,Q,JH,PSL,ITERX)
      IF(ITERX.NE.0) THEN
      TUXX='LACK SPC'
      RETURN
      ENDIF
      TEMP=ETA2
      CALL UXSPQF(NF,MMAX-MM,Q(MM+1),PSL,JH(MM+1),WN11,WN12,XS,INF)
      IF (JOB.EQ.0) THEN
      CALL UXVSFP(NF,PERM,S,XS)
      CALL UXSPQB(NF,MMAX-MM,Q(MM+1),PSL,JH(MM+1),S,0)
      CALL UXVSBP(NF,PERM,S,XS)
      ELSE
      CALL UXSPQB(NF,MMAX-MM,Q(MM+1),PSL,JH(MM+1),S,0)
      ENDIF
C
C  UPDATE MATRIX
C
      JSTOP=0
      DO 400 I=1,NF
        JSTRT=JSTOP+1
        JSTOP=IH(I+1)-1
        IF (JH(JSTRT).GT.0) THEN
         DO 300 J=JSTRT,JSTOP
            K=JH(J)
            IF (K.GT.0) THEN
              H(J)=H(J) + XO(I)*S(K) + XO(K)*S(I)
            ENDIF
300       CONTINUE
        ENDIF
400   CONTINUE
      TUXX='TOINT   '
      NUPD=NUPD+1
      ITERH=0
500   CONTINUE
      RETURN
      END
