  $INTERFACE UUVLV7                                             13/12/01
$REM VL

  $ADD(REAL,'\$XM($NF*$MF)\$GM($NF*$MF)\$XR(2*$MF*$MF)&
  \$GR($MF*($MF+1)/2)\$RW(9*$MF)')
  $ADD(REAL,'\B\BB')
  $ADD(INTEGER,'\$IW(5*$MF)\MX')
  $ADD(REAL,'\UXVDOT')
  $HELP
    MAXIMUM NUMBER OF CORRECTIONS: 0 < MET3 < 5
  $CHECK(MET3,4,'\1\2\3\4',4)   
  CALL UUVLV7($N,MX,MF,$XR,$GR,$XM,$GM,$GN,$XO,$GO,$XR(MF*MF+1)&
,$RW(8*MF+1),$RW,$RW(MF+1),$RW(2*MF+1),$IW,B,R,BB,PO,MET3)
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UUVLV7                ALL SYSTEMS                31/12/13
C PORTABILITY : ALL SYSTEMS
C 31/12/13 VL :                                       ORIGINAL VERSION
*
* PURPOSE :
* UPDATE OF USED VECTORS AND MATRICES.
*
* PARAMETERS :
*  IU  N  NUMBER OF ROWS OF  MATRICES XM, GM.
*  IU  M  NUMBER OF COLUMNS OF MATRICES XM, GM.
*  II  MM  MAXIMUM NUMBER OF COLUMNS OF MATRICES XM, GM.
*  RU  XR(MM,MM) MATRIX  TRANS(XM)*GM.
*  RU  GR(MM*(MM+1)/2)  SYMMETRIC MATRIX TRANS(GM)*GM STORED COLUMNWISE.
*  RU  XM(N*MM)  TRANSFORMED RECTANGULAR MATRIX OF VARIABLES DIFFERENCES.
*  RU  GM(N*MM)  TRANSFORMED RECTANGULAR MATRIX OF GRADIENTS DIFFERENCES.
*  RI  G(N)  GRADIENT VECTOR.
*  RI  XO(N)  VECTOR OF VARIABLES DIFFERENCES.
*  RI  GO(N)  VECTOR OF GRADIENTS DIFFERENCES.
*  RU  RV(MM*(MM+1)/2)  UPPER TRIANGULAR PART OF XR STORED COLUMNWISE.
*  RU  DV(MM)  DIAGONAL OF MATRIX XR.
*  RU  SG(MM)  VECTOR TRANS(XM)*G.
*  RU  YG(MM)  VECTOR TRANS(GM)*G.
*  RA  WW(6*MM)  AUXILIARY ARRAY.
*  IA  IND(5*MM)  AUXILIARY ARRAY. 
*  RI  B  INPUT PARAMETER B = TRANS(XO)*GO.
*  RI  T  INPUT STEPSIZE PARAMETER.
*  RI  AH  INPUT PARAMETER  AH = TRANS(GO)*GO.
*  RI  PO  OLD DIRECTIONAL DERIVATIVE.
*  II  MC  MAXIMUM NUMBER OF CORRECTION VECTORS.
*
* SUBPROGRAMS USED :
*  S   UULBV1  CORRECTION TRANSFORMATION OF USED VECTORS AND MATRICES.
*  S   UXDRMW  MULTIPLICATION OF TWO RECTANGULAR MATRICES STORED
*         ROWWISE BY A VECTOR.
*
* METHOD :
*
      SUBROUTINE UUVLV7(N,M,MM,XR,GR,XM,GM,G,XO,GO,RV,DV,SG,YG,WW,IND,
     & B,T,AH,PO,MC)
      INTEGER N,M,MM,MC,IND(5*MM)
      $FLOAT XR(MM,MM),GR(MM*(MM+1)/2),XM(N*MM),GM(N*MM),G(N),XO(N),
     & GO(N),RV(MM*(MM+1)/2),DV(MM),SG(MM),YG(MM),WW(MM*6),B,T,AH,PO
      $FLOAT C,UXVDOT
      INTEGER I,J,K,L
      B=UXVDOT(N,XO,GO)
      AH=UXVDOT(N,GO,GO)
      C=-T*PO
C      
C     SHIFT M, XM, GM, XR, GR, RV, DV, IND
C
      IF (M.GE.MM)THEN
        DO I=1,M*N-N
          XM(I)=XM(I+N)
          GM(I)=GM(I+N)
        ENDDO
        DO I=1,M-1
          L=I*(I-1)/2+1
          DO J=1,I
            GR(L)=GR(L+I+1)
            RV(L)=RV(L+I+1)
            L=L+1
          ENDDO
          DO J=1,M-1
            XR(I,J)=XR(I+1,J+1)
          ENDDO
          DV(I)=DV(I+1)
          IND(4*MM+I)=IND(4*MM+I+1)
        ENDDO
        K=1
      ELSE
        M=M+1
        K=0
      ENDIF
C     
C     UPDATE XM, GM
C
      DO I=1,M+K-1
        WW(2*M+I)=-T*WW(I+K)
        WW(I)=SG(I)
        WW(I+M)=YG(I)
      ENDDO
      L=M*N-N
      DO I=1,N
        XM(L+I)=XO(I)
        GM(L+I)=GO(I)
      ENDDO
C      
C     COMPUTATION OF SG=TRANS(XM)*G, YG=TRANS(GM)*G
C
C      IF (M.GT.1)CALL UXDRMM(N,M-1,XM,G,SG)
C      IF (M.GT.1)CALL UXDRMM(N,M-1,GM,G,YG)
      IF (M.GT.1) CALL UXDRMW(N,M-1,XM,GM,G,G,SG,YG)
C      
C     UPDATE  XR, GR
C
      L=M*(M-1)/2
      DO I=1,M-1
        XR(M,I)=WW(I+M+M)
        XR(I,M)=SG(I)-WW(I+K)
        GR(L+I)=YG(I)-WW(I+M+K)
      ENDDO
      XR(M,M)=B
      GR(L+M)=AH
C      
C     SETTING TRIANGULAR MATRICES
C
        CALL UULBV1(N,M,MM,XR,GR,XM,GM,RV,DV,WW,IND,IND(MM+1),
     &  IND(2*MM+1),IND(3*MM+1),B,AH,C,MC)
      IF (M.EQ.MM)K=1
      DO J=1,M-K
        IND(J)=IND(3*MM+J+K)
      ENDDO
C      CALL UXDRMM(N,1,XM(M*N-N+1),G,SG(M))
C      CALL UXDRMM(N,1,GM(M*N-N+1),G,YG(M))
      CALL UXDRMW(N,1,XM(M*N-N+1),GM(M*N-N+1),G,G,SG(M),YG(M))
      RETURN
      END
