  $INTERFACE UUVLV9                                             13/12/01
$REM VL

  $ADD(REAL,'\$XM($NF*$MF)\$GM($NF*$MF)\$XR(2*$MF*$MF)&
  \$GR($MF*($MF+1)/2)\$RW(6*$MF)')
  $ADD(REAL,'\B\BB')
  $ADD(INTEGER,'\MX')
  $ADD(REAL,'\UXVDOT')
  $HELP
    MAXIMUM NUMBER OF CORRECTIONS: 0 < MET3 < 5
  $CHECK(MET3,4,'\1\2\3\4',4)   
  CALL UUVLV9($N,MX,MF,$XR,$GR,$XM,$GM,$GN,$XO,$GO&
,$RW,$RW(MF+1),$RW(2*MF+1),$RW(3*MF+1),B,R,BB)
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UUVLV9                ALL SYSTEMS                31/12/13
C PORTABILITY : ALL SYSTEMS
C 31/12/13 VL :                                       ORIGINAL VERSION
*
* PURPOSE :
* UPDATE OF USED VECTORS AND MATRICES.
*
* PARAMETERS :
*  IU  N  NUMBER OF ROWS OF  MATRICES XM, GM.
*  IU  M  NUMBER OF COLUMNS OF MATRICES XM, GM.
*  II  MM  MAXIMUM NUMBER OF COLUMNS OF MATRICES XM, GM.
*  RU  XR(MM*(MM+1)/2)  UPPER TRIANGULAR PART OF SY STORED COLUMNWISE.
*  RU  GR(MM*(MM+1)/2)  SYMMETRIC MATRIX TRANS(GM)*GM STORED COLUMNWISE.
*  RU  XM(N*MM)  TRANSFORMED RECTANGULAR MATRIX OF VARIABLES DIFFERENCES.
*  RU  GM(N*MM)  TRANSFORMED RECTANGULAR MATRIX OF GRADIENTS DIFFERENCES.
*  RI  G(N)  GRADIENT VECTOR.
*  RI  XO(N)  VECTOR OF VARIABLES DIFFERENCES.
*  RI  GO(N)  VECTOR OF GRADIENTS DIFFERENCES.
*  RU  SG(MM)  VECTOR TRANS(XM)*G.
*  RU  YG(MM)  VECTOR TRANS(GM)*G.
*  RU  DV(MM)  DIAGONAL OF MATRIX XR.
*  RA  WW(6*MM)  AUXILIARY ARRAY.
*  RI  B  INPUT PARAMETER B = TRANS(XO)*GO.
*  RI  T  INPUT STEPSIZE PARAMETER.
*  RI  AH  INPUT PARAMETER  AH = TRANS(GO)*GO.
*
* SUBPROGRAMS USED :
*  S   UXDRMW  MULTIPLICATION OF TWO RECTANGULAR MATRICES STORED
*         ROWWISE BY A VECTOR.
*
* METHOD :
*
      SUBROUTINE UUVLV9(N,M,MM,XR,GR,XM,GM,G,XO,GO,SG,YG,DV,WW,B,T,AH)
      INTEGER N,M,MM
      $FLOAT XR(MM*(MM+1)/2),GR(MM*(MM+1)/2),XM(N*MM),GM(N*MM),G(N),
     & XO(N),GO(N),SG(MM),YG(MM),DV(MM),WW(3*MM),B,T,AH
      $FLOAT UXVDOT
      INTEGER I,J,K,L
      B=UXVDOT(N,XO,GO)
      AH=UXVDOT(N,GO,GO)
C      
C     SHIFT M, XM, GM, XR, GR, RV, DV, IND
C
      IF (M.GE.MM)THEN
        DO I=1,M*N-N
          XM(I)=XM(I+N)
          GM(I)=GM(I+N)
        ENDDO
        DO I=1,M-1
          L=I*(I-1)/2+1
          DO J=1,I
            XR(L)=XR(L+I+1)
            GR(L)=GR(L+I+1)
            L=L+1
          ENDDO
        ENDDO
        K=1
      ELSE
        M=M+1
        K=0
      ENDIF
C     
C     UPDATE XM, GM
C
      DO I=1,M+K-1
        WW(2*M+I)=-T*WW(I+K)
        WW(I)=SG(I)
        WW(I+M)=YG(I)
      ENDDO
      L=M*N-N
      DO I=1,N
        XM(L+I)=XO(I)
        GM(L+I)=GO(I)
      ENDDO
C      
C     COMPUTATION OF SG=TRANS(XM)*G, YG=TRANS(GM)*G
C
C      IF (M.GT.1)CALL UXDRMM(N,M-1,XM,G,SG)
C      IF (M.GT.1)CALL UXDRMM(N,M-1,GM,G,YG)
      IF (M.GT.1) CALL UXDRMW(N,M-1,XM,GM,G,G,SG,YG)
C      
C     UPDATE  XR, GR
C
      L=M*(M-1)/2
      DO I=1,M-1
        XR(L+I)=SG(I)-WW(I+K)
        GR(L+I)=YG(I)-WW(I+M+K)
      ENDDO
      XR(L+M)=B
      GR(L+M)=AH
      K=0
      DO J=1,M
        K=K+J
        DV(J)=XR(K)
      ENDDO  
C      
C     SETTING TRIANGULAR MATRICES
C
C      CALL UXDRMM(N,1,XM(M*N-N+1),G,SG(M))
C      CALL UXDRMM(N,1,GM(M*N-N+1),G,YG(M))
      CALL UXDRMW(N,1,XM(M*N-N+1),GM(M*N-N+1),G,G,SG(M),YG(M))
      RETURN
      END
