* SUBROUTINE UXBSDA                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* BLOCKS OF THE SYMMETRIC BLOCKED MATRIX ARE AUGMENTED BY THE SCALED
* UNIT MATRIX.
*
* PARAMETERS :
*  II  NBLA  DIMENSION OF THE ARRAY ABL.
*  II  NBLKS  NUMBER OF BLOCKS OF THE MATRIX.
*  RI  ABL(NBLA)  VALUES OF THE NONZERO ELEMENTS OF THE MATRIX.
*  II  IBLBG(NBLKS+1)  BEGINNINGS OF THE BLOCKS IN THE MATRIX.
*  RI  ALF  SCALING FACTOR.
*
* SUBROUTINES USED :
*  UXDSDA  DENSE SYMMETRIC MATRIX IS AUGMENTED BY THE SCALED UNIT
*  MATRIX.
*
      SUBROUTINE UXBSDA(NBLA,NBLKS,ABL,IBLBG,ALF)
      INTEGER NBLKS,NBLA,IBLBG(NBLKS+1)
      $FLOAT ABL(NBLA),ALF
      INTEGER I,K,KBEG,KLEN
      K=1
      DO 1 I=1,NBLKS
      KBEG=IBLBG(I)
      KLEN=IBLBG(I+1)-KBEG
      CALL UXDSDA(KLEN,ABL(K),ALF)
      K=K+KLEN*(KLEN+1)/2
   1  CONTINUE
      RETURN
      END
