* SUBROUTINE UXBSMX                ALL SYSTEMS                94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* BLOCKS OF THE SYMMETRIC BLOCKED MATRIX ARE SET TO ITS INVERSES.
*
* PARAMETERS :
*  II  NBLA  DIMENSION OF THE ARRAY ABL.
*  II  NBLKS  NUMBER OF BLOCKS OF THE MATRIX.
*  RI  ABL(NBLA)  VALUES OF THE NONZERO ELEMENTS OF THE MATRIX.
*  II  IBLBG(NBLKS+1)  BEGINNINGS OF THE BLOCKS IN THE MATRIX.
*
* SUBROUTINES USED :
*  UXDSMI  DENSE SYMMETRIC MATRIX IS SET TO THE UNIT MATRIX.
*
      SUBROUTINE UXBSMX(NBLA,NBLKS,ABL,IBLBG,INF,TOL)
      INTEGER NBLKS,NBLA,IBLBG(NBLKS+1),INF
      $FLOAT ABL(NBLA),TOL
      INTEGER I,K,KBEG,KLEN,INFI
      $FLOAT ALF,TAU
      K=1
      INF=0
      DO 1 I=1,NBLKS
      KBEG=IBLBG(I)
      KLEN=IBLBG(I+1)-KBEG
      ALF=TOL
      CALL UXDPGF(KLEN,ABL(K),INFI,ALF,TAU)
      IF (INFI.LT.0.AND.INF.EQ.0) INF=INFI
      IF (INFI.GT.0) INF=I
      CALL UXDPGI(KLEN,ABL(K))
      K=K+KLEN*(KLEN+1)/2
   1  CONTINUE
      RETURN
      END
