* SUBROUTINE UXDCHB               ALL SYSTEMS                16/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* VECTOR B IS PREMULTIPLIED BY THE ORTHOGONAL MATRIX TRANS(Q) AFTER QR
* DECOMPOSITION.
*
* PARAMETERS :
*  II  N  NUMBER OF COLUMNS OF THE MATRIX A.
*  II  M  NUMBER OF ROWS OF THE MATRIX A.
*  RI  A(M*N)  RECTANGULAR MATRIX STORED COLUMNMWISE IN THE
*         ONE-DIMENSIONAL ARRAY.
*  II  IA(N)  A PERMUTATION FIELD WHICH CONTAINS AN INFORMATION ABOUT
*         PERMUTATION MATRIX.
*  RU  B(M)  ON INPUT THE RIGHT HAND SIDE. ON OUTPUT THE TRANSFORMED
*         RIGHT HAND SIDE.
*  RO  D(N)  VECTOR CONTAINING INFORMATION ABOUT HOUSEHOLDER
*         TRANSFORMATIONS.
*  IO  NM  ASSUMED RANK OF THE MATRIX A. 
*
      SUBROUTINE UXDCHB(N,M,A,IA,B,D,NM)
      INTEGER N,M,IA(N),NM
      $FLOAT A(M*N),B(M),D(N)
      $FLOAT POM,UXVDOT
      INTEGER J,K,L,KP
      DO 3 K=1,NM
      L=K+1
      J=IA(K)
      KP=(J-1)*M
      IF (K.LT.M) THEN
      POM=D(J)*B(K)+UXVDOT(M-K,A(KP+L),B(L))
      ELSE
      POM=D(J)*B(K)
      ENDIF
      B(K)=B(K)-POM
      POM=POM/D(J)
      IF (K.LT.M) CALL UXVDIR(M-K,-POM,A(KP+L),B(L),B(L))
    3 CONTINUE
      RETURN
      END
