* SUBROUTINE UXDCMW               ALL SYSTEMS                14/12/01
C PORTABILITY : ALL SYSTEMS
C 14/12/01 VL : ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF COLUMNWISE STORED DENSE RECTANGULAR MATRICES A1, A2
* BY A VECTOR X AND ADDITION OF THE SCALED VECTOR ALF*Y.
*
* PARAMETERS :
*  II  N  NUMBER OF ROWS OF THE MATRIX A.
*  II  M  NUMBER OF COLUMNS OF THE MATRIX A.
*  RI  A1(N*M)  RECTANGULAR MATRIX STORED COLUMNWISE IN THE
*         ONE-DIMENSIONAL ARRAY.
*  RI  A2(N*M)  RECTANGULAR MATRIX STORED COLUMNWISE IN THE
*         ONE-DIMENSIONAL ARRAY.
*  RI  X1(M)  INPUT VECTOR.
*  RI  X2(M)  INPUT VECTOR.
*  RU  Y1(N)  OUTPUT VECTOR EQUAL TO A1*X1+Y1.
*  RU  Y2(N)  OUTPUT VECTOR EQUAL TO A2*X2+Y2.
*
      SUBROUTINE UXDCMW(N,M,A1,A2,X1,X2,Y1,Y2)
      INTEGER M,N
      $FLOAT A1(N*M),A2(N*M),X1(M),X2(M),Y1(N),Y2(N)
      INTEGER I,J,L
      $FLOAT W1,W2
      L=0
      DO J=1,M
        W1=X1(J)
        W2=X2(J)
        IF (W1*W1+W2*W2.NE.0.0$P 0) THEN
          DO I=1,N
            Y1(I)=Y1(I)+A1(L+I)*W1
            Y2(I)=Y2(I)+A2(L+I)*W2
          ENDDO
        ENDIF
        L=L+N
      ENDDO
      RETURN
      END
