* SUBROUTINE UXDCMX                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SCALING FACTORS FOR A COLUMNWISE STORED DENSE RECTANGULAR MATRIX.
* THESE SCALING FACTORS ARE NORMS OF THE CORRESPONDING COLUMNS.
*
* PARAMETERS :
*  II  N  NUMBER OF COLUMNS OF THE MATRIX A.
*  II  M  NUMBER OF ROWS OF THE MATRIX A.
*  RI  A(M*N)  RECTANGULAR MATRIX STORED ROWWISE IN THE
*         ONE-DIMENSIONAL ARRAY.
*  RO  X(N)  VECTOR OF SCALING FACTORS.
*
      SUBROUTINE UXDCMX(N,M,A,X)
      INTEGER N,M
      $FLOAT A(M*N),X(N)
      INTEGER I,K
      $FLOAT TEMP,UXVDOT
      $FLOAT ZERO,ONE,CON,CON1,CON2
      PARAMETER (ZERO=0.0$P 0,ONE=1.0$P 0,CON=1.0$P-60,CON1=2.0$P-5,
     & CON2=1.0$P 5)
      K=1
      DO 3 I=1,N
      TEMP=UXVDOT(M,A(K),A(K))
      TEMP=ONE/SQRT(MAX(TEMP,CON))
      IF (TEMP.LE.CON1) TEMP=CON1
      IF (TEMP.GE.CON2) TEMP=CON2
      X(I)=TEMP
      CALL UXVSCL(M,TEMP,A(K))
      K=K+M
    3 CONTINUE
      RETURN
      END
