* SUBROUTINE UXDCRC                ALL SYSTEMS                16/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* CORRECTION OF A SINGULAR DENSE SYMMETRIC POSITIVE SEMIDEFINITE MATRIX
* A DECOMPOSED AS A=TRANS(R)*R.
*
* PARAMETERS :
*  II  N  NUMBER OF COLUMNS OF THE MATRIX A.
*  II  M  NUMBER OF ROWS OF THE MATRIX A.
*  RU  A(M,N)  UPPER TRIANGULAR MATRIX STORED COLUMNWISE IN THE
*         TWO-DIMENSIONAL ARRAY.
*  IO  INF  AN INFORMATION OBTAINED IN THE CORRECTION PROCESS. IF
*         INF=0 THEN A IS SUFFICIENTLY POSITIVE DEFINITE. IF
*         INF<0 THEN A IS NOT SUFFICIENTLY POSITIVE DEFINITE.
*  RI  TOL  DESIRED TOLERANCE FOR POSITIVE DEFINITENESS.
*
      SUBROUTINE UXDCRC(N,M,A,INF,TOL)
      INTEGER N,M,INF
      $FLOAT  A(N*M),TOL
      $FLOAT TOL1,TEMP
      INTEGER I,K,L
      $FLOAT ZERO
      PARAMETER (ZERO=0.0$P 0)
      INF=0
      TOL1=SQRT(TOL)
      TEMP=TOL1
      L=0
      DO 4 K=1,N
      DO 3 I=1,K
      TEMP=MAX(TEMP,ABS(A(I+L)))
    3 CONTINUE
      L=L+M
    4 CONTINUE
      TEMP=TEMP*TOL1
      L=0
      DO 1 K=1,N
      IF (ABS(A(K+L)).LE.TEMP) THEN
      A(K+L)=SIGN(TEMP,A(K+L))
      INF=-1
      ENDIF
      L=L+M
    1 CONTINUE
      RETURN
      END
