* SUBROUTINE UXDCUM                ALL SYSTEMS               16/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  TRANSFORMATION OF SOLUTION OBTAINED FROM THE TOTAL QR DECOMPOSITION.
*
* PARAMETERS :
*  II  N  NUMBER OF COLUMNS OF THE MATRIX A.
*  II  M  NUMBER OF ROWS OF THE MATRIX A.
*  RU  A(M*N)  RECTANGULAR MATRIX STORED COLUMNWISE IN THE
*         ONE-DIMENSIONAL ARRAY.
*  IO  IA(N)  A PERMUTATION FIELD WHICH CONTAINS AN INFORMATION ABOUT
*         PERMUTATION MATRIX.
*  RU  B(M)  TRANSFORMED RIGHT HAND SIDE.
*  RU  X(N)  SOLUTION VECTOR.
*  II  NP  PSAUDORANK OF THE MATRIX A.
*  II  JOB  INDICATOR. IF JOB=0 OR JOB=1 THEN FULL QR FACTORIZATION
*         WAS NOT OR WAS USED RESPECTIVELY.
*
      SUBROUTINE UXDCUM(N,M,A,IA,X,B,NP,JOB)
      INTEGER N,M,IA(N),NP,JOB
      $FLOAT A(M*N),B(M),X(N)
      $FLOAT ZERO
      PARAMETER (ZERO=0.0$P 0)
      INTEGER I,J,K,L,JP,KP
      DO 1 K=1,M
      B(K)=ZERO
    1 CONTINUE
      IF (JOB.LE.0) THEN
      DO 3 K=1,NP
      DO 2 J=K,NP
      I=IA(J)
      JP=(I-1)*M
      B(K)=B(K)+A(K+JP)*X(I)
    2 CONTINUE
    3 CONTINUE
      ELSE
      DO 5 K=1,NP
      L=IA(K)
      KP=(I-1)*M
      DO 4 J=1,NP
      B(L)=B(L)+A(J+KP)*X(J)
    4 CONTINUE
    5 CONTINUE  
      ENDIF
      RETURN
      END
