* SUBROUTINE UXDRFR             ALL SYSTEMS                   05/12/01
C PORTABILITY : ALL SYSTEMS
C 05/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* OPERATIONS AFTER CONSTRAINT DELETION.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  II  NC  NUMBER OF CONSTRAINTS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  II  ICA(NF+1)  VECTOR CONTAINING INDICES OF ACTIVE FUNCTIONS.
*  RI  CR((NF+1)*(NF+2)/2)  TRIANGULAR DECOMPOSITION OF KERNEL OF THE
*         ORTHOGONAL PROJECTION.
*  RA  G(NF+1)  AUXILIARY VECTOR.
*  II  IOLD  INDEX OF THE OLD ACTIVE CONSTRAINT.
*  IO  KREM  AUXILIARY VARIABLE.
*  IO  IER  ERROR INDICATOR.
*
      SUBROUTINE UXDRFR(NF,N,NC,IC,ICA,CR,G,IOLD,KREM,IER)
      INTEGER NF,N,NC,IC(NC),ICA(NF+1),IOLD,KREM,IER
      $FLOAT CR((NF+1)*(NF+2)/2),G(NF+1)
      INTEGER NCA,I,J,K,L,KC
      $FLOAT CK,CL
      NCA=NF-N
      IF (IOLD.LT.NCA) THEN
      K=IOLD*(IOLD-1)/2
      KC=ICA(IOLD)
      CALL UXVCOP(IOLD,CR(K+1),G)
      CALL UXVSET(NCA-IOLD,0.0$P 0,G(IOLD+1))
      K=K+IOLD
      DO 2 I=IOLD+1,NCA
      K=K+I
      CALL UXVORT(CR(K-1),CR(K),CK,CL,IER)
      CALL UXVROT(G(I-1),G(I),CK,CL,IER)
      L=K
      DO 1 J=I,NCA-1
      L=L+J
      CALL UXVROT(CR(L-1),CR(L),CK,CL,IER)
    1 CONTINUE
    2 CONTINUE
      K=IOLD*(IOLD-1)/2
      DO 3 I=IOLD,NCA-1
      L=K+I
      ICA(I)=ICA(I+1)
      CALL UXVCOP(I,CR(L+1),CR(K+1))
      K=L
    3 CONTINUE
      ICA(NCA)=KC
      CALL UXVCOP(NCA,G,CR(K+1))
      ENDIF
      KREM=1
C      CALL ULRMR0(NF,N,ICA,CR,G,IOLD,KREM,IER)
      N=N+1
      L=ICA(NF-N+1)
      IC(L)=-IC(L)
      RETURN
      END


