* SUBROUTINE UXDRFT               ALL SYSTEMS                05/12/01
C PORTABILITY : ALL SYSTEMS
C 05/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* MAXIMUM ABSOLUTE VALUE OF THE NEGATIVE LAGRANGE MULTIPLIER IS
* COMPUTED.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  II  NC  NUMBER OF LINEARIZED CONSTRAINTS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  II  ICA(NF+1)  VECTOR CONTAINING INDICES OF ACTIVE FUNCTIONS.
*  RO  CZ(NF+1)  VECTOR OF LAGRANGE MULTIPLIERS.
*  RI  EPS7  TOLERANCE FOR LINEAR AND QUADRATIC PROGRAMMING.
*  RO  UMAX  MAXIMUM ABSOLUTE VALUE OF THE NEGATIVE LAGRANGE MULTIPLIER.
*  IO  IOLD  INDEX OF THE REMOVED CONSTRAINT.
*
      SUBROUTINE UXDRFT(NF,N,NC,IC,ICA,CZ,EPS7,UMAX,IOLD)
      INTEGER NF,N,NC,IC(NC),ICA(NF+1),IOLD
      $FLOAT CZ(NF+1),EPS7,UMAX
      $FLOAT TEMP
      INTEGER NCA,J,K,L
      IOLD=0
      UMAX=0.0$P 0
      NCA=NF-N
      DO 2 J=1,NCA
      TEMP=CZ(J)
      L=ICA(J)
      K=IC(L)
C      IF (K.LE.-10) THEN
C      ELSE IF (K.EQ.-1.AND.UMAX+TEMP.GE.0.0$P 0) THEN
      IF (K.EQ.-1.AND.UMAX+TEMP.GE.0.0$P 0) THEN
      ELSE IF (K.EQ.-2.AND.UMAX-TEMP.GE.0.0$P 0) THEN
      ELSE
      IOLD=J
      UMAX=ABS(TEMP)
      ENDIF
    2 CONTINUE
      IF (UMAX.LE.EPS7) IOLD=0
      RETURN
      END
