* SUBROUTINE UXDRMO               ALL SYSTEMS                17/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* ROWWISE STORED DENSE RECTANGULAR MATRIX A IS AUGMENTED BY THE SCALED   
* UNIT MATRIX.
*
* PARAMETERS :
*  II  N  NUMBER OF COLUMNS OF THE MATRIX A.
*  II  M  NUMBER OF ROWS OF THE MATRIX A.
*  IO  NM  NUMBER OF ROWS OF THE AUGMENTED MATRIX.
*  II  ALF  INPUT PARAMETER.
*  RI  A(M*N)  RECTANGULAR MATRIX STORED ROWWISE IN THE 
*         ONE-DIMENSIONAL ARRAY. 
*  RO  AO((N+M)*N)  RECTANGULAR MATRIX STORED ROWWISW IN THE
*         ONE-DIMENSIONAL EQUAL TO TRANS([TRANS(A),I]).
*         
      SUBROUTINE UXDRMO(N,M,NM,ALF,A,AO)
      INTEGER N,M,NM
      $FLOAT ALF,A(M*N),AO((N+M)*N)
      INTEGER I,J,K
      $FLOAT ZERO
      PARAMETER (ZERO=0.0$P 0)
      NM=N+M
      K=N*M
      CALL UXVCOP(K,A,AO)
      DO 2 J=1,N
      DO 1 I=1,N
      AO(I+K)=ZERO
      IF (I.EQ.J) AO(I+K)=ALF
    1 CONTINUE
      K=K+N
    2 CONTINUE
      RETURN
      END
