* SUBROUTINE UXDRTM                ALL SYSTEMS               93/12/01
C PORTABILITY : ALL SYSTEMS
C 93/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  TRANSFORMATION OF SOLUTION OBTAINED FROM THE TOTAL QR DECOMPOSITION.
*
* PARAMETERS :
*  II  N  NUMBER OF COLUMNS OF THE MATRIX A.
*  II  M  NUMBER OF ROWS OF THE MATRIX A.
*  RU  A(M*N)  RECTANGULAR MATRIX STORED ROWWISE IN THE
*         ONE-DIMENSIONAL ARRAY.
*  IO  IA(N)  A PERMUTATION FIELD WHICH CONTAINS AN INFORMATION ABOUT
*         PERMUTATION MATRIX.
*  RU  X(N)  SOLUTION VECTOR.
*  RO  D(N)  VECTOR CONTAINING INFORMATION ABOUT HOUSEHOLDER
*         TRANSFORMATIONS.
*  II  NP  PSAUDORANK OF THE MATRIX A.
*
      SUBROUTINE UXDRTM(N,M,A,IA,X,D,NP)
      INTEGER N,M,IA(N),NP
      $FLOAT A(M*N),X(M),D(N)
      $FLOAT POM
      $FLOAT ZERO
      PARAMETER (ZERO=0.0$P 0)
      INTEGER J,K,L,JP,KP
      IF (NP.LT.N) THEN
      L=NP*N
      DO 6 K=NP,1,-1
      L=L-N
      KP=IA(K)
      POM=D(KP)*X(KP)
      DO 4 J=NP+1,N
      JP=IA(J)
      POM=POM+A(L+JP)*X(JP)
    4 CONTINUE
      X(KP)=X(KP)-POM
      POM=POM/D(KP)
      DO 5 J=NP+1,N
      JP=IA(J)
      X(JP)=X(JP)-POM*A(L+JP)
    5 CONTINUE
    6 CONTINUE
      ENDIF
      RETURN
      END
