* SUBROUTINE UXDSGI                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INVERSION OF A DENSE SYMMETRIC MATRIX A+E USING THE DECOMPOSITION
*  A+E=L*D*TRANS(D) OBTAINED BY THE SUBROUTINE UXDPGF.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A
*  RU  A(N*(N+1)/2)  ON INPUT THE DECOMPOSITION
*         A+E=P*L*D*TRANS(L)*TRANS(P) OBTAINED BY THE SUBROUTINE
*         UXDPGF. ON OUTPUT THE INVERSION (A+E)**(-1).
*  II  IA(N)  A PERMUTATION FIELD WHICH CONTAINS AN INFORMATION ABOUT
*         PERMUTATION MATRIX P.
*
* METHOD :
*  INVERSION OF THE LOWER TRIANGULAR MATRIX L AND BACK MULTIPLICATION
*  (A+E)**(-1) = (TRANS(L)*TRANS(P))**(-1)*D**(-1)*(P*L)**(-1).
*
      SUBROUTINE UXDSGI(N,A,IA)
      INTEGER  N,IA(N)
      $FLOAT  A(N*(N+1)/2)
      $FLOAT  AII,AIJ,AIK
      INTEGER  I,J,K,IP,JP,KP,II,IJ,IK,KJ,KK,IND
      $FLOAT  ONE
      PARAMETER(ONE=1.0$P 0)
      IND(I,J)=MAX(I,J)*(MAX(I,J)-1)/2+MIN(I,J)
C
C     INVERSION OF THE LOWER TRIANGULAR MATRIX L
C
      DO 3 I=1,N
      IP=IA(I)
      II=IND(IP,IP)
      A(II)=ONE/A(II)
      DO 2 J=I+1,N
      JP=IA(J)
      IJ=IND(IP,JP)
      AIJ=-A(IJ)
      DO 1 K=I+1,J-1
      KP=IA(K)
      IK=IND(IP,KP)
      KJ=IND(KP,JP)
      AIJ=AIJ-A(IK)*A(KJ)
    1 CONTINUE
      A(IJ)=AIJ
    2 CONTINUE
    3 CONTINUE
C
C     BACK MULTIPLICATION (A+E)**(-1)= TRANS(L**(-1))*D**(-1)*L**(-1)
C
      DO 7 I=1,N
      IP=IA(I)
      II=IND(IP,IP)
      AII=A(II)
      DO 4 K=I+1,N
      KP=IA(K)
      IK=IND(IP,KP)
      KK=IND(KP,KP)
      AIK=A(IK)*A(KK)
      AII=AII+A(IK)*AIK
      A(IK)=AIK
    4 CONTINUE
      A(II)=AII
      DO 6 J=I+1,N
      JP=IA(J)
      IJ=IND(IP,JP)
      AIJ=A(IJ)
      DO 5 K=J+1,N
      KP=IA(K)
      IK=IND(IP,KP)
      KJ=IND(KP,JP)
      AIJ=AIJ+A(IK)*A(KJ)
    5 CONTINUE
      A(IJ)=AIJ
    6 CONTINUE
    7 CONTINUE
      RETURN
      END
