* SUBROUTINE UXDSGX                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SCALING FACTORS FOR A DENSE SYMMETRIC POSITIVE DEFINITE MATRIX A+E
* IN THE FACTORED FORM A+E=P*L*D*TRANS(L)*TRANS(P) OBTAINED BY THE
* SUBROUTINE UXDSGF.
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX A.
*  RU  A(N*(N+1)/2) FACTORIZATION A+E=L*D*TRANS(L) OBTAINED BY THE
*         SUBROUTINE UXDPGF.
*  II  IA(N)  A PERMUTATION FIELD WHICH CONTAINS AN INFORMATION ABOUT
*         PERMUTATION MATRIX P.
*  RO  X(N)  VECTOR OF SCALING FACTORS.
*
*
      SUBROUTINE UXDSGX( N, A, IA, X)
      INTEGER N, IA(N)
      $FLOAT  A(N*(N+1)/2), X(N)
      $FLOAT  TEMP
      INTEGER  I, J, IP, JP, II, IJ, IND
      $FLOAT ONE,CON1,CON2
      PARAMETER (ONE=1.0D 0,CON1=2.0D-5,CON2=1.0D 5)
      IND(I,J)=MAX(I,J)*(MAX(I,J)-1)/2+MIN(I,J)
      DO 2  I = 1, N
      IP = IA(I)
      TEMP=ONE
      DO 1  J = I+1, N
      JP = IA(J)
      IJ = IND(IP,JP)
      TEMP=TEMP+A(IJ)**2
    1 CONTINUE
      X(IP)=SQRT(TEMP)
      IF (X(IP).LE.CON1) X(IP)=CON1
      IF (X(IP).GE.CON2) X(IP)=CON2
    2 CONTINUE
      DO  3  I = 1, N
      IP=IA(I)
      II=IND(IP,IP)
      A(II)=A(II)*X(IP)**2
    3 CONTINUE
      RETURN
      END
