* SUBROUTINE UXDSMM                ALL SYSTEMS                89/12/01
C PORTABILITY : ALL SYSTEMS
C 89/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF A DENSE SYMMETRIC MATRIX A BY THE VECTOR X.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  RI  A(N*(N+1)/2)  DENSE SYMMETRIC MATRIX STORED IN THE PACKED FORM.
*  RI  X(N)  INPUT VECTOR.
*  RO  Y(N)  OUTPUT VECTOR EQUAL TO  A*X.
*
      SUBROUTINE UXDSMM(N,A,X,Y)
      INTEGER N
      $FLOAT  A(N*(N+1)/2), X(N), Y(N)
      $FLOAT TEMP
      INTEGER  I,J,K,L
      $FLOAT ZERO
      PARAMETER  (ZERO = 0.0$P 0)
      K=0
      DO  3  I = 1, N
      TEMP = ZERO
      L=K
      DO  1  J = 1, I
      L=L+1
      TEMP = TEMP + A(L) * X(J)
    1 CONTINUE
      DO  2  J = I+1, N
      L=L+J-1
      TEMP = TEMP + A(L) * X(J)
    2 CONTINUE
      Y(I)=TEMP
      K=K+I
    3 CONTINUE
      RETURN
      END
