* SUBROUTINE UXLSIB                ALL SYSTEMS                31/12/16
C PORTABILITY : ALL SYSTEMS
C 31/12/16 VL :                                       ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF  THE DIRECTION VECTOP BY THE BLOCK BNS METHOD.
*
* PARAMETERS :
*  II  N  NUMBER OF ROWS OF  MATRICES XM, GM.
*  II  M  NUMBER OF COLUMNS OF MATRICES XM, GM.
*  II  MM  MAXIMUM NUMBER OF COLUMNS OF MATRICES XM, GM.
*  RI  XR(MM,MM)  MATRIX  XM^T . GM .
*  RI  GR(MM*(MM+1)/2)  SYMMETRIC MATRIX  GM^T . GM  STORED COLUMNWISE.
*  RI  GRP(MM*MM)  MATRIX  E(~).
*  RI  XM(N*MM)  RECTANGULAR MATRIX OF VARIABLES DIFFERENCES.
*  RI  GM(N*MM)  RECTANGULAR MATRIX OF GRADIENTS DIFFERENCES.
*  RI  G(N)  NEW GRADIENT.
*  RU  S(N)  VECTOR OF VARIABLES DIFFERENCE.
*  RO  HLB(MM*MM)  BLOCK LOWER TRIANGULAR MATRIX  L_D(~).
*  RI  HRB(MM*MM)  BLOCK UPPER TRIANGULAR MATRIX  U.
*  RI  SG(M)  VECTOR  XM^T . G .
*  RI  YG(M)  VECTOR  GM^T . G .
*  RO  WW(3*M)  AUXILIARY VECTOR.
*  RI  BB  INPUT PARAMETER  DZETA = B/(Y^T . Y).
*
* SUBPROGRAMS USED :
*  S  UXDSMM  MULTIPLICATION OF SYMMETRIC MATRIX STORED COLUMNWISE
*             BY VECTOR.
*  S  UXDPRB  MULTIPLICATION OF INVERSION OF UPPER TRIANGULAR MATRIX
*             STORED COLUMNWISE BY VECTOR.
*  S  UXECMM  MULTIPLICATION OF TWO-DIMENSIONAL RECTANGULAR MATRIX BY VECTOR.
*
* METHOD :
*
      SUBROUTINE UXLSIB(N,M,MM,XR,GR,GRP,XM,GM,G,S,HLB,HRB,SG,YG,WW,BB)
      INTEGER I,J,L,M,MM,N
      $FLOAT GRP(MM,MM),G(N),S(N),SG(M),XM(M*N),XR(MM,MM),HLB(M*(M+1)/2)
      $FLOAT HRB(MM*MM),WW(3*M),YG(M),GR(M*(M+1)/2),GM(M*N),BB
c   ***  Comput. of  -H*g,  block BNS method
      WW(:M)=SG
      CALL UXVCOP(M,WW,WW(M+1)) 
      CALL UXDPRB(M,HRB,WW(M+1),-1)
      CALL UXDPRB(M,HLB,WW(M+1),1)
      CALL UXECMM(M,M,MM,GRP,WW(M+1),WW)
      CALL UXDSMM(M,GR,WW(M+1),WW(M+M+1))
      DO J=1,M
        S(J)=(WW(M+M+J)-YG(J))*BB
      END DO
      CALL UXDPRB(M,HLB,S,-1)
      DO J=1,M
        S(J)=WW(J)+S(J)
        WW(J)=S(J)
      END DO
      CALL UXDPRB(M,HRB,WW,1)
      S=-BB*G
      L=0
      DO J=1,M
        DO I=1,N
          S(I)=S(I)-XM(L+I)*WW(J)+(BB*GM(L+I))*WW(M+J)
        END DO
        L=L+N
      END DO
C   pro zrychl.vyp.  Y^T.S   v nasled.   UULBV4
      DO I=1,M
        WW(M+I)=0.0$P 0
        DO J=1,M
          WW(M+I)=WW(M+I)+XR(J,I)*WW(J)
        END DO
      END DO
      DO J=1,M
        WW(J)=WW(M+J)+BB*(YG(J)-WW(2*M+J))
      END DO
      RETURN
      END
