* SUBROUTINE UXPPGM                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* BACK SUBSTITUTION FOR A DECOMPOSED TRIDIAGONAL MATRIX.
*
* PARAMETERS :
*  II  N  ORDER OF THE TRIDIAGONAL MATRIX T.
*  RI  D(N)  ELEMENTS OF THE DIAGONAL MATRIX D IN THE DECOMPOSITION
*         T=L*D*TRANS(L).
*  RI  E(N)  THE FIRST SUBDIAGONAL ELEMENTS OF THE LOWER TRIANGULAR
*         MATRIX L IN THE DECOMPOSITION T=L*D*TRANS(L).
*  RI  F(N)  THE SECOND SUBDIAGONAL ELEMENTS OF THE LOWER TRIANGULAR
*         MATRIX L IN THE DECOMPOSITION T=L*D*TRANS(L).
*  RU  X(N)  ON INPUT THE GIVEN VECTOR. ON OUTPUT THE RESULT OF
*         MULTIPLICATION.
*         EQUATIONS.
*  II  JOB  OPTION. IF JOB=0 THEN X:=T*X. IF JOB>0 THEN
*         X:=TRANS(L)*X. IF JOB<0 THEN X:=L*X.
*
      SUBROUTINE UXPPGM(N,D,E,F,X,JOB)
      INTEGER N,JOB
      $FLOAT  D(N),E(N),F(N),X(N)
      INTEGER I
      IF (JOB.GE.0) THEN
C
C     PHASE 1 : X:=TRANS(L)*X
C
      DO 1 I=1,N-1
      X(I)=X(I)+X(I+1)*E(I)
      IF (I.LT.N-1) X(I)=X(I)+X(I+2)*F(I)
    1 CONTINUE
      ENDIF
      IF (JOB.EQ.0) THEN
C
C     PHASE 2 : X:=D*X
C
      DO 2 I=1,N
      X(I)=X(I)*D(I)
    2 CONTINUE
      ENDIF
      IF (JOB.LE.0) THEN
C
C     PHASE 3 : X:=L*X
C
      DO 3 I=N,2,-1
      X(I)=X(I)+X(I-1)*E(I-1)
      IF (I.GT.2) X(I)=X(I)+X(I-2)*F(I-2)
    3 CONTINUE
      ENDIF
      RETURN
      END
