* SUBROUTINE UXSGMC                ALL SYSTEMS                96/12/01
C PORTABILITY : ALL SYSTEMS
C 96/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* INCOMPLETE FACTORIZATION OF A GENERAL SPARSE MATRIX A.
*
* PARAMETERS :
*  II  N  MATRIX DIMENSION.
*  II  M  NUMBER OF MATRIX NONZERO ELEMENTS.
*  RU  A(M)  NONZERO ELEMENTS OF THE MATRIX A.
*  II  IA(N+1)  ROW POINTERS OF THE MATRIX A.
*  II  JA(M)  COLUMN INDICES OF THE MATRIX A.
*  IO  IP(N)  PERMUTATION VECTOR.
*  IO  ID(N)  DIAGONAL POINTERS OF THE MATRIX A.
*  RA  IW(N)  AUXILIARY VECTOR.
*  RI  TOL  PIVOT TOLERANCE.
*  IO  INF  INFORMATION.
*
      SUBROUTINE UXSGMC(N,M,A,IA,JA,TOL)
      INTEGER N,M,IA(N+1),JA(M)
      $FLOAT A(M),TOL
      INTEGER I,J,JJ,KSTRT,KSTOP
      $FLOAT ZERO,ONE
      PARAMETER (ZERO=0.0$P 0,ONE=1.0$P 0)
      IF (TOL.EQ.ZERO) RETURN
      DO 2 I=1,N
      KSTRT=IA(I)
      KSTOP=IA(I+1)-1
      DO 1 JJ=KSTRT,KSTOP
      J=JA(JJ)
      IF (J.EQ.I) THEN
      IF (TOL.GT.ZERO) A(JJ)=(ONE+TOL)*A(JJ)
      ENDIF
    1 CONTINUE
    2 CONTINUE
      RETURN
      END
