* SUBROUTINE UXSGUG                 ALL SYSTEMS                90/12/01
C PORTABILITY : ALL SYSTEMS
C 90/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* GARBAGE COLLECTION OF THE INDEX ARRAY CNR.
* THIS SUBROUTINE IS ALSO USED FOR GARBAGE COLLECTION
* OF THE INPUT STRUCTURES.
*
* PARAMETERS :
*  II  N  NUMBER OF ROWS OF THE SPARSE MATRIX
*  II  M  NUMBER OF PROCESSED COLUMNS THAT FORM THE COLUMS OF THE MATRIX
*         THAT DESCRIBES THE ACTIVE SET. M <= N.
*  II  NZ SIZE OF THE INDEX ARRAY CNR
*  II  NAU SIZE OF THE ARRAY THAT STORES THE NUMERICAL ELEMENTS OF
*          THE PROCESSED MATRIX.
*  IU  PTR(N) POINTER VECTOR OF THE ROWS OF THE FACTOR U.
*  II  LENR(N) LENGTHS OF THE ROWS OF THE FACTOR U.
*  IU  CNR(NZ) CONTAINS THE INDICES OF THE  ROW SCHEME
*              OF THE PROCESSED FACTOR U AND OF THE FACTOR L.
*  RU  AU(NAU) ELEMENTS OF THE PROCESSED SPARSE MATRIX.
*  IO  IBEG BEGINNING OF THE ROW SCHEME IN CNR. THAT MEANS THAT
*           ELEMENTS OF THE FACTOR L ARE AT THE POSITIONS 1,...
*           IBEG-1 AND THE ELEMENTS OF THE FACTOR U ARE AT THE
*  IO  IENDLU END OF THE COLUMN SCHEME IN CNR.
*
      SUBROUTINE UXSGUG(N,M,NZ,NAU,PTR,LENR,CNR,AU,IBEG,IENDLU)
      INTEGER N,M,NZ,NAU
      INTEGER PTR(N),LENR(N)
      INTEGER CNR(NZ)
      INTEGER IBEG,IENDLU
      $FLOAT  AU(NAU)
      $FLOAT AUI
      INTEGER I,J,K,L,ISTRT,IDIST
C
C     INITIALIZATION OF THE DISTANCE PARAMETER
C
      IDIST=0
C
C     MARK THE BEGINNINGS OF THE ROWS OF FACTOR U
C
      DO 100 I=1,M
      K=PTR(I)
      IF(LENR(I).NE.0) THEN
                       L=CNR(K)
                       CNR(K)=-I
                       PTR(I)=L
                       ELSE
                       PTR(I)=IBEG
      END IF
100   CONTINUE
C
C     GARBAGE COLLECTION OF THE ROWS OF THE FACTOR U
C
      ISTRT=IBEG
      I=IBEG
300   K=CNR(I)
      IF(K.LT.0) THEN
                 AUI=AU(I)
                 DO 400 J=1,LENR(-K)-1
                 CNR(ISTRT+J)=CNR(I+J)
                 AU(ISTRT+J)=AU(I+J)
400              CONTINUE
                 AU(ISTRT)=AUI
                 CNR(ISTRT)=PTR(-K)
                 PTR(-K)=ISTRT
                 ISTRT=ISTRT+LENR(-K)+IDIST
                 I=I+LENR(-K)
                 ELSE
                 I=I+1
      END IF
      IF(I.LT.IENDLU) GO TO 300
      DO 450 I=ISTRT,IENDLU
      CNR(I)=0
450   CONTINUE
      IENDLU=ISTRT-1
      RETURN
      END
