* SUBROUTINE UXSGUI                 ALL SYSTEMS                90/12/01
C PORTABILITY : ALL SYSTEMS
C 90/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* THIS SUBROUTINE ZEROES COLUMN INDICES OF THE FACTOR U OF CNR
* AND SETS THE IBEG: BEGINNING OF THE ROW INDICES IN U.
*
* PARAMETERS :
*  II  N NUMBER OF ROWS OF THE SPARSE MATRIX
*  II  NZ SIZE OF THE INDEX ARRAY CNR
*  IU  PTR(N) POINTER VECTOR OF THE ROWS OF THE FACTOR U.
*  IU  CNR(NZ) CONTAINS THE INDICES OF THE  ROW SCHEME
*              OF THE PROCESSED FACTOR U AND OF THE FACTOR L.
*  IO  IBEG BEGINNING OF THE ROW SCHEME IN CNR. THAT MEANS THAT
*           ELEMENTS OF THE FACTOR L ARE AT THE POSITIONS 1,...
*           IBEG-1 AND THE ELEMENTS OF THE FACTOR U ARE AT THE
*  IU  IBGR ON INPUT: BEGINNING OF THE COLUMN INDICES OF THE
*           FACTOR U. ON OUTPUT IS SET TO NZ.
*
      SUBROUTINE UXSGUI(N,NZ,PTR,CNR,IBEG,IBGR)
      INTEGER N,NZ
      INTEGER PTR(N)
      INTEGER CNR(NZ)
      INTEGER IBEG,IBGR
      INTEGER I
C
C     ZEROEING OF THE ARRAY OF COLUMN INDICES OF THE FACTOR U
C
      DO 100 I=IBGR,NZ-1
      CNR(I)=0
100   CONTINUE
      IBGR=NZ
C
C     FIND THE BEGINNING OF THE ARRAY OF THE ROW INDICES.
C
      IBEG=PTR(1)
      DO 200 I=1,N
      IBEG=MIN(PTR(I),IBEG)
200   CONTINUE
      RETURN
      END
