* SUBROUTINE UXSMIN                ALL SYSTEMS                16/12/01
C PORTABILITY : ALL SYSTEMS
C 96/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* NUMERICAL TRANSFORMATION OF THE PARTITIONED AUGMENTED SYSTEM MATRIX
* INTO THE COMPLETE SYMMETRIC STRUCTURE.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF  APPROXIMATING FUNCTIONS.
*  II  MA  NUMBER OF NONZERO ELEMENTS OF THE JACOBIAN MATRIX.
*  RI  AG(MA)  NONZERO ELEMENTS OF THE JACOBIAN MATRIX.
*  II  IAG(NA+1)  POINTERS OF THE JACOBIAN MATRIX.
*  II  JAG(MA)  COLUMN INDICES OF THE JACOBIAN MATRIX.
*  RO  B(MA+NA+N)  NONZERO ELEMENTS OF THE AUGMENTED SYSTEM MATRIX.
*  II  IB(N+NA+1)  POINTERS OF THE AUGMENTED SYSTEM MATRIX.
*
      SUBROUTINE UXSMIN(N,NA,MA,AG,IAG,JAG,B,IB)
      INTEGER N,NA,MA,IAG(NA+1),JAG(MA),IB(N+NA+1)
      REAL*8 AG(MA),B(MA+NA+N)
      INTEGER I,J,L,KA
      REAL ZERO,ONE
      PARAMETER (ZERO=0.0$P 0,ONE=1.0$P 0)
      DO 2 KA=1,NA
C
C     UNIT SUBMATRIX 
C
      L=IB(KA)
      B(L)=ONE
C
C     JACOBIAN SUBMATRIX
C
      DO 1 J=IAG(KA),IAG(KA+1)-1
      L=L+1
      IF (JAG(J).GT.0) THEN
      B(L)=AG(J)
      ELSE
      B(L)=ZERO
      ENDIF
    1 CONTINUE
    2 CONTINUE
C
C     ZERO SUBMATRIX
C
      DO 3 I=1,N
      B(IB(I+NA))=ZERO
    3 CONTINUE
      RETURN
      END
