* SUBROUTINE UXSMIS                ALL SYSTEMS                16/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SYMBOLIC TRANSFORMATION OF THE PARTITIONED AUGMENTED SYSTEM MATRIX
* INTO THE COMPLETE SYMMETRIC STRUCTURE.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATING FUNCTIONS.
*  II  MA  NUMBER OF NONZERO ELEMENTS OF THE JACOBIAN MATRIX.
*  II  IAG(NA+1)  POINTERS OF THE JACOBIAN MATRIX.
*  II  JAG(MA)  COLUMN INDICES OF THE JACOBIAN MATRIX.
*  IO  IB(NA+N+1)  POINTERS OF THE AUGMENTED SYSTEM MATRIX.
*  IO  JB(MA+NA+N)  COLUMN INDICES OF THE AUGMENTED SYSTEM MATRIX.
*
      SUBROUTINE UXSMIS(N,NA,MA,IAG,JAG,IB,JB)
      INTEGER N,NA,MA,IAG(NA+1),JAG(MA),IB(NA+N+1),JB(MA+NA+N)
      INTEGER I,J,K,KA
C
C     INITIAL COMPUTATION OF POINTERS
C
      K=0
      DO 2 KA=1,NA
C
C     UNIT SUBMATRIX
C
      K=K+1
      IB(KA)=K
      JB(K)=KA
C
C     JACOBIAN SUBMATRIX
C
      DO 1 J=IAG(KA),IAG(KA+1)-1
      K=K+1
      JB(K)=JAG(J)+NA
    1 CONTINUE
    2 CONTINUE
C
C     ZERO SUBMATRIX
C
      DO 3 I=1,N
      K=K+1
      IB(NA+I)=K
      JB(K)=NA+I
    3 CONTINUE
      IB(NA+N+1)=K+1 
      RETURN
      END
