* FUNCTION UXSPCQ                  ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE NUMBER UXSPCQ=TRANS(X)*D*X WHERE D IS A
* DIAGONAL MATRIX IN THE FACTORIZATION A+E=L*D*TRANS(L) OBTAINED BY THE
* SUBROUTINE UXSPGN. FACTORS ARE STORED IN THE COMPACT FORM.
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX A.
*  II  MMAX  LENGTH OF THE PRINCIPAL MATRIX VECTORS (SL,A).
*  RI  A(MMAX)      FACTORIZATION A+E=L*D*TRANS(L) OBTAINED BY THE
*         SUBROUTINE UXSPGN.IT CONTAINS THE NUMERICAL VALUES OF THE
*         FACTORS STORED IN THE COMPACT FORM ACCORDING TO THE
*         INFORMATION IN THE VECTORS PSL,SL.
*  II  PSL(N+1)  POINTER VECTOR OF THE FACTORIZED MATRIX A
*  RI  X(N)  INPUT VECTOR
*  RR  UXSPCQ  COMPUTED NUMBER UXSPCQ=TRANS(X)*D*X
*
      FUNCTION UXSPCQ(N,MMAX,A,PSL,X)
      INTEGER  N,MMAX
      $FLOAT  A(MMAX), X(N), UXSPCQ
      $FLOAT  TEMP
      INTEGER  PSL(N+1),I
      REAL*8 ZERO
      PARAMETER (ZERO = 0.0D0)
      TEMP = ZERO
      DO  100 I=1,N
      TEMP = TEMP + X(I)*X(I)*A(PSL(I)+I-1)
100   CONTINUE
      UXSPCQ = TEMP
      RETURN
      END
