* SUBROUTINE UXSPCT                 ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* REWRITE SYMMETRIC MATRIX INTO THE PERMUTED FACTORIZED COMPACT SCHEME.
*
* PARAMETERS:
*  II  N  SIZE OF THE SYSTEM SOLVED.
*  II  NB NUMBER OF NONZEROS IN THE UPPER TRIANGLE OF THE ORIGINAL
*         MATRIX.
*  II  ML SIZE OF THE COMPACT FACTOR.
*  II  MMAX DECLARED LENGTH OF THE ARRAYS JA,A.
*  RU  A(MMAX) NUMERICAL VALUES OF THE SPARSE HESSIAN APPROXIMATION
*              STORED AT THE POSITIONS 1, ...,NB.
*  IU  JA(MMAX) INDICES OF THE NONZERO ELEMENTS OF THE HESSIAN MATRIX IN
*             THE PACKED ROW FORM AT THE FIRST NB POSITIONS. NEW POSITIONS
*             IN THE PERMUTED FACTOR STORED IN A(NB+1), ..., A(2*NB),
*             INDICES OF COMPACT SCHEME IN A(2*NB+1), ..., A(2*NB+ML).
*  II  PSL(N+1) POINTER VECTOR OF THE COMPACT FORM OF THE TRIANGULAR
*             FACTOR OF THE HESSIAN APPROXIMATION.
*  IO  ITERM  ERROR FLAG. IF ITERM < 0 - LACK OF SPACE IN JA.
*
*
      SUBROUTINE UXSPCT(N,NB,ML,MMAX,A,JA,PSL,ITERM)
      INTEGER N,NB,ML,MMAX,JA(MMAX)
      INTEGER PSL(N+1),ITERM
      REAL*8 A(MMAX),ZERO
      INTEGER I,J
      PARAMETER(ZERO=0.0$P 0)
C
C WN11 CONTAINS BEGINNINGS OF THE FACTOR ROWS
C
      ITERM=0
C
C LACK OF SPACE
C
      IF(MMAX.LE.NB+PSL(N+1)+N-1) THEN
        ITERM=-43
        CALL UOERR1('UXSPCT',43)
        RETURN
      END IF
      IF(MMAX.LE.2*NB+ML) THEN
        ITERM=-44
        CALL UOERR1('UXSPCT',43)
        RETURN
      END IF
C
      DO 50 I=NB+1,NB+PSL(N+1)+N-1
        A(I)=ZERO
 50   CONTINUE
C
      DO 100 I=NB+ML+1,2*NB+ML
        J=ABS(JA(I))
        A(NB+J)=A(I-NB-ML)
 100  CONTINUE
      RETURN
      END
