* SUBROUTINE UXSPPB                ALL SYSTEMS                07/12/01
C PORTABILITY : ALL SYSTEMS
C 07/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SOLUTION OF A SYSTEM OF LINEAR EQUATIONS WITH A SSOR PRECONDITIONER
* C=(L+D)*D**(-1)*TRANS(L+D) WHERE L IS THE STRICT LEFT TRIANGLE AND
* D IS THE DIAGONAL OF THE MATRIX A.
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX A.
*  II  M NUMBER OF NONZERO ELEMENTS OF THE MATRIX A.
*  RI  A(M) NONZERO ELEMENTS OF THE MATRIX A STORED BY THE ROWS.
*  II  IA(N+1)  POINTERS OF THE DIAGONAL ELEMENTS OF A.
*  II  JA(M)  INDICES OF THE NONZERO ELEMENTS OF A.
*  RU  X(N)  ON INPUT THE RIGHT HAND SIDE OF A SYSTEM OF LINEAR
*         EQUATIONS. ON OUTPUT THE SOLUTION OF A SYSTEM OF LINEAR
*         EQUATIONS.
*
* METHOD :
* BACK SUBSTITUTION
*
      SUBROUTINE UXSPPB(N,M,A,IA,JA,X)
      INTEGER N,M,IA(N+1),JA(M)
      $FLOAT A(M),X(N)
      INTEGER I,K,IK,KK,LL
      $FLOAT ZERO,ONE,CON
      PARAMETER (ZERO=0.0$P 0,ONE=1.0$P 0,CON=1.0$(P)120)
      KK=1
      DO 3 K=1,N
      A(KK)=MAX(ABS(A(KK)),ONE/CON)
      X(K)=X(K)/A(KK)
      LL=IA(K+1)
      IF (JA(KK).LE.0) GO TO 2
      DO 1 IK=KK+1,LL-1
      I=JA(IK)
      IF (I.LE.0) GO TO 1
      X(I)=X(I)-A(IK)*X(K)
      IF (ABS(X(I)).GE.CON) X(I)=SIGN(CON,X(I))
    1 CONTINUE
    2 KK=LL
    3 CONTINUE
      DO 4 K=1,N
      IF (JA(IA(K)).LE.0) GO TO 4
      X(K)=X(K)*A(IA(K))
    4 CONTINUE
      LL=IA(N+1)
      DO 7 K=N,1,-1
      KK=IA(K)
      IF (JA(KK).LE.0) GO TO 6
      DO 5 IK=KK+1,LL-1
      I=JA(IK)
      IF (I.LE.0) GO TO 5
      X(K)=X(K)-A(IK)*X(I)
      IF (ABS(X(K)).GE.CON) X(K)=SIGN(CON,X(K))
    5 CONTINUE
      X(K)=X(K)/A(KK)
    6 LL=KK
    7 CONTINUE
      RETURN
      END
