* SUBROUTINE UXSPTX                ALL SYSTEMS                03/12/01
C PORTABILITY : ALL SYSTEMS
C 03/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SOLUTION OF A SYSTEM OF LINEAR EQUATIONS WITH A SPARSE SYMMETRIC
* POSITIVE DEFINITE MATRIX A+E USING THE FACTORIZATION A+E=L*D*TRANS(L)
* STORED IN THE COMPACT SCHEME. THIS FACTORIZATION CAN BE OBTAINED
* USING THE SUBROUTINE UXSSFN.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  II  M NUMBER OF NONZERO ELEMENTS OF THE MATRIX A.
*  II  ND  NUMBER OF DENSE ROWS.
*  RI  A(M) INCOMPLETE FACTORIZATION A+E=L*D*TRANS(L) OBTAINED BY THE
*         SUBROUTINE UXSPTF.
*  II  IA(N+1)  POINTERS OF THE DIAGONAL ELEMENTS OF A.
*  II  JA(M)  INDICES OF THE NONZERO ELEMENTS OF A.
*  RI  U(N*ND)  DENSE ROWS.
*  RI  D(ND)  SCALING MATRIX.
*  RO  B(ND*(ND+1)/2))  DECOMPOSITION OF THE UPDATED MATRIX.
*  RA  Y(N)  AUXILIARY ARRAY.
*
* METHOD :
* BACK SUBSTITUTION
*
      SUBROUTINE UXSPTX(N,M,ND,A,IA,JA,U,D,B,Y)
      INTEGER N,M,ND
      $FLOAT A(M),U(N*ND),D(ND),B(ND*(ND+1)/2),Y(N)
      INTEGER IA(N+1),JA(M)
      INTEGER I,J,INF,IND
      $FLOAT ALF,BET,UXVDOT
      IND(I,J)=I*(I-1)/2+J
      DO 2 I=1,ND
      CALL UXVCOP(N,U((I-1)*N+1),Y)
      CALL UXSPTB(N,M,A,IA,JA,Y,0)
      DO 1 J=1,I
      B(IND(I,J))=UXVDOT(N,U((J-1)*N+1),Y)
    1 CONTINUE
      B(IND(I,I))=B(IND(I,I))+D(I)
    2 CONTINUE
      ALF=1.0$P-16
      CALL UXDPGF(ND,B,INF,ALF,BET)
      RETURN
      END
