* SUBROUTINE UXSRB4                 ALL SYSTEMS               94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* REACHSET OF THE NODE IS COMPUTED WITH THE SPECIAL MARKING NOT TO
* INTERFERE WITH THE REACHSET OF THE NODE ELIMINATED. NEIGHBORHOOD
* OF THE NODE IS NOT NECESSARY.
*
*  PARAMETERS :
*  II  NN NUMBER OF COLUMNS OF THE MATRIX.
*  II  NADJ MAXIMUM NUMBER OF NONZEROS IN ADJNCY.
*  II  ROOT  THE GIVEN NODE NOT IN THE SUBSET.
*  II  XADJ(NN+1) POINTER VECTOR TO THE SPARSE ADJACENCY MATRIX.
*  II  ADJNCY  INDICES OF THE SYMMETRIC ADJACENCY MATRIX.
*  II  DEG(NN) THE DEGREE VECTOR.  DEG(I) LT 0 MEANS THE NODE
*              BELONGS TO THE FINAL SUBSET.
*  II  RCHSZE SIZE OF THE REACHABLE SET.
*  IO  RCHSET(NN) INDICES OF THE NODES IN REACHABLE SET.
*  IU  MARKER(NN) THE MARKER VECTOR FOR REACH AND NBRHD SETS.
*           INPUT:
*               =1 FOR THE NODES OF THE REACHSET OF THE NODE UNDER
*                  ELIMINATION.
*               =0 OTHERWISE.
*           OUTPUT:
*               =1 FOR THE NODES OF THE REACHABLE SET OF THE NODE
*                  UNDER ELIMINATION NOT IN THE REACHSET OF ROOT.
*               =3 FOR THE VERTICES OF BOTH THE REACHSET OF ROOT
*                  AND OF THE REACHSET OF THE NODE UNDER ELIMINATION.
*               =2 FOR THE VERTICES OF THE REACHSET OF ROOT NOT INCLUDED
*                  IN THE REACHSET OF THE NODE UNDER ELIMINATION.
*               =0 OTHERWISE.
*  IO  NHDSZE SIZE OF THE NEIGHORHOOD.
*  IO  NBRHD(NN) VERTICES OF THE NEIGHBORHOOD.
*
      SUBROUTINE UXSRB4(NN,NADJ,ROOT,XADJ,ADJNCY,DEG,MARKER,
     *                  RCHSZE,RCHSET)
      INTEGER NN,NADJ,ROOT
      INTEGER ADJNCY(NADJ),DEG(NN), MARKER(NN)
      INTEGER RCHSET(NN)
      INTEGER XADJ(NN+1),I,ISTRT,ISTOP,J,JSTRT,JSTOP
      INTEGER NABOR, NODE, RCHSZE
      LOGICAL LLL
C
      ISTRT = XADJ(ROOT)
      ISTOP = XADJ(ROOT+1) - 1
      DO 600 I = ISTRT, ISTOP
        NABOR =  ADJNCY(I)
        IF(MARKER(NABOR).GE.2.OR.MARKER(NABOR).LT.0) GO TO 600
        IF (DEG(NABOR).LT.0) GO TO 200
        LLL=.TRUE.
        RCHSZE = RCHSZE + 1
        RCHSET(RCHSZE) = NABOR
        IF(MARKER(NABOR).EQ.0) THEN
          MARKER(NABOR)=2
        ELSE
          MARKER(NABOR)=3
        ENDIF
        GO TO 600
 200    CONTINUE
        LLL=.FALSE.
C
 300    JSTRT = XADJ(NABOR)
        JSTOP = XADJ(NABOR+1) - 1
        DO 500 J = JSTRT, JSTOP
          NODE = ADJNCY(J)
          NABOR = - NODE
          IF (NODE.LT.0) GO TO 300
          IF (NODE.EQ.0) GO TO 600
          IF(MARKER(NODE).GE.2.OR.MARKER(NODE).LT.0) GO TO 500
          RCHSZE = RCHSZE + 1
          RCHSET(RCHSZE) = NODE
          IF(MARKER(NODE).EQ.0) THEN
            MARKER(NODE)=2
          ELSE
            MARKER(NODE)=3
          ENDIF
 500    CONTINUE
 600  CONTINUE
      RETURN
      END
