* SUBROUTINE  UXSRBC               ALL SYSTEMS               92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :  INITIATE ARRAYS BEG,END,P AND VARIABLE NN
*
*  PARAMETERS :
*  II  M NUMBER OF ROWS OF THE MATRIX.
*  II  N NUMBER OF COLUMN OF THE MATRIX.
*  II  IA(N+1) INDICES OF THE FIRST MEMBERS IN COLUMNS OF THE MATRIX.
*  II  JA(*) COLUMN INDICES OF THE MATRIX. 
*  II  WN01(M) INVERSE ROW PERMUTATION.
*  IO  BEG(NN) ROW INDICES WITH BEGINNINGS OF THE COLUMNS.
*  IO  END(NN) ROW INDICES WITH ENDINGS OF THE COLUMNS.
*  II  NN NUMBER OF BLOCK COLUMNS OF A.
*  II  P(NN) WINDTH OF THE BLOCK COLUMNS.
*
      SUBROUTINE UXSRBC(M,N,IA,JA,WN01,LABEL,PERM,BEG,END,NN,P)
      INTEGER M,N,I,II,J,ROW,NN
      INTEGER WN01(M),LABEL(N),PERM(N),BEG(NN),END(NN),IA(N+1),JA(*)
      INTEGER P(NN)
      DO 50 I=1, NN
        BEG(I) = M
        END(I) = 1
        P(I) = 0
   50 CONTINUE
      DO 100 I=1, N
        II = LABEL(I)
        P(II) = P(II) + 1
        DO 200 J=IA(PERM(I)), IA(PERM(I)+1) - 1
          ROW = WN01(JA(J))
          IF (ROW .LT. BEG(II)) THEN
            BEG(II) = ROW
          END IF
          IF (ROW .GT. END(II)) THEN
            END(II) = ROW
          END IF
  200   CONTINUE
  100 CONTINUE
      NN = II
      RETURN
      END
