* SUBROUTINE UXSRBV                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* HOUSEHOLDER REDUCTION OF THE DENSE MATRIX M BY N STORED ROWWISE IN BF
* IN THE ARRAY M BY (N+IPOM).
* PARAMETERS :
*  II  N NUMBER OF MATRIX ROWS.
*  II  M NUMBER OF MATRIX ROWS.
*  II  IPOM DISTANCE PARAMETER.
*  RU  B(M*(N+IPOM)) REAL ARRAY.
*  II  PEL NUMBER OF REFLECTIONS.
*
      SUBROUTINE UXSRBV(M,N,IPOM,BF,PEL)
      INTEGER M,N,PEL,IPOM
      INTEGER INDD,I,J,J1,L,KK1,KK2,KK,L1
      $FLOAT BF(M*N),POM,DDOT,ZERO,ONE,UXSRBU
      PARAMETER(ZERO=0.0$P 0,ONE=1.0$P 0)
C
C     PERFORM THE HOUSEHOLDER REDUCTION OF X.
C
      INDD=-N+IPOM
      DO 600 L=1,PEL
        IF (L.EQ.M) GO TO 170
        INDD=INDD+N+1
C
C COMPUTE THE HOUSEHOLDER TRANSFORMATION FOR COLUMN L.
C
C EUCLIDEAN NORM OF THE L-TH COLUMN.
C
        POM=UXSRBU(M,N,BF,L+IPOM,L)
        IF (POM.EQ.ZERO) GO TO 160
        IF (BF(INDD).NE.ZERO) POM=SIGN(POM,BF(INDD))
C
C SCALE THE HOUSEHOLDER VECTOR
C
        KK=INDD
        DO 200 I=L,M
          BF(KK)=BF(KK)/POM
          KK=KK+N
  200   CONTINUE
        BF(INDD)=BF(INDD)+ONE
C
C APPLY THE TRANSFORMATION TO THE REMAINING COLUMNS
C
        L1=L+1
        DO 400 J=L1,N
          DDOT=ZERO
          KK1=INDD
          KK2=INDD+J-L
          DO 250 J1=1,M-L+1
            DDOT=DDOT-(BF(KK1)*BF(KK2))/BF(INDD)
            KK1=KK1+N
            KK2=KK2+N
  250     CONTINUE
          KK1=INDD
          KK2=INDD+J-L
          DO 300 J1=1,M-L+1
            BF(KK2)=BF(KK2)+DDOT*BF(KK1)
            KK1=KK1+N
            KK2=KK2+N
  300     CONTINUE
  400   CONTINUE
C
C SAVE THE TRANSFORMATION.
C
        BF(INDD)=-POM
  160 CONTINUE
  170 CONTINUE
  600 CONTINUE
      RETURN
      END
