* SUBROUTINE UXSSDS                ALL SYSTEMS                00/12/01
C PORTABILITY : ALL SYSTEMS
C 00/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* CONVERSION OF A SPARSE SYMMETRIC MATRIX TO A DENSE SYMMETRIC MATRIX.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE MATRIX A.
*  RI  A(M) ELEMENTS OF THE SPARSE SYMMETRIC MATRIX STORED IN THE
*      PACKED FORM.
*  II  IA(N+1)  POINTERS OF THE DIAGONAL ELEMENTS OF A.
*  II  JA(M)  INDICES OF THE NONZERO ELEMENTS OF A.
*  RO  B(N*(N+1)/2)  DENSE SYMMETRIC MATRIX B := A.
*
      SUBROUTINE UXSSDS(N,M,A,IA,JA,B)
      INTEGER N,M,IA(N+1),JA(M)
      $FLOAT  A(M),B(N*(N+1)/2)
      $FLOAT ZERO
      INTEGER I,J,K,JSTRT,JSTOP
      PARAMETER  (ZERO = 0.0$P 0)
      DO 100 I=1,N*(N+1)/2
      B(I)=ZERO
100   CONTINUE
      JSTOP=0
      DO 300 I=1,N
        JSTRT=JSTOP+1
        JSTOP=IA(I+1)-1
        IF (JA(JSTRT).GT.0) THEN
          DO 200 J=JSTRT,JSTOP
            K=JA(J)
            IF (K.GT.0) B((K-1)*K/2+I)=A(J)
200       CONTINUE
        ENDIF
300   CONTINUE
      RETURN
      END
