* SUBROUTINE UXSTG2                ALL SYSTEMS                86/11/01
C PORTABILITY : ALL SYSTEMS
C 89/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* WIDTHEN THE PACKED FORM OF VECTORS IA, JA, A OF A SPARSE MATRIX
*
* PARAMETERS :
*  II  N ORDER OF THE SPARSE MATRIX.
*  IU  M NUMBER OF NONZERO ELEMENTS IN THE MATRIX.
*  II  MMAX LENGTH OF THE ARRAY JA.
*  II  IA(N+1) POINTER VECTOR OF THE INPUT MATRIX.
*  II  JA(MMAX) VECTOR OF THE COLUMN INDICES OF THE INPUT MATRIX.
*  IA  PD(N+1) AUXILIARY VECTOR.
*  IA  WN11(N+1) AUXILIARY VECTOR.
*
      SUBROUTINE UXSTG2(N,M,MMAX,IA,JA,A,PD,WN11)
      INTEGER N,M,MMAX
      INTEGER IA(N+1),PD(N+1),JA(MMAX),WN11(N+1)
      INTEGER I,J,L1,L,K
      DOUBLE PRECISION A(MMAX)
C
C UPPER TRIANGULAR INFORMATION TO THE AUXILIARY ARRAY
C
      L1=IA(1)
      DO 100 I=1,N
      L=L1
      L1=IA(I+1)
      WN11(I)=L1-L
100   CONTINUE
C
C LOWER TRIANGULAR INFORMATION TO THE AUXILIARY ARRAY
C
      DO 300  I=1,N
        DO 200  J=IA(I)+1,IA(I+1)-1
        K=JA(J)
        WN11(K)=WN11(K)+1
200     CONTINUE
300   CONTINUE
C
C BY PARTIAL SUMMING WE GET POINTERS OF THE WIDE STRUCTURE
C WN11(I) POINTS AT THE END OF THE ROW I
C
      L=0
      DO 400  I=2,N
      WN11(I)=WN11(I)+WN11(I-1)
400   CONTINUE
C
C DEFINE LENGTH OF THE WITHENED STRUCTURE
C
      M=WN11(N)
C
C SHIFT OF UPPER TRIANGULAR ROWS
C
      PD(1)=1
      DO 600  I=N,1,-1
      L=WN11(I)
      PD(I+1)=L+1
        DO 500  J=IA(I+1)-1,IA(I),-1
        JA(L)=JA(J)
        A(L)=A(J)
        L=L-1
500     CONTINUE
600   CONTINUE
C
C FORMING OF THE LOWER TRIANGULAR PART
C
      DO 800  I=1,N
        DO 700  J=WN11(I)+IA(I)+2-IA(I+1),WN11(I)
        K=JA(J)
        JA(PD(K))=I
        A(PD(K))=A(J)
        PD(K)=PD(K)+1
700     CONTINUE
800   CONTINUE
      DO 900  I=1,N
      IA(I+1)=WN11(I)+1
900   CONTINUE
      RETURN
      END
