* SUBROUTINE UXTGGF                ALL SYSTEMS                95/12/01
C PORTABILITY : ALL SYSTEMS
C 95/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* LIMITED STORAGE INVERSE COLUMN UPDATE METHODS.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RU  D(N) DIAGONAL OF A DECOMPOSED TRIDIAGONAL MATRIX.
*  RU  DL(N) SUBDIAGONAL OF A DECOMPOSED TRIDIAGONAL MATRIX.
*  RU  DU(N) SUPERDIAGONAL OF A DECOMPOSED TRIDIAGONAL MATRIX.
*  RO  DU2(N) SECOND SUPERDIAGONAL OF A DECOMPOSED TRIDIAGONAL MATRIX.
*  IO  ID(N)  PERMUTATION VECTOR.
*  IO  INF  INDDICATION.
*
      SUBROUTINE UXTGGF(N,D,DL,DU,DU2,ID,INF)
      INTEGER INF,N
      INTEGER ID(N)
      $FLOAT D(N),DL(N),DU(N),DU2(N)
      INTEGER I
      $FLOAT FACT,TEMP
      $FLOAT ZERO
      PARAMETER (ZERO=0.0$P 0)
      INF=0
      DO 1 I=1,N
      ID(I)=I
    1 CONTINUE
      DO 2 I=1,N-1
      IF (DL(I).EQ.ZERO) THEN
      IF (D(I).EQ.ZERO.AND.INF.EQ.0) INF=I
      IF (I.LT.N-1) DU2(I)=ZERO
      ELSE IF (ABS(D(I)).GE.ABS(DL(I))) THEN
      FACT=DL(I)/D(I)
      DL(I)=FACT
      D(I+1)=D(I+1)-FACT*DU(I)
      IF (I.LT.N-1) DU2(I)=ZERO
      ELSE
      FACT=D(I)/DL(I)
      D(I)=DL(I)
      DL(I)=FACT
      TEMP=DU(I)
      DU(I)=D(I+1)
      D(I+1)=TEMP-FACT*D(I+1)
      IF (I.LT.N-1) THEN
      DU2(I)=DU(I+1)
      DU(I+1)=-FACT*DU(I+1)
      END IF
      ID(I)=ID(I)+1
      END IF
    2 CONTINUE
      IF (D(N).EQ.ZERO.AND.INF.EQ.0) THEN
      INF=N
      RETURN
      END IF
      RETURN
      END
