* SUBROUTINE UXTQIV                ALL SYSTEMS                06/12/01
C PORTABILITY : ALL SYSTEMS
C 06/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE EIGENVALUES OF A SYMMETRIC TRIDIAGONAL MATRIX
* BY THE IMPLICIT QL METHOD.
*
* PARAMETERS :
*  II  N  ORDER OF THE TRIDIAGONAL MATRIX T.
*  RU  D(N)  ON INPUT DIAGONAL ELEMENTS OF THE TRIDIAGONAL MATRIX T.
*         ON OUTPUT EIGENVALUES OF THE TRIDIAGONAL MATRIX T.
*  RU  E(N)  ON INPUT SUBDIAGONAL ELEMENTS OF THE TRIDIAGONAL MATRIX T
*         ON POSITIONS FROM 2 TO N (E(1) IS ARBITRARY).
*  RO  IER  ERROR INDICATOR.
*
      SUBROUTINE UXTQIV(N,D,E,IER)
      INTEGER N,IER
      $FLOAT D(N),E(N)
      INTEGER I,II,J,L,M,MML
      $FLOAT B,C,F,G,P,R,S,PARM
      IER=0
      PARM=1.0$P-16
      IF (N.LE.1) RETURN
      DO 102 I=2,N
      E(I-1)=E(I)
  102 CONTINUE
      E(N)=0.0D0
      DO 290 L=1,N
      J=0
  105 DO 110 M=L,N
      IF (M.GE.N) GO TO 120
      IF (ABS(E(M)).LE.PARM*(ABS(D(M))+ABS(D(M+1)))) GO TO 120
  110 CONTINUE
  120 P=D(L)
      IF (M.LE.L) GO TO 215
      IF (J.GE.30) THEN
      IER=L
      RETURN
      ENDIF
      J=J+1
      G=(D(L+1)-P)/(2.0D0*E(L))
      R=SQRT(1.0D0+G*G)
      G=D(M)-P+E(L)/(G+SIGN(R,G))
      S=1.0D0
      C=1.0D0
      P=0.0D0
      MML=M-L
      DO 200 II=1,MML
      I=M-II
      F=S*E(I)
      B=C*E(I)
      IF (ABS(F).GE.ABS(G)) THEN
      C=G/F
      R=SQRT(1.0D0+C*C)
      E(I+1)=F*R
      S=1.0D0/R
      C=C*S
      ELSE
      S=F/G
      R=SQRT(1.0D0+S*S)
      E(I+1)=G*R
      C=1.0D0/R
      S=S*C
      ENDIF
      G=D(I+1)-P
      R=(D(I)-G)*S+2.0D0*C*B
      P=S*R
      D(I+1)=G+P
      G=C*R-B
  200 CONTINUE
      D(L)=D(L)-P
      E(L)=G
      E(M)=0.0D0
      GO TO 105
  215 CONTINUE
      DO 230 II=2,L
      I=L+2-II
      IF (P.GE.D(I-1)) GO TO 270
      D(I)=D(I-1)
  230 CONTINUE
      I=1
  270 D(I)=P
  290 CONTINUE
      RETURN
      END
