* SUBROUTINE UXVMUD             ALL SYSTEMS                   03/12/01
C PORTABILITY : ALL SYSTEMS
C 03/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF A POWER OF A DIAGONAL MATRIX D BY A VECTOR X
* AND ADDITION OF A SCALED VECTOR ALF*Y.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  D(N)  DIAGONAL MATRIX STORED AS A VECTOR WITH N ELEMENTS.
*  RI  X(N)  INPUT VECTOR.
*  RI  ALF  SCALING FACTOR.
*  RI  Y(N)  INPUT VECTOR.
*  RO  Z(N)  OUTPUT VECTOR WHERE Z:=(D**K)*X+ALF*Y.
*  II  K  INTEGER EXPONENT.
*

      SUBROUTINE UXVMUD(N,D,X,ALF,Y,Z,K)
      INTEGER N,K
      $FLOAT D(N),X(N),ALF,Y(N),Z(N)
      INTEGER I
      IF (K.EQ.0) THEN
      CALL UXVDIR(N,ALF,Y,X,Z)
      ELSE IF (K.EQ. 1) THEN
      DO 1 I=1,N
      Z(I)=X(I)*D(I)+ALF*Y(I)
    1 CONTINUE
      ELSE IF (K.EQ.-1) THEN
      DO 2 I=1,N
      Z(I)=X(I)/D(I)+ALF*Y(I)
    2 CONTINUE
      ELSE
      DO 3 I=1,N
      Z(I)=X(I)*D(I)**K+ALF*Y(I)
    3 CONTINUE
      ENDIF
      RETURN
      END
