* SUBROUTINE UXVMUL             ALL SYSTEMS                   89/12/01
C PORTABILITY : ALL SYSTEMS
C 89/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* VECTOR IS PREMULTIPLIED BY THE POWER OF A DIAGONAL MATRIX.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  D(N)  DIAGONAL MATRIX STORED AS A VECTOR WITH N ELEMENTS.
*  RI  X(N)  INPUT VECTOR.
*  RO  Y(N)  OUTPUT VECTOR WHERE Y:=(D**K)*X.
*  II  K  INTEGER EXPONENT.
*

      SUBROUTINE UXVMUL(N,D,X,Y,K)
      INTEGER N,K
      $FLOAT D(N),X(N),Y(N)
      INTEGER I
      IF (K.EQ.0) THEN
      CALL UXVCOP(N,X,Y)
      ELSE IF (K.EQ. 1) THEN
      DO 1 I=1,N
      Y(I)=X(I)*D(I)
    1 CONTINUE
      ELSE IF (K.EQ.-1) THEN
      DO 2 I=1,N
      Y(I)=X(I)/D(I)
    2 CONTINUE
      ELSE
      DO 3 I=1,N
      Y(I)=X(I)*D(I)**K
    3 CONTINUE
      ENDIF
      RETURN
      END