* SUBROUTINE UXVSR2                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* RADIXSORT.
*
* PARAMETERS :
*  II  MCOLS  NUMBER OF INTEGER VALUES OF THE SORTED ARRAY.
*  RI  DEG(MCOLS)  VALUES OF THE SORTED ARRAY.
*  RO  ORD(MCOLS)  SORTED OUTPUT.
*  RA  RADIX(MCOLS+1)  AUXILIARY ARRAY.
*  II  WN01(MCOLS)  INDICES OF THE SORTED ARRAY.
*  II  LENGTH   NUMBER OF SORTED PIECES.
*
      SUBROUTINE UXVSR2(MCOLS,DEG,ORD,RADIX,WN01,LENGTH)
      INTEGER MCOLS,WN01(MCOLS)
      $FLOAT DEG(MCOLS),ORD(MCOLS),RADIX(MCOLS+1)
      INTEGER LENGTH,I,L,L1,L2
C
C RADIX IS SHIFTED : 0-(MCOLS-1) --- 1-MCOLS
C
      DO 50 I=1,MCOLS+1
        RADIX(I)=0
50    CONTINUE
      DO 100 I=1,LENGTH
        L2=WN01(I)
        L=DEG(L2)
        RADIX(L+1)=RADIX(L+1)+1
100   CONTINUE
C
C     RADIX COUNTS THE NUMBER OF VERTICES WITH DEG(I)>=L
C
      L=0
      DO 200 I=MCOLS,0,-1
        L=RADIX(I+1)+L
        RADIX(I+1)=L
200   CONTINUE
C
C     ARRAY ORD IS FILLED
C
      DO 300 I=1,LENGTH
        L2=WN01(I)
        L=DEG(L2)
        L1=RADIX(L+1)
        ORD(L1)=L2
        RADIX(L+1)=L1-1
300   CONTINUE
      RETURN
      END
