$INTERFACE UYAGU2                                             99/12/01

  CALL UYAGU2(NF,$H,$G,$GP,$S,ALFN,ALFV)
  $ADD(REAL,'\$H($NF*($NF+1)/2)\$G($NF)\$GP($NF)\$S($NF)')
  $ADD(REAL,'\ALFN\ALFV')
$REM  $ADD(INTEGER,'\NF')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYAGU2                ALL SYSTEMS                99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 VL : ORIGINAL VERSION
*
* PURPOSE :
*  SIMPLIFIED AGGREGATION FOR NONSMOOTH VARIABLE METRIC METHOD.
*
* PARAMETERS :
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  RI  H(M)  POSITIVE DEFINITE APPROXIMATION OF THE INVERSE HESSIAN
*         MATRIX.
*  RI  G(N)  SUBGRADIENT OF THE OBJECTIVE FUNCTION.
*  RU  GV(N)  AGGREGATED SUBGRADIENT OF THE OBJECTIVE FUNCTION.
*  RA  S(N)  AUXILIARY VECTOR.
*  RO  ALF  LINEARIZATION TERM.
*  RU  ALFV  AGGREGATED LINEARIZATION TERM.
*
      SUBROUTINE UYAGU2(N,H,G,GV,S,ALF,ALFV)
      INTEGER N
      $FLOAT H(N*(N+1)/2),G(N),GV(N),S(N),ALF,ALFV
      $FLOAT LAM,P,Q,W
      INTEGER I,J,L
      $FLOAT ZERO,ONE
      PARAMETER (ZERO=0.0$P 0,ONE=1.0$P 0)
      P=ALFV-ALF
      DO 1 I=1,N
      GV(I)=G(I)-GV(I)
      P=P+S(I)*GV(I)
    1 CONTINUE
      Q=ZERO
      DO 4 I=1,N
      L=I*(I-1)/2+1
      W=ZERO
      DO 2 J=1,I-1
      W=W+H(L)*GV(J)
      L=L+1
    2 CONTINUE
      DO 3 J=I,N
      W=W+H(L)*GV(J)
      L=L+J
    3 CONTINUE
      Q=Q+W*GV(I)
    4 CONTINUE
      LAM=0.5$P 0+SIGN(0.5$P 0,P)
      IF (Q.GT.ZERO) LAM=MIN(ONE,MAX(ZERO,P/Q))
      P=ONE-LAM
      DO 5 I=1,N
      GV(I)=G(I)-P*GV(I)
    5 CONTINUE
      ALFV=LAM*ALF+P*ALFV
      RETURN
      END
