$INTERFACE UYAGU4                                             04/12/01

  CALL UYAGU4(NF,MA,MMAX,$H(MM+1),$JH(MM+1),$PSL,$PERM,$AG,$AGP&
,$G,$GP,$S,$GS,ALFN,ALFV)
  $ADD(INTEGER,'\$JH($MMAX)\$PSL($NF+1)\$PERM($NF)')
  $ADD(REAL,'\$H($MMAX)\$AG($MA)\$AGP($MA)\$G($NF)\$GP($NF)\$S($NF)&
  \$GS($NF)')
  $ADD(REAL,'\ALFN\ALFV')
$REM  $ADD(INTEGER,'\NF\MA\MMAX')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYAGU4                ALL SYSTEMS                04/12/01
C PORTABILITY : ALL SYSTEMS
C 04/12/01 VL : ORIGINAL VERSION
*
* PURPOSE :
*  SIMPLIFIED AGGREGATION FOR NONSMOOTH VARIABLE METRIC METHOD.
*
* PARAMETERS :
*  II  NF  ACTUAL NUMBER OF VARIABLES.
*  II  MA  NUMBER OF NONZERO ELEMENTS IN THE GENERALIZED JACOBIAN
*         MATRIX.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE SPARSE HESSIAN MATRIX.
*  RI  H(M)  POSITIVE DEFINITE APPROXIMATION OF THE SPARSE HESSIAN
*         MATRIX.
*  IO  JH(M)  INDICES OF THE NONZERO ELEMENTS OF H.
*  II  PSL(NF+1) POINTER ARRAY OF THE FACTORIZED SPARSE MATRIX
*  II  PERM(NF)  PERMUTATION VECTOR
*  RI  AG(MA)  NEW GENERALIZED JACOBIAN MATRIX.
*  RU  AGV(MA)  AGGREGATED GENERALIZED JACOBIAN MATRIX.
*  RI  G(NF)  ACTUAL SUBGRADIENT OF THE OBJECTIVE FUNCTION.
*  RU  GV(NF)  AGGREGATED SUBGRADIENT OF THE OBJECTIVE FUNCTION.
*  RA  S(NF)  DIRECTION VECTOR.
*  RA  V(NF)  AUXILIARY VECTOR.
*  RO  ALF  LINEARIZATION TERM.
*  RU  ALFV  AGGREGATED LINEARIZATION TERM.
*
      SUBROUTINE UYAGU4(NF,MA,M,H,JH,PSL,PERM,AG,AGV,G,GV,S,V,ALF,
     & ALFV)
      INTEGER NF,MA,M,JH(M),PSL(NF+1),PERM(NF)
      $FLOAT H(M),AG(MA),AGV(MA),G(NF),GV(NF),S(NF),V(NF),ALF,ALFV
      $FLOAT P,Q,W,LAM
      INTEGER I
      $FLOAT ZERO,ONE
      PARAMETER (ZERO=0.0$P 0,ONE=1.0$P 0)
      P=ALFV-ALF
      DO 1 I=1,NF
      W=S(I)
      P=P+W*S(I)
      S(I)=G(I)-GV(I)
    1 CONTINUE
      Q=ZERO
      CALL UXVSFP(NF,PERM,S,V)
      CALL UXSPCB(NF,M,H,PSL,JH,S,1)
      DO 4 I=1,NF
        W=ONE/H(PSL(I)+I-1)
        Q=Q+W*S(I)**2
    4 CONTINUE
      LAM=0.5$P 0+SIGN(0.5$P 0,P)
      IF (Q.GT.ZERO) LAM=MIN(ONE,MAX(ZERO,P/Q))
      P=ONE-LAM
      ALFV=LAM*ALF+P*ALFV
      DO 5 I=1,NF
      GV(I)=LAM*G(I)+P*GV(I)
    5 CONTINUE
      DO 6 I=1,MA
      AGV(I)=LAM*AG(I)+P*AGV(I)
    6 CONTINUE
      RETURN
      END
