$INTERFACE UYBUN1                                             97/12/01

  CALL UYBUN1(NF,MB,NB,$X,$G,F,$AX,$AY,$AZ,ITERS)
  $ADD(REAL,'\$X($NF)\$G($NF)\$AX($NF*($MB))\$AY($NF*($MB))&
  \$AZ(4*($MB))')
$REM  $ADD(REAL,'\F')
$REM  $ADD(INTEGER,'\NF\MB\NB\ITERS')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYBUN1                ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 VL : ORIGINAL VERSION
*
* PURPOSE :
*  BUNDLE UPDATING.
*
* PARAMETERS :
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  II  MB  DECLARED NUMBER OF LINEAR APPROXIMATED FUNCTIONS.
*  II  NB  CURRENT NUMBER OF LINEAR APPROXIMATED FUNCTIONS.
*  RU  X(N)  VECTOR OF VARIABLES.
*  RO  G(N)  SUBGRADIENT OF THE OBJECTIVE FUNCTION.
*  RO  F  VALUE OF THE OBJECTIVE FUNCTION.
*  RI  AY(N*MB)  MATRIX WHOSE COLUMNS ARE VARIABLE VECTORS.
*  RI  AG(N*MB)  MATRIX WHOSE COLUMNS ARE BUNDLE SUBGRADIENTS.
*  RI  AF(4*MB)  VECTOR OF BUNDLE FUNCTIONS VALUES.
*  IO  ITERS  NULL STEP INDICATOR. ITERS=0-NULL STEP. ITERS=1-DESCENT
*         STEP.
*
* SUBPROGRAMS USED :
*  S   UXVCOP  COPYING OF A VECTOR.
*
      SUBROUTINE UYBUN1(N,MB,NB,X,G,F,AY,AG,AF,ITERS)
      INTEGER N,MB,NB,ITERS
      REAL*8 X(N),G(N),F,AY(N*MB),AG(N*MB),AF(MB*4)
      INTEGER I,IND,K,KN,L
      L=0
      IF (ITERS.EQ.0) L=1
C
C     BUNDLE REDUCTION
C
      KN=0
      IF (NB.GE.MB) THEN
        DO 2 K=1,NB-1
        KN=K*N-N
        DO 1 I=1,N
   1    IF (G(I).NE.AG(KN+I)) GO TO 2
        IND=K
        GO TO 3
   2    CONTINUE
        IND=1
   3    DO 4 K=IND,NB-1
        AF(K)=AF(K+1)
        AF(K+MB*3)=AF(K+1+MB*3)
        KN=K*N+1
        CALL UXVCOP(N,AG(KN),AG(KN-N))
        CALL UXVCOP(N,AY(KN),AY(KN-N))
   4    CONTINUE
        NB=NB-1
      ENDIF
C
C     BUNDLE COMPLETION
C
      IF (L.GT.0.AND.KN.EQ.0) THEN
        AF(NB+1)=AF(NB)
        AF(3*MB+NB+1)=AF(3*MB+NB)
        KN=NB*N+1
        CALL UXVCOP(N,AG(KN-N),AG(KN))
        CALL UXVCOP(N,AY(KN-N),AY(KN))
      ENDIF
      NB=NB+1
      KN=NB-L
      AF(KN)=F
      AF(KN+MB*3)=L
      K=(KN-1)*N+1
      CALL UXVCOP(N,G,AG(K))
      CALL UXVCOP(N,X,AY(K))
      RETURN
      END
