$INTERFACE UYFCL1                                             98/12/01

  CALL UYFCL1(NF,M,$MMAX,$IH,$JH,$COL,$S,$XO,$GO,$WN01,$WN02)
  $ADD(REAL,'\$S($NF)\$XO($NF)\$GO($NF+1)')
  $ADD(INTEGER,'\$COL($NF)\$WN01($NF+1)\$WN02($NF+1)')
  $ADD(INTEGER,'\$IH($NF+1)\$JH($MMAX)')
$REM  $ADD(INTEGER,'\NF\M')
  $ADD(INIT)
    NFHX='UYFCL1'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYFCL1                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* COLORING ALGORITHM FOR SPARSE FRACTIONED UPDATES.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE HESSIAN MATRIX.
*  II  MMAX  SIZE OF THE SPARSE HESSIAN ARRAY.
*  II  IH(NF+1) POINTER VECTOR OF SPARSE HESSIAN MATRIX.
*  II  JH(MMAX) INDEX VECTOR OF THE HESSIAN MATRIX.
*  IO  COL(NF) VECTOR DISCERNING GROUPS OF THE HESSIAN COLUMN OF THE
*              SAME COLOUR.
*  RA  DEG(NF) DEGREES OF THE ADJACENCY GRAPH.
*  RA  ORD(NF) AUXILIARY ARRAY.
*  RA  RADIX(NF) AUXILIARY ARRAY.
*  IA  WN01(NF) AUXILIARY VECTOR USED FOR INDICES OF THE COLUMNS
*        THAT HAVE NOT BEEN COLOURED YET.
*  IA  WN02(NF) AUXILIARY VECTOR.
*
* COMMON DATA
*  IO  ITERM  TERMINATION INDICATOR.
*  TO  TDXX  TEXT INFORMATION ON THE CAUSE OF TERMINATION.
*
      SUBROUTINE UYFCL1(NF,M,MMAX,IH,JH,COL,DEG,ORD,RADIX,WN01,WN02)
      $INCLUDE('UMCOMM')
      INTEGER NF,M,MMAX,IH(NF+1),JH(MMAX),COL(NF)
      INTEGER WN01(NF+1),WN02(NF+1)
      $FLOAT DEG(NF),ORD(NF),RADIX(NF+1)
      INTEGER NCOL,I,ML,J,L,ICTYP
C
C SAVE SYMBOLIC STRUCTURE OF FACTOR
C
      IF(COL(1).NE.0) RETURN
      M=IH(NF+1)-1
      IF(2*M-NF+2.GE.MMAX) THEN
        ITERM=-36
        TDXX='LACK SPC'
        GO TO 1100
      END IF
C
C WIDTHEN THE STRUCTURE
C
      CALL UXSTG1(NF,ML,MMAX,IH,JH,WN02,WN01)
C
C
C DEGREE COUNTS
C
      CALL UYSDEG(NF,NF,IH,DEG)
C
C SMALLEST-LAST OR LARGEST-FIRST
C
      ICTYP=2
      IF(ICTYP.EQ.1) THEN
        CALL UXVSR2(NF,DEG,ORD,RADIX,WN01,NF)
      ELSE
        CALL UXVSR3(NF,JH,IH,DEG,ORD,RADIX,WN01,WN02)
      ENDIF
C
C SEQUENTIAL COLORING
C
      CALL UXVCOL(NF,JH,IH,DEG,ORD,COL,WN01,NCOL)
C
C
C SHRINK THE STRUCTURE
C
      CALL UXSTL1(NF,ML,MMAX,IH,JH,WN02)
C
C INTO COL GIVE INDICES OF THE INDIVIDUAL GROUPS ONE AFTER ANOTHER,
C END OF THE GROUP IS MARKED BY THE NEGATIVE INDEX VALUE.
C
C
C READ COL
C
      DO 300 I=1,NF
        WN01(I)=0
 300  CONTINUE
      DO 400 I=1,NF
        J=COL(I)
        WN01(J)=WN01(J)+1
 400  CONTINUE
      WN02(1)=1
      L=1
      DO 500 I=2,NF
        L=L+WN01(I-1)
        WN02(I)=L
        IF(WN01(I).EQ.0) GO TO 550
 500  CONTINUE
 550  CONTINUE
C
C CHANGE COL
C
      DO 600 I=1,NF
        J=COL(I)
        WN01(I)=J
 600  CONTINUE
      DO 700 I=1,NF
        J=WN01(I)
        COL(WN02(J))=I
        WN02(J)=WN02(J)+1
 700  CONTINUE
      DO 800 I=1,NCOL
        L=WN02(I)-1
        IF(L.GT.NF) GO TO 900
        COL(L)=-COL(L)
 800  CONTINUE
 900  CONTINUE
 1100 CONTINUE
      RETURN
      END
