$INTERFACE UYRMS0                                             98/12/01

  $HELP
    OPTION FOR CONSTRAINT DELETION
      0 - SINGLE CONSTRAINT DELETION
      1 - SIMULTANEOUS CONSTRAINT DELETION
  $CHECK(IREM,0,'0\1',4,NO)
  $HELP
    TOLERANCE FOR CONSTRAINTS TO BE REMOVED
  $CHECK(EPS8,'0.5$P 0',REAL,4)
  $IF(IREM>0)
$00 CONTINUE
  $ENDIF
  CALL UYRMS0(NF,N,$IX,$XN,$G,$GN,EPS8,UMAX,GMAX,MOT,IOLD,KOLD)
  $IF(IREM>0)
    IF (IOLD.NE.0) THEN
    CALL UYTRSG(NF,N,$IX,$XN,$G,$GN,UMAX,GMAX,IOLD,KOLD,NORMF)
    GO TO $00
    ENDIF
  $ENDIF
  $ADD(INTEGER,'\$IX($NX)')
  $ADD(REAL,'\$XN($NF)\$G($NF)\$GN($NF)')
$REM  $ADD(INTEGER,'\NF\N\MCL\MOT\IOLD\KOLD')
$REM  $ADD(REAL,'\UMAX\GMAX')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYRMS0                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* OLD SIMPLE BOUND IS REMOVED FROM THE ACTIVE SET. TRANSFORMED
* GRADIENT OF THE OBJECTIVE FUNCTION IS UPDATED.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RI  G(NF)  GRADIENT OF THE OBJECTIVE FUNCTION.
*  RU  GN(NF)  TRANSFORMED GRADIENT OF THE OBJECTIVE FUNCTION.
*  RI  EPS8  TOLERANCE FOR CONSTRAINT TO BE REMOVED.
*  RI  UMAX  MAXIMUN ABSOLUTE VALUE OF THE NEGATIVE LAGRANGE MULTIPLIER.
*  RI  GMAX  NORM OF THE TRANSFORMED GRADIENT.
*  II  MOT  SPECIFICATION OF RESTART AFTER CHANGE OF ACTIVE
*         CONSTRAINTS. MOT=1-RESTART AFTER EACH CHANGE OF ACTIVE
*         CONSTRAINTS. MOT=2-NO RESTART.
*  II  IOLD  INDEX OF THE REMOVED CONSTRAINT.
*  II  KOLD  INDEX OF THE NEW POSITION IN THE TRANSFORMED HESSIAN
*         MATRIX.
*
* COMMON DATA :
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*
* SUBPROGRAMS USED :
*  S   UYRES1  DEFINITION OF THE RESTART VARIABLES.
*  S   UOYRM1  PRINT OF ENTRY TO CONSTRAINT DELETION.
*  S   UOYRM3  PRINT OF INFORMATION ON CONSTRAINT DELETION.
*
      SUBROUTINE UYRMS0(NF,N,IX,XN,G,GN,EPS8,UMAX,GMAX,MOT,IOLD,KOLD)
      $INCLUDE ('UMCOMM')
      INTEGER NF,N,IX(NF),MOT,IOLD,KOLD
      $FLOAT XN(NF),G(NF),GN(NF),EPS8,UMAX,GMAX
      INTEGER I
      IF (UMAX.GT.EPS8*GMAX)  THEN
      CALL UOYRM1(N,GMAX,UMAX,IOLD,'UYRMS0')
      IX(IOLD)=MIN(ABS(IX(IOLD)),3)
      DO 1 I=N,KOLD,-1
      GN(I+1)=GN(I)
    1 CONTINUE
      IF (NORMF.GT.0) THEN
      GN(KOLD)=G(IOLD)*XN(IOLD)
      ELSE
      GN(KOLD)=G(IOLD)
      ENDIF
      N=N+1
      CALL UOYRM3(NF,N,IX,0)
      IF(MOT.EQ.1) CALL UYRES1('REM CONS')
      ELSE
      IOLD=0
      KOLD=0
      ENDIF
      RETURN
      END
