* SUBROUTINE UYSET4                 ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DEFINITION OF THE RESTART VARIABLES.
*
* PARAMETERS :
*  II  NF DECLARED NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  IU  INITS  CHOICE OF THE INITIAL STEPSIZE. INITS=0-INITIAL STEPSIZE
*         IS SPECIFIED IN THE CALLING PROGRAM. INITS=1-UNIT INITIAL
*         STEPSIZE. INITS=2-COMBINED UNIT AND QUADRATICALLY ESTIMATED
*         INITIAL STEPSIZE. INITS=3-QUADRATICALLY ESTIMATED INITIAL
*         STEPSIZE.
*  II  ISTEP  CONTROLLING OF THE INITIAL STEPSIZE. 0-NO CONTROLLING OF
*         THE INITIAL STEPSIZE. 1-CONTROLLING BASED ON THE FUNCTION
*         DECREASE. 2-CONTROLLING BASED ON THE DIRECTION VECTOR.
*         3-CONTROLLING BASED ON THE NUMBER OF APPROXIMATED FUNCTIONS.
*  RI  F  VALUE OF THE OBJECTIVE FUNCTION.
*  RI  FO  PREVIOUS VALUE OF THE OBJECTIVE FUNCTION.
*  RI  SNORM  EUCLIDEAN NORM OF THE DIRECTION VECTOR.
*  RI  DMAX  EUCLIDEAN NORM OF THE DIFFERENCE OF VARIABLES.
*
      SUBROUTINE UYSET4(NF,NA,INITS,ISTEP,F,FO,SNORM,DMAX)
      INTEGER NF,NA,INITS,ISTEP
      $FLOAT F,FO,SNORM,DMAX
      $FLOAT CON,CON1
      PARAMETER (CON=1.0$P-3,CON1=1.0D 2)
      IF (ISTEP.EQ.1) THEN
      INITS=ABS(INITS)
      IF (FO-F.LE.CON*FO) INITS=-INITS
      ELSE IF (ISTEP.EQ.2) THEN
      INITS=ABS(INITS)
      IF (SNORM.GE.CON1*DMAX) INITS=-INITS
      ELSE IF (ISTEP.EQ.3) THEN
      INITS=ABS(INITS)
      IF (NA.GT.NF) INITS=-INITS
      ENDIF
      RETURN
      END
