$INTERFACE UYSFIH                                             98/12/01

  $KH='KH'
  $IW='IW'
  $IW1='IW1'
  $IW2='IW2'
  MM=$IH(NF+1)-1
  CALL UXVINE(MM,$JH)
  CALL UYSFIH(NF,MM,$MMAX,$IH,$JH,$KH,$IW,$IW1,$IW2,NAU,INF)
  $ADD(INTEGER,'\$IH($NF+1)\$JH($M)\$KH($M)\$IW($MMAX)\$IW1(2*$NF+1)&
  \$IW2(3*$NF+1)\MM')
$REM  $ADD(INTEGER,'\NF\M\NAU\INF')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYSFIH                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* SYMBOLIC FACTORIZATION OF THE SYMMETRIC (HESSIAN) MATRIX.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE HESSIAN MATRIX.
*  II  MMAX  SIZE OF THE SPARSE HESSIAN ARRAY.
*  II  IH(NF+1) POINTERS OF THE HESSIAN MATRIX STORED
*           IN A COMPACT FORM.
*  II  JH(M) COLUMN INDICES OF NONZEROES IN THE HESSIAN MATRIX.
*  II  KH(M) ROW INDICES OF NONZEROES IN THE HESSIAN MATRIX.
*  II  IW(MMAX) WORKING ARRAY.
*  II  IW1(2*NF) WORKING ARRAY.
*  II  IW2(3*NF) WORKING ARRAY.
*  IO  NAU  NUMBER OF MAJOR STEPS.
*  IO  INF  ERROR INDICATOR. INF=0-NO ERRORS.
*
* COMMON DATA :
*  IO  ITERM  TERMINATION INDICATOR.
*  TO  TXFU  TEXT INFORMATION ON THE CAUSE OF TERMINATION.
*
* SUBPROGRAMS USED :
*  S   UXSIBS  MINIMUM DEGREE ORDERING.
*
      SUBROUTINE UYSFIH(NF,M,MMAX,IH,JH,KH,IW,IW1,IW2,NAU,INF)
      $INCLUDE('UMCOMM')
      INTEGER NF,M,MMAX,IH(NF+1),JH(M),KH(M),IW(MMAX),IW1(2*NF+1),
     & IW2(3*NF+1)
      INTEGER I,J,NAU,INF
      M=IH(NF+1)-1
      DO 2 I=1,NF
      DO 1 J=IH(I),IH(I+1)-1
      KH(J)=I
    1 CONTINUE
    2 CONTINUE
      CALL UXSIBS(NF,M,KH,JH,IW,MMAX,IW1,IW2,NAU,INF)
      IF (INF.LT.0) THEN
      ITERM=INF
      TXFU='LACK SPC'
      ENDIF
      RETURN
      END
