$INTERFACE UYSFIM                                             98/12/01

  $IB='IB'
  $JB='JB'
  $KB='KB'
  $IW='IW'
  $IW1='IW1'
  $IW2='IW2'
  CALL UXVINE($IH(NF+1)-1,$JH)
  CALL UYSFIM(NF,M,$MMAX,$IH,$JH,$IB,$JB,$KB,$IW,$IW1,$IW2,NAU)
  $ADD(INTEGER,'\$IH($NF+1)\$JH($M)\$IB($NF+2)\$JB($NF+$M+1)&
  \$KB($NF+$M+1)\$IW($MMAX)\$IW1(2*($NF+1)+1)\$IW2(3*($NF+1)+1)')
$REM  $ADD(INTEGER,'\NF\M\MMAX\NAU\INF')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYSFIM                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
* SYMBOLIC FACTORIZATION OF THE SYMMETRIC (HESSIAN) MATRIX.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE HESSIAN MATRIX.
*  II  MMAX  SIZE OF THE SPARSE HESSIAN ARRAY.
*  II  IH(NF+1) POINTERS OF THE HESSIAN MATRIX STORED
*           IN A COMPACT FORM.
*  II  JH(M) COLUMN INDICES OF NONZEROES IN THE HESSIAN MATRIX.
*  IU  IB(NF+2)  POINTERS OF DIAGONAL ELEMENTS OF B.
*  IU  JB(NF+M+1)  COLUMN INDICES OF THE NONZERO ELEMENTS OF B.
*  II  KB(NF+M+1)  ROW INDICES OF THE NONZERO ELEMENTS OF B.
*  II  IW(MMAX) WORKING ARRAY.
*  II  IW1(2*NF) WORKING ARRAY.
*  II  IW2(3*NF) WORKING ARRAY.
*  IO  NAU  NUMBER OF MAJOR STEPS.
*
* COMMON DATA :
*  IO  ITERM  TERMINATION INDICATOR.
*  TO  TXFU  TEXT INFORMATION ON THE CAUSE OF TERMINATION.
*
* SUBPROGRAMS USED :
*  S   UXSIBS  MINIMUM DEGREE ORDERING.
*
      SUBROUTINE UYSFIM(NF,M,MMAX,IH,JH,IB,JB,KB,IW,IW1,IW2,NAU)
      $INCLUDE('UMCOMM')
      INTEGER NF,M,MMAX,IH(NF+1),JH(M),IB(NF+2),JB(NF+M+1),KB(M),
     & IW(MMAX),IW1(2*(NF+1)),IW2(3*(NF+1)),NAU
      INTEGER I,J,INF,POSUN,TEMPA,TEMPB
      M=IH(NF+1)-1
      CALL UXVICP(M,JH,JB)
      IB(1)=1
      POSUN=0
      TEMPA=1
      DO I=1,NF
      TEMPB=IH(I+1)-TEMPA+IB(I)
      TEMPA=IH(I+1)
      IB(I+1)=TEMPB+1
      DO J=M,TEMPA,-1
      JB(J+POSUN+1)=JB(J+POSUN)
      ENDDO
      JB(TEMPA+POSUN)=NF+1
      POSUN=POSUN+1
      ENDDO
      IB(NF+2)=IB(NF+1)+1
      JB(IB(NF+1))=NF+1
      M=IB(NF+2)-1
      DO 2 I=1,NF+1
      DO 1 J=IB(I),IB(I+1)-1
      KB(J)=I
    1 CONTINUE
    2 CONTINUE
      CALL UXSIBS(NF+1,M,KB,JB,IW,MMAX,IW1,IW2,NAU,INF)
      IF (INF.LT.0) THEN
      ITERM=INF
      TXFU='LACK SPC'
      ENDIF
      RETURN
      END
