$INTERFACE UYTBCH                                             98/12/01

  CALL UYTBCH(NF,NA,MA,MAH,$XN,$IX,$AH,$IAG,$JAG)
  $ADD(REAL,'\$XN($NF)\$AH($MAH)')
  $ADD(INTEGER,'\$IX($NF)\$IAG($NA+1)\$JAG($MA)')
$REM  $ADD(INTEGER,'\NF\NA\MA\MAH')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYTBCH             ALL SYSTEMS                   98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* HESSIAN MATRIX OF THE OBJECTIVE FUNCTION OR ITS APPROXIMATION
* IS SCALED.
*
* PARAMETERS :
*  II  NF DECLARED NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  MA  NUMBER OF NONZERO ELEMENTS IN THE FIELD AG.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE MATRIX.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RU  H(M)  HESSIAN MATRIX OR ITS APPROXIMATION.
*  RI  IAG(NA+1)  POSITION OF THE FIRST ROWS ELEMENTS IN THE FIELD AG.
*  RI  JAG(MA)  COLUMN INDICES OF ELEMENTS IN THE FIELD AG.
*
* COMMON DATA :
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*  II  ITERS  TERMINATION INDICATOR FOR STEPLENGTH DETERMINATION.
*         ITERS=0 FOR ZERO STEP.
*  II  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*
      SUBROUTINE UYTBCH(NF,NA,MA,M,XN,IX,H,IAG,JAG)
      $INCLUDE ('UMCOMM')
      INTEGER NF,NA,MA,M,IX(NF),IAG(NA+1),JAG(MA)
      $FLOAT XN(NF),H(M)
      LOGICAL LNORM
      INTEGER I,J,K,L,IP,JP,KP,LP,KA
      LNORM=NORMF.GT.0.AND.LD.EQ.2.AND.ITERS.NE.0
      LP=0
      DO 3 KA=1,NA
      K=IAG(KA)
      KP=K-1
      L=IAG(KA+1)-K
      DO 2 I=1,L
      IP=ABS(JAG(I+KP))
      DO 1 J=1,I
      JP=ABS(JAG(J+KP))
      LP=LP+1
      IF (IX(IP).GE.0.AND.IX(JP).GE.0) THEN
      IF (LNORM) H(LP)=H(LP)*XN(IP)*XN(JP)
      ELSE IF (IP.EQ.JP) THEN
      H(LP)=1.0$P 0
      IF (LNORM) H(LP)=XN(IP)**2
      ELSE
      H(LP)=0.0$P 0
      ENDIF
    1 CONTINUE
    2 CONTINUE
    3 CONTINUE
      RETURN
      END
