$INTERFACE UYTRBA                                            98/12/01

  CALL UYTRBA(NF,N,$XN,$CR,$CZ,$GA)
  $ADD(REAL,'\$XN($NF)\$CR($NF*($NF+1)/2)\$CZ($NF*$NF)\$GA($NF)')
$REM  $ADD(INTEGER,'\NF\N')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYTRBA               ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* GRADIENT OF THE APPROXIMATED FUNCTION IS SCALED AND REDUCED.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RA  CR(NF*(NF+1)/2)  AUXILIARY VECTOR.
*  RI  CZ(NF*NF)  MATRIX WHOSE COLUMNS ARE BASIC VECTORS FROM THE
*         CURRENT REDUCED SUBSPACE.
*  RI  GA(NF)  GRADIENT OF THE APPROXIMATED FUNCTION.
*
* COMMON DATA :
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*
* SUBPROGRAMS USED :
*  S   UXDRMM  PREMULTIPLICATION OF A VECTOR BY TRANSPOSE OF A DENSE
*         RECTANGULAR MATRIX.
*  S   UXVCOP  COPYING OF A VECTOR.
*  S   UXVMUL  DIAGONAL PREMULTIPLICATION OF A VECTOR.
*
      SUBROUTINE UYTRBA(NF,N,XN,CR,CZ,GA)
      $INCLUDE ('UMCOMM')
      INTEGER NF,N
      $FLOAT XN(NF),CR(NF*(NF+1)/2),CZ(NF*NF),GA(NF)
      INTEGER NCA,NCR
      IF (N.GT.0) THEN
      NCA=NF-N
      NCR=NCA*(NCA+1)/2
      IF (NORMF.GT.0) THEN
      CALL UXVMUL(NF,XN,GA,CR(NCR+1),1)
      ELSE
      CALL UXVCOP(NF,GA,CR(NCR+1))
      ENDIF
      CALL UXDRMM(NF,N,CZ,CR(NCR+1),GA)
      ENDIF
      RETURN
      END
