$INTERFACE UYTRBX                                             98/12/01

  CALL UYTRBX(NF,N,$X,$XN,$XO,$CZ,$SN,$S,PP)
  $ADD(REAL,'\$X($NF)\$XN($NF)\$XO($NF)\$CZ($NF*$NF)\$SN($NF)\$S($NF)')
$REM  $ADD(INTEGER,'\NF\N')
$REM  $ADD(REAL,'\PP')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYTRBX               ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* STEP WITH THE SIZE PP IS PERFORMED.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RO  XO(NF)  SAVED VECTOR OF VARIABLES.
*  RI  CZ(NF*NF)  MATRIX WHOSE COLUMNS ARE BASIC VECTORS FROM THE
*         CURRENT REDUCED SUBSPACE.
*  RI  SN(NF)  TRANSFORMED DIRECTION VECTOR.
*  RO  S(NF)  DIRECTION VECTOR.
*  RI  PP  DIFFERENCE FOR COMPUTING DIRECTIONAL DERIVATIVES.
*
* COMMON DATA :
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*
* SUBPROGRAMS USED :
*  S   UXDCMM  MATRIX VECTOR PRODUCT.
*  S   UXVCOP  COPYING OF A VECTOR.
*  S   UXVDIR  VECTOR AUGMENTED BY THE SCALED VECTOR.
*  S   UXVSET  INITIATION OF A VECTOR.
*
      SUBROUTINE UYTRBX(NF,N,X,XN,XO,CZ,SN,S,PP)
      $INCLUDE ('UMCOMM')
      INTEGER NF,N
      $FLOAT X(NF),XN(NF),XO(NF),CZ(NF*NF),SN(NF),S(NF),PP
      IF (N.GT.0) THEN
      CALL UXDCMM(NF,N,CZ,SN,S)
      IF (NORMF.GT.0) CALL UXVMUL(NF,XN,S,S,1)
      CALL UXVDIR(NF,PP,S,XO,X)
      ELSE
      CALL UXVSET(NF,S,ZERO)
      CALL UXVCOP(NF,XO,X)
      ENDIF
      RETURN
      END
