$INTERFACE UYTRTH                                             98/12/01

  CALL UYTRTH(NF,N,$H,ETA2,INF)
  $ADD(REAL,'\$H($NF*($NF+1)/2)')
$REM  $ADD(INTEGER,'\NF\N\IDECF\INF')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYTRTH             ALL SYSTEMS                   98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* HESSIAN MATRIX OF THE OBJECTIVE FUNCTION OR ITS APPROXIMATION
* IS SCALED.
*
* PARAMETERS :
*  II  NF DECLARED NUMBER OF VARIABLES.
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  RU  H(NF*(NF+1)/2)  HESSIAN MATRIX OR ITS APPROXIMATION.
*  RI  ETA2  TOLERANCE FOR POSITIVE DEFINITENESS.
*  IU  INF  DECOMPOSITION INDICATOR. INF=0 IF THE MATRIX IS POSITIVE
*         DEFINITE.
*
* COMMON DATA :
*  IU  IDECF  DECOMPOSITION INDICATOR. IDECF=0-NO DECOMPOSITION.
*         IDECF=1-GILL-MURRAY DECOMPOSITION.
*  IU  NDECF  NUMBER OF DECOMPOSITIONS.
*
* SUBPROGRAMS USED :
*  S   UXDPGF  GILL-MURRAY FACTORIZATION OF A DENSE SYMMETRIC MATRIX
*         WITH CONTROLLING OF POSITIVE DEFINITENESS.
*
      SUBROUTINE UYTRTH(NF,N,H,ETA2,INF)
      $INCLUDE ('UMCOMM')
      INTEGER NF,N,INF
      $FLOAT H(NF*(NF+1)/2),ETA2
      $FLOAT RHO1,RHO2
      IF (IDECF.NE.1) THEN
C
C     GILL-MURRAY DECOMPOSITION
C
      RHO1=ETA2
      CALL UXDPGF(N,H,INF,RHO1,RHO2)
      IDECF=1
      NDECF=NDECF+1
      ENDIF
      RETURN
      END
