$INTERFACE UYTRUA                                             98/12/01

  CALL UYTRUA(NF,N,$XN,$GA)
  $ADD(REAL,'\$XN($NF)\$GA($NF)')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYTRUA             ALL SYSTEMS                   98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  GRADIENT OF THE APPROXIMATED FUNCTION IS SCALED.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RI  GA(NF)  GRADIENT OF THE APPROXIMATED FUNCTION.
*
* COMMON DATA :
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*
      SUBROUTINE UYTRUA(NF,N,XN,GA)
      $INCLUDE ('UMCOMM')
      INTEGER NF,N
      $FLOAT XN(NF),GA(NF)
      INTEGER I
      IF (NORMF.GT.0) THEN
      DO 1 I=1,NF
      GA(I)=GA(I)*XN(I)
    1 CONTINUE
      ENDIF
      N=NF
      RETURN
      END
