$INTERFACE UYTRUC                                             07/12/01

  CALL UYTRUC(NF,$X,$XN,$XO,$S,$G,$GO,R,F,FO,P,PO,DMAX)
  $ADD(REAL,'\$X($NF)\$XN($NF)\$XO($NF)\$S($NF)\$G($NF)\$GO($NF)')
$REM  $ADD(REAL,'\R\F\FO\P\PO\DMAX')
$REM  $ADD(INTEGER,'\NF')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYTRUC             ALL SYSTEMS                   07/12/01
C PORTABILITY : ALL SYSTEMS
C 07/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* GRADIENTS DIFFERENCE IS COMPUTED AND SCALED. TEST VALUE DMAX IS
* DETERMINED.
*
* PARAMETERS :
*  II  NF DECLARED NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RU  XO(NF)  VECTORS OF VARIABLES DIFFERENCE.
*  RI  S(NF)  DIRECTION VECTOR.
*  RI  G(NF)  GRADIENT OF THE OBJECTIVE FUNCTION.
*  RU  GO(NF)  GRADIENTS DIFFERENCE.
*  RO  R  VALUE OF THE STEPSIZE PARAMETER.
*  RO  F  NEW VALUE OF THE OBJECTIVE FUNCTION.
*  RI  FO  OLD VALUE OF THE OBJECTIVE FUNCTION.
*  RO  P  NEW VALUE OF THE DIRECTIONAL DERIVATIVE.
*  RI  PO  OLD VALUE OF THE DIRECTIONAL DERIVATIVE.
*  RO  DMAX  MAXIMUM RELATIVE DIFFERENCE OF VARIABLES.
*
* COMMON DATA :
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*  II  ITERS  TERMINATION INDICATOR FOR STEPLENGTH DETERMINATION.
*         ITERS=0 FOR ZERO STEP.
*
* SUBPROGRAMS USED :
*  S   UYSET1  DEGREE DEFINITION OF THE COMPUTED DERIVATIVES.
*  S   UXVDIF  DIFFERENCE OF TWO VECTORS.
*  S   UXVSAV  DIFFERENCE OF TWO VECTORS WITH COPYING AND SAVING THE
*         SUBSTRACTED ONE.
*
      SUBROUTINE UYTRUC(NF,X,XN,XO,S,G,GO,R,F,FO,P,PO,DMAX)
      $INCLUDE ('UMCOMM')
      INTEGER NF
      $FLOAT X(NF),XN(NF),XO(NF),S(NF),G(NF),GO(NF),R,F,FO,P,PO,DMAX
      INTEGER I
      IF (ITERS.GT.0) THEN
      CALL UXVDIF(NF,G,GO,GO)
      ELSE
      F=FO
      P=PO
      CALL UXVSAV(NF,X,XO)
      CALL UXVSAV(NF,G,GO)
      CALL UYSET1
      ENDIF
      DMAX=ZERO
      DO 1 I=1,NF
      IF (NORMF.GT.0) THEN
      DMAX=MAX(DMAX,ABS(R*S(I))/MAX(ABS(X(I)),XN(I)))
      GO(I)=GO(I)*XN(I)
      ELSE
      DMAX=MAX(DMAX,ABS(R*S(I))/MAX(ABS(X(I)),ONE))
      ENDIF
    1 CONTINUE
      RETURN
      END
