$INTERFACE UYTRUH                                             91/12/01

  CALL UYTRUH(NF,$XN,$H)
  $ADD(REAL,'\$XN($NF)\$H($NF*($NF+1)/2)')
$REM  $ADD(INTEGER,'\NF')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYTRUH             ALL SYSTEMS                   91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* HESSIAN MATRIX OF THE OBJECTIVE FUNCTION OR ITS APPROXIMATION
* IS SCALED.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RU  H(NF*(NF+1)/2)  HESSIAN MATRIX OR ITS APPROXIMATION.
*
* COMMON DATA :
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*  II  ITERS  TERMINATION INDICATOR FOR STEPLENGTH DETERMINATION.
*         ITERS=0 FOR ZERO STEP.
*  II  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*
* SUBPROGRAMS USED :
*  S   UOFTH1  PRINT OF ENTRY TO TRANSFORMATION OF THE HESSIAN MATRIX
*         OR ITS APPROXIMATION.
*  S   UOFTH2  PRINT OF EXIT FROM TRANSFORMATION OF THE HESSIAN MATRIX
*         OR ITS APPROXIMATION.
*
      SUBROUTINE UYTRUH(NF,XN,H)
      $INCLUDE ('UMCOMM')
      INTEGER NF
      $FLOAT XN(NF),H(NF*(NF+1)/2)
      INTEGER I, J, K
      IF (LD.NE.2.OR.ITERS.EQ.0) RETURN
      IF (NORMF.LE.0) RETURN
      CALL UOFTH1(NF,NF*(NF+1)/2,H,XN)
      K=0
      DO 2 I=1,NF
      DO 1 J=1,I
      K=K+1
      H(K)=H(K)*XN(I)*XN(J)
    1 CONTINUE
    2 CONTINUE
      CALL UOFTH2(NF*(NF+1)/2,H)
      RETURN
      END
