$INTERFACE UYTRUV                                             98/12/01

  CALL UYTRUV(NF,NA,MA,$X,$XN,$XO,$G,$GO,$AG,$AGO,$IAG,$JAG)
  $ADD(REAL,'\$X($NF)\$XN($NF)\$XO($NF)\$G($NF)\$GO($NF)&
  \$AG($MA)\$AGO($MA)')
  $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)')
$REM  $ADD(INTEGER,'\NF\NA\MA')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYTRUV             ALL SYSTEMS                   98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* VECTORS OF VARIABLES DIFFERENCE AND GRADIENTS DIFFERENCE ARE COMPUTED
* AND SCALED. TEST VALUE DMAX IS DETERMINED.
*
* PARAMETERS :
*  II  NF DECLARED NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  MA  NUMBER OF NONZERO ELEMENTS IN THE FIELD AG.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RU  XO(NF)  VECTORS OF VARIABLES DIFFERENCE.
*  RI  G(NF)  GRADIENT OF THE OBJECTIVE FUNCTION.
*  RU  GO(NF)  GRADIENTS DIFFERENCE.
*  RI  AG(MA)  JACOBIAN MATRIX OF THE APPROXIMATED FUNCTIONS.
*  RO  AGO(MA)  SAVED JACOBIAN MATRIX OF THE APPROXIMATED FUNCTIONS.
*  RI  IAG(NA+1)  POSITION OF THE FIRST ROWS ELEMENTS IN THE FIELD AG.
*  RI  JAG(MA)  COLUMN INDICES OF ELEMENTS IN THE FIELD AG.
*
* COMMON DATA :
*  II  ISNA  SAVING SPECIFICATION. ISNA=0-NO SAVING. ISNA=1-FUNCTION
*         VALUES ARE SAVED. ISNA=2-FUNCTION VALUES AND GRADIENTS ARE
*         SAVED.
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*  II  ITERS  TERMINATION INDICATOR FOR STEPLENGTH DETERMINATION.
*         ITERS=0 FOR ZERO STEP.
*
* SUBPROGRAMS USED :
*  S   UYSET1  DEGREE DEFINITION OF THE COMPUTED DERIVATIVES.
*  S   UXVDIF  DIFFERENCE OF TWO VECTORS.
*  S   UXVSAV  DIFFERENCE OF TWO VECTORS WITH COPYING AND SAVING THE
*         SUBSTRACTED ONE.
*
      SUBROUTINE UYTRUV(NF,NA,MA,XN,AG,AGO,IAG,JAG)
      $INCLUDE ('UMCOMM')
      INTEGER NF,NA,MA
      $FLOAT XN(NF),AG(MA),AGO(MA)
      INTEGER IAG(NA+1),JAG(MA)
      INTEGER I,J,K,L,JP
      IF (ITERS.GT.0) THEN
      CALL UXVDIF(MA,AG,AGO,AGO)
      ELSE
      CALL UXVSAV(MA,AG,AGO)
      ENDIF
      IF (NORMF.GT.0.AND.ISNA.LE.2) THEN
      DO 4 I=1,NA
      K=IAG(I)
      L=IAG(I+1)-K
      DO 3 J=1,L
      JP=JAG(K)
      AGO(K)=AGO(K)*XN(JP)
      K=K+1
    3 CONTINUE
    4 CONTINUE
      ENDIF
      RETURN
      END
