$INTERFACE UYTRYD                                             96/12/01

  CALL UYTRYD(NF,$X,$XN,$XO,$G,$GO,$S,R,RP,F,FUB,P,DMAX)
  $ADD(REAL,'\$X($NF)\$XN($NF)\$XO($NF)\$G($NF)\$GO($NF)\$S($NF)')
$REM  $ADD(REAL,'\R\RP\F\FUB\P\DMAX')
$REM  $ADD(INTEGER,'\NF')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYTRYD             ALL SYSTEMS                   96/12/01
C PORTABILITY : ALL SYSTEMS
C 96/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* TEST VALUE DMAX IS DETERMINED.
*
* PARAMETERS :
*  II  NF DECLARED NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RU  XO(NF)  VECTORS OF VARIABLES DIFFERENCE.
*  RI  G(NF)  GRADIENT OF THE OBJECTIVE FUNCTION.
*  RO  R  VALUE OF THE STEPSIZE PARAMETER.
*  RO  RP  PREVIOUS VALUE OF THE STEPSIZE PARAMETER.
*  RI  F  VALUE OF THE OBJECTIVE FUNCTION.
*  RO  FUB  VALUE OF THE FUNCTION VALUE
*  RI  P  VALUE OF THE DIRECTIONAL DERIVATIVE.
*  RO  DMAX  MAXIMUM RELATIVE DIFFERENCE OF VARIABLES.
*
* COMMON DATA :
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*  II  ITERS  TERMINATION INDICATOR FOR STEPLENGTH DETERMINATION.
*         ITERS=0 FOR ZERO STEP.
*
* SUBPROGRAMS USED :
*  S   UYSET1  DEGREE DEFINITION OF THE COMPUTED DERIVATIVES.
*  S   UXVDIF  DIFFERENCE OF TWO VECTORS.
*  S   UXVSAV  DIFFERENCE OF TWO VECTORS WITH COPYING AND SAVING THE
*         SUBSTRACTED ONE.
*
      SUBROUTINE UYTRYD(NF,X,XN,XO,G,GO,S,R,RP,F,FUB,P,DMAX)
      $INCLUDE ('UMCOMM')
      INTEGER NF
      $FLOAT X(NF),XN(NF),XO(NF),G(NF),GO(NF),S(NF),R,RP,F,FUB,P,DMAX
      INTEGER I
      $FLOAT UXVDOT,TEMP
      IF (ITERS.GT.0) THEN
        DO 2 I=1,NF
          TEMP=XO(I)
          XO(I)=X(I)-TEMP
          IF(ITERS.GE.9)X(I)=TEMP+RP*S(I)
    2   CONTINUE
        CALL UXVDIF(NF,G,GO,GO)
        CALL UYSET1
      ELSE
        CALL UXVSAV(NF,X,XO)
        CALL UXVSAV(NF,G,GO)
        F=F-UXVDOT(NF,XO,G)
        CALL UYSET1
      ENDIF
      DMAX=ZERO
      DO 1 I=1,NF
      IF ( NORMF .GT. 0) THEN
      DMAX=MAX(DMAX,ABS(XO(I))/MAX(ABS(X(I)),XN(I)))
      ELSE
      DMAX=MAX(DMAX,ABS(XO(I))/MAX(ABS(X(I)),ONE))
      ENDIF
    1 CONTINUE
      TEMP=FUB
      FUB=F
      IF(ITERS.GE.9)FUB=FUB-(R-RP)*P
      FUB=(FUB+TEMP)*HALF
      RETURN
      END
