$REM +---------------------------------------------------------------+
$REM + TEMPLATE: UZMODA                                    01/12/97  +
$REM + SI                                                            +
$REM + PURPOSE:  SPECIFICATION OF MODEL OF APPROXIMATED FUNCTIONS    +
$REM +---------------------------------------------------------------+

$LDA=-1
$GMODA='X'
$DMODA='X'
$HMODA='X'
$IF($DEF(FMODELAS))
  $IF(MODEL='D?')
    $ERROR SIMULTANEOUS COMPUTATION IS NOT ALLOWED : MODEL = D
    $STOP
  $ENDIF
  $FMODELA=FMODELAS
  $ERASE(FMODELAS)
  $ISNA=1
  $LDA=0
$ENDIF
$IF($DEF(FMODELA))
  $FMODA='F'
  $KDA=0
  $IF($DEF(GMODELAS))
    $IF(MODEL='D?')
      $ERROR SIMULTANEOUS COMPUTATION IS NOT ALLOWED : MODEL = D
      $STOP
    $ENDIF
    $IF(LDA<0)
      $ERROR SIMULTANEOUS COMPUTATION IS NOT ALLOWED : LDA < 0
      $STOP
    $ENDIF
    $GMODELA=GMODELAS
    $ERASE(GMODELAS)
    $ISNA=2
    $LDA=1
  $ENDIF
  $IF($DEF(GMODELA))
    $GMODA='G'
    $KDA=1
  $ENDIF
  $IF($DEF(DMODELAS))
    $ERROR SIMULTANEOUS COMPUTATION IS NOT ALLOWED : MODEL = D
    $STOP
  $ENDIF
  $IF($DEF(DMODELA))
    $DMODA='D'
  $ENDIF
  $IF($DEF(HMODELAS))
    $IF(MODEL='D?')
      $ERROR SIMULTANEOUS COMPUTATION IS NOT ALLOWED : MODEL = D
      $STOP
    $ENDIF
    $IF(LDA<1)
      $ERROR SIMULTANEOUS COMPUTATION IS NOT ALLOWED : LDA < 1
      $STOP
    $ENDIF
    $HMODELA=HMODELAS
    $ERASE(HMODELAS)
    $LDA=2
  $ENDIF
  $IF($DEF(HMODELA))
    $HMODA='H'
    $KDA=2
  $ENDIF
  $IF($DEF(GDMODELAS))
    $ERROR SIMULTANEOUS COMPUTATION IS NOT ALLOWED : MODEL = D
    $STOP
  $ENDIF
  $IF($DEF(GDMODELA))
    $GMODA='GD'
    $KDA=1
  $ENDIF
  $MODELA='YES'
  $EXIT
$ENDIF
$IF($DEF(FGMODELAS))
  $IF(MODEL='D?')
    $ERROR SIMULTANEOUS COMPUTATION IS NOT ALLOWED : MODEL = D
    $STOP
  $ENDIF
  $FGMODELA=FGMODELAS
  $ERASE(FGMODELAS)
  $ISNA=2
  $LDA=1
$ENDIF
$IF($DEF(FGMODELA))
  $FMODA='FG'
  $KDA=1
  $IF($DEF(DMODELAS))
    $ERROR SIMULTANEOUS COMPUTATION IS NOT ALLOWED : MODEL = D
    $STOP
  $ENDIF
  $IF($DEF(DMODELA))
    $DMODA='D'
  $ENDIF
  $IF($DEF(HMODELAS))
    $IF(MODEL='D?')
      $ERROR SIMULTANEOUS COMPUTATION IS NOT ALLOWED : MODEL = D
      $STOP
    $ENDIF
    $IF(LDA<1)
      $ERROR SIMULTANEOUS COMPUTATION IS NOT ALLOWED : LDA < 1
      $STOP
    $ENDIF
    $HMODELA=HMODELAS
    $ERASE(HMODELAS)
    $LDA=2
  $ENDIF
  $IF($DEF(HMODELA))
    $HMODA='H'
    $KDA=2
  $ENDIF
  $MODELA='YES'
  $EXIT
$ENDIF
$IF($DEF(FDMODELAS))
  $ERROR SIMULTANEOUS COMPUTATION IS NOT ALLOWED : MODEL = D
  $STOP
$ENDIF
$IF($DEF(FDMODELA))
  $FMODA='FD'
  $KDA=0
  $IF($DEF(GMODELA))
    $GMODA='G'
    $KDA=1
  $ENDIF
  $MODELA='YES'
  $EXIT
$ENDIF
$IF($DEF(FGDMODELAS))
  $ERROR SIMULTANEOUS COMPUTATION IS NOT ALLOWED : MODEL = D
  $STOP
$ENDIF
$IF($DEF(FGDMODELA))
  $FMODA='FGD'
  $KDA=1
  $MODELA='YES'
  $EXIT
$ENDIF
$IF($DEF(FGHMODELAS))
  $IF(MODEL='D?')
    $ERROR SIMULTANEOUS COMPUTATION IS NOT ALLOWED : MODEL = D
    $STOP
  $ENDIF
  $FGHMODELA=FGHMODELAS
  $ERASE(FGHMODELAS)
  $ISNA=2
  $LDA=2
$ENDIF
$IF($DEF(FGHMODELA))
  $FMODA='FGH'
  $KDA=2
  $MODELA='YES'
  $EXIT
$ENDIF
$IF(MODEL='D?')
  $HELP
    MODEL OF THE APPROXIMATED FUNCTION

    FA = <FORTRAN_EXPRESSION>
  $CHECK(FMODELA,'*',STR,1,NO)
  $IF(FMODELA='*')
  $ELSE
  $FMODA='F'
  $KDA=0
  $MODELA='YES'
  $ENDIF
$ELSE
  $FMODA='F'
  $KDA=0
  $MODELA='YES'
  $REPEAT
    $HELP
      MODEL OF THE APPROXIMATED FUNCTION

      FA = <FORTRAN_EXPRESSION>
    $CHECK(FMODELA,'*',STR,1,NO)
    $IF(FMODELA='*')
      $IF(DIALOG>0)
        $ERASE(FMODELA)
      $ELSE
        $ERROR:  MODEL OF APPROXIMATED FUNCTION WAS NOT SPECIFIED.
        $STOP
      $ENDIF
    $ENDIF
  $UNTIL($DEF(FMODELA))
  $HELP
    MODEL OF GRADIENT OF THE APPROXIMATED FUNCTION

      GA(1)  = <FORTRAN_EXPRESSION>
      GA(2)  = <FORTRAN_EXPRESSION>
        .
        .
      GA(NF) = <FORTRAN_EXPRESSION>
  $CHECK(GMODELA,'*',STR,1,NO)
  $IF(GMODELA='*')
    $ERASE(GMODELA)
  $ELSE
    $GMODA='G'
    $KDA=1
  $ENDIF
  $IF($DEF(NE))
    $IF(NE>0)
      $HELP
        MODEL OF DERIVATIVES OF THE APPROXIMATED FUNCTION

          DA(1)  = <FORTRAN_EXPRESSION>
          DA(2)  = <FORTRAN_EXPRESSION>
            .
            .
          DA(NF) = <FORTRAN_EXPRESSION>
      $CHECK(DMODELA,'*',STR,1,NO)
      $IF(DMODELA='*')
        $ERASE(DMODELA)
      $ELSE
        $DMODA='D'
      $ENDIF
    $ENDIF
  $ENDIF
  $HELP
    MODEL OF HESSIAN MATRIX

      HA(1) = <FORTRAN_EXPRESSION>
      HA(2) = <FORTRAN_EXPRESSION>
        .
        .
      HA(M) = <FORTRAN_EXPRESSION>
  $CHECK(HMODELA,'*',STR,1,NO)
  $IF(HMODELA='*')
    $ERASE(HMODELA)
  $ELSE
    $HMODA='H'
    $KDA=2
  $ENDIF
$ENDIF

